/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(B){for(var t=[],P=0,F=B.length;P<F;P++)t[P]=ne[B[P]];return t};const Ve=this,ze=typeof global=="object"?global:{};var fe;(function(B){B.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=t})(fe||(fe={}));var fe;(function(B){class t{constructor(c,w,f){this.type=c,this.detail=w,this.timestamp=f}}B.LoaderEvent=t;class P{constructor(c){this._events=[new t(1,"",c)]}record(c,w){this._events.push(new t(c,w,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=P;class F{record(c,w){}getEvents(){return[]}}F.INSTANCE=new F,B.NullLoaderEventRecorder=F})(fe||(fe={}));var fe;(function(B){class t{static fileUriToFilePath(F,r){if(r=decodeURI(r).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(F,r){return F.length>=r.length&&F.substr(0,r.length)===r}static endsWith(F,r){return F.length>=r.length&&F.substr(F.length-r.length)===r}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,r){if(F){let c;for(c in F)F.hasOwnProperty(c)&&r(c,F[c])}}static isEmpty(F){let r=!0;return t.forEachProperty(F,()=>{r=!1}),r}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let r=Array.isArray(F)?[]:{};return t.forEachProperty(F,(c,w)=>{w&&typeof w=="object"?r[c]=t.recursiveClone(w):r[c]=w}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,B.Utilities=t})(fe||(fe={}));var fe;(function(B){function t(r){if(r instanceof Error)return r;const c=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(c.stack=r.stack),c}B.ensureError=t;class P{static validateConfigurationOptions(c){function w(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=w),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(B.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",c.onError(f),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,w=null){let f=B.Utilities.recursiveClone(w||{});return B.Utilities.forEachProperty(c,(u,s)=>{u==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):u==="paths"&&typeof f.paths<"u"?B.Utilities.forEachProperty(s,(h,N)=>f.paths[h]=N):u==="config"&&typeof f.config<"u"?B.Utilities.forEachProperty(s,(h,N)=>f.config[h]=N):f[u]=B.Utilities.recursiveClone(s)}),P.validateConfigurationOptions(f)}}B.ConfigurationOptionsUtil=P;class F{constructor(c,w){if(this._env=c,this.options=P.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,u=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(c,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:c,to:w}):this.sortedPathsRules.push({from:c,to:[w]})}),this.sortedPathsRules.sort((c,w)=>w.from.length-c.from.length)}cloneAndMerge(c){return new F(this._env,P.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let w;for(let f=0,u=this.sortedPathsRules.length;f<u;f++)if(w=this.sortedPathsRules[f],B.Utilities.startsWith(c,w.from)){let s=[];for(let h=0,N=w.to.length;h<N;h++)s.push(w.to[h]+c.substr(w.from.length));return s}return[c]}_addUrlArgsToUrl(c){return B.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let w=0,f=c.length;w<f;w++)c[w]=this._addUrlArgsToUrl(c[w]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let w=c,f;if(!B.Utilities.endsWith(w,".js")&&!B.Utilities.isAbsolutePath(w)){f=this._applyPaths(w);for(let u=0,s=f.length;u<s;u++)this.isBuild()&&f[u]==="empty:"||(B.Utilities.isAbsolutePath(f[u])||(f[u]=this.options.baseUrl+f[u]),!B.Utilities.endsWith(f[u],".js")&&!B.Utilities.containsQueryString(f[u])&&(f[u]=f[u]+".js"))}else!B.Utilities.endsWith(w,".js")&&!B.Utilities.containsQueryString(w)&&(w=w+".js"),f=[w];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(c){let w=c;return B.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],B.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}B.Configuration=F})(fe||(fe={}));var fe;(function(B){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,N,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new P:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new P;let g={callback:N,errorback:b};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(g);return}this._callbackMap[h]=[g],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let N=0;N<h.length;N++)h[N].callback()}triggerErrorback(s,h){let N=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<N.length;b++)N[b].errorback(h)}}class P{attachListeners(s,h,N){let b=()=>{s.removeEventListener("load",g),s.removeEventListener("error",e)},g=E=>{b(),h()},e=E=>{b(),N(E)};s.addEventListener("load",g),s.addEventListener("error",e)}load(s,h,N,b){if(/^node\|/.test(h)){let g=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),g.nodeRequire||B.global.nodeRequire),E=h.split("|"),A=null;try{A=e(E[1])}catch(p){b(p);return}s.enqueueDefineAnonymousModule([],()=>A),N()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,N,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),g.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&g.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(g)}}}function F(u){const{trustedTypesPolicy:s}=u.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(s)),this._cachedCanUseEval}load(s,h,N,b){if(/^node\|/.test(h)){const g=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),g.nodeRequire||B.global.nodeRequire),E=h.split("|");let A=null;try{A=e(E[1])}catch(p){b(p);return}s.enqueueDefineAnonymousModule([],function(){return A}),N()}else{const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(g?self.eval(g.createScript("",E)):new Function(E)).call(self),N()}).then(void 0,b);return}try{g&&(h=g.createScriptURL(h)),importScripts(h),N()}catch(E){b(E)}}}}class c{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:N}=h.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,g=s("module");function e(E){const A=E.constructor;let p=function(m){try{return E.require(m)}finally{}};return p.resolve=function(m,l){return A._resolveFilename(m,E,!1,l)},p.resolve.paths=function(m){return A._resolveLookupPaths(m,E)},p.main=process.mainModule,p.extensions=A._extensions,p.cache=A._cache,p}g.prototype._compile=function(E,A){const p=g.wrap(E.replace(/^#!.*/,"")),_=h.getRecorder(),m=b._getCachedDataPath(N,A),l={filename:A};let o;try{const R=b._fs.readFileSync(m);o=R.slice(0,16),l.cachedData=R.slice(16),_.record(60,m)}catch{_.record(61,m)}const i=new b._vm.Script(p,l),a=i.runInThisContext(l),L=b._path.dirname(A),d=e(this),v=[this.exports,d,this,A,L,process,ze,Buffer],M=a.apply(this.exports,v);return b._handleCachedData(i,p,m,!l.cachedData,h),b._verifyCachedData(i,p,m,o,h),M}}load(s,h,N,b){const g=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),g.nodeRequire||B.global.nodeRequire),E=g.nodeInstrumenter||function(p){return p};this._init(e),this._initNodeRequire(e,s);let A=s.getRecorder();if(/^node\|/.test(h)){let p=h.split("|"),_=null;try{_=e(p[1])}catch(m){b(m);return}s.enqueueDefineAnonymousModule([],()=>_),N()}else{h=B.Utilities.fileUriToFilePath(this._env.isWindows,h);const p=this._path.normalize(h),_=this._getElectronRendererScriptPathOrUri(p),m=!!g.nodeCachedData,l=m?this._getCachedDataPath(g.nodeCachedData,h):void 0;this._readSourceAndCachedData(p,l,A,(o,i,a,L)=>{if(o){b(o);return}let d;i.charCodeAt(0)===c._BOM?d=c._PREFIX+i.substring(1)+c._SUFFIX:d=c._PREFIX+i+c._SUFFIX,d=E(d,p);const v={filename:_,cachedData:a},M=this._createAndEvalScript(s,d,v,N,b);this._handleCachedData(M,d,l,m&&!a,s),this._verifyCachedData(M,d,l,L,s)})}}_createAndEvalScript(s,h,N,b,g){const e=s.getRecorder();e.record(31,N.filename);const E=new this._vm.Script(h,N),A=E.runInThisContext(N),p=s.getGlobalAMDDefineFunc();let _=!1;const m=function(){return _=!0,p.apply(null,arguments)};return m.amd=p.amd,A.call(B.global,s.getGlobalAMDRequireFunc(),m,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),_?b():g(new Error(`Didn't receive define call in ${N.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const N=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${N}.code`)}_handleCachedData(s,h,N,b,g){s.cachedDataRejected?this._fs.unlink(N,e=>{g.getRecorder().record(62,N),this._createAndWriteCachedData(s,h,N,g),e&&g.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,h,N,g)}_createAndWriteCachedData(s,h,N,b){let g=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,A;const p=()=>{setTimeout(()=>{A||(A=this._crypto.createHash("md5").update(h,"utf8").digest());const _=s.createCachedData();if(!(_.length===0||_.length===e||E>=5)){if(_.length<e){p();return}e=_.length,this._fs.writeFile(N,Buffer.concat([A,_]),m=>{m&&b.getConfig().onError(m),b.getRecorder().record(63,N),p()})}},g*Math.pow(4,E++))};p()}_readSourceAndCachedData(s,h,N,b){if(!h)this._fs.readFile(s,{encoding:"utf8"},b);else{let g,e,E,A=2;const p=_=>{_?b(_):--A===0&&b(void 0,g,e,E)};this._fs.readFile(s,{encoding:"utf8"},(_,m)=>{g=m,p(_)}),this._fs.readFile(h,(_,m)=>{!_&&m&&m.length>0?(E=m.slice(0,16),e=m.slice(16),N.record(60,h)):N.record(61,h),p()})}}_verifyCachedData(s,h,N,b,g){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();b.equals(e)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,E=>{E&&g.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function w(u,s){if(s.__$__isRecorded)return s;const h=function(b){u.record(33,b);try{return s(b)}finally{u.record(34,b)}};return h.__$__isRecorded=!0,h}B.ensureRecordedNodeRequire=w;function f(u){return new t(u)}B.createScriptLoader=f})(fe||(fe={}));var fe;(function(B){class t{constructor(u){let s=u.lastIndexOf("/");s!==-1?this.fromModulePath=u.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(u){let s=u,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(u){let s=u;return B.Utilities.isAbsolutePath(s)||(B.Utilities.startsWith(s,"./")||B.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),B.ModuleIdResolver=t;class P{constructor(u,s,h,N,b,g){this.id=u,this.strId=s,this.dependencies=h,this._callback=N,this._errorback=b,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,s){try{return{returnedValue:u.apply(B.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(u,s,h,N){return u.shouldInvokeFactory(s)?u.shouldCatchError()?this._safeInvokeFunction(h,N):{returnedValue:h.apply(B.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(u,s,h,N){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let g=P._invokeFactory(s,this.strId,this._callback,h);b=g.producedError,u.record(22,this.strId),!b&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(b){let g=B.ensureError(b);g.phase="factory",g.moduleId=this.strId,g.neededBy=N(this.id),this.error=g,s.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}B.Module=P;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let s=this._strModuleIdToIntModuleId.get(u);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(u,s),this._intModuleIdToStrModuleId[s]=u),s}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class r{constructor(u){this.id=u}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),B.RegularDependency=r;class c{constructor(u,s,h){this.id=u,this.pluginId=s,this.pluginParam=h}}B.PluginDependency=c;class w{constructor(u,s,h,N,b=0){this._env=u,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=h,this._requireFunc=N,this._moduleIdProvider=new F,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,s){let h=g=>g.replace(/\\/g,"/"),N=h(u),b=s.split(/\n/);for(let g=0;g<b.length;g++){let e=b[g].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],A=e[2],p=e[3],_=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(_),E=h(E),E===N){let m={line:parseInt(A,10),col:parseInt(p,10)};return m.line===1&&(m.col-=53),m}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],s=0;for(let h=0,N=this._modules2.length;h<N;h++){let b=this._modules2[h];if(!b)continue;let g=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];u[s++]={id:b.strId,path:g,defineLocation:g&&e?w._findRelevantLocationInStack(g,e):null,dependencies:E,shim:null,exports:b.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:u,callback:s}}defineModule(u,s,h,N,b,g=new t(u)){let e=this._moduleIdProvider.getModuleId(u);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let E=new P(e,u,this._normalizeDependencies(s,g),h,N,g);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(A=>this._moduleIdProvider.getStrModuleId(A.id))),this._resolve(E)}_normalizeDependency(u,s){if(u==="exports")return r.EXPORTS;if(u==="module")return r.MODULE;if(u==="require")return r.REQUIRE;let h=u.indexOf("!");if(h>=0){let N=s.resolveModule(u.substr(0,h)),b=s.resolveModule(u.substr(h+1)),g=this._moduleIdProvider.getModuleId(N+"!"+b),e=this._moduleIdProvider.getModuleId(N);return new c(g,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(u)))}_normalizeDependencies(u,s){let h=[],N=0;for(let b=0,g=u.length;b<g;b++)h[N++]=this._normalizeDependency(u[b],s);return h}_relativeRequire(u,s,h,N){if(typeof s=="string")return this.synchronousRequire(s,u);this.defineModule(B.Utilities.generateAnonymousModule(),s,h,N,null,u)}synchronousRequire(u,s=new t(u)){let h=this._normalizeDependency(u,s),N=this._modules2[h.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(u,s){let h=this._config.shouldRecordStats();s?this._config=new B.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),s.dependencies,s.callback,null,s.stack)}}_createLoadError(u,s){let h=this._moduleIdProvider.getStrModuleId(u),N=(this._inverseDependencies2[u]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const b=B.ensureError(s);return b.phase="loading",b.moduleId=h,b.neededBy=N,b}_onLoadError(u,s){const h=this._createLoadError(u,s);this._modules2[u]||(this._modules2[u]=new P(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let N=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)N[e]=!1;let b=!1,g=[];for(g.push(u),N[u]=!0;g.length>0;){let e=g.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(h)||b);let A=this._inverseDependencies2[e];if(A)for(let p=0,_=A.length;p<_;p++){let m=A[p];N[m]||(g.push(m),N[m]=!0)}}b||this._config.onError(h)}_hasDependencyPath(u,s){let h=this._modules2[u];if(!h)return!1;let N=[];for(let g=0,e=this._moduleIdProvider.getMaxModuleId();g<e;g++)N[g]=!1;let b=[];for(b.push(h),N[u]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,A=e.length;E<A;E++){let p=e[E];if(p.id===s)return!0;let _=this._modules2[p.id];_&&!N[p.id]&&(N[p.id]=!0,b.push(_))}}return!1}_findCyclePath(u,s,h){if(u===s||h===50)return[u];let N=this._modules2[u];if(!N)return null;let b=N.dependencies;if(b)for(let g=0,e=b.length;g<e;g++){let E=this._findCyclePath(b[g].id,s,h+1);if(E!==null)return E.push(u),E}return null}_createRequire(u){let s=(h,N,b)=>this._relativeRequire(u,h,N,b);return s.toUrl=h=>this._config.requireToUrl(u.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,N=!1)=>{this.configure(h,N)},s.__$__nodeRequire=B.global.nodeRequire,s}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let s=this._moduleIdProvider.getStrModuleId(u),h=this._config.moduleIdToPaths(s),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||N.test(s))&&h.push("node|"+s);let b=-1,g=e=>{if(b++,b>=h.length)this._onLoadError(u,e);else{let E=h[b],A=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[u]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}A.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=E),A.record(11,E),this._onLoad(u)},p=>{A.record(12,E),g(p)})}};g(null)}_loadPluginDependency(u,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],N,null,null)};h.error=N=>{this._config.onError(this._createLoadError(s.id,N))},u.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(u){let s=u.dependencies;if(s)for(let h=0,N=s.length;h<N;h++){let b=s[h];if(b===r.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(b===r.MODULE){u.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){u.unresolvedDependenciesCount--;continue}let g=this._modules2[b.id];if(g&&g.isComplete()){if(g.error){u.onDependencyError(g.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,u.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(u.id),b instanceof c){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let s=this.getRecorder();if(u.isComplete())return;let h=u.dependencies,N=[];if(h)for(let E=0,A=h.length;E<A;E++){let p=h[E];if(p===r.EXPORTS){N[E]=u.exports;continue}if(p===r.MODULE){N[E]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(p===r.REQUIRE){N[E]=this._createRequire(u.moduleIdResolver);continue}let _=this._modules2[p.id];if(_){N[E]=_.exports;continue}N[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(A=>this._moduleIdProvider.getStrModuleId(A));u.complete(s,this._config,N,b);let g=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,g)for(let E=0,A=g.length;E<A;E++){let p=g[E],_=this._modules2[p];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let e=this._inversePluginDependencies2.get(u.id);if(e){this._inversePluginDependencies2.delete(u.id);for(let E=0,A=e.length;E<A;E++)this._loadPluginDependency(u.exports,e[E])}}}B.ModuleManager=w})(fe||(fe={}));var te,fe;(function(B){const t=new B.Environment;let P=null;const F=function(f,u,s){typeof f!="string"&&(s=u,u=f,f=null),(typeof u!="object"||!Array.isArray(u))&&(s=u,u=null),u||(u=["require","exports","module"]),f?P.defineModule(f,u,s,null,null):P.enqueueDefineAnonymousModule(u,s)};F.amd={jQuery:!0};const r=function(f,u=!1){P.configure(f,u)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=r,c.getConfig=function(){return P.getConfig().getOptionsLiteral()},c.reset=function(){P=P.reset()},c.getBuildInfo=function(){return P.getBuildInfo()},c.getStats=function(){return P.getLoaderEvents()},c.define=F;function w(){if(typeof B.global.require<"u"||typeof require<"u"){const f=B.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const u=B.ensureRecordedNodeRequire(P.getRecorder(),f);B.global.nodeRequire=u,c.nodeRequire=u,c.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(B.global.define=F),B.global.require=c)}B.init=w,(typeof B.global.define!="function"||!B.global.define.amd)&&(P=new B.ModuleManager(t,B.createScriptLoader(t),F,c,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&c.config(B.global.require),te=function(){return F.apply(null,arguments)},te.amd=F.amd,typeof doNotInitLoader>"u"&&w())})(fe||(fe={})),te(ne[69],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function P(f,u,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const b=u.toUrl(f+".css");F(f,b,()=>{s({})},g=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=P;function F(f,u,s,h){if(r(f,u)){s();return}c(f,u,s,h)}function r(f,u){const s=window.document.getElementsByTagName("link");for(let h=0,N=s.length;h<N;h++){const b=s[h].getAttribute("data-name"),g=s[h].getAttribute("href");if(b===f||g===u)return!0}return!1}function c(f,u,s,h){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",f),w(f,N,s,h),N.setAttribute("href",u),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(N)}function w(f,u,s,h){const N=()=>{u.removeEventListener("load",b),u.removeEventListener("error",g)},b=e=>{N(),s()},g=e=>{N(),h(e)};u.addEventListener("load",b),u.addEventListener("error",g)}}),te("vs/nls",["require","exports"],function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let P=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function r(A,p){let _;return p.length===0?_=A:_=A.replace(/\{(\d+)\}/g,(m,l)=>{const o=l[0],i=p[o];let a=m;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),P&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function c(A,p){let _=A[p];return _||(_=A["*"],_)?_:null}function w(A){return A.charAt(A.length-1)==="/"?A:A+"/"}async function f(A,p,_){const m=w(A)+w(p)+"vscode/"+w(_),l=await fetch(m);if(l.ok)return await l.json();throw new Error(`${l.status} - ${l.statusText}`)}function u(A){return function(p,_){const m=Array.prototype.slice.call(arguments,2);return r(A[p],m)}}function s(A){return(p,_,...m)=>({value:r(A[p],m),original:r(_,m)})}function h(A,p,..._){return r(p,_)}t.localize=h;function N(A,p,..._){const m=r(p,_);return{value:m,original:m}}t.localize2=N;function b(A){}t.getConfiguredDefaultLocale=b;function g(A){P=A}t.setPseudoTranslation=g;function e(A,p){return{localize:u(p[A]),localize2:s(p[A]),getConfiguredDefaultLocale:p.getConfiguredDefaultLocale??(_=>{})}}t.create=e;function E(A,p,_,m){const l=m["vs/nls"]??{};if(!A||A.length===0)return _({localize:h,localize2:N,getConfiguredDefaultLocale:()=>l.availableLanguages?.["*"]});const o=l.availableLanguages?c(l.availableLanguages,A):null,i=o===null||o===F;let a=".nls";i||(a=a+"."+o);const L=d=>{Array.isArray(d)?(d.localize=u(d),d.localize2=s(d)):(d.localize=u(d[A]),d.localize2=s(d[A])),d.getConfiguredDefaultLocale=()=>l.availableLanguages?.["*"],_(d)};typeof l.loadBundle=="function"?l.loadBundle(A,o,(d,v)=>{d?p([A+".nls"],L):L(v)}):l.translationServiceUrl&&!i?(async()=>{try{const d=await f(l.translationServiceUrl,o,A);return L(d)}catch(d){if(!o.includes("-"))return console.error(d),p([A+".nls"],L);try{const v=o.split("-")[0],M=await f(l.translationServiceUrl,v,A);return l.availableLanguages??={},l.availableLanguages["*"]=v,L(M)}catch(v){return console.error(v),p([A+".nls"],L)}}})():p([A+a],L,d=>{if(a===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${o}. Falling back to the default language:`,d),p([A+".nls"],L)})}t.load=E}),function(){const B=globalThis.MonacoEnvironment,t=B&&B.baseUrl?B.baseUrl:"../../../";function P(h,N){if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(h,N)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(h,N)}catch(b){console.warn(b);return}}const F=P("amdLoader",{createScriptURL:h=>h,createScript:(h,...N)=>{const b=N.slice(0,-1).join(","),g=N.pop().toString();return`(function anonymous(${b}) { ${g}
})`}});function r(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((h,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,N);return}F?importScripts(F.createScriptURL(b)):importScripts(b),h()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function f(h){c().then(()=>{w(),require([h],function(N){setTimeout(function(){const b=N.create((g,e)=>{globalThis.postMessage(g,e)},null);for(globalThis.onmessage=g=>b.onmessage(g.data,g.ports);s.length>0;){const g=s.shift();b.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let u=!0;const s=[];globalThis.onmessage=h=>{if(!u){s.push(h);return}u=!1,f(h.data)}}(),te(ne[9],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFindFirst=t.findMaxIdxBy=t.findFirstMinBy=t.findLastMaxBy=t.findFirstMaxBy=t.MonotonousArray=t.findFirstIdxMonotonous=t.findFirstIdxMonotonousOrArrLen=t.findFirstMonotonous=t.findLastIdxMonotonous=t.findLastMonotonous=t.findLastIdx=t.findLast=void 0;function P(E,A,p){const _=F(E,A);if(_!==-1)return E[_]}t.findLast=P;function F(E,A,p=E.length-1){for(let _=p;_>=0;_--){const m=E[_];if(A(m))return _}return-1}t.findLastIdx=F;function r(E,A){const p=c(E,A);return p===-1?void 0:E[p]}t.findLastMonotonous=r;function c(E,A,p=0,_=E.length){let m=p,l=_;for(;m<l;){const o=Math.floor((m+l)/2);A(E[o])?m=o+1:l=o}return m-1}t.findLastIdxMonotonous=c;function w(E,A){const p=f(E,A);return p===E.length?void 0:E[p]}t.findFirstMonotonous=w;function f(E,A,p=0,_=E.length){let m=p,l=_;for(;m<l;){const o=Math.floor((m+l)/2);A(E[o])?l=o:m=o+1}return m}t.findFirstIdxMonotonousOrArrLen=f;function u(E,A,p=0,_=E.length){const m=f(E,A,p,_);return m===E.length?-1:m}t.findFirstIdxMonotonous=u;class s{static{this.assertInvariants=!1}constructor(A){this._array=A,this._findLastMonotonousLastIdx=0}findLastMonotonous(A){if(s.assertInvariants){if(this._prevFindLastPredicate){for(const _ of this._array)if(this._prevFindLastPredicate(_)&&!A(_))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=A}const p=c(this._array,A,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}t.MonotonousArray=s;function h(E,A){if(E.length===0)return;let p=E[0];for(let _=1;_<E.length;_++){const m=E[_];A(m,p)>0&&(p=m)}return p}t.findFirstMaxBy=h;function N(E,A){if(E.length===0)return;let p=E[0];for(let _=1;_<E.length;_++){const m=E[_];A(m,p)>=0&&(p=m)}return p}t.findLastMaxBy=N;function b(E,A){return h(E,(p,_)=>-A(p,_))}t.findFirstMinBy=b;function g(E,A){if(E.length===0)return-1;let p=0;for(let _=1;_<E.length;_++){const m=E[_];A(m,E[p])>0&&(p=_)}return p}t.findMaxIdxBy=g;function e(E,A){for(const p of E){const _=A(p);if(_!==void 0)return _}}t.mapFindFirst=e}),te(ne[34],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.intersection=t.diffMaps=t.diffSets=t.groupBy=void 0;function P(w,f){const u=Object.create(null);for(const s of w){const h=f(s);let N=u[h];N||(N=u[h]=[]),N.push(s)}return u}t.groupBy=P;function F(w,f){const u=[],s=[];for(const h of w)f.has(h)||u.push(h);for(const h of f)w.has(h)||s.push(h);return{removed:u,added:s}}t.diffSets=F;function r(w,f){const u=[],s=[];for(const[h,N]of w)f.has(h)||u.push(N);for(const[h,N]of f)w.has(h)||s.push(N);return{removed:u,added:s}}t.diffMaps=r;function c(w,f){const u=new Set;for(const s of f)w.has(s)&&u.add(s);return u}t.intersection=c}),te(ne[35],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function P(f,u){const s=Math.pow(10,u);return Math.round(f*s)/s}class F{constructor(u,s,h,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,s){return u.r===s.r&&u.g===s.g&&u.b===s.b&&u.a===s.a}}t.RGBA=F;class r{constructor(u,s,h,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,s),0),3),this.l=P(Math.max(Math.min(1,h),0),3),this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.l===s.l&&u.a===s.a}static fromRGBA(u){const s=u.r/255,h=u.g/255,N=u.b/255,b=u.a,g=Math.max(s,h,N),e=Math.min(s,h,N);let E=0,A=0;const p=(e+g)/2,_=g-e;if(_>0){switch(A=Math.min(p<=.5?_/(2*p):_/(2-2*p),1),g){case s:E=(h-N)/_+(h<N?6:0);break;case h:E=(N-s)/_+2;break;case N:E=(s-h)/_+4;break}E*=60,E=Math.round(E)}return new r(E,A,p,b)}static _hue2rgb(u,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?u+(s-u)*6*h:h<1/2?s:h<2/3?u+(s-u)*(2/3-h)*6:u}static toRGBA(u){const s=u.h/360,{s:h,l:N,a:b}=u;let g,e,E;if(h===0)g=e=E=N;else{const A=N<.5?N*(1+h):N+h-N*h,p=2*N-A;g=r._hue2rgb(p,A,s+1/3),e=r._hue2rgb(p,A,s),E=r._hue2rgb(p,A,s-1/3)}return new F(Math.round(g*255),Math.round(e*255),Math.round(E*255),b)}}t.HSLA=r;class c{constructor(u,s,h,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,s),0),3),this.v=P(Math.max(Math.min(1,h),0),3),this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.v===s.v&&u.a===s.a}static fromRGBA(u){const s=u.r/255,h=u.g/255,N=u.b/255,b=Math.max(s,h,N),g=Math.min(s,h,N),e=b-g,E=b===0?0:e/b;let A;return e===0?A=0:b===s?A=((h-N)/e%6+6)%6:b===h?A=(N-s)/e+2:A=(s-h)/e+4,new c(Math.round(A*60),E,b,u.a)}static toRGBA(u){const{h:s,s:h,v:N,a:b}=u,g=N*h,e=g*(1-Math.abs(s/60%2-1)),E=N-g;let[A,p,_]=[0,0,0];return s<60?(A=g,p=e):s<120?(A=e,p=g):s<180?(p=g,_=e):s<240?(p=e,_=g):s<300?(A=e,_=g):s<=360&&(A=g,_=e),A=Math.round((A+E)*255),p=Math.round((p+E)*255),_=Math.round((_+E)*255),new F(A,p,_,b)}}t.HSVA=c;class w{static fromHex(u){return w.Format.CSS.parseHex(u)||w.red}static equals(u,s){return!u&&!s?!0:!u||!s?!1:u.equals(s)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:c.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof F)this.rgba=u;else if(u instanceof r)this._hsla=u,this.rgba=r.toRGBA(u);else if(u instanceof c)this._hsva=u,this.rgba=c.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&F.equals(this.rgba,u.rgba)&&r.equals(this.hsla,u.hsla)&&c.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=w._relativeLuminanceForComponent(this.rgba.r),s=w._relativeLuminanceForComponent(this.rgba.g),h=w._relativeLuminanceForComponent(this.rgba.b),N=.2126*u+.7152*s+.0722*h;return P(N,4)}static _relativeLuminanceForComponent(u){const s=u/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(u){const s=this.getRelativeLuminance(),h=u.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const s=this.getRelativeLuminance(),h=u.getRelativeLuminance();return s>h}isDarkerThan(u){const s=this.getRelativeLuminance(),h=u.getRelativeLuminance();return s<h}lighten(u){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:s,g:h,b:N,a:b}=this.rgba;return new w(new F(s,h,N,b*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const s=u.rgba,h=this.rgba.a,N=s.a,b=h+N*(1-h);if(b<1e-6)return w.transparent;const g=this.rgba.r*h/b+s.r*N*(1-h)/b,e=this.rgba.g*h/b+s.g*N*(1-h)/b,E=this.rgba.b*h/b+s.b*N*(1-h)/b;return new w(new F(g,e,E,b))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:s,g:h,b:N,a:b}=this.rgba;return new w(new F(u.rgba.r-b*(u.rgba.r-s),u.rgba.g-b*(u.rgba.g-h),u.rgba.b-b*(u.rgba.b-N),1))}flatten(...u){const s=u.reduceRight((h,N)=>w._flatten(N,h));return w._flatten(this,s)}static _flatten(u,s){const h=1-u.rgba.a;return new w(new F(h*s.rgba.r+u.rgba.a*u.rgba.r,h*s.rgba.g+u.rgba.a*u.rgba.g,h*s.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(u,s,h){if(u.isLighterThan(s))return u;h=h||.5;const N=u.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(b-N)/b,u.lighten(h)}static getDarkerColor(u,s,h){if(u.isDarkerThan(s))return u;h=h||.5;const N=u.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(N-b)/N,u.darken(h)}static{this.white=new w(new F(255,255,255,1))}static{this.black=new w(new F(0,0,0,1))}static{this.red=new w(new F(255,0,0,1))}static{this.blue=new w(new F(0,0,255,1))}static{this.green=new w(new F(0,255,0,1))}static{this.cyan=new w(new F(0,255,255,1))}static{this.lightgrey=new w(new F(211,211,211,1))}static{this.transparent=new w(new F(0,0,0,0))}}t.Color=w,function(f){let u;(function(s){let h;(function(N){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:f.Format.CSS.formatRGBA(i)}N.formatRGB=b;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}N.formatRGBA=g;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(i)}N.formatHSL=e;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}N.formatHSLA=E;function A(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function p(i){return`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}`}N.formatHex=p;function _(i,a=!1){return a&&i.rgba.a===1?f.Format.CSS.formatHex(i):`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}${A(Math.round(i.rgba.a*255))}`}N.formatHexA=_;function m(i){return i.isOpaque()?f.Format.CSS.formatHex(i):f.Format.CSS.formatRGBA(i)}N.format=m;function l(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const L=16*o(i.charCodeAt(1))+o(i.charCodeAt(2)),d=16*o(i.charCodeAt(3))+o(i.charCodeAt(4)),v=16*o(i.charCodeAt(5))+o(i.charCodeAt(6));return new f(new F(L,d,v,1))}if(a===9){const L=16*o(i.charCodeAt(1))+o(i.charCodeAt(2)),d=16*o(i.charCodeAt(3))+o(i.charCodeAt(4)),v=16*o(i.charCodeAt(5))+o(i.charCodeAt(6)),M=16*o(i.charCodeAt(7))+o(i.charCodeAt(8));return new f(new F(L,d,v,M/255))}if(a===4){const L=o(i.charCodeAt(1)),d=o(i.charCodeAt(2)),v=o(i.charCodeAt(3));return new f(new F(16*L+L,16*d+d,16*v+v))}if(a===5){const L=o(i.charCodeAt(1)),d=o(i.charCodeAt(2)),v=o(i.charCodeAt(3)),M=o(i.charCodeAt(4));return new f(new F(16*L+L,16*d+d,16*v+v,(16*M+M)/255))}return null}N.parseHex=l;function o(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(u=f.Format||(f.Format={}))}(w||(t.Color=w={}))}),te(ne[36],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(r,c,w,f){this.originalStart=r,this.originalLength=c,this.modifiedStart=w,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),te(ne[3],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.ReadonlyError=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}t.ErrorHandler=P,t.errorHandler=new P;function F(o){t.errorHandler.setUnexpectedErrorHandler(o)}t.setUnexpectedErrorHandler=F;function r(o){if(!o||typeof o!="object")return!1;const i=o;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=r;function c(o){s(o)||t.errorHandler.onUnexpectedError(o)}t.onUnexpectedError=c;function w(o){s(o)||t.errorHandler.onUnexpectedExternalError(o)}t.onUnexpectedExternalError=w;function f(o){if(o instanceof Error){const{name:i,message:a}=o,L=o.stacktrace||o.stack;return{$isError:!0,name:i,message:a,stack:L,noTelemetry:m.isErrorNoTelemetry(o)}}return o}t.transformErrorForSerialization=f;const u="Canceled";function s(o){return o instanceof h?!0:o instanceof Error&&o.name===u&&o.message===u}t.isCancellationError=s;class h extends Error{constructor(){super(u),this.name=this.message}}t.CancellationError=h;function N(){const o=new Error(u);return o.name=o.message,o}t.canceled=N;function b(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}t.illegalArgument=b;function g(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}t.illegalState=g;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function E(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}t.getErrorMessage=E;class A extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.NotImplementedError=A;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.NotSupportedError=p;class _ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=_;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const a=new m;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.ErrorNoTelemetry=m;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}t.BugIndicatingError=l}),te(ne[6],re([0,1,3,9]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.reverseOrder=t.booleanComparator=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.forEachWithNeighbors=t.forEachAdjacent=t.groupAdjacentBy=t.groupBy=t.quickSelect=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function r(x,z=0){return x[x.length-(1+z)]}t.tail=r;function c(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.tail2=c;function w(x,z,V=(X,j)=>X===j){if(x===z)return!0;if(!x||!z||x.length!==z.length)return!1;for(let X=0,j=x.length;X<j;X++)if(!V(x[X],z[X]))return!1;return!0}t.equals=w;function f(x,z){const V=x.length-1;z<V&&(x[z]=x[V]),x.pop()}t.removeFastWithoutKeepingOrder=f;function u(x,z,V){return s(x.length,X=>V(x[X],z))}t.binarySearch=u;function s(x,z){let V=0,X=x-1;for(;V<=X;){const j=(V+X)/2|0,$=z(j);if($<0)V=j+1;else if($>0)X=j-1;else return j}return-(V+1)}t.binarySearch2=s;function h(x,z,V){if(x=x|0,x>=z.length)throw new TypeError("invalid index");const X=z[Math.floor(z.length*Math.random())],j=[],$=[],Y=[];for(const K of z){const ie=V(K,X);ie<0?j.push(K):ie>0?$.push(K):Y.push(K)}return x<j.length?h(x,j,V):x<j.length+Y.length?Y[0]:h(x-(j.length+Y.length),$,V)}t.quickSelect=h;function N(x,z){const V=[];let X;for(const j of x.slice(0).sort(z))!X||z(X[0],j)!==0?(X=[j],V.push(X)):X.push(j);return V}t.groupBy=N;function*b(x,z){let V,X;for(const j of x)X!==void 0&&z(X,j)?V.push(j):(V&&(yield V),V=[j]),X=j;V&&(yield V)}t.groupAdjacentBy=b;function g(x,z){for(let V=0;V<=x.length;V++)z(V===0?void 0:x[V-1],V===x.length?void 0:x[V])}t.forEachAdjacent=g;function e(x,z){for(let V=0;V<x.length;V++)z(V===0?void 0:x[V-1],x[V],V+1===x.length?void 0:x[V+1])}t.forEachWithNeighbors=e;function E(x,z,V){const X=[];function j(K,ie,le){if(ie===0&&le.length===0)return;const ue=X[X.length-1];ue&&ue.start+ue.deleteCount===K?(ue.deleteCount+=ie,ue.toInsert.push(...le)):X.push({start:K,deleteCount:ie,toInsert:le})}let $=0,Y=0;for(;;){if($===x.length){j($,0,z.slice(Y));break}if(Y===z.length){j($,x.length-$,[]);break}const K=x[$],ie=z[Y],le=V(K,ie);le===0?($+=1,Y+=1):le<0?(j($,1,[]),$+=1):le>0&&(j($,0,[ie]),Y+=1)}return X}t.sortedDiff=E;function A(x,z,V){const X=E(x,z,V),j=[],$=[];for(const Y of X)j.push(...x.slice(Y.start,Y.start+Y.deleteCount)),$.push(...Y.toInsert);return{removed:j,added:$}}t.delta=A;function p(x,z,V){if(V===0)return[];const X=x.slice(0,V).sort(z);return m(x,z,X,V,x.length),X}t.top=p;function _(x,z,V,X,j){return V===0?Promise.resolve([]):new Promise(($,Y)=>{(async()=>{const K=x.length,ie=x.slice(0,V).sort(z);for(let le=V,ue=Math.min(V+X,K);le<K;le=ue,ue=Math.min(ue+X,K)){if(le>V&&await new Promise(ce=>setTimeout(ce)),j&&j.isCancellationRequested)throw new P.CancellationError;m(x,z,ie,le,ue)}return ie})().then($,Y)})}t.topAsync=_;function m(x,z,V,X,j){for(const $=V.length;X<j;X++){const Y=x[X];if(z(Y,V[$-1])<0){V.pop();const K=(0,F.findFirstIdxMonotonousOrArrLen)(V,ie=>z(Y,ie)<0);V.splice(K,0,Y)}}}function l(x){return x.filter(z=>!!z)}t.coalesce=l;function o(x){let z=0;for(let V=0;V<x.length;V++)x[V]&&(x[z]=x[V],z+=1);x.length=z}t.coalesceInPlace=o;function i(x,z,V){x.splice(V,0,x.splice(z,1)[0])}t.move=i;function a(x){return!Array.isArray(x)||x.length===0}t.isFalsyOrEmpty=a;function L(x){return Array.isArray(x)&&x.length>0}t.isNonEmptyArray=L;function d(x,z=V=>V){const V=new Set;return x.filter(X=>{const j=z(X);return V.has(j)?!1:(V.add(j),!0)})}t.distinct=d;function v(x){const z=new Set;return V=>{const X=x(V);return z.has(X)?!1:(z.add(X),!0)}}t.uniqueFilter=v;function M(x,z){return x.length>0?x[0]:z}t.firstOrDefault=M;function R(x,z){return x.length>0?x[x.length-1]:z}t.lastOrDefault=R;function D(x,z,V=(X,j)=>X===j){let X=0;for(let j=0,$=Math.min(x.length,z.length);j<$&&V(x[j],z[j]);j++)X++;return X}t.commonPrefixLength=D;function k(x){return[].concat(...x)}t.flatten=k;function y(x,z){let V=typeof z=="number"?x:0;typeof z=="number"?V=x:(V=0,z=x);const X=[];if(V<=z)for(let j=V;j<z;j++)X.push(j);else for(let j=V;j>z;j--)X.push(j);return X}t.range=y;function I(x,z,V){return x.reduce((X,j)=>(X[z(j)]=V?V(j):j,X),Object.create(null))}t.index=I;function T(x,z){return x.push(z),()=>O(x,z)}t.insert=T;function O(x,z){const V=x.indexOf(z);if(V>-1)return x.splice(V,1),z}t.remove=O;function q(x,z,V){const X=x.slice(0,z),j=x.slice(z);return X.concat(V,j)}t.arrayInsert=q;function S(x,z){let V;if(typeof z=="number"){let X=z;V=()=>{const j=Math.sin(X++)*179426549;return j-Math.floor(j)}}else V=Math.random;for(let X=x.length-1;X>0;X-=1){const j=Math.floor(V()*(X+1)),$=x[X];x[X]=x[j],x[j]=$}}t.shuffle=S;function W(x,z){const V=x.indexOf(z);V>-1&&(x.splice(V,1),x.unshift(z))}t.pushToStart=W;function Q(x,z){const V=x.indexOf(z);V>-1&&(x.splice(V,1),x.push(z))}t.pushToEnd=Q;function H(x,z){for(const V of z)x.push(V)}t.pushMany=H;function Z(x,z){return Array.isArray(x)?x.map(z):z(x)}t.mapArrayOrNot=Z;function ee(x){return Array.isArray(x)?x:[x]}t.asArray=ee;function n(x){return x[Math.floor(Math.random()*x.length)]}t.getRandomElement=n;function ae(x,z,V){const X=be(x,z),j=x.length,$=V.length;x.length=j+$;for(let Y=j-1;Y>=X;Y--)x[Y+$]=x[Y];for(let Y=0;Y<$;Y++)x[Y+X]=V[Y]}t.insertInto=ae;function he(x,z,V,X){const j=be(x,z);let $=x.splice(j,V);return $===void 0&&($=[]),ae(x,j,X),$}t.splice=he;function be(x,z){return z<0?Math.max(z+x.length,0):Math.min(z,x.length)}var Le;(function(x){function z($){return $<0}x.isLessThan=z;function V($){return $<=0}x.isLessThanOrEqual=V;function X($){return $>0}x.isGreaterThan=X;function j($){return $===0}x.isNeitherLessOrGreaterThan=j,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(Le||(t.CompareResult=Le={}));function ye(x,z){return(V,X)=>z(x(V),x(X))}t.compareBy=ye;function _e(...x){return(z,V)=>{for(const X of x){const j=X(z,V);if(!Le.isNeitherLessOrGreaterThan(j))return j}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=_e;const Ne=(x,z)=>x-z;t.numberComparator=Ne;const ke=(x,z)=>(0,t.numberComparator)(x?1:0,z?1:0);t.booleanComparator=ke;function Te(x){return(z,V)=>-x(z,V)}t.reverseOrder=Te;class Ie{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let V=this.firstIdx;for(;V<this.items.length&&z(this.items[V]);)V++;const X=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,X}takeFromEndWhile(z){let V=this.lastIdx;for(;V>=0&&z(this.items[V]);)V--;const X=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,X}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const V=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,V}}t.ArrayQueue=Ie;class Ae{static{this.empty=new Ae(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(V=>(z(V),!0))}toArray(){const z=[];return this.iterate(V=>(z.push(V),!0)),z}filter(z){return new Ae(V=>this.iterate(X=>z(X)?V(X):!0))}map(z){return new Ae(V=>this.iterate(X=>V(z(X))))}some(z){let V=!1;return this.iterate(X=>(V=z(X),!V)),V}findFirst(z){let V;return this.iterate(X=>z(X)?(V=X,!1):!0),V}findLast(z){let V;return this.iterate(X=>(z(X)&&(V=X),!0)),V}findLastMaxBy(z){let V,X=!0;return this.iterate(j=>((X||Le.isGreaterThan(z(j,V)))&&(X=!1,V=j),!0)),V}}t.CallbackIterable=Ae}),te(ne[13],re([0,1,3]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.softAssert=t.assert=t.assertNever=t.ok=void 0;function F(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=F;function r(s,h="Unreachable"){throw new Error(h)}t.assertNever=r;function c(s){if(!s)throw new P.BugIndicatingError("Assertion Failed")}t.assert=c;function w(s){s||(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}t.softAssert=w;function f(s){if(!s()){debugger;s(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}t.assertFn=f;function u(s,h){let N=0;for(;N<s.length-1;){const b=s[N],g=s[N+1];if(!h(b,g))return!1;N++}return!0}t.checkAdjacentItems=u}),te(ne[19],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=void 0;function P(F,r){const c=this;let w=!1,f;return function(){if(w)return f;if(w=!0,r)try{f=F.apply(c,arguments)}finally{r()}else f=F.apply(c,arguments);return f}}t.createSingleCallFunction=P}),te(ne[20],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(F){function r(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}F.is=r;const c=Object.freeze([]);function w(){return c}F.empty=w;function*f(i){yield i}F.single=f;function u(i){return r(i)?i:f(i)}F.wrap=u;function s(i){return i||c}F.from=s;function*h(i){for(let a=i.length-1;a>=0;a--)yield i[a]}F.reverse=h;function N(i){return!i||i[Symbol.iterator]().next().done===!0}F.isEmpty=N;function b(i){return i[Symbol.iterator]().next().value}F.first=b;function g(i,a){for(const L of i)if(a(L))return!0;return!1}F.some=g;function e(i,a){for(const L of i)if(a(L))return L}F.find=e;function*E(i,a){for(const L of i)a(L)&&(yield L)}F.filter=E;function*A(i,a){let L=0;for(const d of i)yield a(d,L++)}F.map=A;function*p(...i){for(const a of i)yield*a}F.concat=p;function _(i,a,L){let d=L;for(const v of i)d=a(d,v);return d}F.reduce=_;function*m(i,a,L=i.length){for(a<0&&(a+=i.length),L<0?L+=i.length:L>i.length&&(L=i.length);a<L;a++)yield i[a]}F.slice=m;function l(i,a=Number.POSITIVE_INFINITY){const L=[];if(a===0)return[L,i];const d=i[Symbol.iterator]();for(let v=0;v<a;v++){const M=d.next();if(M.done)return[L,F.empty()];L.push(M.value)}return[L,{[Symbol.iterator](){return d}}]}F.consume=l;async function o(i){const a=[];for await(const L of i)a.push(L);return Promise.resolve(a)}F.asyncToArray=o})(P||(t.Iterable=P={}))}),te(ne[37],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(P||(t.KeyCode=P={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,A){this._keyCodeToStr[E]=A,this._strToKeyCode[A.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const c=new r,w=new r,f=new r;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],s=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],A=[],p=[];for(const _ of E){const[m,l,o,i,a,L,d,v,M]=_;if(p[l]||(p[l]=!0,u[l]=o,s[o]=l,h[o.toLowerCase()]=l,m&&(t.IMMUTABLE_CODE_TO_KEY_CODE[l]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[i]=l))),!A[i]){if(A[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${o}`);c.define(i,a),w.define(i,v||a),f.define(i,M||v||a)}L&&(t.EVENT_KEY_CODE_MAP[L]=i),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=i)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function E(o){return c.keyCodeToStr(o)}e.toString=E;function A(o){return c.strToKeyCode(o)}e.fromString=A;function p(o){return w.keyCodeToStr(o)}e.toUserSettingsUS=p;function _(o){return f.keyCodeToStr(o)}e.toUserSettingsGeneral=_;function m(o){return w.strToKeyCode(o)||f.strToKeyCode(o)}e.fromUserSettings=m;function l(o){if(o>=98&&o<=113)return null;switch(o){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(o)}e.toElectronAccelerator=l})(N||(t.KeyCodeUtils=N={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function g(e,E){const A=(E&65535)<<16>>>0;return(e|A)>>>0}t.KeyChord=g}),te(ne[38],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class P{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=P}),te(ne[21],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(c){this.element=c,this.next=P.Undefined,this.prev=P.Undefined}}class F{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let c=this._first;for(;c!==P.Undefined;){const w=c.next;c.prev=P.Undefined,c.next=P.Undefined,c=w}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,w){const f=new P(c);if(this._first===P.Undefined)this._first=f,this._last=f;else if(w){const s=this._last;this._last=f,f.prev=s,s.next=f}else{const s=this._first;this._first=f,f.next=s,s.prev=f}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(f))}}shift(){if(this._first!==P.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==P.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==P.Undefined&&c.next!==P.Undefined){const w=c.prev;w.next=c.next,c.next.prev=w}else c.prev===P.Undefined&&c.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):c.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):c.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==P.Undefined;)yield c.element,c=c.next}}t.LinkedList=F}),te(ne[22],re([0,1]),function(B,t){"use strict";var P,F,r;Object.defineProperty(t,"__esModule",{value:!0}),t.mapsStrictEqualIgnoreOrder=t.SetMap=t.BidirectionalMap=t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function c(m,l,o){let i=m.get(l);return i===void 0&&(i=o,m.set(l,i)),i}t.getOrSet=c;function w(m){const l=[];return m.forEach((o,i)=>{l.push(`${i} => ${o}`)}),`Map(${m.size}) {${l.join(", ")}}`}t.mapToString=w;function f(m){const l=[];return m.forEach(o=>{l.push(o)}),`Set(${m.size}) {${l.join(", ")}}`}t.setToString=f;class u{constructor(l,o){this.uri=l,this.value=o}}function s(m){return Array.isArray(m)}class h{static{this.defaultToKey=l=>l.toString()}constructor(l,o){if(this[P]="ResourceMap",l instanceof h)this.map=new Map(l.map),this.toKey=o??h.defaultToKey;else if(s(l)){this.map=new Map,this.toKey=o??h.defaultToKey;for(const[i,a]of l)this.set(i,a)}else this.map=new Map,this.toKey=l??h.defaultToKey}set(l,o){return this.map.set(this.toKey(l),new u(l,o)),this}get(l){return this.map.get(this.toKey(l))?.value}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,o){typeof o<"u"&&(l=l.bind(o));for(const[i,a]of this.map)l(a.value,a.uri,this)}*values(){for(const l of this.map.values())yield l.value}*keys(){for(const l of this.map.values())yield l.uri}*entries(){for(const l of this.map.values())yield[l.uri,l.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.map)yield[l.uri,l.value]}}t.ResourceMap=h;class N{constructor(l,o){this[F]="ResourceSet",!l||typeof l=="function"?this._map=new h(l):(this._map=new h(o),l.forEach(this.add,this))}get size(){return this._map.size}add(l){return this._map.set(l,l),this}clear(){this._map.clear()}delete(l){return this._map.delete(l)}forEach(l,o){this._map.forEach((i,a)=>l.call(o,a,a,this))}has(l){return this._map.has(l)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=N;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class g{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(l){return this._map.has(l)}get(l,o=0){const i=this._map.get(l);if(i)return o!==0&&this.touch(i,o),i.value}set(l,o,i=0){let a=this._map.get(l);if(a)a.value=o,i!==0&&this.touch(a,i);else{switch(a={key:l,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(l,a),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const o=this._map.get(l);if(o)return this._map.delete(l),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}forEach(l,o){const i=this._state;let a=this._head;for(;a;){if(o?l.bind(o)(a.value,a.key,this):l(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const l=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:i.key,done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return a}values(){const l=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:i.value,done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return a}entries(){const l=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:[i.key,i.value],done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return a}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(l>=this.size)return;if(l===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>l;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const o=l.next,i=l.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}l.next=void 0,l.previous=void 0,this._state++}touch(l,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(l===this._head)return;const i=l.next,a=l.previous;l===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(o===2){if(l===this._tail)return;const i=l.next,a=l.previous;l===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((o,i)=>{l.push([i,o])}),l}fromJSON(l){this.clear();for(const[o,i]of l)this.set(o,i)}}t.LinkedMap=g;class e extends g{constructor(l,o=1){super(),this._limit=l,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,o=2){return super.get(l,o)}peek(l){return super.get(l,0)}set(l,o){return super.set(l,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=e;class E{constructor(){this.map=new Map}add(l){return this.map.set(l,(this.map.get(l)||0)+1),this}delete(l){let o=this.map.get(l)||0;return o===0?!1:(o--,o===0?this.map.delete(l):this.map.set(l,o),!0)}has(l){return this.map.has(l)}}t.CounterSet=E;class A{constructor(l){if(this._m1=new Map,this._m2=new Map,l)for(const[o,i]of l)this.set(o,i)}clear(){this._m1.clear(),this._m2.clear()}set(l,o){this._m1.set(l,o),this._m2.set(o,l)}get(l){return this._m1.get(l)}getKey(l){return this._m2.get(l)}delete(l){const o=this._m1.get(l);return o===void 0?!1:(this._m1.delete(l),this._m2.delete(o),!0)}forEach(l,o){this._m1.forEach((i,a)=>{l.call(o,i,a,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=A;class p{constructor(){this.map=new Map}add(l,o){let i=this.map.get(l);i||(i=new Set,this.map.set(l,i)),i.add(o)}delete(l,o){const i=this.map.get(l);i&&(i.delete(o),i.size===0&&this.map.delete(l))}forEach(l,o){const i=this.map.get(l);i&&i.forEach(o)}get(l){const o=this.map.get(l);return o||new Set}}t.SetMap=p;function _(m,l){if(m===l)return!0;if(m.size!==l.size)return!1;for(const[o,i]of m)if(!l.has(o)||l.get(o)!==i)return!1;for(const[o]of l)if(!m.has(o))return!1;return!0}t.mapsStrictEqualIgnoreOrder=_}),te(ne[10],re([0,1,6,34,22,19,20]),function(B,t,P,F,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.markAsDisposed=t.trackDisposable=t.setDisposableTracker=t.DisposableTracker=void 0;const f=!1;let u=null;class s{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(T){let O=this.livingDisposables.get(T);return O||(O={parent:null,source:null,isSingleton:!1,value:T,idx:s.idx++},this.livingDisposables.set(T,O)),O}trackDisposable(T){const O=this.getDisposableData(T);O.source||(O.source=new Error().stack)}setParent(T,O){const q=this.getDisposableData(T);q.parent=O}markAsDisposed(T){this.livingDisposables.delete(T)}markAsSingleton(T){this.getDisposableData(T).isSingleton=!0}getRootParent(T,O){const q=O.get(T);if(q)return q;const S=T.parent?this.getRootParent(this.getDisposableData(T.parent),O):T;return O.set(T,S),S}getTrackedDisposables(){const T=new Map;return[...this.livingDisposables.entries()].filter(([,q])=>q.source!==null&&!this.getRootParent(q,T).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(T=10,O){let q;if(O)q=O;else{const Z=new Map,ee=[...this.livingDisposables.values()].filter(ae=>ae.source!==null&&!this.getRootParent(ae,Z).isSingleton);if(ee.length===0)return;const n=new Set(ee.map(ae=>ae.value));if(q=ee.filter(ae=>!(ae.parent&&n.has(ae.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function S(Z){function ee(ae,he){for(;ae.length>0&&he.some(be=>typeof be=="string"?be===ae[0]:ae[0].match(be));)ae.shift()}const n=Z.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return ee(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const W=new r.SetMap;for(const Z of q){const ee=S(Z);for(let n=0;n<=ee.length;n++)W.add(ee.slice(0,n).join(`
`),Z)}q.sort((0,P.compareBy)(Z=>Z.idx,P.numberComparator));let Q="",H=0;for(const Z of q.slice(0,T)){H++;const ee=S(Z),n=[];for(let ae=0;ae<ee.length;ae++){let he=ee[ae];he=`(shared with ${W.get(ee.slice(0,ae+1).join(`
`)).size}/${q.length} leaks) at ${he}`;const Le=W.get(ee.slice(0,ae).join(`
`)),ye=(0,F.groupBy)([...Le].map(_e=>S(_e)[ae]),_e=>_e);delete ye[ee[ae]];for(const[_e,Ne]of Object.entries(ye))n.unshift(`    - stacktraces of ${Ne.length} other leaks continue with ${_e}`);n.unshift(he)}Q+=`


==================== Leaking disposable ${H}/${q.length}: ${Z.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return q.length>T&&(Q+=`


... and ${q.length-T} more leaking disposables

`),{leaks:q,details:Q}}}t.DisposableTracker=s;function h(I){u=I}if(t.setDisposableTracker=h,f){const I="__is_disposable_tracked__";h(new class{trackDisposable(T){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[I]||console.log(O)},3e3)}setParent(T,O){if(T&&T!==i.None)try{T[I]=!0}catch{}}markAsDisposed(T){if(T&&T!==i.None)try{T[I]=!0}catch{}}markAsSingleton(T){}})}function N(I){return u?.trackDisposable(I),I}t.trackDisposable=N;function b(I){u?.markAsDisposed(I)}t.markAsDisposed=b;function g(I,T){u?.setParent(I,T)}function e(I,T){if(u)for(const O of I)u.setParent(O,T)}function E(I){return u?.markAsSingleton(I),I}t.markAsSingleton=E;function A(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.isDisposable=A;function p(I){if(w.Iterable.is(I)){const T=[];for(const O of I)if(O)try{O.dispose()}catch(q){T.push(q)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.dispose=p;function _(I){for(const T of I)A(T)&&T.dispose();return[]}t.disposeIfDisposable=_;function m(...I){const T=l(()=>p(I));return e(I,T),T}t.combinedDisposable=m;function l(I){const T=N({dispose:(0,c.createSingleCallFunction)(()=>{b(T),I()})});return T}t.toDisposable=l;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,N(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return g(T,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(T),T.dispose()}}deleteAndLeak(T){T&&this._toDispose.has(T)&&(this._toDispose.delete(T),g(T,null))}}t.DisposableStore=o;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,N(this),g(this._store,this)}dispose(){b(this),this._store.dispose()}_register(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(T)}}t.Disposable=i;class a{constructor(){this._isDisposed=!1,N(this)}get value(){return this._isDisposed?void 0:this._value}set value(T){this._isDisposed||T===this._value||(this._value?.dispose(),T&&g(T,this),this._value=T)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const T=this._value;return this._value=void 0,T&&g(T,null),T}}t.MutableDisposable=a;class L{constructor(T){this._disposable=new a,this._isDisposed=!1,this._disposable.value=T}get value(){return this._disposable.value}set value(T){this._isDisposed||T===this._disposable.value||(this._disposable.value=T)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=L;class d{constructor(T){this._disposable=T,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=d;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(T){let O=T;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,b(this))},this}}t.SafeDisposable=v;class M{constructor(){this.references=new Map}acquire(T,...O){let q=this.references.get(T);q||(q={counter:0,object:this.createReferencedObject(T,...O)},this.references.set(T,q));const{object:S}=q,W=(0,c.createSingleCallFunction)(()=>{--q.counter===0&&(this.destroyReferencedObject(T,q.object),this.references.delete(T))});return q.counter++,{object:S,dispose:W}}}t.ReferenceCollection=M;class R{constructor(T){this.referenceCollection=T}async acquire(T,...O){const q=this.referenceCollection.acquire(T,...O);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(S){throw q.dispose(),S}}}t.AsyncReferenceCollection=R;class D{constructor(T){this.object=T}dispose(){}}t.ImmortalReference=D;function k(I){const T=new o;try{I(T)}finally{T.dispose()}}t.disposeOnReturn=k;class y{constructor(){this._store=new Map,this._isDisposed=!1,N(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(T){return this._store.has(T)}get size(){return this._store.size}get(T){return this._store.get(T)}set(T,O,q=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this._store.get(T)?.dispose(),this._store.set(T,O)}deleteAndDispose(T){this._store.get(T)?.dispose(),this._store.delete(T)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=y}),te(ne[23],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(c){return new F(c)}constructor(c){this._now=P&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=F}),te(ne[11],re([0,1,3,19,10,21,23]),function(B,t,P,F,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const f=!1,u=!1;var s;(function(k){k.None=()=>r.Disposable.None;function y(j){if(u){const{onDidAddListener:$}=j,Y=e.create();let K=0;j.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function I(j,$){return n(j,()=>{},0,void 0,!0,void 0,$)}k.defer=I;function T(j){return($,Y=null,K)=>{let ie=!1,le;return le=j(ue=>{if(!ie)return le?le.dispose():ie=!0,$.call(Y,ue)},null,K),ie&&le.dispose(),le}}k.once=T;function O(j,$,Y){return Z((K,ie=null,le)=>j(ue=>K.call(ie,$(ue)),null,le),Y)}k.map=O;function q(j,$,Y){return Z((K,ie=null,le)=>j(ue=>{$(ue),K.call(ie,ue)},null,le),Y)}k.forEach=q;function S(j,$,Y){return Z((K,ie=null,le)=>j(ue=>$(ue)&&K.call(ie,ue),null,le),Y)}k.filter=S;function W(j){return j}k.signal=W;function Q(...j){return($,Y=null,K)=>{const ie=(0,r.combinedDisposable)(...j.map(le=>le(ue=>$.call(Y,ue))));return ee(ie,K)}}k.any=Q;function H(j,$,Y,K){let ie=Y;return O(j,le=>(ie=$(ie,le),ie),K)}k.reduce=H;function Z(j,$){let Y;const K={onWillAddFirstListener(){Y=j(ie.fire,ie)},onDidRemoveLastListener(){Y?.dispose()}};$||y(K);const ie=new m(K);return $?.add(ie),ie.event}function ee(j,$){return $ instanceof Array?$.push(j):$&&$.add(j),j}function n(j,$,Y=100,K=!1,ie=!1,le,ue){let ce,de,De,Fe=0,Se;const Ce={leakWarningThreshold:le,onWillAddFirstListener(){ce=j(Ue=>{Fe++,de=$(de,Ue),K&&!De&&(ve.fire(de),de=void 0),Se=()=>{const qe=de;de=void 0,De=void 0,(!K||Fe>1)&&ve.fire(qe),Fe=0},typeof Y=="number"?(clearTimeout(De),De=setTimeout(Se,Y)):De===void 0&&(De=0,queueMicrotask(Se))})},onWillRemoveListener(){ie&&Fe>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ce.dispose()}};ue||y(Ce);const ve=new m(Ce);return ue?.add(ve),ve.event}k.debounce=n;function ae(j,$=0,Y){return k.debounce(j,(K,ie)=>K?(K.push(ie),K):[ie],$,void 0,!0,void 0,Y)}k.accumulate=ae;function he(j,$=(K,ie)=>K===ie,Y){let K=!0,ie;return S(j,le=>{const ue=K||!$(le,ie);return K=!1,ie=le,ue},Y)}k.latch=he;function be(j,$,Y){return[k.filter(j,$,Y),k.filter(j,K=>!$(K),Y)]}k.split=be;function Le(j,$=!1,Y=[],K){let ie=Y.slice(),le=j(de=>{ie?ie.push(de):ce.fire(de)});K&&K.add(le);const ue=()=>{ie?.forEach(de=>ce.fire(de)),ie=null},ce=new m({onWillAddFirstListener(){le||(le=j(de=>ce.fire(de)),K&&K.add(le))},onDidAddFirstListener(){ie&&($?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(ce),ce.event}k.buffer=Le;function ye(j,$){return(K,ie,le)=>{const ue=$(new Ne);return j(function(ce){const de=ue.evaluate(ce);de!==_e&&K.call(ie,de)},void 0,le)}}k.chain=ye;const _e=Symbol("HaltChainable");class Ne{constructor(){this.steps=[]}map($){return this.steps.push($),this}forEach($){return this.steps.push(Y=>($(Y),Y)),this}filter($){return this.steps.push(Y=>$(Y)?Y:_e),this}reduce($,Y){let K=Y;return this.steps.push(ie=>(K=$(K,ie),K)),this}latch($=(Y,K)=>Y===K){let Y=!0,K;return this.steps.push(ie=>{const le=Y||!$(ie,K);return Y=!1,K=ie,le?ie:_e}),this}evaluate($){for(const Y of this.steps)if($=Y($),$===_e)break;return $}}function ke(j,$,Y=K=>K){const K=(...ce)=>ue.fire(Y(...ce)),ie=()=>j.on($,K),le=()=>j.removeListener($,K),ue=new m({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ue.event}k.fromNodeEventEmitter=ke;function Te(j,$,Y=K=>K){const K=(...ce)=>ue.fire(Y(...ce)),ie=()=>j.addEventListener($,K),le=()=>j.removeEventListener($,K),ue=new m({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ue.event}k.fromDOMEventEmitter=Te;function Ie(j){return new Promise($=>T(j)($))}k.toPromise=Ie;function Ae(j){const $=new m;return j.then(Y=>{$.fire(Y)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}k.fromPromise=Ae;function x(j,$,Y){return $(Y),j(K=>$(K))}k.runAndSubscribe=x;class z{constructor($,Y){this._observable=$,this._counter=0,this._hasChanged=!1;const K={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||y(K),this.emitter=new m(K),Y&&Y.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,Y){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function V(j,$){return new z(j,$).emitter.event}k.fromObservable=V;function X(j){return($,Y,K)=>{let ie=0,le=!1;const ue={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(j.reportChanges(),le&&(le=!1,$.call(Y)))},handlePossibleChange(){},handleChange(){le=!0}};j.addObserver(ue),j.reportChanges();const ce={dispose(){j.removeObserver(ue)}};return K instanceof r.DisposableStore?K.add(ce):Array.isArray(K)&&K.push(ce),ce}}k.fromObservableLight=X})(s||(t.Event=s={}));class h{static{this.all=new Set}static{this._idPool=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${h._idPool++}`,h.all.add(this)}start(y){this._stopWatch=new w.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=h;let N=-1;function b(k){const y=N;return N=k,{dispose(){N=y}}}t.setGlobalLeakWarningThreshold=b;class g{constructor(y,I=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=I,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(y,I){const T=this.threshold;if(T<=0||I<T)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let q,S=0;for(const[W,Q]of this._stacks)(!q||S<Q)&&(q=W,S=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${S}):`),console.warn(q)}return()=>{const q=this._stacks.get(y.value)||0;this._stacks.set(y.value,q-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class A{constructor(y){this.value=y,this.id=E++}}const p=2,_=(k,y)=>{if(k instanceof A)y(k);else for(let I=0;I<k.length;I++){const T=k[I];T&&y(T)}};class m{constructor(y){this._size=0,this._options=y,this._leakageMon=N>0||this._options?.leakWarningThreshold?new g(this._options?.leakWarningThreshold??N):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(f){const y=this._listeners;queueMicrotask(()=>{_(y,I=>I.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(y,I,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;I&&(y=y.bind(I));const O=new A(y);let q,S;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=e.create(),q=this._leakageMon.check(O.stack,this._size+1)),f&&(O.stack=S??e.create()),this._listeners?this._listeners instanceof A?(this._deliveryQueue??=new o,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const W=(0,r.toDisposable)(()=>{q?.(),this._removeListener(O)});return T instanceof r.DisposableStore?T.add(W):Array.isArray(T)&&T.push(W),W},this._event}_removeListener(y){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const I=this._listeners,T=I.indexOf(y);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,I[T]=void 0;const O=this._deliveryQueue.current===this;if(this._size*p<=I.length){let q=0;for(let S=0;S<I.length;S++)I[S]?I[q++]=I[S]:O&&(this._deliveryQueue.end--,q<this._deliveryQueue.i&&this._deliveryQueue.i--);I.length=q}}_deliver(y,I){if(!y)return;const T=this._options?.onListenerError||P.onUnexpectedError;if(!T){y.value(I);return}try{y.value(I)}catch(O){T(O)}}_deliverQueue(y){const I=y.current._listeners;for(;y.i<y.end;)this._deliver(I[y.i++],y.value);y.reset()}fire(y){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof A)this._deliver(this._listeners,y);else{const I=this._deliveryQueue;I.enqueue(this,y,this._listeners.length),this._deliverQueue(I)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=m;const l=()=>new o;t.createEventDeliveryQueue=l;class o{constructor(){this.i=-1,this.end=0}enqueue(y,I,T){this.i=0,this.end=T,this.current=y,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends m{async fireAsync(y,I,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList),_(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,y]));this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[O,q]=this._asyncDeliveryQueue.shift(),S=[],W={...q,token:I,waitUntil:Q=>{if(Object.isFrozen(S))throw new Error("waitUntil can NOT be called asynchronous");T&&(Q=T(Q,O)),S.push(Q)}};try{O(W)}catch(Q){(0,P.onUnexpectedError)(Q);continue}Object.freeze(S),await Promise.allSettled(S).then(Q=>{for(const H of Q)H.status==="rejected"&&(0,P.onUnexpectedError)(H.reason)})}}}t.AsyncEmitter=i;class a extends m{get isPaused(){return this._isPaused!==0}constructor(y){super(y),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}t.PauseableEmitter=a;class L extends a{constructor(y){super(y),this._delay=y.delay??100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}t.DebounceEmitter=L;class d extends m{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=d;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const I={event:y,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const T=()=>{this.hasListeners&&this.unhook(I);const O=this.events.indexOf(I);this.events.splice(O,1)};return(0,r.toDisposable)((0,F.createSingleCallFunction)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(I=>this.emitter.fire(I))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=v;class M{constructor(y,I,T,O){this._store=new r.DisposableStore;const q=this._store.add(new v),S=this._store.add(new r.DisposableMap);function W(Q){S.set(Q,q.add(O(Q)))}for(const Q of y)W(Q);this._store.add(I(Q=>{W(Q)})),this._store.add(T(Q=>{S.deleteAndDispose(Q)})),this.event=q.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=M;class R{constructor(){this.buffers=[]}wrapEvent(y){return(I,T,O)=>y(q=>{const S=this.buffers[this.buffers.length-1];S?S.push(()=>I.call(T,q)):I.call(T,q)},void 0,O)}bufferEvents(y){const I=[];this.buffers.push(I);const T=y();return this.buffers.pop(),I.forEach(O=>O()),T}}t.EventBufferer=R;class D{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=r.Disposable.None,this.emitter=new m({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=D}),te(ne[24],re([0,1,11]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const F=Object.freeze(function(f,u){const s=setTimeout(f.bind(u),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function u(s){return s===f.None||s===f.Cancelled||s instanceof c?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=u,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(r||(t.CancellationToken=r={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=r.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=r.None}}t.CancellationTokenSource=w}),te(ne[39],re([0,1,24]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class F{constructor(f){this.task=f,this.result=null}get(){if(this.result)return this.result;const f=new P.CancellationTokenSource,u=this.task(f.token);return this.result={promise:u,dispose:()=>{this.result=null,f.cancel(),f.dispose()}},this.result}}t.Cache=F;class r{constructor(f){this.fn=f,this.lastCache=void 0,this.lastArgKey=void 0}get(f){const u=JSON.stringify(f);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(f)),this.lastCache}}t.LRUCachedFunction=r;class c{get cachedValues(){return this._map}constructor(f){this.fn=f,this._map=new Map}get(f){if(this._map.has(f))return this._map.get(f);const u=this.fn(f);return this._map.set(f,u),u}}t.CachedFunction=c}),te(ne[7],re([0,1,39,38]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncateMiddle=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.htmlAttributeEncodeValue=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function r(C){return!C||typeof C!="string"?!0:C.trim().length===0}t.isFalsyOrWhitespace=r;const c=/{(\d+)}/g;function w(C,...U){return U.length===0?C:C.replace(c,function(G,J){const se=parseInt(J,10);return isNaN(se)||se<0||se>=U.length?G:U[se]})}t.format=w;const f=/{([^}]+)}/g;function u(C,U){return Object.keys(U).length===0?C:C.replace(f,(G,J)=>U[J]??G)}t.format2=u;function s(C){return C.replace(/[<>"'&]/g,U=>{switch(U){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return U})}t.htmlAttributeEncodeValue=s;function h(C){return C.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.escape=h;function N(C){return C.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=N;function b(C,U){let G=0;const J=U.charCodeAt(0);for(let se=C.length-1;se>=0;se--)C.charCodeAt(se)===J&&G++;return G}t.count=b;function g(C,U,G="\u2026"){return C.length<=U?C:`${C.substr(0,U)}${G}`}t.truncate=g;function e(C,U,G="\u2026"){if(C.length<=U)return C;const J=Math.ceil(U/2)-G.length/2,se=Math.floor(U/2)-G.length/2;return`${C.substr(0,J)}${G}${C.substr(C.length-se)}`}t.truncateMiddle=e;function E(C,U=" "){const G=A(C,U);return p(G,U)}t.trim=E;function A(C,U){if(!C||!U)return C;const G=U.length;if(G===0||C.length===0)return C;let J=0;for(;C.indexOf(U,J)===J;)J=J+G;return C.substring(J)}t.ltrim=A;function p(C,U){if(!C||!U)return C;const G=U.length,J=C.length;if(G===0||J===0)return C;let se=J,oe=-1;for(;oe=C.lastIndexOf(U,se-1),!(oe===-1||oe+G!==se);){if(oe===0)return"";se=oe}return C.substring(0,se)}t.rtrim=p;function _(C){return C.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function m(C){return C.replace(/\*/g,"")}t.stripWildcards=m;function l(C,U,G={}){if(!C)throw new Error("Cannot create regex from empty string");U||(C=N(C)),G.wholeWord&&(/\B/.test(C.charAt(0))||(C="\\b"+C),/\B/.test(C.charAt(C.length-1))||(C=C+"\\b"));let J="";return G.global&&(J+="g"),G.matchCase||(J+="i"),G.multiline&&(J+="m"),G.unicode&&(J+="u"),new RegExp(C,J)}t.createRegExp=l;function o(C){return C.source==="^"||C.source==="^$"||C.source==="$"||C.source==="^\\s*$"?!1:!!(C.exec("")&&C.lastIndex===0)}t.regExpLeadsToEndlessLoop=o;function i(C){return C.split(/\r\n|\r|\n/)}t.splitLines=i;function a(C){for(let U=0,G=C.length;U<G;U++){const J=C.charCodeAt(U);if(J!==32&&J!==9)return U}return-1}t.firstNonWhitespaceIndex=a;function L(C,U=0,G=C.length){for(let J=U;J<G;J++){const se=C.charCodeAt(J);if(se!==32&&se!==9)return C.substring(U,J)}return C.substring(U,G)}t.getLeadingWhitespace=L;function d(C,U=C.length-1){for(let G=U;G>=0;G--){const J=C.charCodeAt(G);if(J!==32&&J!==9)return G}return-1}t.lastNonWhitespaceIndex=d;function v(C,U,G){const J=[];let se=0;for(const oe of C.matchAll(U)){if(J.push(C.slice(se,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");se=oe.index+oe[0].length,J.push(G(oe[0],...oe.slice(1),oe.index,C,oe.groups))}return J.push(C.slice(se)),Promise.all(J).then(oe=>oe.join(""))}t.replaceAsync=v;function M(C,U){return C<U?-1:C>U?1:0}t.compare=M;function R(C,U,G=0,J=C.length,se=0,oe=U.length){for(;G<J&&se<oe;G++,se++){const pe=C.charCodeAt(G),we=U.charCodeAt(se);if(pe<we)return-1;if(pe>we)return 1}const ge=J-G,Me=oe-se;return ge<Me?-1:ge>Me?1:0}t.compareSubstring=R;function D(C,U){return k(C,U,0,C.length,0,U.length)}t.compareIgnoreCase=D;function k(C,U,G=0,J=C.length,se=0,oe=U.length){for(;G<J&&se<oe;G++,se++){let pe=C.charCodeAt(G),we=U.charCodeAt(se);if(pe===we)continue;if(pe>=128||we>=128)return R(C.toLowerCase(),U.toLowerCase(),G,J,se,oe);I(pe)&&(pe-=32),I(we)&&(we-=32);const me=pe-we;if(me!==0)return me}const ge=J-G,Me=oe-se;return ge<Me?-1:ge>Me?1:0}t.compareSubstringIgnoreCase=k;function y(C){return C>=48&&C<=57}t.isAsciiDigit=y;function I(C){return C>=97&&C<=122}t.isLowerAsciiLetter=I;function T(C){return C>=65&&C<=90}t.isUpperAsciiLetter=T;function O(C,U){return C.length===U.length&&k(C,U)===0}t.equalsIgnoreCase=O;function q(C,U){const G=U.length;return U.length>C.length?!1:k(C,U,0,G)===0}t.startsWithIgnoreCase=q;function S(C,U){const G=Math.min(C.length,U.length);let J;for(J=0;J<G;J++)if(C.charCodeAt(J)!==U.charCodeAt(J))return J;return G}t.commonPrefixLength=S;function W(C,U){const G=Math.min(C.length,U.length);let J;const se=C.length-1,oe=U.length-1;for(J=0;J<G;J++)if(C.charCodeAt(se-J)!==U.charCodeAt(oe-J))return J;return G}t.commonSuffixLength=W;function Q(C){return 55296<=C&&C<=56319}t.isHighSurrogate=Q;function H(C){return 56320<=C&&C<=57343}t.isLowSurrogate=H;function Z(C,U){return(C-55296<<10)+(U-56320)+65536}t.computeCodePoint=Z;function ee(C,U,G){const J=C.charCodeAt(G);if(Q(J)&&G+1<U){const se=C.charCodeAt(G+1);if(H(se))return Z(J,se)}return J}t.getNextCodePoint=ee;function n(C,U){const G=C.charCodeAt(U-1);if(H(G)&&U>1){const J=C.charCodeAt(U-2);if(Q(J))return Z(J,G)}return G}class ae{get offset(){return this._offset}constructor(U,G=0){this._str=U,this._len=U.length,this._offset=G}setOffset(U){this._offset=U}prevCodePoint(){const U=n(this._str,this._offset);return this._offset-=U>=65536?2:1,U}nextCodePoint(){const U=ee(this._str,this._len,this._offset);return this._offset+=U>=65536?2:1,U}eol(){return this._offset>=this._len}}t.CodePointIterator=ae;class he{get offset(){return this._iterator.offset}constructor(U,G=0){this._iterator=new ae(U,G)}nextGraphemeLength(){const U=ve.getInstance(),G=this._iterator,J=G.offset;let se=U.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const oe=G.offset,ge=U.getGraphemeBreakType(G.nextCodePoint());if(Se(se,ge)){G.setOffset(oe);break}se=ge}return G.offset-J}prevGraphemeLength(){const U=ve.getInstance(),G=this._iterator,J=G.offset;let se=U.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const oe=G.offset,ge=U.getGraphemeBreakType(G.prevCodePoint());if(Se(ge,se)){G.setOffset(oe);break}se=ge}return J-G.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=he;function be(C,U){return new he(C,U).nextGraphemeLength()}t.nextCharLength=be;function Le(C,U){return new he(C,U).prevGraphemeLength()}t.prevCharLength=Le;function ye(C,U){U>0&&H(C.charCodeAt(U))&&U--;const G=U+be(C,U);return[G-Le(C,G),G]}t.getCharContainingOffset=ye;function _e(C){const U=new he(C);let G=0;for(;!U.eol();)G++,U.nextGraphemeLength();return G}t.charCount=_e;let Ne;function ke(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Te(C){return Ne||(Ne=ke()),Ne.test(C)}t.containsRTL=Te;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Ae(C){return Ie.test(C)}t.isBasicASCII=Ae,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(C){return t.UNUSUAL_LINE_TERMINATORS.test(C)}t.containsUnusualLineTerminators=x;function z(C){return C>=11904&&C<=55215||C>=63744&&C<=64255||C>=65281&&C<=65374}t.isFullWidthCharacter=z;function V(C){return C>=127462&&C<=127487||C===8986||C===8987||C===9200||C===9203||C>=9728&&C<=10175||C===11088||C===11093||C>=127744&&C<=128591||C>=128640&&C<=128764||C>=128992&&C<=129008||C>=129280&&C<=129535||C>=129648&&C<=129782}t.isEmojiImprecise=V;function X(C,U,G=""){const J=C.trimStart();if(J.length<U)return J;const se=/\b/g;let oe=0;for(;se.test(J)&&!(J.length-se.lastIndex<U);)oe=se.lastIndex,se.lastIndex+=1;return oe===0?J:G+J.substring(oe).trimStart()}t.lcut=X;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$=/\x1b\].*?\x07/g;function Y(C){return C&&(C=C.replace(j,"").replace($,"")),C}t.removeAnsiEscapeCodes=Y,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K(C){return!!(C&&C.length>0&&C.charCodeAt(0)===65279)}t.startsWithUTF8BOM=K;function ie(C){return K(C)?C.substr(1):C}t.stripUTF8BOM=ie;function le(C,U){if(!C||!U||C.length<U.length)return!1;const G=U.length,J=C.toLowerCase();let se=0,oe=-1;for(;se<G;){const ge=J.indexOf(U[se],oe+1);if(ge<0)return!1;oe=ge,se++}return!0}t.fuzzyContains=le;function ue(C,U=!1){return C?(U&&(C=C.replace(/\\./g,"")),C.toLowerCase()!==C):!1}t.containsUppercaseCharacter=ue;function ce(C){return C.charAt(0).toUpperCase()+C.slice(1)}t.uppercaseFirstLetter=ce;function de(C,U=1){if(U===0)return"";let G=-1;do G=C.indexOf(`
`,G+1),U--;while(U>0&&G>=0);return G===-1?C:(C[G-1]==="\r"&&G--,C.substr(0,G))}t.getNLines=de;function De(C){return C=C%(2*26),C<26?String.fromCharCode(97+C):String.fromCharCode(65+C-26)}t.singleLetterHash=De;function Fe(C){return ve.getInstance().getGraphemeBreakType(C)}t.getGraphemeBreakType=Fe;function Se(C,U){return C===0?U!==5&&U!==7:C===2&&U===3?!1:C===4||C===2||C===3||U===4||U===2||U===3?!0:!(C===8&&(U===8||U===9||U===11||U===12)||(C===11||C===9)&&(U===9||U===10)||(C===12||C===10)&&U===10||U===5||U===13||U===7||C===1||C===13&&U===14||C===6&&U===6)}var Ce;(function(C){C[C.Other=0]="Other",C[C.Prepend=1]="Prepend",C[C.CR=2]="CR",C[C.LF=3]="LF",C[C.Control=4]="Control",C[C.Extend=5]="Extend",C[C.Regional_Indicator=6]="Regional_Indicator",C[C.SpacingMark=7]="SpacingMark",C[C.L=8]="L",C[C.V=9]="V",C[C.T=10]="T",C[C.LV=11]="LV",C[C.LVT=12]="LVT",C[C.ZWJ=13]="ZWJ",C[C.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(t.GraphemeBreakType=Ce={}));class ve{static{this._INSTANCE=null}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}constructor(){this._data=Ue()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const G=this._data,J=G.length/3;let se=1;for(;se<=J;)if(U<G[3*se])se=2*se;else if(U>G[3*se+1])se=2*se+1;else return G[3*se+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(C,U){if(C===0)return 0;const G=He(C,U);if(G!==void 0)return G;const J=new ae(U,C);return J.prevCodePoint(),J.offset}t.getLeftDeleteOffset=qe;function He(C,U){const G=new ae(U,C);let J=G.prevCodePoint();for(;je(J)||J===65039||J===8419;){if(G.offset===0)return;J=G.prevCodePoint()}if(!V(J))return;let se=G.offset;return se>0&&G.prevCodePoint()===8205&&(se=G.offset),se}function je(C){return 127995<=C&&C<=127999}var We;(function(C){C[C.zwj=8205]="zwj",C[C.emojiVariantSelector=65039]="emojiVariantSelector",C[C.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.noBreakWhitespace="\xA0";class Pe{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction(U=>{function G(me){const Re=new Map;for(let Ee=0;Ee<me.length;Ee+=2)Re.set(me[Ee],me[Ee+1]);return Re}function J(me,Re){const Ee=new Map(me);for(const[xe,Be]of Re)Ee.set(xe,Be);return Ee}function se(me,Re){if(!me)return Re;const Ee=new Map;for(const[xe,Be]of me)Re.has(xe)&&Ee.set(xe,Be);return Ee}const oe=this.ambiguousCharacterData.value;let ge=U.filter(me=>!me.startsWith("_")&&me in oe);ge.length===0&&(ge=["_default"]);let Me;for(const me of ge){const Re=G(oe[me]);Me=se(Me,Re)}const pe=G(oe._common),we=J(pe,Me);return new Pe(we)})}static getInstance(U){return Pe.cache.get(Array.from(U))}static{this._locales=new F.Lazy(()=>Object.keys(Pe.ambiguousCharacterData.value).filter(U=>!U.startsWith("_")))}static getLocales(){return Pe._locales.value}constructor(U){this.confusableDictionary=U}isAmbiguous(U){return this.confusableDictionary.has(U)}getPrimaryConfusable(U){return this.confusableDictionary.get(U)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Pe;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(U){return Oe.getData().has(U)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe}),te(ne[40],re([0,1,7]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function F(p){return r(p,0)}t.hash=F;function r(p,_){switch(typeof p){case"object":return p===null?c(349,_):Array.isArray(p)?u(p,_):s(p,_);case"string":return f(p,_);case"boolean":return w(p,_);case"number":return c(p,_);case"undefined":return c(937,_);default:return c(617,_)}}t.doHash=r;function c(p,_){return(_<<5)-_+p|0}t.numberHash=c;function w(p,_){return c(p?433:863,_)}function f(p,_){_=c(149417,_);for(let m=0,l=p.length;m<l;m++)_=c(p.charCodeAt(m),_);return _}t.stringHash=f;function u(p,_){return _=c(104579,_),p.reduce((m,l)=>r(l,m),_)}function s(p,_){return _=c(181387,_),Object.keys(p).sort().reduce((m,l)=>(m=f(l,m),r(p[l],m)),_)}class h{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=r(_,this._value),this._value}}t.Hasher=h;var N;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function b(p,_,m=32){const l=m-_,o=~((1<<l)-1);return(p<<_|(o&p)>>>l)>>>0}function g(p,_=0,m=p.byteLength,l=0){for(let o=0;o<m;o++)p[_+o]=l}function e(p,_,m="0"){for(;p.length<_;)p=m+p;return p}function E(p,_=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(m=>m.toString(16).padStart(2,"0")).join(""):e((p>>>0).toString(16),_/4)}t.toHexString=E;class A{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const m=_.length;if(m===0)return;const l=this._buff;let o=this._buffLen,i=this._leftoverHighSurrogate,a,L;for(i!==0?(a=i,L=-1,i=0):(a=_.charCodeAt(0),L=0);;){let d=a;if(P.isHighSurrogate(a))if(L+1<m){const v=_.charCodeAt(L+1);P.isLowSurrogate(v)?(L++,d=P.computeCodePoint(a,v)):d=65533}else{i=a;break}else P.isLowSurrogate(a)&&(d=65533);if(o=this._push(l,o,d),L++,L<m)a=_.charCodeAt(L);else break}this._buffLen=o,this._leftoverHighSurrogate=i}_push(_,m,l){return l<128?_[m++]=l:l<2048?(_[m++]=192|(l&1984)>>>6,_[m++]=128|(l&63)>>>0):l<65536?(_[m++]=224|(l&61440)>>>12,_[m++]=128|(l&4032)>>>6,_[m++]=128|(l&63)>>>0):(_[m++]=240|(l&1835008)>>>18,_[m++]=128|(l&258048)>>>12,_[m++]=128|(l&4032)>>>6,_[m++]=128|(l&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=A._bigBlock32,m=this._buffDV;for(let R=0;R<64;R+=4)_.setUint32(R,m.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)_.setUint32(R,b(_.getUint32(R-12,!1)^_.getUint32(R-32,!1)^_.getUint32(R-56,!1)^_.getUint32(R-64,!1),1),!1);let l=this._h0,o=this._h1,i=this._h2,a=this._h3,L=this._h4,d,v,M;for(let R=0;R<80;R++)R<20?(d=o&i|~o&a,v=1518500249):R<40?(d=o^i^a,v=1859775393):R<60?(d=o&i|o&a|i&a,v=2400959708):(d=o^i^a,v=3395469782),M=b(l,5)+d+L+v+_.getUint32(R*4,!1)&4294967295,L=a,a=i,i=b(o,30),o=l,l=M;this._h0=this._h0+l&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+L&4294967295}}t.StringSHA1=A}),te(ne[25],re([0,1,36,40]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class r{constructor(b){this.source=b}getElements(){const b=this.source,g=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)g[e]=b.charCodeAt(e);return g}}t.StringDiffSequence=r;function c(N,b,g){return new h(new r(N),new r(b)).ComputeDiff(g).changes}t.stringDiff=c;class w{static Assert(b,g){if(!b)throw new Error(g)}}class f{static Copy(b,g,e,E,A){for(let p=0;p<A;p++)e[E+p]=b[g+p]}static Copy2(b,g,e,E,A){for(let p=0;p<A;p++)e[E+p]=b[g+p]}}var u;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class s{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(b,g){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,g),this.m_originalCount++}AddModifiedElement(b,g){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,g),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(b,g,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=b,this._modifiedSequence=g;const[E,A,p]=h._getElements(b),[_,m,l]=h._getElements(g);this._hasStrings=p&&l,this._originalStringElements=E,this._originalElementsOrHash=A,this._modifiedStringElements=_,this._modifiedElementsOrHash=m,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(b){return b.length>0&&typeof b[0]=="string"}static _getElements(b){const g=b.getElements();if(h._isStringArray(g)){const e=new Int32Array(g.length);for(let E=0,A=g.length;E<A;E++)e[E]=(0,F.stringHash)(g[E],0);return[g,e,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}ElementsAreEqual(b,g){return this._originalElementsOrHash[b]!==this._modifiedElementsOrHash[g]?!1:this._hasStrings?this._originalStringElements[b]===this._modifiedStringElements[g]:!0}ElementsAreStrictEqual(b,g){if(!this.ElementsAreEqual(b,g))return!1;const e=h._getStrictElement(this._originalSequence,b),E=h._getStrictElement(this._modifiedSequence,g);return e===E}static _getStrictElement(b,g){return typeof b.getStrictElement=="function"?b.getStrictElement(g):null}OriginalElementsAreEqual(b,g){return this._originalElementsOrHash[b]!==this._originalElementsOrHash[g]?!1:this._hasStrings?this._originalStringElements[b]===this._originalStringElements[g]:!0}ModifiedElementsAreEqual(b,g){return this._modifiedElementsOrHash[b]!==this._modifiedElementsOrHash[g]?!1:this._hasStrings?this._modifiedStringElements[b]===this._modifiedStringElements[g]:!0}ComputeDiff(b){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,b)}_ComputeDiff(b,g,e,E,A){const p=[!1];let _=this.ComputeDiffRecursive(b,g,e,E,p);return A&&(_=this.PrettifyChanges(_)),{quitEarly:p[0],changes:_}}ComputeDiffRecursive(b,g,e,E,A){for(A[0]=!1;b<=g&&e<=E&&this.ElementsAreEqual(b,e);)b++,e++;for(;g>=b&&E>=e&&this.ElementsAreEqual(g,E);)g--,E--;if(b>g||e>E){let i;return e<=E?(w.Assert(b===g+1,"originalStart should only be one more than originalEnd"),i=[new P.DiffChange(b,0,e,E-e+1)]):b<=g?(w.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[new P.DiffChange(b,g-b+1,e,0)]):(w.Assert(b===g+1,"originalStart should only be one more than originalEnd"),w.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const p=[0],_=[0],m=this.ComputeRecursionPoint(b,g,e,E,p,_,A),l=p[0],o=_[0];if(m!==null)return m;if(!A[0]){const i=this.ComputeDiffRecursive(b,l,e,o,A);let a=[];return A[0]?a=[new P.DiffChange(l+1,g-(l+1)+1,o+1,E-(o+1)+1)]:a=this.ComputeDiffRecursive(l+1,g,o+1,E,A),this.ConcatenateChanges(i,a)}return[new P.DiffChange(b,g-b+1,e,E-e+1)]}WALKTRACE(b,g,e,E,A,p,_,m,l,o,i,a,L,d,v,M,R,D){let k=null,y=null,I=new s,T=g,O=e,q=L[0]-M[0]-E,S=-1073741824,W=this.m_forwardHistory.length-1;do{const Q=q+b;Q===T||Q<O&&l[Q-1]<l[Q+1]?(i=l[Q+1],d=i-q-E,i<S&&I.MarkNextChange(),S=i,I.AddModifiedElement(i+1,d),q=Q+1-b):(i=l[Q-1]+1,d=i-q-E,i<S&&I.MarkNextChange(),S=i-1,I.AddOriginalElement(i,d+1),q=Q-1-b),W>=0&&(l=this.m_forwardHistory[W],b=l[0],T=1,O=l.length-1)}while(--W>=-1);if(k=I.getReverseChanges(),D[0]){let Q=L[0]+1,H=M[0]+1;if(k!==null&&k.length>0){const Z=k[k.length-1];Q=Math.max(Q,Z.getOriginalEnd()),H=Math.max(H,Z.getModifiedEnd())}y=[new P.DiffChange(Q,a-Q+1,H,v-H+1)]}else{I=new s,T=p,O=_,q=L[0]-M[0]-m,S=1073741824,W=R?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Q=q+A;Q===T||Q<O&&o[Q-1]>=o[Q+1]?(i=o[Q+1]-1,d=i-q-m,i>S&&I.MarkNextChange(),S=i+1,I.AddOriginalElement(i+1,d+1),q=Q+1-A):(i=o[Q-1],d=i-q-m,i>S&&I.MarkNextChange(),S=i,I.AddModifiedElement(i+1,d+1),q=Q-1-A),W>=0&&(o=this.m_reverseHistory[W],A=o[0],T=1,O=o.length-1)}while(--W>=-1);y=I.getChanges()}return this.ConcatenateChanges(k,y)}ComputeRecursionPoint(b,g,e,E,A,p,_){let m=0,l=0,o=0,i=0,a=0,L=0;b--,e--,A[0]=0,p[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=g-b+(E-e),v=d+1,M=new Int32Array(v),R=new Int32Array(v),D=E-e,k=g-b,y=b-e,I=g-E,O=(k-D)%2===0;M[D]=b,R[k]=g,_[0]=!1;for(let q=1;q<=d/2+1;q++){let S=0,W=0;o=this.ClipDiagonalBound(D-q,q,D,v),i=this.ClipDiagonalBound(D+q,q,D,v);for(let H=o;H<=i;H+=2){H===o||H<i&&M[H-1]<M[H+1]?m=M[H+1]:m=M[H-1]+1,l=m-(H-D)-y;const Z=m;for(;m<g&&l<E&&this.ElementsAreEqual(m+1,l+1);)m++,l++;if(M[H]=m,m+l>S+W&&(S=m,W=l),!O&&Math.abs(H-k)<=q-1&&m>=R[H])return A[0]=m,p[0]=l,Z<=R[H]&&1447>0&&q<=1447+1?this.WALKTRACE(D,o,i,y,k,a,L,I,M,R,m,g,A,l,E,p,O,_):null}const Q=(S-b+(W-e)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(S,Q))return _[0]=!0,A[0]=S,p[0]=W,Q>0&&1447>0&&q<=1447+1?this.WALKTRACE(D,o,i,y,k,a,L,I,M,R,m,g,A,l,E,p,O,_):(b++,e++,[new P.DiffChange(b,g-b+1,e,E-e+1)]);a=this.ClipDiagonalBound(k-q,q,k,v),L=this.ClipDiagonalBound(k+q,q,k,v);for(let H=a;H<=L;H+=2){H===a||H<L&&R[H-1]>=R[H+1]?m=R[H+1]-1:m=R[H-1],l=m-(H-k)-I;const Z=m;for(;m>b&&l>e&&this.ElementsAreEqual(m,l);)m--,l--;if(R[H]=m,O&&Math.abs(H-D)<=q&&m<=M[H])return A[0]=m,p[0]=l,Z>=M[H]&&1447>0&&q<=1447+1?this.WALKTRACE(D,o,i,y,k,a,L,I,M,R,m,g,A,l,E,p,O,_):null}if(q<=1447){let H=new Int32Array(i-o+2);H[0]=D-o+1,f.Copy2(M,o,H,1,i-o+1),this.m_forwardHistory.push(H),H=new Int32Array(L-a+2),H[0]=k-a+1,f.Copy2(R,a,H,1,L-a+1),this.m_reverseHistory.push(H)}}return this.WALKTRACE(D,o,i,y,k,a,L,I,M,R,m,g,A,l,E,p,O,_)}PrettifyChanges(b){for(let g=0;g<b.length;g++){const e=b[g],E=g<b.length-1?b[g+1].originalStart:this._originalElementsOrHash.length,A=g<b.length-1?b[g+1].modifiedStart:this._modifiedElementsOrHash.length,p=e.originalLength>0,_=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<A&&(!p||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!_||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const l=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!l)break;e.originalStart++,e.modifiedStart++}const m=[null];if(g<b.length-1&&this.ChangesOverlap(b[g],b[g+1],m)){b[g]=m[0],b.splice(g+1,1),g--;continue}}for(let g=b.length-1;g>=0;g--){const e=b[g];let E=0,A=0;if(g>0){const i=b[g-1];E=i.originalStart+i.originalLength,A=i.modifiedStart+i.modifiedLength}const p=e.originalLength>0,_=e.modifiedLength>0;let m=0,l=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,L=e.modifiedStart-i;if(a<E||L<A||p&&!this.OriginalElementsAreEqual(a,a+e.originalLength)||_&&!this.ModifiedElementsAreEqual(L,L+e.modifiedLength))break;const v=(a===E&&L===A?5:0)+this._boundaryScore(a,e.originalLength,L,e.modifiedLength);v>l&&(l=v,m=i)}e.originalStart-=m,e.modifiedStart-=m;const o=[null];if(g>0&&this.ChangesOverlap(b[g-1],b[g],o)){b[g-1]=o[0],b.splice(g,1),g++;continue}}if(this._hasStrings)for(let g=1,e=b.length;g<e;g++){const E=b[g-1],A=b[g],p=A.originalStart-E.originalStart-E.originalLength,_=E.originalStart,m=A.originalStart+A.originalLength,l=m-_,o=E.modifiedStart,i=A.modifiedStart+A.modifiedLength,a=i-o;if(p<5&&l<20&&a<20){const L=this._findBetterContiguousSequence(_,l,o,a,p);if(L){const[d,v]=L;(d!==E.originalStart+E.originalLength||v!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=v-E.modifiedStart,A.originalStart=d+p,A.modifiedStart=v+p,A.originalLength=m-A.originalStart,A.modifiedLength=i-A.modifiedStart)}}}return b}_findBetterContiguousSequence(b,g,e,E,A){if(g<A||E<A)return null;const p=b+g-A+1,_=e+E-A+1;let m=0,l=0,o=0;for(let i=b;i<p;i++)for(let a=e;a<_;a++){const L=this._contiguousSequenceScore(i,a,A);L>0&&L>m&&(m=L,l=i,o=a)}return m>0?[l,o]:null}_contiguousSequenceScore(b,g,e){let E=0;for(let A=0;A<e;A++){if(!this.ElementsAreEqual(b+A,g+A))return 0;E+=this._originalStringElements[b+A].length}return E}_OriginalIsBoundary(b){return b<=0||b>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[b])}_OriginalRegionIsBoundary(b,g){if(this._OriginalIsBoundary(b)||this._OriginalIsBoundary(b-1))return!0;if(g>0){const e=b+g;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(b){return b<=0||b>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[b])}_ModifiedRegionIsBoundary(b,g){if(this._ModifiedIsBoundary(b)||this._ModifiedIsBoundary(b-1))return!0;if(g>0){const e=b+g;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(b,g,e,E){const A=this._OriginalRegionIsBoundary(b,g)?1:0,p=this._ModifiedRegionIsBoundary(e,E)?1:0;return A+p}ConcatenateChanges(b,g){const e=[];if(b.length===0||g.length===0)return g.length>0?g:b;if(this.ChangesOverlap(b[b.length-1],g[0],e)){const E=new Array(b.length+g.length-1);return f.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],f.Copy(g,1,E,b.length,g.length-1),E}else{const E=new Array(b.length+g.length);return f.Copy(b,0,E,0,b.length),f.Copy(g,0,E,b.length,g.length),E}}ChangesOverlap(b,g,e){if(w.Assert(b.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),w.Assert(b.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=g.originalStart||b.modifiedStart+b.modifiedLength>=g.modifiedStart){const E=b.originalStart;let A=b.originalLength;const p=b.modifiedStart;let _=b.modifiedLength;return b.originalStart+b.originalLength>=g.originalStart&&(A=g.originalStart+g.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=g.modifiedStart&&(_=g.modifiedStart+g.modifiedLength-b.modifiedStart),e[0]=new P.DiffChange(E,A,p,_),!0}else return e[0]=null,!1}ClipDiagonalBound(b,g,e,E){if(b>=0&&b<E)return b;const A=e,p=E-e-1,_=g%2===0;if(b<0){const m=A%2===0;return _===m?0:1}else{const m=p%2===0;return _===m?E-1:E-2}}}t.LcsDiff=h}),te(ne[26],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function P(o){return typeof o=="string"}t.isString=P;function F(o){return Array.isArray(o)&&o.every(i=>P(i))}t.isStringArray=F;function r(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}t.isObject=r;function c(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}t.isTypedArray=c;function w(o){return typeof o=="number"&&!isNaN(o)}t.isNumber=w;function f(o){return!!o&&typeof o[Symbol.iterator]=="function"}t.isIterable=f;function u(o){return o===!0||o===!1}t.isBoolean=u;function s(o){return typeof o>"u"}t.isUndefined=s;function h(o){return!N(o)}t.isDefined=h;function N(o){return s(o)||o===null}t.isUndefinedOrNull=N;function b(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.assertType=b;function g(o){if(N(o))throw new Error("Assertion Failed: argument is undefined or null");return o}t.assertIsDefined=g;function e(...o){const i=[];for(let a=0;a<o.length;a++){const L=o[a];if(N(L))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(L)}return i}t.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function A(o){if(!r(o))return!1;for(const i in o)if(E.call(o,i))return!1;return!0}t.isEmptyObject=A;function p(o){return typeof o=="function"}t.isFunction=p;function _(...o){return o.length>0&&o.every(p)}t.areFunctions=_;function m(o,i){const a=Math.min(o.length,i.length);for(let L=0;L<a;L++)l(o[L],i[L])}t.validateConstraints=m;function l(o,i){if(P(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(o instanceof i)return}catch{}if(!N(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=l}),te(ne[41],re([0,1,26]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const F=Object.create(null);function r(f,u){if((0,P.isString)(u)){const s=F[u];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${u}`);u=s}return F[f]=u,{id:f}}function c(){return F}t.getCodiconFontCharacters=c;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ne[14],re([0,1,26]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function F(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const _=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([m,l])=>{_[m]=l&&typeof l=="object"?F(l):l}),_}t.deepClone=F;function r(p){if(!p||typeof p!="object")return p;const _=[p];for(;_.length>0;){const m=_.shift();Object.freeze(m);for(const l in m)if(c.call(m,l)){const o=m[l];typeof o=="object"&&!Object.isFrozen(o)&&!(0,P.isTypedArray)(o)&&_.push(o)}}return p}t.deepFreeze=r;const c=Object.prototype.hasOwnProperty;function w(p,_){return f(p,_,new Set)}t.cloneAndChange=w;function f(p,_,m){if((0,P.isUndefinedOrNull)(p))return p;const l=_(p);if(typeof l<"u")return l;if(Array.isArray(p)){const o=[];for(const i of p)o.push(f(i,_,m));return o}if((0,P.isObject)(p)){if(m.has(p))throw new Error("Cannot clone recursive data-structure");m.add(p);const o={};for(const i in p)c.call(p,i)&&(o[i]=f(p[i],_,m));return m.delete(p),o}return p}function u(p,_,m=!0){return(0,P.isObject)(p)?((0,P.isObject)(_)&&Object.keys(_).forEach(l=>{l in p?m&&((0,P.isObject)(p[l])&&(0,P.isObject)(_[l])?u(p[l],_[l],m):p[l]=_[l]):p[l]=_[l]}),p):_}t.mixin=u;function s(p,_){if(p===_)return!0;if(p==null||_===null||_===void 0||typeof p!=typeof _||typeof p!="object"||Array.isArray(p)!==Array.isArray(_))return!1;let m,l;if(Array.isArray(p)){if(p.length!==_.length)return!1;for(m=0;m<p.length;m++)if(!s(p[m],_[m]))return!1}else{const o=[];for(l in p)o.push(l);o.sort();const i=[];for(l in _)i.push(l);if(i.sort(),!s(o,i))return!1;for(m=0;m<o.length;m++)if(!s(p[o[m]],_[o[m]]))return!1}return!0}t.equals=s;function h(p){const _=new Set;return JSON.stringify(p,(m,l)=>{if((0,P.isObject)(l)||Array.isArray(l)){if(_.has(l))return"[Circular]";_.add(l)}return l})}t.safeStringify=h;function N(p,_){const m=Object.create(null);return!p||!_||Object.keys(_).forEach(o=>{const i=p[o],a=_[o];s(i,a)||(m[o]=a)}),m}t.distinct=N;function b(p,_){const m=_.toLowerCase(),l=Object.keys(p).find(o=>o.toLowerCase()===m);return l?p[l]:p[_]}t.getCaseInsensitive=b;function g(p,_){const m=Object.create(null);for(const[l,o]of Object.entries(p))_(l,o)&&(m[l]=o);return m}t.filter=g;function e(p){let _=[];for(;Object.prototype!==p;)_=_.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return _}t.getAllPropertyNames=e;function E(p){const _=[];for(const m of e(p))typeof p[m]=="function"&&_.push(m);return _}t.getAllMethodNames=E;function A(p,_){const m=o=>function(){const i=Array.prototype.slice.call(arguments,0);return _(o,i)},l={};for(const o of p)l[o]=m(o);return l}t.createProxyObject=A}),te(ne[27],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(t.Constants=P={}));function F(c){return c<0?0:c>255?255:c|0}t.toUint8=F;function r(c){return c<0?0:c>4294967295?4294967295:c|0}t.toUint32=r}),te(ne[28],re([0,1,27]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class F{constructor(f){const u=(0,P.toUint8)(f);this._defaultValue=u,this._asciiMap=F._createAsciiMap(u),this._map=new Map}static _createAsciiMap(f){const u=new Uint8Array(256);return u.fill(f),u}set(f,u){const s=(0,P.toUint8)(u);f>=0&&f<256?this._asciiMap[f]=s:this._map.set(f,s)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=F;var r;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(r||(r={}));class c{constructor(){this._actual=new F(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}clear(){return this._actual.clear()}}t.CharacterSet=c}),te(ne[4],re([0,1,3]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class F{static addRange(w,f){let u=0;for(;u<f.length&&f[u].endExclusive<w.start;)u++;let s=u;for(;s<f.length&&f[s].start<=w.endExclusive;)s++;if(u===s)f.splice(u,0,w);else{const h=Math.min(w.start,f[u].start),N=Math.max(w.endExclusive,f[s-1].endExclusive);f.splice(u,s-u,new F(h,N))}}static tryCreate(w,f){if(!(w>f))return new F(w,f)}static ofLength(w){return new F(0,w)}static ofStartAndLength(w,f){return new F(w,w+f)}constructor(w,f){if(this.start=w,this.endExclusive=f,w>f)throw new P.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new F(this.start+w,this.endExclusive+w)}deltaStart(w){return new F(this.start+w,this.endExclusive)}deltaEnd(w){return new F(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new F(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const f=Math.max(this.start,w.start),u=Math.min(this.endExclusive,w.endExclusive);if(f<=u)return new F(f,u)}intersects(w){const f=Math.max(this.start,w.start),u=Math.min(this.endExclusive,w.endExclusive);return f<u}intersectsOrTouches(w){const f=Math.max(this.start,w.start),u=Math.min(this.endExclusive,w.endExclusive);return f<=u}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new P.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new P.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const f=[];for(let u=this.start;u<this.endExclusive;u++)f.push(w(u));return f}forEach(w){for(let f=this.start;f<this.endExclusive;f++)w(f)}}t.OffsetRange=F;class r{constructor(){this._sortedRanges=[]}addRange(w){let f=0;for(;f<this._sortedRanges.length&&this._sortedRanges[f].endExclusive<w.start;)f++;let u=f;for(;u<this._sortedRanges.length&&this._sortedRanges[u].start<=w.endExclusive;)u++;if(f===u)this._sortedRanges.splice(f,0,w);else{const s=Math.min(w.start,this._sortedRanges[f].start),h=Math.max(w.endExclusive,this._sortedRanges[u-1].endExclusive);this._sortedRanges.splice(f,u-f,new F(s,h))}}toString(){return this._sortedRanges.map(w=>w.toString()).join(", ")}intersectsStrict(w){let f=0;for(;f<this._sortedRanges.length&&this._sortedRanges[f].endExclusive<=w.start;)f++;return f<this._sortedRanges.length&&this._sortedRanges[f].start<w.endExclusive}intersectWithRange(w){const f=new r;for(const u of this._sortedRanges){const s=u.intersect(w);s&&f.addRange(s)}return f}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this._sortedRanges.reduce((w,f)=>w+f.length,0)}}t.OffsetRangeSet=r}),te(ne[5],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(r,c){this.lineNumber=r,this.column=c}with(r=this.lineNumber,c=this.column){return r===this.lineNumber&&c===this.column?this:new P(r,c)}delta(r=0,c=0){return this.with(this.lineNumber+r,this.column+c)}equals(r){return P.equals(this,r)}static equals(r,c){return!r&&!c?!0:!!r&&!!c&&r.lineNumber===c.lineNumber&&r.column===c.column}isBefore(r){return P.isBefore(this,r)}static isBefore(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<c.column}isBeforeOrEqual(r){return P.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<=c.column}static compare(r,c){const w=r.lineNumber|0,f=c.lineNumber|0;if(w===f){const u=r.column|0,s=c.column|0;return u-s}return w-f}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new P(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.Position=P}),te(ne[2],re([0,1,5]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class F{constructor(c,w,f,u){c>f||c===f&&w>u?(this.startLineNumber=f,this.startColumn=u,this.endLineNumber=c,this.endColumn=w):(this.startLineNumber=c,this.startColumn=w,this.endLineNumber=f,this.endColumn=u)}isEmpty(){return F.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return F.containsPosition(this,c)}static containsPosition(c,w){return!(w.lineNumber<c.startLineNumber||w.lineNumber>c.endLineNumber||w.lineNumber===c.startLineNumber&&w.column<c.startColumn||w.lineNumber===c.endLineNumber&&w.column>c.endColumn)}static strictContainsPosition(c,w){return!(w.lineNumber<c.startLineNumber||w.lineNumber>c.endLineNumber||w.lineNumber===c.startLineNumber&&w.column<=c.startColumn||w.lineNumber===c.endLineNumber&&w.column>=c.endColumn)}containsRange(c){return F.containsRange(this,c)}static containsRange(c,w){return!(w.startLineNumber<c.startLineNumber||w.endLineNumber<c.startLineNumber||w.startLineNumber>c.endLineNumber||w.endLineNumber>c.endLineNumber||w.startLineNumber===c.startLineNumber&&w.startColumn<c.startColumn||w.endLineNumber===c.endLineNumber&&w.endColumn>c.endColumn)}strictContainsRange(c){return F.strictContainsRange(this,c)}static strictContainsRange(c,w){return!(w.startLineNumber<c.startLineNumber||w.endLineNumber<c.startLineNumber||w.startLineNumber>c.endLineNumber||w.endLineNumber>c.endLineNumber||w.startLineNumber===c.startLineNumber&&w.startColumn<=c.startColumn||w.endLineNumber===c.endLineNumber&&w.endColumn>=c.endColumn)}plusRange(c){return F.plusRange(this,c)}static plusRange(c,w){let f,u,s,h;return w.startLineNumber<c.startLineNumber?(f=w.startLineNumber,u=w.startColumn):w.startLineNumber===c.startLineNumber?(f=w.startLineNumber,u=Math.min(w.startColumn,c.startColumn)):(f=c.startLineNumber,u=c.startColumn),w.endLineNumber>c.endLineNumber?(s=w.endLineNumber,h=w.endColumn):w.endLineNumber===c.endLineNumber?(s=w.endLineNumber,h=Math.max(w.endColumn,c.endColumn)):(s=c.endLineNumber,h=c.endColumn),new F(f,u,s,h)}intersectRanges(c){return F.intersectRanges(this,c)}static intersectRanges(c,w){let f=c.startLineNumber,u=c.startColumn,s=c.endLineNumber,h=c.endColumn;const N=w.startLineNumber,b=w.startColumn,g=w.endLineNumber,e=w.endColumn;return f<N?(f=N,u=b):f===N&&(u=Math.max(u,b)),s>g?(s=g,h=e):s===g&&(h=Math.min(h,e)),f>s||f===s&&u>h?null:new F(f,u,s,h)}equalsRange(c){return F.equalsRange(this,c)}static equalsRange(c,w){return!c&&!w?!0:!!c&&!!w&&c.startLineNumber===w.startLineNumber&&c.startColumn===w.startColumn&&c.endLineNumber===w.endLineNumber&&c.endColumn===w.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(c){return new P.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(c){return new P.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,w){return new F(this.startLineNumber,this.startColumn,c,w)}setStartPosition(c,w){return new F(c,w,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(c){return new F(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(c){return new F(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new F(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,w=c){return new F(c.lineNumber,c.column,w.lineNumber,w.column)}static lift(c){return c?new F(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,w){return!(c.endLineNumber<w.startLineNumber||c.endLineNumber===w.startLineNumber&&c.endColumn<w.startColumn||w.endLineNumber<c.startLineNumber||w.endLineNumber===c.startLineNumber&&w.endColumn<c.startColumn)}static areIntersecting(c,w){return!(c.endLineNumber<w.startLineNumber||c.endLineNumber===w.startLineNumber&&c.endColumn<=w.startColumn||w.endLineNumber<c.startLineNumber||w.endLineNumber===c.startLineNumber&&w.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,w){if(c&&w){const s=c.startLineNumber|0,h=w.startLineNumber|0;if(s===h){const N=c.startColumn|0,b=w.startColumn|0;if(N===b){const g=c.endLineNumber|0,e=w.endLineNumber|0;if(g===e){const E=c.endColumn|0,A=w.endColumn|0;return E-A}return g-e}return N-b}return s-h}return(c?1:0)-(w?1:0)}static compareRangesUsingEnds(c,w){return c.endLineNumber===w.endLineNumber?c.endColumn===w.endColumn?c.startLineNumber===w.startLineNumber?c.startColumn-w.startColumn:c.startLineNumber-w.startLineNumber:c.endColumn-w.endColumn:c.endLineNumber-w.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.Range=F}),te(ne[42],re([0,1,2]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class F{static insert(c,w){return{range:new P.Range(c.lineNumber,c.column,c.lineNumber,c.column),text:w,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,w){return{range:c,text:w}}static replaceMove(c,w){return{range:c,text:w,forceMoveMarkers:!0}}}t.EditOperation=F}),te(ne[12],re([0,1,3,4,2,9]),function(B,t,P,F,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class w{static fromRange(s){return new w(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new w(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new w(s.startLineNumber,h.startLineNumber),new w(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new w(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new w(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let N=1;N<s.length;N++)h=h.getUnion(new f(s[N].slice()));return h.ranges}static ofLength(s,h){return new w(s,s+h)}static deserialize(s){return new w(s[0],s[1])}constructor(s,h){if(s>h)throw new P.BugIndicatingError(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new w(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new w(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new w(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),N=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=N)return new w(h,N)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)h.push(s(N));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new F.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=w;class f{constructor(s=[]){this._normalizedRanges=s}get ranges(){return this._normalizedRanges}addRange(s){if(s.length===0)return;const h=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,b=>b.endLineNumberExclusive>=s.startLineNumber),N=(0,c.findLastIdxMonotonous)(this._normalizedRanges,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(h===N)this._normalizedRanges.splice(h,0,s);else if(h===N-1){const b=this._normalizedRanges[h];this._normalizedRanges[h]=b.join(s)}else{const b=this._normalizedRanges[h].join(this._normalizedRanges[N-1]).join(s);this._normalizedRanges.splice(h,N-h,b)}}contains(s){const h=(0,c.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,c.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this._normalizedRanges.length===0)return s;if(s._normalizedRanges.length===0)return this;const h=[];let N=0,b=0,g=null;for(;N<this._normalizedRanges.length||b<s._normalizedRanges.length;){let e=null;if(N<this._normalizedRanges.length&&b<s._normalizedRanges.length){const E=this._normalizedRanges[N],A=s._normalizedRanges[b];E.startLineNumber<A.startLineNumber?(e=E,N++):(e=A,b++)}else N<this._normalizedRanges.length?(e=this._normalizedRanges[N],N++):(e=s._normalizedRanges[b],b++);g===null?g=e:g.endLineNumberExclusive>=e.startLineNumber?g=new w(g.startLineNumber,Math.max(g.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(g),g=e)}return g!==null&&h.push(g),new f(h)}subtractFrom(s){const h=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=s.startLineNumber),N=(0,c.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===N)return new f([s]);const b=[];let g=s.startLineNumber;for(let e=h;e<N;e++){const E=this._normalizedRanges[e];E.startLineNumber>g&&b.push(new w(g,E.startLineNumber)),g=E.endLineNumberExclusive}return g<s.endLineNumberExclusive&&b.push(new w(g,s.endLineNumberExclusive)),new f(b)}toString(){return this._normalizedRanges.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let N=0,b=0;for(;N<this._normalizedRanges.length&&b<s._normalizedRanges.length;){const g=this._normalizedRanges[N],e=s._normalizedRanges[b],E=g.intersect(e);E&&!E.isEmpty&&h.push(E),g.endLineNumberExclusive<e.endLineNumberExclusive?N++:b++}return new f(h)}getWithDelta(s){return new f(this._normalizedRanges.map(h=>h.delta(s)))}}t.LineRangeSet=f}),te(ne[43],re([0,1,5,2]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var r;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class c extends F.Range{constructor(f,u,s,h){super(f,u,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=u,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return c.selectionsEqual(this,f)}static selectionsEqual(f,u){return f.selectionStartLineNumber===u.selectionStartLineNumber&&f.selectionStartColumn===u.selectionStartColumn&&f.positionLineNumber===u.positionLineNumber&&f.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,u){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,f,u):new c(f,u,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,u){return this.getDirection()===0?new c(f,u,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,f,u)}static fromPositions(f,u=f){return new c(f.lineNumber,f.column,u.lineNumber,u.column)}static fromRange(f,u){return u===0?new c(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new c(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new c(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,u){if(f&&!u||!f&&u)return!1;if(!f&&!u)return!0;if(f.length!==u.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],u[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,u,s,h,N){return N===0?new c(f,u,s,h):new c(s,h,f,u)}}t.Selection=c}),te(ne[44],re([0,1,28]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var F;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class r extends P.CharacterClassifier{constructor(f){super(0);for(let u=0,s=f.length;u<s;u++)this.set(f.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=r;function c(w){const f={};return u=>(f.hasOwnProperty(u)||(f[u]=w(u)),f[u])}t.getMapForWordSeparators=c(w=>new r(w))}),te(ne[29],re([0,1,20,10,21]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(N=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const g of t.USUAL_WORD_SEPARATORS)N.indexOf(g)>=0||(b+="\\"+g);return b+="\\s]+)",new RegExp(b,"g")}t.DEFAULT_WORD_REGEXP=c();function w(N){let b=t.DEFAULT_WORD_REGEXP;if(N&&N instanceof RegExp)if(N.global)b=N;else{let g="g";N.ignoreCase&&(g+="i"),N.multiline&&(g+="m"),N.unicode&&(g+="u"),b=new RegExp(N.source,g)}return b.lastIndex=0,b}t.ensureValidWordDefinition=w;const f=new r.LinkedList;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function u(N){const b=f.unshift(N);return(0,F.toDisposable)(b)}t.setDefaultGetWordAtTextConfig=u;function s(N,b,g,e,E){if(b=w(b),E||(E=P.Iterable.first(f)),g.length>E.maxLen){let l=N-E.maxLen/2;return l<0?l=0:e+=l,g=g.substring(l,N+E.maxLen/2),s(N,b,g,e,E)}const A=Date.now(),p=N-1-e;let _=-1,m=null;for(let l=1;!(Date.now()-A>=E.timeBudget);l++){const o=p-E.windowSize*l;b.lastIndex=Math.max(0,o);const i=h(b,g,p,_);if(!i&&m||(m=i,o<=0))break;_=o}if(m){const l={word:m[0],startColumn:e+1+m.index,endColumn:e+1+m.index+m[0].length};return b.lastIndex=0,l}return null}t.getWordAtText=s;function h(N,b,g,e){let E;for(;E=N.exec(b);){const A=E.index||0;if(A<=g&&N.lastIndex>=g)return E;if(e>0&&A>e)return null}return null}}),te(ne[8],re([0,1,6,3,4]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class c{static trivial(N,b){return new c([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(b.length))],!1)}static trivialTimedOut(N,b){return new c([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(b.length))],!0)}constructor(N,b){this.diffs=N,this.hitTimeout=b}}t.DiffAlgorithmResult=c;class w{static invert(N,b){const g=[];return(0,P.forEachAdjacent)(N,(e,E)=>{g.push(w.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),g}static fromOffsetPairs(N,b){return new w(new r.OffsetRange(N.offset1,b.offset1),new r.OffsetRange(N.offset2,b.offset2))}constructor(N,b){this.seq1Range=N,this.seq2Range=b}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new w(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new w(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new w(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new w(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const b=this.seq1Range.intersect(N.seq1Range),g=this.seq2Range.intersect(N.seq2Range);if(!(!b||!g))return new w(b,g)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=w;class f{static{this.zero=new f(0,0)}static{this.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,b){this.offset1=N,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(N){return N===0?this:new f(this.offset1+N,this.offset2+N)}equals(N){return this.offset1===N.offset1&&this.offset2===N.offset2}}t.OffsetPair=f;class u{static{this.instance=new u}isValid(){return!0}}t.InfiniteTimeout=u;class s{constructor(N){if(this.timeout=N,this.startTime=Date.now(),this.valid=!0,N<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=s}),te(ne[30],re([0,1,4,8]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class r{compute(s,h,N=F.InfiniteTimeout.instance){if(s.length===0||h.length===0)return F.DiffAlgorithmResult.trivial(s,h);const b=s,g=h;function e(a,L){for(;a<b.length&&L<g.length&&b.getElement(a)===g.getElement(L);)a++,L++;return a}let E=0;const A=new w;A.set(0,e(0,0));const p=new f;p.set(0,A.get(0)===0?null:new c(null,0,0,A.get(0)));let _=0;e:for(;;){if(E++,!N.isValid())return F.DiffAlgorithmResult.trivialTimedOut(b,g);const a=-Math.min(E,g.length+E%2),L=Math.min(E,b.length+E%2);for(_=a;_<=L;_+=2){let d=0;const v=_===L?-1:A.get(_+1),M=_===a?-1:A.get(_-1)+1;d++;const R=Math.min(Math.max(v,M),b.length),D=R-_;if(d++,R>b.length||D>g.length)continue;const k=e(R,D);A.set(_,k);const y=R===v?p.get(_+1):p.get(_-1);if(p.set(_,k!==R?new c(y,R,D,k-R):y),A.get(_)===b.length&&A.get(_)-_===g.length)break e}}let m=p.get(_);const l=[];let o=b.length,i=g.length;for(;;){const a=m?m.x+m.length:0,L=m?m.y+m.length:0;if((a!==o||L!==i)&&l.push(new F.SequenceDiff(new P.OffsetRange(a,o),new P.OffsetRange(L,i))),!m)break;o=m.x,i=m.y,m=m.prev}return l.reverse(),new F.DiffAlgorithmResult(l,!1)}}t.MyersDiffAlgorithm=r;class c{constructor(s,h,N,b){this.prev=s,this.x=h,this.y=N,this.length=b}}class w{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const N=this.negativeArr;this.negativeArr=new Int32Array(N.length*2),this.negativeArr.set(N)}this.negativeArr[s]=h}else{if(s>=this.positiveArr.length){const N=this.positiveArr;this.positiveArr=new Int32Array(N.length*2),this.positiveArr.set(N)}this.positiveArr[s]=h}}}class f{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,h){s<0?(s=-s-1,this.negativeArr[s]=h):this.positiveArr[s]=h}}}),te(ne[45],re([0,1,6,4,8]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeVeryShortMatchingTextBetweenLongDiffs=t.removeVeryShortMatchingLinesBetweenDiffs=t.extendDiffsToEntireWordIfAppropriate=t.removeShortMatches=t.optimizeSequenceDiffs=void 0;function c(e,E,A){let p=A;return p=w(e,E,p),p=w(e,E,p),p=f(e,E,p),p}t.optimizeSequenceDiffs=c;function w(e,E,A){if(A.length===0)return A;const p=[];p.push(A[0]);for(let m=1;m<A.length;m++){const l=p[p.length-1];let o=A[m];if(o.seq1Range.isEmpty||o.seq2Range.isEmpty){const i=o.seq1Range.start-l.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(o.seq1Range.start-a)!==e.getElement(o.seq1Range.endExclusive-a)||E.getElement(o.seq2Range.start-a)!==E.getElement(o.seq2Range.endExclusive-a));a++);if(a--,a===i){p[p.length-1]=new r.SequenceDiff(new F.OffsetRange(l.seq1Range.start,o.seq1Range.endExclusive-i),new F.OffsetRange(l.seq2Range.start,o.seq2Range.endExclusive-i));continue}o=o.delta(-a)}p.push(o)}const _=[];for(let m=0;m<p.length-1;m++){const l=p[m+1];let o=p[m];if(o.seq1Range.isEmpty||o.seq2Range.isEmpty){const i=l.seq1Range.start-o.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(o.seq1Range.start+a,o.seq1Range.endExclusive+a)||!E.isStronglyEqual(o.seq2Range.start+a,o.seq2Range.endExclusive+a));a++);if(a===i){p[m+1]=new r.SequenceDiff(new F.OffsetRange(o.seq1Range.start+i,l.seq1Range.endExclusive),new F.OffsetRange(o.seq2Range.start+i,l.seq2Range.endExclusive));continue}a>0&&(o=o.delta(a))}_.push(o)}return p.length>0&&_.push(p[p.length-1]),_}function f(e,E,A){if(!e.getBoundaryScore||!E.getBoundaryScore)return A;for(let p=0;p<A.length;p++){const _=p>0?A[p-1]:void 0,m=A[p],l=p+1<A.length?A[p+1]:void 0,o=new F.OffsetRange(_?_.seq1Range.endExclusive+1:0,l?l.seq1Range.start-1:e.length),i=new F.OffsetRange(_?_.seq2Range.endExclusive+1:0,l?l.seq2Range.start-1:E.length);m.seq1Range.isEmpty?A[p]=u(m,e,E,o,i):m.seq2Range.isEmpty&&(A[p]=u(m.swap(),E,e,i,o).swap())}return A}function u(e,E,A,p,_){let l=1;for(;e.seq1Range.start-l>=p.start&&e.seq2Range.start-l>=_.start&&A.isStronglyEqual(e.seq2Range.start-l,e.seq2Range.endExclusive-l)&&l<100;)l++;l--;let o=0;for(;e.seq1Range.start+o<p.endExclusive&&e.seq2Range.endExclusive+o<_.endExclusive&&A.isStronglyEqual(e.seq2Range.start+o,e.seq2Range.endExclusive+o)&&o<100;)o++;if(l===0&&o===0)return e;let i=0,a=-1;for(let L=-l;L<=o;L++){const d=e.seq2Range.start+L,v=e.seq2Range.endExclusive+L,M=e.seq1Range.start+L,R=E.getBoundaryScore(M)+A.getBoundaryScore(d)+A.getBoundaryScore(v);R>a&&(a=R,i=L)}return e.delta(i)}function s(e,E,A){const p=[];for(const _ of A){const m=p[p.length-1];if(!m){p.push(_);continue}_.seq1Range.start-m.seq1Range.endExclusive<=2||_.seq2Range.start-m.seq2Range.endExclusive<=2?p[p.length-1]=new r.SequenceDiff(m.seq1Range.join(_.seq1Range),m.seq2Range.join(_.seq2Range)):p.push(_)}return p}t.removeShortMatches=s;function h(e,E,A){const p=r.SequenceDiff.invert(A,e.length),_=[];let m=new r.OffsetPair(0,0);function l(i,a){if(i.offset1<m.offset1||i.offset2<m.offset2)return;const L=e.findWordContaining(i.offset1),d=E.findWordContaining(i.offset2);if(!L||!d)return;let v=new r.SequenceDiff(L,d);const M=v.intersect(a);let R=M.seq1Range.length,D=M.seq2Range.length;for(;p.length>0;){const k=p[0];if(!(k.seq1Range.intersects(L)||k.seq2Range.intersects(d)))break;const I=e.findWordContaining(k.seq1Range.start),T=E.findWordContaining(k.seq2Range.start),O=new r.SequenceDiff(I,T),q=O.intersect(k);if(R+=q.seq1Range.length,D+=q.seq2Range.length,v=v.join(O),v.seq1Range.endExclusive>=k.seq1Range.endExclusive)p.shift();else break}R+D<(v.seq1Range.length+v.seq2Range.length)*2/3&&_.push(v),m=v.getEndExclusives()}for(;p.length>0;){const i=p.shift();i.seq1Range.isEmpty||(l(i.getStarts(),i),l(i.getEndExclusives().delta(-1),i))}return N(A,_)}t.extendDiffsToEntireWordIfAppropriate=h;function N(e,E){const A=[];for(;e.length>0||E.length>0;){const p=e[0],_=E[0];let m;p&&(!_||p.seq1Range.start<_.seq1Range.start)?m=e.shift():m=E.shift(),A.length>0&&A[A.length-1].seq1Range.endExclusive>=m.seq1Range.start?A[A.length-1]=A[A.length-1].join(m):A.push(m)}return A}function b(e,E,A){let p=A;if(p.length===0)return p;let _=0,m;do{m=!1;const l=[p[0]];for(let o=1;o<p.length;o++){let L=function(v,M){const R=new F.OffsetRange(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=p[o],a=l[l.length-1];L(a,i)?(m=!0,l[l.length-1]=l[l.length-1].join(i)):l.push(i)}p=l}while(_++<10&&m);return p}t.removeVeryShortMatchingLinesBetweenDiffs=b;function g(e,E,A){let p=A;if(p.length===0)return p;let _=0,m;do{m=!1;const o=[p[0]];for(let i=1;i<p.length;i++){let d=function(M,R){const D=new F.OffsetRange(L.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const y=e.getText(D).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(M.seq1Range),T=M.seq1Range.length,O=E.countLinesIn(M.seq2Range),q=M.seq2Range.length,S=e.countLinesIn(R.seq1Range),W=R.seq1Range.length,Q=E.countLinesIn(R.seq2Range),H=R.seq2Range.length,Z=2*40+50;function ee(n){return Math.min(n,Z)}return Math.pow(Math.pow(ee(I*40+T),1.5)+Math.pow(ee(O*40+q),1.5),1.5)+Math.pow(Math.pow(ee(S*40+W),1.5)+Math.pow(ee(Q*40+H),1.5),1.5)>(Z**1.5)**1.5*1.3};const a=p[i],L=o[o.length-1];d(L,a)?(m=!0,o[o.length-1]=o[o.length-1].join(a)):o.push(a)}p=o}while(_++<10&&m);const l=[];return(0,P.forEachWithNeighbors)(p,(o,i,a)=>{let L=i;function d(y){return y.length>0&&y.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),M=e.getText(new F.OffsetRange(v.start,i.seq1Range.start));d(M)&&(L=L.deltaStart(-M.length));const R=e.getText(new F.OffsetRange(i.seq1Range.endExclusive,v.endExclusive));d(R)&&(L=L.deltaEnd(R.length));const D=r.SequenceDiff.fromOffsetPairs(o?o.getEndExclusives():r.OffsetPair.zero,a?a.getStarts():r.OffsetPair.max),k=L.intersect(D);l.length>0&&k.getStarts().equals(l[l.length-1].getEndExclusives())?l[l.length-1]=l[l.length-1].join(k):l.push(k)}),l}t.removeVeryShortMatchingTextBetweenLongDiffs=g}),te(ne[46],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class P{constructor(c,w){this.trimmedHash=c,this.lines=w}getElement(c){return this.trimmedHash[c]}get length(){return this.trimmedHash.length}getBoundaryScore(c){const w=c===0?0:F(this.lines[c-1]),f=c===this.lines.length?0:F(this.lines[c]);return 1e3-(w+f)}getText(c){return this.lines.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,w){return this.lines[c]===this.lines[w]}}t.LineSequence=P;function F(r){let c=0;for(;c<r.length&&(r.charCodeAt(c)===32||r.charCodeAt(c)===9);)c++;return c}}),te(ne[15],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.isSpace=t.Array2D=void 0;class P{constructor(w,f){this.width=w,this.height=f,this.array=[],this.array=new Array(w*f)}get(w,f){return this.array[w+f*this.width]}set(w,f,u){this.array[w+f*this.width]=u}}t.Array2D=P;function F(c){return c===32||c===9}t.isSpace=F;class r{static{this.chrKeys=new Map}static getKey(w){let f=this.chrKeys.get(w);return f===void 0&&(f=this.chrKeys.size,this.chrKeys.set(w,f)),f}constructor(w,f,u){this.range=w,this.lines=f,this.source=u,this.histogram=[];let s=0;for(let h=w.startLineNumber-1;h<w.endLineNumberExclusive-1;h++){const N=f[h];for(let g=0;g<N.length;g++){s++;const e=N[g],E=r.getKey(e);this.histogram[E]=(this.histogram[E]||0)+1}s++;const b=r.getKey(`
`);this.histogram[b]=(this.histogram[b]||0)+1}this.totalCount=s}computeSimilarity(w){let f=0;const u=Math.max(this.histogram.length,w.histogram.length);for(let s=0;s<u;s++)f+=Math.abs((this.histogram[s]??0)-(w.histogram[s]??0));return 1-f/(this.totalCount+w.totalCount)}}t.LineRangeFragment=r}),te(ne[47],re([0,1,4,8,15]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class c{compute(f,u,s=F.InfiniteTimeout.instance,h){if(f.length===0||u.length===0)return F.DiffAlgorithmResult.trivial(f,u);const N=new r.Array2D(f.length,u.length),b=new r.Array2D(f.length,u.length),g=new r.Array2D(f.length,u.length);for(let l=0;l<f.length;l++)for(let o=0;o<u.length;o++){if(!s.isValid())return F.DiffAlgorithmResult.trivialTimedOut(f,u);const i=l===0?0:N.get(l-1,o),a=o===0?0:N.get(l,o-1);let L;f.getElement(l)===u.getElement(o)?(l===0||o===0?L=0:L=N.get(l-1,o-1),l>0&&o>0&&b.get(l-1,o-1)===3&&(L+=g.get(l-1,o-1)),L+=h?h(l,o):1):L=-1;const d=Math.max(i,a,L);if(d===L){const v=l>0&&o>0?g.get(l-1,o-1):0;g.set(l,o,v+1),b.set(l,o,3)}else d===i?(g.set(l,o,0),b.set(l,o,1)):d===a&&(g.set(l,o,0),b.set(l,o,2));N.set(l,o,d)}const e=[];let E=f.length,A=u.length;function p(l,o){(l+1!==E||o+1!==A)&&e.push(new F.SequenceDiff(new P.OffsetRange(l+1,E),new P.OffsetRange(o+1,A))),E=l,A=o}let _=f.length-1,m=u.length-1;for(;_>=0&&m>=0;)b.get(_,m)===3?(p(_,m),_--,m--):b.get(_,m)===1?_--:m--;return p(-1,-1),e.reverse(),new F.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=c}),te(ne[31],re([0,1,9,4,5,2,15]),function(B,t,P,F,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class f{constructor(e,E,A){this.lines=e,this.considerWhitespaceChanges=A,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let p=!1;E.start>0&&E.endExclusive>=e.length&&(E=new F.OffsetRange(E.start-1,E.endExclusive),p=!0),this.lineRange=E,this.firstCharOffsetByLine[0]=0;for(let _=this.lineRange.start;_<this.lineRange.endExclusive;_++){let m=e[_],l=0;if(p)l=m.length,m="",p=!1;else if(!A){const o=m.trimStart();l=m.length-o.length,m=o.trimEnd()}this.additionalOffsetByLine.push(l);for(let o=0;o<m.length;o++)this.elements.push(m.charCodeAt(o));_<e.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[_-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const E=b(e>0?this.elements[e-1]:-1),A=b(e<this.elements.length?this.elements[e]:-1);if(E===7&&A===8)return 0;if(E===8)return 150;let p=0;return E!==A&&(p+=10,E===0&&A===1&&(p+=1)),p+=N(E),p+=N(A),p}translateOffset(e){if(this.lineRange.isEmpty)return new r.Position(this.lineRange.start+1,1);const E=(0,P.findLastIdxMonotonous)(this.firstCharOffsetByLine,A=>A<=e);return new r.Position(this.lineRange.start+E+1,e-this.firstCharOffsetByLine[E]+this.additionalOffsetByLine[E]+1)}translateRange(e){return c.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!u(this.elements[e]))return;let E=e;for(;E>0&&u(this.elements[E-1]);)E--;let A=e;for(;A<this.elements.length&&u(this.elements[A]);)A++;return new F.OffsetRange(E,A)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.elements[e]===this.elements[E]}extendToFullLines(e){const E=(0,P.findLastMonotonous)(this.firstCharOffsetByLine,p=>p<=e.start)??0,A=(0,P.findFirstMonotonous)(this.firstCharOffsetByLine,p=>e.endExclusive<=p)??this.elements.length;return new F.OffsetRange(E,A)}}t.LinesSliceCharSequence=f;function u(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}var s;(function(g){g[g.WordLower=0]="WordLower",g[g.WordUpper=1]="WordUpper",g[g.WordNumber=2]="WordNumber",g[g.End=3]="End",g[g.Other=4]="Other",g[g.Separator=5]="Separator",g[g.Space=6]="Space",g[g.LineBreakCR=7]="LineBreakCR",g[g.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:30,[6]:3,[7]:10,[8]:10};function N(g){return h[g]}function b(g){return g===10?8:g===13?7:(0,w.isSpace)(g)?6:g>=97&&g<=122?0:g>=65&&g<=90?1:g>=48&&g<=57?2:g===-1?3:g===44||g===59?5:4}}),te(ne[32],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class P{constructor(c,w,f){this.changes=c,this.moves=w,this.hitTimeout=f}}t.LinesDiff=P;class F{constructor(c,w){this.lineRangeMapping=c,this.changes=w}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.MovedText=F}),te(ne[16],re([0,1,12]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class F{static inverse(f,u,s){const h=[];let N=1,b=1;for(const e of f){const E=new F(new P.LineRange(N,e.original.startLineNumber),new P.LineRange(b,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),N=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const g=new F(new P.LineRange(N,u+1),new P.LineRange(b,s+1));return g.modified.isEmpty||h.push(g),h}static clip(f,u,s){const h=[];for(const N of f){const b=N.original.intersect(u),g=N.modified.intersect(s);b&&!b.isEmpty&&g&&!g.isEmpty&&h.push(new F(b,g))}return h}constructor(f,u){this.original=f,this.modified=u}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(f){return new F(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.LineRangeMapping=F;class r extends F{constructor(f,u,s){super(f,u),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.DetailedLineRangeMapping=r;class c{constructor(f,u){this.originalRange=f,this.modifiedRange=u}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}t.RangeMapping=c}),te(ne[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(B,t,P,F,r,c,w,f,u,s,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=void 0;function b(m,l,o,i,a,L){let{moves:d,excludedChanges:v}=e(m,l,o,L);if(!L.isValid())return[];const M=m.filter(D=>!v.has(D)),R=E(M,i,a,l,o,L);return(0,r.pushMany)(d,R),d=p(d),d=d.filter(D=>{const k=D.original.toOffsetRange().slice(l).map(I=>I.trim());return k.join(`
`).length>=15&&g(k,I=>I.length>=2)>=2}),d=_(m,d),d}t.computeMovedLines=b;function g(m,l){let o=0;for(const i of m)l(i)&&o++;return o}function e(m,l,o,i){const a=[],L=m.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new h.LineRangeFragment(M.original,l,M)),d=new Set(m.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new h.LineRangeFragment(M.modified,o,M))),v=new Set;for(const M of L){let R=-1,D;for(const k of d){const y=M.computeSimilarity(k);y>R&&(R=y,D=k)}if(R>.9&&D&&(d.delete(D),a.push(new F.LineRangeMapping(M.range,D.range)),v.add(M.source),v.add(D.source)),!i.isValid())return{moves:a,excludedChanges:v}}return{moves:a,excludedChanges:v}}function E(m,l,o,i,a,L){const d=[],v=new w.SetMap;for(const y of m)for(let I=y.original.startLineNumber;I<y.original.endLineNumberExclusive-2;I++){const T=`${l[I-1]}:${l[I+1-1]}:${l[I+2-1]}`;v.add(T,{range:new f.LineRange(I,I+3)})}const M=[];m.sort((0,r.compareBy)(y=>y.modified.startLineNumber,r.numberComparator));for(const y of m){let I=[];for(let T=y.modified.startLineNumber;T<y.modified.endLineNumberExclusive-2;T++){const O=`${o[T-1]}:${o[T+1-1]}:${o[T+2-1]}`,q=new f.LineRange(T,T+3),S=[];v.forEach(O,({range:W})=>{for(const H of I)if(H.originalLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive&&H.modifiedLineRange.endLineNumberExclusive+1===q.endLineNumberExclusive){H.originalLineRange=new f.LineRange(H.originalLineRange.startLineNumber,W.endLineNumberExclusive),H.modifiedLineRange=new f.LineRange(H.modifiedLineRange.startLineNumber,q.endLineNumberExclusive),S.push(H);return}const Q={modifiedLineRange:q,originalLineRange:W};M.push(Q),S.push(Q)}),I=S}if(!L.isValid())return[]}M.sort((0,r.reverseOrder)((0,r.compareBy)(y=>y.modifiedLineRange.length,r.numberComparator)));const R=new f.LineRangeSet,D=new f.LineRangeSet;for(const y of M){const I=y.modifiedLineRange.startLineNumber-y.originalLineRange.startLineNumber,T=R.subtractFrom(y.modifiedLineRange),O=D.subtractFrom(y.originalLineRange).getWithDelta(I),q=T.getIntersection(O);for(const S of q.ranges){if(S.length<3)continue;const W=S,Q=S.delta(-I);d.push(new F.LineRangeMapping(Q,W)),R.addRange(W),D.addRange(Q)}}d.sort((0,r.compareBy)(y=>y.original.startLineNumber,r.numberComparator));const k=new c.MonotonousArray(m);for(let y=0;y<d.length;y++){const I=d[y],T=k.findLastMonotonous(ee=>ee.original.startLineNumber<=I.original.startLineNumber),O=(0,c.findLastMonotonous)(m,ee=>ee.modified.startLineNumber<=I.modified.startLineNumber),q=Math.max(I.original.startLineNumber-T.original.startLineNumber,I.modified.startLineNumber-O.modified.startLineNumber),S=k.findLastMonotonous(ee=>ee.original.startLineNumber<I.original.endLineNumberExclusive),W=(0,c.findLastMonotonous)(m,ee=>ee.modified.startLineNumber<I.modified.endLineNumberExclusive),Q=Math.max(S.original.endLineNumberExclusive-I.original.endLineNumberExclusive,W.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let H;for(H=0;H<q;H++){const ee=I.original.startLineNumber-H-1,n=I.modified.startLineNumber-H-1;if(ee>i.length||n>a.length||R.contains(n)||D.contains(ee)||!A(i[ee-1],a[n-1],L))break}H>0&&(D.addRange(new f.LineRange(I.original.startLineNumber-H,I.original.startLineNumber)),R.addRange(new f.LineRange(I.modified.startLineNumber-H,I.modified.startLineNumber)));let Z;for(Z=0;Z<Q;Z++){const ee=I.original.endLineNumberExclusive+Z,n=I.modified.endLineNumberExclusive+Z;if(ee>i.length||n>a.length||R.contains(n)||D.contains(ee)||!A(i[ee-1],a[n-1],L))break}Z>0&&(D.addRange(new f.LineRange(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+Z)),R.addRange(new f.LineRange(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+Z))),(H>0||Z>0)&&(d[y]=new F.LineRangeMapping(new f.LineRange(I.original.startLineNumber-H,I.original.endLineNumberExclusive+Z),new f.LineRange(I.modified.startLineNumber-H,I.modified.endLineNumberExclusive+Z)))}return d}function A(m,l,o){if(m.trim()===l.trim())return!0;if(m.length>300&&l.length>300)return!1;const a=new N.MyersDiffAlgorithm().compute(new s.LinesSliceCharSequence([m],new u.OffsetRange(0,1),!1),new s.LinesSliceCharSequence([l],new u.OffsetRange(0,1),!1),o);let L=0;const d=P.SequenceDiff.invert(a.diffs,m.length);for(const D of d)D.seq1Range.forEach(k=>{(0,h.isSpace)(m.charCodeAt(k))||L++});function v(D){let k=0;for(let y=0;y<m.length;y++)(0,h.isSpace)(D.charCodeAt(y))||k++;return k}const M=v(m.length>l.length?m:l);return L/M>.6&&M>10}function p(m){if(m.length===0)return m;m.sort((0,r.compareBy)(o=>o.original.startLineNumber,r.numberComparator));const l=[m[0]];for(let o=1;o<m.length;o++){const i=l[l.length-1],a=m[o],L=a.original.startLineNumber-i.original.endLineNumberExclusive,d=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(L>=0&&d>=0&&L+d<=2){l[l.length-1]=i.join(a);continue}l.push(a)}return l}function _(m,l){const o=new c.MonotonousArray(m);return l=l.filter(i=>{const a=o.findLastMonotonous(v=>v.original.startLineNumber<i.original.endLineNumberExclusive)||new F.LineRangeMapping(new f.LineRange(1,1),new f.LineRange(1,1)),L=(0,c.findLastMonotonous)(m,v=>v.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==L}),l}}),te(ne[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(B,t,P,F,r,c,w,f,u,s,h,N,b,g,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.DefaultLinesDiffComputer=void 0;class A{constructor(){this.dynamicProgrammingDiffing=new u.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new s.MyersDiffAlgorithm}computeDiff(l,o,i){if(l.length<=1&&(0,P.equals)(l,o,(Z,ee)=>Z===ee))return new b.LinesDiff([],[],!1);if(l.length===1&&l[0].length===0||o.length===1&&o[0].length===0)return new b.LinesDiff([new g.DetailedLineRangeMapping(new r.LineRange(1,l.length+1),new r.LineRange(1,o.length+1),[new g.RangeMapping(new w.Range(1,1,l.length,l[0].length+1),new w.Range(1,1,o.length,o[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?f.InfiniteTimeout.instance:new f.DateTimeout(i.maxComputationTimeMs),L=!i.ignoreTrimWhitespace,d=new Map;function v(Z){let ee=d.get(Z);return ee===void 0&&(ee=d.size,d.set(Z,ee)),ee}const M=l.map(Z=>v(Z.trim())),R=o.map(Z=>v(Z.trim())),D=new E.LineSequence(M,l),k=new E.LineSequence(R,o),y=(()=>D.length+k.length<1700?this.dynamicProgrammingDiffing.compute(D,k,a,(Z,ee)=>l[Z]===o[ee]?o[ee].length===0?.1:1+Math.log(1+o[ee].length):.99):this.myersDiffingAlgorithm.compute(D,k))();let I=y.diffs,T=y.hitTimeout;I=(0,N.optimizeSequenceDiffs)(D,k,I),I=(0,N.removeVeryShortMatchingLinesBetweenDiffs)(D,k,I);const O=[],q=Z=>{if(L)for(let ee=0;ee<Z;ee++){const n=S+ee,ae=W+ee;if(l[n]!==o[ae]){const he=this.refineDiff(l,o,new f.SequenceDiff(new c.OffsetRange(n,n+1),new c.OffsetRange(ae,ae+1)),a,L);for(const be of he.mappings)O.push(be);he.hitTimeout&&(T=!0)}}};let S=0,W=0;for(const Z of I){(0,F.assertFn)(()=>Z.seq1Range.start-S===Z.seq2Range.start-W);const ee=Z.seq1Range.start-S;q(ee),S=Z.seq1Range.endExclusive,W=Z.seq2Range.endExclusive;const n=this.refineDiff(l,o,Z,a,L);n.hitTimeout&&(T=!0);for(const ae of n.mappings)O.push(ae)}q(l.length-S);const Q=p(O,l,o);let H=[];return i.computeMoves&&(H=this.computeMoves(Q,l,o,M,R,a,L)),(0,F.assertFn)(()=>{function Z(n,ae){if(n.lineNumber<1||n.lineNumber>ae.length)return!1;const he=ae[n.lineNumber-1];return!(n.column<1||n.column>he.length+1)}function ee(n,ae){return!(n.startLineNumber<1||n.startLineNumber>ae.length+1||n.endLineNumberExclusive<1||n.endLineNumberExclusive>ae.length+1)}for(const n of Q){if(!n.innerChanges)return!1;for(const ae of n.innerChanges)if(!(Z(ae.modifiedRange.getStartPosition(),o)&&Z(ae.modifiedRange.getEndPosition(),o)&&Z(ae.originalRange.getStartPosition(),l)&&Z(ae.originalRange.getEndPosition(),l)))return!1;if(!ee(n.modified,o)||!ee(n.original,l))return!1}return!0}),new b.LinesDiff(Q,H,T)}computeMoves(l,o,i,a,L,d,v){return(0,h.computeMovedLines)(l,o,i,a,L,d).map(D=>{const k=this.refineDiff(o,i,new f.SequenceDiff(D.original.toOffsetRange(),D.modified.toOffsetRange()),d,v),y=p(k.mappings,o,i,!0);return new b.MovedText(D,y)})}refineDiff(l,o,i,a,L){const d=new e.LinesSliceCharSequence(l,i.seq1Range,L),v=new e.LinesSliceCharSequence(o,i.seq2Range,L),M=d.length+v.length<500?this.dynamicProgrammingDiffing.compute(d,v,a):this.myersDiffingAlgorithm.compute(d,v,a);let R=M.diffs;return R=(0,N.optimizeSequenceDiffs)(d,v,R),R=(0,N.extendDiffsToEntireWordIfAppropriate)(d,v,R),R=(0,N.removeShortMatches)(d,v,R),R=(0,N.removeVeryShortMatchingTextBetweenLongDiffs)(d,v,R),{mappings:R.map(k=>new g.RangeMapping(d.translateRange(k.seq1Range),v.translateRange(k.seq2Range))),hitTimeout:M.hitTimeout}}}t.DefaultLinesDiffComputer=A;function p(m,l,o,i=!1){const a=[];for(const L of(0,P.groupAdjacentBy)(m.map(d=>_(d,l,o)),(d,v)=>d.original.overlapOrTouch(v.original)||d.modified.overlapOrTouch(v.modified))){const d=L[0],v=L[L.length-1];a.push(new g.DetailedLineRangeMapping(d.original.join(v.original),d.modified.join(v.modified),L.map(M=>M.innerChanges[0])))}return(0,F.assertFn)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,F.checkAdjacentItems)(a,(L,d)=>d.original.startLineNumber-L.original.endLineNumberExclusive===d.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<d.original.startLineNumber&&L.modified.endLineNumberExclusive<d.modified.startLineNumber)),a}t.lineRangeMappingFromRangeMappings=p;function _(m,l,o){let i=0,a=0;m.modifiedRange.endColumn===1&&m.originalRange.endColumn===1&&m.originalRange.startLineNumber+i<=m.originalRange.endLineNumber&&m.modifiedRange.startLineNumber+i<=m.modifiedRange.endLineNumber&&(a=-1),m.modifiedRange.startColumn-1>=o[m.modifiedRange.startLineNumber-1].length&&m.originalRange.startColumn-1>=l[m.originalRange.startLineNumber-1].length&&m.originalRange.startLineNumber<=m.originalRange.endLineNumber+a&&m.modifiedRange.startLineNumber<=m.modifiedRange.endLineNumber+a&&(i=1);const L=new r.LineRange(m.originalRange.startLineNumber+i,m.originalRange.endLineNumber+1+a),d=new r.LineRange(m.modifiedRange.startLineNumber+i,m.modifiedRange.endLineNumber+1+a);return new g.DetailedLineRangeMapping(L,d,[m])}t.getLineRangeMapping=_}),te(ne[33],re([0,1,25,32,16,7,2,13,12]),function(B,t,P,F,r,c,w,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const s=3;class h{computeDiff(i,a,L){const v=new p(i,a,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let R=null;for(const D of v.changes){let k;D.originalEndLineNumber===0?k=new u.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):k=new u.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let y;D.modifiedEndLineNumber===0?y=new u.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):y=new u.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let I=new r.DetailedLineRangeMapping(k,y,D.charChanges?.map(T=>new r.RangeMapping(new w.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new w.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new r.DetailedLineRangeMapping(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),M.pop()),M.push(I),R=I}return(0,f.assertFn)(()=>(0,f.checkAdjacentItems)(M,(D,k)=>k.original.startLineNumber-D.original.endLineNumberExclusive===k.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<k.original.startLineNumber&&D.modified.endLineNumberExclusive<k.modified.startLineNumber)),new F.LinesDiff(M,[],v.quitEarly)}}t.LegacyLinesDiffComputer=h;function N(o,i,a,L){return new P.LcsDiff(o,i,a).ComputeDiff(L)}class b{constructor(i){const a=[],L=[];for(let d=0,v=i.length;d<v;d++)a[d]=_(i[d],1),L[d]=m(i[d],1);this.lines=i,this._startColumns=a,this._endColumns=L}getElements(){const i=[];for(let a=0,L=this.lines.length;a<L;a++)i[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,L){const d=[],v=[],M=[];let R=0;for(let D=a;D<=L;D++){const k=this.lines[D],y=i?this._startColumns[D]:1,I=i?this._endColumns[D]:k.length+1;for(let T=y;T<I;T++)d[R]=k.charCodeAt(T-1),v[R]=D+1,M[R]=T,R++;!i&&D<L&&(d[R]=10,v[R]=D+1,M[R]=k.length+1,R++)}return new g(d,v,M)}}class g{constructor(i,a,L){this._charCodes=i,this._lineNumbers=a,this._columns=L}toString(){return"["+this._charCodes.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class e{constructor(i,a,L,d,v,M,R,D){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=L,this.originalEndColumn=d,this.modifiedStartLineNumber=v,this.modifiedStartColumn=M,this.modifiedEndLineNumber=R,this.modifiedEndColumn=D}static createFromDiffChange(i,a,L){const d=a.getStartLineNumber(i.originalStart),v=a.getStartColumn(i.originalStart),M=a.getEndLineNumber(i.originalStart+i.originalLength-1),R=a.getEndColumn(i.originalStart+i.originalLength-1),D=L.getStartLineNumber(i.modifiedStart),k=L.getStartColumn(i.modifiedStart),y=L.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),I=L.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,v,M,R,D,k,y,I)}}function E(o){if(o.length<=1)return o;const i=[o[0]];let a=i[0];for(let L=1,d=o.length;L<d;L++){const v=o[L],M=v.originalStart-(a.originalStart+a.originalLength),R=v.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(M,R)<s?(a.originalLength=v.originalStart+v.originalLength-a.originalStart,a.modifiedLength=v.modifiedStart+v.modifiedLength-a.modifiedStart):(i.push(v),a=v)}return i}class A{constructor(i,a,L,d,v){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=d,this.charChanges=v}static createFromDiffResult(i,a,L,d,v,M,R){let D,k,y,I,T;if(a.originalLength===0?(D=L.getStartLineNumber(a.originalStart)-1,k=0):(D=L.getStartLineNumber(a.originalStart),k=L.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(y=d.getStartLineNumber(a.modifiedStart)-1,I=0):(y=d.getStartLineNumber(a.modifiedStart),I=d.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),M&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&v()){const O=L.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),q=d.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(O.getElements().length>0&&q.getElements().length>0){let S=N(O,q,v,!0).changes;R&&(S=E(S)),T=[];for(let W=0,Q=S.length;W<Q;W++)T.push(e.createFromDiffChange(S[W],O,q))}}return new A(D,k,y,I,T)}}class p{constructor(i,a,L){this.shouldComputeCharChanges=L.shouldComputeCharChanges,this.shouldPostProcessCharChanges=L.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=L.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=L.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=a,this.original=new b(i),this.modified=new b(a),this.continueLineDiff=l(L.maxComputationTime),this.continueCharDiff=l(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=N(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=i.changes,L=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let D=0,k=a.length;D<k;D++)R.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[D],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:L,changes:R}}const d=[];let v=0,M=0;for(let R=-1,D=a.length;R<D;R++){const k=R+1<D?a[R+1]:null,y=k?k.originalStart:this.originalLines.length,I=k?k.modifiedStart:this.modifiedLines.length;for(;v<y&&M<I;){const T=this.originalLines[v],O=this.modifiedLines[M];if(T!==O){{let q=_(T,1),S=_(O,1);for(;q>1&&S>1;){const W=T.charCodeAt(q-2),Q=O.charCodeAt(S-2);if(W!==Q)break;q--,S--}(q>1||S>1)&&this._pushTrimWhitespaceCharChange(d,v+1,1,q,M+1,1,S)}{let q=m(T,1),S=m(O,1);const W=T.length+1,Q=O.length+1;for(;q<W&&S<Q;){const H=T.charCodeAt(q-1),Z=T.charCodeAt(S-1);if(H!==Z)break;q++,S++}(q<W||S<Q)&&this._pushTrimWhitespaceCharChange(d,v+1,q,W,M+1,S,Q)}}v++,M++}k&&(d.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,k,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),v+=k.originalLength,M+=k.modifiedLength)}return{quitEarly:L,changes:d}}_pushTrimWhitespaceCharChange(i,a,L,d,v,M,R){if(this._mergeTrimWhitespaceCharChange(i,a,L,d,v,M,R))return;let D;this.shouldComputeCharChanges&&(D=[new e(a,L,a,d,v,M,v,R)]),i.push(new A(a,a,v,v,D))}_mergeTrimWhitespaceCharChange(i,a,L,d,v,M,R){const D=i.length;if(D===0)return!1;const k=i[D-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===a&&k.modifiedEndLineNumber===v?(this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new e(a,L,a,d,v,M,v,R)),!0):k.originalEndLineNumber+1===a&&k.modifiedEndLineNumber+1===v?(k.originalEndLineNumber=a,k.modifiedEndLineNumber=v,this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new e(a,L,a,d,v,M,v,R)),!0):!1}}t.DiffComputer=p;function _(o,i){const a=c.firstNonWhitespaceIndex(o);return a===-1?i:a+1}function m(o,i){const a=c.lastNonWhitespaceIndex(o);return a===-1?i:a+2}function l(o){if(o===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<o}}),te(ne[50],re([0,1,33,49]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new P.LegacyLinesDiffComputer,getDefault:()=>new F.DefaultLinesDiffComputer}}),te(ne[51],re([0,1,35]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function F(b){const g=[];for(const e of b){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&g.push(E)}return g}function r(b,g,e,E){return{red:b/255,blue:e/255,green:g/255,alpha:E}}function c(b,g){const e=g.index,E=g[0].length;if(!e)return;const A=b.positionAt(e);return{startLineNumber:A.lineNumber,startColumn:A.column,endLineNumber:A.lineNumber,endColumn:A.column+E}}function w(b,g){if(!b)return;const e=P.Color.Format.CSS.parseHex(g);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(b,g,e){if(!b||g.length!==1)return;const A=g[0].values(),p=F(A);return{range:b,color:r(p[0],p[1],p[2],e?p[3]:1)}}function u(b,g,e){if(!b||g.length!==1)return;const A=g[0].values(),p=F(A),_=new P.Color(new P.HSLA(p[0],p[1]/100,p[2]/100,e?p[3]:1));return{range:b,color:r(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function s(b,g){return typeof b=="string"?[...b.matchAll(g)]:b.findMatches(g)}function h(b){const g=[],E=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const A of E){const p=A.filter(o=>o!==void 0),_=p[1],m=p[2];if(!m)continue;let l;if(_==="rgb"){const o=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;l=f(c(b,A),s(m,o),!1)}else if(_==="rgba"){const o=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;l=f(c(b,A),s(m,o),!0)}else if(_==="hsl"){const o=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;l=u(c(b,A),s(m,o),!1)}else if(_==="hsla"){const o=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;l=u(c(b,A),s(m,o),!0)}else _==="#"&&(l=w(c(b,A),_+m));l&&g.push(l)}return g}function N(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:h(b)}t.computeDefaultDocumentColors=N}),te(ne[52],re([0,1,28]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var F;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class r{constructor(e,E,A){const p=new Uint8Array(e*E);for(let _=0,m=e*E;_<m;_++)p[_]=A;this._data=p,this.rows=e,this.cols=E}get(e,E){return this._data[e*this.cols+E]}set(e,E,A){this._data[e*this.cols+E]=A}}class c{constructor(e){let E=0,A=0;for(let _=0,m=e.length;_<m;_++){const[l,o,i]=e[_];o>E&&(E=o),l>A&&(A=l),i>A&&(A=i)}E++,A++;const p=new r(A,E,0);for(let _=0,m=e.length;_<m;_++){const[l,o,i]=e[_];p.set(l,o,i)}this._states=p,this._maxCharCode=E}nextState(e,E){return E<0||E>=this._maxCharCode?0:this._states.get(e,E)}}t.StateMachine=c;let w=null;function f(){return w===null&&(w=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var u;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let s=null;function h(){if(s===null){s=new P.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<g.length;E++)s.set(g.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class N{static _createLink(e,E,A,p,_){let m=_-1;do{const l=E.charCodeAt(m);if(e.get(l)!==2)break;m--}while(m>p);if(p>0){const l=E.charCodeAt(p-1),o=E.charCodeAt(m);(l===40&&o===41||l===91&&o===93||l===123&&o===125)&&m--}return{range:{startLineNumber:A,startColumn:p+1,endLineNumber:A,endColumn:m+2},url:E.substring(p,m+1)}}static computeLinks(e,E=f()){const A=h(),p=[];for(let _=1,m=e.getLineCount();_<=m;_++){const l=e.getLineContent(_),o=l.length;let i=0,a=0,L=0,d=1,v=!1,M=!1,R=!1,D=!1;for(;i<o;){let k=!1;const y=l.charCodeAt(i);if(d===13){let I;switch(y){case 40:v=!0,I=0;break;case 41:I=v?0:1;break;case 91:R=!0,M=!0,I=0;break;case 93:R=!1,I=M?0:1;break;case 123:D=!0,I=0;break;case 125:I=D?0:1;break;case 39:case 34:case 96:L===y?I=1:L===39||L===34||L===96?I=0:I=1;break;case 42:I=L===42?1:0;break;case 124:I=L===124?1:0;break;case 32:I=R?0:1;break;default:I=A.get(y)}I===1&&(p.push(N._createLink(A,l,_,a,i)),k=!0)}else if(d===12){let I;y===91?(M=!0,I=0):I=A.get(y),I===1?k=!0:d=13}else d=E.nextState(d,y),d===0&&(k=!0);k&&(d=1,v=!1,M=!1,D=!1,a=i+1,L=y),i++}d===13&&p.push(N._createLink(A,l,_,a,o))}return p}}t.LinkComputer=N;function b(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:N.computeLinks(g)}t.computeLinks=b}),te(ne[53],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new P}navigateValueSet(r,c,w,f,u){if(r&&c){const s=this.doNavigateValueSet(c,u);if(s)return{range:r,value:s}}if(w&&f){const s=this.doNavigateValueSet(f,u);if(s)return{range:w,value:s}}return null}doNavigateValueSet(r,c){const w=this.numberReplace(r,c);return w!==null?w:this.textReplace(r,c)}numberReplace(r,c){const w=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const u=parseFloat(r);return!isNaN(f)&&!isNaN(u)&&f===u?f===0&&!c?null:(f=Math.floor(f*w),f+=c?w:-w,String(f/w)):null}textReplace(r,c){return this.valueSetsReplace(this._defaultValueSet,r,c)}valueSetsReplace(r,c,w){let f=null;for(let u=0,s=r.length;f===null&&u<s;u++)f=this.valueSetReplace(r[u],c,w);return f}valueSetReplace(r,c,w){let f=r.indexOf(c);return f>=0?(f+=w?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.BasicInplaceReplace=P}),te(ne[54],re([0,1,14]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var F;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var r;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var c;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var w;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var f;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var u;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var s;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,o.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this._indentSizeIsTabSize===o._indentSizeIsTabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}t.TextModelResolvedOptions=h;class N{constructor(o,i){this._findMatchBrand=void 0,this.range=o,this.matches=i}}t.FindMatch=N;var b;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function g(l){return l&&typeof l.read=="function"}t.isITextSnapshot=g;var e;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class A{constructor(o,i,a,L,d,v){this.identifier=o,this.range=i,this.text=a,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=d,this._isTracked=v}}t.ValidAnnotatedEditOperation=A;class p{constructor(o,i,a){this.regex=o,this.wordSeparators=i,this.simpleSearch=a}}t.SearchData=p;class _{constructor(o,i,a){this.reverseEdits=o,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.ApplyEditsResult=_;function m(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}t.shouldSynchronizeModel=m}),te(ne[55],re([0,1,6,27]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class r{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(u,s){u=(0,F.toUint32)(u);const h=this.values,N=this.prefixSum,b=s.length;return b===0?!1:(this.values=new Uint32Array(h.length+b),this.values.set(h.subarray(0,u),0),this.values.set(h.subarray(u),u+b),this.values.set(s,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,s){return u=(0,F.toUint32)(u),s=(0,F.toUint32)(s),this.values[u]===s?!1:(this.values[u]=s,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,s){u=(0,F.toUint32)(u),s=(0,F.toUint32)(s);const h=this.values,N=this.prefixSum;if(u>=h.length)return!1;const b=h.length-u;return s>=b&&(s=b),s===0?!1:(this.values=new Uint32Array(h.length-s),this.values.set(h.subarray(0,u),0),this.values.set(h.subarray(u+s),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,F.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),u>=this.values.length&&(u=this.values.length-1);for(let h=s;h<=u;h++)this.prefixSum[h]=this.prefixSum[h-1]+this.values[h];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let s=0,h=this.values.length-1,N=0,b=0,g=0;for(;s<=h;)if(N=s+(h-s)/2|0,b=this.prefixSum[N],g=b-this.values[N],u<g)h=N-1;else if(u>=b)s=N+1;else break;return new w(N,u-g)}}t.PrefixSumComputer=r;class c{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const s=this._indexBySum[u],h=s>0?this._prefixSum[s-1]:0;return new w(s,u-h)}removeValues(u,s){this._values.splice(u,s),this._invalidate(u)}insertValues(u,s){this._values=(0,P.arrayInsert)(this._values,u,s),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,s=this._values.length;u<s;u++){const h=this._values[u],N=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=N+h;for(let b=0;b<h;b++)this._indexBySum[N+b]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,s){this._values[u]!==s&&(this._values[u]=s,this._invalidate(u))}}t.ConstantTimePrefixSumComputer=c;class w{constructor(u,s){this.index=u,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=s}}t.PrefixSumIndexOfResult=w}),te(ne[56],re([0,1,7,5,55]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class c{constructor(f,u,s,h){this._uri=f,this._lines=u,this._eol=s,this._versionId=h,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(f){f.eol&&f.eol!==this._eol&&(this._eol=f.eol,this._lineStarts=null);const u=f.changes;for(const s of u)this._acceptDeleteRange(s.range),this._acceptInsertText(new F.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=f.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const f=this._eol.length,u=this._lines.length,s=new Uint32Array(u);for(let h=0;h<u;h++)s[h]=this._lines[h].length+f;this._lineStarts=new r.PrefixSumComputer(s)}}_setLineText(f,u){this._lines[f]=u,this._lineStarts&&this._lineStarts.setValue(f,this._lines[f].length+this._eol.length)}_acceptDeleteRange(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.startLineNumber-1].substring(f.endColumn-1));return}this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.endLineNumber-1].substring(f.endColumn-1)),this._lines.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}_acceptInsertText(f,u){if(u.length===0)return;const s=(0,P.splitLines)(u);if(s.length===1){this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+s[0]+this._lines[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this._lines[f.lineNumber-1].substring(f.column-1),this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let N=1;N<s.length;N++)this._lines.splice(f.lineNumber+N-1,0,s[N]),h[N-1]=s[N].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(f.lineNumber,h)}}t.MirrorTextModel=c}),te(ne[57],re([0,1,7,44,5,2,54]),function(B,t,P,F,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const f=999;class u{constructor(_,m,l,o){this.searchString=_,this.isRegex=m,this.matchCase=l,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=s(this.searchString):_=this.searchString.indexOf(`
`)>=0;let m=null;try{m=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!m)return null;let l=!this.isRegex&&!_;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new w.SearchData(m,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}t.SearchParams=u;function s(p){if(!p||p.length===0)return!1;for(let _=0,m=p.length;_<m;_++){const l=p.charCodeAt(_);if(l===10)return!0;if(l===92){if(_++,_>=m)break;const o=p.charCodeAt(_);if(o===110||o===114||o===87)return!0}}return!1}t.isMultilineRegexSource=s;function h(p,_,m){if(!m)return new w.FindMatch(p,null);const l=[];for(let o=0,i=_.length;o<i;o++)l[o]=_[o];return new w.FindMatch(p,l)}t.createFindMatch=h;class N{constructor(_){const m=[];let l=0;for(let o=0,i=_.length;o<i;o++)_.charCodeAt(o)===10&&(m[l++]=o);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(_){const m=this._lineFeedsOffsets;let l=0,o=m.length-1;if(o===-1||_<=m[0])return 0;for(;l<o;){const i=l+((o-l)/2>>0);m[i]>=_?o=i-1:m[i+1]>=_?(l=i,o=i):l=i+1}return l+1}}class b{static findMatches(_,m,l,o,i){const a=m.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(_,l,new A(a.wordSeparators,a.regex),o,i):this._doFindMatchesLineByLine(_,l,a,o,i):[]}static _getMultilineMatchRange(_,m,l,o,i,a){let L,d=0;o?(d=o.findLineFeedCountBeforeOffset(i),L=m+i+d):L=m+i;let v;if(o){const k=o.findLineFeedCountBeforeOffset(i+a.length)-d;v=L+a.length+k}else v=L+a.length;const M=_.getPositionAt(L),R=_.getPositionAt(v);return new c.Range(M.lineNumber,M.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(_,m,l,o,i){const a=_.getOffsetAt(m.getStartPosition()),L=_.getValueInRange(m,1),d=_.getEOL()===`\r
`?new N(L):null,v=[];let M=0,R;for(l.reset(0);R=l.next(L);)if(v[M++]=h(this._getMultilineMatchRange(_,a,L,d,R.index,R[0]),R,o),M>=i)return v;return v}static _doFindMatchesLineByLine(_,m,l,o,i){const a=[];let L=0;if(m.startLineNumber===m.endLineNumber){const v=_.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return L=this._findMatchesInLine(l,v,m.startLineNumber,m.startColumn-1,L,a,o,i),a}const d=_.getLineContent(m.startLineNumber).substring(m.startColumn-1);L=this._findMatchesInLine(l,d,m.startLineNumber,m.startColumn-1,L,a,o,i);for(let v=m.startLineNumber+1;v<m.endLineNumber&&L<i;v++)L=this._findMatchesInLine(l,_.getLineContent(v),v,0,L,a,o,i);if(L<i){const v=_.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);L=this._findMatchesInLine(l,v,m.endLineNumber,0,L,a,o,i)}return a}static _findMatchesInLine(_,m,l,o,i,a,L,d){const v=_.wordSeparators;if(!L&&_.simpleSearch){const D=_.simpleSearch,k=D.length,y=m.length;let I=-k;for(;(I=m.indexOf(D,I+k))!==-1;)if((!v||E(v,m,y,I,k))&&(a[i++]=new w.FindMatch(new c.Range(l,I+1+o,l,I+1+k+o),null),i>=d))return i;return i}const M=new A(_.wordSeparators,_.regex);let R;M.reset(0);do if(R=M.next(m),R&&(a[i++]=h(new c.Range(l,R.index+1+o,l,R.index+1+R[0].length+o),R,L),i>=d))return i;while(R);return i}static findNextMatch(_,m,l,o){const i=m.parseSearchRequest();if(!i)return null;const a=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(_,l,a,o):this._doFindNextMatchLineByLine(_,l,a,o)}static _doFindNextMatchMultiline(_,m,l,o){const i=new r.Position(m.lineNumber,1),a=_.getOffsetAt(i),L=_.getLineCount(),d=_.getValueInRange(new c.Range(i.lineNumber,i.column,L,_.getLineMaxColumn(L)),1),v=_.getEOL()===`\r
`?new N(d):null;l.reset(m.column-1);const M=l.next(d);return M?h(this._getMultilineMatchRange(_,a,d,v,M.index,M[0]),M,o):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(_,new r.Position(1,1),l,o):null}static _doFindNextMatchLineByLine(_,m,l,o){const i=_.getLineCount(),a=m.lineNumber,L=_.getLineContent(a),d=this._findFirstMatchInLine(l,L,a,m.column,o);if(d)return d;for(let v=1;v<=i;v++){const M=(a+v-1)%i,R=_.getLineContent(M+1),D=this._findFirstMatchInLine(l,R,M+1,1,o);if(D)return D}return null}static _findFirstMatchInLine(_,m,l,o,i){_.reset(o-1);const a=_.next(m);return a?h(new c.Range(l,a.index+1,l,a.index+1+a[0].length),a,i):null}static findPreviousMatch(_,m,l,o){const i=m.parseSearchRequest();if(!i)return null;const a=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(_,l,a,o):this._doFindPreviousMatchLineByLine(_,l,a,o)}static _doFindPreviousMatchMultiline(_,m,l,o){const i=this._doFindMatchesMultiline(_,new c.Range(1,1,m.lineNumber,m.column),l,o,10*f);if(i.length>0)return i[i.length-1];const a=_.getLineCount();return m.lineNumber!==a||m.column!==_.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(_,new r.Position(a,_.getLineMaxColumn(a)),l,o):null}static _doFindPreviousMatchLineByLine(_,m,l,o){const i=_.getLineCount(),a=m.lineNumber,L=_.getLineContent(a).substring(0,m.column-1),d=this._findLastMatchInLine(l,L,a,o);if(d)return d;for(let v=1;v<=i;v++){const M=(i+a-v-1)%i,R=_.getLineContent(M+1),D=this._findLastMatchInLine(l,R,M+1,o);if(D)return D}return null}static _findLastMatchInLine(_,m,l,o){let i=null,a;for(_.reset(0);a=_.next(m);)i=h(new c.Range(l,a.index+1,l,a.index+1+a[0].length),a,o);return i}}t.TextModelSearch=b;function g(p,_,m,l,o){if(l===0)return!0;const i=_.charCodeAt(l-1);if(p.get(i)!==0||i===13||i===10)return!0;if(o>0){const a=_.charCodeAt(l);if(p.get(a)!==0)return!0}return!1}function e(p,_,m,l,o){if(l+o===m)return!0;const i=_.charCodeAt(l+o);if(p.get(i)!==0||i===13||i===10)return!0;if(o>0){const a=_.charCodeAt(l+o-1);if(p.get(a)!==0)return!0}return!1}function E(p,_,m,l,o){return g(p,_,m,l,o)&&e(p,_,m,l,o)}t.isValidMatch=E;class A{constructor(_,m){this._wordSeparators=_,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const m=_.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(l=this._searchRegex.exec(_),!l))return null;const o=l.index,i=l[0].length;if(o===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){P.getNextCodePoint(_,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=i,!this._wordSeparators||E(this._wordSeparators,_,m,o,i))return l}while(l);return null}}t.Searcher=A}),te(ne[58],re([0,1,2,57,7,13,29]),function(B,t,P,F,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class f{static computeUnicodeHighlights(e,E,A){const p=A?A.startLineNumber:1,_=A?A.endLineNumber:e.getLineCount(),m=new h(E),l=m.getCandidateCodePoints();let o;l==="allNonBasicAscii"?o=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):o=new RegExp(`${u(Array.from(l))}`,"g");const i=new F.Searcher(null,o),a=[];let L=!1,d,v=0,M=0,R=0;e:for(let D=p,k=_;D<=k;D++){const y=e.getLineContent(D),I=y.length;i.reset(0);do if(d=i.next(y),d){let T=d.index,O=d.index+d[0].length;if(T>0){const Q=y.charCodeAt(T-1);r.isHighSurrogate(Q)&&T--}if(O+1<I){const Q=y.charCodeAt(O-1);r.isHighSurrogate(Q)&&O++}const q=y.substring(T,O);let S=(0,w.getWordAtText)(T+1,w.DEFAULT_WORD_REGEXP,y,0);S&&S.endColumn<=T+1&&(S=null);const W=m.shouldHighlightNonBasicASCII(q,S?S.word:null);if(W!==0){W===3?v++:W===2?M++:W===1?R++:(0,c.assertNever)(W);const Q=1e3;if(a.length>=Q){L=!0;break e}a.push(new P.Range(D,T+1,D,O+1))}}while(d)}return{ranges:a,hasMore:L,ambiguousCharacterCount:v,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,E){const A=new h(E);switch(A.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const _=e.codePointAt(0),m=A.ambiguousCharacters.getPrimaryConfusable(_),l=r.AmbiguousCharacters.getLocales().filter(o=>!r.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,o])).isAmbiguous(_));return{kind:0,confusableWith:String.fromCodePoint(m),notAmbiguousInLocales:l}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=f;function u(g,e){return`[${r.escapeRegExpCharacters(g.map(A=>String.fromCodePoint(A)).join(""))}]`}var s;(function(g){g[g.Ambiguous=0]="Ambiguous",g[g.Invisible=1]="Invisible",g[g.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const E of r.InvisibleCharacters.codePoints)N(String.fromCodePoint(E))||e.add(E);if(this.options.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.allowedCodePoints)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const A=e.codePointAt(0);if(this.allowedCodePoints.has(A))return 0;if(this.options.nonBasicASCII)return 1;let p=!1,_=!1;if(E)for(const m of E){const l=m.codePointAt(0),o=r.isBasicASCII(m);p=p||o,!o&&!this.ambiguousCharacters.isAmbiguous(l)&&!r.InvisibleCharacters.isInvisibleCharacter(l)&&(_=!0)}return!p&&_?0:this.options.invisibleCharacters&&!N(e)&&r.InvisibleCharacters.isInvisibleCharacter(A)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(A)?3:0}}function N(g){return g===" "||g===`
`||g==="	"}var b;(function(g){g[g.None=0]="None",g[g.NonBasicASCII=1]="NonBasicASCII",g[g.Invisible=2]="Invisible",g[g.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ne[59],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var P;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(P||(t.AccessibilitySupport=P={}));var F;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var c;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var w;(function(n){n[n.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var f;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var u;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(u||(t.ContentWidgetPositionPreference=u={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var N;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var g;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(g||(t.EditorOption=g={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var A;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(A||(t.GlyphMarginLane=A={}));var p;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(p||(t.IndentAction=p={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_||(t.InjectedTextCursorStops=_={}));var m;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(m||(t.InlayHintKind=m={}));var l;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var o;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(o||(t.KeyCode=o={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var v;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(v||(t.OverlayWidgetPositionPreference=v={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var R;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(R||(t.PositionAffinity=R={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var y;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(y||(t.ScrollType=y={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var T;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));var O;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(O||(t.ShowLightbulbIconMode=O={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var S;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(S||(t.SymbolKind=S={}));var W;(function(n){n[n.Deprecated=1]="Deprecated"})(W||(t.SymbolTag=W={}));var Q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(Q||(t.TextEditorCursorBlinkingStyle=Q={}));var H;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(H||(t.TextEditorCursorStyle=H={}));var Z;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Z||(t.TrackedRangeStickiness=Z={}));var ee;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ee||(t.WrappingIndent=ee={}))}),te(ne[60],re([0,1,11,10]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class r{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(f){this._onDidChange.fire({changedLanguages:f,changedColorMap:!1})}register(f,u){return this._tokenizationSupports.set(f,u),this.handleChange([f]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(f)===u&&(this._tokenizationSupports.delete(f),this.handleChange([f]))})}get(f){return this._tokenizationSupports.get(f)||null}registerFactory(f,u){this._factories.get(f)?.dispose();const s=new c(this,f,u);return this._factories.set(f,s),(0,F.toDisposable)(()=>{const h=this._factories.get(f);!h||h!==s||(this._factories.delete(f),h.dispose())})}async getOrCreate(f){const u=this.get(f);if(u)return u;const s=this._factories.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this._factories.get(f);return!!(!s||s.isResolved)}setColorMap(f){this._colorMap=f,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=r;class c extends F.Disposable{get isResolved(){return this._isResolved}constructor(f,u,s){super(),this._registry=f,this._languageId=u,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const f=await this._factory.tokenizationSupport;this._isResolved=!0,f&&!this._isDisposed&&this._register(this._registry.register(this._languageId,f))}}}),te(ne[61],re([62,63]),function(B,t){return B.create("vs/base/common/platform",t)}),te(ne[17],re([0,1,61]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isBigSurOrNewer=t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let F=!1,r=!1,c=!1,w=!1,f=!1,u=!1,s=!1,h=!1,N=!1,b=!1,g,e=t.LANGUAGE_DEFAULT,E=t.LANGUAGE_DEFAULT,A,p;const _=globalThis;let m;typeof _.vscode<"u"&&typeof _.vscode.process<"u"?m=_.vscode.process:typeof process<"u"&&(m=process);const l=typeof m?.versions?.electron=="string",o=l&&m?.type==="renderer";if(typeof m=="object"){F=m.platform==="win32",r=m.platform==="darwin",c=m.platform==="linux",w=c&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,s=l,N=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const y=m.env.VSCODE_NLS_CONFIG;if(y)try{const I=JSON.parse(y),T=I.availableLanguages["*"];g=I.locale,E=I.osLocale,e=T||t.LANGUAGE_DEFAULT,A=I._translationsConfigFile}catch{}f=!0}else typeof navigator=="object"&&!o?(p=navigator.userAgent,F=p.indexOf("Windows")>=0,r=p.indexOf("Macintosh")>=0,h=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=p.indexOf("Linux")>=0,b=p?.indexOf("Mobi")>=0,u=!0,g=P.getConfiguredDefaultLocale(P.localize(0,null))||t.LANGUAGE_DEFAULT,e=g,E=navigator.language):console.error("Unable to resolve platform.");var i;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(i||(t.Platform=i={}));function a(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=a;let L=0;r?L=1:F?L=3:c&&(L=2),t.isWindows=F,t.isMacintosh=r,t.isLinux=c,t.isLinuxSnap=w,t.isNative=f,t.isElectron=s,t.isWeb=u,t.isWebWorker=u&&typeof _.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?_.origin:void 0,t.isIOS=h,t.isMobile=b,t.isCI=N,t.platform=L,t.userAgent=p,t.language=e;var d;(function(y){function I(){return t.language}y.value=I;function T(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}y.isDefaultVariant=T;function O(){return t.language==="en"}y.isDefault=O})(d||(t.Language=d={})),t.locale=g,t.platformLocale=E,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof _.postMessage=="function"&&!_.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const y=[];_.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let O=0,q=y.length;O<q;O++){const S=y[O];if(S.id===T.data.vscodeScheduleAsyncWork){y.splice(O,1),S.callback();return}}});let I=0;return T=>{const O=++I;y.push({id:O,callback:T}),_.postMessage({vscodeScheduleAsyncWork:O},"*")}}return y=>setTimeout(y)})();var v;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(v||(t.OperatingSystem=v={})),t.OS=r||h?2:F?1:3;let M=!0,R=!1;function D(){if(!R){R=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,M=new Uint16Array(y.buffer)[0]===(2<<8)+1}return M}t.isLittleEndian=D,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function k(y){return parseFloat(y)>=20}t.isBigSurOrNewer=k}),te(ne[64],re([0,1,17]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let F;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const c=r.process;F={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.platform=F.platform,t.arch=F.arch}),te(ne[65],re([0,1,64]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const F=65,r=97,c=90,w=122,f=46,u=47,s=92,h=58,N=63;class b extends Error{constructor(a,L,d){let v;typeof L=="string"&&L.indexOf("not ")===0?(v="must not be",L=L.replace(/^not /,"")):v="must be";const M=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${M} ${v} of type ${L}`;R+=`. Received type ${typeof d}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,a){if(i===null||typeof i!="object")throw new b(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new b(a,"string",i)}const E=P.platform==="win32";function A(i){return i===u||i===s}function p(i){return i===u}function _(i){return i>=F&&i<=c||i>=r&&i<=w}function m(i,a,L,d){let v="",M=0,R=-1,D=0,k=0;for(let y=0;y<=i.length;++y){if(y<i.length)k=i.charCodeAt(y);else{if(d(k))break;k=u}if(d(k)){if(!(R===y-1||D===1))if(D===2){if(v.length<2||M!==2||v.charCodeAt(v.length-1)!==f||v.charCodeAt(v.length-2)!==f){if(v.length>2){const I=v.lastIndexOf(L);I===-1?(v="",M=0):(v=v.slice(0,I),M=v.length-1-v.lastIndexOf(L)),R=y,D=0;continue}else if(v.length!==0){v="",M=0,R=y,D=0;continue}}a&&(v+=v.length>0?`${L}..`:"..",M=2)}else v.length>0?v+=`${L}${i.slice(R+1,y)}`:v=i.slice(R+1,y),M=y-R-1;R=y,D=0}else k===f&&D!==-1?++D:D=-1}return v}function l(i,a){g(a,"pathObject");const L=a.dir||a.root,d=a.base||`${a.name||""}${a.ext||""}`;return L?L===a.root?`${L}${d}`:`${L}${i}${d}`:d}t.win32={resolve(...i){let a="",L="",d=!1;for(let v=i.length-1;v>=-1;v--){let M;if(v>=0){if(M=i[v],e(M,"path"),M.length===0)continue}else a.length===0?M=P.cwd():(M=P.env[`=${a}`]||P.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==a.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${a}\\`));const R=M.length;let D=0,k="",y=!1;const I=M.charCodeAt(0);if(R===1)A(I)&&(D=1,y=!0);else if(A(I))if(y=!0,A(M.charCodeAt(1))){let T=2,O=T;for(;T<R&&!A(M.charCodeAt(T));)T++;if(T<R&&T!==O){const q=M.slice(O,T);for(O=T;T<R&&A(M.charCodeAt(T));)T++;if(T<R&&T!==O){for(O=T;T<R&&!A(M.charCodeAt(T));)T++;(T===R||T!==O)&&(k=`\\\\${q}\\${M.slice(O,T)}`,D=T)}}}else D=1;else _(I)&&M.charCodeAt(1)===h&&(k=M.slice(0,2),D=2,R>2&&A(M.charCodeAt(2))&&(y=!0,D=3));if(k.length>0)if(a.length>0){if(k.toLowerCase()!==a.toLowerCase())continue}else a=k;if(d){if(a.length>0)break}else if(L=`${M.slice(D)}\\${L}`,d=y,y&&a.length>0)break}return L=m(L,!d,"\\",A),d?`${a}\\${L}`:`${a}${L}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let L=0,d,v=!1;const M=i.charCodeAt(0);if(a===1)return p(M)?"\\":i;if(A(M))if(v=!0,A(i.charCodeAt(1))){let D=2,k=D;for(;D<a&&!A(i.charCodeAt(D));)D++;if(D<a&&D!==k){const y=i.slice(k,D);for(k=D;D<a&&A(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&!A(i.charCodeAt(D));)D++;if(D===a)return`\\\\${y}\\${i.slice(k)}\\`;D!==k&&(d=`\\\\${y}\\${i.slice(k,D)}`,L=D)}}}else L=1;else _(M)&&i.charCodeAt(1)===h&&(d=i.slice(0,2),L=2,a>2&&A(i.charCodeAt(2))&&(v=!0,L=3));let R=L<a?m(i.slice(L),!v,"\\",A):"";return R.length===0&&!v&&(R="."),R.length>0&&A(i.charCodeAt(a-1))&&(R+="\\"),d===void 0?v?`\\${R}`:R:v?`${d}\\${R}`:`${d}${R}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const L=i.charCodeAt(0);return A(L)||a>2&&_(L)&&i.charCodeAt(1)===h&&A(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,L;for(let M=0;M<i.length;++M){const R=i[M];e(R,"path"),R.length>0&&(a===void 0?a=L=R:a+=`\\${R}`)}if(a===void 0)return".";let d=!0,v=0;if(typeof L=="string"&&A(L.charCodeAt(0))){++v;const M=L.length;M>1&&A(L.charCodeAt(1))&&(++v,M>2&&(A(L.charCodeAt(2))?++v:d=!1))}if(d){for(;v<a.length&&A(a.charCodeAt(v));)v++;v>=2&&(a=`\\${a.slice(v)}`)}return t.win32.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const L=t.win32.resolve(i),d=t.win32.resolve(a);if(L===d||(i=L.toLowerCase(),a=d.toLowerCase(),i===a))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===s;)v++;let M=i.length;for(;M-1>v&&i.charCodeAt(M-1)===s;)M--;const R=M-v;let D=0;for(;D<a.length&&a.charCodeAt(D)===s;)D++;let k=a.length;for(;k-1>D&&a.charCodeAt(k-1)===s;)k--;const y=k-D,I=R<y?R:y;let T=-1,O=0;for(;O<I;O++){const S=i.charCodeAt(v+O);if(S!==a.charCodeAt(D+O))break;S===s&&(T=O)}if(O!==I){if(T===-1)return d}else{if(y>I){if(a.charCodeAt(D+O)===s)return d.slice(D+O+1);if(O===2)return d.slice(D+O)}R>I&&(i.charCodeAt(v+O)===s?T=O:O===2&&(T=3)),T===-1&&(T=0)}let q="";for(O=v+T+1;O<=M;++O)(O===M||i.charCodeAt(O)===s)&&(q+=q.length===0?"..":"\\..");return D+=T,q.length>0?`${q}${d.slice(D,k)}`:(d.charCodeAt(D)===s&&++D,d.slice(D,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const L=a.charCodeAt(2);if(L!==N&&L!==f)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===h&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let L=-1,d=0;const v=i.charCodeAt(0);if(a===1)return A(v)?i:".";if(A(v)){if(L=d=1,A(i.charCodeAt(1))){let D=2,k=D;for(;D<a&&!A(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&A(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&!A(i.charCodeAt(D));)D++;if(D===a)return i;D!==k&&(L=d=D+1)}}}}else _(v)&&i.charCodeAt(1)===h&&(L=a>2&&A(i.charCodeAt(2))?3:2,d=L);let M=-1,R=!0;for(let D=a-1;D>=d;--D)if(A(i.charCodeAt(D))){if(!R){M=D;break}}else R=!1;if(M===-1){if(L===-1)return".";M=L}return i.slice(0,M)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,d=-1,v=!0,M;if(i.length>=2&&_(i.charCodeAt(0))&&i.charCodeAt(1)===h&&(L=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,D=-1;for(M=i.length-1;M>=L;--M){const k=i.charCodeAt(M);if(A(k)){if(!v){L=M+1;break}}else D===-1&&(v=!1,D=M+1),R>=0&&(k===a.charCodeAt(R)?--R===-1&&(d=M):(R=-1,d=D))}return L===d?d=D:d===-1&&(d=i.length),i.slice(L,d)}for(M=i.length-1;M>=L;--M)if(A(i.charCodeAt(M))){if(!v){L=M+1;break}}else d===-1&&(v=!1,d=M+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let a=0,L=-1,d=0,v=-1,M=!0,R=0;i.length>=2&&i.charCodeAt(1)===h&&_(i.charCodeAt(0))&&(a=d=2);for(let D=i.length-1;D>=a;--D){const k=i.charCodeAt(D);if(A(k)){if(!M){d=D+1;break}continue}v===-1&&(M=!1,v=D+1),k===f?L===-1?L=D:R!==1&&(R=1):L!==-1&&(R=-1)}return L===-1||v===-1||R===0||R===1&&L===v-1&&L===d+1?"":i.slice(L,v)},format:l.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.length;let d=0,v=i.charCodeAt(0);if(L===1)return A(v)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(A(v)){if(d=1,A(i.charCodeAt(1))){let T=2,O=T;for(;T<L&&!A(i.charCodeAt(T));)T++;if(T<L&&T!==O){for(O=T;T<L&&A(i.charCodeAt(T));)T++;if(T<L&&T!==O){for(O=T;T<L&&!A(i.charCodeAt(T));)T++;T===L?d=T:T!==O&&(d=T+1)}}}}else if(_(v)&&i.charCodeAt(1)===h){if(L<=2)return a.root=a.dir=i,a;if(d=2,A(i.charCodeAt(2))){if(L===3)return a.root=a.dir=i,a;d=3}}d>0&&(a.root=i.slice(0,d));let M=-1,R=d,D=-1,k=!0,y=i.length-1,I=0;for(;y>=d;--y){if(v=i.charCodeAt(y),A(v)){if(!k){R=y+1;break}continue}D===-1&&(k=!1,D=y+1),v===f?M===-1?M=y:I!==1&&(I=1):M!==-1&&(I=-1)}return D!==-1&&(M===-1||I===0||I===1&&M===D-1&&M===R+1?a.base=a.name=i.slice(R,D):(a.name=i.slice(R,M),a.base=i.slice(R,D),a.ext=i.slice(M,D))),R>0&&R!==d?a.dir=i.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(E){const i=/\\/g;return()=>{const a=P.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>P.cwd()})();t.posix={resolve(...i){let a="",L=!1;for(let d=i.length-1;d>=-1&&!L;d--){const v=d>=0?i[d]:o();e(v,"path"),v.length!==0&&(a=`${v}/${a}`,L=v.charCodeAt(0)===u)}return a=m(a,!L,"/",p),L?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===u,L=i.charCodeAt(i.length-1)===u;return i=m(i,!a,"/",p),i.length===0?a?"/":L?"./":".":(L&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let a;for(let L=0;L<i.length;++L){const d=i[L];e(d,"path"),d.length>0&&(a===void 0?a=d:a+=`/${d}`)}return a===void 0?".":t.posix.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.posix.resolve(i),a=t.posix.resolve(a),i===a))return"";const L=1,d=i.length,v=d-L,M=1,R=a.length-M,D=v<R?v:R;let k=-1,y=0;for(;y<D;y++){const T=i.charCodeAt(L+y);if(T!==a.charCodeAt(M+y))break;T===u&&(k=y)}if(y===D)if(R>D){if(a.charCodeAt(M+y)===u)return a.slice(M+y+1);if(y===0)return a.slice(M+y)}else v>D&&(i.charCodeAt(L+y)===u?k=y:y===0&&(k=0));let I="";for(y=L+k+1;y<=d;++y)(y===d||i.charCodeAt(y)===u)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(M+k)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===u;let L=-1,d=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===u){if(!d){L=v;break}}else d=!1;return L===-1?a?"/":".":a&&L===1?"//":i.slice(0,L)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,d=-1,v=!0,M;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,D=-1;for(M=i.length-1;M>=0;--M){const k=i.charCodeAt(M);if(k===u){if(!v){L=M+1;break}}else D===-1&&(v=!1,D=M+1),R>=0&&(k===a.charCodeAt(R)?--R===-1&&(d=M):(R=-1,d=D))}return L===d?d=D:d===-1&&(d=i.length),i.slice(L,d)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===u){if(!v){L=M+1;break}}else d===-1&&(v=!1,d=M+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let a=-1,L=0,d=-1,v=!0,M=0;for(let R=i.length-1;R>=0;--R){const D=i.charCodeAt(R);if(D===u){if(!v){L=R+1;break}continue}d===-1&&(v=!1,d=R+1),D===f?a===-1?a=R:M!==1&&(M=1):a!==-1&&(M=-1)}return a===-1||d===-1||M===0||M===1&&a===d-1&&a===L+1?"":i.slice(a,d)},format:l.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.charCodeAt(0)===u;let d;L?(a.root="/",d=1):d=0;let v=-1,M=0,R=-1,D=!0,k=i.length-1,y=0;for(;k>=d;--k){const I=i.charCodeAt(k);if(I===u){if(!D){M=k+1;break}continue}R===-1&&(D=!1,R=k+1),I===f?v===-1?v=k:y!==1&&(y=1):v!==-1&&(y=-1)}if(R!==-1){const I=M===0&&L?1:M;v===-1||y===0||y===1&&v===R-1&&v===M+1?a.base=a.name=i.slice(I,R):(a.name=i.slice(I,v),a.base=i.slice(I,R),a.ext=i.slice(v,R))}return M>0?a.dir=i.slice(0,M-1):L&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E?t.win32.normalize:t.posix.normalize,t.isAbsolute=E?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E?t.win32.join:t.posix.join,t.resolve=E?t.win32.resolve:t.posix.resolve,t.relative=E?t.win32.relative:t.posix.relative,t.dirname=E?t.win32.dirname:t.posix.dirname,t.basename=E?t.win32.basename:t.posix.basename,t.extname=E?t.win32.extname:t.posix.extname,t.format=E?t.win32.format:t.posix.format,t.parse=E?t.win32.parse:t.posix.parse,t.toNamespacedPath=E?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E?t.win32.sep:t.posix.sep,t.delimiter=E?t.win32.delimiter:t.posix.delimiter}),te(ne[18],re([0,1,65,17]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,c=/^\//,w=/^\/\//;function f(d,v){if(!d.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!c.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(d,v){return!d&&!v?"file":d}function s(d,v){switch(d){case"https":case"http":case"file":v?v[0]!==N&&(v=N+v):v=N;break}return v}const h="",N="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(v){return v instanceof g?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,M,R,D,k,y=!1){typeof v=="object"?(this.scheme=v.scheme||h,this.authority=v.authority||h,this.path=v.path||h,this.query=v.query||h,this.fragment=v.fragment||h):(this.scheme=u(v,y),this.authority=M||h,this.path=s(this.scheme,R||h),this.query=D||h,this.fragment=k||h,f(this,y))}get fsPath(){return l(this,!1)}with(v){if(!v)return this;let{scheme:M,authority:R,path:D,query:k,fragment:y}=v;return M===void 0?M=this.scheme:M===null&&(M=h),R===void 0?R=this.authority:R===null&&(R=h),D===void 0?D=this.path:D===null&&(D=h),k===void 0?k=this.query:k===null&&(k=h),y===void 0?y=this.fragment:y===null&&(y=h),M===this.scheme&&R===this.authority&&D===this.path&&k===this.query&&y===this.fragment?this:new A(M,R,D,k,y)}static parse(v,M=!1){const R=b.exec(v);return R?new A(R[2]||h,L(R[4]||h),L(R[5]||h),L(R[7]||h),L(R[9]||h),M):new A(h,h,h,h,h)}static file(v){let M=h;if(F.isWindows&&(v=v.replace(/\\/g,N)),v[0]===N&&v[1]===N){const R=v.indexOf(N,2);R===-1?(M=v.substring(2),v=N):(M=v.substring(2,R),v=v.substring(R)||N)}return new A("file",M,v,h,h)}static from(v,M){return new A(v.scheme,v.authority,v.path,v.query,v.fragment,M)}static joinPath(v,...M){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return F.isWindows&&v.scheme==="file"?R=g.file(P.win32.join(l(v,!0),...M)).path:R=P.posix.join(v.path,...M),v.with({path:R})}toString(v=!1){return o(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof g)return v;{const M=new A(v);return M._formatted=v.external??null,M._fsPath=v._sep===E?v.fsPath??null:null,M}}else return v}}t.URI=g;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.isUriComponents=e;const E=F.isWindows?1:void 0;class A extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(v=!1){return v?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=E),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(d,v,M){let R,D=-1;for(let k=0;k<d.length;k++){const y=d.charCodeAt(k);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||v&&y===47||M&&y===91||M&&y===93||M&&y===58)D!==-1&&(R+=encodeURIComponent(d.substring(D,k)),D=-1),R!==void 0&&(R+=d.charAt(k));else{R===void 0&&(R=d.substr(0,k));const I=p[y];I!==void 0?(D!==-1&&(R+=encodeURIComponent(d.substring(D,k)),D=-1),R+=I):D===-1&&(D=k)}}return D!==-1&&(R+=encodeURIComponent(d.substring(D))),R!==void 0?R:d}function m(d){let v;for(let M=0;M<d.length;M++){const R=d.charCodeAt(M);R===35||R===63?(v===void 0&&(v=d.substr(0,M)),v+=p[R]):v!==void 0&&(v+=d[M])}return v!==void 0?v:d}function l(d,v){let M;return d.authority&&d.path.length>1&&d.scheme==="file"?M=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?v?M=d.path.substr(1):M=d.path[1].toLowerCase()+d.path.substr(2):M=d.path,F.isWindows&&(M=M.replace(/\//g,"\\")),M}t.uriToFsPath=l;function o(d,v){const M=v?m:_;let R="",{scheme:D,authority:k,path:y,query:I,fragment:T}=d;if(D&&(R+=D,R+=":"),(k||D==="file")&&(R+=N,R+=N),k){let O=k.indexOf("@");if(O!==-1){const q=k.substr(0,O);k=k.substr(O+1),O=q.lastIndexOf(":"),O===-1?R+=M(q,!1,!1):(R+=M(q.substr(0,O),!1,!1),R+=":",R+=M(q.substr(O+1),!1,!0)),R+="@"}k=k.toLowerCase(),O=k.lastIndexOf(":"),O===-1?R+=M(k,!1,!0):(R+=M(k.substr(0,O),!1,!0),R+=k.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}R+=M(y,!0,!1)}return I&&(R+="?",R+=M(I,!1,!1)),T&&(R+="#",R+=v?T:_(T,!1,!1)),R}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(d){return d.match(a)?d.replace(a,v=>i(v)):d}}),te(ne[70],re([0,1,3,11,10,14,17,7]),function(B,t,P,F,r,c,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let s=!1;function h(L){w.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=h;var N;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class b{constructor(d,v,M,R){this.vsWorker=d,this.req=v,this.method=M,this.args=R,this.type=0}}class g{constructor(d,v,M,R){this.vsWorker=d,this.seq=v,this.res=M,this.err=R,this.type=1}}class e{constructor(d,v,M,R){this.vsWorker=d,this.req=v,this.eventName=M,this.arg=R,this.type=2}}class E{constructor(d,v,M){this.vsWorker=d,this.req=v,this.event=M,this.type=3}}class A{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class p{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,v){const M=String(++this._lastSentReq);return new Promise((R,D)=>{this._pendingReplies[M]={resolve:R,reject:D},this._send(new b(this._workerId,M,d,v))})}listen(d,v){let M=null;const R=new F.Emitter({onWillAddFirstListener:()=>{M=String(++this._lastSentReq),this._pendingEmitters.set(M,R),this._send(new e(this._workerId,M,d,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(M),this._send(new A(this._workerId,M)),M=null}});return R.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let M=d.err;d.err.$isError&&(M=new Error,M.name=d.err.name,M.message=d.err.message,M.stack=d.err.stack),v.reject(M);return}v.resolve(d.res)}_handleRequestMessage(d){const v=d.req;this._handler.handleMessage(d.method,d.args).then(R=>{this._send(new g(this._workerId,v,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,P.transformErrorForSerialization)(R.detail)),this._send(new g(this._workerId,v,void 0,(0,P.transformErrorForSerialization)(R)))})}_handleSubscribeEventMessage(d){const v=d.req,M=this._handler.handleEvent(d.eventName,d.arg)(R=>{this._send(new E(this._workerId,v,R))});this._pendingEvents.set(v,M)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const v=[];if(d.type===0)for(let M=0;M<d.args.length;M++)d.args[M]instanceof ArrayBuffer&&v.push(d.args[M]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this._handler.sendMessage(d,v)}}class _ extends r.Disposable{constructor(d,v,M){super();let R=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{R?.(O)})),this._protocol=new p({sendMessage:(O,q)=>{this._worker.postMessage(O,q)},handleMessage:(O,q)=>{if(typeof M[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(M[O].apply(M,q))}catch(S){return Promise.reject(S)}},handleEvent:(O,q)=>{if(l(O)){const S=M[O].call(M,q);if(typeof S!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return S}if(m(O)){const S=M[O];if(typeof S!="function")throw new Error(`Missing event ${O} on main thread host.`);return S}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?D=k.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const y=(0,c.getAllMethodNames)(M);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(D)),v,y]);const I=(O,q)=>this._request(O,q),T=(O,q)=>this._protocol.listen(O,q);this._lazyProxy=new Promise((O,q)=>{R=q,this._onModuleLoaded.then(S=>{O(o(S,I,T))},S=>{q(S),this._onError("Worker failed to load "+v,S)})})}getProxyObject(){return this._lazyProxy}_request(d,v){return new Promise((M,R)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,v).then(M,R)},R)})}_onError(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=_;function m(L){return L[0]==="o"&&L[1]==="n"&&f.isUpperAsciiLetter(L.charCodeAt(2))}function l(L){return/^onDynamic/.test(L)&&f.isUpperAsciiLetter(L.charCodeAt(9))}function o(L,d,v){const M=k=>function(){const y=Array.prototype.slice.call(arguments,0);return d(k,y)},R=k=>function(y){return v(k,y)},D={};for(const k of L){if(l(k)){D[k]=R(k);continue}if(m(k)){D[k]=v(k,void 0);continue}D[k]=M(k)}return D}class i{constructor(d,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new p({sendMessage:(M,R)=>{d(M,R)},handleMessage:(M,R)=>this._handleMessage(M,R),handleEvent:(M,R)=>this._handleEvent(M,R)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,v){if(d===u)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,v))}catch(M){return Promise.reject(M)}}_handleEvent(d,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(l(d)){const M=this._requestHandler[d].call(this._requestHandler,v);if(typeof M!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return M}if(m(d)){const M=this._requestHandler[d];if(typeof M!="function")throw new Error(`Missing event ${d} on request handler.`);return M}throw new Error(`Malformed event name ${d}`)}initialize(d,v,M,R){this._protocol.setWorkerId(d);const y=o(R,(I,T)=>this._protocol.sendMessage(I,T),(I,T)=>this._protocol.listen(I,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(y),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy<"u"&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((I,T)=>{(globalThis.require||B)([M],q=>{if(this._requestHandler=q.create(y),!this._requestHandler){T(new Error("No RequestHandler!"));return}I((0,c.getAllMethodNames)(this._requestHandler))},T)}))}}t.SimpleWorkerServer=i;function a(L){return new i(L,null)}t.create=a}),te(ne[66],re([62,63]),function(B,t){return B.create("vs/editor/common/languages",t)}),te(ne[67],re([0,1,41,18,42,2,60,66]),function(B,t,P,F,r,c,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.getAriaLabelForSymbol=t.symbolKindNames=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class u{constructor(W,Q,H){this.offset=W,this.type=Q,this.language=H,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=u;class s{constructor(W,Q){this.tokens=W,this.endState=Q,this._tokenizationResultBrand=void 0}}t.TokenizationResult=s;class h{constructor(W,Q){this.tokens=W,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=h;var N;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(N||(t.CompletionItemKind=N={}));var b;(function(S){const W=new Map;W.set(0,P.Codicon.symbolMethod),W.set(1,P.Codicon.symbolFunction),W.set(2,P.Codicon.symbolConstructor),W.set(3,P.Codicon.symbolField),W.set(4,P.Codicon.symbolVariable),W.set(5,P.Codicon.symbolClass),W.set(6,P.Codicon.symbolStruct),W.set(7,P.Codicon.symbolInterface),W.set(8,P.Codicon.symbolModule),W.set(9,P.Codicon.symbolProperty),W.set(10,P.Codicon.symbolEvent),W.set(11,P.Codicon.symbolOperator),W.set(12,P.Codicon.symbolUnit),W.set(13,P.Codicon.symbolValue),W.set(15,P.Codicon.symbolEnum),W.set(14,P.Codicon.symbolConstant),W.set(15,P.Codicon.symbolEnum),W.set(16,P.Codicon.symbolEnumMember),W.set(17,P.Codicon.symbolKeyword),W.set(27,P.Codicon.symbolSnippet),W.set(18,P.Codicon.symbolText),W.set(19,P.Codicon.symbolColor),W.set(20,P.Codicon.symbolFile),W.set(21,P.Codicon.symbolReference),W.set(22,P.Codicon.symbolCustomColor),W.set(23,P.Codicon.symbolFolder),W.set(24,P.Codicon.symbolTypeParameter),W.set(25,P.Codicon.account),W.set(26,P.Codicon.issues);function Q(ee){let n=W.get(ee);return n||(console.info("No codicon found for CompletionItemKind "+ee),n=P.Codicon.symbolProperty),n}S.toIcon=Q;const H=new Map;H.set("method",0),H.set("function",1),H.set("constructor",2),H.set("field",3),H.set("variable",4),H.set("class",5),H.set("struct",6),H.set("interface",7),H.set("module",8),H.set("property",9),H.set("event",10),H.set("operator",11),H.set("unit",12),H.set("value",13),H.set("constant",14),H.set("enum",15),H.set("enum-member",16),H.set("enumMember",16),H.set("keyword",17),H.set("snippet",27),H.set("text",18),H.set("color",19),H.set("file",20),H.set("reference",21),H.set("customcolor",22),H.set("folder",23),H.set("type-parameter",24),H.set("typeParameter",24),H.set("account",25),H.set("issue",26);function Z(ee,n){let ae=H.get(ee);return typeof ae>"u"&&!n&&(ae=9),ae}S.fromString=Z})(b||(t.CompletionItemKinds=b={}));var g;(function(S){S[S.Deprecated=1]="Deprecated"})(g||(t.CompletionItemTag=g={}));var e;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var A;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(A||(t.InlineCompletionTriggerKind=A={}));class p{constructor(W,Q,H,Z){this.range=W,this.text=Q,this.completionKind=H,this.isSnippetText=Z}equals(W){return c.Range.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}t.SelectedSuggestionInfo=p;var _;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var m;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(m||(t.SignatureHelpTriggerKind=m={}));var l;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(l||(t.DocumentHighlightKind=l={}));function o(S){return S&&F.URI.isUri(S.uri)&&c.Range.isIRange(S.range)&&(c.Range.isIRange(S.originSelectionRange)||c.Range.isIRange(S.targetSelectionRange))}t.isLocationLink=o;var i;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.symbolKindNames={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function a(S,W){return(0,f.localize)(26,null,S,t.symbolKindNames[W])}t.getAriaLabelForSymbol=a;var L;(function(S){S[S.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var d;(function(S){const W=new Map;W.set(0,P.Codicon.symbolFile),W.set(1,P.Codicon.symbolModule),W.set(2,P.Codicon.symbolNamespace),W.set(3,P.Codicon.symbolPackage),W.set(4,P.Codicon.symbolClass),W.set(5,P.Codicon.symbolMethod),W.set(6,P.Codicon.symbolProperty),W.set(7,P.Codicon.symbolField),W.set(8,P.Codicon.symbolConstructor),W.set(9,P.Codicon.symbolEnum),W.set(10,P.Codicon.symbolInterface),W.set(11,P.Codicon.symbolFunction),W.set(12,P.Codicon.symbolVariable),W.set(13,P.Codicon.symbolConstant),W.set(14,P.Codicon.symbolString),W.set(15,P.Codicon.symbolNumber),W.set(16,P.Codicon.symbolBoolean),W.set(17,P.Codicon.symbolArray),W.set(18,P.Codicon.symbolObject),W.set(19,P.Codicon.symbolKey),W.set(20,P.Codicon.symbolNull),W.set(21,P.Codicon.symbolEnumMember),W.set(22,P.Codicon.symbolStruct),W.set(23,P.Codicon.symbolEvent),W.set(24,P.Codicon.symbolOperator),W.set(25,P.Codicon.symbolTypeParameter);function Q(H){let Z=W.get(H);return Z||(console.info("No codicon found for SymbolKind "+H),Z=P.Codicon.symbolProperty),Z}S.toIcon=Q})(d||(t.SymbolKinds=d={}));class v{static asEditOperation(W){return r.EditOperation.replace(c.Range.lift(W.range),W.text)}}t.TextEdit=v;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(W){switch(W){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(W)}constructor(W){this.value=W}}t.FoldingRangeKind=M;var R;(function(S){function W(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}S.is=W})(R||(t.Command=R={}));var D;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var k;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var y;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(y||(t.CommentMode=y={}));var I;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(I||(t.CommentState=I={}));var T;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(T||(t.InlayHintKind=T={}));class O{constructor(W){this.createSupport=W,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=O,t.TokenizationRegistry=new w.TokenizationRegistry;var q;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(q||(t.ExternalUriOpenerPriority=q={}))}),te(ne[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(B,t,P,F,r,c,w,f,u,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,E){return(0,r.KeyChord)(e,E)}}t.KeyMod=N;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:F.Emitter,KeyCode:h.KeyCode,KeyMod:N,Position:w.Position,Range:f.Range,Selection:u.Selection,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:c.URI,Token:s.Token}}t.createMonacoBaseAPI=b}),te(ne[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(B,t,P,F,r,c,w,f,u,s,h,N,b,g,e,E,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class _ extends w.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(i){const a=[];for(let L=0;L<this._lines.length;L++){const d=this._lines[L],v=this.offsetAt(new r.Position(L+1,1)),M=d.matchAll(i);for(const R of M)(R.index||R.index===0)&&(R.index=R.index+v),a.push(R)}return a}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,a){const L=(0,f.getWordAtText)(i.column,(0,f.ensureValidWordDefinition)(a),this._lines[i.lineNumber-1],0);return L?new c.Range(i.lineNumber,L.startColumn,i.lineNumber,L.endColumn):null}getWordUntilPosition(i,a){const L=this.getWordAtPosition(i,a);return L?{word:this._lines[i.lineNumber-1].substring(L.startColumn-1,i.column-1),startColumn:L.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this._lines,L=this._wordenize.bind(this);let d=0,v="",M=0,R=[];return{*[Symbol.iterator](){for(;;)if(M<R.length){const D=v.substring(R[M].start,R[M].end);M+=1,yield D}else if(d<a.length)v=a[d],R=L(v,i),M=0,d+=1;else break}}}getLineWords(i,a){const L=this._lines[i-1],d=this._wordenize(L,a),v=[];for(const M of d)v.push({word:L.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return v}_wordenize(i,a){const L=[];let d;for(a.lastIndex=0;(d=a.exec(i))&&d[0].length!==0;)L.push({start:d.index,end:d.index+d[0].length});return L}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this._eol,L=i.startLineNumber-1,d=i.endLineNumber-1,v=[];v.push(this._lines[L].substring(i.startColumn-1));for(let M=L+1;M<d;M++)v.push(this._lines[M]);return v.push(this._lines[d].substring(0,i.endColumn-1)),v.join(a)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(i),L=this._lines[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,L)}}_validateRange(i){const a=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),L=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||L.lineNumber!==i.endLineNumber||L.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:L.lineNumber,endColumn:L.column}:i}_validatePosition(i){if(!r.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:L}=i,d=!1;if(a<1)a=1,L=1,d=!0;else if(a>this._lines.length)a=this._lines.length,L=this._lines[a-1].length+1,d=!0;else{const v=this._lines[a-1].length+1;L<1?(L=1,d=!0):L>v&&(L=v,d=!0)}return d?{lineNumber:a,column:L}:i}}class m{constructor(i,a){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=a,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(a=>i.push(this._models[a])),i}acceptNewModel(i){this._models[i.url]=new _(F.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this._models[i])return;this._models[i].onEvents(a)}acceptRemovedModel(i){this._models[i]&&delete this._models[i]}async computeUnicodeHighlights(i,a,L){const d=this._getModel(i);return d?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,a,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,L,d){const v=this._getModel(i),M=this._getModel(a);return!v||!M?null:m.computeDiff(v,M,L,d)}static computeDiff(i,a,L,d){const v=d==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),M=i.getLinesContent(),R=a.getLinesContent(),D=v.computeDiff(M,R,L),k=D.changes.length>0?!1:this._modelsAreIdentical(i,a);function y(I){return I.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:k,quitEarly:D.hitTimeout,changes:y(D.changes),moves:D.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,y(I.changes)])}}static _modelsAreIdentical(i,a){const L=i.getLineCount(),d=a.getLineCount();if(L!==d)return!1;for(let v=1;v<=L;v++){const M=i.getLineContent(v),R=a.getLineContent(v);if(M!==R)return!1}return!0}async computeDirtyDiff(i,a,L){const d=this._getModel(i),v=this._getModel(a);if(!d||!v)return null;const M=d.getLinesContent(),R=v.getLinesContent();return new g.DiffComputer(M,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(i,a,L){const d=this._getModel(i);if(!d)return a;const v=[];let M;a=a.slice(0).sort((D,k)=>{if(D.range&&k.range)return c.Range.compareRangesUsingStarts(D.range,k.range);const y=D.range?0:1,I=k.range?0:1;return y-I});let R=0;for(let D=1;D<a.length;D++)c.Range.getEndPosition(a[R].range).equals(c.Range.getStartPosition(a[D].range))?(a[R].range=c.Range.fromPositions(c.Range.getStartPosition(a[R].range),c.Range.getEndPosition(a[D].range)),a[R].text+=a[D].text):(R++,a[R]=a[D]);a.length=R+1;for(let{range:D,text:k,eol:y}of a){if(typeof y=="number"&&(M=y),c.Range.isEmpty(D)&&!k)continue;const I=d.getValueInRange(D);if(k=k.replace(/\r\n|\n|\r/g,d.eol),I===k)continue;if(Math.max(k.length,I.length)>m._diffLimit){v.push({range:D,text:k});continue}const T=(0,P.stringDiff)(I,k,L),O=d.offsetAt(c.Range.lift(D).getStartPosition());for(const q of T){const S=d.positionAt(O+q.originalStart),W=d.positionAt(O+q.originalStart+q.originalLength),Q={text:k.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:W.lineNumber,endColumn:W.column}};d.getValueInRange(Q.range)!==Q.text&&v.push(Q)}}return typeof M=="number"&&v.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(i,a,L){const d=this._getModel(i);if(!d)return a;const v=[];let M;a=a.slice(0).sort((R,D)=>{if(R.range&&D.range)return c.Range.compareRangesUsingStarts(R.range,D.range);const k=R.range?0:1,y=D.range?0:1;return k-y});for(let{range:R,text:D,eol:k}of a){let S=function(Q,H){return new r.Position(Q.lineNumber+H.lineNumber-1,H.lineNumber===1?Q.column+H.column-1:H.column)},W=function(Q,H){const Z=[];for(let ee=H.startLineNumber;ee<=H.endLineNumber;ee++){const n=Q[ee-1];ee===H.startLineNumber&&ee===H.endLineNumber?Z.push(n.substring(H.startColumn-1,H.endColumn-1)):ee===H.startLineNumber?Z.push(n.substring(H.startColumn-1)):ee===H.endLineNumber?Z.push(n.substring(0,H.endColumn-1)):Z.push(n)}return Z};if(typeof k=="number"&&(M=k),c.Range.isEmpty(R)&&!D)continue;const y=d.getValueInRange(R);if(D=D.replace(/\r\n|\n|\r/g,d.eol),y===D)continue;if(Math.max(D.length,y.length)>m._diffLimit){v.push({range:R,text:D});continue}const I=y.split(/\r\n|\n|\r/),T=D.split(/\r\n|\n|\r/),O=e.linesDiffComputers.getDefault().computeDiff(I,T,L),q=c.Range.lift(R).getStartPosition();for(const Q of O.changes)if(Q.innerChanges)for(const H of Q.innerChanges)v.push({range:c.Range.fromPositions(S(q,H.originalRange.getStartPosition()),S(q,H.originalRange.getEndPosition())),text:W(T,H.modifiedRange).join(d.eol)});else throw new A.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&v.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(i){const a=this._getModel(i);return a?(0,u.computeLinks)(a):null}async computeDefaultDocumentColors(i){const a=this._getModel(i);return a?(0,p.computeDefaultDocumentColors)(a):null}static{this._suggestionsLimit=1e4}async textualSuggest(i,a,L,d){const v=new N.StopWatch,M=new RegExp(L,d),R=new Set;e:for(const D of i){const k=this._getModel(D);if(k){for(const y of k.words(M))if(!(y===a||!isNaN(Number(y)))&&(R.add(y),R.size>m._suggestionsLimit))break e}}return{words:Array.from(R),duration:v.elapsed()}}async computeWordRanges(i,a,L,d){const v=this._getModel(i);if(!v)return Object.create(null);const M=new RegExp(L,d),R=Object.create(null);for(let D=a.startLineNumber;D<a.endLineNumber;D++){const k=v.getLineWords(D,M);for(const y of k){if(!isNaN(Number(y.word)))continue;let I=R[y.word];I||(I=[],R[y.word]=I),I.push({startLineNumber:D,startColumn:y.startColumn,endLineNumber:D,endColumn:y.endColumn})}}return R}async navigateValueSet(i,a,L,d,v){const M=this._getModel(i);if(!M)return null;const R=new RegExp(d,v);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const D=M.getValueInRange(a),k=M.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},R);if(!k)return null;const y=M.getValueInRange(k);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(a,D,k,y,L)}loadForeignModule(i,a,L){const d=(R,D)=>this._host.fhr(R,D),M={host:(0,E.createProxyObject)(L,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(M,a),Promise.resolve((0,E.getAllMethodNames)(this._foreignModule))):new Promise((R,D)=>{B([i],k=>{this._foreignModule=k.create(M,a),R((0,E.getAllMethodNames)(this._foreignModule))},D)})}fmr(i,a){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,a))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=m;function l(o){return new m(o,null)}t.create=l,typeof importScripts=="function"&&(globalThis.monaco=(0,h.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00d5968fd28fdbb3362ca4686e7ac684b8be63c8/core/vs/base/worker/workerMain.js.map
