/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],N=0,O=G.length;N<O;N++)e[N]=ie[G[N]];return e};define(ie[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class N{static get(){const k=new Map,A=new Map,T=new Map,b=new Map;function f(h,P){h.has(P.detail)||h.set(P.detail,-P.timestamp)}function a(h,P){const I=h.get(P.detail);I&&(I>=0||h.set(P.detail,I+P.timestamp))}let E=[];typeof G=="function"&&typeof G.getStats=="function"&&(E=G.getStats().slice(0).sort((h,P)=>h.timestamp-P.timestamp));for(const h of E)switch(h.type){case 10:f(k,h);break;case 11:case 12:a(k,h);break;case 21:f(A,h);break;case 22:a(A,h);break;case 33:f(T,h);break;case 34:a(T,h);break;case 31:f(b,h);break;case 32:a(b,h);break}let w=0;T.forEach(h=>w+=h);function m(h){const P=[];return h.forEach((I,p)=>P.push([p,I])),P}return{amdLoad:m(k),amdInvoke:m(A),nodeRequire:m(T),nodeEval:m(b),nodeRequireTotal:w}}static toMarkdownTable(k,A){let T="";const b=[];return k.forEach((f,a)=>{b[a]=f.length}),A.forEach(f=>{f.forEach((a,E)=>{typeof a>"u"&&(a=f[E]="-");const w=a.toString().length;b[E]=Math.max(w,b[E])})}),k.forEach((f,a)=>{T+=`| ${f+" ".repeat(b[a]-f.toString().length)} `}),T+=`|
`,k.forEach((f,a)=>{T+=`| ${"-".repeat(b[a])} `}),T+=`|
`,A.forEach(f=>{f.forEach((a,E)=>{typeof a<"u"&&(T+=`| ${a+" ".repeat(b[E]-a.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=N}),define(ie[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(T){return(b,f,a)=>{let E=null,w=null;if(typeof a.value=="function"?(E="value",w=a.value):typeof a.get=="function"&&(E="get",w=a.get),!w)throw new Error("not supported");a[E]=T(w,f)}}function O(T,b,f){let a=null,E=null;if(typeof f.value=="function"?(a="value",E=f.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",E=f.get),!E)throw new Error("not supported");const w=`$memoize$${b}`;f[a]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,m)}),this[w]}}e.memoize=O;function k(T,b,f){return N((a,E)=>{const w=`$debounce$${E}`,m=`$debounce$result$${E}`;return function(...h){this[m]||(this[m]=f?f():void 0),clearTimeout(this[w]),b&&(this[m]=b(this[m],...h),h=[this[m]]),this[w]=setTimeout(()=>{a.apply(this,h),this[m]=f?f():void 0},T)}})}e.debounce=k;function A(T,b,f){return N((a,E)=>{const w=`$throttle$timer$${E}`,m=`$throttle$result$${E}`,h=`$throttle$lastRun$${E}`,P=`$throttle$pending$${E}`;return function(...I){if(this[m]||(this[m]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...I)),this[P])return;const p=this[h]+T;p<=Date.now()?(this[h]=Date.now(),a.apply(this,[this[m]]),this[m]=f?f():void 0):(this[P]=!0,this[w]=setTimeout(()=>{this[P]=!1,this[h]=Date.now(),a.apply(this,[this[m]]),this[m]=f?f():void 0},p-Date.now()))}})}e.throttle=A}),define(ie[71],ne([0,1,7]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function O(a,E){if(!a)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=O;function k(a,E="Unreachable"){throw new Error(E)}e.assertNever=k;function A(a){if(!a)throw new N.BugIndicatingError("Assertion Failed")}e.assert=A;function T(a){a||(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}e.softAssert=T;function b(a){if(!a()){debugger;a(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=b;function f(a,E){let w=0;for(;w<a.length-1;){const m=a[w],h=a[w+1];if(!E(m,h))return!1;w++}return!0}e.checkAdjacentItems=f}),define(ie[38],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(i,s=!1){let t=0;const n=i.length;let r="",o=0,l=16,D=0;function R(se){let fe=0,le=0;for(;fe<se;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)le=le*16+ae-48;else if(ae>=65&&ae<=70)le=le*16+ae-65+10;else if(ae>=97&&ae<=102)le=le*16+ae-97+10;else break;t++,fe++}return fe<se&&(le=-1),le}function y(se){t=se,r="",o=0,l=16,D=0}function L(){const se=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return D=3,i.substring(se,t);let fe=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;fe=t}else D=3;return i.substring(se,fe)}function $(){let se="",fe=t;for(;;){if(t>=n){se+=i.substring(fe,t),D=2;break}const le=i.charCodeAt(t);if(le===34){se+=i.substring(fe,t),t++;break}if(le===92){if(se+=i.substring(fe,t),t++,t>=n){D=2;break}switch(i.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const W=R(4);W>=0?se+=String.fromCharCode(W):D=4;break}default:D=5}fe=t;continue}if(le>=0&&le<=31)if(f(le)){se+=i.substring(fe,t),D=2;break}else D=6;t++}return se}function te(){if(r="",D=0,o=t,t>=n)return o=n,l=17;let se=i.charCodeAt(t);if(b(se)){do t++,r+=String.fromCharCode(se),se=i.charCodeAt(t);while(b(se));return l=15}if(f(se))return t++,r+=String.fromCharCode(se),se===13&&i.charCodeAt(t)===10&&(t++,r+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,r=$(),l=10;case 47:{const fe=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!f(i.charCodeAt(t));)t++;return r=i.substring(fe,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const le=n-1;let ae=!1;for(;t<le;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,D=1),r=i.substring(fe,t),l=13}return r+=String.fromCharCode(se),t++,l=16}case 45:if(r+=String.fromCharCode(se),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),l=11;default:for(;t<n&&Z(se);)t++,se=i.charCodeAt(t);if(o!==t){switch(r=i.substring(o,t),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(se),t++,l=16}}function Z(se){if(b(se)||f(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=te();while(se>=12&&se<=15);return se}return{setPosition:y,getPosition:()=>t,scan:s?oe:te,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>D}}e.createScanner=T;function b(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var E;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(E||(E={}));function w(i,s){const t=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(R,y,L,$){o.value=R,o.offset=y,o.length=L,o.type=$,o.colonOffset=void 0,r=o}try{v(i,{onObjectBegin:(R,y)=>{if(s<=R)throw n;r=void 0,l=s>R,t.push("")},onObjectProperty:(R,y,L)=>{if(s<y||(D(R,y,L,"property"),t[t.length-1]=R,s<=y+L))throw n},onObjectEnd:(R,y)=>{if(s<=R)throw n;r=void 0,t.pop()},onArrayBegin:(R,y)=>{if(s<=R)throw n;r=void 0,t.push(0)},onArrayEnd:(R,y)=>{if(s<=R)throw n;r=void 0,t.pop()},onLiteralValue:(R,y,L)=>{if(s<y||(D(R,y,L,g(R)),s<=y+L))throw n},onSeparator:(R,y,L)=>{if(s<=y)throw n;if(R===":"&&r&&r.type==="property")r.colonOffset=y,l=!1,r=void 0;else if(R===","){const $=t[t.length-1];typeof $=="number"?t[t.length-1]=$+1:(l=!0,t[t.length-1]=""),r=void 0}}})}catch(R){if(R!==n)throw R}return{path:t,previousNode:r,isAtPropertyKey:l,matches:R=>{let y=0;for(let L=0;y<R.length&&L<t.length;L++)if(R[y]===t[L]||R[y]==="*")y++;else if(R[y]!=="**")return!1;return y===R.length}}}e.getLocation=w;function m(i,s=[],t=A.DEFAULT){let n=null,r=[];const o=[];function l(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}return v(i,{onObjectBegin:()=>{const R={};l(R),o.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const R=[];l(R),o.push(r),r=R,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(R,y,L)=>{s.push({error:R,offset:y,length:L})}},t),r[0]}e.parse=m;function h(i,s=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function o(R){return n.children.push(R),R}v(i,{onObjectBegin:R=>{n=o({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,y,L)=>{n=o({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:y,length:L,parent:n})},onObjectEnd:(R,y)=>{n.length=R+y-n.offset,n=n.parent,r(R+y)},onArrayBegin:(R,y)=>{n=o({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,y)=>{n.length=R+y-n.offset,n=n.parent,r(R+y)},onLiteralValue:(R,y,L)=>{o({type:g(R),offset:y,length:L,parent:n,value:R}),r(y+L)},onSeparator:(R,y,L)=>{n.type==="property"&&(R===":"?n.colonOffset=y:R===","&&r(y))},onError:(R,y,L)=>{s.push({error:R,offset:y,length:L})}},t);const D=n.children[0];return D&&delete D.parent,D}e.parseTree=h;function P(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=P;function I(i){if(!i.parent||!i.parent.children)return[];const s=I(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=I;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=p(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function c(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=c;function S(i,s,t=!1){if(c(i,s,t)){const n=i.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=S(n[r],s,t);if(o)return o}return i}}e.findNodeAtOffset=S;function v(i,s,t=A.DEFAULT){const n=T(i,!1);function r(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(X){return X?J=>X(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=r(s.onObjectBegin),D=o(s.onObjectProperty),R=r(s.onObjectEnd),y=r(s.onArrayBegin),L=r(s.onArrayEnd),$=o(s.onLiteralValue),te=o(s.onSeparator),Z=r(s.onComment),oe=o(s.onError),se=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function le(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:se||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(X){case 12:case 13:se?ae(10):Z();break;case 16:ae(1);break;case 15:case 14:break;default:return X}}}function ae(X,J=[],M=[]){if(oe(X),J.length+M.length>0){let F=n.getToken();for(;F!==17;){if(J.indexOf(F)!==-1){le();break}else if(M.indexOf(F)!==-1)break;F=le()}}}function W(X){const J=n.getTokenValue();return X?$(J):D(J),le(),!0}function H(){switch(n.getToken()){case 11:{let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(ae(2),X=0)}catch{ae(2)}$(X);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return le(),!0}function V(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(W(!1),n.getToken()===6?(te(":"),le(),K()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function _(){l(),le();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||ae(4,[],[]),te(","),le(),n.getToken()===2&&fe)break}else X&&ae(6,[],[]);V()||ae(4,[],[2,5]),X=!0}return R(),n.getToken()!==2?ae(7,[2],[]):le(),!0}function j(){y(),le();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||ae(4,[],[]),te(","),le(),n.getToken()===4&&fe)break}else X&&ae(6,[],[]);K()||ae(4,[],[4,5]),X=!0}return L(),n.getToken()!==4?ae(8,[4],[]):le(),!0}function K(){switch(n.getToken()){case 3:return j();case 1:return _();case 10:return W(!0);default:return H()}}return le(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):K()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=v;function u(i,s){const t=T(i),n=[];let r,o=0,l;do switch(l=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(r!==17);return n.join("")}e.stripComments=u;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ie[72],ne([0,1,38]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(a,E,w){let m,h,P,I,p;if(E){for(I=E.offset,p=I+E.length,P=I;P>0&&!f(a,P-1);)P--;let l=p;for(;l<a.length&&!f(a,l);)l++;h=a.substring(P,l),m=T(h,w)}else h=a,m=0,P=0,I=0,p=a.length;const c=b(w,a);let S=!1,v=0,u;w.insertSpaces?u=A(" ",w.tabSize||4):u="	";const g=(0,N.createScanner)(h,!1);let i=!1;function s(){return c+A(u,m+v)}function t(){let l=g.scan();for(S=!1;l===15||l===14;)S=S||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function r(l,D,R){!i&&D<p&&R>I&&a.substring(D,R)!==l&&n.push({offset:D,length:R-D,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+P,D=A(u,m);r(D,P,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+P,D=t(),R="";for(;!S&&(D===12||D===13);){const L=g.getTokenOffset()+P;r(" ",l,L),l=g.getTokenOffset()+g.getTokenLength()+P,R=D===12?s():"",D=t()}if(D===2)o!==1&&(v--,R=s());else if(D===4)o!==3&&(v--,R=s());else{switch(o){case 3:case 1:v++,R=s();break;case 5:case 12:R=s();break;case 13:S?R=s():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(i=!0);break;case 16:i=!0;break}S&&(D===12||D===13)&&(R=s())}const y=g.getTokenOffset()+P;r(R,l,y),o=D}return n}e.format=O;function k(a,E){const w=JSON.stringify(a,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?w.replace(/\r\n|\r|\n/g,E.eol):w}e.toFormattedString=k;function A(a,E){let w="";for(let m=0;m<E;m++)w+=a;return w}function T(a,E){let w=0,m=0;const h=E.tabSize||4;for(;w<a.length;){const P=a.charAt(w);if(P===" ")m++;else if(P==="	")m+=h;else break;w++}return Math.floor(m/h)}function b(a,E){for(let w=0;w<E.length;w++){const m=E.charAt(w);if(m==="\r")return w+1<E.length&&E.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return a&&a.eol||`
`}e.getEOL=b;function f(a,E){return`\r
`.indexOf(a.charAt(E))!==-1}e.isEOL=f}),define(ie[73],ne([0,1,38,72]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(a,E,w){return A(a,E,void 0,w)}e.removeProperty=k;function A(a,E,w,m,h){const P=E.slice(),I=[],p=(0,N.parseTree)(a,I);let c,S;for(;P.length>0&&(S=P.pop(),c=(0,N.findNodeAtLocation)(p,P),c===void 0&&w!==void 0);)typeof S=="string"?w={[S]:w}:w=[w];if(c)if(c.type==="object"&&typeof S=="string"&&Array.isArray(c.children)){const v=(0,N.findNodeAtLocation)(c,[S]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const u=c.children.indexOf(v.parent);let g,i=v.parent.offset+v.parent.length;if(u>0){const s=c.children[u-1];g=s.offset+s.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return T(a,{offset:g,length:i-g,content:""},m)}else return T(a,{offset:v.offset,length:v.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const u=`${JSON.stringify(S)}: ${JSON.stringify(w)}`,g=h?h(c.children.map(s=>s.children[0].value)):c.children.length;let i;if(g>0){const s=c.children[g-1];i={offset:s.offset+s.length,length:0,content:","+u}}else c.children.length===0?i={offset:c.offset+1,length:0,content:u}:i={offset:c.offset+1,length:0,content:u+","};return T(a,i,m)}}else if(c.type==="array"&&typeof S=="number"&&Array.isArray(c.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let u;if(c.children.length===0||S===0)u={offset:c.offset+1,length:0,content:c.children.length===0?v:v+","};else{const g=S===-1||S>c.children.length?c.children.length:S,i=c.children[g-1];u={offset:i.offset+i.length,length:0,content:","+v}}return T(a,u,m)}else{const v=S,u=c.children[v];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===v){const i=c.children[v-1],s=i.offset+i.length,t=c.offset+c.length;g={offset:s,length:t-2-s,content:""}}else g={offset:u.offset,length:c.children[v+1].offset-u.offset,content:""};return T(a,g,m)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${c.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return T(a,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(w)},m)}}e.setProperty=A;function T(a,E,w){let m=b(a,E),h=E.offset,P=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;h>0&&!(0,O.isEOL)(m,h-1);)h--;for(;P<m.length&&!(0,O.isEOL)(m,P);)P++}const I=(0,O.format)(m,{offset:h,length:P-h},w);for(let c=I.length-1;c>=0;c--){const S=I[c];m=b(m,S),h=Math.min(h,S.offset),P=Math.max(P,S.offset+S.length),P+=S.content.length-S.length}const p=a.length-(m.length-P)-h;return[{offset:h,length:p,content:m.substring(h,P)}]}e.withFormatting=T;function b(a,E){return a.substring(0,E.offset)+E.content+a.substring(E.offset+E.length)}e.applyEdit=b;function f(a,E){const w=E.slice(0).sort((h,P)=>{const I=h.offset-P.offset;return I===0?h.length-P.length:I});let m=a.length;for(let h=w.length-1;h>=0;h--){const P=w[h];if(P.offset+P.length<=m)a=b(a,P);else throw new Error("Overlapping edit");m=P.offset}return a}e.applyEdits=f}),define(ie[74],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(b,f,a){return Math.min(Math.max(b,f),a)}e.clamp=N;function O(b,f){return(f+b%f)%f}e.rot=O;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const a=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(f){A.push(f,Date.now())}function b(){const f=[];for(let a=0;a<A.length;a+=2)f.push({name:A[a],startTime:A[a+1]});return f}return{mark:T,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function N(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=N(O))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var O in N)(typeof exports=="object"?exports:G)[O]=N[O]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function N(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return G[O].call(k.exports,k,k.exports,N),k.l=!0,k.exports}return N.m=G,N.c=e,N.d=function(O,k,A){N.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:A})},N.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},N.t=function(O,k){if(1&k&&(O=N(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var T in O)N.d(A,T,function(b){return O[b]}.bind(null,T));return A},N.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return N.d(k,"a",k),k},N.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},N.p="",N(N.s=0)}([function(G,e,N){(function(O){var k;e=G.exports=M,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],f=e.src=[],a=0,E=a++;f[E]="0|[1-9]\\d*";var w=a++;f[w]="[0-9]+";var m=a++;f[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=a++;f[h]="("+f[E]+")\\.("+f[E]+")\\.("+f[E]+")";var P=a++;f[P]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var I=a++;f[I]="(?:"+f[E]+"|"+f[m]+")";var p=a++;f[p]="(?:"+f[w]+"|"+f[m]+")";var c=a++;f[c]="(?:-("+f[I]+"(?:\\."+f[I]+")*))";var S=a++;f[S]="(?:-?("+f[p]+"(?:\\."+f[p]+")*))";var v=a++;f[v]="[0-9A-Za-z-]+";var u=a++;f[u]="(?:\\+("+f[v]+"(?:\\."+f[v]+")*))";var g=a++,i="v?"+f[h]+f[c]+"?"+f[u]+"?";f[g]="^"+i+"$";var s="[v=\\s]*"+f[P]+f[S]+"?"+f[u]+"?",t=a++;f[t]="^"+s+"$";var n=a++;f[n]="((?:<|>)?=?)";var r=a++;f[r]=f[w]+"|x|X|\\*";var o=a++;f[o]=f[E]+"|x|X|\\*";var l=a++;f[l]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[c]+")?"+f[u]+"?)?)?";var D=a++;f[D]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[S]+")?"+f[u]+"?)?)?";var R=a++;f[R]="^"+f[n]+"\\s*"+f[l]+"$";var y=a++;f[y]="^"+f[n]+"\\s*"+f[D]+"$";var L=a++;f[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=a++;f[$]="(?:~>?)";var te=a++;f[te]="(\\s*)"+f[$]+"\\s+",b[te]=new RegExp(f[te],"g");var Z=a++;f[Z]="^"+f[$]+f[l]+"$";var oe=a++;f[oe]="^"+f[$]+f[D]+"$";var se=a++;f[se]="(?:\\^)";var fe=a++;f[fe]="(\\s*)"+f[se]+"\\s+",b[fe]=new RegExp(f[fe],"g");var le=a++;f[le]="^"+f[se]+f[l]+"$";var ae=a++;f[ae]="^"+f[se]+f[D]+"$";var W=a++;f[W]="^"+f[n]+"\\s*("+s+")$|^$";var H=a++;f[H]="^"+f[n]+"\\s*("+i+")$|^$";var V=a++;f[V]="(\\s*)"+f[n]+"\\s*("+s+"|"+f[l]+")",b[V]=new RegExp(f[V],"g");var _=a++;f[_]="^\\s*("+f[l]+")\\s+-\\s+("+f[l]+")\\s*$";var j=a++;f[j]="^\\s*("+f[D]+")\\s+-\\s+("+f[D]+")\\s*$";var K=a++;f[K]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,f[X]),b[X]||(b[X]=new RegExp(f[X]));function J(z,Y){if(z instanceof M)return z;if(typeof z!="string"||z.length>A||!(Y?b[t]:b[g]).test(z))return null;try{return new M(z,Y)}catch{return null}}function M(z,Y){if(z instanceof M){if(z.loose===Y)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(z,Y);k("SemVer",z,Y),this.loose=Y;var Q=z.trim().match(Y?b[t]:b[g]);if(!Q)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<T)return ye}return ge}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=J,e.valid=function(z,Y){var Q=J(z,Y);return Q?Q.version:null},e.clean=function(z,Y){var Q=J(z.trim().replace(/^[=v]+/,""),Y);return Q?Q.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof M||(z=new M(z,this.loose)),this.compareMain(z)||this.comparePre(z)},M.prototype.compareMain=function(z){return z instanceof M||(z=new M(z,this.loose)),d(this.major,z.major)||d(this.minor,z.minor)||d(this.patch,z.patch)},M.prototype.comparePre=function(z){if(z instanceof M||(z=new M(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var Y=0;do{var Q=this.prerelease[Y],ge=z.prerelease[Y];if(k("prerelease compare",Y,Q,ge),Q===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(Q===void 0)return-1;if(Q!==ge)return d(Q,ge)}while(++Y)},M.prototype.inc=function(z,Y){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,Y,Q,ge){typeof Q=="string"&&(ge=Q,Q=void 0);try{return new M(z,Q).inc(Y,ge).version}catch{return null}},e.diff=function(z,Y){if(q(z,Y))return null;var Q=J(z),ge=J(Y);if(Q.prerelease.length||ge.prerelease.length){for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==ge[ye])return ye},e.compareIdentifiers=d;var F=/^[0-9]+$/;function d(z,Y){var Q=F.test(z),ge=F.test(Y);return Q&&ge&&(z=+z,Y=+Y),Q&&!ge?-1:ge&&!Q?1:z<Y?-1:z>Y?1:0}function C(z,Y,Q){return new M(z,Q).compare(new M(Y,Q))}function x(z,Y,Q){return C(z,Y,Q)>0}function U(z,Y,Q){return C(z,Y,Q)<0}function q(z,Y,Q){return C(z,Y,Q)===0}function B(z,Y,Q){return C(z,Y,Q)!==0}function ee(z,Y,Q){return C(z,Y,Q)>=0}function ue(z,Y,Q){return C(z,Y,Q)<=0}function he(z,Y,Q,ge){var ye;switch(Y){case"===":typeof z=="object"&&(z=z.version),typeof Q=="object"&&(Q=Q.version),ye=z===Q;break;case"!==":typeof z=="object"&&(z=z.version),typeof Q=="object"&&(Q=Q.version),ye=z!==Q;break;case"":case"=":case"==":ye=q(z,Q,ge);break;case"!=":ye=B(z,Q,ge);break;case">":ye=x(z,Q,ge);break;case">=":ye=ee(z,Q,ge);break;case"<":ye=U(z,Q,ge);break;case"<=":ye=ue(z,Q,ge);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function pe(z,Y){if(z instanceof pe){if(z.loose===Y)return z;z=z.value}if(!(this instanceof pe))return new pe(z,Y);k("comparator",z,Y),this.loose=Y,this.parse(z),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,Y){return d(Y,z)},e.major=function(z,Y){return new M(z,Y).major},e.minor=function(z,Y){return new M(z,Y).minor},e.patch=function(z,Y){return new M(z,Y).patch},e.compare=C,e.compareLoose=function(z,Y){return C(z,Y,!0)},e.rcompare=function(z,Y,Q){return C(Y,z,Q)},e.sort=function(z,Y){return z.sort(function(Q,ge){return e.compare(Q,ge,Y)})},e.rsort=function(z,Y){return z.sort(function(Q,ge){return e.rcompare(Q,ge,Y)})},e.gt=x,e.lt=U,e.eq=q,e.neq=B,e.gte=ee,e.lte=ue,e.cmp=he,e.Comparator=pe;var Se={};function de(z,Y){if(z instanceof de)return z.loose===Y?z:new de(z.raw,Y);if(z instanceof pe)return new de(z.value,Y);if(!(this instanceof de))return new de(z,Y);if(this.loose=Y,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ce(z){return!z||z.toLowerCase()==="x"||z==="*"}function ve(z,Y,Q,ge,ye,Oe,Ie,xe,De,Ae,_e,Re,Te){return((Y=ce(Q)?"":ce(ge)?">="+Q+".0.0":ce(ye)?">="+Q+"."+ge+".0":">="+Y)+" "+(xe=ce(De)?"":ce(Ae)?"<"+(+De+1)+".0.0":ce(_e)?"<"+De+"."+(+Ae+1)+".0":Re?"<="+De+"."+Ae+"."+_e+"-"+Re:"<="+xe)).trim()}function Ee(z,Y){for(var Q=0;Q<z.length;Q++)if(!z[Q].test(Y))return!1;if(Y.prerelease.length){for(Q=0;Q<z.length;Q++)if(k(z[Q].semver),z[Q].semver!==Se&&z[Q].semver.prerelease.length>0){var ge=z[Q].semver;if(ge.major===Y.major&&ge.minor===Y.minor&&ge.patch===Y.patch)return!0}return!1}return!0}function be(z,Y,Q){try{Y=new de(Y,Q)}catch{return!1}return Y.test(z)}function Le(z,Y,Q,ge){var ye,Oe,Ie,xe,De;switch(z=new M(z,ge),Y=new de(Y,ge),Q){case">":ye=x,Oe=ue,Ie=U,xe=">",De=">=";break;case"<":ye=U,Oe=ee,Ie=x,xe="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(z,Y,ge))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var _e=Y.set[Ae],Re=null,Te=null;if(_e.forEach(function(Fe){Fe.semver===Se&&(Fe=new pe(">=0.0.0")),Re=Re||Fe,Te=Te||Fe,ye(Fe.semver,Re.semver,ge)?Re=Fe:Ie(Fe.semver,Te.semver,ge)&&(Te=Fe)}),Re.operator===xe||Re.operator===De||(!Te.operator||Te.operator===xe)&&Oe(z,Te.semver)||Te.operator===De&&Ie(z,Te.semver))return!1}return!0}pe.prototype.parse=function(z){var Y=this.loose?b[W]:b[H],Q=z.match(Y);if(!Q)throw new TypeError("Invalid comparator: "+z);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new M(Q[2],this.loose):this.semver=Se},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===Se||(typeof z=="string"&&(z=new M(z,this.loose)),he(z,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(z,Y){if(!(z instanceof pe))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new de(z.value,Y),be(this.value,Q,Y);if(z.operator==="")return Q=new de(this.value,Y),be(z.semver,Q,Y);var ge=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),xe=he(this.semver,"<",z.semver,Y)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),De=he(this.semver,">",z.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ge||ye||Oe&&Ie||xe||De},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(z){var Y=this.loose;z=z.trim(),k("range",z,Y);var Q=Y?b[j]:b[_];z=z.replace(Q,ve),k("hyphen replace",z),z=z.replace(b[V],"$1$2$3"),k("comparator trim",z,b[V]),z=(z=(z=z.replace(b[te],"$1~")).replace(b[fe],"$1^")).split(/\s+/).join(" ");var ge=Y?b[W]:b[H],ye=z.split(" ").map(function(Oe){return function(Ie,xe){return k("comp",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(_e){return function(Re,Te){k("caret",Re,Te);var Fe=Te?b[ae]:b[le];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke){var Me;return k("caret",Re,Ne,we,Pe,Ce,ke),ce(we)?Me="":ce(Pe)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Ce)?Me=we==="0"?">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+Pe+"."+(+Ce+1):">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+Ce+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Me=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+Ce+" <"+we+"."+Pe+"."+(+Ce+1):">="+we+"."+Pe+"."+Ce+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+Ce+" <"+(+we+1)+".0.0"),k("caret return",Me),Me})}(_e,Ae)}).join(" ")}(Ie,xe),k("caret",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(_e){return function(Re,Te){var Fe=Te?b[oe]:b[Z];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke){var Me;return k("tilde",Re,Ne,we,Pe,Ce,ke),ce(we)?Me="":ce(Pe)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Ce)?Me=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+(+Pe+1)+".0"):Me=">="+we+"."+Pe+"."+Ce+" <"+we+"."+(+Pe+1)+".0",k("tilde return",Me),Me})}(_e,Ae)}).join(" ")}(Ie,xe),k("tildes",Ie),Ie=function(De,Ae){return k("replaceXRanges",De,Ae),De.split(/\s+/).map(function(_e){return function(Re,Te){Re=Re.trim();var Fe=Te?b[y]:b[R];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke,Me){k("xRange",Re,Ne,we,Pe,Ce,ke,Me);var We=ce(Pe),Ue=We||ce(Ce),Ve=Ue||ce(ke);return we==="="&&Ve&&(we=""),We?Ne=we===">"||we==="<"?"<0.0.0":"*":we&&Ve?(Ue&&(Ce=0),Ve&&(ke=0),we===">"?(we=">=",Ue?(Pe=+Pe+1,Ce=0,ke=0):Ve&&(Ce=+Ce+1,ke=0)):we==="<="&&(we="<",Ue?Pe=+Pe+1:Ce=+Ce+1),Ne=we+Pe+"."+Ce+"."+ke):Ue?Ne=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Ne=">="+Pe+"."+Ce+".0 <"+Pe+"."+(+Ce+1)+".0"),k("xRange return",Ne),Ne})}(_e,Ae)}).join(" ")}(Ie,xe),k("xrange",Ie),Ie=function(De,Ae){return k("replaceStars",De,Ae),De.trim().replace(b[K],"")}(Ie,xe),k("stars",Ie),Ie}(Oe,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match(ge)})),ye=ye.map(function(Oe){return new pe(Oe,Y)})},de.prototype.intersects=function(z,Y){if(!(z instanceof de))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(ge){return z.set.some(function(ye){return ye.every(function(Oe){return ge.intersects(Oe,Y)})})})})},e.toComparators=function(z,Y){return new de(z,Y).set.map(function(Q){return Q.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},de.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new M(z,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Ee(this.set[Y],z))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(z,Y,Q){var ge=null,ye=null;try{var Oe=new de(Y,Q)}catch{return null}return z.forEach(function(Ie){Oe.test(Ie)&&(ge&&ye.compare(Ie)!==-1||(ye=new M(ge=Ie,Q)))}),ge},e.minSatisfying=function(z,Y,Q){var ge=null,ye=null;try{var Oe=new de(Y,Q)}catch{return null}return z.forEach(function(Ie){Oe.test(Ie)&&(ge&&ye.compare(Ie)!==1||(ye=new M(ge=Ie,Q)))}),ge},e.validRange=function(z,Y){try{return new de(z,Y).range||"*"}catch{return null}},e.ltr=function(z,Y,Q){return Le(z,Y,"<",Q)},e.gtr=function(z,Y,Q){return Le(z,Y,">",Q)},e.outside=Le,e.prerelease=function(z,Y){var Q=J(z,Y);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(z,Y,Q){return z=new de(z,Q),Y=new de(Y,Q),z.intersects(Y)},e.coerce=function(z){if(z instanceof M)return z;if(typeof z!="string")return null;var Y=z.match(b[L]);return Y==null?null:J((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,N(1))},function(G,e){var N,O,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function b(p){if(N===setTimeout)return setTimeout(p,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(p,0);try{return N(p,0)}catch{try{return N.call(null,p,0)}catch{return N.call(this,p,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var f,a=[],E=!1,w=-1;function m(){E&&f&&(E=!1,f.length?a=f.concat(a):w=-1,a.length&&h())}function h(){if(!E){var p=b(m);E=!0;for(var c=a.length;c;){for(f=a,a=[];++w<c;)f&&f[w].run();w=-1,c=a.length}f=null,E=!1,function(S){if(O===clearTimeout)return clearTimeout(S);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(S);try{O(S)}catch{try{return O.call(null,S)}catch{return O.call(this,S)}}}(p)}}function P(p,c){this.fun=p,this.array=c}function I(){}k.nextTick=function(p){var c=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)c[S-1]=arguments[S];a.push(new P(p,c)),a.length!==1||E||b(h)},P.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=I,k.addListener=I,k.once=I,k.off=I,k.removeListener=I,k.removeAllListeners=I,k.emit=I,k.prependListener=I,k.prependOnceListener=I,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(G,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(b,f,a){this.level=b,this.key=f,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(b,f=2**16){this.comparator=b,this[N]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new O(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,k,k),this._size=0}has(b){return!!A._search(this,b,this.comparator)}get(b){return A._search(this,b,this.comparator)?.value}set(b,f){return A._insert(this,b,f,this.comparator)&&(this._size+=1),this}delete(b){const f=A._delete(this,b,this.comparator);return f&&(this._size-=1),f}forEach(b,f){let a=this._header.forward[0];for(;a;)b.call(f,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",f=this._header.forward[0];for(;f;)b+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return b}static _search(b,f,a){let E=b._header;for(let w=b._level-1;w>=0;w--)for(;E.forward[w]&&a(E.forward[w].key,f)<0;)E=E.forward[w];if(E=E.forward[0],E&&a(E.key,f)===0)return E}static _insert(b,f,a,E){const w=[];let m=b._header;for(let h=b._level-1;h>=0;h--){for(;m.forward[h]&&E(m.forward[h].key,f)<0;)m=m.forward[h];w[h]=m}if(m=m.forward[0],m&&E(m.key,f)===0)return m.value=a,!1;{const h=A._randomLevel(b);if(h>b._level){for(let P=b._level;P<h;P++)w[P]=b._header;b._level=h}m=new O(h,f,a);for(let P=0;P<h;P++)m.forward[P]=w[P].forward[P],w[P].forward[P]=m;return!0}}static _randomLevel(b,f=.5){let a=1;for(;Math.random()<f&&a<b._maxLevel;)a+=1;return a}static _delete(b,f,a){const E=[];let w=b._header;for(let m=b._level-1;m>=0;m--){for(;w.forward[m]&&a(w.forward[m].key,f)<0;)w=w.forward[m];E[m]=w}if(w=w.forward[0],!w||a(w.key,f)!==0)return!1;for(let m=0;m<b._level&&E[m].forward[m]===w;m++)E[m].forward[m]=w.forward[m];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=A}),define(ie[46],ne([0,1,7,2]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const g=u;return g?typeof g.read=="function":!1}e.isReadable=k;function A(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function T(u){const g=u;return g?A(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=T;function b(u,g){return new f(u,g)}e.newWriteableStream=b;class f{constructor(g,i){this.reducer=g,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(i=>i(g))}emitError(g){this.listeners.error.length===0?(0,N.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(i=>i(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,i){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(g,i){if(this.state.destroyed)return;let s;switch(g){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(u,g){const i=[];let s;for(;(s=u.read())!==null;)i.push(s);return g(i)}e.consumeReadable=a;function E(u,g,i){const s=[];let t;for(;(t=u.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}e.peekReadable=E;function w(u,g){return new Promise((i,s)=>{const t=[];m(u,{onData:n=>{g&&t.push(n)},onError:n=>{g?s(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.consumeStream=w;function m(u,g,i){u.on("error",s=>{i?.isCancellationRequested||g.onError(s)}),u.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),u.on("data",s=>{i?.isCancellationRequested||g.onData(s)})}e.listenStream=m;function h(u,g){return new Promise((i,s)=>{const t=new O.DisposableStore,n=[],r=D=>{if(n.push(D),n.length>g)return t.dispose(),u.pause(),i({stream:u,buffer:n,ended:!1})},o=D=>(t.dispose(),s(D)),l=()=>(t.dispose(),i({stream:u,buffer:n,ended:!0}));t.add((0,O.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),t.add((0,O.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),t.add((0,O.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=h;function P(u,g){const i=b(g);return i.end(u),i}e.toStream=P;function I(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=I;function p(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.toReadable=p;function c(u,g,i){const s=b(i);return m(u,{onData:t=>s.write(g.data(t)),onError:t=>s.error(g.error?g.error(t):t),onEnd:()=>s.end()}),s}e.transform=c;function S(u,g,i){let s=!1;return{read:()=>{const t=g.read();return s?t:(s=!0,t!==null?i([u,t]):u)}}}e.prefixedReadable=S;function v(u,g,i){let s=!1;const t=b(i);return m(g,{onData:n=>s?t.write(n):(s=!0,t.write(i([u,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(u)),t.end()}}),t}e.prefixedStream=v}),define(ie[14],ne([0,1,166,46]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",A=new N.Lazy(()=>new Uint8Array(256));let T,b;class f{static alloc(L){return k?new f(Buffer.allocUnsafe(L)):new f(new Uint8Array(L))}static wrap(L){return k&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new f(L)}static fromString(L,$){return!($?.dontUseNodeBuffer||!1)&&k?new f(Buffer.from(L)):(T||(T=new TextEncoder),new f(T.encode(L)))}static fromByteArray(L){const $=f.alloc(L.length);for(let te=0,Z=L.length;te<Z;te++)$.buffer[te]=L[te];return $}static concat(L,$){if(typeof $>"u"){$=0;for(let oe=0,se=L.length;oe<se;oe++)$+=L[oe].byteLength}const te=f.alloc($);let Z=0;for(let oe=0,se=L.length;oe<se;oe++){const fe=L[oe];te.set(fe,Z),Z+=fe.byteLength}return te}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=f.alloc(this.byteLength);return L.set(this),L}toString(){return k?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(L,$){return new f(this.buffer.subarray(L,$))}set(L,$){if(L instanceof f)this.buffer.set(L.buffer,$);else if(L instanceof Uint8Array)this.buffer.set(L,$);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),$);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),$);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return m(this.buffer,L)}writeUInt32BE(L,$){h(this.buffer,L,$)}readUInt32LE(L){return P(this.buffer,L)}writeUInt32LE(L,$){I(this.buffer,L,$)}readUInt8(L){return p(this.buffer,L)}writeUInt8(L,$){c(this.buffer,L,$)}indexOf(L,$=0){return a(this.buffer,L instanceof f?L.buffer:L,$)}}e.VSBuffer=f;function a(y,L,$=0){const te=L.byteLength,Z=y.byteLength;if(te===0)return 0;if(te===1)return y.indexOf(L[0]);if(te>Z-$)return-1;const oe=A.value;oe.fill(L.length);for(let ae=0;ae<L.length;ae++)oe[L[ae]]=L.length-ae-1;let se=$+L.length-1,fe=se,le=-1;for(;se<Z;)if(y[se]===L[fe]){if(fe===0){le=se;break}se--,fe--}else se+=Math.max(L.length-fe,oe[y[se]]),fe=L.length-1;return le}e.binaryIndexOf=a;function E(y,L){return y[L+0]<<0>>>0|y[L+1]<<8>>>0}e.readUInt16LE=E;function w(y,L,$){y[$+0]=L&255,L=L>>>8,y[$+1]=L&255}e.writeUInt16LE=w;function m(y,L){return y[L]*2**24+y[L+1]*2**16+y[L+2]*2**8+y[L+3]}e.readUInt32BE=m;function h(y,L,$){y[$+3]=L,L=L>>>8,y[$+2]=L,L=L>>>8,y[$+1]=L,L=L>>>8,y[$]=L}e.writeUInt32BE=h;function P(y,L){return y[L+0]<<0>>>0|y[L+1]<<8>>>0|y[L+2]<<16>>>0|y[L+3]<<24>>>0}e.readUInt32LE=P;function I(y,L,$){y[$+0]=L&255,L=L>>>8,y[$+1]=L&255,L=L>>>8,y[$+2]=L&255,L=L>>>8,y[$+3]=L&255}e.writeUInt32LE=I;function p(y,L){return y[L]}e.readUInt8=p;function c(y,L,$){y[$]=L}e.writeUInt8=c;function S(y){return O.consumeReadable(y,L=>f.concat(L))}e.readableToBuffer=S;function v(y){return O.toReadable(y)}e.bufferToReadable=v;function u(y){return O.consumeStream(y,L=>f.concat(L))}e.streamToBuffer=u;async function g(y){return y.ended?f.concat(y.buffer):f.concat([...y.buffer,await u(y.stream)])}e.bufferedStreamToBuffer=g;function i(y){return O.toStream(y,L=>f.concat(L))}e.bufferToStream=i;function s(y){return O.transform(y,{data:L=>typeof L=="string"?f.fromString(L):f.wrap(L)},L=>f.concat(L))}e.streamToBufferReadableStream=s;function t(y){return O.newWriteableStream(L=>f.concat(L),y)}e.newWriteableBufferStream=t;function n(y,L){return O.prefixedReadable(y,L,$=>f.concat($))}e.prefixedBufferReadable=n;function r(y,L){return O.prefixedStream(y,L,$=>f.concat($))}e.prefixedBufferStream=r;function o(y){let L=0,$=0,te=0;const Z=new Uint8Array(Math.floor(y.length/4*3)),oe=fe=>{switch($){case 3:Z[te++]=L|fe,$=0;break;case 2:Z[te++]=L|fe>>>2,L=fe<<6,$=3;break;case 1:Z[te++]=L|fe>>>4,L=fe<<4,$=2;break;default:L=fe<<2,$=1}};for(let fe=0;fe<y.length;fe++){const le=y.charCodeAt(fe);if(le>=65&&le<=90)oe(le-65);else if(le>=97&&le<=122)oe(le-97+26);else if(le>=48&&le<=57)oe(le-48+52);else if(le===43||le===45)oe(62);else if(le===47||le===95)oe(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${y[fe]}`)}}const se=te;for(;$>0;)oe(0);return f.wrap(Z).slice(0,se)}e.decodeBase64=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:y},L=!0,$=!1){const te=$?D:l;let Z="";const oe=y.byteLength%3;let se=0;for(;se<y.byteLength-oe;se+=3){const fe=y[se+0],le=y[se+1],ae=y[se+2];Z+=te[fe>>>2],Z+=te[(fe<<4|le>>>4)&63],Z+=te[(le<<2|ae>>>6)&63],Z+=te[ae&63]}if(oe===1){const fe=y[se+0];Z+=te[fe>>>2],Z+=te[fe<<4&63],L&&(Z+="==")}else if(oe===2){const fe=y[se+0],le=y[se+1];Z+=te[fe>>>2],Z+=te[(fe<<4|le>>>4)&63],Z+=te[le<<2&63],L&&(Z+="=")}return Z}e.encodeBase64=R}),define(ie[43],ne([0,1,30]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return k(c,0)}e.hash=O;function k(c,S){switch(typeof c){case"object":return c===null?A(349,S):Array.isArray(c)?f(c,S):a(c,S);case"string":return b(c,S);case"boolean":return T(c,S);case"number":return A(c,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=k;function A(c,S){return(S<<5)-S+c|0}e.numberHash=A;function T(c,S){return A(c?433:863,S)}function b(c,S){S=A(149417,S);for(let v=0,u=c.length;v<u;v++)S=A(c.charCodeAt(v),S);return S}e.stringHash=b;function f(c,S){return S=A(104579,S),c.reduce((v,u)=>k(u,v),S)}function a(c,S){return S=A(181387,S),Object.keys(c).sort().reduce((v,u)=>(v=b(u,v),k(c[u],v)),S)}class E{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=E;var w;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(c,S,v=32){const u=v-S,g=~((1<<u)-1);return(c<<S|(g&c)>>>u)>>>0}function h(c,S=0,v=c.byteLength,u=0){for(let g=0;g<v;g++)c[S+g]=u}function P(c,S,v="0"){for(;c.length<S;)c=v+c;return c}function I(c,S=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(v=>v.toString(16).padStart(2,"0")).join(""):P((c>>>0).toString(16),S/4)}e.toHexString=I;class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const v=S.length;if(v===0)return;const u=this._buff;let g=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=S.charCodeAt(0),t=0);;){let n=s;if(N.isHighSurrogate(s))if(t+1<v){const r=S.charCodeAt(t+1);N.isLowSurrogate(r)?(t++,n=N.computeCodePoint(s,r)):n=65533}else{i=s;break}else N.isLowSurrogate(s)&&(n=65533);if(g=this._push(u,g,n),t++,t<v)s=S.charCodeAt(t);else break}this._buffLen=g,this._leftoverHighSurrogate=i}_push(S,v,u){return u<128?S[v++]=u:u<2048?(S[v++]=192|(u&1984)>>>6,S[v++]=128|(u&63)>>>0):u<65536?(S[v++]=224|(u&61440)>>>12,S[v++]=128|(u&4032)>>>6,S[v++]=128|(u&63)>>>0):(S[v++]=240|(u&1835008)>>>18,S[v++]=128|(u&258048)>>>12,S[v++]=128|(u&4032)>>>6,S[v++]=128|(u&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),I(this._h0)+I(this._h1)+I(this._h2)+I(this._h3)+I(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=p._bigBlock32,v=this._buffDV;for(let l=0;l<64;l+=4)S.setUint32(l,v.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)S.setUint32(l,m(S.getUint32(l-12,!1)^S.getUint32(l-32,!1)^S.getUint32(l-56,!1)^S.getUint32(l-64,!1),1),!1);let u=this._h0,g=this._h1,i=this._h2,s=this._h3,t=this._h4,n,r,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&s,r=1518500249):l<40?(n=g^i^s,r=1859775393):l<60?(n=g&i|g&s|i&s,r=2400959708):(n=g^i^s,r=3395469782),o=m(u,5)+n+t+r+S.getUint32(l*4,!1)&4294967295,t=s,s=i,i=m(g,30),g=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=p}),define(ie[54],ne([0,1,30]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const A="error",T="warning",b="warn",f="info",a="ignore";function E(m){return m?N.equalsIgnoreCase(A,m)?k.Error:N.equalsIgnoreCase(T,m)||N.equalsIgnoreCase(b,m)?k.Warning:N.equalsIgnoreCase(f,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function w(m){switch(m){case k.Error:return A;case k.Warning:return T;case k.Info:return f;default:return a}}k.toString=w}(O||(O={})),e.default=O}),define(ie[27],ne([0,1,3]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const S=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([v,u])=>{S[v]=u&&typeof u=="object"?O(u):u}),S}e.deepClone=O;function k(c){if(!c||typeof c!="object")return c;const S=[c];for(;S.length>0;){const v=S.shift();Object.freeze(v);for(const u in v)if(A.call(v,u)){const g=v[u];typeof g=="object"&&!Object.isFrozen(g)&&!(0,N.isTypedArray)(g)&&S.push(g)}}return c}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(c,S){return b(c,S,new Set)}e.cloneAndChange=T;function b(c,S,v){if((0,N.isUndefinedOrNull)(c))return c;const u=S(c);if(typeof u<"u")return u;if(Array.isArray(c)){const g=[];for(const i of c)g.push(b(i,S,v));return g}if((0,N.isObject)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const g={};for(const i in c)A.call(c,i)&&(g[i]=b(c[i],S,v));return v.delete(c),g}return c}function f(c,S,v=!0){return(0,N.isObject)(c)?((0,N.isObject)(S)&&Object.keys(S).forEach(u=>{u in c?v&&((0,N.isObject)(c[u])&&(0,N.isObject)(S[u])?f(c[u],S[u],v):c[u]=S[u]):c[u]=S[u]}),c):S}e.mixin=f;function a(c,S){if(c===S)return!0;if(c==null||S===null||S===void 0||typeof c!=typeof S||typeof c!="object"||Array.isArray(c)!==Array.isArray(S))return!1;let v,u;if(Array.isArray(c)){if(c.length!==S.length)return!1;for(v=0;v<c.length;v++)if(!a(c[v],S[v]))return!1}else{const g=[];for(u in c)g.push(u);g.sort();const i=[];for(u in S)i.push(u);if(i.sort(),!a(g,i))return!1;for(v=0;v<g.length;v++)if(!a(c[g[v]],S[g[v]]))return!1}return!0}e.equals=a;function E(c){const S=new Set;return JSON.stringify(c,(v,u)=>{if((0,N.isObject)(u)||Array.isArray(u)){if(S.has(u))return"[Circular]";S.add(u)}return u})}e.safeStringify=E;function w(c,S){const v=Object.create(null);return!c||!S||Object.keys(S).forEach(g=>{const i=c[g],s=S[g];a(i,s)||(v[g]=s)}),v}e.distinct=w;function m(c,S){const v=S.toLowerCase(),u=Object.keys(c).find(g=>g.toLowerCase()===v);return u?c[u]:c[S]}e.getCaseInsensitive=m;function h(c,S){const v=Object.create(null);for(const[u,g]of Object.entries(c))S(u,g)&&(v[u]=g);return v}e.filter=h;function P(c){let S=[];for(;Object.prototype!==c;)S=S.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return S}e.getAllPropertyNames=P;function I(c){const S=[];for(const v of P(c))typeof c[v]=="function"&&S.push(v);return S}e.getAllMethodNames=I;function p(c,S){const v=g=>function(){const i=Array.prototype.slice.call(arguments,0);return S(g,i)},u={};for(const g of c)u[g]=v(g);return u}e.createProxyObject=p}),define(ie[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return N.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let f=0;f<b.length;f++)b[f]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,a="";return a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a+="-",a+=T[A[f++]],a+=T[A[f++]],a+="-",a+=T[A[f++]],a+=T[A[f++]],a+="-",a+=T[A[f++]],a+=T[A[f++]],a+="-",a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a+=T[A[f++]],a}}()}),define(ie[76],ne([0,1,33]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const b=T.replace(/\-/g,":").toLowerCase();return!O.has(b)}function A(){const T=(0,N.networkInterfaces)();for(const b in T){const f=T[b];if(f){for(const{mac:a}of f)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ie[77],ne([8,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,A=k*24,T=A*7,b=A*30,f=A*365;function a(w,m,h,P){typeof w!="number"&&(w=w.getTime());const I=Math.round((new Date().getTime()-w)/1e3);if(I<-30)return(0,N.localize)(0,null,a(new Date().getTime()+I*1e3,!1));if(!P&&I<30)return(0,N.localize)(1,null);let p;return I<O?(p=I,m?p===1?h?(0,N.localize)(2,null,p):(0,N.localize)(3,null,p):h?(0,N.localize)(4,null,p):(0,N.localize)(5,null,p):p===1?h?(0,N.localize)(6,null,p):(0,N.localize)(7,null,p):h?(0,N.localize)(8,null,p):(0,N.localize)(9,null,p)):I<k?(p=Math.floor(I/O),m?p===1?h?(0,N.localize)(10,null,p):(0,N.localize)(11,null,p):h?(0,N.localize)(12,null,p):(0,N.localize)(13,null,p):p===1?h?(0,N.localize)(14,null,p):(0,N.localize)(15,null,p):h?(0,N.localize)(16,null,p):(0,N.localize)(17,null,p)):I<A?(p=Math.floor(I/k),m?p===1?h?(0,N.localize)(18,null,p):(0,N.localize)(19,null,p):h?(0,N.localize)(20,null,p):(0,N.localize)(21,null,p):p===1?h?(0,N.localize)(22,null,p):(0,N.localize)(23,null,p):h?(0,N.localize)(24,null,p):(0,N.localize)(25,null,p)):I<T?(p=Math.floor(I/A),m?p===1?(0,N.localize)(26,null,p):(0,N.localize)(27,null,p):p===1?(0,N.localize)(28,null,p):(0,N.localize)(29,null,p)):I<b?(p=Math.floor(I/T),m?p===1?h?(0,N.localize)(30,null,p):(0,N.localize)(31,null,p):h?(0,N.localize)(32,null,p):(0,N.localize)(33,null,p):p===1?h?(0,N.localize)(34,null,p):(0,N.localize)(35,null,p):h?(0,N.localize)(36,null,p):(0,N.localize)(37,null,p)):I<f?(p=Math.floor(I/b),m?p===1?h?(0,N.localize)(38,null,p):(0,N.localize)(39,null,p):h?(0,N.localize)(40,null,p):(0,N.localize)(41,null,p):p===1?h?(0,N.localize)(42,null,p):(0,N.localize)(43,null,p):h?(0,N.localize)(44,null,p):(0,N.localize)(45,null,p)):(p=Math.floor(I/f),m?p===1?h?(0,N.localize)(46,null,p):(0,N.localize)(47,null,p):h?(0,N.localize)(48,null,p):(0,N.localize)(49,null,p):p===1?h?(0,N.localize)(50,null,p):(0,N.localize)(51,null,p):h?(0,N.localize)(52,null,p):(0,N.localize)(53,null,p))}e.fromNow=a;function E(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ie[79],ne([8,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(w,m){return m&&(w.stack||w.stacktrace)?k.localize(0,null,b(w),T(w.stack)||T(w.stacktrace)):b(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function b(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,m=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const h=N.coalesce(w),P=f(h[0],m);return h.length>1?k.localize(4,null,P,h.length):P}if(O.isString(w))return w;if(w.detail){const h=w.detail;if(h.error)return A(h.error,m);if(h.exception)return A(h.exception,m)}return w.stack?A(w,m):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f;function a(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=a;function E(w,m){let h;return typeof w=="string"?h=new Error(w):h=w,h.actions=m,h}e.createErrorWithActions=E}),define(ie[80],ne([8,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ie[55],ne([0,1,12]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(b,...f){const a=f.reduce((m,h)=>(m[h]=!0,m),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!a[m]).forEach(m=>{for(let h=0;h<E.length;h++)if(m.search(E[h])!==-1){delete b[m];break}})}e.sanitizeProcessEnvironment=A;function T(b){b&&(delete b.DEBUG,N.isMacintosh&&delete b.DYLD_LIBRARY_PATH,N.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ie[82],ne([0,1,11]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(a){const E=a;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=O;function k(a){const E=[];let w;try{const m=JSON.parse(a.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),w=h.__$stack),E.push(...m)}catch{E.push("Unable to log remote console arguments",a.arguments)}return{args:E,stack:w}}e.parse=k;function A(a){if(typeof a!="string")return A(k(a).stack);const E=a;if(E){const w=T(E),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:N.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=A;function T(a){if(!a)return a;const E=a.indexOf(`
`);return E===-1?a:a.substring(0,E)}function b(a,E){const{args:w,stack:m}=k(a),h=typeof w[0]=="string"&&w.length===1;let P=T(m);P&&(P=`(${P.trim()})`);let I=[];if(typeof w[0]=="string"?P&&h?I=[`%c[${E}] %c${w[0]} %c${P}`,f("blue"),f(""),f("grey")]:I=[`%c[${E}] %c${w[0]}`,f("blue"),f(""),...w.slice(1)]:I=[`%c[${E}]%`,f("blue"),...w],P&&!h&&I.push(P),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}e.log=b;function f(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(f){return JSON.stringify(f,T)}e.stringify=k;function A(f){let a=JSON.parse(f);return a=b(a),a}e.parse=A;function T(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function b(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return O.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof N.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let E=0;E<f.length;++E)f[E]=b(f[E],a+1);else for(const E in f)Object.hasOwnProperty.call(f,E)&&(f[E]=b(f[E],a+1))}return f}e.revive=b}),define(ie[83],ne([0,1,70,15,12,11]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(m,h,P){this.id=m,this.dependencies=h,this.callback=P}}class b{static{this.INSTANCE=new b}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(m,h,P)=>{typeof m!="string"&&(P=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&(P=h,h=null),this._defineCalls.push(new T(m,h,P))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(m):this._isRenderer?this._rendererLoadScript(m):this._nodeJSLoadScript(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(m){return new Promise((h,P)=>{const I=document.createElement("script");I.setAttribute("async","async"),I.setAttribute("type","text/javascript");const p=()=>{I.removeEventListener("load",c),I.removeEventListener("error",S)},c=v=>{p(),h(this._defineCalls.pop())},S=v=>{p(),P(v)};I.addEventListener("load",c),I.addEventListener("error",S),this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),I.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(I)})}_workerLoadScript(m){return new Promise((h,P)=>{try{this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),importScripts(m),h(this._defineCalls.pop())}catch(I){P(I)}})}async _nodeJSLoadScript(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,P=globalThis._VSCODE_NODE_MODULES.vm,I=globalThis._VSCODE_NODE_MODULES.module,p=A.URI.parse(m).fsPath,c=h.readFileSync(p).toString(),S=I.wrap(c.replace(/^#!.*/,""));return new P.Script(S).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const f=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function E(w,m,h){if(N.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[w]&&(w=a[w]);const P=`${w}/${m}`;if(f.has(P))return f.get(P);let I;if(/^\w[\w\d+.-]*:\/\//.test(P))I=P;else{const v=`${h&&!k.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${P}`;I=O.FileAccess.asBrowserUri(v).toString(!0)}const p=b.INSTANCE.load(I);return f.set(P,p),p}else return await new Promise((P,I)=>{G([w],P,I)})}e.importAMDNodeModule=E}),define(ie[84],ne([0,1,33,48,28,76,12]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,h=0;const P=(0,N.networkInterfaces)();for(const I in P){const p=P[I];if(p)for(const{mac:c,internal:S}of p)S||(h+=1,this._isVirtualMachineMacAddress(c.toUpperCase())&&(m+=1))}this._value=h>0?m/h:0}return this._value}};let b;async function f(m){return b||(b=(async()=>await a(m)||k.generateUuid())()),b}e.getMachineId=f;async function a(m){try{const h=await new Promise((I,p)=>{G(["crypto"],I,p)}),P=(0,A.getMac)();return h.createHash("sha256").update(P,"utf8").digest("hex")}catch(h){m(h);return}}const E="Software\\Microsoft\\SQMClient";async function w(m){if(T.isWindows){const h=await new Promise((P,I)=>{G(["@vscode/windows-registry"],P,I)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(P){return m(P),""}}return""}e.getSqmMachineId=w}),define(ie[85],ne([0,1,33,16,24]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var f;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class w{constructor(g,i,s){this.exePath=g,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:u=!1}={}){return u?a===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:u=!1,findPreview:g=!1}={}){const i=m({useAlternateBitness:u});if(!i)return null;const s=O.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(s)){let D=-1;if(g){const y=l.indexOf("-");if(y<0)continue;const L=l.substring(0,y);if(!A.test(L)||l.substring(y+1)!=="preview")continue;D=parseInt(L,10)}else{if(!A.test(l))continue;D=parseInt(l,10)}if(D<=t)continue;const R=O.join(s,l,"pwsh.exe");await k.SymlinkSupport.existsFile(R)&&(n=R,t=D)}if(!n)return null;const r=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new w(n,`PowerShell${o}${r}`,!0)}async function P({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const g=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=u?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(g))if(i.test(t)){const n=O.join(g,t,"pwsh.exe");return new w(n,s)}return null}function I(){const u=O.join(N.homedir(),".dotnet","tools","pwsh.exe");return new w(u,".NET Core PowerShell Global Tool")}function p(){const u=O.join(process.env.windir,a===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(u,"Windows PowerShell",!0)}async function*c(){let u=await h();u&&(yield u),u=await h({useAlternateBitness:!0}),u&&(yield u),u=await P(),u&&(yield u),u=I(),u&&(yield u),u=await h({findPreview:!0}),u&&(yield u),u=await P({findPreview:!0}),u&&(yield u),u=await h({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=p(),u&&(yield u)}async function*S(){for await(const u of c())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=S;async function v(){for await(const u of S())return u;return null}e.getFirstAvailablePowerShellInstallation=v}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(G,e,N,O,k,A,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=f;function a(w){let m=[],h=!1;const P=function(I){if(h){m.push(I);return}(!w.send(I,c=>{if(c&&console.error(c),h=!1,m.length>0){const S=m.slice(0);m=[],S.forEach(v=>P(v))}})||O.isWindows)&&(h=!0)};return{send:P}}e.createQueuedSender=a;var E;(function(w){async function m(h,P,I){if(N.isAbsolute(h))return h;if(P===void 0&&(P=k.cwd()),N.dirname(h)!=="."||(I===void 0&&T.isString(k.env.PATH)&&(I=k.env.PATH.split(N.delimiter)),I===void 0||I.length===0))return N.join(P,h);async function c(S){if(await b.Promises.exists(S)){let v;try{v=await b.Promises.stat(S)}catch(u){u.message.startsWith("EACCES")&&(v=await b.Promises.lstat(S))}return v?!v.isDirectory():!1}return!1}for(const S of I){let v;if(N.isAbsolute(S)?v=N.join(S,h):v=N.join(P,S,h),await c(v))return v;let u=v+".com";if(await c(u)||(u=v+".exe",await c(u)))return u}return N.join(P,h)}w.findExecutable=m})(E||(e.win32=E={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(w,m){return w===1?O.isWindows?E():A.getWindowsShell(m):f(w,m)}e.getSystemShell=T;let b=null;function f(w,m){if(O.isLinux&&w===2||O.isMacintosh&&w===3)return"/bin/bash";if(!b){let h;if(O.isWindows)h="/bin/bash";else{if(h=m.SHELL,!h)try{h=(0,N.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}b=h}return b}let a=null;async function E(){return a||(a=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),a}});var me=this&&this.__decorate||function(G,e,N,O){var k=arguments.length,A=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,N):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,N,O);else for(var b=G.length-1;b>=0;b--)(T=G[b])&&(A=(k<3?T(A):k>3?T(e,N,A):T(e,N))||A);return k>3&&A&&Object.defineProperty(e,N,A),A};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(G,e,N,O,k,A,T,b,f,a,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(h||(h={}));function P(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(I||(I={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(c||(c={}));function S(V){let _=0;for(let j=0;;j+=7){const K=V.read(1);if(_|=(K.buffer[0]&127)<<j,!(K.buffer[0]&128))return _}}const v=t(0);function u(V,_){if(_===0){V.write(v);return}let j=0;for(let X=_;X!==0;X=X>>>7)j++;const K=k.VSBuffer.alloc(j);for(let X=0;_!==0;X++)K.buffer[X]=_&127,_=_>>>7,_>0&&(K.buffer[X]|=128);V.write(K)}class g{constructor(_){this.buffer=_,this.pos=0}read(_){const j=this.buffer.slice(this.pos,this.pos+_);return this.pos+=j.byteLength,j}}e.BufferReader=g;class i{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}e.BufferWriter=i;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function t(V){const _=k.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const n={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function o(V,_){if(typeof _>"u")V.write(n.Undefined);else if(typeof _=="string"){const j=k.VSBuffer.fromString(_);V.write(n.String),u(V,j.byteLength),V.write(j)}else if(r&&Buffer.isBuffer(_)){const j=k.VSBuffer.wrap(_);V.write(n.Buffer),u(V,j.byteLength),V.write(j)}else if(_ instanceof k.VSBuffer)V.write(n.VSBuffer),u(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(n.Array),u(V,_.length);for(const j of _)o(V,j)}else if(typeof _=="number"&&(_|0)===_)V.write(n.Uint),u(V,_);else{const j=k.VSBuffer.fromString(JSON.stringify(_));V.write(n.Object),u(V,j.byteLength),V.write(j)}}e.serialize=o;function l(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(S(V)).toString();case s.Buffer:return V.read(S(V)).buffer;case s.VSBuffer:return V.read(S(V));case s.Array:{const j=S(V),K=[];for(let X=0;X<j;X++)K.push(l(V));return K}case s.Object:return JSON.parse(V.read(S(V)).toString());case s.Int:return S(V)}}e.deserialize=l;class D{constructor(_,j,K=null,X=1e3){this.protocol=_,this.ctx=j,this.logger=K,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(_,j){this.channels.set(_,j),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const j=this.send([_.type]);this.logger?.logOutgoing(j,0,1,p(_.type));return}case 201:case 202:case 204:case 203:{const j=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(j,_.id,1,p(_.type),_.data);return}}}send(_,j=void 0){const K=new i;return o(K,_),o(K,j),this.sendBuffer(K.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const j=new g(_),K=l(j),X=l(j),J=K[0];switch(J){case 100:return this.logger?.logIncoming(_.byteLength,K[1],1,`${P(J)}: ${K[2]}.${K[3]}`,X),this.onPromise({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 102:return this.logger?.logIncoming(_.byteLength,K[1],1,`${P(J)}: ${K[2]}.${K[3]}`,X),this.onEventListen({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 101:return this.logger?.logIncoming(_.byteLength,K[1],1,`${P(J)}`),this.disposeActiveRequest({type:J,id:K[1]});case 103:return this.logger?.logIncoming(_.byteLength,K[1],1,`${P(J)}`),this.disposeActiveRequest({type:J,id:K[1]})}}onPromise(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const K=new A.CancellationTokenSource;let X;try{X=j.call(this.ctx,_.name,_.arg,K.token)}catch(F){X=Promise.reject(F)}const J=_.id;X.then(F=>{this.sendResponse({id:J,data:F,type:201})},F=>{F instanceof Error?this.sendResponse({id:J,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:J,data:F,type:203})}).finally(()=>{M.dispose(),this.activeRequests.delete(_.id)});const M=(0,a.toDisposable)(()=>K.cancel());this.activeRequests.set(_.id,M)}onEventListen(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const K=_.id,J=j.listen(this.ctx,_.name,_.arg)(M=>this.sendResponse({id:K,data:M,type:204}));this.activeRequests.set(_.id,J)}disposeActiveRequest(_){const j=this.activeRequests.get(_.id);j&&(j.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let j=this.pendingRequests.get(_.channelName);j||(j=[],this.pendingRequests.set(_.channelName,j));const K=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:_,timeoutTimer:K})}flushPendingRequests(_){const j=this.pendingRequests.get(_);if(j){for(const K of j)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var R;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class y{constructor(_,j=null){this.protocol=_,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=j}getChannel(_){const j=this;return{call(K,X,J){return j.isDisposed?Promise.reject(new b.CancellationError):j.requestPromise(_,K,X,J)},listen(K,X){return j.isDisposed?f.Event.None:j.requestEvent(_,K,X)}}}requestPromise(_,j,K,X=A.CancellationToken.None){const J=this.lastRequestId++,F={id:J,type:100,channelName:_,name:j,arg:K};if(X.isCancellationRequested)return Promise.reject(new b.CancellationError);let d;return new Promise((x,U)=>{if(X.isCancellationRequested)return U(new b.CancellationError);const q=()=>{const he=pe=>{switch(pe.type){case 201:this.handlers.delete(J),x(pe.data);break;case 202:{this.handlers.delete(J);const Se=new Error(pe.data.message);Se.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,Se.name=pe.data.name,U(Se);break}case 203:this.handlers.delete(J),U(pe.data);break}};this.handlers.set(J,he),this.sendRequest(F)};let B=null;this.state===c.Idle?q():(B=(0,O.createCancelablePromise)(he=>this.whenInitialized()),B.then(()=>{B=null,q()}));const ee=()=>{B?(B.cancel(),B=null):this.sendRequest({id:J,type:101}),U(new b.CancellationError)},ue=X.onCancellationRequested(ee);d=(0,a.combinedDisposable)((0,a.toDisposable)(ee),ue),this.activeRequests.add(d)}).finally(()=>{d.dispose(),this.activeRequests.delete(d)})}requestEvent(_,j,K){const X=this.lastRequestId++,M={id:X,type:102,channelName:_,name:j,arg:K};let F=null;const d=new f.Emitter({onWillAddFirstListener:()=>{F=(0,O.createCancelablePromise)(x=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(d),this.sendRequest(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(d),this.sendRequest({id:X,type:103}))}}),C=x=>d.fire(x.data);return this.handlers.set(X,C),d.event}sendRequest(_){switch(_.type){case 100:case 102:{const j=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(j,_.id,0,`${P(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const j=this.send([_.type,_.id]);this.logger?.logOutgoing(j,_.id,0,P(_.type));return}}}send(_,j=void 0){const K=new i;return o(K,_),o(K,j),this.sendBuffer(K.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const j=new g(_),K=l(j),X=l(j),J=K[0];switch(J){case 200:return this.logger?.logIncoming(_.byteLength,0,0,p(J)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,K[1],0,p(J),X),this.onResponse({type:K[0],id:K[1],data:X})}}onResponse(_){if(_.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=y,me([T.memoize],y.prototype,"onDidInitializePromise",null);class L{get connections(){const _=[];return this._connections.forEach(j=>_.push(j)),_}constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(_(({protocol:j,onDidClientDisconnect:K})=>{const X=f.Event.once(j.onMessage);this.disposables.add(X(J=>{const M=new g(J),F=l(M),d=new D(j,F),C=new y(j);this.channels.forEach((U,q)=>d.registerChannel(q,U));const x={channelServer:d,channelClient:C,ctx:F};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(K(()=>{d.dispose(),C.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(_,j){const K=this;return{call(X,J,M){let F;if((0,m.isFunction)(j)){const C=(0,N.getRandomElement)(K.connections.filter(j));F=C?Promise.resolve(C):f.Event.toPromise(f.Event.filter(K.onDidAddConnection,j))}else F=j.routeCall(K,X,J);const d=F.then(C=>C.channelClient.getChannel(_));return te(d).call(X,J,M)},listen(X,J){if((0,m.isFunction)(j))return K.getMulticastEvent(_,j,X,J);const M=j.routeEvent(K,X,J).then(F=>F.channelClient.getChannel(_));return te(M).listen(X,J)}}}getMulticastEvent(_,j,K,X){const J=this;let M;const F=new f.Emitter({onWillAddFirstListener:()=>{M=new a.DisposableStore;const d=new f.EventMultiplexer,C=new Map,x=q=>{const ee=q.channelClient.getChannel(_).listen(K,X),ue=d.add(ee);C.set(q,ue)},U=q=>{const B=C.get(q);B&&(B.dispose(),C.delete(q))};J.connections.filter(j).forEach(x),f.Event.filter(J.onDidAddConnection,j)(x,void 0,M),J.onDidRemoveConnection(U,void 0,M),d.event(F.fire,F,M),M.add(d)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(_,j){this.channels.set(_,j);for(const K of this._connections)K.channelServer.registerChannel(_,j)}dispose(){this.disposables.dispose();for(const _ of this._connections)_.channelClient.dispose(),_.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class ${constructor(_,j,K=null){const X=new i;o(X,j),_.send(X.buffer),this.channelClient=new y(_,K),this.channelServer=new D(_,j,K)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,j){this.channelServer.registerChannel(_,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function te(V){return{call(_,j,K){return V.then(X=>X.call(_,j,K))},listen(_,j){const K=new f.Relay;return V.then(X=>K.input=X.listen(_,j)),K.event}}}e.getDelayedChannel=te;function Z(V){let _=!1;return{call(j,K,X){return _?V.call(j,K,X):(0,O.timeout)(0).then(()=>_=!0).then(()=>V.call(j,K,X))},listen(j,K){if(_)return V.listen(j,K);const X=new f.Relay;return(0,O.timeout)(0).then(()=>_=!0).then(()=>X.input=V.listen(j,K)),X.event}}}e.getNextTickChannel=Z;class oe{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const j of _.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=oe;var se;(function(V){function _(J,M,F){const d=J,C=F&&F.disableMarshalling,x=new Map;for(const U in d)K(U)&&x.set(U,f.Event.buffer(d[U],!0,void 0,M));return new class{listen(U,q,B){const ee=x.get(q);if(ee)return ee;if(X(q)){const ue=d[q];if(typeof ue=="function")return ue.call(d,B)}throw new b.ErrorNoTelemetry(`Event not found: ${q}`)}call(U,q,B){const ee=d[q];if(typeof ee=="function"){if(!C&&Array.isArray(B))for(let he=0;he<B.length;he++)B[he]=(0,E.revive)(B[he]);let ue=ee.apply(d,B);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new b.ErrorNoTelemetry(`Method not found: ${q}`)}}}V.fromService=_;function j(J,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(d,C){if(typeof C=="string")return M?.properties?.has(C)?M.properties.get(C):X(C)?function(x){return J.listen(C,x)}:K(C)?J.listen(C):async function(...x){let U;M&&!(0,m.isUndefinedOrNull)(M.context)?U=[M.context,...x]:U=x;const q=await J.call(C,U);return F?q:(0,E.revive)(q)};throw new b.ErrorNoTelemetry(`Property not found: ${String(C)}`)}})}V.toService=j;function K(J){return J[0]==="o"&&J[1]==="n"&&w.isUpperAsciiLetter(J.charCodeAt(2))}function X(J){return/^onDynamic/.test(J)&&w.isUpperAsciiLetter(J.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function ae(V){return Array.isArray(V)?V.map(le):le(V)}function W(V,_,j,K,X,J,M){M=ae(M);const F=fe[X],d=F[K%F.length];let C=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(J)?(C=C.concat(M),C.push(")")):C.push(M),console.log.apply(console,C)}class H{constructor(_,j){this._outgoingPrefix=_,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,j,K,X,J){this._totalOutgoing+=_,W(this._outgoingPrefix,this._totalOutgoing,_,j,K,X,J)}logIncoming(_,j,K,X,J){this._totalIncoming+=_,W(this._incomingPrefix,this._totalIncoming,_,j,K,X,J)}}e.IPCLogger=H}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class P extends h.ChannelServer{constructor(c){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=P;class I{constructor(c,S){this.modulePath=c,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new O.Delayer(v),this.child=null,this._client=null}getChannel(c){const S=this;return{call(v,u,g){return S.requestPromise(c,v,u,g)},listen(v,u){return S.requestEvent(c,v,u)}}}requestPromise(c,S,v,u=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const g=this.getCachedChannel(c),i=(0,O.createCancelablePromise)(n=>g.call(S,v,n)),s=u.onCancellationRequested(()=>i.cancel()),t=(0,a.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(c,S,v){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let u;const g=new f.Emitter({onWillAddFirstListener:()=>{u=this.getCachedChannel(c).listen(S,v)(g.fire,g),this.activeRequests.add(u)},onDidRemoveLastListener:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return g.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(S.env),this.child=(0,N.fork)(this.modulePath,c,S);const v=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}v.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const g=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&g.send(r.buffer.toString("base64")),s=v.event,t={send:i,onMessage:s};this._client=new h.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,a.dispose)(l)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(c){let S=this.channels.get(c);return S||(S=this.client.getChannel(c),this.channels.set(c,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(ie[88],ne([0,1,9,6,2,47,3]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function f(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class E extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,P=Object.create(null)){super(),this.database=h,this.options=P,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new N.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((P,I)=>this.acceptExternal(I,P)),h.deleted?.forEach(P=>this.acceptExternal(P,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,P){if(this.state===a.Closed)return;let I=!1;(0,T.isUndefinedOrNull)(P)?I=this.cache.delete(h):this.cache.get(h)!==P&&(this.cache.set(h,P),I=!0),I&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,P){const I=this.cache.get(h);return(0,T.isUndefinedOrNull)(I)?P:I}getBoolean(h,P){const I=this.get(h);return(0,T.isUndefinedOrNull)(I)?P:I==="true"}getNumber(h,P){const I=this.get(h);return(0,T.isUndefinedOrNull)(I)?P:parseInt(I,10)}getObject(h,P){const I=this.get(h);return(0,T.isUndefinedOrNull)(I)?P:(0,A.parse)(I)}async set(h,P,I=!1){if(this.state===a.Closed)return;if((0,T.isUndefinedOrNull)(P))return this.delete(h,I);const p=(0,T.isObject)(P)||Array.isArray(P)?(0,A.stringify)(P):String(P);if(this.cache.get(h)!==p)return this.cache.set(h,p),this.pendingInserts.set(h,p),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:I}),this.doFlush()}async delete(h,P=!1){if(!(this.state===a.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:P}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===b.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===b.STORAGE_IN_MEMORY}}e.Storage=E;class w{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((P,I)=>this.items.set(I,P)),h.delete?.forEach(P=>this.items.delete(P))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(ie[89],ne([8,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(G,e,N,O,k,A,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const f=new RegExp(e.CorruptZipMessage);class a extends Error{constructor(g,i){let s=i.message;switch(g){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=g,this.cause=i}}e.ExtractError=a;function E(u){const g=u.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,s)=>i+s,g&61440)}function w(u){if(u instanceof a)return u;let g;return f.test(u.message)&&(g="CorruptZip"),new a(g,u)}function m(u,g,i,s,t,n){const r=k.dirname(g),o=k.join(s,r);if(!o.startsWith(s))return Promise.reject(new Error(b.localize(0,null,g)));const l=k.join(s,g);let D;return n.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,y)=>{if(!n.isCancellationRequested)try{D=(0,N.createWriteStream)(l,{mode:i}),D.once("close",()=>R()),D.once("error",y),u.once("error",y),u.pipe(D)}catch(L){y(L)}}))}function h(u,g,i,s){let t=(0,O.createCancelablePromise)(()=>Promise.resolve()),n=0;const r=s.onCancellationRequested(()=>{t.cancel(),u.close()});return new Promise((o,l)=>{const D=new O.Sequencer,R=y=>{y.isCancellationRequested||(n++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{s.isCancellationRequested||u.entryCount===n?o():l(new a("Incomplete",new Error(b.localize(1,null,n,u.entryCount))))},l)),u.readEntry(),u.on("entry",y=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(y.fileName)){R(s);return}const L=y.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(L)){const Z=k.join(g,L);t=(0,O.createCancelablePromise)(oe=>T.Promises.mkdir(Z,{recursive:!0}).then(()=>R(oe)).then(void 0,l));return}const $=I(u,y),te=E(y);t=(0,O.createCancelablePromise)(Z=>D.queue(()=>$.then(oe=>m(oe,L,te,g,i,Z).then(()=>R(Z)))).then(null,l))})}).finally(()=>r.dispose())}async function P(u,g=!1){const{open:i}=await new Promise((s,t)=>{G(["yauzl"],s,t)});return new Promise((s,t)=>{i(u,g?{lazyEntries:!0}:void 0,(n,r)=>{n?t(w(n)):s((0,A.assertIsDefined)(r))})})}function I(u,g){return new Promise((i,s)=>{u.openReadStream(g,(t,n)=>{t?s(w(t)):i((0,A.assertIsDefined)(n))})})}async function p(u,g){const{ZipFile:i}=await new Promise((s,t)=>{G(["yazl"],s,t)});return new Promise((s,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,N.createWriteStream)(u);n.outputStream.pipe(r),n.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(u))})}e.zip=p;function c(u,g,i={},s){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=P(u,!0);return i.overwrite&&(n=n.then(r=>T.Promises.rm(g).then(()=>r))),n.then(r=>h(r,g,{sourcePathRegex:t},s))}e.extract=c;function S(u,g){return P(u).then(i=>new Promise((s,t)=>{i.on("entry",n=>{n.fileName===g&&I(i,n).then(r=>s(r),r=>t(r))}),i.once("close",()=>t(new Error(b.localize(2,null,g))))}))}function v(u,g){return S(u,g).then(i=>new Promise((s,t)=>{const n=[];i.once("error",t),i.on("data",r=>n.push(r)),i.on("end",()=>s(Buffer.concat(n)))}))}e.buffer=v}),define(ie[91],ne([8,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,O.localize)(0,null,a[0]);case 2:return(0,O.localize)(1,null,a[0],a[1]);case 3:return(0,O.localize)(2,null,a[0],a[1],a[2]);default:return}}const T=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(E){return this._input=E,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(E){return this._isAtEnd()||this._input.charCodeAt(this._current)!==E?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(E){this._tokens.push({type:E,offset:this._start})}_error(E){const w=this._start,m=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:m};this._errors.push({offset:w,lexeme:m,additionalInfo:E}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const E=this.stringRe.exec(this._input);if(E){this._current=this._start+E[0].length;const w=this._input.substring(this._start,this._current),m=f._keywords.get(w);m?this._addToken(m):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let E=this._current,w=!1,m=!1;for(;;){if(E>=this._input.length){this._current=E,this._error(b);return}const P=this._input.charCodeAt(E);if(w)w=!1;else if(P===47&&!m){E++;break}else P===91?m=!0:P===92?w=!0:P===93&&(m=!1);E++}for(;E<this._input.length&&f._regexFlags.has(this._input.charCodeAt(E));)E++;this._current=E;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?f.URI.file((0,A.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,A.resolve)(h)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const P=T.env.VSCODE_EXTENSIONS;if(P)return P;const I=T.env.VSCODE_PORTABLE;return I?(0,A.join)(I,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(P=>/^[^:/?#]+?:\/\//.test(P)?f.URI.parse(P):f.URI.file((0,A.normalize)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const P of this.args.log||[]){const I=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(P);I&&I[1]&&I[2]&&h.push([I[1],I[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?f.URI.file((0,A.join)(h,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,P,I){this._args=h,this.paths=P,this.productService=I,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,me([O.memoize],a.prototype,"appRoot",null),me([O.memoize],a.prototype,"userHome",null),me([O.memoize],a.prototype,"userDataPath",null),me([O.memoize],a.prototype,"appSettingsHome",null),me([O.memoize],a.prototype,"tmpDir",null),me([O.memoize],a.prototype,"cacheHome",null),me([O.memoize],a.prototype,"stateResource",null),me([O.memoize],a.prototype,"userRoamingDataHome",null),me([O.memoize],a.prototype,"userDataSyncHome",null),me([O.memoize],a.prototype,"sync",null),me([O.memoize],a.prototype,"machineSettingsResource",null),me([O.memoize],a.prototype,"workspaceStorageHome",null),me([O.memoize],a.prototype,"localHistoryHome",null),me([O.memoize],a.prototype,"keyboardLayoutResource",null),me([O.memoize],a.prototype,"argvResource",null),me([O.memoize],a.prototype,"isExtensionDevelopment",null),me([O.memoize],a.prototype,"untitledWorkspacesHome",null),me([O.memoize],a.prototype,"builtinExtensionsPath",null),me([O.memoize],a.prototype,"extensionsPath",null),me([O.memoize],a.prototype,"extensionDevelopmentLocationURI",null),me([O.memoize],a.prototype,"extensionDevelopmentKind",null),me([O.memoize],a.prototype,"extensionTestsLocationURI",null),me([O.memoize],a.prototype,"debugExtensionHost",null),me([O.memoize],a.prototype,"logLevel",null),me([O.memoize],a.prototype,"extensionLogLevel",null),me([O.memoize],a.prototype,"serviceMachineIdResource",null),me([O.memoize],a.prototype,"disableTelemetry",null),me([O.memoize],a.prototype,"disableWorkspaceTrust",null),me([O.memoize],a.prototype,"useInMemorySecretStorage",null),me([O.memoize],a.prototype,"policyFile",null);function E(m,h){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=E;function w(m,h,P,I,p,c){const v=Number(h||m)||(I?null:P),u=v?!!h:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:v,break:u,debugId:p,env:g}}e.parseDebugParams=w}),function(){"use strict";function G(e,N,O){function k(T,b){const f=A(T,b),a=[f];return e.isAbsolute(f)||a.unshift(O),e.resolve(...a)}function A(T,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,b);const E=T["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,b)}return{getUserDataPath:k}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,N,O){return G(e,N,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=G(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(a,E){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,E.nameShort)},E)}}e.NativeEnvironmentService=A;function T(f,a){return(0,O.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.parsePtyHostDebugPort=T;function b(f,a){return(0,O.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.parseSharedProcessDebugPort=b}),define(ie[115],ne([0,1,3,97]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,b,f,a){try{A(T,b,f,a)}catch(E){T.error(E?.message??E)}return b}e.localizeManifest=k;function A(T,b,f,a){const E=(w,m,h)=>{const P=w[m];if((0,N.isString)(P)){const I=P,p=I.length;if(p>1&&I[0]==="%"&&I[p-1]==="%"){const c=I.substr(1,p-2);let S=f[c];S===void 0&&a&&(S=a[c]);const v=typeof S=="string"?S:S?.message,u=a?.[c],g=typeof u=="string"?u:u?.message;if(!v){g||T.warn(`[${b.name}]: ${(0,O.localize)(0,null,c)}`);return}if(h&&(m==="title"||m==="category")&&g&&g!==v){const i={value:v,original:g};w[m]=i}else w[m]=v}}else if((0,N.isObject)(P))for(const I in P)P.hasOwnProperty(I)&&(I==="commands"?E(P,I,!0):E(P,I,h));else if(Array.isArray(P))for(let I=0;I<P.length;I++)E(P,I,h)};for(const w in b)b.hasOwnProperty(w)&&E(b,w)}}),define(ie[116],ne([0,1,49,100]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,N.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(ie[50],ne([0,1,17,54,101,44]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function f(c){return c=c.trim(),c==="*"||T.test(c)}e.isValidVersionStr=f;function a(c){if(!f(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=c.match(T);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=a;function E(c){if(!c)return null;const S=c.majorBase,v=c.majorMustEqual,u=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let s=c.patchMustEqual;c.hasCaret&&(S===0||(g=!1),s=!1);let t=0;if(c.preRelease){const n=b.exec(c.preRelease);if(n){const[,r,o,l]=n;t=Date.UTC(Number(r),Number(o)-1,Number(l))}}return{majorBase:S,majorMustEqual:v,minorBase:u,minorMustEqual:g,patchBase:i,patchMustEqual:s,isMinimum:c.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function w(c,S,v){let u;typeof c=="string"?u=E(a(c)):u=c;let g;S instanceof Date?g=S.getTime():typeof S=="string"&&(g=new Date(S).getTime());let i;if(typeof v=="string"?i=E(a(v)):i=v,!u||!i)return!1;const s=u.majorBase,t=u.minorBase,n=u.patchBase;let r=i.majorBase,o=i.minorBase,l=i.patchBase;const D=i.notBefore;let R=i.majorMustEqual,y=i.minorMustEqual,L=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:t>o?!0:t<o||g&&g<D?!1:n>=l:(s===1&&r===0&&(!R||!y||!L)&&(r=1,o=0,l=0,R=!0,y=!1,L=!1),s<r?!1:s>r?!R:t<o?!1:t>o?!y:n<l?!1:n>l?!L:!(g&&g<D))}e.isValidVersion=w;function m(c,S,v,u,g){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([O.default.Error,k.localize(0,null)]),i;if(typeof u.name!="string")return i.push([O.default.Error,k.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([O.default.Error,k.localize(2,null,"version")]),i;if(!u.engines)return i.push([O.default.Error,k.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([O.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!p(u.extensionDependencies))return i.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!p(u.activationEvents))return i.push([O.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([O.default.Error,k.localize(9,null,"main")]),i;{const n=(0,N.joinPath)(v,u.main);(0,N.isEqualOrParent)(n,v)||i.push([O.default.Warning,k.localize(10,null,n.path,v.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([O.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,N.joinPath)(v,u.browser);(0,N.isEqualOrParent)(n,v)||i.push([O.default.Warning,k.localize(12,null,n.path,v.path)])}}if(!A.valid(u.version))return i.push([O.default.Error,k.localize(13,null)]),i;const s=[];if(!h(c,S,u,g,s))for(const n of s)i.push([O.default.Error,n]);return i}e.validateExtensionManifest=m;function h(c,S,v,u,g){return u||typeof v.main>"u"&&typeof v.browser>"u"?!0:I(c,S,v.engines.vscode,g)}e.isValidExtensionVersion=h;function P(c,S,v){return c==="*"||I(S,v,c)}e.isEngineValid=P;function I(c,S,v,u=[]){const g=E(a(v));if(!g)return u.push(k.localize(14,null,v)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(k.localize(15,null,v)),!1}else if(!g.majorMustEqual)return u.push(k.localize(16,null,v)),!1;return w(c,S,g)?!0:(u.push(k.localize(17,null,c,v)),!1)}function p(c){if(!Array.isArray(c))return!1;for(let S=0,v=c.length;S<v;S++)if(typeof c[S]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,b){let f=b&&b.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const E=(await T.readFile(A.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(E)?E:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,N.VSBuffer.fromString(f))}catch{}}return b?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=k}),define(ie[51],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(k,A=[],T=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=N}),define(ie[118],ne([0,1,51]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(b,f,a){f instanceof N.SyncDescriptor||(f=new N.SyncDescriptor(f,[],!!a)),O.push([b,f])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(ie[119],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const b=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(T);b.outgoing.set(f.key,f),f.incoming.set(b.key,b)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const b of this._nodes.values())b.outgoing.delete(T),b.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let b=this._nodes.get(T);return b||(b=new N(T,A),this._nodes.set(T,b)),b}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,b]of this._nodes)A.push(`${T}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const b=new Set([A]),f=this._findCycle(T,b);if(f)return f}}_findCycle(A,T){for(const[b,f]of A.outgoing){if(T.has(b))return[...T,b].join(" -> ");T.add(b);const a=this._findCycle(f,T);if(a)return a;T.delete(b)}}}e.Graph=O}),define(ie[29],ne([0,1,3,11,10]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function f(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.isConfigured=a;function E(c,S){const v=Object.create(null);for(const u in c)w(v,u,c[u],S);return v}e.toValuesTree=E;function w(c,S,v,u){const g=S.split("."),i=g.pop();let s=c;for(let t=0;t<g.length;t++){const n=g[t];let r=s[n];switch(typeof r){case"undefined":r=s[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${S} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[i]=v}catch{u(`Ignoring ${S} as ${g.join(".")} is ${JSON.stringify(s)}`)}else u(`Ignoring ${S} as ${g.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=w;function m(c,S){const v=S.split(".");h(c,v)}e.removeFromValueTree=m;function h(c,S){const v=S.shift();if(S.length===0){delete c[v];return}if(Object.keys(c).indexOf(v)!==-1){const u=c[v];typeof u=="object"&&!Array.isArray(u)&&(h(u,S),Object.keys(u).length===0&&delete c[v])}}function P(c,S,v){function u(s,t){let n=s;for(const r of t){if(typeof n!="object"||n===null)return;n=n[r]}return n}const g=S.split("."),i=u(c,g);return typeof i>"u"?v:i}e.getConfigurationValue=P;function I(c,S,v){Object.keys(S).forEach(u=>{u!=="__proto__"&&(u in c?N.isObject(c[u])&&N.isObject(S[u])?I(c[u],S[u],v):v&&(c[u]=S[u]):c[u]=S[u])})}e.merge=I;function p(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(G,e,N,O,k,A,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",N.isMacintosh),f.set("isLinux",N.isLinux),f.set("isWindows",N.isWindows),f.set("isWeb",N.isWeb),f.set("isMacNative",N.isMacintosh&&!N.isWeb),f.set("isEdge",N.isEdge),f.set("isFirefox",N.isFirefox),f.set("isChrome",N.isChrome),f.set("isSafari",N.isSafari);function a(F,d){if(f.get(F)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,d)}e.setConstant=a;const E=Object.prototype.hasOwnProperty;var w;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const m={regexParsingWithErrorRecovery:!0},h=(0,T.localize)(0,null),P=(0,T.localize)(1,null),I=(0,T.localize)(2,null),p=(0,T.localize)(3,null),c=(0,T.localize)(4,null),S=(0,T.localize)(5,null),v=(0,T.localize)(6,null),u=(0,T.localize)(7,null);class g{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(d=m){this._config=d,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(d){if(d===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:P});return}this._tokens=this._scanner.reset(d).scan(),this._current=0,this._parsingErrors=[];try{const C=this._expr();if(!this._isAtEnd()){const x=this._peek(),U=x.type===17?S:void 0;throw this._parsingErrors.push({message:c,offset:x.offset,lexeme:k.Scanner.getLexeme(x),additionalInfo:U}),g._parseError}return C}catch(C){if(C!==g._parseError)throw C;return}}_expr(){return this._or()}_or(){const d=[this._and()];for(;this._matchOne(16);){const C=this._and();d.push(C)}return d.length===1?d[0]:i.or(...d)}_and(){const d=[this._term()];for(;this._matchOne(15);){const C=this._term();d.push(C)}return d.length===1?d[0]:i.and(...d)}_term(){if(this._matchOne(2)){const d=this._peek();switch(d.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const C=this._expr();return this._consume(1,p),C?.negate()}case 17:return this._advance(),$.create(d.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",d)}}return this._primary()}_primary(){const d=this._peek();switch(d.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const C=this._expr();return this._consume(1,p),C}case 17:{const C=d.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const q=U.lexeme,B=q.lastIndexOf("/"),ee=B===q.length-1?void 0:this._removeFlagsGY(q.substring(B+1));let ue;try{ue=new RegExp(q.substring(1,B),ee)}catch{throw this._errExpectedButGot("REGEX",U)}return le.create(C,ue)}switch(U.type){case 10:case 19:{const q=[U.lexeme];this._advance();let B=this._peek(),ee=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let de=0;de<B.lexeme.length;de++)B.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--}if(ee<0)break;q.push(k.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const ue=q.join(""),he=ue.lastIndexOf("/"),pe=he===ue.length-1?void 0:this._removeFlagsGY(ue.substring(he+1));let Se;try{Se=new RegExp(ue.substring(1,he),pe)}catch{throw this._errExpectedButGot("REGEX",U)}return i.regex(C,Se)}case 18:{const q=U.lexeme;this._advance();let B=null;if(!(0,O.isFalsyOrWhitespace)(q)){const ee=q.indexOf("/"),ue=q.lastIndexOf("/");if(ee!==ue&&ee>=0){const he=q.slice(ee+1,ue),pe=q[ue+1]==="i"?"i":"";try{B=new RegExp(he,pe)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(B===null)throw this._errExpectedButGot("REGEX",U);return le.create(C,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,I);const U=this._value();return i.notIn(C,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return i.equals(C,U);switch(U){case"true":return i.has(C);case"false":return i.not(C);default:return i.equals(C,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return i.notEquals(C,U);switch(U){case"true":return i.not(C);case"false":return i.has(C);default:return i.notEquals(C,U)}}case 5:return this._advance(),se.create(C,this._value());case 6:return this._advance(),fe.create(C,this._value());case 7:return this._advance(),Z.create(C,this._value());case 8:return this._advance(),oe.create(C,this._value());case 13:return this._advance(),i.in(C,this._value());default:return i.has(C)}}case 20:throw this._parsingErrors.push({message:v,offset:d.offset,lexeme:"",additionalInfo:u}),g._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const d=this._peek();switch(d.type){case 17:case 18:return this._advance(),d.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(d){return d.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(d){return this._check(d)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(d,C){if(this._check(d))return this._advance();throw this._errExpectedButGot(C,this._peek())}_errExpectedButGot(d,C,x){const U=(0,T.localize)(8,null,d,k.Scanner.getLexeme(C)),q=C.offset,B=k.Scanner.getLexeme(C);return this._parsingErrors.push({message:U,offset:q,lexeme:B,additionalInfo:x}),g._parseError}_check(d){return this._peek().type===d}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=g;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(d){return l.create(d)}static equals(d,C){return D.create(d,C)}static notEquals(d,C){return L.create(d,C)}static regex(d,C){return le.create(d,C)}static in(d,C){return R.create(d,C)}static notIn(d,C){return y.create(d,C)}static not(d){return $.create(d)}static and(...d){return H.create(d,null,!0)}static or(...d){return V.create(d,null,!0)}static greater(d,C){return Z.create(d,C)}static greaterEquals(d,C){return oe.create(d,C)}static smaller(d,C){return se.create(d,C)}static smallerEquals(d,C){return fe.create(d,C)}static{this._parser=new g({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this._parser.parse(d)}}e.ContextKeyExpr=i;function s(F){const d=new g({regexParsingWithErrorRecovery:!1});return F.map(C=>(d.parse(C),d.lexingErrors.length>0?d.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,T.localize)(9,null,x.additionalInfo):(0,T.localize)(10,null),offset:x.offset,length:x.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.validateWhenClauses=s;function t(F,d){const C=F?F.substituteConstants():void 0,x=d?d.substituteConstants():void 0;return!C&&!x?!0:!C||!x?!1:C.equals(x)}e.expressionsAreEqualWithConstantSubstitution=t;function n(F,d){return F.cmp(d)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class l{static create(d,C=null){const x=f.get(d);return typeof x=="boolean"?x?o.INSTANCE:r.INSTANCE:new l(d,C)}constructor(d,C){this.key=d,this.negated=C,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:j(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=f.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:r.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.negated||(this.negated=$.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class D{static create(d,C,x=null){if(typeof C=="boolean")return C?l.create(d,x):$.create(d,x);const U=f.get(d);return typeof U=="boolean"?C===(U?"true":"false")?o.INSTANCE:r.INSTANCE:new D(d,C,x)}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=f.get(this.key);if(typeof d=="boolean"){const C=d?"true":"false";return this.value===C?o.INSTANCE:r.INSTANCE}return this}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class R{static create(d,C){return new R(d,C)}constructor(d,C){this.key=d,this.valueKey=C,this.type=10,this.negated=null}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}substituteConstants(){return this}evaluate(d){const C=d.getValue(this.valueKey),x=d.getValue(this.key);return Array.isArray(C)?C.includes(x):typeof x=="string"&&typeof C=="object"&&C!==null?E.call(C,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class y{static create(d,C){return new y(d,C)}constructor(d,C){this.key=d,this.valueKey=C,this.type=11,this._negated=R.create(d,C)}cmp(d){return d.type!==this.type?this.type-d.type:this._negated.cmp(d._negated)}equals(d){return d.type===this.type?this._negated.equals(d._negated):!1}substituteConstants(){return this}evaluate(d){return!this._negated.evaluate(d)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(d){return d.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class L{static create(d,C,x=null){if(typeof C=="boolean")return C?$.create(d,x):l.create(d,x);const U=f.get(d);return typeof U=="boolean"?C===(U?"true":"false")?r.INSTANCE:o.INSTANCE:new L(d,C,x)}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=f.get(this.key);if(typeof d=="boolean"){const C=d?"true":"false";return this.value===C?r.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class ${static create(d,C=null){const x=f.get(d);return typeof x=="boolean"?x?r.INSTANCE:o.INSTANCE:new $(d,C)}constructor(d,C){this.key=d,this.negated=C,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:j(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=f.get(this.key);return typeof d=="boolean"?d?r.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=$;function te(F,d){if(typeof F=="string"){const C=parseFloat(F);isNaN(C)||(F=C)}return typeof F=="string"||typeof F=="number"?d(F):r.INSTANCE}class Z{static create(d,C,x=null){return te(C,U=>new Z(d,U,x))}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Z;class oe{static create(d,C,x=null){return te(C,U=>new oe(d,U,x))}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=oe;class se{static create(d,C,x=null){return te(C,U=>new se(d,U,x))}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=oe.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=se;class fe{static create(d,C,x=null){return te(C,U=>new fe(d,U,x))}constructor(d,C,x){this.key=d,this.value=C,this.negated=x,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:K(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=fe;class le{static create(d,C){return new le(d,C)}constructor(d,C){this.key=d,this.regexp=C,this.type=7,this.negated=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const C=this.regexp?this.regexp.source:"",x=d.regexp?d.regexp.source:"";return C<x?-1:C>x?1:0}equals(d){if(d.type===this.type){const C=this.regexp?this.regexp.source:"",x=d.regexp?d.regexp.source:"";return this.key===d.key&&C===x}return!1}substituteConstants(){return this}evaluate(d){const C=d.getValue(this.key);return this.regexp?this.regexp.test(C):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ae.create(this)),this.negated}}e.ContextKeyRegexExpr=le;class ae{static create(d){return new ae(d)}constructor(d){this._actual=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}substituteConstants(){return this}evaluate(d){return!this._actual.evaluate(d)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(d){return new ae(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ae;function W(F){let d=null;for(let C=0,x=F.length;C<x;C++){const U=F[C].substituteConstants();if(F[C]!==U&&d===null){d=[];for(let q=0;q<C;q++)d[q]=F[q]}d!==null&&(d[C]=U)}return d===null?F:d}class H{static create(d,C,x){return H._normalizeArr(d,C,x)}constructor(d,C){this.expr=d,this.negated=C,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let C=0,x=this.expr.length;C<x;C++){const U=n(this.expr[C],d.expr[C]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let C=0,x=this.expr.length;C<x;C++)if(!this.expr[C].equals(d.expr[C]))return!1;return!0}return!1}substituteConstants(){const d=W(this.expr);return d===this.expr?this:H.create(d,this.negated,!1)}evaluate(d){for(let C=0,x=this.expr.length;C<x;C++)if(!this.expr[C].evaluate(d))return!1;return!0}static _normalizeArr(d,C,x){const U=[];let q=!1;for(const B of d)if(B){if(B.type===1){q=!0;continue}if(B.type===0)return r.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&q)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const ee=U.pop(),ue=U.length===0,he=V.create(B.expr.map(pe=>H.create([pe,ee],null,x)),null,ue);he&&(U.push(he),U.sort(n))}if(U.length===1)return U[0];if(x){for(let B=0;B<U.length;B++)for(let ee=B+1;ee<U.length;ee++)if(U[B].negate().equals(U[ee]))return r.INSTANCE;if(U.length===1)return U[0]}return new H(U,C)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const C of this.expr)d.push(...C.keys());return d}map(d){return new H(this.expr.map(C=>C.map(d)),null)}negate(){if(!this.negated){const d=[];for(const C of this.expr)d.push(C.negate());this.negated=V.create(d,this,!0)}return this.negated}}e.ContextKeyAndExpr=H;class V{static create(d,C,x){return V._normalizeArr(d,C,x)}constructor(d,C){this.expr=d,this.negated=C,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let C=0,x=this.expr.length;C<x;C++){const U=n(this.expr[C],d.expr[C]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let C=0,x=this.expr.length;C<x;C++)if(!this.expr[C].equals(d.expr[C]))return!1;return!0}return!1}substituteConstants(){const d=W(this.expr);return d===this.expr?this:V.create(d,this.negated,!1)}evaluate(d){for(let C=0,x=this.expr.length;C<x;C++)if(this.expr[C].evaluate(d))return!0;return!1}static _normalizeArr(d,C,x){let U=[],q=!1;if(d){for(let B=0,ee=d.length;B<ee;B++){const ue=d[B];if(ue){if(ue.type===0){q=!0;continue}if(ue.type===1)return o.INSTANCE;if(ue.type===9){U=U.concat(ue.expr);continue}U.push(ue)}}if(U.length===0&&q)return r.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(x){for(let B=0;B<U.length;B++)for(let ee=B+1;ee<U.length;ee++)if(U[B].negate().equals(U[ee]))return o.INSTANCE;if(U.length===1)return U[0]}return new V(U,C)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const C of this.expr)d.push(...C.keys());return d}map(d){return new V(this.expr.map(C=>C.map(d)),null)}negate(){if(!this.negated){const d=[];for(const C of this.expr)d.push(C.negate());for(;d.length>1;){const C=d.shift(),x=d.shift(),U=[];for(const q of M(C))for(const B of M(x))U.push(H.create([q,B],null,!1));d.unshift(V.create(U,null,!1))}this.negated=V.create(d,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class _ extends l{static{this._info=[]}static all(){return _._info.values()}constructor(d,C,x){super(d,null),this._defaultValue=C,typeof x=="object"?_._info.push({...x,key:d}):x!==!0&&_._info.push({key:d,description:x,type:C!=null?typeof C:void 0})}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return D.create(this.key,d)}notEqualsTo(d){return L.create(this.key,d)}}e.RawContextKey=_,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function j(F,d){return F<d?-1:F>d?1:0}function K(F,d,C,x){return F<C?-1:F>C?1:d<x?-1:d>x?1:0}function X(F,d){if(F.type===0||d.type===1)return!0;if(F.type===9)return d.type===9?J(F.expr,d.expr):!1;if(d.type===9){for(const C of d.expr)if(X(F,C))return!0;return!1}if(F.type===6){if(d.type===6)return J(d.expr,F.expr);for(const C of F.expr)if(X(C,d))return!0;return!1}return F.equals(d)}e.implies=X;function J(F,d){let C=0,x=0;for(;C<F.length&&x<d.length;){const U=F[C].cmp(d[x]);if(U<0)return!1;U===0&&C++,x++}return C===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(ie[59],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(ie[18],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[21],ne([0,1,95,10]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(v){switch(v){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(v,u){switch(v){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":u==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function b(v,u){return u==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function f(v,u,g){return b(u,g)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===g}e.isTargetPlatformCompatible=f;function a(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=a;var E;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var w;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var m;(function(v){v.Install="install",v.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var h;(function(v){v[v.None=1]="None",v[v.Install=2]="Install",v[v.Update=3]="Update",v[v.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var P;(function(v){v.Unsupported="Unsupported",v.Deprecated="Deprecated",v.Malicious="Malicious",v.Incompatible="Incompatible",v.IncompatibleTargetPlatform="IncompatibleTargetPlatform",v.ReleaseVersionNotFound="ReleaseVersionNotFound",v.Invalid="Invalid",v.Download="Download",v.DownloadSignature="DownloadSignature",v.UpdateMetadata="UpdateMetadata",v.Extract="Extract",v.Scanning="Scanning",v.Delete="Delete",v.Rename="Rename",v.CorruptZip="CorruptZip",v.IncompleteZip="IncompleteZip",v.Signature="Signature",v.NotAllowed="NotAllowed",v.Gallery="Gallery",v.Unknown="Unknown",v.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));var I;(function(v){v.UnknownError="UnknownError",v.PackageIsInvalidZip="PackageIsInvalidZip",v.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(I||(e.ExtensionSignaturetErrorCode=I={}));class p extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.ExtensionManagementError=p;var c;(function(v){v.Timeout="Timeout",v.Cancelled="Cancelled",v.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class S extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.ExtensionGalleryError=S,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel=(0,N.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(E,w,m,h,P,I){let p;try{await b(E,w,m,h,P,I)}catch(c){p=c}finally{p&&P.errorTransformer&&(p=P.errorTransformer(p)),typeof p<"u"&&m.error(p),m.end()}}e.readFileIntoStream=T;async function b(E,w,m,h,P,I){f(I);const p=await E.open(w,{create:!1});try{f(I);let c=0,S=0,v=P&&typeof P.length=="number"?P.length:void 0,u=N.VSBuffer.alloc(Math.min(P.bufferSize,typeof v=="number"?v:P.bufferSize)),g=P&&typeof P.position=="number"?P.position:0,i=0;do S=await E.read(p,g,u.buffer,i,u.byteLength-i),g+=S,i+=S,c+=S,typeof v=="number"&&(v-=S),i===u.byteLength&&(await m.write(h(u)),u=N.VSBuffer.alloc(Math.min(P.bufferSize,typeof v=="number"?v:P.bufferSize)),i=0);while(S>0&&(typeof v!="number"||v>0)&&f(I)&&a(c,P));if(i>0){let s=i;typeof v=="number"&&(s=Math.min(i,v)),m.write(h(u.slice(0,s)))}}catch(c){throw(0,A.ensureFileSystemProviderError)(c)}finally{await E.close(p)}}function f(E){if(E.isCancellationRequested)throw(0,O.canceled)();return!0}function a(E,w){if(typeof w?.limits?.size=="number"&&E>w.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new N.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=N.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(a){const E=this.normalizeRequests(a),w=E.filter(h=>{const P=this.watchers.get(h.path);return P?!(0,O.patternsEquals)(P.request.excludes,h.excludes)||!(0,O.patternsEquals)(P.request.includes,h.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:h})=>!E.find(P=>P.path===h.path&&(0,O.patternsEquals)(P.excludes,h.excludes)&&(0,O.patternsEquals)(P.includes,h.includes))).map(({request:h})=>h.path);w.length&&this.trace(`Request to start watching: ${w.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.stopWatching(h);for(const h of w)this.startWatching(h)}startWatching(a){const E=new T.NodeJSFileWatcherLibrary(a,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),w={request:a,instance:E};this.watchers.set(a.path,w)}async stop(){for(const[a]of this.watchers)this.stopWatching(a);this.watchers.clear()}stopWatching(a){const E=this.watchers.get(a);E&&(this.watchers.delete(a),E.instance.dispose())}normalizeRequests(a){const E=new Map;for(const w of a){const m=A.isLinux?w.path:w.path.toLowerCase();let h=E.get(w.correlationId);h||(h=new Map,E.set(w.correlationId,h)),h.set(m,w)}return Array.from(E.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(a){this.verboseLogging=a;for(const[,E]of this.watchers)E.instance.setVerboseLogging(a)}trace(a){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a)})}toMessage(a,E){return E?`[File Watcher (node.js)] ${a} (path: ${E.request.path})`:`[File Watcher (node.js)] ${a}`}}e.NodeJSWatcher=b}),define(ie[122],ne([0,1,61,121]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends N.AbstractNonRecursiveWatcherClient{constructor(T,b,f){super(T,b,f),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=k}),define(ie[123],ne([0,1,15,57,87,61]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(f,a,E){super(f,a,E),this.init()}createWatcher(f){const a=f.add(new k.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:E,signal:w})=>this.onError(`terminated by itself with code ${E}, signal: ${w}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ie[62],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...k){this._entries=new Map;for(const[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=N}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class w extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class m{constructor(p=new f.ServiceCollection,c=!1,S,v=E){this._services=p,this._strict=c,this._parent=S,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=v?S?._globalGraph??new T.Graph(u=>u):void 0}createChild(p){return new m(p,this._strict,this,this._enableTracing)}invokeFunction(p,...c){const S=P.traceInvocation(this._enableTracing,p);let v=!1;try{return p({get:g=>{if(v)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(g,S);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{v=!0,S.stop()}}createInstance(p,...c){let S,v;return p instanceof A.SyncDescriptor?(S=P.traceCreation(this._enableTracing,p.ctor),v=this._createInstance(p.ctor,p.staticArguments.concat(c),S)):(S=P.traceCreation(this._enableTracing,p),v=this._createInstance(p,c,S)),S.stop(),v}_createInstance(p,c=[],S){const v=b._util.getServiceDependencies(p).sort((i,s)=>i.index-s.index),u=[];for(const i of v){const s=this._getOrCreateServiceInstance(i.id,S);s||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),u.push(s)}const g=v.length>0?v[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${p.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(p,c.concat(u))}_setServiceInstance(p,c){if(this._services.get(p)instanceof A.SyncDescriptor)this._services.set(p,c);else if(this._parent)this._parent._setServiceInstance(p,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const c=this._services.get(p);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):c}_getOrCreateServiceInstance(p,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const S=this._getServiceInstanceOrDescriptor(p);return S instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,S,c.branch(p,!0)):(c.branch(p,!1),S)}_safeCreateAndCacheServiceInstance(p,c,S){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,c,S)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,c,S){const v=new T.Graph(i=>i.id.toString());let u=0;const g=[{id:p,desc:c,_trace:S}];for(;g.length;){const i=g.pop();if(v.lookupOrInsertNode(i),u++>1e3)throw new w(v);for(const s of b._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof A.SyncDescriptor){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};v.insertEdge(i,n),g.push(n)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:s}of i){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,c,S=[],v,u){if(this._services.get(p)instanceof A.SyncDescriptor)return this._createServiceInstance(p,c,S,v,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,c,S,v,u);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(p,c,S=[],v,u){if(v){const g=new m(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(p);const i=new Map,s=new N.GlobalIdleValue(()=>{const t=g._createInstance(c,S,u);for(const[n,r]of i){const o=t[n];if(typeof o=="function")for(const l of r)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.LinkedList,i.set(n,l)),(R,y,L)=>{if(s.isInitialized)return s.value[n](R,y,L);{const $={listener:[R,y,L],disposable:void 0},te=l.push($);return(0,k.toDisposable)(()=>{te(),$.disposable?.dispose()})}}}if(n in t)return t[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),t[n]=o),o},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return c.prototype}})}else return this._createInstance(c,S,u)}_throwIfStrict(p,c){if(c&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=m;var h;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(h||(h={}));class P{static{this.all=new Set}static{this._None=new class extends P{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,c){return p?new P(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):P._None}static traceCreation(p,c){return p?new P(1,c.name):P._None}static{this._totals=0}constructor(p,c){this.type=p,this.name=c,this._start=Date.now(),this._dep=[]}branch(p,c){const S=new P(3,p.toString());return this._dep.push([p,c,S]),S}stop(){const p=Date.now()-this._start;P._totals+=p;let c=!1;function S(u,g){const i=[],s=new Array(u+1).join("	");for(const[t,n,r]of g._dep)if(n&&r){c=!0,i.push(`${s}CREATES -> ${t}`);const o=S(u+1,r);o&&i.push(o)}else i.push(`${s}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(p>2||c)&&P.all.add(v.join(`
`))}}e.Trace=P});var re=this&&this.__param||function(G,e){return function(N,O){e(N,O,G)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(G,e,N,O,k,A,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(E){return E.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let a=class extends O.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new N.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const P=m.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(p=>p.startsWith("lp-"))).map(I=>{const p=I.properties.localizedLanguages?.[0],c=f(I);return{...this.createQuickPickItem(c,p,I),extensionId:I.identifier.id,galleryExtension:I}});return P.push(this.createQuickPickItem("en","English")),P}createQuickPickItem(w,m,h){const P=m??w;let I;if(P!==w&&(I=`(${w})`),w.toLowerCase()===k.language.toLowerCase()&&(I??="",I+=(0,A.localize)(0,null)),h?.installCount){I??="";const p=h.installCount;let c;p>1e6?c=`${Math.floor(p/1e5)/10}M`:p>1e3?c=`${Math.floor(p/1e3)}K`:c=String(p),I+=` $(cloud-download) ${c}`}return{id:w,label:P,description:I}}};e.LanguagePackBaseService=a,e.LanguagePackBaseService=a=me([re(0,T.IExtensionGalleryService)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(G,e,N,O,k,A,T,b,f,a,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function h(){return new Date().toISOString()}function P(R){return(0,a.isNumber)(R)}e.isLogLevel=P;var I;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(I||(e.LogLevel=I={})),e.DEFAULT_LOG_LEVEL=I.Info;function p(R,y,L){switch(y){case I.Trace:R.trace(L);break;case I.Debug:R.debug(L);break;case I.Info:R.info(L);break;case I.Warning:R.warn(L);break;case I.Error:R.error(L);break;case I.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=p;function c(R,y=!1){let L="";for(let $=0;$<R.length;$++){let te=R[$];if(te instanceof Error&&(te=(0,N.toErrorMessage)(te,y)),typeof te=="object")try{te=JSON.stringify(te)}catch{}L+=($>0?" ":"")+te}return L}class S extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(y){this.level!==y&&(this.level=y,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(y){return this.level!==I.Off&&this.level<=y}}e.AbstractLogger=S;class v extends S{constructor(y){super(),this.logAlways=y}checkLogLevel(y){return this.logAlways||super.checkLogLevel(y)}trace(y,...L){this.checkLogLevel(I.Trace)&&this.log(I.Trace,c([y,...L],!0))}debug(y,...L){this.checkLogLevel(I.Debug)&&this.log(I.Debug,c([y,...L]))}info(y,...L){this.checkLogLevel(I.Info)&&this.log(I.Info,c([y,...L]))}warn(y,...L){this.checkLogLevel(I.Warning)&&this.log(I.Warning,c([y,...L]))}error(y,...L){if(this.checkLogLevel(I.Error))if(y instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=y.stack,this.log(I.Error,c($))}else this.log(I.Error,c([y,...L]))}flush(){}}e.AbstractMessageLogger=v;class u extends S{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.useColors=!b.isWindows}trace(y,...L){this.checkLogLevel(I.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...L):console.log(`[main ${h()}]`,y,...L))}debug(y,...L){this.checkLogLevel(I.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...L):console.log(`[main ${h()}]`,y,...L))}info(y,...L){this.checkLogLevel(I.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...L):console.log(`[main ${h()}]`,y,...L))}warn(y,...L){this.checkLogLevel(I.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,y,...L):console.warn(`[main ${h()}]`,y,...L))}error(y,...L){this.checkLogLevel(I.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,y,...L):console.error(`[main ${h()}]`,y,...L))}flush(){}}e.ConsoleMainLogger=u;class g extends S{constructor(y=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(y)}trace(y,...L){this.checkLogLevel(I.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",y,...L):console.log(y,...L))}debug(y,...L){this.checkLogLevel(I.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",y,...L):console.log(y,...L))}info(y,...L){this.checkLogLevel(I.Info)&&(this.useColors?console.log("%c INFO","color: #33f",y,...L):console.log(y,...L))}warn(y,...L){this.checkLogLevel(I.Warning)&&(this.useColors?console.log("%c WARN","color: #993",y,...L):console.log(y,...L))}error(y,...L){this.checkLogLevel(I.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",y,...L):console.error(y,...L))}flush(){}}e.ConsoleLogger=g;class i extends S{constructor(y,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=y,this.setLevel(L)}trace(y,...L){this.checkLogLevel(I.Trace)&&this.adapter.log(I.Trace,[this.extractMessage(y),...L])}debug(y,...L){this.checkLogLevel(I.Debug)&&this.adapter.log(I.Debug,[this.extractMessage(y),...L])}info(y,...L){this.checkLogLevel(I.Info)&&this.adapter.log(I.Info,[this.extractMessage(y),...L])}warn(y,...L){this.checkLogLevel(I.Warning)&&this.adapter.log(I.Warning,[this.extractMessage(y),...L])}error(y,...L){this.checkLogLevel(I.Error)&&this.adapter.log(I.Error,[this.extractMessage(y),...L])}extractMessage(y){return typeof y=="string"?y:(0,N.toErrorMessage)(y,this.checkLogLevel(I.Trace))}flush(){}}e.AdapterLogger=i;class s extends S{constructor(y){super(),this.loggers=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const L of this.loggers)L.setLevel(y);super.setLevel(y)}trace(y,...L){for(const $ of this.loggers)$.trace(y,...L)}debug(y,...L){for(const $ of this.loggers)$.debug(y,...L)}info(y,...L){for(const $ of this.loggers)$.info(y,...L)}warn(y,...L){for(const $ of this.loggers)$.warn(y,...L)}error(y,...L){for(const $ of this.loggers)$.error(y,...L)}flush(){for(const y of this.loggers)y.flush()}dispose(){for(const y of this.loggers)y.dispose();super.dispose()}}e.MultiplexLogger=s;class t extends A.Disposable{constructor(y,L,$){if(super(),this.logLevel=y,this.logsHome=L,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,$)for(const te of $)this._loggers.set(te.resource,{logger:void 0,info:te})}getLoggerEntry(y){return(0,a.isString)(y)?[...this._loggers.values()].find(L=>L.info.id===y):this._loggers.get(y)}getLogger(y){return this.getLoggerEntry(y)?.logger}createLogger(y,L){const $=this.toResource(y),te=(0,a.isString)(y)?y:L?.id??(0,k.hash)($.toString()).toString(16);let Z=this._loggers.get($)?.logger;const oe=L?.logLevel==="always"?I.Trace:L?.logLevel;Z||(Z=this.doCreateLogger($,oe??this.getLogLevel($)??this.logLevel,{...L,id:te}));const se={logger:Z,info:{resource:$,id:te,logLevel:oe,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(se.info),this._loggers.set($,se),Z}toResource(y){return(0,a.isString)(y)?(0,f.joinPath)(this.logsHome,`${y}.log`):y}setLogLevel(y,L){if(E.URI.isUri(y)){const $=y,te=L,Z=this._loggers.get($);Z&&te!==Z.info.logLevel&&(Z.info.logLevel=te===this.logLevel?void 0:te,Z.logger?.setLevel(te),this._loggers.set(Z.info.resource,Z),this._onDidChangeLogLevel.fire([$,te]))}else{this.logLevel=y;for(const[$,te]of this._loggers.entries())this._loggers.get($)?.info.logLevel===void 0&&te.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(y,L){const $=this.getLoggerEntry(y);$&&L!==!$.info.hidden&&($.info.hidden=!L,this._loggers.set($.info.resource,$),this._onDidChangeVisibility.fire([$.info.resource,L]))}getLogLevel(y){let L;return y&&(L=this._loggers.get(y)?.info.logLevel),L??this.logLevel}registerLogger(y){const L=this._loggers.get(y.resource);L?L.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this._loggers.set(y.resource,{info:y,logger:void 0}),this._onDidChangeLoggers.fire({added:[y],removed:[]}))}deregisterLogger(y){const L=this._loggers.get(y);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(y),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const y of this._loggers.values())yield y.info}getRegisteredLogger(y){return this._loggers.get(y)?.info}dispose(){this._loggers.forEach(y=>y.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class n{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(y){}getLevel(){return I.Info}trace(y,...L){}debug(y,...L){}info(y,...L){}warn(y,...L){}error(y,...L){}critical(y,...L){}dispose(){}flush(){}}e.NullLogger=n;class r extends n{}e.NullLogService=r;function o(R){if(R.verbose)return I.Trace;if(typeof R.logLevel=="string"){const y=D(R.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(R){switch(R){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}e.LogLevelToString=l;function D(R){switch(R){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",l(I.Info))}),define(ie[64],ne([0,1,7,10,4]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");let A=class{constructor(b){this.logService=b}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((b,f)=>G(["node-vsce-sign"],async a=>b(a),f))),this.moduleLoadingPromise}async verify(b,f,a){let E;try{E=await this.vsceSign()}catch(w){return this.logService.error("Could not load vsce-sign module",(0,N.getErrorMessage)(w)),!1}return E.verify(b,f,a)}};e.ExtensionSignatureVerificationService=A,e.ExtensionSignatureVerificationService=A=me([re(0,k.ILogService)],A)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends T.Disposable{constructor(m,h){super(),this.logService=m,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(m,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,h):this.watchNonRecursive(m,h)}watchUniversal(m,h){const P={path:this.toFilePath(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},I=(0,N.insert)(this.universalPathsToWatch,P);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&m.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,h){const P={path:this.toFilePath(m),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},I=(0,N.insert)(this.nonRecursivePathsToWatch,P);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends a.Disposable{static{u=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new T.Emitter),this._onDidUncorrelatedFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new a.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(r=>{const o=new p.FileChangesEvent(r,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,a.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await O.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return f.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,h.isAbsolutePath)(s))throw new p.FileOperationError((0,I.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new v.ErrorNoTelemetry;throw n.message=(0,I.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t)||(0,p.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,p.toFileSystemProviderErrorCode)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,I.localize)(2,null,this.resourceForError(s)),1):(0,p.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),r=this.isPathCaseSensitive(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,D=t?.resolveMetadata,R=await n.stat(s);let y;return this.toFileStat(n,s,R,void 0,!!D,(L,$)=>(y||(y=E.TernarySearchTree.forUris(()=>!r),y.set(s,!0),o&&y.fill(!0,o)),y.get(L.resource)||y.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&l?$===1:!1))}async toFileStat(s,t,n,r,o,l){const{providerExtUri:D}=this.getExtUri(s),R={resource:t,name:D.basename(t),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&l(R,r)){try{const y=await s.readdir(t),L=await O.Promises.settled(y.map(async([$,te])=>{try{const Z=D.joinPath(t,$),oe=o?await s.stat(Z):{type:te};return await this.toFileStat(s,Z,oe,y.length,o,l)}catch(Z){return this.logService.trace(Z),null}}));R.children=(0,N.coalesce)(L)}catch(y){this.logService.trace(y),R.children=[]}return R}return R}async resolveAll(s){return O.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new p.FileOperationError((0,I.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=k.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const r=await this.writeFile(s,t);return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,r)),r}async writeFile(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(r);let l=n;if((0,p.hasFileAtomicWriteCapability)(r)&&!l?.atomic){const D=r.enforceAtomicWriteFile?.(s);D&&(l={...n,atomic:D})}try{await this.validateWriteFile(r,s,l)||await this.mkdirp(r,o.dirname(s));let R;if((0,p.hasReadWriteCapability)(r)&&!(t instanceof k.VSBuffer))if((0,P.isReadableStream)(t)){const y=await(0,P.peekStream)(t,3);y.ended?R=k.VSBuffer.concat(y.buffer):R=y}else R=(0,P.peekReadable)(t,y=>k.VSBuffer.concat(y),3);else R=t;!(0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasReadWriteCapability)(r)&&R instanceof k.VSBuffer||(0,p.hasReadWriteCapability)(r)&&(0,p.hasFileAtomicWriteCapability)(r)&&l?.atomic?await this.doWriteUnbuffered(r,s,l,R):await this.doWriteBuffered(r,s,l,R instanceof k.VSBuffer?(0,k.bufferToReadable)(R):R),this._onDidRunOperation.fire(new p.FileOperationEvent(s,4))}catch(D){throw new p.FileOperationError((0,I.localize)(4,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(D).toString()),(0,p.toFileOperationResult)(D),l)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){const r=!!n?.unlock;if(r&&!(s.capabilities&8192))throw new Error((0,I.localize)(5,null,this.resourceForError(t)));if(!!n?.atomic){if(!(s.capabilities&32768))throw new Error((0,I.localize)(6,null,this.resourceForError(t)));if(!(s.capabilities&2))throw new Error((0,I.localize)(7,null,this.resourceForError(t)));if(r)throw new Error((0,I.localize)(8,null,this.resourceForError(t)))}let l;try{l=await s.stat(t)}catch{return}if(l.type&p.FileType.Directory)throw new p.FileOperationError((0,I.localize)(9,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,p.etag)({mtime:n.mtime,size:l.size}))throw new p.FileOperationError((0,I.localize)(10,null),3,n);return l}async readFile(s,t,n){const r=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(r,s,t,n):this.doReadFile(r,s,t,n)}async doReadFileAtomic(s,t,n,r){return new Promise((o,l)=>{this.writeQueue.queueFor(t,async()=>{try{const D=await this.doReadFile(s,t,n,r);o(D)}catch(D){l(D)}},this.getExtUri(s).providerExtUri)})}async doReadFile(s,t,n,r){const o=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},r);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(s,t,n){const r=await this.withReadProvider(s);return this.doReadFileStream(r,s,t,n)}async doReadFileStream(s,t,n,r){const o=new A.CancellationTokenSource(r);let l=n;(0,p.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const D=this.validateReadFile(t,l).then(y=>y,y=>{throw o.dispose(!0),y});let R;try{return typeof l?.etag=="string"&&l.etag!==p.ETAG_DISABLED&&await D,l?.atomic&&(0,p.hasFileAtomicReadCapability)(s)||!((0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasFileReadStreamCapability)(s))||(0,p.hasReadWriteCapability)(s)&&l?.preferUnbuffered?R=this.readFileUnbuffered(s,t,l):(0,p.hasFileReadStreamCapability)(s)?R=this.readFileStreamed(s,t,o.token,l):R=this.readFileBuffered(s,t,o.token,l),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await D,value:R}}catch(y){throw R&&await(0,P.consumeStream)(R),this.restoreReadError(y,t,l)}}restoreReadError(s,t,n){const r=(0,I.localize)(11,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString());return s instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(r,s.stat,n):s instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(r,s.fileOperationResult,s.size,s.options):new p.FileOperationError(r,(0,p.toFileOperationResult)(s),n)}readFileStreamed(s,t,n,r=Object.create(null)){const o=s.readFileStream(t,r,n);return(0,P.transform)(o,{data:l=>l instanceof k.VSBuffer?l:k.VSBuffer.wrap(l),error:l=>this.restoreReadError(l,t,r)},l=>k.VSBuffer.concat(l))}readFileBuffered(s,t,n,r=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,c.readFileIntoStream)(s,t,o,l=>l,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:l=>this.restoreReadError(l,t,r)},n),o}readFileUnbuffered(s,t,n){const r=(0,P.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,p.hasFileAtomicReadCapability)(s)?o=await s.readFile(t,{atomic:!0}):o=await s.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.validateReadFileLimits(t,o.byteLength,n),r.end(k.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new p.FileOperationError((0,I.localize)(12,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&t.etag===n.etag)throw new p.NotModifiedSinceFileOperationError((0,I.localize)(13,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new p.TooLargeFileOperationError((0,I.localize)(14,null,this.resourceForError(s)),7,t,n)}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,r){if(s.toString()!==t.toString())try{const o=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,s,l,t,n,r)}catch(o){return o}return!0}async move(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),l=await this.doMoveCopy(r,s,o,t,"move",!!n),D=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,l==="move"?2:3,D)),D}async copy(s,t,n){const r=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),l=await this.doMoveCopy(r,s,o,t,"copy",!!n),D=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,l==="copy"?3:2,D)),D}async doMoveCopy(s,t,n,r,o,l){if(t.toString()===r.toString())return o;const{exists:D,isSameResourceWithDifferentPathCase:R}=await this.doValidateMoveCopy(s,t,n,r,o,l);if(D&&!R&&l&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),o==="copy"){if(s===n&&(0,p.hasFileFolderCopyCapability)(s))await s.copy(t,r,{overwrite:l});else{const y=await this.resolve(t);y.isDirectory?await this.doCopyFolder(s,y,n,r):await this.doCopyFile(s,t,n,r)}return o}else return s===n?(await s.rename(t,r,{overwrite:l}),o):(await this.doMoveCopy(s,t,n,r,"copy",l),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,r){if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,r);if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,r);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,r);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,r)}async doCopyFolder(s,t,n,r){await n.mkdir(r),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async o=>{const l=this.getExtUri(n).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),n,l):this.doCopyFile(s,o.resource,n,l)}))}async doValidateMoveCopy(s,t,n,r,o,l){let D=!1;if(s===n){const{providerExtUri:y,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(D=y.isEqual(t,r)),D&&o==="copy")throw new Error((0,I.localize)(15,null,this.resourceForError(t),this.resourceForError(r)));if(!D&&y.isEqualOrParent(r,t))throw new Error((0,I.localize)(16,null,this.resourceForError(t),this.resourceForError(r)))}const R=await this.exists(r);if(R&&!D){if(!l)throw new p.FileOperationError((0,I.localize)(17,null,this.resourceForError(t),this.resourceForError(r)),4);if(s===n){const{providerExtUri:y}=this.getExtUri(s);if(y.isEqualOrParent(t,r))throw new Error((0,I.localize)(18,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:R,isSameResourceWithDifferentPathCase:D}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(t,r.dirname(t));)try{if(!((await s.stat(t)).type&p.FileType.Directory))throw new Error((0,I.localize)(19,null,this.resourceForError(t)));break}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(t)),t=r.dirname(t)}for(let o=n.length-1;o>=0;o--){t=r.joinPath(t,n[o]);try{await s.mkdir(t)}catch(l){if((0,p.toFileSystemProviderErrorCode)(l)!==p.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),r=!!t?.useTrash;if(r&&!(n.capabilities&4096))throw new Error((0,I.localize)(20,null,this.resourceForError(s)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,I.localize)(21,null,this.resourceForError(s)));if(r&&o)throw new Error((0,I.localize)(22,null,this.resourceForError(s)));let l;try{l=await n.stat(s)}catch{}if(l)this.throwIfFileIsReadonly(s,l);else throw new p.FileOperationError((0,I.localize)(23,null,this.resourceForError(s)),1);if(!!!t?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,I.localize)(24,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t);let r=t;if((0,p.hasFileAtomicDeleteCapability)(n)&&!r?.atomic){const R=n.enforceAtomicDelete?.(s);R&&(r={...t,atomic:R})}const o=!!r?.useTrash,l=!!r?.recursive,D=r?.atomic??!1;await n.delete(s,{recursive:l,useTrash:o,atomic:D}),this._onDidRunOperation.fire(new p.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(!(n===r&&this.getExtUri(n).providerExtUri.isEqual(s,t)))return n===r&&(0,p.hasFileCloneCapability)(n)?n.cloneFile(s,t):(await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n===r&&(0,p.hasFileFolderCopyCapability)(n)?this.writeQueue.queueFor(s,()=>n.copy(s,t,{overwrite:!0}),this.getExtUri(n).providerExtUri):this.writeQueue.queueFor(s,()=>this.doCopyFile(n,s,r,t),this.getExtUri(n).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,t){return this.watch(s,{...t,correlationId:u.WATCHER_CORRELATION_IDS++})}watch(s,t={recursive:!1,excludes:[]}){const n=new a.DisposableStore;let r=!1,o=()=>{r=!0};n.add((0,a.toDisposable)(()=>o())),(async()=>{try{const D=await this.doWatch(s,t);r?(0,a.dispose)(D):o=()=>(0,a.dispose)(D)}catch(D){this.logService.error(D)}})();const l=t.correlationId;if(typeof l=="number"){const D=n.add(new T.Emitter);return n.add(this.internalOnDidFilesChange.event(y=>{y.correlates(l)&&D.fire(y)})),{onDidChange:D.event,dispose:()=>n.dispose()}}return n}async doWatch(s,t){const n=await this.withProvider(s),r=(0,b.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let o=this.activeWatchers.get(r);return o||(o={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(r,o)),o.count+=1,(0,a.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,a.dispose)(o.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,a.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,r){return this.writeQueue.queueFor(t,async()=>{const o=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,P.isReadableStream)(r)||(0,P.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,o,r):await this.doWriteReadableBufferedQueued(s,o,r)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await s.close(o)}},this.getExtUri(s).providerExtUri)}async doWriteStreamBufferedQueued(s,t,n){let r=0,o;if((0,P.isReadableBufferedStream)(n)){if(n.buffer.length>0){const l=k.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,l,l.byteLength,r,0),r+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,D)=>{(0,P.listenStream)(o,{onData:async R=>{o.pause();try{await this.doWriteBuffer(s,t,R,R.byteLength,r,0)}catch(y){return D(y)}r+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>D(R),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(s,t,n){let r=0,o;for(;(o=n.read())!==null;)await this.doWriteBuffer(s,t,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(s,t,n,r,o,l){let D=0;for(;D<r;){const R=await s.write(t,o+D,n.buffer,l+D,r-D);D+=R}}async doWriteUnbuffered(s,t,n,r){return this.writeQueue.queueFor(t,()=>this.doWriteUnbufferedQueued(s,t,n,r),this.getExtUri(s).providerExtUri)}async doWriteUnbufferedQueued(s,t,n,r){let o;r instanceof k.VSBuffer?o=r:(0,P.isReadableStream)(r)?o=await(0,k.streamToBuffer)(r):(0,P.isReadableBufferedStream)(r)?o=await(0,k.bufferedStreamToBuffer)(r):o=(0,k.readableToBuffer)(r),await s.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeBufferedQueued(s,t,n,r){let o,l;try{o=await s.open(t,{create:!1}),l=await n.open(r,{create:!0,unlock:!1});const D=k.VSBuffer.alloc(this.BUFFER_SIZE);let R=0,y=0,L=0;do L=await s.read(o,R,D.buffer,y,D.byteLength-y),await this.doWriteBuffer(n,l,D,L,R,y),R+=L,y+=L,y===D.byteLength&&(y=0);while(L>0)}catch(D){throw(0,p.ensureFileSystemProviderError)(D)}finally{await O.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedQueued(s,t,n,r){return n.writeFile(r,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedToBufferedQueued(s,t,n,r){const o=await n.open(r,{create:!0,unlock:!1});try{const l=await s.readFile(t);await this.doWriteBuffer(n,o,k.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await n.close(o)}}async doPipeBufferedToUnbuffered(s,t,n,r){const o=await(0,k.streamToBuffer)(this.readFileBuffered(s,t,A.CancellationToken.None));await this.doWriteUnbuffered(n,r,void 0,o)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new p.FileOperationError((0,I.localize)(25,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,I.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=g,e.FileService=g=u=me([re(0,S.ILogService)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(N)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(s)}`)}})();class i extends S.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new A.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:r}=await P.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await P.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,m.joinPath)(t,o.name))).type:l=this.toType(o),r.push([o.name,l])}catch(l){this.logService.trace(l)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let r;return n?.dangling?r=p.FileType.Unknown:t.isFile()?r=p.FileType.File:t.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,n&&(r|=p.FileType.SymbolicLink),r}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new k.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const o=this.toFilePath(t);return await P.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,r){const o=(0,h.newWriteableStream)(l=>T.VSBuffer.concat(l.map(D=>T.VSBuffer.wrap(D))).buffer);return(0,c.readFileIntoStream)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(t,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,m.joinPath)((0,m.dirname)(t),`${(0,m.basename)(t)}${r.atomic.postfix}`),n,r):this.doWriteFile(t,n,r)}async canWriteFileAtomic(t){try{const n=this.toFilePath(t),{symbolicLink:r}=await P.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async doWriteFileAtomic(t,n,r,o){const l=new a.DisposableStore;try{l.add(await this.createResourceLock(t)),l.add(await this.createResourceLock(n)),await this.doWriteFile(n,r,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(D){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{l.dispose()}}async doWriteFile(t,n,r,o){let l;try{const D=this.toFilePath(t);if(!r.create||!r.overwrite){if(await P.Promises.exists(D)){if(!r.overwrite)throw(0,p.createFileSystemProviderError)((0,I.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.createFileSystemProviderError)((0,I.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:r.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(t,D)}finally{typeof l=="number"&&await this.close(l)}}static{this.canFlush=!0}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n,r){const o=this.toFilePath(t);let l;(0,p.isFileOpenForWriteOptions)(n)&&!r&&(l=await this.createResourceLock(t));let D;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await P.SymlinkSupport.stat(o);y.mode&128||await P.Promises.chmod(o,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}let R;if((0,p.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await P.Promises.truncate(o,0),R="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}R||(R="w")}else R="r";D=await P.Promises.open(o,R)}catch(R){throw l?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,R):this.toFileSystemProviderError(R)}if(this.mapHandleToPos.set(D,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(D,t),l){const R=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${o})`),this.mapHandleToLock.set(D,l),R&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${o})`),R.dispose())}return D}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await P.Promises.fdatasync(t)}catch(r){i.configureFlushOnWrite(!1),this.logService.error(r)}return await P.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,r,o,l){const D=this.normalizePos(t,n);let R=null;try{R=(await P.Promises.read(t,r,o,l,D)).bytesRead}catch(y){throw this.toFileSystemProviderError(y)}finally{this.updatePos(t,D,R)}return R}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,r){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,o+r):this.mapHandleToPos.delete(t)))}async write(t,n,r,o,l){return(0,k.retry)(()=>this.doWrite(t,n,r,o,l),100,3)}async doWrite(t,n,r,o,l){const D=this.normalizePos(t,n);let R=null;try{R=(await P.Promises.write(t,r,o,l,D)).bytesWritten}catch(y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),y)}finally{this.updatePos(t,D,R)}return R}async mkdir(t){try{await P.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const r=this.toFilePath(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,E.join)((0,E.dirname)(r),`${(0,E.basename)(r)}${n.atomic.postfix}`)),await P.Promises.rm(r,P.RimRafMode.MOVE,o)}else try{await P.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:D,symbolicLink:R}=await P.SymlinkSupport.stat(r);l=D.isDirectory()&&!R}catch{}if(l)await P.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,n,r){const o=this.toFilePath(t),l=this.toFilePath(n);if(o!==l)try{await this.validateMoveCopy(t,n,"move",r.overwrite),await P.Promises.rename(o,l)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,I.localize)(2,null,(0,E.basename)(o),(0,E.basename)((0,E.dirname)(l)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(t,n,r){const o=this.toFilePath(t),l=this.toFilePath(n);if(o!==l)try{await this.validateMoveCopy(t,n,"copy",r.overwrite),await P.Promises.copy(o,l,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,I.localize)(3,null,(0,E.basename)(o),(0,E.basename)((0,E.dirname)(l)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(t,n,r,o){const l=this.toFilePath(t),D=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,f.isEqual)(l,D,!0)),R){if(r==="copy")throw(0,p.createFileSystemProviderError)((0,I.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const L=await this.statIgnoreError(t);if(!L)throw(0,p.createFileSystemProviderError)((0,I.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const $=await this.statIgnoreError(n);if($){if(!o)throw(0,p.createFileSystemProviderError)((0,I.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);L.type&p.FileType.File&&$.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,r){const o=this.toFilePath(t),l=this.toFilePath(n),D=!!(this.capabilities&1024);if((0,f.isEqual)(o,l,!D))return;const R=new a.DisposableStore;try{R.add(await this.createResourceLock(t)),R.add(await this.createResourceLock(n)),r&&await P.Promises.mkdir((0,E.dirname)(l),{recursive:!0}),await P.Promises.copyFile(o,l)}catch(y){if(y.code==="ENOENT"&&!r)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(y)}finally{R.dispose()}}createUniversalWatcher(t,n,r){return new u.UniversalWatcherClient(o=>t(o),o=>n(o),r)}createNonRecursiveWatcher(t,n,r){return new g.NodeJSWatcherClient(o=>t(o),o=>n(o),r)}toFileSystemProviderError(t){if(t instanceof p.FileSystemProviderError)return t;let n=t,r;switch(t.code){case"ENOENT":r=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=p.FileSystemProviderErrorCode.Unknown;break;default:r=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(t,n){let r=this.toFileSystemProviderError(n);if(t&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await P.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(r=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=i}),define(ie[129],ne([0,1,2,4]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends N.Disposable{constructor(T,b=[]){super(),this.logger=new O.MultiplexLogger([T,...b]),this._register(T.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...b){this.logger.trace(T,...b)}debug(T,...b){this.logger.debug(T,...b)}info(T,...b){this.logger.info(T,...b)}warn(T,...b){this.logger.warn(T,...b)}error(T,...b){this.logger.error(T,...b)}flush(){this.logger.flush()}}e.LogService=k}),define(ie[130],ne([0,1,13,4]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,E,w,m,h){try{const P=await new Promise((p,c)=>{G(["@vscode/spdlog"],p,c)});P.setFlushOn(k.Trace);const I=await P.createAsyncRotatingLogger(a,E,w,m);return h?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(P){console.error(P)}return null}function T(a,E,w){switch(E){case O.LogLevel.Trace:a.trace(w);break;case O.LogLevel.Debug:a.debug(w);break;case O.LogLevel.Info:a.info(w);break;case O.LogLevel.Warning:a.warn(w);break;case O.LogLevel.Error:a.error(w);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function b(a,E){switch(E){case O.LogLevel.Trace:a.setLevel(k.Trace);break;case O.LogLevel.Debug:a.setLevel(k.Debug);break;case O.LogLevel.Info:a.setLevel(k.Info);break;case O.LogLevel.Warning:a.setLevel(k.Warning);break;case O.LogLevel.Error:a.setLevel(k.Error);break;case O.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class f extends O.AbstractMessageLogger{constructor(E,w,m,h,P){super(),this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(E,w,m,h),this._register(this.onDidChangeLogLevel(I=>{this._logger&&b(this._logger,I)}))}async _createSpdLogLogger(E,w,m,h){const P=m?6:1,I=30/P*N.ByteSize.MB,p=await A(E,w,I,P,h);if(p){this._logger=p,b(this._logger,this.getLevel());for(const{level:c,message:S}of this.buffer)T(this._logger,c,S);this.buffer=[]}}log(E,w){this._logger?T(this._logger,E,w):this.getLevel()<=E&&this.buffer.push({level:E,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(ie[131],ne([0,1,28,4,130]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(b,f,a){return new k.SpdLogLogger((0,N.generateUuid)(),b.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.LoggerService=A}),define(ie[39],ne([0,1,6,65,2,10]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),O.Iterable.reduce(this.policies.entries(),(w,[m,h])=>({...w,[m]:h}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[E,w])=>({...a,[E]:{definition:w,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=T;class b{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(w,m){const h=[];for(const P of new Set(k.Iterable.concat(w.keys(),m.keys())))w.get(P)!==m.get(P)&&h.push(P);return h}let E=class extends f.AbstractPolicyService{constructor(m,h,P){super(),this.file=m,this.fileService=h,this.logService=P,this.throttledDelayer=this._register(new N.ThrottledDelayer(500));const I=O.Event.filter(h.onDidFilesChange,p=>p.affects(m));this._register(h.watch(m)),this._register(I(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const m=new Map;try{const h=await this.fileService.readFile(this.file),P=JSON.parse(h.value.toString());if(!(0,A.isObject)(P))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(P))this.policyDefinitions[I]&&m.set(I,P[I])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return m}async refresh(){const m=await this.read(),h=a(this.policies,m);this.policies=m,h.length>0&&this._onDidChange.fire(h)}};e.FilePolicyService=E,e.FilePolicyService=E=me([re(1,T.IFileService),re(2,b.ILogService)],E)}),define(ie[133],ne([0,1,39,9,2,4]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let T=class extends N.AbstractPolicyService{constructor(f,a){super(),this.logService=f,this.productName=a,this.throttler=new O.Throttler,this.watcher=this._register(new k.MutableDisposable)}async _updatePolicyDefinitions(f){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:a}=await new Promise((E,w)=>{G(["@vscode/policy-watcher"],E,w)});await this.throttler.queue(()=>new Promise((E,w)=>{try{this.watcher.value=a(this.productName,f,m=>{this._onDidPolicyChange(m),E()})}catch(m){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),w(m)}}))}_onDidPolicyChange(f){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const a in f){const E=f[a];E===void 0?this.policies.delete(a):this.policies.set(a,E)}this._onDidChange.fire(Object.keys(f))}};e.NativePolicyService=T,e.NativePolicyService=T=me([re(0,A.ILogService)],T)}),define(ie[32],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,b){N.ok(O.isString(T)),N.ok(O.isObject(b)),N.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,b)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ie[134],ne([0,1,6,36]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,a){this.schemasById[k(f)]=a,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=f.Registry.as(b.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=new Set;this.doRegisterConfigurations(i,s,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=new Set;this.doDeregisterConfigurations(i,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(i,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(i){const s=new Set;this.doRegisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,s){const t=[];for(const{overrides:n,source:r}of i)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.configurationDefaultsOverrides.get(o),D=l?.valuesSources??new Map;if(r)for(const $ of Object.keys(n[o]))D.set($,r);const R={...l?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:R,valuesSources:D});const y=(0,T.getLanguageTagSettingPlainKey)(o),L={type:"object",default:R,description:A.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:k.isString(r)?void 0:r,defaultValueSource:r};t.push(...I(o)),this.configurationProperties[o]=L,this.defaultLanguageConfigurationOverridesNode.properties[o]=L}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:r});const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(i){const s=new Set;this.doDeregisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,s){for(const{overrides:t,source:n}of i)for(const r in t){const o=this.configurationDefaultsOverrides.get(r),l=k.isString(n)?n:n?.id,D=k.isString(o?.source)?o?.source:o?.source?.id;if(l===D)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const R=this.configurationProperties[r];R&&(this.updatePropertyDefaultValue(r,R),this.updateSchema(r,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let s=!1;const t=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,t),s=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,t),s=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,t),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s,t){i.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,t),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(i,s){const t=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>t(r))};for(const n of i){t(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,s=!0,t,n,r=3,o){r=k.isUndefinedOrNull(i.scope)?r:i.scope;const l=i.properties;if(l)for(const R in l){const y=l[R];if(s&&v(R,y)){delete l[R];continue}if(y.source=t,y.defaultDefaultValue=l[R].default,this.updatePropertyDefaultValue(R,y),e.OVERRIDE_PROPERTY_REGEX.test(R)?y.scope=void 0:(y.scope=k.isUndefinedOrNull(y.scope)?r:y.scope,y.restricted=k.isUndefinedOrNull(y.restricted)?!!n?.includes(R):y.restricted),l[R].hasOwnProperty("included")&&!l[R].included){this.excludedConfigurationProperties[R]=l[R],delete l[R];continue}else this.configurationProperties[R]=l[R],l[R].policy?.name&&this.policyConfigurations.set(l[R].policy.name,R);!l[R].deprecationMessage&&l[R].markdownDeprecationMessage&&(l[R].deprecationMessage=l[R].markdownDeprecationMessage),o.add(R)}const D=i.allOf;if(D)for(const R of D)this.validateAndRegisterProperties(R,s,t,n,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,r=t?.source;k.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),k.isUndefined(n)&&(n=c(s.type)),s.default=n,s.defaultValueSource=r}}const h="\\[([^\\]]+)\\]",P=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function I(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=P.exec(g);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=P.exec(g)}}return(0,N.distinct)(i)}e.overrideIdentifiersFromKey=I;function p(g){return g.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=p;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const S=new m;f.Registry.add(e.Extensions.Configuration,S);function v(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?A.localize(7,null,g):S.getConfigurationProperties()[g]!==void 0?A.localize(8,null,g):i.policy?.name&&S.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,g,i.policy?.name,S.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=v;function u(){const g=[],i=S.getConfigurationProperties();for(const s of Object.keys(i))g.push([s,i[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=u}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(G,e,N,O,k,A,T,b,f,a,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(s){return Object.isFrozen(s)?s:b.deepFreeze(s)}class P{constructor(t={},n=[],r=[],o){this._contents=t,this._keys=n,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof P)return n;const r=new I("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,E.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const r=this.rawConfiguration.getValue(t),o=n?this.rawConfiguration.getOverrideValue(t,n):void 0,l=n?this.rawConfiguration.override(n).getValue(t):r;return{value:r,override:o,merged:l}}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,E.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return N.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return N.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=b.deepClone(this.contents),r=b.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of t)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(n,D.contents);for(const R of D.overrides){const[y]=r.filter(L=>N.equals(L.identifiers,R.identifiers));y?(this.mergeContents(y.contents,R.contents),y.keys.push(...R.keys),y.keys=N.distinct(y.keys)):r.push(b.deepClone(R))}for(const R of D.keys)o.indexOf(R)===-1&&o.push(R)}return new P(n,o,r,l.every(D=>D instanceof P)?void 0:l)}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of N.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const D=n[o];D&&(typeof l=="object"&&typeof D=="object"?(l=b.deepClone(l),this.mergeContents(l,D)):l=D),r[o]=l}return new P(r,this.keys,this.overrides)}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&f.isObject(t[r])&&f.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=b.deepClone(n[r])}}getContentsForOverrideIdentifer(t){let n=null,r=null;const o=l=>{l&&(r?this.mergeContents(r,l):r=b.deepClone(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.updateValue(t,n,!0)}setValue(t,n){this.updateValue(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,E.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>N.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}updateValue(t,n,r){(0,E.addToValueTree)(this.contents,t,n,o=>console.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,E.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=P;class I{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!f.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:o,overrides:l,restricted:D,hasExcludedProperties:R}=this.doParseRaw(t,n);this._configurationModel=new P(r,o,l,R?[t]:void 0),this._restrictedConfigurations=D||[]}doParseContent(t){let n={},r=null,o=[];const l=[],D=[];function R(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}const y={onObjectBegin:()=>{const L={};R(L),l.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const L=[];R(L),l.push(o),o=L,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:R,onError:(L,$,te)=>{D.push({error:L,offset:$,length:te})}};if(t)try{k.visit(t,y),n=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return n}doParseRaw(t,n){const r=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,n);t=o.raw;const l=(0,E.toValuesTree)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),D=Object.keys(t),R=this.toOverrides(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:l,keys:D,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,n,r,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const D={},R=[];for(const y in t)if(w.OVERRIDE_PROPERTY_REGEX.test(y)&&r){const L=this.filter(t[y],n,!1,o);D[y]=L.raw,l=l||L.hasExcludedProperties,R.push(...L.restricted)}else{const L=n[y],$=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&R.push(y),!o.exclude?.includes(y)&&(o.include?.includes(y)||($===void 0||o.scopes===void 0||o.scopes.includes($))&&!(o.skipRestricted&&L?.restricted))?D[y]=t[y]:l=!0}return{raw:D,restricted:R,hasExcludedProperties:l}}toOverrides(t,n){const r=[];for(const o of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const D in t[o])l[D]=t[o][D];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,n)})}return r}}e.ConfigurationModelParser=I;class p extends A.Disposable{constructor(t,n,r,o){super(),this.userSettingsResource=t,this.parseOptions=n,this.fileService=o,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class c{constructor(t,n,r,o,l,D,R,y,L,$,te,Z,oe){this.key=t,this.overrides=n,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=l,this.policyConfiguration=D,this.applicationConfiguration=R,this.userConfiguration=y,this.localUserConfiguration=L,this.remoteUserConfiguration=$,this.workspaceConfiguration=te,this.folderConfigurationModel=Z,this.memoryConfigurationModel=oe}get value(){return h(this._value)}inspect(t,n,r){const o=t.inspect(n,r);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class S{constructor(t,n,r,o,l=new P,D=new P,R=new T.ResourceMap,y=new P,L=new T.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=l,this._workspaceConfiguration=D,this._folderConfigurations=R,this._memoryConfiguration=y,this._memoryConfigurationByResource=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidatedConfigurationModel(t,n,r).getValue(t)}updateValue(t,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new P,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const o=this.getConsolidatedConfigurationModel(t,n,r),l=this.getFolderConfigurationModelForResource(n.resource,r),D=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const y of o.overrides)for(const L of y.identifiers)o.getOverrideValue(t,L)!==void 0&&R.add(L);return new c(t,n,o.getValue(t),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,l||void 0,D)}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:o,updated:l,removed:D}=g(this._defaultConfiguration,t);n=[...o,...l,...D]}for(const o of n)for(const l of(0,w.overrideIdentifiersFromKey)(o)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(l),R=t.getKeysForOverrideIdentifier(l),y=[...R.filter(L=>D.indexOf(L)===-1),...D.filter(L=>R.indexOf(L)===-1),...D.filter(L=>!b.equals(this._defaultConfiguration.override(l).getValue(L),t.override(l).getValue(L)))];r.push([l,y])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:o}=g(this._policyConfiguration,t),l=[...n,...r,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:o,overrides:l}=g(this.applicationConfiguration,t),D=[...n,...r,...o];return D.length&&this.updateApplicationConfiguration(t),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:l}=g(this.localUserConfiguration,t),D=[...n,...r,...o];return D.length&&this.updateLocalUserConfiguration(t),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),D=[...n,...r,...o];return D.length&&this.updateRemoteUserConfiguration(t),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:o,overrides:l}=g(this.workspaceConfiguration,t),D=[...n,...r,...o];return D.length&&this.updateWorkspaceConfiguration(t),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:o,updated:l,removed:D,overrides:R}=g(r,n),y=[...o,...l,...D];return(y.length||!r)&&this.updateFolderConfiguration(t,n),{keys:y,overrides:R}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:l,overrides:D}=g(n,void 0);return{keys:[...r,...o,...l],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,n,r){let o=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=r.merge(o),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:o,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this._workspaceConfiguration.keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),l=this.parseConfigurationModel(t.user),D=this.parseConfigurationModel(t.workspace),R=t.folders.reduce((y,L)=>(y.set(a.URI.revive(L[0]),this.parseConfigurationModel(L[1])),y),new T.ResourceMap);return new S(n,r,o,l,new P,D,R,new P,new T.ResourceMap)}static parseConfigurationModel(t){return new P(t.contents,t.keys,t.overrides)}}e.Configuration=S;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const o of s)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,D])=>{const R=(0,T.getOrSet)(n,l,new Set);D.forEach(y=>R.add(y))});const r=[];return n.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=v;class u{constructor(t,n,r,o){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const D of l)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const l of this.affectedKeys)this._affectsConfigStr+=l+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const l=o+r.length;if(l>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(l);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(n){const R=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,y=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!b.equals(R,y)}return!0}}e.ConfigurationChangeEvent=u;function g(s,t){const{added:n,removed:r,updated:o}=i(t?.rawConfiguration,s?.rawConfiguration),l=[],D=s?.getAllOverrideIdentifiers()||[],R=t?.getAllOverrideIdentifiers()||[];if(t){const y=R.filter(L=>!D.includes(L));for(const L of y)l.push([L,t.getKeysForOverrideIdentifier(L)])}if(s){const y=D.filter(L=>!R.includes(L));for(const L of y)l.push([L,s.getKeysForOverrideIdentifier(L)])}if(t&&s){for(const y of D)if(R.includes(y)){const L=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:t.getOverrideValue(void 0,y)||{},keys:t.getKeysForOverrideIdentifier(y)});l.push([y,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:r,updated:o,overrides:l}}function i(s,t){const n=s?t?s.keys.filter(l=>t.keys.indexOf(l)===-1):[...s.keys]:[],r=t?s?t.keys.filter(l=>s.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(s&&t){for(const l of t.keys)if(s.keys.indexOf(l)!==-1){const D=(0,E.getConfigurationValue)(t.contents,l),R=(0,E.getConfigurationValue)(s.contents,l);b.equals(D,R)||o.push(l)}}return{added:n,removed:r,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(G,e,N,O,k,A,T,b,f,a,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:c})=>this.onDidUpdateConfiguration(Array.from(p),c))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,c){this.updateConfigurationModel(p,w.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new b.ConfigurationModel;const p=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,c){const S=this.getConfigurationDefaultOverrides();for(const v of p){const u=S[v],g=c[v];u!==void 0?this._configurationModel.addValue(v,u):g?this._configurationModel.addValue(v,g.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=m;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let P=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(p,c,S){super(),this.defaultConfiguration=p,this.policyService=c,this.logService=S,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const c={},S=[],v=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const u of p){const g=v[u];if(!g){S.push(u);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.logService.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}S.push(u),c[g.policy.name]={type:g.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.updatePolicyDefinitions(c),S}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const c=w.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),S=(0,N.coalesce)(p.map(v=>c.get(v)));this.update(S,!0)}update(p,c){this.logService.trace("PolicyConfiguration#update",p);const S=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),v=[],u=this._configurationModel.isEmpty();for(const g of p){const i=S[g]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(u?s!==void 0:!(0,A.equals)(this._configurationModel.getValue(g),s))&&v.push([g,s])}else this._configurationModel.getValue(g)!==void 0&&v.push([g,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const g=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const i of g.keys)this._configurationModel.setValue(i,g.getValue(i));for(const[i,s]of v)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=P,e.PolicyConfiguration=P=me([re(1,E.IPolicyService),re(2,a.ILogService)],P)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class c extends f.Disposable{constructor(u,g,i,s){super(),this.settingsResource=u,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=i instanceof p.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,i,s)),this.userConfiguration=this._register(new h.UserSettings(this.settingsResource,{},w.extUriBiasedIgnorePathCase,g)),this.configuration=new h.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new h.ConfigurationModel,new h.ConfigurationModel),this.configurationEditing=new S(u,g,this),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:t,properties:n})=>this.onDidDefaultConfigurationChange(t,n))),this._register(this.policyConfiguration.onDidChangeConfiguration(t=>this.onDidPolicyConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[u,g,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new h.Configuration(u,g,new h.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(u,g){const i=typeof u=="string"?u:void 0,s=(0,m.isConfigurationOverrides)(u)?u:(0,m.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(i,s,void 0)}async updateValue(u,g,i,s,t){const n=(0,m.isConfigurationUpdateOverrides)(i)?i:(0,m.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,r=n?s:i;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${u} to target ${r}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,N.distinct)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(u,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,a.equals)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const D=n.overrideIdentifiers.sort(),R=this.configuration.localUserConfiguration.overrides.find(y=>(0,N.equals)([...y.identifiers].sort(),D));R&&(n.overrideIdentifiers=R.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,P.keyFromOverrideIdentifiers)(n.overrideIdentifiers),u]:[u];await this.configurationEditing.write(l,g),await this.reloadConfiguration()}inspect(u,g={}){return this.configuration.inspect(u,g,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const u=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(u)}onDidChangeUserConfiguration(u){const g=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(u);this.trigger(i,g,2)}onDidDefaultConfigurationChange(u,g){const i=this.configuration.toData(),s=this.configuration.compareAndUpdateDefaultConfiguration(u,g);this.trigger(s,i,7)}onDidPolicyConfigurationChange(u){const g=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(u);this.trigger(i,g,7)}trigger(u,g,i){const s=new h.ConfigurationChangeEvent(u,{data:g},this.configuration);s.source=i,this._onDidChangeConfiguration.fire(s)}}e.ConfigurationService=c;class S{constructor(u,g,i){this.settingsResource=u,this.fileService=g,this.configurationService=i,this.queue=new O.Queue}write(u,g){return this.queue.queue(()=>this.doWriteConfiguration(u,g))}async doWriteConfiguration(u,g){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const s=[];if((0,T.parse)(i,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.getEdits(i,u,g);i=(0,b.applyEdits)(i,t),await this.fileService.writeFile(this.settingsResource,k.VSBuffer.fromString(i))}getEdits(u,g,i){const{tabSize:s,insertSpaces:t,eol:n}=this.formattingOptions;if(!g.length){const r=JSON.stringify(i,null,t?" ".repeat(s):"	");return[{content:r,length:r.length,offset:0}]}return(0,b.setProperty)(u,g,i,{tabSize:s,insertSpaces:t,eol:n})}get formattingOptions(){if(!this._formattingOptions){let u=E.OS===3||E.OS===2?`
`:`\r
`;const g=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(u=g),this._formattingOptions={eol:u,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ie[67],ne([0,1,15]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(a){return a.scheme===N.Schemas.vscodeRemote?a.authority:void 0}e.getRemoteAuthority=O;function k(a){if(!a)return;const E=a.indexOf("+");return E<0?a:a.substr(0,E)}e.getRemoteName=k;function A(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(a){const{host:E,port:w}=f(a);if(typeof w>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:w}}e.parseAuthorityWithPort=T;function b(a,E){let{host:w,port:m}=f(a);return typeof m>"u"&&(m=E),{host:w,port:m}}e.parseAuthorityWithOptionalPort=b;function f(a){const E=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=a.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(T||(e.ExtensionType=T={}));var b;(function(I){I.WIN32_X64="win32-x64",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.LINUX_PPC64LE="linux-ppc64le",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class f{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,c){if(typeof p>"u"||p===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof p=="string"||typeof c=="string"){const S=typeof p=="string"?p:p.value,v=typeof c=="string"?c:c.value;return N.equalsIgnoreCase(S,v)}return p._lower===c._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=f;class a{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const c of p)this.add(c)}add(p){this._set.add(f.toKey(p))}delete(p){return this._set.delete(f.toKey(p))}has(p){return this._set.has(f.toKey(p))}}e.ExtensionIdentifierSet=a;class E{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(f.toKey(p))}get(p){return this._map.get(f.toKey(p))}has(p){return this._map.has(f.toKey(p))}set(p,c){this._map.set(f.toKey(p),c)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=E;function w(I){return m(I)}e.isApplicationScopedExtension=w;function m(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function h(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function P(I,p){if(p){const c=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return!!I.activationEvents?.includes(c)}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends N.Disposable{constructor(b,f,a,E,w){super(),this.userDataProfilesService=b,this.fileService=f,this.uriIdentityService=a,this.logService=w,this._register(E.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(E.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(b){for(const f of b)f.local&&this.invalidate(f.profileLocation)}onDidUnInstallExtension(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const f of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(f.extensionsResource,b)&&await this.deleteUserCacheFile(f);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(b){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(b.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(f){(0,k.toFileOperationResult)(f)!==1&&this.logService.error(f)}}}e.ExtensionsManifestCache=A}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,b.createDecorator)("requestService");class E{constructor(g){this.original=g}toJSON(){if(!this.headers){const g=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.original[i];this.headers=g}return this.headers}}class w extends k.Disposable{constructor(g){super(),this.counter=0,this.logger=g.createLogger("network",{name:(0,A.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(g,i,s){const t=`${g} #${++this.counter}: ${i.url}`;this.logger.trace(`${t} - begin`,i.type,new E(i.headers??{}));try{const n=await s();return this.logger.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${t} - error`,i.type,(0,O.getErrorMessage)(n)),n}}}e.AbstractRequestService=w;function m(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=m;function h(u){return u.res.statusCode===204}e.hasNoContent=h;async function P(u){return h(u)?null:(await(0,N.streamToBuffer)(u.stream)).toString()}e.asText=P;async function I(u){if(!m(u))throw new Error("Server returned "+u.res.statusCode);return P(u)}e.asTextOrError=I;async function p(u){if(!m(u))throw new Error("Server returned "+u.res.statusCode);if(h(u))return null;const i=(await(0,N.streamToBuffer)(u.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}e.asJson=p;function c(u){v(u)}e.updateProxyConfigurationsScope=c;let S;function v(u){const g=a.Registry.as(T.Extensions.Configuration),i=S;S={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[S],remove:i?[i]:[]})}v(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(f,a){this.requestService=f,this.fileService=a}async download(f,a,E=N.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(f,a);return}const w={type:"GET",url:f.toString(!0)},m=await this.requestService.request(w,E);if(m.res.statusCode===200)await this.fileService.writeFile(a,m.stream);else{const h=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.DownloadService=T,e.DownloadService=T=me([re(0,A.IRequestService),re(1,k.IFileService)],T)}),define(ie[139],ne([0,1,140,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(T,b){return T.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:T.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(T,b,f={}){const a=(0,N.parse)(T),E=f.proxyUrl||k(a,b);if(!E)return null;const w=(0,N.parse)(E);if(!/^https?:$/.test(w.protocol||""))return null;const m={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((h,P)=>{G(["http-proxy-agent"],h,P)})).HttpProxyAgent(E,m):new(await new Promise((h,P)=>{G(["https-proxy-agent"],h,P)})).HttpsProxyAgent(E,m)}e.getProxyAgent=A}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let P;async function I(c,S,v,u){return v["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(u)&&!v["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(u)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),P||(P=m.Promises.withAsyncBody(async(g,i)=>{const s=new A.CancellationTokenSource;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,h.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{g(await p(S,s.token))}catch(o){!(0,b.isCancellationError)(o)&&!s.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(o)))):g({})}finally{clearTimeout(r),s.dispose()}})),P)}e.getResolvedShellEnv=I;async function p(c,S){const v=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",v);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",u);const g=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",s);const t=await(0,E.getSystemShell)(f.OS,s);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,r)=>{if(S.isCancellationRequested)return r(new b.CancellationError);const o=(0,O.basename)(t);let l,D;const R="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${R} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,D=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${R} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,D=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,D=["-i","-l","-c"]):(l=`'${process.execPath}' ${R} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),l);const y=(0,N.spawn)(t,[...D,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});S.onCancellationRequested(()=>(y.kill(),r(new b.CancellationError))),y.on("error",te=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(te)),r(te)});const L=[];y.stdout.on("data",te=>L.push(te));const $=[];y.stderr.on("data",te=>$.push(te)),y.on("close",(te,Z)=>{const oe=Buffer.concat(L).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat($).toString("utf8");if(se.trim()&&c.trace("getUnixShellEnvironment#stderr",se),te||Z)return r(new Error((0,k.localize)(2,null,te,Z)));const fe=i.exec(oe),le=fe?fe[1]:"{}";try{const ae=JSON.parse(le);v?ae.ELECTRON_RUN_AS_NODE=v:delete ae.ELECTRON_RUN_AS_NODE,u?ae.ELECTRON_NO_ATTACH_CONSOLE=u:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(ae)),r(ae)}})})}}),define(ie[142],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class E extends k.Disposable{constructor(P,I,p,c){super(),this.storagePath=P,this.saveStrategy=I,this.logService=p,this.fileService=c,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new N.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,I){const p=this.storage[P];return(0,A.isUndefinedOrNull)(p)?I:p}setItem(P,I){this.setItems([{key:P,data:I}])}setItems(P){let I=!1;for(const{key:p,data:c}of P)this.storage[p]!==c&&((0,A.isUndefinedOrNull)(c)?(0,A.isUndefined)(this.storage[p])||(this.storage[p]=void 0,I=!0):(this.storage[p]=c,I=!0));I&&this.save()}removeItem(P){(0,A.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(P),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=P}catch(I){this.logService.error(I)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=E;let w=class extends k.Disposable{constructor(P,I,p,c){super(),this.fileStorage=this._register(new E(I.stateResource,P,p,c))}async init(){await this.fileStorage.init()}getItem(P,I){return this.fileStorage.getItem(P,I)}};e.StateReadonlyService=w,e.StateReadonlyService=w=me([re(1,T.IEnvironmentService),re(2,f.ILogService),re(3,b.IFileService)],w);class m extends w{setItem(P,I){this.fileStorage.setItem(P,I)}setItems(P){this.fileStorage.setItems(P)}removeItem(P){this.fileStorage.removeItem(P)}close(){return this.fileStorage.close()}}e.StateService=m}),define(ie[69],ne([0,1,12,35,28]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(f){if(N.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function T(f,a,E,w,m,h,P,I,p){const c=Object.create(null);c["common.machineId"]=h,c["common.sqmId"]=P,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=w,c.version=m,c["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.PlatformToString)(N.platform),c["common.nodePlatform"]=O.platform,c["common.nodeArch"]=E,c["common.product"]=p||"desktop",I&&(c["common.msftInternal"]=I);let S=0;const v=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),N.isLinuxSnap&&(c["common.snap"]="true");const u=A(a);return u&&(c["common.platformDetail"]=u),c}e.resolveCommonProperties=T;function b(f){const a=O.env.USERDNSDOMAIN;if(!a)return!1;const E=a.toLowerCase();return f.some(w=>E===w)}e.verifyMicrosoftInternalDomain=b}),define(ie[25],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class b{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=b;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=f,e.NullTelemetryService=new f;class a{async publicLog(s,t,n){}async publicLogError(s,t,n){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=E;function w(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=w;function m(i){const s=i.getValue(T.TELEMETRY_SETTING_ID),t=i.getValue(T.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function h(i){const s={},t={},n={};p(i,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const o=n[r];typeof o=="number"?t[r]=o:typeof o=="boolean"?t[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),s[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[r]=o)}return{properties:s,measurements:t}}e.validateTelemetryData=h;const P=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(i){if(!i)return"none";const s=(0,k.getRemoteName)(i);return P.has(s)?s:"other"}e.cleanRemoteAuthority=I;function p(i,s,t=0,n){if(i)for(const r of Object.getOwnPropertyNames(i)){const o=i[r],l=n?n+r:r;Array.isArray(o)?s[l]=(0,N.safeStringify)(o):o instanceof Date?s[l]=o.toISOString():(0,O.isObject)(o)?t<2?p(o,s,t+1,l+"."):s[l]=(0,N.safeStringify)(o):s[l]=o}}function c(i,s){const t=i.msftInternalDomains||[],n=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(t)||n}e.isInternalTelemetry=c;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=S;function v(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const D of s)for(;;){const R=D.exec(i);if(!R)break;n.push([R.index,D.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const D=o.exec(i);if(!D)break;const R=n.some(([y,L])=>D.index<L&&y<o.lastIndex);!r.test(D[0])&&!R&&(t+=i.substring(l,D.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function u(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of s)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,s){return(0,N.cloneAndChange)(i,t=>{if(t instanceof b||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=v(n,s);for(const r of s)n=n.replace(r,"");return n=u(n),n}})}e.cleanData=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,N.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=E;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,r,o)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(t){const n=h.exec(t);return n&&n[1]?[p(n[1]),n[2]]:[p(t),void 0]}e.getIdAndVersion=P;function I(t,n){return`${t}.${n}`}e.getExtensionId=I;function p(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=p;function c(t,n){return p(I(t??k.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=c;function S(t,n){const r=[],o=l=>{for(const D of r)if(D.some(R=>E(n(R),n(l))))return D;return null};for(const l of t){const D=o(l);D?D.push(l):r.push([l])}return r}e.groupByExtension=S;function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function u(t){return{id:new a.TelemetryTrustedValue(t.identifier.id),name:new a.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(t,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&r.every(D=>!E(D.identifier,{id:l}))){const D=t.filter(R=>E(R.identifier,{id:l}));D.length===1&&(r.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function i(t,n){if(!A.isLinux)return!1;let r;try{r=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,n){const r=await i(t,n),o=(0,O.getTargetPlatform)(r?"alpine":A.platform,f.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(G,e,N,O,k,A,T,b,f,a,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=I=>(0,f.localize)(0,null,I),h=(0,f.localize)(1,null,"ms-dotnettools.csharp");let P=class{constructor(p,c,S){this.logger=p,this.extensionManagementService=c,this.extensionGalleryService=S}get location(){}async listExtensions(p,c,S){let v=await this.extensionManagementService.getInstalled(1,S);const u=w.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(c&&c!==""){if(u.indexOf(c.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.logger.info("Possible Categories: "),u.forEach(i=>{this.logger.info(i)});return}this.location&&this.logger.info((0,f.localize)(2,null,this.location)),v=v.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let g;for(const i of v)g!==i.identifier.id&&(g=i.identifier.id,this.logger.info(p?`${g}@${i.manifest.version}`:g))}async installExtensions(p,c,S,v){const u=[];try{const g=[];p.length&&this.logger.info(this.location?(0,f.localize)(3,null,this.location):(0,f.localize)(4,null));const i=[];let s=[];const t=(r,o,l)=>{s.push({id:r,version:o!=="prerelease"?o:void 0,installOptions:{...S,isBuiltin:l,installPreReleaseVersion:o==="prerelease"||S.installPreReleaseVersion}})};for(const r of p)if(r instanceof b.URI)i.push({vsix:r,installOptions:S});else{const[o,l]=(0,E.getIdAndVersion)(r);t(o,l,!1)}for(const r of c)if(r instanceof b.URI)i.push({vsix:r,installOptions:{...S,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[o,l]=(0,E.getIdAndVersion)(r);t(o,l,!0)}const n=await this.extensionManagementService.getInstalled(1,S.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:r,installOptions:o})=>{try{const l=await this.installVSIX(r,o,v,n);l&&g.push(l)}catch(l){this.logger.error(l),u.push(r.toString())}})),s.length&&(s=s.filter(({id:r,version:o})=>{const l=n.find(D=>(0,E.areSameExtensions)(D.identifier,{id:r}));if(l){if(!v&&(!o||o==="prerelease"&&l.preRelease))return this.logger.info((0,f.localize)(5,null,r,l.manifest.version,r)),!1;if(o&&l.manifest.version===o)return this.logger.info((0,f.localize)(6,null,`${r}@${o}`)),!1}return!0}),s.length)){const r=await this.getGalleryExtensions(s);await Promise.all(s.map(async o=>{const l=r.get(o.id.toLowerCase());if(l)try{const D=await this.installFromGallery(o,l,n);D&&g.push(D)}catch(D){this.logger.error(D.message||D.stack||D),u.push(o.id)}else this.logger.error(`${m(o.version?`${o.id}@${o.version}`:o.id)}
${h}`),u.push(o.id)}))}}catch(g){throw this.logger.error((0,f.localize)(7,null,(0,O.getErrorMessage)(g))),g}if(u.length)throw new Error((0,f.localize)(8,null,u.join(", ")))}async updateExtensions(p){const c=await this.extensionManagementService.getInstalled(1,p),S=[];for(const i of c)i.identifier.uuid&&S.push({...i.identifier,preRelease:i.preRelease});this.logger.trace((0,f.localize)(9,null,S.length));const v=await this.extensionGalleryService.getExtensions(S,{compatible:!0},N.CancellationToken.None),u=[];for(const i of v)for(const s of c)(0,E.areSameExtensions)(s.identifier,i.identifier)&&(0,T.gt)(i.version,s.manifest.version)&&u.push({extension:i,options:{operation:3,installPreReleaseVersion:s.isPreReleaseVersion}});if(!u.length){this.logger.info((0,f.localize)(10,null));return}this.logger.info((0,f.localize)(11,null,u.map(i=>i.extension.identifier.id).join(", ")));const g=await this.extensionManagementService.installGalleryExtensions(u);for(const i of g)i.error?this.logger.error((0,f.localize)(12,null,i.identifier.id,(0,O.getErrorMessage)(i.error))):this.logger.info((0,f.localize)(13,null,i.identifier.id,i.local?.manifest.version))}async installVSIX(p,c,S,v){const u=await this.extensionManagementService.getManifest(p);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,S,c.profileLocation,v))try{return await this.extensionManagementService.install(p,c),this.logger.info((0,f.localize)(14,null,(0,A.basename)(p))),u}catch(i){if((0,O.isCancellationError)(i))return this.logger.info((0,f.localize)(15,null,(0,A.basename)(p))),null;throw i}return null}async getGalleryExtensions(p){const c=new Map,S=p.some(g=>g.installOptions.installPreReleaseVersion),v=await this.extensionManagementService.getTargetPlatform(),u=[];for(const g of p)a.EXTENSION_IDENTIFIER_REGEX.test(g.id)&&u.push({...g,preRelease:S});if(u.length){const g=await this.extensionGalleryService.getExtensions(u,{targetPlatform:v},N.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}async installFromGallery({id:p,version:c,installOptions:S},v,u){const g=await this.extensionGalleryService.getManifest(v,N.CancellationToken.None);if(g&&!this.validateExtensionKind(g))return null;const i=u.find(s=>(0,E.areSameExtensions)(s.identifier,v.identifier));if(i){if(v.version===i.manifest.version)return this.logger.info((0,f.localize)(16,null,c?`${p}@${c}`:p)),null;this.logger.info((0,f.localize)(17,null,p,v.version))}try{S.isBuiltin?this.logger.info(c?(0,f.localize)(18,null,p,c):(0,f.localize)(19,null,p)):this.logger.info(c?(0,f.localize)(20,null,p,c):(0,f.localize)(21,null,p));const s=await this.extensionManagementService.installFromGallery(v,{...S,installGivenVersion:!!c});return this.logger.info((0,f.localize)(22,null,p,s.manifest.version)),g}catch(s){if((0,O.isCancellationError)(s))return this.logger.info((0,f.localize)(23,null,p)),null;throw s}}validateExtensionKind(p){return!0}async validateVSIX(p,c,S,v){if(!c){const u={id:(0,E.getGalleryExtensionId)(p.publisher,p.name)},g=v.find(i=>(0,E.areSameExtensions)(u,i.identifier)&&(0,T.gt)(i.manifest.version,p.version));if(g)return this.logger.info((0,f.localize)(24,null,g.identifier.id,g.manifest.version,p.version)),!1}return this.validateExtensionKind(p)}async uninstallExtensions(p,c,S){const v=async g=>{if(g instanceof b.URI){const i=await this.extensionManagementService.getManifest(g);return(0,E.getExtensionId)(i.publisher,i.name)}return g},u=[];for(const g of p){const i=await v(g),t=(await this.extensionManagementService.getInstalled(void 0,S)).filter(n=>(0,E.areSameExtensions)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.notInstalled(i)}
${h}`);if(t.some(n=>n.type===0)){this.logger.info((0,f.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.logger.info((0,f.localize)(26,null,i));return}this.logger.info((0,f.localize)(27,null,i));for(const n of t)await this.extensionManagementService.uninstall(n,{profileLocation:S}),u.push(n);this.location?this.logger.info((0,f.localize)(28,null,i,this.location)):this.logger.info((0,f.localize)(29,null,i))}}async locateExtension(p){const c=await this.extensionManagementService.getInstalled();p.forEach(S=>{c.forEach(v=>{if(v.identifier.id===S&&v.location.scheme===k.Schemas.file){this.logger.info(v.location.fsPath);return}})})}notInstalled(p){return this.location?(0,f.localize)(30,null,p,this.location):(0,f.localize)(31,null,p)}};e.ExtensionManagementCLI=P,e.ExtensionManagementCLI=P=me([re(1,a.IExtensionManagementService),re(2,a.IExtensionGalleryService)],P)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let u=class extends k.Disposable{static{v=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,s,t,n,r,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=n,this.extensionSignatureVerificationService=r,this.logService=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,s,t){await this.cleanUpPromise;const n=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,n,o=>this.extensionGalleryService.download(i,o,s))}catch(o){throw new P.ExtensionManagementError(o.message,P.ExtensionManagementErrorCode.Download)}let r=!1;if(t&&this.shouldVerifySignature(i)){const o=await this.downloadSignatureArchive(i);try{r=await this.extensionSignatureVerificationService.verify(n.fsPath,o.fsPath,this.logService.getLevel()===S.LogLevel.Trace)}catch(l){const D=l;if(r=D.code,D.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${D.output}`),r===P.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===P.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(R){this.logService.error(R)}throw new P.ExtensionManagementError(w.CorruptZipMessage,P.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.logService.error(l)}}}return r===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${i.identifier.id}`),{location:n,verificationStatus:r}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,f.isBoolean)(s)?s:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const s=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${v.SignatureArchiveExtension}`);try{await this.downloadFile(i,s,t=>this.extensionGalleryService.downloadSignatureArchive(i,t))}catch(t){throw new P.ExtensionManagementError(t.message,P.ExtensionManagementErrorCode.DownloadSignature)}return s}async downloadFile(i,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const n=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,a.generateUuid)()}`);await this.fileService.exists(n)||await t(n);try{await E.Promises.rename(n.fsPath,s.fsPath,2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(v.SignatureArchiveExtension))n.push(l.resource);else{const D=I.ExtensionKey.parse(l.name);D&&t.push([D,l])}const r=(0,I.groupByExtension)(t,([l])=>l),o=[];for(const l of r)l.sort((D,R)=>b.rcompare(D[0].version,R[0].version)),s.push(...l.slice(1).map(D=>D[1].resource)),o.push(l[0][1]);o.sort((l,D)=>l.mtime-D.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(l=>l.resource)),s.push(...n),await N.Promises.settled(s.map(l=>(this.logService.trace("Deleting from cache",l.path),this.fileService.del(l))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?I.ExtensionKey.create(i).toString().toLowerCase():(0,a.generateUuid)()}};e.ExtensionsDownloader=u,e.ExtensionsDownloader=u=v=me([re(0,h.INativeEnvironmentService),re(1,c.IFileService),re(2,P.IExtensionGalleryService),re(3,m.IConfigurationService),re(4,p.IExtensionSignatureVerificationService),re(5,S.ILogService)],u)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends O.Disposable{constructor(a,E,w,m,h,P,I){super(),this.extensionManagementService=a,this.extensionsScannerService=E,this.userDataProfilesService=w,this.extensionsProfileScannerService=m,this.uriIdentityService=h,this.fileService=P,this.logService=I,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,p=>I.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(a=>this.onDidChangeProfiles(a.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(a=>this.onAddExtensions(a))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(a=>this.onDidAddExtensions(a))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(a=>this.onRemoveExtensions(a))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(a=>this.onDidRemoveExtensions(a))),this._register(this.fileService.onDidFilesChange(a=>this.onDidFilesChange(a)))}async onDidChangeProfiles(a){try{a.length&&await Promise.all(a.map(E=>(this.extensionsProfileWatchDisposables.set(E.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(E.extensionsResource)),this.fileService.watch(E.extensionsResource))),this.populateExtensionsFromProfile(E.extensionsResource))))}catch(E){throw this.logService.error(E),E}}async onAddExtensions(a){for(const E of a.extensions)this.addExtensionWithKey(this.getKey(E.identifier,E.version),a.profileLocation)}async onDidAddExtensions(a){for(const E of a.extensions){const w=this.getKey(E.identifier,E.version);a.error?this.removeExtensionWithKey(w,a.profileLocation):this.addExtensionWithKey(w,a.profileLocation)}}async onRemoveExtensions(a){for(const E of a.extensions)this.removeExtensionWithKey(this.getKey(E.identifier,E.version),a.profileLocation)}async onDidRemoveExtensions(a){const E=[],w=[];for(const m of a.extensions){const h=this.getKey(m.identifier,m.version);a.error?this.addExtensionWithKey(h,a.profileLocation):(this.removeExtensionWithKey(h,a.profileLocation),this.allExtensions.has(h)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),w.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(P=>{P?E.push(P):this.logService.info("Extension not found at the location",m.location.toString())},P=>this.logService.error(P)))))}try{await Promise.all(w),E.length&&await this.uninstallExtensionsNotInProfiles(E)}catch(m){this.logService.error(m)}}onDidFilesChange(a){for(const E of this.userDataProfilesService.profiles)a.contains(E.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(E.extensionsResource)}async onDidExtensionsProfileChange(a){const E=[],w=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(a),h=new Set,P=new Set;for(const[I,p]of this.allExtensions)p.has(a)&&P.add(I);for(const I of m){const p=this.getKey(I.identifier,I.version);h.add(p),P.has(p)||(E.push(I.identifier),this.addExtensionWithKey(p,a))}for(const I of P)if(!h.has(I)){const p=this.fromKey(I);p&&(w.push(p.identifier),this.removeExtensionWithKey(I,a))}(E.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E.length?{extensions:E,profileLocation:a}:void 0,removed:w.length?{extensions:w,profileLocation:a}:void 0})}async populateExtensionsFromProfile(a){const E=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const w of E)this.addExtensionWithKey(this.getKey(w.identifier,w.version),a)}async uninstallExtensionsNotInProfiles(a){a||(a=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(w=>!this.allExtensions.has(this.getKey(w.identifier,w.manifest.version)))),a.length&&await this.extensionManagementService.markAsUninstalled(...a)}addExtensionWithKey(a,E){let w=this.allExtensions.get(a);w||this.allExtensions.set(a,w=new k.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),w.add(E)}removeExtensionWithKey(a,E){const w=this.allExtensions.get(a);w&&w.delete(E),w?.size||this.allExtensions.delete(a)}getKey(a,E){return`${T.ExtensionIdentifier.toKey(a.id)}@${E}`}fromKey(a){const[E,w]=(0,A.getIdAndVersion)(a);return w?{identifier:{id:E},version:w}:void 0}}e.ExtensionsWatcher=b}),define(ie[146],ne([0,1,117,41]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,T,b,f,a,E,w){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,b)&&(0,O.getTelemetryLevel)(f)===3){const h=await(0,N.getServiceMachineId)(b,a,E);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=w.machineId||h}return m}e.resolveMarketplaceHeaders=k}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let I=class extends h.LanguagePackBaseService{constructor(v,u,g,i){super(g),this.extensionManagementService=v,this.logService=i,this.cache=this._register(new p(u,i)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(v,u){const i=(await this.cache.getLanguagePacks())[u];if(!i){this.logService.warn(`No language pack found for ${u}`);return}const s=i.translations[v];return s?P.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.cache.getLanguagePacks(),u=Object.keys(v).map(g=>{const i=v[g];return{...this.createQuickPickItem(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return u.push(this.createQuickPickItem("en","English")),u.sort((g,i)=>g.label.localeCompare(i.label)),u}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const u=await this.cache.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(i=>(0,w.areSameExtensions)(i.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(u);return!(0,O.equals)(Object.keys(v),Object.keys(g))}};e.NativeLanguagePackService=I,e.NativeLanguagePackService=I=me([re(0,E.IExtensionManagementService),re(1,a.INativeEnvironmentService),re(2,E.IExtensionGalleryService),re(3,m.ILogService)],I);let p=class extends A.Disposable{constructor(v,u){super(),this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(u=>{Object.keys(u).forEach(g=>delete u[g]),this.createLanguagePacksFromExtensions(u,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,g);Object.keys(v).forEach(g=>this.updateHash(v[g]))}createLanguagePacksFromExtension(v,u){const g=u.identifier,i=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of i)if(u.location.scheme===T.Schemas.file&&c(s)){let t=v[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},v[s.languageId]=t);const n=t.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,g))[0];n?n.version=u.manifest.version:t.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,b.join)(u.location.fsPath,r.path)}}updateHash(v){if(v){const u=(0,N.createHash)("md5");for(const g of v.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=u.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return f.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=v(g),g)).then(g=>{for(const s of Object.keys(g))g[s]||delete g[s];this.languagePacks=g,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),f.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>u,g=>this.logService.error(g))})}};p=me([re(0,a.INativeEnvironmentService),re(1,m.ILogService)],p);function c(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const v of S.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",b="https://0.0.0.0/ping";async function f(E,w,m){const h=await(0,N.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),P=await(0,N.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new h.AppInsightsCore,p=new P.PostChannel,c={instrumentationKey:E,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(m){c.extensionConfig={};const S={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};c.extensionConfig[p.identifier]=S}return I.initialize(c,[]),I.addTelemetryInitializer(S=>{S.ext=S.ext??{},S.ext.web=S.ext.web??{},S.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',w&&(S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),I}class a{constructor(w,m,h,P,I){this._isInternalTelemetry=w,this._eventPrefix=m,this._defaultData=h,this._xhrOverride=I,this.endPointUrl=T,this.endPointHealthUrl=b,this._defaultData||(this._defaultData={}),typeof P=="function"?this._aiCoreOrKey=P():this._aiCoreOrKey=P,this._asyncAiCore=null}_withAIClient(w){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=f(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(m=>{w(m)},m=>{(0,O.onUnexpectedError)(m),console.error(m)})}}log(w,m){if(!this._aiCoreOrKey)return;m=(0,k.mixin)(m,this._defaultData),m=(0,A.validateTelemetryData)(m);const h=this._eventPrefix+"/"+w;try{this._withAIClient(P=>{P.pluginVersionString=m?.properties.version??"Unknown",P.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(m=>{m.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,S,v){this._configurationService=S,this._productService=v,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=c.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi")),u.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(u=>{(u.affectsConfiguration(m.TELEMETRY_SETTING_ID)||u.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||u.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(c,S){this._experimentProperties[c]=S}_updateTelemetryLevel(){let c=(0,h.getTelemetryLevel)(this._configurationService);const S=this._productService.enabledTelemetryLevels;if(S){this._sendErrorTelemetry=this.sendErrorTelemetry?S.error:!1;const v=S.usage?3:S.error?2:0;c=Math.min(c,v)}this._telemetryLevel=c}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(c,S,v){this._telemetryLevel<S||(v=(0,O.mixin)(v,this._experimentProperties),v=(0,h.cleanData)(v,this._cleanupPatterns),v=(0,O.mixin)(v,this._commonProperties),this._appenders.forEach(u=>u.log(c,v)))}publicLog(c,S){this._log(c,3,S)}publicLog2(c,S){this.publicLog(c,S)}publicLogError(c,S){this._sendErrorTelemetry&&this._log(c,2,S)}publicLogError2(c,S){this.publicLogError(c,S)}};e.TelemetryService=P,e.TelemetryService=P=me([re(1,b.IConfigurationService),re(2,E.IProductService)],P);function I(){const p=(0,T.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=k.isWeb?"":(0,T.localize)(3,null),v=(0,T.localize)(4,null),u=(0,T.localize)(5,null),g=(0,T.localize)(6,null),i=(0,T.localize)(7,null),s=`
|       | ${v} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${p} ${c} ${S}

&nbsp;

${i}
${s}

&nbsp;

${t}
`}w.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:I(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,T.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,T.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(E,w){const m=await w.request(E,O.CancellationToken.None),h=(await(0,N.streamToBuffer)(m.stream)).toString(),P=m.res.statusCode??200;return{headers:m.res.headers,statusCode:P,responseData:h}}async function b(E){const w={method:E.type,headers:E.headers};return new Promise((h,P)=>{const I=k.request(E.url??"",w,p=>{p.on("data",function(c){h({headers:p.headers,statusCode:p.statusCode??200,responseData:c.toString()})}),p.on("error",function(c){P(c)})});I.write(E.data,p=>{p&&P(p)}),I.end()})}async function f(E,w,m){const h=typeof w.data=="string"?w.data:new TextDecoder().decode(w.data),P={type:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data).toString()},url:w.urlString,data:h};try{const I=E?await T(P,E):await b(P);m(I.statusCode,I.headers,I.responseData)}catch{m(0,{})}}class a extends A.AbstractOneDataSystemAppender{constructor(w,m,h,P,I){const p={sendPOST:(c,S)=>{f(w,c,S)}};super(m,h,P,I,p)}}e.OneDataSystemAppender=a}),define(ie[152],ne([0,1,16,24]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,T){const b=Object.create(null),f=(E,w)=>{const m=JSON.parse(E);b[w]=m};if(T){const E=[],w=await O.Promises.readdir(T);for(const h of w)try{(await O.Promises.stat((0,N.join)(T,h))).isDirectory()&&E.push(h)}catch{}const m=[];for(const h of E)(await O.Promises.readdir((0,N.join)(T,h))).filter(I=>I==="telemetry.json").length===1&&m.push(h);for(const h of m){const P=(await O.Promises.readFile((0,N.join)(T,h,"telemetry.json"))).toString();f(P,h)}}let a=(await O.Promises.readFile((0,N.join)(A,"telemetry-core.json"))).toString();return f(a,"vscode-core"),a=(await O.Promises.readFile((0,N.join)(A,"telemetry-extensions.json"))).toString(),f(a,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(ie[153],ne([0,1,12,84,25]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function A(b,f){let a=b.getItem(k.machineIdKey);return(typeof a!="string"||N.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.getMachineId)(f.error.bind(f))),a}e.resolveMachineId=A;async function T(b,f){let a=b.getItem(k.sqmIdKey);return typeof a!="string"&&(a=await(0,O.getSqmMachineId)(f.error.bind(f))),a}e.resolveSqmId=T}),define(ie[22],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let E=class{constructor(m){this._fileService=m,this._dispooables=new f.DisposableStore,this._limit=2**16;const h=new Map,P=I=>{let p=h.get(I.scheme);return p===void 0&&(p=m.hasProvider(I)&&!this._fileService.hasCapability(I,1024),h.set(I.scheme,p)),p};this._dispooables.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(I=>{h.delete(I.scheme)})),this.extUri=new A.ExtUri(P),this._canonicalUris=new T.SkipList((I,p)=>this.extUri.compare(I,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,A.normalizePath)(m));const h=this._canonicalUris.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new a(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((P,I)=>P[1].time<I[1].time?1:P[1].time>I[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let P=0;P<h;P++)this._canonicalUris.set(m[P][0],m[P][1].touch())}};e.UriIdentityService=E,e.UriIdentityService=E=me([re(0,k.IFileService)],E),(0,O.registerSingleton)(N.IUriIdentityService,E,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends O.Disposable{constructor(a,E,w,m,h,P){super(),this.fileSystemScheme=a,this.fileSystemProvider=E,this.userDataScheme=w,this.userDataProfilesService=m,this.uriIdentityService=h,this.logService=P,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new T.ResourceSet(I=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(I))),this.updateAtomicReadWritesResources(),this._register(m.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(I=>this.handleFileChanges(I)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,E){return this.fileSystemProvider.open(this.toFileSystemResource(a),E)}close(a){return this.fileSystemProvider.close(a)}read(a,E,w,m,h){return this.fileSystemProvider.read(a,E,w,m,h)}write(a,E,w,m,h){return this.fileSystemProvider.write(a,E,w,m,h)}watch(a,E){this.watchResources.set(a,a);const w=this.fileSystemProvider.watch(this.toFileSystemResource(a),E);return(0,O.toDisposable)(()=>{this.watchResources.delete(a),w.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,E,w){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(E),w)}readFile(a,E){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),E)}readFileStream(a,E,w){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),E,w)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,E,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),E,w)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,E){return this.fileSystemProvider.delete(this.toFileSystemResource(a),E)}copy(a,E,w){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(E),w);throw new Error("copy not supported")}cloneFile(a,E){if((0,k.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(E));throw new Error("clone not supported")}handleFileChanges(a){const E=[];for(const w of a){if(w.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(w.resource);this.watchResources.findSubstr(m)&&E.push({resource:m,type:w.type,cId:w.cId})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(G,e,N,O,k,A,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function a(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=a;function E(n){return typeof n?.id=="string"&&!a(n)&&!m(n)}e.isEmptyWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=w;function m(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function h(n){const r=n;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=h;var P;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(P||(e.WorkbenchState=P={}));function I(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=I;function p(n){const r=n;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=p;class c{constructor(r,o,l,D,R){this._id=r,this._transient=l,this._configuration=D,this._ignorePathCasing=R,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class S{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function v(n){return new S({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(n,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function g(n){let r;return T.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=g,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function s(n,r){return!u(n,r)&&!g(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,O.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var v;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function u(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&T.URI.isUri(r.location)&&T.URI.isUri(r.globalStorageHome)&&T.URI.isUri(r.settingsResource)&&T.URI.isUri(r.keybindingsResource)&&T.URI.isUri(r.tasksResource)&&T.URI.isUri(r.snippetsHome)&&T.URI.isUri(r.extensionsResource))}e.isUserDataProfile=u,e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function g(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:T.URI.revive(n.location).with({scheme:r}),globalStorageHome:T.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:T.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:T.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:T.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:T.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:T.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:T.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=g;function i(n,r,o,l,D,R){return{id:n,name:r,location:o,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:R&&D?.useDefaultFlags?.globalState?R.globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:R&&D?.useDefaultFlags?.settings?R.settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:R&&D?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:R&&D?.useDefaultFlags?.tasks?R.tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:R&&D?.useDefaultFlags?.snippets?R.snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:R&&D?.useDefaultFlags?.extensions?R.extensionsResource:(0,A.joinPath)(o,"extensions.json"),cacheHome:(0,A.joinPath)(l,n),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=i;let s=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,l,D){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=l,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),o=[r];if(this.enabled)try{for(const R of this.getStoredProfiles()){if(!R.name||!(0,S.isString)(R.name)||!R.location){this.logService.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(i((0,A.basename)(R.location),R.name,R.location,this.profilesCacheHome,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},r))}}catch(R){this.logService.error(R)}const l=new h.ResourceMap,D=new Map;if(o.length)try{const R=this.getStoredProfileAssociations();if(R.workspaces)for(const[y,L]of Object.entries(R.workspaces)){const $=T.URI.parse(y),te=o.find(Z=>Z.id===L);te&&l.set($,te)}if(R.emptyWindows)for(const[y,L]of Object.entries(R.emptyWindows)){const $=o.find(te=>te.id===L);$&&D.set(y,$)}}catch(R){this.logService.error(R)}this._profilesObject={profiles:o,workspaces:l,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const r=i("__default__profile__",(0,b.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",l=new RegExp(`${(0,c.escapeRegExpCharacters)(o)}\\s(\\d+)`);let D=0;for(const y of this.profiles){const L=l.exec(y.name),$=L?parseInt(L[1]):0;D=$>D?$:D}const R=`${o} ${D+1}`;return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),R,{transient:!0},r)}async createNamedProfile(r,o,l){return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),r,o,l)}async createProfile(r,o,l,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const R=await this.doCreateProfile(r,o,l);return D&&await this.setProfileForWorkspace(D,R),R}async doCreateProfile(r,o,l){if(!(0,S.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(o);return D||(D=(async()=>{try{const R=this.profiles.find($=>$.name===o||$.id===r);if(R)return R;const y=i(r,o,(0,A.joinPath)(this.profilesHome,r),this.profilesCacheHome,l,this.defaultProfile);await this.fileService.createFolder(y.location);const L=[];return this._onWillCreateProfile.fire({profile:y,join($){L.push($)}}),await I.Promises.settled(L),this.updateProfiles([y],[],[]),y}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,D)),D}async updateProfile(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(D=>D.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.profilesCacheHome,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[l]),l}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(D=>D.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:o,join(D){l.push(D)}});try{await Promise.allSettled(l)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(D){(0,a.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(D=>D.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,l)}unsetWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return T.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(r){return(0,m.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,m.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,l){const D=[...this.profiles,...r],R=[];this.transientProfilesObject.profiles=[];for(let y of D)y.isDefault||o.some(L=>y.id===L.id)||(y=l.find(L=>y.id===L.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):R.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(R),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,l)}triggerProfilesChanges(r,o,l){this._onDidChangeProfiles.fire({added:r,removed:o,updated:l,all:this.profiles})}updateWorkspaceAssociation(r,o,l){l=o?.isTransient?!0:l,l||this.updateWorkspaceAssociation(r,void 0,!0);const D=this.getWorkspace(r),R=l?this.transientProfilesObject:this.profilesObject;T.URI.isUri(D)?(R.workspaces.delete(D),o&&R.workspaces.set(D,o)):(R.emptyWindows.delete(D),o&&R.emptyWindows.set(D,o)),l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[l,D]of this.profilesObject.workspaces.entries())r[l.toString()]=D.id;const o={};for(const[l,D]of this.profilesObject.emptyWindows.entries())o[l.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const o={},l=this.createDefaultProfile();if(r.workspaces)for(const[R,y]of Object.entries(r.workspaces)){const L=T.URI.parse(y);o[R]=this.uriIdentityService.extUri.isEqual(L,l.location)?l.id:this.uriIdentityService.extUri.basename(L)}const D={};if(r.emptyWindows)for(const[R,y]of Object.entries(r.emptyWindows)){const L=T.URI.parse(y);D[R]=this.uriIdentityService.extUri.isEqual(L,l.location)?l.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=me([re(0,f.IEnvironmentService),re(1,a.IFileService),re(2,P.IUriIdentityService),re(3,w.ILogService)],s);class t extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let u=class extends b.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,o,l,D,R,y){super(),this.galleryService=r,this.telemetryService=o,this.uriIdentityService=l,this.logService=D,this.productService=R,this.userDataProfilesService=y,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(l=>(0,m.isTargetPlatformCompatible)(l,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const D=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:R})=>(0,h.areSameExtensions)(R,r.identifier));if(D?.local)return D?.local;throw D?.error?D.error:new m.ExtensionManagementError(`Unknown error while installing extension ${r.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(w.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(r.map(async({extension:D,options:R})=>{try{const y=await this.checkAndGetCompatibleVersion(D,!!R?.installGivenVersion,!!R?.installPreReleaseVersion);l.push({...y,options:R})}catch(y){o.push({identifier:D.identifier,operation:2,source:D,error:y})}})),l.length&&o.push(...await this.installExtensions(l));for(const D of o)D.error&&(this.logService.error("Failed to install extension.",D.identifier.id),this.logService.error(D.error),D.source&&!E.URI.isUri(D.source)&&s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(D.source),error:D.error}));return o}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtension(r,o)}async toggleAppliationScope(r,o){if((0,P.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let l=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(l=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const D of this.userDataProfilesService.profiles){const R=(await this.getInstalled(1,D.extensionsResource)).find(y=>(0,h.areSameExtensions)(y.identifier,r.identifier));R?this._onDidUpdateExtensionMetadata.fire(R):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:D.extensionsResource})}return l}else{const l=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtensions(r){const o=[];return await Promise.allSettled(r.map(async l=>{try{const D=await this.installExtension(l,(R,y)=>r.some(L=>(0,h.adoptToGalleryExtensionId)(y.identifier.id)===(0,h.getGalleryExtensionId)(L.manifest.publisher,L.manifest.name))?!1:this.canWaitForTask(R,y));o.push(...D)}catch(D){o.push({identifier:{id:(0,h.getGalleryExtensionId)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:D})}})),this._onDidInstallExtensions.fire(o),o}async installExtension({manifest:r,extension:o,options:l},D){const R=l.isApplicationScoped||l.isBuiltin||(0,P.isApplicationScopedExtension)(r),y={...l,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(o)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:R,profileLocation:R?this.userDataProfilesService.defaultProfile.extensionsResource:l.profileLocation??this.getCurrentExtensionsManifestLocation()},L=fe=>`${h.ExtensionKey.create(fe).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!E.URI.isUri(o)){const fe=this.installingExtensions.get(L(o));if(fe)return this.logService.info("Extensions is already requested to install",o.identifier.id),await fe.task.waitUntilTaskIsFinished(),[]}const $=[],te=[],Z=[],oe=this.createInstallExtensionTask(r,o,y);E.URI.isUri(o)||this.installingExtensions.set(L(o),{task:oe,waitingTasks:[]}),this._onInstallExtension.fire({identifier:oe.identifier,source:o,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",oe.identifier.id),$.push({task:oe,manifest:r});let se=!1;try{if(y.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const le=await this.getAllDepsAndPackExtensions(oe.identifier,r,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),ae=await this.getInstalled(void 0,y.profileLocation),W={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:H,manifest:V}of(0,N.distinct)(le,({gallery:_})=>_.identifier.id)){se=se||!!V.extensionDependencies?.some(K=>(0,h.areSameExtensions)({id:K},oe.identifier));const _=L(H),j=this.installingExtensions.get(_);if(j){if(D(oe,j.task)){const K=j.task.identifier;this.logService.info("Waiting for already requested installing extension",K.id,oe.identifier.id),j.waitingTasks.push(oe),te.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,X=>X.some(J=>(0,h.areSameExtensions)(J.identifier,K)))).then(X=>{if(this.logService.info("Finished waiting for already requested installing extension",K.id,oe.identifier.id),!X.find(M=>(0,h.areSameExtensions)(M.identifier,K))?.local)throw new Error(`Extension ${K.id} is not installed`)}))}}else if(!ae.some(({identifier:K})=>(0,h.areSameExtensions)(K,H.identifier))){const K=this.createInstallExtensionTask(V,H,W);this.installingExtensions.set(_,{task:K,waitingTasks:[oe]}),this._onInstallExtension.fire({identifier:K.identifier,source:H,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",K.identifier.id,oe.identifier.id),$.push({task:K,manifest:V})}}}catch(le){if(E.URI.isUri(oe.source))(0,N.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",oe.identifier.id,le.message),(0,N.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",oe.identifier.id,le.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),le}const fe=$.reduce((le,{task:ae,manifest:W})=>(le.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:W}),le),new Map);for(;fe.size;){let le;const ae=[...fe.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(H=>fe.has(H.toLowerCase())));ae.length?le=fe.size===1?ae:ae.filter(({task:W})=>!(W===oe&&!se)):(this.logService.info("Found extensions with circular dependencies",ae.map(({task:W})=>W.identifier.id)),le=[...fe.values()]),await this.joinAllSettled(le.map(async({task:W})=>{const H=new Date().getTime();try{const V=await W.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(V,W.source,y,k.CancellationToken.None))),!E.URI.isUri(W.source)){const _=W.operation===3,j=_?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(s(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:j}),f.isWeb&&W.operation!==3)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}Z.push({local:V,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw this.logService.error("Error while installing the extension",W.identifier.id,(0,A.getErrorMessage)(V)),V}finally{fe.delete(W.identifier.id.toLowerCase())}}))}return te.length&&await this.joinAllSettled(te),Z.forEach(({identifier:le})=>this.logService.info("Extension installed successfully:",le.id)),Z}catch(fe){if($.forEach(({task:le})=>le.cancel()),Z.length)try{const le=await Promise.allSettled(Z.map(({local:ae})=>this.createUninstallExtensionTask(ae,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let ae=0;ae<le.length;ae++){const W=le[ae],{identifier:H}=Z[ae];W.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",H.id):this.logService.warn("Rollback: Error while uninstalling extension",H.id,(0,A.getErrorMessage)(W.reason))}}catch(le){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(le),Z.map(({identifier:ae})=>ae.id))}return $.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:y.context,profileLocation:y.profileLocation,error:fe}))}finally{for(const{task:fe}of $)fe.source&&!E.URI.isUri(fe.source)&&this.installingExtensions.delete(L(fe.source))}}canWaitForTask(r,o){for(const[,{task:l,waitingTasks:D}]of this.installingExtensions.entries())if(l===r&&(D.includes(o)||D.some(R=>this.canWaitForTask(R,o)))||l===o&&D[0]&&!this.canWaitForTask(r,D[0]))return!1;return!0}async joinAllSettled(r){const o=[],l=[],D=await Promise.allSettled(r);for(const R of D)R.status==="fulfilled"?o.push(R.value):l.push(R.reason);if(l.length)throw g(l);return o}async getAllDepsAndPackExtensions(r,o,l,D,R){if(!this.galleryService.isEnabled())return[];const y=await this.getInstalled(void 0,R),L=[],$=[],te=async(Z,oe)=>{L.push(Z);const se=oe.extensionDependencies||[],fe=[...se];if(oe.extensionPack){const le=l?y.find(ae=>(0,h.areSameExtensions)(ae.identifier,Z)):void 0;for(const ae of oe.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(W=>(0,h.areSameExtensions)({id:W},{id:ae}))||fe.every(W=>!(0,h.areSameExtensions)({id:W},{id:ae}))&&fe.push(ae)}if(fe.length){const le=fe.filter(ae=>L.every(W=>!(0,h.areSameExtensions)(W,{id:ae})));if(le.length){const ae=await this.galleryService.getExtensions(le.map(W=>({id:W,preRelease:D})),k.CancellationToken.None);for(const W of ae){if(L.find(_=>(0,h.areSameExtensions)(_,W.identifier)))continue;const H=se.some(_=>(0,h.areSameExtensions)({id:_},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,D)}catch(_){if(H)throw _;this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.getErrorMessage)(_));continue}$.push({gallery:V.extension,manifest:V.manifest}),await te(V.extension.identifier,V.manifest)}}}};return await te(r,o),$}async checkAndGetCompatibleVersion(r,o,l){let D;const R=await this.getExtensionsControlManifest();if(R.malicious.some($=>(0,h.areSameExtensions)(r.identifier,$)))throw new m.ExtensionManagementError(w.localize(1,null,r.identifier.id),m.ExtensionManagementErrorCode.Malicious);const y=R.deprecated[r.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),D=(await this.galleryService.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0],!D)throw new m.ExtensionManagementError(w.localize(2,null,r.identifier.id,y.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const $=await this.getTargetPlatform();throw new m.ExtensionManagementError(w.localize(3,null,r.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)($)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.getCompatibleVersion(r,o,l),!D)throw!l&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],k.CancellationToken.None))[0]?new m.ExtensionManagementError(w.localize(4,null,r.displayName??r.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(w.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",D.identifier.id);const L=await this.galleryService.getManifest(D,k.CancellationToken.None);if(L===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${D.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(L.version!==D.version)throw new m.ExtensionManagementError(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:L}}async getCompatibleVersion(r,o,l){const D=await this.getTargetPlatform();let R=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==l&&(R=(await this.galleryService.getExtensions([{...r.identifier,preRelease:l}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null),!R&&await this.galleryService.isExtensionCompatible(r,l,D)&&(R=r),R||(o?R=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null:R=await this.galleryService.getCompatibleExtension(r,l,D)),R}async uninstallExtension(r,o){const l={...o,profileLocation:r.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},D=Z=>`${Z.id.toLowerCase()}${l.versionOnly?`-${r.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,R=this.uninstallingExtensions.get(D(r.identifier));if(R)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),R.waitUntilTaskIsFinished();const y=Z=>{const oe=this.createUninstallExtensionTask(Z,l);return this.uninstallingExtensions.set(D(oe.extension.identifier),oe),l.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this._onUninstallExtension.fire({identifier:Z.identifier,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped}),oe},L=(Z,oe)=>{oe?l.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString(),oe.message):this.logService.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,oe.message):l.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(Z),error:oe}),this._onDidUninstallExtension.fire({identifier:Z.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped})},$=[],te=[];try{$.push(y(r));const Z=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const oe=this.getAllPackExtensionsToUninstall(r,Z);for(const se of oe)this.uninstallingExtensions.has(D(se.identifier))?this.logService.info("Extensions is already requested to uninstall",se.identifier.id):$.push(y(se))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.checkForDependents($.map(oe=>oe.extension),Z,r),await this.joinAllSettled($.map(async oe=>{try{if(await oe.run(),await this.joinAllSettled(this.participants.map(se=>se.postUninstall(oe.extension,l,k.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.galleryService.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}L(oe.extension)}catch(se){const fe=se instanceof m.ExtensionManagementError?se:new m.ExtensionManagementError((0,A.getErrorMessage)(se),m.ExtensionManagementErrorCode.Internal);throw L(oe.extension,fe),fe}finally{te.push(oe)}}))}catch(Z){const oe=Z instanceof m.ExtensionManagementError?Z:new m.ExtensionManagementError((0,A.getErrorMessage)(Z),m.ExtensionManagementErrorCode.Internal);for(const se of $){try{se.cancel()}catch{}te.includes(se)||L(se.extension,oe)}throw oe}finally{for(const Z of $)this.uninstallingExtensions.delete(D(Z.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}checkForDependents(r,o,l){for(const D of r){const R=this.getDependents(D,o);if(R.length){const y=R.filter(L=>!r.some($=>(0,h.areSameExtensions)($.identifier,L.identifier)));if(y.length)throw new Error(this.getDependentsErrorMessage(D,y,l))}}}getDependentsErrorMessage(r,o,l){return l===r?o.length===1?w.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?w.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):w.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?w.localize(9,null,l.manifest.displayName||l.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?w.localize(10,null,l.manifest.displayName||l.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):w.localize(11,null,l.manifest.displayName||l.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,l=[]){if(l.indexOf(r)!==-1)return[];l.push(r);const D=r.manifest.extensionPack?r.manifest.extensionPack:[];if(D.length){const R=o.filter(L=>!L.isBuiltin&&D.some($=>(0,h.areSameExtensions)({id:$},L.identifier))),y=[];for(const L of R)y.push(...this.getAllPackExtensionsToUninstall(L,o,l));return[...R,...y]}return[]}getDependents(r,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(D=>(0,h.areSameExtensions)({id:D},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=u,e.AbstractExtensionManagementService=u=me([re(0,m.IExtensionGalleryService),re(1,c.ITelemetryService),re(2,S.IUriIdentityService),re(3,I.ILogService),re(4,p.IProductService),re(5,v.IUserDataProfilesService)],u);function g(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=g;function i(n){if(n instanceof m.ExtensionManagementError)return n;if(n instanceof m.ExtensionGalleryError){const o=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const r=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}e.toExtensionManagementError=i;function s(n,r,{extensionData:o,verificationStatus:l,duration:D,error:R,durationSinceUpdate:y}){let L,$;(0,a.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(L=m.ExtensionManagementErrorCode.Signature,$=l),l="Unverified")),R&&(R instanceof m.ExtensionManagementError||R instanceof m.ExtensionGalleryError?(L=R.code,R.code===m.ExtensionManagementErrorCode.Signature&&($=R.message)):L=m.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...o,verificationStatus:l,success:!R,duration:D,errorcode:L,errorcodeDetail:$,durationSinceUpdate:y})}class t{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>new Promise((o,l)=>{const D=r.onCancellationRequested(()=>{D.dispose(),l(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var S;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(S||(e.ExtensionsProfileScanningErrorCode=S={}));class v extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let u=class extends k.Disposable{constructor(t,n,r,o,l,D){super(),this.extensionsLocation=t,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=l,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(t,n){return this.withProfileExtensions(t,void 0,n)}async addExtensionsToProfile(t,n){const r=[],o=[];try{return await this.withProfileExtensions(n,l=>{const D=[];for(const R of l)t.some(([y])=>(0,a.areSameExtensions)(y.identifier,R.identifier)&&y.manifest.version!==R.version)?r.push(R):D.push(R);for(const[R,y]of t){const L=D.findIndex(te=>(0,a.areSameExtensions)(te.identifier,R.identifier)&&te.version===R.manifest.version),$={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:y};L===-1?(o.push($),D.push($)):D.splice(L,1,$)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),D}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),o}catch(l){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:l,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const r=[];return await this.withProfileExtensions(n,o=>{const l=[];for(const D of o){const R=t.find(([y])=>(0,a.areSameExtensions)(y.identifier,D.identifier)&&y.manifest.version===D.version);R&&(D.metadata={...D.metadata,...R[1]},r.push(D)),l.push(D)}return l}),r}async removeExtensionFromProfile(t,n){const r=[];try{await this.withProfileExtensions(n,o=>{const l=[];for(const D of o)(0,a.areSameExtensions)(D.identifier,t.identifier)?r.push(D):l.push(D);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),l}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async withProfileExtensions(t,n,r){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],l;try{const D=await this.fileService.readFile(t);l=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,E.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(l=await this.migrateFromOldDefaultProfileExtensionsLocation()),!l&&r?.bailOutWhenFileNotFound)throw new v((0,p.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.reportAndThrowInvalidConentError(t);let D=!1;for(const R of l){g(R)||this.reportAndThrowInvalidConentError(t);let y;if((0,I.isString)(R.relativeLocation)&&R.relativeLocation)y=this.resolveExtensionLocation(R.relativeLocation);else if((0,I.isString)(R.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{y=b.URI.revive(R.location);const L=this.toRelativePath(y);L&&(D=!0,R.relativeLocation=L)}(0,I.isUndefined)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(D=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:y,version:R.version,metadata:R.metadata})}D&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(l)))}if(n){o=n(o);const D=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(D)))}return o})}reportAndThrowInvalidConentError(t){const n=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(l){if((0,E.toFileOperationResult)(l)===1)return;throw l}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(D=>g(D))?o=l:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.logService.error(l)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(l){if((0,E.toFileOperationResult)(l)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw l}try{await this.fileService.del(t)}catch(l){(0,E.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{await this.fileService.del(n)}catch(l){(0,E.toFileOperationResult)(l)!==1&&this.logService.error(l)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let n=this.resourcesAccessQueueMap.get(t);return n||(n=new N.Queue,this.resourcesAccessQueueMap.set(t,n)),n}};e.AbstractExtensionsProfileScannerService=u,e.AbstractExtensionsProfileScannerService=u=me([re(1,E.IFileService),re(2,h.IUserDataProfilesService),re(3,P.IUriIdentityService),re(4,c.ITelemetryService),re(5,m.ILogService)],u);function g(s){return(0,I.isObject)(s)&&(0,f.isIExtensionIdentifier)(s.identifier)&&(i(s.location)||(0,I.isString)(s.location)&&s.location)&&((0,I.isUndefined)(s.relativeLocation)||(0,I.isString)(s.relativeLocation))&&s.version&&(0,I.isString)(s.version)}function i(s){return s?(0,I.isString)(s.path)&&(0,I.isString)(s.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v,u,g,i,s,t,n,r,o,l,D,R,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(ae){function W(H,V){if(H===V)return!0;const _=Object.keys(H),j=new Set;for(const K of Object.keys(V))j.add(K);if(_.length!==j.size)return!1;for(const K of _){if(H[K]!==V[K])return!1;j.delete(K)}return j.size===0}ae.equals=W})($||(e.Translations=$={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let te=class extends a.Disposable{constructor(W,H,V,_,j,K,X,J,M,F,d,C){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=H,this.extensionsControlLocation=V,this.currentProfile=_,this.userDataProfilesService=j,this.extensionsProfileScannerService=K,this.fileService=X,this.logService=J,this.environmentService=M,this.productService=F,this.uriIdentityService=d,this.instantiationService=C,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,H,V){const[_,j]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(H)]),K=V?await this.scanExtensionsUnderDevelopment(W,[..._,...j]):[];return this.dedupExtensions(_,j,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const H=[];H.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),H.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[V,_]=await Promise.all(H);return this.applyScanOptions([...V,..._],0,W,!1)}async scanUserExtensions(W){const H=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",H);const V=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,_=await this.createExtensionScannerInput(H,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),j=W.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let K;try{K=await j.scanExtensions(_)}catch(X){if(X instanceof D.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),K=await j.scanExtensions(_);else throw X}return K=await this.applyScanOptions(K,1,W,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(W,H){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===E.Schemas.file).map(async _=>{const j=await this.createExtensionScannerInput(_,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(j)).map(X=>(X.type=H.find(J=>(0,u.areSameExtensions)(J.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,j)))}))).flat();return this.applyScanOptions(V,"development",W,!0)}return[]}async scanExistingExtension(W,H,V){const _=await this.createExtensionScannerInput(W,!1,H,!0,V.language,!0,void 0),j=await this.extensionsScanner.scanExtension(_);return!j||!V.includeInvalid&&!j.isValid?null:j}async scanOneOrMultipleExtensions(W,H,V){const _=await this.createExtensionScannerInput(W,!1,H,!0,V.language,!0,void 0),j=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions(j,H,V,!0)}async scanMetadata(W){const H=(0,h.joinPath)(W,"package.json"),V=(await this.fileService.readFile(H)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,H){const V=(0,h.joinPath)(W,"package.json"),_=(await this.fileService.readFile(V)).value.toString(),j=JSON.parse(_);H.isMachineScoped===!1&&delete H.isMachineScoped,H.isBuiltin===!1&&delete H.isBuiltin,j.__metadata={...j.__metadata,...H},await this.fileService.writeFile((0,h.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify(j,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof D.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(H=>[H,H.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(H){(0,s.toFileOperationResult)(H)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(H))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,H,V,_){return V.includeAllVersions||(W=this.dedupExtensions(H===0?W:void 0,H===1?W:void 0,H==="development"?W:void 0,await this.getTargetPlatform(),_)),V.includeInvalid||(W=W.filter(j=>j.isValid)),W.sort((j,K)=>{const X=w.basename(j.location.fsPath),J=w.basename(K.location.fsPath);return X<J?-1:X>J?1:0})}dedupExtensions(W,H,V,_,j){const K=(J,M,F)=>{if(J.isValid&&!M.isValid)return!1;if(J.isValid===M.isValid){if(j&&P.gt(J.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(P.eq(J.manifest.version,M.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===_)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.logService.warn(`Overwriting user extension ${J.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${M.location.path}.`),!0},X=new g.ExtensionIdentifierMap;return W?.forEach(J=>{const M=X.get(J.identifier.id);(!M||K(M,J,!1))&&X.set(J.identifier.id,J)}),H?.forEach(J=>{const M=X.get(J.identifier.id);if(!M&&W&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!M||K(M,J,!1))&&X.set(J.identifier.id,J)}),V?.forEach(J=>{const M=X.get(J.identifier.id);(!M||K(M,J,!0))&&X.set(J.identifier.id,J),X.set(J.identifier.id,J)}),[...X.values()]}async scanDefaultSystemExtensions(W,H){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),j=await(W&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",j.length),j}async scanDevSystemExtensions(W,H){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=H?await this.getBuiltInExtensionControl():{},j=[],K=c.URI.file(w.normalize(w.join(E.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const M=_[J.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":j.push((0,h.joinPath)(K,J.name));break;default:j.push(c.URI.file(M));break}}const X=await Promise.all(j.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,H,V,_,j,K,X){const J=await this.getTranslations(j??m.language),M=await this.getMtime(W),F=H&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,d=F?await this.getMtime(F):void 0;return new Z(W,M,F,d,H,X,V,_,K,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,j,J)}async getMtime(W){try{const H=await this.fileService.stat(W);if(typeof H.mtime=="number")return H.mtime}catch{}}};e.AbstractExtensionsScannerService=te,e.AbstractExtensionsScannerService=te=me([re(4,R.IUserDataProfilesService),re(5,D.IExtensionsProfileScannerService),re(6,s.IFileService),re(7,n.ILogService),re(8,v.IEnvironmentService),re(9,r.IProductService),re(10,y.IUriIdentityService),re(11,t.IInstantiationService)],te);class Z{constructor(W,H,V,_,j,K,X,J,M,F,d,C,x,U,q){this.location=W,this.mtime=H,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=_,this.profile=j,this.profileScanOptions=K,this.type=X,this.excludeObsolete=J,this.validate=M,this.productVersion=F,this.productDate=d,this.productCommit=C,this.devMode=x,this.language=U,this.translations=q}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,H){return(0,h.isEqual)(W.location,H.location)&&W.mtime===H.mtime&&(0,h.isEqual)(W.applicationExtensionslocation,H.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&W.profile===H.profile&&k.equals(W.profileScanOptions,H.profileScanOptions)&&W.type===H.type&&W.excludeObsolete===H.excludeObsolete&&W.validate===H.validate&&W.productVersion===H.productVersion&&W.productDate===H.productDate&&W.productCommit===H.productCommit&&W.devMode===H.devMode&&W.language===H.language&&$.equals(W.translations,H.translations)}}e.ExtensionScannerInput=Z;let oe=class extends a.Disposable{constructor(W,H,V,_,j){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=H,this.uriIdentityService=V,this.fileService=_,this.logService=j}async scanExtensions(W){const H=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let V={};if(W.excludeObsolete&&W.type===1)try{const _=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(_)}catch{}return(0,p.isEmptyObject)(V)?H:H.filter(_=>!V[u.ExtensionKey.create(_).toString()])}async scanExtensionsFromLocation(W){const H=await this.fileService.resolve(W.location);if(!H.children?.length)return[];const V=await Promise.all(H.children.map(async _=>{if(!_.isDirectory||W.type===1&&(0,h.basename)(_.resource).indexOf(".")===0)return null;const j=new Z(_.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(j)}));return(0,N.coalesce)(V).sort((_,j)=>_.location.path<j.location.path?-1:1)}async scanExtensionsFromProfile(W){let H=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){H=H.filter(_=>!_.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,_=>!!_.metadata?.isBuiltin||!!_.metadata?.isApplicationScoped,W);H.push(...V)}return H}async scanExtensionsFromProfileResource(W,H,V){const _=await this.extensionsProfileScannerService.scanProfileExtensions(W,V.profileScanOptions);if(!_.length)return[];const j=await Promise.all(_.map(async K=>{if(H(K)){const X=new Z(K.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X,K.metadata)}return null}));return(0,N.coalesce)(j)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,h.joinPath)(W.location,"package.json"))){const H=await this.scanExtension(W);return H?[H]:[]}else return await this.scanExtensions(W)}catch(H){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,T.getErrorMessage)(H)),[]}}async scanExtension(W,H){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=g.UNDEFINED_PUBLISHER),H=H??V.__metadata,delete V.__metadata;const _=(0,u.getGalleryExtensionId)(V.publisher,V.name),j=H?.id?{id:_,uuid:H.id}:{id:_},K=H?.isSystem?0:W.type,X=K===0||!!H?.isBuiltin;V=await this.translateManifest(W.location,V,Z.createNlsConfiguration(W));const J={type:K,identifier:j,manifest:V,location:W.location,isBuiltin:X,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return W.validate?this.validate(J,W):J}}catch(V){W.type!==0&&this.logService.error(V)}return null}validate(W,H){let V=!0;const _=(0,i.validateExtensionManifest)(H.productVersion,H.productDate,H.location,W.manifest,W.isBuiltin);for(const[j,K]of _)j===I.default.Error&&(V=!1,this.logService.error(this.formatMessage(H.location,K)));return W.isValid=V,W.validations=_,W}async scanExtensionManifest(W){const H=(0,h.joinPath)(W,"package.json");let V;try{V=(await this.fileService.readFile(H)).value.toString()}catch(j){return(0,s.toFileOperationResult)(j)!==1&&this.logService.error(this.formatMessage(W,(0,S.localize)(0,null,H.path,j.message))),null}let _;try{_=JSON.parse(V)}catch{const K=[];(0,b.parse)(V,K);for(const X of K)this.logService.error(this.formatMessage(W,(0,S.localize)(1,null,H.path,X.offset,X.length,(0,f.getParseErrorMessage)(X.error))));return null}return(0,b.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(W,(0,S.localize)(2,null,H.path))),null):_}async translateManifest(W,H,V){const _=await this.getLocalizedMessages(W,H,V);if(_)try{const j=[],K=await this.resolveOriginalMessageBundle(_.default,j);if(j.length>0)return j.forEach(J=>{this.logService.error(this.formatMessage(W,(0,S.localize)(3,null,_.default?.path,(0,f.getParseErrorMessage)(J.error))))}),H;if((0,b.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(W,(0,S.localize)(4,null,_.default?.path))),H;const X=_.values||Object.create(null);return(0,L.localizeManifest)(this.logService,H,X,K)}catch{}return H}async getLocalizedMessages(W,H,V){const _=(0,h.joinPath)(W,"package.nls.json"),j=(M,F)=>{F.forEach(d=>{this.logService.error(this.formatMessage(W,(0,S.localize)(5,null,M?.path,(0,f.getParseErrorMessage)(d.error))))})},K=M=>{this.logService.error(this.formatMessage(W,(0,S.localize)(6,null,M?.path)))},X=`${H.publisher}.${H.name}`,J=V.translations[X];if(J)try{const M=c.URI.file(J),F=(await this.fileService.readFile(M)).value.toString(),d=[],C=(0,b.parse)(F,d);return d.length>0?(j(M,d),{values:void 0,default:_}):(0,b.getNodeType)(C)!=="object"?(K(M),{values:void 0,default:_}):{values:C.contents?C.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let F;try{F=await this.findMessageBundles(W,V)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const d=(await this.fileService.readFile(F.localized)).value.toString(),C=[],x=(0,b.parse)(d,C);return C.length>0?(j(F.localized,C),{values:void 0,default:F.original}):(0,b.getNodeType)(x)!=="object"?(K(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async resolveOriginalMessageBundle(W,H){if(W)try{const V=(await this.fileService.readFile(W)).value.toString();return(0,b.parse)(V,H)}catch{}}findMessageBundles(W,H){return new Promise((V,_)=>{const j=K=>{const X=(0,h.joinPath)(W,`package.nls.${K}.json`);this.fileService.exists(X).then(J=>{J&&V({localized:X,original:(0,h.joinPath)(W,"package.nls.json")});const M=K.lastIndexOf("-");M===-1?V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null}):(K=K.substring(0,M),j(K))})};if(H.devMode||H.pseudo||!H.language)return V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null});j(H.language)})}formatMessage(W,H){return`[${W.path}]: ${H}`}};oe=me([re(1,D.IExtensionsProfileScannerService),re(2,y.IUriIdentityService),re(3,s.IFileService),re(4,n.ILogService)],oe);let se=class extends oe{constructor(W,H,V,_,j,K,X){super(H,_,j,K,X),this.currentProfile=W,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const H=this.getCacheFile(W),V=await this.readExtensionCache(H);if(this.input=W,V&&V.input&&Z.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(j=>(j.location=c.URI.revive(j.location),j));const _=await super.scanExtensions(W);return await this.writeExtensionCache(H,{input:W,result:_}),_}async readExtensionCache(W){try{const H=await this.fileService.readFile(W),V=JSON.parse(H.value.toString());return{result:V.result,input:(0,l.revive)(V.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",W.path,(0,T.getErrorMessage)(H))}return null}async writeExtensionCache(W,H){try{await this.fileService.writeFile(W,A.VSBuffer.fromString(JSON.stringify(H)))}catch(V){this.logService.debug("Error while writing the extension cache file:",W.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const W=this.getCacheFile(this.input),H=await this.readExtensionCache(W);if(!H)return;const V=H.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(_,V))try{this.logService.info("Invalidating Cache",V,_),await this.fileService.del(W),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}getCacheFile(W){const H=this.getProfile(W);return this.uriIdentityService.extUri.joinPath(H.cacheHome,W.type===0?g.BUILTIN_MANIFEST_CACHE_FILE:g.USER_MANIFEST_CACHE_FILE)}getProfile(W){return W.type===0?this.userDataProfilesService.defaultProfile:W.profile?this.uriIdentityService.extUri.isEqual(W.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(H=>this.uriIdentityService.extUri.isEqual(W.location,H.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};se=me([re(2,R.IUserDataProfilesService),re(3,D.IExtensionsProfileScannerService),re(4,y.IUriIdentityService),re(5,s.IFileService),re(6,n.ILogService)],se);function fe(ae,W){const H=(0,u.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:H,identifier:new g.ExtensionIdentifier(H),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:W,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.toExtensionDescription=fe;class le extends te{constructor(W,H,V,_,j,K,X,J,M,F,d,C){super(W,H,(0,h.joinPath)(V,".vscode-oss-dev","extensions","control.json"),_,j,K,X,J,M,F,d,C),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const x=await this.fileService.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(G,e,N,O,k,A,T,b,f,a,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(P,I){super(),this.userDataProfilesService=P,this.logService=I,this.processesLimiter=new O.Limiter(5)}async postUninstall(P){const I=this.parseScript(P,"uninstall");I&&(this.logService.info(P.identifier.id,P.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(I.script,"uninstall",I.args,!0,P),this.logService.info("Finished running post uninstall script",P.identifier.id,P.manifest.version)}catch(p){this.logService.error("Failed to run post uninstall script",P.identifier.id,P.manifest.version),this.logService.error(p)}}));try{await a.Promises.rm(this.getExtensionStoragePath(P))}catch(p){this.logService.error("Error while removing extension storage path",P.identifier.id),this.logService.error(p)}}parseScript(P,I){const p=`vscode:${I}`;if(P.location.scheme===b.Schemas.file&&P.manifest&&P.manifest.scripts&&typeof P.manifest.scripts[p]=="string"){const c=P.manifest.scripts[p].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(P.identifier.id,P.manifest.version,`${p} should be a node script`),null):{script:(0,f.join)(P.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(P,I,p,c,S){return new Promise((v,u)=>{const g=this.start(P,I,p,S);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?u(t):v(void 0)};g.on("error",t=>{s((0,k.toErrorMessage)(t)||"Unknown")}),g.on("exit",(t,n)=>{s(t?`post-${I} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),u("timed out")},5e3))})}start(P,I,p,c){const S={silent:!0,execArgv:void 0},v=(0,N.fork)(P,[`--type=extension-post-${I}`,...p],S);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const u=A.Event.fromNodeEventEmitter(v.stdout,"data"),g=A.Event.fromNodeEventEmitter(v.stderr,"data");u(t=>this.logService.info(c.identifier.id,c.manifest.version,`post-${I}`,t)),g(t=>this.logService.error(c.identifier.id,c.manifest.version,`post-${I}`,t));const i=A.Event.any(A.Event.map(u,t=>({data:`%c${t}`,format:[""]})),A.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}getExtensionStoragePath(P){return(0,f.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,P.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m,e.ExtensionsLifecycle=m=me([re(0,w.IUserDataProfilesService),re(1,E.ILogService)],m)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v,u,g,i,s,t,n,r,o,l,D,R,y,L,$,te,Z,oe,se,fe,le,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,Z.refineServiceDecorator)(t.IExtensionManagementService);const W=".vsctmp";let H=class extends s.AbstractExtensionManagementService{constructor(M,F,d,C,x,U,q,B,ee,ue,he,pe){super(M,F,he,d,ue,pe),this.extensionsScannerService=x,this.extensionsProfileScannerService=U,this.downloadService=q,this.fileService=ee,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new E.ResourceSet;const Se=this._register(B.createInstance(D.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(V,ce=>Se.postUninstall(ce))),this.manifestCache=this._register(new y.ExtensionsManifestCache(pe,ee,he,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(l.ExtensionsDownloader));const de=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,pe,U,he,ee,d));this._register(de.onDidChangeExtensionsByAnotherSource(ce=>this.onDidChangeExtensionsFromAnotherSource(ce))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),d=await(0,v.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,F);return p.URI.file(d)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:d}=await this.downloadVsix(M),C=m.resolve(F.fsPath);try{return await(0,R.getManifest)(C)}finally{await d()}}getInstalled(M,F=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.extensionsScanner.scanUserExtensionAtLocation(M)}async install(M,F={}){this.logService.trace("ExtensionManagementService#install",M.toString());const{location:d,cleanup:C}=await this.downloadVsix(M);try{const x=await(0,R.getManifest)(m.resolve(d.fsPath)),U=(0,n.getGalleryExtensionId)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,$.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,U,this.productService.version));const B=(await this.installExtensions([{manifest:x,extension:d,options:F}])).find(({identifier:ee})=>(0,n.areSameExtensions)(ee,{id:U}));if(B?.local)return B.local;throw B?.error?B.error:(0,s.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await C()}}async installFromLocation(M,F){this.logService.trace("ExtensionManagementService#installFromLocation",M.toString());const d=await this.extensionsScanner.scanUserExtensionAtLocation(M);if(!d)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.addExtensionsToProfile([[d,void 0]],F),this.logService.info("Successfully installed extension",d.identifier.id,F.toString()),d}async installExtensionsFromProfile(M,F,d){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),d.toString());const C=(await this.extensionsScanner.scanExtensions(1,F)).filter(x=>M.some(U=>(0,n.areSameExtensions)(U,x.identifier)));if(C.length){const x=await Promise.all(C.map(U=>this.extensionsScanner.scanMetadata(U,F)));await this.addExtensionsToProfile(C.map((U,q)=>[U,x[q]]),d),this.logService.info("Successfully installed extensions",C.map(U=>U.identifier.id),d.toString())}return C}async updateMetadata(M,F,d=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.extensionsScanner.updateMetadata(M,F,d),this.manifestCache.invalidate(d),this._onDidUpdateExtensionMetadata.fire(M),M}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(u.localize(1,null));const F=await this.getTargetPlatform(),[d]=await this.galleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!d)throw new Error(u.localize(2,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(C){throw new Error(u.localize(3,null,(0,A.toErrorMessage)(C)))}return this.installFromGallery(d)}copyExtension(M,F,d,C){return this.extensionsScanner.copyExtension(M,F,d,C)}copyExtensions(M,F){return this.extensionsScanner.copyExtensions(M,F)}markAsUninstalled(...M){return this.extensionsScanner.setUninstalled(...M)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(M){this.logService.error(M)}}async download(M,F,d){const{location:C}=await this.extensionsDownloader.download(M,F,!d);return C}async downloadVsix(M){if(M.scheme===w.Schemas.file)return{location:M,async cleanup(){}};this.logService.trace("Downloading extension from",M.toString());const F=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)());return await this.downloadService.download(M,F),this.logService.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.fileService.del(F)}catch(C){this.logService.error(C)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(M,F,d){if(p.URI.isUri(F))return new K(M,F,d,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const C=n.ExtensionKey.create(F).toString();let x=this.installGalleryExtensionsTasks.get(C);return x||(this.installGalleryExtensionsTasks.set(C,x=new j(M,F,d,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),x.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(C))),x}createUninstallExtensionTask(M,F){return new X(M,F.profileLocation,this.extensionsProfileScannerService)}async collectFiles(M){const F=async C=>{let x=await S.Promises.readdir(C);x=x.map(B=>m.join(C,B));const U=await Promise.all(x.map(B=>S.Promises.stat(B)));let q=Promise.resolve([]);return U.forEach((B,ee)=>{const ue=x[ee];B.isFile()&&(q=q.then(he=>[...he,ue])),B.isDirectory()&&(q=q.then(he=>F(ue).then(pe=>[...he,...pe])))}),q};return(await F(M.location.fsPath)).map(C=>({path:`extension/${m.relative(M.location.fsPath,C)}`,localPath:C}))}async onDidChangeExtensionsFromAnotherSource({added:M,removed:F}){if(F){const d=M&&this.uriIdentityService.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(C=>M.extensions.every(x=>!(0,n.areSameExtensions)(x,C))):F.extensions;for(const C of d)this.logService.info("Extensions removed from another source",C.id,F.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:C,profileLocation:F.profileLocation})}if(M){const C=(await this.extensionsScanner.scanExtensions(1,M.profileLocation)).filter(x=>M.extensions.some(U=>(0,n.areSameExtensions)(U,x.identifier)));this._onDidInstallExtensions.fire(C.map(x=>(this.logService.info("Extensions added from another source",x.identifier.id,M.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:M.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(F=>this.knownDirectories.add(F)));const M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.knownDirectories.add(F.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(F=>this.onDidFilesChange(F)))}async onDidFilesChange(M){if(!M.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const F=[];for(const d of M.rawAdded){if(this.knownDirectories.has(d)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(d,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(d).startsWith(".")||!(await this.fileService.stat(d)).isDirectory)continue;const C=await this.extensionsScanner.scanUserExtensionAtLocation(d);C&&C.installedTimestamp===void 0&&(this.knownDirectories.add(d),F.push(C))}F.length&&(await this.addExtensionsToProfile(F.map(d=>[d,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",F.map(d=>d.identifier.id)))}async addExtensionsToProfile(M,F){const d=M.map(C=>C[0]);await this.setInstalled(d),await this.extensionsProfileScannerService.addExtensionsToProfile(M,F),this._onDidInstallExtensions.fire(d.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:F})))}async setInstalled(M){const F=await this.extensionsScanner.getUninstalledExtensions();for(const d of M){const C=n.ExtensionKey.create(d);F[C.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",C.id),await this.extensionsScanner.setInstalled(C),this.logService.info("Removed the extension from uninstalled list:",C.id))}}};e.ExtensionManagementService=H,e.ExtensionManagementService=H=me([re(0,t.IExtensionGalleryService),re(1,fe.ITelemetryService),re(2,oe.ILogService),re(3,i.INativeEnvironmentService),re(4,o.IExtensionsScannerService),re(5,r.IExtensionsProfileScannerService),re(6,g.IDownloadService),re(7,Z.IInstantiationService),re(8,te.IFileService),re(9,se.IProductService),re(10,le.IUriIdentityService),re(11,ae.IUserDataProfilesService)],H);let V=class extends a.Disposable{constructor(M,F,d,C,x,U){super(),this.beforeRemovingExtension=M,this.fileService=F,this.extensionsScannerService=d,this.extensionsProfileScannerService=C,this.uriIdentityService=x,this.logService=U,this._onExtract=this._register(new b.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new N.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(M,F){const d={includeInvalid:!0,profileLocation:F};let C=[];return M===null||M===0?C.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},d,!1)):M===1&&C.push(...await this.extensionsScannerService.scanUserExtensions(d)),C=M!==null?C.filter(x=>x.type===M):C,Promise.all(C.map(x=>this.toLocalExtension(x)))}async scanAllUserExtensions(M){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(d=>this.toLocalExtension(d)))}async scanUserExtensionAtLocation(M){try{const F=await this.extensionsScannerService.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.toLocalExtension(F)}catch(F){this.logService.error(F)}return null}async extractUserExtension(M,F,d,C,x){const U=M.toString(),q=p.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`)),B=p.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let ee=await this.fileService.exists(B);if(ee&&C){try{await this.deleteExtensionFromLocation(M.id,B,"removeExisting")}catch{throw new t.ExtensionManagementError(u.localize(4,null,B.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(ee)await this.extensionsScannerService.updateMetadata(B,d);else try{try{this.logService.trace(`Started extracting the extension from ${F} to ${B.fsPath}`),await(0,v.extract)(F,q.fsPath,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${B}:`,M.id)}catch(ue){let he=t.ExtensionManagementErrorCode.Extract;throw ue instanceof v.ExtractError&&(ue.type==="CorruptZip"?he=t.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(he=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ue.message,he)}await this.extensionsScannerService.updateMetadata(q,d);try{this.logService.trace(`Started renaming the extension from ${q.fsPath} to ${B.fsPath}`),await this.rename(q.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(ue)}. Deleted from extracted location`,q),ue}this._onExtract.fire(B)}catch(ue){try{await this.fileService.del(q,{recursive:!0})}catch{}throw ue}return this.scanLocalExtension(B,1)}async scanMetadata(M,F){return F?(await this.getScannedExtension(M,F))?.metadata:this.extensionsScannerService.scanMetadata(M.location)}async getScannedExtension(M,F){return(await this.extensionsProfileScannerService.scanProfileExtensions(F)).find(C=>(0,n.areSameExtensions)(C.identifier,M.identifier))}async updateMetadata(M,F,d){return d?await this.extensionsProfileScannerService.updateMetadata([[M,F]],d):await this.extensionsScannerService.updateMetadata(M.location,F),this.scanLocalExtension(M.location,M.type,d)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...M){const F=M.map(d=>n.ExtensionKey.create(d));await this.withUninstalledExtensions(d=>F.forEach(C=>{d[C.toString()]=!0,this.logService.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(M){await this.withUninstalledExtensions(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.uriIdentityService.extUri.isEqualOrParent(M.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[n.ExtensionKey.create(M).toString()])}async copyExtension(M,F,d,C){const x=await this.getScannedExtension(M,F),U=await this.getScannedExtension(M,d);return C={...x?.metadata,...C},U?await this.extensionsProfileScannerService.updateMetadata([[M,{...U.metadata,...C}]],d):await this.extensionsProfileScannerService.addExtensionsToProfile([[M,C]],d),this.scanLocalExtension(M.location,M.type,d)}async copyExtensions(M,F){const d=await this.scanExtensions(1,M),C=await Promise.all(d.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,M)]));await this.extensionsProfileScannerService.addExtensionsToProfile(C,F)}async deleteExtensionFromLocation(M,F,d){this.logService.trace(`Deleting ${d} extension from disk`,M,F.fsPath);const C=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(F),`${this.uriIdentityService.extUri.basename(F)}.${(0,f.hash)((0,c.generateUuid)()).toString(16)}${W}`);await this.rename(F.fsPath,C.fsPath),await this.fileService.del(C,{recursive:!0}),this.logService.info(`Deleted ${d} extension from disk`,M,F.fsPath)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(C){if((0,te.toFileOperationResult)(C)!==1)throw C}let d={};if(F)try{d=JSON.parse(F)}catch{}return M&&(M(d),Object.keys(d).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(d))):await this.fileService.del(this.uninstalledResource)),d})}async rename(M,F){try{await S.Promises.rename(M,F,2*60*1e3)}catch(d){throw new t.ExtensionManagementError(d.message||u.localize(5,null,M,F),d.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(M,F,d){if(d){const x=(await this.extensionsScannerService.scanUserExtensions({profileLocation:d})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,M));if(x)return this.toLocalExtension(x)}else{const C=await this.extensionsScannerService.scanExistingExtension(M,F,{includeInvalid:!0});if(C)return this.toLocalExtension(C)}throw new Error(u.localize(6,null,M.path))}async toLocalExtension(M){const F=await this.fileService.resolve(M.location);let d,C;return F.children&&(d=F.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,C=F.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:d,changelogUrl:C,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!M.metadata?.hasPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const x of F)M[n.ExtensionKey.create(x).toString()]||d.add(x.identifier.id.toLowerCase());try{const x=(0,n.groupByExtension)(F,U=>U.identifier);await N.Promises.settled(x.map(async U=>{const q=U.sort((B,ee)=>P.rcompare(B.manifest.version,ee.manifest.version))[0];d.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}))}catch(x){this.logService.error(x)}const C=F.filter(x=>x.metadata&&M[n.ExtensionKey.create(x).toString()]);await Promise.allSettled(C.map(x=>this.removeUninstalledExtension(x)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(F){(0,te.toFileOperationResult)(F)!==1&&this.logService.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(W))){this.logService.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.fileService.del(F.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(d){(0,te.toFileOperationResult)(d)!==1&&this.logService.error(d)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=me([re(1,te.IFileService),re(2,o.IExtensionsScannerService),re(3,r.IExtensionsProfileScannerService),re(4,le.IUriIdentityService),re(5,oe.ILogService)],V);class _ extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,I.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(M,F,d,C,x,U,q,B,ee){super(),this.identifier=M,this.source=F,this.options=d,this.extensionsScanner=C,this.uriIdentityService=x,this.userDataProfilesService=U,this.extensionsScannerService=q,this.extensionsProfileScannerService=B,this.logService=ee,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(M){const[F,d]=await this.install(M);return this._profileLocation=F.isBuiltin||F.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,d]],this._profileLocation),F}async extractExtension({zipPath:M,key:F,metadata:d},C,x){let U=await this.unsetIfUninstalled(F);return U?U=await this.extensionsScanner.updateMetadata(U,d):(this.logService.trace("Extracting extension...",F.id),U=await this.extensionsScanner.extractUserExtension(F,M,d,C,x),this.logService.info("Extracting extension completed.",F.id)),U}async unsetIfUninstalled(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(C=>n.ExtensionKey.create(C).equals(M))):void 0}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.toString()]}}class j extends _{constructor(M,F,d,C,x,U,q,B,ee,ue){super(F.identifier,F,d,x,U,q,B,ee,ue),this.gallery=F,this.extensionsDownloader=C}async install(M){let F;try{F=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)}catch(q){throw new t.ExtensionManagementError(q,t.ExtensionManagementErrorCode.Scanning)}const d=F.find(q=>(0,n.areSameExtensions)(q.identifier,this.gallery.identifier));d&&(this._operation=3);const C={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,I.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||d?.preRelease};if(d?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(d,C),C]}catch(q){throw new t.ExtensionManagementError((0,T.getErrorMessage)(q),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:x,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(x.fsPath),[await this.extractExtension({zipPath:x.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:C},!1,M),C]}catch(q){try{await this.extensionsDownloader.delete(x)}catch(B){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,T.getErrorMessage)(B))}throw q}}async validateManifest(M){try{await(0,R.getManifest)(M)}catch(F){throw new t.ExtensionManagementError((0,s.joinErrors)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class K extends _{constructor(M,F,d,C,x,U,q,B,ee,ue){super({id:(0,n.getGalleryExtensionId)(M.publisher,M.name)},F,d,x,U,q,B,ee,ue),this.manifest=M,this.location=F,this.galleryService=C}async doRun(M){const F=await super.doRun(M);return this.updateMetadata(F,M),F}async install(M){const F=new n.ExtensionKey(this.identifier,this.manifest.version),C=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(q=>(0,n.areSameExtensions)(this.identifier,q.identifier)),x={isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??C?.pinned};if(C)if(this._operation=3,F.equals(new n.ExtensionKey(C.identifier,C.manifest.version)))try{await this.extensionsScanner.removeExtension(C,"existing")}catch{throw new Error(u.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&P.gt(C.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(C);else{const q=await this.unsetIfUninstalled(F);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(u.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:m.resolve(this.location.fsPath),key:F,metadata:x},!0,M),x]}async updateMetadata(M,F){try{let[d]=await this.galleryService.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(d||([d]=await this.galleryService.getExtensions([{id:M.identifier.id}],F)),d){const C={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:M.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(M,C,this.options.profileLocation)}}catch{}}}class X extends s.AbstractExtensionTask{constructor(M,F,d){super(),this.extension=M,this.profileLocation=F,this.extensionsProfileScannerService=d}async doRun(M){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let E=class extends T.AbstractExtensionsProfileScannerService{constructor(m,h,P,I,p,c){super(a.URI.file(m.extensionsPath),h,P,I,p,c)}};e.ExtensionsProfileScannerService=E,e.ExtensionsProfileScannerService=E=me([re(0,f.INativeEnvironmentService),re(1,b.IFileService),re(2,O.IUserDataProfilesService),re(3,k.IUriIdentityService),re(4,A.ITelemetryService),re(5,N.ILogService)],E)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(G,e,N,O,k,A,T,b,f,a,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends A.NativeExtensionsScannerService{constructor(P,I,p,c,S,v,u,g){super(N.URI.file(S.builtinExtensionsPath),N.URI.file(S.extensionsPath),S.userHome,P.defaultProfile,P,I,p,c,S,v,u,g)}};e.ExtensionsScannerService=m,e.ExtensionsScannerService=m=me([re(0,w.IUserDataProfilesService),re(1,k.IExtensionsProfileScannerService),re(2,T.IFileService),re(3,f.ILogService),re(4,O.INativeEnvironmentService),re(5,a.IProductService),re(6,E.IUriIdentityService),re(7,b.IInstantiationService)],m)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(G,e,N,O,k,A,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var E;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var w;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var m;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(S){const v=S.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=h;class P extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(v,u,g){return O.Event.filter(this._onDidChangeValue.event,i=>i.scope===v&&(u===void 0||i.key===u),g)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,u){const{key:g,external:i}=u;if(g===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:g,target:this.getKeyTargets(v)[g],external:i})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,u,g){return this.getStorage(u)?.get(v,g)}getBoolean(v,u,g){return this.getStorage(u)?.getBoolean(v,g)}getNumber(v,u,g){return this.getStorage(u)?.getNumber(v,g)}getObject(v,u,g){return this.getStorage(u)?.getObject(v,g)}storeAll(v,u){this.withPausedEmitters(()=>{for(const g of v)this.store(g.key,g.value,g.scope,g.target,u)})}store(v,u,g,i,s=!1){if((0,T.isUndefinedOrNull)(u)){this.remove(v,g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,g,i),this.getStorage(g)?.set(v,u,s)})}remove(v,u,g=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,u,void 0),this.getStorage(u)?.delete(v,g)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,u){const g=[],i=this.getKeyTargets(v);for(const s of Object.keys(i))i[s]===u&&g.push(s);return g}updateKeyTarget(v,u,g,i=!1){const s=this.getKeyTargets(u);typeof g=="number"?s[v]!==g&&(s[v]=g,this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(s),i)):typeof s[v]=="number"&&(delete s[v],this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(s),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const u=this.getStorage(v);return u?h(u):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=E.NONE){this._onWillSaveState.fire({reason:v});const u=this.getStorage(-1),g=this.getStorage(0),i=this.getStorage(1);switch(v){case E.NONE:await N.Promises.settled([u?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await N.Promises.settled([u?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return c(v,u,g,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(v){return await this.flush(),this.getStorage(v)?.optimize()}async switch(v,u){return this.emitWillSaveState(E.NONE),(0,a.isUserDataProfile)(v)?this.switchToProfile(v,u):this.switchToWorkspace(v,u)}canSwitchProfile(v,u){return!(v.id===u.id||I(u)&&I(v))}switchData(v,u,g){this.withPausedEmitters(()=>{const i=new Set;for(const[s,t]of v)i.add(s),u.get(s)!==t&&this.emitDidChangeValue(g,{key:s,external:!0});for(const[s]of u.items)i.has(s)||this.emitDidChangeValue(g,{key:s,external:!0})})}}e.AbstractStorageService=P;function I(S){return S.isDefault||!!S.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=I;class p extends P{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(v){return!1}}e.InMemoryStorageService=p;async function c(S,v,u,g,i,s){const t=$=>{try{return JSON.parse($)}catch{return $}},n=new Map,r=new Map;S.forEach(($,te)=>{n.set(te,$),r.set(te,t($))});const o=new Map,l=new Map;v.forEach(($,te)=>{o.set(te,$),l.set(te,t($))});const D=new Map,R=new Map;u.forEach(($,te)=>{D.set(te,$),R.set(te,t($))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const y=[];if(n.forEach(($,te)=>{y.push({key:te,value:$})}),console.table(y),console.groupEnd(),console.log(r),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const $=[];o.forEach((te,Z)=>{$.push({key:Z,value:te})}),console.table($),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${s})`);const L=[];D.forEach(($,te)=>{L.push({key:te,value:$})}),console.table(L),console.groupEnd(),console.log(R)}e.logStorage=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,w.getTargetPlatform)(A.platform,T.arch),s="X-Market-Search-Activity-Id";var t;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...C){return String(C.reduce((x,U)=>x|U,0))}var r;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class y{constructor(x=R){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,U=this.state.pageSize){return new y({...this.state,pageNumber:x,pageSize:U})}withFilter(x,...U){const q=[...this.state.criteria,...U.length?U.map(B=>({filterType:x,value:B})):[{filterType:x}]];return new y({...this.state,criteria:q})}withSortBy(x){return new y({...this.state,sortBy:x})}withSortOrder(x){return new y({...this.state,sortOrder:x})}withFlags(...x){return new y({...this.state,flags:x.reduce((U,q)=>U|q,0)})}withAssetTypes(...x){return new y({...this.state,assetTypes:x})}withSource(x){return new y({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:U,pageSize:q,sortBy:B,sortOrder:ee,flags:ue,assetTypes:he}=this.state;return{filters:[{criteria:x,pageNumber:U,pageSize:q,sortBy:B,sortOrder:ee}],assetTypes:he,flags:ue}}get searchText(){const x=this.state.criteria.filter(U=>U.filterType===r.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function L(C,x){const U=(C||[]).filter(q=>q.statisticName===x)[0];return U?U.value:0}function $(C){const x="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(q=>q.assetType.indexOf(x)===0).reduce((q,B)=>{const ee=oe(C,B.assetType);return ee&&q.push([B.assetType.substring(x.length),ee]),q},[])}function te(C){if(C.properties){const x=C.properties.filter(B=>B.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=x.filter(B=>U.test(B.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return oe(C,o.Repository)}function Z(C){return{uri:`${C.fallbackAssetUri}/${o.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${o.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function oe(C,x){return C.files.filter(q=>q.assetType===x)[0]?{uri:`${C.assetUri}/${x}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${x}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function se(C,x){const U=C.properties?C.properties.filter(B=>B.key===x):[],q=U.length>0&&U[0].value;return q?q.split(",").map(B=>(0,m.adoptToGalleryExtensionId)(B)):[]}function fe(C){const x=C.properties?C.properties.filter(U=>U.key===l.Engine):[];return x.length>0&&x[0].value||""}function le(C){const x=C.properties?C.properties.filter(U=>U.key===l.PreRelease):[];return x.length>0&&x[0].value==="true"}function ae(C){const x=C.properties?C.properties.filter(q=>q.key===l.LocalizedLanguages):[],U=x.length>0&&x[0].value||"";return U?U.split(","):[]}function W(C){return C.properties?.find(x=>x.key===l.SponsorLink)?.value}function H(C){return C.properties?.find(x=>x.key===l.SupportLink)?.value}function V(C){return C.indexOf("preview")!==-1}function _(C){return C.targetPlatform?(0,w.toTargetPlatform)(C.targetPlatform):"undefined"}function j(C){const x=(0,N.distinct)(C.versions.map(_)),U=!!C.tags?.includes(w.WEB_EXTENSION_TAG),q=x.indexOf("web");return U?q===-1&&x.push("web"):q!==-1&&x.splice(q,1),x}function K(C,x){for(let U=0;U<C.length;U++){const q=C[U];if(q.version===C[U-1]?.version){let B=U;if(_(q)===x)for(;B>0&&C[B-1].version===q.version;)B--;B!==U&&(C.splice(U,1),C.splice(B,0,q))}}return C}e.sortExtensionVersions=K;function X(C,x,U){C.telemetryData={index:x,querySource:U,queryActivityId:C.queryContext?.[s]}}function J(C,x,U,q){const B=C.versions[0],ee={manifest:oe(x,o.Manifest),readme:oe(x,o.Details),changelog:oe(x,o.Changelog),license:oe(x,o.License),repository:te(x),download:Z(x),icon:oe(x,o.Icon),signature:oe(x,o.Signature),coreTranslations:$(x)};return{identifier:{id:(0,m.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:x.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(B),description:C.shortDescription||"",installCount:L(C.statistics,"install"),rating:L(C.statistics,"averagerating"),ratingCount:L(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:U,assets:ee,properties:{dependencies:se(x,l.Dependency),extensionPack:se(x,l.ExtensionPack),engine:fe(x),localizedLanguages:ae(x),targetPlatform:_(x),isPreReleaseVersion:le(x)},hasPreReleaseVersion:le(B),hasReleaseVersion:!0,preview:V(C.flags),isSigned:!!ee.signature,queryContext:q,supportLink:H(B)}}let M=class{constructor(x,U,q,B,ee,ue,he,pe){this.requestService=U,this.logService=q,this.environmentService=B,this.telemetryService=ee,this.fileService=ue,this.productService=he,this.configurationService=pe;const Se=he.extensionsGallery,de=Se?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=de?Se.servicePPEUrl:Se?.serviceUrl,this.extensionsGallerySearchUrl=de?void 0:Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,S.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,U,q){const B=O.CancellationToken.isCancellationToken(U)?{}:U,ee=O.CancellationToken.isCancellationToken(U)?U:q,ue=[],he=[],pe=[],Se=[];let de=!0;for(const Ee of x){Ee.uuid?he.push(Ee.uuid):ue.push(Ee.id);const be=!!(Ee.version||Ee.preRelease);pe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:be}),Ee.version&&Se.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!be}if(!he.length&&!ue.length)return[];let ce=new y().withPage(1,x.length);he.length&&(ce=ce.withFilter(r.ExtensionId,...he)),ue.length&&(ce=ce.withFilter(r.ExtensionName,...ue)),(B.queryAllVersions||de)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),B.source&&(ce=ce.withSource(B.source));const{extensions:ve}=await this.queryGalleryExtensions(ce,{targetPlatform:B.targetPlatform??i,includePreRelease:pe,versions:Se,compatible:!!B.compatible},ee);return B.source&&ve.forEach((Ee,be)=>X(Ee,be,B.source)),ve}async getCompatibleExtension(x,U,q){if((0,w.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(x,U,q))return x;const B=new y().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,x.identifier.uuid),{extensions:ee}=await this.queryGalleryExtensions(B,{targetPlatform:q,compatible:!0,includePreRelease:U},O.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(x,U,q){if(!(0,w.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,q)||!U&&x.properties.isPreReleaseVersion)return!1;let B=x.properties.engine;if(!B){const ee=await this.getManifest(x,O.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");B=ee.engines.vscode}return(0,h.isEngineValid)(B,this.productService.version,this.productService.date)}async isValidVersion(x,U,q,B,ee){if(!(0,w.isTargetPlatformCompatible)(_(x),B,ee)||U!=="any"&&le(x)!==(U==="prerelease"))return!1;if(q)try{const ue=await this.getEngine(x);if(!(0,h.isEngineValid)(ue,this.productService.version,this.productService.date))return!1}catch(ue){return this.logService.error(`Error while getting the engine for the version ${x.version}.`,(0,k.getErrorMessage)(ue)),!1}return!0}async query(x,U){let q=x.text||"";const B=x.pageSize??50;let ee=new y().withPage(1,B);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ce,ve)=>(ee=ee.withFilter(r.Category,ve||ce),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ce,ve)=>(ee=ee.withFilter(r.Tag,ve||ce),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(r.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),ee=ee.withFilter(r.SearchText,q)),ee=ee.withSortBy(0)):x.ids?ee=ee.withFilter(r.ExtensionId,...x.ids):x.names?ee=ee.withFilter(r.ExtensionName,...x.names):ee=ee.withSortBy(4),typeof x.sortBy=="number"&&(ee=ee.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ee=ee.withSortOrder(x.sortOrder)),x.source&&(ee=ee.withSource(x.source));const ue=async(de,ce)=>{const{extensions:ve,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:i,compatible:!1,includePreRelease:!!x.includePreRelease},ce);return ve.forEach((be,Le)=>X(be,(de.pageNumber-1)*de.pageSize+Le,x.source)),{extensions:ve,total:Ee}},{extensions:he,total:pe}=await ue(ee,U),Se=async(de,ce)=>{if(ce.isCancellationRequested)throw new k.CancellationError;const{extensions:ve}=await ue(ee.withPage(de+1),ce);return ve};return{firstPage:he,total:pe,pageSize:ee.pageSize,getPage:Se}}async queryGalleryExtensions(x,U,q){const B=x.flags;x.flags&t.IncludeLatestVersionOnly&&x.flags&t.IncludeVersions&&(x=x.withFlags(x.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(x.flags&t.IncludeLatestVersionOnly)&&!(x.flags&t.IncludeVersions)&&(x=x.withFlags(x.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(x=x.withFlags(x.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),x=x.withFlags(x.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ee,total:ue,context:he}=await this.queryRawGalleryExtensions(x,q);if(!(x.flags&t.IncludeLatestVersionOnly)){const ce=[];for(const ve of ee){const Ee=await this.toGalleryExtensionWithCriteria(ve,U,he);Ee&&ce.push(Ee)}return{extensions:ce,total:ue}}const Se=[],de=new Map;for(let ce=0;ce<ee.length;ce++){const ve=ee[ce],Ee={id:(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},be=(0,b.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(z=>(0,m.areSameExtensions)(z,Ee))?.includePreRelease;if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(j(ve),U.targetPlatform))continue;const Le=await this.toGalleryExtensionWithCriteria(ve,U,he);!Le||Le.properties.isPreReleaseVersion&&(!be||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==U.targetPlatform&&Le.hasPreReleaseVersion?de.set(ve.extensionId,ce):Se.push([ce,Le])}if(de.size){const ce=new g.StopWatch,ve=new y().withFlags(B&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,de.size).withFilter(r.ExtensionId,...de.keys()),{extensions:Ee}=await this.queryGalleryExtensions(ve,U,q);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:de.size});for(const be of Ee){const Le=de.get(be.identifier.uuid);Se.push([Le,be])}}return{extensions:Se.sort((ce,ve)=>ce[0]-ve[0]).map(([,ce])=>ce),total:ue}}async toGalleryExtensionWithCriteria(x,U,q){const B={id:(0,m.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},ee=U.versions?.find(Se=>(0,m.areSameExtensions)(Se,B))?.version,ue=(0,b.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Se=>(0,m.areSameExtensions)(Se,B))?.includePreRelease,he=j(x),pe=K(x.versions,U.targetPlatform);if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(he,U.targetPlatform))return null;for(let Se=0;Se<pe.length;Se++){const de=pe[Se];if(!(ee&&de.version!==ee)){if(await this.isValidVersion(de,ue?"any":"release",U.compatible,he,U.targetPlatform))return J(x,de,he,q);if(ee&&de.version===ee)return null}}return ee||U.compatible?null:J(x,x.versions[0],he)}async queryRawGalleryExtensions(x,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(t.Unpublished));const q=await this.commonHeadersPromise,B=JSON.stringify(x.raw),ee={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},ue=new g.StopWatch;let he,pe,Se=0;try{if(he=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(ce=>ce.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:B,headers:ee},U),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:Se};const de=await(0,c.asJson)(he);if(de){const ce=de.results[0],ve=ce.extensions,Ee=ce.resultMetadata&&ce.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return Se=Ee&&Ee.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:Se,context:{[s]:he.res.headers.activityid}}}return{galleryExtensions:[],total:Se}}catch(de){const ce=(0,k.isCancellationError)(de)?w.ExtensionGalleryErrorCode.Cancelled:(0,k.getErrorMessage)(de).startsWith("XHR timeout")?w.ExtensionGalleryErrorCode.Timeout:w.ExtensionGalleryErrorCode.Failed;throw pe=new w.ExtensionGalleryError((0,k.getErrorMessage)(de),ce),pe}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(B.length),duration:ue.elapsed(),success:!!he&&(0,c.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(Se)})}}async reportStatistic(x,U,q,B){if(!this.isEnabled())return;const ee=A.isWeb?this.api(`/itemName/${x}.${U}/version/${q}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${U}/${q}/stats?statType=${B}`),ue=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:ee,headers:pe},O.CancellationToken.None)}catch{}}async download(x,U,q){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const B=(0,m.getGalleryExtensionTelemetryData)(x),ee=new Date().getTime(),ue=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:ce}),he=q===2?"install":q===3?"update":"",pe=he?{uri:`${x.assets.download.uri}${f.URI.parse(x.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${x.assets.download.fallbackUri}${f.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:x.assets.download,Se=x.queryContext?.[s]?{[s]:x.queryContext[s]}:void 0,de=await this.getAsset(pe,Se?{headers:Se}:void 0);await this.fileService.writeFile(U,de.stream),ue(new Date().getTime()-ee)}async downloadSignatureArchive(x,U){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const q=await this.getAsset(x.assets.signature);await this.fileService.writeFile(U,q.stream)}async getReadme(x,U){if(x.assets.readme){const q=await this.getAsset(x.assets.readme,{},U);return await(0,c.asTextOrError)(q)||""}return""}async getManifest(x,U){if(x.assets.manifest){const q=await this.getAsset(x.assets.manifest,{},U),B=await(0,c.asTextOrError)(q);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(x,U){const q=oe(x,o.Manifest);if(!q)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},ee=await this.getAsset(q,{headers:B});return await(0,c.asJson)(ee)}async getCoreTranslation(x,U){const q=x.assets.coreTranslations.filter(B=>B[0]===U.toUpperCase())[0];if(q){const B=await this.getAsset(q[1]),ee=await(0,c.asTextOrError)(B);return ee?JSON.parse(ee):null}return null}async getChangelog(x,U){if(x.assets.changelog){const q=await this.getAsset(x.assets.changelog,{},U);return await(0,c.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(x,U,q){let B=new y().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?B=B.withFilter(r.ExtensionId,x.identifier.uuid):B=B.withFilter(r.ExtensionName,x.identifier.id);const{galleryExtensions:ee}=await this.queryRawGalleryExtensions(B,O.CancellationToken.None);if(!ee.length)return[];const ue=j(ee[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ue,q))return[];const he=[];await Promise.all(ee[0].versions.map(async de=>{try{await this.isValidVersion(de,U?"any":"release",!0,ue,q)&&he.push(de)}catch{}}));const pe=[],Se=new Set;for(const de of K(he,q))Se.has(de.version)||(Se.add(de.version),pe.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:le(de)}));return pe}async getAsset(x,U={},q=O.CancellationToken.None){const B=await this.commonHeadersPromise,ee={type:"GET"},ue={...B,...U.headers||{}};U={...U,...ee,headers:ue};const he=x.uri,pe=x.fallbackUri,Se={...U,url:he};try{const de=await this.requestService.request(Se,q);if(de.res.statusCode===200)return de;const ce=await(0,c.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ce}`)}catch(de){if((0,k.isCancellationError)(de))throw de;const ce=(0,k.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:he,message:ce});const ve={...U,url:pe};return this.requestService.request(ve,q)}}async getEngine(x){let U=fe(x);if(!U){const q=await this.getManifestFromRawExtensionVersion(x,O.CancellationToken.None);if(!q)throw new Error("Manifest was not found");U=q.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,c.asJson)(x),q=[],B={},ee=[];if(U){for(const ue of U.malicious)q.push({id:ue});if(U.migrateToPreRelease)for(const[ue,he]of Object.entries(U.migrateToPreRelease))(!he.engine||(0,h.isEngineValid)(he.engine,this.productService.version,this.productService.date))&&(B[ue.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ue,he]of Object.entries(U.deprecated))he&&(B[ue.toLowerCase()]=(0,b.isBoolean)(he)?{}:he);if(U.search)for(const ue of U.search)ee.push(ue)}return{malicious:q,deprecated:B,search:ee}}};M=me([re(1,c.IRequestService),re(2,I.ILogService),re(3,E.IEnvironmentService),re(4,u.ITelemetryService),re(5,P.IFileService),re(6,p.IProductService),re(7,a.IConfigurationService)],M);let F=class extends M{constructor(x,U,q,B,ee,ue,he,pe){super(x,U,q,B,ee,ue,he,pe)}};e.ExtensionGalleryService=F,e.ExtensionGalleryService=F=me([re(0,v.IStorageService),re(1,c.IRequestService),re(2,I.ILogService),re(3,E.IEnvironmentService),re(4,u.ITelemetryService),re(5,P.IFileService),re(6,p.IProductService),re(7,a.IConfigurationService)],F);let d=class extends M{constructor(x,U,q,B,ee,ue,he){super(void 0,x,U,q,B,ee,ue,he)}};e.ExtensionGalleryServiceWithNoStorageService=d,e.ExtensionGalleryServiceWithNoStorageService=d=me([re(0,c.IRequestService),re(1,I.ILogService),re(2,E.IEnvironmentService),re(3,u.ITelemetryService),re(4,P.IFileService),re(5,p.IProductService),re(6,a.IConfigurationService)],d)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(G,e,N,O,k,A,T,b,f,a,E){"use strict";var w,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let h=class extends f.UserDataProfilesService{static{w=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(c,S,v,u,g){super(v,u,S,g),this.stateReadonlyService=c,this.nativeEnvironmentService=v}getStoredProfiles(){return this.stateReadonlyService.getItem(w.PROFILES_KEY,[]).map(S=>({...S,location:(0,a.isString)(S.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,S.location):N.URI.revive(S.location)}))}getStoredProfileAssociations(){const c=this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?c:this.migrateStoredProfileAssociations(c)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(N.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=h,e.UserDataProfilesReadonlyService=h=w=me([re(0,T.IStateReadService),re(1,b.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],h);let P=m=class extends h{constructor(c,S,v,u,g){super(c,S,v,u,g),this.stateService=c}saveStoredProfiles(c){c.length?this.stateService.setItem(m.PROFILES_KEY,c.map(S=>({...S,location:this.uriIdentityService.extUri.basename(S.location)}))):this.stateService.removeItem(m.PROFILES_KEY)}getStoredProfiles(){const c=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(c),this.stateService.setItem("userDataProfilesMigration",!0)),c}saveStoredProfileAssociations(c){c.emptyWindows||c.workspaces?this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,c):this.stateService.removeItem(m.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const c="workspaceAndProfileInfo",S=this.stateService.getItem(c,void 0);if(S){this.stateService.removeItem(c);const u=S.reduce((g,{workspace:i,profile:s})=>(g[N.URI.revive(i).toString()]=N.URI.revive(s).toString(),g),{});this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,{workspaces:u})}const v=super.getStoredProfileAssociations();return this.stateService.getItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(v),this.stateService.setItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),v}};e.UserDataProfilesService=P,e.UserDataProfilesService=P=m=me([re(0,T.IStateService),re(1,b.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],P);let I=class extends P{constructor(c,S,v,u){super(new E.StateService(0,S,u,v),c,S,v,u)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=I,e.ServerUserDataProfilesService=I=me([re(0,b.IUriIdentityService),re(1,O.INativeEnvironmentService),re(2,k.IFileService),re(3,A.ILogService)],I)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let P=class extends w.AbstractRequestService{constructor(S,v,u,g){super(g),this.configurationService=S,this.environmentService=v,this.logService=u,this.configure(),this._register(S.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const S=this.configurationService.getValue("http");this.proxyUrl=S?.proxy,this.strictSSL=!!S?.proxyStrictSSL,this.authorization=S?.proxyAuthorization}async request(S,v){const{proxyUrl:u,strictSSL:g}=this;let i;try{i=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(n)))}const s={...process.env,...i},t=S.agent?S.agent:await(0,m.getProxyAgent)(S.url||"",s,{proxyUrl:u,strictSSL:g});return S.agent=t,S.strictSSL=g,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(S.isChromiumNetwork?"electron":"node",S,()=>p(S,v))}async resolveProxy(S){}async loadCertificates(){return(await new Promise((v,u)=>{G(["@vscode/proxy-agent"],v,u)})).loadSystemCertificates({log:this.logService})}};e.RequestService=P,e.RequestService=P=me([re(0,b.IConfigurationService),re(1,f.INativeEnvironmentService),re(2,E.ILogService),re(3,E.ILoggerService)],P);async function I(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((u,g)=>{G(["https"],u,g)}):await new Promise((u,g)=>{G(["http"],u,g)})).request}async function p(c,S){return O.Promises.withAsyncBody(async(v,u)=>{const g=(0,N.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await I(c),s={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,T.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(s.auth=c.user+":"+c.password);const t=i(s,n=>{const r=(0,T.isNumber)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)p({...c,url:n.headers.location,followRedirects:r-1},S).then(v,u);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,h.createGunzip)())),v({res:n,stream:(0,k.streamToBufferReadableStream)(o)})}});t.on("error",u),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),S.onCancellationRequested(()=>{t.abort(),u(new A.CancellationError)})})}e.nodeRequest=p}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(G,e,N,O,k,A,T,b,f,a,E,w,m,h,P,I,p,c,S,v,u,g,i,s,t,n,r,o,l,D,R,y,L,$,te,Z,oe,se,fe,le,ae,W,H,V,_,j,K,X,J,M,F,d,C,x,U,q,B,ee,ue,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends T.Disposable{constructor(ce){super(),this.argv=ce,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ce,ve]=await this.initServices();return ce.invokeFunction(async Ee=>{const be=Ee.get(Z.ILogService),Le=Ee.get(o.IFileService),z=Ee.get(c.INativeEnvironmentService),Y=Ee.get(C.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(z,Le,Y,ce),await Promise.all(ve.map(Q=>{(0,O.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const ce=new L.ServiceCollection,ve={_serviceBrand:void 0,...le.default};ce.set(ae.IProductService,ve);const Ee=new S.NativeEnvironmentService(this.argv,ve);ce.set(c.INativeEnvironmentService,Ee),await Promise.all([Ee.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,Ee.extensionsPath].map(Ne=>Ne?m.Promises.mkdir(Ne,{recursive:!0}):void 0));const be=new ee.LoggerService((0,Z.getLogLevel)(Ee),Ee.logsHome);ce.set(Z.ILoggerService,be);const Le=this._register(be.createLogger("cli",{name:(0,ue.localize)(0,null)})),z=[];be.getLogLevel()===Z.LogLevel.Trace&&z.push(new Z.ConsoleLogger(be.getLogLevel()));const Y=this._register(new B.LogService(Le,z));ce.set(Z.ILogService,Y);const Q=this._register(new l.FileService(Y));ce.set(o.IFileService,Q);const ge=this._register(new D.DiskFileSystemProvider(Y));Q.registerProvider(b.Schemas.file,ge);const ye=new d.UriIdentityService(Q);ce.set(F.IUriIdentityService,ye);const Oe=new V.StateReadonlyService(1,Ee,Y,Q),Ie=new x.UserDataProfilesReadonlyService(Oe,ye,Ee,Q,Y);ce.set(C.IUserDataProfilesService,Ie),Q.registerProvider(b.Schemas.vscodeUserData,new he.FileUserDataProvider(b.Schemas.file,ge,b.Schemas.vscodeUserData,Ie,ye,Y));const xe=a.isWindows&&ve.win32RegValueName?this._register(new fe.NativePolicyService(Y,ve.win32RegValueName)):Ee.policyFile?this._register(new oe.FilePolicyService(Ee.policyFile,Q,Y)):new se.NullPolicyService;ce.set(se.IPolicyService,xe);const De=this._register(new P.ConfigurationService(Ie.defaultProfile.settingsResource,Q,xe,Y));ce.set(h.IConfigurationService,De),await Promise.all([Oe.init(),De.initialize()]);let Ae;try{Ae=await(0,U.resolveMachineId)(Oe,Y)}catch(Ne){Ne.code!=="ENOENT"&&Y.error(Ne)}const _e=await(0,U.resolveSqmId)(Oe,Y);Ie.init(),ce.set(F.IUriIdentityService,new d.UriIdentityService(Q));const Re=new H.RequestService(De,Ee,Y,be);ce.set(W.IRequestService,Re),ce.set(I.IDownloadService,new R.SyncDescriptor(p.DownloadService,void 0,!0)),ce.set(s.IExtensionsProfileScannerService,new R.SyncDescriptor(q.ExtensionsProfileScannerService,void 0,!0)),ce.set(t.IExtensionsScannerService,new R.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),ce.set(g.IExtensionSignatureVerificationService,new R.SyncDescriptor(g.ExtensionSignatureVerificationService,void 0,!0)),ce.set(n.INativeServerExtensionManagementService,new R.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),ce.set(u.IExtensionGalleryService,new R.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ce.set($.ILanguagePackService,new R.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Te=[],Fe=(0,X.isInternalTelemetry)(ve,De);if((0,X.supportsTelemetry)(ve,Ee)){ve.aiConfig&&ve.aiConfig.ariaKey&&Te.push(new J.OneDataSystemAppender(Re,Fe,"monacoworkbench",null,ve.aiConfig.ariaKey));const Ne={appenders:Te,sendErrorTelemetry:!1,commonProperties:(0,_.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,ve.commit,ve.version,Ae,_e,Fe),piiPaths:(0,X.getPiiPathsFromEnvironment)(Ee)};ce.set(j.ITelemetryService,new R.SyncDescriptor(K.TelemetryService,[Ne],!1))}else ce.set(j.ITelemetryService,X.NullTelemetryService);return[new y.InstantiationService(ce),Te]}registerErrorHandler(ce){(0,A.setUnexpectedErrorHandler)(ve=>{const Ee=(0,k.toErrorMessage)(ve,!0);Ee&&ce.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",ve=>{(0,A.isSigPipeError)(ve)||(0,A.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,A.onUnexpectedError)(ve))}async doRun(ce,ve,Ee,be){let Le;if(ce.args.profile&&(Le=Ee.profiles.find(Y=>Y.name===ce.args.profile),!Le))throw new Error(`Profile '${ce.args.profile}' not found.`);const z=(Le??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(i.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,z);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:z};return be.createInstance(i.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(i.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,z);if(this.argv["update-extensions"])return be.createInstance(i.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).updateExtensions(z);if(this.argv["locate-extension"])return be.createInstance(i.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ce.appRoot,ce.extensionsPath))}}asExtensionIdOrVSIX(ce){return ce.map(ve=>/\.vsix$/i.test(ve)?w.URI.file((0,f.isAbsolute)(ve)?ve:(0,f.join)((0,E.cwd)(),ve)):ve)}}async function Se(de){const ce=new pe(de);try{await ce.run()}finally{ce.dispose()}}e.main=Se})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00d5968fd28fdbb3362ca4686e7ac684b8be63c8/core/vs/code/node/cliProcessMain.js.map
