/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=ye[me[I]];return e};define(ye[157],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class I{static get(){const f=new Map,P=new Map,A=new Map,E=new Map;function p(S,C){S.has(C.detail)||S.set(C.detail,-C.timestamp)}function y(S,C){const c=S.get(C.detail);c&&(c>=0||S.set(C.detail,c+C.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((S,C)=>S.timestamp-C.timestamp));for(const S of R)switch(S.type){case 10:p(f,S);break;case 11:case 12:y(f,S);break;case 21:p(P,S);break;case 22:y(P,S);break;case 33:p(A,S);break;case 34:y(A,S);break;case 31:p(E,S);break;case 32:y(E,S);break}let D=0;A.forEach(S=>D+=S);function v(S){const C=[];return S.forEach((c,m)=>C.push([m,c])),C}return{amdLoad:v(f),amdInvoke:v(P),nodeRequire:v(A),nodeEval:v(E),nodeRequireTotal:D}}static toMarkdownTable(f,P){let A="";const E=[];return f.forEach((p,y)=>{E[y]=p.length}),P.forEach(p=>{p.forEach((y,R)=>{typeof y>"u"&&(y=p[R]="-");const D=y.toString().length;E[R]=Math.max(D,E[R])})}),f.forEach((p,y)=>{A+=`| ${p+" ".repeat(E[y]-p.toString().length)} `}),A+=`|
`,f.forEach((p,y)=>{A+=`| ${"-".repeat(E[y])} `}),A+=`|
`,P.forEach(p=>{p.forEach((y,R)=>{typeof y<"u"&&(A+=`| ${y+" ".repeat(E[R]-y.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=I}),define(ye[158],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(c,m,o){const i=F(c,m);if(i!==-1)return c[i]}e.findLast=I;function F(c,m,o=c.length-1){for(let i=o;i>=0;i--){const r=c[i];if(m(r))return i}return-1}e.findLastIdx=F;function f(c,m){const o=P(c,m);return o===-1?void 0:c[o]}e.findLastMonotonous=f;function P(c,m,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);m(c[a])?r=a+1:n=a}return r-1}e.findLastIdxMonotonous=P;function A(c,m){const o=E(c,m);return o===c.length?void 0:c[o]}e.findFirstMonotonous=A;function E(c,m,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);m(c[a])?n=a:r=a+1}return r}e.findFirstIdxMonotonousOrArrLen=E;function p(c,m,o=0,i=c.length){const r=E(c,m,o,i);return r===c.length?-1:r}e.findFirstIdxMonotonous=p;class y{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(y.assertInvariants){if(this._prevFindLastPredicate){for(const i of this._array)if(this._prevFindLastPredicate(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const o=P(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=o+1,o===-1?void 0:this._array[o]}}e.MonotonousArray=y;function R(c,m){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];m(r,o)>0&&(o=r)}return o}e.findFirstMaxBy=R;function D(c,m){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];m(r,o)>=0&&(o=r)}return o}e.findLastMaxBy=D;function v(c,m){return R(c,(o,i)=>-m(o,i))}e.findFirstMinBy=v;function S(c,m){if(c.length===0)return-1;let o=0;for(let i=1;i<c.length;i++){const r=c[i];m(r,c[o])>0&&(o=i)}return o}e.findMaxIdxBy=S;function C(c,m){for(const o of c){const i=m(o);if(i!==void 0)return i}}e.mapFindFirst=C}),define(ye[73],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(A,E){const p=Object.create(null);for(const y of A){const R=E(y);let D=p[R];D||(D=p[R]=[]),D.push(y)}return p}e.groupBy=I;function F(A,E){const p=[],y=[];for(const R of A)E.has(R)||p.push(R);for(const R of E)A.has(R)||y.push(R);return{removed:p,added:y}}e.diffSets=F;function f(A,E){const p=[],y=[];for(const[R,D]of A)E.has(R)||p.push(D);for(const[R,D]of E)A.has(R)||y.push(D);return{removed:p,added:y}}e.diffMaps=f;function P(A,E){const p=new Set;for(const y of E)A.has(y)&&p.add(y);return p}e.intersection=P}),define(ye[52],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(A){return(E,p,y)=>{let R=null,D=null;if(typeof y.value=="function"?(R="value",D=y.value):typeof y.get=="function"&&(R="get",D=y.get),!D)throw new Error("not supported");y[R]=A(D,p)}}function F(A,E,p){let y=null,R=null;if(typeof p.value=="function"?(y="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(y="get",R=p.get),!R)throw new Error("not supported");const D=`$memoize$${E}`;p[y]=function(...v){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,v)}),this[D]}}e.memoize=F;function f(A,E,p){return I((y,R)=>{const D=`$debounce$${R}`,v=`$debounce$result$${R}`;return function(...S){this[v]||(this[v]=p?p():void 0),clearTimeout(this[D]),E&&(this[v]=E(this[v],...S),S=[this[v]]),this[D]=setTimeout(()=>{y.apply(this,S),this[v]=p?p():void 0},A)}})}e.debounce=f;function P(A,E,p){return I((y,R)=>{const D=`$throttle$timer$${R}`,v=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,C=`$throttle$pending$${R}`;return function(...c){if(this[v]||(this[v]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...c)),this[C])return;const m=this[S]+A;m<=Date.now()?(this[S]=Date.now(),y.apply(this,[this[v]]),this[v]=p?p():void 0):(this[C]=!0,this[D]=setTimeout(()=>{this[C]=!1,this[S]=Date.now(),y.apply(this,[this[v]]),this[v]=p?p():void 0},m-Date.now()))}})}e.throttle=P}),define(ye[14],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(d=>{d(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function F(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=f;function P(a){y(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=P;function A(a){y(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=A;function E(a){if(a instanceof Error){const{name:t,message:d}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:d,stack:s,noTelemetry:r.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=E;const p="Canceled";function y(a){return a instanceof R?!0:a instanceof Error&&a.name===p&&a.message===p}e.isCancellationError=y;class R extends Error{constructor(){super(p),this.name=this.message}}e.CancellationError=R;function D(){const a=new Error(p);return a.name=a.message,a}e.canceled=D;function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=v;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=S;class C extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=C;function c(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=c;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const d=new r;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.BugIndicatingError=n}),define(ye[19],Ce([1,0,14,158]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function f(he,fe=0){return he[he.length-(1+fe)]}e.tail=f;function P(he){if(he.length===0)throw new Error("Invalid tail call");return[he.slice(0,he.length-1),he[he.length-1]]}e.tail2=P;function A(he,fe,Z=(ee,j)=>ee===j){if(he===fe)return!0;if(!he||!fe||he.length!==fe.length)return!1;for(let ee=0,j=he.length;ee<j;ee++)if(!Z(he[ee],fe[ee]))return!1;return!0}e.equals=A;function E(he,fe){const Z=he.length-1;fe<Z&&(he[fe]=he[Z]),he.pop()}e.removeFastWithoutKeepingOrder=E;function p(he,fe,Z){return y(he.length,ee=>Z(he[ee],fe))}e.binarySearch=p;function y(he,fe){let Z=0,ee=he-1;for(;Z<=ee;){const j=(Z+ee)/2|0,J=fe(j);if(J<0)Z=j+1;else if(J>0)ee=j-1;else return j}return-(Z+1)}e.binarySearch2=y;function R(he,fe,Z){if(he=he|0,he>=fe.length)throw new TypeError("invalid index");const ee=fe[Math.floor(fe.length*Math.random())],j=[],J=[],ge=[];for(const we of fe){const Ae=Z(we,ee);Ae<0?j.push(we):Ae>0?J.push(we):ge.push(we)}return he<j.length?R(he,j,Z):he<j.length+ge.length?ge[0]:R(he-(j.length+ge.length),J,Z)}e.quickSelect=R;function D(he,fe){const Z=[];let ee;for(const j of he.slice(0).sort(fe))!ee||fe(ee[0],j)!==0?(ee=[j],Z.push(ee)):ee.push(j);return Z}e.groupBy=D;function*v(he,fe){let Z,ee;for(const j of he)ee!==void 0&&fe(ee,j)?Z.push(j):(Z&&(yield Z),Z=[j]),ee=j;Z&&(yield Z)}e.groupAdjacentBy=v;function S(he,fe){for(let Z=0;Z<=he.length;Z++)fe(Z===0?void 0:he[Z-1],Z===he.length?void 0:he[Z])}e.forEachAdjacent=S;function C(he,fe){for(let Z=0;Z<he.length;Z++)fe(Z===0?void 0:he[Z-1],he[Z],Z+1===he.length?void 0:he[Z+1])}e.forEachWithNeighbors=C;function c(he,fe,Z){const ee=[];function j(we,Ae,Ee){if(Ae===0&&Ee.length===0)return;const ke=ee[ee.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Ae,ke.toInsert.push(...Ee)):ee.push({start:we,deleteCount:Ae,toInsert:Ee})}let J=0,ge=0;for(;;){if(J===he.length){j(J,0,fe.slice(ge));break}if(ge===fe.length){j(J,he.length-J,[]);break}const we=he[J],Ae=fe[ge],Ee=Z(we,Ae);Ee===0?(J+=1,ge+=1):Ee<0?(j(J,1,[]),J+=1):Ee>0&&(j(J,0,[Ae]),ge+=1)}return ee}e.sortedDiff=c;function m(he,fe,Z){const ee=c(he,fe,Z),j=[],J=[];for(const ge of ee)j.push(...he.slice(ge.start,ge.start+ge.deleteCount)),J.push(...ge.toInsert);return{removed:j,added:J}}e.delta=m;function o(he,fe,Z){if(Z===0)return[];const ee=he.slice(0,Z).sort(fe);return r(he,fe,ee,Z,he.length),ee}e.top=o;function i(he,fe,Z,ee,j){return Z===0?Promise.resolve([]):new Promise((J,ge)=>{(async()=>{const we=he.length,Ae=he.slice(0,Z).sort(fe);for(let Ee=Z,ke=Math.min(Z+ee,we);Ee<we;Ee=ke,ke=Math.min(ke+ee,we)){if(Ee>Z&&await new Promise(z=>setTimeout(z)),j&&j.isCancellationRequested)throw new I.CancellationError;r(he,fe,Ae,Ee,ke)}return Ae})().then(J,ge)})}e.topAsync=i;function r(he,fe,Z,ee,j){for(const J=Z.length;ee<j;ee++){const ge=he[ee];if(fe(ge,Z[J-1])<0){Z.pop();const we=(0,F.findFirstIdxMonotonousOrArrLen)(Z,Ae=>fe(ge,Ae)<0);Z.splice(we,0,ge)}}}function n(he){return he.filter(fe=>!!fe)}e.coalesce=n;function a(he){let fe=0;for(let Z=0;Z<he.length;Z++)he[Z]&&(he[fe]=he[Z],fe+=1);he.length=fe}e.coalesceInPlace=a;function t(he,fe,Z){he.splice(Z,0,he.splice(fe,1)[0])}e.move=t;function d(he){return!Array.isArray(he)||he.length===0}e.isFalsyOrEmpty=d;function s(he){return Array.isArray(he)&&he.length>0}e.isNonEmptyArray=s;function h(he,fe=Z=>Z){const Z=new Set;return he.filter(ee=>{const j=fe(ee);return Z.has(j)?!1:(Z.add(j),!0)})}e.distinct=h;function l(he){const fe=new Set;return Z=>{const ee=he(Z);return fe.has(ee)?!1:(fe.add(ee),!0)}}e.uniqueFilter=l;function u(he,fe){return he.length>0?he[0]:fe}e.firstOrDefault=u;function w(he,fe){return he.length>0?he[he.length-1]:fe}e.lastOrDefault=w;function k(he,fe,Z=(ee,j)=>ee===j){let ee=0;for(let j=0,J=Math.min(he.length,fe.length);j<J&&Z(he[j],fe[j]);j++)ee++;return ee}e.commonPrefixLength=k;function b(he){return[].concat(...he)}e.flatten=b;function g(he,fe){let Z=typeof fe=="number"?he:0;typeof fe=="number"?Z=he:(Z=0,fe=he);const ee=[];if(Z<=fe)for(let j=Z;j<fe;j++)ee.push(j);else for(let j=Z;j>fe;j--)ee.push(j);return ee}e.range=g;function _(he,fe,Z){return he.reduce((ee,j)=>(ee[fe(j)]=Z?Z(j):j,ee),Object.create(null))}e.index=_;function T(he,fe){return he.push(fe),()=>O(he,fe)}e.insert=T;function O(he,fe){const Z=he.indexOf(fe);if(Z>-1)return he.splice(Z,1),fe}e.remove=O;function x(he,fe,Z){const ee=he.slice(0,fe),j=he.slice(fe);return ee.concat(Z,j)}e.arrayInsert=x;function N(he,fe){let Z;if(typeof fe=="number"){let ee=fe;Z=()=>{const j=Math.sin(ee++)*179426549;return j-Math.floor(j)}}else Z=Math.random;for(let ee=he.length-1;ee>0;ee-=1){const j=Math.floor(Z()*(ee+1)),J=he[ee];he[ee]=he[j],he[j]=J}}e.shuffle=N;function M(he,fe){const Z=he.indexOf(fe);Z>-1&&(he.splice(Z,1),he.unshift(fe))}e.pushToStart=M;function L(he,fe){const Z=he.indexOf(fe);Z>-1&&(he.splice(Z,1),he.push(fe))}e.pushToEnd=L;function U(he,fe){for(const Z of fe)he.push(Z)}e.pushMany=U;function B(he,fe){return Array.isArray(he)?he.map(fe):fe(he)}e.mapArrayOrNot=B;function G(he){return Array.isArray(he)?he:[he]}e.asArray=G;function le(he){return he[Math.floor(Math.random()*he.length)]}e.getRandomElement=le;function Y(he,fe,Z){const ee=Q(he,fe),j=he.length,J=Z.length;he.length=j+J;for(let ge=j-1;ge>=ee;ge--)he[ge+J]=he[ge];for(let ge=0;ge<J;ge++)he[ge+ee]=Z[ge]}e.insertInto=Y;function K(he,fe,Z,ee){const j=Q(he,fe);let J=he.splice(j,Z);return J===void 0&&(J=[]),Y(he,j,ee),J}e.splice=K;function Q(he,fe){return fe<0?Math.max(fe+he.length,0):Math.min(fe,he.length)}var ue;(function(he){function fe(J){return J<0}he.isLessThan=fe;function Z(J){return J<=0}he.isLessThanOrEqual=Z;function ee(J){return J>0}he.isGreaterThan=ee;function j(J){return J===0}he.isNeitherLessOrGreaterThan=j,he.greaterThan=1,he.lessThan=-1,he.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function ne(he,fe){return(Z,ee)=>fe(he(Z),he(ee))}e.compareBy=ne;function pe(...he){return(fe,Z)=>{for(const ee of he){const j=ee(fe,Z);if(!ue.isNeitherLessOrGreaterThan(j))return j}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=pe;const oe=(he,fe)=>he-fe;e.numberComparator=oe;const q=(he,fe)=>(0,e.numberComparator)(he?1:0,fe?1:0);e.booleanComparator=q;function W(he){return(fe,Z)=>-he(fe,Z)}e.reverseOrder=W;class ie{constructor(fe){this.items=fe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(fe){let Z=this.firstIdx;for(;Z<this.items.length&&fe(this.items[Z]);)Z++;const ee=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ee}takeFromEndWhile(fe){let Z=this.lastIdx;for(;Z>=0&&fe(this.items[Z]);)Z--;const ee=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ee}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const fe=this.items[this.firstIdx];return this.firstIdx++,fe}removeLast(){const fe=this.items[this.lastIdx];return this.lastIdx--,fe}takeCount(fe){const Z=this.items.slice(this.firstIdx,this.firstIdx+fe);return this.firstIdx+=fe,Z}}e.ArrayQueue=ie;class Se{static{this.empty=new Se(fe=>{})}constructor(fe){this.iterate=fe}forEach(fe){this.iterate(Z=>(fe(Z),!0))}toArray(){const fe=[];return this.iterate(Z=>(fe.push(Z),!0)),fe}filter(fe){return new Se(Z=>this.iterate(ee=>fe(ee)?Z(ee):!0))}map(fe){return new Se(Z=>this.iterate(ee=>Z(fe(ee))))}some(fe){let Z=!1;return this.iterate(ee=>(Z=fe(ee),!Z)),Z}findFirst(fe){let Z;return this.iterate(ee=>fe(ee)?(Z=ee,!1):!0),Z}findLast(fe){let Z;return this.iterate(ee=>(fe(ee)&&(Z=ee),!0)),Z}findLastMaxBy(fe){let Z,ee=!0;return this.iterate(j=>((ee||ue.isGreaterThan(fe(j,Z)))&&(ee=!1,Z=j),!0)),Z}}e.CallbackIterable=Se}),define(ye[61],Ce([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function F(y,R){if(!y)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=F;function f(y,R="Unreachable"){throw new Error(R)}e.assertNever=f;function P(y){if(!y)throw new I.BugIndicatingError("Assertion Failed")}e.assert=P;function A(y){y||(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}e.softAssert=A;function E(y){if(!y()){debugger;y(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=E;function p(y,R){let D=0;for(;D<y.length-1;){const v=y[D],S=y[D+1];if(!R(v,S))return!1;D++}return!0}e.checkAdjacentItems=p}),define(ye[74],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(F,f){const P=this;let A=!1,E;return function(){if(A)return E;if(A=!0,f)try{E=F.apply(P,arguments)}finally{f()}else E=F.apply(P,arguments);return E}}e.createSingleCallFunction=I}),define(ye[121],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(f){this._prefix=f,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(ye[53],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function f(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}F.is=f;const P=Object.freeze([]);function A(){return P}F.empty=A;function*E(t){yield t}F.single=E;function p(t){return f(t)?t:E(t)}F.wrap=p;function y(t){return t||P}F.from=y;function*R(t){for(let d=t.length-1;d>=0;d--)yield t[d]}F.reverse=R;function D(t){return!t||t[Symbol.iterator]().next().done===!0}F.isEmpty=D;function v(t){return t[Symbol.iterator]().next().value}F.first=v;function S(t,d){for(const s of t)if(d(s))return!0;return!1}F.some=S;function C(t,d){for(const s of t)if(d(s))return s}F.find=C;function*c(t,d){for(const s of t)d(s)&&(yield s)}F.filter=c;function*m(t,d){let s=0;for(const h of t)yield d(h,s++)}F.map=m;function*o(...t){for(const d of t)yield*d}F.concat=o;function i(t,d,s){let h=s;for(const l of t)h=d(h,l);return h}F.reduce=i;function*r(t,d,s=t.length){for(d<0&&(d+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);d<s;d++)yield t[d]}F.slice=r;function n(t,d=Number.POSITIVE_INFINITY){const s=[];if(d===0)return[s,t];const h=t[Symbol.iterator]();for(let l=0;l<d;l++){const u=h.next();if(u.done)return[s,F.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return h}}]}F.consume=n;async function a(t){const d=[];for await(const s of t)d.push(s);return Promise.resolve(d)}F.asyncToArray=a})(I||(e.Iterable=I={}))}),define(ye[159],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,d=!1){let s=0;const h=t.length;let l="",u=0,w=16,k=0;function b(M){let L=0,U=0;for(;L<M;){const B=t.charCodeAt(s);if(B>=48&&B<=57)U=U*16+B-48;else if(B>=65&&B<=70)U=U*16+B-65+10;else if(B>=97&&B<=102)U=U*16+B-97+10;else break;s++,L++}return L<M&&(U=-1),U}function g(M){s=M,l="",u=0,w=16,k=0}function _(){const M=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return k=3,t.substring(M,s);let L=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;L=s}else k=3;return t.substring(M,L)}function T(){let M="",L=s;for(;;){if(s>=h){M+=t.substring(L,s),k=2;break}const U=t.charCodeAt(s);if(U===34){M+=t.substring(L,s),s++;break}if(U===92){if(M+=t.substring(L,s),s++,s>=h){k=2;break}switch(t.charCodeAt(s++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const G=b(4);G>=0?M+=String.fromCharCode(G):k=4;break}default:k=5}L=s;continue}if(U>=0&&U<=31)if(p(U)){M+=t.substring(L,s),k=2;break}else k=6;s++}return M}function O(){if(l="",k=0,u=s,s>=h)return u=h,w=17;let M=t.charCodeAt(s);if(E(M)){do s++,l+=String.fromCharCode(M),M=t.charCodeAt(s);while(E(M));return w=15}if(p(M))return s++,l+=String.fromCharCode(M),M===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),w=14;switch(M){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,l=T(),w=10;case 47:{const L=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<h&&!p(t.charCodeAt(s));)s++;return l=t.substring(L,s),w=12}if(t.charCodeAt(s+1)===42){s+=2;const U=h-1;let B=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,k=1),l=t.substring(L,s),w=13}return l+=String.fromCharCode(M),s++,w=16}case 45:if(l+=String.fromCharCode(M),s++,s===h||!y(t.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=_(),w=11;default:for(;s<h&&x(M);)s++,M=t.charCodeAt(s);if(u!==s){switch(l=t.substring(u,s),l){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return l+=String.fromCharCode(M),s++,w=16}}function x(M){if(E(M)||p(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:g,getPosition:()=>s,scan:d?N:O,getToken:()=>w,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>k}}e.createScanner=A;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function D(t,d){const s=[],h=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(b,g,_,T){u.value=b,u.offset=g,u.length=_,u.type=T,u.colonOffset=void 0,l=u}try{r(t,{onObjectBegin:(b,g)=>{if(d<=b)throw h;l=void 0,w=d>b,s.push("")},onObjectProperty:(b,g,_)=>{if(d<g||(k(b,g,_,"property"),s[s.length-1]=b,d<=g+_))throw h},onObjectEnd:(b,g)=>{if(d<=b)throw h;l=void 0,s.pop()},onArrayBegin:(b,g)=>{if(d<=b)throw h;l=void 0,s.push(0)},onArrayEnd:(b,g)=>{if(d<=b)throw h;l=void 0,s.pop()},onLiteralValue:(b,g,_)=>{if(d<g||(k(b,g,_,a(b)),d<=g+_))throw h},onSeparator:(b,g,_)=>{if(d<=g)throw h;if(b===":"&&l&&l.type==="property")l.colonOffset=g,w=!1,l=void 0;else if(b===","){const T=s[s.length-1];typeof T=="number"?s[s.length-1]=T+1:(w=!0,s[s.length-1]=""),l=void 0}}})}catch(b){if(b!==h)throw b}return{path:s,previousNode:l,isAtPropertyKey:w,matches:b=>{let g=0;for(let _=0;g<b.length&&_<s.length;_++)if(b[g]===s[_]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.getLocation=D;function v(t,d=[],s=P.DEFAULT){let h=null,l=[];const u=[];function w(b){Array.isArray(l)?l.push(b):h!==null&&(l[h]=b)}return r(t,{onObjectBegin:()=>{const b={};w(b),u.push(l),l=b,h=null},onObjectProperty:b=>{h=b},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const b=[];w(b),u.push(l),l=b,h=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:w,onError:(b,g,_)=>{d.push({error:b,offset:g,length:_})}},s),l[0]}e.parse=v;function S(t,d=[],s=P.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){h.type==="property"&&(h.length=b-h.offset,h=h.parent)}function u(b){return h.children.push(b),b}r(t,{onObjectBegin:b=>{h=u({type:"object",offset:b,length:-1,parent:h,children:[]})},onObjectProperty:(b,g,_)=>{h=u({type:"property",offset:g,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:b,offset:g,length:_,parent:h})},onObjectEnd:(b,g)=>{h.length=b+g-h.offset,h=h.parent,l(b+g)},onArrayBegin:(b,g)=>{h=u({type:"array",offset:b,length:-1,parent:h,children:[]})},onArrayEnd:(b,g)=>{h.length=b+g-h.offset,h=h.parent,l(b+g)},onLiteralValue:(b,g,_)=>{u({type:a(b),offset:g,length:_,parent:h,value:b}),l(g+_)},onSeparator:(b,g,_)=>{h.type==="property"&&(b===":"?h.colonOffset=g:b===","&&l(g))},onError:(b,g,_)=>{d.push({error:b,offset:g,length:_})}},s);const k=h.children[0];return k&&delete k.parent,k}e.parseTree=S;function C(t,d){if(!t)return;let s=t;for(const h of d)if(typeof h=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===h){s=u.children[1],l=!0;break}if(!l)return}else{const l=h;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=C;function c(t){if(!t.parent||!t.parent.children)return[];const d=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;d.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&d.push(s)}return d}e.getNodePath=c;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const d=Object.create(null);for(const s of t.children){const h=s.children[1];h&&(d[s.children[0].value]=m(h))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=m;function o(t,d,s=!1){return d>=t.offset&&d<t.offset+t.length||s&&d===t.offset+t.length}e.contains=o;function i(t,d,s=!1){if(o(t,d,s)){const h=t.children;if(Array.isArray(h))for(let l=0;l<h.length&&h[l].offset<=d;l++){const u=i(h[l],d,s);if(u)return u}return t}}e.findNodeAtOffset=i;function r(t,d,s=P.DEFAULT){const h=A(t,!1);function l(ne){return ne?()=>ne(h.getTokenOffset(),h.getTokenLength()):()=>!0}function u(ne){return ne?pe=>ne(pe,h.getTokenOffset(),h.getTokenLength()):()=>!0}const w=l(d.onObjectBegin),k=u(d.onObjectProperty),b=l(d.onObjectEnd),g=l(d.onArrayBegin),_=l(d.onArrayEnd),T=u(d.onLiteralValue),O=u(d.onSeparator),x=l(d.onComment),N=u(d.onError),M=s&&s.disallowComments,L=s&&s.allowTrailingComma;function U(){for(;;){const ne=h.scan();switch(h.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:M||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ne){case 12:case 13:M?B(10):x();break;case 16:B(1);break;case 15:case 14:break;default:return ne}}}function B(ne,pe=[],oe=[]){if(N(ne),pe.length+oe.length>0){let q=h.getToken();for(;q!==17;){if(pe.indexOf(q)!==-1){U();break}else if(oe.indexOf(q)!==-1)break;q=U()}}}function G(ne){const pe=h.getTokenValue();return ne?T(pe):k(pe),U(),!0}function le(){switch(h.getToken()){case 11:{let ne=0;try{ne=JSON.parse(h.getTokenValue()),typeof ne!="number"&&(B(2),ne=0)}catch{B(2)}T(ne);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return U(),!0}function Y(){return h.getToken()!==10?(B(3,[],[2,5]),!1):(G(!1),h.getToken()===6?(O(":"),U(),ue()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function K(){w(),U();let ne=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(ne||B(4,[],[]),O(","),U(),h.getToken()===2&&L)break}else ne&&B(6,[],[]);Y()||B(4,[],[2,5]),ne=!0}return b(),h.getToken()!==2?B(7,[2],[]):U(),!0}function Q(){g(),U();let ne=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(ne||B(4,[],[]),O(","),U(),h.getToken()===4&&L)break}else ne&&B(6,[],[]);ue()||B(4,[],[4,5]),ne=!0}return _(),h.getToken()!==4?B(8,[4],[]):U(),!0}function ue(){switch(h.getToken()){case 3:return Q();case 1:return K();case 10:return G(!0);default:return le()}}return U(),h.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):ue()?(h.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=r;function n(t,d){const s=A(t),h=[];let l,u=0,w;do switch(w=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:u!==w&&h.push(t.substring(u,w)),d!==void 0&&h.push(s.getTokenValue().replace(/[^\r\n]/g,d)),u=s.getPosition();break}while(l!==17);return h.join("")}e.stripComments=n;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ye[43],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(f){this.executor=f,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(f){this._error=f}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(ye[75],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(P){this.element=P,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let P=this._first;for(;P!==I.Undefined;){const A=P.next;P.prev=I.Undefined,P.next=I.Undefined,P=A}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,A){const E=new I(P);if(this._first===I.Undefined)this._first=E,this._last=E;else if(A){const y=this._last;this._last=E,E.prev=y,y.next=E}else{const y=this._first;this._first=E,E.next=y,y.prev=E}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(E))}}shift(){if(this._first!==I.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==I.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==I.Undefined&&P.next!==I.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===I.Undefined&&P.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):P.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):P.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==I.Undefined;)yield P.element,P=P.next}}e.LinkedList=F}),define(ye[28],Ce([1,0]),function(me,e){"use strict";var I,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,n,a){let t=r.get(n);return t===void 0&&(t=a,r.set(n,t)),t}e.getOrSet=P;function A(r){const n=[];return r.forEach((a,t)=>{n.push(`${t} => ${a}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=A;function E(r){const n=[];return r.forEach(a=>{n.push(a)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=E;class p{constructor(n,a){this.uri=n,this.value=a}}function y(r){return Array.isArray(r)}class R{static{this.defaultToKey=n=>n.toString()}constructor(n,a){if(this[I]="ResourceMap",n instanceof R)this.map=new Map(n.map),this.toKey=a??R.defaultToKey;else if(y(n)){this.map=new Map,this.toKey=a??R.defaultToKey;for(const[t,d]of n)this.set(t,d)}else this.map=new Map,this.toKey=n??R.defaultToKey}set(n,a){return this.map.set(this.toKey(n),new p(n,a)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,a){typeof a<"u"&&(n=n.bind(a));for(const[t,d]of this.map)n(d.value,d.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=R;class D{constructor(n,a){this[F]="ResourceSet",!n||typeof n=="function"?this._map=new R(n):(this._map=new R(a),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,a){this._map.forEach((t,d)=>n.call(a,d,d,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=D;var v;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class S{constructor(){this[f]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,a=0){const t=this._map.get(n);if(t)return a!==0&&this.touch(t,a),t.value}set(n,a,t=0){let d=this._map.get(n);if(d)d.value=a,t!==0&&this.touch(d,t);else{switch(d={key:n,value:a,next:void 0,previous:void 0},t){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(n,d),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this._map.get(n);if(a)return this._map.delete(n),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,a){const t=this._state;let d=this._head;for(;d;){if(a?n.bind(a)(d.value,d.key,this):n(d.value,d.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const n=this,a=this._state;let t=this._head;const d={[Symbol.iterator](){return d},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}values(){const n=this,a=this._state;let t=this._head;const d={[Symbol.iterator](){return d},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}entries(){const n=this,a=this._state;let t=this._head;const d={[Symbol.iterator](){return d},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let a=this._head,t=this.size;for(;a&&t>n;)this._map.delete(a.key),a=a.next,t--;this._head=a,this._size=t,a&&(a.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const a=n.next,t=n.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}n.next=void 0,n.previous=void 0,this._state++}touch(n,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this._head)return;const t=n.next,d=n.previous;n===this._tail?(d.next=void 0,this._tail=d):(t.previous=d,d.next=t),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(a===2){if(n===this._tail)return;const t=n.next,d=n.previous;n===this._head?(t.previous=void 0,this._head=t):(t.previous=d,d.next=t),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((a,t)=>{n.push([t,a])}),n}fromJSON(n){this.clear();for(const[a,t]of n)this.set(a,t)}}e.LinkedMap=S;class C extends S{constructor(n,a=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=C;class c{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let a=this.map.get(n)||0;return a===0?!1:(a--,a===0?this.map.delete(n):this.map.set(n,a),!0)}has(n){return this.map.has(n)}}e.CounterSet=c;class m{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[a,t]of n)this.set(a,t)}clear(){this._m1.clear(),this._m2.clear()}set(n,a){this._m1.set(n,a),this._m2.set(a,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const a=this._m1.get(n);return a===void 0?!1:(this._m1.delete(n),this._m2.delete(a),!0)}forEach(n,a){this._m1.forEach((t,d)=>{n.call(a,t,d,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class o{constructor(){this.map=new Map}add(n,a){let t=this.map.get(n);t||(t=new Set,this.map.set(n,t)),t.add(a)}delete(n,a){const t=this.map.get(n);t&&(t.delete(a),t.size===0&&this.map.delete(n))}forEach(n,a){const t=this.map.get(n);t&&t.forEach(a)}get(n){const a=this.map.get(n);return a||new Set}}e.SetMap=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[a,t]of r)if(!n.has(a)||n.get(a)!==t)return!1;for(const[a]of n)if(!r.has(a))return!1;return!0}e.mapsStrictEqualIgnoreOrder=i}),define(ye[3],Ce([1,0,19,73,28,74,53]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const E=!1;let p=null;class y{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(T){let O=this.livingDisposables.get(T);return O||(O={parent:null,source:null,isSingleton:!1,value:T,idx:y.idx++},this.livingDisposables.set(T,O)),O}trackDisposable(T){const O=this.getDisposableData(T);O.source||(O.source=new Error().stack)}setParent(T,O){const x=this.getDisposableData(T);x.parent=O}markAsDisposed(T){this.livingDisposables.delete(T)}markAsSingleton(T){this.getDisposableData(T).isSingleton=!0}getRootParent(T,O){const x=O.get(T);if(x)return x;const N=T.parent?this.getRootParent(this.getDisposableData(T.parent),O):T;return O.set(T,N),N}getTrackedDisposables(){const T=new Map;return[...this.livingDisposables.entries()].filter(([,x])=>x.source!==null&&!this.getRootParent(x,T).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(T=10,O){let x;if(O)x=O;else{const B=new Map,G=[...this.livingDisposables.values()].filter(Y=>Y.source!==null&&!this.getRootParent(Y,B).isSingleton);if(G.length===0)return;const le=new Set(G.map(Y=>Y.value));if(x=G.filter(Y=>!(Y.parent&&le.has(Y.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function N(B){function G(Y,K){for(;Y.length>0&&K.some(Q=>typeof Q=="string"?Q===Y[0]:Y[0].match(Q));)Y.shift()}const le=B.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return G(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const M=new f.SetMap;for(const B of x){const G=N(B);for(let le=0;le<=G.length;le++)M.add(G.slice(0,le).join(`
`),B)}x.sort((0,I.compareBy)(B=>B.idx,I.numberComparator));let L="",U=0;for(const B of x.slice(0,T)){U++;const G=N(B),le=[];for(let Y=0;Y<G.length;Y++){let K=G[Y];K=`(shared with ${M.get(G.slice(0,Y+1).join(`
`)).size}/${x.length} leaks) at ${K}`;const ue=M.get(G.slice(0,Y).join(`
`)),ne=(0,F.groupBy)([...ue].map(pe=>N(pe)[Y]),pe=>pe);delete ne[G[Y]];for(const[pe,oe]of Object.entries(ne))le.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${pe}`);le.unshift(K)}L+=`


==================== Leaking disposable ${U}/${x.length}: ${B.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return x.length>T&&(L+=`


... and ${x.length-T} more leaking disposables

`),{leaks:x,details:L}}}e.DisposableTracker=y;function R(_){p=_}if(e.setDisposableTracker=R,E){const _="__is_disposable_tracked__";R(new class{trackDisposable(T){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[_]||console.log(O)},3e3)}setParent(T,O){if(T&&T!==t.None)try{T[_]=!0}catch{}}markAsDisposed(T){if(T&&T!==t.None)try{T[_]=!0}catch{}}markAsSingleton(T){}})}function D(_){return p?.trackDisposable(_),_}e.trackDisposable=D;function v(_){p?.markAsDisposed(_)}e.markAsDisposed=v;function S(_,T){p?.setParent(_,T)}function C(_,T){if(p)for(const O of _)p.setParent(O,T)}function c(_){return p?.markAsSingleton(_),_}e.markAsSingleton=c;function m(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=m;function o(_){if(A.Iterable.is(_)){const T=[];for(const O of _)if(O)try{O.dispose()}catch(x){T.push(x)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}e.dispose=o;function i(_){for(const T of _)m(T)&&T.dispose();return[]}e.disposeIfDisposable=i;function r(..._){const T=n(()=>o(_));return C(_,T),T}e.combinedDisposable=r;function n(_){const T=D({dispose:(0,P.createSingleCallFunction)(()=>{v(T),_()})});return T}e.toDisposable=n;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return S(T,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(T),T.dispose()}}deleteAndLeak(T){T&&this._toDispose.has(T)&&(this._toDispose.delete(T),S(T,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,D(this),S(this._store,this)}dispose(){v(this),this._store.dispose()}_register(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(T)}}e.Disposable=t;class d{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(T){this._isDisposed||T===this._value||(this._value?.dispose(),T&&S(T,this),this._value=T)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const T=this._value;return this._value=void 0,T&&S(T,null),T}}e.MutableDisposable=d;class s{constructor(T){this._disposable=new d,this._isDisposed=!1,this._disposable.value=T}get value(){return this._disposable.value}set value(T){this._isDisposed||T===this._disposable.value||(this._disposable.value=T)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class h{constructor(T){this._disposable=T,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(T){let O=T;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,v(this))},this}}e.SafeDisposable=l;class u{constructor(){this.references=new Map}acquire(T,...O){let x=this.references.get(T);x||(x={counter:0,object:this.createReferencedObject(T,...O)},this.references.set(T,x));const{object:N}=x,M=(0,P.createSingleCallFunction)(()=>{--x.counter===0&&(this.destroyReferencedObject(T,x.object),this.references.delete(T))});return x.counter++,{object:N,dispose:M}}}e.ReferenceCollection=u;class w{constructor(T){this.referenceCollection=T}async acquire(T,...O){const x=this.referenceCollection.acquire(T,...O);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(N){throw x.dispose(),N}}}e.AsyncReferenceCollection=w;class k{constructor(T){this.object=T}dispose(){}}e.ImmortalReference=k;function b(_){const T=new a;try{_(T)}finally{T.dispose()}}e.disposeOnReturn=b;class g{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(T){return this._store.has(T)}get size(){return this._store.size}get(T){return this._store.get(T)}set(T,O,x=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this._store.get(T)?.dispose(),this._store.set(T,O)}deleteAndDispose(T){this._store.get(T)?.dispose(),this._store.delete(T)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=g}),function(me,e){typeof define=="function"&&define.amd?define(ye[160],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(fe,Z){for(var ee=0;ee<Z.length;ee++){var j=Z[ee];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(fe,j.key,j)}}function I(fe,Z,ee){return Z&&e(fe.prototype,Z),ee&&e(fe,ee),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function F(fe,Z){if(fe){if(typeof fe=="string")return f(fe,Z);var ee=Object.prototype.toString.call(fe).slice(8,-1);if(ee==="Object"&&fe.constructor&&(ee=fe.constructor.name),ee==="Map"||ee==="Set")return Array.from(fe);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return f(fe,Z)}}function f(fe,Z){(Z==null||Z>fe.length)&&(Z=fe.length);for(var ee=0,j=new Array(Z);ee<Z;ee++)j[ee]=fe[ee];return j}function P(fe,Z){var ee=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(ee)return(ee=ee.call(fe)).next.bind(ee);if(Array.isArray(fe)||(ee=F(fe))||Z&&fe&&typeof fe.length=="number"){ee&&(fe=ee);var j=0;return function(){return j>=fe.length?{done:!0}:{done:!1,value:fe[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function E(fe){me.defaults=fe}var p=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(Z){return v[Z]};function C(fe,Z){if(Z){if(p.test(fe))return fe.replace(y,S)}else if(R.test(fe))return fe.replace(D,S);return fe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(fe){return fe.replace(c,function(Z,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(fe,Z){fe=typeof fe=="string"?fe:fe.source,Z=Z||"";var ee={replace:function(J,ge){return ge=ge.source||ge,ge=ge.replace(o,"$1"),fe=fe.replace(J,ge),ee},getRegex:function(){return new RegExp(fe,Z)}};return ee}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(fe,Z,ee){if(fe){var j;try{j=decodeURIComponent(m(ee)).replace(r,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}Z&&!n.test(ee)&&(ee=l(Z,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch{return null}return ee}var t={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(fe,Z){t[" "+fe]||(d.test(fe)?t[" "+fe]=fe+"/":t[" "+fe]=b(fe,"/",!0)),fe=t[" "+fe];var ee=fe.indexOf(":")===-1;return Z.substring(0,2)==="//"?ee?Z:fe.replace(s,"$1")+Z:Z.charAt(0)==="/"?ee?Z:fe.replace(h,"$1")+Z:fe+Z}var u={exec:function(){}};function w(fe){for(var Z=1,ee,j;Z<arguments.length;Z++){ee=arguments[Z];for(j in ee)Object.prototype.hasOwnProperty.call(ee,j)&&(fe[j]=ee[j])}return fe}function k(fe,Z){var ee=fe.replace(/\|/g,function(ge,we,Ae){for(var Ee=!1,ke=we;--ke>=0&&Ae[ke]==="\\";)Ee=!Ee;return Ee?"|":" |"}),j=ee.split(/ \|/),J=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>Z)j.splice(Z);else for(;j.length<Z;)j.push("");for(;J<j.length;J++)j[J]=j[J].trim().replace(/\\\|/g,"|");return j}function b(fe,Z,ee){var j=fe.length;if(j===0)return"";for(var J=0;J<j;){var ge=fe.charAt(j-J-1);if(ge===Z&&!ee)J++;else if(ge!==Z&&ee)J++;else break}return fe.slice(0,j-J)}function g(fe,Z){if(fe.indexOf(Z[1])===-1)return-1;for(var ee=fe.length,j=0,J=0;J<ee;J++)if(fe[J]==="\\")J++;else if(fe[J]===Z[0])j++;else if(fe[J]===Z[1]&&(j--,j<0))return J;return-1}function _(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(fe,Z){if(Z<1)return"";for(var ee="";Z>1;)Z&1&&(ee+=fe),Z>>=1,fe+=fe;return ee+fe}function O(fe,Z,ee,j){var J=Z.href,ge=Z.title?C(Z.title):null,we=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){j.state.inLink=!0;var Ae={type:"link",raw:ee,href:J,title:ge,text:we,tokens:j.inlineTokens(we)};return j.state.inLink=!1,Ae}return{type:"image",raw:ee,href:J,title:ge,text:C(we)}}function x(fe,Z){var ee=fe.match(/^(\s+)(?:```)/);if(ee===null)return Z;var j=ee[1];return Z.split(`
`).map(function(J){var ge=J.match(/^\s+/);if(ge===null)return J;var we=ge[0];return we.length>=j.length?J.slice(j.length):J}).join(`
`)}var N=function(){function fe(ee){this.options=ee||me.defaults}var Z=fe.prototype;return Z.space=function(j){var J=this.rules.block.newline.exec(j);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},Z.code=function(j){var J=this.rules.block.code.exec(j);if(J){var ge=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:b(ge,`
`)}}},Z.fences=function(j){var J=this.rules.block.fences.exec(j);if(J){var ge=J[0],we=x(ge,J[3]||"");return{type:"code",raw:ge,lang:J[2]?J[2].trim():J[2],text:we}}},Z.heading=function(j){var J=this.rules.block.heading.exec(j);if(J){var ge=J[2].trim();if(/#$/.test(ge)){var we=b(ge,"#");(this.options.pedantic||!we||/ $/.test(we))&&(ge=we.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:ge,tokens:this.lexer.inline(ge)}}},Z.hr=function(j){var J=this.rules.block.hr.exec(j);if(J)return{type:"hr",raw:J[0]}},Z.blockquote=function(j){var J=this.rules.block.blockquote.exec(j);if(J){var ge=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},Z.list=function(j){var J=this.rules.block.list.exec(j);if(J){var ge,we,Ae,Ee,ke,z,X,te,H,ae,de,Re,Ue=J[1].trim(),Ve=Ue.length>1,Ke={type:"list",raw:"",ordered:Ve,start:Ve?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ve?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ve?Ue:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(Re=!1,!(!(J=Ze.exec(j))||this.rules.block.hr.test(j)));){if(ge=J[0],j=j.substring(ge.length),te=J[2].split(`
`,1)[0],H=j.split(`
`,1)[0],this.options.pedantic?(Ee=2,de=te.trimLeft()):(Ee=J[2].search(/[^ ]/),Ee=Ee>4?1:Ee,de=te.slice(Ee),Ee+=J[1].length),z=!1,!te&&/^ *$/.test(H)&&(ge+=H+`
`,j=j.substring(H.length+1),Re=!0),!Re)for(var at=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");j&&(ae=j.split(`
`,1)[0],te=ae,this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(te)||Pe.test(te)||at.test(te)||st.test(j)));){if(te.search(/[^ ]/)>=Ee||!te.trim())de+=`
`+te.slice(Ee);else if(!z)de+=`
`+te;else break;!z&&!te.trim()&&(z=!0),ge+=ae+`
`,j=j.substring(ae.length+1)}Ke.loose||(X?Ke.loose=!0:/\n *\n *$/.test(ge)&&(X=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(de),we&&(Ae=we[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:ge,task:!!we,checked:Ae,loose:!1,text:de}),Ke.raw+=ge}Ke.items[Ke.items.length-1].raw=ge.trimRight(),Ke.items[Ke.items.length-1].text=de.trimRight(),Ke.raw=Ke.raw.trimRight();var xe=Ke.items.length;for(ke=0;ke<xe;ke++){this.lexer.state.top=!1,Ke.items[ke].tokens=this.lexer.blockTokens(Ke.items[ke].text,[]);var Te=Ke.items[ke].tokens.filter(function(re){return re.type==="space"}),Xe=Te.every(function(re){for(var se=re.raw.split(""),Ie=0,He=P(se),Qe;!(Qe=He()).done;){var it=Qe.value;if(it===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Ke.loose&&Te.length&&Xe&&(Ke.loose=!0,Ke.items[ke].loose=!0)}return Ke}},Z.html=function(j){var J=this.rules.block.html.exec(j);if(J){var ge={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(J[0]):C(J[0]);ge.type="paragraph",ge.text=we,ge.tokens=this.lexer.inline(we)}return ge}},Z.def=function(j){var J=this.rules.block.def.exec(j);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var ge=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:J[0],href:J[2],title:J[3]}}},Z.table=function(j){var J=this.rules.block.table.exec(j);if(J){var ge={type:"table",header:k(J[1]).map(function(X){return{text:X}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=J[0];var we=ge.align.length,Ae,Ee,ke,z;for(Ae=0;Ae<we;Ae++)/^ *-+: *$/.test(ge.align[Ae])?ge.align[Ae]="right":/^ *:-+: *$/.test(ge.align[Ae])?ge.align[Ae]="center":/^ *:-+ *$/.test(ge.align[Ae])?ge.align[Ae]="left":ge.align[Ae]=null;for(we=ge.rows.length,Ae=0;Ae<we;Ae++)ge.rows[Ae]=k(ge.rows[Ae],ge.header.length).map(function(X){return{text:X}});for(we=ge.header.length,Ee=0;Ee<we;Ee++)ge.header[Ee].tokens=this.lexer.inline(ge.header[Ee].text);for(we=ge.rows.length,Ee=0;Ee<we;Ee++)for(z=ge.rows[Ee],ke=0;ke<z.length;ke++)z[ke].tokens=this.lexer.inline(z[ke].text);return ge}}},Z.lheading=function(j){var J=this.rules.block.lheading.exec(j);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},Z.paragraph=function(j){var J=this.rules.block.paragraph.exec(j);if(J){var ge=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:ge,tokens:this.lexer.inline(ge)}}},Z.text=function(j){var J=this.rules.block.text.exec(j);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},Z.escape=function(j){var J=this.rules.inline.escape.exec(j);if(J)return{type:"escape",raw:J[0],text:C(J[1])}},Z.tag=function(j){var J=this.rules.inline.tag.exec(j);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):C(J[0]):J[0]}},Z.link=function(j){var J=this.rules.inline.link.exec(j);if(J){var ge=J[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var we=b(ge.slice(0,-1),"\\");if((ge.length-we.length)%2===0)return}else{var Ae=g(J[2],"()");if(Ae>-1){var Ee=J[0].indexOf("!")===0?5:4,ke=Ee+J[1].length+Ae;J[2]=J[2].substring(0,Ae),J[0]=J[0].substring(0,ke).trim(),J[3]=""}}var z=J[2],X="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);te&&(z=te[1],X=te[3])}else X=J[3]?J[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(ge)?z=z.slice(1):z=z.slice(1,-1)),O(J,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},Z.reflink=function(j,J){var ge;if((ge=this.rules.inline.reflink.exec(j))||(ge=this.rules.inline.nolink.exec(j))){var we=(ge[2]||ge[1]).replace(/\s+/g," ");if(we=J[we.toLowerCase()],!we||!we.href){var Ae=ge[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(ge,we,ge[0],this.lexer)}},Z.emStrong=function(j,J,ge){ge===void 0&&(ge="");var we=this.rules.inline.emStrong.lDelim.exec(j);if(we&&!(we[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=we[1]||we[2]||"";if(!Ae||Ae&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Ee=we[0].length-1,ke,z,X=Ee,te=0,H=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,J=J.slice(-1*j.length+Ee);(we=H.exec(J))!=null;)if(ke=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ke){if(z=ke.length,we[3]||we[4]){X+=z;continue}else if((we[5]||we[6])&&Ee%3&&!((Ee+z)%3)){te+=z;continue}if(X-=z,!(X>0)){if(z=Math.min(z,z+X+te),Math.min(Ee,z)%2){var ae=j.slice(1,Ee+we.index+z);return{type:"em",raw:j.slice(0,Ee+we.index+z+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var de=j.slice(2,Ee+we.index+z-1);return{type:"strong",raw:j.slice(0,Ee+we.index+z+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},Z.codespan=function(j){var J=this.rules.inline.code.exec(j);if(J){var ge=J[2].replace(/\n/g," "),we=/[^ ]/.test(ge),Ae=/^ /.test(ge)&&/ $/.test(ge);return we&&Ae&&(ge=ge.substring(1,ge.length-1)),ge=C(ge,!0),{type:"codespan",raw:J[0],text:ge}}},Z.br=function(j){var J=this.rules.inline.br.exec(j);if(J)return{type:"br",raw:J[0]}},Z.del=function(j){var J=this.rules.inline.del.exec(j);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},Z.autolink=function(j,J){var ge=this.rules.inline.autolink.exec(j);if(ge){var we,Ae;return ge[2]==="@"?(we=C(this.options.mangle?J(ge[1]):ge[1]),Ae="mailto:"+we):(we=C(ge[1]),Ae=we),{type:"link",raw:ge[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},Z.url=function(j,J){var ge;if(ge=this.rules.inline.url.exec(j)){var we,Ae;if(ge[2]==="@")we=C(this.options.mangle?J(ge[0]):ge[0]),Ae="mailto:"+we;else{var Ee;do Ee=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Ee!==ge[0]);we=C(ge[0]),ge[1]==="www."?Ae="http://"+we:Ae=we}return{type:"link",raw:ge[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},Z.inlineText=function(j,J){var ge=this.rules.inline.text.exec(j);if(ge){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):C(ge[0]):ge[0]:we=C(this.options.smartypants?J(ge[0]):ge[0]),{type:"text",raw:ge[0],text:we}}},fe}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=i(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=i(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=i(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=i(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=i(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=w({},M),M.gfm=w({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=i(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=w({},M.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:i(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=i(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=i(M._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=i(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=i(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=i(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=i(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=i(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=i(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=i(L.reflink).replace("label",L._label).replace("ref",M._label).getRegex(),L.nolink=i(L.nolink).replace("ref",M._label).getRegex(),L.reflinkSearch=i(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=w({},L),L.pedantic=w({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=w({},L.normal,{escape:i(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=i(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=w({},L.gfm,{br:i(L.br).replace("{2,}","*").getRegex(),text:i(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(fe){var Z="",ee,j,J=fe.length;for(ee=0;ee<J;ee++)j=fe.charCodeAt(ee),Math.random()>.5&&(j="x"+j.toString(16)),Z+="&#"+j+";";return Z}var G=function(){function fe(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||me.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:M.normal,inline:L.normal};this.options.pedantic?(j.block=M.pedantic,j.inline=L.pedantic):this.options.gfm&&(j.block=M.gfm,this.options.breaks?j.inline=L.breaks:j.inline=L.gfm),this.tokenizer.rules=j}fe.lex=function(j,J){var ge=new fe(J);return ge.lex(j)},fe.lexInline=function(j,J){var ge=new fe(J);return ge.inlineTokens(j)};var Z=fe.prototype;return Z.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},Z.blockTokens=function(j,J){var ge=this;J===void 0&&(J=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(X,te,H){return te+"    ".repeat(H.length)});for(var we,Ae,Ee,ke;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(we=X.call({lexer:ge},j,J))?(j=j.substring(we.raw.length),J.push(we),!0):!1}))){if(we=this.tokenizer.space(j)){j=j.substring(we.raw.length),we.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(we);continue}if(we=this.tokenizer.code(j)){j=j.substring(we.raw.length),Ae=J[J.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(we);continue}if(we=this.tokenizer.fences(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.heading(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.hr(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.blockquote(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.list(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.html(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.def(j)){j=j.substring(we.raw.length),Ae=J[J.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.lheading(j)){j=j.substring(we.raw.length),J.push(we);continue}if(Ee=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,te=j.slice(1),H=void 0;ge.options.extensions.startBlock.forEach(function(ae){H=ae.call({lexer:this},te),typeof H=="number"&&H>=0&&(X=Math.min(X,H))}),X<1/0&&X>=0&&(Ee=j.substring(0,X+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ee))){Ae=J[J.length-1],ke&&Ae.type==="paragraph"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(we),ke=Ee.length!==j.length,j=j.substring(we.raw.length);continue}if(we=this.tokenizer.text(j)){j=j.substring(we.raw.length),Ae=J[J.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(we);continue}if(j){var z="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,J},Z.inline=function(j,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:j,tokens:J}),J},Z.inlineTokens=function(j,J){var ge=this;J===void 0&&(J=[]);var we,Ae,Ee,ke=j,z,X,te;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)H.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,z.index)+"["+T("a",z[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,z.index)+"["+T("a",z[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,z.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(X||(te=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(we=de.call({lexer:ge},j,J))?(j=j.substring(we.raw.length),J.push(we),!0):!1}))){if(we=this.tokenizer.escape(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.tag(j)){j=j.substring(we.raw.length),Ae=J[J.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):J.push(we);continue}if(we=this.tokenizer.link(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(we.raw.length),Ae=J[J.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):J.push(we);continue}if(we=this.tokenizer.emStrong(j,ke,te)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.codespan(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.br(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.del(j)){j=j.substring(we.raw.length),J.push(we);continue}if(we=this.tokenizer.autolink(j,B)){j=j.substring(we.raw.length),J.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(j,B))){j=j.substring(we.raw.length),J.push(we);continue}if(Ee=j,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Re=j.slice(1),Ue=void 0;ge.options.extensions.startInline.forEach(function(Ve){Ue=Ve.call({lexer:this},Re),typeof Ue=="number"&&Ue>=0&&(de=Math.min(de,Ue))}),de<1/0&&de>=0&&(Ee=j.substring(0,de+1))}(),we=this.tokenizer.inlineText(Ee,U)){j=j.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(te=we.raw.slice(-1)),X=!0,Ae=J[J.length-1],Ae&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):J.push(we);continue}if(j){var ae="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return J},I(fe,null,[{key:"rules",get:function(){return{block:M,inline:L}}}]),fe}(),le=function(){function fe(ee){this.options=ee||me.defaults}var Z=fe.prototype;return Z.code=function(j,J,ge){var we=(J||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(j,we);Ae!=null&&Ae!==j&&(ge=!0,j=Ae)}return j=j.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+C(we,!0)+'">'+(ge?j:C(j,!0))+`</code></pre>
`:"<pre><code>"+(ge?j:C(j,!0))+`</code></pre>
`},Z.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},Z.html=function(j){return j},Z.heading=function(j,J,ge,we){if(this.options.headerIds){var Ae=this.options.headerPrefix+we.slug(ge);return"<h"+J+' id="'+Ae+'">'+j+"</h"+J+`>
`}return"<h"+J+">"+j+"</h"+J+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(j,J,ge){var we=J?"ol":"ul",Ae=J&&ge!==1?' start="'+ge+'"':"";return"<"+we+Ae+`>
`+j+"</"+we+`>
`},Z.listitem=function(j){return"<li>"+j+`</li>
`},Z.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(j){return"<p>"+j+`</p>
`},Z.table=function(j,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+J+`</table>
`},Z.tablerow=function(j){return`<tr>
`+j+`</tr>
`},Z.tablecell=function(j,J){var ge=J.header?"th":"td",we=J.align?"<"+ge+' align="'+J.align+'">':"<"+ge+">";return we+j+("</"+ge+`>
`)},Z.strong=function(j){return"<strong>"+j+"</strong>"},Z.em=function(j){return"<em>"+j+"</em>"},Z.codespan=function(j){return"<code>"+j+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(j){return"<del>"+j+"</del>"},Z.link=function(j,J,ge){if(j=a(this.options.sanitize,this.options.baseUrl,j),j===null)return ge;var we='<a href="'+C(j)+'"';return J&&(we+=' title="'+J+'"'),we+=">"+ge+"</a>",we},Z.image=function(j,J,ge){if(j=a(this.options.sanitize,this.options.baseUrl,j),j===null)return ge;var we='<img src="'+j+'" alt="'+ge+'"';return J&&(we+=' title="'+J+'"'),we+=this.options.xhtml?"/>":">",we},Z.text=function(j){return j},fe}(),Y=function(){function fe(){}var Z=fe.prototype;return Z.strong=function(j){return j},Z.em=function(j){return j},Z.codespan=function(j){return j},Z.del=function(j){return j},Z.html=function(j){return j},Z.text=function(j){return j},Z.link=function(j,J,ge){return""+ge},Z.image=function(j,J,ge){return""+ge},Z.br=function(){return""},fe}(),K=function(){function fe(){this.seen={}}var Z=fe.prototype;return Z.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(j,J){var ge=j,we=0;if(this.seen.hasOwnProperty(ge)){we=this.seen[j];do we++,ge=j+"-"+we;while(this.seen.hasOwnProperty(ge))}return J||(this.seen[j]=we,this.seen[ge]=0),ge},Z.slug=function(j,J){J===void 0&&(J={});var ge=this.serialize(j);return this.getNextSafeSlug(ge,J.dryrun)},fe}(),Q=function(){function fe(ee){this.options=ee||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new K}fe.parse=function(j,J){var ge=new fe(J);return ge.parse(j)},fe.parseInline=function(j,J){var ge=new fe(J);return ge.parseInline(j)};var Z=fe.prototype;return Z.parse=function(j,J){J===void 0&&(J=!0);var ge="",we,Ae,Ee,ke,z,X,te,H,ae,de,Re,Ue,Ve,Ke,Ze,at,st,rt,Pe,xe=j.length;for(we=0;we<xe;we++){if(de=j[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Pe=this.options.extensions.renderers[de.type].call({parser:this},de),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){ge+=Pe||"";continue}switch(de.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(de.tokens),de.depth,m(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(H="",te="",ke=de.header.length,Ae=0;Ae<ke;Ae++)te+=this.renderer.tablecell(this.parseInline(de.header[Ae].tokens),{header:!0,align:de.align[Ae]});for(H+=this.renderer.tablerow(te),ae="",ke=de.rows.length,Ae=0;Ae<ke;Ae++){for(X=de.rows[Ae],te="",z=X.length,Ee=0;Ee<z;Ee++)te+=this.renderer.tablecell(this.parseInline(X[Ee].tokens),{header:!1,align:de.align[Ee]});ae+=this.renderer.tablerow(te)}ge+=this.renderer.table(H,ae);continue}case"blockquote":{ae=this.parse(de.tokens),ge+=this.renderer.blockquote(ae);continue}case"list":{for(Re=de.ordered,Ue=de.start,Ve=de.loose,ke=de.items.length,ae="",Ae=0;Ae<ke;Ae++)Ze=de.items[Ae],at=Ze.checked,st=Ze.task,Ke="",Ze.task&&(rt=this.renderer.checkbox(at),Ve?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=rt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=rt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:rt}):Ke+=rt),Ke+=this.parse(Ze.tokens,Ve),ae+=this.renderer.listitem(Ke,st,at);ge+=this.renderer.list(ae,Re,Ue);continue}case"html":{ge+=this.renderer.html(de.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ae=de.tokens?this.parseInline(de.tokens):de.text;we+1<xe&&j[we+1].type==="text";)de=j[++we],ae+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);ge+=J?this.renderer.paragraph(ae):ae;continue}default:{var Te='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return ge},Z.parseInline=function(j,J){J=J||this.renderer;var ge="",we,Ae,Ee,ke=j.length;for(we=0;we<ke;we++){if(Ae=j[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ee=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){ge+=Ee||"";continue}switch(Ae.type){case"escape":{ge+=J.text(Ae.text);break}case"html":{ge+=J.html(Ae.text);break}case"link":{ge+=J.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,J));break}case"image":{ge+=J.image(Ae.href,Ae.title,Ae.text);break}case"strong":{ge+=J.strong(this.parseInline(Ae.tokens,J));break}case"em":{ge+=J.em(this.parseInline(Ae.tokens,J));break}case"codespan":{ge+=J.codespan(Ae.text);break}case"br":{ge+=J.br();break}case"del":{ge+=J.del(this.parseInline(Ae.tokens,J));break}case"text":{ge+=J.text(Ae.text);break}default:{var z='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return ge},fe}();function ue(fe,Z,ee){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof Z=="function"&&(ee=Z,Z=null),Z=w({},ue.defaults,Z||{}),_(Z),ee){var j=Z.highlight,J;try{J=G.lex(fe,Z)}catch(ke){return ee(ke)}var ge=function(z){var X;if(!z)try{Z.walkTokens&&ue.walkTokens(J,Z.walkTokens),X=Q.parse(J,Z)}catch(te){z=te}return Z.highlight=j,z?ee(z):ee(null,X)};if(!j||j.length<3||(delete Z.highlight,!J.length))return ge();var we=0;ue.walkTokens(J,function(ke){ke.type==="code"&&(we++,setTimeout(function(){j(ke.text,ke.lang,function(z,X){if(z)return ge(z);X!=null&&X!==ke.text&&(ke.text=X,ke.escaped=!0),we--,we===0&&ge()})},0))}),we===0&&ge();return}function Ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+C(ke.message+"",!0)+"</pre>";throw ke}try{var Ee=G.lex(fe,Z);if(Z.walkTokens){if(Z.async)return Promise.all(ue.walkTokens(Ee,Z.walkTokens)).then(function(){return Q.parse(Ee,Z)}).catch(Ae);ue.walkTokens(Ee,Z.walkTokens)}return Q.parse(Ee,Z)}catch(ke){Ae(ke)}}ue.options=ue.setOptions=function(fe){return w(ue.defaults,fe),E(ue.defaults),ue},ue.getDefaults=A,ue.defaults=me.defaults,ue.use=function(){for(var fe=arguments.length,Z=new Array(fe),ee=0;ee<fe;ee++)Z[ee]=arguments[ee];var j=w.apply(void 0,[{}].concat(Z)),J=ue.defaults.extensions||{renderers:{},childTokens:{}},ge;Z.forEach(function(we){if(we.extensions&&(ge=!0,we.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var ke=J.renderers?J.renderers[Ee.name]:null;ke?J.renderers[Ee.name]=function(){for(var z=arguments.length,X=new Array(z),te=0;te<z;te++)X[te]=arguments[te];var H=Ee.renderer.apply(this,X);return H===!1&&(H=ke.apply(this,X)),H}:J.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[Ee.level]?J[Ee.level].unshift(Ee.tokenizer):J[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?J.startBlock?J.startBlock.push(Ee.start):J.startBlock=[Ee.start]:Ee.level==="inline"&&(J.startInline?J.startInline.push(Ee.start):J.startInline=[Ee.start]))}Ee.childTokens&&(J.childTokens[Ee.name]=Ee.childTokens)})),we.renderer&&function(){var Ee=ue.defaults.renderer||new le,ke=function(te){var H=Ee[te];Ee[te]=function(){for(var ae=arguments.length,de=new Array(ae),Re=0;Re<ae;Re++)de[Re]=arguments[Re];var Ue=we.renderer[te].apply(Ee,de);return Ue===!1&&(Ue=H.apply(Ee,de)),Ue}};for(var z in we.renderer)ke(z);j.renderer=Ee}(),we.tokenizer&&function(){var Ee=ue.defaults.tokenizer||new N,ke=function(te){var H=Ee[te];Ee[te]=function(){for(var ae=arguments.length,de=new Array(ae),Re=0;Re<ae;Re++)de[Re]=arguments[Re];var Ue=we.tokenizer[te].apply(Ee,de);return Ue===!1&&(Ue=H.apply(Ee,de)),Ue}};for(var z in we.tokenizer)ke(z);j.tokenizer=Ee}(),we.walkTokens){var Ae=ue.defaults.walkTokens;j.walkTokens=function(Ee){var ke=[];return ke.push(we.walkTokens.call(this,Ee)),Ae&&(ke=ke.concat(Ae.call(this,Ee))),ke}}ge&&(j.extensions=J),ue.setOptions(j)})},ue.walkTokens=function(fe,Z){for(var ee=[],j=function(){var Ae=ge.value;switch(ee=ee.concat(Z.call(ue,Ae)),Ae.type){case"table":{for(var Ee=P(Ae.header),ke;!(ke=Ee()).done;){var z=ke.value;ee=ee.concat(ue.walkTokens(z.tokens,Z))}for(var X=P(Ae.rows),te;!(te=X()).done;)for(var H=te.value,ae=P(H),de;!(de=ae()).done;){var Re=de.value;ee=ee.concat(ue.walkTokens(Re.tokens,Z))}break}case"list":{ee=ee.concat(ue.walkTokens(Ae.items,Z));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ae.type]?ue.defaults.extensions.childTokens[Ae.type].forEach(function(Ue){ee=ee.concat(ue.walkTokens(Ae[Ue],Z))}):Ae.tokens&&(ee=ee.concat(ue.walkTokens(Ae.tokens,Z)))}},J=P(fe),ge;!(ge=J()).done;)j();return ee},ue.parseInline=function(fe,Z){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");Z=w({},ue.defaults,Z||{}),_(Z);try{var ee=G.lexInline(fe,Z);return Z.walkTokens&&ue.walkTokens(ee,Z.walkTokens),Q.parseInline(ee,Z)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+C(j.message+"",!0)+"</pre>";throw j}},ue.Parser=Q,ue.parser=Q.parse,ue.Renderer=le,ue.TextRenderer=Y,ue.Lexer=G,ue.lexer=G.lex,ue.Tokenizer=N,ue.Slugger=K,ue.parse=ue;var ne=ue.options,pe=ue.setOptions,oe=ue.use,q=ue.walkTokens,W=ue.parseInline,ie=ue,Se=Q.parse,he=G.lex;me.Lexer=G,me.Parser=Q,me.Renderer=le,me.Slugger=K,me.TextRenderer=Y,me.Tokenizer=N,me.getDefaults=A,me.lexer=he,me.marked=ue,me.options=ne,me.parse=ie,me.parseInline=W,me.parser=Se,me.setOptions=pe,me.use=oe,me.walkTokens=q,Object.defineProperty(me,"__esModule",{value:!0})}),define(ye[161],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function I(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}e.getKoreanAltChars=I;let F=0;const f=new Uint32Array(10);function P(c){if(F=0,A(c,D,4352),F>0||(A(c,v,4449),F>0)||(A(c,S,4520),F>0)||(A(c,C,12593),F))return f.subarray(0,F);if(c>=44032&&c<=55203){const m=c-44032,o=m%588,i=Math.floor(m/588),r=Math.floor(o/28),n=o%28-1;if(i<D.length?A(i,D,0):4352+i-12593<C.length&&A(4352+i,C,12593),r<v.length?A(r,v,0):4449+r-12593<C.length&&A(4449+r-12593,C,12593),n>=0&&(n<S.length?A(n,S,0):4520+n-12593<C.length&&A(4520+n-12593,C,12593)),F>0)return f.subarray(0,F)}}function A(c,m,o){c>=o&&c<o+m.length&&E(m[c-o])}function E(c){c!==0&&(f[F++]=c&255,c>>8&&(f[F++]=c>>8&255),c>>16&&(f[F++]=c>>16&255))}var p;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var y;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(y||(y={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),C=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[76],Ce([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new I.LRUCache(1e4);function f(y){return p(y,"NFC",F)}e.normalizeNFC=f;const P=new I.LRUCache(1e4);function A(y){return p(y,"NFD",P)}e.normalizeNFD=A;const E=/[^\u0000-\u0080]/;function p(y,R,D){if(!y)return y;const v=D.get(y);if(v)return v;let S;return E.test(y)?S=y.normalize(R):S=y,D.set(y,S),S}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(R){return A(R).replace(y,"")}}()}),define(ye[122],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(E,p,y){return Math.min(Math.max(E,p),y)}e.clamp=I;function F(E,p){return(p+E%p)%p}e.rot=F;class f{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=f;class P{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class A{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const y=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=y,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function me(f){const P=[];typeof f=="number"&&P.push("code/timeOrigin",f);function A(p){P.push(p,Date.now())}function E(){const p=[];for(let y=0;y<P.length;y+=2)p.push({name:P[y],startTime:P[y+1]});return p}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(f+A.startTime)});return P}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return me[F].call(f.exports,f,f.exports,I),f.l=!0,f.exports}return I.m=me,I.c=e,I.d=function(F,f,P){I.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:P})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,f){if(1&f&&(F=I(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var P=Object.create(null);if(I.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var A in F)I.d(P,A,function(E){return F[E]}.bind(null,A));return P},I.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(f,"a",f),f},I.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var f;e=me.exports=oe,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],p=e.src=[],y=0,R=y++;p[R]="0|[1-9]\\d*";var D=y++;p[D]="[0-9]+";var v=y++;p[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=y++;p[S]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var C=y++;p[C]="("+p[D]+")\\.("+p[D]+")\\.("+p[D]+")";var c=y++;p[c]="(?:"+p[R]+"|"+p[v]+")";var m=y++;p[m]="(?:"+p[D]+"|"+p[v]+")";var o=y++;p[o]="(?:-("+p[c]+"(?:\\."+p[c]+")*))";var i=y++;p[i]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var r=y++;p[r]="[0-9A-Za-z-]+";var n=y++;p[n]="(?:\\+("+p[r]+"(?:\\."+p[r]+")*))";var a=y++,t="v?"+p[S]+p[o]+"?"+p[n]+"?";p[a]="^"+t+"$";var d="[v=\\s]*"+p[C]+p[i]+"?"+p[n]+"?",s=y++;p[s]="^"+d+"$";var h=y++;p[h]="((?:<|>)?=?)";var l=y++;p[l]=p[D]+"|x|X|\\*";var u=y++;p[u]=p[R]+"|x|X|\\*";var w=y++;p[w]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[o]+")?"+p[n]+"?)?)?";var k=y++;p[k]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[i]+")?"+p[n]+"?)?)?";var b=y++;p[b]="^"+p[h]+"\\s*"+p[w]+"$";var g=y++;p[g]="^"+p[h]+"\\s*"+p[k]+"$";var _=y++;p[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=y++;p[T]="(?:~>?)";var O=y++;p[O]="(\\s*)"+p[T]+"\\s+",E[O]=new RegExp(p[O],"g");var x=y++;p[x]="^"+p[T]+p[w]+"$";var N=y++;p[N]="^"+p[T]+p[k]+"$";var M=y++;p[M]="(?:\\^)";var L=y++;p[L]="(\\s*)"+p[M]+"\\s+",E[L]=new RegExp(p[L],"g");var U=y++;p[U]="^"+p[M]+p[w]+"$";var B=y++;p[B]="^"+p[M]+p[k]+"$";var G=y++;p[G]="^"+p[h]+"\\s*("+d+")$|^$";var le=y++;p[le]="^"+p[h]+"\\s*("+t+")$|^$";var Y=y++;p[Y]="(\\s*)"+p[h]+"\\s*("+d+"|"+p[w]+")",E[Y]=new RegExp(p[Y],"g");var K=y++;p[K]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var Q=y++;p[Q]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var ue=y++;p[ue]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)f(ne,p[ne]),E[ne]||(E[ne]=new RegExp(p[ne]));function pe(H,ae){if(H instanceof oe)return H;if(typeof H!="string"||H.length>P||!(ae?E[s]:E[a]).test(H))return null;try{return new oe(H,ae)}catch{return null}}function oe(H,ae){if(H instanceof oe){if(H.loose===ae)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof oe))return new oe(H,ae);f("SemVer",H,ae),this.loose=ae;var de=H.trim().match(ae?E[s]:E[a]);if(!de)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Ue=+Re;if(Ue>=0&&Ue<A)return Ue}return Re}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=pe,e.valid=function(H,ae){var de=pe(H,ae);return de?de.version:null},e.clean=function(H,ae){var de=pe(H.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(H){return f("SemVer.compare",this.version,this.loose,H),H instanceof oe||(H=new oe(H,this.loose)),this.compareMain(H)||this.comparePre(H)},oe.prototype.compareMain=function(H){return H instanceof oe||(H=new oe(H,this.loose)),W(this.major,H.major)||W(this.minor,H.minor)||W(this.patch,H.patch)},oe.prototype.comparePre=function(H){if(H instanceof oe||(H=new oe(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Re=H.prerelease[ae];if(f("prerelease compare",ae,de,Re),de===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(de===void 0)return-1;if(de!==Re)return W(de,Re)}while(++ae)},oe.prototype.inc=function(H,ae){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,ae,de,Re){typeof de=="string"&&(Re=de,de=void 0);try{return new oe(H,de).inc(ae,Re).version}catch{return null}},e.diff=function(H,ae){if(fe(H,ae))return null;var de=pe(H),Re=pe(ae);if(de.prerelease.length||Re.prerelease.length){for(var Ue in de)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&de[Ue]!==Re[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in de)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&de[Ue]!==Re[Ue])return Ue},e.compareIdentifiers=W;var q=/^[0-9]+$/;function W(H,ae){var de=q.test(H),Re=q.test(ae);return de&&Re&&(H=+H,ae=+ae),de&&!Re?-1:Re&&!de?1:H<ae?-1:H>ae?1:0}function ie(H,ae,de){return new oe(H,de).compare(new oe(ae,de))}function Se(H,ae,de){return ie(H,ae,de)>0}function he(H,ae,de){return ie(H,ae,de)<0}function fe(H,ae,de){return ie(H,ae,de)===0}function Z(H,ae,de){return ie(H,ae,de)!==0}function ee(H,ae,de){return ie(H,ae,de)>=0}function j(H,ae,de){return ie(H,ae,de)<=0}function J(H,ae,de,Re){var Ue;switch(ae){case"===":typeof H=="object"&&(H=H.version),typeof de=="object"&&(de=de.version),Ue=H===de;break;case"!==":typeof H=="object"&&(H=H.version),typeof de=="object"&&(de=de.version),Ue=H!==de;break;case"":case"=":case"==":Ue=fe(H,de,Re);break;case"!=":Ue=Z(H,de,Re);break;case">":Ue=Se(H,de,Re);break;case">=":Ue=ee(H,de,Re);break;case"<":Ue=he(H,de,Re);break;case"<=":Ue=j(H,de,Re);break;default:throw new TypeError("Invalid operator: "+ae)}return Ue}function ge(H,ae){if(H instanceof ge){if(H.loose===ae)return H;H=H.value}if(!(this instanceof ge))return new ge(H,ae);f("comparator",H,ae),this.loose=ae,this.parse(H),this.semver===we?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(H,ae){return W(ae,H)},e.major=function(H,ae){return new oe(H,ae).major},e.minor=function(H,ae){return new oe(H,ae).minor},e.patch=function(H,ae){return new oe(H,ae).patch},e.compare=ie,e.compareLoose=function(H,ae){return ie(H,ae,!0)},e.rcompare=function(H,ae,de){return ie(ae,H,de)},e.sort=function(H,ae){return H.sort(function(de,Re){return e.compare(de,Re,ae)})},e.rsort=function(H,ae){return H.sort(function(de,Re){return e.rcompare(de,Re,ae)})},e.gt=Se,e.lt=he,e.eq=fe,e.neq=Z,e.gte=ee,e.lte=j,e.cmp=J,e.Comparator=ge;var we={};function Ae(H,ae){if(H instanceof Ae)return H.loose===ae?H:new Ae(H.raw,ae);if(H instanceof ge)return new Ae(H.value,ae);if(!(this instanceof Ae))return new Ae(H,ae);if(this.loose=ae,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ee(H){return!H||H.toLowerCase()==="x"||H==="*"}function ke(H,ae,de,Re,Ue,Ve,Ke,Ze,at,st,rt,Pe,xe){return((ae=Ee(de)?"":Ee(Re)?">="+de+".0.0":Ee(Ue)?">="+de+"."+Re+".0":">="+ae)+" "+(Ze=Ee(at)?"":Ee(st)?"<"+(+at+1)+".0.0":Ee(rt)?"<"+at+"."+(+st+1)+".0":Pe?"<="+at+"."+st+"."+rt+"-"+Pe:"<="+Ze)).trim()}function z(H,ae){for(var de=0;de<H.length;de++)if(!H[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<H.length;de++)if(f(H[de].semver),H[de].semver!==we&&H[de].semver.prerelease.length>0){var Re=H[de].semver;if(Re.major===ae.major&&Re.minor===ae.minor&&Re.patch===ae.patch)return!0}return!1}return!0}function X(H,ae,de){try{ae=new Ae(ae,de)}catch{return!1}return ae.test(H)}function te(H,ae,de,Re){var Ue,Ve,Ke,Ze,at;switch(H=new oe(H,Re),ae=new Ae(ae,Re),de){case">":Ue=Se,Ve=j,Ke=he,Ze=">",at=">=";break;case"<":Ue=he,Ve=ee,Ke=Se,Ze="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(X(H,ae,Re))return!1;for(var st=0;st<ae.set.length;++st){var rt=ae.set[st],Pe=null,xe=null;if(rt.forEach(function(Te){Te.semver===we&&(Te=new ge(">=0.0.0")),Pe=Pe||Te,xe=xe||Te,Ue(Te.semver,Pe.semver,Re)?Pe=Te:Ke(Te.semver,xe.semver,Re)&&(xe=Te)}),Pe.operator===Ze||Pe.operator===at||(!xe.operator||xe.operator===Ze)&&Ve(H,xe.semver)||xe.operator===at&&Ke(H,xe.semver))return!1}return!0}ge.prototype.parse=function(H){var ae=this.loose?E[G]:E[le],de=H.match(ae);if(!de)throw new TypeError("Invalid comparator: "+H);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new oe(de[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(H){return f("Comparator.test",H,this.loose),this.semver===we||(typeof H=="string"&&(H=new oe(H,this.loose)),J(H,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(H,ae){if(!(H instanceof ge))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ae(H.value,ae),X(this.value,de,ae);if(H.operator==="")return de=new Ae(this.value,ae),X(H.semver,de,ae);var Re=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ve=this.semver.version===H.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ze=J(this.semver,"<",H.semver,ae)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),at=J(this.semver,">",H.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Re||Ue||Ve&&Ke||Ze||at},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(H){var ae=this.loose;H=H.trim(),f("range",H,ae);var de=ae?E[Q]:E[K];H=H.replace(de,ke),f("hyphen replace",H),H=H.replace(E[Y],"$1$2$3"),f("comparator trim",H,E[Y]),H=(H=(H=H.replace(E[O],"$1~")).replace(E[L],"$1^")).split(/\s+/).join(" ");var Re=ae?E[G]:E[le],Ue=H.split(" ").map(function(Ve){return function(Ke,Ze){return f("comp",Ke),Ke=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,xe){f("caret",Pe,xe);var Te=xe?E[B]:E[U];return Pe.replace(Te,function(Xe,re,se,Ie,He){var Qe;return f("caret",Pe,Xe,re,se,Ie,He),Ee(re)?Qe="":Ee(se)?Qe=">="+re+".0.0 <"+(+re+1)+".0.0":Ee(Ie)?Qe=re==="0"?">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":">="+re+"."+se+".0 <"+(+re+1)+".0.0":He?(f("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Qe=re==="0"?se==="0"?">="+re+"."+se+"."+Ie+He+" <"+re+"."+se+"."+(+Ie+1):">="+re+"."+se+"."+Ie+He+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ie+He+" <"+(+re+1)+".0.0"):(f("no pr"),Qe=re==="0"?se==="0"?">="+re+"."+se+"."+Ie+" <"+re+"."+se+"."+(+Ie+1):">="+re+"."+se+"."+Ie+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ie+" <"+(+re+1)+".0.0"),f("caret return",Qe),Qe})}(rt,st)}).join(" ")}(Ke,Ze),f("caret",Ke),Ke=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,xe){var Te=xe?E[N]:E[x];return Pe.replace(Te,function(Xe,re,se,Ie,He){var Qe;return f("tilde",Pe,Xe,re,se,Ie,He),Ee(re)?Qe="":Ee(se)?Qe=">="+re+".0.0 <"+(+re+1)+".0.0":Ee(Ie)?Qe=">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":He?(f("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Qe=">="+re+"."+se+"."+Ie+He+" <"+re+"."+(+se+1)+".0"):Qe=">="+re+"."+se+"."+Ie+" <"+re+"."+(+se+1)+".0",f("tilde return",Qe),Qe})}(rt,st)}).join(" ")}(Ke,Ze),f("tildes",Ke),Ke=function(at,st){return f("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Pe,xe){Pe=Pe.trim();var Te=xe?E[g]:E[b];return Pe.replace(Te,function(Xe,re,se,Ie,He,Qe){f("xRange",Pe,Xe,re,se,Ie,He,Qe);var it=Ee(se),nt=it||Ee(Ie),Me=nt||Ee(He);return re==="="&&Me&&(re=""),it?Xe=re===">"||re==="<"?"<0.0.0":"*":re&&Me?(nt&&(Ie=0),Me&&(He=0),re===">"?(re=">=",nt?(se=+se+1,Ie=0,He=0):Me&&(Ie=+Ie+1,He=0)):re==="<="&&(re="<",nt?se=+se+1:Ie=+Ie+1),Xe=re+se+"."+Ie+"."+He):nt?Xe=">="+se+".0.0 <"+(+se+1)+".0.0":Me&&(Xe=">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0"),f("xRange return",Xe),Xe})}(rt,st)}).join(" ")}(Ke,Ze),f("xrange",Ke),Ke=function(at,st){return f("replaceStars",at,st),at.trim().replace(E[ue],"")}(Ke,Ze),f("stars",Ke),Ke}(Ve,ae)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ve){return!!Ve.match(Re)})),Ue=Ue.map(function(Ve){return new ge(Ve,ae)})},Ae.prototype.intersects=function(H,ae){if(!(H instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Re){return H.set.some(function(Ue){return Ue.every(function(Ve){return Re.intersects(Ve,ae)})})})})},e.toComparators=function(H,ae){return new Ae(H,ae).set.map(function(de){return de.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new oe(H,this.loose));for(var ae=0;ae<this.set.length;ae++)if(z(this.set[ae],H))return!0;return!1},e.satisfies=X,e.maxSatisfying=function(H,ae,de){var Re=null,Ue=null;try{var Ve=new Ae(ae,de)}catch{return null}return H.forEach(function(Ke){Ve.test(Ke)&&(Re&&Ue.compare(Ke)!==-1||(Ue=new oe(Re=Ke,de)))}),Re},e.minSatisfying=function(H,ae,de){var Re=null,Ue=null;try{var Ve=new Ae(ae,de)}catch{return null}return H.forEach(function(Ke){Ve.test(Ke)&&(Re&&Ue.compare(Ke)!==1||(Ue=new oe(Re=Ke,de)))}),Re},e.validRange=function(H,ae){try{return new Ae(H,ae).range||"*"}catch{return null}},e.ltr=function(H,ae,de){return te(H,ae,"<",de)},e.gtr=function(H,ae,de){return te(H,ae,">",de)},e.outside=te,e.prerelease=function(H,ae){var de=pe(H,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(H,ae,de){return H=new Ae(H,de),ae=new Ae(ae,de),H.intersects(ae)},e.coerce=function(H){if(H instanceof oe)return H;if(typeof H!="string")return null;var ae=H.match(E[_]);return ae==null?null:pe((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,f=me.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(m){if(I===setTimeout)return setTimeout(m,0);if((I===P||!I)&&setTimeout)return I=setTimeout,setTimeout(m,0);try{return I(m,0)}catch{try{return I.call(null,m,0)}catch{return I.call(this,m,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:P}catch{I=P}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var p,y=[],R=!1,D=-1;function v(){R&&p&&(R=!1,p.length?y=p.concat(y):D=-1,y.length&&S())}function S(){if(!R){var m=E(v);R=!0;for(var o=y.length;o;){for(p=y,y=[];++D<o;)p&&p[D].run();D=-1,o=y.length}p=null,R=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(m)}}function C(m,o){this.fun=m,this.array=o}function c(){}f.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new C(m,o)),y.length!==1||R||E(S)},C.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=c,f.addListener=c,f.once=c,f.off=c,f.removeListener=c,f.removeAllListeners=c,f.emit=c,f.prependListener=c,f.prependOnceListener=c,f.listeners=function(m){return[]},f.binding=function(m){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(m){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ye[38],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(P){return new F(P)}constructor(P){this._now=I&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=F}),define(ye[4],Ce([1,0,14,74,3,75,38]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,p=!1;var y;(function(b){b.None=()=>f.Disposable.None;function g(j){if(p){const{onDidAddListener:J}=j,ge=C.create();let we=0;j.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),J?.()}}}function _(j,J){return le(j,()=>{},0,void 0,!0,void 0,J)}b.defer=_;function T(j){return(J,ge=null,we)=>{let Ae=!1,Ee;return Ee=j(ke=>{if(!Ae)return Ee?Ee.dispose():Ae=!0,J.call(ge,ke)},null,we),Ae&&Ee.dispose(),Ee}}b.once=T;function O(j,J,ge){return B((we,Ae=null,Ee)=>j(ke=>we.call(Ae,J(ke)),null,Ee),ge)}b.map=O;function x(j,J,ge){return B((we,Ae=null,Ee)=>j(ke=>{J(ke),we.call(Ae,ke)},null,Ee),ge)}b.forEach=x;function N(j,J,ge){return B((we,Ae=null,Ee)=>j(ke=>J(ke)&&we.call(Ae,ke),null,Ee),ge)}b.filter=N;function M(j){return j}b.signal=M;function L(...j){return(J,ge=null,we)=>{const Ae=(0,f.combinedDisposable)(...j.map(Ee=>Ee(ke=>J.call(ge,ke))));return G(Ae,we)}}b.any=L;function U(j,J,ge,we){let Ae=ge;return O(j,Ee=>(Ae=J(Ae,Ee),Ae),we)}b.reduce=U;function B(j,J){let ge;const we={onWillAddFirstListener(){ge=j(Ae.fire,Ae)},onDidRemoveLastListener(){ge?.dispose()}};J||g(we);const Ae=new r(we);return J?.add(Ae),Ae.event}function G(j,J){return J instanceof Array?J.push(j):J&&J.add(j),j}function le(j,J,ge=100,we=!1,Ae=!1,Ee,ke){let z,X,te,H=0,ae;const de={leakWarningThreshold:Ee,onWillAddFirstListener(){z=j(Ue=>{H++,X=J(X,Ue),we&&!te&&(Re.fire(X),X=void 0),ae=()=>{const Ve=X;X=void 0,te=void 0,(!we||H>1)&&Re.fire(Ve),H=0},typeof ge=="number"?(clearTimeout(te),te=setTimeout(ae,ge)):te===void 0&&(te=0,queueMicrotask(ae))})},onWillRemoveListener(){Ae&&H>0&&ae?.()},onDidRemoveLastListener(){ae=void 0,z.dispose()}};ke||g(de);const Re=new r(de);return ke?.add(Re),Re.event}b.debounce=le;function Y(j,J=0,ge){return b.debounce(j,(we,Ae)=>we?(we.push(Ae),we):[Ae],J,void 0,!0,void 0,ge)}b.accumulate=Y;function K(j,J=(we,Ae)=>we===Ae,ge){let we=!0,Ae;return N(j,Ee=>{const ke=we||!J(Ee,Ae);return we=!1,Ae=Ee,ke},ge)}b.latch=K;function Q(j,J,ge){return[b.filter(j,J,ge),b.filter(j,we=>!J(we),ge)]}b.split=Q;function ue(j,J=!1,ge=[],we){let Ae=ge.slice(),Ee=j(X=>{Ae?Ae.push(X):z.fire(X)});we&&we.add(Ee);const ke=()=>{Ae?.forEach(X=>z.fire(X)),Ae=null},z=new r({onWillAddFirstListener(){Ee||(Ee=j(X=>z.fire(X)),we&&we.add(Ee))},onDidAddFirstListener(){Ae&&(J?setTimeout(ke):ke())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return we&&we.add(z),z.event}b.buffer=ue;function ne(j,J){return(we,Ae,Ee)=>{const ke=J(new oe);return j(function(z){const X=ke.evaluate(z);X!==pe&&we.call(Ae,X)},void 0,Ee)}}b.chain=ne;const pe=Symbol("HaltChainable");class oe{constructor(){this.steps=[]}map(J){return this.steps.push(J),this}forEach(J){return this.steps.push(ge=>(J(ge),ge)),this}filter(J){return this.steps.push(ge=>J(ge)?ge:pe),this}reduce(J,ge){let we=ge;return this.steps.push(Ae=>(we=J(we,Ae),we)),this}latch(J=(ge,we)=>ge===we){let ge=!0,we;return this.steps.push(Ae=>{const Ee=ge||!J(Ae,we);return ge=!1,we=Ae,Ee?Ae:pe}),this}evaluate(J){for(const ge of this.steps)if(J=ge(J),J===pe)break;return J}}function q(j,J,ge=we=>we){const we=(...z)=>ke.fire(ge(...z)),Ae=()=>j.on(J,we),Ee=()=>j.removeListener(J,we),ke=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:Ee});return ke.event}b.fromNodeEventEmitter=q;function W(j,J,ge=we=>we){const we=(...z)=>ke.fire(ge(...z)),Ae=()=>j.addEventListener(J,we),Ee=()=>j.removeEventListener(J,we),ke=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:Ee});return ke.event}b.fromDOMEventEmitter=W;function ie(j){return new Promise(J=>T(j)(J))}b.toPromise=ie;function Se(j){const J=new r;return j.then(ge=>{J.fire(ge)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}b.fromPromise=Se;function he(j,J,ge){return J(ge),j(we=>J(we))}b.runAndSubscribe=he;class fe{constructor(J,ge){this._observable=J,this._counter=0,this._hasChanged=!1;const we={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ge||g(we),this.emitter=new r(we),ge&&ge.add(this.emitter)}beginUpdate(J){this._counter++}handlePossibleChange(J){}handleChange(J,ge){this._hasChanged=!0}endUpdate(J){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Z(j,J){return new fe(j,J).emitter.event}b.fromObservable=Z;function ee(j){return(J,ge,we)=>{let Ae=0,Ee=!1;const ke={beginUpdate(){Ae++},endUpdate(){Ae--,Ae===0&&(j.reportChanges(),Ee&&(Ee=!1,J.call(ge)))},handlePossibleChange(){},handleChange(){Ee=!0}};j.addObserver(ke),j.reportChanges();const z={dispose(){j.removeObserver(ke)}};return we instanceof f.DisposableStore?we.add(z):Array.isArray(we)&&we.push(z),z}}b.fromObservableLight=ee})(y||(e.Event=y={}));class R{static{this.all=new Set}static{this._idPool=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${R._idPool++}`,R.all.add(this)}start(g){this._stopWatch=new A.StopWatch,this.listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=R;let D=-1;function v(b){const g=D;return D=b,{dispose(){D=g}}}e.setGlobalLeakWarningThreshold=v;class S{constructor(g,_=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=_,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(g,_){const T=this.threshold;if(T<=0||_<T)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(g.value)||0;if(this._stacks.set(g.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let x,N=0;for(const[M,L]of this._stacks)(!x||N<L)&&(x=M,N=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${N}):`),console.warn(x)}return()=>{const x=this._stacks.get(g.value)||0;this._stacks.set(g.value,x-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(g){this.value=g,this.id=c++}}const o=2,i=(b,g)=>{if(b instanceof m)g(b);else for(let _=0;_<b.length;_++){const T=b[_];T&&g(T)}};class r{constructor(g){this._size=0,this._options=g,this._leakageMon=D>0||this._options?.leakWarningThreshold?new S(this._options?.leakWarningThreshold??D):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(E){const g=this._listeners;queueMicrotask(()=>{i(g,_=>_.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(g,_,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.Disposable.None;if(this._disposed)return f.Disposable.None;_&&(g=g.bind(_));const O=new m(g);let x,N;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=C.create(),x=this._leakageMon.check(O.stack,this._size+1)),E&&(O.stack=N??C.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new a,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const M=(0,f.toDisposable)(()=>{x?.(),this._removeListener(O)});return T instanceof f.DisposableStore?T.add(M):Array.isArray(T)&&T.push(M),M},this._event}_removeListener(g){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const _=this._listeners,T=_.indexOf(g);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,_[T]=void 0;const O=this._deliveryQueue.current===this;if(this._size*o<=_.length){let x=0;for(let N=0;N<_.length;N++)_[N]?_[x++]=_[N]:O&&(this._deliveryQueue.end--,x<this._deliveryQueue.i&&this._deliveryQueue.i--);_.length=x}}_deliver(g,_){if(!g)return;const T=this._options?.onListenerError||I.onUnexpectedError;if(!T){g.value(_);return}try{g.value(_)}catch(O){T(O)}}_deliverQueue(g){const _=g.current._listeners;for(;g.i<g.end;)this._deliver(_[g.i++],g.value);g.reset()}fire(g){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,g);else{const _=this._deliveryQueue;_.enqueue(this,g,this._listeners.length),this._deliverQueue(_)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=r;const n=()=>new a;e.createEventDeliveryQueue=n;class a{constructor(){this.i=-1,this.end=0}enqueue(g,_,T){this.i=0,this.end=T,this.current=g,this.value=_}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(g,_,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList),i(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,g]));this._asyncDeliveryQueue.size>0&&!_.isCancellationRequested;){const[O,x]=this._asyncDeliveryQueue.shift(),N=[],M={...x,token:_,waitUntil:L=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");T&&(L=T(L,O)),N.push(L)}};try{O(M)}catch(L){(0,I.onUnexpectedError)(L);continue}Object.freeze(N),await Promise.allSettled(N).then(L=>{for(const U of L)U.status==="rejected"&&(0,I.onUnexpectedError)(U.reason)})}}}e.AsyncEmitter=t;class d extends r{get isPaused(){return this._isPaused!==0}constructor(g){super(g),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._size&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=d;class s extends d{constructor(g){super(g),this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=s;class h extends r{constructor(g){super(g),this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this.hasListeners()&&(this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(_=>super.fire(_)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=h;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const _={event:g,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const T=()=>{this.hasListeners&&this.unhook(_);const O=this.events.indexOf(_);this.events.splice(O,1)};return(0,f.toDisposable)((0,F.createSingleCallFunction)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(_=>this.emitter.fire(_))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class u{constructor(g,_,T,O){this._store=new f.DisposableStore;const x=this._store.add(new l),N=this._store.add(new f.DisposableMap);function M(L){N.set(L,x.add(O(L)))}for(const L of g)M(L);this._store.add(_(L=>{M(L)})),this._store.add(T(L=>{N.deleteAndDispose(L)})),this.event=x.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=u;class w{constructor(){this.buffers=[]}wrapEvent(g){return(_,T,O)=>g(x=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>_.call(T,x)):_.call(T,x)},void 0,O)}bufferEvents(g){const _=[];this.buffers.push(_);const T=g();return this.buffers.pop(),_.forEach(O=>O()),T}}e.EventBufferer=w;class k{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=f.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=k}),define(ye[21],Ce([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(E,p){const y=setTimeout(E.bind(p),0);return{dispose(){clearTimeout(y)}}});var f;(function(E){function p(y){return y===E.None||y===E.Cancelled||y instanceof P?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}E.isCancellationToken=p,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=f.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=f.None}}e.CancellationTokenSource=A}),define(ye[162],Ce([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class F{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new I.CancellationTokenSource,p=this.task(E.token);return this.result={promise:p,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=F;class f{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const p=JSON.stringify(E);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=f;class P{get cachedValues(){return this._map}constructor(E){this.fn=E,this._map=new Map}get(E){if(this._map.has(E))return this._map.get(E);const p=this.fn(E);return this._map.set(E,p),p}}e.CachedFunction=P}),define(ye[99],Ce([1,0,14,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function f(n){const a=n;return a?typeof a.read=="function":!1}e.isReadable=f;function P(n){const a=n;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=P;function A(n){const a=n;return a?P(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=A;function E(n,a){return new p(n,a)}e.newWriteableStream=E;class p{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,I.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let d;switch(a){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const s=d.indexOf(t);s>=0&&d.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(n,a){const t=[];let d;for(;(d=n.read())!==null;)t.push(d);return a(t)}e.consumeReadable=y;function R(n,a,t){const d=[];let s;for(;(s=n.read())!==null&&d.length<t;)d.push(s);return s===null&&d.length>0?a(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const h=s;return s=void 0,h}return n.read()}}}e.peekReadable=R;function D(n,a){return new Promise((t,d)=>{const s=[];v(n,{onData:h=>{a&&s.push(h)},onError:h=>{a?d(h):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.consumeStream=D;function v(n,a,t){n.on("error",d=>{t?.isCancellationRequested||a.onError(d)}),n.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),n.on("data",d=>{t?.isCancellationRequested||a.onData(d)})}e.listenStream=v;function S(n,a){return new Promise((t,d)=>{const s=new F.DisposableStore,h=[],l=k=>{if(h.push(k),h.length>a)return s.dispose(),n.pause(),t({stream:n,buffer:h,ended:!1})},u=k=>(s.dispose(),d(k)),w=()=>(s.dispose(),t({stream:n,buffer:h,ended:!0}));s.add((0,F.toDisposable)(()=>n.removeListener("error",u))),n.on("error",u),s.add((0,F.toDisposable)(()=>n.removeListener("end",w))),n.on("end",w),s.add((0,F.toDisposable)(()=>n.removeListener("data",l))),n.on("data",l)})}e.peekStream=S;function C(n,a){const t=E(a);return t.end(n),t}e.toStream=C;function c(){const n=E(()=>{throw new Error("not supported")});return n.end(),n}e.emptyStream=c;function m(n){let a=!1;return{read:()=>a?null:(a=!0,n)}}e.toReadable=m;function o(n,a,t){const d=E(t);return v(n,{onData:s=>d.write(a.data(s)),onError:s=>d.error(a.error?a.error(s):s),onEnd:()=>d.end()}),d}e.transform=o;function i(n,a,t){let d=!1;return{read:()=>{const s=a.read();return d?s:(d=!0,s!==null?t([n,s]):n)}}}e.prefixedReadable=i;function r(n,a,t){let d=!1;const s=E(t);return v(a,{onData:h=>d?s.write(h):(d=!0,s.write(t([n,h]))),onError:h=>s.error(h),onEnd:()=>{d||(d=!0,s.write(n)),s.end()}}),s}e.prefixedStream=r}),define(ye[22],Ce([1,0,43,99]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const f=typeof Buffer<"u",P=new I.Lazy(()=>new Uint8Array(256));let A,E;class p{static alloc(_){return f?new p(Buffer.allocUnsafe(_)):new p(new Uint8Array(_))}static wrap(_){return f&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new p(_)}static fromString(_,T){return!(T?.dontUseNodeBuffer||!1)&&f?new p(Buffer.from(_)):(A||(A=new TextEncoder),new p(A.encode(_)))}static fromByteArray(_){const T=p.alloc(_.length);for(let O=0,x=_.length;O<x;O++)T.buffer[O]=_[O];return T}static concat(_,T){if(typeof T>"u"){T=0;for(let N=0,M=_.length;N<M;N++)T+=_[N].byteLength}const O=p.alloc(T);let x=0;for(let N=0,M=_.length;N<M;N++){const L=_[N];O.set(L,x),x+=L.byteLength}return O}constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}clone(){const _=p.alloc(this.byteLength);return _.set(this),_}toString(){return f?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(_,T){return new p(this.buffer.subarray(_,T))}set(_,T){if(_ instanceof p)this.buffer.set(_.buffer,T);else if(_ instanceof Uint8Array)this.buffer.set(_,T);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),T);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return v(this.buffer,_)}writeUInt32BE(_,T){S(this.buffer,_,T)}readUInt32LE(_){return C(this.buffer,_)}writeUInt32LE(_,T){c(this.buffer,_,T)}readUInt8(_){return m(this.buffer,_)}writeUInt8(_,T){o(this.buffer,_,T)}indexOf(_,T=0){return y(this.buffer,_ instanceof p?_.buffer:_,T)}}e.VSBuffer=p;function y(g,_,T=0){const O=_.byteLength,x=g.byteLength;if(O===0)return 0;if(O===1)return g.indexOf(_[0]);if(O>x-T)return-1;const N=P.value;N.fill(_.length);for(let B=0;B<_.length;B++)N[_[B]]=_.length-B-1;let M=T+_.length-1,L=M,U=-1;for(;M<x;)if(g[M]===_[L]){if(L===0){U=M;break}M--,L--}else M+=Math.max(_.length-L,N[g[M]]),L=_.length-1;return U}e.binaryIndexOf=y;function R(g,_){return g[_+0]<<0>>>0|g[_+1]<<8>>>0}e.readUInt16LE=R;function D(g,_,T){g[T+0]=_&255,_=_>>>8,g[T+1]=_&255}e.writeUInt16LE=D;function v(g,_){return g[_]*2**24+g[_+1]*2**16+g[_+2]*2**8+g[_+3]}e.readUInt32BE=v;function S(g,_,T){g[T+3]=_,_=_>>>8,g[T+2]=_,_=_>>>8,g[T+1]=_,_=_>>>8,g[T]=_}e.writeUInt32BE=S;function C(g,_){return g[_+0]<<0>>>0|g[_+1]<<8>>>0|g[_+2]<<16>>>0|g[_+3]<<24>>>0}e.readUInt32LE=C;function c(g,_,T){g[T+0]=_&255,_=_>>>8,g[T+1]=_&255,_=_>>>8,g[T+2]=_&255,_=_>>>8,g[T+3]=_&255}e.writeUInt32LE=c;function m(g,_){return g[_]}e.readUInt8=m;function o(g,_,T){g[T]=_}e.writeUInt8=o;function i(g){return F.consumeReadable(g,_=>p.concat(_))}e.readableToBuffer=i;function r(g){return F.toReadable(g)}e.bufferToReadable=r;function n(g){return F.consumeStream(g,_=>p.concat(_))}e.streamToBuffer=n;async function a(g){return g.ended?p.concat(g.buffer):p.concat([...g.buffer,await n(g.stream)])}e.bufferedStreamToBuffer=a;function t(g){return F.toStream(g,_=>p.concat(_))}e.bufferToStream=t;function d(g){return F.transform(g,{data:_=>typeof _=="string"?p.fromString(_):p.wrap(_)},_=>p.concat(_))}e.streamToBufferReadableStream=d;function s(g){return F.newWriteableStream(_=>p.concat(_),g)}e.newWriteableBufferStream=s;function h(g,_){return F.prefixedReadable(g,_,T=>p.concat(T))}e.prefixedBufferReadable=h;function l(g,_){return F.prefixedStream(g,_,T=>p.concat(T))}e.prefixedBufferStream=l;function u(g){let _=0,T=0,O=0;const x=new Uint8Array(Math.floor(g.length/4*3)),N=L=>{switch(T){case 3:x[O++]=_|L,T=0;break;case 2:x[O++]=_|L>>>2,_=L<<6,T=3;break;case 1:x[O++]=_|L>>>4,_=L<<4,T=2;break;default:_=L<<2,T=1}};for(let L=0;L<g.length;L++){const U=g.charCodeAt(L);if(U>=65&&U<=90)N(U-65);else if(U>=97&&U<=122)N(U-97+26);else if(U>=48&&U<=57)N(U-48+52);else if(U===43||U===45)N(62);else if(U===47||U===95)N(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${g[L]}`)}}const M=O;for(;T>0;)N(0);return p.wrap(x).slice(0,M)}e.decodeBase64=u;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:g},_=!0,T=!1){const O=T?k:w;let x="";const N=g.byteLength%3;let M=0;for(;M<g.byteLength-N;M+=3){const L=g[M+0],U=g[M+1],B=g[M+2];x+=O[L>>>2],x+=O[(L<<4|U>>>4)&63],x+=O[(U<<2|B>>>6)&63],x+=O[B&63]}if(N===1){const L=g[M+0];x+=O[L>>>2],x+=O[L<<4&63],_&&(x+="==")}else if(N===2){const L=g[M+0],U=g[M+1];x+=O[L>>>2],x+=O[(L<<4|U>>>4)&63],x+=O[U<<2&63],_&&(x+="=")}return x}e.encodeBase64=b}),define(ye[12],Ce([1,0,162,43]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function f(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.isFalsyOrWhitespace=f;const P=/{(\d+)}/g;function A(Pe,...xe){return xe.length===0?Pe:Pe.replace(P,function(Te,Xe){const re=parseInt(Xe,10);return isNaN(re)||re<0||re>=xe.length?Te:xe[re]})}e.format=A;const E=/{([^}]+)}/g;function p(Pe,xe){return Object.keys(xe).length===0?Pe:Pe.replace(E,(Te,Xe)=>xe[Xe]??Te)}e.format2=p;function y(Pe){return Pe.replace(/[<>"'&]/g,xe=>{switch(xe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return xe})}e.htmlAttributeEncodeValue=y;function R(Pe){return Pe.replace(/[<>&]/g,function(xe){switch(xe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return xe}})}e.escape=R;function D(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function v(Pe,xe){let Te=0;const Xe=xe.charCodeAt(0);for(let re=Pe.length-1;re>=0;re--)Pe.charCodeAt(re)===Xe&&Te++;return Te}e.count=v;function S(Pe,xe,Te="\u2026"){return Pe.length<=xe?Pe:`${Pe.substr(0,xe)}${Te}`}e.truncate=S;function C(Pe,xe,Te="\u2026"){if(Pe.length<=xe)return Pe;const Xe=Math.ceil(xe/2)-Te.length/2,re=Math.floor(xe/2)-Te.length/2;return`${Pe.substr(0,Xe)}${Te}${Pe.substr(Pe.length-re)}`}e.truncateMiddle=C;function c(Pe,xe=" "){const Te=m(Pe,xe);return o(Te,xe)}e.trim=c;function m(Pe,xe){if(!Pe||!xe)return Pe;const Te=xe.length;if(Te===0||Pe.length===0)return Pe;let Xe=0;for(;Pe.indexOf(xe,Xe)===Xe;)Xe=Xe+Te;return Pe.substring(Xe)}e.ltrim=m;function o(Pe,xe){if(!Pe||!xe)return Pe;const Te=xe.length,Xe=Pe.length;if(Te===0||Xe===0)return Pe;let re=Xe,se=-1;for(;se=Pe.lastIndexOf(xe,re-1),!(se===-1||se+Te!==re);){if(se===0)return"";re=se}return Pe.substring(0,re)}e.rtrim=o;function i(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=i;function r(Pe){return Pe.replace(/\*/g,"")}e.stripWildcards=r;function n(Pe,xe,Te={}){if(!Pe)throw new Error("Cannot create regex from empty string");xe||(Pe=D(Pe)),Te.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Xe="";return Te.global&&(Xe+="g"),Te.matchCase||(Xe+="i"),Te.multiline&&(Xe+="m"),Te.unicode&&(Xe+="u"),new RegExp(Pe,Xe)}e.createRegExp=n;function a(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function t(Pe){return Pe.split(/\r\n|\r|\n/)}e.splitLines=t;function d(Pe){for(let xe=0,Te=Pe.length;xe<Te;xe++){const Xe=Pe.charCodeAt(xe);if(Xe!==32&&Xe!==9)return xe}return-1}e.firstNonWhitespaceIndex=d;function s(Pe,xe=0,Te=Pe.length){for(let Xe=xe;Xe<Te;Xe++){const re=Pe.charCodeAt(Xe);if(re!==32&&re!==9)return Pe.substring(xe,Xe)}return Pe.substring(xe,Te)}e.getLeadingWhitespace=s;function h(Pe,xe=Pe.length-1){for(let Te=xe;Te>=0;Te--){const Xe=Pe.charCodeAt(Te);if(Xe!==32&&Xe!==9)return Te}return-1}e.lastNonWhitespaceIndex=h;function l(Pe,xe,Te){const Xe=[];let re=0;for(const se of Pe.matchAll(xe)){if(Xe.push(Pe.slice(re,se.index)),se.index===void 0)throw new Error("match.index should be defined");re=se.index+se[0].length,Xe.push(Te(se[0],...se.slice(1),se.index,Pe,se.groups))}return Xe.push(Pe.slice(re)),Promise.all(Xe).then(se=>se.join(""))}e.replaceAsync=l;function u(Pe,xe){return Pe<xe?-1:Pe>xe?1:0}e.compare=u;function w(Pe,xe,Te=0,Xe=Pe.length,re=0,se=xe.length){for(;Te<Xe&&re<se;Te++,re++){const Qe=Pe.charCodeAt(Te),it=xe.charCodeAt(re);if(Qe<it)return-1;if(Qe>it)return 1}const Ie=Xe-Te,He=se-re;return Ie<He?-1:Ie>He?1:0}e.compareSubstring=w;function k(Pe,xe){return b(Pe,xe,0,Pe.length,0,xe.length)}e.compareIgnoreCase=k;function b(Pe,xe,Te=0,Xe=Pe.length,re=0,se=xe.length){for(;Te<Xe&&re<se;Te++,re++){let Qe=Pe.charCodeAt(Te),it=xe.charCodeAt(re);if(Qe===it)continue;if(Qe>=128||it>=128)return w(Pe.toLowerCase(),xe.toLowerCase(),Te,Xe,re,se);_(Qe)&&(Qe-=32),_(it)&&(it-=32);const nt=Qe-it;if(nt!==0)return nt}const Ie=Xe-Te,He=se-re;return Ie<He?-1:Ie>He?1:0}e.compareSubstringIgnoreCase=b;function g(Pe){return Pe>=48&&Pe<=57}e.isAsciiDigit=g;function _(Pe){return Pe>=97&&Pe<=122}e.isLowerAsciiLetter=_;function T(Pe){return Pe>=65&&Pe<=90}e.isUpperAsciiLetter=T;function O(Pe,xe){return Pe.length===xe.length&&b(Pe,xe)===0}e.equalsIgnoreCase=O;function x(Pe,xe){const Te=xe.length;return xe.length>Pe.length?!1:b(Pe,xe,0,Te)===0}e.startsWithIgnoreCase=x;function N(Pe,xe){const Te=Math.min(Pe.length,xe.length);let Xe;for(Xe=0;Xe<Te;Xe++)if(Pe.charCodeAt(Xe)!==xe.charCodeAt(Xe))return Xe;return Te}e.commonPrefixLength=N;function M(Pe,xe){const Te=Math.min(Pe.length,xe.length);let Xe;const re=Pe.length-1,se=xe.length-1;for(Xe=0;Xe<Te;Xe++)if(Pe.charCodeAt(re-Xe)!==xe.charCodeAt(se-Xe))return Xe;return Te}e.commonSuffixLength=M;function L(Pe){return 55296<=Pe&&Pe<=56319}e.isHighSurrogate=L;function U(Pe){return 56320<=Pe&&Pe<=57343}e.isLowSurrogate=U;function B(Pe,xe){return(Pe-55296<<10)+(xe-56320)+65536}e.computeCodePoint=B;function G(Pe,xe,Te){const Xe=Pe.charCodeAt(Te);if(L(Xe)&&Te+1<xe){const re=Pe.charCodeAt(Te+1);if(U(re))return B(Xe,re)}return Xe}e.getNextCodePoint=G;function le(Pe,xe){const Te=Pe.charCodeAt(xe-1);if(U(Te)&&xe>1){const Xe=Pe.charCodeAt(xe-2);if(L(Xe))return B(Xe,Te)}return Te}class Y{get offset(){return this._offset}constructor(xe,Te=0){this._str=xe,this._len=xe.length,this._offset=Te}setOffset(xe){this._offset=xe}prevCodePoint(){const xe=le(this._str,this._offset);return this._offset-=xe>=65536?2:1,xe}nextCodePoint(){const xe=G(this._str,this._len,this._offset);return this._offset+=xe>=65536?2:1,xe}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class K{get offset(){return this._iterator.offset}constructor(xe,Te=0){this._iterator=new Y(xe,Te)}nextGraphemeLength(){const xe=Re.getInstance(),Te=this._iterator,Xe=Te.offset;let re=xe.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const se=Te.offset,Ie=xe.getGraphemeBreakType(Te.nextCodePoint());if(ae(re,Ie)){Te.setOffset(se);break}re=Ie}return Te.offset-Xe}prevGraphemeLength(){const xe=Re.getInstance(),Te=this._iterator,Xe=Te.offset;let re=xe.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const se=Te.offset,Ie=xe.getGraphemeBreakType(Te.prevCodePoint());if(ae(Ie,re)){Te.setOffset(se);break}re=Ie}return Xe-Te.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function Q(Pe,xe){return new K(Pe,xe).nextGraphemeLength()}e.nextCharLength=Q;function ue(Pe,xe){return new K(Pe,xe).prevGraphemeLength()}e.prevCharLength=ue;function ne(Pe,xe){xe>0&&U(Pe.charCodeAt(xe))&&xe--;const Te=xe+Q(Pe,xe);return[Te-ue(Pe,Te),Te]}e.getCharContainingOffset=ne;function pe(Pe){const xe=new K(Pe);let Te=0;for(;!xe.eol();)Te++,xe.nextGraphemeLength();return Te}e.charCount=pe;let oe;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Pe){return oe||(oe=q()),oe.test(Pe)}e.containsRTL=W;const ie=/^[\t\n\r\x20-\x7E]*$/;function Se(Pe){return ie.test(Pe)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function he(Pe){return e.UNUSUAL_LINE_TERMINATORS.test(Pe)}e.containsUnusualLineTerminators=he;function fe(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.isFullWidthCharacter=fe;function Z(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.isEmojiImprecise=Z;function ee(Pe,xe,Te=""){const Xe=Pe.trimStart();if(Xe.length<xe)return Xe;const re=/\b/g;let se=0;for(;re.test(Xe)&&!(Xe.length-re.lastIndex<xe);)se=re.lastIndex,re.lastIndex+=1;return se===0?Xe:Te+Xe.substring(se).trimStart()}e.lcut=ee;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,J=/\x1b\].*?\x07/g;function ge(Pe){return Pe&&(Pe=Pe.replace(j,"").replace(J,"")),Pe}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ae(Pe){return we(Pe)?Pe.substr(1):Pe}e.stripUTF8BOM=Ae;function Ee(Pe,xe){if(!Pe||!xe||Pe.length<xe.length)return!1;const Te=xe.length,Xe=Pe.toLowerCase();let re=0,se=-1;for(;re<Te;){const Ie=Xe.indexOf(xe[re],se+1);if(Ie<0)return!1;se=Ie,re++}return!0}e.fuzzyContains=Ee;function ke(Pe,xe=!1){return Pe?(xe&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.containsUppercaseCharacter=ke;function z(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.uppercaseFirstLetter=z;function X(Pe,xe=1){if(xe===0)return"";let Te=-1;do Te=Pe.indexOf(`
`,Te+1),xe--;while(xe>0&&Te>=0);return Te===-1?Pe:(Pe[Te-1]==="\r"&&Te--,Pe.substr(0,Te))}e.getNLines=X;function te(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.singleLetterHash=te;function H(Pe){return Re.getInstance().getGraphemeBreakType(Pe)}e.getGraphemeBreakType=H;function ae(Pe,xe){return Pe===0?xe!==5&&xe!==7:Pe===2&&xe===3?!1:Pe===4||Pe===2||Pe===3||xe===4||xe===2||xe===3?!0:!(Pe===8&&(xe===8||xe===9||xe===11||xe===12)||(Pe===11||Pe===9)&&(xe===9||xe===10)||(Pe===12||Pe===10)&&xe===10||xe===5||xe===13||xe===7||Pe===1||Pe===13&&xe===14||Pe===6&&xe===6)}var de;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(de||(e.GraphemeBreakType=de={}));class Re{static{this._INSTANCE=null}static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}constructor(){this._data=Ue()}getGraphemeBreakType(xe){if(xe<32)return xe===10?3:xe===13?2:4;if(xe<127)return 0;const Te=this._data,Xe=Te.length/3;let re=1;for(;re<=Xe;)if(xe<Te[3*re])re=2*re;else if(xe>Te[3*re+1])re=2*re+1;else return Te[3*re+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Pe,xe){if(Pe===0)return 0;const Te=Ke(Pe,xe);if(Te!==void 0)return Te;const Xe=new Y(xe,Pe);return Xe.prevCodePoint(),Xe.offset}e.getLeftDeleteOffset=Ve;function Ke(Pe,xe){const Te=new Y(xe,Pe);let Xe=Te.prevCodePoint();for(;Ze(Xe)||Xe===65039||Xe===8419;){if(Te.offset===0)return;Xe=Te.prevCodePoint()}if(!Z(Xe))return;let re=Te.offset;return re>0&&Te.prevCodePoint()===8205&&(re=Te.offset),re}function Ze(Pe){return 127995<=Pe&&Pe<=127999}var at;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.noBreakWhitespace="\xA0";class st{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(xe=>{function Te(nt){const Me=new Map;for(let St=0;St<nt.length;St+=2)Me.set(nt[St],nt[St+1]);return Me}function Xe(nt,Me){const St=new Map(nt);for(const[Dt,Ft]of Me)St.set(Dt,Ft);return St}function re(nt,Me){if(!nt)return Me;const St=new Map;for(const[Dt,Ft]of nt)Me.has(Dt)&&St.set(Dt,Ft);return St}const se=this.ambiguousCharacterData.value;let Ie=xe.filter(nt=>!nt.startsWith("_")&&nt in se);Ie.length===0&&(Ie=["_default"]);let He;for(const nt of Ie){const Me=Te(se[nt]);He=re(He,Me)}const Qe=Te(se._common),it=Xe(Qe,He);return new st(it)})}static getInstance(xe){return st.cache.get(Array.from(xe))}static{this._locales=new F.Lazy(()=>Object.keys(st.ambiguousCharacterData.value).filter(xe=>!xe.startsWith("_")))}static getLocales(){return st._locales.value}constructor(xe){this.confusableDictionary=xe}isAmbiguous(xe){return this.confusableDictionary.has(xe)}getPrimaryConfusable(xe){return this.confusableDictionary.get(xe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=st;class rt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(rt.getRawData())),this._data}static isInvisibleCharacter(xe){return rt.getData().has(xe)}static get codePoints(){return rt.getData()}}e.InvisibleCharacters=rt}),define(ye[123],Ce([1,0,28,161,12]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...Ee){return function(ke,z){for(let X=0,te=Ee.length;X<te;X++){const H=Ee[X](ke,z);if(H)return H}return null}}e.or=P,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(Ee,ke,z){if(!z||z.length<ke.length)return null;let X;return Ee?X=f.startsWithIgnoreCase(z,ke):X=z.indexOf(ke)===0,X?ke.length>0?[{start:0,end:ke.length}]:[]:null}function E(Ee,ke){const z=ke.toLowerCase().indexOf(Ee.toLowerCase());return z===-1?null:[{start:z,end:z+Ee.length}]}e.matchesContiguousSubString=E;function p(Ee,ke){return y(Ee.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=p;function y(Ee,ke,z,X){if(z===Ee.length)return[];if(X===ke.length)return null;if(Ee[z]===ke[X]){let te=null;return(te=y(Ee,ke,z+1,X+1))?n({start:X,end:X+1},te):null}return y(Ee,ke,z,X+1)}function R(Ee){return 97<=Ee&&Ee<=122}function D(Ee){return 65<=Ee&&Ee<=90}e.isUpper=D;function v(Ee){return 48<=Ee&&Ee<=57}function S(Ee){return Ee===32||Ee===9||Ee===10||Ee===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ee=>C.add(Ee.charCodeAt(0)));function c(Ee){return S(Ee)||C.has(Ee)}function m(Ee,ke){return Ee===ke||c(Ee)&&c(ke)}const o=new Map;function i(Ee){if(o.has(Ee))return o.get(Ee);let ke;const z=(0,F.getKoreanAltChars)(Ee);return z&&(ke=z),o.set(Ee,ke),ke}function r(Ee){return R(Ee)||D(Ee)||v(Ee)}function n(Ee,ke){return ke.length===0?ke=[Ee]:Ee.end===ke[0].start?ke[0].start=Ee.start:ke.unshift(Ee),ke}function a(Ee,ke){for(let z=ke;z<Ee.length;z++){const X=Ee.charCodeAt(z);if(D(X)||v(X)||z>0&&!r(Ee.charCodeAt(z-1)))return z}return Ee.length}function t(Ee,ke,z,X){if(z===Ee.length)return[];if(X===ke.length)return null;if(Ee[z]!==ke[X].toLowerCase())return null;{let te=null,H=X+1;for(te=t(Ee,ke,z+1,X+1);!te&&(H=a(ke,H))<ke.length;)te=t(Ee,ke,z+1,H),H++;return te===null?null:n({start:X,end:X+1},te)}}function d(Ee){let ke=0,z=0,X=0,te=0,H=0;for(let Ve=0;Ve<Ee.length;Ve++)H=Ee.charCodeAt(Ve),D(H)&&ke++,R(H)&&z++,r(H)&&X++,v(H)&&te++;const ae=ke/Ee.length,de=z/Ee.length,Re=X/Ee.length,Ue=te/Ee.length;return{upperPercent:ae,lowerPercent:de,alphaPercent:Re,numericPercent:Ue}}function s(Ee){const{upperPercent:ke,lowerPercent:z}=Ee;return z===0&&ke>.6}function h(Ee){const{upperPercent:ke,lowerPercent:z,alphaPercent:X,numericPercent:te}=Ee;return z>.2&&ke<.8&&X>.6&&te<.2}function l(Ee){let ke=0,z=0,X=0,te=0;for(let H=0;H<Ee.length;H++)X=Ee.charCodeAt(H),D(X)&&ke++,R(X)&&z++,S(X)&&te++;return(ke===0||z===0)&&te===0?Ee.length<=30:ke<=5}function u(Ee,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!l(Ee)||ke.length>60)return null;const z=d(ke);if(!h(z)){if(!s(z))return null;ke=ke.toLowerCase()}let X=null,te=0;for(Ee=Ee.toLowerCase();te<ke.length&&(X=t(Ee,ke,0,te))===null;)te=a(ke,te+1);return X}e.matchesCamelCase=u;function w(Ee,ke,z=!1){if(!ke||ke.length===0)return null;let X=null,te=0;for(Ee=Ee.toLowerCase(),ke=ke.toLowerCase();te<ke.length&&(X=k(Ee,ke,0,te,z),X===null);)te=b(ke,te+1);return X}e.matchesWords=w;function k(Ee,ke,z,X,te){let H=0;if(z===Ee.length)return[];if(X===ke.length)return null;if(!m(Ee.charCodeAt(z),ke.charCodeAt(X))){const Re=i(Ee.charCodeAt(z));if(!Re)return null;for(let Ue=0;Ue<Re.length;Ue++)if(!m(Re[Ue],ke.charCodeAt(X+Ue)))return null;H+=Re.length-1}let ae=null,de=X+H+1;if(ae=k(Ee,ke,z+1,de,te),!te)for(;!ae&&(de=b(ke,de))<ke.length;)ae=k(Ee,ke,z+1,de,te),de++;if(!ae)return null;if(Ee.charCodeAt(z)!==ke.charCodeAt(X)){const Re=i(Ee.charCodeAt(z));if(!Re)return ae;for(let Ue=0;Ue<Re.length;Ue++)if(Re[Ue]!==ke.charCodeAt(X+Ue))return ae}return n({start:X,end:X+H+1},ae)}function b(Ee,ke){for(let z=ke;z<Ee.length;z++)if(c(Ee.charCodeAt(z))||z>0&&c(Ee.charCodeAt(z-1)))return z;return Ee.length}const g=P(e.matchesPrefix,u,E),_=P(e.matchesPrefix,u,p),T=new I.LRUCache(1e4);function O(Ee,ke,z=!1){if(typeof Ee!="string"||typeof ke!="string")return null;let X=T.get(Ee);X||(X=new RegExp(f.convertSimple2RegExpPattern(Ee),"i"),T.set(Ee,X));const te=X.exec(ke);return te?[{start:te.index,end:te.index+te[0].length}]:z?_(Ee,ke):g(Ee,ke)}e.matchesFuzzy=O;function x(Ee,ke){const z=Z(Ee,Ee.toLowerCase(),0,ke,ke.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?M(z):null}e.matchesFuzzy2=x;function N(Ee,ke,z,X,te,H){const ae=Math.min(13,Ee.length);for(;z<ae;z++){const de=Z(Ee,ke,z,X,te,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,H]}e.anyScore=N;function M(Ee){if(typeof Ee>"u")return[];const ke=[],z=Ee[1];for(let X=Ee.length-1;X>1;X--){const te=Ee[X]+z,H=ke[ke.length-1];H&&H.end===te?H.end=te+1:ke.push({start:te,end:te+1})}return ke}e.createMatches=M;const L=128;function U(){const Ee=[],ke=[];for(let z=0;z<=L;z++)ke[z]=0;for(let z=0;z<=L;z++)Ee.push(ke.slice(0));return Ee}function B(Ee){const ke=[];for(let z=0;z<=Ee;z++)ke[z]=0;return ke}const G=B(2*L),le=B(2*L),Y=U(),K=U(),Q=U(),ue=!1;function ne(Ee,ke,z,X,te){function H(de,Re,Ue=" "){for(;de.length<Re;)de=Ue+de;return de}let ae=` |   |${X.split("").map(de=>H(de,3)).join("|")}
`;for(let de=0;de<=z;de++)de===0?ae+=" |":ae+=`${ke[de-1]}|`,ae+=Ee[de].slice(0,te+1).map(Re=>H(Re.toString(),3)).join("|")+`
`;return ae}function pe(Ee,ke,z,X){Ee=Ee.substr(ke),z=z.substr(X),console.log(ne(K,Ee,Ee.length,z,z.length)),console.log(ne(Q,Ee,Ee.length,z,z.length)),console.log(ne(Y,Ee,Ee.length,z,z.length))}function oe(Ee,ke){if(ke<0||ke>=Ee.length)return!1;const z=Ee.codePointAt(ke);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.isEmojiImprecise(z)}}function q(Ee,ke){if(ke<0||ke>=Ee.length)return!1;switch(Ee.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function W(Ee,ke,z){return ke[Ee]!==z[Ee]}function ie(Ee,ke,z,X,te,H,ae=!1){for(;ke<z&&te<H;)Ee[ke]===X[te]&&(ae&&(G[ke]=te),ke+=1),te+=1;return ke===z}e.isPatternInWord=ie;var Se;(function(Ee){Ee[Ee.Diag=1]="Diag",Ee[Ee.Left=2]="Left",Ee[Ee.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var he;(function(Ee){Ee.Default=[-100,0];function ke(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}Ee.isDefault=ke})(he||(e.FuzzyScore=he={}));class fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ke,z){this.firstMatchCanBeWeak=ke,this.boostFullMatch=z}}e.FuzzyScoreOptions=fe;function Z(Ee,ke,z,X,te,H,ae=fe.default){const de=Ee.length>L?L:Ee.length,Re=X.length>L?L:X.length;if(z>=de||H>=Re||de-z>Re-H||!ie(ke,z,de,te,H,Re,!0))return;ee(de,Re,z,H,ke,te);let Ue=1,Ve=1,Ke=z,Ze=H;const at=[!1];for(Ue=1,Ke=z;Ke<de;Ue++,Ke++){const Te=G[Ke],Xe=le[Ke],re=Ke+1<de?le[Ke+1]:Re;for(Ve=Te-H+1,Ze=Te;Ze<re;Ve++,Ze++){let se=Number.MIN_SAFE_INTEGER,Ie=!1;Ze<=Xe&&(se=j(Ee,ke,Ke,z,X,te,Ze,Re,H,Y[Ue-1][Ve-1]===0,at));let He=0;se!==Number.MAX_SAFE_INTEGER&&(Ie=!0,He=se+K[Ue-1][Ve-1]);const Qe=Ze>Te,it=Qe?K[Ue][Ve-1]+(Y[Ue][Ve-1]>0?-5:0):0,nt=Ze>Te+1&&Y[Ue][Ve-1]>0,Me=nt?K[Ue][Ve-2]+(Y[Ue][Ve-2]>0?-5:0):0;if(nt&&(!Qe||Me>=it)&&(!Ie||Me>=He))K[Ue][Ve]=Me,Q[Ue][Ve]=3,Y[Ue][Ve]=0;else if(Qe&&(!Ie||it>=He))K[Ue][Ve]=it,Q[Ue][Ve]=2,Y[Ue][Ve]=0;else if(Ie)K[Ue][Ve]=He,Q[Ue][Ve]=1,Y[Ue][Ve]=Y[Ue-1][Ve-1]+1;else throw new Error("not possible")}}if(ue&&pe(Ee,z,X,H),!at[0]&&!ae.firstMatchCanBeWeak)return;Ue--,Ve--;const st=[K[Ue][Ve],H];let rt=0,Pe=0;for(;Ue>=1;){let Te=Ve;do{const Xe=Q[Ue][Te];if(Xe===3)Te=Te-2;else if(Xe===2)Te=Te-1;else break}while(Te>=1);rt>1&&ke[z+Ue-1]===te[H+Ve-1]&&!W(Te+H-1,X,te)&&rt+1>Y[Ue][Te]&&(Te=Ve),Te===Ve?rt++:rt=1,Pe||(Pe=Te),Ue--,Ve=Te-1,st.push(Ve)}Re===de&&ae.boostFullMatch&&(st[0]+=2);const xe=Pe-de;return st[0]-=xe,st}e.fuzzyScore=Z;function ee(Ee,ke,z,X,te,H){let ae=Ee-1,de=ke-1;for(;ae>=z&&de>=X;)te[ae]===H[de]&&(le[ae]=de,ae--),de--}function j(Ee,ke,z,X,te,H,ae,de,Re,Ue,Ve){if(ke[z]!==H[ae])return Number.MIN_SAFE_INTEGER;let Ke=1,Ze=!1;return ae===z-X?Ke=Ee[z]===te[ae]?7:5:W(ae,te,H)&&(ae===0||!W(ae-1,te,H))?(Ke=Ee[z]===te[ae]?7:5,Ze=!0):oe(H,ae)&&(ae===0||!oe(H,ae-1))?Ke=5:(oe(H,ae-1)||q(H,ae-1))&&(Ke=5,Ze=!0),Ke>1&&z===X&&(Ve[0]=!0),Ze||(Ze=W(ae,te,H)||oe(H,ae-1)||q(H,ae-1)),z===X?ae>Re&&(Ke-=Ze?3:5):Ue?Ke+=Ze?2:0:Ke+=Ze?0:1,ae+1===de&&(Ke-=Ze?3:5),Ke}function J(Ee,ke,z,X,te,H,ae){return we(Ee,ke,z,X,te,H,!0,ae)}e.fuzzyScoreGracefulAggressive=J;function ge(Ee,ke,z,X,te,H,ae){return we(Ee,ke,z,X,te,H,!1,ae)}e.fuzzyScoreGraceful=ge;function we(Ee,ke,z,X,te,H,ae,de){let Re=Z(Ee,ke,z,X,te,H,de);if(Re&&!ae)return Re;if(Ee.length>=3){const Ue=Math.min(7,Ee.length-1);for(let Ve=z+1;Ve<Ue;Ve++){const Ke=Ae(Ee,Ve);if(Ke){const Ze=Z(Ke,Ke.toLowerCase(),z,X,te,H,de);Ze&&(Ze[0]-=3,(!Re||Ze[0]>Re[0])&&(Re=Ze))}}}return Re}function Ae(Ee,ke){if(ke+1>=Ee.length)return;const z=Ee[ke],X=Ee[ke+1];if(z!==X)return Ee.slice(0,ke)+X+z+Ee.slice(ke+2)}}),define(ye[54],Ce([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(o){return f(o,0)}e.hash=F;function f(o,i){switch(typeof o){case"object":return o===null?P(349,i):Array.isArray(o)?p(o,i):y(o,i);case"string":return E(o,i);case"boolean":return A(o,i);case"number":return P(o,i);case"undefined":return P(937,i);default:return P(617,i)}}e.doHash=f;function P(o,i){return(i<<5)-i+o|0}e.numberHash=P;function A(o,i){return P(o?433:863,i)}function E(o,i){i=P(149417,i);for(let r=0,n=o.length;r<n;r++)i=P(o.charCodeAt(r),i);return i}e.stringHash=E;function p(o,i){return i=P(104579,i),o.reduce((r,n)=>f(n,r),i)}function y(o,i){return i=P(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=E(n,r),f(o[n],r)),i)}class R{constructor(){this._value=0}get value(){return this._value}hash(i){return this._value=f(i,this._value),this._value}}e.Hasher=R;var D;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function v(o,i,r=32){const n=r-i,a=~((1<<n)-1);return(o<<i|(a&o)>>>n)>>>0}function S(o,i=0,r=o.byteLength,n=0){for(let a=0;a<r;a++)o[i+a]=n}function C(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function c(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):C((o>>>0).toString(16),i/4)}e.toHexString=c;class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(i){const r=i.length;if(r===0)return;const n=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,d,s;for(t!==0?(d=t,s=-1,t=0):(d=i.charCodeAt(0),s=0);;){let h=d;if(I.isHighSurrogate(d))if(s+1<r){const l=i.charCodeAt(s+1);I.isLowSurrogate(l)?(s++,h=I.computeCodePoint(d,l)):h=65533}else{t=d;break}else I.isLowSurrogate(d)&&(h=65533);if(a=this._push(n,a,h),s++,s<r)d=i.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this._step(),r-=64,this._totalLen+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const i=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(i/4294967296),!1),this._buffDV.setUint32(60,i%4294967296,!1),this._step()}_step(){const i=m._bigBlock32,r=this._buffDV;for(let w=0;w<64;w+=4)i.setUint32(w,r.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)i.setUint32(w,v(i.getUint32(w-12,!1)^i.getUint32(w-32,!1)^i.getUint32(w-56,!1)^i.getUint32(w-64,!1),1),!1);let n=this._h0,a=this._h1,t=this._h2,d=this._h3,s=this._h4,h,l,u;for(let w=0;w<80;w++)w<20?(h=a&t|~a&d,l=1518500249):w<40?(h=a^t^d,l=1859775393):w<60?(h=a&t|a&d|t&d,l=2400959708):(h=a^t^d,l=3395469782),u=v(n,5)+h+s+l+i.getUint32(w*4,!1)&4294967295,s=d,d=t,t=v(a,30),a=n,n=u;this._h0=this._h0+n&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m}),define(ye[39],Ce([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const P="error",A="warning",E="warn",p="info",y="ignore";function R(v){return v?I.equalsIgnoreCase(P,v)?f.Error:I.equalsIgnoreCase(A,v)||I.equalsIgnoreCase(E,v)?f.Warning:I.equalsIgnoreCase(p,v)?f.Info:f.Ignore:f.Ignore}f.fromValue=R;function D(v){switch(v){case f.Error:return P;case f.Warning:return A;case f.Info:return p;default:return y}}f.toString=D}(F||(F={})),e.default=F}),define(ye[163],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[77],Ce([1,0,19,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class f{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const C=S.charCodeAt(0),c=this._value.charCodeAt(this._pos);return C-c}value(){return this._value[this._pos]}}e.StringIterator=f;class P{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,F.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class A{constructor(S=!0,C=!0){this._splitOnBackslash=S,this._caseSensitive=C}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let C=S.length-1;C>=0;C--,this._valueLen--){const c=this._value.charCodeAt(C);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const C=this._value.charCodeAt(this._to);if(C===47||this._splitOnBackslash&&C===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,F.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var E;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(E||(E={}));class p{constructor(S,C){this._ignorePathCasing=S,this._ignoreQueryAndFragment=C,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,F.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(R||(R={}));class D{static forUris(S=()=>!1,C=()=>!1){return new D(new p(S,C))}static forPaths(S=!1){return new D(new A(void 0,!S))}static forStrings(){return new D(new f)}static forConfigKeys(){return new D(new P)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,C){if(C){const c=C.slice(0);(0,I.shuffle)(c);for(const m of c)this.set(m,S)}else{const c=S.slice(0);(0,I.shuffle)(c);for(const m of c)this.set(m[0],m[1])}}set(S,C){const c=this._iter.reset(S);let m;this._root||(this._root=new y,this._root.segment=c.value());const o=[];for(m=this._root;;){const r=c.cmp(m.segment);if(r>0)m.left||(m.left=new y,m.left.segment=c.value()),o.push([-1,m]),m=m.left;else if(r<0)m.right||(m.right=new y,m.right.segment=c.value()),o.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new y,m.mid.segment=c.value()),o.push([0,m]),m=m.mid;else break}const i=m.value;m.value=C,m.key=S;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const a=n.balanceFactor();if(a<-1||a>1){const t=o[r][0],d=o[r+1][0];if(t===1&&d===1)o[r][1]=n.rotateLeft();else if(t===-1&&d===-1)o[r][1]=n.rotateRight();else if(t===1&&d===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&d===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this._root=o[0][1]}}return i}get(S){return this._getNode(S)?.value}_getNode(S){const C=this._iter.reset(S);let c=this._root;for(;c;){const m=C.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(C.hasNext())C.next(),c=c.mid;else break}return c}has(S){const C=this._getNode(S);return!(C?.value===void 0&&C?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,C){const c=this._iter.reset(S),m=[];let o=this._root;for(;o;){const i=c.cmp(o.segment);if(i>0)m.push([-1,o]),o=o.left;else if(i<0)m.push([1,o]),o=o.right;else if(c.hasNext())c.next(),m.push([0,o]),o=o.mid;else break}if(o){if(C?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this._min(o.right);if(i.key){const{key:r,value:n,segment:a}=i;this._delete(i.key,!1),o.key=r,o.value=n,o.segment=a}}else{const i=o.left??o.right;if(m.length>0){const[r,n]=m[m.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this._root=i}for(let i=m.length-1;i>=0;i--){const r=m[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),m[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),m[i][1]=r.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this._root=m[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const C=this._iter.reset(S);let c=this._root,m;for(;c;){const o=C.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(C.hasNext())C.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,C){const c=this._iter.reset(S);let m=this._root;for(;m;){const o=c.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this._entries(m.mid):C?m.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[C,c]of this)S(c,C)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const C=[];return this._dfsEntries(S,C),C[Symbol.iterator]()}_dfsEntries(S,C){S&&(S.left&&this._dfsEntries(S.left,C),S.value&&C.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,C),S.right&&this._dfsEntries(S.right,C))}_isBalanced(){const S=C=>{if(!C)return!0;const c=C.balanceFactor();return c<-1||c>1?!1:S(C.left)&&S(C.right)};return S(this._root)}}e.TernarySearchTree=D}),define(ye[18],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(a){return typeof a=="string"}e.isString=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.isStringArray=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=f;function P(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=P;function A(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=A;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function p(a){return a===!0||a===!1}e.isBoolean=p;function y(a){return typeof a>"u"}e.isUndefined=y;function R(a){return!D(a)}e.isDefined=R;function D(a){return y(a)||a===null}e.isUndefinedOrNull=D;function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function S(a){if(D(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=S;function C(...a){const t=[];for(let d=0;d<a.length;d++){const s=a[d];if(D(s))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(s)}return t}e.assertAllDefined=C;const c=Object.prototype.hasOwnProperty;function m(a){if(!f(a))return!1;for(const t in a)if(c.call(a,t))return!1;return!0}e.isEmptyObject=m;function o(a){return typeof a=="function"}e.isFunction=o;function i(...a){return a.length>0&&a.every(o)}e.areFunctions=i;function r(a,t){const d=Math.min(a.length,t.length);for(let s=0;s<d;s++)n(a[s],t[s])}e.validateConstraints=r;function n(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!D(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=n}),define(ye[78],Ce([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const F=Object.create(null);function f(E,p){if((0,I.isString)(p)){const y=F[p];if(y===void 0)throw new Error(`${E} references an unknown codicon: ${p}`);p=y}return F[E]=p,{id:E}}function P(){return F}e.getCodiconFontCharacters=P;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugBreakpointPending:f("debug-breakpoint-pending",60377),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),surroundWith:f("surround-with",60452),gitStash:f("git-stash",60454),gitStashApply:f("git-stash-apply",60455),gitStashPop:f("git-stash-pop",60456),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ye[24],Ce([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?F(n):n}),i}e.deepClone=F;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(P.call(r,n)){const a=r[n];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.isTypedArray)(a)&&i.push(a)}}return o}e.deepFreeze=f;const P=Object.prototype.hasOwnProperty;function A(o,i){return E(o,i,new Set)}e.cloneAndChange=A;function E(o,i,r){if((0,I.isUndefinedOrNull)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const a=[];for(const t of o)a.push(E(t,i,r));return a}if((0,I.isObject)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const a={};for(const t in o)P.call(o,t)&&(a[t]=E(o[t],i,r));return r.delete(o),a}return o}function p(o,i,r=!0){return(0,I.isObject)(o)?((0,I.isObject)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,I.isObject)(o[n])&&(0,I.isObject)(i[n])?p(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.mixin=p;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!y(o[r],i[r]))return!1}else{const a=[];for(n in o)a.push(n);a.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(a,t))return!1;for(r=0;r<a.length;r++)if(!y(o[a[r]],i[a[r]]))return!1}return!0}e.equals=y;function R(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,I.isObject)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.safeStringify=R;function D(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],d=i[a];y(t,d)||(r[a]=d)}),r}e.distinct=D;function v(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(a=>a.toLowerCase()===r);return n?o[n]:o[i]}e.getCaseInsensitive=v;function S(o,i){const r=Object.create(null);for(const[n,a]of Object.entries(o))i(n,a)&&(r[n]=a);return r}e.filter=S;function C(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.getAllPropertyNames=C;function c(o){const i=[];for(const r of C(o))typeof o[r]=="function"&&i.push(r);return i}e.getAllMethodNames=c;function m(o,i){const r=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},n={};for(const a of o)n[a]=r(a);return n}e.createProxyObject=m}),define(ye[55],Ce([1,0,78]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(A){function E(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=E})(F||(e.ThemeColor=F={}));function f(A){return{id:A}}e.themeColorFromId=f;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(i){const r=E.exec(i.id);if(!r)return p(I.Codicon.error);const[,n,a]=r,t=["codicon","codicon-"+n];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=p;function y(i){return p(i).join(" ")}A.asClassName=y;function R(i){return"."+p(i).join(".")}A.asCSSSelector=R;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}A.isThemeIcon=D;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(i){const r=v.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=S;function C(i){return{id:i}}A.fromId=C;function c(i,r){let n=i.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}A.modify=c;function m(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=m;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=o})(P||(e.ThemeIcon=P={}))}),define(ye[164],Ce([1,0,123,12,55]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const P="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${A.source}`,"g");function p(o){return o.replace(E,(i,r)=>r?i:`\\${i}`)}e.escapeIcons=p;const y=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(y,i=>`\\${i}`)}e.markdownEscapeEscapedIcons=R;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(o){return o.indexOf(P)===-1?o:o.replace(D,(i,r,n,a)=>n?i:r||a||"")}e.stripIcons=v;function S(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.getCodiconAriaLabel=S;const C=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(o){C.lastIndex=0;let i="";const r=[];let n=0;for(;;){const a=C.lastIndex,t=C.exec(o),d=o.substring(a,t?.index);if(d.length>0){i+=d;for(let s=0;s<d.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.parseLabelWithIcons=c;function m(o,i,r=!1){const{text:n,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.matchesFuzzy)(o,n,r);const t=(0,F.ltrim)(n," "),d=n.length-t.length,s=(0,I.matchesFuzzy)(o,t,r);if(s)for(const h of s){const l=a[h.start+d]+d;h.start+=l,h.end+=l}return s}e.matchesFuzzyIconAware=m}),define(ye[124],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var I;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(P){return P<0?0:P>255?255:P|0}e.toUint8=F;function f(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=f}),define(ye[30],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return I.test(f)}e.isUUID=F,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(E){for(let p=0;p<E.length;p++)E[p]=Math.floor(Math.random()*256);return E};const P=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){f(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let p=0,y="";return y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y+="-",y+=A[P[p++]],y+=A[P[p++]],y+="-",y+=A[P[p++]],y+=A[P[p++]],y+="-",y+=A[P[p++]],y+=A[P[p++]],y+="-",y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y+=A[P[p++]],y}}()}),define(ye[165],Ce([1,0,19,53,30]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function P(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=P;function A(D,v,S){const C={id:(0,f.generateUuid)(),name:D,uri:v,data:S};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.createFileDataTransferItem=A;class E{constructor(){this._entries=new Map}get size(){let v=0;for(const S of this._entries)v++;return v}has(v){return this._entries.has(this.toKey(v))}matches(v){const S=[...this._entries.keys()];return F.Iterable.some(this,([C,c])=>c.asFile())&&S.push("files"),R(p(v),S)}get(v){return this._entries.get(this.toKey(v))?.[0]}append(v,S){const C=this._entries.get(v);C?C.push(S):this._entries.set(this.toKey(v),[S])}replace(v,S){this._entries.set(this.toKey(v),[S])}delete(v){this._entries.delete(this.toKey(v))}*[Symbol.iterator](){for(const[v,S]of this._entries)for(const C of S)yield[v,C]}toKey(v){return p(v)}}e.VSDataTransfer=E;function p(D){return D.toLowerCase()}function y(D,v){return R(p(D),v.map(p))}e.matchesMimeType=y;function R(D,v){if(D==="*/*")return v.length>0;if(v.includes(D))return!0;const S=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[C,c,m]=S;return m==="*"?v.some(o=>o.startsWith(c+"/")):!1}e.UriList=Object.freeze({create:D=>(0,I.distinct)(D.map(v=>v.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(v=>!v.startsWith("#"))})}),define(ye[166],Ce([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function F(E,p,y,R=1){let D=!1;return new Promise(v=>{const S=setTimeout(()=>{if(!D)return D=!0,v(0)},y);f(E,p,R,C=>{if(!D)return D=!0,clearTimeout(S),v(C)})})}e.findFreePort=F;function f(E,p,y,R){if(p===0)return R(0);const D=new I.Socket;D.once("connect",()=>(A(D),f(E+y,p-1,y,R))),D.once("data",()=>{}),D.once("error",v=>(A(D),v.code!=="ECONNREFUSED"?f(E+y,p-1,y,R):R(E))),D.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(E,p,y,R="127.0.0.1"){let D=!1,v,S=1;const C=I.createServer({pauseOnConnect:!0});function c(m,o){D||(D=!0,C.removeAllListeners(),C.close(),v&&clearTimeout(v),o(m))}return new Promise(m=>{v=setTimeout(()=>{c(0,m)},y),C.on("listening",()=>{c(E,m)}),C.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<p?(E++,S++,C.listen(E,R)):c(0,m)}),C.on("close",()=>{c(0,m)}),C.listen(E,R)})}e.findFreePortFaster=P;function A(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(p){console.error(p)}}}),define(ye[125],Ce([1,0,124]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(E){const p=(0,I.toUint8)(E);this._defaultValue=p,this._asciiMap=F._createAsciiMap(p),this._map=new Map}static _createAsciiMap(E){const p=new Uint8Array(256);return p.fill(E),p}set(E,p){const y=(0,I.toUint8)(p);E>=0&&E<256?this._asciiMap[E]=y:this._map.set(E,y)}get(E){return E>=0&&E<256?this._asciiMap[E]:this._map.get(E)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=F;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class P{constructor(){this._actual=new F(0)}add(E){this._actual.set(E,1)}has(E){return this._actual.get(E)===1}clear(){return this._actual.clear()}}e.CharacterSet=P}),define(ye[167],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var I;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(f){let P=0,A=0,E=0,p=0;for(let y=0,R=f.length;y<R;y++){const D=f.charCodeAt(y);D===13?(P===0&&(A=y),P++,y+1<R&&f.charCodeAt(y+1)===10?(p|=2,y++):p|=3,E=y+1):D===10&&(p|=1,P===0&&(A=y),P++,E=y+1)}return P===0&&(A=f.length),[P,A,f.length-E,p]}e.countEOL=F}),define(ye[48],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(f,P){this.lineNumber=f,this.column=P}with(f=this.lineNumber,P=this.column){return f===this.lineNumber&&P===this.column?this:new I(f,P)}delta(f=0,P=0){return this.with(this.lineNumber+f,this.column+P)}equals(f){return I.equals(this,f)}static equals(f,P){return!f&&!P?!0:!!f&&!!P&&f.lineNumber===P.lineNumber&&f.column===P.column}isBefore(f){return I.isBefore(this,f)}static isBefore(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<P.column}isBeforeOrEqual(f){return I.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<=P.column}static compare(f,P){const A=f.lineNumber|0,E=P.lineNumber|0;if(A===E){const p=f.column|0,y=P.column|0;return p-y}return A-E}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new I(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=I}),define(ye[29],Ce([1,0,48]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(P,A,E,p){P>E||P===E&&A>p?(this.startLineNumber=E,this.startColumn=p,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=E,this.endColumn=p)}isEmpty(){return F.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return F.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return F.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return F.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return F.plusRange(this,P)}static plusRange(P,A){let E,p,y,R;return A.startLineNumber<P.startLineNumber?(E=A.startLineNumber,p=A.startColumn):A.startLineNumber===P.startLineNumber?(E=A.startLineNumber,p=Math.min(A.startColumn,P.startColumn)):(E=P.startLineNumber,p=P.startColumn),A.endLineNumber>P.endLineNumber?(y=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(y=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(y=P.endLineNumber,R=P.endColumn),new F(E,p,y,R)}intersectRanges(P){return F.intersectRanges(this,P)}static intersectRanges(P,A){let E=P.startLineNumber,p=P.startColumn,y=P.endLineNumber,R=P.endColumn;const D=A.startLineNumber,v=A.startColumn,S=A.endLineNumber,C=A.endColumn;return E<D?(E=D,p=v):E===D&&(p=Math.max(p,v)),y>S?(y=S,R=C):y===S&&(R=Math.min(R,C)),E>y||E===y&&p>R?null:new F(E,p,y,R)}equalsRange(P){return F.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(P){return new I.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(P){return new I.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new F(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new F(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(P){return new F(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(P){return new F(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new F(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new F(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new F(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const y=P.startLineNumber|0,R=A.startLineNumber|0;if(y===R){const D=P.startColumn|0,v=A.startColumn|0;if(D===v){const S=P.endLineNumber|0,C=A.endLineNumber|0;if(S===C){const c=P.endColumn|0,m=A.endColumn|0;return c-m}return S-C}return D-v}return y-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=F}),define(ye[168],Ce([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class F{static insert(P,A){return{range:new I.Range(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.EditOperation=F}),define(ye[169],Ce([1,0,48,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class P extends F.Range{constructor(E,p,y,R){super(E,p,y,R),this.selectionStartLineNumber=E,this.selectionStartColumn=p,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(E){return P.selectionsEqual(this,E)}static selectionsEqual(E,p){return E.selectionStartLineNumber===p.selectionStartLineNumber&&E.selectionStartColumn===p.selectionStartColumn&&E.positionLineNumber===p.positionLineNumber&&E.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(E,p){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,E,p):new P(E,p,this.startLineNumber,this.startColumn)}getPosition(){return new I.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(E,p){return this.getDirection()===0?new P(E,p,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,E,p)}static fromPositions(E,p=E){return new P(E.lineNumber,E.column,p.lineNumber,p.column)}static fromRange(E,p){return p===0?new P(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):new P(E.endLineNumber,E.endColumn,E.startLineNumber,E.startColumn)}static liftSelection(E){return new P(E.selectionStartLineNumber,E.selectionStartColumn,E.positionLineNumber,E.positionColumn)}static selectionsArrEqual(E,p){if(E&&!p||!E&&p)return!1;if(!E&&!p)return!0;if(E.length!==p.length)return!1;for(let y=0,R=E.length;y<R;y++)if(!this.selectionsEqual(E[y],p[y]))return!1;return!0}static isISelection(E){return E&&typeof E.selectionStartLineNumber=="number"&&typeof E.selectionStartColumn=="number"&&typeof E.positionLineNumber=="number"&&typeof E.positionColumn=="number"}static createWithDirection(E,p,y,R,D){return D===0?new P(E,p,y,R):new P(y,R,E,p)}}e.Selection=P}),define(ye[170],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[171],Ce([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends I.CharacterClassifier{constructor(E){super(0);for(let p=0,y=E.length;p<y;p++)this.set(E.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=f;function P(A){const E={};return p=>(E.hasOwnProperty(p)||(E[p]=A(p)),E[p])}e.getMapForWordSeparators=P(A=>new f(A))}),define(ye[126],Ce([1,0,53,3,75]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(D=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.USUAL_WORD_SEPARATORS)D.indexOf(S)>=0||(v+="\\"+S);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=P();function A(D){let v=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)v=D;else{let S="g";D.ignoreCase&&(S+="i"),D.multiline&&(S+="m"),D.unicode&&(S+="u"),v=new RegExp(D.source,S)}return v.lastIndex=0,v}e.ensureValidWordDefinition=A;const E=new f.LinkedList;E.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(D){const v=E.unshift(D);return(0,F.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=p;function y(D,v,S,C,c){if(v=A(v),c||(c=I.Iterable.first(E)),S.length>c.maxLen){let n=D-c.maxLen/2;return n<0?n=0:C+=n,S=S.substring(n,D+c.maxLen/2),y(D,v,S,C,c)}const m=Date.now(),o=D-1-C;let i=-1,r=null;for(let n=1;!(Date.now()-m>=c.timeBudget);n++){const a=o-c.windowSize*n;v.lastIndex=Math.max(0,a);const t=R(v,S,o,i);if(!t&&r||(r=t,a<=0))break;i=a}if(r){const n={word:r[0],startColumn:C+1+r.index,endColumn:C+1+r.index+r[0].length};return v.lastIndex=0,n}return null}e.getWordAtText=y;function R(D,v,S,C){let c;for(;c=D.exec(v);){const m=c.index||0;if(m<=S&&D.lastIndex>=S)return c;if(C>0&&m>C)return null}return null}}),define(ye[172],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(E){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=E.open,this.close=E.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(E.notIn))for(let p=0,y=E.notIn.length;p<y;p++)switch(E.notIn[p]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(E){switch(E){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(E,p){if(E.getTokenCount()===0)return!0;const y=E.findTokenIndexAtOffset(p-2),R=E.getStandardTokenType(y);return this.isOK(R)}_findNeutralCharacterInRange(E,p){for(let y=E;y<=p;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class f{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of E)P(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),P(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),P(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),P(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&P(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.AutoClosingPairs=f;function P(A,E,p){A.has(E)?A.get(E).push(p):A.set(E,[p])}}),define(ye[173],Ce([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var F;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(C,c,m){const o=new Uint8Array(C*c);for(let i=0,r=C*c;i<r;i++)o[i]=m;this._data=o,this.rows=C,this.cols=c}get(C,c){return this._data[C*this.cols+c]}set(C,c,m){this._data[C*this.cols+c]=m}}class P{constructor(C){let c=0,m=0;for(let i=0,r=C.length;i<r;i++){const[n,a,t]=C[i];a>c&&(c=a),n>m&&(m=n),t>m&&(m=t)}c++,m++;const o=new f(m,c,0);for(let i=0,r=C.length;i<r;i++){const[n,a,t]=C[i];o.set(n,a,t)}this._states=o,this._maxCharCode=c}nextState(C,c){return c<0||c>=this._maxCharCode?0:this._states.get(C,c)}}e.StateMachine=P;let A=null;function E(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var p;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let y=null;function R(){if(y===null){y=new I.CharacterClassifier(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<S.length;c++)y.set(S.charCodeAt(c),1);const C=".,;:";for(let c=0;c<C.length;c++)y.set(C.charCodeAt(c),2)}return y}class D{static _createLink(C,c,m,o,i){let r=i-1;do{const n=c.charCodeAt(r);if(C.get(n)!==2)break;r--}while(r>o);if(o>0){const n=c.charCodeAt(o-1),a=c.charCodeAt(r);(n===40&&a===41||n===91&&a===93||n===123&&a===125)&&r--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:r+2},url:c.substring(o,r+1)}}static computeLinks(C,c=E()){const m=R(),o=[];for(let i=1,r=C.getLineCount();i<=r;i++){const n=C.getLineContent(i),a=n.length;let t=0,d=0,s=0,h=1,l=!1,u=!1,w=!1,k=!1;for(;t<a;){let b=!1;const g=n.charCodeAt(t);if(h===13){let _;switch(g){case 40:l=!0,_=0;break;case 41:_=l?0:1;break;case 91:w=!0,u=!0,_=0;break;case 93:w=!1,_=u?0:1;break;case 123:k=!0,_=0;break;case 125:_=k?0:1;break;case 39:case 34:case 96:s===g?_=1:s===39||s===34||s===96?_=0:_=1;break;case 42:_=s===42?1:0;break;case 124:_=s===124?1:0;break;case 32:_=w?0:1;break;default:_=m.get(g)}_===1&&(o.push(D._createLink(m,n,i,d,t)),b=!0)}else if(h===12){let _;g===91?(u=!0,_=0):_=m.get(g),_===1?b=!0:h=13}else h=c.nextState(h,g),h===0&&(b=!0);b&&(h=1,l=!1,u=!1,k=!1,d=t+1,s=g),t++}h===13&&o.push(D._createLink(m,n,i,d,a))}return o}}e.LinkComputer=D;function v(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:D.computeLinks(S)}e.computeLinks=v}),define(ye[79],Ce([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(f||(e.GlyphMarginLane=f={}));var P;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var E;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(E||(e.EndOfLinePreference=E={}));var p;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class R{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class D{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.FindMatch=D;var v;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function S(n){return n&&typeof n.read=="function"}e.isITextSnapshot=S;var C;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var c;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class m{constructor(a,t,d,s,h,l){this.identifier=a,this.range=t,this.text=d,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=h,this._isTracked=l}}e.ValidAnnotatedEditOperation=m;class o{constructor(a,t,d){this.regex=a,this.wordSeparators=t,this.simpleSearch=d}}e.SearchData=o;class i{constructor(a,t,d){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=d}}e.ApplyEditsResult=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.shouldSynchronizeModel=r}),define(ye[174],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class I{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return f(this.right);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.left!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}prev(){if(this.left!==e.SENTINEL)return P(this.left);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.right!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=I;var F;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(F||(e.NodeColor=F={})),e.SENTINEL=new I(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function f(c){for(;c.left!==e.SENTINEL;)c=c.left;return c}e.leftest=f;function P(c){for(;c.right!==e.SENTINEL;)c=c.right;return c}e.righttest=P;function A(c){return c===e.SENTINEL?0:c.size_left+c.piece.length+A(c.right)}function E(c){return c===e.SENTINEL?0:c.lf_left+c.piece.lineFeedCnt+E(c.right)}function p(){e.SENTINEL.parent=e.SENTINEL}function y(c,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.SENTINEL&&(o.left.parent=m),o.parent=m.parent,m.parent===e.SENTINEL?c.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}e.leftRotate=y;function R(c,m){const o=m.left;m.left=o.right,o.right!==e.SENTINEL&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.SENTINEL?c.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}e.rightRotate=R;function D(c,m){let o,i;if(m.left===e.SENTINEL?(i=m,o=i.right):m.right===e.SENTINEL?(i=m,o=i.left):(i=f(m.right),o=i.right),i===c.root){c.root=o,o.color=0,m.detach(),p(),c.root.parent=e.SENTINEL;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===m?(o.parent=i.parent,C(c,o)):(i.parent===m?o.parent=i:o.parent=i.parent,C(c,o),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===c.root?c.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.SENTINEL&&(i.left.parent=i),i.right!==e.SENTINEL&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,C(c,i)),m.detach(),o.parent.left===o){const a=A(o),t=E(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const d=a-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,S(c,o.parent,d,s)}}if(C(c,o.parent),r){p();return}let n;for(;o!==c.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,y(c,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(c,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,y(c,o.parent),o=c.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,R(c,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(c,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,R(c,o.parent),o=c.root));o.color=0,p()}e.rbDelete=D;function v(c,m){for(C(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,y(c,m)),m.parent.color=0,m.parent.parent.color=1,R(c,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(c,m)),m.parent.color=0,m.parent.parent.color=1,y(c,m.parent.parent))}c.root.color=0}e.fixInsert=v;function S(c,m,o,i){for(;m!==c.root&&m!==e.SENTINEL;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}e.updateTreeMetadata=S;function C(c,m){let o=0,i=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,o=A(m.left)-m.size_left,i=E(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=i;m!==c.root&&(o!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}}e.recomputeTreeMetadata=C}),define(ye[175],Ce([1,0,19,124]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class f{constructor(p){this.values=p,this.prefixSum=new Uint32Array(p.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(p,y){p=(0,F.toUint32)(p);const R=this.values,D=this.prefixSum,v=y.length;return v===0?!1:(this.values=new Uint32Array(R.length+v),this.values.set(R.subarray(0,p),0),this.values.set(R.subarray(p),p+v),this.values.set(y,p),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(p,y){return p=(0,F.toUint32)(p),y=(0,F.toUint32)(y),this.values[p]===y?!1:(this.values[p]=y,p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),!0)}removeValues(p,y){p=(0,F.toUint32)(p),y=(0,F.toUint32)(y);const R=this.values,D=this.prefixSum;if(p>=R.length)return!1;const v=R.length-p;return y>=v&&(y=v),y===0?!1:(this.values=new Uint32Array(R.length-y),this.values.set(R.subarray(0,p),0),this.values.set(R.subarray(p+y),p),this.prefixSum=new Uint32Array(this.values.length),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(p){return p<0?0:(p=(0,F.toUint32)(p),this._getPrefixSum(p))}_getPrefixSum(p){if(p<=this.prefixSumValidIndex[0])return this.prefixSum[p];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),p>=this.values.length&&(p=this.values.length-1);for(let R=y;R<=p;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],p),this.prefixSum[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let y=0,R=this.values.length-1,D=0,v=0,S=0;for(;y<=R;)if(D=y+(R-y)/2|0,v=this.prefixSum[D],S=v-this.values[D],p<S)R=D-1;else if(p>=v)y=D+1;else break;return new A(D,p-S)}}e.PrefixSumComputer=f;class P{constructor(p){this._values=p,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(p){return this._ensureValid(),p===0?0:this._prefixSum[p-1]}getIndexOf(p){this._ensureValid();const y=this._indexBySum[p],R=y>0?this._prefixSum[y-1]:0;return new A(y,p-R)}removeValues(p,y){this._values.splice(p,y),this._invalidate(p)}insertValues(p,y){this._values=(0,I.arrayInsert)(this._values,p,y),this._invalidate(p)}_invalidate(p){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,p-1)}_ensureValid(){if(!this._isValid){for(let p=this._validEndIndex+1,y=this._values.length;p<y;p++){const R=this._values[p],D=p>0?this._prefixSum[p-1]:0;this._prefixSum[p]=D+R;for(let v=0;v<R;v++)this._indexBySum[D+v]=p}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(p,y){this._values[p]!==y&&(this._values[p]=y,this._invalidate(p))}}e.ConstantTimePrefixSumComputer=P;class A{constructor(p,y){this.index=p,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=y}}e.PrefixSumIndexOfResult=A}),define(ye[176],Ce([1,0,12,48,175]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(E,p,y,R){this._uri=E,this._lines=p,this._eol=y,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(E){E.eol&&E.eol!==this._eol&&(this._eol=E.eol,this._lineStarts=null);const p=E.changes;for(const y of p)this._acceptDeleteRange(y.range),this._acceptInsertText(new F.Position(y.range.startLineNumber,y.range.startColumn),y.text);this._versionId=E.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const E=this._eol.length,p=this._lines.length,y=new Uint32Array(p);for(let R=0;R<p;R++)y[R]=this._lines[R].length+E;this._lineStarts=new f.PrefixSumComputer(y)}}_setLineText(E,p){this._lines[E]=p,this._lineStarts&&this._lineStarts.setValue(E,this._lines[E].length+this._eol.length)}_acceptDeleteRange(E){if(E.startLineNumber===E.endLineNumber){if(E.startColumn===E.endColumn)return;this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.startLineNumber-1].substring(E.endColumn-1));return}this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.endLineNumber-1].substring(E.endColumn-1)),this._lines.splice(E.startLineNumber,E.endLineNumber-E.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(E.startLineNumber,E.endLineNumber-E.startLineNumber)}_acceptInsertText(E,p){if(p.length===0)return;const y=(0,I.splitLines)(p);if(y.length===1){this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+y[0]+this._lines[E.lineNumber-1].substring(E.column-1));return}y[y.length-1]+=this._lines[E.lineNumber-1].substring(E.column-1),this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let D=1;D<y.length;D++)this._lines.splice(E.lineNumber+D-1,0,y[D]),R[D-1]=y[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(E.lineNumber,R)}}e.MirrorTextModel=P}),define(ye[100],Ce([1,0,12,171,48,29,79]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const E=999;class p{constructor(i,r,n,a){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=I.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.SearchData(r,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,n?this.searchString:null)}}e.SearchParams=p;function y(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.isMultilineRegexSource=y;function R(o,i,r){if(!r)return new A.FindMatch(o,null);const n=[];for(let a=0,t=i.length;a<t;a++)n[a]=i[a];return new A.FindMatch(o,n)}e.createFindMatch=R;class D{constructor(i){const r=[];let n=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(r[n++]=a);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(i){const r=this._lineFeedsOffsets;let n=0,a=r.length-1;if(a===-1||i<=r[0])return 0;for(;n<a;){const t=n+((a-n)/2>>0);r[t]>=i?a=t-1:r[t+1]>=i?(n=t,a=t):n=t+1}return n+1}}class v{static findMatches(i,r,n,a,t){const d=r.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(i,n,new m(d.wordSeparators,d.regex),a,t):this._doFindMatchesLineByLine(i,n,d,a,t):[]}static _getMultilineMatchRange(i,r,n,a,t,d){let s,h=0;a?(h=a.findLineFeedCountBeforeOffset(t),s=r+t+h):s=r+t;let l;if(a){const b=a.findLineFeedCountBeforeOffset(t+d.length)-h;l=s+d.length+b}else l=s+d.length;const u=i.getPositionAt(s),w=i.getPositionAt(l);return new P.Range(u.lineNumber,u.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(i,r,n,a,t){const d=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),h=i.getEOL()===`\r
`?new D(s):null,l=[];let u=0,w;for(n.reset(0);w=n.next(s);)if(l[u++]=R(this._getMultilineMatchRange(i,d,s,h,w.index,w[0]),w,a),u>=t)return l;return l}static _doFindMatchesLineByLine(i,r,n,a,t){const d=[];let s=0;if(r.startLineNumber===r.endLineNumber){const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this._findMatchesInLine(n,l,r.startLineNumber,r.startColumn-1,s,d,a,t),d}const h=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this._findMatchesInLine(n,h,r.startLineNumber,r.startColumn-1,s,d,a,t);for(let l=r.startLineNumber+1;l<r.endLineNumber&&s<t;l++)s=this._findMatchesInLine(n,i.getLineContent(l),l,0,s,d,a,t);if(s<t){const l=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this._findMatchesInLine(n,l,r.endLineNumber,0,s,d,a,t)}return d}static _findMatchesInLine(i,r,n,a,t,d,s,h){const l=i.wordSeparators;if(!s&&i.simpleSearch){const k=i.simpleSearch,b=k.length,g=r.length;let _=-b;for(;(_=r.indexOf(k,_+b))!==-1;)if((!l||c(l,r,g,_,b))&&(d[t++]=new A.FindMatch(new P.Range(n,_+1+a,n,_+1+b+a),null),t>=h))return t;return t}const u=new m(i.wordSeparators,i.regex);let w;u.reset(0);do if(w=u.next(r),w&&(d[t++]=R(new P.Range(n,w.index+1+a,n,w.index+1+w[0].length+a),w,s),t>=h))return t;while(w);return t}static findNextMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(i,n,d,a):this._doFindNextMatchLineByLine(i,n,d,a)}static _doFindNextMatchMultiline(i,r,n,a){const t=new f.Position(r.lineNumber,1),d=i.getOffsetAt(t),s=i.getLineCount(),h=i.getValueInRange(new P.Range(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),l=i.getEOL()===`\r
`?new D(h):null;n.reset(r.column-1);const u=n.next(h);return u?R(this._getMultilineMatchRange(i,d,h,l,u.index,u[0]),u,a):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(i,new f.Position(1,1),n,a):null}static _doFindNextMatchLineByLine(i,r,n,a){const t=i.getLineCount(),d=r.lineNumber,s=i.getLineContent(d),h=this._findFirstMatchInLine(n,s,d,r.column,a);if(h)return h;for(let l=1;l<=t;l++){const u=(d+l-1)%t,w=i.getLineContent(u+1),k=this._findFirstMatchInLine(n,w,u+1,1,a);if(k)return k}return null}static _findFirstMatchInLine(i,r,n,a,t){i.reset(a-1);const d=i.next(r);return d?R(new P.Range(n,d.index+1,n,d.index+1+d[0].length),d,t):null}static findPreviousMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(i,n,d,a):this._doFindPreviousMatchLineByLine(i,n,d,a)}static _doFindPreviousMatchMultiline(i,r,n,a){const t=this._doFindMatchesMultiline(i,new P.Range(1,1,r.lineNumber,r.column),n,a,10*E);if(t.length>0)return t[t.length-1];const d=i.getLineCount();return r.lineNumber!==d||r.column!==i.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(i,new f.Position(d,i.getLineMaxColumn(d)),n,a):null}static _doFindPreviousMatchLineByLine(i,r,n,a){const t=i.getLineCount(),d=r.lineNumber,s=i.getLineContent(d).substring(0,r.column-1),h=this._findLastMatchInLine(n,s,d,a);if(h)return h;for(let l=1;l<=t;l++){const u=(t+d-l-1)%t,w=i.getLineContent(u+1),k=this._findLastMatchInLine(n,w,u+1,a);if(k)return k}return null}static _findLastMatchInLine(i,r,n,a){let t=null,d;for(i.reset(0);d=i.next(r);)t=R(new P.Range(n,d.index+1,n,d.index+1+d[0].length),d,a);return t}}e.TextModelSearch=v;function S(o,i,r,n,a){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(n);if(o.get(d)!==0)return!0}return!1}function C(o,i,r,n,a){if(n+a===r)return!0;const t=i.charCodeAt(n+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(n+a-1);if(o.get(d)!==0)return!0}return!1}function c(o,i,r,n,a){return S(o,i,r,n,a)&&C(o,i,r,n,a)}e.isValidMatch=c;class m{constructor(i,r){this._wordSeparators=i,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const r=i.length;let n;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(n=this._searchRegex.exec(i),!n))return null;const a=n.index,t=n[0].length;if(a===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){I.getNextCodePoint(i,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=t,!this._wordSeparators||c(this._wordSeparators,i,r,a,t))return n}while(n);return null}}e.Searcher=m}),define(ye[127],Ce([1,0,48,29,79,174,100]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const E=65535;function p(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,r,n,a,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=a,this.isBasicASCII=t}}function R(o,i=!0){const r=[0];let n=1;for(let a=0,t=o.length;a<t;a++){const d=o.charCodeAt(a);d===13?a+1<t&&o.charCodeAt(a+1)===10?(r[n++]=a+2,a++):r[n++]=a+1:d===10&&(r[n++]=a+1)}return i?p(r):r}e.createLineStartsFast=R;function D(o,i){o.length=0,o[0]=0;let r=1,n=0,a=0,t=0,d=!0;for(let h=0,l=i.length;h<l;h++){const u=i.charCodeAt(h);u===13?h+1<l&&i.charCodeAt(h+1)===10?(t++,o[r++]=h+2,h++):(n++,o[r++]=h+1):u===10?(a++,o[r++]=h+1):d&&u!==9&&(u<32||u>126)&&(d=!1)}const s=new y(p(o),n,a,t,d);return o.length=0,s}e.createLineStarts=D;class v{constructor(i,r,n,a,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=a,this.length=t}}e.Piece=v;class S{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.StringBuffer=S;class C{constructor(i,r){this._pieces=[],this._tree=i,this._BOM=r,this._index=0,i.root!==P.SENTINEL&&i.iterate(i.root,n=>(n!==P.SENTINEL&&this._pieces.push(n.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class c{constructor(i){this._limit=i,this._cache=[]}get(i){for(let r=this._cache.length-1;r>=0;r--){const n=this._cache[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this._cache.length-1;r>=0;r--){const n=this._cache[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let r=!1;const n=this._cache;for(let a=0;a<n.length;a++){const t=n[a];if(t.node.parent===null||t.nodeStartOffset>=i){n[a]=null,r=!0;continue}}if(r){const a=[];for(const t of n)t!==null&&a.push(t);this._cache=a}}}class m{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this._buffers=[new S("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=P.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=r,this._EOLLength=r.length,this._EOLNormalized=n;let a=null;for(let t=0,d=i.length;t<d;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new v(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this._buffers.push(i[t]),a=this.rbInsertRight(a,s)}this._searchCache=new c(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const r=E,n=r-Math.floor(r/3),a=n*2;let t="",d=0;const s=[];if(this.iterate(this.root,h=>{const l=this.getNodeContent(h),u=l.length;if(d<=n||d+u<a)return t+=l,d+=u,!0;const w=t.replace(/\r\n|\r|\n/g,i);return s.push(new S(w,R(w))),t=l,d=u,!0}),d>0){const h=t.replace(/\r\n|\r|\n/g,i);s.push(new S(h,R(h)))}this.create(s,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new C(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,a=>{if(a===P.SENTINEL)return!0;const t=this.getNodeContent(a),d=t.length,s=i.nodeAt(r),h=i.nodeAt(r+d),l=i.getValueInRange2(s,h);return r+=d,t===l})}getOffsetAt(i,r){let n=0,a=this.root;for(;a!==P.SENTINEL;)if(a.left!==P.SENTINEL&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){n+=a.size_left;const t=this.getAccumulatedValue(a,i-a.lf_left-2);return n+=t+r-1}else i-=a.lf_left+a.piece.lineFeedCnt,n+=a.size_left+a.piece.length,a=a.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const a=i;for(;r!==P.SENTINEL;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.getIndexOf(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const d=this.getOffsetAt(n+1,1),s=a-d;return new I.Position(n+1,s+1)}return new I.Position(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===P.SENTINEL){const t=this.getOffsetAt(n+1,1),d=a-i-t;return new I.Position(n+1,d+1)}else r=r.right;return new I.Position(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.nodeAt2(i.startLineNumber,i.startColumn),a=this.nodeAt2(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,a);return r?r!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,h=this._buffers[s.piece.bufferIndex].buffer,l=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);return h.substring(l+i.remainder,l+r.remainder)}let n=i.node;const a=this._buffers[n.piece.bufferIndex].buffer,t=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);let d=a.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==P.SENTINEL;){const s=this._buffers[n.piece.bufferIndex].buffer,h=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);if(n===r.node){d+=s.substring(h,h+r.remainder);break}else d+=s.substr(h,n.piece.length);n=n.next()}return d}getLinesContent(){const i=[];let r=0,n="",a=!1;return this.iterate(this.root,t=>{if(t===P.SENTINEL)return!0;const d=t.piece;let s=d.length;if(s===0)return!0;const h=this._buffers[d.bufferIndex].buffer,l=this._buffers[d.bufferIndex].lineStarts,u=d.start.line,w=d.end.line;let k=l[u]+d.start.column;if(a&&(h.charCodeAt(k)===10&&(k++,s--),i[r++]=n,n="",a=!1,s===0))return!0;if(u===w)return!this._EOLNormalized&&h.charCodeAt(k+s-1)===13?(a=!0,n+=h.substr(k,s-1)):n+=h.substr(k,s),!0;n+=this._EOLNormalized?h.substring(k,Math.max(k,l[u+1]-this._EOLLength)):h.substring(k,l[u+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let b=u+1;b<w;b++)n=this._EOLNormalized?h.substring(l[b],l[b+1]-this._EOLLength):h.substring(l[b],l[b+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this._EOLNormalized&&h.charCodeAt(l[w]+d.end.column-1)===13?(a=!0,d.end.column===0?r--:n=h.substr(l[w],d.end.column-1)):n=h.substr(l[w],d.end.column),!0}),a&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this._buffers[r.piece.bufferIndex],a=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(a)}else{const r=this._buffers[i.node.piece.bufferIndex],a=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(a)}}getLineCharCode(i,r){const n=this.nodeAt2(i,r+1);return this._getCharCode(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const r=this.nodeAt(i);return this._getCharCode(r)}findMatchesInNode(i,r,n,a,t,d,s,h,l,u,w){const k=this._buffers[i.piece.bufferIndex],b=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),g=this.offsetInBuffer(i.piece.bufferIndex,t),_=this.offsetInBuffer(i.piece.bufferIndex,d);let T;const O={line:0,column:0};let x,N;r._wordSeparators?(x=k.buffer.substring(g,_),N=M=>M+g,r.reset(0)):(x=k.buffer,N=M=>M,r.reset(g));do if(T=r.next(x),T){if(N(T.index)>=_)return u;this.positionInBuffer(i,N(T.index)-b,O);const M=this.getLineFeedCnt(i.piece.bufferIndex,t,O),L=O.line===t.line?O.column-t.column+a:O.column+1,U=L+T[0].length;if(w[u++]=(0,A.createFindMatch)(new F.Range(n+M,L,n+M,U),T,h),N(T.index)+T[0].length>=_||u>=l)return u}while(T);return u}findMatchesLineByLine(i,r,n,a){const t=[];let d=0;const s=new A.Searcher(r.wordSeparators,r.regex);let h=this.nodeAt2(i.startLineNumber,i.startColumn);if(h===null)return[];const l=this.nodeAt2(i.endLineNumber,i.endColumn);if(l===null)return[];let u=this.positionInBuffer(h.node,h.remainder);const w=this.positionInBuffer(l.node,l.remainder);if(h.node===l.node)return this.findMatchesInNode(h.node,s,i.startLineNumber,i.startColumn,u,w,r,n,a,d,t),t;let k=i.startLineNumber,b=h.node;for(;b!==l.node;){const _=this.getLineFeedCnt(b.piece.bufferIndex,u,b.piece.end);if(_>=1){const O=this._buffers[b.piece.bufferIndex].lineStarts,x=this.offsetInBuffer(b.piece.bufferIndex,b.piece.start),N=O[u.line+_],M=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(b,s,k,M,u,this.positionInBuffer(b,N-x),r,n,a,d,t),d>=a)return t;k+=_}const T=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const O=this.getLineContent(k).substring(T,i.endColumn-1);return d=this._findMatchesInLine(r,s,O,i.endLineNumber,T,d,t,n,a),t}if(d=this._findMatchesInLine(r,s,this.getLineContent(k).substr(T),k,T,d,t,n,a),d>=a)return t;k++,h=this.nodeAt2(k,1),b=h.node,u=this.positionInBuffer(h.node,h.remainder)}if(k===i.endLineNumber){const _=k===i.startLineNumber?i.startColumn-1:0,T=this.getLineContent(k).substring(_,i.endColumn-1);return d=this._findMatchesInLine(r,s,T,i.endLineNumber,_,d,t,n,a),t}const g=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(l.node,s,k,g,u,w,r,n,a,d,t),t}_findMatchesInLine(i,r,n,a,t,d,s,h,l){const u=i.wordSeparators;if(!h&&i.simpleSearch){const k=i.simpleSearch,b=k.length,g=n.length;let _=-b;for(;(_=n.indexOf(k,_+b))!==-1;)if((!u||(0,A.isValidMatch)(u,n,g,_,b))&&(s[d++]=new f.FindMatch(new F.Range(a,_+1+t,a,_+1+b+t),null),d>=l))return d;return d}let w;r.reset(0);do if(w=r.next(n),w&&(s[d++]=(0,A.createFindMatch)(new F.Range(a,w.index+1+t,a,w.index+1+w[0].length+t),w,h),d>=l))return d;while(w);return d}insert(i,r,n=!1){if(this._EOLNormalized=this._EOLNormalized&&n,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==P.SENTINEL){const{node:a,remainder:t,nodeStartOffset:d}=this.nodeAt(i),s=a.piece,h=s.bufferIndex,l=this.positionInBuffer(a,t);if(a.piece.bufferIndex===0&&s.end.line===this._lastChangeBufferPos.line&&s.end.column===this._lastChangeBufferPos.column&&d+s.length===i&&r.length<E){this.appendToNode(a,r),this.computeBufferMetadata();return}if(d===i)this.insertContentToNodeLeft(r,a),this._searchCache.validate(i);else if(d+a.piece.length>i){const u=[];let w=new v(s.bufferIndex,l,s.end,this.getLineFeedCnt(s.bufferIndex,l,s.end),this.offsetInBuffer(h,s.end)-this.offsetInBuffer(h,l));if(this.shouldCheckCRLF()&&this.endWithCR(r)&&this.nodeCharCodeAt(a,t)===10){const _={line:w.start.line+1,column:0};w=new v(w.bufferIndex,_,w.end,this.getLineFeedCnt(w.bufferIndex,_,w.end),w.length-1),r+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(r))if(this.nodeCharCodeAt(a,t-1)===13){const _=this.positionInBuffer(a,t-1);this.deleteNodeTail(a,_),r="\r"+r,a.piece.length===0&&u.push(a)}else this.deleteNodeTail(a,l);else this.deleteNodeTail(a,l);const k=this.createNewPieces(r);w.length>0&&this.rbInsertRight(a,w);let b=a;for(let g=0;g<k.length;g++)b=this.rbInsertRight(b,k[g]);this.deleteNodes(u)}else this.insertContentToNodeRight(r,a)}else{const a=this.createNewPieces(r);let t=this.rbInsertLeft(null,a[0]);for(let d=1;d<a.length;d++)t=this.rbInsertRight(t,a[d])}this.computeBufferMetadata()}delete(i,r){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",r<=0||this.root===P.SENTINEL)return;const n=this.nodeAt(i),a=this.nodeAt(i+r),t=n.node,d=a.node;if(t===d){const k=this.positionInBuffer(t,n.remainder),b=this.positionInBuffer(t,a.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const g=t.next();(0,P.rbDelete)(this,t),this.validateCRLFWithPrevNode(g),this.computeBufferMetadata();return}this.deleteNodeHead(t,b),this._searchCache.validate(i),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(n.nodeStartOffset+t.piece.length===i+r){this.deleteNodeTail(t,k),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,k,b),this.computeBufferMetadata();return}const s=[],h=this.positionInBuffer(t,n.remainder);this.deleteNodeTail(t,h),this._searchCache.validate(i),t.piece.length===0&&s.push(t);const l=this.positionInBuffer(d,a.remainder);this.deleteNodeHead(d,l),d.piece.length===0&&s.push(d);const u=t.next();for(let k=u;k!==P.SENTINEL&&k!==d;k=k.next())s.push(k);const w=t.piece.length===0?t.prev():t;this.deleteNodes(s),this.validateCRLFWithNextNode(w),this.computeBufferMetadata()}insertContentToNodeLeft(i,r){const n=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(r)){const d=r.piece,s={line:d.start.line+1,column:0},h=new v(d.bufferIndex,s,d.end,this.getLineFeedCnt(d.bufferIndex,s,d.end),d.length-1);r.piece=h,i+=`
`,(0,P.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const a=this.createNewPieces(i);let t=this.rbInsertLeft(r,a[a.length-1]);for(let d=a.length-2;d>=0;d--)t=this.rbInsertLeft(t,a[d]);this.validateCRLFWithPrevNode(t),this.deleteNodes(n)}insertContentToNodeRight(i,r){this.adjustCarriageReturnFromNext(i,r)&&(i+=`
`);const n=this.createNewPieces(i),a=this.rbInsertRight(r,n[0]);let t=a;for(let d=1;d<n.length;d++)t=this.rbInsertRight(t,n[d]);this.validateCRLFWithPrevNode(a)}positionInBuffer(i,r,n){const a=i.piece,t=i.piece.bufferIndex,d=this._buffers[t].lineStarts,h=d[a.start.line]+a.start.column+r;let l=a.start.line,u=a.end.line,w=0,k=0,b=0;for(;l<=u&&(w=l+(u-l)/2|0,b=d[w],w!==u);)if(k=d[w+1],h<b)u=w-1;else if(h>=k)l=w+1;else break;return n?(n.line=w,n.column=h-b,null):{line:w,column:h-b}}getLineFeedCnt(i,r,n){if(n.column===0)return n.line-r.line;const a=this._buffers[i].lineStarts;if(n.line===a.length-1)return n.line-r.line;const t=a[n.line+1],d=a[n.line]+n.column;if(t>d+1)return n.line-r.line;const s=d-1;return this._buffers[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}offsetInBuffer(i,r){return this._buffers[i].lineStarts[r.line]+r.column}deleteNodes(i){for(let r=0;r<i.length;r++)(0,P.rbDelete)(this,i[r])}createNewPieces(i){if(i.length>E){const u=[];for(;i.length>E;){const k=i.charCodeAt(E-1);let b;k===13||k>=55296&&k<=56319?(b=i.substring(0,E-1),i=i.substring(E-1)):(b=i.substring(0,E),i=i.substring(E));const g=R(b);u.push(new v(this._buffers.length,{line:0,column:0},{line:g.length-1,column:b.length-g[g.length-1]},g.length-1,b.length)),this._buffers.push(new S(b,g))}const w=R(i);return u.push(new v(this._buffers.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this._buffers.push(new S(i,w)),u}let r=this._buffers[0].buffer.length;const n=R(i,!1);let a=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===r&&r!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},a=this._lastChangeBufferPos;for(let u=0;u<n.length;u++)n[u]+=r+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(n.slice(1)),this._buffers[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let u=0;u<n.length;u++)n[u]+=r;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(n.slice(1)),this._buffers[0].buffer+=i}const t=this._buffers[0].buffer.length,d=this._buffers[0].lineStarts.length-1,s=t-this._buffers[0].lineStarts[d],h={line:d,column:s},l=new v(0,a,h,this.getLineFeedCnt(0,a,h),t-r);return this._lastChangeBufferPos=h,[l]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,r=0){let n=this.root,a="";const t=this._searchCache.get2(i);if(t){n=t.node;const d=this.getAccumulatedValue(n,i-t.nodeStartLineNumber-1),s=this._buffers[n.piece.bufferIndex].buffer,h=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)a=s.substring(h+d,h+n.piece.length);else{const l=this.getAccumulatedValue(n,i-t.nodeStartLineNumber);return s.substring(h+d,h+l-r)}}else{let d=0;const s=i;for(;n!==P.SENTINEL;)if(n.left!==P.SENTINEL&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const h=this.getAccumulatedValue(n,i-n.lf_left-2),l=this.getAccumulatedValue(n,i-n.lf_left-1),u=this._buffers[n.piece.bufferIndex].buffer,w=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return d+=n.size_left,this._searchCache.set({node:n,nodeStartOffset:d,nodeStartLineNumber:s-(i-1-n.lf_left)}),u.substring(w+h,w+l-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const h=this.getAccumulatedValue(n,i-n.lf_left-2),l=this._buffers[n.piece.bufferIndex].buffer,u=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);a=l.substring(u+h,u+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,d+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==P.SENTINEL;){const d=this._buffers[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.getAccumulatedValue(n,0),h=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return a+=d.substring(h,h+s-r),a}else{const s=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);a+=d.substr(s,n.piece.length)}n=n.next()}return a}computeBufferMetadata(){let i=this.root,r=1,n=0;for(;i!==P.SENTINEL;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this._lineCnt=r,this._length=n,this._searchCache.validate(this._length)}getIndexOf(i,r){const n=i.piece,a=this.positionInBuffer(i,r),t=a.line-n.start.line;if(this.offsetInBuffer(n.bufferIndex,n.end)-this.offsetInBuffer(n.bufferIndex,n.start)===r){const d=this.getLineFeedCnt(i.piece.bufferIndex,n.start,a);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:a.column}}getAccumulatedValue(i,r){if(r<0)return 0;const n=i.piece,a=this._buffers[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?a[n.end.line]+n.end.column-a[n.start.line]-n.start.column:a[t]-a[n.start.line]-n.start.column}deleteNodeTail(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.offsetInBuffer(n.bufferIndex,n.end),d=r,s=this.offsetInBuffer(n.bufferIndex,d),h=this.getLineFeedCnt(n.bufferIndex,n.start,d),l=h-a,u=s-t,w=n.length+u;i.piece=new v(n.bufferIndex,n.start,d,h,w),(0,P.updateTreeMetadata)(this,i,u,l)}deleteNodeHead(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.offsetInBuffer(n.bufferIndex,n.start),d=r,s=this.getLineFeedCnt(n.bufferIndex,d,n.end),h=this.offsetInBuffer(n.bufferIndex,d),l=s-a,u=t-h,w=n.length+u;i.piece=new v(n.bufferIndex,d,n.end,s,w),(0,P.updateTreeMetadata)(this,i,u,l)}shrinkNode(i,r,n){const a=i.piece,t=a.start,d=a.end,s=a.length,h=a.lineFeedCnt,l=r,u=this.getLineFeedCnt(a.bufferIndex,a.start,l),w=this.offsetInBuffer(a.bufferIndex,r)-this.offsetInBuffer(a.bufferIndex,t);i.piece=new v(a.bufferIndex,a.start,l,u,w),(0,P.updateTreeMetadata)(this,i,w-s,u-h);const k=new v(a.bufferIndex,n,d,this.getLineFeedCnt(a.bufferIndex,n,d),this.offsetInBuffer(a.bufferIndex,d)-this.offsetInBuffer(a.bufferIndex,n)),b=this.rbInsertRight(i,k);this.validateCRLFWithPrevNode(b)}appendToNode(i,r){this.adjustCarriageReturnFromNext(r,i)&&(r+=`
`);const n=this.shouldCheckCRLF()&&this.startWithLF(r)&&this.endWithCR(i),a=this._buffers[0].buffer.length;this._buffers[0].buffer+=r;const t=R(r,!1);for(let b=0;b<t.length;b++)t[b]+=a;if(n){const b=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:a-b}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const d=this._buffers[0].lineStarts.length-1,s=this._buffers[0].buffer.length-this._buffers[0].lineStarts[d],h={line:d,column:s},l=i.piece.length+r.length,u=i.piece.lineFeedCnt,w=this.getLineFeedCnt(0,i.piece.start,h),k=w-u;i.piece=new v(i.piece.bufferIndex,i.piece.start,h,w,l),this._lastChangeBufferPos=h,(0,P.updateTreeMetadata)(this,i,r.length,k)}nodeAt(i){let r=this.root;const n=this._searchCache.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let a=0;for(;r!==P.SENTINEL;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){a+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:a};return this._searchCache.set(t),t}else i-=r.size_left+r.piece.length,a+=r.size_left+r.piece.length,r=r.right;return null}nodeAt2(i,r){let n=this.root,a=0;for(;n!==P.SENTINEL;)if(n.left!==P.SENTINEL&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.getAccumulatedValue(n,i-n.lf_left-2),d=this.getAccumulatedValue(n,i-n.lf_left-1);return a+=n.size_left,{node:n,remainder:Math.min(t+r-1,d),nodeStartOffset:a}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.getAccumulatedValue(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:a};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==P.SENTINEL;){if(n.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(n,0),d=this.offsetOfNode(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:d}}else if(n.piece.length>=r-1){const t=this.offsetOfNode(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}nodeCharCodeAt(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this._buffers[i.piece.bufferIndex],a=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(a)}offsetOfNode(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.SENTINEL||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this._buffers[r.bufferIndex].lineStarts,a=r.start.line,t=n[a]+r.start.column;return a===n.length-1||n[a+1]>t+1?!1:this._buffers[r.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const r=i.prev();this.endWithCR(r)&&this.fixCRLF(r,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const r=i.next();this.startWithLF(r)&&this.fixCRLF(i,r)}}fixCRLF(i,r){const n=[],a=this._buffers[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new v(i.piece.bufferIndex,i.piece.start,t,s,d),(0,P.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&n.push(i);const h={line:r.piece.start.line+1,column:0},l=r.piece.length-1,u=this.getLineFeedCnt(r.piece.bufferIndex,h,r.piece.end);r.piece=new v(r.piece.bufferIndex,h,r.piece.end,u,l),(0,P.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&n.push(r);const w=this.createNewPieces(`\r
`);this.rbInsertRight(i,w[0]);for(let k=0;k<n.length;k++)(0,P.rbDelete)(this,n[k])}adjustCarriageReturnFromNext(i,r){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=r.next();if(this.startWithLF(n)){if(i+=`
`,n.piece.length===1)(0,P.rbDelete)(this,n);else{const a=n.piece,t={line:a.start.line+1,column:0},d=a.length-1,s=this.getLineFeedCnt(a.bufferIndex,t,a.end);n.piece=new v(a.bufferIndex,t,a.end,s,d),(0,P.updateTreeMetadata)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===P.SENTINEL)return r(P.SENTINEL);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}getNodeContent(i){if(i===P.SENTINEL)return"";const r=this._buffers[i.piece.bufferIndex],n=i.piece,a=this.offsetInBuffer(n.bufferIndex,n.start),t=this.offsetInBuffer(n.bufferIndex,n.end);return r.buffer.substring(a,t)}getPieceContent(i){const r=this._buffers[i.bufferIndex],n=this.offsetInBuffer(i.bufferIndex,i.start),a=this.offsetInBuffer(i.bufferIndex,i.end);return r.buffer.substring(n,a)}rbInsertRight(i,r){const n=new P.TreeNode(r,1);if(n.left=P.SENTINEL,n.right=P.SENTINEL,n.parent=P.SENTINEL,n.size_left=0,n.lf_left=0,this.root===P.SENTINEL)this.root=n,n.color=0;else if(i.right===P.SENTINEL)i.right=n,n.parent=i;else{const t=(0,P.leftest)(i.right);t.left=n,n.parent=t}return(0,P.fixInsert)(this,n),n}rbInsertLeft(i,r){const n=new P.TreeNode(r,1);if(n.left=P.SENTINEL,n.right=P.SENTINEL,n.parent=P.SENTINEL,n.size_left=0,n.lf_left=0,this.root===P.SENTINEL)this.root=n,n.color=0;else if(i.left===P.SENTINEL)i.left=n,n.parent=i;else{const a=(0,P.righttest)(i.left);a.right=n,n.parent=a}return(0,P.fixInsert)(this,n),n}getContentOfSubTree(i){let r="";return this.iterate(i,n=>(r+=this.getNodeContent(n),!0)),r}}e.PieceTreeBase=m}),define(ye[177],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(P){if(P&&this._dragOperations.has(P)){const A=this._dragOperations.get(P);return this._dragOperations.delete(P),A}}addDragOperationTransfer(P,A){this._dragOperations.set(P,A)}}e.TreeViewsDnDService=I;class F{constructor(P){this.identifier=P}}e.DraggedTreeItemsIdentifier=F}),define(ye[178],Ce([1,0,4,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class f{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,p){return this._tokenizationSupports.set(E,p),this.handleChange([E]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(E)===p&&(this._tokenizationSupports.delete(E),this.handleChange([E]))})}get(E){return this._tokenizationSupports.get(E)||null}registerFactory(E,p){this._factories.get(E)?.dispose();const y=new P(this,E,p);return this._factories.set(E,y),(0,F.toDisposable)(()=>{const R=this._factories.get(E);!R||R!==y||(this._factories.delete(E),R.dispose())})}async getOrCreate(E){const p=this.get(E);if(p)return p;const y=this._factories.get(E);return!y||y.isResolved?null:(await y.resolve(),this.get(E))}isResolved(E){if(this.get(E))return!0;const y=this._factories.get(E);return!!(!y||y.isResolved)}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=f;class P extends F.Disposable{get isResolved(){return this._isResolved}constructor(E,p,y){super(),this._registry=E,this._languageId=p,this._factory=y,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const E=await this._factory.tokenizationSupport;this._isResolved=!0,E&&!this._isDisposed&&this._register(this._registry.register(this._languageId,E))}}}),define(ye[179],Ce([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ye[180],Ce([1,0,4,3,179]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class P extends F.Disposable{constructor(v,S="",C="",c=!0,m){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=v,this._label=S,this._cssClass=C,this._enabled=c,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}async run(v,S){this._actionCallback&&await this._actionCallback(v)}}e.Action=P;class A extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(v,S){if(!v.enabled)return;this._onWillRun.fire({action:v});let C;try{await this.runAction(v,S)}catch(c){C=c}this._onDidRun.fire({action:v,error:C})}async runAction(v,S){await v.run(S)}}e.ActionRunner=A;class E{constructor(){this.id=E.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let S=[];for(const C of v)C.length&&(S.length?S=[...S,new E,...C]:S=C);return S}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=E;class p{get actions(){return this._actions}constructor(v,S,C,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=S,this.class=c,this._actions=C}async run(){}}e.SubmenuAction=p;class y extends P{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,f.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=y;function R(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...v)=>D.run(...v),tooltip:D.label}}e.toAction=R}),define(ye[181],Ce([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ye[182],Ce([1,0,181]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,f=F*60,P=f*24,A=P*7,E=P*30,p=P*365;function y(D,v,S,C){typeof D!="number"&&(D=D.getTime());const c=Math.round((new Date().getTime()-D)/1e3);if(c<-30)return(0,I.localize)(0,null,y(new Date().getTime()+c*1e3,!1));if(!C&&c<30)return(0,I.localize)(1,null);let m;return c<F?(m=c,v?m===1?S?(0,I.localize)(2,null,m):(0,I.localize)(3,null,m):S?(0,I.localize)(4,null,m):(0,I.localize)(5,null,m):m===1?S?(0,I.localize)(6,null,m):(0,I.localize)(7,null,m):S?(0,I.localize)(8,null,m):(0,I.localize)(9,null,m)):c<f?(m=Math.floor(c/F),v?m===1?S?(0,I.localize)(10,null,m):(0,I.localize)(11,null,m):S?(0,I.localize)(12,null,m):(0,I.localize)(13,null,m):m===1?S?(0,I.localize)(14,null,m):(0,I.localize)(15,null,m):S?(0,I.localize)(16,null,m):(0,I.localize)(17,null,m)):c<P?(m=Math.floor(c/f),v?m===1?S?(0,I.localize)(18,null,m):(0,I.localize)(19,null,m):S?(0,I.localize)(20,null,m):(0,I.localize)(21,null,m):m===1?S?(0,I.localize)(22,null,m):(0,I.localize)(23,null,m):S?(0,I.localize)(24,null,m):(0,I.localize)(25,null,m)):c<A?(m=Math.floor(c/P),v?m===1?(0,I.localize)(26,null,m):(0,I.localize)(27,null,m):m===1?(0,I.localize)(28,null,m):(0,I.localize)(29,null,m)):c<E?(m=Math.floor(c/A),v?m===1?S?(0,I.localize)(30,null,m):(0,I.localize)(31,null,m):S?(0,I.localize)(32,null,m):(0,I.localize)(33,null,m):m===1?S?(0,I.localize)(34,null,m):(0,I.localize)(35,null,m):S?(0,I.localize)(36,null,m):(0,I.localize)(37,null,m)):c<p?(m=Math.floor(c/E),v?m===1?S?(0,I.localize)(38,null,m):(0,I.localize)(39,null,m):S?(0,I.localize)(40,null,m):(0,I.localize)(41,null,m):m===1?S?(0,I.localize)(42,null,m):(0,I.localize)(43,null,m):S?(0,I.localize)(44,null,m):(0,I.localize)(45,null,m)):(m=Math.floor(c/p),v?m===1?S?(0,I.localize)(46,null,m):(0,I.localize)(47,null,m):S?(0,I.localize)(48,null,m):(0,I.localize)(49,null,m):m===1?S?(0,I.localize)(50,null,m):(0,I.localize)(51,null,m):S?(0,I.localize)(52,null,m):(0,I.localize)(53,null,m))}e.fromNow=y;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[183],Ce([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ye[44],Ce([1,0,19,18,183]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(D,v){return v&&(D.stack||D.stacktrace)?f.localize(0,null,E(D),A(D.stack)||A(D.stacktrace)):E(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function E(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?f.localize(1,null,D.message):D.message||f.localize(2,null)}function p(D=null,v=!1){if(!D)return f.localize(3,null);if(Array.isArray(D)){const S=I.coalesce(D),C=p(S[0],v);return S.length>1?f.localize(4,null,C,S.length):C}if(F.isString(D))return D;if(D.detail){const S=D.detail;if(S.error)return P(S.error,v);if(S.exception)return P(S.exception,v)}return D.stack?P(D,v):D.message?D.message:f.localize(5,null)}e.toErrorMessage=p;function y(D){const v=D;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=y;function R(D,v){let S;return typeof D=="string"?S=new Error(D):S=D,S.actions=v,S}e.createErrorWithActions=R}),define(ye[184],Ce([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ye[10],Ce([1,0,184]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let F=!1,f=!1,P=!1,A=!1,E=!1,p=!1,y=!1,R=!1,D=!1,v=!1,S,C=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT,m,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",a=n&&r?.type==="renderer";if(typeof r=="object"){F=r.platform==="win32",f=r.platform==="darwin",P=r.platform==="linux",A=P&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,y=n,D=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const g=r.env.VSCODE_NLS_CONFIG;if(g)try{const _=JSON.parse(g),T=_.availableLanguages["*"];S=_.locale,c=_.osLocale,C=T||e.LANGUAGE_DEFAULT,m=_._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(o=navigator.userAgent,F=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,p=!0,S=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,C=S,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(t||(e.Platform=t={}));function d(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let s=0;f?s=1:F?s=3:P&&(s=2),e.isWindows=F,e.isMacintosh=f,e.isLinux=P,e.isLinuxSnap=A,e.isNative=E,e.isElectron=y,e.isWeb=p,e.isWebWorker=p&&typeof i.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?i.origin:void 0,e.isIOS=R,e.isMobile=v,e.isCI=D,e.platform=s,e.userAgent=o,e.language=C;var h;(function(g){function _(){return e.language}g.value=_;function T(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}g.isDefaultVariant=T;function O(){return e.language==="en"}g.isDefault=O})(h||(e.Language=h={})),e.locale=S,e.platformLocale=c,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof i.postMessage=="function"&&!i.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const g=[];i.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let O=0,x=g.length;O<x;O++){const N=g[O];if(N.id===T.data.vscodeScheduleAsyncWork){g.splice(O,1),N.callback();return}}});let _=0;return T=>{const O=++_;g.push({id:O,callback:T}),i.postMessage({vscodeScheduleAsyncWork:O},"*")}}return g=>setTimeout(g)})();var l;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||R?2:F?1:3;let u=!0,w=!1;function k(){if(!w){w=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,u=new Uint16Array(g.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=k,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function b(g){return parseFloat(g)>=20}e.isBigSurOrNewer=b}),define(ye[49],Ce([1,0,10]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const P=f.process;F={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(ye[17],Ce([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,f=97,P=90,A=122,E=46,p=47,y=92,R=58,D=63;class v extends Error{constructor(d,s,h){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const u=d.indexOf(".")!==-1?"property":"argument";let w=`The "${d}" ${u} ${l} of type ${s}`;w+=`. Received type ${typeof h}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,d){if(t===null||typeof t!="object")throw new v(d,"Object",t)}function C(t,d){if(typeof t!="string")throw new v(d,"string",t)}const c=I.platform==="win32";function m(t){return t===p||t===y}function o(t){return t===p}function i(t){return t>=F&&t<=P||t>=f&&t<=A}function r(t,d,s,h){let l="",u=0,w=-1,k=0,b=0;for(let g=0;g<=t.length;++g){if(g<t.length)b=t.charCodeAt(g);else{if(h(b))break;b=p}if(h(b)){if(!(w===g-1||k===1))if(k===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const _=l.lastIndexOf(s);_===-1?(l="",u=0):(l=l.slice(0,_),u=l.length-1-l.lastIndexOf(s)),w=g,k=0;continue}else if(l.length!==0){l="",u=0,w=g,k=0;continue}}d&&(l+=l.length>0?`${s}..`:"..",u=2)}else l.length>0?l+=`${s}${t.slice(w+1,g)}`:l=t.slice(w+1,g),u=g-w-1;w=g,k=0}else b===E&&k!==-1?++k:k=-1}return l}function n(t,d){S(d,"pathObject");const s=d.dir||d.root,h=d.base||`${d.name||""}${d.ext||""}`;return s?s===d.root?`${s}${h}`:`${s}${t}${h}`:h}e.win32={resolve(...t){let d="",s="",h=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],C(u,"path"),u.length===0)continue}else d.length===0?u=I.cwd():(u=I.env[`=${d}`]||I.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==d.toLowerCase()&&u.charCodeAt(2)===y)&&(u=`${d}\\`));const w=u.length;let k=0,b="",g=!1;const _=u.charCodeAt(0);if(w===1)m(_)&&(k=1,g=!0);else if(m(_))if(g=!0,m(u.charCodeAt(1))){let T=2,O=T;for(;T<w&&!m(u.charCodeAt(T));)T++;if(T<w&&T!==O){const x=u.slice(O,T);for(O=T;T<w&&m(u.charCodeAt(T));)T++;if(T<w&&T!==O){for(O=T;T<w&&!m(u.charCodeAt(T));)T++;(T===w||T!==O)&&(b=`\\\\${x}\\${u.slice(O,T)}`,k=T)}}}else k=1;else i(_)&&u.charCodeAt(1)===R&&(b=u.slice(0,2),k=2,w>2&&m(u.charCodeAt(2))&&(g=!0,k=3));if(b.length>0)if(d.length>0){if(b.toLowerCase()!==d.toLowerCase())continue}else d=b;if(h){if(d.length>0)break}else if(s=`${u.slice(k)}\\${s}`,h=g,g&&d.length>0)break}return s=r(s,!h,"\\",m),h?`${d}\\${s}`:`${d}${s}`||"."},normalize(t){C(t,"path");const d=t.length;if(d===0)return".";let s=0,h,l=!1;const u=t.charCodeAt(0);if(d===1)return o(u)?"\\":t;if(m(u))if(l=!0,m(t.charCodeAt(1))){let k=2,b=k;for(;k<d&&!m(t.charCodeAt(k));)k++;if(k<d&&k!==b){const g=t.slice(b,k);for(b=k;k<d&&m(t.charCodeAt(k));)k++;if(k<d&&k!==b){for(b=k;k<d&&!m(t.charCodeAt(k));)k++;if(k===d)return`\\\\${g}\\${t.slice(b)}\\`;k!==b&&(h=`\\\\${g}\\${t.slice(b,k)}`,s=k)}}}else s=1;else i(u)&&t.charCodeAt(1)===R&&(h=t.slice(0,2),s=2,d>2&&m(t.charCodeAt(2))&&(l=!0,s=3));let w=s<d?r(t.slice(s),!l,"\\",m):"";return w.length===0&&!l&&(w="."),w.length>0&&m(t.charCodeAt(d-1))&&(w+="\\"),h===void 0?l?`\\${w}`:w:l?`${h}\\${w}`:`${h}${w}`},isAbsolute(t){C(t,"path");const d=t.length;if(d===0)return!1;const s=t.charCodeAt(0);return m(s)||d>2&&i(s)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,s;for(let u=0;u<t.length;++u){const w=t[u];C(w,"path"),w.length>0&&(d===void 0?d=s=w:d+=`\\${w}`)}if(d===void 0)return".";let h=!0,l=0;if(typeof s=="string"&&m(s.charCodeAt(0))){++l;const u=s.length;u>1&&m(s.charCodeAt(1))&&(++l,u>2&&(m(s.charCodeAt(2))?++l:h=!1))}if(h){for(;l<d.length&&m(d.charCodeAt(l));)l++;l>=2&&(d=`\\${d.slice(l)}`)}return e.win32.normalize(d)},relative(t,d){if(C(t,"from"),C(d,"to"),t===d)return"";const s=e.win32.resolve(t),h=e.win32.resolve(d);if(s===h||(t=s.toLowerCase(),d=h.toLowerCase(),t===d))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===y;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===y;)u--;const w=u-l;let k=0;for(;k<d.length&&d.charCodeAt(k)===y;)k++;let b=d.length;for(;b-1>k&&d.charCodeAt(b-1)===y;)b--;const g=b-k,_=w<g?w:g;let T=-1,O=0;for(;O<_;O++){const N=t.charCodeAt(l+O);if(N!==d.charCodeAt(k+O))break;N===y&&(T=O)}if(O!==_){if(T===-1)return h}else{if(g>_){if(d.charCodeAt(k+O)===y)return h.slice(k+O+1);if(O===2)return h.slice(k+O)}w>_&&(t.charCodeAt(l+O)===y?T=O:O===2&&(T=3)),T===-1&&(T=0)}let x="";for(O=l+T+1;O<=u;++O)(O===u||t.charCodeAt(O)===y)&&(x+=x.length===0?"..":"\\..");return k+=T,x.length>0?`${x}${h.slice(k,b)}`:(h.charCodeAt(k)===y&&++k,h.slice(k,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.win32.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===y){if(d.charCodeAt(1)===y){const s=d.charCodeAt(2);if(s!==D&&s!==E)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(i(d.charCodeAt(0))&&d.charCodeAt(1)===R&&d.charCodeAt(2)===y)return`\\\\?\\${d}`;return t},dirname(t){C(t,"path");const d=t.length;if(d===0)return".";let s=-1,h=0;const l=t.charCodeAt(0);if(d===1)return m(l)?t:".";if(m(l)){if(s=h=1,m(t.charCodeAt(1))){let k=2,b=k;for(;k<d&&!m(t.charCodeAt(k));)k++;if(k<d&&k!==b){for(b=k;k<d&&m(t.charCodeAt(k));)k++;if(k<d&&k!==b){for(b=k;k<d&&!m(t.charCodeAt(k));)k++;if(k===d)return t;k!==b&&(s=h=k+1)}}}}else i(l)&&t.charCodeAt(1)===R&&(s=d>2&&m(t.charCodeAt(2))?3:2,h=s);let u=-1,w=!0;for(let k=d-1;k>=h;--k)if(m(t.charCodeAt(k))){if(!w){u=k;break}}else w=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,d){d!==void 0&&C(d,"ext"),C(t,"path");let s=0,h=-1,l=!0,u;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let w=d.length-1,k=-1;for(u=t.length-1;u>=s;--u){const b=t.charCodeAt(u);if(m(b)){if(!l){s=u+1;break}}else k===-1&&(l=!1,k=u+1),w>=0&&(b===d.charCodeAt(w)?--w===-1&&(h=u):(w=-1,h=k))}return s===h?h=k:h===-1&&(h=t.length),t.slice(s,h)}for(u=t.length-1;u>=s;--u)if(m(t.charCodeAt(u))){if(!l){s=u+1;break}}else h===-1&&(l=!1,h=u+1);return h===-1?"":t.slice(s,h)},extname(t){C(t,"path");let d=0,s=-1,h=0,l=-1,u=!0,w=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(d=h=2);for(let k=t.length-1;k>=d;--k){const b=t.charCodeAt(k);if(m(b)){if(!u){h=k+1;break}continue}l===-1&&(u=!1,l=k+1),b===E?s===-1?s=k:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||l===-1||w===0||w===1&&s===l-1&&s===h+1?"":t.slice(s,l)},format:n.bind(null,"\\"),parse(t){C(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const s=t.length;let h=0,l=t.charCodeAt(0);if(s===1)return m(l)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(m(l)){if(h=1,m(t.charCodeAt(1))){let T=2,O=T;for(;T<s&&!m(t.charCodeAt(T));)T++;if(T<s&&T!==O){for(O=T;T<s&&m(t.charCodeAt(T));)T++;if(T<s&&T!==O){for(O=T;T<s&&!m(t.charCodeAt(T));)T++;T===s?h=T:T!==O&&(h=T+1)}}}}else if(i(l)&&t.charCodeAt(1)===R){if(s<=2)return d.root=d.dir=t,d;if(h=2,m(t.charCodeAt(2))){if(s===3)return d.root=d.dir=t,d;h=3}}h>0&&(d.root=t.slice(0,h));let u=-1,w=h,k=-1,b=!0,g=t.length-1,_=0;for(;g>=h;--g){if(l=t.charCodeAt(g),m(l)){if(!b){w=g+1;break}continue}k===-1&&(b=!1,k=g+1),l===E?u===-1?u=g:_!==1&&(_=1):u!==-1&&(_=-1)}return k!==-1&&(u===-1||_===0||_===1&&u===k-1&&u===w+1?d.base=d.name=t.slice(w,k):(d.name=t.slice(w,u),d.base=t.slice(w,k),d.ext=t.slice(u,k))),w>0&&w!==h?d.dir=t.slice(0,w-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(c){const t=/\\/g;return()=>{const d=I.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let d="",s=!1;for(let h=t.length-1;h>=-1&&!s;h--){const l=h>=0?t[h]:a();C(l,"path"),l.length!==0&&(d=`${l}/${d}`,s=l.charCodeAt(0)===p)}return d=r(d,!s,"/",o),s?`/${d}`:d.length>0?d:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===p,s=t.charCodeAt(t.length-1)===p;return t=r(t,!d,"/",o),t.length===0?d?"/":s?"./":".":(s&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let d;for(let s=0;s<t.length;++s){const h=t[s];C(h,"path"),h.length>0&&(d===void 0?d=h:d+=`/${h}`)}return d===void 0?".":e.posix.normalize(d)},relative(t,d){if(C(t,"from"),C(d,"to"),t===d||(t=e.posix.resolve(t),d=e.posix.resolve(d),t===d))return"";const s=1,h=t.length,l=h-s,u=1,w=d.length-u,k=l<w?l:w;let b=-1,g=0;for(;g<k;g++){const T=t.charCodeAt(s+g);if(T!==d.charCodeAt(u+g))break;T===p&&(b=g)}if(g===k)if(w>k){if(d.charCodeAt(u+g)===p)return d.slice(u+g+1);if(g===0)return d.slice(u+g)}else l>k&&(t.charCodeAt(s+g)===p?b=g:g===0&&(b=0));let _="";for(g=s+b+1;g<=h;++g)(g===h||t.charCodeAt(g)===p)&&(_+=_.length===0?"..":"/..");return`${_}${d.slice(u+b)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===p;let s=-1,h=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===p){if(!h){s=l;break}}else h=!1;return s===-1?d?"/":".":d&&s===1?"//":t.slice(0,s)},basename(t,d){d!==void 0&&C(d,"ext"),C(t,"path");let s=0,h=-1,l=!0,u;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let w=d.length-1,k=-1;for(u=t.length-1;u>=0;--u){const b=t.charCodeAt(u);if(b===p){if(!l){s=u+1;break}}else k===-1&&(l=!1,k=u+1),w>=0&&(b===d.charCodeAt(w)?--w===-1&&(h=u):(w=-1,h=k))}return s===h?h=k:h===-1&&(h=t.length),t.slice(s,h)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===p){if(!l){s=u+1;break}}else h===-1&&(l=!1,h=u+1);return h===-1?"":t.slice(s,h)},extname(t){C(t,"path");let d=-1,s=0,h=-1,l=!0,u=0;for(let w=t.length-1;w>=0;--w){const k=t.charCodeAt(w);if(k===p){if(!l){s=w+1;break}continue}h===-1&&(l=!1,h=w+1),k===E?d===-1?d=w:u!==1&&(u=1):d!==-1&&(u=-1)}return d===-1||h===-1||u===0||u===1&&d===h-1&&d===s+1?"":t.slice(d,h)},format:n.bind(null,"/"),parse(t){C(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const s=t.charCodeAt(0)===p;let h;s?(d.root="/",h=1):h=0;let l=-1,u=0,w=-1,k=!0,b=t.length-1,g=0;for(;b>=h;--b){const _=t.charCodeAt(b);if(_===p){if(!k){u=b+1;break}continue}w===-1&&(k=!1,w=b+1),_===E?l===-1?l=b:g!==1&&(g=1):l!==-1&&(g=-1)}if(w!==-1){const _=u===0&&s?1:u;l===-1||g===0||g===1&&l===w-1&&l===u+1?d.base=d.name=t.slice(_,w):(d.name=t.slice(_,l),d.base=t.slice(_,w),d.ext=t.slice(l,w))}return u>0?d.dir=t.slice(0,u-1):s&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c?e.win32.normalize:e.posix.normalize,e.isAbsolute=c?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c?e.win32.join:e.posix.join,e.resolve=c?e.win32.resolve:e.posix.resolve,e.relative=c?e.win32.relative:e.posix.relative,e.dirname=c?e.win32.dirname:e.posix.dirname,e.basename=c?e.win32.basename:e.posix.basename,e.extname=c?e.win32.extname:e.posix.extname,e.format=c?e.win32.format:e.posix.format,e.parse=c?e.win32.parse:e.posix.parse,e.toNamespacedPath=c?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c?e.win32.sep:e.posix.sep,e.delimiter=c?e.win32.delimiter:e.posix.delimiter}),define(ye[128],Ce([1,0,43,17]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const f=new I.Lazy(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),P=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(k,b,g=!1){const _=k||"",T=b||"",O=f.value.collator.compare(_,T);return f.value.collatorIsNumeric&&O===0&&_!==T?_<T?-1:1:O}e.compareFileNames=E;function p(k,b){const g=P.value.collator;return k=k||"",b=b||"",n(g,k,b)}e.compareFileNamesDefault=p;function y(k,b){const g=P.value.collator;return k=k||"",b=b||"",s(k,b)||n(g,k,b)}e.compareFileNamesUpper=y;function R(k,b){const g=P.value.collator;return k=k||"",b=b||"",d(k,b)||n(g,k,b)}e.compareFileNamesLower=R;function D(k,b){return k=k||"",b=b||"",k===b?0:k<b?-1:1}e.compareFileNamesUnicode=D;function v(k,b){const[g,_]=i(k),[T,O]=i(b);let x=f.value.collator.compare(_,O);if(x===0){if(f.value.collatorIsNumeric&&_!==O)return _<O?-1:1;if(x=f.value.collator.compare(g,T),f.value.collatorIsNumeric&&x===0&&g!==T)return g<T?-1:1}return x}e.compareFileExtensions=v;function S(k,b){k=k||"",b=b||"";const g=r(k),_=r(b),T=P.value.collator,O=A.value.collator;return n(O,g,_)||n(T,k,b)}e.compareFileExtensionsDefault=S;function C(k,b){k=k||"",b=b||"";const g=r(k),_=r(b),T=P.value.collator,O=A.value.collator;return n(O,g,_)||s(k,b)||n(T,k,b)}e.compareFileExtensionsUpper=C;function c(k,b){k=k||"",b=b||"";const g=r(k),_=r(b),T=P.value.collator,O=A.value.collator;return n(O,g,_)||d(k,b)||n(T,k,b)}e.compareFileExtensionsLower=c;function m(k,b){k=k||"",b=b||"";const g=r(k).toLowerCase(),_=r(b).toLowerCase();return g!==_?g<_?-1:1:k!==b?k<b?-1:1:0}e.compareFileExtensionsUnicode=m;const o=/^(.*?)(\.([^.]*))?$/;function i(k,b=!1){const g=k?o.exec(k):[];let _=[g&&g[1]||"",g&&g[3]||""];return b&&(!_[0]&&_[1]||_[0]&&_[0].charAt(0)===".")&&(_=[_[0]+"."+_[1],""]),_}function r(k){const b=k?o.exec(k):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function n(k,b,g){const _=k.compare(b,g);return _!==0?_:b.length!==g.length?b.length<g.length?-1:1:0}function a(k){const b=k.charAt(0);return b.toLocaleUpperCase()!==b}function t(k){const b=k.charAt(0);return b.toLocaleLowerCase()!==b}function d(k,b){return a(k)&&t(b)?-1:t(k)&&a(b)?1:0}function s(k,b){return t(k)&&a(b)?-1:a(k)&&t(b)?1:0}function h(k,b,g=!1){return g||(k=k&&k.toLowerCase(),b=b&&b.toLowerCase()),k===b?0:k<b?-1:1}function l(k,b,g=!1){const _=k.split(F.sep),T=b.split(F.sep),O=_.length-1,x=T.length-1;let N,M;for(let L=0;;L++){if(N=O===L,M=x===L,N&&M)return E(_[L],T[L],g);if(N)return-1;if(M)return 1;const U=h(_[L],T[L],g);if(U!==0)return U}}e.comparePaths=l;function u(k,b,g){const _=k.toLowerCase(),T=b.toLowerCase(),O=w(k,b,g);if(O)return O;const x=_.endsWith(g),N=T.endsWith(g);if(x!==N)return x?-1:1;const M=E(_,T);return M!==0?M:_.localeCompare(T)}e.compareAnything=u;function w(k,b,g){const _=k.toLowerCase(),T=b.toLowerCase(),O=_.startsWith(g),x=T.startsWith(g);if(O!==x)return O?-1:1;if(O&&x){if(_.length<T.length)return-1;if(_.length>T.length)return 1}return 0}e.compareByPrefix=w}),define(ye[34],Ce([1,0,17,10,12,18]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(u){return u===47||u===92}e.isPathSeparator=A;function E(u){return u.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=E;function p(u){return u.indexOf("/")===-1&&(u=E(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=p;function y(u,w=I.posix.sep){if(!u)return"";const k=u.length,b=u.charCodeAt(0);if(A(b)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let _=3;const T=_;for(;_<k&&!A(u.charCodeAt(_));_++);if(T!==_&&!A(u.charCodeAt(_+1))){for(_+=1;_<k;_++)if(A(u.charCodeAt(_)))return u.slice(0,_+1).replace(/[\\/]/g,w)}}return w}else if(o(b)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+w:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<k;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.getRoot=y;function R(u){if(!F.isWindows||!u||u.length<5)return!1;let w=u.charCodeAt(0);if(w!==92||(w=u.charCodeAt(1),w!==92))return!1;let k=2;const b=k;for(;k<u.length&&(w=u.charCodeAt(k),w!==92);k++);return!(b===k||(w=u.charCodeAt(k+1),isNaN(w)||w===92))}e.isUNC=R;const D=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(u,w=F.isWindows){const k=w?D:v;return!(!u||u.length===0||/^\s+$/.test(u)||(k.lastIndex=0,k.test(u))||w&&S.test(u)||u==="."||u===".."||w&&u[u.length-1]==="."||w&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=C;function c(u,w,k){const b=u===w;return!k||b?b:!u||!w?!1:(0,f.equalsIgnoreCase)(u,w)}e.isEqual=c;function m(u,w,k,b=I.sep){if(u===w)return!0;if(!u||!w||w.length>u.length)return!1;if(k){if(!(0,f.startsWithIgnoreCase)(u,w))return!1;if(w.length===u.length)return!0;let _=w.length;return w.charAt(w.length-1)===b&&_--,u.charAt(_)===b}return w.charAt(w.length-1)!==b&&(w+=b),u.indexOf(w)===0}e.isEqualOrParent=m;function o(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=o;function i(u,w){return F.isWindows&&u.endsWith(":")&&(u+=I.sep),(0,I.isAbsolute)(u)||(u=(0,I.join)(w,u)),u=(0,I.normalize)(u),F.isWindows?(u=(0,f.rtrim)(u,I.sep),u.endsWith(":")&&(u+=I.sep)):(u=(0,f.rtrim)(u,I.sep),u||(u=I.sep)),u}e.sanitizeFilePath=i;function r(u){const w=(0,I.normalize)(u);return F.isWindows?u.length>3?!1:n(w)&&(u.length===2||w.charCodeAt(2)===92):w===I.posix.sep}e.isRootOrDriveLetter=r;function n(u,w=F.isWindows){return w?o(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=n;function a(u,w=F.isWindows){return n(u,w)?u[0]:void 0}e.getDriveLetter=a;function t(u,w,k){return w.length>u.length?-1:u===w?0:(k&&(u=u.toLowerCase(),w=w.toLowerCase()),u.indexOf(w))}e.indexOfPath=t;function d(u){const w=u.split(":");let k,b,g;for(const _ of w){const T=Number(_);(0,P.isNumber)(T)?b===void 0?b=T:g===void 0&&(g=T):k=k?[k,_].join(":"):_}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:b!==void 0?b:void 0,column:g!==void 0?g:b!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(u,w,k=8){let b="";for(let _=0;_<k;_++){let T;_===0&&F.isWindows&&!w&&(k===3||k===4)?T=h:T=s,b+=T.charAt(Math.floor(Math.random()*T.length))}let g;return w?g=`${w}-${b}`:g=b,u?(0,I.join)(u,g):g}e.randomPath=l}),define(ye[129],Ce([1,0,128,123,54,17,10,12]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const p=0,y=[p,[]];function R(B,G,le,Y){if(!B||!G)return y;const K=B.length,Q=G.length;if(K<Q)return y;const ue=B.toLowerCase();return D(G,le,Q,B,ue,K,Y)}e.scoreFuzzy=R;function D(B,G,le,Y,K,Q,ue){const ne=[],pe=[];for(let ie=0;ie<le;ie++){const Se=ie*Q,he=Se-Q,fe=ie>0,Z=B[ie],ee=G[ie];for(let j=0;j<Q;j++){const J=j>0,ge=Se+j,we=ge-1,Ae=he+j-1,Ee=J?ne[we]:0,ke=fe&&J?ne[Ae]:0,z=fe&&J?pe[Ae]:0;let X;!ke&&fe?X=0:X=v(Z,ee,Y,K,j,z),X&&ke+X>=Ee&&(ue||fe||K.startsWith(G,j))?(pe[ge]=z+1,ne[ge]=ke+X):(pe[ge]=p,ne[ge]=Ee)}}const oe=[];let q=le-1,W=Q-1;for(;q>=0&&W>=0;){const ie=q*Q+W;pe[ie]===p||(oe.push(W),q--),W--}return[ne[le*Q-1],oe.reverse()]}function v(B,G,le,Y,K,Q){let ue=0;if(!S(G,Y[K]))return ue;if(ue+=1,Q>0&&(ue+=Q*5),B===le[K]&&(ue+=1),K===0)ue+=8;else{const ne=C(le.charCodeAt(K-1));ne?ue+=ne:(0,F.isUpper)(le.charCodeAt(K))&&Q===0&&(ue+=2)}return ue}function S(B,G){return B===G?!0:B==="/"||B==="\\"?G==="/"||G==="\\":!1}function C(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(B,G,le=0,Y=0){const K=G;return K.values&&K.values.length>1?o(B,K.values,le,Y):i(B,G,le,Y)}e.scoreFuzzy2=m;function o(B,G,le,Y){let K=0;const Q=[];for(const ue of G){const[ne,pe]=i(B,ue,le,Y);if(typeof ne!="number")return c;K+=ne,Q.push(...pe)}return[K,k(Q)]}function i(B,G,le,Y){const K=(0,F.fuzzyScore)(G.original,G.originalLowercase,le,B,B.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,F.createMatches)(K)]:c}const r=Object.freeze({score:0}),n=1<<18,a=1<<17,t=1<<16;function d(B,G,le,Y){const K=Y.values?Y.values:[Y];return(0,f.hash)({[Y.normalized]:{values:K.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:B,description:G,allowNonContiguousMatches:le}})}function s(B,G,le,Y,K){if(!B||!G.normalized)return r;const Q=Y.getItemLabel(B);if(!Q)return r;const ue=Y.getItemDescription(B),ne=d(Q,ue,le,G),pe=K[ne];if(pe)return pe;const oe=h(Q,ue,Y.getItemPath(B),G,le);return K[ne]=oe,oe}e.scoreItemFuzzy=s;function h(B,G,le,Y,K){const Q=!le||!Y.containsPathSeparator;return le&&(A.isLinux?Y.pathNormalized===le:(0,E.equalsIgnoreCase)(Y.pathNormalized,le))?{score:n,labelMatch:[{start:0,end:B.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:Y.values&&Y.values.length>1?l(B,G,le,Y.values,Q,K):u(B,G,le,Y,Q,K)}function l(B,G,le,Y,K,Q){let ue=0;const ne=[],pe=[];for(const oe of Y){const{score:q,labelMatch:W,descriptionMatch:ie}=u(B,G,le,oe,K,Q);if(q===p)return r;ue+=q,W&&ne.push(...W),ie&&pe.push(...ie)}return{score:ue,labelMatch:k(ne),descriptionMatch:k(pe)}}function u(B,G,le,Y,K,Q){if(K||!G){const[ue,ne]=R(B,Y.normalized,Y.normalizedLowercase,Q&&!Y.expectContiguousMatch);if(ue){const pe=(0,F.matchesPrefix)(Y.normalized,B);let oe;if(pe){oe=a;const q=Math.round(Y.normalized.length/B.length*100);oe+=q}else oe=t;return{score:oe+ue,labelMatch:pe||w(ne)}}}if(G){let ue=G;le&&(ue=`${G}${P.sep}`);const ne=ue.length,pe=`${ue}${B}`,[oe,q]=R(pe,Y.normalized,Y.normalizedLowercase,Q&&!Y.expectContiguousMatch);if(oe){const W=w(q),ie=[],Se=[];return W.forEach(he=>{he.start<ne&&he.end>ne?(ie.push({start:0,end:he.end-ne}),Se.push({start:he.start,end:ne})):he.start>=ne?ie.push({start:he.start-ne,end:he.end-ne}):Se.push(he)}),{score:oe,labelMatch:ie,descriptionMatch:Se}}}return r}function w(B){const G=[];if(!B)return G;let le;for(const Y of B)le&&le.end===Y?le.end+=1:(le={start:Y,end:Y+1},G.push(le));return G}function k(B){const G=B.sort((K,Q)=>K.start-Q.start),le=[];let Y;for(const K of G)!Y||!b(Y,K)?(Y=K,le.push(K)):(Y.start=Math.min(Y.start,K.start),Y.end=Math.max(Y.end,K.end));return le}function b(B,G){return!(B.end<G.start||G.end<B.start)}function g(B,G,le,Y,K,Q){const ue=s(B,le,Y,K,Q),ne=s(G,le,Y,K,Q),pe=ue.score,oe=ne.score;if((pe===n||oe===n)&&pe!==oe)return pe===n?-1:1;if(pe>t||oe>t){if(pe!==oe)return pe>oe?-1:1;if(pe<a&&oe<a){const Z=T(ue.labelMatch,ne.labelMatch);if(Z!==0)return Z}const he=K.getItemLabel(B)||"",fe=K.getItemLabel(G)||"";if(he.length!==fe.length)return he.length-fe.length}if(pe!==oe)return pe>oe?-1:1;const q=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(q&&!W)return-1;if(W&&!q)return 1;const ie=_(B,ue,K),Se=_(G,ne,K);return ie&&Se&&ie!==Se?Se>ie?-1:1:O(B,G,le,K)}e.compareItemsByFuzzyScore=g;function _(B,G,le){let Y=-1,K=-1;if(G.descriptionMatch&&G.descriptionMatch.length?Y=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(Y=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(K=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const Q=le.getItemDescription(B);Q&&(K+=Q.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(K=G.descriptionMatch[G.descriptionMatch.length-1].end);return K-Y}function T(B,G){if(!B&&!G||(!B||!B.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!B||!B.length)return 1;const le=B[0].start,K=B[B.length-1].end-le,Q=G[0].start,ne=G[G.length-1].end-Q;return K===ne?0:ne<K?1:-1}function O(B,G,le,Y){const K=Y.getItemLabel(B)||"",Q=Y.getItemLabel(G)||"",ue=Y.getItemDescription(B),ne=Y.getItemDescription(G),pe=K.length+(ue?ue.length:0),oe=Q.length+(ne?ne.length:0);if(pe!==oe)return pe-oe;const q=Y.getItemPath(B),W=Y.getItemPath(G);return q&&W&&q.length!==W.length?q.length-W.length:K!==Q?(0,I.compareAnything)(K,Q,le.normalized):ue&&ne&&ue!==ne?(0,I.compareAnything)(ue,ne,le.normalized):q&&W&&q!==W?(0,I.compareAnything)(q,W,le.normalized):0}function x(B){return B.startsWith('"')&&B.endsWith('"')}const N=" ";function M(B){typeof B!="string"&&(B="");const G=B.toLowerCase(),{pathNormalized:le,normalized:Y,normalizedLowercase:K}=L(B),Q=le.indexOf(P.sep)>=0,ue=x(B);let ne;const pe=B.split(N);if(pe.length>1)for(const oe of pe){const q=x(oe),{pathNormalized:W,normalized:ie,normalizedLowercase:Se}=L(oe);ie&&(ne||(ne=[]),ne.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:W,normalized:ie,normalizedLowercase:Se,expectContiguousMatch:q}))}return{original:B,originalLowercase:G,pathNormalized:le,normalized:Y,normalizedLowercase:K,values:ne,containsPathSeparator:Q,expectContiguousMatch:ue}}e.prepareQuery=M;function L(B){let G;A.isWindows?G=B.replace(/\//g,P.sep):G=B.replace(/\\/g,P.sep);const le=(0,E.stripWildcards)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:le,normalizedLowercase:le.toLowerCase()}}function U(B){return Array.isArray(B)?M(B.map(G=>G.original).join(N)):M(B.original)}e.pieceToQuery=U}),define(ye[101],Ce([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const D=(0,I.extname)(R),v=F[D.toLowerCase()];return v!==void 0?v:A(R)}e.getMediaOrTextMime=P;function A(R){const D=(0,I.extname)(R);return f[D.toLowerCase()]}e.getMediaMime=A;function E(R){for(const D in f)if(f[D]===R)return D}e.getExtensionForMimeType=E;const p=/^(.+)\/(.+?)(;.+)?$/;function y(R,D){const v=p.exec(R);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:D?void 0:R}e.normalizeMimeType=y}),define(ye[102],Ce([1,0,10]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var F;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function P(E,...p){const y=p.reduce((v,S)=>(v[S]=!0,v),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(v=>!y[v]).forEach(v=>{for(let S=0;S<R.length;S++)if(v.search(R[S])!==-1){delete E[v];break}})}e.sanitizeProcessEnvironment=P;function A(E){E&&(delete E.DEBUG,I.isMacintosh&&delete E.DYLD_LIBRARY_PATH,I.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ye[2],Ce([1,0,17,10]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function E(h,l){if(!h.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!f.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!P.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(h,l){return!h&&!l?"file":h}function y(h,l){switch(h){case"https":case"http":case"file":l?l[0]!==D&&(l=D+l):l=D;break}return l}const R="",D="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(l){return l instanceof S?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,u,w,k,b,g=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=p(l,g),this.authority=u||R,this.path=y(this.scheme,w||R),this.query=k||R,this.fragment=b||R,E(this,g))}get fsPath(){return n(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:w,path:k,query:b,fragment:g}=l;return u===void 0?u=this.scheme:u===null&&(u=R),w===void 0?w=this.authority:w===null&&(w=R),k===void 0?k=this.path:k===null&&(k=R),b===void 0?b=this.query:b===null&&(b=R),g===void 0?g=this.fragment:g===null&&(g=R),u===this.scheme&&w===this.authority&&k===this.path&&b===this.query&&g===this.fragment?this:new m(u,w,k,b,g)}static parse(l,u=!1){const w=v.exec(l);return w?new m(w[2]||R,s(w[4]||R),s(w[5]||R),s(w[7]||R),s(w[9]||R),u):new m(R,R,R,R,R)}static file(l){let u=R;if(F.isWindows&&(l=l.replace(/\\/g,D)),l[0]===D&&l[1]===D){const w=l.indexOf(D,2);w===-1?(u=l.substring(2),l=D):(u=l.substring(2,w),l=l.substring(w)||D)}return new m("file",u,l,R,R)}static from(l,u){return new m(l.scheme,l.authority,l.path,l.query,l.fragment,u)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return F.isWindows&&l.scheme==="file"?w=S.file(I.win32.join(n(l,!0),...u)).path:w=I.posix.join(l.path,...u),l.with({path:w})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof S)return l;{const u=new m(l);return u._formatted=l.external??null,u._fsPath=l._sep===c?l.fsPath??null:null,u}}else return l}}e.URI=S;function C(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}e.isUriComponents=C;const c=F.isWindows?1:void 0;class m extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(h,l,u){let w,k=-1;for(let b=0;b<h.length;b++){const g=h.charCodeAt(b);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||l&&g===47||u&&g===91||u&&g===93||u&&g===58)k!==-1&&(w+=encodeURIComponent(h.substring(k,b)),k=-1),w!==void 0&&(w+=h.charAt(b));else{w===void 0&&(w=h.substr(0,b));const _=o[g];_!==void 0?(k!==-1&&(w+=encodeURIComponent(h.substring(k,b)),k=-1),w+=_):k===-1&&(k=b)}}return k!==-1&&(w+=encodeURIComponent(h.substring(k))),w!==void 0?w:h}function r(h){let l;for(let u=0;u<h.length;u++){const w=h.charCodeAt(u);w===35||w===63?(l===void 0&&(l=h.substr(0,u)),l+=o[w]):l!==void 0&&(l+=h[u])}return l!==void 0?l:h}function n(h,l){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?l?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,F.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=n;function a(h,l){const u=l?r:i;let w="",{scheme:k,authority:b,path:g,query:_,fragment:T}=h;if(k&&(w+=k,w+=":"),(b||k==="file")&&(w+=D,w+=D),b){let O=b.indexOf("@");if(O!==-1){const x=b.substr(0,O);b=b.substr(O+1),O=x.lastIndexOf(":"),O===-1?w+=u(x,!1,!1):(w+=u(x.substr(0,O),!1,!1),w+=":",w+=u(x.substr(O+1),!1,!0)),w+="@"}b=b.toLowerCase(),O=b.lastIndexOf(":"),O===-1?w+=u(b,!1,!0):(w+=u(b.substr(0,O),!1,!0),w+=b.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}w+=u(g,!0,!1)}return _&&(w+="?",w+=u(_,!1,!1)),T&&(w+="#",w+=l?T:i(T,!1,!1)),w}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(h){return h.match(d)?h.replace(d,l=>t(l)):h}}),define(ye[185],Ce([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function F(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=F;function f(y){const R=[];let D;try{const v=JSON.parse(y.arguments),S=v[v.length-1];S&&S.__$stack&&(v.pop(),D=S.__$stack),R.push(...v)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:D}}e.parse=f;function P(y){if(typeof y!="string")return P(f(y).stack);const R=y;if(R){const D=A(R),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(v&&v.length===4)return{uri:I.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=P;function A(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function E(y,R){const{args:D,stack:v}=f(y),S=typeof D[0]=="string"&&D.length===1;let C=A(v);C&&(C=`(${C.trim()})`);let c=[];if(typeof D[0]=="string"?C&&S?c=[`%c[${R}] %c${D[0]} %c${C}`,p("blue"),p(""),p("grey")]:c=[`%c[${R}] %c${D[0]}`,p("blue"),p(""),...D.slice(1)]:c=[`%c[${R}]%`,p("blue"),...D],C&&!S&&c.push(C),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,c)}e.log=E;function p(y){return`color: ${y}`}}),define(ye[56],Ce([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function f(p){return JSON.stringify(p,A)}e.stringify=f;function P(p){let y=JSON.parse(p);return y=E(y),y}e.parse=P;function A(p,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function E(p,y=0){if(!p||y>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return F.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof I.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let R=0;R<p.length;++R)p[R]=E(p[R],y+1);else for(const R in p)Object.hasOwnProperty.call(p,R)&&(p[R]=E(p[R],y+1))}return p}e.revive=E}),define(ye[16],Ce([1,0,14,10,12,2]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function E(v,S){return P.URI.isUri(v)?(0,f.equalsIgnoreCase)(v.scheme,S):(0,f.startsWithIgnoreCase)(v,S+":")}e.matchesScheme=E;function p(v,...S){return S.some(C=>E(v,C))}e.matchesSomeScheme=p,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}setServerRootPath(S){this._remoteResourcesPath=`${S}/${A.vscodeRemoteResource}`}set(S,C,c){this._hosts[S]=C,this._ports[S]=c}setConnectionToken(S,C){this._connectionTokens[S]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)try{return this._delegate(S)}catch(r){return I.onUnexpectedError(r),S}const C=S.authority;let c=this._hosts[C];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const m=this._ports[C],o=this._connectionTokens[C];let i=`path=${encodeURIComponent(S.path)}`;return typeof o=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(o)}`),P.URI.from({scheme:F.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${c}:${m}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new y,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class R{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(S){const C=this.toUri(S,me);return this.uriToBrowserUri(C)}uriToBrowserUri(S){return S.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===A.file&&(F.isNative||F.webWorkerOrigin===`${A.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?S.with({scheme:A.vscodeFileResource,authority:S.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(S){const C=this.toUri(S,me);return this.uriToFileUri(C)}uriToFileUri(S){return S.scheme===A.vscodeFileResource?S.with({scheme:A.file,authority:S.authority!==R.FALLBACK_AUTHORITY?S.authority:null,query:null,fragment:null}):S}toUri(S,C){return P.URI.isUri(S)?S:P.URI.parse(C.toUrl(S))}}e.FileAccess=new R;var D;(function(v){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(S.get("3"));const C="vscode-coi";function c(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:P.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(C);if(r)return S.get(r)}v.getHeadersFromQuery=c;function m(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(C,n):o[C]=n}v.addSearchParam=m})(D||(e.COI=D={}))}),define(ye[186],Ce([1,0,157,16,10,2]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class A{constructor(v,S,C){this.id=v,this.dependencies=S,this.callback=C}}class E{static{this.INSTANCE=new E}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,S,C)=>{typeof v!="string"&&(C=S,S=v,v=null),(typeof S!="object"||!Array.isArray(S))&&(C=S,S=null),this._defineCalls.push(new A(v,S,C))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!S)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(v){return new Promise((S,C)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",o),c.removeEventListener("error",i)},o=r=>{m(),S(this._defineCalls.pop())},i=r=>{m(),C(r)};c.addEventListener("load",o),c.addEventListener("error",i),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),c.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(c)})}_workerLoadScript(v){return new Promise((S,C)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),S(this._defineCalls.pop())}catch(c){C(c)}})}async _nodeJSLoadScript(v){try{const S=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(v).fsPath,o=S.readFileSync(m).toString(),i=c.wrap(o.replace(/^#!.*/,""));return new C.Script(i).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const p=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(D,v,S){if(I.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[D]&&(D=y[D]);const C=`${D}/${v}`;if(p.has(C))return p.get(C);let c;if(/^\w[\w\d+.-]*:\/\//.test(C))c=C;else{const r=`${S&&!f.isWeb?F.nodeModulesAsarPath:F.nodeModulesPath}/${C}`;c=F.FileAccess.asBrowserUri(r).toString(!0)}const m=E.INSTANCE.load(c);return p.set(C,m),m}else return await new Promise((C,c)=>{me([D],C,c)})}e.importAMDNodeModule=R}),define(ye[23],Ce([1,0,34,16,17,10,12,2]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(S){return(0,E.uriToFsPath)(S,!0)}e.originalFSPath=p;class y{constructor(C){this._ignorePathCasing=C}compare(C,c,m=!1){return C===c?0:(0,A.compare)(this.getComparisonKey(C,m),this.getComparisonKey(c,m))}isEqual(C,c,m=!1){return C===c?!0:!C||!c?!1:this.getComparisonKey(C,m)===this.getComparisonKey(c,m)}getComparisonKey(C,c=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,c,m=!1){if(C.scheme===c.scheme){if(C.scheme===F.Schemas.file)return I.isEqualOrParent(p(C),p(c),this._ignorePathCasing(C))&&C.query===c.query&&(m||C.fragment===c.fragment);if((0,e.isEqualAuthority)(C.authority,c.authority))return I.isEqualOrParent(C.path,c.path,this._ignorePathCasing(C),"/")&&C.query===c.query&&(m||C.fragment===c.fragment)}return!1}joinPath(C,...c){return E.URI.joinPath(C,...c)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return f.posix.basename(C.path)}extname(C){return f.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let c;return C.scheme===F.Schemas.file?c=E.URI.file(f.dirname(p(C))).path:(c=f.posix.dirname(C.path),C.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),c="/")),C.with({path:c})}normalizePath(C){if(!C.path.length)return C;let c;return C.scheme===F.Schemas.file?c=E.URI.file(f.normalize(p(C))).path:c=f.posix.normalize(C.path),C.with({path:c})}relativePath(C,c){if(C.scheme!==c.scheme||!(0,e.isEqualAuthority)(C.authority,c.authority))return;if(C.scheme===F.Schemas.file){const i=f.relative(p(C),p(c));return P.isWindows?I.toSlashes(i):i}let m=C.path||"/";const o=c.path||"/";if(this._ignorePathCasing(C)){let i=0;for(const r=Math.min(m.length,o.length);i<r&&!(m.charCodeAt(i)!==o.charCodeAt(i)&&m.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);m=o.substr(0,i)+m.substr(i)}return f.posix.relative(m,o)}resolvePath(C,c){if(C.scheme===F.Schemas.file){const m=E.URI.file(f.resolve(p(C),c));return C.with({authority:m.authority,path:m.path})}return c=I.toPosixPath(c),C.with({path:f.posix.resolve(C.path,c)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,c){return C===c||C!==void 0&&c!==void 0&&(0,A.equalsIgnoreCase)(C,c)}hasTrailingPathSeparator(C,c=f.sep){if(C.scheme===F.Schemas.file){const m=p(C);return m.length>I.getRoot(m).length&&m[m.length-1]===c}else{const m=C.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,c=f.sep){return(0,e.hasTrailingPathSeparator)(C,c)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,c=f.sep){let m=!1;if(C.scheme===F.Schemas.file){const o=p(C);m=o!==void 0&&o.length===I.getRoot(o).length&&o[o.length-1]===c}else{c="/";const o=C.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(C,c)?C.with({path:C.path+"/"}):C}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(S=>S.scheme===F.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new y(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(S,C){const c=[];for(let m=0;m<S.length;m++){const o=C(S[m]);S.some((i,r)=>r===m?!1:(0,e.isEqualOrParent)(o,C(i)))||c.push(S[m])}return c}e.distinctParents=R;var D;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function C(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,a]=r.split(":");n&&a&&m.set(n,a)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&m.set(S.META_DATA_MIME,i),m}S.parseMetaData=C})(D||(e.DataUri=D={}));function v(S,C,c){if(C){let m=S.path;return m&&m[0]!==f.posix.sep&&(m=f.posix.sep+m),S.with({scheme:c,authority:C,path:m})}return S.with({scheme:c})}e.toLocalResource=v}),define(ye[11],Ce([1,0,21,14,4,3,23,10,163,43]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=R;function D(Z){const ee=new I.CancellationTokenSource,j=Z(ee.token),J=new Promise((ge,we)=>{const Ae=ee.token.onCancellationRequested(()=>{Ae.dispose(),we(new F.CancellationError)});Promise.resolve(j).then(Ee=>{Ae.dispose(),ee.dispose(),ge(Ee)},Ee=>{Ae.dispose(),ee.dispose(),we(Ee)})});return new class{cancel(){ee.cancel(),ee.dispose()}then(ge,we){return J.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return J.finally(ge)}}}e.createCancelablePromise=D;function v(Z,ee,j){return new Promise((J,ge)=>{const we=ee.onCancellationRequested(()=>{we.dispose(),J(j)});Z.then(J,ge).finally(()=>we.dispose())})}e.raceCancellation=v;function S(Z,ee){return new Promise((j,J)=>{const ge=ee.onCancellationRequested(()=>{ge.dispose(),J(new F.CancellationError)});Z.then(j,J).finally(()=>ge.dispose())})}e.raceCancellationError=S;async function C(Z){let ee=-1;const j=Z.map((J,ge)=>J.then(we=>(ee=ge,we)));try{return await Promise.race(j)}finally{Z.forEach((J,ge)=>{ge!==ee&&J.cancel()})}}e.raceCancellablePromises=C;function c(Z,ee,j){let J;const ge=setTimeout(()=>{J?.(void 0),j?.()},ee);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(we=>J=we)])}e.raceTimeout=c;function m(Z){return new Promise((ee,j)=>{const J=Z();R(J)?J.then(ee,j):ee(J)})}e.asPromise=m;class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const j=()=>{if(this.queuedPromise=null,this.isDisposed)return;const J=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,J};this.queuedPromise=new Promise(J=>{this.activePromise.then(j,j).then(J)})}return new Promise((j,J)=>{this.queuedPromise.then(j,J)})}return this.activePromise=ee(),new Promise((j,J)=>{this.activePromise.then(ge=>{this.activePromise=null,j(ge)},ge=>{this.activePromise=null,J(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class i{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=i;class r{constructor(){this.promiseMap=new Map}queue(ee,j){const ge=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(ee)===ge&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,ge),ge}}e.SequencerByKey=r;const n=(Z,ee)=>{let j=!0;const J=setTimeout(()=>{j=!1,ee()},Z);return{isTriggered:()=>j,dispose:()=>{clearTimeout(J),j=!1}}},a=Z=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Z())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class t{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,j=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,we)=>{this.doResolve=ge,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const J=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===p.MicrotaskDelay?a(J):n(j,J),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class d{constructor(ee){this.delayer=new t(ee),this.throttler=new o}trigger(ee,j){return this.delayer.trigger(()=>this.throttler.queue(ee),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=d;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ee,j)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class h extends s{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function l(Z,ee){return ee?new Promise((j,J)=>{const ge=setTimeout(()=>{we.dispose(),j()},Z),we=ee.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),J(new F.CancellationError)})}):D(j=>l(Z,j))}e.timeout=l;function u(Z,ee=0,j){const J=setTimeout(()=>{Z(),j&&ge.dispose()},ee),ge=(0,P.toDisposable)(()=>{clearTimeout(J),j?.deleteAndLeak(ge)});return j?.add(ge),ge}e.disposableTimeout=u;function w(Z){const ee=[];let j=0;const J=Z.length;function ge(){return j<J?Z[j++]():null}function we(Ae){Ae!=null&&ee.push(Ae);const Ee=ge();return Ee?Ee.then(we):Promise.resolve(ee)}return Promise.resolve(null).then(we)}e.sequence=w;function k(Z,ee=J=>!!J,j=null){let J=0;const ge=Z.length,we=()=>{if(J>=ge)return Promise.resolve(j);const Ae=Z[J++];return Promise.resolve(Ae()).then(ke=>ee(ke)?Promise.resolve(ke):we())};return we()}e.first=k;function b(Z,ee=J=>!!J,j=null){if(Z.length===0)return Promise.resolve(j);let J=Z.length;const ge=()=>{J=-1;for(const we of Z)we.cancel?.()};return new Promise((we,Ae)=>{for(const Ee of Z)Ee.then(ke=>{--J>=0&&ee(ke)?(ge(),we(ke)):J===0&&we(j)}).catch(ke=>{--J>=0&&(ge(),Ae(ke))})})}e.firstParallel=b;class g{constructor(ee){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new f.Emitter}whenIdle(){return this.size>0?f.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((j,J)=>{this.outstandingPromises.push({factory:ee,c:j,e:J}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const j=ee.factory();j.then(ee.c,ee.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=g;class _ extends g{constructor(){super(1)}}e.Queue=_;class T{constructor(){this.sequentializer=new K,this.tasks=0}queue(ee){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,ee())):this.sequentializer.run(this.tasks++,ee())}}e.LimitedQueue=T;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const ee=new ne;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueSize(ee,j=A.extUri){const J=j.getComparisonKey(ee);return this.queues.get(J)?.size??0}queueFor(ee,j,J=A.extUri){const ge=J.getComparisonKey(ee);let we=this.queues.get(ge);if(!we){we=new _;const Ae=this.drainListenerCount++,Ee=f.Event.once(we.onDrained)(()=>{we?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ae),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new P.DisposableMap),this.drainListeners.set(Ae,Ee),this.queues.set(ge,we)}return we.queue(j)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class x{constructor(ee,j){this._token=-1,typeof ee=="function"&&typeof j=="number"&&this.setIfNotSet(ee,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},j)}setIfNotSet(ee,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},j))}}e.TimeoutTimer=x;class N{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(ee,j,J=globalThis){this.cancel();const ge=J.setInterval(()=>{ee()},j);this.disposable=(0,P.toDisposable)(()=>{J.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=N;class M{constructor(ee,j){this.timeoutToken=-1,this.runner=ee,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class L{constructor(ee,j){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=L;class U extends M{constructor(ee,j){super(ee,j),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class B extends P.Disposable{constructor(ee,j){super(),this.options=ee,this.handler=j,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const j of ee)this.pendingWork.push(j);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Z,ee)=>{(0,E.setTimeout0)(()=>{if(j)return;const J=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e._runWhenIdle=(Z,ee,j)=>{const J=Z.requestIdleCallback(ee,typeof j=="number"?{timeout:j}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,Z.cancelIdleCallback(J))}}},e.runWhenGlobalIdle=Z=>(0,e._runWhenIdle)(globalThis,Z)}();class G{constructor(ee,j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(J){this._error=J}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(ee,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=G;class le extends G{constructor(ee){super(globalThis,ee)}}e.GlobalIdleValue=le;async function Y(Z,ee,j){let J;for(let ge=0;ge<j;ge++)try{return await Z()}catch(we){J=we,await l(ee)}throw J}e.retry=Y;class K{isRunning(ee){return typeof ee=="number"?this._running?.taskId===ee:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(ee,j,J){return this._running={taskId:ee,cancel:()=>J?.(),promise:j},j.then(()=>this.doneRunning(ee),()=>this.doneRunning(ee)),j}doneRunning(ee){this._running&&ee===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const ee=this._queued;this._queued=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this._queued)this._queued.run=ee;else{let j,J;const ge=new Promise((we,Ae)=>{j=we,J=Ae});this._queued={run:ee,promise:ge,promiseResolve:j,promiseReject:J}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=K;class Q{constructor(ee,j=()=>Date.now()){this.interval=ee,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;var ue;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((ee,j)=>{this.completeCallback=ee,this.errorCallback=j})}complete(ee){return new Promise(j=>{this.completeCallback(ee),this.outcome={outcome:0,value:ee},j()})}error(ee){return new Promise(j=>{this.errorCallback(ee),this.outcome={outcome:1,value:ee},j()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=ne;var pe;(function(Z){async function ee(J){let ge;const we=await Promise.all(J.map(Ae=>Ae.then(Ee=>Ee,Ee=>{ge||(ge=Ee)})));if(typeof ge<"u")throw ge;return we}Z.settled=ee;function j(J){return new Promise(async(ge,we)=>{try{await J(ge,we)}catch(Ae){we(Ae)}})}Z.withAsyncBody=j})(pe||(e.Promises=pe={}));class oe{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(ee){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=ee.then(j=>(this._value=j,this._isResolved=!0,j),j=>{throw this._error=j,this._isResolved=!0,j})}requireValue(){if(!this._isResolved)throw new F.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=oe;class q{constructor(ee){this._compute=ee,this._promise=new y.Lazy(()=>new oe(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=q;var W;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(W||(W={}));class ie{static fromArray(ee){return new ie(j=>{j.emitMany(ee)})}static fromPromise(ee){return new ie(async j=>{j.emitMany(await ee)})}static fromPromises(ee){return new ie(async j=>{await Promise.all(ee.map(async J=>j.emitOne(await J)))})}static merge(ee){return new ie(async j=>{await Promise.all(ee.map(async J=>{for await(const ge of J)j.emitOne(ge)}))})}static{this.EMPTY=ie.fromArray([])}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new f.Emitter,queueMicrotask(async()=>{const j={emitOne:J=>this.emitOne(J),emitMany:J=>this.emitMany(J),reject:J=>this.reject(J)};try{await Promise.resolve(ee(j)),this.resolve()}catch(J){this.reject(J)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await f.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,j){return new ie(async J=>{for await(const ge of ee)J.emitOne(j(ge))})}map(ee){return ie.map(this,ee)}static filter(ee,j){return new ie(async J=>{for await(const ge of ee)j(ge)&&J.emitOne(ge)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,j=>!!j)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const j=[];for await(const J of ee)j.push(J);return j}toPromise(){return ie.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class Se extends ie{constructor(ee,j){super(j),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Se;function he(Z){const ee=new I.CancellationTokenSource,j=Z(ee.token);return new Se(ee,async J=>{const ge=ee.token.onCancellationRequested(()=>{ge.dispose(),ee.dispose(),J.reject(new F.CancellationError)});try{for await(const we of j){if(ee.token.isCancellationRequested)return;J.emitOne(we)}ge.dispose(),ee.dispose()}catch(we){ge.dispose(),ee.dispose(),J.reject(we)}})}e.createCancelableAsyncIterable=he;class fe{constructor(){this._deferred=new ne,this._asyncIterable=new ie(J=>{if(ee){J.reject(ee);return}return j&&J.emitMany(j),this._errorFn=ge=>J.reject(ge),this._emitFn=ge=>J.emitOne(ge),this._deferred.p});let ee,j;this._emitFn=J=>{j||(j=[]),j.push(J)},this._errorFn=J=>{ee||(ee=J)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(ee){this._errorFn(ee),this._deferred.complete()}emitOne(ee){this._emitFn(ee)}}e.AsyncIterableSource=fe}),define(ye[35],Ce([1,0,19,11,34,28,17,10,12]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",D="[^/\\\\]",v=/\//g;function S(le,Y){switch(le){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}${Y?`|${R}${D}+`:""})*?`}}function C(le,Y){if(!le)return[];const K=[];let Q=!1,ue=!1,ne="";for(const pe of le){switch(pe){case Y:if(!Q&&!ue){K.push(ne),ne="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=pe}return ne&&K.push(ne),K}e.splitGlobAware=C;function c(le){if(!le)return"";let Y="";const K=C(le,e.GLOB_SPLIT);if(K.every(Q=>Q===e.GLOBSTAR))Y=".*";else{let Q=!1;K.forEach((ue,ne)=>{if(ue===e.GLOBSTAR){if(Q)return;Y+=S(2,ne===K.length-1)}else{let pe=!1,oe="",q=!1,W="";for(const ie of ue){if(ie!=="}"&&pe){oe+=ie;continue}if(q&&(ie!=="]"||!W)){let Se;ie==="-"?Se=ie:(ie==="^"||ie==="!")&&!W?Se="^":ie===e.GLOB_SPLIT?Se="":Se=(0,p.escapeRegExpCharacters)(ie),W+=Se;continue}switch(ie){case"{":pe=!0;continue;case"[":q=!0;continue;case"}":{const he=`(?:${C(oe,",").map(fe=>c(fe)).join("|")})`;Y+=he,pe=!1,oe="";break}case"]":{Y+="["+W+"]",q=!1,W="";break}case"?":Y+=D;continue;case"*":Y+=S(1);continue;default:Y+=(0,p.escapeRegExpCharacters)(ie)}}ne<K.length-1&&(K[ne+1]!==e.GLOBSTAR||ne+2<K.length)&&(Y+=R)}Q=ue===e.GLOBSTAR})}return Y}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),d=function(){return!1},s=function(){return null};function h(le,Y){if(!le)return s;let K;typeof le!="string"?K=le.pattern:K=le,K=K.trim();const Q=`${K}_${!!Y.trimForExclusions}`;let ue=t.get(Q);if(ue)return l(ue,le);let ne;return m.test(K)?ue=w(K.substr(4),K):(ne=o.exec(u(K,Y)))?ue=k(ne[1],K):(Y.trimForExclusions?r:i).test(K)?ue=b(K,Y):(ne=n.exec(u(K,Y)))?ue=g(ne[1].substr(1),K,!0):(ne=a.exec(u(K,Y)))?ue=g(ne[1],K,!1):ue=_(K),t.set(Q,ue),l(ue,le)}function l(le,Y){if(typeof Y=="string")return le;const K=function(Q,ue){return(0,f.isEqualOrParent)(Q,Y.base,!E.isLinux)?le((0,p.ltrim)(Q.substr(Y.base.length),A.sep),ue):null};return K.allBasenames=le.allBasenames,K.allPaths=le.allPaths,K.basenames=le.basenames,K.patterns=le.patterns,K}function u(le,Y){return Y.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function w(le,Y){return function(K,Q){return typeof K=="string"&&K.endsWith(le)?Y:null}}function k(le,Y){const K=`/${le}`,Q=`\\${le}`,ue=function(pe,oe){return typeof pe!="string"?null:oe?oe===le?Y:null:pe===le||pe.endsWith(K)||pe.endsWith(Q)?Y:null},ne=[le];return ue.basenames=ne,ue.patterns=[Y],ue.allBasenames=ne,ue}function b(le,Y){const K=B(le.slice(1,-1).split(",").map(oe=>h(oe,Y)).filter(oe=>oe!==s),le),Q=K.length;if(!Q)return s;if(Q===1)return K[0];const ue=function(oe,q){for(let W=0,ie=K.length;W<ie;W++)if(K[W](oe,q))return le;return null},ne=K.find(oe=>!!oe.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const pe=K.reduce((oe,q)=>q.allPaths?oe.concat(q.allPaths):oe,[]);return pe.length&&(ue.allPaths=pe),ue}function g(le,Y,K){const Q=A.sep===A.posix.sep,ue=Q?le:le.replace(v,A.sep),ne=A.sep+ue,pe=A.posix.sep+le;let oe;return K?oe=function(q,W){return typeof q=="string"&&(q===ue||q.endsWith(ne)||!Q&&(q===le||q.endsWith(pe)))?Y:null}:oe=function(q,W){return typeof q=="string"&&(q===ue||!Q&&q===le)?Y:null},oe.allPaths=[(K?"*/":"./")+le],oe}function _(le){try{const Y=new RegExp(`^${c(le)}$`);return function(K){return Y.lastIndex=0,typeof K=="string"&&Y.test(K)?le:null}}catch{return s}}function T(le,Y,K){return!le||typeof Y!="string"?!1:O(le)(Y,void 0,K)}e.match=T;function O(le,Y={}){if(!le)return d;if(typeof le=="string"||x(le)){const K=h(le,Y);if(K===s)return d;const Q=function(ue,ne){return!!K(ue,ne)};return K.allBasenames&&(Q.allBasenames=K.allBasenames),K.allPaths&&(Q.allPaths=K.allPaths),Q}return L(le,Y)}e.parse=O;function x(le){const Y=le;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=x;function N(le){return le.allBasenames||[]}e.getBasenameTerms=N;function M(le){return le.allPaths||[]}e.getPathTerms=M;function L(le,Y){const K=B(Object.getOwnPropertyNames(le).map(oe=>U(oe,le[oe],Y)).filter(oe=>oe!==s)),Q=K.length;if(!Q)return s;if(!K.some(oe=>!!oe.requiresSiblings)){if(Q===1)return K[0];const oe=function(ie,Se){let he;for(let fe=0,Z=K.length;fe<Z;fe++){const ee=K[fe](ie,Se);if(typeof ee=="string")return ee;(0,F.isThenable)(ee)&&(he||(he=[]),he.push(ee))}return he?(async()=>{for(const fe of he){const Z=await fe;if(typeof Z=="string")return Z}return null})():null},q=K.find(ie=>!!ie.allBasenames);q&&(oe.allBasenames=q.allBasenames);const W=K.reduce((ie,Se)=>Se.allPaths?ie.concat(Se.allPaths):ie,[]);return W.length&&(oe.allPaths=W),oe}const ue=function(oe,q,W){let ie,Se;for(let he=0,fe=K.length;he<fe;he++){const Z=K[he];Z.requiresSiblings&&W&&(q||(q=(0,A.basename)(oe)),ie||(ie=q.substr(0,q.length-(0,A.extname)(oe).length)));const ee=Z(oe,q,ie,W);if(typeof ee=="string")return ee;(0,F.isThenable)(ee)&&(Se||(Se=[]),Se.push(ee))}return Se?(async()=>{for(const he of Se){const fe=await he;if(typeof fe=="string")return fe}return null})():null},ne=K.find(oe=>!!oe.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const pe=K.reduce((oe,q)=>q.allPaths?oe.concat(q.allPaths):oe,[]);return pe.length&&(ue.allPaths=pe),ue}function U(le,Y,K){if(Y===!1)return s;const Q=h(le,K);if(Q===s)return s;if(typeof Y=="boolean")return Q;if(Y){const ue=Y.when;if(typeof ue=="string"){const ne=(pe,oe,q,W)=>{if(!W||!Q(pe,oe))return null;const ie=ue.replace("$(basename)",()=>q),Se=W(ie);return(0,F.isThenable)(Se)?Se.then(he=>he?le:null):Se?le:null};return ne.requiresSiblings=!0,ne}}return Q}function B(le,Y){const K=le.filter(oe=>!!oe.basenames);if(K.length<2)return le;const Q=K.reduce((oe,q)=>{const W=q.basenames;return W?oe.concat(W):oe},[]);let ue;if(Y){ue=[];for(let oe=0,q=Q.length;oe<q;oe++)ue.push(Y)}else ue=K.reduce((oe,q)=>{const W=q.patterns;return W?oe.concat(W):oe},[]);const ne=function(oe,q){if(typeof oe!="string")return null;if(!q){let ie;for(ie=oe.length;ie>0;ie--){const Se=oe.charCodeAt(ie-1);if(Se===47||Se===92)break}q=oe.substr(ie)}const W=Q.indexOf(q);return W!==-1?ue[W]:null};ne.basenames=Q,ne.patterns=ue,ne.allBasenames=Q;const pe=le.filter(oe=>!oe.basenames);return pe.push(ne),pe}function G(le,Y){return(0,I.equals)(le,Y,(K,Q)=>typeof K=="string"&&typeof Q=="string"?K===Q:typeof K!="string"&&typeof Q!="string"?K.base===Q.base&&K.pattern===Q.pattern:!1)}e.patternsEquals=G}),define(ye[80],Ce([1,0,14,164,23,12,2]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.appendEscapedMarkdownCodeBlockFence=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(E||(e.MarkdownStringTextNewlineStyle=E={}));class p{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=v(this.supportThemeIcons?(0,F.escapeIcons)(i):i).replace(/([ \t]+)/g,(n,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${S(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this._escape(r,"]"),this.value+="](",this.value+=this._escape(String(i),")"),n&&(this.value+=` "${this._escape(this._escape(n,'"'),")")}"`),this.value+=")",this}_escape(i,r){const n=new RegExp((0,P.escapeRegExpCharacters)(r),"g");return i.replace(n,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=p;function y(o){return R(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.isEmptyMarkdownString=y;function R(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function D(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,f.isEqual)(A.URI.from(o.baseUri),A.URI.from(i.baseUri)))}e.markdownStringEqual=D;function v(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function S(o,i){const r=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.appendEscapedMarkdownCodeBlockFence=S;function C(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=c;function m(o){const i=[],r=o.split("|").map(a=>a.trim());o=r[0];const n=r[1];if(n){const a=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),d=a?a[1]:"",s=t?t[1]:"",h=isFinite(parseInt(s)),l=isFinite(parseInt(d));h&&i.push(`width="${s}"`),l&&i.push(`height="${d}"`)}return{href:o,dimensions:i}}e.parseHrefAndDimensions=m}),define(ye[103],Ce([1,0,19,34,17,10,23,12]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(h,l){const{os:u,tildify:w,relative:k}=l;if(k){const _=y(h,k,u);if(typeof _=="string")return _}let b=h.fsPath;if(u===1&&!P.isWindows?b=b.replace(/\//g,"\\"):u!==1&&P.isWindows&&(b=b.replace(/\\/g,"/")),u!==1&&w?.userHome){const _=w.userHome.fsPath;let T;h.scheme!==w.userHome.scheme&&h.path[0]===f.posix.sep&&h.path[1]!==f.posix.sep?T=w.userHome.with({path:h.path}).fsPath:T=b,b=v(T,_,u)}return(u===1?f.win32:f.posix).normalize(R(b,u===1))}e.getPathLabel=p;function y(h,l,u){const w=u===1?f.win32:f.posix,k=u===3?A.extUri:A.extUriIgnorePathCase,b=l.getWorkspace(),g=(0,I.firstOrDefault)(b.folders);if(!g)return;h.scheme!==g.uri.scheme&&h.path[0]===f.posix.sep&&h.path[1]!==f.posix.sep&&(h=g.uri.with({path:h.path}));const _=l.getWorkspaceFolder(h);if(!_)return;let T;if(k.isEqual(_.uri,h)?T="":T=k.relativePath(_.uri,h)??"",T&&(T=w.normalize(T)),b.folders.length>1&&!l.noPrefix){const O=_.name?_.name:k.basenameOrAuthority(_.uri);T=T?`${O} \u2022 ${T}`:O}return T}function R(h,l=P.isWindows){return(0,F.hasDriveLetter)(h,l)?h.charAt(0).toUpperCase()+h.slice(1):h}e.normalizeDriveLetter=R;let D=Object.create(null);function v(h,l,u=P.OS){if(u===1||!h||!l)return h;let w=D.original===l?D.normalized:void 0;w||(w=l,P.isWindows&&(w=(0,F.toSlashes)(w)),w=`${(0,E.rtrim)(w,f.posix.sep)}${f.posix.sep}`,D={original:l,normalized:w});let k=h;return P.isWindows&&(k=(0,F.toSlashes)(k)),(u===3?k.startsWith(w):(0,E.startsWithIgnoreCase)(k,w))?`~/${k.substr(w.length)}`:h}e.tildify=v;function S(h,l){return h.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=S;const C="\u2026",c="\\\\",m="~";function o(h,l=f.sep){const u=new Array(h.length);let w=!1;for(let k=0;k<h.length;k++){const b=h[k];if(b===""){u[k]=`.${l}`;continue}if(!b){u[k]=b;continue}w=!0;let g="",_=b;_.indexOf(c)===0?(g=_.substr(0,_.indexOf(c)+c.length),_=_.substr(_.indexOf(c)+c.length)):_.indexOf(l)===0?(g=_.substr(0,_.indexOf(l)+l.length),_=_.substr(_.indexOf(l)+l.length)):_.indexOf(m)===0&&(g=_.substr(0,_.indexOf(m)+m.length),_=_.substr(_.indexOf(m)+m.length));const T=_.split(l);for(let O=1;w&&O<=T.length;O++)for(let x=T.length-O;w&&x>=0;x--){w=!1;let N=T.slice(x,x+O).join(l);for(let M=0;!w&&M<h.length;M++)if(M!==k&&h[M]&&h[M].indexOf(N)>-1){const L=x+O===T.length,U=x>0&&h[M].indexOf(l)>-1?l+N:N,B=h[M].endsWith(U);w=!L||B}if(!w){let M="";(T[0].endsWith(":")||g!=="")&&(x===1&&(x=0,O++,N=T[0]+l+N),x>0&&(M=T[0]+l),M=g+M),x>0&&(M=M+C+l),M=M+N,x+O<T.length&&(M=M+l+C),u[k]=M}}w&&(u[k]=b)}return u}e.shorten=o;var i;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(h,l=Object.create(null)){const u=[];let w=!1,k="";for(const b of h)if(b==="$"||w&&b==="{")k&&u.push({value:k,type:i.TEXT}),k="",w=!0;else if(b==="}"&&w){const g=l[k];if(typeof g=="string")g.length&&u.push({value:g,type:i.VARIABLE});else if(g){const _=u[u.length-1];(!_||_.type!==i.SEPARATOR)&&u.push({value:g.label,type:i.SEPARATOR})}k="",w=!1}else k+=b;return k&&!w&&u.push({value:k,type:i.TEXT}),u.filter((b,g)=>{if(b.type===i.SEPARATOR){const _=u[g-1],T=u[g+1];return[_,T].every(O=>O&&(O.type===i.VARIABLE||O.type===i.TEXT)&&O.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=r;function n(h,l){return P.isMacintosh||l?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):h.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=n;function a(h,l){return P.isMacintosh||l?h.replace(/\(&&\w\)|&&/g,""):P.isWindows?h.replace(/&&|&/g,u=>u==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(h){return h.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(h){if(h.endsWith("]")){const l=h.lastIndexOf(" [",h.length-2);if(l!==-1){const u=s(h.substring(0,l)),w=h.substring(l);return{name:u.name+w,parentPath:u.parentPath}}}return s(h)}e.splitRecentLabel=d;function s(h){const l=h.indexOf("/")!==-1?f.posix:f.win32,u=l.basename(h),w=l.dirname(h);return u.length?{name:u,parentPath:w}:{name:w,parentPath:""}}}),define(ye[130],Ce([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function f(D){return D.toJSON()}class P{constructor(v){this._uriTransformer=v}transformIncoming(v){const S=this._uriTransformer.transformIncoming(v);return S===v?v:f(F.URI.from(S))}transformOutgoing(v){const S=this._uriTransformer.transformOutgoing(v);return S===v?v:f(F.URI.from(S))}transformOutgoingURI(v){const S=this._uriTransformer.transformOutgoing(v);return S===v?v:F.URI.from(S)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,v,S){if(!D||S>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return v.transformOutgoing(D);for(const C in D)if(Object.hasOwnProperty.call(D,C)){const c=A(D[C],v,S+1);c!==null&&(D[C]=c)}}return null}function E(D,v){const S=A(D,v,0);return S===null?D:S}e.transformOutgoingURIs=E;function p(D,v,S,C){if(!D||C>200)return null;if(typeof D=="object"){if(D.$mid===1)return S?F.URI.revive(v.transformIncoming(D)):v.transformIncoming(D);if(D instanceof I.VSBuffer)return null;for(const c in D)if(Object.hasOwnProperty.call(D,c)){const m=p(D[c],v,S,C+1);m!==null&&(D[c]=m)}}return null}function y(D,v){const S=p(D,v,!1,0);return S===null?D:S}e.transformIncomingURIs=y;function R(D,v){const S=p(D,v,!0,0);return S===null?D:S}e.transformAndReviveIncomingURIs=R}),define(ye[31],Ce([1,0,57,63,386,11,34,76,17,10,23,2]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function S(U,B=v.UNLINK,G){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?c(U):C(U,G)}async function C(U,B=(0,A.randomPath)((0,F.tmpdir)())){try{try{await I.promises.rename(U,B)}catch(G){return G.code==="ENOENT"?void 0:c(U)}c(B).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function c(U){return(0,f.promisify)(I.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function m(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function o(U,B){return n(await(B?i(U):(0,f.promisify)(I.readdir)(U)))}async function i(U){try{return await(0,f.promisify)(I.readdir)(U,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const B=[],G=await o(U);for(const le of G){let Y=!1,K=!1,Q=!1;try{const ue=await e.Promises.lstat((0,p.join)(U,le));Y=ue.isFile(),K=ue.isDirectory(),Q=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}B.push({name:le,isFile:()=>Y,isDirectory:()=>K,isSymbolicLink:()=>Q})}return B}function r(U){return n(I.readdirSync(U))}e.readdirSync=r;function n(U){return U.map(B=>typeof B=="string"?y.isMacintosh?(0,E.normalizeNFC)(B):B:(B.name=y.isMacintosh?(0,E.normalizeNFC)(B.name):B.name,B))}async function a(U){const B=await o(U),G=[];for(const le of B)await d.existsDirectory((0,p.join)(U,le))&&G.push(le);return G}function t(U,B=1e3){return new Promise(G=>{let le=!1;const Y=setInterval(()=>{le||(le=!0,I.access(U,K=>{le=!1,K&&(clearInterval(Y),G(void 0))}))},B)})}e.whenDeleted=t;var d;(function(U){async function B(Y){let K;try{if(K=await e.Promises.lstat(Y),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(y.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ue}throw Q}}U.stat=B;async function G(Y){try{const{stat:K,symbolicLink:Q}=await U.stat(Y);return K.isFile()&&Q?.dangling!==!0}catch{}return!1}U.existsFile=G;async function le(Y){try{const{stat:K,symbolicLink:Q}=await U.stat(Y);return K.isDirectory()&&Q?.dangling!==!0}catch{}return!1}U.existsDirectory=le})(d||(e.SymlinkSupport=d={}));const s=new P.ResourceQueue;function h(U,B,G){return s.queueFor(D.URI.file(U),()=>{const le=b(G);return new Promise((Y,K)=>w(U,B,le,Q=>Q?K(Q):Y()))},R.extUriBiasedIgnorePathCase)}let l=!0;function u(U){l=U}e.configureFlushOnWrite=u;function w(U,B,G,le){if(!l)return I.writeFile(U,B,{mode:G.mode,flag:G.flag},le);I.open(U,G.flag,G.mode,(Y,K)=>{if(Y)return le(Y);I.writeFile(K,B,Q=>{if(Q)return I.close(K,()=>le(Q));I.fdatasync(K,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),u(!1)),I.close(K,ne=>le(ne))))})})}function k(U,B,G){const le=b(G);if(!l)return I.writeFileSync(U,B,{mode:le.mode,flag:le.flag});const Y=I.openSync(U,le.flag,le.mode);try{I.writeFileSync(Y,B);try{I.fdatasyncSync(Y)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),u(!1)}}finally{I.closeSync(Y)}}e.writeFileSync=k;function b(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,B,G=6e4){if(U!==B)try{y.isWindows&&typeof G=="number"?await _(U,B,Date.now(),G):await(0,f.promisify)(I.rename)(U,B)}catch(le){if(U.toLowerCase()!==B.toLowerCase()&&le.code==="EXDEV"||U.endsWith("."))await T(U,B,{preserveSymlinks:!1}),await S(U,v.MOVE);else throw le}}async function _(U,B,G,le,Y=0){try{return await(0,f.promisify)(I.rename)(U,B)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-G>=le)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${K}`),K;if(Y===0){let Q=!1;try{const{stat:ue}=await d.stat(B);ue.isFile()||(Q=!0)}catch{}if(Q)throw K}return await(0,P.timeout)(Math.min(100,Y*10)),_(U,B,G,le,Y+1)}}async function T(U,B,G){return x(U,B,{root:{source:U,target:B},options:G,handledSourcePaths:new Set})}const O=511;async function x(U,B,G){if(G.handledSourcePaths.has(U))return;G.handledSourcePaths.add(U);const{stat:le,symbolicLink:Y}=await d.stat(U);if(Y){if(G.options.preserveSymlinks)try{return await L(U,B,G)}catch{}if(Y.dangling)return}return le.isDirectory()?N(U,B,le.mode&O,G):M(U,B,le.mode&O)}async function N(U,B,G,le){await e.Promises.mkdir(B,{recursive:!0,mode:G});const Y=await o(U);for(const K of Y)await x((0,p.join)(U,K),(0,p.join)(B,K),le)}async function M(U,B,G){await e.Promises.copyFile(U,B),await e.Promises.chmod(B,G)}async function L(U,B,G){let le=await e.Promises.readlink(U);(0,A.isEqualOrParent)(le,G.root.source,!y.isLinux)&&(le=(0,p.join)(G.root.target,le.substr(G.root.source.length+1))),await e.Promises.symlink(le,B)}e.Promises=new class{get access(){return(0,f.promisify)(I.access)}get stat(){return(0,f.promisify)(I.stat)}get lstat(){return(0,f.promisify)(I.lstat)}get utimes(){return(0,f.promisify)(I.utimes)}get read(){return(U,B,G,le,Y)=>new Promise((K,Q)=>{I.read(U,B,G,le,Y,(ue,ne,pe)=>ue?Q(ue):K({bytesRead:ne,buffer:pe}))})}get readFile(){return(0,f.promisify)(I.readFile)}get write(){return(U,B,G,le,Y)=>new Promise((K,Q)=>{I.write(U,B,G,le,Y,(ue,ne,pe)=>ue?Q(ue):K({bytesWritten:ne,buffer:pe}))})}get appendFile(){return(0,f.promisify)(I.appendFile)}get fdatasync(){return(0,f.promisify)(I.fdatasync)}get truncate(){return(0,f.promisify)(I.truncate)}get copyFile(){return(0,f.promisify)(I.copyFile)}get open(){return(0,f.promisify)(I.open)}get close(){return(0,f.promisify)(I.close)}get symlink(){return(0,f.promisify)(I.symlink)}get readlink(){return(0,f.promisify)(I.readlink)}get chmod(){return(0,f.promisify)(I.chmod)}get mkdir(){return(0,f.promisify)(I.mkdir)}get unlink(){return(0,f.promisify)(I.unlink)}get rmdir(){return(0,f.promisify)(I.rmdir)}get realpath(){return(0,f.promisify)(I.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return h}get rm(){return S}get rename(){return g}get copy(){return T}}}),define(ye[104],Ce([1,0,57,17,10,12,31]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(v){if(f.isLinux)return v;const S=(0,F.dirname)(v);if(v===S)return v;const C=((0,F.basename)(v)||v).toLowerCase();try{const m=(0,A.readdirSync)(S).filter(o=>o.toLowerCase()===C);if(m.length===1){const o=E(S);if(o)return(0,F.join)(o,m[0])}else if(m.length>1){const o=m.indexOf(C);if(o>=0){const i=E(S);if(i)return(0,F.join)(i,m[o])}}}catch{}return null}e.realcaseSync=E;async function p(v){if(f.isLinux)return v;const S=(0,F.dirname)(v);if(v===S)return v;const C=((0,F.basename)(v)||v).toLowerCase();try{const m=(await A.Promises.readdir(S)).filter(o=>o.toLowerCase()===C);if(m.length===1){const o=await p(S);if(o)return(0,F.join)(o,m[0])}else if(m.length>1){const o=m.indexOf(C);if(o>=0){const i=await p(S);if(i)return(0,F.join)(i,m[o])}}}catch{}return null}e.realcase=p;async function y(v){try{return await A.Promises.realpath(v)}catch{const C=D(v);return await A.Promises.access(C,I.constants.R_OK),C}}e.realpath=y;function R(v){try{return I.realpathSync(v)}catch{const C=D(v);return I.accessSync(C,I.constants.R_OK),C}}e.realpathSync=R;function D(v){return(0,P.rtrim)((0,F.normalize)(v),F.sep)}}),define(ye[105],Ce([1,0,17,10,49,102,18,31]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(D=f.env){return D.comspec||"cmd.exe"}e.getWindowsShell=p;function y(D){let v=[],S=!1;const C=function(c){if(S){v.push(c);return}(!D.send(c,o=>{if(o&&console.error(o),S=!1,v.length>0){const i=v.slice(0);v=[],i.forEach(r=>C(r))}})||F.isWindows)&&(S=!0)};return{send:C}}e.createQueuedSender=y;var R;(function(D){async function v(S,C,c){if(I.isAbsolute(S))return S;if(C===void 0&&(C=f.cwd()),I.dirname(S)!=="."||(c===void 0&&A.isString(f.env.PATH)&&(c=f.env.PATH.split(I.delimiter)),c===void 0||c.length===0))return I.join(C,S);async function o(i){if(await E.Promises.exists(i)){let r;try{r=await E.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await E.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of c){let r;if(I.isAbsolute(i)?r=I.join(i,S):r=I.join(C,i,S),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return I.join(C,S)}D.findExecutable=v})(R||(e.win32=R={}))});var je=this&&this.__decorate||function(me,e,I,F){var f=arguments.length,P=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(me,e,I,F);else for(var E=me.length-1;E>=0;E--)(A=me[E])&&(P=(f<3?A(P):f>3?A(e,I,P):A(e,I))||P);return f>3&&P&&Object.defineProperty(e,I,P),P};define(ye[81],Ce([1,0,19,11,22,21,52,14,4,3,56,12,18]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(S||(S={}));function C(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(c||(c={}));function m(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(o||(o={}));function i(Y){let K=0;for(let Q=0;;Q+=7){const ue=Y.read(1);if(K|=(ue.buffer[0]&127)<<Q,!(ue.buffer[0]&128))return K}}const r=s(0);function n(Y,K){if(K===0){Y.write(r);return}let Q=0;for(let ne=K;ne!==0;ne=ne>>>7)Q++;const ue=f.VSBuffer.alloc(Q);for(let ne=0;K!==0;ne++)ue.buffer[ne]=K&127,K=K>>>7,K>0&&(ue.buffer[ne]|=128);Y.write(ue)}class a{constructor(K){this.buffer=K,this.pos=0}read(K){const Q=this.buffer.slice(this.pos,this.pos+K);return this.pos+=Q.byteLength,Q}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return f.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}e.BufferWriter=t;var d;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(d||(d={}));function s(Y){const K=f.VSBuffer.alloc(1);return K.writeUInt8(Y,0),K}const h={Undefined:s(d.Undefined),String:s(d.String),Buffer:s(d.Buffer),VSBuffer:s(d.VSBuffer),Array:s(d.Array),Object:s(d.Object),Uint:s(d.Int)},l=typeof Buffer<"u";function u(Y,K){if(typeof K>"u")Y.write(h.Undefined);else if(typeof K=="string"){const Q=f.VSBuffer.fromString(K);Y.write(h.String),n(Y,Q.byteLength),Y.write(Q)}else if(l&&Buffer.isBuffer(K)){const Q=f.VSBuffer.wrap(K);Y.write(h.Buffer),n(Y,Q.byteLength),Y.write(Q)}else if(K instanceof f.VSBuffer)Y.write(h.VSBuffer),n(Y,K.byteLength),Y.write(K);else if(Array.isArray(K)){Y.write(h.Array),n(Y,K.length);for(const Q of K)u(Y,Q)}else if(typeof K=="number"&&(K|0)===K)Y.write(h.Uint),n(Y,K);else{const Q=f.VSBuffer.fromString(JSON.stringify(K));Y.write(h.Object),n(Y,Q.byteLength),Y.write(Q)}}e.serialize=u;function w(Y){switch(Y.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return Y.read(i(Y)).toString();case d.Buffer:return Y.read(i(Y)).buffer;case d.VSBuffer:return Y.read(i(Y));case d.Array:{const Q=i(Y),ue=[];for(let ne=0;ne<Q;ne++)ue.push(w(Y));return ue}case d.Object:return JSON.parse(Y.read(i(Y)).toString());case d.Int:return i(Y)}}e.deserialize=w;class k{constructor(K,Q,ue=null,ne=1e3){this.protocol=K,this.ctx=Q,this.logger=ue,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(pe=>this.onRawMessage(pe)),this.sendResponse({type:200})}registerChannel(K,Q){this.channels.set(K,Q),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const Q=this.send([K.type]);this.logger?.logOutgoing(Q,0,1,m(K.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(Q,K.id,1,m(K.type),K.data);return}}}send(K,Q=void 0){const ue=new t;return u(ue,K),u(ue,Q),this.sendBuffer(ue.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const Q=new a(K),ue=w(Q),ne=w(Q),pe=ue[0];switch(pe){case 100:return this.logger?.logIncoming(K.byteLength,ue[1],1,`${C(pe)}: ${ue[2]}.${ue[3]}`,ne),this.onPromise({type:pe,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 102:return this.logger?.logIncoming(K.byteLength,ue[1],1,`${C(pe)}: ${ue[2]}.${ue[3]}`,ne),this.onEventListen({type:pe,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 101:return this.logger?.logIncoming(K.byteLength,ue[1],1,`${C(pe)}`),this.disposeActiveRequest({type:pe,id:ue[1]});case 103:return this.logger?.logIncoming(K.byteLength,ue[1],1,`${C(pe)}`),this.disposeActiveRequest({type:pe,id:ue[1]})}}onPromise(K){const Q=this.channels.get(K.channelName);if(!Q){this.collectPendingRequest(K);return}const ue=new P.CancellationTokenSource;let ne;try{ne=Q.call(this.ctx,K.name,K.arg,ue.token)}catch(q){ne=Promise.reject(q)}const pe=K.id;ne.then(q=>{this.sendResponse({id:pe,data:q,type:201})},q=>{q instanceof Error?this.sendResponse({id:pe,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:pe,data:q,type:203})}).finally(()=>{oe.dispose(),this.activeRequests.delete(K.id)});const oe=(0,y.toDisposable)(()=>ue.cancel());this.activeRequests.set(K.id,oe)}onEventListen(K){const Q=this.channels.get(K.channelName);if(!Q){this.collectPendingRequest(K);return}const ue=K.id,pe=Q.listen(this.ctx,K.name,K.arg)(oe=>this.sendResponse({id:ue,data:oe,type:204}));this.activeRequests.set(K.id,pe)}disposeActiveRequest(K){const Q=this.activeRequests.get(K.id);Q&&(Q.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let Q=this.pendingRequests.get(K.channelName);Q||(Q=[],this.pendingRequests.set(K.channelName,Q));const ue=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:K,timeoutTimer:ue})}flushPendingRequests(K){const Q=this.pendingRequests.get(K);if(Q){for(const ue of Q)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.onPromise(ue.request);break;case 102:this.onEventListen(ue.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=k;var b;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class g{constructor(K,Q=null){this.protocol=K,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ue=>this.onBuffer(ue)),this.logger=Q}getChannel(K){const Q=this;return{call(ue,ne,pe){return Q.isDisposed?Promise.reject(new E.CancellationError):Q.requestPromise(K,ue,ne,pe)},listen(ue,ne){return Q.isDisposed?p.Event.None:Q.requestEvent(K,ue,ne)}}}requestPromise(K,Q,ue,ne=P.CancellationToken.None){const pe=this.lastRequestId++,q={id:pe,type:100,channelName:K,name:Q,arg:ue};if(ne.isCancellationRequested)return Promise.reject(new E.CancellationError);let W;return new Promise((Se,he)=>{if(ne.isCancellationRequested)return he(new E.CancellationError);const fe=()=>{const J=ge=>{switch(ge.type){case 201:this.handlers.delete(pe),Se(ge.data);break;case 202:{this.handlers.delete(pe);const we=new Error(ge.data.message);we.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,we.name=ge.data.name,he(we);break}case 203:this.handlers.delete(pe),he(ge.data);break}};this.handlers.set(pe,J),this.sendRequest(q)};let Z=null;this.state===o.Idle?fe():(Z=(0,F.createCancelablePromise)(J=>this.whenInitialized()),Z.then(()=>{Z=null,fe()}));const ee=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:pe,type:101}),he(new E.CancellationError)},j=ne.onCancellationRequested(ee);W=(0,y.combinedDisposable)((0,y.toDisposable)(ee),j),this.activeRequests.add(W)}).finally(()=>{W.dispose(),this.activeRequests.delete(W)})}requestEvent(K,Q,ue){const ne=this.lastRequestId++,oe={id:ne,type:102,channelName:K,name:Q,arg:ue};let q=null;const W=new p.Emitter({onWillAddFirstListener:()=>{q=(0,F.createCancelablePromise)(Se=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(W),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(W),this.sendRequest({id:ne,type:103}))}}),ie=Se=>W.fire(Se.data);return this.handlers.set(ne,ie),W.event}sendRequest(K){switch(K.type){case 100:case 102:{const Q=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger?.logOutgoing(Q,K.id,0,`${C(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const Q=this.send([K.type,K.id]);this.logger?.logOutgoing(Q,K.id,0,C(K.type));return}}}send(K,Q=void 0){const ue=new t;return u(ue,K),u(ue,Q),this.sendBuffer(ue.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const Q=new a(K),ue=w(Q),ne=w(Q),pe=ue[0];switch(pe){case 200:return this.logger?.logIncoming(K.byteLength,0,0,m(pe)),this.onResponse({type:ue[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(K.byteLength,ue[1],0,m(pe),ne),this.onResponse({type:ue[0],id:ue[1],data:ne})}}onResponse(K){if(K.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(K.id)?.(K)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=g,je([A.memoize],g.prototype,"onDidInitializePromise",null);class _{get connections(){const K=[];return this._connections.forEach(Q=>K.push(Q)),K}constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new y.DisposableStore,this.disposables.add(K(({protocol:Q,onDidClientDisconnect:ue})=>{const ne=p.Event.once(Q.onMessage);this.disposables.add(ne(pe=>{const oe=new a(pe),q=w(oe),W=new k(Q,q),ie=new g(Q);this.channels.forEach((he,fe)=>W.registerChannel(fe,he));const Se={channelServer:W,channelClient:ie,ctx:q};this._connections.add(Se),this._onDidAddConnection.fire(Se),this.disposables.add(ue(()=>{W.dispose(),ie.dispose(),this._connections.delete(Se),this._onDidRemoveConnection.fire(Se)}))}))}))}getChannel(K,Q){const ue=this;return{call(ne,pe,oe){let q;if((0,v.isFunction)(Q)){const ie=(0,I.getRandomElement)(ue.connections.filter(Q));q=ie?Promise.resolve(ie):p.Event.toPromise(p.Event.filter(ue.onDidAddConnection,Q))}else q=Q.routeCall(ue,ne,pe);const W=q.then(ie=>ie.channelClient.getChannel(K));return O(W).call(ne,pe,oe)},listen(ne,pe){if((0,v.isFunction)(Q))return ue.getMulticastEvent(K,Q,ne,pe);const oe=Q.routeEvent(ue,ne,pe).then(q=>q.channelClient.getChannel(K));return O(oe).listen(ne,pe)}}}getMulticastEvent(K,Q,ue,ne){const pe=this;let oe;const q=new p.Emitter({onWillAddFirstListener:()=>{oe=new y.DisposableStore;const W=new p.EventMultiplexer,ie=new Map,Se=fe=>{const ee=fe.channelClient.getChannel(K).listen(ue,ne),j=W.add(ee);ie.set(fe,j)},he=fe=>{const Z=ie.get(fe);Z&&(Z.dispose(),ie.delete(fe))};pe.connections.filter(Q).forEach(Se),p.Event.filter(pe.onDidAddConnection,Q)(Se,void 0,oe),pe.onDidRemoveConnection(he,void 0,oe),W.event(q.fire,q,oe),oe.add(W)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return q.event}registerChannel(K,Q){this.channels.set(K,Q);for(const ue of this._connections)ue.channelServer.registerChannel(K,Q)}dispose(){this.disposables.dispose();for(const K of this._connections)K.channelClient.dispose(),K.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class T{constructor(K,Q,ue=null){const ne=new t;u(ne,Q),K.send(ne.buffer),this.channelClient=new g(K,ue),this.channelServer=new k(K,Q,ue)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,Q){this.channelServer.registerChannel(K,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(Y){return{call(K,Q,ue){return Y.then(ne=>ne.call(K,Q,ue))},listen(K,Q){const ue=new p.Relay;return Y.then(ne=>ue.input=ne.listen(K,Q)),ue.event}}}e.getDelayedChannel=O;function x(Y){let K=!1;return{call(Q,ue,ne){return K?Y.call(Q,ue,ne):(0,F.timeout)(0).then(()=>K=!0).then(()=>Y.call(Q,ue,ne))},listen(Q,ue){if(K)return Y.listen(Q,ue);const ne=new p.Relay;return(0,F.timeout)(0).then(()=>K=!0).then(()=>ne.input=Y.listen(Q,ue)),ne.event}}}e.getNextTickChannel=x;class N{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const Q of K.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await p.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=N;var M;(function(Y){function K(pe,oe,q){const W=pe,ie=q&&q.disableMarshalling,Se=new Map;for(const he in W)ue(he)&&Se.set(he,p.Event.buffer(W[he],!0,void 0,oe));return new class{listen(he,fe,Z){const ee=Se.get(fe);if(ee)return ee;if(ne(fe)){const j=W[fe];if(typeof j=="function")return j.call(W,Z)}throw new E.ErrorNoTelemetry(`Event not found: ${fe}`)}call(he,fe,Z){const ee=W[fe];if(typeof ee=="function"){if(!ie&&Array.isArray(Z))for(let J=0;J<Z.length;J++)Z[J]=(0,R.revive)(Z[J]);let j=ee.apply(W,Z);return j instanceof Promise||(j=Promise.resolve(j)),j}throw new E.ErrorNoTelemetry(`Method not found: ${fe}`)}}}Y.fromService=K;function Q(pe,oe){const q=oe&&oe.disableMarshalling;return new Proxy({},{get(W,ie){if(typeof ie=="string")return oe?.properties?.has(ie)?oe.properties.get(ie):ne(ie)?function(Se){return pe.listen(ie,Se)}:ue(ie)?pe.listen(ie):async function(...Se){let he;oe&&!(0,v.isUndefinedOrNull)(oe.context)?he=[oe.context,...Se]:he=Se;const fe=await pe.call(ie,he);return q?fe:(0,R.revive)(fe)};throw new E.ErrorNoTelemetry(`Property not found: ${String(ie)}`)}})}Y.toService=Q;function ue(pe){return pe[0]==="o"&&pe[1]==="n"&&D.isUpperAsciiLetter(pe.charCodeAt(2))}function ne(pe){return/^onDynamic/.test(pe)&&D.isUpperAsciiLetter(pe.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const L=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const K=Y.toString();if(K!=="[object Object]")return K}return Y}function B(Y){return Array.isArray(Y)?Y.map(U):U(Y)}function G(Y,K,Q,ue,ne,pe,oe){oe=B(oe);const q=L[ne],W=q[ue%q.length];let ie=[`%c[${Y}]%c[${String(K).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(pe)?(ie=ie.concat(oe),ie.push(")")):ie.push(oe),console.log.apply(console,ie)}class le{constructor(K,Q){this._outgoingPrefix=K,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,Q,ue,ne,pe){this._totalOutgoing+=K,G(this._outgoingPrefix,this._totalOutgoing,K,Q,ue,ne,pe)}logIncoming(K,Q,ue,ne,pe){this._totalIncoming+=K,G(this._incomingPrefix,this._totalIncoming,K,Q,ue,ne,pe)}}e.IPCLogger=le}),define(ye[82],Ce([1,0,22,4,3,81]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var E;(function(h){h.enableDiagnostics=!1,h.records=[];const l=new WeakMap;let u=0;function w(b,g){if(!l.has(b)){const _=String(++u);l.set(b,_)}return l.get(b)}function k(b,g,_,T){if(!h.enableDiagnostics)return;const O=w(b,g);if(T instanceof I.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const x=I.VSBuffer.alloc(T.byteLength);x.set(T),h.records.push({timestamp:Date.now(),id:O,label:g,type:_,buff:x})}else h.records.push({timestamp:Date.now(),id:O,label:g,type:_,data:T})}h.traceSocketEvent=k})(E||(e.SocketDiagnostics=E={}));var p;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let y=null;function R(){return y||(y=I.VSBuffer.alloc(0)),y}class D{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(l){this._chunks.push(l),this._totalLength+=l.byteLength}read(l){return this._read(l,!0)}peek(l){return this._read(l,!1)}_read(l,u){if(l===0)return R();if(l>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===l){const g=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=l),g}if(this._chunks[0].byteLength>l){const g=this._chunks[0].slice(0,l);return u&&(this._chunks[0]=this._chunks[0].slice(l),this._totalLength-=l),g}const w=I.VSBuffer.alloc(l);let k=0,b=0;for(;l>0;){const g=this._chunks[b];if(g.byteLength>l){const _=g.slice(0,l);w.set(_,k),k+=l,u&&(this._chunks[b]=g.slice(l),this._totalLength-=l),l-=l}else w.set(g,k),k+=g.byteLength,u?(this._chunks.shift(),this._totalLength-=g.byteLength):b++,l-=g.byteLength}return w}}e.ChunkStream=D;var v;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(v||(v={}));function S(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class c{constructor(l,u,w,k){this.type=l,this.id=u,this.ack=w,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends f.Disposable{constructor(l){super(),this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=l,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const w=this._state.messageType,k=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new c(w,k,b,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(l){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=l,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(l){if(this._isDisposed)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=I.VSBuffer.alloc(13);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",l.data),this._writeSoon(u,l.data)}_bufferAdd(l,u){const w=this._totalLength===0;return this._data.push(l,u),this._totalLength+=l.byteLength+u.byteLength,w}_bufferTake(){const l=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,l}_writeSoon(l,u){this._bufferAdd(l,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const l=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this._socket.write(l)}}class i extends f.Disposable{constructor(l){super(),this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=l,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(l){this._socketWriter.write(new c(1,0,0,l))}}e.Protocol=i;class r extends P.IPCClient{static fromSocket(l,u){return new r(new i(l),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(l,u,w=null){super(l,u,w),this.protocol=l}dispose(){super.dispose();const l=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),l.end()}}e.Client=r;class n{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(l){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(l):this._emitter.fire(l):this._bufferedMessages.push(l)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=n;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let l=0,u=this._first;for(;u;)u=u.next,l++;return l}peek(){return this._first?this._first.data:null}toArray(){const l=[];let u=0,w=this._first;for(;w;)l[u++]=w.data,w=w.next;return l}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(l){const u=new a(l);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class d{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}constructor(){this.lastRuns=[];const l=Date.now();for(let u=0;u<d._HISTORY_LENGTH;u++)this.lastRuns[u]=l-1e3*u;setInterval(()=>{for(let u=d._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const l=Date.now(),u=(1+d._HISTORY_LENGTH)*1e3;let w=0;for(let k=0;k<d._HISTORY_LENGTH;k++)l-this.lastRuns[k]<=u&&w++;return 1-w/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(l){this._onControlMessage=new n,this.onControlMessage=this._onControlMessage.event,this._onMessage=new n,this.onMessage=this._onMessage.event,this._onDidDispose=new n,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new n,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new n,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l.loadEstimator??d.getInstance(),this._shouldSendKeepAlive=l.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new f.DisposableStore,this._socket=l.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),l.initialChunk&&this._socketReader.acceptChunk(l.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const l=new c(5,0,0,R());this._socketWriter.write(l),this._socketWriter.flush()}sendPause(){const l=new c(7,0,0,R());this._socketWriter.write(l)}sendResume(){const l=new c(8,0,0,R());this._socketWriter.write(l)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(l,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new f.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=l,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.add(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const l=new c(3,0,this._incomingAckId,R());this._socketWriter.write(l);const u=this._outgoingUnackMsg.toArray();for(let w=0,k=u.length;w<k;w++)this._socketWriter.write(u[w]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(l){if(l.ack>this._outgoingAckId){this._outgoingAckId=l.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=l.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this._incomingMsgId)if(l.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new c(6,0,0,R())))}else this._incomingMsgId=l.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(l.data);break}case 2:{this._onControlMessage.fire(l.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let w=0,k=u.length;w<k;w++)this._socketWriter.write(u[w]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(l){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new c(1,u,this._incomingAckId,l);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(l){const u=new c(2,0,0,l);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const l=Date.now()-this._incomingMsgLastTime;if(l>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-l+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const l=this._outgoingUnackMsg.peek(),u=Date.now()-l.writtenTime,w=Date.now()-this._socketReader.lastReadTime,k=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&w>=2e4&&k>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:w});return}const b=Math.max(2e4-u,2e4-w,2e4-k,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},b)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const l=new c(3,0,this._incomingAckId,R());this._socketWriter.write(l)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const l=new c(9,0,this._incomingAckId,R());this._socketWriter.write(l)}}e.PersistentProtocol=s}),define(ye[187],Ce([1,0,50,11,22,21,185,14,4,3,24,105,102,81]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class C extends S.ChannelServer{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",i=>f.VSBuffer.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=C;class c{constructor(o,i){this.modulePath=o,this.options=i,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const r=i&&i.timeout?i.timeout:6e4;this.disposeDelayer=new F.Delayer(r),this.child=null,this._client=null}getChannel(o){const i=this;return{call(r,n,a){return i.requestPromise(o,r,n,a)},listen(r,n){return i.requestEvent(o,r,n)}}}requestPromise(o,i,r,n=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(o),t=(0,F.createCancelablePromise)(h=>a.call(i,r,h)),d=n.onCancellationRequested(()=>t.cancel()),s=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{d.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,i,r){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let n;const a=new p.Emitter({onWillAddFirstListener:()=>{n=this.getCachedChannel(o).listen(i,r)(a.fire,a),this.activeRequests.add(n)},onDidRemoveLastListener:()=>{this.activeRequests.delete(n),n.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],i=Object.create(null);i.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(i.env={...i.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(i.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(i.env),this.child=(0,I.fork)(this.modulePath,o,i);const r=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,A.isRemoteConsoleLog)(l)){(0,A.log)(l,`IPC Library: ${this.options.serverName}`);return}r.fire(f.VSBuffer.wrap(Buffer.from(l,"base64")))});const a=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&a.send(l.buffer.toString("base64")),d=r.event,s={send:t,onMessage:d};this._client=new S.ChannelClient(s);const h=()=>this.disposeClient();process.once("exit",h),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,u)=>{process.removeListener("exit",h),this.activeRequests.forEach(w=>(0,y.dispose)(w)),this.activeRequests.clear(),l!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:u})})}return this._client}getCachedChannel(o){let i=this.channels.get(o);return i||(i=this.client.getChannel(o),this.channels.set(o,i)),i}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(ye[188],Ce([1,0,11,4,3,56,18]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function p(v){const S=v;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=p;var y;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends f.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,C=Object.create(null)){super(),this.database=S,this.options=C,this._onDidChangeStorage=this._register(new F.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(R.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((C,c)=>this.acceptExternal(c,C)),S.deleted?.forEach(C=>this.acceptExternal(C,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,C){if(this.state===y.Closed)return;let c=!1;(0,A.isUndefinedOrNull)(C)?c=this.cache.delete(S):this.cache.get(S)!==C&&(this.cache.set(S,C),c=!0),c&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,C){const c=this.cache.get(S);return(0,A.isUndefinedOrNull)(c)?C:c}getBoolean(S,C){const c=this.get(S);return(0,A.isUndefinedOrNull)(c)?C:c==="true"}getNumber(S,C){const c=this.get(S);return(0,A.isUndefinedOrNull)(c)?C:parseInt(c,10)}getObject(S,C){const c=this.get(S);return(0,A.isUndefinedOrNull)(c)?C:(0,P.parse)(c)}async set(S,C,c=!1){if(this.state===y.Closed)return;if((0,A.isUndefinedOrNull)(C))return this.delete(S,c);const m=(0,A.isObject)(C)||Array.isArray(C)?(0,P.stringify)(C):String(C);if(this.cache.get(S)!==m)return this.cache.set(S,m),this.pendingInserts.set(S,m),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:c}),this.doFlush()}async delete(S,C=!1){if(!(this.state===y.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:C}),this.doFlush()}async optimize(){if(this.state!==y.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(this.hasPending)return this.doFlush(S)}async doFlush(S){return this.options.hint===E.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===E.STORAGE_IN_MEMORY}}e.Storage=R;class D{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((C,c)=>this.items.set(c,C)),S.delete?.forEach(C=>this.items.delete(C))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=D}),define(ye[189],Ce([1,0,12,10,22]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let E;function p(){return E||(E=new TextDecoder("UTF-16BE")),E}let y;function R(){return y||(y=F.isLittleEndian()?A():p()),y}e.getPlatformTextDecoder=R;function D(C,c,m){const o=new Uint16Array(C.buffer,c,m);return m>0&&(o[0]===65279||o[0]===65534)?v(C,c,m):A().decode(o)}e.decodeUTF16LE=D;function v(C,c,m){const o=[];let i=0;for(let r=0;r<m;r++){const n=f.readUInt16LE(C,c);c+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class S{constructor(c){this._capacity=c|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const c=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return R().decode(c)}_flushBuffer(){const c=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[c]:this._completedStrings[this._completedStrings.length]=c}appendCharCode(c){const m=this._capacity-this._bufferLength;m<=1&&(m===0||I.isHighSurrogate(c))&&this._flushBuffer(),this._buffer[this._bufferLength++]=c}appendASCIICharCode(c){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=c}appendString(c){const m=c.length;if(this._bufferLength+m>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=c;return}for(let o=0;o<m;o++)this._buffer[this._bufferLength++]=c.charCodeAt(o)}}e.StringBuilder=S}),define(ye[190],Ce([1,0,22,189]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function f(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,D,v){this.oldPosition=y,this.oldText=R,this.newPosition=D,this.newText=v}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static _writeStringSize(y){return 4+2*y.length}static _writeString(y,R,D){const v=R.length;I.writeUInt32BE(y,v,D),D+=4;for(let S=0;S<v;S++)I.writeUInt16LE(y,R.charCodeAt(S),D),D+=2;return D}static _readString(y,R){const D=I.readUInt32BE(y,R);return R+=4,(0,F.decodeUTF16LE)(y,R,D)}writeSize(){return 4+4+P._writeStringSize(this.oldText)+P._writeStringSize(this.newText)}write(y,R){return I.writeUInt32BE(y,this.oldPosition,R),R+=4,I.writeUInt32BE(y,this.newPosition,R),R+=4,R=P._writeString(y,this.oldText,R),R=P._writeString(y,this.newText,R),R}static read(y,R,D){const v=I.readUInt32BE(y,R);R+=4;const S=I.readUInt32BE(y,R);R+=4;const C=P._readString(y,R);R+=P._writeStringSize(C);const c=P._readString(y,R);return R+=P._writeStringSize(c),D.push(new P(v,C,S,c)),R}}e.TextChange=P;function A(p,y){return p===null||p.length===0?y:new E(p,y).compress()}e.compressConsecutiveTextChanges=A;class E{constructor(y,R){this._prevEdits=y,this._currEdits=R,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let y=0,R=0,D=this._getPrev(y),v=this._getCurr(R);for(;y<this._prevLen||R<this._currLen;){if(D===null){this._acceptCurr(v),v=this._getCurr(++R);continue}if(v===null){this._acceptPrev(D),D=this._getPrev(++y);continue}if(v.oldEnd<=D.newPosition){this._acceptCurr(v),v=this._getCurr(++R);continue}if(D.newEnd<=v.oldPosition){this._acceptPrev(D),D=this._getPrev(++y);continue}if(v.oldPosition<D.newPosition){const[o,i]=E._splitCurr(v,D.newPosition-v.oldPosition);this._acceptCurr(o),v=i;continue}if(D.newPosition<v.oldPosition){const[o,i]=E._splitPrev(D,v.oldPosition-D.newPosition);this._acceptPrev(o),D=i;continue}let c,m;if(v.oldEnd===D.newEnd)c=D,m=v,D=this._getPrev(++y),v=this._getCurr(++R);else if(v.oldEnd<D.newEnd){const[o,i]=E._splitPrev(D,v.oldLength);c=o,m=v,D=i,v=this._getCurr(++R)}else{const[o,i]=E._splitCurr(v,D.newLength);c=D,m=o,D=this._getPrev(++y),v=i}this._result[this._resultLen++]=new P(c.oldPosition,c.oldText,m.newPosition,m.newText),this._prevDeltaOffset+=c.newLength-c.oldLength,this._currDeltaOffset+=m.newLength-m.oldLength}const S=E._merge(this._result);return E._removeNoOps(S)}_acceptCurr(y){this._result[this._resultLen++]=E._rebaseCurr(this._prevDeltaOffset,y),this._currDeltaOffset+=y.newLength-y.oldLength}_getCurr(y){return y<this._currLen?this._currEdits[y]:null}_acceptPrev(y){this._result[this._resultLen++]=E._rebasePrev(this._currDeltaOffset,y),this._prevDeltaOffset+=y.newLength-y.oldLength}_getPrev(y){return y<this._prevLen?this._prevEdits[y]:null}static _rebaseCurr(y,R){return new P(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static _rebasePrev(y,R){return new P(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static _splitPrev(y,R){const D=y.newText.substr(0,R),v=y.newText.substr(R);return[new P(y.oldPosition,y.oldText,y.newPosition,D),new P(y.oldEnd,"",y.newPosition+R,v)]}static _splitCurr(y,R){const D=y.oldText.substr(0,R),v=y.oldText.substr(R);return[new P(y.oldPosition,D,y.newPosition,y.newText),new P(y.oldPosition+R,v,y.newEnd,"")]}static _merge(y){if(y.length===0)return y;const R=[];let D=0,v=y[0];for(let S=1;S<y.length;S++){const C=y[S];v.oldEnd===C.oldPosition?v=new P(v.oldPosition,v.oldText+C.oldText,v.newPosition,v.newText+C.newText):(R[D++]=v,v=C)}return R[D++]=v,R}static _removeNoOps(y){if(y.length===0)return y;const R=[];let D=0;for(let v=0;v<y.length;v++){const S=y[v];S.oldText!==S.newText&&(R[D++]=S)}return R}}}),define(ye[191],Ce([1,0,35,17]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function f(P,A,E,p,y,R){if(Array.isArray(P)){let D=0;for(const v of P){const S=f(v,A,E,p,y,R);if(S===10)return S;S>D&&(D=S)}return D}else{if(typeof P=="string")return p?P==="*"?5:P===E?10:0:0;if(P){const{language:D,pattern:v,scheme:S,hasAccessToAllModels:C,notebookType:c}=P;if(!p&&!C)return 0;c&&y&&(A=y);let m=0;if(S)if(S===A.scheme)m=10;else if(S==="*")m=5;else return 0;if(D)if(D===E)m=10;else if(D==="*")m=Math.max(m,5);else return 0;if(c)if(c===R)m=10;else if(c==="*"&&R!==void 0)m=Math.max(m,5);else return 0;if(v){let o;if(typeof v=="string"?o=v:o={...v,base:(0,F.normalize)(v.base)},o===A.fsPath||(0,I.match)(o,A.fsPath))m=10;else return 0}return m}else return 0}}e.score=f}),define(ye[192],Ce([1,0,4,12,29,79,127,167,190,3]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class R extends y.Disposable{constructor(v,S,C,c,m,o,i){super(),this._onDidChangeContent=this._register(new I.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=S,this._mightContainNonBasicASCII=!o,this._mightContainRTL=c,this._mightContainUnusualLineTerminators=m,this._pieceTree=new A.PieceTreeBase(v,C,i)}equals(v){return!(v instanceof R)||this._BOM!==v._BOM||this.getEOL()!==v.getEOL()?!1:this._pieceTree.equal(v._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(v){return this._pieceTree.createSnapshot(v?this._BOM:"")}getOffsetAt(v,S){return this._pieceTree.getOffsetAt(v,S)}getPositionAt(v){return this._pieceTree.getPositionAt(v)}getRangeAt(v,S){const C=v+S,c=this.getPositionAt(v),m=this.getPositionAt(C);return new f.Range(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(v,S=0){if(v.isEmpty())return"";const C=this._getEndOfLine(S);return this._pieceTree.getValueInRange(v,C)}getValueLengthInRange(v,S=0){if(v.isEmpty())return 0;if(v.startLineNumber===v.endLineNumber)return v.endColumn-v.startColumn;const C=this.getOffsetAt(v.startLineNumber,v.startColumn),c=this.getOffsetAt(v.endLineNumber,v.endColumn);let m=0;const o=this._getEndOfLine(S),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=v.endLineNumber-v.startLineNumber;m=r*n}return c-C+m}getCharacterCountInRange(v,S=0){if(this._mightContainNonBasicASCII){let C=0;const c=v.startLineNumber,m=v.endLineNumber;for(let o=c;o<=m;o++){const i=this.getLineContent(o),r=o===c?v.startColumn-1:0,n=o===m?v.endColumn-1:i.length;for(let a=r;a<n;a++)F.isHighSurrogate(i.charCodeAt(a))?(C=C+1,a=a+1):C=C+1}return C+=this._getEndOfLine(S).length*(m-c),C}return this.getValueLengthInRange(v,S)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(v){return this._pieceTree.getLineContent(v)}getLineCharCode(v,S){return this._pieceTree.getLineCharCode(v,S)}getCharCode(v){return this._pieceTree.getCharCode(v)}getLineLength(v){return this._pieceTree.getLineLength(v)}getLineMinColumn(v){return 1}getLineMaxColumn(v){return this.getLineLength(v)+1}getLineFirstNonWhitespaceColumn(v){const S=F.firstNonWhitespaceIndex(this.getLineContent(v));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(v){const S=F.lastNonWhitespaceIndex(this.getLineContent(v));return S===-1?0:S+2}_getEndOfLine(v){switch(v){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(v){this._pieceTree.setEOL(v)}applyEdits(v,S,C){let c=this._mightContainRTL,m=this._mightContainUnusualLineTerminators,o=this._mightContainNonBasicASCII,i=!0,r=[];for(let l=0;l<v.length;l++){const u=v[l];i&&u._isTracked&&(i=!1);const w=u.range;if(u.text){let T=!0;o||(T=!F.isBasicASCII(u.text),o=T),!c&&T&&(c=F.containsRTL(u.text)),!m&&T&&(m=F.containsUnusualLineTerminators(u.text))}let k="",b=0,g=0,_=0;if(u.text){let T;[b,g,_,T]=(0,E.countEOL)(u.text);const O=this.getEOL();T===0||T===(O===`\r
`?2:1)?k=u.text:k=u.text.replace(/\r\n|\r|\n/g,O)}r[l]={sortIndex:l,identifier:u.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:k,eolCount:b,firstLineLength:g,lastLineLength:_,forceMoveMarkers:!!u.forceMoveMarkers,isAutoWhitespaceEdit:u.isAutoWhitespaceEdit||!1}}r.sort(R._sortOpsAscending);let n=!1;for(let l=0,u=r.length-1;l<u;l++){const w=r[l].range.getEndPosition(),k=r[l+1].range.getStartPosition();if(k.isBeforeOrEqual(w)){if(k.isBefore(w))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this._reduceOperations(r));const a=C||S?R._getInverseEditRanges(r):[],t=[];if(S)for(let l=0;l<r.length;l++){const u=r[l],w=a[l];if(u.isAutoWhitespaceEdit&&u.range.isEmpty())for(let k=w.startLineNumber;k<=w.endLineNumber;k++){let b="";k===w.startLineNumber&&(b=this.getLineContent(u.range.startLineNumber),F.firstNonWhitespaceIndex(b)!==-1)||t.push({lineNumber:k,oldContent:b})}}let d=null;if(C){let l=0;d=[];for(let u=0;u<r.length;u++){const w=r[u],k=a[u],b=this.getValueInRange(w.range),g=w.rangeOffset+l;l+=w.text.length-b.length,d[u]={sortIndex:w.sortIndex,identifier:w.identifier,range:k,text:b,textChange:new p.TextChange(w.rangeOffset,b,g,w.text)}}n||d.sort((u,w)=>u.sortIndex-w.sortIndex)}this._mightContainRTL=c,this._mightContainUnusualLineTerminators=m,this._mightContainNonBasicASCII=o;const s=this._doApplyEdits(r);let h=null;if(S&&t.length>0){t.sort((l,u)=>u.lineNumber-l.lineNumber),h=[];for(let l=0,u=t.length;l<u;l++){const w=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===w)continue;const k=t[l].oldContent,b=this.getLineContent(w);b.length===0||b===k||F.firstNonWhitespaceIndex(b)!==-1||h.push(w)}}return this._onDidChangeContent.fire(),new P.ApplyEditsResult(d,s,h)}_reduceOperations(v){return v.length<1e3?v:[this._toSingleEditOperation(v)]}_toSingleEditOperation(v){let S=!1;const C=v[0].range,c=v[v.length-1].range,m=new f.Range(C.startLineNumber,C.startColumn,c.endLineNumber,c.endColumn);let o=C.startLineNumber,i=C.startColumn;const r=[];for(let s=0,h=v.length;s<h;s++){const l=v[s],u=l.range;S=S||l.forceMoveMarkers,r.push(this.getValueInRange(new f.Range(o,i,u.startLineNumber,u.startColumn))),l.text.length>0&&r.push(l.text),o=u.endLineNumber,i=u.endColumn}const n=r.join(""),[a,t,d]=(0,E.countEOL)(n);return{sortIndex:0,identifier:v[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:n,eolCount:a,firstLineLength:t,lastLineLength:d,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}_doApplyEdits(v){v.sort(R._sortOpsDescending);const S=[];for(let C=0;C<v.length;C++){const c=v[C],m=c.range.startLineNumber,o=c.range.startColumn,i=c.range.endLineNumber,r=c.range.endColumn;if(m===i&&o===r&&c.text.length===0)continue;c.text?(this._pieceTree.delete(c.rangeOffset,c.rangeLength),this._pieceTree.insert(c.rangeOffset,c.text,!0)):this._pieceTree.delete(c.rangeOffset,c.rangeLength);const n=new f.Range(m,o,i,r);S.push({range:n,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return S}findMatchesLineByLine(v,S,C,c){return this._pieceTree.findMatchesLineByLine(v,S,C,c)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(v,S){const C=v.startLineNumber,c=v.startColumn,[m,o,i]=(0,E.countEOL)(S);let r;if(S.length>0){const n=m+1;n===1?r=new f.Range(C,c,C,c+o):r=new f.Range(C,c,C+n-1,i+1)}else r=new f.Range(C,c,C,c);return r}static _getInverseEditRanges(v){const S=[];let C=0,c=0,m=null;for(let o=0,i=v.length;o<i;o++){const r=v[o];let n,a;m?m.range.endLineNumber===r.range.startLineNumber?(n=C,a=c+(r.range.startColumn-m.range.endColumn)):(n=C+(r.range.startLineNumber-m.range.endLineNumber),a=r.range.startColumn):(n=r.range.startLineNumber,a=r.range.startColumn);let t;if(r.text.length>0){const d=r.eolCount+1;d===1?t=new f.Range(n,a,n,a+r.firstLineLength):t=new f.Range(n,a,n+d-1,r.lastLineLength+1)}else t=new f.Range(n,a,n,a);C=t.endLineNumber,c=t.endColumn,S.push(t),m=r}return S}static _sortOpsAscending(v,S){const C=f.Range.compareRangesUsingEnds(v.range,S.range);return C===0?v.sortIndex-S.sortIndex:C}static _sortOpsDescending(v,S){const C=f.Range.compareRangesUsingEnds(v.range,S.range);return C===0?S.sortIndex-v.sortIndex:-C}}e.PieceTreeTextBuffer=R}),define(ye[193],Ce([1,0,12,127,192]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class P{constructor(p,y,R,D,v,S,C,c,m){this._chunks=p,this._bom=y,this._cr=R,this._lf=D,this._crlf=v,this._containsRTL=S,this._containsUnusualLineTerminators=C,this._isBasicASCII=c,this._normalizeEOL=m}_getEOL(p){const y=this._cr+this._lf+this._crlf,R=this._cr+this._crlf;return y===0?p===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create(p){const y=this._getEOL(p),R=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let v=0,S=R.length;v<S;v++){const C=R[v].buffer.replace(/\r\n|\r|\n/g,y),c=(0,F.createLineStartsFast)(C);R[v]=new F.StringBuffer(C,c)}const D=new f.PieceTreeTextBuffer(R,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:D,disposable:D}}getFirstLineText(p){return this._chunks[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(p){if(p.length===0)return;this.chunks.length===0&&I.startsWithUTF8BOM(p)&&(this.BOM=I.UTF8_BOM_CHARACTER,p=p.substr(1));const y=p.charCodeAt(p.length-1);y===13||y>=55296&&y<=56319?(this._acceptChunk1(p.substr(0,p.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(p,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(p,y){!y&&p.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+p):this._acceptChunk2(p))}_acceptChunk2(p){const y=(0,F.createLineStarts)(this._tmpLineStarts,p);this.chunks.push(new F.StringBuffer(p,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=I.containsRTL(p)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=I.containsUnusualLineTerminators(p)))}finish(p=!0){return this._finish(),new P(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,p)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const p=this.chunks[this.chunks.length-1];p.buffer+=String.fromCharCode(this._previousChar);const y=(0,F.createLineStartsFast)(p.buffer);p.lineStarts=y,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=A}),define(ye[131],Ce([1,0,22,10]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var f;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(f||(f={}));function P(D){for(let v=0,S=D.length;v<S;v+=4){const C=D[v+0],c=D[v+1],m=D[v+2],o=D[v+3];D[v+0]=o,D[v+1]=m,D[v+2]=c,D[v+3]=C}}function A(D){const v=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.isLittleEndian()||P(v),I.VSBuffer.wrap(v)}function E(D){const v=D.buffer;if(F.isLittleEndian()||P(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const S=new Uint8Array(v.byteLength);return S.set(v),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(D){const v=new Uint32Array(y(D));let S=0;if(v[S++]=D.id,D.type==="full")v[S++]=1,v[S++]=D.data.length,v.set(D.data,S),S+=D.data.length;else{v[S++]=2,v[S++]=D.deltas.length;for(const C of D.deltas)v[S++]=C.start,v[S++]=C.deleteCount,C.data?(v[S++]=C.data.length,v.set(C.data,S),S+=C.data.length):v[S++]=0}return A(v)}e.encodeSemanticTokensDto=p;function y(D){let v=0;if(v+=1+1,D.type==="full")v+=1+D.data.length;else{v+=1,v+=(1+1+1)*D.deltas.length;for(const S of D.deltas)S.data&&(v+=S.data.length)}return v}function R(D){const v=E(D);let S=0;const C=v[S++];if(v[S++]===1){const i=v[S++],r=v.subarray(S,S+i);return S+=i,{id:C,type:"full",data:r}}const m=v[S++],o=[];for(let i=0;i<m;i++){const r=v[S++],n=v[S++],a=v[S++];let t;a>0&&(t=v.subarray(S,S+a),S+=a),o[i]={start:r,deleteCount:n,data:t}}return{id:C,type:"delta",deltas:o}}e.decodeSemanticTokensDto=R}),define(ye[194],Ce([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ye[132],Ce([1,0,19,24,10,170,126,194]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var p;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class D{constructor(se,Ie,He,Qe){this.id=se,this.name=Ie,this.defaultValue=He,this.schema=Qe}applyUpdate(se,Ie){return S(se,Ie)}compute(se,Ie,He){return He}}class v{constructor(se,Ie){this.newValue=se,this.didChange=Ie}}e.ApplyUpdateResult=v;function S(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new v(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const He=Array.isArray(re)&&Array.isArray(se)&&I.equals(re,se);return new v(se,!He)}let Ie=!1;for(const He in se)if(se.hasOwnProperty(He)){const Qe=S(re[He],se[He]);Qe.didChange&&(re[He]=Qe.newValue,Ie=!0)}return new v(re,Ie)}class C{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ie){return S(se,Ie)}validate(se){return this.defaultValue}}class c{constructor(se,Ie,He,Qe){this.id=se,this.name=Ie,this.defaultValue=He,this.schema=Qe}applyUpdate(se,Ie){return S(se,Ie)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ie,He){return He}}function m(re,se){return typeof re>"u"?se:re==="false"?!1:!!re}e.boolean=m;class o extends c{constructor(se,Ie,He,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=He),super(se,Ie,He,Qe)}validate(se){return m(se,this.defaultValue)}}function i(re,se,Ie,He){if(typeof re>"u")return se;let Qe=parseInt(re,10);return isNaN(Qe)?se:(Qe=Math.max(Ie,Qe),Qe=Math.min(He,Qe),Qe|0)}e.clampedInt=i;class r extends c{static clampedInt(se,Ie,He,Qe){return i(se,Ie,He,Qe)}constructor(se,Ie,He,Qe,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=He,nt.minimum=Qe,nt.maximum=it),super(se,Ie,He,nt),this.minimum=Qe,this.maximum=it}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(re,se,Ie,He){if(typeof re>"u")return se;const Qe=a.float(re,se);return a.clamp(Qe,Ie,He)}e.clampedFloat=n;class a extends c{static clamp(se,Ie,He){return se<Ie?Ie:se>He?He:se}static float(se,Ie){if(typeof se=="number")return se;if(typeof se>"u")return Ie;const He=parseFloat(se);return isNaN(He)?Ie:He}constructor(se,Ie,He,Qe,it){typeof it<"u"&&(it.type="number",it.default=He),super(se,Ie,He,it),this.validationFn=Qe}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class t extends c{static string(se,Ie){return typeof se!="string"?Ie:se}constructor(se,Ie,He,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=He),super(se,Ie,He,Qe)}validate(se){return t.string(se,this.defaultValue)}}function d(re,se,Ie,He){return typeof re!="string"?se:He&&re in He?He[re]:Ie.indexOf(re)===-1?se:re}e.stringSet=d;class s extends c{constructor(se,Ie,He,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=He),super(se,Ie,He,it),this._allowedValues=Qe}validate(se){return d(se,this.defaultValue,this._allowedValues)}}class h extends D{constructor(se,Ie,He,Qe,it,nt,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=it,Me.default=Qe),super(se,Ie,He,Me),this._allowedValues=it,this._convert=nt}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function l(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",tags:["accessibility"],description:E.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ie,He){return He===0?se.accessibilitySupport:He}}class w extends D{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:E.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function b(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function _(re){switch(re){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function T(re){switch(re){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class O extends C{constructor(){super(140)}compute(se,Ie,He){const Qe=["monaco-editor"];return Ie.get(39)&&Qe.push(Ie.get(39)),se.extraEditorClassName&&Qe.push(se.extraEditorClassName),Ie.get(73)==="default"?Qe.push("mouse-default"):Ie.get(73)==="copy"&&Qe.push("mouse-copy"),Ie.get(110)&&Qe.push("showUnused"),Ie.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class x extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(se,Ie,He){return He&&se.emptySelectionClipboard}}class N extends D{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[E.localize(8,null),E.localize(9,null),E.localize(10,null)],description:E.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[E.localize(12,null),E.localize(13,null),E.localize(14,null)],description:E.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:E.localize(16,null),included:f.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:E.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:E.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":d(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":d(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class M extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:E.localize(19,null)},{type:"string",description:E.localize(20,null)}],description:E.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?M.OFF:se==="true"?M.ON:se:se?M.ON:M.OFF}}e.EditorFontLigatures=M;class L extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:E.localize(22,null)},{type:"string",description:E.localize(23,null)}],description:E.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?L.OFF:se==="true"?L.TRANSLATE:se:se?L.TRANSLATE:L.OFF}compute(se,Ie,He){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class U extends C{constructor(){super(50)}compute(se,Ie,He){return se.fontInfo}}class B extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(25,null)})}validate(se){const Ie=a.float(se,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(se,Ie,He){return se.fontInfo.fontSize}}class G extends D{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:E.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}class le extends D{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[E.localize(28,null),E.localize(29,null),E.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:E.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:E.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:E.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:E.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:E.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:He,description:E.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:He,description:E.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:He,description:E.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:He,description:E.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:He,description:E.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{multiple:d(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??d(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??d(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??d(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??d(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??d(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends D{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:E.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:E.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:E.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:E.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:E.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var K;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(K||(e.RenderMinimap=K={}));class Q extends C{constructor(){super(143)}compute(se,Ie,He){return Q.computeLayout(Ie,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ie=se.height/se.lineHeight,He=Math.floor(se.paddingTop/se.lineHeight);let Qe=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Qe=Math.max(Qe,Ie-1));const it=(He+se.viewLineCount+Qe)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:nt}}static _computeMinimapLayout(se,Ie){const He=se.outerWidth,Qe=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const nt=Ie.stableMinimapLayoutInput,Me=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,St=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Ft=se.scrollBeyondLastLine,Nt=se.minimap.renderCharacters;let _t=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Vt=se.minimap.maxColumn,Mt=se.minimap.size,Qt=se.minimap.side,$t=se.verticalScrollbarWidth,Bt=se.viewLineCount,et=se.remainingWidth,jt=se.isViewportWrapping,Gt=Nt?2:3;let dt=Math.floor(it*Qe);const pt=dt/it;let zt=!1,Kt=!1,yt=Gt*_t,ft=_t/it,kt=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:mt,extraLinesBeforeFirstLine:Ot,extraLinesBeyondLastLine:At,desiredRatio:Wt,minimapLineCount:Le}=Q.computeContainedMinimapLineCount({viewLineCount:Bt,scrollBeyondLastLine:Ft,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Qe,lineHeight:St,pixelRatio:it});if(Bt/Le>1)zt=!0,Kt=!0,_t=1,yt=1,ft=_t/it;else{let De=!1,ce=_t+1;if(Mt==="fit"){const Fe=Math.ceil((Ot+Bt+At)*yt);jt&&Me&&et<=Ie.stableFitRemainingWidth?(De=!0,ce=Ie.stableFitMaxMinimapScale):De=Fe>dt}if(Mt==="fill"||De){zt=!0;const Fe=_t;yt=Math.min(St*it,Math.max(1,Math.floor(1/Wt))),jt&&Me&&et<=Ie.stableFitRemainingWidth&&(ce=Ie.stableFitMaxMinimapScale),_t=Math.min(ce,Math.max(1,Math.floor(yt/Gt))),_t>Fe&&(kt=Math.min(2,_t/Fe)),ft=_t/it/kt,dt=Math.ceil(Math.max(mt,Ot+Bt+At)*yt),jt?(Ie.stableMinimapLayoutInput=se,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=_t):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Zt=Math.floor(Vt*ft),Tt=Math.min(Zt,Math.max(0,Math.floor((et-$t-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(it*Tt);const Lt=Ge/it;Ge=Math.floor(Ge*kt);const Ut=Nt?1:2,Xt=Qt==="left"?0:He-Tt-$t;return{renderMinimap:Ut,minimapLeft:Xt,minimapWidth:Tt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Kt,minimapScale:_t,minimapLineHeight:yt,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:pt}}static computeLayout(se,Ie){const He=Ie.outerWidth|0,Qe=Ie.outerHeight|0,it=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,Me=Ie.typicalHalfwidthCharacterWidth,St=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Ft=Ie.viewLineCount,Nt=se.get(135),_t=Nt==="inherit"?se.get(134):Nt,Vt=_t==="inherit"?se.get(130):_t,Mt=se.get(133),Qt=Ie.isDominatedByLongLines,$t=se.get(57),Bt=se.get(67).renderType!==0,et=se.get(68),jt=se.get(104),Gt=se.get(83),dt=se.get(72),pt=se.get(102),zt=pt.verticalScrollbarSize,Kt=pt.verticalHasArrows,yt=pt.arrowSize,ft=pt.horizontalScrollbarSize,kt=se.get(43),Zt=se.get(109)!=="never";let Tt=se.get(65);kt&&Zt&&(Tt+=16);let Ge=0;if(Bt){const Je=Math.max(nt,et);Ge=Math.round(Je*St)}let Lt=0;$t&&(Lt=it*Ie.glyphMarginDecorationLaneCount);let Ut=0,Xt=Ut+Lt,mt=Xt+Ge,Ot=mt+Tt;const At=He-Lt-Ge-Tt;let Wt=!1,Le=!1,Ne=-1;_t==="inherit"&&Qt?(Wt=!0,Le=!0):Vt==="on"||Vt==="bounded"?Le=!0:Vt==="wordWrapColumn"&&(Ne=Mt);const De=Q._computeMinimapLayout({outerWidth:He,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Me,pixelRatio:Dt,scrollBeyondLastLine:jt,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:dt,verticalScrollbarWidth:zt,viewLineCount:Ft,remainingWidth:At,isViewportWrapping:Le},Ie.memory||new R);De.renderMinimap!==0&&De.minimapLeft===0&&(Ut+=De.minimapWidth,Xt+=De.minimapWidth,mt+=De.minimapWidth,Ot+=De.minimapWidth);const ce=At-De.minimapWidth,Fe=Math.max(1,Math.floor((ce-zt-2)/Me)),ze=Kt?yt:0;return Le&&(Ne=Math.max(1,Fe),Vt==="bounded"&&(Ne=Math.min(Ne,Mt))),{width:He,height:Qe,glyphMarginLeft:Ut,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Xt,lineNumbersWidth:Ge,decorationsLeft:mt,decorationsWidth:Tt,contentLeft:Ot,contentWidth:ce,minimap:De,viewportColumn:Fe,isWordWrapMinified:Wt,isViewportWrapping:Le,wrappingColumn:Ne,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ft,overviewRuler:{top:ze,width:zt,height:Qe-2*ze,right:0}}}}e.EditorLayoutInfoComputer=Q;class ue extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[E.localize(47,null),E.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:E.localize(49,null)}})}validate(se){return d(se,"simple",["simple","advanced"])}compute(se,Ie,He){return Ie.get(2)===2?"advanced":He}}var ne;(function(re){re.Off="off",re.OnCode="onCode",re.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class pe extends D{constructor(){const se={enabled:ne.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:se.enabled,enumDescriptions:[E.localize(50,null),E.localize(51,null),E.localize(52,null)],description:E.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:d(se.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class oe extends D{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:E.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:E.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:E.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:E.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class q extends D{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:E.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[E.localize(59,null),E.localize(60,null,f.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),E.localize(61,null,f.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),E.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:E.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:E.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:E.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:d(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class W extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ie,He){return He<0?r.clampedInt(-He*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class ie extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:E.localize(66,null)})}compute(se,Ie,He){return se.fontInfo.lineHeight}}class Se extends D{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:E.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:E.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(69,null),E.localize(70,null),E.localize(71,null)],default:se.size,description:E.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:E.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:E.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:E.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:E.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:d(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Ie.side,this.defaultValue.side,["right","left"]),showSlider:d(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ie.scale,1,1,3),maxColumn:r.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(re){return re==="ctrlCmd"?f.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{top:r.clampedInt(Ie.top,0,0,1e3),bottom:r.clampedInt(Ie.bottom,0,0,1e3)}}}class Z extends D{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:E.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:E.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class ee extends C{constructor(){super(141)}compute(se,Ie,He){return se.pixelRatio}}class j extends D{constructor(){const se={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[E.localize(82,null),E.localize(83,null),E.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:se.strings,description:E.localize(85,null)},comments:{anyOf:Ie,default:se.comments,description:E.localize(86,null)},other:{anyOf:Ie,default:se.other,description:E.localize(87,null)}},default:se,markdownDescription:E.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ie,comments:He,strings:Qe}=se,it=["on","inline","off"];let nt,Me,St;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=d(Ie,this.defaultValue.other,it),typeof He=="boolean"?Me=He?"on":"off":Me=d(He,this.defaultValue.comments,it),typeof Qe=="boolean"?St=Qe?"on":"off":St=d(Qe,this.defaultValue.strings,it),{other:nt,comments:Me,strings:St}}}var J;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(J||(e.RenderLineNumbersType=J={}));class ge extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(89,null),E.localize(90,null),E.localize(91,null),E.localize(92,null)],default:"on",description:E.localize(93,null)})}validate(se){let Ie=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ie=4,He=se):se==="interval"?Ie=3:se==="relative"?Ie=2:se==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:He}}}function we(re){const se=re.get(97);return se==="editable"?re.get(90):se!=="on"}e.filterValidationDecorations=we;class Ae extends D{constructor(){const se=[],Ie={type:"number",description:E.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:E.localize(95,null),format:"color-hex"}}}]},default:se,description:E.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ie=[];for(const He of se)if(typeof He=="number")Ie.push({column:r.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Qe=He;Ie.push({column:r.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return Ie.sort((He,Qe)=>He.column-Qe.column),Ie}return this.defaultValue}}class Ee extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function ke(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends D{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[E.localize(97,null),E.localize(98,null),E.localize(99,null)],default:"auto",description:E.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[E.localize(101,null),E.localize(102,null),E.localize(103,null)],default:"auto",description:E.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:E.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:E.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:E.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:E.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se,He=r.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=r.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(Ie.vertical,this.defaultValue.vertical),horizontal:ke(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:r.clampedInt(Ie.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:r.clampedInt(Ie.verticalSliderSize,Qe,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends D{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:E.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:E.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:E.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:E.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:E.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:E.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:E.localize(115,null)}})}applyUpdate(se,Ie){let He=!1;Ie.allowedCharacters&&se&&(F.equals(se.allowedCharacters,Ie.allowedCharacters)||(se={...se,allowedCharacters:Ie.allowedCharacters},He=!0)),Ie.allowedLocales&&se&&(F.equals(se.allowedLocales,Ie.allowedLocales)||(se={...se,allowedLocales:Ie.allowedLocales},He=!0));const Qe=super.applyUpdate(se,Ie);return He?new v(Qe.newValue,!0):Qe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{nonBasicASCII:de(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ie){if(typeof se!="object"||!se)return Ie;const He={};for(const[Qe,it]of Object.entries(se))it===!0&&(He[Qe]=!0);return He}}class te extends D{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:E.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[E.localize(117,null),E.localize(118,null),E.localize(119,null)],description:E.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:E.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:E.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:d(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class H extends D{constructor(){const se={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:E.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:E.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends D{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[E.localize(125,null),E.localize(126,null),E.localize(127,null)],default:se.bracketPairs,description:E.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[E.localize(129,null),E.localize(130,null),E.localize(131,null)],default:se.bracketPairsHorizontal,description:E.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:E.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:E.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[E.localize(135,null),E.localize(136,null),E.localize(137,null)],default:se.highlightActiveIndentation,description:E.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{bracketPairs:de(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(re,se,Ie){const He=Ie.indexOf(re);return He===-1?se:Ie[He]}class Re extends D{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(139,null),E.localize(140,null)],default:se.insertMode,description:E.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:E.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:E.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:E.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[E.localize(145,null),E.localize(146,null),E.localize(147,null),E.localize(148,null)],default:se.selectionMode,markdownDescription:E.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:E.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:E.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:E.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:E.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:E.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:E.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:E.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertMode:d(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:d(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class Ue extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:E.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ke extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[E.localize(189,null),E.localize(190,null),E.localize(191,null),E.localize(192,null)],description:E.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ie,He){return Ie.get(2)===2?0:He}}class Ze extends C{constructor(){super(144)}compute(se,Ie,He){const Qe=Ie.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class at extends D{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:E.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:E.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[E.localize(196,null),E.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:d(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends D{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:E.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:E.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[E.localize(200,null),E.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:d(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.isMacintosh?Pe:f.isLinux?xe:rt,fontWeight:"normal",fontSize:f.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(re){return e.editorOptionsRegistry[re.id]=re,re}var Xe;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.ariaRequired=5]="ariaRequired",re[re.autoClosingBrackets=6]="autoClosingBrackets",re[re.autoClosingComments=7]="autoClosingComments",re[re.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",re[re.autoClosingDelete=9]="autoClosingDelete",re[re.autoClosingOvertype=10]="autoClosingOvertype",re[re.autoClosingQuotes=11]="autoClosingQuotes",re[re.autoIndent=12]="autoIndent",re[re.automaticLayout=13]="automaticLayout",re[re.autoSurround=14]="autoSurround",re[re.bracketPairColorization=15]="bracketPairColorization",re[re.guides=16]="guides",re[re.codeLens=17]="codeLens",re[re.codeLensFontFamily=18]="codeLensFontFamily",re[re.codeLensFontSize=19]="codeLensFontSize",re[re.colorDecorators=20]="colorDecorators",re[re.colorDecoratorsLimit=21]="colorDecoratorsLimit",re[re.columnSelection=22]="columnSelection",re[re.comments=23]="comments",re[re.contextmenu=24]="contextmenu",re[re.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",re[re.cursorBlinking=26]="cursorBlinking",re[re.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",re[re.cursorStyle=28]="cursorStyle",re[re.cursorSurroundingLines=29]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",re[re.cursorWidth=31]="cursorWidth",re[re.disableLayerHinting=32]="disableLayerHinting",re[re.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",re[re.domReadOnly=34]="domReadOnly",re[re.dragAndDrop=35]="dragAndDrop",re[re.dropIntoEditor=36]="dropIntoEditor",re[re.emptySelectionClipboard=37]="emptySelectionClipboard",re[re.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",re[re.extraEditorClassName=39]="extraEditorClassName",re[re.fastScrollSensitivity=40]="fastScrollSensitivity",re[re.find=41]="find",re[re.fixedOverflowWidgets=42]="fixedOverflowWidgets",re[re.folding=43]="folding",re[re.foldingStrategy=44]="foldingStrategy",re[re.foldingHighlight=45]="foldingHighlight",re[re.foldingImportsByDefault=46]="foldingImportsByDefault",re[re.foldingMaximumRegions=47]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=49]="fontFamily",re[re.fontInfo=50]="fontInfo",re[re.fontLigatures=51]="fontLigatures",re[re.fontSize=52]="fontSize",re[re.fontWeight=53]="fontWeight",re[re.fontVariations=54]="fontVariations",re[re.formatOnPaste=55]="formatOnPaste",re[re.formatOnType=56]="formatOnType",re[re.glyphMargin=57]="glyphMargin",re[re.gotoLocation=58]="gotoLocation",re[re.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",re[re.hover=60]="hover",re[re.inDiffEditor=61]="inDiffEditor",re[re.inlineSuggest=62]="inlineSuggest",re[re.letterSpacing=63]="letterSpacing",re[re.lightbulb=64]="lightbulb",re[re.lineDecorationsWidth=65]="lineDecorationsWidth",re[re.lineHeight=66]="lineHeight",re[re.lineNumbers=67]="lineNumbers",re[re.lineNumbersMinChars=68]="lineNumbersMinChars",re[re.linkedEditing=69]="linkedEditing",re[re.links=70]="links",re[re.matchBrackets=71]="matchBrackets",re[re.minimap=72]="minimap",re[re.mouseStyle=73]="mouseStyle",re[re.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=75]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",re[re.multiCursorModifier=77]="multiCursorModifier",re[re.multiCursorPaste=78]="multiCursorPaste",re[re.multiCursorLimit=79]="multiCursorLimit",re[re.occurrencesHighlight=80]="occurrencesHighlight",re[re.overviewRulerBorder=81]="overviewRulerBorder",re[re.overviewRulerLanes=82]="overviewRulerLanes",re[re.padding=83]="padding",re[re.pasteAs=84]="pasteAs",re[re.parameterHints=85]="parameterHints",re[re.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",re[re.quickSuggestions=88]="quickSuggestions",re[re.quickSuggestionsDelay=89]="quickSuggestionsDelay",re[re.readOnly=90]="readOnly",re[re.readOnlyMessage=91]="readOnlyMessage",re[re.renameOnType=92]="renameOnType",re[re.renderControlCharacters=93]="renderControlCharacters",re[re.renderFinalNewline=94]="renderFinalNewline",re[re.renderLineHighlight=95]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=97]="renderValidationDecorations",re[re.renderWhitespace=98]="renderWhitespace",re[re.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",re[re.roundedSelection=100]="roundedSelection",re[re.rulers=101]="rulers",re[re.scrollbar=102]="scrollbar",re[re.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=104]="scrollBeyondLastLine",re[re.scrollPredominantAxis=105]="scrollPredominantAxis",re[re.selectionClipboard=106]="selectionClipboard",re[re.selectionHighlight=107]="selectionHighlight",re[re.selectOnLineNumbers=108]="selectOnLineNumbers",re[re.showFoldingControls=109]="showFoldingControls",re[re.showUnused=110]="showUnused",re[re.snippetSuggestions=111]="snippetSuggestions",re[re.smartSelect=112]="smartSelect",re[re.smoothScrolling=113]="smoothScrolling",re[re.stickyScroll=114]="stickyScroll",re[re.stickyTabStops=115]="stickyTabStops",re[re.stopRenderingLineAfter=116]="stopRenderingLineAfter",re[re.suggest=117]="suggest",re[re.suggestFontSize=118]="suggestFontSize",re[re.suggestLineHeight=119]="suggestLineHeight",re[re.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",re[re.suggestSelection=121]="suggestSelection",re[re.tabCompletion=122]="tabCompletion",re[re.tabIndex=123]="tabIndex",re[re.unicodeHighlighting=124]="unicodeHighlighting",re[re.unusualLineTerminators=125]="unusualLineTerminators",re[re.useShadowDOM=126]="useShadowDOM",re[re.useTabStops=127]="useTabStops",re[re.wordBreak=128]="wordBreak",re[re.wordSeparators=129]="wordSeparators",re[re.wordWrap=130]="wordWrap",re[re.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=133]="wordWrapColumn",re[re.wordWrapOverride1=134]="wordWrapOverride1",re[re.wordWrapOverride2=135]="wordWrapOverride2",re[re.wrappingIndent=136]="wrappingIndent",re[re.wrappingStrategy=137]="wrappingStrategy",re[re.showDeprecated=138]="showDeprecated",re[re.inlayHints=139]="inlayHints",re[re.editorClassName=140]="editorClassName",re[re.pixelRatio=141]="pixelRatio",re[re.tabFocusMode=142]="tabFocusMode",re[re.layoutInfo=143]="layoutInfo",re[re.wrappingInfo=144]="wrappingInfo",re[re.defaultColorDecorators=145]="defaultColorDecorators",re[re.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",re[re.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(202,null)})),acceptSuggestionOnEnter:Te(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(203,null),""],markdownDescription:E.localize(204,null)})),accessibilitySupport:Te(new u),accessibilityPageSize:Te(new r(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(205,null),tags:["accessibility"]})),ariaLabel:Te(new t(4,"ariaLabel",E.localize(206,null))),ariaRequired:Te(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Te(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:E.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Te(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(208,null),E.localize(209,null),""],description:E.localize(210,null)})),autoClosingComments:Te(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(211,null),E.localize(212,null),""],description:E.localize(213,null)})),autoClosingDelete:Te(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(214,null),""],description:E.localize(215,null)})),autoClosingOvertype:Te(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(216,null),""],description:E.localize(217,null)})),autoClosingQuotes:Te(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(218,null),E.localize(219,null),""],description:E.localize(220,null)})),autoIndent:Te(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null),E.localize(224,null),E.localize(225,null)],description:E.localize(226,null)})),automaticLayout:Te(new o(13,"automaticLayout",!1)),autoSurround:Te(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(227,null),E.localize(228,null),E.localize(229,null),""],description:E.localize(230,null)})),bracketPairColorization:Te(new H),bracketPairGuides:Te(new ae),stickyTabStops:Te(new o(115,"stickyTabStops",!1,{description:E.localize(231,null)})),codeLens:Te(new o(17,"codeLens",!0,{description:E.localize(232,null)})),codeLensFontFamily:Te(new t(18,"codeLensFontFamily","",{description:E.localize(233,null)})),codeLensFontSize:Te(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:E.localize(234,null)})),colorDecorators:Te(new o(20,"colorDecorators",!0,{description:E.localize(235,null)})),colorDecoratorActivatedOn:Te(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[E.localize(236,null),E.localize(237,null),E.localize(238,null)],description:E.localize(239,null)})),colorDecoratorsLimit:Te(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:E.localize(240,null)})),columnSelection:Te(new o(22,"columnSelection",!1,{description:E.localize(241,null)})),comments:Te(new w),contextmenu:Te(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(25,"copyWithSyntaxHighlighting",!0,{description:E.localize(242,null)})),cursorBlinking:Te(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:E.localize(243,null)})),cursorSmoothCaretAnimation:Te(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[E.localize(244,null),E.localize(245,null),E.localize(246,null)],description:E.localize(247,null)})),cursorStyle:Te(new h(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:E.localize(248,null)})),cursorSurroundingLines:Te(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(249,null)})),cursorSurroundingLinesStyle:Te(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(250,null),E.localize(251,null)],markdownDescription:E.localize(252,null)})),cursorWidth:Te(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(253,null)})),disableLayerHinting:Te(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(34,"domReadOnly",!1)),dragAndDrop:Te(new o(35,"dragAndDrop",!0,{description:E.localize(254,null)})),emptySelectionClipboard:Te(new x),dropIntoEditor:Te(new at),stickyScroll:Te(new oe),experimentalWhitespaceRendering:Te(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[E.localize(255,null),E.localize(256,null),E.localize(257,null)],description:E.localize(258,null)})),extraEditorClassName:Te(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Te(new a(40,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:E.localize(259,null)})),find:Te(new N),fixedOverflowWidgets:Te(new o(42,"fixedOverflowWidgets",!1)),folding:Te(new o(43,"folding",!0,{description:E.localize(260,null)})),foldingStrategy:Te(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(261,null),E.localize(262,null)],description:E.localize(263,null)})),foldingHighlight:Te(new o(45,"foldingHighlight",!0,{description:E.localize(264,null)})),foldingImportsByDefault:Te(new o(46,"foldingImportsByDefault",!1,{description:E.localize(265,null)})),foldingMaximumRegions:Te(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:E.localize(266,null)})),unfoldOnClickAfterEndOfLine:Te(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(267,null)})),fontFamily:Te(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(268,null)})),fontInfo:Te(new U),fontLigatures2:Te(new M),fontSize:Te(new B),fontWeight:Te(new G),fontVariations:Te(new L),formatOnPaste:Te(new o(55,"formatOnPaste",!1,{description:E.localize(269,null)})),formatOnType:Te(new o(56,"formatOnType",!1,{description:E.localize(270,null)})),glyphMargin:Te(new o(57,"glyphMargin",!0,{description:E.localize(271,null)})),gotoLocation:Te(new le),hideCursorInOverviewRuler:Te(new o(59,"hideCursorInOverviewRuler",!1,{description:E.localize(272,null)})),hover:Te(new Y),inDiffEditor:Te(new o(61,"inDiffEditor",!1)),letterSpacing:Te(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>a.clamp(re,-5,20),{description:E.localize(273,null)})),lightbulb:Te(new pe),lineDecorationsWidth:Te(new W),lineHeight:Te(new ie),lineNumbers:Te(new ge),lineNumbersMinChars:Te(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(69,"linkedEditing",!1,{description:E.localize(274,null)})),links:Te(new o(70,"links",!0,{description:E.localize(275,null)})),matchBrackets:Te(new s(71,"matchBrackets","always",["always","near","never"],{description:E.localize(276,null)})),minimap:Te(new Se),mouseStyle:Te(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new a(74,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:E.localize(277,null)})),mouseWheelZoom:Te(new o(75,"mouseWheelZoom",!1,{markdownDescription:f.isMacintosh?E.localize(278,null):E.localize(279,null)})),multiCursorMergeOverlapping:Te(new o(76,"multiCursorMergeOverlapping",!0,{description:E.localize(280,null)})),multiCursorModifier:Te(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[E.localize(281,null),E.localize(282,null)],markdownDescription:E.localize(283,null)})),multiCursorPaste:Te(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(284,null),E.localize(285,null)],markdownDescription:E.localize(286,null)})),multiCursorLimit:Te(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:E.localize(287,null)})),occurrencesHighlight:Te(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[E.localize(288,null),E.localize(289,null),E.localize(290,null)],markdownDescription:E.localize(291,null)})),overviewRulerBorder:Te(new o(81,"overviewRulerBorder",!0,{description:E.localize(292,null)})),overviewRulerLanes:Te(new r(82,"overviewRulerLanes",3,0,3)),padding:Te(new fe),pasteAs:Te(new st),parameterHints:Te(new Z),peekWidgetDefaultFocus:Te(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(293,null),E.localize(294,null)],description:E.localize(295,null)})),definitionLinkOpensInPeek:Te(new o(87,"definitionLinkOpensInPeek",!1,{description:E.localize(296,null)})),quickSuggestions:Te(new j),quickSuggestionsDelay:Te(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(297,null)})),readOnly:Te(new o(90,"readOnly",!1)),readOnlyMessage:Te(new Ee),renameOnType:Te(new o(92,"renameOnType",!1,{description:E.localize(298,null),markdownDeprecationMessage:E.localize(299,null)})),renderControlCharacters:Te(new o(93,"renderControlCharacters",!0,{description:E.localize(300,null),restricted:!0})),renderFinalNewline:Te(new s(94,"renderFinalNewline",f.isLinux?"dimmed":"on",["off","on","dimmed"],{description:E.localize(301,null)})),renderLineHighlight:Te(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(302,null)],description:E.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(304,null)})),renderValidationDecorations:Te(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(305,null),E.localize(306,null),E.localize(307,null),""],description:E.localize(308,null)})),revealHorizontalRightPadding:Te(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new o(100,"roundedSelection",!0,{description:E.localize(309,null)})),rulers:Te(new Ae),scrollbar:Te(new z),scrollBeyondLastColumn:Te(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:E.localize(310,null)})),scrollBeyondLastLine:Te(new o(104,"scrollBeyondLastLine",!0,{description:E.localize(311,null)})),scrollPredominantAxis:Te(new o(105,"scrollPredominantAxis",!0,{description:E.localize(312,null)})),selectionClipboard:Te(new o(106,"selectionClipboard",!0,{description:E.localize(313,null),included:f.isLinux})),selectionHighlight:Te(new o(107,"selectionHighlight",!0,{description:E.localize(314,null)})),selectOnLineNumbers:Te(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Te(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[E.localize(315,null),E.localize(316,null),E.localize(317,null)],description:E.localize(318,null)})),showUnused:Te(new o(110,"showUnused",!0,{description:E.localize(319,null)})),showDeprecated:Te(new o(138,"showDeprecated",!0,{description:E.localize(320,null)})),inlayHints:Te(new q),snippetSuggestions:Te(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(321,null),E.localize(322,null),E.localize(323,null),E.localize(324,null)],description:E.localize(325,null)})),smartSelect:Te(new Ue),smoothScrolling:Te(new o(113,"smoothScrolling",!1,{description:E.localize(326,null)})),stopRenderingLineAfter:Te(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new Re),inlineSuggest:Te(new te),inlineCompletionsAccessibilityVerbose:Te(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:E.localize(327,null)})),suggestFontSize:Te(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(120,"suggestOnTriggerCharacters",!0,{description:E.localize(330,null)})),suggestSelection:Te(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(331,null),E.localize(332,null),E.localize(333,null)],description:E.localize(334,null)})),tabCompletion:Te(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(335,null),E.localize(336,null),E.localize(337,null)],description:E.localize(338,null)})),tabIndex:Te(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new X),unusualLineTerminators:Te(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(339,null),E.localize(340,null),E.localize(341,null)],description:E.localize(342,null)})),useShadowDOM:Te(new o(126,"useShadowDOM",!0)),useTabStops:Te(new o(127,"useTabStops",!0,{description:E.localize(343,null)})),wordBreak:Te(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[E.localize(344,null),E.localize(345,null)],description:E.localize(346,null)})),wordSeparators:Te(new t(129,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:E.localize(347,null)})),wordWrap:Te(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(348,null),E.localize(349,null),E.localize(350,null),E.localize(351,null)],description:E.localize(352,null)})),wordWrapBreakAfterCharacters:Te(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(353,null)})),wordWrapOverride1:Te(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Te(new O),defaultColorDecorators:Te(new o(145,"defaultColorDecorators",!1,{markdownDescription:E.localize(354,null)})),pixelRatio:Te(new ee),tabFocusMode:Te(new o(142,"tabFocusMode",!1,{markdownDescription:E.localize(355,null)})),layoutInfo:Te(new Q),wrappingInfo:Te(new Ze),wrappingIndent:Te(new Ke),wrappingStrategy:Te(new ue)}}),define(ye[195],Ce([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ye[83],Ce([1,0,78,2,168,29,178,195]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class p{constructor(M,L,U){this.offset=M,this.type=L,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class y{constructor(M,L){this.tokens=M,this.endState=L,this._tokenizationResultBrand=void 0}}e.TokenizationResult=y;class R{constructor(M,L){this.tokens=M,this.endState=L,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=R;var D;(function(N){N[N.Method=0]="Method",N[N.Function=1]="Function",N[N.Constructor=2]="Constructor",N[N.Field=3]="Field",N[N.Variable=4]="Variable",N[N.Class=5]="Class",N[N.Struct=6]="Struct",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Event=10]="Event",N[N.Operator=11]="Operator",N[N.Unit=12]="Unit",N[N.Value=13]="Value",N[N.Constant=14]="Constant",N[N.Enum=15]="Enum",N[N.EnumMember=16]="EnumMember",N[N.Keyword=17]="Keyword",N[N.Text=18]="Text",N[N.Color=19]="Color",N[N.File=20]="File",N[N.Reference=21]="Reference",N[N.Customcolor=22]="Customcolor",N[N.Folder=23]="Folder",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue",N[N.Snippet=27]="Snippet"})(D||(e.CompletionItemKind=D={}));var v;(function(N){const M=new Map;M.set(0,I.Codicon.symbolMethod),M.set(1,I.Codicon.symbolFunction),M.set(2,I.Codicon.symbolConstructor),M.set(3,I.Codicon.symbolField),M.set(4,I.Codicon.symbolVariable),M.set(5,I.Codicon.symbolClass),M.set(6,I.Codicon.symbolStruct),M.set(7,I.Codicon.symbolInterface),M.set(8,I.Codicon.symbolModule),M.set(9,I.Codicon.symbolProperty),M.set(10,I.Codicon.symbolEvent),M.set(11,I.Codicon.symbolOperator),M.set(12,I.Codicon.symbolUnit),M.set(13,I.Codicon.symbolValue),M.set(15,I.Codicon.symbolEnum),M.set(14,I.Codicon.symbolConstant),M.set(15,I.Codicon.symbolEnum),M.set(16,I.Codicon.symbolEnumMember),M.set(17,I.Codicon.symbolKeyword),M.set(27,I.Codicon.symbolSnippet),M.set(18,I.Codicon.symbolText),M.set(19,I.Codicon.symbolColor),M.set(20,I.Codicon.symbolFile),M.set(21,I.Codicon.symbolReference),M.set(22,I.Codicon.symbolCustomColor),M.set(23,I.Codicon.symbolFolder),M.set(24,I.Codicon.symbolTypeParameter),M.set(25,I.Codicon.account),M.set(26,I.Codicon.issues);function L(G){let le=M.get(G);return le||(console.info("No codicon found for CompletionItemKind "+G),le=I.Codicon.symbolProperty),le}N.toIcon=L;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function B(G,le){let Y=U.get(G);return typeof Y>"u"&&!le&&(Y=9),Y}N.fromString=B})(v||(e.CompletionItemKinds=v={}));var S;(function(N){N[N.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var C;(function(N){N[N.None=0]="None",N[N.KeepWhitespace=1]="KeepWhitespace",N[N.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var c;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var m;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class o{constructor(M,L,U,B){this.range=M,this.text=L,this.completionKind=U,this.isSnippetText=B}equals(M){return P.Range.lift(this.range).equalsRange(M.range)&&this.text===M.text&&this.completionKind===M.completionKind&&this.isSnippetText===M.isSnippetText}}e.SelectedSuggestionInfo=o;var i;(function(N){N[N.Invoke=1]="Invoke",N[N.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function a(N){return N&&F.URI.isUri(N.uri)&&P.Range.isIRange(N.range)&&(P.Range.isIRange(N.originSelectionRange)||P.Range.isIRange(N.targetSelectionRange))}e.isLocationLink=a;var t;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,E.localize)(0,null),[16]:(0,E.localize)(1,null),[4]:(0,E.localize)(2,null),[13]:(0,E.localize)(3,null),[8]:(0,E.localize)(4,null),[9]:(0,E.localize)(5,null),[21]:(0,E.localize)(6,null),[23]:(0,E.localize)(7,null),[7]:(0,E.localize)(8,null),[0]:(0,E.localize)(9,null),[11]:(0,E.localize)(10,null),[10]:(0,E.localize)(11,null),[19]:(0,E.localize)(12,null),[5]:(0,E.localize)(13,null),[1]:(0,E.localize)(14,null),[2]:(0,E.localize)(15,null),[20]:(0,E.localize)(16,null),[15]:(0,E.localize)(17,null),[18]:(0,E.localize)(18,null),[24]:(0,E.localize)(19,null),[3]:(0,E.localize)(20,null),[6]:(0,E.localize)(21,null),[14]:(0,E.localize)(22,null),[22]:(0,E.localize)(23,null),[25]:(0,E.localize)(24,null),[12]:(0,E.localize)(25,null)};function d(N,M){return(0,E.localize)(26,null,N,e.symbolKindNames[M])}e.getAriaLabelForSymbol=d;var s;(function(N){N[N.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var h;(function(N){const M=new Map;M.set(0,I.Codicon.symbolFile),M.set(1,I.Codicon.symbolModule),M.set(2,I.Codicon.symbolNamespace),M.set(3,I.Codicon.symbolPackage),M.set(4,I.Codicon.symbolClass),M.set(5,I.Codicon.symbolMethod),M.set(6,I.Codicon.symbolProperty),M.set(7,I.Codicon.symbolField),M.set(8,I.Codicon.symbolConstructor),M.set(9,I.Codicon.symbolEnum),M.set(10,I.Codicon.symbolInterface),M.set(11,I.Codicon.symbolFunction),M.set(12,I.Codicon.symbolVariable),M.set(13,I.Codicon.symbolConstant),M.set(14,I.Codicon.symbolString),M.set(15,I.Codicon.symbolNumber),M.set(16,I.Codicon.symbolBoolean),M.set(17,I.Codicon.symbolArray),M.set(18,I.Codicon.symbolObject),M.set(19,I.Codicon.symbolKey),M.set(20,I.Codicon.symbolNull),M.set(21,I.Codicon.symbolEnumMember),M.set(22,I.Codicon.symbolStruct),M.set(23,I.Codicon.symbolEvent),M.set(24,I.Codicon.symbolOperator),M.set(25,I.Codicon.symbolTypeParameter);function L(U){let B=M.get(U);return B||(console.info("No codicon found for SymbolKind "+U),B=I.Codicon.symbolProperty),B}N.toIcon=L})(h||(e.SymbolKinds=h={}));class l{static asEditOperation(M){return f.EditOperation.replace(P.Range.lift(M.range),M.text)}}e.TextEdit=l;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(M){switch(M){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(M)}constructor(M){this.value=M}}e.FoldingRangeKind=u;var w;(function(N){function M(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}N.is=M})(w||(e.Command=w={}));var k;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var b;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var g;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var _;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(_||(e.CommentState=_={}));var T;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class O{constructor(M){this.createSupport=M,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(M=>{M&&M.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=O,e.TokenizationRegistry=new A.TokenizationRegistry;var x;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(x||(e.ExternalUriOpenerPriority=x={}))}),define(ye[196],Ce([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[197],Ce([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[198],Ce([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ye[199],Ce([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[200],Ce([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[201],Ce([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[202],Ce([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[203],Ce([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ye[204],Ce([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ye[205],Ce([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[206],Ce([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ye[207],Ce([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[208],Ce([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[209],Ce([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ye[210],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ye[211],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[212],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[213],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[214],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[215],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[216],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[217],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[218],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[219],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[220],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[221],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[222],Ce([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[223],Ce([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ye[224],Ce([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ye[225],Ce([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ye[226],Ce([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[227],Ce([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[228],Ce([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[229],Ce([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[230],Ce([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[231],Ce([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[232],Ce([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[233],Ce([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[234],Ce([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[235],Ce([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[236],Ce([1,0,14,198]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var f;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(f||(e.TokenType=f={}));function P(...y){switch(y.length){case 1:return(0,F.localize)(0,null,y[0]);case 2:return(0,F.localize)(1,null,y[0],y[1]);case 3:return(0,F.localize)(2,null,y[0],y[1],y[2]);default:return}}const A=(0,F.localize)(3,null),E=(0,F.localize)(4,null);class p{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const D=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:D})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const D=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:D})}else this._match(126)?this._addToken(9):this._error(P("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(P("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const D=this._start,v=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:v};this._errors.push({offset:D,lexeme:v,additionalInfo:R}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const D=this._input.substring(this._start,this._current),v=p._keywords.get(D);v?this._addToken(v):this._tokens.push({type:17,lexeme:D,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,D=!1,v=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(E);return}const C=this._input.charCodeAt(R);if(D)D=!1;else if(C===47&&!v){R++;break}else C===91?v=!0:C===92?D=!0:C===93&&(v=!1);R++}for(;R<this._input.length&&p._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=p}),define(ye[237],Ce([1,0,23,39,201,387]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||A.test(o)}e.isValidVersionStr=p;function y(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.parseVersion=y;function R(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let d=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),d=!1);let s=0;if(o.preRelease){const h=E.exec(o.preRelease);if(h){const[,l,u,w]=h;s=Date.UTC(Number(l),Number(u)-1,Number(w))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:a,patchBase:t,patchMustEqual:d,isMinimum:o.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function D(o,i,r){let n;typeof o=="string"?n=R(y(o)):n=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof r=="string"?t=R(y(r)):t=r,!n||!t)return!1;const d=n.majorBase,s=n.minorBase,h=n.patchBase;let l=t.majorBase,u=t.minorBase,w=t.patchBase;const k=t.notBefore;let b=t.majorMustEqual,g=t.minorMustEqual,_=t.patchMustEqual;return t.isMinimum?d>l?!0:d<l?!1:s>u?!0:s<u||a&&a<k?!1:h>=w:(d===1&&l===0&&(!b||!g||!_)&&(l=1,u=0,w=0,b=!0,g=!1,_=!1),d<l?!1:d>l?!b:s<u?!1:s>u?!g:h<w?!1:h>w?!_:!(a&&a<k))}e.isValidVersion=D;function v(o,i,r,n,a){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof n.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!n.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!m(n.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!m(n.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const h=(0,I.joinPath)(r,n.main);(0,I.isEqualOrParent)(h,r)||t.push([F.default.Warning,f.localize(10,null,h.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const h=(0,I.joinPath)(r,n.browser);(0,I.isEqualOrParent)(h,r)||t.push([F.default.Warning,f.localize(12,null,h.path,r.path)])}}if(!P.valid(n.version))return t.push([F.default.Error,f.localize(13,null)]),t;const d=[];if(!S(o,i,n,a,d))for(const h of d)t.push([F.default.Error,h]);return t}e.validateExtensionManifest=v;function S(o,i,r,n,a){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:c(o,i,r.engines.vscode,a)}e.isValidExtensionVersion=S;function C(o,i,r){return o==="*"||c(i,r,o)}e.isEngineValid=C;function c(o,i,r,n=[]){const a=R(y(r));if(!a)return n.push(f.localize(14,null,r)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return n.push(f.localize(15,null,r)),!1}else if(!a.majorMustEqual)return n.push(f.localize(16,null,r)),!1;return D(o,i,a)?!0:(n.push(f.localize(17,null,o,r)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ye[106],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(f,P=[],A=!1){this.ctor=f,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(ye[84],Ce([1,0,106]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const F=[];var f;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function P(E,p,y){p instanceof I.SyncDescriptor||(p=new I.SyncDescriptor(p,[],!!y)),F.push([E,p])}e.registerSingleton=P;function A(){return F}e.getSingletonServiceDescriptors=A}),define(ye[238],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class F{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const A of this._nodes.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const E=this.lookupOrInsertNode(P),p=this.lookupOrInsertNode(A);E.outgoing.set(p.key,p),p.incoming.set(E.key,E)}removeNode(P){const A=this._hashFn(P);this._nodes.delete(A);for(const E of this._nodes.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(P){const A=this._hashFn(P);let E=this._nodes.get(A);return E||(E=new I(A,P),this._nodes.set(A,E)),E}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[A,E]of this._nodes)P.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this._nodes){const E=new Set([P]),p=this._findCycle(A,E);if(p)return p}}_findCycle(P,A){for(const[E,p]of P.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const y=this._findCycle(p,A);if(y)return y;A.delete(E)}}}e.Graph=F}),define(ye[5],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function E(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=E})(I||(e._util=I={})),e.IInstantiationService=f("instantiationService");function F(A,E,p){E[I.DI_TARGET]===E?E[I.DI_DEPENDENCIES].push({id:A,index:p}):(E[I.DI_DEPENDENCIES]=[{id:A,index:p}],E[I.DI_TARGET]=E)}function f(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const E=function(p,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(E,p,R)};return E.toString=()=>A,I.serviceIds.set(A,E),E}e.createDecorator=f;function P(A){return A}e.refineServiceDecorator=P}),define(ye[51],Ce([1,0,18,2,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,f.createDecorator)("configurationService");function P(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationOverrides=P;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=A;var E;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.isConfigured=y;function R(o,i){const r=Object.create(null);for(const n in o)D(r,n,o[n],i);return r}e.toValuesTree=R;function D(o,i,r,n){const a=i.split("."),t=a.pop();let d=o;for(let s=0;s<a.length;s++){const h=a[s];let l=d[h];switch(typeof l){case"undefined":l=d[h]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}d=l}if(typeof d=="object"&&d!==null)try{d[t]=r}catch{n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}else n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=D;function v(o,i){const r=i.split(".");S(o,r)}e.removeFromValueTree=v;function S(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(S(n,i),Object.keys(n).length===0&&delete o[r])}}function C(o,i,r){function n(d,s){let h=d;for(const l of s){if(typeof h!="object"||h===null)return;h=h[l]}return h}const a=i.split("."),t=n(o,a);return typeof t>"u"?r:t}e.getConfigurationValue=C;function c(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?I.isObject(o[n])&&I.isObject(i[n])?c(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.merge=c;function m(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ye[45],Ce([1,0,10,12,236,5,197,14]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",I.isMacintosh),p.set("isLinux",I.isLinux),p.set("isWindows",I.isWindows),p.set("isWeb",I.isWeb),p.set("isMacNative",I.isMacintosh&&!I.isWeb),p.set("isEdge",I.isEdge),p.set("isFirefox",I.isFirefox),p.set("isChrome",I.isChrome),p.set("isSafari",I.isSafari);function y(q,W){if(p.get(q)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(q,W)}e.setConstant=y;const R=Object.prototype.hasOwnProperty;var D;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const v={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),C=(0,A.localize)(1,null),c=(0,A.localize)(2,null),m=(0,A.localize)(3,null),o=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=v){this._config=W,this._scanner=new f.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const ie=this._expr();if(!this._isAtEnd()){const Se=this._peek(),he=Se.type===17?i:void 0;throw this._parsingErrors.push({message:o,offset:Se.offset,lexeme:f.Scanner.getLexeme(Se),additionalInfo:he}),a._parseError}return ie}catch(ie){if(ie!==a._parseError)throw ie;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(16);){const ie=this._and();W.push(ie)}return W.length===1?W[0]:t.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(15);){const ie=this._term();W.push(ie)}return W.length===1?W[0]:t.and(...W)}_term(){if(this._matchOne(2)){const W=this._peek();switch(W.type){case 11:return this._advance(),l.INSTANCE;case 12:return this._advance(),u.INSTANCE;case 0:{this._advance();const ie=this._expr();return this._consume(1,m),ie?.negate()}case 17:return this._advance(),T.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const ie=this._expr();return this._consume(1,m),ie}case 17:{const ie=W.lexeme;if(this._advance(),this._matchOne(9)){const he=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),he.type!==10)throw this._errExpectedButGot("REGEX",he);const fe=he.lexeme,Z=fe.lastIndexOf("/"),ee=Z===fe.length-1?void 0:this._removeFlagsGY(fe.substring(Z+1));let j;try{j=new RegExp(fe.substring(1,Z),ee)}catch{throw this._errExpectedButGot("REGEX",he)}return U.create(ie,j)}switch(he.type){case 10:case 19:{const fe=[he.lexeme];this._advance();let Z=this._peek(),ee=0;for(let Ae=0;Ae<he.lexeme.length;Ae++)he.lexeme.charCodeAt(Ae)===40?ee++:he.lexeme.charCodeAt(Ae)===41&&ee--;for(;!this._isAtEnd()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Ae=0;Ae<Z.lexeme.length;Ae++)Z.lexeme.charCodeAt(Ae)===40?ee++:he.lexeme.charCodeAt(Ae)===41&&ee--}if(ee<0)break;fe.push(f.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const j=fe.join(""),J=j.lastIndexOf("/"),ge=J===j.length-1?void 0:this._removeFlagsGY(j.substring(J+1));let we;try{we=new RegExp(j.substring(1,J),ge)}catch{throw this._errExpectedButGot("REGEX",he)}return t.regex(ie,we)}case 18:{const fe=he.lexeme;this._advance();let Z=null;if(!(0,F.isFalsyOrWhitespace)(fe)){const ee=fe.indexOf("/"),j=fe.lastIndexOf("/");if(ee!==j&&ee>=0){const J=fe.slice(ee+1,j),ge=fe[j+1]==="i"?"i":"";try{Z=new RegExp(J,ge)}catch{throw this._errExpectedButGot("REGEX",he)}}}if(Z===null)throw this._errExpectedButGot("REGEX",he);return U.create(ie,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,c);const he=this._value();return t.notIn(ie,he)}switch(this._peek().type){case 3:{this._advance();const he=this._value();if(this._previous().type===18)return t.equals(ie,he);switch(he){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,he)}}case 4:{this._advance();const he=this._value();if(this._previous().type===18)return t.notEquals(ie,he);switch(he){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,he)}}case 5:return this._advance(),M.create(ie,this._value());case 6:return this._advance(),L.create(ie,this._value());case 7:return this._advance(),x.create(ie,this._value());case 8:return this._advance(),N.create(ie,this._value());case 13:return this._advance(),t.in(ie,this._value());default:return t.has(ie)}}case 20:throw this._parsingErrors.push({message:r,offset:W.offset,lexeme:"",additionalInfo:n}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case 17:case 18:return this._advance(),W.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,ie){if(this._check(W))return this._advance();throw this._errExpectedButGot(ie,this._peek())}_errExpectedButGot(W,ie,Se){const he=(0,A.localize)(8,null,W,f.Scanner.getLexeme(ie)),fe=ie.offset,Z=f.Scanner.getLexeme(ie);return this._parsingErrors.push({message:he,offset:fe,lexeme:Z,additionalInfo:Se}),a._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(W){return w.create(W)}static equals(W,ie){return k.create(W,ie)}static notEquals(W,ie){return _.create(W,ie)}static regex(W,ie){return U.create(W,ie)}static in(W,ie){return b.create(W,ie)}static notIn(W,ie){return g.create(W,ie)}static not(W){return T.create(W)}static and(...W){return le.create(W,null,!0)}static or(...W){return Y.create(W,null,!0)}static greater(W,ie){return x.create(W,ie)}static greaterEquals(W,ie){return N.create(W,ie)}static smaller(W,ie){return M.create(W,ie)}static smallerEquals(W,ie){return L.create(W,ie)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=t;function d(q){const W=new a({regexParsingWithErrorRecovery:!1});return q.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,A.localize)(9,null,Se.additionalInfo):(0,A.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.validateWhenClauses=d;function s(q,W){const ie=q?q.substituteConstants():void 0,Se=W?W.substituteConstants():void 0;return!ie&&!Se?!0:!ie||!Se?!1:ie.equals(Se)}e.expressionsAreEqualWithConstantSubstitution=s;function h(q,W){return q.cmp(W)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=l;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=u;class w{static create(W,ie=null){const Se=p.get(W);return typeof Se=="boolean"?Se?u.INSTANCE:l.INSTANCE:new w(W,ie)}constructor(W,ie){this.key=W,this.negated=ie,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:Q(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=p.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:l.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class k{static create(W,ie,Se=null){if(typeof ie=="boolean")return ie?w.create(W,Se):T.create(W,Se);const he=p.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?u.INSTANCE:l.INSTANCE:new k(W,ie,Se)}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=p.get(this.key);if(typeof W=="boolean"){const ie=W?"true":"false";return this.value===ie?u.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=k;class b{static create(W,ie){return new b(W,ie)}constructor(W,ie){this.key=W,this.valueKey=ie,this.type=10,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.valueKey),Se=W.getValue(this.key);return Array.isArray(ie)?ie.includes(Se):typeof Se=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,Se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=b;class g{static create(W,ie){return new g(W,ie)}constructor(W,ie){this.key=W,this.valueKey=ie,this.type=11,this._negated=b.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class _{static create(W,ie,Se=null){if(typeof ie=="boolean")return ie?T.create(W,Se):w.create(W,Se);const he=p.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?l.INSTANCE:u.INSTANCE:new _(W,ie,Se)}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=p.get(this.key);if(typeof W=="boolean"){const ie=W?"true":"false";return this.value===ie?l.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class T{static create(W,ie=null){const Se=p.get(W);return typeof Se=="boolean"?Se?l.INSTANCE:u.INSTANCE:new T(W,ie)}constructor(W,ie){this.key=W,this.negated=ie,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:Q(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=p.get(this.key);return typeof W=="boolean"?W?l.INSTANCE:u.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function O(q,W){if(typeof q=="string"){const ie=parseFloat(q);isNaN(ie)||(q=ie)}return typeof q=="string"||typeof q=="number"?W(q):l.INSTANCE}class x{static create(W,ie,Se=null){return O(ie,he=>new x(W,he,Se))}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=x;class N{static create(W,ie,Se=null){return O(ie,he=>new N(W,he,Se))}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=N;class M{static create(W,ie,Se=null){return O(ie,he=>new M(W,he,Se))}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class L{static create(W,ie,Se=null){return O(ie,he=>new L(W,he,Se))}constructor(W,ie,Se){this.key=W,this.value=ie,this.negated=Se,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=L;class U{static create(W,ie){return new U(W,ie)}constructor(W,ie){this.key=W,this.regexp=ie,this.type=7,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const ie=this.regexp?this.regexp.source:"",Se=W.regexp?W.regexp.source:"";return ie<Se?-1:ie>Se?1:0}equals(W){if(W.type===this.type){const ie=this.regexp?this.regexp.source:"",Se=W.regexp?W.regexp.source:"";return this.key===W.key&&ie===Se}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.key);return this.regexp?this.regexp.test(ie):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}e.ContextKeyRegexExpr=U;class B{static create(W){return new B(W)}constructor(W){this._actual=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new B(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=B;function G(q){let W=null;for(let ie=0,Se=q.length;ie<Se;ie++){const he=q[ie].substituteConstants();if(q[ie]!==he&&W===null){W=[];for(let fe=0;fe<ie;fe++)W[fe]=q[fe]}W!==null&&(W[ie]=he)}return W===null?q:W}class le{static create(W,ie,Se){return le._normalizeArr(W,ie,Se)}constructor(W,ie){this.expr=W,this.negated=ie,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,Se=this.expr.length;ie<Se;ie++){const he=h(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=G(this.expr);return W===this.expr?this:le.create(W,this.negated,!1)}evaluate(W){for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static _normalizeArr(W,ie,Se){const he=[];let fe=!1;for(const Z of W)if(Z){if(Z.type===1){fe=!0;continue}if(Z.type===0)return l.INSTANCE;if(Z.type===6){he.push(...Z.expr);continue}he.push(Z)}if(he.length===0&&fe)return u.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(h);for(let Z=1;Z<he.length;Z++)he[Z-1].equals(he[Z])&&(he.splice(Z,1),Z--);if(he.length===1)return he[0];for(;he.length>1;){const Z=he[he.length-1];if(Z.type!==9)break;he.pop();const ee=he.pop(),j=he.length===0,J=Y.create(Z.expr.map(ge=>le.create([ge,ee],null,Se)),null,j);J&&(he.push(J),he.sort(h))}if(he.length===1)return he[0];if(Se){for(let Z=0;Z<he.length;Z++)for(let ee=Z+1;ee<he.length;ee++)if(he[Z].negate().equals(he[ee]))return l.INSTANCE;if(he.length===1)return he[0]}return new le(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new le(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.negated){const W=[];for(const ie of this.expr)W.push(ie.negate());this.negated=Y.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=le;class Y{static create(W,ie,Se){return Y._normalizeArr(W,ie,Se)}constructor(W,ie){this.expr=W,this.negated=ie,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,Se=this.expr.length;ie<Se;ie++){const he=h(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=G(this.expr);return W===this.expr?this:Y.create(W,this.negated,!1)}evaluate(W){for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static _normalizeArr(W,ie,Se){let he=[],fe=!1;if(W){for(let Z=0,ee=W.length;Z<ee;Z++){const j=W[Z];if(j){if(j.type===0){fe=!0;continue}if(j.type===1)return u.INSTANCE;if(j.type===9){he=he.concat(j.expr);continue}he.push(j)}}if(he.length===0&&fe)return l.INSTANCE;he.sort(h)}if(he.length!==0){if(he.length===1)return he[0];for(let Z=1;Z<he.length;Z++)he[Z-1].equals(he[Z])&&(he.splice(Z,1),Z--);if(he.length===1)return he[0];if(Se){for(let Z=0;Z<he.length;Z++)for(let ee=Z+1;ee<he.length;ee++)if(he[Z].negate().equals(he[ee]))return u.INSTANCE;if(he.length===1)return he[0]}return new Y(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new Y(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.negated){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),Se=W.shift(),he=[];for(const fe of oe(ie))for(const Z of oe(Se))he.push(le.create([fe,Z],null,!1));W.unshift(Y.create(he,null,!1))}this.negated=Y.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=Y;class K extends w{static{this._info=[]}static all(){return K._info.values()}constructor(W,ie,Se){super(W,null),this._defaultValue=ie,typeof Se=="object"?K._info.push({...Se,key:W}):Se!==!0&&K._info.push({key:W,description:Se,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return _.create(this.key,W)}}e.RawContextKey=K,e.IContextKeyService=(0,P.createDecorator)("contextKeyService");function Q(q,W){return q<W?-1:q>W?1:0}function ue(q,W,ie,Se){return q<ie?-1:q>ie?1:W<Se?-1:W>Se?1:0}function ne(q,W){if(q.type===0||W.type===1)return!0;if(q.type===9)return W.type===9?pe(q.expr,W.expr):!1;if(W.type===9){for(const ie of W.expr)if(ne(q,ie))return!0;return!1}if(q.type===6){if(W.type===6)return pe(W.expr,q.expr);for(const ie of q.expr)if(ne(ie,W))return!0;return!1}return q.equals(W)}e.implies=ne;function pe(q,W){let ie=0,Se=0;for(;ie<q.length&&Se<W.length;){const he=q[ie].cmp(W[Se]);if(he<0)return!1;he===0&&ie++,Se++}return ie===q.length}function oe(q){return q.type===9?q.expr:[q]}}),define(ye[239],Ce([1,0,23,39,199,5,103,10,24]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,P.createDecorator)("dialogService");var y;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(y||(y={}));class R{getConfirmationButtons(m){return this.getButtons(m,y.Confirmation)}getPromptButtons(m){return this.getButtons(m,y.Prompt)}getInputButtons(m){return this.getButtons(m,y.Input)}getButtons(m,o){const i=[];switch(o){case y.Confirmation:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(1,null));break}case y.Prompt:{const r=m;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case y.Input:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(6,null));break}}return i}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===F.default.Info?"info":m===F.default.Error?"error":m===F.default.Warning?"warning":"none"}getPromptResult(m,o,i){const r=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&r.push(m.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.AbstractDialogHandler=R,e.IFileDialogService=(0,P.createDecorator)("fileDialogService");var D;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const v=10;function S(c){const m=[];return m.push(...c.slice(0,v).map(o=>typeof o=="string"?o:(0,I.basename)(o))),c.length>v&&(c.length-v===1?m.push((0,f.localize)(7,null)):m.push((0,f.localize)(8,null,c.length-v))),m.push(""),m.join(`
`)}e.getFileNamesMessage=S;function C(c,m){const o=(0,p.deepClone)(c);let i=(o.buttons??[]).map(t=>(0,A.mnemonicButtonLabel)(t)),r=(c.buttons||[]).map((t,d)=>d),n=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(E.isLinux||E.isMacintosh){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const d=r[a];r.splice(a,1),r.splice(1,0,d),a=1}E.isLinux&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(a=n-1))}else if(E.isWindows&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const d=r[a];r.splice(a,1),r.push(d),a=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=a,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:r}}e.massageMessageBoxOptions=C}),define(ye[133],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[134],Ce([1,0,200,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function f(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=f;function P(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":n==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function E(r,n){return n==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function p(r,n,a){return E(n,a)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===a}e.isTargetPlatformCompatible=p;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=y;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var D;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var v;(function(r){r.Install="install",r.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var S;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService");var C;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(C||(e.ExtensionManagementErrorCode=C={}));var c;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.ExtensionManagementError=m;var o;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.ExtensionGalleryError=i,e.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel=(0,I.localize2)(1,"Preferences")}),define(ye[240],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ye[241],Ce([1,0,50,52,16,17,10,102,31,105,202,240]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=R.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends S{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(I,a,y.getWindowsShell(),t)}spawnTerminal(a,t,d,s){const h=t.windowsExec||C.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=P.basename(h,".exe").toLowerCase();if(l==="cmder")return a.spawn(h,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return h.indexOf(" ")>=0&&u.push('""'),u.push(h),l==="wt"&&u.push("-d ."),new Promise((w,k)=>{const b=o(process),g=a.spawn(d,u,{cwd:s,env:b,detached:!0});g.on("error",k),g.on("exit",()=>w())})}async runInTerminal(a,t,d,s,h){const l="windowsExec"in h&&h.windowsExec?h.windowsExec:C.getDefaultTerminalWindows(),u=await C.getWtExePath();return new Promise((w,k)=>{const b=`"${t} - ${v}"`,g=`""${d.join('" "')}" & pause"`,_=Object.assign({},o(process),s);Object.keys(_).filter(M=>_[M]===null).forEach(M=>delete _[M]);const T={cwd:t,env:_,windowsVerbatimArguments:!0};let O,x;P.basename(l,".exe")==="wt"?(O=l,x=["-d",".",C.CMD,"/c",g]):u?(O=u,x=["-d",t,l,"/c",g]):(O=C.CMD,x=["/c","start",b,"/wait",l,"/c",g]),I.spawn(O,x,T).on("error",M=>{k(i(M))}),w(void 0)})}static getDefaultTerminalWindows(){if(!C._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return C._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await y.win32.findExecutable("wt");return await p.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=C,je([F.memoize],C,"getWtExePath",null);class c extends S{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,d,s,h){const l=h.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((u,w)=>{if(l===D.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const k=l===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",g=[f.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",a||v,"-w",t];for(const O of d)g.push("-a"),g.push(O);if(s){const O=Object.assign({},o(process),s);for(const x in O){const N=O[x];N===null?(g.push("-u"),g.push(x)):(g.push("-e"),g.push(`${x}=${N}`))}}let _="";const T=I.spawn(c.OSASCRIPT,g);T.on("error",O=>{w(i(O))}),T.stderr.on("data",O=>{_+=O.toString()}),T.on("exit",O=>{if(O===0)u(void 0);else if(_){const x=_.split(`
`,1);w(new Error(x[0]))}else w(new Error(R.localize(1,null,k,O)))})}else w(new Error(R.localize(2,null,l)))})}spawnTerminal(a,t,d){const s=t.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((h,l)=>{const u=["-a",s];d&&u.push(d);const w=o(process),k=a.spawn("/usr/bin/open",u,{cwd:d,env:w});k.on("error",l),k.on("exit",()=>h())})}}e.MacExternalTerminalService=c;class m extends S{static{this.WAIT_MESSAGE=R.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,d,s,h){const l=h.linuxExec?Promise.resolve(h.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,w)=>{const k=[];l.then(b=>{b.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const g=`${r(d)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;k.push(`''${g}''`);const _=Object.assign({},o(process),s);Object.keys(_).filter(N=>_[N]===null).forEach(N=>delete _[N]);const T={cwd:t,env:_};let O="";const x=I.spawn(b,k,T);x.on("error",N=>{w(i(N))}),x.stderr.on("data",N=>{O+=N.toString()}),x.on("exit",N=>{if(N===0)u(void 0);else if(O){const M=O.split(`
`,1);w(new Error(M[0]))}else w(new Error(R.localize(4,null,b,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await p.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,d){const s=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,l)=>{s.then(u=>{const w=o(process),k=a.spawn(u,[],{cwd:d,env:w});k.on("error",l),k.on("exit",()=>h())})})}}e.LinuxExternalTerminalService=m;function o(n){const a={...n.env};return(0,E.sanitizeProcessEnvironment)(a),a}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let a="";for(const t of n)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ye[32],Ce([1,0,77,17,12,18,2,203,5,10,16,43]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function v(ne){return ne.create===!0}e.isFileOpenForWriteOptions=v;var S;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var C;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(C||(e.FilePermission=C={}));function c(ne){const pe=ne;return!!pe&&typeof pe.onDidChange=="function"}e.isFileSystemWatcher=c;var m;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(ne){return!!(ne.capabilities&2)}e.hasReadWriteCapability=o;function i(ne){return!!(ne.capabilities&8)}e.hasFileFolderCopyCapability=i;function r(ne){return!!(ne.capabilities&131072)}e.hasFileCloneCapability=r;function n(ne){return!!(ne.capabilities&4)}e.hasOpenReadWriteCloseCapability=n;function a(ne){return!!(ne.capabilities&16)}e.hasFileReadStreamCapability=a;function t(ne){return o(ne)?!!(ne.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function d(ne){return o(ne)?!!(ne.capabilities&32768):!1}e.hasFileAtomicWriteCapability=d;function s(ne){return!!(ne.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function h(ne){return!!(ne.capabilities&2048)}e.hasReadonlyCapability=h;var l;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class u extends Error{static create(pe,oe){const q=new u(pe.toString(),oe);return b(q,oe),q}constructor(pe,oe){super(pe),this.code=oe}}e.FileSystemProviderError=u;function w(ne,pe){return u.create(ne,pe)}e.createFileSystemProviderError=w;function k(ne){return ne||w((0,E.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=k;function b(ne,pe){return ne.name=pe?`${pe} (FileSystemError)`:"FileSystemError",ne}e.markAsFileSystemProviderError=b;function g(ne){if(!ne)return l.Unknown;if(ne instanceof u)return ne.code;const pe=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!pe)return l.Unknown;switch(pe[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=g;function _(ne){if(ne instanceof L)return ne.fileOperationResult;switch(g(ne)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=_;var T;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class O{constructor(pe,oe,q){this.resource=pe,this.operation=oe,this.target=q}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=O;var x;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class N{static{this.MIXED_CORRELATION=null}constructor(pe,oe){this.ignorePathCasing=oe,this.correlationId=void 0,this.added=new D.Lazy(()=>{const q=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return q.fill(this.rawAdded.map(W=>[W,!0])),q}),this.updated=new D.Lazy(()=>{const q=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return q.fill(this.rawUpdated.map(W=>[W,!0])),q}),this.deleted=new D.Lazy(()=>{const q=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return q.fill(this.rawDeleted.map(W=>[W,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of pe){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.correlationId!==N.MIXED_CORRELATION&&(typeof q.cId=="number"?this.correlationId===void 0?this.correlationId=q.cId:this.correlationId!==q.cId&&(this.correlationId=N.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=N.MIXED_CORRELATION))}}contains(pe,...oe){return this.doContains(pe,{includeChildren:!1},...oe)}affects(pe,...oe){return this.doContains(pe,{includeChildren:!0},...oe)}doContains(pe,oe,...q){if(!pe)return!1;const W=q.length>0;return!!((!W||q.includes(1))&&(this.added.value.get(pe)||oe.includeChildren&&this.added.value.findSuperstr(pe))||(!W||q.includes(0))&&(this.updated.value.get(pe)||oe.includeChildren&&this.updated.value.findSuperstr(pe))||(!W||q.includes(2))&&(this.deleted.value.findSubstr(pe)||oe.includeChildren&&this.deleted.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.correlationId===pe}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=N;function M(ne,pe,oe){return!ne||!pe||ne===pe||pe.length>ne.length?!1:(pe.charAt(pe.length-1)!==F.sep&&(pe+=F.sep),oe?(0,f.startsWithIgnoreCase)(ne,pe):ne.indexOf(pe)===0)}e.isParent=M;class L extends Error{constructor(pe,oe,q){super(pe),this.fileOperationResult=oe,this.options=q}}e.FileOperationError=L;class U extends L{constructor(pe,oe,q,W){super(pe,oe,W),this.fileOperationResult=oe,this.size=q}}e.TooLargeFileOperationError=U;class B extends L{constructor(pe,oe,q){super(pe,2,q),this.stat=oe}}e.NotModifiedSinceFileOperationError=B;var G;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var le;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.ETAG_DISABLED="";function Y(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.etag=Y;async function K(ne,pe){if(!pe.hasProvider(A.URI.from({scheme:ne.scheme})))return new Promise(oe=>{const q=pe.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(q.dispose(),oe())})})}e.whenProviderRegistered=K;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(pe){return(0,P.isNumber)(pe)||(pe=0),pe<Q.KB?(0,E.localize)(1,null,pe.toFixed(0)):pe<Q.MB?(0,E.localize)(2,null,(pe/Q.KB).toFixed(2)):pe<Q.GB?(0,E.localize)(3,null,(pe/Q.MB).toFixed(2)):pe<Q.TB?(0,E.localize)(4,null,(pe/Q.GB).toFixed(2)):(0,E.localize)(5,null,(pe/Q.TB).toFixed(2))}}e.ByteSize=Q;function ue(ne){const pe=typeof ne=="string"||ne?.scheme===R.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===R.Schemas.file?1024*Q.MB:pe?10*Q.MB:y.isWeb?50*Q.MB:1024*Q.MB}e.getLargeFileConfirmationLimit=ue}),define(ye[242],Ce([1,0,22,14,204,32]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(R,D,v,S,C,c){let m;try{await E(R,D,v,S,C,c)}catch(o){m=o}finally{m&&C.errorTransformer&&(m=C.errorTransformer(m)),typeof m<"u"&&v.error(m),v.end()}}e.readFileIntoStream=A;async function E(R,D,v,S,C,c){p(c);const m=await R.open(D,{create:!1});try{p(c);let o=0,i=0,r=C&&typeof C.length=="number"?C.length:void 0,n=I.VSBuffer.alloc(Math.min(C.bufferSize,typeof r=="number"?r:C.bufferSize)),a=C&&typeof C.position=="number"?C.position:0,t=0;do i=await R.read(m,a,n.buffer,t,n.byteLength-t),a+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await v.write(S(n)),n=I.VSBuffer.alloc(Math.min(C.bufferSize,typeof r=="number"?r:C.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&p(c)&&y(o,C));if(t>0){let d=t;typeof r=="number"&&(d=Math.min(t,r)),v.write(S(n.slice(0,d)))}}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await R.close(m)}}function p(R){if(R.isCancellationRequested)throw(0,F.canceled)();return!0}function y(R,D){if(typeof D?.limits?.size=="number"&&R>D.limits.size)throw(0,P.createFileSystemProviderError)((0,f.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[85],Ce([1,0,35,3,17,10,2,32]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(o){return o.recursive===!0}e.isRecursiveWatchRequest=p;class y extends F.Disposable{static{this.MAX_RESTARTS=5}constructor(i,r,n,a){super(),this.onFileChanges=i,this.onLogMessage=r,this.verboseLogging=n,this.options=a,this.watcherDisposables=this._register(new F.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const i=new F.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(r=>this.onFileChanges(r))),i.add(this.watcher.onDidLogMessage(r=>this.onLogMessage(r))),i.add(this.watcher.onDidError(r=>this.onError(r)))}onError(i){this.options.restartOnError?this.restartCounter<y.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${i}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${i}`):this.error(i)}restart(i){this.restartCounter++,this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=y;class R extends y{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class D extends y{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=D;function v(o){return o.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.reviveFileChanges=v;function S(o){const i=new m;for(const r of o)i.processEvent(r);return i.coalesce()}e.coalesceEvents=S;function C(o,i){return typeof i=="string"&&!i.startsWith(I.GLOBSTAR)&&!(0,f.isAbsolute)(i)?{base:o,pattern:i}:i}e.normalizeWatcherPattern=C;function c(o,i){const r=[];for(const n of i)r.push((0,I.parse)(C(o,n)));return r}e.parseWatcherPatterns=c;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return P.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.mapPathToChange.get(this.toKey(i));let n=!1;if(r){const a=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(r)):a===2&&t===1?r.type=0:a===1&&t===0||(r.type=t)}else n=!0;n&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],r=[];return Array.from(this.coalesced).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,a)=>n.resource.fsPath.length-a.resource.fsPath.length).filter(n=>r.some(a=>(0,E.isParent)(n.resource.fsPath,a,!P.isLinux))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ye[243],Ce([1,0,57,11,21,34,3,76,17,10,23,2,104,31,85]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class c extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(i,r,n,a){super(),this.request=i,this.onDidFilesChange=r,this.onLogMessage=n,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new F.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new F.RunOnceWorker(t=>this.handleFileChanges(t),c.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new f.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const r=await S.Promises.stat(i);this._register(await this.doWatch(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(i)}}async normalizePath(i){let r=i.path;try{r=await S.Promises.realpath(i.path),i.path===r&&(r=await(0,v.realcase)(i.path)??i.path),i.path!==r&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async doWatch(i,r){if(y.isMacintosh&&(0,P.isEqualOrParent)(i,"/Volumes/",!0))return this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const n=new f.CancellationTokenSource(this.cts.token),a=new A.DisposableStore;try{const t=D.URI.file(this.request.path),d=(0,p.basename)(i),s=(0,I.watch)(i);a.add((0,A.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${i}'`);const h=new Set;if(r)try{for(const u of await S.Promises.readdir(i))h.add(u)}catch(u){this.error(u)}const l=new Map;a.add((0,A.toDisposable)(()=>{for(const[,u]of l)u.dispose();l.clear()})),s.on("error",(u,w)=>{this.error(`Failed to watch ${i} for changes using fs.watch() (${u}, ${w})`),this.dispose()}),s.on("change",(u,w)=>{if(n.token.isCancellationRequested)return;this.trace(`[raw] ["${u}"] ${w}`);let k="";if(w&&(k=w.toString(),y.isMacintosh&&(k=(0,E.normalizeNFC)(k))),!(!k||u!=="change"&&u!=="rename"))if(r)if(u==="rename"){l.get(k)?.dispose();const b=setTimeout(async()=>{if(l.delete(k),k===d&&!await S.Promises.exists(i)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.existsChildStrictCase((0,p.join)(i,k));if(n.token.isCancellationRequested)return;let _;g?h.has(k)?_=0:(_=1,h.add(k)):(h.delete(k),_=2),this.onFileChange({resource:(0,R.joinPath)(t,k),type:_,cId:this.request.correlationId})},c.FILE_DELETE_HANDLER_DELAY);l.set(k,(0,A.toDisposable)(()=>clearTimeout(b)))}else{let b;h.has(k)?b=0:(b=1,h.add(k)),this.onFileChange({resource:(0,R.joinPath)(t,k),type:b,cId:this.request.correlationId})}else if(u==="rename"||k!==d){const b=setTimeout(async()=>{const g=await S.Promises.exists(i);n.token.isCancellationRequested||(g?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(i,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},c.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,A.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await S.Promises.exists(i)&&!n.token.isCancellationRequested&&this.error(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.toDisposable)(()=>{n.dispose(!0),a.dispose()})}onFileChange(i,r=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.excludes.some(n=>n(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.includes&&this.includes.length>0&&!this.includes.some(n=>n(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const r=(0,C.coalesceEvents)(i);if(r.length>0){if(this.verboseLogging)for(const a of r)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(r)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(i){if(y.isLinux)return S.Promises.exists(i);try{const r=(0,p.basename)(i);return(await S.Promises.readdir((0,p.dirname)(i))).some(a=>a===r)}catch(r){return this.trace(r),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=c;async function m(o,i,r,n,a=512){const t=await S.Promises.open(o,"r"),d=Buffer.allocUnsafe(a),s=new f.CancellationTokenSource(n);let h,l=!1;const u={path:o,excludes:[],recursive:!1},w=new c(u,k=>{(async()=>{for(const{type:b}of k)if(b===0){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:g}=await S.Promises.read(t,d,0,a,null);if(!g||s.token.isCancellationRequested)break;i(d.slice(0,g))}}catch(g){h=new Error(g),s.dispose(!0)}finally{l=!1}}})()});return await w.ready,r(),new Promise((k,b)=>{s.token.onCancellationRequested(async()=>{w.dispose();try{await S.Promises.close(t)}catch(g){h=new Error(g)}h?b(h):k()})})}e.watchFileContents=m}),define(ye[244],Ce([1,0,4,35,3,10,243]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends f.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const R=this.normalizeRequests(y),D=R.filter(S=>{const C=this.watchers.get(S.path);return C?!(0,F.patternsEquals)(C.request.excludes,S.excludes)||!(0,F.patternsEquals)(C.request.includes,S.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:S})=>!R.find(C=>C.path===S.path&&(0,F.patternsEquals)(C.excludes,S.excludes)&&(0,F.patternsEquals)(C.includes,S.includes))).map(({request:S})=>S.path);D.length&&this.trace(`Request to start watching: ${D.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const S of v)this.stopWatching(S);for(const S of D)this.startWatching(S)}startWatching(y){const R=new A.NodeJSFileWatcherLibrary(y,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),D={request:y,instance:R};this.watchers.set(y.path,D)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const R=this.watchers.get(y);R&&(this.watchers.delete(y),R.instance.dispose())}normalizeRequests(y){const R=new Map;for(const D of y){const v=P.isLinux?D.path:D.path.toLowerCase();let S=R.get(D.correlationId);S||(S=new Map,R.set(D.correlationId,S)),S.set(v,D)}return Array.from(R.values()).map(D=>Array.from(D.values())).flat()}async setVerboseLogging(y){this.verboseLogging=y;for(const[,R]of this.watchers)R.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,R){return R?`[File Watcher (node.js)] ${y} (path: ${R.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=E}),define(ye[245],Ce([1,0,85,244]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class f extends I.AbstractNonRecursiveWatcherClient{constructor(A,E,p){super(A,E,p),this.init()}createWatcher(A){return A.add(new F.NodeJSWatcher)}}e.NodeJSWatcherClient=f}),define(ye[246],Ce([1,0,16,81,187,85]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends P.AbstractUniversalWatcherClient{constructor(p,y,R){super(p,y,R),this.init()}createWatcher(p){const y=p.add(new f.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(y.onDidProcessExit(({code:R,signal:D})=>this.onError(`terminated by itself with code ${R}, signal: ${D}`))),F.ProxyChannel.toService((0,F.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ye[107],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...f){this._entries=new Map;for(const[P,A]of f)this.set(P,A)}set(f,P){const A=this._entries.get(f);return this._entries.set(f,P),A}has(f){return this._entries.has(f)}get(f){return this._entries.get(f)}}e.ServiceCollection=I}),define(ye[247],Ce([1,0,11,14,3,106,238,5,107,75]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class D extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class v{constructor(m=new p.ServiceCollection,o=!1,i,r=R){this._services=m,this._strict=o,this._parent=i,this._enableTracing=r,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=r?i?._globalGraph??new A.Graph(n=>n):void 0}createChild(m){return new v(m,this._strict,this,this._enableTracing)}invokeFunction(m,...o){const i=C.traceInvocation(this._enableTracing,m);let r=!1;try{return m({get:a=>{if(r)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(m,...o){let i,r;return m instanceof P.SyncDescriptor?(i=C.traceCreation(this._enableTracing,m.ctor),r=this._createInstance(m.ctor,m.staticArguments.concat(o),i)):(i=C.traceCreation(this._enableTracing,m),r=this._createInstance(m,o,i)),i.stop(),r}_createInstance(m,o=[],i){const r=E._util.getServiceDependencies(m).sort((t,d)=>t.index-d.index),n=[];for(const t of r){const d=this._getOrCreateServiceInstance(t.id,i);d||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(d)}const a=r.length>0?r[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${m.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(m,o.concat(n))}_setServiceInstance(m,o){if(this._services.get(m)instanceof P.SyncDescriptor)this._services.set(m,o);else if(this._parent)this._parent._setServiceInstance(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const o=this._services.get(m);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):o}_getOrCreateServiceInstance(m,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const i=this._getServiceInstanceOrDescriptor(m);return i instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,i,o.branch(m,!0)):(o.branch(m,!1),i)}_safeCreateAndCacheServiceInstance(m,o,i){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,o,i)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,o,i){const r=new A.Graph(t=>t.id.toString());let n=0;const a=[{id:m,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new D(r);for(const d of E._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(d.id);if(s||this._throwIfStrict(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),s instanceof P.SyncDescriptor){const h={id:d.id,desc:s,_trace:t._trace.branch(d.id,!0)};r.insertEdge(t,h),a.push(h)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new D(r);break}for(const{data:d}of t){if(this._getServiceInstanceOrDescriptor(d.id)instanceof P.SyncDescriptor){const h=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,h)}r.removeNode(d)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,o,i=[],r,n){if(this._services.get(m)instanceof P.SyncDescriptor)return this._createServiceInstance(m,o,i,r,n);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(m,o,i=[],r,n){if(r){const a=new v(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(m);const t=new Map,d=new I.GlobalIdleValue(()=>{const s=a._createInstance(o,i,n);for(const[h,l]of t){const u=s[h];if(typeof u=="function")for(const w of l)w.disposable=u.apply(s,w.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,h){if(!d.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=t.get(h);return w||(w=new y.LinkedList,t.set(h,w)),(b,g,_)=>{if(d.isInitialized)return d.value[h](b,g,_);{const T={listener:[b,g,_],disposable:void 0},O=w.push(T);return(0,f.toDisposable)(()=>{O(),T.disposable?.dispose()})}}}if(h in s)return s[h];const l=d.value;let u=l[h];return typeof u!="function"||(u=u.bind(l),s[h]=u),u},set(s,h,l){return d.value[h]=l,!0},getPrototypeOf(s){return o.prototype}})}else return this._createInstance(o,i,n)}_throwIfStrict(m,o){if(o&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=v;var S;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(S||(S={}));class C{static{this.all=new Set}static{this._None=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new C(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C._None}static traceCreation(m,o){return m?new C(1,o.name):C._None}static{this._totals=0}constructor(m,o){this.type=m,this.name=o,this._start=Date.now(),this._dep=[]}branch(m,o){const i=new C(3,m.toString());return this._dep.push([m,o,i]),i}stop(){const m=Date.now()-this._start;C._totals+=m;let o=!1;function i(n,a){const t=[],d=new Array(n+1).join("	");for(const[s,h,l]of a._dep)if(h&&l){o=!0,t.push(`${d}CREATES -> ${s}`);const u=i(n+1,l);u&&t.push(u)}else t.push(`${d}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(m>2||o)&&C.all.add(r.join(`
`))}}e.Trace=C}),define(ye[13],Ce([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function S(){return new Date().toISOString()}function C(b){return(0,y.isNumber)(b)}e.isLogLevel=C;var c;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(c||(e.LogLevel=c={})),e.DEFAULT_LOG_LEVEL=c.Info;function m(b,g,_){switch(g){case c.Trace:b.trace(_);break;case c.Debug:b.debug(_);break;case c.Info:b.info(_);break;case c.Warning:b.warn(_);break;case c.Error:b.error(_);break;case c.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=m;function o(b,g=!1){let _="";for(let T=0;T<b.length;T++){let O=b[T];if(O instanceof Error&&(O=(0,I.toErrorMessage)(O,g)),typeof O=="object")try{O=JSON.stringify(O)}catch{}_+=(T>0?" ":"")+O}return _}class i extends P.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(g){this.level!==g&&(this.level=g,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(g){return this.level!==c.Off&&this.level<=g}}e.AbstractLogger=i;class r extends i{constructor(g){super(),this.logAlways=g}checkLogLevel(g){return this.logAlways||super.checkLogLevel(g)}trace(g,..._){this.checkLogLevel(c.Trace)&&this.log(c.Trace,o([g,..._],!0))}debug(g,..._){this.checkLogLevel(c.Debug)&&this.log(c.Debug,o([g,..._]))}info(g,..._){this.checkLogLevel(c.Info)&&this.log(c.Info,o([g,..._]))}warn(g,..._){this.checkLogLevel(c.Warning)&&this.log(c.Warning,o([g,..._]))}error(g,..._){if(this.checkLogLevel(c.Error))if(g instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=g.stack,this.log(c.Error,o(T))}else this.log(c.Error,o([g,..._]))}flush(){}}e.AbstractMessageLogger=r;class n extends i{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.useColors=!E.isWindows}trace(g,..._){this.checkLogLevel(c.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,..._):console.log(`[main ${S()}]`,g,..._))}debug(g,..._){this.checkLogLevel(c.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,..._):console.log(`[main ${S()}]`,g,..._))}info(g,..._){this.checkLogLevel(c.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,..._):console.log(`[main ${S()}]`,g,..._))}warn(g,..._){this.checkLogLevel(c.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,g,..._):console.warn(`[main ${S()}]`,g,..._))}error(g,..._){this.checkLogLevel(c.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,g,..._):console.error(`[main ${S()}]`,g,..._))}flush(){}}e.ConsoleMainLogger=n;class a extends i{constructor(g=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(g)}trace(g,..._){this.checkLogLevel(c.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",g,..._):console.log(g,..._))}debug(g,..._){this.checkLogLevel(c.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",g,..._):console.log(g,..._))}info(g,..._){this.checkLogLevel(c.Info)&&(this.useColors?console.log("%c INFO","color: #33f",g,..._):console.log(g,..._))}warn(g,..._){this.checkLogLevel(c.Warning)&&(this.useColors?console.log("%c WARN","color: #993",g,..._):console.log(g,..._))}error(g,..._){this.checkLogLevel(c.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",g,..._):console.error(g,..._))}flush(){}}e.ConsoleLogger=a;class t extends i{constructor(g,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=g,this.setLevel(_)}trace(g,..._){this.checkLogLevel(c.Trace)&&this.adapter.log(c.Trace,[this.extractMessage(g),..._])}debug(g,..._){this.checkLogLevel(c.Debug)&&this.adapter.log(c.Debug,[this.extractMessage(g),..._])}info(g,..._){this.checkLogLevel(c.Info)&&this.adapter.log(c.Info,[this.extractMessage(g),..._])}warn(g,..._){this.checkLogLevel(c.Warning)&&this.adapter.log(c.Warning,[this.extractMessage(g),..._])}error(g,..._){this.checkLogLevel(c.Error)&&this.adapter.log(c.Error,[this.extractMessage(g),..._])}extractMessage(g){return typeof g=="string"?g:(0,I.toErrorMessage)(g,this.checkLogLevel(c.Trace))}flush(){}}e.AdapterLogger=t;class d extends i{constructor(g){super(),this.loggers=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const _ of this.loggers)_.setLevel(g);super.setLevel(g)}trace(g,..._){for(const T of this.loggers)T.trace(g,..._)}debug(g,..._){for(const T of this.loggers)T.debug(g,..._)}info(g,..._){for(const T of this.loggers)T.info(g,..._)}warn(g,..._){for(const T of this.loggers)T.warn(g,..._)}error(g,..._){for(const T of this.loggers)T.error(g,..._)}flush(){for(const g of this.loggers)g.flush()}dispose(){for(const g of this.loggers)g.dispose();super.dispose()}}e.MultiplexLogger=d;class s extends P.Disposable{constructor(g,_,T){if(super(),this.logLevel=g,this.logsHome=_,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new F.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const O of T)this._loggers.set(O.resource,{logger:void 0,info:O})}getLoggerEntry(g){return(0,y.isString)(g)?[...this._loggers.values()].find(_=>_.info.id===g):this._loggers.get(g)}getLogger(g){return this.getLoggerEntry(g)?.logger}createLogger(g,_){const T=this.toResource(g),O=(0,y.isString)(g)?g:_?.id??(0,f.hash)(T.toString()).toString(16);let x=this._loggers.get(T)?.logger;const N=_?.logLevel==="always"?c.Trace:_?.logLevel;x||(x=this.doCreateLogger(T,N??this.getLogLevel(T)??this.logLevel,{..._,id:O}));const M={logger:x,info:{resource:T,id:O,logLevel:N,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(M.info),this._loggers.set(T,M),x}toResource(g){return(0,y.isString)(g)?(0,p.joinPath)(this.logsHome,`${g}.log`):g}setLogLevel(g,_){if(R.URI.isUri(g)){const T=g,O=_,x=this._loggers.get(T);x&&O!==x.info.logLevel&&(x.info.logLevel=O===this.logLevel?void 0:O,x.logger?.setLevel(O),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([T,O]))}else{this.logLevel=g;for(const[T,O]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&O.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(g,_){const T=this.getLoggerEntry(g);T&&_!==!T.info.hidden&&(T.info.hidden=!_,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,_]))}getLogLevel(g){let _;return g&&(_=this._loggers.get(g)?.info.logLevel),_??this.logLevel}registerLogger(g){const _=this._loggers.get(g.resource);_?_.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this._loggers.set(g.resource,{info:g,logger:void 0}),this._onDidChangeLoggers.fire({added:[g],removed:[]}))}deregisterLogger(g){const _=this._loggers.get(g);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(g),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const g of this._loggers.values())yield g.info}getRegisteredLogger(g){return this._loggers.get(g)?.info}dispose(){this._loggers.forEach(g=>g.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class h{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(g){}getLevel(){return c.Info}trace(g,..._){}debug(g,..._){}info(g,..._){}warn(g,..._){}error(g,..._){}critical(g,..._){}dispose(){}flush(){}}e.NullLogger=h;class l extends h{}e.NullLogService=l;function u(b){if(b.verbose)return c.Trace;if(typeof b.logLevel=="string"){const g=k(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function w(b){switch(b){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.LogLevelToString=w;function k(b){switch(b){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.parseLogLevel=k,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",w(c.Info))}),define(ye[248],Ce([1,0,19,11,14,4,3,17,85,13]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends A.Disposable{constructor(v,S){super(),this.logService=v,this.options=S,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new F.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new F.ThrottledDelayer(0))}watch(v,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,S):this.watchNonRecursive(v,S)}watchUniversal(v,S){const C={path:this.toFilePath(v),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},c=(0,I.insert)(this.universalPathsToWatch,C);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{c(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,f.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const S of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const S of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(S)&&v.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,S){const C={path:this.toFilePath(v),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},c=(0,I.insert)(this.nonRecursivePathsToWatch,C);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{c(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,f.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,E.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(ye[249],Ce([1,0,57,388,11,28,22,4,34,3,17,10,23,99,31,205,32,242,248,44,246,245]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(d){console.error(`Error enabling graceful-fs: ${(0,r.toErrorMessage)(d)}`)}})();class t extends i.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,h){super(s,h),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new P.ResourceMap(l=>v.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:h,symbolicLink:l}=await C.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(h,l),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:m.FilePermission.Locked}}catch(h){throw this.toFileSystemProviderError(h)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const h=await C.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),l=[];return await Promise.all(h.map(async u=>{try{let w;u.isSymbolicLink()?w=(await this.stat((0,v.joinPath)(s,u.name))).type:w=this.toType(u),l.push([u.name,w])}catch(w){this.logService.trace(w)}})),l}catch(h){throw this.toFileSystemProviderError(h)}}toType(s,h){let l;return h?.dangling?l=m.FileType.Unknown:s.isFile()?l=m.FileType.File:s.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,h&&(l|=m.FileType.SymbolicLink),l}async createResourceLock(s){const h=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let l;for(;l=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await l.wait();const u=new f.Barrier;return this.resourceLocks.set(s,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,y.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.resourceLocks.get(s)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),u.open()})}async readFile(s,h){let l;try{h?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),l=await this.createResourceLock(s));const u=this.toFilePath(s);return await C.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{l?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,h,l){const u=(0,S.newWriteableStream)(w=>A.VSBuffer.concat(w.map(k=>A.VSBuffer.wrap(k))).buffer);return(0,o.readFileIntoStream)(this,s,u,w=>w.buffer,{...h,bufferSize:256*1024},l),u}async writeFile(s,h,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,v.joinPath)((0,v.dirname)(s),`${(0,v.basename)(s)}${l.atomic.postfix}`),h,l):this.doWriteFile(s,h,l)}async canWriteFileAtomic(s){try{const h=this.toFilePath(s),{symbolicLink:l}=await C.SymlinkSupport.stat(h);if(l)return!1}catch{}return!0}async doWriteFileAtomic(s,h,l,u){const w=new y.DisposableStore;try{w.add(await this.createResourceLock(s)),w.add(await this.createResourceLock(h)),await this.doWriteFile(h,l,u,!0);try{await this.rename(h,s,{overwrite:!0})}catch(k){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{w.dispose()}}async doWriteFile(s,h,l,u){let w;try{const k=this.toFilePath(s);if(!l.create||!l.overwrite){if(await C.Promises.exists(k)){if(!l.overwrite)throw(0,m.createFileSystemProviderError)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.createFileSystemProviderError)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0,unlock:l.unlock},u),await this.write(w,0,h,0,h.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(s,k)}finally{typeof w=="number"&&await this.close(w)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,h,l){const u=this.toFilePath(s);let w;(0,m.isFileOpenForWriteOptions)(h)&&!l&&(w=await this.createResourceLock(s));let k;try{if((0,m.isFileOpenForWriteOptions)(h)&&h.unlock)try{const{stat:g}=await C.SymlinkSupport.stat(u);g.mode&128||await C.Promises.chmod(u,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}let b;if((0,m.isFileOpenForWriteOptions)(h)){if(D.isWindows)try{await C.Promises.truncate(u,0),b="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}b||(b="w")}else b="r";k=await C.Promises.open(u,b)}catch(b){throw w?.dispose(),(0,m.isFileOpenForWriteOptions)(h)?await this.toFileSystemProviderWriteError(s,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(k,0),(0,m.isFileOpenForWriteOptions)(h)&&this.writeHandles.set(k,s),w){const b=this.mapHandleToLock.get(k);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${u})`),this.mapHandleToLock.set(k,w),b&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${u})`),b.dispose())}return k}async close(s){const h=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await C.Promises.fdatasync(s)}catch(l){t.configureFlushOnWrite(!1),this.logService.error(l)}return await C.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}finally{h&&(this.mapHandleToLock.get(s)===h&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),h.dispose())}}async read(s,h,l,u,w){const k=this.normalizePos(s,h);let b=null;try{b=(await C.Promises.read(s,l,u,w,k)).bytesRead}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(s,k,b)}return b}normalizePos(s,h){return h===this.mapHandleToPos.get(s)?null:h}updatePos(s,h,l){const u=this.mapHandleToPos.get(s);typeof u=="number"&&(typeof h=="number"||(typeof l=="number"?this.mapHandleToPos.set(s,u+l):this.mapHandleToPos.delete(s)))}async write(s,h,l,u,w){return(0,f.retry)(()=>this.doWrite(s,h,l,u,w),100,3)}async doWrite(s,h,l,u,w){const k=this.normalizePos(s,h);let b=null;try{b=(await C.Promises.write(s,l,u,w,k)).bytesWritten}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),g)}finally{this.updatePos(s,k,b)}return b}async mkdir(s){try{await C.Promises.mkdir(this.toFilePath(s))}catch(h){throw this.toFileSystemProviderError(h)}}async delete(s,h){try{const l=this.toFilePath(s);if(h.recursive){let u;h?.atomic!==!1&&h.atomic.postfix&&(u=(0,R.join)((0,R.dirname)(l),`${(0,R.basename)(l)}${h.atomic.postfix}`)),await C.Promises.rm(l,C.RimRafMode.MOVE,u)}else try{await C.Promises.unlink(l)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let w=!1;try{const{stat:k,symbolicLink:b}=await C.SymlinkSupport.stat(l);w=k.isDirectory()&&!b}catch{}if(w)await C.Promises.rmdir(l);else throw u}else throw u}}catch(l){throw this.toFileSystemProviderError(l)}}async rename(s,h,l){const u=this.toFilePath(s),w=this.toFilePath(h);if(u!==w)try{await this.validateMoveCopy(s,h,"move",l.overwrite),await C.Promises.rename(u,w)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,c.localize)(2,null,(0,R.basename)(u),(0,R.basename)((0,R.dirname)(w)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(s,h,l){const u=this.toFilePath(s),w=this.toFilePath(h);if(u!==w)try{await this.validateMoveCopy(s,h,"copy",l.overwrite),await C.Promises.copy(u,w,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,c.localize)(3,null,(0,R.basename)(u),(0,R.basename)((0,R.dirname)(w)),k.toString()))),this.toFileSystemProviderError(k)}}async validateMoveCopy(s,h,l,u){const w=this.toFilePath(s),k=this.toFilePath(h);let b=!1;if(!!(this.capabilities&1024)||(b=(0,p.isEqual)(w,k,!0)),b){if(l==="copy")throw(0,m.createFileSystemProviderError)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const _=await this.statIgnoreError(s);if(!_)throw(0,m.createFileSystemProviderError)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(h);if(T){if(!u)throw(0,m.createFileSystemProviderError)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);_.type&m.FileType.File&&T.type&m.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,h){return this.doCloneFile(s,h,!1)}async doCloneFile(s,h,l){const u=this.toFilePath(s),w=this.toFilePath(h),k=!!(this.capabilities&1024);if((0,p.isEqual)(u,w,!k))return;const b=new y.DisposableStore;try{b.add(await this.createResourceLock(s)),b.add(await this.createResourceLock(h)),l&&await C.Promises.mkdir((0,R.dirname)(w),{recursive:!0}),await C.Promises.copyFile(u,w)}catch(g){if(g.code==="ENOENT"&&!l)return this.doCloneFile(s,h,!0);throw this.toFileSystemProviderError(g)}finally{b.dispose()}}createUniversalWatcher(s,h,l){return new n.UniversalWatcherClient(u=>s(u),u=>h(u),l)}createNonRecursiveWatcher(s,h,l){return new a.NodeJSWatcherClient(u=>s(u),u=>h(u),l)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let h=s,l;switch(s.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(h,l)}async toFileSystemProviderWriteError(s,h){let l=this.toFileSystemProviderError(h);if(s&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await C.SymlinkSupport.stat(this.toFilePath(s));u.mode&128||(l=(0,m.createFileSystemProviderError)(h,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}}e.DiskFileSystemProvider=t}),define(ye[250],Ce([1,0,3,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class f extends I.Disposable{constructor(A,E=[]){super(),this.logger=new F.MultiplexLogger([A,...E]),this._register(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...E){this.logger.trace(A,...E)}debug(A,...E){this.logger.debug(A,...E)}info(A,...E){this.logger.info(A,...E)}warn(A,...E){this.logger.warn(A,...E)}error(A,...E){this.logger.error(A,...E)}flush(){this.logger.flush()}}e.LogService=f}),define(ye[251],Ce([1,0,32,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var f;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(f||(f={}));async function P(y,R,D,v,S){try{const C=await new Promise((m,o)=>{me(["@vscode/spdlog"],m,o)});C.setFlushOn(f.Trace);const c=await C.createAsyncRotatingLogger(y,R,D,v);return S?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(C){console.error(C)}return null}function A(y,R,D){switch(R){case F.LogLevel.Trace:y.trace(D);break;case F.LogLevel.Debug:y.debug(D);break;case F.LogLevel.Info:y.info(D);break;case F.LogLevel.Warning:y.warn(D);break;case F.LogLevel.Error:y.error(D);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function E(y,R){switch(R){case F.LogLevel.Trace:y.setLevel(f.Trace);break;case F.LogLevel.Debug:y.setLevel(f.Debug);break;case F.LogLevel.Info:y.setLevel(f.Info);break;case F.LogLevel.Warning:y.setLevel(f.Warning);break;case F.LogLevel.Error:y.setLevel(f.Error);break;case F.LogLevel.Off:y.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class p extends F.AbstractMessageLogger{constructor(R,D,v,S,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(R,D,v,S),this._register(this.onDidChangeLogLevel(c=>{this._logger&&E(this._logger,c)}))}async _createSpdLogLogger(R,D,v,S){const C=v?6:1,c=30/C*I.ByteSize.MB,m=await P(R,D,c,C,S);if(m){this._logger=m,E(this._logger,this.getLevel());for(const{level:o,message:i}of this.buffer)A(this._logger,o,i);this.buffer=[]}}log(R,D){this._logger?A(this._logger,R,D):this.getLevel()<=R&&this.buffer.push({level:R,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ye[135],Ce([1,0,39,206,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function y(C,c){return c-C}p.compare=y;const R=Object.create(null);R[p.Error]=(0,F.localize)(0,null),R[p.Warning]=(0,F.localize)(1,null),R[p.Info]=(0,F.localize)(2,null);function D(C){return R[C]||""}p.toString=D;function v(C){switch(C){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=v;function S(C){switch(C){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=S}(A||(e.MarkerSeverity=A={}));var E;(function(p){const y="";function R(v){return D(v,!0)}p.makeKey=R;function D(v,S){const C=[y];return v.source?C.push(v.source.replace("\xA6","\\\xA6")):C.push(y),v.code?typeof v.code=="string"?C.push(v.code.replace("\xA6","\\\xA6")):C.push(v.code.value.replace("\xA6","\\\xA6")):C.push(y),v.severity!==void 0&&v.severity!==null?C.push(A.toString(v.severity)):C.push(y),v.message&&S?C.push(v.message.replace("\xA6","\\\xA6")):C.push(y),v.startLineNumber!==void 0&&v.startLineNumber!==null?C.push(v.startLineNumber.toString()):C.push(y),v.startColumn!==void 0&&v.startColumn!==null?C.push(v.startColumn.toString()):C.push(y),v.endLineNumber!==void 0&&v.endLineNumber!==null?C.push(v.endLineNumber.toString()):C.push(y),v.endColumn!==void 0&&v.endColumn!==null?C.push(v.endColumn.toString()):C.push(y),C.push(y),C.join("\xA6")}p.makeKeyOptionalMessage=D})(E||(e.IMarkerData=E={})),e.IMarkerService=(0,f.createDecorator)("markerService")}),define(ye[252],Ce([1,0,4,39,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.isNotificationSource=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,f.createDecorator)("notificationService");var P;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function E(D){if(D){const v=D;return typeof v.id=="string"&&typeof v.label=="string"}return!1}e.isNotificationSource=E;var p;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class y{constructor(){this.progress=new R,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(v){}updateMessage(v){}updateActions(v){}close(){}}e.NoOpNotification=y;class R{infinite(){}done(){}total(v){}worked(v){}}e.NoOpProgress=R}),define(ye[253],Ce([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const P=f.context.configuration();if(P)F=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){F=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:P,searchUrl:A,itemUrl:E,controlUrl:p}=F.extensionsGallery||{};Object.assign(F,{extensionsGallery:{serviceUrl:I.env.VSCODE_GALLERY_SERVICE_URL||P,searchUrl:I.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:I.env.VSCODE_GALLERY_ITEM_URL||E,controlUrl:I.env.VSCODE_GALLERY_CONTROL_URL||p}});try{const y=(...D)=>D.reduce((v,S)=>(Object.keys(S).forEach(C=>{Array.isArray(v[C])&&Array.isArray(S[C])?v[C]=S[C]:typeof v[C]=="object"&&typeof S[C]=="object"?v[C]=y(v[C],S[C]):v[C]=S[C]}),v),{}),R=globalThis._VSCODE_USER_PRODUCT_JSON||{};F=y(F,R)}catch{}if(I.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const y=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:y.version,release:y.release})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(ye[136],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(ye[86],Ce([1,0,11,21,3,5]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(v){this.callback=v}report(v){this._value=v,this.callback(this._value)}}e.Progress=E;class p{get value(){return this._value}constructor(v){this.callback=v}report(v){this._asyncQueue?this._asyncQueue.push(v):this._asyncQueue=[v],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const v=this._asyncQueue.shift();this._value=v,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const v=this._drainListener;this._drainListener=void 0,v?.()}}drain(){return this._processingAsyncQueue?new Promise(v=>{const S=this._drainListener;this._drainListener=()=>{S?.(),v()}}):Promise.resolve()}}e.AsyncProgress=p;let y=class extends f.Disposable{constructor(v,S){super(),this.deferred=new I.DeferredPromise,S.withProgress(v,C=>(this.reporter=C,this.lastStep&&C.report(this.lastStep),this.deferred.p)),this._register((0,f.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=je([$e(1,e.IProgressService)],y);class R extends f.Disposable{constructor(v){super(),this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new f.DisposableStore)}start(v){this.stop();const S=++this.currentOperationId,C=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,f.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,f.toDisposable)(()=>C.cancel())),this.currentOperationDisposables.add((0,f.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:C.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(ye[37],Ce([1,0,61,18]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class f{constructor(){this.data=new Map}add(A,E){I.ok(F.isString(A)),I.ok(F.isObject(E)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,E)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new f}),define(ye[108],Ce([1,0,4,37]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function f(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,y){this.schemasById[f(p)]=y,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new P;F.Registry.add(e.Extensions.JSONContribution,A)}),define(ye[87],Ce([1,0,19,4,18,196,51,108,37]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=p.Registry.as(E.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const s=new Set;this.doRegisterConfigurations(t,d,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const d=new Set;this.doDeregisterConfigurations(t,d),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:t,remove:d}){const s=new Set;this.doDeregisterConfigurations(d,s),this.doRegisterConfigurations(t,!1,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const d=new Set;this.doRegisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,d){const s=[];for(const{overrides:h,source:l}of t)for(const u in h)if(d.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const w=this.configurationDefaultsOverrides.get(u),k=w?.valuesSources??new Map;if(l)for(const T of Object.keys(h[u]))k.set(T,l);const b={...w?.value||{},...h[u]};this.configurationDefaultsOverrides.set(u,{source:l,value:b,valuesSources:k});const g=(0,A.getLanguageTagSettingPlainKey)(u),_={type:"object",default:b,description:P.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:f.isString(l)?void 0:l,defaultValueSource:l};s.push(...c(u)),this.configurationProperties[u]=_,this.defaultLanguageConfigurationOverridesNode.properties[u]=_}else{this.configurationDefaultsOverrides.set(u,{value:h[u],source:l});const w=this.configurationProperties[u];w&&(this.updatePropertyDefaultValue(u,w),this.updateSchema(u,w))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const d=new Set;this.doDeregisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,d){for(const{overrides:s,source:h}of t)for(const l in s){const u=this.configurationDefaultsOverrides.get(l),w=f.isString(h)?h:h?.id,k=f.isString(u?.source)?u?.source:u?.source?.id;if(w===k)if(d.add(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const b=this.configurationProperties[l];b&&(this.updatePropertyDefaultValue(l,b),this.updateSchema(l,b))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let d=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),d=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),d=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const d of t)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,d,s){t.forEach(h=>{this.validateAndRegisterProperties(h,d,h.extensionInfo,h.restrictedProperties,void 0,s),this.configurationContributors.push(h),this.registerJSONConfiguration(h)})}doDeregisterConfigurations(t,d){const s=h=>{if(h.properties)for(const l in h.properties){d.add(l);const u=this.configurationProperties[l];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,h.properties[l])}h.allOf?.forEach(l=>s(l))};for(const h of t){s(h);const l=this.configurationContributors.indexOf(h);l!==-1&&this.configurationContributors.splice(l,1)}}validateAndRegisterProperties(t,d=!0,s,h,l=3,u){l=f.isUndefinedOrNull(t.scope)?l:t.scope;const w=t.properties;if(w)for(const b in w){const g=w[b];if(d&&r(b,g)){delete w[b];continue}if(g.source=s,g.defaultDefaultValue=w[b].default,this.updatePropertyDefaultValue(b,g),e.OVERRIDE_PROPERTY_REGEX.test(b)?g.scope=void 0:(g.scope=f.isUndefinedOrNull(g.scope)?l:g.scope,g.restricted=f.isUndefinedOrNull(g.restricted)?!!h?.includes(b):g.restricted),w[b].hasOwnProperty("included")&&!w[b].included){this.excludedConfigurationProperties[b]=w[b],delete w[b];continue}else this.configurationProperties[b]=w[b],w[b].policy?.name&&this.policyConfigurations.set(w[b].policy.name,b);!w[b].deprecationMessage&&w[b].markdownDeprecationMessage&&(w[b].deprecationMessage=w[b].markdownDeprecationMessage),u.add(b)}const k=t.allOf;if(k)for(const b of k)this.validateAndRegisterProperties(b,d,s,h,l,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const d=s=>{const h=s.properties;if(h)for(const u in h)this.updateSchema(u,h[u]);s.allOf?.forEach(d)};d(t)}updateSchema(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.resourceLanguageSettingsSchema.properties[t]=d;break}}removeFromSchema(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const d=`[${t}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,d){const s=this.configurationDefaultsOverrides.get(t);let h=s?.value,l=s?.source;f.isUndefined(h)&&(h=d.defaultDefaultValue,l=void 0),f.isUndefined(h)&&(h=o(d.type)),d.default=h,d.defaultValueSource=l}}const S="\\[([^\\]]+)\\]",C=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let d=C.exec(a);for(;d?.length;){const s=d[1].trim();s&&t.push(s),d=C.exec(a)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=c;function m(a){return a.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=m;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const i=new v;p.Registry.add(e.Extensions.Configuration,i);function r(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?P.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?P.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.validateProperty=r;function n(){const a=[],t=i.getConfigurationProperties();for(const d of Object.keys(t))a.push([d,t[d].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=n}),define(ye[254],Ce([1,0,19,4,159,3,28,24,18,2,51,87,37]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(d){return Object.isFrozen(d)?d:E.deepFreeze(d)}class C{constructor(s={},h=[],l=[],u){this._contents=s,this._keys=h,this._overrides=l,this.raw=u,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(h=>{if(h instanceof C)return h;const l=new c("");return l.parseRaw(h),l.configurationModel});this._rawConfiguration=s.reduce((h,l)=>l===h?l:h.merge(l),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,h){const l=this.rawConfiguration.getValue(s),u=h?this.rawConfiguration.getOverrideValue(s,h):void 0,w=h?this.rawConfiguration.override(h).getValue(s):l;return{value:l,override:u,merged:w}}getOverrideValue(s,h){const l=this.getContentsForOverrideIdentifer(h);return l?s?(0,R.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const h=[];for(const l of this.overrides)l.identifiers.includes(s)&&h.push(...l.keys);return I.distinct(h)}getAllOverrideIdentifiers(){const s=[];for(const h of this.overrides)s.push(...h.identifiers);return I.distinct(s)}override(s){let h=this.overrideConfigurations.get(s);return h||(h=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,h)),h}merge(...s){const h=E.deepClone(this.contents),l=E.deepClone(this.overrides),u=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of s)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.mergeContents(h,k.contents);for(const b of k.overrides){const[g]=l.filter(_=>I.equals(_.identifiers,b.identifiers));g?(this.mergeContents(g.contents,b.contents),g.keys.push(...b.keys),g.keys=I.distinct(g.keys)):l.push(E.deepClone(b))}for(const b of k.keys)u.indexOf(b)===-1&&u.push(b)}return new C(h,u,l,w.every(k=>k instanceof C)?void 0:w)}createOverrideConfigurationModel(s){const h=this.getContentsForOverrideIdentifer(s);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const l={};for(const u of I.distinct([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[u];const k=h[u];k&&(typeof w=="object"&&typeof k=="object"?(w=E.deepClone(w),this.mergeContents(w,k)):w=k),l[u]=w}return new C(l,this.keys,this.overrides)}mergeContents(s,h){for(const l of Object.keys(h)){if(l in s&&p.isObject(s[l])&&p.isObject(h[l])){this.mergeContents(s[l],h[l]);continue}s[l]=E.deepClone(h[l])}}getContentsForOverrideIdentifer(s){let h=null,l=null;const u=w=>{w&&(l?this.mergeContents(l,w):l=E.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===s?h=w.contents:w.identifiers.includes(s)&&u(w.contents);return u(h),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,h){this.updateValue(s,h,!0)}setValue(s,h){this.updateValue(s,h,!1)}removeValue(s){const h=this.keys.indexOf(s);h!==-1&&(this.keys.splice(h,1),(0,R.removeFromValueTree)(this.contents,s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>I.equals(l.identifiers,(0,D.overrideIdentifiersFromKey)(s))),1))}updateValue(s,h,l){(0,R.addToValueTree)(this.contents,s,h,u=>console.error(u)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],u=>console.error(u))})}}e.ConfigurationModel=C;class c{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,h){if(!p.isUndefinedOrNull(s)){const l=this.doParseContent(s);this.parseRaw(l,h)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,h){this._raw=s;const{contents:l,keys:u,overrides:w,restricted:k,hasExcludedProperties:b}=this.doParseRaw(s,h);this._configurationModel=new C(l,u,w,b?[s]:void 0),this._restrictedConfigurations=k||[]}doParseContent(s){let h={},l=null,u=[];const w=[],k=[];function b(_){Array.isArray(u)?u.push(_):l!==null&&(u[l]=_)}const g={onObjectBegin:()=>{const _={};b(_),w.push(u),u=_,l=null},onObjectProperty:_=>{l=_},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const _=[];b(_),w.push(u),u=_,l=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:b,onError:(_,T,O)=>{k.push({error:_,offset:T,length:O})}};if(s)try{f.visit(s,g),h=u[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return h}doParseRaw(s,h){const l=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),u=this.filter(s,l,!0,h);s=u.raw;const w=(0,R.toValuesTree)(s,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),k=Object.keys(s),b=this.toOverrides(s,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:w,keys:k,overrides:b,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(s,h,l,u){let w=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:w};const k={},b=[];for(const g in s)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&l){const _=this.filter(s[g],h,!1,u);k[g]=_.raw,w=w||_.hasExcludedProperties,b.push(..._.restricted)}else{const _=h[g],T=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&b.push(g),!u.exclude?.includes(g)&&(u.include?.includes(g)||(T===void 0||u.scopes===void 0||u.scopes.includes(T))&&!(u.skipRestricted&&_?.restricted))?k[g]=s[g]:w=!0}return{raw:k,restricted:b,hasExcludedProperties:w}}toOverrides(s,h){const l=[];for(const u of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(u)){const w={};for(const k in s[u])w[k]=s[u][k];l.push({identifiers:(0,D.overrideIdentifiersFromKey)(u),keys:Object.keys(w),contents:(0,R.toValuesTree)(w,h)})}return l}}e.ConfigurationModelParser=c;class m extends P.Disposable{constructor(s,h,l,u){super(),this.userSettingsResource=s,this.parseOptions=h,this.fileService=u,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.any(F.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),F.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&l.isEqual(w.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class o{constructor(s,h,l,u,w,k,b,g,_,T,O,x,N){this.key=s,this.overrides=h,this._value=l,this.overrideIdentifiers=u,this.defaultConfiguration=w,this.policyConfiguration=k,this.applicationConfiguration=b,this.userConfiguration=g,this.localUserConfiguration=_,this.remoteUserConfiguration=T,this.workspaceConfiguration=O,this.folderConfigurationModel=x,this.memoryConfigurationModel=N}get value(){return S(this._value)}inspect(s,h,l){const u=s.inspect(h,l);return{get value(){return S(u.value)},get override(){return S(u.override)},get merged(){return S(u.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class i{constructor(s,h,l,u,w=new C,k=new C,b=new A.ResourceMap,g=new C,_=new A.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=h,this._applicationConfiguration=l,this._localUserConfiguration=u,this._remoteUserConfiguration=w,this._workspaceConfiguration=k,this._folderConfigurations=b,this._memoryConfiguration=g,this._memoryConfigurationByResource=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(s,h,l){return this.getConsolidatedConfigurationModel(s,h,l).getValue(s)}updateValue(s,h,l={}){let u;l.resource?(u=this._memoryConfigurationByResource.get(l.resource),u||(u=new C,this._memoryConfigurationByResource.set(l.resource,u))):u=this._memoryConfiguration,h===void 0?u.removeValue(s):u.setValue(s,h),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,h,l){const u=this.getConsolidatedConfigurationModel(s,h,l),w=this.getFolderConfigurationModelForResource(h.resource,l),k=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,b=new Set;for(const g of u.overrides)for(const _ of g.identifiers)u.getOverrideValue(s,_)!==void 0&&b.add(_);return new o(s,h,u.getValue(s),b.size?[...b]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this._workspaceConfiguration:void 0,w||void 0,k)}keys(s){const h=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,h){this._folderConfigurations.set(s,h),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,h){const l=[];if(!h){const{added:u,updated:w,removed:k}=a(this._defaultConfiguration,s);h=[...u,...w,...k]}for(const u of h)for(const w of(0,D.overrideIdentifiersFromKey)(u)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(w),b=s.getKeysForOverrideIdentifier(w),g=[...b.filter(_=>k.indexOf(_)===-1),...k.filter(_=>b.indexOf(_)===-1),...k.filter(_=>!E.equals(this._defaultConfiguration.override(w).getValue(_),s.override(w).getValue(_)))];l.push([w,g])}return this.updateDefaultConfiguration(s),{keys:h,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:h,updated:l,removed:u}=a(this._policyConfiguration,s),w=[...h,...l,...u];return w.length&&this.updatePolicyConfiguration(s),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:h,updated:l,removed:u,overrides:w}=a(this.applicationConfiguration,s),k=[...h,...l,...u];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(s){const{added:h,updated:l,removed:u,overrides:w}=a(this.localUserConfiguration,s),k=[...h,...l,...u];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(s){const{added:h,updated:l,removed:u,overrides:w}=a(this.remoteUserConfiguration,s),k=[...h,...l,...u];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(s){const{added:h,updated:l,removed:u,overrides:w}=a(this.workspaceConfiguration,s),k=[...h,...l,...u];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(s,h){const l=this.folderConfigurations.get(s),{added:u,updated:w,removed:k,overrides:b}=a(l,h),g=[...u,...w,...k];return(g.length||!l)&&this.updateFolderConfiguration(s,h),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(s){const h=this.folderConfigurations.get(s);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:u,removed:w,overrides:k}=a(h,void 0);return{keys:[...l,...u,...w],overrides:k}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,h,l){let u=this.getConsolidatedConfigurationModelForResource(h,l);return h.overrideIdentifier&&(u=u.override(h.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:s},h){let l=this.getWorkspaceConsolidatedConfiguration();if(h&&s){const u=h.getFolder(s);u&&(l=this.getFolderConsolidatedConfiguration(u.uri)||l);const w=this._memoryConfigurationByResource.get(s);w&&(l=l.merge(w))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let h=this._foldersConsolidatedConfigurations.get(s);if(!h){const l=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(s);u?(h=l.merge(u),this._foldersConsolidatedConfigurations.set(s,h)):h=l}return h}getFolderConfigurationModelForResource(s,h){if(h&&s){const l=h.getFolder(s);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,h)=>{const{contents:l,overrides:u,keys:w}=this._folderConfigurations.get(h);return s.push([h,{contents:l,overrides:u,keys:w}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(h=>s.add(h)),this.userConfiguration.keys.forEach(h=>s.add(h)),this._workspaceConfiguration.keys.forEach(h=>s.add(h)),this._folderConfigurations.forEach(h=>h.keys.forEach(l=>s.add(l))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(h=>s.add(h)),this._folderConfigurations.forEach(h=>h.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>h.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>h.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>h.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(u=>h.add(u))),[...h.values()]}static parse(s){const h=this.parseConfigurationModel(s.defaults),l=this.parseConfigurationModel(s.policy),u=this.parseConfigurationModel(s.application),w=this.parseConfigurationModel(s.user),k=this.parseConfigurationModel(s.workspace),b=s.folders.reduce((g,_)=>(g.set(y.URI.revive(_[0]),this.parseConfigurationModel(_[1])),g),new A.ResourceMap);return new i(h,l,u,w,new C,k,b,new C,new A.ResourceMap)}static parseConfigurationModel(s){return new C(s.contents,s.keys,s.overrides)}}e.Configuration=i;function r(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const s=new Set,h=new Map;for(const u of d)u.keys.forEach(w=>s.add(w)),u.overrides.forEach(([w,k])=>{const b=(0,A.getOrSet)(h,w,new Set);k.forEach(g=>b.add(g))});const l=[];return h.forEach((u,w)=>l.push([w,[...u.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=r;class n{constructor(s,h,l,u){this.change=s,this.previous=h,this.currentConfiguraiton=l,this.currentWorkspace=u,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of s.keys)this.affectedKeys.add(w);for(const[,w]of s.overrides)for(const k of w)this.affectedKeys.add(k);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,h){const l=this._marker+s,u=this._affectsConfigStr.indexOf(l);if(u<0)return!1;const w=u+l.length;if(w>=this._affectsConfigStr.length)return!1;const k=this._affectsConfigStr.charCodeAt(w);if(k!==this._markerCode1&&k!==this._markerCode2)return!1;if(h){const b=this.previousConfiguration?this.previousConfiguration.getValue(s,h,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(s,h,this.currentWorkspace);return!E.equals(b,g)}return!0}}e.ConfigurationChangeEvent=n;function a(d,s){const{added:h,removed:l,updated:u}=t(s?.rawConfiguration,d?.rawConfiguration),w=[],k=d?.getAllOverrideIdentifiers()||[],b=s?.getAllOverrideIdentifiers()||[];if(s){const g=b.filter(_=>!k.includes(_));for(const _ of g)w.push([_,s.getKeysForOverrideIdentifier(_)])}if(d){const g=k.filter(_=>!b.includes(_));for(const _ of g)w.push([_,d.getKeysForOverrideIdentifier(_)])}if(s&&d){for(const g of k)if(b.includes(g)){const _=t({contents:d.getOverrideValue(void 0,g)||{},keys:d.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});w.push([g,[..._.added,..._.removed,..._.updated]])}}return{added:h,removed:l,updated:u,overrides:w}}function t(d,s){const h=d?s?d.keys.filter(w=>s.keys.indexOf(w)===-1):[...d.keys]:[],l=s?d?s.keys.filter(w=>d.keys.indexOf(w)===-1):[...s.keys]:[],u=[];if(d&&s){for(const w of s.keys)if(d.keys.indexOf(w)!==-1){const k=(0,R.getConfigurationValue)(s.contents,w),b=(0,R.getConfigurationValue)(d.contents,w);E.equals(k,b)||u.push(w)}}return{added:h,removed:l,updated:u}}}),define(ye[255],Ce([1,0,22,4,3,82]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const A=(y,R,D)=>{const v=new Uint8Array(16);for(let c=0;c<16;c++)v[c]=Math.round(Math.random()*256);const S=(0,I.encodeBase64)(I.VSBuffer.wrap(v));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=A,e.socketRawEndHeaderSequence=I.VSBuffer.fromString(`\r
\r
`);async function E(y,R,D,v,S){y.write(I.VSBuffer.fromString((0,e.makeRawSocketHeaders)(R,D,v)));const C=new f.DisposableStore;try{return await new Promise((c,m)=>{let o;C.add(y.onData(i=>{o?o=I.VSBuffer.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.socketRawEndHeaderSequence);if(r===-1)return;c(y),y.pauseData();const n=o.slice(r+e.socketRawEndHeaderSequence.byteLength);n.byteLength&&S.onData.fire(n)})),C.add(y.onClose(i=>m(i??new Error("socket closed")))),C.add(y.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw y.dispose(),c}finally{C.dispose()}}e.connectManagedSocket=E;class p extends f.Disposable{constructor(R,D){super(),this.debugLabel=R,this.pausableDataEmitter=this._register(new F.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new F.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(D.onData),this._register(D.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(D.onClose).event,this.onEnd=this._register(D.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(R,D){P.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,R,D)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=p}),define(ye[64],Ce([1,0,14,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,F.createDecorator)("remoteAuthorityResolverService");var f;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class P{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=P;class A{constructor(D,v){this.host=D,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var E;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class p extends I.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof p&&D._code===E.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof p&&D._code===E.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof p&&D._code===E.NoResolverFound}static isInvalidAuthority(D){return D instanceof p&&D._code===E.InvalidAuthority}static isHandled(D){return D instanceof p&&D.isHandled}constructor(D,v=E.Unknown,S){super(D),this._message=D,this._code=v,this._detail=S,this.isHandled=v===E.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.RemoteAuthorityResolverError=p;function y(R){const D=R.indexOf("+");return D===-1?R:R.substring(0,D)}e.getRemoteAuthorityPrefix=y}),define(ye[65],Ce([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function F(y){return y.scheme===I.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=F;function f(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.getRemoteName=f;function P(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=P;function A(y){const{host:R,port:D}=p(y);if(typeof D>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:D}}e.parseAuthorityWithPort=A;function E(y,R){let{host:D,port:v}=p(y);return typeof v>"u"&&(v=R),{host:D,port:v}}e.parseAuthorityWithOptionalPort=E;function p(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const D=y.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const v=y.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:y,port:void 0}}}),define(ye[25],Ce([1,0,12,5,65]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.LINUX_PPC64LE="linux-ppc64le",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const i=typeof m=="string"?m:m.value,r=typeof o=="string"?o:o.value;return I.equalsIgnoreCase(i,r)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=p;class y{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const o of m)this.add(o)}add(m){this._set.add(p.toKey(m))}delete(m){return this._set.delete(p.toKey(m))}has(m){return this._set.has(p.toKey(m))}}e.ExtensionIdentifierSet=y;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(p.toKey(m))}get(m){return this._map.get(p.toKey(m))}has(m){return this._map.has(p.toKey(m))}set(m,o){this._map.set(p.toKey(m),o)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function D(c){return v(c)}e.isApplicationScopedExtension=D;function v(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function C(c,m){if(m){const o=`onResolveRemoteAuthority:${(0,f.getRemoteName)(m)}`;return!!c.activationEvents?.includes(o)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[137],Ce([1,0,14,25]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class f{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,E){this._generators.set(A,E)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const E=Object.create(null);for(const p of A){const y=this.readActivationEvents(p);y.length>0&&(E[F.ExtensionIdentifier.toKey(p.identifier)]=y)}return E}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const E=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<E.length;p++)E[p]==="onUri"&&(E[p]=`onUri:${F.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return E;for(const p in A.contributes){const y=this._generators.get(p);if(!y)continue;const R=A.contributes[p],D=Array.isArray(R)?R:[R];try{y(D,E)}catch(v){(0,I.onUnexpectedError)(v)}}return E}}e.ImplicitActivationEventsImpl=f,e.ImplicitActivationEvents=new f}),define(ye[256],Ce([1,0,11,22,21,14,4,3,58,38,30,82,64,65]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var c;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const W=new f.CancellationTokenSource;return setTimeout(()=>W.cancel(),q),W.token}function i(q,W){if(q.isCancellationRequested||W.isCancellationRequested)return f.CancellationToken.Cancelled;const ie=new f.CancellationTokenSource;return q.onCancellationRequested(()=>ie.cancel()),W.onCancellationRequested(()=>ie.cancel()),ie.token}class r{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((ie,Se)=>{this._resolvePromise=ie,this._rejectPromise=Se}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function n(q,W){const ie=new r(W);return ie.registerDisposable(q.onControlMessage(Se=>{const he=JSON.parse(Se.toString()),fe=K(he);fe?ie.reject(fe):ie.resolve(he)})),ie.promise}function a(q,W,ie,Se,he,fe,Z,ee){const j=new r(ee),J=y.StopWatch.create(!1);return q.info(`Creating a socket (${Z})...`),p.mark(`code/willCreateSocket/${fe}`),W.connect(ie,Se,he,Z).then(ge=>{j.didTimeout?(p.mark(`code/didCreateSocketError/${fe}`),q.info(`Creating a socket (${Z}) finished after ${J.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(p.mark(`code/didCreateSocketOK/${fe}`),q.info(`Creating a socket (${Z}) was successful after ${J.elapsed()} ms.`),j.resolve(ge))},ge=>{p.mark(`code/didCreateSocketError/${fe}`),q.info(`Creating a socket (${Z}) returned an error after ${J.elapsed()} ms.`),q.error(ge),j.reject(ge)}),j.promise}function t(q,W){const ie=new r(W);return q.then(Se=>{ie.didTimeout||ie.resolve(Se)},Se=>{ie.didTimeout||ie.reject(Se)}),ie.promise}async function d(q,W,ie,Se){const he=pe(q,W);q.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let fe;try{fe=await a(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,S.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,m(W),`renderer-${m(W)}-${q.reconnectionToken}`,Se)}catch(ge){throw q.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ge),ge}q.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let Z,ee;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(fe,null),Z=q.reconnectionProtocol,ee=!1):(Z=new D.PersistentProtocol({socket:fe}),ee=!0),q.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const j=await t(q.signService.createNewMessage((0,R.generateUuid)()),Se),J={type:"auth",auth:q.connectionToken||"00000000000000000000",data:j.data};Z.sendControl(F.VSBuffer.fromString(JSON.stringify(J)));try{const ge=await n(Z,i(Se,o(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(q.logService.trace(`${he} 4/6. received SignRequest control message.`),!await t(q.signService.validate(j,ge.signedData),Se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ae=await t(q.signService.sign(ge.data),Se),Ee={type:"connectionType",commit:q.commit,signedData:Ae,desiredConnectionType:W};return ie&&(Ee.args=ie),q.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(F.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:Z,ownsProtocol:ee}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(q.logService.error(`${he} the handshake timed out. Error:`),q.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${he} received error control message when negotiating connection. Error:`),q.logService.error(ge)),ee&&Y(Z),ge}}async function s(q,W,ie,Se){const he=Date.now(),fe=pe(q,W),{protocol:Z,ownsProtocol:ee}=await d(q,W,ie,Se),j=new r(Se);return j.registerDisposable(Z.onControlMessage(J=>{const ge=JSON.parse(J.toString()),we=K(ge);we?(q.logService.error(`${fe} received error control message when negotiating connection. Error:`),q.logService.error(we),ee&&Y(Z),j.reject(we)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${oe(he)}!`),j.resolve({protocol:Z,firstMessage:ge}))})),j.promise}async function h(q,W){const{protocol:ie}=await s(q,1,void 0,W);return{protocol:ie}}async function l(q,W,ie){const{protocol:Se,firstMessage:he}=await s(q,2,W,ie),fe=he&&he.debugPort;return{protocol:Se,debugPort:fe}}async function u(q,W,ie){const Se=Date.now(),he=pe(q,3),{protocol:fe}=await d(q,3,W,ie);return q.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${oe(Se)}!`),fe}async function w(q,W,ie){const{connectTo:Se,connectionToken:he}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:Se,connectionToken:he,reconnectionToken:W,reconnectionProtocol:ie,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function k(q,W,ie){return g(q,async Se=>{const{protocol:he}=await h(Se,f.CancellationToken.None);return new G(q,W,ie,Se.reconnectionToken,he)})}e.connectRemoteAgentManagement=k;async function b(q,W){return g(q,async ie=>{const{protocol:Se,debugPort:he}=await l(ie,W,f.CancellationToken.None);return new le(q,W,ie.reconnectionToken,Se,he)})}e.connectRemoteAgentExtensionHost=b;async function g(q,W){for(let Se=1;;Se++)try{const he=(0,R.generateUuid)(),fe=await w(q,he,null);return await W(fe)}catch(he){if(Se<5)q.logService.error(`[remote-connection][attempt ${Se}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(he);else throw q.logService.error(`[remote-connection][attempt ${Se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(he),B.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(he)),he}}async function _(q,W,ie){const Se=await w(q,(0,R.generateUuid)(),null);return await u(Se,{host:W,port:ie},f.CancellationToken.None)}e.connectRemoteAgentTunnel=_;function T(q){return(0,I.createCancelablePromise)(W=>new Promise((ie,Se)=>{const he=setTimeout(ie,q*1e3);W.onCancellationRequested(()=>{clearTimeout(he),ie()})}))}var O;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class x{constructor(W,ie){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.type=0}}e.ConnectionLostEvent=x;class N{constructor(W,ie,Se,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.durationSeconds=Se,this.cancellableTimer=he,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class M{constructor(W,ie,Se){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=Se,this.type=2}}e.ReconnectionRunningEvent=M;class L{constructor(W,ie,Se){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=Se,this.type=4}}e.ConnectionGainEvent=L;class U{constructor(W,ie,Se,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=Se,this.handled=he,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class B extends E.Disposable{static triggerPermanentFailure(W,ie,Se){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=ie,this._permanentFailureHandled=Se,this._instances.forEach(he=>he._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||B._permanentFailure}constructor(W,ie,Se,he,fe){super(),this._connectionType=W,this._options=ie,this.reconnectionToken=Se,this.protocol=he,this._reconnectionFailureIsFatal=fe,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new L(this.reconnectionToken,0,0)),this._register(he.onSocketClose(Z=>{const ee=ne(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${ee} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${ee} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${ee} received socket close event.`),this._beginReconnecting()})),this._register(he.onSocketTimeout(Z=>{const ee=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),B._instances.push(this),this._register((0,E.toDisposable)(()=>{const Z=B._instances.indexOf(this);Z>=0&&B._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(B._permanentFailureMillisSinceLastIncomingData,B._permanentFailureAttempt,B._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let Se=-1;do{Se++;const he=Se<ie.length?ie[Se]:ie[ie.length-1];try{if(he>0){const Z=T(he);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,Z)),this._options.logService.info(`${W} waiting for ${he} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1)),this._options.logService.info(`${W} resolving connection...`);const fe=await w(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${fe.connectTo}...`),await this._reconnect(fe,o(C)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1));break}catch(fe){if(fe.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(fe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(Se>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(fe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(fe)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(fe);continue}if((fe.code==="ETIMEDOUT"||fe.code==="ENETUNREACH"||fe.code==="ECONNREFUSED"||fe.code==="ECONNRESET")&&fe.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(fe);continue}if((0,P.isCancellationError)(fe)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(fe);continue}if(fe instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(fe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,v.RemoteAuthorityResolverError.isHandled(fe));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(fe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,ie,Se){this._reconnectionFailureIsFatal?B.triggerPermanentFailure(W,ie,Se):this._gotoPermanentFailure(W,ie,Se)}_gotoPermanentFailure(W,ie,Se){this._onDidStateChange.fire(new U(this.reconnectionToken,W,ie,Se)),Y(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=B;class G extends B{constructor(W,ie,Se,he,fe){super(1,W,he,fe,!0),this.client=this._register(new D.Client(fe,{remoteAuthority:ie,clientId:Se},W.ipcLogger))}async _reconnect(W,ie){await h(W,ie)}}e.ManagementPersistentConnection=G;class le extends B{constructor(W,ie,Se,he,fe){super(2,W,Se,he,!1),this._startArguments=ie,this.debugPort=fe}async _reconnect(W,ie){await l(W,this._startArguments,ie)}}e.ExtensionHostPersistentConnection=le;function Y(q){try{q.acceptDisconnect();const W=q.getSocket();q.dispose(),W.dispose()}catch(W){(0,P.onUnexpectedError)(W)}}function K(q){if(q&&q.type==="error"){const W=new Error(`Connection error: ${q.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Q(q,W){for(;q.length<W;)q+=" ";return q}function ue(q,W){return`[remote-connection][${Q(m(q),13)}][${W.substr(0,5)}\u2026]`}function ne(q,W,ie){return`${ue(q,W)}[${ie?"reconnect":"initial"}]`}function pe(q,W){return`${ne(W,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function oe(q){return`${Date.now()-q} ms`}}),define(ye[257],Ce([1,0,3,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,F.createDecorator)("remoteSocketFactoryService");class f{constructor(){this.factories={}}register(A,E){return this.factories[A]??=[],this.factories[A].push(E),(0,I.toDisposable)(()=>{const p=this.factories[A]?.indexOf(E);typeof p=="number"&&p>=0&&this.factories[A]?.splice(p,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(p=>p.supports(A))}connect(A,E,p,y){const R=this.getSocketFactory(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,E,p,y)}}e.RemoteSocketFactoryService=f}),define(ye[258],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(f){try{const P=await this.getValidator();if(P){const A=String(I._nextId++);return this.validators.set(A,P),{id:A,data:P.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,P){if(!f.id)return!0;const A=this.validators.get(f.id);if(!A)return!1;this.validators.delete(f.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.signValue(f)}catch{}return f}}e.AbstractSignService=I}),define(ye[109],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ye[138],Ce([1,0,258]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class F extends I.AbstractSignService{getValidator(){return this.vsda().then(P=>new P.validator)}signValue(P){return this.vsda().then(A=>new A.signer().sign(P))}vsda(){return new Promise((P,A)=>me(["vsda"],P,A))}}e.SignService=F}),define(ye[259],Ce([1,0,10,49,30]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(p){if(I.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,y,R,D,v,S,C,c,m){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=C,o.sessionID=(0,f.generateUuid)()+Date.now(),o.commitHash=D,o.version=v,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,I.PlatformToString)(I.platform),o["common.nodePlatform"]=F.platform,o["common.nodeArch"]=R,o["common.product"]=m||"desktop",c&&(o["common.msftInternal"]=c);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.isLinuxSnap&&(o["common.snap"]="true");const n=P(y);return n&&(o["common.platformDetail"]=n),o}e.resolveCommonProperties=A;function E(p){const y=F.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return p.some(D=>R===D)}e.verifyMicrosoftInternalDomain=E}),define(ye[260],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var F;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ye[88],Ce([1,0,24,18,65,259,260]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class E{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=E;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class y{async publicLog(d,s,h){}async publicLogError(d,s,h){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=R;function D(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=D;function v(t){const d=t.getValue(A.TELEMETRY_SETTING_ID),s=t.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function S(t){const d={},s={},h={};m(t,h);for(let l in h){l=l.length>150?l.substr(l.length-149):l;const u=h[l];typeof u=="number"?s[l]=u:typeof u=="boolean"?s[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),d[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(d[l]=u)}return{properties:d,measurements:s}}e.validateTelemetryData=S;const C=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const d=(0,f.getRemoteName)(t);return C.has(d)?d:"other"}e.cleanRemoteAuthority=c;function m(t,d,s=0,h){if(t)for(const l of Object.getOwnPropertyNames(t)){const u=t[l],w=h?h+l:l;Array.isArray(u)?d[w]=(0,I.safeStringify)(u):u instanceof Date?d[w]=u.toISOString():(0,F.isObject)(u)?s<2?m(u,d,s+1,w+"."):d[w]=(0,I.safeStringify)(u):d[w]=u}}function o(t,d){const s=t.msftInternalDomains||[],h=d.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(s)||h}e.isInternalTelemetry=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=i;function r(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const h=[];for(const k of d)for(;;){const b=k.exec(t);if(!b)break;h.push([b.index,k.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const k=u.exec(t);if(!k)break;const b=h.some(([g,_])=>k.index<_&&g<u.lastIndex);!l.test(k[0])&&!b&&(s+=t.substring(w,k.index)+"<REDACTED: user-file-path>",w=u.lastIndex)}return w<t.length&&(s+=t.substr(w)),s}function n(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of d)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,d){return(0,I.cloneAndChange)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let h=s.replaceAll("%20"," ");h=r(h,d);for(const l of d)h=h.replace(l,"");return h=n(h),h}})}e.cleanData=a}),define(ye[261],Ce([1,0,12,134,25,10,2,14,49,88]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,h){return s.uuid&&h.uuid?s.uuid===h.uuid:s.id===h.id?!0:(0,I.compareIgnoreCase)(s.id,h.id)===0}e.areSameExtensions=R;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(h){const l=h.manifest?h.manifest.version:h.version,u=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new v(h.identifier,l,u)}static parse(h){const l=D.exec(h);return l&&l[1]&&l[2]?new v({id:l[1]},l[2],l[4]||void 0):null}constructor(h,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof v?R(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.ExtensionKey=v;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const h=S.exec(s);return h&&h[1]?[m(h[1]),h[2]]:[m(s),void 0]}e.getIdAndVersion=C;function c(s,h){return`${s}.${h}`}e.getExtensionId=c;function m(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=m;function o(s,h){return m(c(s??f.UNDEFINED_PUBLISHER,h))}e.getGalleryExtensionId=o;function i(s,h){const l=[],u=w=>{for(const k of l)if(k.some(b=>R(h(b),h(w))))return k;return null};for(const w of s){const k=u(w);k?k.push(w):l.push([w])}return l}e.groupByExtension=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function n(s){return{id:new y.TelemetryTrustedValue(s.identifier.id),name:new y.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=n,e.BetterMergeId=new f.ExtensionIdentifier("pprice.better-merge");function a(s,h){const l=[],u=h.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const w=u.shift();if(w&&l.every(k=>!R(k.identifier,{id:w}))){const k=s.filter(b=>R(b.identifier,{id:w}));k.length===1&&(l.push(k[0]),u.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=a;async function t(s,h){if(!P.isLinux)return!1;let l;try{l=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){h.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(w))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(s,h){const l=await t(s,h),u=(0,F.getTargetPlatform)(l?"alpine":P.platform,p.arch);return h.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=d}),define(ye[262],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=I;function F(p){return p?[...p.entries()]:[]}e.serializeEnvironmentDescriptionMap=F;function f(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=f;function P(p){return new Map(p??[])}e.deserializeEnvironmentDescriptionMap=P;function A(p){return Array.from(p.entries()).map(y=>[y[0],I(y[1].map),F(y[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function E(p){return new Map(p.map(y=>[y[0],{map:f(y[1]),descriptionMap:P(y[2])}]))}e.deserializeEnvironmentVariableCollections=E}),define(ye[263],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(f){this._callback=f,this._terminalBufferMap=new Map}dispose(){for(const f of this._terminalBufferMap.values())f.dispose()}startBuffering(f,P,A=5){const E=P(p=>{const y=typeof p=="string"?p:p.data;let R=this._terminalBufferMap.get(f);if(R){R.data.push(y);return}const D=setTimeout(()=>this.flushBuffer(f),A);R={data:[y],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(f),E.dispose()}},this._terminalBufferMap.set(f,R)});return E}stopBuffering(f){this._terminalBufferMap.get(f)?.dispose()}flushBuffer(f){const P=this._terminalBufferMap.get(f);P&&(this._terminalBufferMap.delete(f),this._callback(f,P.data.join("")))}}e.TerminalDataBufferer=I}),define(ye[264],Ce([1,0,11,78,55,4,18,2,207,108,37]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(n){function a(t,d){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const h=C.getIcon(s.id);if(!h)return;s=h.defaults}return s}n.getDefinition=a})(D||(e.IconContribution=D={}));var v;(function(n){function a(d){return{weight:d.weight,style:d.style,src:d.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=a;function t(d){const s=h=>(0,A.isString)(h)?h:void 0;if(d&&Array.isArray(d.src)&&d.src.every(h=>(0,A.isString)(h.format)&&(0,A.isString)(h.location)))return{weight:s(d.weight),style:s(d.style),src:d.src.map(h=>({format:h.format,location:E.URI.parse(h.location)}))}}n.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class S{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(a,t,d,s){const h=this.iconsById[a];if(h){if(d&&!h.description){h.description=d,this.iconSchema.properties[a].markdownDescription=`${d} $(${a})`;const w=this.iconReferenceSchema.enum.indexOf(a);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=d),this._onDidChange.fire()}return h}const l={id:a,description:d,defaults:t,deprecationMessage:s};this.iconsById[a]=l;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),d&&(u.markdownDescription=`${d}: $(${a})`),this.iconSchema.properties[a]=u,this.iconReferenceSchema.enum.push(a),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:a}}deregisterIcon(a){delete this.iconsById[a],delete this.iconSchema.properties[a];const t=this.iconReferenceSchema.enum.indexOf(a);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(a=>this.iconsById[a])}getIcon(a){return this.iconsById[a]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(a,t){const d=this.iconFontsById[a];return d||(this.iconFontsById[a]=t,this._onDidChange.fire(),t)}deregisterIconFont(a){delete this.iconFontsById[a]}getIconFont(a){return this.iconFontsById[a]}toString(){const a=(h,l)=>h.id.localeCompare(l.id),t=h=>{for(;f.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of s.filter(l=>!!l.description).sort(a))d.push(`|<i class="${t(h)}"></i>|${h.id}|${f.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const h of s.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(a))d.push(`|<i class="${t(h)}"></i>|${h.id}|`);return d.join(`
`)}}const C=new S;R.Registry.add(e.Extensions.IconContribution,C);function c(n,a,t,d){return C.registerIcon(n,a,t,d)}e.registerIcon=c;function m(){return C}e.getIconRegistry=m;function o(){const n=(0,F.getCodiconFontCharacters)();for(const a in n){const t="\\"+n[a].toString(16);C.registerIcon(a,{fontCharacter:t})}}o(),e.iconsSchemaId="vscode://schemas/icons";const i=R.Registry.as(y.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,C.getIconSchema());const r=new I.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.widgetClose=c("widget-close",F.Codicon.close,(0,p.localize)(2,null)),e.gotoPreviousLocation=c("goto-previous-location",F.Codicon.arrowUp,(0,p.localize)(3,null)),e.gotoNextLocation=c("goto-next-location",F.Codicon.arrowDown,(0,p.localize)(4,null)),e.syncing=f.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=f.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(ye[89],Ce([1,0,4,51,5,13]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,f.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,f.createDecorator)("sharedTunnelsService");var A;(function(m){m.Http="http",m.Https="https"})(A||(e.TunnelProtocol=A={}));var E;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(E||(e.TunnelPrivacyId=E={}));function p(m){return!!m.forwardPort}e.isTunnelProvider=p;var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=v;function S(m,o,i,r){if(i===1)return!1;if(i===2&&v(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return m<1024}e.isPortPrivileged=S;class C{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this._dispose=r,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let c=class{constructor(o,i){this.logService=o,this.configurationService=i,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions,this._canChangeProtocol=o.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],i=Array.from(this._tunnels.values());for(const r of i){const n=Array.from(r.values());for(const a of n){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,i,r,n,a){this.addTunnelToMap(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(v(o)||D(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const r=this.getTunnelFromMap(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,a,t=!1,d,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${a}.`);const h=this._tunnelProvider??o;if(!h)return;if(i||(i="localhost"),n||(n=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(r)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.retainOrCreateTunnel(h,i,r,n,a,t,d,s);return l?l.then(u=>{if(u){if(typeof u=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(i,r),u}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(i,r);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.makeTunnel(u);return(u.tunnelRemoteHost!==i||u.tunnelRemotePort!==r)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&u.privacy!==d&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(w),w}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this._tunnels.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async tryDisposeTunnel(o,i,r){if(r.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(i),n}}async closeTunnel(o,i){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this._tunnels.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.tryDisposeTunnel(o,i,n)}}addTunnelToMap(o,i,r){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(i,{refcount:1,value:r})}async removeEmptyOrErrorTunnelFromMap(o,i){const r=this._tunnels.get(o);if(r){const n=r.get(i),a=n?await n.value:void 0;(!a||typeof a=="string")&&r.delete(i),r.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,i){const r=[o];D(o)?(r.push(...e.LOCALHOST_ADDRESSES),r.push(...e.ALL_INTERFACES_ADDRESSES)):v(o)&&r.push(...e.ALL_INTERFACES_ADDRESSES);const n=r.map(a=>this._tunnels.get(a));for(const a of n){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!R(o)}createWithProvider(o,i,r,n,a,t,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this._factoryInProgress.add(s);const h=n===void 0?r:n,l={elevationRequired:a?this.isPortPrivileged(h):!1},u={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==E.Private:void 0,protocol:d},w=o.forwardPort(u,l);return w?(this.addTunnelToMap(i,r,w),w.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),w}};e.AbstractTunnelService=c,e.AbstractTunnelService=c=je([$e(0,P.ILogService),$e(1,F.IConfigurationService)],c)}),define(ye[265],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ye[266],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ye[267],Ce([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function F(p){return p.scheme!==I.Schemas.file&&p.scheme!==I.Schemas.vscodeRemote}e.isVirtualResource=F;function f(p){if(p.folders.length)return p.folders.every(y=>F(y.uri))?p.folders[0].uri:void 0;if(p.configuration&&F(p.configuration))return p.configuration}e.getVirtualWorkspaceLocation=f;function P(p){return f(p)?.scheme}e.getVirtualWorkspaceScheme=P;function A(p){return f(p)?.authority}e.getVirtualWorkspaceAuthority=A;function E(p){return f(p)!==void 0}e.isVirtualWorkspace=E}),define(ye[40],Ce([1,0,209,17,77,23,2,5,16]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function y(h){const l=h;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=y;function R(h){return typeof h?.id=="string"&&!y(h)&&!v(h)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(h,l){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,F.basename)(h)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=h;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.toWorkspaceIdentifier=D;function v(h){const l=h;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=v;function S(h){const l=h;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const u=h;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(h?.id)return{id:h.id}}e.reviveIdentifier=S;var C;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function c(h){const l=h;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=c;function m(h){const l=h;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=m;class o{constructor(l,u,w,k,b){this._id=l,this._transient=w,this._configuration=k,this._ignorePathCasing=b,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class i{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function r(h){return new i({uri:h,index:0,name:(0,P.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=r,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function n(h,l){return P.extUriBiasedIgnorePathCase.isEqualOrParent(h,l.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function a(h){let l;return A.URI.isUri(h)?l=h:l=h.configuration,l?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function d(h,l){return!n(h,l)&&!a(h)}e.isSavedWorkspace=d;function s(h){return(typeof h=="string"?(0,F.extname)(h):(0,P.extname)(h))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[268],Ce([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var r;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(h){const l=h;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.isUserDataProfile=n,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function a(h,l){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:A.URI.revive(h.location).with({scheme:l}),globalStorageHome:A.URI.revive(h.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(h.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(h.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(h.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(h.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(h.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(h.cacheHome).with({scheme:l}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}e.reviveProfile=a;function t(h,l,u,w,k,b){return{id:h,name:l,location:u,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:b&&k?.useDefaultFlags?.globalState?b.globalStorageHome:(0,P.joinPath)(u,"globalStorage"),settingsResource:b&&k?.useDefaultFlags?.settings?b.settingsResource:(0,P.joinPath)(u,"settings.json"),keybindingsResource:b&&k?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,P.joinPath)(u,"keybindings.json"),tasksResource:b&&k?.useDefaultFlags?.tasks?b.tasksResource:(0,P.joinPath)(u,"tasks.json"),snippetsHome:b&&k?.useDefaultFlags?.snippets?b.snippetsHome:(0,P.joinPath)(u,"snippets"),extensionsResource:b&&k?.useDefaultFlags?.extensions?b.extensionsResource:(0,P.joinPath)(u,"extensions.json"),cacheHome:(0,P.joinPath)(w,h),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.toUserDataProfile=t;let d=class extends f.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(l,u,w,k){super(),this.environmentService=l,this.fileService=u,this.uriIdentityService=w,this.logService=k,this.enabled=!0,this._onDidChangeProfiles=this._register(new F.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new F.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new F.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new F.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,P.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,P.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(l){this.enabled!==l&&(this._profilesObject=void 0,this.enabled=l)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const l=this.createDefaultProfile(),u=[l];if(this.enabled)try{for(const b of this.getStoredProfiles()){if(!b.name||!(0,i.isString)(b.name)||!b.location){this.logService.warn("Skipping the invalid stored profile",b.location||b.name);continue}u.push(t((0,P.basename)(b.location),b.name,b.location,this.profilesCacheHome,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},l))}}catch(b){this.logService.error(b)}const w=new S.ResourceMap,k=new Map;if(u.length)try{const b=this.getStoredProfileAssociations();if(b.workspaces)for(const[g,_]of Object.entries(b.workspaces)){const T=A.URI.parse(g),O=u.find(x=>x.id===_);O&&w.set(T,O)}if(b.emptyWindows)for(const[g,_]of Object.entries(b.emptyWindows)){const T=u.find(O=>O.id===_);T&&k.set(g,T)}}catch(b){this.logService.error(b)}this._profilesObject={profiles:u,workspaces:w,emptyWindows:k}}return this._profilesObject}createDefaultProfile(){const l=t("__default__profile__",(0,E.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",w=new RegExp(`${(0,o.escapeRegExpCharacters)(u)}\\s(\\d+)`);let k=0;for(const g of this.profiles){const _=w.exec(g.name),T=_?parseInt(_[1]):0;k=T>k?T:k}const b=`${u} ${k+1}`;return this.createProfile((0,I.hash)((0,m.generateUuid)()).toString(16),b,{transient:!0},l)}async createNamedProfile(l,u,w){return this.createProfile((0,I.hash)((0,m.generateUuid)()).toString(16),l,u,w)}async createProfile(l,u,w,k){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const b=await this.doCreateProfile(l,u,w);return k&&await this.setProfileForWorkspace(k,b),b}async doCreateProfile(l,u,w){if(!(0,i.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.profileCreationPromises.get(u);return k||(k=(async()=>{try{const b=this.profiles.find(T=>T.name===u||T.id===l);if(b)return b;const g=t(l,u,(0,P.joinPath)(this.profilesHome,l),this.profilesCacheHome,w,this.defaultProfile);await this.fileService.createFolder(g.location);const _=[];return this._onWillCreateProfile.fire({profile:g,join(T){_.push(T)}}),await c.Promises.settled(_),this.updateProfiles([g],[],[]),g}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,k)),k}async updateProfile(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(k=>k.id===l.id);if(!w)throw new Error(`Profile '${l.name}' does not exist`);return w=t(w.id,u.name??w.name,w.location,this.profilesCacheHome,{shortName:u.shortName??w.shortName,icon:u.icon===null?void 0:u.icon??w.icon,transient:u.transient??w.isTransient,useDefaultFlags:u.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[w]),w}async removeProfile(l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(k=>k.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const w=[];this._onWillRemoveProfile.fire({profile:u,join(k){w.push(k)}});try{await Promise.allSettled(w)}catch(k){this.logService.error(k)}for(const k of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(k)?.id&&this.profilesObject.emptyWindows.delete(k);for(const k of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(k)?.id&&this.profilesObject.workspaces.delete(k);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(k){(0,y.toFileOperationResult)(k)!==1&&this.logService.error(k)}}async setProfileForWorkspace(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(k=>k.id===u.id);if(!w)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(l,w)}unsetWorkspace(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(l,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const l=await this.fileService.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(w=>!this.uriIdentityService.extUri.isEqual(w.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const l=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.getWorkspace(l);return A.URI.isUri(u)?this.transientProfilesObject.workspaces.get(u)??this.profilesObject.workspaces.get(u):this.transientProfilesObject.emptyWindows.get(u)??this.profilesObject.emptyWindows.get(u)}getWorkspace(l){return(0,v.isSingleFolderWorkspaceIdentifier)(l)?l.uri:(0,v.isWorkspaceIdentifier)(l)?l.configPath:l.id}isProfileAssociatedToWorkspace(l){return!!([...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location)))}updateProfiles(l,u,w){const k=[...this.profiles,...l],b=[];this.transientProfilesObject.profiles=[];for(let g of k)g.isDefault||u.some(_=>g.id===_.id)||(g=w.find(_=>g.id===_.id)??g,g.isTransient?this.transientProfilesObject.profiles.push(g):b.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.saveStoredProfiles(b),this._profilesObject=void 0,this.triggerProfilesChanges(l,u,w)}triggerProfilesChanges(l,u,w){this._onDidChangeProfiles.fire({added:l,removed:u,updated:w,all:this.profiles})}updateWorkspaceAssociation(l,u,w){w=u?.isTransient?!0:w,w||this.updateWorkspaceAssociation(l,void 0,!0);const k=this.getWorkspace(l),b=w?this.transientProfilesObject:this.profilesObject;A.URI.isUri(k)?(b.workspaces.delete(k),u&&b.workspaces.set(k,u)):(b.emptyWindows.delete(k),u&&b.emptyWindows.set(k,u)),w||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const l={};for(const[w,k]of this.profilesObject.workspaces.entries())l[w.toString()]=k.id;const u={};for(const[w,k]of this.profilesObject.emptyWindows.entries())u[w.toString()]=k.id;this.saveStoredProfileAssociations({workspaces:l,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(l){const u={},w=this.createDefaultProfile();if(l.workspaces)for(const[b,g]of Object.entries(l.workspaces)){const _=A.URI.parse(g);u[b]=this.uriIdentityService.extUri.isEqual(_,w.location)?w.id:this.uriIdentityService.extUri.basename(_)}const k={};if(l.emptyWindows)for(const[b,g]of Object.entries(l.emptyWindows)){const _=A.URI.parse(g);k[b]=this.uriIdentityService.extUri.isEqual(_,w.location)?w.id:this.uriIdentityService.extUri.basename(_)}return{workspaces:u,emptyWindows:k}}getStoredProfiles(){return[]}saveStoredProfiles(l){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(l){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=d,e.UserDataProfilesService=d=je([$e(0,p.IEnvironmentService),$e(1,y.IFileService),$e(2,C.IUriIdentityService),$e(3,D.ILogService)],d);class s extends d{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(l){this.storedProfiles=l}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(l){this.storedProfileAssociations=l}}e.InMemoryUserDataProfilesService=s}),define(ye[269],Ce([1,0,11,4,3,58,18,188,5,268]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var v;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function S(i){const r=i.get(e.TARGET_KEY);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.loadKeyTargets=S;class C extends f.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(r={flushInterval:C.DEFAULT_FLUSH_INTERVAL}){super(),this.options=r,this._onDidChangeValue=this._register(new F.PauseableEmitter),this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new f.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(r,n,a){return F.Event.filter(this._onDidChangeValue.event,t=>t.scope===r&&(n===void 0||t.key===n),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,f.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(r,n){const{key:a,external:t}=n;if(a===e.TARGET_KEY){switch(r){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:r})}else this._onDidChangeValue.fire({scope:r,key:a,target:this.getKeyTargets(r)[a],external:t})}emitWillSaveState(r){this._onWillSaveState.fire({reason:r})}get(r,n,a){return this.getStorage(n)?.get(r,a)}getBoolean(r,n,a){return this.getStorage(n)?.getBoolean(r,a)}getNumber(r,n,a){return this.getStorage(n)?.getNumber(r,a)}getObject(r,n,a){return this.getStorage(n)?.getObject(r,a)}storeAll(r,n){this.withPausedEmitters(()=>{for(const a of r)this.store(a.key,a.value,a.scope,a.target,n)})}store(r,n,a,t,d=!1){if((0,A.isUndefinedOrNull)(n)){this.remove(r,a,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(r,a,t),this.getStorage(a)?.set(r,n,d)})}remove(r,n,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(r,n,void 0),this.getStorage(n)?.delete(r,a)})}withPausedEmitters(r){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{r()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(r,n){const a=[],t=this.getKeyTargets(r);for(const d of Object.keys(t))t[d]===n&&a.push(d);return a}updateKeyTarget(r,n,a,t=!1){const d=this.getKeyTargets(n);typeof a=="number"?d[r]!==a&&(d[r]=a,this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(d),t)):typeof d[r]=="number"&&(delete d[r],this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(d),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(r){switch(r){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(r){const n=this.getStorage(r);return n?S(n):Object.create(null)}isNew(r){return this.getBoolean(e.IS_NEW_KEY,r)===!0}async flush(r=R.NONE){this._onWillSaveState.fire({reason:r});const n=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(r){case R.NONE:await I.Promises.settled([n?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([n?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.getStorage(-1)?.items??new Map,n=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return o(r,n,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(r){return await this.flush(),this.getStorage(r)?.optimize()}async switch(r,n){return this.emitWillSaveState(R.NONE),(0,y.isUserDataProfile)(r)?this.switchToProfile(r,n):this.switchToWorkspace(r,n)}canSwitchProfile(r,n){return!(r.id===n.id||c(n)&&c(r))}switchData(r,n,a){this.withPausedEmitters(()=>{const t=new Set;for(const[d,s]of r)t.add(d),n.get(d)!==s&&this.emitDidChangeValue(a,{key:d,external:!0});for(const[d]of n.items)t.has(d)||this.emitDidChangeValue(a,{key:d,external:!0})})}}e.AbstractStorageService=C;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=c;class m extends C{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(r=>this.emitDidChangeValue(1,r))),this._register(this.profileStorage.onDidChangeStorage(r=>this.emitDidChangeValue(0,r))),this._register(this.applicationStorage.onDidChangeStorage(r=>this.emitDidChangeValue(-1,r)))}getStorage(r){switch(r){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(r){return!1}}e.InMemoryStorageService=m;async function o(i,r,n,a,t,d){const s=T=>{try{return JSON.parse(T)}catch{return T}},h=new Map,l=new Map;i.forEach((T,O)=>{h.set(O,T),l.set(O,s(T))});const u=new Map,w=new Map;r.forEach((T,O)=>{u.set(O,T),w.set(O,s(T))});const k=new Map,b=new Map;n.forEach((T,O)=>{k.set(O,T),b.set(O,s(T))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const g=[];if(h.forEach((T,O)=>{g.push({key:O,value:T})}),console.table(g),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];u.forEach((O,x)=>{T.push({key:x,value:O})}),console.table(T),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${d})`);const _=[];k.forEach((T,O)=>{_.push({key:O,value:T})}),console.table(_),console.groupEnd(),console.log(b)}e.logStorage=o}),define(ye[110],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(f){this.id=f,this._data=new Map,this._idPool=1}add(f){const P=this._idPool++;return this._data.set(P,f),this.logDebugInfo(),P}get(f,P){return this._data.has(f)?this._data.get(f)[P]:void 0}delete(f){this._data.delete(f),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(ye[59],Ce([1,0,16,23,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(E=>{const p=this._providerInfo.get(E.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(E,p){p===null?this._providerInfo.delete(E.scheme):this._providerInfo.set(E.scheme,p)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,f.createDecorator)("IExtHostFileSystemInfo")}),define(ye[27],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(ye[270],Ce([1,0,214,13,250,27]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends f.LogService{constructor(p,y,R){const D=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",v=R.remote.isRemote?(0,I.localize)(0,null):p?(0,I.localize)(1,null):(0,I.localize)(2,null);super(y.createLogger(D,{name:v}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([$e(1,F.ILoggerService),$e(2,P.IExtHostInitDataService)],A)}),define(ye[271],Ce([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,E,p){this._deferredPromises=new Map,this._id=A,this._shared=E,this._storage=p,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of y.values())R.complete()}catch(R){for(const D of y.values())D.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,E){let p=this._value[A];return typeof p>"u"&&(p=E),p}update(A,E){this._value[A]=E;const p=this._deferredPromises.get(A);if(p!==void 0)return p.p;const y=new I.DeferredPromise;return this._deferredPromises.set(A,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class f extends F{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,E){super(A.identifier.value,!0,E),this._extension=A}}e.ExtensionGlobalMemento=f}),define(ye[272],Ce([1,0,4,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class f{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,E,p,y){const D=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(E.value,p,y);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(A,E){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptDirty(E)}$acceptModelSaved(A){const E=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}}e.ExtHostNotebookDocuments=f}),define(ye[20],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class F{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=F}),define(ye[273],Ce([1,0,25,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class f{#e;constructor(A,E){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(A.identifier),this.#e=E,this.#e.onDidChangePassword(p=>{p.extensionId===this._id&&this._onDidChange.fire({key:p.key})})}get(A){return this.#e.get(this._id,A)}store(A,E){return this.#e.store(this._id,A,E)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=f}),define(ye[66],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class F{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(ye[274],Ce([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(p){let y=this.buffers.indexOf(p);return y<0&&(y=this.buffers.length,this.buffers.push(p)),y}}function f(E,p){if(p.serializeBuffersForPostMessage){const y=new F,D=JSON.stringify(E,(S,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(C)};if(ArrayBuffer.isView(C)){const c=P(C);if(c)return{$$vscode_array_buffer_reference$$:!0,index:y.add(C.buffer),view:{type:c,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),v=y.buffers.map(S=>{const C=new Uint8Array(S);return I.VSBuffer.wrap(C)});return{message:D,buffers:v}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeWebviewMessage=f;function P(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(E,p){const y=p.map(v=>{const S=new ArrayBuffer(v.byteLength);return new Uint8Array(S).set(v.buffer),S}),R=p.length?(v,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const C=S,{index:c}=C,m=y[c];if(C.view)switch(C.view.type){case 1:return new Int8Array(m,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return S}:void 0;return{message:JSON.parse(E,R),arrayBuffers:y}}e.deserializeWebviewMessage=A}),define(ye[275],Ce([1,0,276,389,390,62,2,13,391]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const y=!1;function R(r,n,a,t,d,s){const h=s.environment.useHostProxy,l=typeof h=="boolean"?h:!s.remote.isRemote,u={resolveProxy:b=>r.resolveProxy(b),lookupProxyAuthorization:m.bind(void 0,t,d,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>v(n),addCertificatesV2:()=>S(n),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case E.LogLevel.Trace:return p.LogLevel.Trace;case E.LogLevel.Debug:return p.LogLevel.Debug;case E.LogLevel.Info:return p.LogLevel.Info;case E.LogLevel.Warning:return p.LogLevel.Warning;case E.LogLevel.Error:return p.LogLevel.Error;case E.LogLevel.Off:return p.LogLevel.Off;default:return g(b)}function g(_){return t.error("Unknown log level",_),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const b=[];if(s.remote.isRemote&&b.push((0,p.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const g=r.loadCertificates();g.then(_=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",_.length)),b.push(g)}return(await Promise.all(b)).flat()},env:process.env},w=(0,p.createProxyResolver)(u),k=D(u,w);return c(a,k)}e.connectProxyResolver=R;function D(r,n){return{http:Object.assign(I,(0,p.createHttpPatch)(r,I,n)),https:Object.assign(F,(0,p.createHttpPatch)(r,F,n)),net:Object.assign(P,(0,p.createNetPatch)(r,P)),tls:Object.assign(f,(0,p.createTlsPatch)(r,f))}}function v(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function S(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const C=new Map;function c(r,n){return r.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(h,l,u){if(h==="net")return n.net;if(h==="tls")return n.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const w=a.findSubstr(A.URI.file(l.filename));let k=C.get(w);if(k||C.set(w,k={}),!k[h]){const b=n[h];k[h]={...b}}return k[h]}})}async function m(r,n,a,t,d,s,h,l){const u=t[s];h&&(t[s]=h),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${u}`);const w=h||u,k=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(i(n,k,d),k.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const b=await new Promise((x,N)=>{me(["kerberos"],x,N)}),g=new URL(s),_=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${_}`),"Negotiate "+await(await b.initializeClient(_)).step("")}catch(b){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function i(r,n,a){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ye[277],Ce([1,0,130]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function F(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(P){return new I.URITransformer(F(P))}e.createURITransformer=f}),define(ye[139],Ce([1,0,224,18,2,3,5,37,32,16,44,180,39]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var C;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function c(oe){const q=oe;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.isEditorPaneWithSelection=c;function m(oe,q,W){for(const ie of W.visibleEditorPanes)if(ie.group.id===q&&oe.matches(ie.input))return ie.getViewState()}e.findViewStateForEditor=m;function o(oe){if(w(oe))return!1;const q=oe;return f.URI.isUri(q?.resource)}e.isResourceEditorInput=o;function i(oe){if(w(oe))return!1;const q=oe;return q?.original!==void 0&&q.modified!==void 0}e.isResourceDiffEditorInput=i;function r(oe){if(w(oe))return!1;const q=oe;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}e.isResourceDiffListEditorInput=r;function n(oe){if(w(oe)||i(oe))return!1;const q=oe;return q?.primary!==void 0&&q.secondary!==void 0}e.isResourceSideBySideEditorInput=n;function a(oe){if(w(oe))return!1;const q=oe;return q?q.resource===void 0||q.resource.scheme===y.Schemas.untitled||q.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;function t(oe){if(w(oe))return!1;const q=oe;return f.URI.isUri(q?.base?.resource)&&f.URI.isUri(q?.input1?.resource)&&f.URI.isUri(q?.input2?.resource)&&f.URI.isUri(q?.result?.resource)}e.isResourceMergeEditorInput=t;var d;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class h{constructor(){this.mapIdToSaveSource=new Map}registerSource(q,W){let ie=this.mapIdToSaveSource.get(q);return ie||(ie={source:q,label:W},this.mapIdToSaveSource.set(q,ie)),ie.source}getSourceLabel(q){return this.mapIdToSaveSource.get(q)?.label??q}}e.SaveSourceRegistry=new h;var l;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class u extends P.Disposable{}e.AbstractEditorInput=u;function w(oe){return oe instanceof u}e.isEditorInput=w;function k(oe){const q=oe;return f.URI.isUri(q?.preferredResource)}function b(oe){const q=oe;return w(q?.primary)&&w(q?.secondary)}e.isSideBySideEditorInput=b;function g(oe){const q=oe;return w(q?.modified)&&w(q?.original)}e.isDiffEditorInput=g;function _(oe,q,W,ie,Se){return pe(ie,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const he={...W,limits:{size:Number.MAX_VALUE}};oe.openEditor(q,he)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=_;function T(oe){return w(oe?.editor)}e.isEditorInputWithOptions=T;function O(oe){const q=oe;return T(oe)&&q?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function x(oe){const q=oe;return typeof q?.groupId=="number"&&w(q.editor)}e.isEditorIdentifier=x;var N;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var M;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var L;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class U{getOriginalUri(q,W){if(!q)return;if(t(q))return e.EditorResourceAccessor.getOriginalUri(q.result,W);if(W?.supportSideBySide){const{primary:Se,secondary:he}=this.getSideEditors(q);if(Se&&he){if(W?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===L.ANY)return this.getOriginalUri(Se,{filterByScheme:W.filterByScheme})??this.getOriginalUri(he,{filterByScheme:W.filterByScheme});q=W.supportSideBySide===L.PRIMARY?Se:he}}if(i(q)||r(q)||n(q)||t(q))return;const ie=k(q)?q.preferredResource:q.resource;return!ie||!W||!W.filterByScheme?ie:this.filterUri(ie,W.filterByScheme)}getSideEditors(q){return b(q)||n(q)?{primary:q.primary,secondary:q.secondary}:g(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,W){if(!q)return;if(t(q))return e.EditorResourceAccessor.getCanonicalUri(q.result,W);if(W?.supportSideBySide){const{primary:Se,secondary:he}=this.getSideEditors(q);if(Se&&he){if(W?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===L.ANY)return this.getCanonicalUri(Se,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:W.filterByScheme});q=W.supportSideBySide===L.PRIMARY?Se:he}}if(i(q)||r(q)||n(q)||t(q))return;const ie=q.resource;return!ie||!W||!W.filterByScheme?ie:this.filterUri(ie,W.filterByScheme)}filterUri(q,W){if(Array.isArray(W)){if(W.some(ie=>q.scheme===ie))return q}else if(W===q.scheme)return q}}var B;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function G(oe,q,W,ie){if(!oe.isSticky(q))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return W===B.MOUSE||W===B.KEYBOARD;case"mouse":return W===B.MOUSE;case"keyboard":return W===B.KEYBOARD}return!1}e.preventEditorClose=G,e.EditorResourceAccessor=new U;var le;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(q){const W=this.instantiationService=q.get(A.IInstantiationService);for(const[ie,Se]of this.editorSerializerConstructors)this.createEditorSerializer(ie,Se,W);this.editorSerializerConstructors.clear()}createEditorSerializer(q,W,ie){const Se=ie.createInstance(W);this.editorSerializerInstances.set(q,Se)}registerFileEditorFactory(q){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=q}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(q,W){if(this.editorSerializerConstructors.has(q)||this.editorSerializerInstances.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.instantiationService?this.createEditorSerializer(q,W,this.instantiationService):this.editorSerializerConstructors.set(q,W),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(q),this.editorSerializerInstances.delete(q)})}getEditorSerializer(q){return this.editorSerializerInstances.get(typeof q=="string"?q:q.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function K(oe,q,W){return!oe||!oe.length?[]:await Promise.all(oe.map(async ie=>{const Se=f.URI.revive(ie.fileUri);if(!Se){W.info("Cannot resolve the path because it is not valid.",ie);return}if(!await q.canHandleResource(Se)){W.info("Cannot resolve the path because it cannot be handled",ie);return}let fe=ie.exists,Z=ie.type;if(typeof fe!="boolean"||typeof Z!="number")try{Z=(await q.stat(Se)).isDirectory?p.FileType.Directory:p.FileType.Unknown,fe=!0}catch(j){W.error(j),fe=!1}if(!fe&&ie.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ie);return}if(Z===p.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ie);return}const ee={...ie.options,pinned:!0};return fe?{resource:Se,options:ee}:{resource:Se,options:ee,forceUntitled:!0}}))}e.pathsToEditors=K;var Q;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function ue(oe){const q=oe;if(!q)return!1;const W=q;if(W.modified)return ue(W.modified);const ie=q;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.isTextEditorViewState=ue;function ne(oe){return(0,R.isErrorWithActions)(oe)}e.isEditorOpenError=ne;function pe(oe,q,W){const ie=(0,R.createErrorWithActions)(oe,q);return ie.forceMessage=W?.forceMessage,ie.forceSeverity=W?.forceSeverity,ie.allowDialog=W?.allowDialog,ie}e.createEditorOpenError=pe}),define(ye[278],Ce([1,0,4,225,5,3,28,37,19,24,78,264]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,F.localize)(0,null),e.defaultViewIcon=(0,D.registerIcon)("default-view-icon",R.Codicon.window,(0,F.localize)(1,null));var v;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var S;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.ViewContainerLocations=[0,1,2];function C(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=C;class c extends P.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,p.flatten)([...this.viewContainers.values()])}registerViewContainer(s,h,l){const u=this.get(s.id);if(u)return u;const w=s;return w.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,A.getOrSet)(this.viewContainers,h,[]).push(w),l?.isDefault&&this.defaultViewContainers.push(w),this._onDidRegister.fire({viewContainer:w,viewContainerLocation:h}),w}deregisterViewContainer(s){for(const h of this.viewContainers.keys()){const l=this.viewContainers.get(h),u=l?.indexOf(s);if(u!==-1){l?.splice(u,1),l.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:h});return}}}get(s){return this.all.filter(h=>h.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(l=>l?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===s)}}E.Registry.add(v.ViewContainersRegistry,new c);var m;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(d,s){const h=d.group??m.More,l=s.group??m.More;return h!==l?h.localeCompare(l):(d.order??5)-(s.order??5)}class i extends P.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(s,h){this.registerViews2([{views:s,viewContainer:h}])}registerViews2(s){s.forEach(({views:h,viewContainer:l})=>this.addViews(h,l)),this._onViewsRegistered.fire(s)}deregisterViews(s,h){const l=this.removeViews(s,h);l.length&&this._onViewsDeregistered.fire({views:l,viewContainer:h})}moveViews(s,h){for(const l of this._views.keys())if(l!==h){const u=this.removeViews(s,l);u.length&&(this.addViews(u,h),this._onDidChangeContainer.fire({views:u,from:l,to:h}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const h of this._viewContainers){const l=(this._views.get(h)||[]).filter(u=>u.id===s)[0];if(l)return l}return null}getViewContainer(s){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(u=>u.id===s)[0])return h;return null}registerViewWelcomeContent(s,h){return this._viewWelcomeContents.add(s,h),this._onDidChangeViewWelcomeContent.fire(s),(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(s,h),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,h){const l=new Map;for(const[u,w]of h)this._viewWelcomeContents.add(s,w),l.set(u,(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(s,w),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),l}getViewWelcomeContent(s){const h=[];return this._viewWelcomeContents.forEach(s,l=>h.push(l)),h.sort(o)}addViews(s,h){let l=this._views.get(h);l||(l=[],this._views.set(h,l),this._viewContainers.push(h));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,F.localize)(2,null,u.id));l.push(u)}}removeViews(s,h){const l=this._views.get(h);if(!l)return[];const u=[],w=[];for(const k of l)s.includes(k)?u.push(k):w.push(k);return u.length&&(w.length?this._views.set(h,w):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),u}}E.Registry.add(v.ViewsRegistry,new i),e.IViewDescriptorService=(0,f.createDecorator)("viewDescriptorService");var r;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class a{constructor(s,h){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,s),this._hasResolve=!!h,this.resolve=async l=>{if(h&&!this.resolved){const u=await h(l);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}l.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a;class t extends Error{constructor(s){super((0,F.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(ye[279],Ce([1,0,2,29,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function P(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof I.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(F.Range.isIRange)}e.isIDocumentContext=P;function A(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(P)}e.isIUsedContext=A;var E;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(E||(e.InteractiveSessionVoteDirection=E={}));var p;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(p||(e.ChatAgentCopyKind=p={})),e.IChatService=(0,f.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(ye[140],Ce([1,0,4,11,226]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,p,y,R){const D={command:E};if(p&&Object.keys(p).length>0&&(D.arguments=p),this.internalSend("request",D),typeof R=="number"){const v=setTimeout(()=>{clearTimeout(v);const S=this.pendingRequests.get(D.seq);if(S){this.pendingRequests.delete(D.seq);const C={type:"response",seq:0,request_seq:D.seq,success:!1,command:E,message:(0,f.localize)(0,null,R,E)};S(C)}},R)}return y&&this.pendingRequests.set(D.seq,y),D.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,p){return E.type!=="event"||p.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,F.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback?.(E);break;case"request":this.requestCallback?.(E);break;case"response":{const p=E,y=this.pendingRequests.get(p.request_seq);y&&(this.pendingRequests.delete(p.request_seq),y(p));break}}}}internalSend(E,p){p.type=E,p.seq=this.sequence++,this.sendMessage(p)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((p,y)=>E.set(y,p)),await(0,F.timeout)(500),E.forEach((p,y)=>{p({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(ye[280],Ce([1,0,2,227,45,5]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new f.RawContextKey("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new f.RawContextKey("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new f.RawContextKey("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new f.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:F.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new f.RawContextKey("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new f.RawContextKey("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new f.RawContextKey("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new f.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new f.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new f.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new f.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new f.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new f.RawContextKey("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new f.RawContextKey("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new f.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new f.RawContextKey("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new f.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new f.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new f.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new f.RawContextKey("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new f.RawContextKey("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new f.RawContextKey("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new f.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new f.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new f.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:F.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new f.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new f.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(26,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new f.RawContextKey("stepBackSupported",!1,{type:"boolean",description:F.localize(27,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new f.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new f.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(29,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new f.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new f.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new f.RawContextKey("breakpointsExist",!1,{type:"boolean",description:F.localize(32,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new f.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:F.localize(33,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new f.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(34,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new f.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(35,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new f.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(36,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new f.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new f.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new f.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new f.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new f.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new f.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new f.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(43,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new f.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:F.localize(44,null)}),e.CONTEXT_VARIABLE_VALUE=new f.RawContextKey("variableValue",!1,{type:"string",description:F.localize(45,null)}),e.CONTEXT_VARIABLE_TYPE=new f.RawContextKey("variableType",!1,{type:"string",description:F.localize(46,null)}),e.CONTEXT_VARIABLE_NAME=new f.RawContextKey("variableName",!1,{type:"string",description:F.localize(47,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new f.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(48,null)}),e.CONTEXT_MULTI_SESSION_REPL=new f.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:F.localize(49,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new f.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:F.localize(50,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new f.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(51,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new f.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(52,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new f.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(53,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new f.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(54,null)});const A=c=>F.localize(55,null,c);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(56,null)};var E;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(E||(e.State=E={}));function p(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=p;var y;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var D;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.IDebugService=(0,P.createDecorator)("debugService");var v;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var S;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(S||(e.DebugVisualizationType=S={}));var C;(function(c){c.deserialize=m=>({id:m.id,name:m.name,iconPath:m.iconPath&&{light:I.URI.revive(m.iconPath.light),dark:I.URI.revive(m.iconPath.dark)},iconClass:m.iconClass,visualization:m.visualization}),c.serialize=m=>m})(C||(e.IDebugVisualization=C={}))}),define(ye[281],Ce([1,0,12,2,17,24,16,29,21,19]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function D(k,b,g){return k.replace(R,function(_,T){return b&&T.length>0&&T[0]!=="_"?_:g&&g.hasOwnProperty(T)?g[T]:_})}e.formatPII=D;function v(k){const b={};for(const g of Object.keys(k))g.startsWith("!")||(b[g]=k[g]);return b}e.filterExceptionsFromTelemetry=v;function S(k){return k.configuration.request==="attach"&&!C(k)&&(!k.parentSession||S(k.parentSession))}e.isSessionAttach=S;function C(k){let b=k.configuration.type;if(b)return b==="vslsShare"&&(b=k.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(b,"extensionhost")||(0,I.equalsIgnoreCase)(b,"pwa-extensionhost")?k:k.parentSession?C(k.parentSession):void 0}e.getExtensionHostDebugSession=C;function c(k){return k.type&&(k.label||k.program||k.runtime)}e.isDebuggerMainContribution=c;function m(k,b,g){let _,T=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let x=null;for(;x=O.exec(k);){const N=x.index+1,M=N+x[0].length;if(N<=b&&M>=g){_=x[0],T=N;break}}if(_){const N=/\w+/g;let M=null;for(;(M=N.exec(_))&&!(M.index+1+T+M[0].length>=g););M&&(_=_.substring(0,N.lastIndex))}return _?{start:T,end:T+_.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;async function o(k,b,g,_){if(k.evaluatableExpressionProvider.has(b)){const T=k.evaluatableExpressionProvider.ordered(b),O=(0,y.coalesce)(await Promise.all(T.map(async x=>{try{return await x.provideEvaluatableExpression(b,g,_??p.CancellationToken.None)}catch{return}})));if(O.length>0){let x=O[0].expression;const N=O[0].range;return x||(x=b.getLineContent(g.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:x}}}else{const T=b.getLineContent(g.lineNumber),{start:O,end:x}=m(T,g.column,g.column),N=T.substring(O-1,x);return{matchingExpression:N,range:new E.Range(g.lineNumber,O,g.lineNumber,O+N.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(k){return!!(k&&k.match(i))}e.isUri=r;function n(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(r(k.path))return F.URI.parse(k.path);if((0,f.isAbsolute)(k.path))return F.URI.file(k.path)}return k.path}function a(k){if(typeof k.path=="object"){const b=F.URI.revive(k.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return k.path}function t(k,b){const g=b?n:a,_=(0,P.deepClone)(k);return s(_,(T,O)=>{T&&O&&(O.path=g(O))}),_}e.convertToDAPaths=t;function d(k,b){const g=b?n:a,_=(0,P.deepClone)(k);return s(_,(T,O)=>{!T&&O&&(O.path=g(O))}),_}e.convertToVSCPaths=d;function s(k,b){switch(k.type){case"event":{const g=k;switch(g.event){case"output":b(!1,g.body.source);break;case"loadedSource":b(!1,g.body.source);break;case"breakpoint":b(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=k;switch(g.command){case"setBreakpoints":b(!0,g.arguments.source);break;case"breakpointLocations":b(!0,g.arguments.source);break;case"source":b(!0,g.arguments.source);break;case"gotoTargets":b(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(_=>b(!1,_));break;default:break}break}case"response":{const g=k;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(_=>b(!1,_.source));break;case"loadedSources":g.body.sources.forEach(_=>b(!1,_));break;case"scopes":g.body.scopes.forEach(_=>b(!1,_.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(_=>b(!1,_.source));break;case"setBreakpoints":g.body.breakpoints.forEach(_=>b(!1,_.source));break;case"disassemble":g.body?.instructions.forEach(T=>b(!1,T.location));break;default:break}break}}}function h(k){return k.filter(b=>!b.presentation?.hidden).sort((b,g)=>b.presentation?g.presentation?b.presentation.group?g.presentation.group?b.presentation.group!==g.presentation.group?b.presentation.group.localeCompare(g.presentation.group):l(b.presentation.order,g.presentation.order):-1:g.presentation.group?1:l(b.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=h;function l(k,b){return typeof k!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:k-b}async function u(k,b){const g=k.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(g!=="none"&&(await b.saveAll(),g==="allEditorsInActiveGroup")){const _=b.activeEditorPane;_&&_.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:_.input,groupId:_.group.id})}await k.reloadConfiguration()}e.saveAllBeforeDebugStart=u;const w=(k,b)=>!k||!b?k===b:k.name===b.name&&k.path===b.path&&k.sourceReference===b.sourceReference;e.sourcesEqual=w}),define(ye[282],Ce([1,0,50,62,24,17,10,12,31,228,140]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class D extends R.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,i){this.outputStream=i,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",r=>this.handleData(r))}sendMessage(o){if(this.outputStream){const i=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${D.TWO_CRLF}${i}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const i=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.rawData.indexOf(D.TWO_CRLF);if(i!==-1){const n=this.rawData.toString("utf8",0,i).split(D.HEADER_LINESEPARATOR);for(const a of n){const t=a.split(D.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(i+D.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=D;class v extends D{startSession(){return new Promise((o,i)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.socket.on("error",n=>{r?this._onError.fire(n):i(n)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class S extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=S;class C extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=C;class c extends D{constructor(o,i){super(),this.adapterExecutable=o,this.debugType=i}async startSession(){const o=this.adapterExecutable.command,i=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(o)if(P.isAbsolute(o)){if(!await p.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=f.mixin(f.deepClone(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const d=I.fork(i[0],i.slice(1),t);if(!d.pid)throw new Error(y.localize(2,null,i[0]));this.serverProcess=d}else throw new Error(y.localize(3,null));else{const a={env:n};r.cwd&&(a.cwd=r.cwd),this.serverProcess=I.spawn(o,i,a)}this.serverProcess.on("error",a=>{this._onError.fire(a)}),this.serverProcess.on("exit",(a,t)=>{this._onExit.fire(a)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stdin.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(n){this._onError.fire(n)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((o,i)=>{const r=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(n,a,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=P.join(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(P.isAbsolute(o.program)?r.program=o.program:r.program=P.join(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=c.extract(n.win,i)),n.winx86&&(r.winx86=c.extract(n.winx86,i)),n.windows&&(r.windows=c.extract(n.windows,i)),n.osx&&(r.osx=c.extract(n.osx,i)),n.linux&&(r.linux=c.extract(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const h of o)if(h.contributes){const l=h.contributes.debuggers;l&&l.length>0&&l.filter(u=>typeof u.type=="string"&&E.equalsIgnoreCase(u.type,i)).forEach(u=>{const w=c.extract(u,h.extensionLocation.fsPath);r=f.mixin(r,w,h.isBuiltin)})}let n;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.isWindows?n=r.win||r.windows:A.isMacintosh?n=r.osx:A.isLinux&&(n=r.linux),n=n||r;const a=n.program||r.program,t=n.args||r.args,d=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(d)return{type:"executable",command:d,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.ExecutableDebugAdapter=c}),define(ye[283],Ce([1,0,50,34,10]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(y,R){return new Promise((D,v)=>{let S="";const C=I.spawn(y,R);C.pid&&C.stdout.on("data",c=>{S+=c.toString()}),C.on("error",c=>{v(c)}),C.on("close",c=>{D(S)})})}async function A(y){if(y)if(f.isWindows){const R=await new Promise((D,v)=>{me(["@vscode/windows-process-tree"],D,v)});return new Promise(D=>{R.getProcessTree(y,v=>{D(!!v&&v.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const D=R.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var E;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(E||(E={}));function p(y,R,D,v,S){y=y.trim().toLowerCase();let C;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?C=1:y.indexOf("cmd.exe")>=0?C=0:y.indexOf("bash")>=0?C=2:f.isWindows?C=0:C=2;let c,m=" ";switch(C){case 1:if(c=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),v){const o=(0,F.getDriveLetter)(v);o&&(m+=`${o}:; `),m+=`cd ${c(v)}; `}if(S)for(const o in S){const i=S[o];i===null?m+=`Remove-Item env:${o}; `:m+=`\${env:${o}}='${i}'; `}if(R.length>0){const o=R.shift(),i=D?o:c(o);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)m+=r==="<"||r===">"||D?r:c(r),m+=" "}break;case 0:if(c=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),v){const o=(0,F.getDriveLetter)(v);o&&(m+=`${o}: && `),m+=`cd ${c(v)} && `}if(S){m+='cmd /C "';for(const o in S){let i=S[o];i===null?m+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),m+=`set "${o}=${i}" && `)}}for(const o of R)m+=o==="<"||o===">"||D?o:c(o),m+=" ";S&&(m+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(v&&(m+=`cd ${c(v)} ; `),S){m+="/usr/bin/env";for(const i in S){const r=S[i];r===null?m+=` -u ${o(i)}`:m+=` ${o(`${i}=${r}`)}`}m+=" "}for(const i of R)m+=i==="<"||i===">"||D?i:c(i),m+=" ";break}}return m}e.prepareCommand=p}),define(ye[284],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(ye[285],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var F;(function(f){f[f.Disconnected=1]="Disconnected",f[f.Connected=2]="Connected",f[f.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.INotebookKernelService=(0,I.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,I.createDecorator)("INotebookKernelHistoryService")}),define(ye[286],Ce([1,0,3,29,193,100]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class A extends I.Disposable{constructor(p,y,R){super(),this._source=p,this._inputTextBuffer=y,this._outputs=R,this._outputTextBuffers=void 0}_getFullModelRange(p){const y=p.getLineCount();return new F.Range(1,1,y,this._getLineMaxColumn(p,y))}_getLineMaxColumn(p,y){if(y<1||y>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(y)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const p=new f.PieceTreeTextBufferBuilder;p.acceptChunk(this._source);const y=p.finish(!0),{textBuffer:R,disposable:D}=y.create(1);this._inputTextBuffer=R,this._register(D)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(p=>{const y=new f.PieceTreeTextBufferBuilder;y.acceptChunk(p);const R=y.finish(!0),{textBuffer:D,disposable:v}=R.create(1);return this._register(v),D})),this._outputTextBuffers}findInInputs(p){const R=new P.SearchParams(p,!1,!1,null).parseSearchRequest();if(!R)return[];const D=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,R,!0,5e3)}findInOutputs(p){const R=new P.SearchParams(p,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(D=>{const v=D.findMatchesLineByLine(this._getFullModelRange(D),R,!0,5e3);if(v.length!==0)return{textBuffer:D,matches:v}}).filter(D=>!!D):[]}}e.CellSearchModel=A}),define(ye[67],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(P){P.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(A,E,p=A.parent){if(A._isRoot)return new f([E]);const y=[A.id];for(let R=p;R&&R.id!==E;R=R.parent)y.push(R.id);return y.push(E),new f(y.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const E=A.indexOf("\0");return E===-1?A:A.slice(0,E)}static fromString(A){return new f(A.split("\0"))}static join(A,E){return new f([...A.path,E])}static joinToString(A,E){return A.toString()+"\0"+E}static parentId(A){const E=A.lastIndexOf("\0");return E===-1?void 0:A.slice(0,E)}static localId(A){const E=A.lastIndexOf("\0");return E===-1?A:A.slice(E+1)}static isChild(A,E){return E.startsWith(A)&&E[A.length]==="\0"}static compare(A,E){return A===E?0:f.isChild(A,E)?2:f.isChild(E,A)?3:1}constructor(A,E=A.length){if(this.path=A,this.viewEnd=E,A.length===0||E<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.viewEnd>1?new f(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let E=0;E<A.viewEnd&&E<this.viewEnd;E++)if(A.path[E]!==this.path[E])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=f}),define(ye[90],Ce([1,0,2,48,29,67]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(L){L[L.Unset=0]="Unset",L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var E;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(E||(e.ExtTestRunProfileKind=E={}));var p;(function(L){L[L.Run=2]="Run",L[L.Debug=4]="Debug",L[L.Coverage=8]="Coverage",L[L.HasNonDefaultProfile=16]="HasNonDefaultProfile",L[L.HasConfigurable=32]="HasConfigurable",L[L.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=L=>"runId"in L;e.isStartControllerTests=y;var R;(function(L){L.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),L.deserialize=(U,B)=>({range:f.Range.lift(B.range),uri:U.asCanonicalUri(I.URI.revive(B.uri))})})(R||(e.IRichLocation=R={}));var D;(function(L){L[L.Error=0]="Error",L[L.Output=1]="Output"})(D||(e.TestMessageType=D={}));var v;(function(L){L.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&R.serialize(U.location)}),L.deserialize=(U,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&R.deserialize(U,B.location)})})(v||(e.ITestErrorMessage=v={}));const S=(L,U)=>`${U?"s":"e"}${L}`;e.getMarkId=S;var C;(function(L){L.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&R.serialize(U.location)}),L.deserialize=(U,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&R.deserialize(U,B.location)})})(C||(e.ITestOutputMessage=C={}));var c;(function(L){L.serialize=U=>U.type===0?v.serialize(U):C.serialize(U),L.deserialize=(U,B)=>B.type===0?v.deserialize(U,B):C.deserialize(U,B)})(c||(e.ITestMessage=c={}));var m;(function(L){L.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),L.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(c.serialize)}),L.deserialize=(U,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(G=>c.deserialize(U,G))})})(m||(e.ITestTaskState=m={}));const o="\0",i=(L,U)=>L+o+U;e.namespaceTestTag=i;const r=L=>{const U=L.indexOf(o);return{ctrlId:L.slice(0,U),tagId:L.slice(U+1)}};e.denamespaceTestTag=r;var n;(function(L){L.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),L.deserialize=(U,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?U.asCanonicalUri(I.URI.revive(B.uri)):void 0,range:B.range?f.Range.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(n||(e.ITestItem=n={}));var a;(function(L){L[L.NotExpandable=0]="NotExpandable",L[L.Expandable=1]="Expandable",L[L.BusyExpanding=2]="BusyExpanding",L[L.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(L){L.serialize=U=>({expand:U.expand,item:n.serialize(U.item)}),L.deserialize=(U,B)=>({controllerId:P.TestId.root(B.item.extId),expand:B.expand,item:n.deserialize(U,B.item)})})(t||(e.InternalTestItem=t={}));var d;(function(L){L.serialize=U=>{let B;return U.item&&(B={},U.item.label!==void 0&&(B.label=U.item.label),U.item.tags!==void 0&&(B.tags=U.item.tags),U.item.busy!==void 0&&(B.busy=U.item.busy),U.item.uri!==void 0&&(B.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(B.range=U.item.range?.toJSON()),U.item.description!==void 0&&(B.description=U.item.description),U.item.error!==void 0&&(B.error=U.item.error),U.item.sortText!==void 0&&(B.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:B}},L.deserialize=U=>{let B;return U.item&&(B={},U.item.label!==void 0&&(B.label=U.item.label),U.item.tags!==void 0&&(B.tags=U.item.tags),U.item.busy!==void 0&&(B.busy=U.item.busy),U.item.range!==void 0&&(B.range=U.item.range?f.Range.lift(U.item.range):null),U.item.description!==void 0&&(B.description=U.item.description),U.item.error!==void 0&&(B.error=U.item.error),U.item.sortText!==void 0&&(B.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:B}}})(d||(e.ITestItemUpdate=d={}));const s=(L,U)=>{U.expand!==void 0&&(L.expand=U.expand),U.item!==void 0&&(L.item=L.item?Object.assign(L.item,U.item):U.item)};e.applyTestItemUpdate=s;var h;(function(L){L.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(m.serializeWithoutMessages)}),L.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(m.serialize)}),L.deserialize=(U,B)=>({...t.deserialize(U,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(G=>m.deserialize(U,G)),retired:!0})})(h||(e.TestResultItem=h={}));var l;(function(L){L.empty=()=>({covered:0,total:0}),L.sum=(U,B)=>{U.covered+=B.covered,U.total+=B.total}})(l||(e.ICoveredCount=l={}));var u;(function(L){L.serialize=U=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(g.serialize),uri:U.uri.toJSON()}),L.deserialize=(U,B)=>({statement:B.statement,branch:B.branch,function:B.function,details:B.details?.map(g.deserialize),uri:U.asCanonicalUri(I.URI.revive(B.uri))})})(u||(e.IFileCoverage=u={}));function w(L){return{...L,location:L.location?.toJSON()}}function k(L){return L.location=L.location?F.Position.isIPosition(L.location)?F.Position.lift(L.location):f.Range.lift(L.location):void 0,L}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var b;(function(L){L[L.Function=0]="Function",L[L.Statement=1]="Statement",L[L.Branch=2]="Branch"})(b||(e.DetailType=b={}));var g;(function(L){L.serialize=U=>U.type===0?T.serialize(U):O.serialize(U),L.deserialize=U=>U.type===0?T.deserialize(U):O.deserialize(U)})(g||(e.CoverageDetails=g={}));var _;(function(L){L.serialize=w,L.deserialize=k})(_||(e.IBranchCoverage=_={}));var T;(function(L){L.serialize=w,L.deserialize=k})(T||(e.IFunctionCoverage=T={}));var O;(function(L){L.serialize=U=>({...w(U),branches:U.branches?.map(_.serialize)}),L.deserialize=U=>({...k(U),branches:U.branches?.map(_.deserialize)})})(O||(e.IStatementCoverage=O={}));var x;(function(L){L[L.Add=0]="Add",L[L.Update=1]="Update",L[L.DocumentSynced=2]="DocumentSynced",L[L.Remove=3]="Remove",L[L.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",L[L.Retire=5]="Retire",L[L.AddTag=6]="AddTag",L[L.RemoveTag=7]="RemoveTag"})(x||(e.TestDiffOpType=x={}));var N;(function(L){L.deserialize=(U,B)=>B.op===0?{op:B.op,item:t.deserialize(U,B.item)}:B.op===1?{op:B.op,item:d.deserialize(B.item)}:B.op===2?{op:B.op,uri:U.asCanonicalUri(I.URI.revive(B.uri)),docv:B.docv}:B,L.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:d.serialize(U.item)}:U})(N||(e.TestsDiffOp=N={}));class M{constructor(U){this.uriIdentity=U,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(U){const B=this.createChangeCollector();for(const G of U)switch(G.op){case 0:this.add(t.deserialize(this.uriIdentity,G.item),B);break;case 1:this.update(d.deserialize(G.item),B);break;case 3:this.remove(G.itemId,B);break;case 5:this.retireTest(G.itemId);break;case 4:this.updatePendingRoots(G.amount);break;case 6:this._tags.set(G.tag.id,G.tag);break;case 7:this._tags.delete(G.id);break}B.complete?.()}add(U,B){const G=P.TestId.parentId(U.item.extId)?.toString();let le;if(!G)le=this.createItem(U),this.roots.add(le),this.items.set(U.item.extId,le);else if(this.items.has(G)){const Y=this.items.get(G);Y.children.add(U.item.extId),le=this.createItem(U,Y),this.items.set(U.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return B.add?.(le),U.expand===2&&this.busyControllerCount++,le}update(U,B){const G=this.items.get(U.extId);if(G)return U.expand!==void 0&&(G.expand===2&&this.busyControllerCount--,U.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(G,U),B.update?.(G),G}remove(U,B){const G=this.items.get(U);if(!G)return;const le=P.TestId.parentId(G.item.extId)?.toString();le?this.items.get(le).children.delete(G.item.extId):this.roots.delete(G);const Y=[[U]];for(;Y.length;)for(const K of Y.pop()){const Q=this.items.get(K);Q&&(Y.push(Q.children),this.items.delete(K),B.remove?.(Q,Q!==G),Q.expand===2&&this.busyControllerCount--)}}retireTest(U){}updatePendingRoots(U){this.pendingRootCount+=U}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=M}),define(ye[111],Ce([1,0,11,4,3,61,90,67]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const y=(i,r)=>i===r,D=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),v=(i,r)=>{let n;for(const[a,t]of D)t(i[a],r[a])||(n?n[a]=r[a]:n={[a]:r[a]});return n};class S extends f.Disposable{get root(){return this.options.root}constructor(r){super(),this.options=r,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const n of this.tree.values())this.updateExpandability(n)}get resolveHandler(){return this._resolveHandler}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.diff)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.diff[this.diff.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.applyTestItemUpdate)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.applyTestItemUpdate)(n.item,r.item);return}}break}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,n){const a=this.tree.get(r);if(a){if((a.expandLevels===void 0||n>a.expandLevels)&&(a.expandLevels=n),a.expand===1){const t=this.resolveChildren(a);return t.isOpen()?this.expandChildren(a,n-1):t.wait().then(()=>this.expandChildren(a,n-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,n-1)):this.expandChildren(a,n-1)}}dispose(){for(const r of this.tree.values())this.options.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,n){switch(n.op){case 3:this.removeItem(E.TestId.joinToString(r.fullId,n.id));break;case 0:this.upsertItem(n.item,r);break;case 5:for(const a of n.ops)this.onTestItemEvent(r,a);break;case 1:this.diffTagRefs(n.new,n.old,r.fullId.toString());break;case 2:this.updateExpandability(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.documentSynced(r.actual.uri);break;default:(0,P.assertNever)(n)}}documentSynced(r){r&&this.pushDiff({op:2,uri:r,docv:this.options.getDocumentVersion(r)})}upsertItem(r,n){const a=E.TestId.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.options.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.options.getChildren(t.parent).delete(r.id);let d=this.tree.get(a.toString());if(!d){d={fullId:a,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(r,n),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:d.expand,item:this.options.toITestItem(r)}}),this.connectItemAndChildren(r,d,n);return}if(d.actual===r){this.connectItem(r,d,n);return}if(d.actual.uri?.toString()!==r.uri?.toString())return this.removeItem(a.toString()),this.upsertItem(r,n);const s=this.options.getChildren(d.actual),h=d.actual,l=v(this.options.toITestItem(h),this.options.toITestItem(r));this.options.getApiFor(h).listener=void 0,d.actual=r,d.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(r.tags,h.tags,a.toString()),delete l.tags),this.onTestItemEvent(d,{op:4,update:l})),this.connectItemAndChildren(r,d,n);for(const[u,w]of s)this.options.getChildren(r).get(w.id)||this.removeItem(E.TestId.joinToString(a,w.id));this.documentSynced(d.actual.uri)}diffTagRefs(r,n,a){const t=new Set(n.map(d=>d.id));for(const d of r)t.delete(d.id)||this.incrementTagRefs(d);this.pushDiff({op:1,item:{extId:a,item:{tags:r.map(d=>(0,A.namespaceTestTag)(this.options.controllerId,d.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(r){const n=this.tags.get(r.id);n?n.refCount++:(this.tags.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,r.id)}}))}decrementTagRefs(r){const n=this.tags.get(r);n&&!--n.refCount&&(this.tags.delete(r),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,r)}))}setItemParent(r,n){this.options.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}connectItem(r,n,a){this.setItemParent(r,a);const t=this.options.getApiFor(r);t.parent=a?.actual,t.listener=d=>this.onTestItemEvent(n,d),this.updateExpandability(n)}connectItemAndChildren(r,n,a){this.connectItem(r,n,a);for(const[t,d]of this.options.getChildren(r))this.upsertItem(d,n)}updateExpandability(r){let n;this._resolveHandler?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,n){if(n<0)return;const a=[];for(const[t,d]of this.options.getChildren(r.actual)){const s=this.expand(E.TestId.joinToString(r.fullId,d.id),n);(0,I.isThenable)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const d=new I.Barrier;return d.open(),d}r.expand=2,this.pushExpandStateUpdate(r);const n=r.resolveBarrier=new I.Barrier,a=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,d)};let t;try{t=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(d){a(d)}return(0,I.isThenable)(t)?t.catch(a).then(()=>{n.open(),this.updateExpandability(r)}):(n.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}removeItem(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const a=[n];for(;a.length;){const t=a.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(t.fullId.toString());for(const[d,s]of this.options.getChildren(t.actual))a.push(this.tree.get(E.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.TestItemCollection=S;class C extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.DuplicateTestItemError=C;class c extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=c;class m extends Error{constructor(r,n,a){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=m;const o=(i,r,n)=>{let a=new Map;return{get size(){return a.size},forEach(t,d){for(const s of a.values())t.call(d,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const d=new Map,s=new Set(a.keys()),h={op:5,ops:[]};for(const l of t){if(!(l instanceof n))throw new c(l.id);const u=r(l).controllerId;if(u!==i.controllerId)throw new m(l.id,u,i.controllerId);if(d.has(l.id))throw new C(l.id);d.set(l.id,l),s.delete(l.id),h.ops.push({op:0,item:l})}for(const l of s.keys())h.ops.push({op:3,id:l});i.listener?.(h),a=d},add(t){if(!(t instanceof n))throw new c(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=o}),define(ye[141],Ce([1,0,111]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const F=new WeakMap,f=(A,E)=>{const p={controllerId:E};return F.set(A,p),p};e.createPrivateApiFor=f;const P=A=>{const E=F.get(A);if(!E)throw new I.InvalidTestItemError(A?.id||"<unknown>");return E};e.getPrivateApiFor=P}),define(ye[112],Ce([1,0,16,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function f(E,p){return E.scheme===I.Schemas.http||E.scheme===I.Schemas.https?E:(p&&p.authority&&p.isRemote&&E.scheme===I.Schemas.file&&(E=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:p.authority,path:E.path})),F.URI.from({scheme:I.Schemas.https,authority:`${E.scheme}+${P(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=f;function P(E){return E.replace(/./g,p=>{const y=p.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?p:"-"+y.toString(16).padStart(4,"0")})}function A(E){return E.replace(/-([0-9a-f]{4})/g,(p,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=A}),define(ye[287],Ce([1,0,4,3,112]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(E,p,y){this._proxy=E,this._editors=p,this._remoteInfo=y,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const D of this._insets.values())R.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,p,y,R,D){let v;for(const r of this._editors.getVisibleTextEditors(!0))if(r.value===E){v=r;break}if(!v)throw new Error("not a visible editor");const S=this,C=this._handlePool++,c=new I.Emitter,m=new I.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(r){return(0,f.asWebviewUri)(r,S._remoteInfo)}get cspSource(){return f.webviewGenericCspSource}set options(r){this._options=r,S._proxy.$setOptions(C,r)}get options(){return this._options}set html(r){this._html=r,S._proxy.$setHtml(C,r)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(r){return S._proxy.$postMessage(C,r)}},i=new class{constructor(){this.editor=E,this.line=p,this.height=y,this.webview=o,this.onDidDispose=m.event}dispose(){S._insets.has(C)&&(S._insets.delete(C),S._proxy.$disposeEditorInset(C),m.fire(),m.dispose(),c.dispose())}};return this._proxy.$createEditorInset(C,v.id,v.value.document.uri,p+1,y,R||{},D.identifier,D.extensionLocation),this._insets.set(C,{editor:E,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(E){const p=this._insets.get(E);p&&p.inset.dispose()}$onDidReceiveMessage(E,p){this._insets.get(E)?.onDidReceiveMessage.fire(p)}}e.ExtHostEditorInsets=P}),define(ye[288],Ce([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var F;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class f extends Error{constructor(A,E){super(E),this.variable=A}}e.VariableError=f}),define(ye[289],Ce([1,0,17,49,18,24,10,103,231,288,12]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,C,c,m){this._contributedVariables=new Map,this._context=S,this._labelService=C,this._userHomePromise=c,m&&(this._envVariablesPromise=m.then(o=>this.prepareEnv(o)))}prepareEnv(S){if(A.isWindows){const C=Object.create(null);return Object.keys(S).forEach(c=>{C[c.toLowerCase()]=S[c]}),C}return S}resolveWithEnvironment(S,C,c){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},C?C.uri:void 0,c)}async resolveAsync(S,C){const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,S?S.uri:void 0,C)}async resolveAnyBase(S,C,c,m){const o=P.deepClone(C);A.isWindows&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,S?S.uri:void 0,o,c,m)}async resolveAnyAsync(S,C,c){return this.resolveAnyBase(S,C,c)}async resolveAnyMap(S,C,c){const m=new Map;return{newConfig:await this.resolveAnyBase(S,C,c,m),resolvedVariables:m}}resolveWithInteractionReplace(S,C,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,C,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,C){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,C)}async recursiveResolve(S,C,c,m,o){if(f.isString(c))return this.resolveString(S,C,c,m,o);if(Array.isArray(c))return Promise.all(c.map(i=>this.recursiveResolve(S,C,i,m,o)));if(f.isObject(c)){const i=Object.create(null),r=await Promise.all(Object.keys(c).map(async n=>[await this.resolveString(S,C,n,m,o),await this.recursiveResolve(S,C,c[n],m,o)]));for(const[n,a]of r)i[n]=a;return i}return c}resolveString(S,C,c,m,o){return(0,R.replaceAsync)(c,D.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(D.VARIABLE_LHS))return i;let n=await this.evaluateSingleVariable(S,i,r,C,m);return o?.set(r,n),n!==i&&f.isString(n)&&n.match(D.VARIABLE_REGEXP)&&(n=await this.resolveString(S,C,n,m,o)),n})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,C,c,m,o){let i;const r=c.split(":");r.length>1&&(c=r[0],i=r[1]);const n=d=>{const s=this._context.getFilePath();if(s)return(0,E.normalizeDriveLetter)(s);throw new y.VariableError(d,(0,p.localize)(0,null,C))},a=d=>{const s=n(d);if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return(0,E.normalizeDriveLetter)(h)}throw new y.VariableError(d,(0,p.localize)(1,null,C,I.basename(s)))},t=d=>{if(i){const s=this._context.getFolderUri(i);if(s)return s;throw new y.VariableError(d,(0,p.localize)(2,null,C,i))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new y.VariableError(d,(0,p.localize)(3,null,C)):new y.VariableError(d,(0,p.localize)(4,null,C))};switch(c){case"env":if(i){if(S.env){const d=S.env[A.isWindows?i.toLowerCase():i];if(f.isString(d))return d}return""}throw new y.VariableError(y.VariableKind.Env,(0,p.localize)(5,null,C));case"config":if(i){const d=this._context.getConfigurationValue(m,i);if(f.isUndefinedOrNull(d))throw new y.VariableError(y.VariableKind.Config,(0,p.localize)(6,null,C,i));if(f.isObject(d))throw new y.VariableError(y.VariableKind.Config,(0,p.localize)(7,null,C,i));return d}throw new y.VariableError(y.VariableKind.Config,(0,p.localize)(8,null,C));case"command":return this.resolveFromMap(y.VariableKind.Command,C,i,o,"command");case"input":return this.resolveFromMap(y.VariableKind.Input,C,i,o,"input");case"extensionInstallFolder":if(i){const d=await this._context.getExtension(i);if(!d)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,C,i));return this.fsPath(d.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,C));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,E.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,E.normalizeDriveLetter)(I.basename(this.fsPath(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,p.localize)(11,null,C))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new y.VariableError(y.VariableKind.LineNumber,(0,p.localize)(12,null,C))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new y.VariableError(y.VariableKind.SelectedText,(0,p.localize)(13,null,C))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.basename(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?I.relative(this.fsPath(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const d=I.dirname(n(y.VariableKind.RelativeFileDirname));if(m||i){const s=I.relative(this.fsPath(t(y.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return I.dirname(n(y.VariableKind.FileDirname));case"fileExtname":return I.extname(n(y.VariableKind.FileExtname));case"fileBasename":return I.basename(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=I.basename(n(y.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-I.extname(d).length)}case"fileDirnameBasename":return I.basename(I.dirname(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||C}case"execInstallFolder":{const d=this._context.getAppRoot();return d||C}case"pathSeparator":case"/":return I.sep;default:try{const d=i?`${c}:${i}`:c;return this.resolveFromMap(y.VariableKind.Unknown,C,d,o,void 0)}catch{return C}}}}resolveFromMap(S,C,c,m,o){if(c&&m){const i=o===void 0?m[c]:m[o+":"+c];if(typeof i=="string")return i;throw new y.VariableError(S,(0,p.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=D}),define(ye[142],Ce([1,0,5,139]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var f;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var P;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var E;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EXPAND=1]="EXPAND",C[C.EVEN=2]="EVEN"})(E||(e.GroupsArrangement=E={}));var p;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function y(C){const c=C;return(0,F.isEditorInput)(c?.editor)&&(0,F.isEditorInput)(c?.replacement)}e.isEditorReplacement=y;var R;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var D;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function v(C){const c=C;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=v;function S(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(ye[290],Ce([1,0,5,142]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function f(P){const A=P;return typeof P=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=f}),define(ye[143],Ce([1,0,5,133]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(F.IEnvironmentService)}),define(ye[144],Ce([1,0,25,4,17,3]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class E{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this._activationEventsReader=o,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const o of this._extensionDescriptions){if(this._extensionsMap.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this._extensionsMap.set(o.identifier,o),this._extensionsArr.push(o);const i=this._activationEventsReader.readActivationEvents(o);for(const r of i)this._activationMap.has(r)||this._activationMap.set(r,[]),this._activationMap.get(r).push(o)}}set(o){return this._extensionDescriptions=o,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(o,i){this._extensionDescriptions=c(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(o);const r=E._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=c(this._extensionDescriptions,r.map(n=>n.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,r)}static _findLoopingExtensions(o){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,s){this.addNode(d),this.addNode(s),this._arcs.has(d)?this._arcs.get(d).push(s):this._arcs.set(d,[s])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,s){const h=i.getArcs(d);for(let l=0;l<h.length;l++)if(!s.has(h[l]))return!1;return!0}getNodes(){return this._nodesArr}},r=new I.ExtensionIdentifierMap;for(const d of o)if(r.set(d.identifier,d),d.extensionDependencies)for(const s of d.extensionDependencies)i.addArc(I.ExtensionIdentifier.toKey(d.identifier),I.ExtensionIdentifier.toKey(s));const n=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>n.add(d));const a=i.getNodes().filter(d=>!n.has(d));let t;do{t=!1;for(let d=0;d<a.length;d++){const s=a[d];i.hasOnlyGoodArcs(s,n)&&(a.splice(d,1),d--,n.add(s),t=!0)}}while(t);return a.map(d=>r.get(d))}containsActivationEvent(o){return this._activationMap.has(o)}containsExtension(o){return this._extensionsMap.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this._activationMap.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new p(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this._extensionsMap.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this._extensionsArr)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=E;class p{constructor(o,i){this.versionId=o,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=p;class y{constructor(o){this._lock=new v,this._actual=new E(o,[])}async acquireLock(o){const i=await this._lock.acquire(o);return new R(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,r)}containsActivationEvent(o){return this._actual.containsActivationEvent(o)}containsExtension(o){return this._actual.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this._actual.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(o){return this._actual.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this._actual.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this._actual.getExtensionDescriptionByIdOrUUID(o,i)}}e.LockableExtensionDescriptionRegistry=y;class R extends P.Disposable{constructor(o,i){super(),this._registry=o,this._isDisposed=!1,this._register(i)}isAcquiredFor(o){return!this._isDisposed&&this._registry===o}}e.ExtensionDescriptionRegistryLock=R;class D{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this._resolve=i})}resolve(o){this._resolve(o)}}class v{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(o){const i=new D(o);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const o=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this._isLocked=!1,this._advance())};o.resolve((0,P.toDisposable)(n))}}var S;(function(m){m[m.Builtin=0]="Builtin",m[m.User=1]="User",m[m.Dev=2]="Dev"})(S||(S={}));function C(m,o){const i=m.isBuiltin?0:m.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=f.posix.basename(m.extensionLocation.path),a=f.posix.basename(o.extensionLocation.path);return n<a?-1:n>a?1:0}function c(m,o){const i=new I.ExtensionIdentifierSet(o);return m.filter(r=>!i.has(r.identifier))}}),define(ye[291],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var I;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(D){this.pipeName=D,this.type=1}serialize(D){D[F.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(D){D[f.ENV_KEY]="1"}}e.SocketExtHostConnection=f;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(D){D[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P;function A(R){delete R[F.ENV_KEY],delete R[f.ENV_KEY],delete R[P.ENV_KEY]}function E(R,D){A(D),R.serialize(D)}e.writeExtHostConnection=E;function p(R){if(R[F.ENV_KEY])return y(R,new F(R[F.ENV_KEY]));if(R[f.ENV_KEY])return y(R,new f);if(R[P.ENV_KEY])return y(R,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function y(R,D){return A(R),D}}),define(ye[113],Ce([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var P;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(y){const R=I.VSBuffer.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=A;function E(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=E;var p;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ye[91],Ce([1,0,5,4,13,27,113,65,88,24,2,3,217]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class extends D.Disposable{constructor(o,i){super(),this.initData=o,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new F.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new F.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:p.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(r=>{(0,f.isLogLevel)(r)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),a=new C(i,r,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this._level=o,this._telemetryIsSupported=i,this._productConfig=r??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=c(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,E.getRemoteName)((0,p.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((r,n)=>{const a=r.filter(t=>!t.isDisposed);a.length===0?this._telemetryLoggers.delete(n):this._telemetryLoggers.set(n,a)}),this._telemetryLoggers.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,i){const n=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this._telemetryLoggers.delete(o.value),!1;let a=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=je([$e(0,P.IExtHostInitDataService),$e(1,f.ILoggerService)],S);class C{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,a,t,d){this._extension=r,this._logger=n,this._inLoggingOnlyMode=a,this._commonProperties=t,this._onDidChangeEnableStates=new F.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(o,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,p.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,y.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,y.mixin)(i,this._commonProperties)),"properties"in o?o.properties=i:o=i,o}logEvent(o,i){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,i),this._logger.trace(o,i))}logUsage(o,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,i)}logError(o,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,p.cleanData)(r,[]),a=new Error(n.message,{cause:n.cause});a.stack=n.stack,a.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(a,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=C;function c(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=c,e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(ye[26],Ce([1,0,4,2,261,137,25,5]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");class p{constructor(a){this.dependency=a}}e.MissingExtensionDependency=p;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(a,t,d){this._versionId=a,this._allExtensions=t.slice(0),this._myExtensions=d.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:P.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(a,t,d){if(this._versionId>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this._versionId})`);const s=[],h=[],l=[],u=[],w=D(this._allExtensions),k=D(t),b=(x,N)=>x.extensionLocation.toString()===N.extensionLocation.toString()||x.isBuiltin===N.isBuiltin||x.isUserBuiltin===N.isUserBuiltin||x.isUnderDevelopment===N.isUnderDevelopment;for(const x of this._allExtensions){const N=k.get(x.identifier);if(!N){s.push(x.identifier),w.delete(x.identifier);continue}if(!b(x,N)){s.push(x.identifier),w.delete(x.identifier);continue}}for(const x of t){const N=w.get(x.identifier);if(!N){h.push(x);continue}if(!b(N,x)){s.push(N.identifier),w.delete(N.identifier);continue}}const g=new A.ExtensionIdentifierSet(this._myExtensions),_=new A.ExtensionIdentifierSet(d);for(const x of this._myExtensions)_.has(x)||l.push(x);for(const x of d)g.has(x)||u.push(x);const T=P.ImplicitActivationEvents.createActivationEventsMap(h),O={versionId:a,toRemove:s,toAdd:h,addActivationEvents:T,myToRemove:l,myToAdd:u};return this.delta(O),O}delta(a){if(this._versionId>=a.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:s,myToAdd:h}=a,l=new A.ExtensionIdentifierSet(t),u=new A.ExtensionIdentifierSet(s);for(let w=0;w<this._allExtensions.length;w++)l.has(this._allExtensions[w].identifier)&&(this._allExtensions.splice(w,1),w--);for(let w=0;w<this._myExtensions.length;w++)u.has(this._myExtensions[w])&&(this._myExtensions.splice(w,1),w--);for(const w of d)this._allExtensions.push(w);for(const w of h)this._myExtensions.push(w);return this._myActivationEvents=null,a}containsExtension(a){for(const t of this._myExtensions)if(A.ExtensionIdentifier.equals(t,a))return!0;return!1}containsActivationEvent(a){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(a)}_readMyActivationEvents(){const a=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const d=P.ImplicitActivationEvents.readActivationEvents(t);for(const s of d)a.add(s)}return a}}e.ExtensionHostExtensions=R;function D(n){const a=new A.ExtensionIdentifierMap;for(const t of n)a.set(t.identifier,t);return a}function v(n,a){return n.enabledApiProposals?n.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function S(n,a){if(!v(n,a))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=S;class C{constructor(a,t,d,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=s}}e.ActivationTimes=C;class c{constructor(a,t){this.description=a,this.value=t}}e.ExtensionPointContribution=c;var m;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,f.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function i(n,a){return{identifier:new A.ExtensionIdentifier((0,f.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!a,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=i;class r{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=r}),define(ye[292],Ce([1,0,14,144,25,26,13,11]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.ExtensionActivationTimes=p;class y{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,i){return o===-1||i===-1?-1:i-o}build(){return new p(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class R{constructor(o,i,r,n,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=a,this.subscriptions=t}}e.ActivatedExtension=R;class D extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class v extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class S extends R{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(o,i,r,n){this._logService=n,this._registry=o,this._globalRegistry=i,this._host=r,this._operations=new f.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this._operations)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this._operations.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this._operations.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this._alreadyActivatedEvents[o])return;const r=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,i){const r=this._registry.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:r.identifier,reason:i}])}async _activateExtensions(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this._handleActivationRequest(r));await Promise.all(i.map(r=>r.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const i=this._registry.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new S(a));return this._host.onExtensionActivationError(o.id,a,new P.MissingExtensionDependency(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of n){if(this._isResolvedExtension(a))continue;const t=this._operations.get(a);if(t){r.push(t);continue}if(this._isHostExtension(a)){r.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(a).identifier,reason:o.reason}));continue}const d=this._registry.getExtensionDescription(a);if(d){if(!d.main&&!d.browser)continue;r.push(this._handleActivationRequest({id:d.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),l=this._createAndSaveOperation(o,i.displayName,[],new S(h));return this._host.onExtensionActivationError(i.identifier,h,new P.MissingExtensionDependency(a)),l}return this._createAndSaveOperation(o,i.displayName,r,null)}_createAndSaveOperation(o,i,r,n){const a=new c(o.id,i,o.reason,r,n,this._host,this._logService);return this._operations.set(o.id,a),a}_isHostExtension(o){return F.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const i=this._globalRegistry.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=C,e.ExtensionsActivator=C=je([$e(3,A.ILogService)],C);let c=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,i,r,n,a,t,d){this._id=o,this._displayName=i,this._reason=r,this._deps=n,this._value=a,this._host=t,this._logService=d,this._barrier=new E.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const i=this._deps[o];if(i.value&&!i.value.activationFailed){this._deps.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this._value=new S(r),this._host.onExtensionActivationError(this._id,r,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this._value=new S(i),this._isDisposed&&I.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};c=je([$e(6,A.ILogService)],c)}),define(ye[293],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[294],Ce([1,0,233,14,39,134,108,37,25,293,136,137]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=E.Registry.as(A.Extensions.JSONContribution);class S{constructor(a,t,d){this._messageHandler=a,this._extension=t,this._extensionPointId=d}_msg(a,t){this._messageHandler({type:a,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(f.default.Error,a)}warn(a){this._msg(f.default.Warning,a)}info(a){this._msg(f.default.Info,a)}}e.ExtensionMessageCollector=S;class C{static _toSet(a){const t=new p.ExtensionIdentifierSet;for(let d=0,s=a.length;d<s;d++)t.add(a[d].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new C(t,[]);if(!t||!t.length)return new C([],a);const d=this._toSet(a),s=this._toSet(t),h=t.filter(u=>!d.has(u.description.identifier)),l=a.filter(u=>!s.has(u.description.identifier));return new C(h,l)}constructor(a,t){this.added=a,this.removed=t}}e.ExtensionPointUserDelta=C;class c{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=C.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,F.onUnexpectedError)(a)}}}e.ExtensionPoint=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new c(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,t),a.activationEventsGenerator&&D.ImplicitActivationEvents.register(a.extensionPoint,a.activationEventsGenerator),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,v.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};E.Registry.add(r.ExtensionsRegistry,new i),e.ExtensionsRegistry=E.Registry.as(r.ExtensionsRegistry),v.registerSchema(o,e.schema),v.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ye[295],Ce([1,0,229,18,24,294,45,4]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var y;(function(v){function S(C,c,m){if(!C)return;const o=F.isString(C.type)?C.type:void 0;if(!o||o.length===0){m.error(I.localize(3,null));return}const i=[];if(Array.isArray(C.required))for(const r of C.required)F.isString(r)&&i.push(r);return{extensionId:c.value,taskType:o,required:i,properties:C.properties?f.deepClone(C.properties):{},when:C.when?A.ContextKeyExpr.deserialize(C.when):void 0}}v.from=S})(y||(y={}));const R=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,S)=>{for(const C of v)C.type&&S.push(`onTaskType:${C.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:p}});class D{constructor(){this._onDefinitionsChanged=new E.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,C)=>{R.setHandler((c,m)=>{this._schema=void 0;try{for(const o of m.removed){const i=o.value;for(const r of i)this.taskTypes&&r.type&&this.taskTypes[r.type]&&delete this.taskTypes[r.type]}for(const o of m.added){const i=o.value;for(const r of i){const n=y.from(r,o.description.identifier,o.collector);n&&(this.taskTypes[n.taskType]=n)}}(m.removed.length>0||m.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){const S=[];for(const C of this.all()){const c={type:"object",additionalProperties:!1};C.required.length>0&&(c.required=C.required.slice(0)),C.properties!==void 0?c.properties=f.deepClone(C.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[C.taskType]},S.push(c)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistry=new D}),define(ye[296],Ce([1,0,230,18,23,24,45,295]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY={value:I.localize(1,null),original:"Tasks"};var p;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function U(B){if(!B)return L.Strong;switch(B.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=U}(p||(e.ShellQuoting=p={}));var y;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(R||(e.RevealKind=R={})),function(L){function U(B){switch(B.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=U}(R||(e.RevealKind=R={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(L){function U(B){switch(B.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=U}(D||(e.RevealProblemKind=D={}));var v;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(v||(e.PanelKind=v={})),function(L){function U(B){switch(B.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=U}(v||(e.PanelKind=v={}));var S;(function(L){L.defaults={echo:!0,reveal:R.Always,revealProblems:D.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var C;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(L){function U(G){switch(G.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=U;function B(G){switch(G){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=B}(C||(e.RuntimeType=C={}));var c;(function(L){function U(B){return F.isString(B)?B:B.value}L.value=U})(c||(e.CommandString=c={}));var m;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function U(G){return G===L.Clean._id||G===L.Build._id||G===L.Rebuild._id||G===L.Test._id}L.is=U;function B(G){if(G!==void 0)return F.isString(G)?U(G)?{_id:G,isDefault:!1}:void 0:G}L.from=B})(m||(e.TaskGroup=m={}));var o;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function U(B){switch(B){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var r;(function(L){L.parallel="parallel",L.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var a;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(U,B,G,le,Y,K){this._label="",this._id=U,B&&(this._label=B),G&&(this.type=G),this.runOptions=le,this.configurationProperties=Y,this._source=K}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.getFolderId(),id:this._id};return JSON.stringify(U)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,B=!1){if(U===void 0)return!1;if(F.isString(U))return U===this._label||U===this.configurationProperties.identifier||B&&U===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),U&&(this._taskLoadMessages=this._taskLoadMessages.concat(U))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class d extends t{constructor(U,B,G,le,Y,K,Q,ue){super(U,G,void 0,Q,ue,B),this.command={},this._source=B,this.hasDefinedMatchers=K,Y&&(this.command=Y)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case C.Shell:B="shell";break;case C.Process:B="process";break;case C.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(U){return U instanceof d}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.getFolderId();if(!U)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const G={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:B};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(U){return new d(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=d;class s extends t{constructor(U,B,G,le,Y,K,Q){super(U,G,le,K,Q,B),this._source=B,this.configures=Y}static is(U){return U instanceof s}fromObject(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.getFolderId();if(!U)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const G={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:B};return JSON.stringify(G)}}e.ConfiguringTask=s;class h extends t{constructor(U,B,G,le,Y,K,Q,ue,ne){super(U,G,le,ue,ne,B),this.defines=Y,this.hasDefinedMatchers=Q,this.command=K,this.icon=ne.icon,this.hide=ne.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof h}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.getFolderId(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(U){return new h(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=h;class l extends t{constructor(U,B,G,le,Y,K){super(U,G,le,Y,K,B),this._source=B}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(U){return new l(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=l;var u;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(L){L._default=L.Terminal}(u||(e.ExecutionEngine=u={}));var w;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class k{constructor(U){this._order=new Map;for(let B=0;B<U.length;B++)this._order.set(U[B].uri.toString(),B)}compare(U,B){const G=U.getWorkspaceFolder(),le=B.getWorkspaceFolder();if(G&&le){let Y=this._order.get(G.uri.toString());Y=Y===void 0?0:Y+1;let K=this._order.get(le.uri.toString());return K=K===void 0?0:K+1,Y===K?U._label.localeCompare(B._label):Y-K}else return!G&&le?-1:G&&!le?1:0}}e.TaskSorter=k;var b;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(b||(e.TaskEventKind=b={}));var g;(function(L){L.SingleRun="singleRun",L.Background="background"})(g||(e.TaskRunType=g={}));var _;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(_||(e.TaskRunSource=_={}));var T;(function(L){function U(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function B(ue,ne,pe){return{...U(ue),kind:"start",terminalId:ne,resolvedVariables:pe}}L.start=B;function G(ue,ne,pe){return{...U(ue),kind:"processStarted",terminalId:ne,processId:pe}}L.processStarted=G;function le(ue,ne,pe){return{...U(ue),kind:"processEnded",terminalId:ne,exitCode:pe}}L.processEnded=le;function Y(ue,ne,pe){return{...U(ue),kind:"terminated",exitReason:pe,terminalId:ne}}L.terminated=Y;function K(ue,ne,pe){return{...U(ne),kind:ue,terminalId:pe}}L.general=K;function Q(){return{kind:"changed"}}L.changed=Q})(T||(e.TaskEvent=T={}));var O;(function(L){function U(G){const le=Object.keys(G).sort();let Y="";for(const K of le){let Q=G[K];Q instanceof Object?Q=U(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),Y+=K+","+Q+","}return Y}function B(G){const Y={_key:U(G),type:G.taskType};return Object.assign(Y,G),Y}L.create=B})(O||(e.KeyedTaskIdentifier=O={}));var x;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(x||(e.TaskSettingId=x={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var M;(function(L){function U(B,G){const le=E.TaskDefinitionRegistry.get(B.type);if(le===void 0){const ue=P.deepClone(B);return delete ue._key,O.create(ue)}const Y=Object.create(null);Y.type=le.taskType;const K=new Set;le.required.forEach(ue=>K.add(ue));const Q=le.properties;for(const ue of Object.keys(Q)){const ne=B[ue];if(ne!=null)Y[ue]=ne;else if(K.has(ue)){const pe=Q[ue];if(pe.default!==void 0)Y[ue]=P.deepClone(pe.default);else switch(pe.type){case"boolean":Y[ue]=!1;break;case"number":case"integer":Y[ue]=0;break;case"string":Y[ue]="";break;default:G.error(I.localize(2,null,JSON.stringify(B,void 0,0),ue));return}}}return O.create(Y)}L.createTaskIdentifier=U})(M||(e.TaskDefinition=M={}))}),define(ye[297],Ce([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,E)=>{this._actualOk=A,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,I.onUnexpectedError)(A))}then(A,E){return this._ensureActual().then(A,E)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F;class f extends F{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=f}),define(ye[68],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.ProxyIdentifier=I;const F=[];function f(E){const p=new I(E);return F[p.nid]=p,p}e.createProxyIdentifier=f;function P(E){return F[E].sid}e.getStringIdentifierForProxy=P;class A{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=A}),define(ye[6],Ce([1,0,68]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var E;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(E||(e.WebviewMessageArrayBufferViewType=E={}));var p;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class D{static{this._n=0}static mixin(m){return m._id=D._n++,m}}e.IdObject=D;var v;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var S;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var C;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,I.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,I.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,I.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,I.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.createProxyIdentifier)("ExtHostIssueReporter")}}),define(ye[92],Ce([1,0,5,13,6,20]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(p,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=p.getProxy(f.MainContext.MainThreadTelemetry)}report(p,y,R){const D=this.getUsageKey(p,y);this._reportedUsages.has(D)||(this._reportedUsages.add(D),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:p}))}getUsageKey(p,y){return`${p}-${y.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=je([$e(0,P.IExtHostRpcService),$e(1,F.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(E,p,y){}})}),define(ye[298],Ce([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(P){const A=P.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(E){return A.$writeText(E)}})}}e.ExtHostClipboard=F}),define(ye[299],Ce([1,0,24,6,27,20]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(R,D){this._mainThreadConsole=R.getProxy(F.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,D){const v=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){v._handleConsoleCall(R,D,S,arguments)}})}_handleConsoleCall(R,D,v,S){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:p(S,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,v,S)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=je([$e(0,P.IExtHostRpcService),$e(1,f.IExtHostInitDataService)],A);const E=1e5;function p(y,R){const D=[];if(y.length)for(let v=0;v<y.length;v++){let S=y[v];if(typeof S>"u")S="undefined";else if(S instanceof Error){const C=S;C.stack?S=C.stack:S=C.toString()}D.push(S)}if(R){const v=new Error().stack;v&&D.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,I.safeStringify)(D);return v.length>E?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[300],Ce([1,0,2,6,26]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(E){this._proxy=E.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(E,p){return p?.allowUIResources&&(0,f.checkProposedApiEnabled)(E,"showLocal"),this._proxy.$showOpenDialog(p).then(y=>y?y.map(R=>I.URI.revive(R)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(p=>p?I.URI.revive(p):void 0)}}e.ExtHostDialogs=P}),define(ye[301],Ce([1,0,3,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class f{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,A),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=f}),define(ye[114],Ce([1,0,10,12,2,5,13,6,27,20]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(v,S,C){this.logService=C,this.bundleCache=new Map,this._proxy=S.getProxy(E.MainContext.MainThreadLocalization),this.currentLanguage=v.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(v,S){const{message:C,args:c,comment:m}=S;if(this.isDefaultLanguage)return(0,F.format2)(C,c??{});let o=C;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.bundleCache.get(v)?.contents[o];return i||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.format2)(i??C,c??{})}getBundle(v){return this.bundleCache.get(v)?.contents}getBundleUri(v){return this.bundleCache.get(v)?.uri}async initializeLocalizedMessages(v){if(this.isDefaultLanguage||!v.l10n&&!v.isBuiltin||this.bundleCache.has(v.identifier.value))return;let S;const C=await this.getBundleLocation(v);if(!C){this.logService.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const c=await this._proxy.$fetchBundleContents(C),m=JSON.parse(c);S=v.isBuiltin?m.contents?.bundle:m}catch(c){this.logService.error(`Failed to load translations for ${v.identifier.value} from ${C}: ${c.message}`);return}S&&this.bundleCache.set(v.identifier.value,{contents:S,uri:C})}async getBundleLocation(v){if(v.isBuiltin){const S=await this._proxy.$fetchBuiltInBundleUri(v.identifier.value,this.currentLanguage);return f.URI.revive(S)}return v.l10n?f.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R,e.ExtHostLocalizationService=R=je([$e(0,p.IExtHostInitDataService),$e(1,y.IExtHostRpcService),$e(2,A.ILogService)],R),e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(ye[145],Ce([1,0,13,6,27,20,2,56]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let p=class extends I.AbstractLoggerService{constructor(D,v){super(v.logLevel,v.logsLocation,v.loggers.map(S=>(0,E.revive)(S))),this._proxy=D.getProxy(F.MainContext.MainThreadLogger)}$setLogLevel(D,v){v?this.setLogLevel(A.URI.revive(v),D):this.setLogLevel(D)}setVisibility(D,v){super.setVisibility(D,v),this._proxy.$setVisibility(D,v)}doCreateLogger(D,v,S){return new y(this._proxy,D,v,S)}};e.ExtHostLoggerService=p,e.ExtHostLoggerService=p=je([$e(0,P.IExtHostRpcService),$e(1,f.IExtHostInitDataService)],p);class y extends I.AbstractMessageLogger{constructor(D,v,S,C){super(C?.logLevel==="always"),this.proxy=D,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(v,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(D,v){const S=[[D,v]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(D){this.proxy.$log(this.file,D)}flush(){this.proxy.$flush(this.file)}}}),define(ye[115],Ce([1,0,6,5,3,20,22]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,F.createDecorator)("IExtHostManagedSockets");let E=class{constructor(D){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(D,v){for(const S of this._managedRemoteSockets.values())S.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new p(D,v),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(D){if(!this._factory||this._factory.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const v=++this._remoteSocketIdCounter,S=await this._factory.makeConnection(),C=new f.DisposableStore;return this._managedRemoteSockets.set(v,new y(v,S,C)),C.add((0,f.toDisposable)(()=>this._managedRemoteSockets.delete(v))),C.add(S.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(v),C.dispose()})),C.add(S.onDidClose(c=>{this._proxy.$onDidManagedSocketClose(v,c?.stack??c?.message),C.dispose()})),C.add(S.onDidReceiveMessage(c=>this._proxy.$onDidManagedSocketHaveData(v,A.VSBuffer.wrap(c)))),v}$remoteSocketWrite(D,v){this._managedRemoteSockets.get(D)?.actual.send(v.buffer)}$remoteSocketEnd(D){const v=this._managedRemoteSockets.get(D);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(D){await this._managedRemoteSockets.get(D)?.actual.drain?.()}};e.ExtHostManagedSockets=E,e.ExtHostManagedSockets=E=je([$e(0,P.IExtHostRpcService)],E);class p{constructor(D,v){this.socketFactoryId=D,this.makeConnection=v}}class y extends f.Disposable{constructor(D,v,S){super(),this.socketId=D,this.actual=v,this._register(S)}}}),define(ye[302],Ce([1,0,6,13,26]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(E){return E&&E.title}let A=class{constructor(p,y){this._logService=y,this._proxy=p.getProxy(I.MainContext.MainThreadMessageService)}showMessage(p,y,R,D,v){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let C;typeof D=="string"||P(D)?C=[D,...v]:(S.modal=D?.modal,S.useCustom=D?.useCustom,S.detail=D?.detail,C=v),S.useCustom&&(0,f.checkProposedApiEnabled)(p,"resolvers");const c=[];let m=!1;for(let o=0;o<C.length;o++){const i=C[o];if(typeof i=="string")c.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;c.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(m?this._logService.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this._logService.warn(`[${p.identifier}] Invalid message item:`,i)}return this._proxy.$showMessage(y,R,S,c).then(o=>{if(typeof o=="number")return C[o]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=je([$e(1,F.ILogService)],A)}),define(ye[303],Ce([1,0,3,18,2,26,6]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class E{constructor(y){this.handlers=new Map,this.proxy=y.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,R,D){if((0,P.checkProposedApiEnabled)(y,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,D),this.proxy.$registerProfileContentHandler(R,D.name,D.description,y.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,D,v){const S=this.handlers.get(y);if(!S)throw new Error(`Unknown handler with id: ${y}`);return S.saveProfile(R,D,v)}async $readProfile(y,R,D){const v=this.handlers.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.readProfile((0,F.isString)(R)?R:f.URI.revive(R),D)}}e.ExtHostProfileContentHandlers=E}),define(ye[116],Ce([1,0,6,4,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(E){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,p){return this._proxy.$getPassword(E,p)}store(E,p,y){return this._proxy.$setPassword(E,p,y)}delete(E,p){return this._proxy.$deletePassword(E,p)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,f.createDecorator)("IExtHostSecretState")}),define(ye[304],Ce([1,0,21,3,6]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class P{static{this.ID_POOL=1}constructor(E){this.providers=new Map,this.sessions=new Map,this.proxy=E.getProxy(f.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(E,p){const y=this.providers.get(E);if(!y)return;const R=new F.DisposableStore,D=new I.CancellationTokenSource;this.sessions.set(p,D);const v=R.add(y.provideSpeechToTextSession(D.token));R.add(v.onDidChange(S=>{D.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(p,S)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(E){this.sessions.get(E)?.dispose(!0),this.sessions.delete(E)}async $createKeywordRecognitionSession(E,p){const y=this.providers.get(E);if(!y)return;const R=new F.DisposableStore,D=new I.CancellationTokenSource;this.sessions.set(p,D);const v=R.add(y.provideKeywordRecognitionSession(D.token));R.add(v.onDidChange(S=>{D.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(p,S)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(E){this.sessions.get(E)?.dispose(!0),this.sessions.delete(E)}registerProvider(E,p,y){const R=P.ID_POOL++;return this.providers.set(R,y),this.proxy.$registerProvider(R,p,{extension:E,displayName:E.value}),(0,F.toDisposable)(()=>{this.proxy.$unregisterProvider(R),this.providers.delete(R)})}}e.ExtHostSpeech=P}),define(ye[117],Ce([1,0,6,4,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(E,p){this._logService=p,this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,p){this._proxy.$registerExtensionStorageKeysToSync(E,p)}async initializeExtensionStorage(E,p,y){const R=await this._proxy.$initializeExtensionStorage(E,p);let D;return R&&(D=this.safeParseValue(E,p,R)),D||y}setValue(E,p,y){return this._proxy.$setValue(E,p,y)}$acceptValue(E,p,y){const R=this.safeParseValue(E,p,y);R&&this._onDidChangeStorage.fire({shared:E,key:p,value:R})}safeParseValue(E,p,y){try{return JSON.parse(y)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${E}): ${R}`)}}}e.ExtHostStorage=P,e.IExtHostStorage=(0,f.createDecorator)("IExtHostStorage")}),define(ye[305],Ce([1,0,3,16,2,6]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}constructor(p){this._openers=new Map,this._proxy=p.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(p,y,R,D){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const v=D.schemes.find(S=>!A.supportedSchemes.has(S));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,R),this._proxy.$registerUriOpener(y,D.schemes,p,D.label),(0,I.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(p,y,R){const D=this._openers.get(p);if(!D)throw new Error(`Unknown opener with id: ${p}`);const v=f.URI.revive(y);return D.canOpenExternalUri(v,R)}async $openUri(p,y,R){const D=this._openers.get(p);if(!D)throw new Error(`Unknown opener id: '${p}'`);return D.openExternalUri(f.URI.revive(y.resolvedUri),{sourceUri:f.URI.revive(y.sourceUri)},R)}}e.ExtHostUriOpeners=A}),define(ye[306],Ce([1,0,6,2,3,14,25]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{static{this.HandlePool=0}constructor(y){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(y,R){const D=y.identifier;if(this.handles.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const v=E.HandlePool++;return this.handles.add(D),this.handlers.set(v,R),this._proxy.$registerUriHandler(v,D,y.displayName||y.name),(0,f.toDisposable)(()=>{this.handles.delete(D),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(y,R){const D=this.handlers.get(y);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(R))}catch(v){(0,P.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(y){return F.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=E}),define(ye[93],Ce([1,0,4,3,16,24,2,237,274,112,6]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(n,a,t,d,s,h,l){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=n,this.#t=a,this.#o=t,this.#n=d,this.#s=s,this.#r=h,this.#u=v(h),this.#h=S(h),this.#i=l}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,y.asWebviewUri)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===f.Schemas.https||n.scheme===f.Schemas.http){let a=n.toString();return a.endsWith("/")||(a+="/"),a+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(n){this.assertNotDisposed(),this.#a!==n&&(this.#a=n,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(n)))}get options(){return this.assertNotDisposed(),this.#o}set options(n){this.assertNotDisposed(),P.equals(this.#o,n)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const a=(0,p.serializeWebviewMessage)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(n){if(!this.#h)return n;const a=this.#r.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,s,h,l,u,w)=>{const k=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,y.asWebviewUri)(k,{isRemote:a,authority:t}).toString();return`${s}${b}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,s,h,l,u,w)=>{const k=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,y.asWebviewUri)(k,{isRemote:a,authority:t}).toString();return`${s}${b}${w}`})}}e.ExtHostWebview=D;function v(r){try{const n=(0,E.normalizeVersion)((0,E.parseVersion)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;function S(r){try{const n=(0,E.normalizeVersion)((0,E.parseVersion)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class C extends F.Disposable{constructor(n,a,t,d,s){super(),this.remoteInfo=a,this.workspace=t,this._logService=d,this._deprecationService=s,this._webviews=new Map,this._webviewProxy=n.getProxy(R.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const n of this._webviews.values())n.dispose();this._webviews.clear()}$onMessage(n,a,t){const d=this.getWebview(n);if(d){const{message:s}=(0,p.deserializeWebviewMessage)(a,t.value);d._onMessageEmitter.fire(s)}}$onMissingCsp(n,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,a,t){const d=new D(n,this._webviewProxy,o(a),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(n,d);const s=d._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return d}deleteWebview(n){this._webviews.delete(n)}getWebview(n){return this._webviews.get(n)}}e.ExtHostWebviews=C;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=c;function m(r,n,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(r,n)}}e.serializeWebviewOptions=m;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>A.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(a=>a.uri),r.extensionLocation]}}),define(ye[146],Ce([1,0,4,6,2,16,12,5,20,26]),function(me,e,I,F,f,P,A,E,p,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class{static{R=this}static{this.InitialState={focused:!0,active:!0}}getState(S){const C=this._state;return{get focused(){return C.focused},get active(){return(0,y.checkProposedApiEnabled)(S,"windowActivity"),C.active}}}constructor(S){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=R.InitialState,this._proxy=S.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:c})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,C){C!==this._state[S]&&(this._state={...this._state,[S]:C},this._onDidChangeWindowState.fire(this._state))}openUri(S,C){let c;if(typeof S=="string"){c=S;try{S=f.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,c,C)}async asExternalUri(S,C){if((0,A.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this._proxy.$asExternalUri(S,C);return f.URI.from(c)}};e.ExtHostWindow=D,e.ExtHostWindow=D=R=je([$e(0,p.IExtHostRpcService)],D),e.IExtHostWindow=(0,E.createDecorator)("IExtHostWindow")}),define(ye[307],Ce([1,0,299,27,20]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let A=class extends I.AbstractExtHostConsoleForwarder{constructor(p,y){super(p,y),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(p,y,R){const D=p==="error"||p==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,D.write(`
START_NATIVE_LOG
`),y.apply(console,R),D.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(p,y){const R=process[p],D=R.write;let v="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,C,c)=>{if(!this._isMakingConsoleCall){v+=S.toString(C);const m=v.length>P?v.length:v.lastIndexOf(`
`);m!==-1&&(console[y](v.slice(0,m)),v=v.slice(m+1))}D.call(R,S,C,c)}})}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=je([$e(0,f.IExtHostRpcService),$e(1,F.IExtHostInitDataService)],A)}),define(ye[308],Ce([1,0,145,16,251,30]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends I.ExtHostLoggerService{doCreateLogger(p,y,R){return p.scheme===F.Schemas.file?new f.SpdLogLogger(R?.name||(0,P.generateUuid)(),p.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.doCreateLogger(p,y,R)}registerLogger(p){super.registerLogger(p),this._proxy.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this._proxy.$deregisterLogger(p)}}e.ExtHostLoggerService=A}),define(ye[309],Ce([1,0,11,22,21,14,4,3,130,297,68]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(_,T){try{return JSON.stringify(_,T)}catch{return"null"}}const S="$$ref$$",C={[S]:-1};class c{constructor(T,O){this.jsonString=T,this.referencedBuffers=O}}function m(_,T=null,O=!1){const x=[];return{jsonString:(O?v:JSON.stringify)(_,(M,L)=>{if(typeof L>"u")return C;if(typeof L=="object"){if(L instanceof F.VSBuffer){const U=x.push(L)-1;return{[S]:U}}if(T)return T(M,L)}return L}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=m;function o(_,T,O){return JSON.parse(_,(x,N)=>{if(N){const M=N[S];if(typeof M=="number")return T[M];if(O&&N.$mid===1)return O.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=o;function i(_,T){return JSON.stringify(_,T)}function r(_){return _?(T,O)=>O&&O.$mid===1?_.transformOutgoing(O):O:null}var n;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var a;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class h extends E.Disposable{static{D=d}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(T,O=null,x=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=O,this._uriTransformer=x,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,M=R.ProxyIdentifier.count;N<M;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{const O=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],O.resolveErr(P.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,p.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:O,sid:x}=T;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,x)),this._proxies[O]}_createProxy(T,O){const x={get:(N,M)=>(typeof M=="string"&&!N[M]&&M.charCodeAt(0)===36&&(N[M]=(...L)=>this._remoteCall(T,M,L)),M===s?O:N[M])};return new Proxy(Object.create(null),x)}set(T,O){return this._locals[T.nid]=O,O}assertRegistered(T){for(let O=0,x=T.length;O<x;O++){const N=T[O];if(!this._locals[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const O=T.byteLength,x=u.read(T,0),N=x.readUInt8(),M=x.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:U,args:B}=k.deserializeRequestJSONArgs(x);this._uriTransformer&&(B=(0,p.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(O,M,L,U,B,N===2);break}case 3:case 4:{let{rpcId:L,method:U,args:B}=k.deserializeRequestMixedArgs(x);this._uriTransformer&&(B=(0,p.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(O,M,L,U,B,N===4);break}case 5:{this._logger?.logIncoming(O,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(O,M);break}case 7:{this._receiveReply(O,M,void 0);break}case 9:{let L=k.deserializeReplyOKJSON(x);this._uriTransformer&&(L=(0,p.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(O,M,L);break}case 10:{const L=k.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(O,M,L);break}case 8:{const L=k.deserializeReplyOKVSBuffer(x);this._receiveReply(O,M,L);break}case 11:{let L=k.deserializeReplyErrError(x);this._uriTransformer&&(L=(0,p.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(O,M,L);break}case 12:{this._receiveReplyErr(O,M,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,O,x,N,M,L){this._logger?.logIncoming(T,O,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${N}(`,M);const U=String(O);let B,G;if(L){const Y=new f.CancellationTokenSource;M.push(Y.token),B=this._invokeHandler(x,N,M),G=()=>Y.cancel()}else B=this._invokeHandler(x,N,M),G=t;this._cancelInvokedHandlers[U]=G;const le=k.serializeAcknowledged(O);this._logger?.logOutgoing(le.byteLength,O,1,"ack"),this._protocol.send(le),B.then(Y=>{delete this._cancelInvokedHandlers[U];const K=k.serializeReplyOK(O,Y,this._uriReplacer);this._logger?.logOutgoing(K.byteLength,O,1,"reply:",Y),this._protocol.send(K)},Y=>{delete this._cancelInvokedHandlers[U];const K=k.serializeReplyErr(O,Y);this._logger?.logOutgoing(K.byteLength,O,1,"replyErr:",Y),this._protocol.send(K)})}_receiveCancel(T,O){this._logger?.logIncoming(T,O,1,"receiveCancel");const x=String(O);this._cancelInvokedHandlers[x]?.()}_receiveReply(T,O,x){this._logger?.logIncoming(T,O,0,"receiveReply:",x);const N=String(O);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const M=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],M.resolveOk(x)}_receiveReplyErr(T,O,x){this._logger?.logIncoming(T,O,0,"receiveReplyErr:",x);const N=String(O);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const M=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let L;x&&(x.$isError?(L=new Error,L.name=x.name,L.message=x.message,L.stack=x.stack):L=x),M.resolveErr(L)}_invokeHandler(T,O,x){try{return Promise.resolve(this._doInvokeHandler(T,O,x))}catch(N){return Promise.reject(N)}}_doInvokeHandler(T,O,x){const N=this._locals[T];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(T));const M=N[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.getStringIdentifierForProxy)(T));return M.apply(N,x)}_remoteCall(T,O,x){if(this._isDisposed)return new y.CanceledLazyPromise;let N=null;if(x.length>0&&f.CancellationToken.isCancellationToken(x[x.length-1])&&(N=x.pop()),N&&N.isCancellationRequested)return Promise.reject(P.canceled());const M=k.serializeRequestArguments(x,this._uriReplacer),L=++this._lastMessageId,U=String(L),B=new y.LazyPromise,G=new E.DisposableStore;N&&G.add(N.onCancellationRequested(()=>{const Y=k.serializeCancel(L);this._logger?.logOutgoing(Y.byteLength,L,0,"cancel"),this._protocol.send(k.serializeCancel(L))})),this._pendingRPCReplies[U]=new l(B,G),this._onWillSendRequest(L);const le=k.serializeRequest(L,T,O,M,!!N);return this._logger?.logOutgoing(le.byteLength,L,0,`request: ${(0,R.getStringIdentifierForProxy)(T)}.${O}(`,x),this._protocol.send(le),B}}e.RPCProtocol=h;class l{constructor(T,O){this._promise=T,this._disposable=O}resolveOk(T){this._promise.resolveOk(T),this._disposable.dispose()}resolveErr(T){this._promise.resolveErr(T),this._disposable.dispose()}}class u{static alloc(T,O,x){const N=new u(F.VSBuffer.alloc(x+1+4),0);return N.writeUInt8(T),N.writeUInt32(O),N}static read(T,O){return new u(T,O)}get buffer(){return this._buff}constructor(T,O){this._buff=T,this._offset=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,O}static sizeMixedArray(T){let O=0;O+=1;for(let x=0,N=T.length;x<N;x++){const M=T[x];switch(O+=1,M.type){case 1:O+=this.sizeLongString(M.value);break;case 2:O+=this.sizeVSBuffer(M.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let L=0;L<M.buffers.length;++L)O+=this.sizeVSBuffer(M.buffers[L]);break;case 4:break}}return O}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let O=0,x=T.length;O<x;O++){const N=T[O];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let M=0;M<N.buffers.length;++M)this.writeBuffer(N.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(T);for(let x=0;x<T;x++)switch(this.readUInt8()){case 1:O[x]=this.readLongString();break;case 2:O[x]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),L=this.readLongString(),U=[];for(let B=0;B<M;++B)U.push(this.readVSBuffer());O[x]=new R.SerializableObjectWithBuffers(o(L,U,null));break}case 4:O[x]=void 0;break}return O}}var w;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(w||(w={}));class k{static _useMixedArgSerialization(T){for(let O=0,x=T.length;O<x;O++)if(T[O]instanceof F.VSBuffer||T[O]instanceof R.SerializableObjectWithBuffers||typeof T[O]>"u")return!0;return!1}static serializeRequestArguments(T,O){if(this._useMixedArgSerialization(T)){const x=[];for(let N=0,M=T.length;N<M;N++){const L=T[N];if(L instanceof F.VSBuffer)x[N]={type:2,value:L};else if(typeof L>"u")x[N]={type:4};else if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:B}=m(L.value,O);x[N]={type:3,value:F.VSBuffer.fromString(U),buffers:B}}else x[N]={type:1,value:F.VSBuffer.fromString(i(L,O))}}return{type:1,args:x}}return{type:0,args:i(T,O)}}static serializeRequest(T,O,x,N,M){switch(N.type){case 0:return this._requestJSONArgs(T,O,x,N.args,M);case 1:return this._requestMixedArgs(T,O,x,N.args,M)}}static _requestJSONArgs(T,O,x,N,M){const L=F.VSBuffer.fromString(x),U=F.VSBuffer.fromString(N);let B=0;B+=u.sizeUInt8(),B+=u.sizeShortString(L),B+=u.sizeLongString(U);const G=u.alloc(M?2:1,T,B);return G.writeUInt8(O),G.writeShortString(L),G.writeLongString(U),G.buffer}static deserializeRequestJSONArgs(T){const O=T.readUInt8(),x=T.readShortString(),N=T.readLongString();return{rpcId:O,method:x,args:JSON.parse(N)}}static _requestMixedArgs(T,O,x,N,M){const L=F.VSBuffer.fromString(x);let U=0;U+=u.sizeUInt8(),U+=u.sizeShortString(L),U+=u.sizeMixedArray(N);const B=u.alloc(M?4:3,T,U);return B.writeUInt8(O),B.writeShortString(L),B.writeMixedArray(N),B.buffer}static deserializeRequestMixedArgs(T){const O=T.readUInt8(),x=T.readShortString(),N=T.readMixedArray(),M=new Array(N.length);for(let L=0,U=N.length;L<U;L++){const B=N[L];typeof B=="string"?M[L]=JSON.parse(B):M[L]=B}return{rpcId:O,method:x,args:M}}static serializeAcknowledged(T){return u.alloc(5,T,0).buffer}static serializeCancel(T){return u.alloc(6,T,0).buffer}static serializeReplyOK(T,O,x){if(typeof O>"u")return this._serializeReplyOKEmpty(T);if(O instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(T,O);if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:M}=m(O.value,x,!0);return this._serializeReplyOKJSONWithBuffers(T,N,M)}else return this._serializeReplyOKJSON(T,v(O,x))}static _serializeReplyOKEmpty(T){return u.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,O){let x=0;x+=u.sizeVSBuffer(O);const N=u.alloc(8,T,x);return N.writeVSBuffer(O),N.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,O){const x=F.VSBuffer.fromString(O);let N=0;N+=u.sizeLongString(x);const M=u.alloc(9,T,N);return M.writeLongString(x),M.buffer}static _serializeReplyOKJSONWithBuffers(T,O,x){const N=F.VSBuffer.fromString(O);let M=0;M+=u.sizeUInt32,M+=u.sizeLongString(N);for(const U of x)M+=u.sizeVSBuffer(U);const L=u.alloc(10,T,M);L.writeUInt32(x.length),L.writeLongString(N);for(const U of x)L.writeBuffer(U);return L.buffer}static deserializeReplyOKJSON(T){const O=T.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(T,O){const x=T.readUInt32(),N=T.readLongString(),M=[];for(let L=0;L<x;++L)M.push(T.readVSBuffer());return new R.SerializableObjectWithBuffers(o(N,M,O))}static serializeReplyErr(T,O){const x=O?v(P.transformErrorForSerialization(O),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(T);const N=F.VSBuffer.fromString(x);let M=0;M+=u.sizeLongString(N);const L=u.alloc(11,T,M);return L.writeLongString(N),L.buffer}static deserializeReplyErrError(T){const O=T.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(T){return u.alloc(12,T,0).buffer}}var b;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var g;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(g||(g={}))}),define(ye[310],Ce([1,0,22,28,16,84,5]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.generate=e.parse=e.INotebookDocumentService=void 0,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const E=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${E.join("")}]+`),y=7;function R(S){if(S.scheme!==f.Schemas.vscodeNotebookCell)return;const C=S.fragment.indexOf("s");if(C<0)return;const c=parseInt(S.fragment.substring(0,C).replace(p,""),y),m=(0,I.decodeBase64)(S.fragment.substring(C+1)).toString();if(!isNaN(c))return{handle:c,notebook:S.with({scheme:m,fragment:null})}}e.parse=R;function D(S,C){const c=C.toString(y),o=`${c.length<E.length?E[c.length-1]:"z"}${c}s${(0,I.encodeBase64)(I.VSBuffer.fromString(S.scheme),!0,!0)}`;return S.with({scheme:f.Schemas.vscodeNotebookCell,fragment:o})}e.generate=D;class v{constructor(){this._documents=new F.ResourceMap}getNotebook(C){if(C.scheme===f.Schemas.vscodeNotebookCell){const c=R(C);if(c){const m=this._documents.get(c.notebook);if(m)return m}}return this._documents.get(C)}addNotebookDocument(C){this._documents.set(C.uri,C)}removeNotebookDocument(C){this._documents.delete(C.uri)}}e.NotebookDocumentWorkbenchService=v,(0,P.registerSingleton)(e.INotebookDocumentService,v,1)}),define(ye[118],Ce([1,0,22,35,53,101,16,17,10,45,310]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var D;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(D||(e.CellKind=D={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var v;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var C;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(C||(e.NotebookExecutionState=C={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(B){B.scheme=A.Schemas.vscodeNotebookCell;function G(ne,pe){return(0,R.generate)(ne,pe)}B.generate=G;function le(ne){return(0,R.parse)(ne)}B.parse=le;function Y(ne,pe){return ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${ne.scheme!==A.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=Y;function K(ne){if(ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!pe)return;const oe=pe[1]&&pe[1]!==""?pe[1]:void 0,q=pe[2];return{outputId:oe,notebook:ne.with({scheme:q||A.Schemas.file,fragment:null})}}B.parseCellOutputUri=K;function Q(ne,pe,oe){return B.generate(ne,pe).with({scheme:oe})}B.generateCellPropertyUri=Q;function ue(ne,pe){if(ne.scheme===pe)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(n||(e.CellUri=n={}));const a=B=>p.isWindows?B.replace(/\//g,"\\"):B;class t{constructor(G=[],le=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=le,this.order=[...new Set(G)].map(Y=>({pattern:Y,matches:F.parse(a(Y))}))}sort(G){const le=new Map(f.Iterable.map(G,K=>[K,a(K)]));let Y=[];for(const{matches:K}of this.order)for(const[Q,ue]of le)if(K(ue)){Y.push(Q),le.delete(Q);break}return le.size&&(Y=Y.concat([...le.keys()].sort((K,Q)=>this.defaultOrder.indexOf(K)-this.defaultOrder.indexOf(Q)))),Y}prioritize(G,le){const Y=this.findIndex(G);if(Y===-1){this.order.unshift({pattern:G,matches:F.parse(a(G))});return}const K=new Set(le.map(ue=>this.findIndex(ue,Y)));K.delete(-1);const Q=Array.from(K).sort();this.order.splice(Y+1,0,...Q.map(ue=>this.order[ue]));for(let ue=Q.length-1;ue>=0;ue--)this.order.splice(Q[ue],1)}toArray(){return this.order.map(G=>G.pattern)}findIndex(G,le=this.order.length){const Y=a(G);for(let K=0;K<le;K++)if(this.order[K].matches(Y))return K;return-1}}e.MimeTypeDisplayOrder=t;function d(B,G,le,Y=(K,Q)=>K===Q){const K=[];function Q(pe,oe,q){if(oe===0&&q.length===0)return;const W=K[K.length-1];W&&W.start+W.deleteCount===pe?(W.deleteCount+=oe,W.toInsert.push(...q)):K.push({start:pe,deleteCount:oe,toInsert:q})}let ue=0,ne=0;for(;;){if(ue===B.length){Q(ue,0,G.slice(ne));break}if(ne===G.length){Q(ue,B.length-ue,[]);break}const pe=B[ue],oe=G[ne];if(Y(pe,oe)){ue+=1,ne+=1;continue}le(oe)?(Q(ue,1,[]),ue+=1):(Q(ue,0,[oe]),ne+=1)}return K}e.diff=d,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtLineBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s||(e.NotebookEditorPriority=s={}));function h(B){const G=B;return!!((typeof G.include=="string"||F.isRelativePattern(G.include))&&(typeof G.exclude=="string"||F.isRelativePattern(G.exclude)))}e.isDocumentExcludePattern=h;function l(B,G,le){if(Array.isArray(B.viewType)&&B.viewType.indexOf(G)>=0||B.viewType===G)return!0;if(B.filenamePattern){const Y=h(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,K=h(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(F.match(Y,(0,E.basename)(le.fsPath).toLowerCase()))return!(K&&F.match(K,(0,E.basename)(le.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var u;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class w{static{this._prefix="notebook/"}static create(G){return`${w._prefix}${G}`}static parse(G){if(G.startsWith(w._prefix))return G.substring(w._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=w;function k(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=k;const b=new TextDecoder;function g(B){const G=[];let le=!1;for(const ue of B)(G.length===0||le)&&(G.push(ue),le=!0);let Y=O(G);const K=I.VSBuffer.concat(G.map(ue=>I.VSBuffer.wrap(ue))),Q=U(K);return Y=Y||Q.byteLength!==K.byteLength,{data:Q,didCompression:Y}}e.compressOutputItemStreams=g,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const _=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(B=>B.charCodeAt(0)),T=10;function O(B){let G=!1;return B.forEach((le,Y)=>{if(Y===0||le.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const K=B[Y-1],Q=le.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Q[0]===_[0]&&Q[1]===_[1]&&Q[2]===_[2]){const ue=K.lastIndexOf(T);if(ue===-1)return;G=!0,B[Y-1]=K.subarray(0,ue),B[Y]=le.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),G}function x(B){let G=B;do B=G,G=B.replace(/[^\n]\x08/gm,"");while(G.length<B.length);return B}function N(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const G=B.match(/^(.*)\r+/m)[1];let le=B.match(/\r+(.*)$/m)[1];le=le+G.slice(le.length,G.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return B}const M="\b".charCodeAt(0),L="\r".charCodeAt(0);function U(B){return!B.buffer.includes(M)&&!B.buffer.includes(L)?B:I.VSBuffer.fromString(N(x(b.decode(B.buffer))))}}),define(ye[7],Ce([1,0,19,14,80,28,101,12,18,2,30,25,32,64,118]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";var c,m,o,i,r,n,a,t,d,s,h,l,u,w,k,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.ChatAgentCompletionItem=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function _(V){return Object.assign(V,{apply:function(...be){if(be.length===0)return Reflect.construct(V,[]);{const Oe=be.length===1?[]:be[1];return Reflect.construct(V,Oe,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(V,[]);{const[Oe,...Ye]=be;return Reflect.construct(V,Ye,Oe.constructor)}}})}var T;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var O;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let x=c=class{static from(...$){let be=$;return new c(function(){if(be){for(const Oe of be)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();be=void 0}})}#e;constructor($){this.#e=$}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=x,e.Disposable=x=c=je([_],x);let N=m=class{static Min(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Oe=1;Oe<$.length;Oe++){const Ye=$[Oe];Ye.isBefore(be)&&(be=Ye)}return be}static Max(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Oe=1;Oe<$.length;Oe++){const Ye=$[Oe];Ye.isAfter(be)&&(be=Ye)}return be}static isPosition($){if(!$)return!1;if($ instanceof m)return!0;const{line:be,character:Oe}=$;return typeof be=="number"&&typeof Oe=="number"}static of($){if($ instanceof m)return $;if(this.isPosition($))return new m($.line,$.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor($,be){if($<0)throw(0,F.illegalArgument)("line must be non-negative");if(be<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=$,this._character=be}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,be=0){if($===null||be===null)throw(0,F.illegalArgument)();let Oe;return typeof $>"u"?Oe=0:typeof $=="number"?Oe=$:(Oe=typeof $.lineDelta=="number"?$.lineDelta:0,be=typeof $.characterDelta=="number"?$.characterDelta:0),Oe===0&&be===0?this:new m(this.line+Oe,this.character+be)}with($,be=this.character){if($===null||be===null)throw(0,F.illegalArgument)();let Oe;return typeof $>"u"?Oe=this.line:typeof $=="number"?Oe=$:(Oe=typeof $.line=="number"?$.line:this.line,be=typeof $.character=="number"?$.character:this.character),Oe===this.line&&be===this.character?this:new m(Oe,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=N,e.Position=N=m=je([_],N);let M=o=class{static isRange($){return $ instanceof o?!0:$?N.isPosition($.start)&&N.isPosition($.end):!1}static of($){if($ instanceof o)return $;if(this.isRange($))return new o($.start,$.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor($,be,Oe,Ye){let tt,ut;if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(tt=new N($,be),ut=new N(Oe,Ye)):N.isPosition($)&&N.isPosition(be)&&(tt=N.of($),ut=N.of(be)),!tt||!ut)throw new Error("Invalid arguments");tt.isBefore(ut)?(this._start=tt,this._end=ut):(this._start=ut,this._end=tt)}contains($){return o.isRange($)?this.contains($.start)&&this.contains($.end):N.isPosition($)?!(N.of($).isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const be=N.Max($.start,this._start),Oe=N.Min($.end,this._end);if(!be.isAfter(Oe))return new o(be,Oe)}union($){if(this.contains($))return this;if($.contains(this))return $;const be=N.Min($.start,this._start),Oe=N.Max($.end,this.end);return new o(be,Oe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,be=this.end){if($===null||be===null)throw(0,F.illegalArgument)();let Oe;return $?N.isPosition($)?Oe=$:(Oe=$.start||this.start,be=$.end||this.end):Oe=this.start,Oe.isEqual(this._start)&&be.isEqual(this.end)?this:new o(Oe,be)}toJSON(){return[this.start,this.end]}};e.Range=M,e.Range=M=o=je([_],M);let L=i=class extends M{static isSelection($){return $ instanceof i?!0:$?M.isRange($)&&N.isPosition($.anchor)&&N.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor($,be,Oe,Ye){let tt,ut;if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(tt=new N($,be),ut=new N(Oe,Ye)):N.isPosition($)&&N.isPosition(be)&&(tt=N.of($),ut=N.of(be)),!tt||!ut)throw new Error("Invalid arguments");super(tt,ut),this._anchor=tt,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=L,e.Selection=L=i=je([_],L);const U=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,F.illegalArgument)("connectionToken")};class B{static isResolvedAuthority($){return $&&typeof $=="object"&&typeof $.host=="string"&&typeof $.port=="number"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be,Oe){if(typeof $!="string"||$.length===0)throw(0,F.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,F.illegalArgument)("port");typeof Oe<"u"&&U(Oe),this.host=$,this.port=Math.round(be),this.connectionToken=Oe}}e.ResolvedAuthority=B;class G{static isManagedResolvedAuthority($){return $&&typeof $=="object"&&typeof $.makeConnection=="function"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be){this.makeConnection=$,this.connectionToken=be,typeof be<"u"&&U(be)}}e.ManagedResolvedAuthority=G;class le extends Error{static NotAvailable($,be){return new le($,S.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable($){return new le($,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor($,be=S.RemoteAuthorityResolverErrorCode.Unknown,Oe){super($),this._message=$,this._code=be,this._detail=Oe,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var Y;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var K;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let Q=r=class{static isTextEdit($){return $ instanceof r?!0:$?M.isRange($)&&typeof $.newText=="string":!1}static replace($,be){return new r($,be)}static insert($,be){return r.replace(new M($,$),be)}static delete($){return r.replace($,"")}static setEndOfLine($){const be=new r(new M(new N(0,0),new N(0,0)),"");return be.newEol=$,be}get range(){return this._range}set range($){if($&&!M.isRange($))throw(0,F.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,F.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,F.illegalArgument)("newEol");this._newEol=$}constructor($,be){this._range=$,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Q,e.TextEdit=Q=r=je([_],Q);let ue=n=class{static isNotebookCellEdit($){return $ instanceof n?!0:$?ni.isNotebookRange($)&&Array.isArray($.newCells):!1}static replaceCells($,be){return new n($,be)}static insertCells($,be){return new n(new ni($,$),be)}static deleteCells($){return new n($,[])}static updateCellMetadata($,be){const Oe=new n(new ni($,$),[]);return Oe.newCellMetadata=be,Oe}static updateNotebookMetadata($){const be=new n(new ni(0,0),[]);return be.newNotebookMetadata=$,be}constructor($,be){this.range=$,this.newCells=be}};e.NotebookEdit=ue,e.NotebookEdit=ue=n=je([_],ue);class ne{static isSnippetTextEdit($){return $ instanceof ne?!0:$?M.isRange($.range)&&q.isSnippetString($.snippet):!1}static replace($,be){return new ne($,be)}static insert($,be){return ne.replace(new M($,$),be)}constructor($,be){this.range=$,this.snippet=be}}e.SnippetTextEdit=ne;var pe;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let oe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,be,Oe,Ye){this._edits.push({_type:1,from:$,to:be,options:Oe,metadata:Ye})}createFile($,be,Oe){this._edits.push({_type:1,from:void 0,to:$,options:be,metadata:Oe})}deleteFile($,be,Oe){this._edits.push({_type:1,from:$,to:void 0,options:be,metadata:Oe})}replaceNotebookMetadata($,be,Oe){this._edits.push({_type:3,metadata:Oe,uri:$,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells($,be,Oe,Ye){const tt=be.start,ut=be.end;(tt!==ut||Oe.length>0)&&this._edits.push({_type:5,uri:$,index:tt,count:ut-tt,cells:Oe,metadata:Ye})}replaceNotebookCellMetadata($,be,Oe,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:3,index:be,metadata:Oe}})}replace($,be,Oe,Ye){this._edits.push({_type:2,uri:$,edit:new Q(be,Oe),metadata:Ye})}insert($,be,Oe,Ye){this.replace($,new M(be,be),Oe,Ye)}delete($,be,Oe){this.replace($,be,"",Oe)}has($){return this._edits.some(be=>be._type===2&&be.uri.toString()===$.toString())}set($,be){if(be)for(const Oe of be){if(!Oe)continue;let Ye,tt;Array.isArray(Oe)?(Ye=Oe[0],tt=Oe[1]):Ye=Oe,ue.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata($,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.replaceNotebookMetadata($,Ye.newNotebookMetadata,tt):this.replaceNotebookCells($,Ye.range,Ye.newCells,tt):ne.isSnippetTextEdit(Ye)?this._edits.push({_type:6,uri:$,range:Ye.range,edit:Ye.snippet,metadata:tt}):this._edits.push({_type:2,uri:$,edit:Ye,metadata:tt})}else{for(let Oe=0;Oe<this._edits.length;Oe++){const Ye=this._edits[Oe];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===$.toString()&&(this._edits[Oe]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get($){const be=[];for(const Oe of this._edits)Oe._type===2&&Oe.uri.toString()===$.toString()&&be.push(Oe.edit);return be}entries(){const $=new P.ResourceMap;for(const be of this._edits)if(be._type===2){let Oe=$.get(be.uri);Oe||(Oe=[be.uri,[]],$.set(be.uri,Oe)),Oe[1].push(be.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=oe,e.WorkspaceEdit=oe=je([_],oe);let q=a=class{static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}constructor($){this._tabstop=1,this.value=$||""}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,be=this._tabstop++){if(typeof $=="function"){const Oe=new a;Oe._tabstop=this._tabstop,$(Oe),this._tabstop=Oe._tabstop,$=Oe.value}else $=a._escape($);return this.value+="${",this.value+=be,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,be=this._tabstop++){const Oe=$.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable($,be){if(typeof be=="function"){const Oe=new a;Oe._tabstop=this._tabstop,be(Oe),this._tabstop=Oe._tabstop,be=Oe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=q,e.SnippetString=q=a=je([_],q);var W;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ie;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Se=t=class{static isLocation($){return $ instanceof t?!0:$?M.isRange($.range)&&y.URI.isUri($.uri):!1}constructor($,be){if(this.uri=$,be)if(M.isRange(be))this.range=M.of(be);else if(N.isPosition(be))this.range=new M(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Se,e.Location=Se=t=je([_],Se);let he=class{static is($){return $?typeof $.message=="string"&&$.location&&M.isRange($.location.range)&&y.URI.isUri($.location.uri):!1}constructor($,be){this.location=$,this.message=be}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.location.range.isEqual(be.location.range)&&$.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=he,e.DiagnosticRelatedInformation=he=je([_],he);let fe=class{constructor($,be,Oe=ie.Error){if(!M.isRange($))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=$,this.message=be,this.severity=Oe}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.severity===be.severity&&$.code===be.code&&$.severity===be.severity&&$.source===be.source&&$.range.isEqual(be.range)&&(0,I.equals)($.tags,be.tags)&&(0,I.equals)($.relatedInformation,be.relatedInformation,he.isEqual)}};e.Diagnostic=fe,e.Diagnostic=fe=je([_],fe);let Z=class{constructor($,be){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=be}};e.Hover=Z,e.Hover=Z=je([_],Z);var ee;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let j=class{constructor($,be=ee.Text){this.range=$,this.kind=be}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.DocumentHighlight=j,e.DocumentHighlight=j=je([_],j);let J=class{constructor($,be){this.uri=$,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map($=>$.toJSON())}}};e.MultiDocumentHighlight=J,e.MultiDocumentHighlight=J=je([_],J);var ge;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var we;(function(V){V[V.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ae=d=class{static validate($){if(!$.name)throw new Error("name must not be falsy")}constructor($,be,Oe,Ye,tt){this.name=$,this.kind=be,this.containerName=tt,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof Se?this.location=Ye:Oe instanceof M&&(this.location=new Se(Ye,Oe)),d.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ae,e.SymbolInformation=Ae=d=je([_],Ae);let Ee=s=class{static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children?.forEach(s.validate)}constructor($,be,Oe,Ye,tt){this.name=$,this.detail=be,this.kind=Oe,this.range=Ye,this.selectionRange=tt,this.children=[],s.validate(this)}};e.DocumentSymbol=Ee,e.DocumentSymbol=Ee=s=je([_],Ee);var ke;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(ke||(e.CodeActionTriggerKind=ke={}));let z=class{constructor($,be){this.title=$,this.kind=be}};e.CodeAction=z,e.CodeAction=z=je([_],z);let X=class{static{h=this}static{this.sep="."}constructor($){this.value=$}append($){return new h(this.value?this.value+h.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+h.sep)}};e.CodeActionKind=X,e.CodeActionKind=X=h=je([_],X),X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorMove=X.Refactor.append("move"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll"),X.Notebook=X.Empty.append("notebook");let te=class{constructor($,be){if(this.range=$,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=te,e.SelectionRange=te=je([_],te);class H{constructor($,be,Oe,Ye,tt,ut){this.kind=$,this.name=be,this.detail=Oe,this.uri=Ye,this.range=tt,this.selectionRange=ut}}e.CallHierarchyItem=H;class ae{constructor($,be){this.fromRanges=be,this.from=$}}e.CallHierarchyIncomingCall=ae;class de{constructor($,be){this.fromRanges=be,this.to=$}}e.CallHierarchyOutgoingCall=de;var Re;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Ue=class{constructor($,be){this.range=$,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=Ue,e.CodeLens=Ue=je([_],Ue);let Ve=l=class{#e;static isMarkdownString($){return $ instanceof l?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}constructor($,be=!1){this.#e=new f.MarkdownString($,{supportThemeIcons:be})}get value(){return this.#e.value}set value($){this.#e.value=$}get isTrusted(){return this.#e.isTrusted}set isTrusted($){this.#e.isTrusted=$}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons($){this.#e.supportThemeIcons=$}get supportHtml(){return this.#e.supportHtml}set supportHtml($){this.#e.supportHtml=$}get baseUri(){return this.#e.baseUri}set baseUri($){this.#e.baseUri=$}appendText($){return this.#e.appendText($),this}appendMarkdown($){return this.#e.appendMarkdown($),this}appendCodeblock($,be){return this.#e.appendCodeblock(be??"",$),this}};e.MarkdownString=Ve,e.MarkdownString=Ve=l=je([_],Ve);let Ke=class{constructor($,be){this.label=$,this.documentation=be}};e.ParameterInformation=Ke,e.ParameterInformation=Ke=je([_],Ke);let Ze=class{constructor($,be){this.label=$,this.documentation=be,this.parameters=[]}};e.SignatureInformation=Ze,e.SignatureInformation=Ze=je([_],Ze);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=at,e.SignatureHelp=at=je([_],at);var st;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Pe=class{constructor($){this.value=$}};e.InlayHintLabelPart=Pe,e.InlayHintLabelPart=Pe=je([_],Pe);let xe=class{constructor($,be,Oe){this.position=$,this.label=be,this.kind=Oe}};e.InlayHint=xe,e.InlayHint=xe=je([_],xe);var Te;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Te||(e.CompletionTriggerKind=Te={}));var Xe;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var re;(function(V){V[V.Deprecated=1]="Deprecated"})(re||(e.CompletionItemTag=re={}));let se=class{constructor($,be){this.label=$,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=se,e.CompletionItem=se=je([_],se);let Ie=class{constructor($=[],be=!1){this.items=$,this.isIncomplete=be}};e.CompletionList=Ie,e.CompletionList=Ie=je([_],Ie);let He=class{constructor($,be,Oe){this.insertText=$,this.range=be,this.command=Oe}};e.InlineSuggestion=He,e.InlineSuggestion=He=je([_],He);let Qe=class{constructor($){this.commands=void 0,this.suppressSuggestions=void 0,this.items=$}};e.InlineSuggestionList=Qe,e.InlineSuggestionList=Qe=je([_],Qe);var it;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Me(V,$){return`${D.ExtensionIdentifier.toKey(V)}.${$}`}e.asStatusBarItemIdentifier=Me;var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Dt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Ft;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Nt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var _t;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Vt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Vt||(e.DecorationRangeBehavior=Vt={})),function(V){function $(be){switch(be){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=$}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var Mt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Mt||(e.SyntaxTokenType=Mt={})),function(V){function $(be){switch(be){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=$}(Mt||(e.SyntaxTokenType=Mt={}));let Qt=class{constructor($,be){if(be&&!y.URI.isUri(be))throw(0,F.illegalArgument)("target");if(!M.isRange($)||$.isEmpty)throw(0,F.illegalArgument)("range");this.range=$,this.target=be}};e.DocumentLink=Qt,e.DocumentLink=Qt=je([_],Qt);let $t=class{constructor($,be,Oe,Ye){this.red=$,this.green=be,this.blue=Oe,this.alpha=Ye}};e.Color=$t,e.Color=$t=je([_],$t);let Bt=class{constructor($,be){if(be&&!(be instanceof $t))throw(0,F.illegalArgument)("color");if(!M.isRange($)||$.isEmpty)throw(0,F.illegalArgument)("range");this.range=$,this.color=be}};e.ColorInformation=Bt,e.ColorInformation=Bt=je([_],Bt);let et=class{constructor($){if(!$||typeof $!="string")throw(0,F.illegalArgument)("label");this.label=$}};e.ColorPresentation=et,e.ColorPresentation=et=je([_],et);var jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var Gt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var dt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class pt{constructor($,be,Oe){if(this.startIndex=$,this.length=be,this.tooltip=Oe,typeof $!="number"||$<0)throw(0,F.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,F.illegalArgument)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=pt;class zt{constructor($){this.uri=$}}e.TerminalQuickFixOpener=zt;class Kt{constructor($){this.terminalCommand=$}}e.TerminalQuickFixCommand=Kt;var yt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(yt||(e.TerminalLocation=yt={}));class ft{constructor($){if(this.options=$,typeof $!="object")throw(0,F.illegalArgument)("options")}}e.TerminalProfile=ft;var kt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Zt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let Tt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from($){switch($){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor($,be){if(this.label=be,typeof $!="string"||typeof be!="string")throw(0,F.illegalArgument)("name");this._id=$}get id(){return this._id}};e.TaskGroup=Tt,e.TaskGroup=Tt=u=je([_],Tt);function Ge(V){let $="";for(let be=0;be<V.length;be++)$+=V[be].replace(/,/g,",,")+",";return $}let Lt=class{constructor($,be,Oe){if(typeof $!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=$,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Oe):this._options=be)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,F.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(const be of this._args)$.push(be);return Ge($)}};e.ProcessExecution=Lt,e.ProcessExecution=Lt=je([_],Lt);let Ut=class{constructor($,be,Oe){if(this._args=[],Array.isArray(be)){if(!$)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,F.illegalArgument)("command");this._command=$,this._args=be,this._options=Oe}else{if(typeof $!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=$,this._options=be}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,F.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)$.push(typeof be=="string"?be:be.value);return Ge($)}};e.ShellExecution=Ut,e.ShellExecution=Ut=je([_],Ut);var Xt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Xt||(e.ShellQuoting=Xt={}));var mt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class Ot{constructor($){this._callback=$}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Ot;let At=class{static{w=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor($,be,Oe,Ye,tt,ut){this.__deprecated=!1,this._definition=this.definition=$;let gt;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Oe,this.execution=Ye,gt=tt,this.__deprecated=!0):be===mt.Global||be===mt.Workspace?(this.target=be,this._name=this.name=Oe,this._source=this.source=Ye,this.execution=tt,gt=ut):(this.target=be,this._name=this.name=Oe,this._source=this.source=Ye,this.execution=tt,gt=ut),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Lt?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ut?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const be=this._definition.type;(w.EmptyType===be||w.ProcessType===be||w.ShellType===be||w.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};e.Task=At,e.Task=At=w=je([_],At);var Wt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Le;(function(V){function $(be){const Oe=be;return(0,p.isNumber)(Oe.value)?Oe.tooltip&&!(0,p.isString)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}V.isViewBadge=$})(Le||(e.ViewBadge=Le={}));let Ne=k=class{static isTreeItem($,be){const Oe=$;if(Oe.checkboxState!==void 0){const Ye=(0,p.isNumber)(Oe.checkboxState)?Oe.checkboxState:(0,p.isObject)(Oe.checkboxState)&&(0,p.isNumber)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,tt=!(0,p.isNumber)(Oe.checkboxState)&&(0,p.isObject)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==ce.Checked&&Ye!==ce.Unchecked||tt!==void 0&&!(0,p.isString)(tt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if($ instanceof k)return!0;if(Oe.label!==void 0&&!(0,p.isString)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.isString)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.isString)(Oe.iconPath)&&!y.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.isString)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,p.isString)(Ye.light)&&!y.URI.isUri(Ye.light)&&!(0,p.isString)(Ye.dark)&&!y.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.isString)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!y.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.isString)(Oe.tooltip)&&!(Oe.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<De.None&&Oe.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.isString)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor($,be=De.None){this.collapsibleState=be,y.URI.isUri($)?this.resourceUri=$:this.label=$}};e.TreeItem=Ne,e.TreeItem=Ne=k=je([_],Ne);var De;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ce;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(ce||(e.TreeItemCheckboxState=ce={}));let Fe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor($){this.value=$}};e.DataTransferItem=Fe,e.DataTransferItem=Fe=je([_],Fe);class ze extends Fe{}e.InternalDataTransferItem=ze;class Je extends ze{#e;constructor($){super(""),this.#e=$}asFile(){return this.#e}}e.InternalFileDataTransferItem=Je;class qe{constructor($,be,Oe,Ye){this.name=$,this.uri=be,this._itemId=Oe,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=qe;let ct=class{#e=new Map;constructor($){for(const[be,Oe]of $??[]){const Ye=this.#e.get(this.#t(be));Ye?Ye.push(Oe):this.#e.set(this.#t(be),[Oe])}}get($){return this.#e.get(this.#t($))?.[0]}set($,be){this.#e.set(this.#t($),[be])}forEach($,be){for(const[Oe,Ye]of this.#e)for(const tt of Ye)$.call(be,tt,Oe,this)}*[Symbol.iterator](){for(const[$,be]of this.#e)for(const Oe of be)yield[$,Oe]}#t($){return $.toLowerCase()}};e.DataTransfer=ct,e.DataTransfer=ct=je([_],ct);let wt=class{constructor($){this.insertText=$}};e.DocumentDropEdit=wt,e.DocumentDropEdit=wt=je([_],wt);let qt=class{constructor($,be){this.label=be,this.insertText=$}};e.DocumentPasteEdit=qt,e.DocumentPasteEdit=qt=je([_],qt);let Ct=class{constructor($,be){this.id=$,this.color=be}static isThemeIcon($){return typeof $.id!="string"?(console.log("INVALID ThemeIcon, invalid id",$.id),!1):!0}};e.ThemeIcon=Ct,e.ThemeIcon=Ct=je([_],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let It=class{constructor($){this.id=$}};e.ThemeColor=It,e.ThemeColor=It=je([_],It);var Et;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Et||(e.ConfigurationTarget=Et={}));let Ci=class{get base(){return this._base}set base($){this._base=$,this._baseUri=y.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}constructor($,be){if(typeof $!="string"&&(!$||!y.URI.isUri($)&&!y.URI.isUri($.uri)))throw(0,F.illegalArgument)("base");if(typeof be!="string")throw(0,F.illegalArgument)("pattern");typeof $=="string"?this.baseUri=y.URI.file($):y.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ci,e.RelativePattern=Ci=je([_],Ci);const qi=new WeakMap;function Pt(V,$){qi.set(V,$)}e.setBreakpointId=Pt;let si=class{constructor($,be,Oe,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof be=="string"&&(this.condition=be),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=qi.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=si,e.Breakpoint=si=je([_],si);let gi=class extends si{constructor($,be,Oe,Ye,tt){if(super(be,Oe,Ye,tt),$===null)throw(0,F.illegalArgument)("location");this.location=$}};e.SourceBreakpoint=gi,e.SourceBreakpoint=gi=je([_],gi);let li=class extends si{constructor($,be,Oe,Ye,tt){super(be,Oe,Ye,tt),this.functionName=$}};e.FunctionBreakpoint=li,e.FunctionBreakpoint=li=je([_],li);let Di=class extends si{constructor($,be,Oe,Ye,tt,ut,gt){if(super(Ye,tt,ut,gt),!be)throw(0,F.illegalArgument)("dataId");this.label=$,this.dataId=be,this.canPersist=Oe}};e.DataBreakpoint=Di,e.DataBreakpoint=Di=je([_],Di);let Ii=class{constructor($,be,Oe){this.command=$,this.args=be||[],this.options=Oe}};e.DebugAdapterExecutable=Ii,e.DebugAdapterExecutable=Ii=je([_],Ii);let xt=class{constructor($,be){this.port=$,this.host=be}};e.DebugAdapterServer=xt,e.DebugAdapterServer=xt=je([_],xt);let pi=class{constructor($){this.path=$}};e.DebugAdapterNamedPipeServer=pi,e.DebugAdapterNamedPipeServer=pi=je([_],pi);let ki=class{constructor($){this.implementation=$}};e.DebugAdapterInlineImplementation=ki,e.DebugAdapterInlineImplementation=ki=je([_],ki);let ui=class{constructor($,be,Oe){this.session=$,this.threadId=be,this.frameId=Oe}};e.StackFrameFocus=ui,e.StackFrameFocus=ui=je([_],ui);let di=class{constructor($,be){this.session=$,this.threadId=be}};e.ThreadFocus=di,e.ThreadFocus=di=je([_],di);let ht=class{constructor($,be){this.range=$,this.expression=be}};e.EvaluatableExpression=ht,e.EvaluatableExpression=ht=je([_],ht);var Gi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let ei=class{constructor($,be){this.range=$,this.text=be}};e.InlineValueText=ei,e.InlineValueText=ei=je([_],ei);let oi=class{constructor($,be,Oe=!0){this.range=$,this.variableName=be,this.caseSensitiveLookup=Oe}};e.InlineValueVariableLookup=oi,e.InlineValueVariableLookup=oi=je([_],oi);let vi=class{constructor($,be){this.range=$,this.expression=be}};e.InlineValueEvaluatableExpression=vi,e.InlineValueEvaluatableExpression=vi=je([_],vi);let Pi=class{constructor($,be){this.frameId=$,this.stoppedLocation=be}};e.InlineValueContext=Pi,e.InlineValueContext=Pi=je([_],Pi);var Ki;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ti=b=class extends Error{static FileExists($){return new b($,v.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,v.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,v.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,v.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,v.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,v.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor($,be=v.FileSystemProviderErrorCode.Unknown,Oe){super(y.URI.isUri($)?$.toString(!0):$),this.code=Oe?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.FileSystemError=Ti,e.FileSystemError=Ti=b=je([_],Ti);let bi=class{constructor($,be,Oe){this.start=$,this.end=be,this.kind=Oe}};e.FoldingRange=bi,e.FoldingRange=bi=je([_],bi);var Xi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ai;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var hi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Qi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var Ei;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class Ri{constructor($,be=[]){this.tokenTypes=$,this.tokenModifiers=be}}e.SemanticTokensLegend=Ri;function un(V){return typeof V>"u"||(0,p.isStringArray)(V)}class Li{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let be=0,Oe=$.tokenTypes.length;be<Oe;be++)this._tokenTypeStrToInt.set($.tokenTypes[be],be);for(let be=0,Oe=$.tokenModifiers.length;be<Oe;be++)this._tokenModifierStrToInt.set($.tokenModifiers[be],be)}}push($,be,Oe,Ye,tt){if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded($,be,Oe,Ye,tt);if(M.isRange($)&&typeof be=="string"&&un(Oe))return this._push($,be,Oe);throw(0,F.illegalArgument)()}_push($,be,Oe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,tt=$.start.character,ut=$.end.character-$.start.character,gt=this._tokenTypeStrToInt.get(be);let Ht=0;if(Oe)for(const Jt of Oe){if(!this._tokenModifierStrToInt.has(Jt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this._tokenModifierStrToInt.get(Jt);Ht|=1<<ii>>>0}this._pushEncoded(Ye,tt,ut,gt,Ht)}_pushEncoded($,be,Oe,Ye,tt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ht=this._data.length/5|0;let Jt=0,ii=0;for(let ri=0;ri<Ht;ri++){let ci=this._data[5*ri],Vi=this._data[5*ri+1];ci===0?(ci=Jt,Vi+=ii):ci+=Jt,this._data[5*ri]=ci,this._data[5*ri+1]=Vi,Jt=ci,ii=Vi}}let ut=$,gt=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Oe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=tt,this._prevLine=$,this._prevChar=be}static _sortAndDeltaEncode($){const be=[],Oe=$.length/5|0;for(let gt=0;gt<Oe;gt++)be[gt]=gt;be.sort((gt,Ht)=>{const Jt=$[5*gt],ii=$[5*Ht];if(Jt===ii){const ri=$[5*gt+1],ci=$[5*Ht+1];return ri-ci}return Jt-ii});const Ye=new Uint32Array($.length);let tt=0,ut=0;for(let gt=0;gt<Oe;gt++){const Ht=5*be[gt],Jt=$[Ht+0],ii=$[Ht+1],ri=$[Ht+2],ci=$[Ht+3],Vi=$[Ht+4],kn=Jt-tt,Bn=kn===0?ii-ut:ii,ji=5*gt;Ye[ji+0]=kn,Ye[ji+1]=Bn,Ye[ji+2]=ri,Ye[ji+3]=ci,Ye[ji+4]=Vi,tt=Jt,ut=ii}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new ai(new Uint32Array(this._data),$):new ai(Li._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Li;class ai{constructor($,be){this.resultId=be,this.data=$}}e.SemanticTokens=ai;class dn{constructor($,be,Oe){this.start=$,this.deleteCount=be,this.data=Oe}}e.SemanticTokensEdit=dn;class hn{constructor($,be){this.resultId=be,this.edits=$}}e.SemanticTokensEdits=hn;var Yi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class Oi{constructor($){this.name=$}}e.DebugVisualization=Oi;let Fi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.QuickInputButtons=Fi,e.QuickInputButtons=Fi=je([_],Fi);var Ji;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var wi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(wi||(e.InputBoxValidationSeverity=wi={}));var Ni;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class fn{static validate($){if(typeof $.badge=="string"){let be=(0,E.nextCharLength)($.badge,0);if(be<$.badge.length&&(be+=(0,E.nextCharLength)($.badge,be)),$.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if($.badge&&!Ct.isThemeIcon($.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}constructor($,be,Oe){this.badge=$,this.tooltip=be,this.color=Oe}}e.FileDecoration=fn;let Si=class{constructor($){this.kind=$}};e.ColorTheme=Si,e.ColorTheme=Si=je([_],Si);var Mi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Mi||(e.ColorThemeKind=Mi={}));class ni{static isNotebookRange($){return $ instanceof ni?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor($,be){if($<0)throw(0,F.illegalArgument)("start must be positive");if(be<0)throw(0,F.illegalArgument)("end must be positive");$<=be?(this._start=$,this._end=be):(this._start=be,this._end=$)}with($){let be=this._start,Oe=this._end;return $.start!==void 0&&(be=$.start),$.end!==void 0&&(Oe=$.end),be===this._start&&Oe===this._end?this:new ni(be,Oe)}}e.NotebookRange=ni;class _i{static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(be=>_i.isNotebookCellData(be))}static isNotebookCellData($){return!0}constructor($,be,Oe,Ye,tt,ut,gt){this.kind=$,this.value=be,this.languageId=Oe,this.mime=Ye,this.outputs=tt??[],this.metadata=ut,this.executionSummary=gt,_i.validate(this)}}e.NotebookCellData=_i;class mn{constructor($){this.cells=$}}e.NotebookData=mn;class Yt{static isNotebookCellOutputItem($){return $ instanceof Yt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const be={name:$.name,message:$.message,stack:$.stack};return Yt.json(be,"application/vnd.code.notebook.error")}static stdout($){return Yt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Yt.text($,"application/vnd.code.notebook.stderr")}static bytes($,be="application/octet-stream"){return new Yt($,be)}static#e=new TextEncoder;static text($,be=A.Mimes.text){const Oe=Yt.#e.encode(String($));return new Yt(Oe,be)}static json($,be="text/x-json"){const Oe=JSON.stringify($,void 0,"	");return Yt.text(Oe,be)}constructor($,be){this.data=$,this.mime=be;const Oe=(0,A.normalizeMimeType)(be,!0);if(!Oe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.NotebookCellOutputItem=Yt;class fi{static isNotebookCellOutput($){return $ instanceof fi?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&Array.isArray($.items)}static ensureUniqueMimeTypes($,be=!1){const Oe=new Set,Ye=new Set;for(let tt=0;tt<$.length;tt++){const ut=$[tt],gt=(0,A.normalizeMimeType)(ut.mime);if(!Oe.has(gt)||(0,C.isTextStreamMime)(gt)){Oe.add(gt);continue}Ye.add(tt),be&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ye.size===0?$:$.filter((tt,ut)=>!Ye.has(ut))}constructor($,be,Oe){this.items=fi.ensureUniqueMimeTypes($,!0),typeof be=="string"?(this.id=be,this.metadata=Oe):(this.id=(0,R.generateUuid)(),this.metadata=be??Oe)}}e.NotebookCellOutput=fi;var Ui;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var We;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(We||(e.NotebookCellExecutionState=We={}));var ti;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var xi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(xi||(e.NotebookEditorRevealType=xi={}));class ot{constructor($,be){this.text=$,this.alignment=be}}e.NotebookCellStatusBarItem=ot;var vt;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(vt||(e.NotebookControllerAffinity=vt={}));var Zi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(Zi||(e.NotebookControllerAffinity2=Zi={}));class gn{constructor($,be=[]){this.uri=$,this.provides=(0,I.asArray)(be)}}e.NotebookRendererScript=gn;class en{constructor($){this.label=$}}e.NotebookKernelSourceAction=en;var tn;(function(V){V[V.Named=1]="Named",V[V.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let mi=class{constructor($,be){this.label=$,this.timestamp=be}};e.TimelineItem=mi,e.TimelineItem=mi=je([_],mi);var nn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class on{constructor($,be){this.ranges=$,this.wordPattern=be}}e.LinkedEditingRanges=on;class pn{constructor($){this._autoForwardAction=$}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=pn;var an;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Bi=class{constructor($=void 0,be=void 0,Oe=void 0,Ye=!1){this.include=$,this.exclude=be,this.profile=Oe,this.continuous=Ye}};e.TestRunRequest=Bi,e.TestRunRequest=Bi=je([_],Bi);let zi=g=class{static diff($,be,Oe){const Ye=new g($);return Ye.expectedOutput=be,Ye.actualOutput=Oe,Ye}constructor($){this.message=$}};e.TestMessage=zi,e.TestMessage=zi=g=je([_],zi);let Wi=class{constructor($){this.id=$}};e.TestTag=Wi,e.TestTag=Wi=je([_],Wi);class yi{constructor($,be){this.covered=$,this.total=be}}e.CoveredCount=yi;const $i=V=>{if(V&&V.covered>V.total)throw new Error(`The total number of covered items (${V.covered}) cannot be greater than the total (${V.total})`)};class Hi{static fromDetails($,be){const Oe=new yi(0,0),Ye=new yi(0,0),tt=new yi(0,0);for(const gt of be)if("branches"in gt){Oe.total+=1,Oe.covered+=gt.executionCount>0?1:0;for(const Ht of gt.branches)Ye.total+=1,Ye.covered+=Ht.executionCount>0?1:0}else tt.total+=1,tt.covered+=gt.executionCount>0?1:0;const ut=new Hi($,Oe,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return ut.detailedCoverage=be,ut}constructor($,be,Oe,Ye){this.uri=$,this.statementCoverage=be,this.branchCoverage=Oe,this.functionCoverage=Ye,$i(be),$i(Oe),$i(Ye)}}e.FileCoverage=Hi;class vn{constructor($,be,Oe=[]){this.executionCount=$,this.location=be,this.branches=Oe}}e.StatementCoverage=vn;class ve{constructor($,be,Oe){this.executionCount=$,this.location=be,this.label=Oe}}e.BranchCoverage=ve;class _e{constructor($,be,Oe){this.name=$,this.executionCount=be,this.location=Oe}}e.FunctionCoverage=_e;var Be;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Be||(e.ExternalUriOpenerPriority=Be={}));var lt;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(lt||(e.WorkspaceTrustState=lt={}));var bt;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class Rt{constructor($,be,Oe,Ye,tt,ut){this.kind=$,this.name=be,this.detail=Oe,this.uri=Ye,this.range=tt,this.selectionRange=ut}}e.TypeHierarchyItem=Rt;class ln{constructor($){this.uri=$}}e.TextTabInput=ln;class Pn{constructor($,be){this.original=$,this.modified=be}}e.TextDiffTabInput=Pn;class Tn{constructor($,be,Oe,Ye){this.base=$,this.input1=be,this.input2=Oe,this.result=Ye}}e.TextMergeTabInput=Tn;class An{constructor($,be){this.uri=$,this.viewType=be}}e.CustomEditorTabInput=An;class Rn{constructor($){this.viewType=$}}e.WebviewEditorTabInput=Rn;class Ln{constructor($,be){this.uri=$,this.notebookType=be}}e.NotebookEditorTabInput=Ln;class On{constructor($,be,Oe){this.original=$,this.modified=be,this.notebookType=Oe}}e.NotebookDiffEditorTabInput=On;class Fn{constructor(){}}e.TerminalEditorTabInput=Fn;class Nn{constructor($,be){this.uri=$,this.inputBoxUri=be}}e.InteractiveWindowInput=Nn;class Mn{constructor($){this.providerId=$}}e.ChatEditorTabInput=Mn;var bn;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var En;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(En||(e.ChatAgentCopyKind=En={}));var wn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Un{constructor($,be){this.label=$,this.values=be}}e.ChatAgentCompletionItem=Un;var Sn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted",V[V.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var _n;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(_n||(e.ChatMessageRole=_n={}));class xn{constructor($,be){this.role=$,this.content=be}}e.ChatMessage=xn;var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var Cn;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Dn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var In;(function(V){V[V.Recognized=1]="Recognized",V[V.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(ye[311],Ce([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class f{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,E,p){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const y=this._relatedInformationProviders.get(A);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(E,p)??[]}getRelatedInformation(A,E,p){return this._proxy.$getAiRelatedInformation(E,p)}registerRelatedInformationProvider(A,E,p){const y=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(y,p),this._proxy.$registerAiRelatedInformationProvider(y,E),new F.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(y),this._relatedInformationProviders.delete(y)})}}e.ExtHostRelatedInformation=f}),define(ye[312],Ce([1,0,4,6,7,25]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(y){this._authenticationProviders=new Map,this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new E,this._getSessionsTaskSingler=new E,this._proxy=y.getProxy(F.MainContext.MainThreadAuthentication)}async getSession(y,R,D,v={}){const S=P.ExtensionIdentifier.toKey(y.identifier),C=[...D].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${S} ${R} ${C}`,async()=>{await this._proxy.$ensureProvider(R);const c=y.displayName||y.name;return this._proxy.$getSession(R,D,S,c,v)})}async getSessions(y,R,D){const v=P.ExtensionIdentifier.toKey(y.identifier),S=[...D].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${v} ${S}`,async()=>{await this._proxy.$ensureProvider(R);const C=y.displayName||y.name;return this._proxy.$getSessions(R,D,v,C)})}async removeSession(y,R){const D=this._authenticationProviders.get(y);return D?D.provider.removeSession(R):this._proxy.$removeSession(y,R)}registerAuthenticationProvider(y,R,D,v){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:R,provider:D,options:v??{supportsMultipleAccounts:!1}});const S=D.onDidChangeSessions(C=>this._proxy.$sendDidChangeSessions(y,C));return this._proxy.$registerAuthenticationProvider(y,R,v?.supportsMultipleAccounts??!1),new f.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(y),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,R,D){const v=this._authenticationProviders.get(y);if(v)return Promise.resolve(v.provider.createSession(R,D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const D=this._authenticationProviders.get(y);if(D)return Promise.resolve(D.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const D=this._authenticationProviders.get(y);if(D)return Promise.resolve(D.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this._onDidChangeSessions.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=A;class E{constructor(){this._inFlightPromises=new Map}getOrCreate(y,R){const D=this._inFlightPromises.get(y);if(D)return D;const v=R().finally(()=>this._inFlightPromises.delete(y));return this._inFlightPromises.set(y,v),v}}}),define(ye[147],Ce([1,0,2,6,7,5,20,13,19,12,17,26]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class{static{v=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(c,m){this._logService=m,this._provider=new Map,this._proxy=c.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(c,m){const o=v._handlePool++;this._provider.set(o,{provider:c,extensionDescription:m}),this._proxy.$registerDecorationProvider(o,m.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(r=>{if(!r){this._proxy.$onDidChange(o,null);return}const n=(0,p.asArray)(r);if(n.length<=v._maxEventSize){this._proxy.$onDidChange(o,n);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,n.length);const a=n.map(s=>({uri:s,rank:(0,y.count)(s.path,"/")})),t=(0,p.groupBy)(a,(s,h)=>s.rank-h.rank||(0,y.compare)(s.uri.path,h.uri.path)),d=[];e:for(const s of t){let h;for(const l of s){const u=(0,R.dirname)(l.uri.path);if(h!==u&&(h=u,d.push(l.uri)>=v._maxEventSize))break e}}this._proxy.$onDidChange(o,d)});return new f.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(c,m,o){if(!this._provider.has(c))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this._provider.get(c);return await Promise.all(m.map(async a=>{try{const{uri:t,id:d}=a,s=await Promise.resolve(r.provideFileDecoration(I.URI.revive(t),o));if(!s)return;try{f.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.checkProposedApiEnabled)(n,"codiconDecoration"),i[d]=[s.propagate,s.tooltip,s.badge,s.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${n.identifier.value}': ${h}`)}}catch(t){this._logService.error(t)}})),i}};e.ExtHostDecorations=S,e.ExtHostDecorations=S=v=je([$e(0,A.IExtHostRpcService),$e(1,E.ILogService)],S),e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(ye[313],Ce([1,0,14,2,7,6,16,21,12]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{static{this._handlePool=0}constructor(D,v,S){this._documentsAndEditors=v,this._logService=S,this._documentContentProviders=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,v){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const S=y._handlePool++;this._documentContentProviders.set(S,v),this._proxy.$registerTextContentProvider(S,D);let C;if(typeof v.onDidChange=="function"){let c;C=v.onDidChange(async m=>{if(m.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(m))return;c&&await c;const o=this.$provideTextDocumentContent(S,m).then(async i=>{if(!i&&typeof i!="string")return;const r=this._documentsAndEditors.getDocument(m);if(!r)return;const n=(0,p.splitLines)(i);if(!r.equalLines(n))return this._proxy.$onVirtualDocumentChange(m,i)}).catch(I.onUnexpectedError).finally(()=>{c===o&&(c=void 0)});c=o})}return new f.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(D,v){const S=this._documentContentProviders.get(D);return S?Promise.resolve(S.provideTextDocumentContent(F.URI.revive(v),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=y}),define(ye[148],Ce([1,0,61,16,12,176,126,7,19]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function R(C,c){c?y.set(C,c):y.delete(C)}e.setWordDefinitionFor=R;function D(C){return y.get(C)}class v extends P.MirrorTextModel{constructor(c,m,o,i,r,n,a,t){super(m,o,i,r),this._proxy=c,this._languageId=n,this._isDirty=a,this.notebook=t,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,p.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===F.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},save(){return c._save()},getText(m){return m?c._getTextInRange(m):c.getText()},get eol(){return c._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(m){return c._lineAt(m)},offsetAt(m){return c._offsetAt(m)},positionAt(m){return c._positionAt(m)},validateRange(m){return c._validateRange(m)},validatePosition(m){return c._validatePosition(m)},getWordRangeAtPosition(m,o){return c._getWordRangeAtPosition(m,o)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,I.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,I.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const m=this._validateRange(c);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const o=this._eol,i=m.start.line,r=m.end.line,n=[];n.push(this._lines[i].substring(m.start.character));for(let a=i+1;a<r;a++)n.push(this._lines[a]);return n.push(this._lines[r].substring(0,m.end.character)),n.join(o)}_lineAt(c){let m;if(c instanceof E.Position?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new S(m,this._lines[m],m===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(c),o=this._lines[m.index].length;return new E.Position(m.index,Math.min(m.remainder,o))}_validateRange(c){if(!(c instanceof E.Range))throw new Error("Invalid argument");const m=this._validatePosition(c.start),o=this._validatePosition(c.end);return m===c.start&&o===c.end?c:new E.Range(m.line,m.character,o.line,o.character)}_validatePosition(c){if(!(c instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:m,character:o}=c,i=!1;if(m<0)m=0,o=0,i=!0;else if(m>=this._lines.length)m=this._lines.length-1,o=this._lines[m].length,i=!0;else{const r=this._lines[m].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new E.Position(m,o):c}_getWordRangeAtPosition(c,m){const o=this._validatePosition(c);if(!m)m=D(this._languageId);else if((0,f.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,A.getWordAtText)(o.character+1,(0,A.ensureValidWordDefinition)(m),this._lines[o.line],0);if(i)return new E.Range(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.ExtHostDocumentData=v;class S{constructor(c,m,o){this._line=c,this._text=m,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(ye[314],Ce([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class f{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,E,p){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const y=this._AiEmbeddingVectorProviders.get(A);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(E,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,E,p){const y=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(y,p),this._proxy.$registerAiEmbeddingVectorProvider(E,y),new F.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(y),this._AiEmbeddingVectorProviders.delete(y)})}}e.ExtHostAiEmbeddingVector=f}),define(ye[69],Ce([1,0,6,32,7,22,5,20,59,3,11,23,16]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=S=class{constructor(m,o){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const a=i._fileSystemProvider.get(r.scheme);return a?(await i._proxy.$ensureActivation(r.scheme),n=await a.impl.stat(r)):n=await i._proxy.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===F.FilePermission.Readonly?1:void 0}}catch(n){S._handleError(n)}},async readDirectory(r){try{const n=i._fileSystemProvider.get(r.scheme);return n?(await i._proxy.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i._proxy.$readdir(r)}catch(n){return S._handleError(n)}},async createDirectory(r){try{const n=i._fileSystemProvider.get(r.scheme);return n&&!n.isReadonly?(await i._proxy.$ensureActivation(r.scheme),await i.mkdirp(n.impl,n.extUri,r)):await i._proxy.$mkdir(r)}catch(n){return S._handleError(n)}},async readFile(r){try{const n=i._fileSystemProvider.get(r.scheme);return n?(await i._proxy.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i._proxy.$readFile(r)).buffer}catch(n){return S._handleError(n)}},async writeFile(r,n){try{const a=i._fileSystemProvider.get(r.scheme);return a&&!a.isReadonly?(await i._proxy.$ensureActivation(r.scheme),await i.mkdirp(a.impl,a.extUri,a.extUri.dirname(r)),await i._writeQueue.queueFor(r,()=>Promise.resolve(a.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(r,P.VSBuffer.wrap(n))}catch(a){return S._handleError(a)}},async delete(r,n){try{const a=i._fileSystemProvider.get(r.scheme);return a&&!a.isReadonly&&!n?.useTrash?(await i._proxy.$ensureActivation(r.scheme),await a.impl.delete(r,{recursive:!1,...n})):await i._proxy.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(a){return S._handleError(a)}},async rename(r,n,a){try{return await i._proxy.$rename(r,n,{overwrite:!1,...a})}catch(t){return S._handleError(t)}},async copy(r,n,a){try{return await i._proxy.$copy(r,n,{overwrite:!1,...a})}catch(t){return S._handleError(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async mkdirp(m,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await m.stat(i)).type&F.FileType.Directory))throw f.FileSystemError.FileExists(`Unable to create folder '${i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(F.toFileSystemProviderErrorCode(n)!==F.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await m.createDirectory(i)}catch(a){if(F.toFileSystemProviderErrorCode(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static _handleError(m){if(m instanceof f.FileSystemError)throw m;if(m instanceof F.FileSystemProviderError)switch(m.code){case F.FileSystemProviderErrorCode.FileExists:throw f.FileSystemError.FileExists(m.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.FileSystemError.FileNotFound(m.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.FileSystemError.FileNotADirectory(m.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.FileSystemError.FileIsADirectory(m.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.FileSystemError.NoPermissions(m.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.FileSystemError.Unavailable(m.message);default:throw new f.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new f.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw f.FileSystemError.Unavailable(m.message);switch(m.name){case F.FileSystemProviderErrorCode.FileExists:throw f.FileSystemError.FileExists(m.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.FileSystemError.FileNotFound(m.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.FileSystemError.FileNotADirectory(m.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.FileSystemError.FileIsADirectory(m.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.FileSystemError.NoPermissions(m.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.FileSystemError.Unavailable(m.message);default:throw new f.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,o,i){return this._fileSystemProvider.set(m,{impl:o,extUri:i?.isCaseSensitive?D.extUri:D.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(m))}getFileSystemProviderExtUri(m){return this._fileSystemProvider.get(m)?.extUri??D.extUri}};e.ExtHostConsumerFileSystem=C,e.ExtHostConsumerFileSystem=C=S=je([$e(0,E.IExtHostRpcService),$e(1,p.IExtHostFileSystemInfo)],C),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[315],Ce([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class f{constructor(A){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=A.getProxy(I.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,E){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const p=this._IssueUriRequestHandlers.get(A);if(!p)throw new Error("Issue request handler not found");const y=await p.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(A,E){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(A);if(!p)throw new Error("Issue data provider not found");const y=await p.provideIssueData(E);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(A,E){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(A);if(!p)throw new Error("Issue data provider not found");const y=await p.provideIssueTemplate(E);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(A,E){const p=A.identifier.value;return this._IssueUriRequestHandlers.set(p,E),this._proxy.$registerIssueUriRequestHandler(p),new F.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(p),this._IssueUriRequestHandlers.delete(p)})}registerIssueDataProvider(A,E){const p=A.identifier.value;return this._IssueDataProviders.set(p,E),this._proxy.$registerIssueDataProvider(p),new F.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(p),this._IssueDataProviders.delete(p)})}}e.ExtHostIssueReporter=f}),define(ye[94],Ce([1,0,5,27,13,69,2]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let E=class{constructor(y,R,D){this._logService=R,this._extHostFileSystem=D,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(y){return A.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,R=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(y){if(this._value)return A.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return A.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=E,e.ExtensionStoragePaths=E=je([$e(0,F.IExtHostInitDataService),$e(1,f.ILogService),$e(2,P.IExtHostConsumerFileSystem)],E)}),define(ye[316],Ce([1,0,7,20,4]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(E){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new f.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let p;switch(E){case"light":p=I.ColorThemeKind.Light;break;case"hcDark":p=I.ColorThemeKind.HighContrast;break;case"hcLight":p=I.ColorThemeKind.HighContrastLight;break;default:p=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(p),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=P,e.ExtHostTheming=P=je([$e(0,F.IExtHostRpcService)],P)}),define(ye[70],Ce([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class S extends p.DisposableTunnel{}var C;(function(m){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:r.protocol}}m.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==p.TunnelPrivacyId.ConstantPrivate&&r.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}m.fromServiceTunnel=i})(C||(e.TunnelDtoConverter=C={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let c=class extends f.Disposable{constructor(o,i,r){super(),this.logService=r,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new F.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadTunnelService)}async openTunnel(o,i){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this._proxy.$openTunnel(i,o.displayName);if(r){const n=new S(r.remoteAddress,r.localAddress,()=>this._proxy.$closeTunnel(r.remoteAddress));return this._register(n),n}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,i){const r=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(r,{selector:o,provider:i}),this._proxy.$registerPortsAttributesProvider(o,r),new v.Disposable(()=>{this._portAttributesProviders.delete(r),this._proxy.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,a){const t=[];for(const s of o){const h=this._portAttributesProviders.get(s);if(!h)return[];t.push(...await Promise.all(i.map(async l=>{let u;try{u=await h.provider.providePortAttributes({port:l,pid:r,commandLine:n},a)}catch{u=await h.provider.providePortAttributes(l,r,n,a)}return{providedAttributes:u,port:l}})))}const d=t.filter(s=>!!s.providedAttributes);return d.length>0?d.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(n,a)=>await o.provideTunnel(n,a,new I.CancellationTokenSource().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(r),Promise.resolve((0,f.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const r=o.tunnelFactory??(i?this.makeManagedTunnelFactory(i):void 0);if(r){this._forwardPortProvider=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this._proxy.$setTunnelProvider(a)}}else this._forwardPortProvider=void 0;return(0,f.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,i){if(this._extensionTunnels.has(o.host)){const r=this._extensionTunnels.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,i){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this._forwardPortProvider(o,i);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const a=this._register(n.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(n.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:a}),C.fromApiTunnel(n)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this._showCandidatePort(n.host,n.port,n.detail??""))),r=o.filter((n,a)=>i[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.ExtHostTunnelService=c,e.ExtHostTunnelService=c=je([$e(0,D.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,E.ILogService)],c)}),define(ye[15],Ce([1,0,19,22,165,74,80,28,160,56,101,24,18,2,29,83,135,141,139,118,67,90,290,26,7]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var h;(function(Le){function Ne(ce){const{selectionStartLineNumber:Fe,selectionStartColumn:ze,positionLineNumber:Je,positionColumn:qe}=ce,ct=new s.Position(Fe-1,ze-1),wt=new s.Position(Je-1,qe-1);return new s.Selection(ct,wt)}Le.to=Ne;function De(ce){const{anchor:Fe,active:ze}=ce;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Le.from=De})(h||(e.Selection=h={}));var l;(function(Le){function Ne(ce){if(!ce)return;const{start:Fe,end:ze}=ce;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Le.from=Ne;function De(ce){if(!ce)return;const{startLineNumber:Fe,startColumn:ze,endLineNumber:Je,endColumn:qe}=ce;return new s.Range(Fe-1,ze-1,Je-1,qe-1)}Le.to=De})(l||(e.Range=l={}));var u;(function(Le){function Ne(De){return new s.Location(S.URI.revive(De.uri),l.to(De.range))}Le.to=Ne})(u||(e.Location=u={}));var w;(function(Le){function Ne(De){switch(De){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Le.to=Ne})(w||(e.TokenType=w={}));var k;(function(Le){function Ne(ce){return new s.Position(ce.lineNumber-1,ce.column-1)}Le.to=Ne;function De(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Le.from=De})(k||(e.Position=k={}));var b;(function(Le){function Ne(Fe,ze,Je){return(0,I.coalesce)((0,I.asArray)(Fe).map(qe=>De(qe,ze,Je)))}Le.from=Ne;function De(Fe,ze,Je){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Je?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ce(Fe.scheme,ze),pattern:se.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Je?.isBuiltin}}function ce(Fe,ze){return ze&&typeof Fe=="string"?ze.transformOutgoingScheme(Fe):Fe}})(b||(e.DocumentSelector=b={}));var g;(function(Le){function Ne(ce){switch(ce){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Le.from=Ne;function De(ce){switch(ce){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Le.to=De})(g||(e.DiagnosticTag=g={}));var _;(function(Le){function Ne(ce){let Fe;return ce.code&&((0,v.isString)(ce.code)||(0,v.isNumber)(ce.code)?Fe=String(ce.code):Fe={value:String(ce.code.value),target:ce.code.target}),{...l.from(ce.range),message:ce.message,source:ce.source,code:Fe,severity:O.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(T.from),tags:Array.isArray(ce.tags)?(0,I.coalesce)(ce.tags.map(g.from)):void 0}}Le.from=Ne;function De(ce){const Fe=new s.Diagnostic(l.to(ce),ce.message,O.to(ce.severity));return Fe.source=ce.source,Fe.code=(0,v.isString)(ce.code)?ce.code:ce.code?.value,Fe.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(T.to),Fe.tags=ce.tags&&(0,I.coalesce)(ce.tags.map(g.to)),Fe}Le.to=De})(_||(e.Diagnostic=_={}));var T;(function(Le){function Ne(ce){return{...l.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Le.from=Ne;function De(ce){return new s.DiagnosticRelatedInformation(new s.Location(ce.resource,l.to(ce)),ce.message)}Le.to=De})(T||(e.DiagnosticRelatedInformation=T={}));var O;(function(Le){function Ne(ce){switch(ce){case s.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Le.from=Ne;function De(ce){switch(ce){case m.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Le.to=De})(O||(e.DiagnosticSeverity=O={}));var x;(function(Le){function Ne(ce){return typeof ce=="number"&&ce>=s.ViewColumn.One?ce-1:ce===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Ne;function De(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=De})(x||(e.ViewColumn=x={}));function N(Le){return typeof Le.range<"u"}function M(Le){return Le.length===0?!0:!!N(Le[0])}e.isDecorationOptionsArr=M;var L;(function(Le){function Ne(qe){return qe.map(Le.from)}Le.fromMany=Ne;function De(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function ce(qe){let ct;if(De(qe)){const{language:It,value:Et}=qe;ct={value:"```"+It+`
`+Et+"\n```\n"}}else s.MarkdownString.isMarkdownString(qe)?ct={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ct={value:qe}:ct={value:""};const wt=Object.create(null);ct.uris=wt;const qt=It=>{try{let Et=S.URI.parse(It,!0);Et=Et.with({query:Fe(Et.query,wt)}),wt[It]=Et}catch{}return""},Ct=new p.marked.Renderer;return Ct.link=qt,Ct.image=It=>typeof It=="string"?qt(A.parseHrefAndDimensions(It).href):"",(0,p.marked)(ct.value,{renderer:Ct}),ct}Le.from=ce;function Fe(qe,ct){if(!qe)return qe;let wt;try{wt=(0,y.parse)(qe)}catch{}if(!wt)return qe;let qt=!1;return wt=(0,D.cloneAndChange)(wt,Ct=>{if(S.URI.isUri(Ct)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[It]=Ct,qt=!0,It}else return}),qt?JSON.stringify(wt):qe}function ze(qe){const ct=new s.MarkdownString(qe.value,qe.supportThemeIcons);return ct.isTrusted=qe.isTrusted,ct.supportHtml=qe.supportHtml,ct.baseUri=qe.baseUri?S.URI.from(qe.baseUri):void 0,ct}Le.to=ze;function Je(qe){if(qe)return typeof qe=="string"?qe:Le.from(qe)}Le.fromStrict=Je})(L||(e.MarkdownString=L={}));function U(Le){return M(Le)?Le.map(Ne=>({range:l.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?L.fromMany(Ne.hoverMessage):Ne.hoverMessage?L.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Le.map(Ne=>({range:l.from(Ne)}))}e.fromRangeOrRangeWithMessage=U;function B(Le){return typeof Le>"u"?Le:typeof Le=="string"?S.URI.file(Le):Le}e.pathOrURIToURI=B;var G;(function(Le){function Ne(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?B(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Le.from=Ne})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var le;(function(Le){function Ne(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?B(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?G.from(De.before):void 0,after:De.after?G.from(De.after):void 0}}Le.from=Ne})(le||(e.ThemableDecorationRenderOptions=le={}));var Y;(function(Le){function Ne(De){if(typeof De>"u")return De;switch(De){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Ne})(Y||(e.DecorationRangeBehavior=Y={}));var K;(function(Le){function Ne(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?Y.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?le.from(De.light):void 0,dark:De.dark?le.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?B(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?G.from(De.before):void 0,after:De.after?G.from(De.after):void 0}}Le.from=Ne})(K||(e.DecorationRenderOptions=K={}));var Q;(function(Le){function Ne(ce){return{text:ce.newText,eol:ce.newEol&&Pe.from(ce.newEol),range:l.from(ce.range)}}Le.from=Ne;function De(ce){const Fe=new s.TextEdit(l.to(ce.range),ce.text);return Fe.newEol=typeof ce.eol>"u"?void 0:Pe.to(ce.eol),Fe}Le.to=De})(Q||(e.TextEdit=Q={}));var ue;(function(Le){function Ne(ce,Fe){const ze={edits:[]};if(ce instanceof s.WorkspaceEdit){const Je=new E.ResourceSet;for(const qe of ce._allEntries())qe._type===1&&S.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of ce._allEntries())if(qe._type===1){let ct;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ct={type:"base64",value:(0,F.encodeBase64)(F.VSBuffer.wrap(qe.options.contents))}:ct={type:"dataTransferItem",id:qe.options.contents._itemId}),ze.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ct},metadata:qe.metadata})}else qe._type===2?ze.edits.push({resource:qe.uri,textEdit:Q.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?ze.edits.push({resource:qe.uri,textEdit:{range:l.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?ze.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&ze.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return ze}Le.from=Ne;function De(ce){const Fe=new s.WorkspaceEdit,ze=new E.ResourceMap;for(const Je of ce.edits)if(Je.textEdit){const qe=Je,ct=S.URI.revive(qe.resource),wt=l.to(qe.textEdit.range),qt=qe.textEdit.text,Ct=qe.textEdit.insertAsSnippet;let It;Ct?It=s.SnippetTextEdit.replace(wt,new s.SnippetString(qt)):It=s.TextEdit.replace(wt,qt);const Et=ze.get(ct);Et?Et.push(It):ze.set(ct,[It])}else Fe.renameFile(S.URI.revive(Je.oldResource),S.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of ze)Fe.set(Je,qe);return Fe}Le.to=De})(ue||(e.WorkspaceEdit=ue={}));var ne;(function(Le){const Ne=Object.create(null);Ne[s.SymbolKind.File]=0,Ne[s.SymbolKind.Module]=1,Ne[s.SymbolKind.Namespace]=2,Ne[s.SymbolKind.Package]=3,Ne[s.SymbolKind.Class]=4,Ne[s.SymbolKind.Method]=5,Ne[s.SymbolKind.Property]=6,Ne[s.SymbolKind.Field]=7,Ne[s.SymbolKind.Constructor]=8,Ne[s.SymbolKind.Enum]=9,Ne[s.SymbolKind.Interface]=10,Ne[s.SymbolKind.Function]=11,Ne[s.SymbolKind.Variable]=12,Ne[s.SymbolKind.Constant]=13,Ne[s.SymbolKind.String]=14,Ne[s.SymbolKind.Number]=15,Ne[s.SymbolKind.Boolean]=16,Ne[s.SymbolKind.Array]=17,Ne[s.SymbolKind.Object]=18,Ne[s.SymbolKind.Key]=19,Ne[s.SymbolKind.Null]=20,Ne[s.SymbolKind.EnumMember]=21,Ne[s.SymbolKind.Struct]=22,Ne[s.SymbolKind.Event]=23,Ne[s.SymbolKind.Operator]=24,Ne[s.SymbolKind.TypeParameter]=25;function De(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Le.from=De;function ce(Fe){for(const ze in Ne)if(Ne[ze]===Fe)return Number(ze);return s.SymbolKind.Property}Le.to=ce})(ne||(e.SymbolKind=ne={}));var pe;(function(Le){function Ne(ce){switch(ce){case s.SymbolTag.Deprecated:return 1}}Le.from=Ne;function De(ce){switch(ce){case 1:return s.SymbolTag.Deprecated}}Le.to=De})(pe||(e.SymbolTag=pe={}));var oe;(function(Le){function Ne(ce){return{name:ce.name,kind:ne.from(ce.kind),tags:ce.tags&&ce.tags.map(pe.from),containerName:ce.containerName,location:he.from(ce.location)}}Le.from=Ne;function De(ce){const Fe=new s.SymbolInformation(ce.name,ne.to(ce.kind),ce.containerName,he.to(ce.location));return Fe.tags=ce.tags&&ce.tags.map(pe.to),Fe}Le.to=De})(oe||(e.WorkspaceSymbol=oe={}));var q;(function(Le){function Ne(ce){const Fe={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),kind:ne.from(ce.kind),tags:ce.tags?.map(pe.from)??[]};return ce.children&&(Fe.children=ce.children.map(Ne)),Fe}Le.from=Ne;function De(ce){const Fe=new s.DocumentSymbol(ce.name,ce.detail,ne.to(ce.kind),l.to(ce.range),l.to(ce.selectionRange));return(0,I.isNonEmptyArray)(ce.tags)&&(Fe.tags=ce.tags.map(pe.to)),ce.children&&(Fe.children=ce.children.map(De)),Fe}Le.to=De})(q||(e.DocumentSymbol=q={}));var W;(function(Le){function Ne(ce){const Fe=new s.CallHierarchyItem(ne.to(ce.kind),ce.name,ce.detail||"",S.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Fe._sessionId=ce._sessionId,Fe._itemId=ce._itemId,Fe}Le.to=Ne;function De(ce,Fe,ze){if(Fe=Fe??ce._sessionId,ze=ze??ce._itemId,Fe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:ze,name:ce.name,detail:ce.detail,kind:ne.from(ce.kind),uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map(pe.from)}}Le.from=De})(W||(e.CallHierarchyItem=W={}));var ie;(function(Le){function Ne(De){return new s.CallHierarchyIncomingCall(W.to(De.from),De.fromRanges.map(ce=>l.to(ce)))}Le.to=Ne})(ie||(e.CallHierarchyIncomingCall=ie={}));var Se;(function(Le){function Ne(De){return new s.CallHierarchyOutgoingCall(W.to(De.to),De.fromRanges.map(ce=>l.to(ce)))}Le.to=Ne})(Se||(e.CallHierarchyOutgoingCall=Se={}));var he;(function(Le){function Ne(ce){return{range:ce.range&&l.from(ce.range),uri:ce.uri}}Le.from=Ne;function De(ce){return new s.Location(S.URI.revive(ce.uri),l.to(ce.range))}Le.to=De})(he||(e.location=he={}));var fe;(function(Le){function Ne(ce){const Fe=ce,ze=ce;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:ze.uri,range:l.from(Fe.targetRange?Fe.targetRange:ze.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Le.from=Ne;function De(ce){return{targetUri:S.URI.revive(ce.uri),targetRange:l.to(ce.range),targetSelectionRange:ce.targetSelectionRange?l.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?l.to(ce.originSelectionRange):void 0}}Le.to=De})(fe||(e.DefinitionLink=fe={}));var Z;(function(Le){function Ne(ce){return{range:l.from(ce.range),contents:L.fromMany(ce.contents)}}Le.from=Ne;function De(ce){return new s.Hover(ce.contents.map(L.to),l.to(ce.range))}Le.to=De})(Z||(e.Hover=Z={}));var ee;(function(Le){function Ne(ce){return{range:l.from(ce.range),expression:ce.expression}}Le.from=Ne;function De(ce){return new s.EvaluatableExpression(l.to(ce.range),ce.expression)}Le.to=De})(ee||(e.EvaluatableExpression=ee={}));var j;(function(Le){function Ne(ce){if(ce instanceof s.InlineValueText)return{type:"text",range:l.from(ce.range),text:ce.text};if(ce instanceof s.InlineValueVariableLookup)return{type:"variable",range:l.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Ne;function De(ce){switch(ce.type){case"text":return{range:l.to(ce.range),text:ce.text};case"variable":return{range:l.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:l.to(ce.range),expression:ce.expression}}}Le.to=De})(j||(e.InlineValue=j={}));var J;(function(Le){function Ne(ce){return{frameId:ce.frameId,stoppedLocation:l.from(ce.stoppedLocation)}}Le.from=Ne;function De(ce){return new s.InlineValueContext(ce.frameId,l.to(ce.stoppedLocation))}Le.to=De})(J||(e.InlineValueContext=J={}));var ge;(function(Le){function Ne(ce){return{range:l.from(ce.range),kind:ce.kind}}Le.from=Ne;function De(ce){return new s.DocumentHighlight(l.to(ce.range),ce.kind)}Le.to=De})(ge||(e.DocumentHighlight=ge={}));var we;(function(Le){function Ne(ce){return{uri:ce.uri,highlights:ce.highlights.map(ge.from)}}Le.from=Ne;function De(ce){return new s.MultiDocumentHighlight(S.URI.revive(ce.uri),ce.highlights.map(ge.to))}Le.to=De})(we||(e.MultiDocumentHighlight=we={}));var Ae;(function(Le){function Ne(De){switch(De){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Le.to=Ne})(Ae||(e.CompletionTriggerKind=Ae={}));var Ee;(function(Le){function Ne(De){return{triggerKind:Ae.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Le.to=Ne})(Ee||(e.CompletionContext=Ee={}));var ke;(function(Le){function Ne(ce){switch(ce){case s.CompletionItemTag.Deprecated:return 1}}Le.from=Ne;function De(ce){switch(ce){case 1:return s.CompletionItemTag.Deprecated}}Le.to=De})(ke||(e.CompletionItemTag=ke={}));var z;(function(Le){const Ne=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function De(ze){return Ne.get(ze)??9}Le.from=De;const ce=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(ze){return ce.get(ze)??s.CompletionItemKind.Property}Le.to=Fe})(z||(e.CompletionItemKind=z={}));var X;(function(Le){function Ne(De,ce){const Fe=new s.CompletionItem(De.label);return Fe.insertText=De.insertText,Fe.kind=z.to(De.kind),Fe.tags=De.tags?.map(ke.to),Fe.detail=De.detail,Fe.documentation=A.isMarkdownString(De.documentation)?L.to(De.documentation):De.documentation,Fe.sortText=De.sortText,Fe.filterText=De.filterText,Fe.preselect=De.preselect,Fe.commitCharacters=De.commitCharacters,C.Range.isIRange(De.range)?Fe.range=l.to(De.range):typeof De.range=="object"&&(Fe.range={inserting:l.to(De.range.insert),replacing:l.to(De.range.replace)}),Fe.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Fe.insertText=new s.SnippetString(De.insertText):(Fe.insertText=De.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Fe.additionalTextEdits=De.additionalTextEdits.map(ze=>Q.to(ze))),Fe.command=ce&&De.command?ce.fromInternal(De.command):void 0,Fe}Le.to=Ne})(X||(e.CompletionItem=X={}));var te;(function(Le){function Ne(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:L.fromStrict(ce.documentation)}}Le.from=Ne;function De(ce){return{label:ce.label,documentation:A.isMarkdownString(ce.documentation)?L.to(ce.documentation):ce.documentation}}Le.to=De})(te||(e.ParameterInformation=te={}));var H;(function(Le){function Ne(ce){return{label:ce.label,documentation:L.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.from):[],activeParameter:ce.activeParameter}}Le.from=Ne;function De(ce){return{label:ce.label,documentation:A.isMarkdownString(ce.documentation)?L.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.to):[],activeParameter:ce.activeParameter}}Le.to=De})(H||(e.SignatureInformation=H={}));var ae;(function(Le){function Ne(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(H.from):[]}}Le.from=Ne;function De(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(H.to):[]}}Le.to=De})(ae||(e.SignatureHelp=ae={}));var de;(function(Le){function Ne(De,ce){const Fe=new s.InlayHint(k.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(Re.to.bind(void 0,De)),ce.kind&&Ue.to(ce.kind));return Fe.textEdits=ce.textEdits&&ce.textEdits.map(Q.to),Fe.tooltip=A.isMarkdownString(ce.tooltip)?L.to(ce.tooltip):ce.tooltip,Fe.paddingLeft=ce.paddingLeft,Fe.paddingRight=ce.paddingRight,Fe}Le.to=Ne})(de||(e.InlayHint=de={}));var Re;(function(Le){function Ne(De,ce){const Fe=new s.InlayHintLabelPart(ce.label);return Fe.tooltip=A.isMarkdownString(ce.tooltip)?L.to(ce.tooltip):ce.tooltip,c.Command.is(ce.command)&&(Fe.command=De.fromInternal(ce.command)),ce.location&&(Fe.location=he.to(ce.location)),Fe}Le.to=Ne})(Re||(e.InlayHintLabelPart=Re={}));var Ue;(function(Le){function Ne(ce){return ce}Le.from=Ne;function De(ce){return ce}Le.to=De})(Ue||(e.InlayHintKind=Ue={}));var Ve;(function(Le){function Ne(ce){return{range:l.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Le.from=Ne;function De(ce){let Fe;if(ce.url)try{Fe=typeof ce.url=="string"?S.URI.parse(ce.url,!0):S.URI.revive(ce.url)}catch{}return new s.DocumentLink(l.to(ce.range),Fe)}Le.to=De})(Ve||(e.DocumentLink=Ve={}));var Ke;(function(Le){function Ne(ce){const Fe=new s.ColorPresentation(ce.label);return ce.textEdit&&(Fe.textEdit=Q.to(ce.textEdit)),ce.additionalTextEdits&&(Fe.additionalTextEdits=ce.additionalTextEdits.map(ze=>Q.to(ze))),Fe}Le.to=Ne;function De(ce){return{label:ce.label,textEdit:ce.textEdit?Q.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Fe=>Q.from(Fe)):void 0}}Le.from=De})(Ke||(e.ColorPresentation=Ke={}));var Ze;(function(Le){function Ne(ce){return new s.Color(ce[0],ce[1],ce[2],ce[3])}Le.to=Ne;function De(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Le.from=De})(Ze||(e.Color=Ze={}));var at;(function(Le){function Ne(ce){return{range:l.from(ce.range)}}Le.from=Ne;function De(ce){return new s.SelectionRange(l.to(ce.range))}Le.to=De})(at||(e.SelectionRange=at={}));var st;(function(Le){function Ne(De){switch(De){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Le.to=Ne})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Le){function Ne(ce){switch(ce){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Ne;function De(ce){switch(ce){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Le.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Pe;(function(Le){function Ne(ce){if(ce===s.EndOfLine.CRLF)return 1;if(ce===s.EndOfLine.LF)return 0}Le.from=Ne;function De(ce){if(ce===1)return s.EndOfLine.CRLF;if(ce===0)return s.EndOfLine.LF}Le.to=De})(Pe||(e.EndOfLine=Pe={}));var xe;(function(Le){function Ne(De){if(typeof De=="object")return De.viewId;switch(De){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Ne})(xe||(e.ProgressLocation=xe={}));var Te;(function(Le){function Ne(ce){const Fe={start:ce.start+1,end:ce.end+1};return ce.kind&&(Fe.kind=Xe.from(ce.kind)),Fe}Le.from=Ne;function De(ce){const Fe={start:ce.start-1,end:ce.end-1};return ce.kind&&(Fe.kind=Xe.to(ce.kind)),Fe}Le.to=De})(Te||(e.FoldingRange=Te={}));var Xe;(function(Le){function Ne(ce){if(ce)switch(ce){case s.FoldingRangeKind.Comment:return c.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return c.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return c.FoldingRangeKind.Region}}Le.from=Ne;function De(ce){if(ce)switch(ce.value){case c.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Le.to=De})(Xe||(e.FoldingRangeKind=Xe={}));var re;(function(Le){function Ne(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?l.from(De.selection):void 0,override:typeof De.override=="boolean"?i.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Ne})(re||(e.TextEditorOpenOptions=re={}));var se;(function(Le){function Ne(ze){return ze instanceof s.RelativePattern?ze.toJSON():typeof ze=="string"?ze:De(ze)||ce(ze)?new s.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Le.from=Ne;function De(ze){const Je=ze;return Je?S.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function ce(ze){const Je=ze;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(ze){return typeof ze=="string"?ze:new s.RelativePattern(S.URI.revive(ze.baseUri),ze.pattern)}Le.to=Fe})(se||(e.GlobPattern=se={}));var Ie;(function(Le){function Ne(De){if(De){if(Array.isArray(De))return De.map(Ne);if(typeof De=="string")return De;{const ce=De;return{language:ce.language,scheme:ce.scheme,pattern:se.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Le.from=Ne})(Ie||(e.LanguageSelector=Ie={}));var He;(function(Le){function Ne(ce){return!!ce&&typeof ce=="object"&&"documents"in ce&&Array.isArray(ce.documents)&&ce.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&S.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Je=>Je instanceof s.Range)))}Le.is=Ne;function De(ce){return{documents:ce.documents.map(Fe=>Fe.map(ze=>({uri:S.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Je=>l.from(Je))})))}}Le.from=De})(He||(e.MappedEditsContext=He={}));var Qe;(function(Le){function Ne(ce){return{start:ce.start,end:ce.end}}Le.from=Ne;function De(ce){return new s.NotebookRange(ce.start,ce.end)}Le.to=De})(Qe||(e.NotebookRange=Qe={}));var it;(function(Le){function Ne(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Le.to=Ne;function De(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Le.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Le){function Ne(De){if(De===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(De===r.NotebookCellExecutionState.Pending)return;if(De===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Le.to=Ne})(nt||(e.NotebookCellExecutionState=nt={}));var Me;(function(Le){function Ne(ce){switch(ce){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Le.from=Ne;function De(ce){switch(ce){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Le.to=De})(Me||(e.NotebookCellKind=Me={}));var St;(function(Le){function Ne(ce){const Fe={metadata:ce.metadata??Object.create(null),cells:[]};for(const ze of ce.cells)s.NotebookCellData.validate(ze),Fe.cells.push(Dt.from(ze));return Fe}Le.from=Ne;function De(ce){const Fe=new s.NotebookData(ce.cells.map(Dt.to));return(0,v.isEmptyObject)(ce.metadata)||(Fe.metadata=ce.metadata),Fe}Le.to=De})(St||(e.NotebookData=St={}));var Dt;(function(Le){function Ne(ce){return{cellKind:Me.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:it.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(Nt.from):[]}}Le.from=Ne;function De(ce){return new s.NotebookCellData(Me.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(Nt.to):void 0,ce.metadata,ce.internalMetadata?it.to(ce.internalMetadata):void 0)}Le.to=De})(Dt||(e.NotebookCellData=Dt={}));var Ft;(function(Le){function Ne(ce){return{mime:ce.mime,valueBytes:F.VSBuffer.wrap(ce.data)}}Le.from=Ne;function De(ce){return new s.NotebookCellOutputItem(ce.valueBytes.buffer,ce.mime)}Le.to=De})(Ft||(e.NotebookCellOutputItem=Ft={}));var Nt;(function(Le){function Ne(ce){return{outputId:ce.id,items:ce.items.map(Ft.from),metadata:ce.metadata}}Le.from=Ne;function De(ce){const Fe=ce.items.map(Ft.to);return new s.NotebookCellOutput(Fe,ce.outputId,ce.metadata)}Le.to=De})(Nt||(e.NotebookCellOutput=Nt={}));var _t;(function(Le){function Ne(Fe){return ce(Fe)?{include:se.from(Fe.include)??void 0,exclude:se.from(Fe.exclude)??void 0}:se.from(Fe)??void 0}Le.from=Ne;function De(Fe){return ce(Fe)?{include:se.to(Fe.include),exclude:se.to(Fe.exclude)}:se.to(Fe)}Le.to=De;function ce(Fe){const ze=Fe;return ze?!(0,v.isUndefinedOrNull)(ze.include)&&!(0,v.isUndefinedOrNull)(ze.exclude):!1}})(_t||(e.NotebookExclusiveDocumentPattern=_t={}));var Vt;(function(Le){function Ne(De,ce,Fe){const ze=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(ze,Fe),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Le.from=Ne})(Vt||(e.NotebookStatusBarItem=Vt={}));var Mt;(function(Le){function Ne(De,ce,Fe){const ze=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ce.toInternal(ze,Fe),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Le.from=Ne})(Mt||(e.NotebookKernelSourceAction=Mt={}));var Qt;(function(Le){function Ne(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Le.from=Ne})(Qt||(e.NotebookDocumentContentOptions=Qt={}));var $t;(function(Le){function Ne(ce){return{uri:ce.uri,provides:ce.provides}}Le.from=Ne;function De(ce){return new s.NotebookRendererScript(S.URI.revive(ce.uri),ce.provides)}Le.to=De})($t||(e.NotebookRendererScript=$t={}));var Bt;(function(Le){function Ne(ce){return{message:L.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,contextValue:ce.contextValue,location:ce.location&&{range:l.from(ce.location.range),uri:ce.location.uri}}}Le.from=Ne;function De(ce){const Fe=new s.TestMessage(typeof ce.message=="string"?ce.message:L.to(ce.message));return Fe.actualOutput=ce.actual,Fe.expectedOutput=ce.expected,Fe.contextValue=ce.contextValue,Fe.location=ce.location?he.to(ce.location):void 0,Fe}Le.to=De})(Bt||(e.TestMessage=Bt={}));var et;(function(Le){Le.namespace=a.namespaceTestTag,Le.denamespace=a.denamespaceTestTag})(et||(e.TestTag=et={}));var jt;(function(Le){function Ne(ce){const Fe=(0,o.getPrivateApiFor)(ce).controllerId;return{extId:n.TestId.fromExtHostTestItem(ce,Fe).toString(),label:ce.label,uri:S.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(ze=>et.namespace(Fe,ze.id)),range:C.Range.lift(l.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&L.fromStrict(ce.error)||null}}Le.from=Ne;function De(ce){return{parent:void 0,error:void 0,id:n.TestId.fromString(ce.extId).localId,label:ce.label,uri:S.URI.revive(ce.uri),tags:(ce.tags||[]).map(Fe=>{const{tagId:ze}=et.denamespace(Fe);return new s.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Le.toPlain=De})(jt||(e.TestItem=jt={})),function(Le){function Ne(ce){return{id:ce.id}}Le.from=Ne;function De(ce){return new s.TestTag(ce.id)}Le.to=De}(et||(e.TestTag=et={}));var Gt;(function(Le){const Ne=(ce,Fe)=>{const ze=[];for(const[qe,ct]of Fe)n.TestId.compare(ct.item.extId,qe)===2&&(Fe.delete(qe),ze.push(ct));const Je={...jt.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ct=>ct.type===0).map(Bt.to)})),children:ze.map(qe=>Ne(qe,Fe))};for(const qe of Je.children)qe.parent=Je;return Je};function De(ce){const Fe=[],ze=new Map;for(const Je of ce.items){ze.set(Je.item.extId,Je);const qe=n.TestId.root(Je.item.extId);ce.request.targets.some(ct=>ct.controllerId===qe&&ct.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:ce.completedAt,results:Fe.map(Je=>Ne(Je,ze))}}Le.to=De})(Gt||(e.TestResults=Gt={}));var dt;(function(Le){function Ne(ze){return{covered:ze.covered,total:ze.total}}function De(ze){return"line"in ze?k.from(ze):l.from(ze)}function ce(ze){return"branches"in ze?{count:ze.executionCount,location:De(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Je=>({count:Je.executionCount,location:Je.location&&De(Je.location),label:Je.label})):void 0}:{type:0,name:ze.name,count:ze.executionCount,location:De(ze.location)}}Le.fromDetailed=ce;function Fe(ze){return{uri:ze.uri,statement:Ne(ze.statementCoverage),branch:ze.branchCoverage&&Ne(ze.branchCoverage),function:ze.functionCoverage&&Ne(ze.functionCoverage),details:ze.detailedCoverage?.map(ce)}}Le.fromFile=Fe})(dt||(e.TestCoverage=dt={}));var pt;(function(Le){function Ne(De){switch(De){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Le.to=Ne})(pt||(e.CodeActionTriggerKind=pt={}));var zt;(function(Le){function Ne(ce){const Fe=new s.TypeHierarchyItem(ne.to(ce.kind),ce.name,ce.detail||"",S.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Fe._sessionId=ce._sessionId,Fe._itemId=ce._itemId,Fe}Le.to=Ne;function De(ce,Fe,ze){if(Fe=Fe??ce._sessionId,ze=ze??ce._itemId,Fe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:ze,kind:ne.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map(pe.from)}}Le.from=De})(zt||(e.TypeHierarchyItem=zt={}));var Kt;(function(Le){function Ne(De){if(De)return{value:De.value,tooltip:De.tooltip}}Le.from=Ne})(Kt||(e.ViewBadge=Kt={}));var yt;(function(Le){function Ne(ze,Je,qe){const ct=Je.fileData;return ct?new s.InternalFileDataTransferItem(new s.DataTransferFile(ct.name,S.URI.revive(ct.uri),ct.id,(0,P.createSingleCallFunction)(()=>qe(ct.id)))):ze===R.Mimes.uriList&&Je.uriListData?new s.InternalDataTransferItem(Fe(Je.uriListData)):new s.InternalDataTransferItem(Je.asString)}Le.to=Ne;async function De(ze,Je){const qe=await Je.asString();if(ze===R.Mimes.uriList)return{asString:qe,fileData:void 0,uriListData:ce(qe)};const ct=Je.asFile();return{asString:qe,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Le.from=De;function ce(ze){return f.UriList.split(ze).map(Je=>{if(Je.startsWith("#"))return Je;try{return S.URI.parse(Je)}catch{}return Je})}function Fe(ze){return f.UriList.create(ze.map(Je=>typeof Je=="string"?Je:S.URI.revive(Je)))}})(yt||(e.DataTransferItem=yt={}));var ft;(function(Le){function Ne(ce,Fe){const ze=ce.items.map(([Je,qe])=>[Je,yt.to(Je,qe,Fe)]);return new s.DataTransfer(ze)}Le.toDataTransfer=Ne;async function De(ce){const Fe={items:[]},ze=[];for(const[Je,qe]of ce)ze.push((async()=>{Fe.items.push([Je,await yt.from(Je,qe)])})());return await Promise.all(ze),Fe}Le.from=De})(ft||(e.DataTransfer=ft={}));var kt;(function(Le){function Ne(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Le.from=Ne})(kt||(e.ChatReplyFollowup=kt={}));var Zt;(function(Le){function Ne(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:kt.from(De)}Le.from=Ne})(Zt||(e.ChatFollowup=Zt={}));var Tt;(function(Le){function Ne(ce){const Fe=new s.ChatMessage(Ge.to(ce.role),ce.content);return Fe.name=ce.name,Fe}Le.to=Ne;function De(ce){return{role:Ge.from(ce.role),content:ce.content,name:ce.name}}Le.from=De})(Tt||(e.ChatMessage=Tt={}));var Ge;(function(Le){function Ne(ce){switch(ce){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Le.to=Ne;function De(ce){switch(ce){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Le.from=De})(Ge||(e.ChatMessageRole=Ge={}));var Lt;(function(Le){function Ne(Fe){const ze={};for(const Je of Object.keys(Fe))ze[Je]=Fe[Je].map(Le.to);return ze}Le.objectTo=Ne;function De(Fe){return{level:Ut.to(Fe.level),kind:Fe.kind,value:(0,S.isUriComponents)(Fe.value)?S.URI.revive(Fe.value):Fe.value,description:Fe.description}}Le.to=De;function ce(Fe){return{level:Ut.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Le.from=ce})(Lt||(e.ChatVariable=Lt={}));var Ut;(function(Le){function Ne(ce){switch(ce){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Le.to=Ne;function De(ce){switch(ce){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Le.from=De})(Ut||(e.ChatVariableLevel=Ut={}));var Xt;(function(Le){function Ne(De){switch(De){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=Ne})(Xt||(e.InteractiveEditorResponseFeedbackKind=Xt={}));var mt;(function(Le){function Ne(Fe,ze){return"markdownContent"in ze?((0,d.checkProposedApiEnabled)(Fe,"chatAgents2Additions"),{content:L.from(ze.markdownContent),kind:"markdownContent"}):"content"in ze?"vulnerabilities"in ze&&ze.vulnerabilities?((0,d.checkProposedApiEnabled)(Fe,"chatAgents2Additions"),{content:ze.content,vulnerabilities:ze.vulnerabilities,kind:"vulnerability"}):typeof ze.content=="string"?{content:ze.content,kind:"content"}:((0,d.checkProposedApiEnabled)(Fe,"chatAgents2Additions"),{content:L.from(ze.content),kind:"markdownContent"}):"documents"in ze?{documents:ze.documents.map(Je=>({uri:Je.uri,version:Je.version,ranges:Je.ranges.map(qe=>l.from(qe))})),kind:"usedContext"}:"reference"in ze?{reference:"uri"in ze.reference?{uri:ze.reference.uri,range:l.from(ze.reference.range)}:ze.reference,kind:"reference"}:"inlineReference"in ze?{inlineReference:"uri"in ze.inlineReference?{uri:ze.inlineReference.uri,range:l.from(ze.inlineReference.range)}:ze.inlineReference,name:ze.title,kind:"inlineReference"}:"agentName"in ze?((0,d.checkProposedApiEnabled)(Fe,"chatAgents2Additions"),{agentName:ze.agentName,command:ze.command,kind:"agentDetection"}):"treeData"in ze?{treeData:ze.treeData,kind:"treeData"}:"message"in ze?{content:L.from(ze.message),kind:"progressMessage"}:void 0}Le.from=Ne;function De(Fe){switch(Fe.kind){case"markdownContent":case"inlineReference":case"treeData":return Le.to(Fe);case"content":return{content:Fe.content};case"usedContext":return{documents:Fe.documents.map(ze=>({uri:S.URI.revive(ze.uri),version:ze.version,ranges:ze.ranges.map(Je=>l.to(Je))}))};case"reference":return{reference:(0,S.isUriComponents)(Fe.reference)?S.URI.revive(Fe.reference):u.to(Fe.reference)};case"agentDetection":return;case"progressMessage":return{message:Fe.content.value};case"vulnerability":return{content:Fe.content,vulnerabilities:Fe.vulnerabilities};default:return}}Le.to=De;function ce(Fe){switch(Fe.kind){case"markdownContent":return{content:Fe.content.value};case"inlineReference":return{inlineReference:(0,S.isUriComponents)(Fe.inlineReference)?S.URI.revive(Fe.inlineReference):u.to(Fe.inlineReference),title:Fe.name};case"treeData":return{treeData:(0,y.revive)(Fe.treeData)};default:return}}Le.toProgressContent=ce})(mt||(e.ChatResponseProgress=mt={}));var Ot;(function(Le){function Ne(De,ce){return{prompt:De.message,variables:Lt.objectTo(De.variables),slashCommand:ce,subCommand:De.command,agentId:De.agentId}}Le.to=Ne})(Ot||(e.ChatAgentRequest=Ot={}));var At;(function(Le){function Ne(De){return{label:De.label,values:De.values.map(Lt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Le.from=Ne})(At||(e.ChatAgentCompletionItem=At={}));var Wt;(function(Le){function Ne(De,ce,Fe){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ce.toInternal(De,Fe)}Le.from=Ne})(Wt||(e.TerminalQuickFix=Wt={}))}),define(ye[317],Ce([1,0,6,20,15]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(E,p){this._proxy=E.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:y=>p.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,p,y){const R=f.WorkspaceEdit.from(E,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.ExtHostBulkEdits=P,e.ExtHostBulkEdits=P=je([$e(0,F.IExtHostRpcService)],P)}),define(ye[318],Ce([1,0,53,3,6,15]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class A{static{this._pool=0}constructor(y,R){this.extension=y,this.provider=R,this.handle=A._pool++}}class E{static{this._nextId=0}constructor(y){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=y.getProxy(f.MainContext.MainThreadChat)}registerChatProvider(y,R,D){const v=new A(y,D);return this._chatProvider.set(v.handle,v),this._proxy.$registerChatProvider(v.handle,R),(0,F.toDisposable)(()=>{this._proxy.$unregisterChatProvider(v.handle),this._chatProvider.delete(v.handle)})}transferChatSession(y,R){const D=I.Iterable.find(this._chatSessions.keys(),v=>this._chatSessions.get(v)===y)??0;typeof D=="number"&&this._proxy.$transferChatSession(D,R)}sendInteractiveRequestToProvider(y,R){this._proxy.$sendRequestToProvider(y,R)}async $prepareChat(y,R){const D=this._chatProvider.get(y);if(!D)return;const v=await D.provider.prepareSession(R);if(!v)return;const S=E._nextId++;return this._chatSessions.set(S,v),{id:S,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(y,R){const D=this._chatProvider.get(y);if(!D||!D.provider.provideWelcomeMessage)return;const v=await D.provider.provideWelcomeMessage(R);if(v)return v.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(C=>P.ChatReplyFollowup.from(C)):P.MarkdownString.from(S))}async $provideSampleQuestions(y,R){const D=this._chatProvider.get(y);if(!D||!D.provider.provideSampleQuestions)return;const v=await D.provider.provideSampleQuestions(R);if(v)return v?.map(S=>P.ChatReplyFollowup.from(S))}$releaseSession(y){this._chatSessions.delete(y)}}e.ExtHostChat=E}),define(ye[319],Ce([1,0,19,11,21,44,4,38,18,2,210,86,6,15,7,279,26]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class o{static{this._idPool=0}constructor(n,a,t){this._extHostChatProvider=a,this._logService=t,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=n.getProxy(v.MainContext.MainThreadChatAgents2)}createChatAgent(n,a,t){const d=o._idPool++,s=new i(n,a,this._proxy,d,t);return this._agents.set(d,s),this._proxy.$registerAgent(d,a,{}),s.apiAgent}async $invokeAgent(n,a,t,d){this._previousResultMap.delete(a.sessionId);const s=this._agents.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let h=!1;function l(){if(h)throw new Error("Only valid while executing the command")}const u=new F.DeferredPromise;d.onCancellationRequested(()=>u.complete()),this._extHostChatProvider.allowListExtensionWhile(s.extension.identifier,u.p);const w=a.command?await s.validateSlashCommand(a.command):void 0,k=E.StopWatch.create(!1);let b;try{const g=await this.prepareHistory(s,a,t),_=s.invoke(S.ChatAgentRequest.to(a,w),{history:g},new D.Progress(T=>{l(),typeof b>"u"&&"content"in T&&(b=k.elapsed());const O=S.ChatResponseProgress.from(s.extension,T);if(!O){this._logService.error("Unknown progress type: "+JSON.stringify(T));return}"placeholder"in T&&"resolvedContent"in T||this._proxy.$handleProgressChunk(a.requestId,O)}),d);return await(0,F.raceCancellation)(Promise.resolve(_).then(T=>{if(T){this._previousResultMap.set(a.sessionId,T);let O=this._resultsBySessionAndRequestId.get(a.sessionId);O||(O=new Map,this._resultsBySessionAndRequestId.set(a.sessionId,O)),O.set(a.requestId,T);const x={firstProgress:b,totalElapsed:k.elapsed()};return{errorDetails:T.errorDetails,timings:x}}else this._previousResultMap.delete(a.sessionId)}),d)}catch(g){return this._logService.error(g,s.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,P.toErrorMessage)(g)),responseIsIncomplete:!0}}}finally{h=!0,u.complete()}}async prepareHistory(n,a,t){return(0,I.coalesce)(await Promise.all(t.history.map(async d=>{const s=a.agentId===d.request.agentId&&this._resultsBySessionAndRequestId.get(a.sessionId)?.get(d.request.requestId)||d.result;return{request:S.ChatAgentRequest.to(d.request,void 0),response:(0,I.coalesce)(d.response.map(h=>S.ChatResponseProgress.toProgressContent(h))),result:s}})))}$releaseSession(n){this._previousResultMap.delete(n),this._resultsBySessionAndRequestId.delete(n)}async $provideSlashCommands(n,a){const t=this._agents.get(n);return t?t.provideSlashCommand(a):[]}$provideFollowups(n,a,t){const d=this._agents.get(n);if(!d)return Promise.resolve([]);const s=this._previousResultMap.get(a);return s?d.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(n,a,t,d,s){const h=this._agents.get(n);if(!h)return;const l=this._resultsBySessionAndRequestId.get(a)?.get(t);if(!l)return;let u;switch(d){case c.InteractiveSessionVoteDirection.Down:u=C.ChatAgentResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:u=C.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(s?{result:l,kind:u,reportIssue:s}:{result:l,kind:u}))}$acceptAction(n,a,t,d){const s=this._agents.get(n);if(!s)return;const h=this._resultsBySessionAndRequestId.get(a)?.get(t);h&&d.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:d.action,result:h}))}async $invokeCompletionProvider(n,a,t){const d=this._agents.get(n);return d?(await d.invokeCompletionProvider(a,t)).map(S.ChatAgentCompletionItem.from):[]}}e.ExtHostChatAgents2=o;class i{constructor(n,a,t,d,s){this.extension=n,this.id=a,this._proxy=t,this._handle=d,this._callback=s,this._onDidReceiveFeedback=new A.Emitter,this._onDidPerformAction=new A.Emitter}acceptFeedback(n){this._onDidReceiveFeedback.fire(n)}acceptAction(n){this._onDidPerformAction.fire(n)}async invokeCompletionProvider(n,a){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(n,a)??[]:[]}async validateSlashCommand(n){this._lastSlashCommands||(await this.provideSlashCommand(f.CancellationToken.None),(0,p.assertType)(this._lastSlashCommands));const a=this._lastSlashCommands.find(t=>t.name===n);if(!a)throw new Error(`Unknown slashCommand: ${n}`);return a}async provideSlashCommand(n){if(!this._slashCommandProvider)return[];const a=await this._slashCommandProvider.provideSubCommands(n);return a?(this._lastSlashCommands=a,a.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(n,a){if(!this._followupProvider)return[];const t=await this._followupProvider.provideFollowups(n,a);return t?t.map(d=>S.ChatFollowup.from(d)):[]}get apiAgent(){let n=!1,a=!1;const t=()=>{n||a||(a=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof y.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof C.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:S.MarkdownString.from(this._helpTextPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:S.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting}),a=!1}))},d=this;return{get name(){return d.id},get description(){return d._description??""},set description(s){d._description=s,t()},get fullName(){return d._fullName??d.extension.displayName??d.extension.name},set fullName(s){d._fullName=s,t()},get iconPath(){return d._iconPath},set iconPath(s){d._iconPath=s,t()},get subCommandProvider(){return d._slashCommandProvider},set subCommandProvider(s){d._slashCommandProvider=s,t()},get followupProvider(){return d._followupProvider},set followupProvider(s){d._followupProvider=s,t()},get isDefault(){return(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isDefault},set isDefault(s){(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isDefault=s,t()},get helpTextPrefix(){return(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._helpTextPrefix},set helpTextPrefix(s){if((0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),!d._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");d._helpTextPrefix=s,t()},get helpTextPostfix(){return(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._helpTextPostfix},set helpTextPostfix(s){if((0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),!d._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");d._helpTextPostfix=s,t()},get isSecondary(){return(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isSecondary},set isSecondary(s){(0,m.checkProposedApiEnabled)(d.extension,"defaultChatAgent"),d._isSecondary=s,t()},get sampleRequest(){return d._sampleRequest},set sampleRequest(s){d._sampleRequest=s,t()},get supportIssueReporting(){return(0,m.checkProposedApiEnabled)(d.extension,"chatAgents2Additions"),d._supportIssueReporting},set supportIssueReporting(s){(0,m.checkProposedApiEnabled)(d.extension,"chatAgents2Additions"),d._supportIssueReporting=s,t()},get onDidReceiveFeedback(){return d._onDidReceiveFeedback.event},set agentVariableProvider(s){if(d._agentVariableProvider=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");d._proxy.$registerAgentCompletionsProvider(d._handle,s.triggerCharacters)}else d._proxy.$unregisterAgentCompletionsProvider(d._handle)},get agentVariableProvider(){return d._agentVariableProvider},onDidPerformAction:(0,m.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){n=!0,d._slashCommandProvider=void 0,d._followupProvider=void 0,d._onDidReceiveFeedback.dispose(),d._proxy.$unregisterAgent(d._handle)}}}invoke(n,a,t,d){return this._callback(n,a,t,d)}}}),define(ye[320],Ce([1,0,21,3,6,15,86,25,11,4]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class R{constructor(C,c){this.stream=new p.AsyncIterableSource,this.stream=c??new p.AsyncIterableSource;const m=this;this.apiObj={option:C,response:m.stream.asyncIterable}}}class D{constructor(C,c){this._onDidStart=new y.Emitter,this._responseStreams=new Map,this._defaultStream=new p.AsyncIterableSource,this._isDone=!1;const m=this;this.apiObject={result:C,response:m._defaultStream.asyncIterable,onDidStartResponseStream:m._onDidStart.event,cancel(){c.cancel()}},C.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,o]of this._responseStreams)o.stream.resolve();else this._defaultStream.resolve()})}handleFragment(C){if(this._isDone)return;let c=this._responseStreams.get(C.index);c||(this._responseStreams.size===0?c=new R(C.index,this._defaultStream):c=new R(C.index),this._responseStreams.set(C.index,c),this._onDidStart.fire(c.apiObj)),c.stream.emitOne(C.part)}}class v{static{this._idPool=1}constructor(C,c){this._logService=c,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new E.ExtensionIdentifierMap,this._proxy=C.getProxy(f.MainContext.MainThreadChatProvider)}registerProvider(C,c,m,o){const i=v._idPool++;return this._providers.set(i,{extension:C,provider:m}),this._proxy.$registerProvider(i,c,{extension:C,model:o.name??""}),(0,F.toDisposable)(()=>{this._proxy.$unregisterProvider(i),this._providers.delete(i)})}async $provideChatResponse(C,c,m,o,i){const r=this._providers.get(C);if(!r)return;const n=new A.Progress(async a=>{if(i.isCancellationRequested){this._logService.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(c,{index:a.index,part:a.part})});return r.provider.provideChatResponse(m.map(P.ChatMessage.to),o,n,i)}allowListExtensionWhile(C,c){this._chatAccessAllowList.set(C,c),c.finally(()=>this._chatAccessAllowList.delete(C))}async requestChatResponseProvider(C,c){if(!this._chatAccessAllowList.has(C))throw new Error("Extension is NOT allowed to make chat requests");const m=await this._proxy.$prepareChatAccess(c);if(!m)throw new Error(`ChatAccess '${c}' NOT found`);const o=this;return{get model(){return m.model},get isRevoked(){return!o._chatAccessAllowList.has(C)},makeRequest(i,r,n){if(!o._chatAccessAllowList.has(C))throw new Error("Access to chat has been revoked");const a=new I.CancellationTokenSource(n),t=Math.random()*1e6|0,d=o._proxy.$fetchResponse(C,c,t,i.map(P.ChatMessage.from),r??{},a.token),s=new D(d,a);return o._pendingRequest.set(t,{res:s}),d.finally(()=>{o._pendingRequest.delete(t)}),s.apiObject}}}async $handleResponseFragment(C,c){const m=this._pendingRequest.get(C);m&&m.res.handleFragment(c)}}e.ExtHostChatProvider=v}),define(ye[321],Ce([1,0,3,6,14,15]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class A{static{this._idPool=0}constructor(p){this._resolver=new Map,this._proxy=p.getProxy(F.MainContext.MainThreadChatVariables)}async $resolveVariable(p,y,R){const D=this._resolver.get(p);if(D)try{const v=await D.resolver.resolve(D.data.name,{prompt:y},R);if(v)return v.map(P.ChatVariable.from)}catch(v){(0,f.onUnexpectedExternalError)(v)}}registerVariableResolver(p,y,R,D){const v=A._idPool++;return this._resolver.set(v,{extension:p.identifier,data:{name:y,description:R},resolver:D}),this._proxy.$registerVariable(v,{name:y,description:R}),(0,I.toDisposable)(()=>{this._resolver.delete(v),this._proxy.$unregisterVariable(v)})}}e.ExtHostChatVariables=A}),define(ye[322],Ce([1,0,11,52,4,3,2,83,25,15,7,6,26]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(C,c,m){const o=C.getProxy(D.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new p.ExtensionIdentifierMap,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const w=this._commentControllers.get(u.handle);return w?w.value:u}else if(u&&u.$mid===7){const w=this._commentControllers.get(u.commentControlHandle);if(!w)return u;const k=w.getCommentThread(u.commentThreadHandle);return k?k.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const w=this._commentControllers.get(u.thread.commentControlHandle);if(!w)return u;const k=w.getCommentThread(u.thread.commentThreadHandle);return k?u.$mid===8?k.value:{thread:k.value,text:u.text}:u}else if(u&&u.$mid===10){const w=this._commentControllers.get(u.thread.commentControlHandle);if(!w)return u;const k=w.getCommentThread(u.thread.commentThreadHandle);if(!k)return u;const b=u.commentUniqueId,g=k.getCommentByUniqueId(b);return g||u}else if(u&&u.$mid===11){const w=this._commentControllers.get(u.thread.commentControlHandle);if(!w)return u;const k=w.getCommentThread(u.thread.commentThreadHandle);if(!k)return u;const b=u.text,g=u.commentUniqueId,_=k.getCommentByUniqueId(g);return _?(typeof _.body=="string"?_.body=b:_.body=new R.MarkdownString(b),_):u}return u}})}createCommentController(u,w,k){const b=i.handlePool++,g=new n(u,b,w,k);this._commentControllers.set(g.handle,g);const _=this._commentControllersByExtension.get(u.identifier)||[];return _.push(g),this._commentControllersByExtension.set(u.identifier,_),g.value}async $createCommentThreadTemplate(u,w,k){const b=this._commentControllers.get(u);b&&b.$createCommentThreadTemplate(w,k)}async $updateCommentThreadTemplate(u,w,k){const b=this._commentControllers.get(u);b&&b.$updateCommentThreadTemplate(w,k)}$deleteCommentThread(u,w){this._commentControllers.get(u)?.$deleteCommentThread(w)}$provideCommentingRanges(u,w,k){const b=this._commentControllers.get(u);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const g=m.getDocument(A.URI.revive(w));return(0,I.asPromise)(async()=>{const _=await b.commentingRangeProvider.provideCommentingRanges(g,k);let T;return Array.isArray(_)?T={ranges:_,fileComments:!1}:_?T={ranges:_.ranges||[],fileComments:_.fileComments||!1}:T=_??void 0,T}).then(_=>{let T;return _&&(T={ranges:_.ranges.map(O=>y.Range.from(O)),fileComments:_.fileComments}),T})}$toggleReaction(u,w,k,b,g){const _=this._commentControllers.get(u);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const T=_.getCommentThread(w);if(T){const O=T.getCommentByUniqueId(b.uniqueIdInThread);if(_!==void 0&&O&&_.reactionHandler)return _.reactionHandler(O,d(g))}return Promise.resolve(void 0)})}}class r{static{this._handlePool=0}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){(u===void 0!=(this._range===void 0)||!u||!this._range||!u.isEqual(this._range))&&(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(u){this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,w,k,b,g,_,T,O){this._commentControllerHandle=w,this._id=k,this._uri=b,this._range=g,this._comments=_,this.extensionDescription=T,this._isTemplate=O,this.handle=r._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new f.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),o.$createCommentThread(w,this.handle,this._id,this._uri,y.Range.from(this._range),T.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(w,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(N){x.range=N},get comments(){return x.comments},set comments(N){x.comments=N},get collapsibleState(){return x.collapsibleState},set collapsibleState(N){x.collapsibleState=N},get canReply(){return x.canReply},set canReply(N){x.canReply=N},get contextValue(){return x.contextValue},set contextValue(N){x.contextValue=N},get label(){return x.label},set label(N){x.label=N},get state(){return x.state},set state(N){x.state=N},dispose:()=>{x.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=k=>Object.prototype.hasOwnProperty.call(this.modifications,k),w={};u("range")&&(w.range=y.Range.from(this._range)),u("label")&&(w.label=this.label),u("contextValue")&&(w.contextValue=this.contextValue??null),u("comments")&&(w.comments=this._comments.map(k=>a(this,k,this._commentsMap,this.extensionDescription))),u("collapsibleState")&&(w.collapseState=s(this._collapseState)),u("canReply")&&(w.canReply=this.canReply),u("state")&&(w.state=h(this._state)),u("isTemplate")&&(w.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(u){for(const w of this._commentsMap){const k=w[0],b=w[1];if(u===b)return k}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}je([(0,F.debounce)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,w,k,b){this._extension=u,this._handle=w,this._id=k,this._label=b,this._threads=new Map,o.$registerCommentController(this.handle,k,b,this._extension.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(_){g.options=_},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(_){g.commentingRangeProvider=_},get reactionHandler(){return g.reactionHandler},set reactionHandler(_){g.reactionHandler=_},createCommentThread(_,T,O){return g.createCommentThread(_,T,O).value},dispose:()=>{g.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(u,w,k){w===void 0&&(0,v.checkProposedApiEnabled)(this._extension,"fileComments");const b=new r(this.id,this.handle,void 0,u,w,k,this._extension,!1);return this._threads.set(b.handle,b),b}$createCommentThreadTemplate(u,w){const k=new r(this.id,this.handle,void 0,A.URI.revive(u),y.Range.to(w),[],this._extension,!0);return k.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(k.handle,k),k}$updateCommentThreadTemplate(u,w){const k=this._threads.get(u);k&&(k.range=y.Range.to(w))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function a(l,u,w,k){let b=w.get(u);return b||(b=++l.commentHandle,w.set(u,b)),u.state!==void 0&&(0,v.checkProposedApiEnabled)(k,"commentsDraftState"),u.reactions?.some(g=>g.reactors!==void 0)&&(0,v.checkProposedApiEnabled)(k,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:b,body:typeof u.body=="string"?u.body:y.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(g=>t(g)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?y.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(u=>u.name):l.reactors}}function d(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(u=>({name:u}))}}function s(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}function h(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return E.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return E.CommentThreadState.Resolved}return E.CommentThreadState.Unresolved}return new i}e.createExtHostComments=S}),define(ye[323],Ce([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(d,s){this.document=d,this._storagePath=s,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,s){await this.getEdit(d).undo(),s||this.disposeBackup()}async redo(d,s){await this.getEdit(d).redo(),s||this.disposeBackup()}disposeEdits(d){for(const s of d)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=a(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const s=this._edits.get(d,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this._documents=new Map}get(d,s){return this._documents.get(this.key(d,s))}add(d,s,h){const l=this.key(d,s.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${d} resource:${s.uri}`);const u=new S(s,h);return this._documents.set(l,u),u}delete(d,s){const h=this.key(d,s.uri);this._documents.delete(h)}key(d,s){return`${d}@@@${s}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this._providers=new Map}addTextProvider(d,s,h){return this.add(0,d,s,h)}addCustomProvider(d,s,h){return this.add(1,d,s,h)}get(d){return this._providers.get(d)}add(d,s,h,l){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:d,extension:h,provider:l}),new v.Disposable(()=>this._providers.delete(s))}}class o{constructor(d,s,h,l,u){this._extHostDocuments=s,this._extensionStoragePaths=h,this._extHostWebview=l,this._extHostWebviewPanels=u,this._editorProviders=new m,this._documents=new C,this._proxy=d.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,s,h,l){const u=new f.DisposableStore;return r(h)?(u.add(this._editorProviders.addTextProvider(s,d,h)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(d),s,l.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(d))):(u.add(this._editorProviders.addCustomProvider(s,d,h)),i(h)&&u.add(h.onDidChangeCustomDocument(w=>{const k=this.getCustomDocumentEntry(s,w.document.uri);if(n(w)){const b=k.addEdit(w);this._proxy.$onDidEdit(w.document.uri,s,b,w.label)}else this._proxy.$onContentChange(w.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(d),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(d))),v.Disposable.from(u,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(d,s,h,l,u){const w=this._editorProviders.get(s);if(!w)throw new Error(`No provider found for '${s}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${s}'`);const k=E.URI.revive(d),b=await w.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:l?.buffer},u);let g;return i(w.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(w.extension)??this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(s,b,g),{editable:i(w.provider)}}async $disposeCustomDocument(d,s){const h=this._editorProviders.get(s);if(!h)throw new Error(`No provider found for '${s}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=E.URI.revive(d),{document:u}=this.getCustomDocumentEntry(s,l);this._documents.delete(s,u),u.dispose()}async $resolveCustomEditor(d,s,h,l,u,w){const k=this._editorProviders.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const b=p.ViewColumn.to(u),g=this._extHostWebview.createNewWebview(s,l.contentOptions,k.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(s,h,l.title,b,l.options,g,l.active),T=E.URI.revive(d);switch(k.type){case 1:{const{document:O}=this.getCustomDocumentEntry(h,T);return k.provider.resolveCustomEditor(O,_,w)}case 0:{const O=this._extHostDocuments.getDocument(T);return k.provider.resolveCustomTextEditor(O,_,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,s,h){this.getCustomDocumentEntry(s,d).disposeEdits(h)}async $onMoveCustomEditor(d,s,h){const l=this._editorProviders.get(h);if(!l)throw new Error(`No provider found for '${h}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const u=this._extHostWebviewPanels.getWebviewPanel(d);if(!u)throw new Error("No webview found");const w=E.URI.revive(s),k=this._extHostDocuments.getDocument(w);await l.provider.moveCustomTextEditor(k,u,I.CancellationToken.None)}async $undo(d,s,h,l){return this.getCustomDocumentEntry(s,d).undo(h,l)}async $redo(d,s,h,l){return this.getCustomDocumentEntry(s,d).redo(h,l)}async $revert(d,s,h){const l=this.getCustomDocumentEntry(s,d);await this.getCustomEditorProvider(s).revertCustomDocument(l.document,h),l.disposeBackup()}async $onSave(d,s,h){const l=this.getCustomDocumentEntry(s,d);await this.getCustomEditorProvider(s).saveCustomDocument(l.document,h),l.disposeBackup()}async $onSaveAs(d,s,h,l){const u=this.getCustomDocumentEntry(s,d);return this.getCustomEditorProvider(s).saveCustomDocumentAs(u.document,E.URI.revive(h),l)}async $backup(d,s,h){const l=this.getCustomDocumentEntry(s,d),w=await this.getCustomEditorProvider(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},h);return l.updateBackup(w),w.id}getCustomDocumentEntry(d,s){const h=this._documents.get(d,E.URI.revive(s));if(!h)throw new Error("No custom document found");return h}getCustomEditorProvider(d){const h=this._editorProviders.get(d)?.provider;if(!h||!i(h))throw new Error("Custom document is not editable");return h}}e.ExtHostCustomEditors=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const d=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,F.hash)(d)+""}}),define(ye[324],Ce([1,0,211,135,2,6,7,15,4,13,28,59]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class S{#e;#t;#i;constructor(m,o,i,r,n,a,t,d){this._name=m,this._owner=o,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=r,this._modelVersionIdProvider=n,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(r,i),this.#i=new R.ResourceMap(s=>a.getComparisonKey(s)),this.#e=t,this.#t=d}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,o){if(!m){this.clear();return}this._checkDisposed();let i=[];if(f.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),i=[m]}else if(Array.isArray(m)){i=[];let a;m=[...m].sort(S._compareIndexedTuplesByUri);for(const t of m){const[d,s]=t;if((!a||d.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=d,i.push(d),this.#i.set(d,[])),s)this.#i.get(d)?.push(...s);else{const h=this.#i.get(d);h&&(h.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const a of i){let t=[];const d=this.#i.get(a);if(d)if(d.length>this._maxDiagnosticsPerFile){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const l of d)if(l.severity===s[h]&&t.push({...E.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(a)})===this._maxDiagnosticsPerFile)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(s=>({...E.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(a)}));if(r.push([a,t]),n+=t.length,n>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,r)}delete(m){this._checkDisposed(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(m,o){this._checkDisposed();for(const[i,r]of this)m.call(o,i,r,this)}*[Symbol.iterator](){this._checkDisposed();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this.#i.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=S;let C=class{static{v=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*v._maxDiagnosticsPerFile}static _mapper(m){const o=new R.ResourceMap;for(const i of m)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,i,r){this._logService=o,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=r,this._collections=new Map,this._onDidChangeDiagnostics=new p.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this._onDidChangeDiagnostics.event,v._mapper),this._proxy=m.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{_collections:i,_proxy:r,_onDidChangeDiagnostics:n,_logService:a,_fileSystemInfoService:t,_extHostDocumentsAndEditors:d}=this,s=new class{$changeMany(u,w){r.$changeMany(u,w),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,u,w.length===0?"CLEARING":w)}$clear(u){r.$clear(u),a.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,u)}dispose(){r.dispose()}};let h;if(!o)o="_generated_diagnostic_collection_name_#"+v._idPool++,h=o;else if(!i.has(o))h=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do h=o+v._idPool++;while(i.has(h))}return new class extends S{constructor(){super(o,h,v._maxDiagnosticsTotal,v._maxDiagnosticsPerFile,u=>d.getDocument(u)?.version,t.extUri,s,n),i.set(h,this)}dispose(){super.dispose(),i.delete(h)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const o=new Map,i=[];for(const r of this._collections.values())r.forEach((n,a)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...a)});return i}}_getDiagnostics(m){let o=[];for(const i of this._collections.values())i.has(m)&&(o=o.concat(i.get(m)));return o}$acceptMarkersChange(m){if(!this._mirrorCollection){const o="_generated_mirror",i=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,i),this._mirrorCollection=i}for(const[o,i]of m)this._mirrorCollection.set(f.URI.revive(o),i.map(E.Diagnostic.to))}};e.ExtHostDiagnostics=C,e.ExtHostDiagnostics=C=v=je([$e(1,y.ILogService),$e(2,D.IExtHostFileSystemInfo)],C)}),define(ye[325],Ce([1,0,2,14,7,15,75]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class E{constructor(y,R,D,v={timeout:1500,errors:3}){this._logService=y,this._documents=R,this._mainThreadBulkEdits=D,this._thresholds=v,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(R,D,v)=>{const C={dispose:this._callbacks.push([R,D,y])};return Array.isArray(v)&&v.push(C),C}}async $participateInSave(y,R){const D=I.URI.revive(y);let v=!1;const S=setTimeout(()=>v=!0,this._thresholds.timeout),C=[];try{for(const c of[...this._callbacks]){if(v)break;const m=this._documents.getDocument(D),o=await this._deliverEventAsyncAndBlameBadListeners(c,{document:m,reason:P.TextDocumentSaveReason.to(R)});C.push(o)}}finally{clearTimeout(S)}return C}_deliverEventAsyncAndBlameBadListeners([y,R,D],v){const S=this._badListeners.get(y);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,y,R,v).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const c=this._badListeners.get(y);this._badListeners.set(y,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,R,D,v){const S=[],C=Date.now(),{document:c,reason:m}=v,{version:o}=c,i=Object.freeze({document:c,reason:m,waitUntil(r){if(Object.isFrozen(S))throw(0,F.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(r))}});try{R.apply(D,[i])}catch(r){return Promise.reject(r)}return Object.freeze(S),new Promise((r,n)=>{const a=setTimeout(()=>n(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(a),r(t)}).catch(t=>{clearTimeout(a),n(t)})}).then(r=>{const n={edits:[]};for(const a of r)if(Array.isArray(a)&&a.every(t=>t instanceof f.TextEdit))for(const{newText:t,newEol:d,range:s}of a)n.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:t,eol:d&&P.EndOfLine.from(d)}});if(n.edits.length!==0)return o===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=E}),define(ye[326],Ce([1,0,4,3,2,6,148,15,18,24,7]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(S,C){this._onDidAddDocument=new I.Emitter,this._onDidRemoveDocument=new I.Emitter,this._onDidChangeDocument=new I.Emitter,this._onDidSaveDocument=new I.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=C,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const m of c)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const m of c)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(S){if(!S)return;const C=this._documentsAndEditors.getDocument(S);if(C)return C}getDocument(S){const C=this.getDocumentData(S);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return C.document}ensureDocumentData(S){const C=this._documentsAndEditors.getDocument(S);if(C)return Promise.resolve(C);let c=this._documentLoader.get(S.toString());return c||(c=this._proxy.$tryOpenDocument(S).then(m=>{this._documentLoader.delete(S.toString());const o=f.URI.revive(m);return(0,p.assertIsDefined)(this._documentsAndEditors.getDocument(o))},m=>(this._documentLoader.delete(S.toString()),Promise.reject(m))),this._documentLoader.set(S.toString(),c)),c}createDocumentData(S){return this._proxy.$tryCreateDocument(S).then(C=>f.URI.revive(C))}$acceptModelLanguageChanged(S,C){const c=f.URI.revive(S),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(C),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(S){const C=f.URI.revive(S),c=this._documentsAndEditors.getDocument(C);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(S,C){const c=f.URI.revive(S),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(C),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,C,c){const m=f.URI.revive(S),o=this._documentsAndEditors.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(c),o.onEvents(C);let i;C.isUndoing?i=R.TextDocumentChangeReason.Undo:C.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:o.document,contentChanges:C.changes.map(r=>({range:E.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(S,C){(0,A.setWordDefinitionFor)(S,C)}}e.ExtHostDocuments=D}),define(ye[71],Ce([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class D{constructor(m,o,i){this._activeTabIdGetter=i,this._parentGroup=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this._apiObject){const m=this,o={get isActive(){return m._dto.id===m._activeTabIdGetter()},get label(){return m._dto.label},get input(){return m._input},get isDirty(){return m._dto.isDirty},get isPinned(){return m._dto.isPinned},get isPreview(){return m._dto.isPreview},get group(){return m._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(m){this._dto=m,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new R.TextTabInput(P.URI.revive(this._dto.input.uri));case 2:return new R.TextDiffTabInput(P.URI.revive(this._dto.input.original),P.URI.revive(this._dto.input.modified));case 3:return new R.TextMergeTabInput(P.URI.revive(this._dto.input.base),P.URI.revive(this._dto.input.input1),P.URI.revive(this._dto.input.input2),P.URI.revive(this._dto.input.result));case 6:return new R.CustomEditorTabInput(P.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new R.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new R.NotebookEditorTabInput(P.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(P.URI.revive(this._dto.input.original),P.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(P.URI.revive(this._dto.input.uri),P.URI.revive(this._dto.input.inputBoxUri));case 10:return new R.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class v{constructor(m,o){this._tabs=[],this._activeTabId="",this._dto=m,this._activeGroupIdGetter=o;for(const i of m.tabs)i.isActive&&(this._activeTabId=i.id),this._tabs.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const m=this,o={get isActive(){return m._dto.groupId===m._activeGroupIdGetter()},get viewColumn(){return y.ViewColumn.to(m._dto.viewColumn)},get activeTab(){return m._tabs.find(i=>i.tabId===m._activeTabId)?.apiObject},get tabs(){return Object.freeze(m._tabs.map(i=>i.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(m){this._dto=m}acceptTabOperation(m){if(m.kind===0){const i=new D(m.tabDto,this,()=>this.activeTabId());return this._tabs.splice(m.index,0,i),m.tabDto.isActive&&(this._activeTabId=i.tabId),i}else if(m.kind===1){const i=this._tabs.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this._activeTabId&&(this._activeTabId=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this._tabs.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this._tabs.splice(m.index,0,i),i}const o=this._tabs.find(i=>i.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this._activeTabId=m.tabDto.id:this._activeTabId===m.tabDto.id&&!m.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this._activeTabId}}let S=class{constructor(m){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=m.getProxy(E.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const m=this,o={onDidChangeTabGroups:m._onDidChangeTabGroups.event,onDidChangeTabs:m._onDidChangeTabs.event,get all(){return Object.freeze(m._extHostTabGroups.map(i=>i.apiObject))},get activeTabGroup(){const i=m._activeGroupId;return(0,f.assertIsDefined)(m._extHostTabGroups.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?C(n[0])?this._closeGroups(n,r):this._closeTabs(n,r):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(m){const o=new Set(this._extHostTabGroups.map(s=>s.groupId)),i=new Set(m.map(s=>s.groupId)),r=(0,I.diffSets)(o,i),n=this._extHostTabGroups.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this._extHostTabGroups=m.map(s=>{const h=new v(s,()=>this._activeGroupId);return r.added.includes(h.groupId)?a.push(h.apiObject):t.push(h.apiObject),h});const d=(0,f.assertIsDefined)(m.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:a,closed:n,changed:t}))}$acceptTabGroupUpdate(m){const o=this._extHostTabGroups.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this._activeGroupId=m.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this._extHostTabGroups.find(r=>r.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(m);switch(m.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}_findExtHostTabFromApi(m){for(const o of this._extHostTabGroups)for(const i of o.tabs)if(i.apiObject===m)return i}_findExtHostTabGroupFromApi(m){return this._extHostTabGroups.find(o=>o.apiObject===m)}async _closeTabs(m,o){const i=[];for(const r of m){const n=this._findExtHostTabFromApi(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this._proxy.$closeTab(i,o)}async _closeGroups(m,o){const i=[];for(const r of m){const n=this._findExtHostTabGroupFromApi(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this._proxy.$closeGroup(i,o)}};e.ExtHostEditorTabs=S,e.ExtHostEditorTabs=S=je([$e(0,p.IExtHostRpcService)],S);function C(c){return c.tabs!==void 0}}),define(ye[327],Ce([1,0,2,6,3,7,15,173,12,22,26,80]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(c){this._stateMachine=void 0,this._schemes.push(c)}delete(c){const m=this._schemes.indexOf(c);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const c=this._schemes.sort(),m=[];let o,i,r=14,n=14;for(const a of c){let t=o?(0,p.commonPrefixLength)(o,a):0;for(t===0?i=1:i=n;t<a.length;t++)t+1===a.length?(r=n,n=9):n+=1,m.push([i,a.toUpperCase().charCodeAt(t),n]),m.push([i,a.toLowerCase().charCodeAt(t),n]),i=n;o=a,n=r}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new E.StateMachine(m)}}provideDocumentLinks(c){this._initStateMachine();const m=[],o=E.LinkComputer.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this._stateMachine);for(const i of o){const r=A.DocumentLink.to(i);r.target&&m.push(r)}return m}}class S{constructor(c,m){this._extHostLanguageFeatures=m,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=c.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(c,m,o,i={}){if(S._validateFileSystemProvider(o),this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(c,"*",this._linkProvider));const r=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.checkProposedApiEnabled)(c,"fsChunks"),n+=4);let a;i.isReadonly&&(0,D.isMarkdownString)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this._proxy.$registerFileSystemProvider(r,m,n,a).catch(d=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(d)});const t=o.onDidChangeFile(d=>{const s=[];for(const h of d){const{uri:l,type:u}=h;if(l.scheme!==m)continue;let w;switch(u){case P.FileChangeType.Changed:w=0;break;case P.FileChangeType.Created:w=1;break;case P.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:w})}this._proxy.$onFileSystemChange(r,s)});return(0,f.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(r),this._proxy.$unregisterProvider(r)})}static _validateFileSystemProvider(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(c){const{type:m,ctime:o,mtime:i,size:r,permissions:n}=c;return{type:m,ctime:o,mtime:i,size:r,permissions:n}}$stat(c,m){return Promise.resolve(this._getFsProvider(c).stat(I.URI.revive(m))).then(o=>S._asIStat(o))}$readdir(c,m){return Promise.resolve(this._getFsProvider(c).readDirectory(I.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this._getFsProvider(c).readFile(I.URI.revive(m))).then(o=>y.VSBuffer.wrap(o))}$writeFile(c,m,o,i){return Promise.resolve(this._getFsProvider(c).writeFile(I.URI.revive(m),o.buffer,i))}$delete(c,m,o){return Promise.resolve(this._getFsProvider(c).delete(I.URI.revive(m),o))}$rename(c,m,o,i){return Promise.resolve(this._getFsProvider(c).rename(I.URI.revive(m),I.URI.revive(o),i))}$copy(c,m,o,i){const r=this._getFsProvider(c);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(I.URI.revive(m),I.URI.revive(o),i))}$mkdir(c,m){return Promise.resolve(this._getFsProvider(c).createDirectory(I.URI.revive(m)))}$watch(c,m,o,i){const r=this._getFsProvider(c).watch(I.URI.revive(o),i);this._watches.set(m,r)}$unwatch(c,m){const o=this._watches.get(m);o&&(o.dispose(),this._watches.delete(m))}$open(c,m,o){const i=this._getFsProvider(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(m),o))}$close(c,m){const o=this._getFsProvider(c);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(c,m,o,i){const r=this._getFsProvider(c);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.VSBuffer.alloc(i);return Promise.resolve(r.read(m,o,n.buffer,0,i)).then(a=>n.slice(0,a))}$write(c,m,o,i){const r=this._getFsProvider(c);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(m,o,i.buffer,0,i.byteLength))}_getFsProvider(c){const m=this._fsProvider.get(c);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.ExtHostFileSystem=S}),define(ye[328],Ce([1,0,4,35,2,6,15,7,43]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(S,C,c,m,o,i){this.session=Math.random(),this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const r=(0,F.parse)(o),n=typeof o=="string",a=i?.correlate,t=m(d=>{if(!(typeof d.session=="number"&&d.session!==this.session)&&!(a&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const s of d.created){const h=f.URI.revive(s);r(h.fsPath)&&(!n||C.getWorkspaceFolder(h))&&this._onDidCreate.fire(h)}if(!i?.ignoreChangeEvents)for(const s of d.changed){const h=f.URI.revive(s);r(h.fsPath)&&(!n||C.getWorkspaceFolder(h))&&this._onDidChange.fire(h)}if(!i?.ignoreDeleteEvents)for(const s of d.deleted){const h=f.URI.revive(s);r(h.fsPath)&&(!n||C.getWorkspaceFolder(h))&&this._onDidDelete.fire(h)}}});this._disposable=E.Disposable.from(this.ensureWatching(S,c,o,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(S,C,c,m,o){const i=E.Disposable.from();if(typeof c=="string")return i;const r=S.getProxy(P.MainContext.MainThreadFileSystemEventService);let n=!1;return(c.pattern.includes(F.GLOBSTAR)||c.pattern.includes(F.GLOB_SPLIT))&&(n=!0),r.$watch(C.identifier.value,this.session,c.baseUri,{recursive:n,excludes:m?.excludes??[]},!!o),E.Disposable.from({dispose:()=>r.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(S){this._events=S,this.session=this._events.session,this._created=new p.Lazy(()=>this._events.created.map(f.URI.revive)),this._changed=new p.Lazy(()=>this._events.changed.map(f.URI.revive)),this._deleted=new p.Lazy(()=>this._events.deleted.map(f.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class D{constructor(S,C,c){this._mainContext=S,this._logService=C,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,C,c,m){return new y(this._mainContext,S,C,this._onFileSystemEvent.event,A.GlobPattern.from(c),m)}$onFileEvent(S){this._onFileSystemEvent.fire(new R(S))}$onDidRunFileOperation(S,C){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(c=>({oldUri:f.URI.revive(c.source),newUri:f.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(c=>f.URI.revive(c.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:C.map(c=>f.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,C){return(c,m,o)=>{const i=function(n){c.call(m,n)};return i.extension=S,C.event(i,void 0,o)}}async $onWillRunFileOperation(S,C,c,m){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},c,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(o=>f.URI.revive(o.target))},c,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(o=>f.URI.revive(o.target))},c,m)}}async _fireWillEvent(S,C,c,m){const o=new Set,i=[];if(await S.fireAsync(C,m,async(n,a)=>{const t=Date.now(),d=await Promise.resolve(n);d instanceof E.WorkspaceEdit&&(i.push([a.extension,d]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>c&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:a}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(a)}return{edit:r,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=D}),define(ye[329],Ce([1,0,2,24,15,7,83,6,12,29,19,18,169,21,25,3,131,121,110,38,14,11,26,213]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(z,X){this._documents=z,this._provider=X}async provideDocumentSymbols(z,X){const te=this._documents.getDocument(z),H=await this._provider.provideDocumentSymbols(te,X);if(!(0,R.isFalsyOrEmpty)(H))return H[0]instanceof P.DocumentSymbol?H.map(f.DocumentSymbol.from):s._asDocumentSymbolTree(H)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((H,ae)=>{let de=H.location.range.start.compareTo(ae.location.range.start);return de===0&&(de=ae.location.range.end.compareTo(H.location.range.end)),de});const X=[],te=[];for(const H of z){const ae={name:H.name||"!!MISSING: name!!",kind:f.SymbolKind.from(H.kind),tags:H.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:f.Range.from(H.location.range),selectionRange:f.Range.from(H.location.range),children:[]};for(;;){if(te.length===0){te.push(ae),X.push(ae);break}const de=te[te.length-1];if(y.Range.containsRange(de.range,ae.range)&&!y.Range.equalsRange(de.range,ae.range)){de.children?.push(ae),te.push(ae);break}te.pop()}}return X}}class h{constructor(z,X,te,H,ae,de){this._documents=z,this._commands=X,this._provider=te,this._extension=H,this._extTelemetry=ae,this._logService=de,this._cache=new i.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,X){const te=this._documents.getDocument(z),H=await this._provider.provideCodeLenses(te,X);if(!H||X.isCancellationRequested)return;const ae=this._cache.add(H),de=new c.DisposableStore;this._disposables.set(ae,de);const Re={cacheId:ae,lenses:[]};for(let Ue=0;Ue<H.length;Ue++)Re.lenses.push({cacheId:[ae,Ue],range:f.Range.from(H[Ue].range),command:this._commands.toInternal(H[Ue].command,de)});return Re}async resolveCodeLens(z,X){const te=z.cacheId&&this._cache.get(...z.cacheId);if(!te)return;let H;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?H=te:H=await this._provider.resolveCodeLens(te,X),H||(H=te),X.isCancellationRequested)return;const ae=z.cacheId&&this._disposables.get(z.cacheId[0]);if(ae){if(!H.command){const de=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,de),this._logService.error(de);return}return z.command=this._commands.toInternal(H.command,ae),z}}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}function l(ke){return Array.isArray(ke)?ke.map(f.DefinitionLink.from):ke?[f.DefinitionLink.from(ke)]:[]}class u{constructor(z,X){this._documents=z,this._provider=X}async provideDefinition(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideDefinition(H,ae,te);return l(de)}}class w{constructor(z,X){this._documents=z,this._provider=X}async provideDeclaration(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideDeclaration(H,ae,te);return l(de)}}class k{constructor(z,X){this._documents=z,this._provider=X}async provideImplementation(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideImplementation(H,ae,te);return l(de)}}class b{constructor(z,X){this._documents=z,this._provider=X}async provideTypeDefinition(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideTypeDefinition(H,ae,te);return l(de)}}class g{constructor(z,X){this._documents=z,this._provider=X}async provideHover(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideHover(H,ae,te);if(!(!de||(0,R.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=H.getWordRangeAtPosition(ae)),de.range||(de.range=new P.Range(ae,ae)),f.Hover.from(de)}}class _{constructor(z,X){this._documents=z,this._provider=X}async provideEvaluatableExpression(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideEvaluatableExpression(H,ae,te);if(de)return f.EvaluatableExpression.from(de)}}class T{constructor(z,X){this._documents=z,this._provider=X}async provideInlineValues(z,X,te,H){const ae=this._documents.getDocument(z),de=await this._provider.provideInlineValues(ae,f.Range.to(X),f.InlineValueContext.to(te),H);if(Array.isArray(de))return de.map(Re=>f.InlineValue.from(Re))}}class O{constructor(z,X){this._documents=z,this._provider=X}async provideDocumentHighlights(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideDocumentHighlights(H,ae,te);if(Array.isArray(de))return de.map(f.DocumentHighlight.from)}}class x{constructor(z,X){this._documents=z,this._provider=X}async provideMultiDocumentHighlights(z,X,te,H){const ae=this._documents.getDocument(z),de=te.map(Ve=>this._documents.getDocument(Ve)),Re=f.Position.to(X),Ue=await this._provider.provideMultiDocumentHighlights(ae,Re,de,H);if(Array.isArray(Ue))return Ue.map(f.MultiDocumentHighlight.from)}}class N{constructor(z,X){this._documents=z,this._provider=X}async provideLinkedEditingRanges(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.provideLinkedEditingRanges(H,ae,te);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.coalesce)(de.ranges.map(f.Range.from)),wordPattern:de.wordPattern}}}class M{constructor(z,X){this._documents=z,this._provider=X}async provideReferences(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Position.to(X),Re=await this._provider.provideReferences(ae,de,te,H);if(Array.isArray(Re))return Re.map(f.location.from)}}class L{static{this._maxCodeActionsPerFile=1e3}constructor(z,X,te,H,ae,de,Re){this._documents=z,this._commands=X,this._diagnostics=te,this._provider=H,this._logService=ae,this._extension=de,this._apiDeprecation=Re,this._cache=new i.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,X,te,H){const ae=this._documents.getDocument(z),de=v.Selection.isISelection(X)?f.Selection.to(X):f.Range.to(X),Re=[];for(const st of this._diagnostics.getDiagnostics(z))if(de.intersection(st.range)&&Re.push(st)>L._maxCodeActionsPerFile)break;const Ue={diagnostics:Re,only:te.only?new P.CodeActionKind(te.only):void 0,triggerKind:f.CodeActionTriggerKind.to(te.trigger)},Ve=await this._provider.provideCodeActions(ae,de,Ue,H);if(!(0,R.isNonEmptyArray)(Ve)||H.isCancellationRequested)return;const Ke=this._cache.add(Ve),Ze=new c.DisposableStore;this._disposables.set(Ke,Ze);const at=[];for(let st=0;st<Ve.length;st++){const rt=Ve[st];if(rt)if(L._isCommand(rt))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,Ze)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Pe=rt.ranges??[];at.push({cacheId:[Ke,st],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,Ze),diagnostics:rt.diagnostics&&rt.diagnostics.map(f.Diagnostic.from),edit:rt.edit&&f.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?rt.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,R.coalesce)(Pe.map(f.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Ke,actions:at}}async resolveCodeAction(z,X){const[te,H]=z,ae=this._cache.get(te,H);if(!ae||L._isCommand(ae))return{};if(!this._provider.resolveCodeAction)return{};const de=await this._provider.resolveCodeAction(ae,X)??ae;let Re;de.edit&&(Re=f.WorkspaceEdit.from(de.edit,void 0));let Ue;if(de.command){const Ve=this._disposables.get(te);Ve&&(Ue=this._commands.toInternal(de.command,Ve))}return{edit:Re,command:Ue}}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}class U{static toInternalProviderId(z,X){return z+"."+X}constructor(z,X,te,H,ae){this._proxy=z,this._documents=X,this._provider=te,this._handle=H,this._extension=ae}async prepareDocumentPaste(z,X,te,H){if(!this._provider.prepareDocumentPaste)return;const ae=this._documents.getDocument(z),de=X.map(Ve=>f.Range.to(Ve)),Re=f.DataTransfer.toDataTransfer(te,()=>{throw new n.NotImplementedError});if(await this._provider.prepareDocumentPaste(ae,de,Re,H),H.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ve])=>!(Ve instanceof P.InternalDataTransferItem));return f.DataTransfer.from(Ue)}async providePasteEdits(z,X,te,H,ae){if(!this._provider.provideDocumentPasteEdits)return;const de=this._documents.getDocument(X),Re=te.map(Ke=>f.Range.to(Ke)),Ue=f.DataTransfer.toDataTransfer(H,async Ke=>(await this._proxy.$resolvePasteFileData(this._handle,z,Ke)).buffer),Ve=await this._provider.provideDocumentPasteEdits(de,Re,Ue,ae);if(Ve)return{label:Ve.label??(0,d.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:U.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?f.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class B{constructor(z,X){this._documents=z,this._provider=X}async provideDocumentFormattingEdits(z,X,te){const H=this._documents.getDocument(z),ae=await this._provider.provideDocumentFormattingEdits(H,X,te);if(Array.isArray(ae))return ae.map(f.TextEdit.from)}}class G{constructor(z,X){this._documents=z,this._provider=X}async provideDocumentRangeFormattingEdits(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Range.to(X),Re=await this._provider.provideDocumentRangeFormattingEdits(ae,de,te,H);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,X,te,H){(0,D.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this._documents.getDocument(z),de=X.map(f.Range.to),Re=await this._provider.provideDocumentRangesFormattingEdits(ae,de,te,H);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}}class le{constructor(z,X){this._documents=z,this._provider=X,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,X,te,H,ae){const de=this._documents.getDocument(z),Re=f.Position.to(X),Ue=await this._provider.provideOnTypeFormattingEdits(de,Re,te,H,ae);if(Array.isArray(Ue))return Ue.map(f.TextEdit.from)}}class Y{constructor(z,X){this._provider=z,this._logService=X,this._cache=new i.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,X){const te=await this._provider.provideWorkspaceSymbols(z,X);if(!(0,R.isNonEmptyArray)(te))return{symbols:[]};const H=this._cache.add(te),ae={cacheId:H,symbols:[]};for(let de=0;de<te.length;de++){const Re=te[de];if(!Re||!Re.name){this._logService.warn("INVALID SymbolInformation",Re);continue}ae.symbols.push({...f.WorkspaceSymbol.from(Re),cacheId:[H,de]})}return ae}async resolveWorkspaceSymbol(z,X){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const te=this._cache.get(...z.cacheId);if(te){const H=await this._provider.resolveWorkspaceSymbol(te,X);return H&&(0,F.mixin)(z,f.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class K{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,X,te){this._documents=z,this._provider=X,this._logService=te}async provideRenameEdits(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Position.to(X);try{const Re=await this._provider.provideRenameEdits(ae,de,te,H);return Re?f.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=K._asMessage(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(z,X,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const H=this._documents.getDocument(z),ae=f.Position.to(X);try{const de=await this._provider.prepareRename(H,ae,te);let Re,Ue;if(P.Range.isRange(de)?(Re=de,Ue=H.getText(de)):(0,D.isObject)(de)&&(Re=de.range,Ue=de.placeholder),!Re||!Ue)return;if(Re.start.line>ae.line||Re.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Re),text:Ue}}catch(de){const Re=K._asMessage(de);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class Q{constructor(z,X){this.resultId=z,this.tokens=X}}class ue{constructor(z,X){this._documents=z,this._provider=X,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,X,te){const H=this._documents.getDocument(z),ae=X!==0?this._previousResults.get(X):null;let de=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(H,ae.resultId,te):await this._provider.provideDocumentSemanticTokens(H,te);return ae&&this._previousResults.delete(X),de?(de=ue._fixProvidedSemanticTokens(de),this._send(ue._convertToEdits(ae,de),de)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return ue._isSemanticTokens(z)?ue._isCorrectSemanticTokens(z)?z:new P.SemanticTokens(new Uint32Array(z.data),z.resultId):ue._isSemanticTokensEdits(z)?ue._isCorrectSemanticTokensEdits(z)?z:new P.SemanticTokensEdits(z.edits.map(X=>new P.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const X of z.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,X){if(!ue._isSemanticTokens(X)||!z||!z.tokens)return X;const te=z.tokens,H=te.length,ae=X.data,de=ae.length;let Re=0;const Ue=Math.min(H,de);for(;Re<Ue&&te[Re]===ae[Re];)Re++;if(Re===H&&Re===de)return new P.SemanticTokensEdits([],X.resultId);let Ve=0;const Ke=Ue-Re;for(;Ve<Ke&&te[H-Ve-1]===ae[de-Ve-1];)Ve++;return new P.SemanticTokensEdits([{start:Re,deleteCount:H-Re-Ve,data:ae.subarray(Re,de-Ve)}],X.resultId)}_send(z,X){if(ue._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new Q(z.resultId,z.data)),(0,m.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(ue._isSemanticTokensEdits(z)){const te=this._nextResultId++;return ue._isSemanticTokens(X)?this._previousResults.set(te,new Q(X.resultId,X.data)):this._previousResults.set(te,new Q(z.resultId)),(0,m.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ne{constructor(z,X){this._documents=z,this._provider=X}async provideDocumentRangeSemanticTokens(z,X,te){const H=this._documents.getDocument(z),ae=await this._provider.provideDocumentRangeSemanticTokens(H,f.Range.to(X),te);return ae?this._send(ae):null}_send(z){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}class pe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,X,te,H,ae){this._documents=z,this._commands=X,this._provider=te,this._apiDeprecation=H,this._extension=ae,this._cache=new i.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Position.to(X),Re=ae.getWordRangeAtPosition(de)||new P.Range(de,de),Ue=Re.with({end:de}),Ve=new r.StopWatch,Ke=await this._provider.provideCompletionItems(ae,de,H,f.CompletionContext.to(te));if(!Ke||H.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new P.CompletionList(Ke):Ke,at=pe.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),st=new c.DisposableStore;this._disposables.set(at,st);const rt=[],Pe={x:at,b:rt,a:{replace:f.Range.from(Re),insert:f.Range.from(Ue)},c:Ze.isIncomplete||void 0,d:Ve.elapsed()};for(let xe=0;xe<Ze.items.length;xe++){const Te=Ze.items[xe],Xe=this._convertCompletionItem(Te,[at,xe],Ue,Re);rt.push(Xe)}return Pe}async resolveCompletionItem(z,X){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...z);if(!te)return;const H=this._convertCompletionItem(te,z),ae=await this._provider.resolveCompletionItem(te,X);if(!ae)return;const de=this._convertCompletionItem(ae,z);return(H.h!==de.h||H.i!==de.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==de.n||H.o!==de.o||!(0,F.equals)(H.p,de.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,X,te,H){const ae=this._disposables.get(X[0]);if(!ae)throw Error("DisposableStore is missing...");const de=this._commands.toInternal(z.command,ae),Re={x:X,a:z.label,b:z.kind!==void 0?f.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(f.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:f.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(f.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=z.textEdit.newText):typeof z.insertText=="string"?Re.h=z.insertText:z.insertText instanceof P.SnippetString&&(Re.h=z.insertText.value,Re.i|=4);let Ue;return z.textEdit?Ue=z.textEdit.range:z.range&&(Ue=z.range),P.Range.isRange(Ue)?Re.j=f.Range.from(Ue):Ue&&(!te?.isEqual(Ue.inserting)||!H?.isEqual(Ue.replacing))&&(Re.j={insert:f.Range.from(Ue.inserting),replace:f.Range.from(Ue.replacing)}),Re}}class oe{async provideInlineCompletions(z,X,te,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,X,te){}handlePartialAccept(z,X,te){}}class q extends oe{constructor(z,X,te,H){super(),this._extension=z,this._documents=X,this._provider=te,this._commands=H,this._references=new W,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Position.to(X),Re=await this._provider.provideInlineCompletionItems(ae,de,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:f.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[te.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ve=this._isAdditionsProposedApiEnabled?Array.isArray(Re)?[]:Re.commands||[]:[],Ke=this._isAdditionsProposedApiEnabled&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let Ze;return{pid:this._references.createReferenceId({dispose(){Ze?.dispose()},items:Ue}),items:Ue.map((st,rt)=>{let Pe;st.command&&(Ze||(Ze=new c.DisposableStore),Pe=this._commands.toInternal(st.command,Ze));const xe=st.insertText;return{insertText:typeof xe=="string"?xe:{snippet:xe.value},filterText:st.filterText,range:st.range?f.Range.from(st.range):void 0,command:Pe,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?st.completeBracketPairs:!1}}),commands:Ve.map(st=>(Ze||(Ze=new c.DisposableStore),this._commands.toInternal(st,Ze))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(z){this._references.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,X,te){const H=this._references.get(z)?.items[X];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H,te)}handlePartialAccept(z,X,te){const H=this._references.get(z)?.items[X];H&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(H,te)}}class W{constructor(){this._references=new Map,this._idPool=1}createReferenceId(z){const X=this._idPool++;return this._references.set(X,z),X}disposeReferenceId(z){const X=this._references.get(z);return this._references.delete(z),X}get(z){return this._references.get(z)}}class ie{constructor(z,X){this._documents=z,this._provider=X,this._cache=new i.Cache("SignatureHelp")}async provideSignatureHelp(z,X,te,H){const ae=this._documents.getDocument(z),de=f.Position.to(X),Re=this.reviveContext(te),Ue=await this._provider.provideSignatureHelp(ae,de,H,Re);if(Ue){const Ve=this._cache.add([Ue]);return{...f.SignatureHelp.from(Ue),id:Ve}}}reviveContext(z){let X;if(z.activeSignatureHelp){const te=f.SignatureHelp.to(z.activeSignatureHelp),H=this._cache.get(z.activeSignatureHelp.id,0);H?(X=H,X.activeSignature=te.activeSignature,X.activeParameter=te.activeParameter):X=te}return{...z,activeSignatureHelp:X}}releaseSignatureHelp(z){this._cache.delete(z)}}class Se{constructor(z,X,te,H,ae){this._documents=z,this._commands=X,this._provider=te,this._logService=H,this._extension=ae,this._cache=new i.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,X,te){const H=this._documents.getDocument(z),ae=f.Range.to(X),de=await this._provider.provideInlayHints(H,ae,te);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(X)}`);return}if(te.isCancellationRequested)return;const Re=this._cache.add(de);this._disposables.set(Re,new c.DisposableStore);const Ue={hints:[],cacheId:Re};for(let Ve=0;Ve<de.length;Ve++)this._isValidInlayHint(de[Ve],ae)&&Ue.hints.push(this._convertInlayHint(de[Ve],[Re,Ve]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(X)}`),Ue}async resolveInlayHint(z,X){if(typeof this._provider.resolveInlayHint!="function")return;const te=this._cache.get(...z);if(!te)return;const H=await this._provider.resolveInlayHint(te,X);if(H&&this._isValidInlayHint(H))return this._convertInlayHint(H,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,X){return z.label.length===0||Array.isArray(z.label)&&z.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(X&&!X.contains(z.position))}_convertInlayHint(z,X){const te=this._disposables.get(X[0]);if(!te)throw Error("DisposableStore is missing...");const H={label:"",cacheId:X,tooltip:f.MarkdownString.fromStrict(z.tooltip),position:f.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(f.TextEdit.from),kind:z.kind&&f.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ae=[];H.label=ae;for(const de of z.label){if(!de.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Re={label:de.value,tooltip:f.MarkdownString.fromStrict(de.tooltip)};P.Location.isLocation(de.location)&&(Re.location=f.location.from(de.location)),de.command&&(Re.command=this._commands.toInternal(de.command,te)),ae.push(Re)}}return H}}class he{constructor(z,X){this._documents=z,this._provider=X,this._cache=new i.Cache("DocumentLink")}async provideLinks(z,X){const te=this._documents.getDocument(z),H=await this._provider.provideDocumentLinks(te,X);if(!(!Array.isArray(H)||H.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:H.filter(he._validateLink).map(f.DocumentLink.from)};{const ae=this._cache.add(H),de={links:[],cacheId:ae};for(let Re=0;Re<H.length;Re++){if(!he._validateLink(H[Re]))continue;const Ue=f.DocumentLink.from(H[Re]);Ue.cacheId=[ae,Re],de.links.push(Ue)}return de}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,X){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...z);if(!te)return;const H=await this._provider.resolveDocumentLink(te,X);if(!(!H||!he._validateLink(H)))return f.DocumentLink.from(H)}releaseLinks(z){this._cache.delete(z)}}class fe{constructor(z,X){this._documents=z,this._provider=X}async provideColors(z,X){const te=this._documents.getDocument(z),H=await this._provider.provideDocumentColors(te,X);return Array.isArray(H)?H.map(de=>({color:f.Color.from(de.color),range:f.Range.from(de.range)})):[]}async provideColorPresentations(z,X,te){const H=this._documents.getDocument(z),ae=f.Range.to(X.range),de=f.Color.to(X.color),Re=await this._provider.provideColorPresentations(de,{document:H,range:ae},te);if(Array.isArray(Re))return Re.map(f.ColorPresentation.from)}}class Z{constructor(z,X){this._documents=z,this._provider=X}async provideFoldingRanges(z,X,te){const H=this._documents.getDocument(z),ae=await this._provider.provideFoldingRanges(H,X,te);if(Array.isArray(ae))return ae.map(f.FoldingRange.from)}}class ee{constructor(z,X,te){this._documents=z,this._provider=X,this._logService=te}async provideSelectionRanges(z,X,te){const H=this._documents.getDocument(z),ae=X.map(f.Position.to),de=await this._provider.provideSelectionRanges(H,ae,te);if(!(0,R.isNonEmptyArray)(de))return[];if(de.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ae.length;Ue++){const Ve=[];Re.push(Ve);let Ke=ae[Ue],Ze=de[Ue];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(f.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return Re}}class j{constructor(z,X){this._documents=z,this._provider=X,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.prepareCallHierarchy(H,ae,te);if(!de)return;const Re=this._idPool.nextId();return this._cache.set(Re,new Map),Array.isArray(de)?de.map(Ue=>this._cacheAndConvertItem(Re,Ue)):[this._cacheAndConvertItem(Re,de)]}async provideCallsTo(z,X,te){const H=this._itemFromCache(z,X);if(!H)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(H,te);if(ae)return ae.map(de=>({from:this._cacheAndConvertItem(z,de.from),fromRanges:de.fromRanges.map(Re=>f.Range.from(Re))}))}async provideCallsFrom(z,X,te){const H=this._itemFromCache(z,X);if(!H)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(H,te);if(ae)return ae.map(de=>({to:this._cacheAndConvertItem(z,de.to),fromRanges:de.fromRanges.map(Re=>f.Range.from(Re))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,X){const te=this._cache.get(z),H=f.CallHierarchyItem.from(X,z,te.size.toString(36));return te.set(H._itemId,X),H}_itemFromCache(z,X){return this._cache.get(z)?.get(X)}}class J{constructor(z,X){this._documents=z,this._provider=X,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(z,X,te){const H=this._documents.getDocument(z),ae=f.Position.to(X),de=await this._provider.prepareTypeHierarchy(H,ae,te);if(!de)return;const Re=this._idPool.nextId();return this._cache.set(Re,new Map),Array.isArray(de)?de.map(Ue=>this._cacheAndConvertItem(Re,Ue)):[this._cacheAndConvertItem(Re,de)]}async provideSupertypes(z,X,te){const H=this._itemFromCache(z,X);if(!H)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(H,te);if(ae)return ae.map(de=>this._cacheAndConvertItem(z,de))}async provideSubtypes(z,X,te){const H=this._itemFromCache(z,X);if(!H)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(H,te);if(ae)return ae.map(de=>this._cacheAndConvertItem(z,de))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,X){const te=this._cache.get(z),H=f.TypeHierarchyItem.from(X,z,te.size.toString(36));return te.set(H._itemId,X),H}_itemFromCache(z,X){return this._cache.get(z)?.get(X)}}class ge{static toInternalProviderId(z,X){return z+"."+X}constructor(z,X,te,H,ae){this._proxy=z,this._documents=X,this._provider=te,this._handle=H,this._extension=ae}async provideDocumentOnDropEdits(z,X,te,H,ae){const de=this._documents.getDocument(X),Re=f.Position.to(te),Ue=f.DataTransfer.toDataTransfer(H,async Ke=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,z,Ke)).buffer),Ve=await this._provider.provideDocumentDropEdits(de,Re,Ue,ae);if(Ve)return{label:Ve.label??(0,d.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:ge.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?f.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class we{constructor(z,X){this._documents=z,this._provider=X}async provideMappedEdits(z,X,te,H){const ae=I.URI.revive(z),de=this._documents.getDocument(ae),Re=te.documents.map(Ke=>Ke.map(Ze=>({uri:I.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(at=>f.Range.to(at))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ve=await this._provider.provideMappedEdits(de,X,Ue,H);return Ve?f.WorkspaceEdit.from(Ve):null}}class Ae{constructor(z,X){this.adapter=z,this.extension=X}}class Ee{static{this._handlePool=0}constructor(z,X,te,H,ae,de,Re,Ue){this._uriTransformer=X,this._documents=te,this._commands=H,this._diagnostics=ae,this._logService=de,this._apiDeprecation=Re,this._extensionTelemetry=Ue,this._adapter=new Map,this._proxy=z.getProxy(E.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(z,X){return f.DocumentSelector.from(z,this._uriTransformer,X)}_createDisposable(z){return new P.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ee._handlePool++}async _withAdapter(z,X,te,H,ae,de=!1){const Re=this._adapter.get(z);if(!Re||!(Re.adapter instanceof X))return H;const Ue=Date.now();de||this._logService.trace(`[${Re.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const Ve=te(Re.adapter,Re.extension);return Promise.resolve(Ve).catch(Ke=>{(0,n.isCancellationError)(Ke)||(this._logService.error(`[${Re.extension.identifier.value}] provider FAILED`),this._logService.error(Ke),this._extensionTelemetry.onExtensionError(Re.extension.identifier,Ke))}).finally(()=>{de||this._logService.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),S.CancellationToken.isCancellationToken(ae)?(0,a.raceCancellationError)(Ve,ae):Ve}_addNewAdapter(z,X){const te=this._nextHandle();return this._adapter.set(te,new Ae(z,X)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,X,te,H){const ae=this._addNewAdapter(new s(this._documents,te),z),de=H&&H.label||Ee._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(X,z),de),this._createDisposable(ae)}$provideDocumentSymbols(z,X,te){return this._withAdapter(z,s,H=>H.provideDocumentSymbols(I.URI.revive(X),te),void 0,te)}registerCodeLensProvider(z,X,te){const H=this._nextHandle(),ae=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(H,new Ae(new h(this._documents,this._commands.converter,te,z,this._extensionTelemetry,this._logService),z)),this._proxy.$registerCodeLensSupport(H,this._transformDocumentSelector(X,z),ae);let de=this._createDisposable(H);if(ae!==void 0){const Re=te.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(ae));de=P.Disposable.from(de,Re)}return de}$provideCodeLenses(z,X,te){return this._withAdapter(z,h,H=>H.provideCodeLenses(I.URI.revive(X),te),void 0,te)}$resolveCodeLens(z,X,te){return this._withAdapter(z,h,H=>H.resolveCodeLens(X,te),void 0,void 0)}$releaseCodeLenses(z,X){this._withAdapter(z,h,te=>Promise.resolve(te.releaseCodeLenses(X)),void 0,void 0)}registerDefinitionProvider(z,X,te){const H=this._addNewAdapter(new u(this._documents,te),z);return this._proxy.$registerDefinitionSupport(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideDefinition(z,X,te,H){return this._withAdapter(z,u,ae=>ae.provideDefinition(I.URI.revive(X),te,H),[],H)}registerDeclarationProvider(z,X,te){const H=this._addNewAdapter(new w(this._documents,te),z);return this._proxy.$registerDeclarationSupport(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideDeclaration(z,X,te,H){return this._withAdapter(z,w,ae=>ae.provideDeclaration(I.URI.revive(X),te,H),[],H)}registerImplementationProvider(z,X,te){const H=this._addNewAdapter(new k(this._documents,te),z);return this._proxy.$registerImplementationSupport(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideImplementation(z,X,te,H){return this._withAdapter(z,k,ae=>ae.provideImplementation(I.URI.revive(X),te,H),[],H)}registerTypeDefinitionProvider(z,X,te){const H=this._addNewAdapter(new b(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideTypeDefinition(z,X,te,H){return this._withAdapter(z,b,ae=>ae.provideTypeDefinition(I.URI.revive(X),te,H),[],H)}registerHoverProvider(z,X,te,H){const ae=this._addNewAdapter(new g(this._documents,te),z);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(X,z)),this._createDisposable(ae)}$provideHover(z,X,te,H){return this._withAdapter(z,g,ae=>ae.provideHover(I.URI.revive(X),te,H),void 0,H)}registerEvaluatableExpressionProvider(z,X,te,H){const ae=this._addNewAdapter(new _(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(X,z)),this._createDisposable(ae)}$provideEvaluatableExpression(z,X,te,H){return this._withAdapter(z,_,ae=>ae.provideEvaluatableExpression(I.URI.revive(X),te,H),void 0,H)}registerInlineValuesProvider(z,X,te,H){const ae=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new T(this._documents,te),z);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(X,z),ae);let Re=this._createDisposable(de);if(ae!==void 0){const Ue=te.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(ae));Re=P.Disposable.from(Re,Ue)}return Re}$provideInlineValues(z,X,te,H,ae){return this._withAdapter(z,T,de=>de.provideInlineValues(I.URI.revive(X),te,H,ae),void 0,ae)}registerDocumentHighlightProvider(z,X,te){const H=this._addNewAdapter(new O(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}registerMultiDocumentHighlightProvider(z,X,te){const H=this._addNewAdapter(new x(this._documents,te),z);return this._proxy.$registerMultiDocumentHighlightProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideDocumentHighlights(z,X,te,H){return this._withAdapter(z,O,ae=>ae.provideDocumentHighlights(I.URI.revive(X),te,H),void 0,H)}$provideMultiDocumentHighlights(z,X,te,H,ae){return this._withAdapter(z,x,de=>de.provideMultiDocumentHighlights(I.URI.revive(X),te,H.map(Re=>I.URI.revive(Re)),ae),void 0,ae)}registerLinkedEditingRangeProvider(z,X,te){const H=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideLinkedEditingRanges(z,X,te,H){return this._withAdapter(z,N,async ae=>{const de=await ae.provideLinkedEditingRanges(I.URI.revive(X),te,H);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Ee._serializeRegExp(de.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,X,te){const H=this._addNewAdapter(new M(this._documents,te),z);return this._proxy.$registerReferenceSupport(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideReferences(z,X,te,H,ae){return this._withAdapter(z,M,de=>de.provideReferences(I.URI.revive(X),te,H,ae),void 0,ae)}registerCodeActionProvider(z,X,te,H){const ae=new c.DisposableStore,de=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(X,z),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this._commands.converter.toInternal(Re.command,ae)}))},Ee._extLabel(z),!!te.resolveCodeAction),ae.add(this._createDisposable(de)),ae}$provideCodeActions(z,X,te,H,ae){return this._withAdapter(z,L,de=>de.provideCodeActions(I.URI.revive(X),te,H,ae),void 0,ae)}$resolveCodeAction(z,X,te){return this._withAdapter(z,L,H=>H.resolveCodeAction(X,te),{},void 0)}$releaseCodeActions(z,X){this._withAdapter(z,L,te=>Promise.resolve(te.releaseCodeActions(X)),void 0,void 0)}registerDocumentFormattingEditProvider(z,X,te){const H=this._addNewAdapter(new B(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(H,this._transformDocumentSelector(X,z),z.identifier,z.displayName||z.name),this._createDisposable(H)}$provideDocumentFormattingEdits(z,X,te,H){return this._withAdapter(z,B,ae=>ae.provideDocumentFormattingEdits(I.URI.revive(X),te,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,X,te){const H=typeof te.provideDocumentRangesFormattingEdits=="function",ae=this._addNewAdapter(new G(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(X,z),z.identifier,z.displayName||z.name,H),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,X,te,H,ae){return this._withAdapter(z,G,de=>de.provideDocumentRangeFormattingEdits(I.URI.revive(X),te,H,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(z,X,te,H,ae){return this._withAdapter(z,G,de=>de.provideDocumentRangesFormattingEdits(I.URI.revive(X),te,H,ae),void 0,ae)}registerOnTypeFormattingEditProvider(z,X,te,H){const ae=this._addNewAdapter(new le(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(X,z),H,z.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(z,X,te,H,ae,de){return this._withAdapter(z,le,Re=>Re.provideOnTypeFormattingEdits(I.URI.revive(X),te,H,ae,de),void 0,de)}registerWorkspaceSymbolProvider(z,X){const te=this._addNewAdapter(new Y(X,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te,typeof X.resolveWorkspaceSymbol=="function"),this._createDisposable(te)}$provideWorkspaceSymbols(z,X,te){return this._withAdapter(z,Y,H=>H.provideWorkspaceSymbols(X,te),{symbols:[]},te)}$resolveWorkspaceSymbol(z,X,te){return this._withAdapter(z,Y,H=>H.resolveWorkspaceSymbol(X,te),void 0,void 0)}$releaseWorkspaceSymbols(z,X){this._withAdapter(z,Y,te=>te.releaseWorkspaceSymbols(X),void 0,void 0)}registerRenameProvider(z,X,te){const H=this._addNewAdapter(new K(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(H,this._transformDocumentSelector(X,z),K.supportsResolving(te)),this._createDisposable(H)}$provideRenameEdits(z,X,te,H,ae){return this._withAdapter(z,K,de=>de.provideRenameEdits(I.URI.revive(X),te,H,ae),void 0,ae)}$resolveRenameLocation(z,X,te,H){return this._withAdapter(z,K,ae=>ae.resolveRenameLocation(I.URI.revive(X),te,H),void 0,H)}registerDocumentSemanticTokensProvider(z,X,te,H){const ae=this._addNewAdapter(new ue(this._documents,te),z),de=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(X,z),H,de);let Re=this._createDisposable(ae);if(de){const Ue=te.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(de));Re=P.Disposable.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(z,X,te,H){return this._withAdapter(z,ue,ae=>ae.provideDocumentSemanticTokens(I.URI.revive(X),te,H),null,H)}$releaseDocumentSemanticTokens(z,X){this._withAdapter(z,ue,te=>te.releaseDocumentSemanticColoring(X),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,X,te,H){const ae=this._addNewAdapter(new ne(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(X,z),H),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(z,X,te,H){return this._withAdapter(z,ne,ae=>ae.provideDocumentRangeSemanticTokens(I.URI.revive(X),te,H),null,H)}registerCompletionItemProvider(z,X,te,H){const ae=this._addNewAdapter(new pe(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerCompletionsProvider(ae,this._transformDocumentSelector(X,z),H,pe.supportsResolving(te),z.identifier),this._createDisposable(ae)}$provideCompletionItems(z,X,te,H,ae){return this._withAdapter(z,pe,de=>de.provideCompletionItems(I.URI.revive(X),te,H,ae),void 0,ae)}$resolveCompletionItem(z,X,te){return this._withAdapter(z,pe,H=>H.resolveCompletionItem(X,te),void 0,te)}$releaseCompletionItems(z,X){this._withAdapter(z,pe,te=>te.releaseCompletionItems(X),void 0,void 0)}registerInlineCompletionsProvider(z,X,te,H){const ae=new q(z,this._documents,te,this._commands.converter),de=this._addNewAdapter(ae,z);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector(X,z),ae.supportsHandleEvents,C.ExtensionIdentifier.toKey(z.identifier.value),H?.yieldTo?.map(Re=>C.ExtensionIdentifier.toKey(Re))||[]),this._createDisposable(de)}$provideInlineCompletions(z,X,te,H,ae){return this._withAdapter(z,oe,de=>de.provideInlineCompletions(I.URI.revive(X),te,H,ae),void 0,ae)}$handleInlineCompletionDidShow(z,X,te,H){this._withAdapter(z,oe,async ae=>{ae.handleDidShowCompletionItem(X,te,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,X,te,H){this._withAdapter(z,oe,async ae=>{ae.handlePartialAccept(X,te,H)},void 0,void 0)}$freeInlineCompletionsList(z,X){this._withAdapter(z,oe,async te=>{te.disposeCompletions(X)},void 0,void 0)}registerSignatureHelpProvider(z,X,te,H){const ae=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,de=this._addNewAdapter(new ie(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(X,z),ae),this._createDisposable(de)}$provideSignatureHelp(z,X,te,H,ae){return this._withAdapter(z,ie,de=>de.provideSignatureHelp(I.URI.revive(X),te,H,ae),void 0,ae)}$releaseSignatureHelp(z,X){this._withAdapter(z,ie,te=>te.releaseSignatureHelp(X),void 0,void 0)}registerInlayHintsProvider(z,X,te){const H=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new Se(this._documents,this._commands.converter,te,this._logService,z),z);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(X,z),typeof te.resolveInlayHint=="function",H,Ee._extLabel(z));let de=this._createDisposable(ae);if(H!==void 0){const Re=te.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(H));de=P.Disposable.from(de,Re)}return de}$provideInlayHints(z,X,te,H){return this._withAdapter(z,Se,ae=>ae.provideInlayHints(I.URI.revive(X),te,H),void 0,H)}$resolveInlayHint(z,X,te){return this._withAdapter(z,Se,H=>H.resolveInlayHint(X,te),void 0,te)}$releaseInlayHints(z,X){this._withAdapter(z,Se,te=>te.releaseHints(X),void 0,void 0)}registerDocumentLinkProvider(z,X,te){const H=this._addNewAdapter(new he(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(H,this._transformDocumentSelector(X,z),typeof te.resolveDocumentLink=="function"),this._createDisposable(H)}$provideDocumentLinks(z,X,te){return this._withAdapter(z,he,H=>H.provideLinks(I.URI.revive(X),te),void 0,te,X.scheme==="output")}$resolveDocumentLink(z,X,te){return this._withAdapter(z,he,H=>H.resolveLink(X,te),void 0,void 0,!0)}$releaseDocumentLinks(z,X){this._withAdapter(z,he,te=>te.releaseLinks(X),void 0,void 0,!0)}registerColorProvider(z,X,te){const H=this._addNewAdapter(new fe(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideDocumentColors(z,X,te){return this._withAdapter(z,fe,H=>H.provideColors(I.URI.revive(X),te),[],te)}$provideColorPresentations(z,X,te,H){return this._withAdapter(z,fe,ae=>ae.provideColorPresentations(I.URI.revive(X),te,H),void 0,H)}registerFoldingRangeProvider(z,X,te){const H=this._nextHandle(),ae=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(H,new Ae(new Z(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(H,this._transformDocumentSelector(X,z),z.identifier,ae);let de=this._createDisposable(H);if(ae!==void 0){const Re=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));de=P.Disposable.from(de,Re)}return de}$provideFoldingRanges(z,X,te,H){return this._withAdapter(z,Z,ae=>ae.provideFoldingRanges(I.URI.revive(X),te,H),void 0,H)}registerSelectionRangeProvider(z,X,te){const H=this._addNewAdapter(new ee(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideSelectionRanges(z,X,te,H){return this._withAdapter(z,ee,ae=>ae.provideSelectionRanges(I.URI.revive(X),te,H),[],H)}registerCallHierarchyProvider(z,X,te){const H=this._addNewAdapter(new j(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$prepareCallHierarchy(z,X,te,H){return this._withAdapter(z,j,ae=>Promise.resolve(ae.prepareSession(I.URI.revive(X),te,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,X,te,H){return this._withAdapter(z,j,ae=>ae.provideCallsTo(X,te,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,X,te,H){return this._withAdapter(z,j,ae=>ae.provideCallsFrom(X,te,H),void 0,H)}$releaseCallHierarchy(z,X){this._withAdapter(z,j,te=>Promise.resolve(te.releaseSession(X)),void 0,void 0)}registerTypeHierarchyProvider(z,X,te){const H=this._addNewAdapter(new J(this._documents,te),z);return this._proxy.$registerTypeHierarchyProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$prepareTypeHierarchy(z,X,te,H){return this._withAdapter(z,J,ae=>Promise.resolve(ae.prepareSession(I.URI.revive(X),te,H)),void 0,H)}$provideTypeHierarchySupertypes(z,X,te,H){return this._withAdapter(z,J,ae=>ae.provideSupertypes(X,te,H),void 0,H)}$provideTypeHierarchySubtypes(z,X,te,H){return this._withAdapter(z,J,ae=>ae.provideSubtypes(X,te,H),void 0,H)}$releaseTypeHierarchy(z,X){this._withAdapter(z,J,te=>Promise.resolve(te.releaseSession(X)),void 0,void 0)}registerDocumentOnDropEditProvider(z,X,te,H){const ae=this._nextHandle();this._adapter.set(ae,new Ae(new ge(this._proxy,this._documents,te,ae,z),z));const de=(0,t.isProposedApiEnabled)(z,"dropMetadata")&&H?ge.toInternalProviderId(z.identifier.value,H.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(ae,this._transformDocumentSelector(X,z),de,(0,t.isProposedApiEnabled)(z,"dropMetadata")?H:void 0),this._createDisposable(ae)}$provideDocumentOnDropEdits(z,X,te,H,ae,de){return this._withAdapter(z,ge,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(X,I.URI.revive(te),H,ae,de)),void 0,void 0)}registerMappedEditsProvider(z,X,te){const H=this._addNewAdapter(new we(this._documents,te),z);return this._proxy.$registerMappedEditsProvider(H,this._transformDocumentSelector(X,z)),this._createDisposable(H)}$provideMappedEdits(z,X,te,H,ae){return this._withAdapter(z,we,de=>Promise.resolve(de.provideMappedEdits(X,te,H,ae)),null,ae)}registerDocumentPasteEditProvider(z,X,te,H){const ae=this._nextHandle();this._adapter.set(ae,new Ae(new U(this._proxy,this._documents,te,ae,z),z));const de=U.toInternalProviderId(z.identifier.value,H.id);return this._proxy.$registerPasteEditProvider(ae,this._transformDocumentSelector(X,z),de,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this._createDisposable(ae)}$prepareDocumentPaste(z,X,te,H,ae){return this._withAdapter(z,U,de=>de.prepareDocumentPaste(I.URI.revive(X),te,H,ae),void 0,ae)}$providePasteEdits(z,X,te,H,ae,de){return this._withAdapter(z,U,Re=>Re.providePasteEdits(X,I.URI.revive(te),H,ae,de),void 0,de)}static _serializeRegExp(z){return{pattern:z.source,flags:z.flags}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ee._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ee._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ee._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ee._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ee._serializeRegExp(z.beforeText),afterText:z.afterText?Ee._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ee._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ee._serializeOnEnterRule)}static _serializeAutoClosingPair(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(X=>P.SyntaxTokenType.toString(X)):void 0}}static _serializeAutoClosingPairs(z){return z.map(Ee._serializeAutoClosingPair)}setLanguageConfiguration(z,X,te){const{wordPattern:H}=te;if(H&&(0,p.regExpLeadsToEndlessLoop)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this._documents.setWordDefinitionFor(X,H):this._documents.setWordDefinitionFor(X,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ae=this._nextHandle(),de={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ee._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ee._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ee._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?Ee._serializeAutoClosingPairs(te.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ae,X,de),this._createDisposable(ae)}$setWordDefinitions(z){for(const X of z)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=Ee}),define(ye[330],Ce([1,0,6,15,7,39,11,3,26]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(D,v,S,C){this._documents=v,this._commands=S,this._uriTransformer=C,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=D.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(D){this._languageIds=D}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(D,v){await this._proxy.$changeLanguage(D,v);const S=this._documents.getDocumentData(D);if(!S)throw new Error(`document '${D.toString()}' NOT found`);return S.document}async tokenAtPosition(D,v){const S=D.version,C=F.Position.from(v),c=await this._proxy.$tokensAtPosition(D.uri,C),m={type:f.StandardTokenType.Other,range:D.getWordRangeAtPosition(v)??new f.Range(v.line,v.character,v.line,v.character)};if(!c)return m;const o={range:F.Range.to(c.range),type:F.TokenType.to(c.type)};return!o.range.contains(v)||S!==D.version?m:o}createLanguageStatusItem(D,v,S){const C=this._handlePool++,c=this._proxy,m=this._ids,o=`${D.identifier.value}/${v}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);m.add(o);const i={selector:S,id:v,name:D.displayName??D.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new E.DisposableStore,a=()=>{if(r?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${v}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.disposableTimeout)(()=>{n.clear(),this._proxy.$setLanguageStatus(C,{id:o,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:F.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?P.default.Error:i.severity===f.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this._commands.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),c.$removeLanguageStatus(C),m.delete(o)},get id(){return i.id},get name(){return i.name},set name(d){i.name=d,a()},get selector(){return i.selector},set selector(d){i.selector=d,a()},get text(){return i.text},set text(d){i.text=d,a()},set text2(d){(0,p.checkProposedApiEnabled)(D,"languageStatusText"),i.text=d,a()},get text2(){return(0,p.checkProposedApiEnabled)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(d){i.detail=d,a()},get severity(){return i.severity},set severity(d){i.severity=d,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(d){i.accessibilityInformation=d,a()},get command(){return i.command},set command(d){i.command=d,a()},get busy(){return i.busy},set busy(d){i.busy=d,a()}};return a(),t}}e.ExtHostLanguages=y}),define(ye[331],Ce([1,0,16,2,15,7,118]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(D,v,S,C){this.start=D,this.deletedCount=v,this.deletedItems=S,this.items=C}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(D,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,v,S){this.notebook=D,this._extHostDocument=v,this._cellData=S,this.handle=S.handle,this.uri=F.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(f.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(f.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:f.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return D._mime},set mime(C){D._mime=C},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(D){this._outputs=D.map(f.NotebookCellOutput.to)}setOutputItems(D,v,S){const C=S.map(f.NotebookCellOutputItem.to),c=this._outputs.find(m=>m.id===D);if(c&&(v||(c.items.length=0),c.items.push(...C),c.items.length>1&&c.items.every(m=>A.isTextStreamMime(m.mime)))){const m=new Map,o=[];c.items.forEach(i=>{let r;m.has(i.mime)?r=m.get(i.mime):(r=[],m.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),c.items.length=0,o.forEach(i=>{const r=A.compressOutputItemStreams(m.get(i));c.items.push({mime:i,data:r.data.buffer})})}}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(f.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=p;class y{static{this._handlePool=0}constructor(D,v,S,C,c){this._proxy=D,this._textDocumentsAndEditors=v,this._textDocuments=S,this.uri=C,this.handle=y._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=c.viewType,this._metadata=Object.freeze(c.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,c.cells]],!0,void 0),this._versionId=c.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const D=this,v={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===I.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(S){return S=D._validateIndex(S),D._cells[S].apiCell},getCells(S){return(S?D._getCells(S):D._cells).map(c=>c.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(v)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,v,S){this._versionId=D.versionId,this._isDirty=v,this.acceptDocumentPropertiesChanged({metadata:S});const C={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},c=[];for(const o of D.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,C.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,C.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),c.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),c.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),c.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),c.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),c.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<c.length;o++){const i=c[o],r=m.get(i.cell);if(r===void 0){const n=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,n-1)}else C.cellChanges[r]={...C.cellChanges[r],...i}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let v=D.start|0,S=D.end|0;return v<0&&(v=0),S>this._cells.length&&(S=this._cells.length),D.with({start:v,end:S})}_getCells(D){D=this._validateRange(D);const v=[];for(let S=D.start;S<D.end;S++)v.push(this._cells[S]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,v,S){if(this._disposed)return;const C=[],c=[],m=[];if(D.reverse().forEach(o=>{const r=o[2].map(t=>{const d=new p(this,this._textDocumentsAndEditors,t);return v||c.push(p.asModelAddData(this.apiNotebook,t)),d}),n=new E(o[0],o[1],[],r),a=this._cells.splice(o[0],o[1],...r);for(const t of a)m.push(t.uri),n.deletedItems.push(t.apiCell);C.push(n)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),S)for(const o of C)S.push(o.asApiEvent())}_moveCells(D,v,S,C){const c=this._cells.splice(D,v);this._cells.splice(S,0,...c);const m=[new E(D,v,c.map(o=>o.apiCell),[]),new E(S,0,[],c)];for(const o of m)C.push(o.asApiEvent())}_setCellOutputs(D,v){this._cells[D].setOutputs(v)}_setCellOutputItems(D,v,S,C){this._cells[D].setOutputItems(v,S,C)}_changeCellLanguage(D,v){const S=this._cells[D];S.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(S.uri,v)}_changeCellMime(D,v){const S=this._cells[D];S.apiCell.mime=v}_changeCellMetadata(D,v){this._cells[D].setMetadata(v)}_changeCellInternalMetadata(D,v){this._cells[D].setInternalMetadata(v)}getCellFromApiCell(D){return this._cells.find(v=>v.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(v=>v.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=y}),define(ye[332],Ce([1,0,4,2,15,7]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(p,y,R,D={timeout:1500,errors:3}){this._logService=p,this._notebooksAndEditors=y,this._mainThreadBulkEdits=R,this._thresholds=D,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(y,R,D)=>{const v=function(C){y.call(R,C)};return v.extension=p,this._onWillSaveNotebookDocumentEvent.event(v,void 0,D)}}async $participateInSave(p,y,R){const D=F.URI.revive(p),v=this._notebooksAndEditors.getNotebookDocument(D);if(!v)throw new Error("Unable to resolve notebook document");const S=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:v.apiNotebook,reason:f.TextDocumentSaveReason.to(y)},R,async(c,m)=>{const o=Date.now(),i=await await Promise.resolve(c);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.WorkspaceEdit?S.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const C={edits:[]};for(const c of S){const{edits:m}=f.WorkspaceEdit.from(c);C.edits=C.edits.concat(m)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(ye[149],Ce([1,0,14,15,7]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(E,p,y,R,D,v){this.id=E,this._proxy=p,this.notebookData=y,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=R,this._viewColumn=v}get apiEditor(){if(!this._editor){const E=this;this._editor={get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(p){this.selections=[p]},get selections(){return E._selections},set selections(p){if(!Array.isArray(p)||!p.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");E._selections=p,E._trySetSelections(p)},get visibleRanges(){return E._visibleRanges},revealRange(p,y){E._proxy.$tryRevealRange(E.id,F.NotebookRange.from(p),y??f.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(F.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}}e.ExtHostNotebookEditor=P}),define(ye[333],Ce([1,0,4,13,15]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(E,p){this._logService=E,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new I.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(E,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,p);const y=this._notebooksAndEditors.getEditorById(E);p.visibleRanges&&y._acceptVisibleRanges(p.visibleRanges.ranges.map(f.NotebookRange.to)),p.selections&&y._acceptSelections(p.selections.selections.map(f.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const p in E)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(f.ViewColumn.to(E[p]))}};e.ExtHostNotebookEditors=P,e.ExtHostNotebookEditors=P=je([$e(0,F.ILogService)],P)}),define(ye[334],Ce([1,0,4,6,149]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(E,p){this._extHostNotebook=p,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,p,y){const R=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(p)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(E,p){if(!E.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,D,v)=>this.getOrCreateEmitterFor(p).event(R,D,v),postMessage:(R,D)=>{f.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,D]=[D,R]);const v=D&&f.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(v?.id,p,R)}}}getOrCreateEmitterFor(E){let p=this._rendererMessageEmitters.get(E);return p||(p=new I.Emitter({onDidRemoveLastListener:()=>{p?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,p),p)}}e.ExtHostNotebookRenderers=P}),define(ye[335],Ce([1,0,15,86,21,52,14]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(D){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=D}async withProgress(D,v,S){const C=this._handles++,{title:c,location:m,cancellable:o}=v,i={label:D.displayName||D.name,id:D.identifier.value};return this._proxy.$startProgress(C,{location:I.ProgressLocation.from(m),title:c,source:i,cancellable:o},D.isUnderDevelopment?void 0:D.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(C,S,!!o)}_withProgress(D,v,S){let C;S&&(C=new f.CancellationTokenSource,this._mapHandleToCancellationSource.set(D,C));const c=o=>{this._proxy.$progressEnd(o),this._mapHandleToCancellationSource.delete(o),C?.dispose()};let m;try{m=v(new y(this._proxy,D),S&&C?C.token:f.CancellationToken.None)}catch(o){throw c(D),o}return m.then(o=>c(D),o=>c(D)),m}$acceptProgressCanceled(D){const v=this._mapHandleToCancellationSource.get(D);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(D))}}e.ExtHostProgress=E;function p(R,D){return R.message=D.message,typeof D.increment=="number"&&(typeof R.increment=="number"?R.increment+=D.increment:R.increment=D.increment),R}class y extends F.Progress{constructor(D,v){super(S=>this.throttledReport(S)),this._proxy=D,this._handle=v}throttledReport(D){this._proxy.$progressReport(this._handle,D)}}je([(0,P.throttle)(100,(R,D)=>p(R,D),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ye[336],Ce([1,0,2,6,11,15]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(p,y){this.uriTransformer=y,this.providers=new Map,this.proxy=p.getProxy(F.MainContext.MainThreadQuickDiff)}$provideOriginalResource(p,y,R){const D=I.URI.revive(y),v=this.providers.get(p);return v?(0,f.asPromise)(()=>v.provideOriginalResource(D,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,y,R,D){const v=A.handlePool++;return this.providers.set(v,y),this.proxy.$registerQuickDiffProvider(v,P.DocumentSelector.from(p,this.uriTransformer),R,D),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(v),this.providers.delete(v)}}}}e.ExtHostQuickDiff=A}),define(ye[337],Ce([1,0,21,4,3,6,2,7,14,19,39,55,26,15]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(c,m,o){const i=c.getProxy(P.MainContext.MainThreadQuickOpen);class r{constructor(w,k){this._sessions=new Map,this._instances=0,this._workspace=w,this._commands=k}showQuickPick(w,k,b,g=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(k),T=++this._instances,O=i.$show(T,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},g),x={},N=O.then(()=>x);return Promise.race([N,_]).then(M=>{if(M===x)return;const L=(0,v.isProposedApiEnabled)(w,"quickPickItemTooltip");return _.then(U=>{const B=[];for(let G=0;G<U.length;G++){const le=U[G];if(typeof le=="string")B.push({label:le,handle:G});else if(le.kind===E.QuickPickItemKind.Separator)B.push({type:"separator",label:le.label});else{le.tooltip&&!L&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const Y=le.iconPath?s(le.iconPath):void 0;B.push({label:le.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:L?S.MarkdownString.fromStrict(le.tooltip):void 0,handle:G})}}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{b.onDidSelectItem(U[G])}),i.$setItems(T,B),O.then(G=>{if(typeof G=="number")return U[G];if(Array.isArray(G))return G.map(le=>U[le])})})}).then(void 0,M=>{if(!(0,p.isCancellationError)(M))return i.$setError(T,M),Promise.reject(M)})}$onItemSelected(w){this._onDidSelectItem?.(w)}showInput(w,k=I.CancellationToken.None){return this._validateInput=w?.validateInput,i.$input(w,typeof this._validateInput=="function",k).then(void 0,b=>{if(!(0,p.isCancellationError)(b))return Promise.reject(b)})}async $validateInput(w){if(!this._validateInput)return;const k=await this._validateInput(w);if(!k||typeof k=="string")return k;let b;switch(k.severity){case E.InputBoxValidationSeverity.Info:b=R.default.Info;break;case E.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case E.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=k.message?R.default.Error:R.default.Ignore;break}return{content:k.message,severity:b}}async showWorkspaceFolderPick(w,k=I.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!b)return;const g=await this._workspace.getWorkspaceFolders2();if(g)return g.find(_=>_.uri.toString()===b.uri.toString())}createQuickPick(w){const k=new h(w,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}createInputBox(w){const k=new l(w,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}$onDidChangeValue(w,k){this._sessions.get(w)?._fireDidChangeValue(k)}$onDidAccept(w){this._sessions.get(w)?._fireDidAccept()}$onDidChangeActive(w,k){const b=this._sessions.get(w);b instanceof h&&b._fireDidChangeActive(k)}$onDidChangeSelection(w,k){const b=this._sessions.get(w);b instanceof h&&b._fireDidChangeSelection(k)}$onDidTriggerButton(w,k){this._sessions.get(w)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(w,k,b){const g=this._sessions.get(w);g instanceof h&&g._fireDidTriggerItemButton(k,b)}$onDidHide(w){this._sessions.get(w)?._fireDidHide()}}class n{static{this._nextId=1}constructor(w,k){this._extensionId=w,this._onDidDispose=k,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new F.Emitter,this._onDidChangeValueEmitter=new F.Emitter,this._onDidTriggerButtonEmitter=new F.Emitter,this._onDidHideEmitter=new F.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(w){this._title=w,this.update({title:w})}get step(){return this._steps}set step(w){this._steps=w,this.update({step:w})}get totalSteps(){return this._totalSteps}set totalSteps(w){this._totalSteps=w,this.update({totalSteps:w})}get enabled(){return this._enabled}set enabled(w){this._enabled=w,this.update({enabled:w})}get busy(){return this._busy}set busy(w){this._busy=w,this.update({busy:w})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(w){this._ignoreFocusOut=w,this.update({ignoreFocusOut:w})}get value(){return this._value}set value(w){this._value=w,this.update({value:w})}get placeholder(){return this._placeholder}set placeholder(w){this._placeholder=w,this.update({placeholder:w})}get buttons(){return this._buttons}set buttons(w){this._buttons=w.slice(),this._handlesToButtons.clear(),w.forEach((k,b)=>{const g=k===E.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(g,k)}),this.update({buttons:w.map((k,b)=>({...s(k.iconPath),tooltip:k.tooltip,handle:k===E.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(w){this._value=w,this._onDidChangeValueEmitter.fire(w)}_fireDidTriggerButton(w){const k=this._handlesToButtons.get(w);k&&this._onDidTriggerButtonEmitter.fire(k)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,f.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),i.$dispose(this._id))}update(w){if(!this._disposed){for(const k of Object.keys(w)){const b=w[k];this._pendingUpdate[k]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){i.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function a(u){if(u instanceof E.ThemeIcon)return{id:u.id};const w=d(u),k=t(u);return{dark:typeof w=="string"?A.URI.file(w):w,light:typeof k=="string"?A.URI.file(k):k}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function d(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const w=a(u);let k,b;return"id"in w?b=D.ThemeIcon.asClassName(w):k=w,{iconPath:k,iconClass:b}}class h extends n{constructor(w,k){super(w.identifier,k),this.extension=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new F.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new F.Emitter,this._onDidTriggerItemButtonEmitter=new F.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(w){this._items=w.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),w.forEach((g,_)=>{this._handlesToItems.set(_,g),this._itemsToHandles.set(g,_)});const k=(0,v.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),b=[];for(let g=0;g<w.length;g++){const _=w[g];if(_.kind===E.QuickPickItemKind.Separator)b.push({type:"separator",label:_.label});else{_.tooltip&&!k&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const T=_.iconPath?s(_.iconPath):void 0;b.push({handle:g,label:_.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,tooltip:k?S.MarkdownString.fromStrict(_.tooltip):void 0,buttons:_.buttons?.map((O,x)=>({...s(O.iconPath),tooltip:O.tooltip,handle:x}))})}}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(w){this._canSelectMany=w,this.update({canSelectMany:w})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(w){this._matchOnDescription=w,this.update({matchOnDescription:w})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(w){this._matchOnDetail=w,this.update({matchOnDetail:w})}get sortByLabel(){return this._sortByLabel}set sortByLabel(w){this._sortByLabel=w,this.update({sortByLabel:w})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(w){this._keepScrollPosition=w,this.update({keepScrollPosition:w})}get activeItems(){return this._activeItems}set activeItems(w){this._activeItems=w.filter(k=>this._itemsToHandles.has(k)),this.update({activeItems:this._activeItems.map(k=>this._itemsToHandles.get(k))})}get selectedItems(){return this._selectedItems}set selectedItems(w){this._selectedItems=w.filter(k=>this._itemsToHandles.has(k)),this.update({selectedItems:this._selectedItems.map(k=>this._itemsToHandles.get(k))})}_fireDidChangeActive(w){const k=(0,y.coalesce)(w.map(b=>this._handlesToItems.get(b)));this._activeItems=k,this._onDidChangeActiveEmitter.fire(k)}_fireDidChangeSelection(w){const k=(0,y.coalesce)(w.map(b=>this._handlesToItems.get(b)));this._selectedItems=k,this._onDidChangeSelectionEmitter.fire(k)}_fireDidTriggerItemButton(w,k){const b=this._handlesToItems.get(w);if(!b||!b.buttons||!b.buttons.length)return;const g=b.buttons[k];g&&this._onDidTriggerItemButtonEmitter.fire({button:g,item:b})}}class l extends n{constructor(w,k){super(w.identifier,k),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(w){this._password=w,this.update({password:w})}get prompt(){return this._prompt}set prompt(w){this._prompt=w,this.update({prompt:w})}get valueSelection(){return this._valueSelection}set valueSelection(w){this._valueSelection=w,this.update({valueSelection:w})}get validationMessage(){return this._validationMessage}set validationMessage(w){this._validationMessage=w,w?typeof w=="string"?this.update({validationMessage:w,severity:R.default.Error}):this.update({validationMessage:w.message,severity:w.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new r(m,o)}e.createExtHostQuickOpen=C}),define(ye[338],Ce([1,0,2,4,52,3,11,6,19,128,13,25,55,15,26,16,10]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(T){return T instanceof I.URI}function r(T,O){return T.scheme===c.Schemas.file&&O.scheme===c.Schemas.file&&m.isLinux?T.toString()===O.toString():T.toString().toLowerCase()===O.toString().toLowerCase()}function n(T){if(T)return typeof T.iconPath=="string"?I.URI.file(T.iconPath):I.URI.isUri(T.iconPath)||v.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function a(T){if(T.icon){if(I.URI.isUri(T.icon))return T.icon;if(v.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const O=T.icon;return{light:O.light,dark:O.dark}}}else return}function t(T,O){if(!T.iconPath&&!O.iconPath)return 0;if(T.iconPath){if(!O.iconPath)return 1}else return-1;const x=typeof T.iconPath=="string"?T.iconPath:I.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,N=typeof O.iconPath=="string"?O.iconPath:I.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,y.comparePaths)(x,N)}function d(T,O){let x=0;if(T.strikeThrough!==O.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==O.faded)return T.faded?1:-1;if(T.tooltip!==O.tooltip)return(T.tooltip||"").localeCompare(O.tooltip||"");if(x=t(T,O),x!==0)return x;if(T.light&&O.light)x=t(T.light,O.light);else{if(T.light)return 1;if(O.light)return-1}if(x!==0)return x;if(T.dark&&O.dark)x=t(T.dark,O.dark);else{if(T.dark)return 1;if(O.dark)return-1}return x}function s(T,O){if(T.command!==O.command)return T.command<O.command?-1:1;if(T.title!==O.title)return T.title<O.title?-1:1;if(T.tooltip!==O.tooltip){if(T.tooltip!==void 0&&O.tooltip!==void 0)return T.tooltip<O.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(T.arguments===O.arguments)return 0;if(T.arguments)if(O.arguments){if(T.arguments.length!==O.arguments.length)return T.arguments.length-O.arguments.length}else return 1;else return-1;for(let x=0;x<T.arguments.length;x++){const N=T.arguments[x],M=O.arguments[x];if(N!==M&&!(i(N)&&i(M)&&r(N,M)))return N<M?-1:1}return 0}function h(T,O){let x=(0,y.comparePaths)(T.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(x!==0)return x;if(T.command&&O.command)x=s(T.command,O.command);else{if(T.command)return 1;if(O.command)return-1}if(x!==0)return x;if(T.decorations&&O.decorations)x=d(T.decorations,O.decorations);else{if(T.decorations)return 1;if(O.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)x=(0,y.comparePaths)(T.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)x=(0,y.comparePaths)(T.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return x}function l(T,O){for(let x=0;x<T.length;x++)if(T[x]!==O[x])return!1;return!0}function u(T,O){return T.command===O.command&&T.title===O.title&&T.tooltip===O.tooltip&&(T.arguments&&O.arguments?l(T.arguments,O.arguments):T.arguments===O.arguments)}function w(T,O){return(0,p.equals)(T,O,u)}class k{#e;#t;get value(){return this._value}set value(O){O=O??"",this.#e.$setInputBoxValue(this._sourceControlHandle,O),this.updateValue(O)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(O){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,O),this._placeholder=O}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(O){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=O,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!O)}get enabled(){return this._enabled}set enabled(O){O=!!O,this._enabled!==O&&(this._enabled=O,this.#e.$setInputBoxEnablement(this._sourceControlHandle,O))}get visible(){return this._visible}set visible(O){O=!!O,this._visible!==O&&(this._visible=O,this.#e.$setInputBoxVisibility(this._sourceControlHandle,O))}get document(){return(0,C.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(O,x,N,M,L){this._extension=O,this._sourceControlHandle=M,this._documentUri=L,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=x,this.#e=N}showValidationMessage(O,x){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,O,x)}$onInputBoxValueChange(O){this.updateValue(O)}updateValue(O){this._value=O,this._onDidChange.fire(O)}}e.ExtHostSCMInputBox=k;class b{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(O){this._label=O,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,O)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(O){this._hideWhenEmpty=O,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(O){this._resourceStates=[...O],this._onDidUpdateResourceStates.fire()}constructor(O,x,N,M,L,U,B){this._proxy=O,this._commands=x,this._sourceControlHandle=N,this._id=M,this._label=L,this.multiDiffEditorEnableViewChanges=U,this._extension=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=b._handlePool++}getResourceState(O){return this._resourceStatesMap.get(O)}$executeResourceCommand(O,x){const N=this._resourceStatesCommandsMap.get(O);return N?(0,A.asPromise)(()=>this._commands.executeCommand(N.command,...N.arguments||[],x)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this._resourceStates].sort(h),N=(0,p.sortedDiff)(this._resourceSnapshot,O,h).map(U=>{const B=U.toInsert.map(G=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,G);const Y=G.resourceUri;let K;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const ee=new P.DisposableStore;K=this._commands.converter.toInternal(G.command,ee),this._resourceStatesDisposablesMap.set(le,ee)}else this._resourceStatesCommandsMap.set(le,G.command);const Q=(0,C.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ue=Q?G.multiDiffEditorOriginalUri:void 0,ne=Q?G.multiFileDiffEditorModifiedUri:void 0,pe=n(G.decorations),oe=G.decorations&&n(G.decorations.light)||pe,q=G.decorations&&n(G.decorations.dark)||pe,W=[oe,q],ie=G.decorations&&G.decorations.tooltip||"",Se=G.decorations&&!!G.decorations.strikeThrough,he=G.decorations&&!!G.decorations.faded,fe=G.contextValue||"";return{rawResource:[le,Y,W,ie,Se,he,fe,K,ue,ne],handle:le}});return{start:U.start,deleteCount:U.deleteCount,toInsert:B}}),M=N.map(({start:U,deleteCount:B,toInsert:G})=>[U,B,G.map(le=>le.rawResource)]),L=N.reverse();for(const{start:U,deleteCount:B,toInsert:G}of L){const le=G.map(K=>K.handle),Y=this._handlesSnapshot.splice(U,B,...le);for(const K of Y)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=O,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class g{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(O){this._count!==O&&(this._count=O,this.#e.$updateSourceControl(this.handle,{count:O}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(O){this._quickDiffProvider=O;let x;(0,C.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(x=O?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!O,quickDiffLabel:x})}get historyProvider(){return(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(O){(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=O,this._historyProviderDisposable.value=new P.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!O}),O&&this._historyProviderDisposable.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(O){O!==this._commitTemplate&&(this._commitTemplate=O,this.#e.$updateSourceControl(this.handle,{commitTemplate:O}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(O){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=O;const x=this._commands.converter.toInternal(O,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:x})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(O){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=O;const x=O!==void 0?{command:this._commands.converter.toInternal(O.command,this._actionButtonDisposables.value),secondaryCommands:O.secondaryCommands?.map(N=>N.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:x??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(O){if(this._statusBarCommands&&O&&w(this._statusBarCommands,O))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=O;const x=(O||[]).map(N=>this._commands.converter.toInternal(N,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:x})}get selected(){return this._selected}constructor(O,x,N,M,L,U,B){this._extension=O,this._commands=M,this._id=L,this._label=U,this._rootUri=B,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new P.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=N;const G=I.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${L}/scm${this.handle}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this._inputBox=new k(O,x,this.#e,this.handle,G),this.#e.$registerSourceControl(this.handle,L,U,B,G)}createResourceGroup(O,x,N){const M=(0,C.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&N?.multiDiffEditorEnableViewChanges===!0,L=new b(this.#e,this._commands,this.handle,O,x,M,this._extension),U=F.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,U),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const O=[],x=[];for(const[N,M]of this.createdResourceGroups){M.dispose();const L=N.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(N),this.eventuallyUpdateResourceStates()});F.Event.once(N.onDidDispose)(()=>{this.updatedResourceGroups.delete(N),L.dispose(),this._groups.delete(N.handle),this.#e.$unregisterGroup(this.handle,N.handle)}),O.push([N.handle,N.id,N.label,N.features,N.multiDiffEditorEnableViewChanges]);const U=N._takeResourceStateSnapshot();U.length>0&&x.push([N.handle,U]),this._groups.set(N.handle,N)}this.#e.$registerGroups(this.handle,O,x),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const O=[];this.updatedResourceGroups.forEach(x=>{const N=x._takeResourceStateSnapshot();N.length!==0&&O.push([x.handle,N])}),O.length>0&&this.#e.$spliceResourceStates(this.handle,O),this.updatedResourceGroups.clear()}getResourceGroup(O){return this._groups.get(O)}setSelectionState(O){this._selected=O,this._onDidChangeSelection.fire(O)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,f.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),je([(0,f.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let _=class{static{o=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(O,x,N,M){this._commands=x,this._extHostDocuments=N,this.logService=M,this._sourceControls=new Map,this._sourceControlsByExtension=new D.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=O.getProxy(E.MainContext.MainThreadSCM),this._telemetry=O.getProxy(E.MainContext.MainThreadTelemetry),x.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const U=this._sourceControls.get(L.sourceControlHandle);if(!U)return L;const B=U.getResourceGroup(L.groupHandle);return B?B.getResourceState(L.handle):L}else if(L&&L.$mid===4){const U=this._sourceControls.get(L.sourceControlHandle);return U?U.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const U=this._sourceControls.get(L.handle);return U||L}return L}})}createSourceControl(O,x,N,M){this.logService.trace("ExtHostSCM#createSourceControl",O.identifier.value,x,N,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const L=o._handlePool++,U=new g(O,this._extHostDocuments,this._proxy,this._commands,x,N,M);this._sourceControls.set(L,U);const B=this._sourceControlsByExtension.get(O.identifier)||[];return B.push(U),this._sourceControlsByExtension.set(O.identifier,B),U}getLastInputBox(O){this.logService.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const x=this._sourceControlsByExtension.get(O.identifier),N=x&&x[x.length-1];return N&&N.inputBox}$provideOriginalResource(O,x,N){const M=I.URI.revive(x);this.logService.trace("ExtHostSCM#$provideOriginalResource",O,M.toString());const L=this._sourceControls.get(O);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(M,N)).then(U=>U||null)}$onInputBoxValueChange(O,x){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",O);const N=this._sourceControls.get(O);return N&&N.inputBox.$onInputBoxValueChange(x),Promise.resolve(void 0)}$executeResourceCommand(O,x,N,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",O,x,N);const L=this._sourceControls.get(O);if(!L)return Promise.resolve(void 0);const U=L.getResourceGroup(x);return U?U.$executeResourceCommand(N,M):Promise.resolve(void 0)}$validateInput(O,x,N){this.logService.trace("ExtHostSCM#$validateInput",O);const M=this._sourceControls.get(O);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>M.inputBox.validateInput(x,N)).then(L=>{if(!L)return Promise.resolve(void 0);const U=S.MarkdownString.fromStrict(L.message);return U?Promise.resolve([U,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this._sourceControls.get(O)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,x,N,M){return await this._sourceControls.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(x,N,M)??void 0}async $provideHistoryItems(O,x,N,M){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems(x,N,M))?.map(B=>({...B,icon:a(B)}))??void 0}async $provideHistoryItemSummary(O,x,N,M){const L=this._sourceControls.get(O)?.historyProvider;if(typeof L?.provideHistoryItemSummary!="function")return;const U=await L.provideHistoryItemSummary(x,N,M);return U?{...U,icon:a(U)}:void 0}async $provideHistoryItemChanges(O,x,N,M){return await this._sourceControls.get(O)?.historyProvider?.provideHistoryItemChanges(x,N,M)??void 0}};e.ExtHostSCM=_,e.ExtHostSCM=_=o=je([$e(3,R.ILogService)],_)}),define(ye[339],Ce([1,0,6,15,2]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class P{static{this.handlePool=0}constructor(E,p){this.uriTransformer=p,this.providers=new Map,this.proxy=E.getProxy(I.MainContext.MainThreadShare)}async $provideShare(E,p,y){return await this.providers.get(E)?.provideShare({selection:F.Range.to(p.selection),resourceUri:f.URI.revive(p.resourceUri)},y)??void 0}registerShareProvider(E,p){const y=P.handlePool++;return this.providers.set(y,p),this.proxy.$registerShareProvider(y,F.DocumentSelector.from(E,this.uriTransformer),p.id,p.label,p.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(y),this.providers.delete(y)}}}}e.ExtHostShare=P}),define(ye[340],Ce([1,0,7,6,216,3,15,18]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class p{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(v,S,C,c,m,o=I.StatusBarAlignment.Left,i){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new P.DisposableStore,this.#e=v,this.#t=S,m&&c){this._entryId=(0,I.asStatusBarItemIdentifier)(c.identifier,m);const r=C.get(this._entryId);r&&(o=r.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=r.priority,this._visible=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this._entryId=String(p.ID_GEN++);this._extension=c,this._id=m,this._alignment=o,this._priority=this.validatePriority(i)}validatePriority(v){if((0,E.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!p.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new P.DisposableStore,typeof v=="string"?this._command={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this._latestCommandRegistration)}:v?this._command={fromApi:v,internal:this.#t.toInternal(v,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let S;this._name?S=this._name:S=(0,f.localize)(0,null,this._extension.displayName||this._extension.name);let C=this._color;this._backgroundColor&&(C=p.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const c=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,v,this._extension?.identifier.value,S,this._text,c,this._command?.internal,C,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=p;class y{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,f.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const S={message:v};return this._messages.unshift(S),this._update(),new I.Disposable(()=>{const C=this._messages.indexOf(S);C>=0&&(this._messages.splice(C,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(v,S){this._existingItems=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new y(this)}$acceptStaticEntries(v){for(const S of v)this._existingItems.set(S.entryId,S)}createStatusBarEntry(v,S,C,c){return new p(this._proxy,this._commands,this._existingItems,v,S,C,c)}setStatusBarMessage(v,S){const C=this._statusMessage.setMessage(v);let c;return typeof S=="number"?c=setTimeout(()=>C.dispose(),S):typeof S<"u"&&S.then(()=>C.dispose(),()=>C.dispose()),new I.Disposable(()=>{C.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=R}),define(ye[150],Ce([1,0,29,141,67,111,90,15,2]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(r,n,a,t)=>{let d=n;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!a(d,s)){const h=d;d=s,r.listener?.(t(s,h))}}}},R=(r,n)=>r===n,D={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(a=>!n.find(t=>a.id===t.id)))},v=r=>n=>({op:4,update:r(n)}),S=(r,n)=>({range:(()=>{let a;const t=v(d=>({range:I.Range.lift(E.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return a},set(d){r.listener?.({op:6}),D.range(a,d)||(a=d,r.listener?.(t(d)))}}})(),label:y(r,n,D.label,v(a=>({label:a}))),description:y(r,void 0,D.description,v(a=>({description:a}))),sortText:y(r,void 0,D.sortText,v(a=>({sortText:a}))),canResolveChildren:y(r,!1,D.canResolveChildren,a=>({op:2,state:a})),busy:y(r,!1,D.busy,v(a=>({busy:a}))),error:y(r,void 0,D.error,v(a=>({error:E.MarkdownString.fromStrict(a)||null}))),tags:y(r,[],D.tags,(a,t)=>({op:1,new:a.map(E.TestTag.from),old:t.map(E.TestTag.from)}))}),C=r=>{const n=f.TestId.fromString(r.extId),a=new m(n.controllerId,n.localId,r.label,p.URI.revive(r.uri)||void 0);return a.range=E.Range.to(r.range||void 0),a.description=r.description||void 0,a.sortText=r.sortText||void 0,a.tags=r.tags.map(t=>E.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),a},c=r=>{let n;for(const a of r.tests){const t=C(a.item);(0,F.getPrivateApiFor)(t).parent=n,n=t}return n};e.toItemFromContext=c;class m{constructor(n,a,t,d){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,F.createPrivateApiFor)(this,n);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,F.getPrivateApiFor,m),enumerable:!0,writable:!1},...S(s,t)})}}e.TestItemImpl=m;class o extends m{constructor(n,a){super(n,n,a,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class i extends P.TestItemCollection{constructor(n,a,t){super({controllerId:n,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:F.getPrivateApiFor,getChildren:d=>d.children,root:new o(n,a),toITestItem:E.TestItem.from})}}e.ExtHostTestItemCollection=i}),define(ye[33],Ce([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,150,22,68,44,38,88,91,30]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{#e;#t;#i;constructor(b,g,_){this._commands=new Map,this._apiCommands=new Map,this.#e=b.getProxy(A.MainContext.MainThreadCommands),this._logService=g,this.#i=_,this.#t=b.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new h(this,T=>{const O=this._apiCommands.get(T);return O?.result===u.Void?O:void 0},g),this._argumentProcessors=[{processArgument(T){return(0,y.revive)(T)}},{processArgument(T){return(0,P.cloneAndChange)(T,function(O){if(R.Range.isIRange(O))return f.Range.to(O);if(D.Position.isIPosition(O))return f.Position.to(O);if(R.Range.isIRange(O.range)&&v.URI.isUri(O.uri))return f.location.to(O);if(O instanceof o.VSBuffer)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(b){this._argumentProcessors.push(b)}registerApiCommand(b){const g=this.registerCommand(!1,b.id,async(..._)=>{const T=b.args.map((x,N)=>{if(!x.validate(_[N]))throw new Error(`Invalid argument '${x.name}' when running '${b.id}', received: ${typeof _[N]=="object"?JSON.stringify(_[N],null,"	"):_[N]} `);return x.convert(_[N])}),O=await this.executeCommand(b.internalId,...T);return b.result.convert(O,_,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this._apiCommands.set(b.id,b),new F.Disposable(()=>{g.dispose(),this._apiCommands.delete(b.id)})}registerCommand(b,g,_,T,O,x){if(this._logService.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this._commands.has(g))throw new Error(`command '${g}' already exists`);return this._commands.set(g,{callback:_,thisArg:T,metadata:O,extension:x}),b&&this.#e.$registerCommand(g),new F.Disposable(()=>{this._commands.delete(g)&&b&&this.#e.$unregisterCommand(g)})}executeCommand(b,...g){return this._logService.trace("ExtHostCommands#executeCommand",b),this._doExecuteCommand(b,g,!0)}async _doExecuteCommand(b,g,_){if(this._commands.has(b))return this.#e.$fireCommandActivationEvent(b),this._executeContributedCommand(b,g,!1);{let T=!1;const O=(0,P.cloneAndChange)(g,function(x){if(x instanceof F.Position)return f.Position.from(x);if(x instanceof F.Range)return f.Range.from(x);if(x instanceof F.Location)return f.location.from(x);if(F.NotebookRange.isNotebookRange(x))return f.NotebookRange.from(x);if(x instanceof ArrayBuffer)return T=!0,o.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return T=!0,o.VSBuffer.wrap(x);if(x instanceof o.VSBuffer)return T=!0,x;if(!Array.isArray(x))return x});try{const x=await this.#e.$executeCommand(b,T?new i.SerializableObjectWithBuffers(O):O,_);return(0,y.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this._doExecuteCommand(b,g,!1);throw x}}}async _executeContributedCommand(b,g,_){const T=this._commands.get(b);if(!T)throw new Error("Unknown command");const{callback:O,thisArg:x,metadata:N}=T;if(N?.args)for(let L=0;L<N.args.length;L++)try{(0,I.validateConstraint)(g[L],N.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${N.args[L].name}' - ${N.args[L].description}`)}const M=n.StopWatch.create();try{return await O.apply(x,g)}catch(L){if(b===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...g);U&&(b=U.command)}if(this._logService.error(L,b,T.extension?.identifier),!_)throw L;if(T.extension?.identifier){const U=this.#i.onExtensionError(T.extension.identifier,L);this._logService.trace("forwarded error to extension?",U,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.toErrorMessage)(L)),this.id=b,this.source=T.extension?.displayName??T.extension?.name}}}finally{this._reportTelemetry(T,b,M.elapsed())}}_reportTelemetry(b,g,_){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new a.TelemetryTrustedValue(g),duration:_})}$executeContributedCommand(b,...g){this._logService.trace("ExtHostCommands#$executeContributedCommand",b);const _=this._commands.get(b);return _?(g=g.map(T=>this._argumentProcessors.reduce((O,x)=>x.processArgument(O,_.extension?.identifier),T)),this._executeContributedCommand(b,g,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this._logService.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(g=>(b&&(g=g.filter(_=>_[0]!=="_")),g))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[g,_]of this._commands){const{metadata:T}=_;T&&(b[g]=T)}return Promise.resolve(b)}};e.ExtHostCommands=s,e.ExtHostCommands=s=je([$e(0,c.IExtHostRpcService),$e(1,p.ILogService),$e(2,t.IExtHostTelemetry)],s),e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class h{constructor(b,g,_){this._commands=b,this._lookupApiCommand=g,this._logService=_,this.delegatingCommandId=`__vsc${(0,d.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(b,g){if(!b)return;const _={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return _;const T=this._lookupApiCommand(b.command);if(T)_.id=T.internalId,_.arguments=T.args.map((O,x)=>O.convert(b.arguments&&b.arguments[x]));else if((0,E.isNonEmptyArray)(b.arguments)){const O=`${b.command} /${++this._cachIdPool}`;this._cache.set(O,b),g.add((0,S.toDisposable)(()=>{this._cache.delete(O),this._logService.trace("CommandsConverter#DISPOSE",O)})),_.$ident=O,_.id=this.delegatingCommandId,_.arguments=[O],this._logService.trace("CommandsConverter#CREATE",b.command,O)}return _}fromInternal(b){return typeof b.$ident=="string"?this._cache.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this._cache.get(b[0])}_executeConvertedCommand(...b){const g=this.getActualCommand(...b);return this._logService.trace("CommandsConverter#EXECUTE",b[0],g?g.command:"MISSING"),g?this._commands.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.CommandsConverter=h;class l{static{this.Uri=new l("uri","Uri of a text document",b=>v.URI.isUri(b),b=>b)}static{this.Position=new l("position","A position in a text document",b=>F.Position.isPosition(b),f.Position.from)}static{this.Range=new l("range","A range in a text document",b=>F.Range.isRange(b),f.Range.from)}static{this.Selection=new l("selection","A selection in a text document",b=>F.Selection.isSelection(b),f.Selection.from)}static{this.Number=new l("number","",b=>typeof b=="number",b=>b)}static{this.String=new l("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=l.Arr(l.String)}static Arr(b){return new l(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,g=>Array.isArray(g)&&g.every(_=>b.validate(_)),g=>g.map(_=>b.convert(_)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",b=>b instanceof F.CallHierarchyItem,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",b=>b instanceof F.TypeHierarchyItem,f.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VSCodium TestItem",b=>b instanceof m.TestItemImpl,f.TestItem.from)}constructor(b,g,_,T){this.name=b,this.description=g,this.validate=_,this.convert=T}optional(){return new l(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,g){return new l(b??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l;class u{static{this.Void=new u("no result",b=>b)}constructor(b,g){this.description=b,this.convert=g}}e.ApiCommandResult=u;class w{constructor(b,g,_,T,O){this.id=b,this.internalId=g,this.description=_,this.args=T,this.result=O}}e.ApiCommand=w}),define(ye[341],Ce([1,0,19,16,2,83,131,45,33,15,7]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",S(y.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,I.isFalsyOrEmpty)(c))return;class o extends R.SymbolInformation{static to(r){const n=new o(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new R.Location(m[0],y.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=y.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return c.map(o.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new p.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",S(y.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",S(y.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.Position.isPosition(m)),c=>c.map(y.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(m=>{let o;for(const i of m.reverse())o=new R.SelectionRange(y.Range.to(i),o);return o}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(y.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(y.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(y.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(y.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:y.Range.to(c.range),placeholder:c.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,m,o)=>{if(!c)return new R.CompletionList([]);const i=c.suggestions.map(r=>y.CompletionItem.to(r,o));return new R.CompletionList(i,c.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,m,o)=>S(i=>new R.CodeLens(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(c))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.Range.isRange(c),c=>R.Selection.isSelection(c)?y.Selection.from(c):y.Range.from(c)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,m,o)=>S(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new R.CodeAction(i.title,i.kind?new R.CodeActionKind(i.kind):void 0);return i.edit&&(r.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(c))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.ColorInformation(y.Range.to(m.range),y.Color.to(m.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",c=>c instanceof R.Color,y.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,m,o)=>c.map(y.InlayHint.to.bind(void 0,o)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(y.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>y.NotebookExclusiveDocumentPattern.to(m))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.Range,c=>y.InlineValueContext.from(c))],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>f.URI.isUri(c)||typeof c=="string"&&(0,F.matchesSomeScheme)(c,F.Schemas.http,F.Schemas.https),c=>c),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new p.ApiCommandArgument("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[o,i,r]=m;if(!f.URI.isUri(o)||!f.URI.isUri(i)&&i!==void 0&&i!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},c=>c)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,c=>c)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.StringArray,new p.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",c=>y.MappedEditsContext.is(c),c=>y.MappedEditsContext.from(c))],new p.ApiCommandResult("A promise that resolves to a workspace edit or null",c=>c?y.WorkspaceEdit.to(c):null))];class v{static register(m){D.forEach(m.registerApiCommand,m),this._registerValidateWhenClausesCommand(m)}static _registerValidateWhenClausesCommand(m){m.registerCommand(!1,"_validateWhenClauses",E.validateWhenClauses)}}e.ExtHostApiCommands=v;function S(c){return m=>{if(Array.isArray(m))return m.map(c)}}function C(c){if(!Array.isArray(c))return;const m=[];for(const o of c)P.isLocationLink(o)?m.push(y.DefinitionLink.to(o)):m.push(y.location.to(o));return m}}),define(ye[342],Ce([1,0,3,2,6,15,7,33,11]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(S,C){this.extension=S,this.provider=C,this.handle=y._pool++}}class R{constructor(S){this.session=S,this.responses=[]}}class D{static{this._nextId=0}constructor(S,C,c,m){this._documents=c,this._logService=m,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=S.getProxy(f.MainContext.MainThreadInlineChat),C.registerApiCommand(new E.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new E.ApiCommandArgument("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?P.Range.from(o.initialRange):void 0,initialSelection:A.Selection.isSelection(o.initialSelection)?P.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?P.Position.from(o.position):void 0}})],E.ApiCommandResult.Void))}registerProvider(S,C,c){const m=new y(S,C);return this._inputProvider.set(m.handle,m),this._proxy.$registerInteractiveEditorProvider(m.handle,c?.label??S.displayName??S.name,S.identifier.value,typeof C.handleInteractiveEditorResponseFeedback=="function",typeof C.provideFollowups=="function",c?.supportReportIssue??!1),(0,I.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(m.handle),this._inputProvider.delete(m.handle)})}async $prepareSession(S,C,c,m){const o=this._inputProvider.get(S);if(!o){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(F.URI.revive(C)),r=P.Selection.to(c),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},m);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=D._nextId++;return this._inputSessions.set(a,new R(n)),{id:a,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(n.wholeRange),message:n.message}}async $provideResponse(S,C,c,m){const o=this._inputProvider.get(S);if(!o)return;const i=this._inputSessions.get(C.id);if(!i)return;const r={prompt:c.prompt,selection:P.Selection.to(c.selection),wholeRange:P.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,withIntentDetection:c.withIntentDetection};let n=!1;const a={report:async k=>{if(!c.live&&k.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||m.isCancellationRequested||await this._proxy.$handleProgressChunk(c.requestId,{message:k.message,edits:k.edits?.map(P.TextEdit.from),editsShouldBeInstant:k.editsShouldBeInstant,slashCommand:k.slashCommand?.command,markdownFragment:A.MarkdownString.isMarkdownString(k.content)?k.content.value:k.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,a,m));let d;try{d=await(0,p.raceCancellation)(t,m)}finally{n=!0}if(!d)return;const s=i.responses.push(d)-1,h={wholeRange:P.Range.from(d.wholeRange),placeholder:d.placeholder};if(!D._isEditResponse(d))return{...h,id:s,type:"editorEdit",message:P.MarkdownString.from(d.contents),edits:[]};const{edits:l,contents:u}=d,w=u!==void 0?P.MarkdownString.from(u):void 0;return l instanceof A.WorkspaceEdit?{...h,id:s,type:"bulkEdit",edits:P.WorkspaceEdit.from(l),message:w}:{...h,id:s,type:"editorEdit",edits:l.map(P.TextEdit.from),message:w}}async $provideFollowups(S,C,c,m){const o=this._inputProvider.get(S),i=this._inputSessions.get(C),r=i?.responses[c];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,m));return(await(0,p.raceCancellation)(n,m))?.map(P.ChatFollowup.from)}}$handleFeedback(S,C,c,m){const o=this._inputProvider.get(S),i=this._inputSessions.get(C),r=i?.responses[c];if(o&&r){const n=P.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(S,C){}static _isEditResponse(S){return typeof S=="object"&&typeof S.edits=="object"}}e.ExtHostInteractiveEditor=D}),define(ye[343],Ce([1,0,2,33]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class f{constructor(A,E,p,y,R){this._extHostNotebooks=E,this._textDocumentsAndEditors=p,this._commands=y;const D=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new F.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new F.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new F.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new F.ApiCommandResult("Notebook and input URI",v=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(v.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:I.URI.revive(v.notebookUri),inputUri:I.URI.revive(v.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:I.URI.revive(v.notebookUri),inputUri:I.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(A,E,p,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(I.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=f}),define(ye[344],Ce([1,0,19,11,21,4,3,28,2,25,13,6,33,15,7,112,284,26,68,285]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let n=class{constructor(w,k,b,g,_){this._initData=k,this._extHostNotebook=b,this._commands=g,this._logService=_,this._activeExecutions=new E.ResourceMap,this._activeNotebookExecutions=new E.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=w.getProxy(D.MainContext.MainThreadNotebookKernels);const T=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const x=this._extHostNotebook.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:x}}else if(O&&"notebookEditor"in O){const x=this._extHostNotebook.getIdByEditor(O.notebookEditor);if(x===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:x}}return O})],v.ApiCommandResult.Void);this._commands.registerApiCommand(T)}createNotebookController(w,k,b,g,_,T){for(const pe of this._kernelData.values())if(pe.controller.id===k&&y.ExtensionIdentifier.equals(w.identifier,pe.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const O=this._handlePool++,x=this;this._logService.trace(`NotebookController[${O}], CREATED by ${w.identifier.value}, ${k}`);const N=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${w.identifier}'`);let M=!1;const L=new P.Emitter,U=new P.Emitter,B={id:l(w.identifier,k),notebookType:b,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:g||w.identifier.value,preloads:T?T.map(S.NotebookRendererScript.from):[]};let G=_??N,le,Y;this._proxy.$addKernel(O,B).catch(pe=>{console.log(pe),M=!0});let K=0;const Q=()=>{if(M)return;const pe=++K;Promise.resolve().then(()=>{pe===K&&this._proxy.$updateKernel(O,B)})},ue=new E.ResourceMap,ne={get id(){return k},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return B.label},set label(pe){B.label=pe??w.displayName??w.name,Q()},get detail(){return B.detail??""},set detail(pe){B.detail=pe,Q()},get description(){return B.description??""},set description(pe){B.description=pe,Q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(pe){B.supportedLanguages=pe,Q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){B.supportsExecutionOrder=pe,Q()},get rendererScripts(){return B.preloads?B.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(pe){G=pe??N},get interruptHandler(){return le},set interruptHandler(pe){le=pe,B.supportsInterrupt=!!pe,Q()},set variableProvider(pe){(0,o.checkProposedApiEnabled)(w,"notebookVariableProvider"),Y=pe,B.hasVariableProvider=!!pe,pe?.onDidChangeVariables(oe=>x._proxy.$variablesUpdated(oe.uri)),Q()},get variableProvider(){return Y},createNotebookCellExecution(pe){if(M)throw new Error("notebook controller is DISPOSED");if(!ue.has(pe.notebook.uri))throw x._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return x._createNotebookCellExecution(pe,l(w.identifier,this.id))},createNotebookExecution(pe){if((0,o.checkProposedApiEnabled)(w,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!ue.has(pe.uri))throw x._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return x._createNotebookExecution(pe,l(w.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${O}], DISPOSED`),M=!0,this._kernelData.delete(O),L.dispose(),U.dispose(),this._proxy.$removeKernel(O))},updateNotebookAffinity(pe,oe){oe===C.NotebookControllerAffinity2.Hidden&&(0,o.checkProposedApiEnabled)(w,"notebookControllerAffinityHidden"),x._proxy.$updateNotebookPriority(O,pe.uri,oe)},onDidReceiveMessage:U.event,postMessage(pe,oe){return(0,o.checkProposedApiEnabled)(w,"notebookMessaging"),x._proxy.$postMessage(O,oe&&x._extHostNotebook.getIdByEditor(oe),pe)},asWebviewUri(pe){return(0,o.checkProposedApiEnabled)(w,"notebookMessaging"),(0,c.asWebviewUri)(pe,x._initData.remote)}};return this._kernelData.set(O,{extensionId:w.identifier,controller:ne,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:ue}),ne}getIdByController(w){for(const[k,b]of this._kernelData)if(b.controller===w)return l(b.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,k){const b=this._kernelDetectionTaskHandlePool++,g=this;this._logService.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelDetectionTask(b,k);const _={dispose:()=>{this._kernelDetectionTask.delete(b),g._proxy.$removeKernelDetectionTask(b)}};return this._kernelDetectionTask.set(b,_),_}registerKernelSourceActionProvider(w,k,b){const g=this._kernelSourceActionProviderHandlePool++,_=typeof b.onDidChangeNotebookKernelSourceActions=="function"?g:void 0,T=this;this._kernelSourceActionProviders.set(g,b),this._logService.trace(`NotebookKernelSourceActionProvider[${g}], CREATED by ${w.identifier.value}`),this._proxy.$addKernelSourceActionProvider(g,g,k);let O;return _!==void 0&&(O=b.onDidChangeNotebookKernelSourceActions(x=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(_))),{dispose:()=>{this._kernelSourceActionProviders.delete(g),T._proxy.$removeKernelSourceActionProvider(g,g),O?.dispose()}}}async $provideKernelSourceActions(w,k){const b=this._kernelSourceActionProviders.get(w);if(b){const g=new A.DisposableStore;return(await b.provideNotebookKernelSourceActions(k)??[]).map(T=>S.NotebookKernelSourceAction.from(T,this._commands.converter,g))}return[]}$acceptNotebookAssociation(w,k,b){const g=this._kernelData.get(w);if(g){const _=this._extHostNotebook.getNotebookDocument(p.URI.revive(k));b?g.associatedNotebooks.set(_.uri,!0):g.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${w}] ASSOCIATE notebook`,_.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:_.apiNotebook})}}async $executeCells(w,k,b){const g=this._kernelData.get(w);if(!g)return;const _=this._extHostNotebook.getNotebookDocument(p.URI.revive(k)),T=[];for(const O of b){const x=_.getCell(O);x&&T.push(x.apiCell)}try{this._logService.trace(`NotebookController[${w}] EXECUTE cells`,_.uri.toString(),T.length),await g.controller.executeHandler.call(g.controller,T,_.apiNotebook,g.controller)}catch(O){this._logService.error(`NotebookController[${w}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(w,k,b){const g=this._kernelData.get(w);if(!g)return;const _=this._extHostNotebook.getNotebookDocument(p.URI.revive(k));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,_.apiNotebook);else for(const T of b){const O=_.getCell(T);O&&this._activeExecutions.get(O.uri)?.cancel()}if(g.controller.interruptHandler){const T=this._activeNotebookExecutions.get(_.uri);b.length&&Array.isArray(T)&&T.length&&T.forEach(O=>O.dispose())}}async $provideVariables(w,k,b,g,_,T,O){const x=this._kernelData.get(w);if(!x)return;const N=this._extHostNotebook.getNotebookDocument(p.URI.revive(b)),M=x.controller.variableProvider;if(!M)return;let L;if(g!==void 0){if(L=this.variableStore[g],!L)return}else this.variableStore={};const U=_==="named"?C.NotebookVariablesRequestKind.Named:C.NotebookVariablesRequestKind.Indexed,B=M.provideVariables(N.apiNotebook,L,U,T,O);let G=0;for await(const le of B){if(O.isCancellationRequested)return;const Y={id:this.id++,name:le.variable.name,value:le.variable.value,type:le.variable.type,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount};if(this.variableStore[Y.id]=le.variable,this._proxy.$receiveVariable(k,Y),G++>=r.variablePageSize)return}}$acceptKernelMessageFromRenderer(w,k,b){const g=this._kernelData.get(w);if(!g)return;const _=this._extHostNotebook.getEditorById(k);g.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:b}))}$cellExecutionChanged(w,k,b){const _=this._extHostNotebook.getNotebookDocument(p.URI.revive(w)).getCell(k);if(_){const T=b?S.NotebookCellExecutionState.to(b):C.NotebookCellExecutionState.Idle;T!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:T})}}_createNotebookCellExecution(w,k){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this._extHostNotebook.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!g)throw new Error("invalid cell");if(this._activeExecutions.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const _=new t(k,g,this._proxy);this._activeExecutions.set(g.uri,_);const T=_.onDidChangeState(()=>{_.state===a.Resolved&&(_.dispose(),T.dispose(),this._activeExecutions.delete(g.uri))});return _.asApiObject()}_createNotebookExecution(w,k){const b=this._extHostNotebook.getNotebookDocument(w.uri),g=w.getCells().find(O=>{const x=b.getCellFromApiCell(O);return x&&this._activeExecutions.has(x.uri)});if(g)throw new Error(`duplicate cell execution for ${g.document.uri}`);if(this._activeNotebookExecutions.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const _=new s(k,b,this._proxy),T=_.onDidChangeState(()=>{_.state===d.Resolved&&(_.dispose(),T.dispose(),this._activeNotebookExecutions.delete(b.uri))});return this._activeNotebookExecutions.set(b.uri,[_,T]),_.asApiObject()}};e.ExtHostNotebookKernels=n,e.ExtHostNotebookKernels=n=je([$e(4,R.ILogService)],n);var a;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(a||(a={}));class t extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,k,b){super(),this._cell=k,this._proxy=b,this._handle=t.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new f.CancellationTokenSource),this._collector=new h(10,g=>this.update(g)),this._executionOrder=k.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,w,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(w){await this._collector.addItem(w)}async update(w){const k=Array.isArray(w)?w:[w];return this._proxy.$updateExecution(this._handle,new i.SerializableObjectWithBuffers(k))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(w){let k=this._cell;if(w&&(k=this._cell.notebook.getCellFromApiCell(w)),!k)throw new Error("INVALID cell");return k.handle}validateAndConvertOutputs(w){return w.map(k=>{const b=C.NotebookCellOutput.ensureUniqueMimeTypes(k.items,!0);return b===k.items?S.NotebookCellOutput.from(k):S.NotebookCellOutput.from({items:b,id:k.id,metadata:k.metadata})})}async updateOutputs(w,k,b){const g=this.cellIndexToHandle(k),_=this.validateAndConvertOutputs((0,I.asArray)(w));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,cellHandle:g,append:b,outputs:_})}async updateOutputItems(w,k,b){return w=C.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(w),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:w.map(S.NotebookCellOutputItem.from),outputId:k.id,append:b})}asApiObject(){const w=this;return Object.freeze({get token(){return w._tokenSource.token},get cell(){return w._cell.apiCell},get executionOrder(){return w._executionOrder},set executionOrder(b){w._executionOrder=b,w.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:w._executionOrder}])},start(b){if(w._state===a.Resolved||w._state===a.Started)throw new Error("Cannot call start again");w._state=a.Started,w._onDidChangeState.fire(),w.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,g){if(w._state===a.Resolved)throw new Error("Cannot call resolve twice");w._state=a.Resolved,w._onDidChangeState.fire(),w._collector.flush(),w._proxy.$completeExecution(w._handle,new i.SerializableObjectWithBuffers({runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return w.verifyStateForOutput(),w.updateOutputs([],b,!1)},appendOutput(b,g){return w.verifyStateForOutput(),w.updateOutputs(b,g,!0)},replaceOutput(b,g){return w.verifyStateForOutput(),w.updateOutputs(b,g,!1)},appendOutputItems(b,g){return w.verifyStateForOutput(),w.updateOutputItems(b,g,!0)},replaceOutputItems(b,g){return w.verifyStateForOutput(),w.updateOutputItems(b,g,!1)}})}}var d;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(d||(d={}));class s extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(w,k,b){super(),this._notebook=k,this._proxy=b,this._handle=s.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new f.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,w,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===d.Resolved||this._state===d.Started)throw new Error("Cannot call start again");this._state=d.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===d.Resolved)throw new Error("Cannot call resolve twice");this._state=d.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class h{constructor(w,k){this.delay=w,this.callback=k,this.batch=[],this.startedTimer=Date.now()}addItem(w){return this.batch.push(w),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const w=this.currentDeferred;this.currentDeferred=void 0;const k=this.batch;return this.batch=[],this.callback(k).finally(()=>w.complete())}}function l(u,w){return`${u.value}/${w}`}e.createKernelId=l}),define(ye[46],Ce([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,55,11,15,33]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,f.createDecorator)("IExtHostTerminalService");class r{constructor(b,g,_,T){this._proxy=b,this._id=g,this._creationOptions=_,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(x=>this._pidPromiseComplete=x);const O=this;this.value={get name(){return O._name||""},get processId(){return O._pidPromise},get creationOptions(){return O._creationOptions},get exitStatus(){return O._exitStatus},get state(){return O._state},get selection(){return O._selection},sendText(x,N=!0){O._checkDisposed(),O._proxy.$sendText(O._id,x,N)},show(x){O._checkDisposed(),O._proxy.$show(O._id,x)},hide(){O._checkDisposed(),O._proxy.$hide(O._id)},dispose(){O._disposed||(O._disposed=!0,O._proxy.$dispose(O._id))},get dimensions(){if(!(O._cols===void 0||O._rows===void 0))return{columns:O._cols,rows:O._rows}}}}async create(b,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??g?.cwd??void 0,env:b.env??void 0,icon:l(b.iconPath)??void 0,color:c.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this._serializeParentTerminal(b.location,g?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,g,_,T,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:T,color:c.ThemeColor.isThemeColor(O)?O.id:void 0,location:g?.location||this._serializeParentTerminal(b,_),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(b,g){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(b){this._name=b}setExitStatus(b,g){this._exitStatus=Object.freeze({code:b,reason:g})}setDimensions(b,g){return b===this._cols&&g===this._rows||b===0||g===0?!1:(this._cols=b,this._rows=g,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(b){this._selection=b}_setProcessId(b){this._pidPromiseComplete?(this._pidPromiseComplete(b),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==b&&(this._pidPromise=Promise.resolve(b))})}}e.ExtHostTerminal=r;class n{get onProcessReady(){return this._onProcessReady.event}constructor(b){this._pty=b,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${g}`)}async start(){}shutdown(){this._pty.close()}input(b){this._pty.handleInput?.(b)}resize(b,g){this._pty.setDimensions?.({columns:b,rows:g})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose?.((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions?.(g=>{g&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this._pty.onDidChangeName?.(g=>{this._onDidChangeProperty.fire({type:"title",value:g})}),this._pty.open(b||void 0),b&&this._pty.setDimensions?.(b),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends E.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(b=>b.value)}constructor(b,g,_){super(),this._extHostCommands=g,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new E.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=_.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(b),this._extHostCommands.registerArgumentProcessor({processArgument:T=>{const O=x=>{const N=x;return this._getTerminalById(N.instanceId)?.value};switch(T?.$mid){case 15:return O(T);default:{if(Array.isArray(T))for(let x=0;x<T.length&&T[x].$mid===15;x++)T[x]=O(T[x]);return T}}}}),this._register({dispose:()=>{for(const[T,O]of this._terminalProcesses)O.shutdown(!0)}})}getDefaultShell(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(b,g){const _=new r(this._proxy,(0,S.generateUuid)(),b,b.name),T=new n(b.pty);return _.createExtensionTerminal(b.location,g,this._serializeParentTerminal(b,g).resolvedExtHostIdentifier,l(b.iconPath),u(b.color)).then(O=>{const x=this._setupExtHostProcessListeners(O,T);this._terminalProcessDisposables[O]=x}),this._terminals.push(_),_.value}_serializeParentTerminal(b,g){if(g=g||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const _=b.location.parentTerminal;if(_){const T=this._terminals.find(O=>O.value===_);T&&(g.resolvedExtHostIdentifier=T._id)}}else b.location&&typeof b.location!="object"?g.location=b.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(b,g){if(!this._getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const T=new n(g),O=this._setupExtHostProcessListeners(b,T);this._terminalProcessDisposables[b]=O}async $acceptActiveTerminalChanged(b){const g=this._activeTerminal;if(b===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(b);_&&(this._activeTerminal=_,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(b,g){const _=this._getTerminalById(b);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:g})}async $acceptTerminalDimensions(b,g,_){const T=this._getTerminalById(b);T&&T.setDimensions(g,_)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(b,g){const _=this._getTerminalById(b);_&&this._onDidExecuteCommand.fire({terminal:_.value,...g})}async $acceptTerminalMaximumDimensions(b,g,_){this._terminalProcesses.get(b)?.resize(g,_)}async $acceptTerminalTitleChange(b,g){const _=this._getTerminalById(b);_&&(_.name=g)}async $acceptTerminalClosed(b,g,_){const T=this._getTerminalObjectIndexById(this._terminals,b);if(T!==null){const O=this._terminals.splice(T,1)[0];O.setExitStatus(g,_),this._onDidCloseTerminal.fire(O.value)}}$acceptTerminalOpened(b,g,_,T){if(g){const N=this._getTerminalObjectIndexById(this._terminals,g);if(N!==null){this._terminals[N]._id=b,this._onDidOpenTerminal.fire(this.terminals[N]),this._terminals[N].isOpen=!0;return}}const O={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:P.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},x=new r(this._proxy,b,O,_);this._terminals.push(x),this._onDidOpenTerminal.fire(x.value),x.isOpen=!0}async $acceptTerminalProcessId(b,g){this._getTerminalById(b)?._setProcessId(g)}async $startExtensionTerminal(b,g){const _=this._getTerminalById(b);if(!_)return{message:(0,y.localize)(0,null,b)};_.isOpen||await new Promise(O=>{const x=this.onDidOpenTerminal(async N=>{N===_.value&&(x.dispose(),O())})});const T=this._terminalProcesses.get(b);T?T.startSendingEvents(g):this._extensionTerminalAwaitingStart[b]={initialDimensions:g}}_setupExtHostProcessListeners(b,g){const _=new E.DisposableStore;_.add(g.onProcessReady(O=>this._proxy.$sendProcessReady(b,O.pid,O.cwd,O.windowsPty))),_.add(g.onDidChangeProperty(O=>this._proxy.$sendProcessProperty(b,O))),this._bufferer.startBuffering(b,g.onProcessData),_.add(g.onProcessExit(O=>this._onProcessExit(b,O))),this._terminalProcesses.set(b,g);const T=this._extensionTerminalAwaitingStart[b];return T&&g instanceof n&&(g.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[b]),_}$acceptProcessAckDataEvent(b,g){this._terminalProcesses.get(b)?.acknowledgeDataEvent(g)}$acceptProcessInput(b,g){this._terminalProcesses.get(b)?.input(g)}$acceptTerminalInteraction(b){const g=this._getTerminalById(b);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptTerminalSelection(b,g){this._getTerminalById(b)?.setSelection(g)}$acceptProcessResize(b,g,_){try{this._terminalProcesses.get(b)?.resize(g,_)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(b,g){this._terminalProcesses.get(b)?.shutdown(g)}$acceptProcessRequestInitialCwd(b){this._terminalProcesses.get(b)?.getInitialCwd().then(g=>this._proxy.$sendProcessProperty(b,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(b){this._terminalProcesses.get(b)?.getCwd().then(g=>this._proxy.$sendProcessProperty(b,{type:"cwd",value:g}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this._linkProviders.add(b),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new p.Disposable(()=>{this._linkProviders.delete(b),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(b,g,_){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,_),this._proxy.$registerProfileProvider(g,b.identifier.value),new p.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(b,g,_){if(this._quickFixProviders.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this._quickFixProviders.set(b,_),this._proxy.$registerQuickFixProvider(b,g),new p.Disposable(()=>{this._quickFixProviders.delete(b),this._proxy.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,g){const _=new v.CancellationTokenSource().token;if(_.isCancellationRequested)return;const T=this._quickFixProviders.get(b);if(!T)return;const O=await T.provideTerminalQuickFixes(g,_);if(O===null||Array.isArray(O)&&O.length===0)return;const x=new E.DisposableStore;if(this._lastQuickFixCommands.value=x,!Array.isArray(O))return O?o.TerminalQuickFix.from(O,this._extHostCommands.converter,x):void 0;const N=[];for(const M of O){const L=o.TerminalQuickFix.from(M,this._extHostCommands.converter,x);L&&N.push(L)}return N}async $createContributedProfileTerminal(b,g){const _=new v.CancellationTokenSource().token;let T=await this._profileProviders.get(b)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,g);return}this.createTerminalFromOptions(T.options,g)}}async $provideLinks(b,g){const _=this._getTerminalById(b);if(!_)return[];this._terminalLinkCache.delete(b),this._terminalLinkCancellationSource.get(b)?.dispose(!0);const O=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(b,O);const x=[],N={terminal:_.value,line:g},M=[];for(const B of this._linkProviders)M.push(m.Promises.withAsyncBody(async G=>{O.token.onCancellationRequested(()=>G({provider:B,links:[]}));const le=await B.provideTerminalLinks(N,O.token)||[];O.token.isCancellationRequested||G({provider:B,links:le})}));const L=await Promise.all(M);if(O.token.isCancellationRequested)return[];const U=new Map;for(const B of L)B&&B.links.length>0&&x.push(...B.links.map(G=>{const le={id:a++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return U.set(le.id,{provider:B.provider,link:G}),le}));return this._terminalLinkCache.set(b,U),x}$activateLink(b,g){const _=this._terminalLinkCache.get(b)?.get(g);_&&_.provider.handleTerminalLink(_.link)}_onProcessExit(b,g){this._bufferer.stopBuffering(b),this._terminalProcesses.delete(b),delete this._extensionTerminalAwaitingStart[b];const _=this._terminalProcessDisposables[b];_&&(_.dispose(),delete this._terminalProcessDisposables[b]),this._proxy.$sendProcessExit(b,g)}_getTerminalById(b){return this._getTerminalObjectById(this._terminals,b)}_getTerminalObjectById(b,g){const _=this._getTerminalObjectIndexById(b,g);return _!==null?b[_]:null}_getTerminalObjectIndexById(b,g){const _=b.findIndex(T=>T._id===g);return _===-1?null:_}getEnvironmentVariableCollection(b){let g=this._environmentVariableCollections.get(b.identifier.value);return g||(g=new d,this._setEnvironmentVariableCollection(b.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(b,g){const _=(0,D.serializeEnvironmentVariableCollection)(g.map),T=(0,D.serializeEnvironmentDescriptionMap)(g.descriptionMap);this._proxy.$setEnvironmentVariableCollection(b,g.persistent,_.length===0?void 0:_,T)}$initEnvironmentVariableCollections(b){b.forEach(g=>{const _=g[0],T=new d(g[1]);this._setEnvironmentVariableCollection(_,T)})}$acceptDefaultProfile(b,g){const _=this._defaultProfile;this._defaultProfile=b,this._defaultAutomationProfile=g,_?.path!==b.path&&this._onDidChangeShell.fire(b.path)}_setEnvironmentVariableCollection(b,g){this._environmentVariableCollections.set(b,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(b,g)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=je([$e(1,i.IExtHostCommands),$e(2,A.IExtHostRpcService)],t);class d{get persistent(){return this._persistent}set persistent(b){this._persistent=b,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const g=this.getScopeKey(b);let _=this.scopedCollections.get(g);return _||(_=new s(this,b),this.scopedCollections.set(g,_),_.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),_}replace(b,g,_,T){this._setIfDiffers(b,{value:g,type:p.EnvironmentVariableMutatorType.Replace,options:_??{applyAtProcessCreation:!0},scope:T})}append(b,g,_,T){this._setIfDiffers(b,{value:g,type:p.EnvironmentVariableMutatorType.Append,options:_??{applyAtProcessCreation:!0},scope:T})}prepend(b,g,_,T){this._setIfDiffers(b,{value:g,type:p.EnvironmentVariableMutatorType.Prepend,options:_??{applyAtProcessCreation:!0},scope:T})}_setIfDiffers(b,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const _=this.getKey(b,g.scope),T=this.map.get(_),O=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==g.value||T.type!==g.type||T.options?.applyAtProcessCreation!==O.applyAtProcessCreation||T.options?.applyAtShellIntegration!==O.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const x=this.getKey(b,g.scope),N={variable:b,...g,options:O};this.map.set(x,N),this._onDidChangeCollection.fire()}}get(b,g){const _=this.getKey(b,g),T=this.map.get(_);return T?w(T):void 0}getKey(b,g){const _=this.getScopeKey(g);return _.length?`${b}:::${_}`:b}getScopeKey(b){return this.getWorkspaceKey(b?.workspaceFolder)??""}getWorkspaceKey(b){return b?b.uri.toString():void 0}getVariableMap(b){const g=new Map;for(const[_,T]of this.map)this.getScopeKey(T.scope)===this.getScopeKey(b)&&g.set(T.variable,w(T));return g}delete(b,g){const _=this.getKey(b,g);this.map.delete(_),this._onDidChangeCollection.fire()}clear(b){if(b?.workspaceFolder){for(const[g,_]of this.map)_.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(g);this.clearDescription(b)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(b,g){const _=this.getScopeKey(g),T=this.descriptionMap.get(_);if(!T||T.description!==b){let O;typeof b=="string"?O=b:O=b?.value.split(`

`)[0];const x={description:O,scope:g};this.descriptionMap.set(_,x),this._onDidChangeCollection.fire()}}getDescription(b){const g=this.getScopeKey(b);return this.descriptionMap.get(g)?.description}clearDescription(b){const g=this.getScopeKey(b);this.descriptionMap.delete(g)}}class s{get persistent(){return this.collection.persistent}set persistent(b){this.collection.persistent=b}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b,g){this.collection=b,this.scope=g,this._onDidChangeCollection=new I.Emitter}getScoped(b){return this.collection.getScopedEnvironmentVariableCollection(b)}replace(b,g,_){this.collection.replace(b,g,_,this.scope)}append(b,g,_){this.collection.append(b,g,_,this.scope)}prepend(b,g,_){this.collection.prepend(b,g,_,this.scope)}get(b){return this.collection.get(b,this.scope)}forEach(b,g){this.collection.getVariableMap(this.scope).forEach((_,T)=>b.call(g,T,_,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(b){this.collection.delete(b,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(b){this.collection.setDescription(b,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let h=class extends t{constructor(b,g){super(!1,b,g)}createTerminal(b,g,_){throw new R.NotSupportedError}createTerminalFromOptions(b,g){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=h,e.WorkerExtHostTerminalService=h=je([$e(0,i.IExtHostCommands),$e(1,A.IExtHostRpcService)],h);function l(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function u(k){return c.ThemeColor.isThemeColor(k)?k:void 0}function w(k){const b={...k};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ye[345],Ce([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,26]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class extends p.Disposable{constructor(M,L,U,B){super(),this.editors=B,this.resultsChangedEmitter=this._register(new P.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new P.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(S.MainContext.MainThreadTesting),this.observer=new _(this.proxy),this.runTracker=new l(this.proxy,L),U.registerArgumentProcessor({processArgument:G=>{switch(G?.$mid){case 16:{const le=G,Y=le.tests[le.tests.length-1].item.extId;return this.controllers.get(i.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,c.toItemFromContext)(G)}case 18:{const{extId:le,message:Y}=G;return{test:this.controllers.get(i.TestId.root(le))?.collection.tree.get(le)?.actual,message:m.TestMessage.to(Y)}}default:return G}}}),U.registerCommand(!1,"testing.getExplorerSelection",async()=>{const G=await U.executeCommand("_testing.getExplorerSelection"),le=Y=>{const K=this.controllers.get(i.TestId.root(Y));if(K)return i.TestId.isRoot(Y)?K.controller:K.collection.tree.get(Y)?.actual};return{include:G?.include.map(le).filter(R.isDefined)||[],exclude:G?.exclude.map(le).filter(R.isDefined)||[]}})}createTestController(M,L,U,B){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const G=new p.DisposableStore,le=G.add(new c.ExtHostTestItemCollection(L,U,this.editors));le.root.label=U;const Y=new Map,K=new Set,Q=this.proxy,ue={items:le.root.children,get label(){return U},set label(pe){U=pe,le.root.label=pe,Q.$updateController(L,{label:U})},get refreshHandler(){return B},set refreshHandler(pe){B=pe,Q.$updateController(L,{canRefresh:!!pe})},get id(){return L},createRunProfile:(pe,oe,q,W,ie,Se)=>{let he=(0,E.hash)(pe);for(;Y.has(he);)he++;return new O(this.proxy,Y,K,this.defaultProfilesChangedEmitter.event,L,he,pe,oe,q,W,ie,Se)},createTestItem(pe,oe,q){return new c.TestItemImpl(L,pe,oe,q)},createTestRun:(pe,oe,q=!0)=>this.runTracker.createTestRun(M,L,le,pe,oe,q),invalidateTestResults:pe=>{if(pe===void 0)this.proxy.$markTestRetired(void 0);else{const oe=pe instanceof Array?pe:[pe];this.proxy.$markTestRetired(oe.map(q=>i.TestId.fromExtHostTestItem(q,L).toString()))}},set resolveHandler(pe){le.resolveHandler=pe},get resolveHandler(){return le.resolveHandler},dispose:()=>{G.dispose()}};Q.$registerTestController(L,U,!!B),G.add((0,p.toDisposable)(()=>Q.$unregisterTestController(L)));const ne={controller:ue,collection:le,profiles:Y,extension:M,activeProfiles:K};return this.controllers.set(L,ne),G.add((0,p.toDisposable)(()=>this.controllers.delete(L))),G.add(le.onDidGenerateDiff(pe=>Q.$publishDiff(L,pe.map(n.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.observer.checkout()}async runTests(M,L=f.CancellationToken.None){const U=u(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(U.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(G=>i.TestId.fromExtHostTestItem(G,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:x[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(G=>G.id)},L)}$syncTests(){for(const{collection:M}of this.controllers.values())M.flushDiff();return Promise.resolve()}async $provideFileCoverage(M,L,U){return await this.runTracker.getCoverageReport(M,L)?.provideFileCoverage(U)??[]}async $resolveFileCoverage(M,L,U,B){return await this.runTracker.getCoverageReport(M,L)?.resolveFileCoverage(U,B)??[]}$configureRunProfile(M,L){this.controllers.get(M)?.profiles.get(L)?.configureHandler?.()}$setDefaultRunProfiles(M){const L=new Map;for(const[U,B]of Object.entries(M)){const G=this.controllers.get(U);if(!G)continue;const le=new Map,Y=B.filter(Q=>!G.activeProfiles.has(Q)),K=[...G.activeProfiles].filter(Q=>!B.includes(Q));for(const Q of Y)le.set(Q,!0),G.activeProfiles.add(Q);for(const Q of K)le.set(Q,!1),G.activeProfiles.delete(Q);le.size&&L.set(U,le)}this.defaultProfilesChangedEmitter.fire(L)}async $refreshTests(M,L){await this.controllers.get(M)?.controller.refreshHandler?.(L)}$publishTestResults(M){this.results=Object.freeze(M.map(L=>(0,y.deepFreeze)(m.TestResults.to(L))).concat(this.results).sort((L,U)=>U.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,L){const U=this.controllers.get(i.TestId.fromString(M).controllerId)?.collection;U&&(await U.expand(M,L<0?1/0:L),U.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(L=>n.TestsDiffOp.deserialize({asCanonicalUri:U=>U},L)))}async $runControllerTests(M,L){return Promise.all(M.map(U=>this.runControllerTestRequest(U,!1,L)))}async $startContinuousRun(M,L){const U=new f.CancellationTokenSource(L),B=await Promise.all(M.map(G=>this.runControllerTestRequest(G,!0,U.token)));return!L.isCancellationRequested&&!B.some(G=>G.error)&&await new Promise(G=>L.onCancellationRequested(G)),U.dispose(!0),B}async runControllerTestRequest(M,L,U){const B=this.controllers.get(M.controllerId);if(!B)return{};const{collection:G,profiles:le,extension:Y}=B,K=le.get(M.profileId);if(!K)return{};const Q=M.testIds.map(oe=>G.tree.get(oe)).filter(R.isDefined),ue=M.excludeExtIds.map(oe=>B.collection.tree.get(oe)).filter(R.isDefined).filter(oe=>Q.some(q=>q.fullId.compare(oe.fullId)===2));if(!Q.length)return{};const ne=new o.TestRunRequest(Q.some(oe=>oe.actual instanceof c.TestItemRootImpl)?void 0:Q.map(oe=>oe.actual),ue.map(oe=>oe.actual),K,L),pe=(0,n.isStartControllerTests)(M)&&this.runTracker.prepareForMainThreadTestRun(ne,w.fromInternal(M,B.collection),Y,U);try{return await K.runHandler(ne,U),{}}catch(oe){return{error:String(oe)}}finally{pe&&(pe.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};e.ExtHostTesting=t,e.ExtHostTesting=t=je([$e(0,C.IExtHostRpcService),$e(1,v.ILogService)],t);const d=1e4;var s;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(s||(s={}));class h extends p.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(M,L,U,B,G){super(),this.dto=M,this.proxy=L,this.extension=U,this.logService=B,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.coverageEmitter=this._register(new P.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new f.CancellationTokenSource(G));const le=this._register(new I.RunOnceScheduler(()=>this.forciblyEndTasks(),d));this._register(this.cts.token.onCancellationRequested(()=>le.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun(M){const L=this.dto.id,U=this.dto.controllerId,B=(0,D.generateUuid)(),G=this.extension,le=this.coverageEmitter;let Y;const K=pe=>(oe,...q)=>{if(ue){this.logService.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(oe)&&(this.ensureTestIsKnown(oe),pe(oe,...q))},Q=(pe,oe)=>{const q=oe instanceof Array?oe.map(m.TestMessage.from):[m.TestMessage.from(oe)];if(pe.uri&&pe.range){const W={range:m.Range.from(pe.range),uri:pe.uri};for(const ie of q)ie.location=ie.location||W}this.proxy.$appendTestMessagesInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),q)};let ue=!1;const ne={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return Y?.provider},set coverageProvider(pe){(0,a.checkProposedApiEnabled)(G,"testCoverage"),Y=pe&&new k(pe),le.fire({taskId:B,runId:L,coverage:Y})},enqueued:K(pe=>{this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),1)}),skipped:K(pe=>{this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),5)}),started:K(pe=>{this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),2)}),errored:K((pe,oe,q)=>{Q(pe,oe),this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),6,q)}),failed:K((pe,oe,q)=>{Q(pe,oe),this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,U).toString(),4,q)}),passed:K((pe,oe)=>{this.proxy.$updateTestStateInRun(L,B,i.TestId.fromExtHostTestItem(pe,this.dto.controllerId).toString(),3,oe)}),appendOutput:(pe,oe,q)=>{ue||(q&&(this.dto.isIncluded(q)?this.ensureTestIsKnown(q):q=void 0),this.proxy.$appendOutputToRun(L,B,F.VSBuffer.fromString(pe),oe&&m.location.from(oe),q&&i.TestId.fromExtHostTestItem(q,U).toString()))},end:()=>{ue||(ue=!0,this.proxy.$finishedTestRunTask(L,B),this.tasks.delete(B),this.tasks.size||this.markEnded())}};return this.tasks.set(B,{run:ne}),this.proxy.$startedTestRunTask(L,{id:B,name:M,running:!0}),ne}forciblyEndTasks(){for(const{run:M}of this.tasks.values())M.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(M){if(!(M instanceof c.TestItemImpl))throw new r.InvalidTestItemError(M.id);if(this.sharedTestIds.has(i.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const L=[],U=this.dto.colllection.root;for(;;){const B=m.TestItem.from(M);if(L.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),M===U))break;M=M.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}dispose(){this.markEnded(),super.dispose()}}class l{get trackers(){return this.tracked.values()}constructor(M,L){this.proxy=M,this.logService=L,this.tracked=new Map,this.coverageReports=[]}getCoverageReport(M,L){return this.coverageReports.find(U=>U.runId===M)?.coverage.get(L)}prepareForMainThreadTestRun(M,L,U,B){return this.getTracker(M,L,U,B)}cancelRunById(M){for(const L of this.tracked.values())if(L.id===M){L.cancel();return}}cancelAllRuns(){for(const M of this.tracked.values())M.cancel()}createTestRun(M,L,U,B,G,le){const Y=this.tracked.get(B);if(Y)return Y.createRun(G);const K=w.fromPublic(L,U,B,le),Q=u(B);this.proxy.$startedExtensionTestRun({controllerId:L,continuous:!!B.continuous,profile:Q&&{group:x[Q.kind],id:Q.profileId},exclude:B.exclude?.map(ne=>i.TestId.fromExtHostTestItem(ne,U.root.id).toString())??[],id:K.id,include:B.include?.map(ne=>i.TestId.fromExtHostTestItem(ne,U.root.id).toString())??[U.root.id],persist:le});const ue=this.getTracker(B,K,M);return P.Event.once(ue.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(K.id),ue.dispose()}),ue.createRun(G)}getTracker(M,L,U,B){const G=new h(L,this.proxy,U,this.logService,B);this.tracked.set(M,G);let le;const Y=G.onDidCoverage(({runId:K,taskId:Q,coverage:ue})=>{le||(le={runId:K,coverage:new Map},this.coverageReports.unshift(le),this.coverageReports.length>n.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),le.coverage.set(Q,ue),this.proxy.$signalCoverageAvailable(K,Q,!!ue)});return P.Event.once(G.onEnd)(()=>{this.tracked.delete(M),Y.dispose()}),G}}e.TestRunCoordinator=l;const u=N=>{if(N.profile){if(!(N.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class w{static fromPublic(M,L,U,B){return new w(M,(0,D.generateUuid)(),U.include?.map(G=>i.TestId.fromExtHostTestItem(G,M).toString())??[M],U.exclude?.map(G=>i.TestId.fromExtHostTestItem(G,M).toString())??[],B,L)}static fromInternal(M,L){return new w(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,L)}constructor(M,L,U,B,G,le){this.controllerId=M,this.id=L,this.isPersisted=G,this.colllection=le,this.includePrefix=U.map(Y=>Y+"\0"),this.excludePrefix=B.map(Y=>Y+"\0")}isIncluded(M){const L=i.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(L===U||L.startsWith(U))return!1;for(const U of this.includePrefix)if(L===U||L.startsWith(U))return!0;return!1}}e.TestRunDto=w;class k{constructor(M){this.provider=M}async provideFileCoverage(M){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(M,L){const U=await this.fileCoverage;let B=U?.[M];return!this.provider||!U||!B?[]:(B.detailedCoverage||(B=U[M]=await this.provider.resolveFileCoverage?.(B,L)??B),B.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(M){this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(M){this.added.add(M)}update(M){Object.assign(M.revived,m.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}this.updated.delete(M);const L=i.TestId.parentId(M.item.extId);if(L&&this.alreadyRemoved.has(L.toString())){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:L,removed:U}=this;return{get added(){return[...M].map(B=>B.revived)},get updated(){return[...L].map(B=>B.revived)},get removed(){return[...U].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,L){return{...M,revived:m.TestItem.toPlain(M.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new b(this.changeEmitter)}}class _{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(L=>L.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new g({asCanonicalUri:L=>L});return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}const T=(N,M,L,U)=>{L?Object.assign(L,U):M.$updateTestRunConfig(N.controllerId,N.profileId,U)};class O{#e;#t;#i;#n;#s;get label(){return this._label}set label(M){M!==this._label&&(this._label=M,T(this,this.#e,this.#n,{label:M}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(M){M!==this._supportsContinuousRun&&(this._supportsContinuousRun=M,T(this,this.#e,this.#n,{supportsContinuousRun:M}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(M){M!==this.isDefault&&(M?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,T(this,this.#e,this.#n,{tag:M?m.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,T(this,this.#e,this.#n,{hasConfigurationHandler:!!M}))}get onDidChangeDefault(){return P.Event.chain(this.#i,M=>M.map(L=>L.get(this.controllerId)?.get(this.profileId)).filter(R.isDefined))}constructor(M,L,U,B,G,le,Y,K,Q,ue=!1,ne=void 0,pe=!1){this.controllerId=G,this.profileId=le,this._label=Y,this.kind=K,this.runHandler=Q,this._tag=ne,this._supportsContinuousRun=pe,this.#e=M,this.#s=L,this.#t=U,this.#i=B,L.set(le,this);const oe=x[K];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);ue&&U.add(le),this.#n={profileId:le,controllerId:G,tag:ne?m.TestTag.namespace(this.controllerId,ne.id):null,label:Y,group:oe,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=O;const x={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ye[151],Ce([1,0,61,14,121,15,7]),function(me,e,I,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class E{static{this._Keys=new f.IdGenerator("TextEditorDecorationType")}constructor(v,S,C){const c=E._Keys.nextId();v.$registerTextEditorDecorationType(S.identifier,c,P.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:c,dispose(){v.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=E;class p{constructor(v,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,S){this._throwIfFinalized();let C=null;if(v instanceof A.Position)C=new A.Range(v,v);else if(v instanceof A.Range)C=v;else throw new Error("Unrecognized location");this._pushEdit(C,S,!1)}insert(v,S){this._throwIfFinalized(),this._pushEdit(new A.Range(v,v),S,!0)}delete(v){this._throwIfFinalized();let S=null;if(v instanceof A.Range)S=v;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(v,S,C){const c=this._document.validateRange(v);this._collectedEdits.push({range:c,text:S,forceMoveMarkers:C})}setEndOfLine(v){if(this._throwIfFinalized(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=v}}class y{constructor(v,S,C,c){this._proxy=v,this._id=S,this._accept(C),this._logService=c;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(o){m._setTabSize(o)},get indentSize(){return m._indentSize},set indentSize(o){m._setIndentSize(o)},get insertSpaces(){return m._insertSpaces},set insertSpaces(o){m._setInsertSpaces(o)},get cursorStyle(){return m._cursorStyle},set cursorStyle(o){m._setCursorStyle(o)},get lineNumbers(){return m._lineNumbers},set lineNumbers(o){m._setLineNumbers(o)}}}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._originalIndentSize=v.originalIndentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(v){const S=this._validateTabSize(v);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}_setIndentSize(v){const S=this._validateIndentSize(v);if(S!==null){if(typeof S=="number"){if(this._originalIndentSize===S)return;this._indentSize=S,this._originalIndentSize=S}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:S}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:!!v}_setInsertSpaces(v){const S=this._validateInsertSpaces(v);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(v)})))}assign(v){const S={};let C=!1;if(typeof v.tabSize<"u"){const c=this._validateTabSize(v.tabSize);c==="auto"?(C=!0,S.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,C=!0,S.tabSize=c)}if(typeof v.indentSize<"u"){const c=this._validateIndentSize(v.indentSize);c==="tabSize"?(C=!0,S.indentSize=c):typeof c=="number"&&this._originalIndentSize!==c&&(this._indentSize=c,this._originalIndentSize=c,C=!0,S.indentSize=c)}if(typeof v.insertSpaces<"u"){const c=this._validateInsertSpaces(v.insertSpaces);c==="auto"?(C=!0,S.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,C=!0,S.insertSpaces=c)}typeof v.cursorStyle<"u"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,C=!0,S.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,C=!0,S.lineNumbers=P.TextEditorLineNumbersStyle.from(v.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(v,S){S.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=y;class R{constructor(v,S,C,c,m,o,i,r){this.id=v,this._proxy=S,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new y(this._proxy,this.id,o,C),this._visibleRanges=i,this._viewColumn=r;const n=this;this.value=Object.freeze({get document(){return c.value},set document(a){throw new F.ReadonlyError("document")},get selection(){return n._selections&&n._selections[0]},set selection(a){if(!(a instanceof A.Selection))throw(0,F.illegalArgument)("selection");n._selections=[a],n._trySetSelection()},get selections(){return n._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");n._selections=a,n._trySetSelection()},get visibleRanges(){return n._visibleRanges},set visibleRanges(a){throw new F.ReadonlyError("visibleRanges")},get options(){return n._options.value},set options(a){n._disposed||n._options.assign(a)},get viewColumn(){return n._viewColumn},set viewColumn(a){throw new F.ReadonlyError("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new p(c.value,t);return a(d),n._applyEdit(d)},insertSnippet(a,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n._selections.map(h=>P.Range.from(h));else if(t instanceof A.Position){const{lineNumber:h,column:l}=P.Position.from(t);s=[{startLineNumber:h,startColumn:l,endLineNumber:h,endColumn:l}]}else if(t instanceof A.Range)s=[P.Range.from(t)];else{s=[];for(const h of t)if(h instanceof A.Range)s.push(P.Range.from(h));else{const{lineNumber:l,column:u}=P.Position.from(h);s.push({startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u})}}return S.$tryInsertSnippet(v,c.value.version,a.value,s,d)},setDecorations(a,t){const d=t.length===0;d&&!n._hasDecorationsForKey.has(a.key)||(d?n._hasDecorationsForKey.delete(a.key):n._hasDecorationsForKey.add(a.key),n._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return S.$trySetDecorations(v,a.key,P.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let h=0,l=t.length;h<l;h++){const u=t[h];s[4*h]=u.start.line+1,s[4*h+1]=u.start.character+1,s[4*h+2]=u.end.line+1,s[4*h+3]=u.end.character+1}return S.$trySetDecorationsFast(v,a.key,s)}}))},revealRange(a,t){n._runOnProxy(()=>S.$tryRevealRange(v,P.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){S.$tryShowEditor(v,P.ViewColumn.from(a))},hide(){S.$tryHideEditor(v)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,I.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,I.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,I.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,I.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const S=v.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const C=S.edits.map(m=>m.range);C.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=C.length-1;m<o;m++){const i=C[m].end;if(C[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=S.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,c,{setEndOfLine:typeof S.setEndOfLine=="number"?P.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=R}),define(ye[72],Ce([1,0,61,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(n){this.value=n,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let i=class{constructor(n,a){this._extHostRpc=n,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const a=[],t=[],d=[];if(n.removedDocuments)for(const s of n.removedDocuments){const h=P.URI.revive(s),l=this._documents.get(h);l?.unref()&&(this._documents.delete(h),a.push(l.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const h=P.URI.revive(s.uri);let l=this._documents.get(h);if(l&&h.scheme!==C.Schemas.vscodeNotebookCell&&h.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);l||(l=new o(new p.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),h,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(h,l),t.push(l.value)),l.ref()}if(n.removedEditors)for(const s of n.removedEditors){const h=this._editors.get(s);this._editors.delete(s),h&&d.push(h)}if(n.addedEditors)for(const s of n.addedEditors){const h=P.URI.revive(s.documentUri);I.ok(this._documents.has(h),`document '${h}' does not exist`),I.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(h).value,u=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>l.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(w=>D.Range.to(w)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,u)}n.newActiveEditor!==void 0&&(I.ok(n.newActiveEditor===null||this._editors.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this._activeEditorId=n.newActiveEditor),(0,f.dispose)(a),(0,f.dispose)(d),n.removedDocuments&&this._onDidRemoveDocuments.fire(a),n.addedDocuments&&this._onDidAddDocuments.fire(t),(n.removedEditors||n.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(n){return this._documents.get(n)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),n=>n.value)}getEditor(n){return this._editors.get(n)}activeEditor(n){if(!this._activeEditorId)return;const a=this._editors.get(this._activeEditorId);return n?a:a?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=i,e.ExtHostDocumentsAndEditors=i=je([$e(0,y.IExtHostRpcService),$e(1,v.ILogService)],i),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[346],Ce([1,0,19,4,6,151,15,7]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class p{constructor(R,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new F.Emitter,this._onDidChangeTextEditorOptions=new F.Emitter,this._onDidChangeTextEditorVisibleRanges=new F.Emitter,this._onDidChangeTextEditorViewColumn=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(f.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const D=this._extHostDocumentsAndEditors.allEditors();return R?D:D.map(v=>v.value)}async showTextDocument(R,D,v){let S;typeof D=="number"?S={position:A.ViewColumn.from(D),preserveFocus:v}:typeof D=="object"?S={position:A.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?A.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:S={preserveFocus:!1};const C=await this._proxy.$tryShowTextDocument(R.uri,S),c=C&&this._extHostDocumentsAndEditors.getEditor(C);if(c)return c.value;throw C?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,D){return new P.TextEditorDecorationType(this._proxy,R,D).value}$acceptEditorPropertiesChanged(R,D){const v=this._extHostDocumentsAndEditors.getEditor(R);if(!v)throw new Error("unknown text editor");if(D.options&&v._acceptOptions(D.options),D.selections){const S=D.selections.selections.map(A.Selection.to);v._acceptSelections(S)}if(D.visibleRanges){const S=I.coalesce(D.visibleRanges.map(A.Range.to));v._acceptVisibleRanges(S)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...D.options,lineNumbers:A.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const S=E.TextEditorSelectionChangeKind.fromValue(D.selections.source),C=D.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:C,kind:S})}if(D.visibleRanges){const S=I.coalesce(D.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(R){for(const D in R){const v=this._extHostDocumentsAndEditors.getEditor(D);if(!v)throw new Error("Unknown text editor");const S=A.ViewColumn.to(R[D]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=p}),define(ye[347],Ce([1,0,2,5,6,3,7,15,25,18]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class R{constructor(S,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(f.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this._providers.get(c.source)&&p.ExtensionIdentifier.equals(m,this._providers.get(c.source)?.extension)){const o=c.uri===void 0?void 0:I.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(D(o))?.get(c.handle)}else return;return c}})}async $getTimeline(S,C,c,m){return this._providers.get(S)?.provider.provideTimeline(I.URI.revive(C),c,m)}registerTimelineProvider(S,C,c,m){const o=new P.DisposableStore,i=this.convertTimelineItem(C.id,m,o).bind(this);let r;C.onDidChange&&(r=C.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:C.id}),this));const n=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:S,onDidChange:void 0,async provideTimeline(a,t,d){t?.resetCache&&(o.clear(),n.get(C.id)?.clear());const s=await C.provideTimeline(a,t,d);if(s==null)return;const h=i(a,t);return{...s,source:C.id,items:s.items.map(h)}},dispose(){for(const a of n.values())a.get(C.id)?.clear();r?.dispose(),o.dispose()}},c)}convertTimelineItem(S,C,c){return(m,o)=>{let i;if(o?.cacheResults){let r=this._itemsBySourceAndUriMap.get(S);r===void 0&&(r=new Map,this._itemsBySourceAndUriMap.set(S,r));const n=D(m);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...a}=r,t=`${S}|${r.id??r.timestamp}`;i?.set(t,r);let d,s,h;r.iconPath&&(n instanceof A.ThemeIcon?h={id:n.id,color:n.color}:I.URI.isUri(n)?(d=n,s=n):{light:d,dark:s}=n);let l;return A.MarkdownString.isMarkdownString(a.tooltip)?l=E.MarkdownString.from(a.tooltip):(0,y.isString)(a.tooltip)?l=a.tooltip:A.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=E.MarkdownString.from(a.detail)):(0,y.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:r.command?C.toInternal(r.command,c):void 0,icon:d,iconDark:s,themeIcon:h,tooltip:l,accessibilityInformation:r.accessibilityInformation}}}}registerTimelineProviderCore(S,C){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:C}),(0,P.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=R;function D(v){return v?.toString()}}),define(ye[348],Ce([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,26]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(n,a){if((0,R.isString)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.Disposable{constructor(a,t,d){super(),this._proxy=a,this.commands=t,this.logService=d,this.treeViews=new Map,this.treeDragAndDropService=new c.TreeViewsDnDService;function s(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>s(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(l=>s(l)?this.convertArgument(l):l):h})}registerTreeDataProvider(a,t,d){const s=this.createTreeView(a,{treeDataProvider:t},d);return{dispose:()=>s.dispose()}}createTreeView(a,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,w=this.createExtHostTreeView(a,t,d),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:h,hasHandleDrag:l,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this._proxy.$registerTreeViewDataProvider(a,k),g={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,m.checkProposedApiEnabled)(d,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,m.checkProposedApiEnabled)(d,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(_){(0,S.isMarkdownString)(_)&&(0,m.checkProposedApiEnabled)(d,"treeViewMarkdownMessage"),w.message=_},get title(){return w.title},set title(_){w.title=_},get description(){return w.description},set description(_){w.description=_},get badge(){return w.badge},set badge(_){_!==void 0&&y.ViewBadge.isViewBadge(_)?w.badge={value:Math.floor(Math.abs(_.value)),tooltip:_.tooltip}:_===void 0&&(w.badge=void 0)},reveal:(_,T)=>w.reveal(_,T),dispose:async()=>{await b,this.treeViews.delete(a),w.dispose()}};return this._register(g),g}$getChildren(a,t){const d=this.treeViews.get(a);return d?d.getChildren(t):Promise.reject(new E.NoTreeViewError(a))}async $handleDrop(a,t,d,s,h,l,u,w){const k=this.treeViews.get(a);if(!k)return Promise.reject(new E.NoTreeViewError(a));const b=v.DataTransfer.toDataTransfer(d,async g=>(await this._proxy.$resolveDropFileData(a,t,g)).buffer);return u===a&&w&&await this.addAdditionalTransferItems(b,k,w,h,l),k.onDrop(b,s,h)}async addAdditionalTransferItems(a,t,d,s,h){const l=this.treeDragAndDropService.removeDragOperationTransfer(h);if(l)(await l)?.forEach((u,w)=>{u&&a.set(w,u)});else if(h&&t.handleDrag){const u=t.handleDrag(d,a,s);this.treeDragAndDropService.addDragOperationTransfer(h,u),await u}return a}async $handleDrag(a,t,d,s){const h=this.treeViews.get(a);if(!h)return Promise.reject(new E.NoTreeViewError(a));const l=await this.addAdditionalTransferItems(new y.DataTransfer,h,t,s,d);if(!(!l||s.isCancellationRequested))return v.DataTransfer.from(l)}async $hasResolve(a){const t=this.treeViews.get(a);if(!t)throw new E.NoTreeViewError(a);return t.hasResolve}$resolve(a,t,d){const s=this.treeViews.get(a);if(!s)throw new E.NoTreeViewError(a);return s.resolveTreeItem(t,d)}$setExpanded(a,t,d){const s=this.treeViews.get(a);if(!s)throw new E.NoTreeViewError(a);s.setExpanded(t,d)}$setSelectionAndFocus(a,t,d){const s=this.treeViews.get(a);if(!s)throw new E.NoTreeViewError(a);s.setSelectionAndFocus(t,d)}$setVisible(a,t){const d=this.treeViews.get(a);if(!d){if(!t)return;throw new E.NoTreeViewError(a)}d.setVisible(t)}$changeCheckboxState(a,t){const d=this.treeViews.get(a);if(!d)throw new E.NoTreeViewError(a);d.setCheckboxState(t)}createExtHostTreeView(a,t,d){const s=this._register(new r(a,t,this._proxy,this.commands.converter,this.logService,d));return this.treeViews.set(a,s),s}convertArgument(a){const t=this.treeViews.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=i;class r extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(a,t,d,s,h,l){if(super(),this.viewId=a,this.proxy=d,this.commands=s,this.logService=h,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new P.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new P.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,l.contributes&&l.contributes.views)for(const b in l.contributes.views)for(const g of l.contributes.views[b])g.id===a&&(this._title=g.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(b=>this._onDidChangeData.fire({message:!1,element:b})));let u,w;const k=P.Event.debounce(this._onDidChangeData.event,(b,g)=>(b||(b={message:!1,elements:[]}),g.element!==!1&&(u||(u=new Promise(_=>w=_),this.refreshPromise=this.refreshPromise.then(()=>u)),Array.isArray(g.element)?b.elements.push(...g.element):b.elements.push(g.element)),g.message&&(b.message=!0),b),200,!0);this._register(k(({message:b,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=w;return u=null,this.refresh(g).then(()=>_())})),b&&this.proxy.$setMessage(this.viewId,v.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let d=this.getChildrenNodes(a);return d||(d=await this.fetchChildrenNodes(t)),d?d.map(s=>s.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const d=(0,R.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,R.isUndefinedOrNull)(t.focus)?!1:t.focus,h=(0,R.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(l=>this.resolveTreeNode(a,l[l.length-1]).then(u=>this.proxy.$reveal(this.viewId,{item:u.item,parentChain:l.map(w=>w.item)},{select:d,focus:s,expand:h})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:s,expand:h})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=v.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,t){const d=this.getExtensionElement(a);d&&(t?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelectionAndFocus(a,t){const d=!(0,D.equals)(this._selectedHandles,a);this._selectedHandles=a;const s=this._focusedHandle!==t;this._focusedHandle=t,d&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async d=>{const s=this.getExtensionElement(d.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:d.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(a,t,d){const s=[];for(const h of a){const l=this.getExtensionElement(h);l&&s.push(l)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,t,d),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,t,d){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,a,d):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,t){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(a);if(d){const s=this.nodes.get(d);if(s){const h=await this.dataProvider.resolveTreeItem(s.extensionItem,d,t)??s.extensionItem;return this.validateTreeItem(h),s.item.tooltip=this.getTooltip(h.tooltip),s.item.command=this.getCommand(s.disposableStore,h.command),s.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(t=>t?this.resolveUnknownParentChain(t).then(d=>this.resolveTreeNode(t,d[d.length-1]).then(s=>(d.push(s),d))):Promise.resolve([]))}resolveParent(a){const t=this.nodes.get(a);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,t){const d=this.nodes.get(a);return d?Promise.resolve(d):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>this.createHandle(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(s);if(h){const l=this.nodes.get(h);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(a){if(a){let t;if(typeof a=="string"){const d=this.getExtensionElement(a);t=d?this.nodes.get(d):void 0}else t=a;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const t=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=a?this.nodes.get(a):void 0,s=await this.dataProvider.getChildren(a);if(t.token.isCancellationRequested)return;const h=(0,D.coalesce)(s||[]),l=await Promise.all((0,D.coalesce)(h).map(w=>this.dataProvider.getTreeItem(w)));if(t.token.isCancellationRequested)return;const u=l.map((w,k)=>w?this.createAndRegisterTreeNode(h[k],w,d):null);return(0,D.coalesce)(u)}finally{t.dispose()}}refresh(a){if(a.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(a);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const t=new Set,d=a.map(h=>this.nodes.get(h));for(const h of d)if(h&&!t.has(h.item.handle)){let l=h;for(;l&&l.parent&&d.findIndex(u=>l&&l.parent&&u&&u.item.handle===l.parent.item.handle)===-1;){const u=this.elements.get(l.parent.item.handle);l=u?this.nodes.get(u):void 0}l&&!l.parent&&t.add(h.item.handle)}const s=[];return t.forEach(h=>{const l=this.elements.get(h);if(l){const u=this.nodes.get(l);u&&(!u.parent||!t.has(u.parent.item.handle))&&s.push(h)}}),s}refreshHandles(a){const t={};return Promise.all(a.map(d=>this.refreshNode(d).then(s=>{s&&(t[d]=s.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(a){const t=this.getExtensionElement(a);if(t){const d=this.nodes.get(t);if(d)return this.clearChildren(t),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(s=>{if(s){const h=this.createTreeNode(t,s,d.parent);return this.updateNodeCache(t,h,d,d.parent),d.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,t,d){const s=this.createTreeNode(a,t,d);if(t.id&&this.elements.has(s.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.addNodeToCache(a,s),this.addNodeToParentCache(s,d),s}getTooltip(a){return y.MarkdownString.isMarkdownString(a)?v.MarkdownString.from(a):a}getCommand(a,t){return t?{...this.commands.toInternal(t,a),originalId:t.command}:void 0}getCheckbox(a){if(a.checkboxState===void 0)return;let t,d,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,d=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:s}}validateTreeItem(a){if(!y.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,t,d){this.validateTreeItem(t);const s=this._register(new A.DisposableStore),h=this.createHandle(a,t,d),l=this.getLightIconPath(t);return{item:{handle:h,parentHandle:d?d.item.handle:void 0,label:o(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.getDarkIconPath(t)||l,themeIcon:this.getThemeIcon(t),collapsibleState:(0,R.isUndefinedOrNull)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:d,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(a){return a.iconPath instanceof y.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:t,label:d,resourceUri:s},h,l){if(t)return`${r.ID_HANDLE_PREFIX}/${t}`;const u=o(d,this.extension),w=h?h.item.handle:r.LABEL_HANDLE_PREFIX;let k=u?u.label:s?(0,F.basename)(s):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const b=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,g=this.getChildrenNodes(h)||[];let _,T=0;do{if(_=`${w}/${T}:${k}`,l||!this.elements.has(_)||b===_)break;T++}while(T<=g.length);return _}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof y.ThemeIcon))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof y.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return f.URI.isUri(a)?a:f.URI.file(a)}addNodeToCache(a,t){this.elements.set(t.item.handle,a),this.nodes.set(a,t)}updateNodeCache(a,t,d,s){this.elements.delete(t.item.handle),this.nodes.delete(a),t.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(a,t);const h=this.getChildrenNodes(s)||[],l=h.filter(u=>u.item.handle===d.item.handle)[0];l&&h.splice(h.indexOf(l),1,t)}addNodeToParentCache(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const t=this.nodes.get(a);if(t){if(t.children)for(const d of t.children){const s=this.elements.get(d.item.handle);s&&this.clear(s)}t.children=void 0}}else this.clearAll()}clear(a){const t=this.nodes.get(a);if(t){if(t.children)for(const d of t.children){const s=this.elements.get(d.item.handle);s&&this.clear(s)}this.nodes.delete(a),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(ye[349],Ce([1,0,4,3,2,30,15,93,6,7]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends F.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(C,c,m,o){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=C,this.#t=c,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#l=o.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(C){this.assertNotDisposed(),this.#r!==C&&(this.#r=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(C){this.assertNotDisposed(),this.#a!==C&&(this.#a=C,this.#t.$setIconPath(this.#e,f.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(C){this.#u||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#l=C.active,this.#c=C.visible,this.#o=C.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(C,c){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:A.ViewColumn.from(C),preserveFocus:!!c})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class D extends F.Disposable{static newHandle(){return(0,P.generateUuid)()}constructor(C,c,m){super(),this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=C.getProxy(p.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(C=>C.dispose()),this._webviewPanels.clear()}createWebviewPanel(C,c,m,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:A.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,E.shouldSerializeBuffersForPostMessage)(C),t=D.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(C),t,c,{title:m,panelOptions:v(i),webviewOptions:(0,E.serializeWebviewOptions)(C,this.workspace,i),serializeBuffersForPostMessage:a},n);const d=this.webviews.createNewWebview(t,i,C);return this.createNewWebviewPanel(t,c,m,r,i,d,!0)}$onDidChangeWebviewPanelViewStates(C){const c=Object.keys(C);c.sort((m,o)=>{const i=C[m],r=C[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const m of c){const o=this.getWebviewPanel(m);if(!o)continue;const i=C[m];o._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this._webviewPanels.delete(C),this.webviews.deleteWebview(C)}registerWebviewPanelSerializer(C,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:C}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(C)}),new y.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(C,c,m,o){const i=this._serializers.get(c);if(!i)throw new Error(`No serializer found for '${c}'`);const{serializer:r,extension:n}=i,a=this.webviews.createNewWebview(C,m.webviewOptions,n),t=this.createNewWebviewPanel(C,c,m.title,o,m.panelOptions,a,m.active);await r.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(C,c,m,o,i,r,n){const a=new R(C,this._proxy,r,{viewType:c,title:m,viewColumn:o,panelOptions:i,active:n});return this._webviewPanels.set(C,a),a}getWebviewPanel(C){return this._webviewPanels.get(C)}}e.ExtHostWebviewPanels=D;function v(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ye[350],Ce([1,0,4,3,93,15,6,7]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends F.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,v,S,C,c,m){super(),this.#s=!1,this.#l=this._register(new I.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new I.Emitter),this.onDidDispose=this.#u.event,this.#i=S,this.#a=C,this.#e=D,this.#t=v,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(D){this.assertNotDisposed(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.assertNotDisposed(),this.#o}set description(D){this.assertNotDisposed(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(D){this.assertNotDisposed(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.assertNotDisposed(),this.#t.$show(this.#e,!!D)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(D,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(D,v,S,C){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:S,extension:D}),this._proxy.$registerWebviewViewProvider((0,f.toExtensionData)(D),v,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.shouldSerializeBuffersForPostMessage)(D)}),new E.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(D,v,S,C,c){const m=this._viewProviders.get(v);if(!m)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:i}=m,r=this._extHostWebview.createNewWebview(D,{},i),n=new p(D,this._proxy,v,S,r,!0);this._webviewViews.set(D,n),await o.resolveWebviewView(n,{state:C},c)}async $onDidChangeWebviewViewVisibility(D,v){this.getWebviewView(D)._setVisible(v)}async $disposeWebviewView(D){const v=this.getWebviewView(D);this._webviewViews.delete(D),v.dispose(),this._extHostWebview.deleteWebview(D)}getWebviewView(D){const v=this._webviewViews.get(D);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=y}),define(ye[351],Ce([1,0,69,16,13,249,32,10]),function(me,e,I,F,f,P,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let p=class{constructor(D,v){D.addFileSystemProvider(F.Schemas.file,new y(v),{isCaseSensitive:E.isLinux})}};e.ExtHostDiskFileSystemProvider=p,e.ExtHostDiskFileSystemProvider=p=je([$e(0,I.IExtHostConsumerFileSystem),$e(1,f.ILogService)],p);class y{constructor(D){this.logService=D,this.impl=new P.DiskFileSystemProvider(this.logService)}async stat(D){const v=await this.impl.stat(D);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.impl.readdir(D)}createDirectory(D){return this.impl.mkdir(D)}readFile(D){return this.impl.readFile(D)}writeFile(D,v,S){return this.impl.writeFile(D,v,{...S,unlock:!1,atomic:!1})}delete(D,v){return this.impl.delete(D,{...v,useTrash:!1,atomic:!1})}rename(D,v,S){return this.impl.rename(D,v,S)}copy(D,v,S){return this.impl.copy(D,v,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,v){throw new Error("Method not implemented.")}}}),define(ye[352],Ce([1,0,17,63,30,33,3,6,2,20]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends A.Disposable{constructor(v,S){super();const C=v.getProxy(E.MainContext.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=p.URI.file((0,I.join)((0,F.tmpdir)(),(0,f.generateUuid)()));return await C.$download(c,m),m})}};e.ExtHostDownloadService=R,e.ExtHostDownloadService=R=je([$e(0,y.IExtHostRpcService),$e(1,P.IExtHostCommands)],R)}),define(ye[353],Ce([1,0,57,17,2,94,3,16,11,31]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const d=await super._getWorkspaceStorageURI(t);if(d.scheme!==E.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const s=d.fsPath;let h=0;do{let l;h===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${h}`:`${s}-${h}`,await D(l);const u=F.join(l,"vscode.lock"),w=await c(this._logService,u,!1);if(w)return this._workspaceStorageLock=w,process.on("exit",()=>{w.dispose()}),f.URI.file(l);h++}while(h<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function D(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const v=1e3,S=10*60*1e3;class C extends A.Disposable{constructor(t,d){super(),this.logService=t,this.filename=d,this._timer=this._register(new p.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await m(t,d);(!s||s.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await y.Promises.utimes(d,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${d}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{I.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function c(a,t,d){try{const h={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){a.error(h)}const s=await m(a,t);return!s||s.pid!==process.pid?d?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new C(a,t))}async function m(a,t){let d;try{d=await y.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(d))}catch(s){return a.error(s),null}}async function o(a,t){let d;try{d=await y.Promises.stat(t)}catch(s){return a.error(s),0}return d.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function r(a,t){const d=await m(a,t);if(!d)return a.info(`Lock '${t}': Could not read pid of lock holder.`),n(a,t);if(d.willReleaseAt){let w=d.willReleaseAt-Date.now();if(w<5e3){for(w>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,p.timeout)(Math.min(100,w)),await o(a,t)===0)return n(a,t);w=d.willReleaseAt-Date.now()}return n(a,t)}}if(!i(d.pid))return a.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),n(a,t);const s=await o(a,t),h=Date.now()-s;if(h<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.timeout)(2e3);const l=await o(a,t),u=Date.now()-l;return u<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(a,t))}async function n(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return c(a,t,!0)}}),define(ye[354],Ce([1,0,30,20,46,33]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends f.BaseExtHostTerminalService{constructor(p,y){super(!0,p,y)}createTerminal(p,y,R){return this.createTerminalFromOptions({name:p,shellPath:y,shellArgs:R})}createTerminalFromOptions(p,y){const R=new f.ExtHostTerminal(this._proxy,(0,I.generateUuid)(),p,p.name);return this._terminals.push(R),R.create(p,this._serializeParentTerminal(p,y)),R.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=je([$e(0,P.IExtHostCommands),$e(1,F.IExtHostRpcService)],A)}),define(ye[355],Ce([1,0,4,37,45,5]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new f.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new f.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new f.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class E{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(y){this.channels.has(y.id)||(this.channels.set(y.id,y),this._onDidRegisterChannel.fire(y.id))}getChannels(){const y=[];return this.channels.forEach(R=>y.push(R)),y}getChannel(y){return this.channels.get(y)}removeChannel(y){this.channels.delete(y),this._onDidRemoveChannel.fire(y)}}F.Registry.add(e.Extensions.OutputChannels,new E),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new f.RawContextKey("activeOutputChannel","")}),define(ye[152],Ce([1,0,6,5,20,25,13,355,69,27,59,182,22,18,32,4,3]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(a,t,d,s,h){super(),this.id=a,this.name=t,this.logger=d,this.proxy=s,this.extension=h,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(d.getLevel()),this._register(d.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.offset;this.info(a),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(a,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.proxy.$close(this.id)}log(a,t){this.offset+=v.VSBuffer.fromString(t).byteLength,(0,A.log)(this.logger,a,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class i extends o{appendLine(a){this.append(a)}}let r=class{constructor(a,t,d,s,h,l){this.initData=t,this.extHostFileSystem=d,this.extHostFileSystemInfo=s,this.loggerService=h,this.logService=l,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[t,d]of this.channels)d.visible=t===this.visibleChannelId}createOutputChannel(a,t,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,h=(0,S.isString)(t)?t:void 0;if((0,S.isString)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const u=this.initData.environment.extensionLogLevel?.find(([k])=>P.ExtensionIdentifier.equals(d.identifier,k))?.[1];u&&(l=(0,A.parseLogLevel)(u));const w=s?this.doCreateLogOutputChannel(a,l,d):this.doCreateOutputChannel(a,h,d);return w.then(k=>{this.channels.set(k.id,k),k.visible=k.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(a,l??this.logService.getLevel(),w):this.createExtHostOutputChannel(a,w)}async doCreateOutputChannel(a,t,d){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,h=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.proxy.$register(a,h,t,d.identifier.value);return new o(u,a,l,this.proxy,d)}async doCreateLogOutputChannel(a,t,d){const s=await this.createExtensionLogDirectory(d),h=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.extHostFileSystemInfo.extUri.joinPath(s,`${h}.log`),u=`${d.identifier.value}.${h}`,w=this.loggerService.createLogger(l,{id:u,name:a,logLevel:t,extensionId:d.identifier.value});return new i(u,a,w,this.proxy,d)}createExtensionLogDirectory(a){let t=this.extensionLogDirectoryPromise.get(a.identifier.value);if(!t){const d=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,a.identifier.value);this.extensionLogDirectoryPromise.set(a.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(d)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return d})())}return t}createExtHostOutputChannel(a,t){let d=!1;const s=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return a},append(h){s(),t.then(l=>l.append(h))},appendLine(h){s(),t.then(l=>l.appendLine(h))},clear(){s(),t.then(h=>h.clear())},replace(h){s(),t.then(l=>l.replace(h))},show(h,l){s(),t.then(u=>u.show(h,l))},hide(){s(),t.then(h=>h.hide())},dispose(){d=!0,t.then(h=>h.dispose())}}}createExtHostLogOutputChannel(a,t,d){const s=new m.DisposableStore,h=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new c.Emitter);function u(w){t=w,l.fire(w)}return d.then(w=>{s.add(w),w.logLevel!==t&&u(w.logLevel),s.add(w.onDidChangeLogLevel(k=>u(k)))}),{...this.createExtHostOutputChannel(a,d),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(w,...k){h(),d.then(b=>b.trace(w,...k))},debug(w,...k){h(),d.then(b=>b.debug(w,...k))},info(w,...k){h(),d.then(b=>b.info(w,...k))},warn(w,...k){h(),d.then(b=>b.warn(w,...k))},error(w,...k){h(),d.then(b=>b.error(w,...k))},dispose(){s.dispose()}}}};e.ExtHostOutputService=r,e.ExtHostOutputService=r=je([$e(0,f.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,p.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,A.ILoggerService),$e(5,A.ILogService)],r),e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(ye[153],Ce([1,0,5,11]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let P=1/0;for(let E=0;E<this.maxSampleCount;E++){const p=await f.getRoundTripTime();if(p===void 0)return;P=Math.min(P,p/2),await(0,F.timeout)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((E,p)=>E+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((E,p)=>E+p,0)/this.average.length,high:(()=>typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ye[356],Ce([1,0,223,87,37,40,51,3,4,153,10,24]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchConfigurationWorkbenchContribution=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new p.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const S=new v;f.Registry.add(e.Extensions.ConfigurationMigration,S);let C=class extends E.Disposable{constructor(o,i){super(),this.configurationService=o,this.workspaceService=i,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.migrateConfigurationsForFolder(n,S.migrations)})),this.migrateConfigurations(S.migrations),this._register(S.onDidRegisterConfigurationMigration(r=>this.migrateConfigurations(r)))}async migrateConfigurations(o){await this.migrateConfigurationsForFolder(void 0,o);for(const i of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(i,o)}async migrateConfigurationsForFolder(o,i){await Promise.all([i.map(r=>this.migrateConfigurationsForFolderAndOverride(r,o?.uri))])}async migrateConfigurationsForFolderAndOverride(o,i){const r=this.configurationService.inspect(o.key,{resource:i}),n=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of n){const d=[];for(const h of r.overrideIdentifiers??[]){const l=await this.runMigration(o,{resource:i,overrideIdentifier:h},a);for(const u of l??[]){let w=d.find(([[k,b]])=>k===u[0]&&(0,D.equals)(b.value,u[1].value));w||d.push(w=[u,[]]),w[1].push(h)}}const s=await this.runMigration(o,{resource:i},a,r);for(const h of s??[])d.push([h,[]]);d.length&&await Promise.allSettled(d.map(async([[h,l],u])=>this.configurationService.updateValue(h,l.value,{resource:i,overrideIdentifiers:u},t)))}}async runMigration(o,i,r,n){const a=h=>t(this.configurationService.inspect(h,i)),t=h=>{const l=h[r];return i.overrideIdentifier?l?.override:l?.value},d=n?t(n):a(o.key);if(d===void 0)return;const s=await o.migrateFn(d,a);return Array.isArray(s)?s:[[o.key,s]]}};e.ConfigurationMigrationWorkbenchContribution=C,e.ConfigurationMigrationWorkbenchContribution=C=je([$e(0,A.IConfigurationService),$e(1,P.IWorkspaceContextService)],C);let c=class extends E.Disposable{constructor(o){super(),(async()=>{if(!R.isWindows&&(await o.getEnvironment())?.os!==1)return;f.Registry.as(F.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})})()}};e.DynamicWorkbenchConfigurationWorkbenchContribution=c,e.DynamicWorkbenchConfigurationWorkbenchContribution=c=je([$e(0,y.IRemoteAgentService)],c)}),define(ye[357],Ce([1,0,35,16,17,23,232,356,87,5,37]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,y.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const D=R.Registry.as(p.Extensions.Configuration),v={...E.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(v);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var C;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(C||(e.ResolvedStatus=C={}));function c(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}e.priorityToRank=c;function m(o,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.posix.sep)>=0?`${i.scheme}:${i.path}`:(0,P.basename)(i);return I.match(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.globMatchesResource=m}),define(ye[358],Ce([1,0,34,16,17,10,23,2,5,267,40,143,153]),function(me,e,I,F,f,P,A,E,p,y,R,D,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,p.createDecorator)("pathService");let C=S=class{constructor(m,o,i,r){this.localUserHome=m,this.remoteAgentService=o,this.environmentService=i,this.contextService=r,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const n=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=n?.userHome??m})()}hasValidBasename(m,o,i){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(r=>this.doHasValidBasename(m,r,o)):this.doHasValidBasename(m,o,i)}doHasValidBasename(m,o,i){return m.scheme===F.Schemas.file||m.scheme===F.Schemas.vscodeRemote?(0,I.isValidBasename)(i??(0,A.basename)(m),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,y.getVirtualWorkspaceScheme)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:F.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?f.win32:f.posix)}async fileURI(m){let o="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const r=m.indexOf("/",2);r===-1?(o=m.substring(2),m="/"):(o=m.substring(2,r),m=m.substring(r)||"/")}return E.URI.from({scheme:F.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.AbstractPathService=C,e.AbstractPathService=C=S=je([$e(1,v.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],C)}),define(ye[359],Ce([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,26,21,18,24,45]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,d="remote.tunnels.toRestore";e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new a.RawContextKey("forwardedPortsViewEnabled",!1,I.localize(0,null));function s(O){const x=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(x)return{host:x[1]?.substring(0,x[1].length-1)||"localhost",port:Number(x[2])}}e.parseAddress=s;var h;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var l;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.UserTunnelSource={source:l.User,description:I.localize(1,null)},e.AutoTunnelSource={source:l.Auto,description:I.localize(2,null)};function u(O,x,N){const M=O.get(k(x,N));if(M)return M;if((0,C.isLocalhost)(x))for(const L of C.LOCALHOST_ADDRESSES){const U=k(L,N);if(O.has(U))return O.get(U)}else if((0,C.isAllInterfaces)(x))for(const L of C.ALL_INTERFACES_ADDRESSES){const U=k(L,N);if(O.has(U))return O.get(U)}}e.mapHasAddress=u;function w(O,x,N){const M=u(O,x,N);if(M)return M;const L=(0,C.isAllInterfaces)(x)?"localhost":(0,C.isLocalhost)(x)?"0.0.0.0":void 0;if(L)return u(O,L,N)}e.mapHasAddressLocalhostOrAllInterfaces=w;function k(O,x){return O+":"+x}e.makeAddress=k;var b;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(b||(e.OnPortForward=b={}));function g(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.isCandidatePort=g;class _ extends E.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(x){super(),this.configurationService=x,this.portsAttributes=[],this._onDidChangeAttributes=new P.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(x.onDidChangeConfiguration(N=>{(N.affectsConfiguration(_.SETTING)||N.affectsConfiguration(_.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(x,N,M){let L=this.findNextIndex(x,N,M,this.portsAttributes,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;L>=0;){const B=this.portsAttributes[L];B.key===x?(U.onAutoForward=B.onAutoForward??U.onAutoForward,U.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:U.elevateIfNeeded,U.label=B.label??U.label,U.requireLocalPort=B.requireLocalPort,U.protocol=B.protocol):(U.onAutoForward=U.onAutoForward??B.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:B.elevateIfNeeded,U.label=U.label??B.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??B.protocol),L=this.findNextIndex(x,N,M,this.portsAttributes,L+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.getOtherAttributes()}hasStartEnd(x){return x.start!==void 0&&x.end!==void 0}hasHostAndPort(x){return x.host!==void 0&&x.port!==void 0&&(0,r.isString)(x.host)&&(0,r.isNumber)(x.port)}findNextIndex(x,N,M,L,U){if(U>=L.length)return-1;const B=!(0,C.isLocalhost)(N)&&!(0,C.isAllInterfaces)(N),le=L.slice(U).findIndex(Y=>(0,r.isNumber)(Y.key)?B?!1:Y.key===x:this.hasStartEnd(Y.key)?B?!1:x>=Y.key.start&&x<=Y.key.end:this.hasHostAndPort(Y.key)?x===Y.key.port&&N===Y.key.host:M?Y.key.test(M):!1);return le>=0?le+U:-1}readSetting(){const x=this.configurationService.getValue(_.SETTING);if(!x||!(0,r.isObject)(x))return[];const N=[];for(const L in x){if(L===void 0)continue;const U=x[L];let B;if(Number(L))B=Number(L);else if((0,r.isString)(L))if(_.RANGE.test(L)){const G=L.match(_.RANGE);B={start:Number(G[1]),end:Number(G[2])}}else if(_.HOST_AND_PORT.test(L)){const G=L.match(_.HOST_AND_PORT);B={host:G[1],port:Number(G[2])}}else{let G;try{G=RegExp(L)}catch{}G&&(B=G)}B&&N.push({key:B,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const M=this.configurationService.getValue(_.DEFAULTS);return M&&(this.defaultPortAttributes={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.sortAttributes(N)}sortAttributes(x){function N(M,L){return(0,r.isNumber)(M.key)?M.key:L.hasStartEnd(M.key)?M.key.start:L.hasHostAndPort(M.key)?M.key.port:Number.MAX_VALUE}return x.sort((M,L)=>N(M,this)-N(L,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(x){switch(x){case C.ProvidedOnAutoForward.Notify:return b.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case C.ProvidedOnAutoForward.Silent:return b.Silent;case C.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(x,N,M){const U=this.configurationService.inspect(_.SETTING).userRemoteValue;let B;!U||!(0,r.isObject)(U)?B={}:B=(0,n.deepClone)(U),B[`${x}`]||(B[`${x}`]={});for(const G in N)B[`${x}`][G]=N[G];return this.configurationService.updateValue(_.SETTING,B,M)}}e.PortsAttributes=_;let T=class extends E.Disposable{constructor(x,N,M,L,U,B,G,le,Y,K){super(),this.tunnelService=x,this.storageService=N,this.configurationService=M,this.environmentService=L,this.remoteAuthorityResolverService=U,this.workspaceContextService=B,this.logService=G,this.dialogService=le,this.extensionService=Y,this.contextKeyService=K,this.inProgress=new Map,this._onForwardPort=new P.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new P.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new P.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new P.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new P.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new P.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new _(M),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async Q=>{const ue=await this.getAttributes(Q.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of Q)if(ne.localAddress){const pe=k(ne.tunnelRemoteHost,ne.tunnelRemotePort),oe=w(this._candidates??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(pe,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ue?.get(ne.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(ne.localAddress,ue?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:ne.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(pe,ne)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async Q=>{const ue=k(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!w(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!w(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!w(this.inProgress,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const ne=w(this._candidates??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),pe=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:pe?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(Q.localAddress,pe),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:Q.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(ue,Q),this._onForwardPort.fire(this.forwarded.get(ue))})),this._register(this.tunnelService.onTunnelClosed(Q=>this.onTunnelClosed(Q,h.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(x=>x.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const x=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&x.dispose()}))}async onTunnelClosed(x,N){const M=k(x.host,x.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.storeForwarded(),this._onClosePort.fire(x))}makeLocalUri(x,N){if(x.startsWith("http"))return p.URI.parse(x);const M=N?.protocol??"http";return p.URI.parse(`${M}://${x}`)}async getStorageKey(){const x=this.workspaceContextService.getWorkspace(),N=x.configuration?(0,A.hash)(x.configuration.path):x.folders.length>0?(0,A.hash)(x.folders[0].uri.path):void 0;if(N===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${d}.${this.environmentService.remoteAuthority}.${N}`}async getTunnelRestoreValue(){const x=this.storageService.get(d,1);if(x)return this.storageService.remove(d,1),await this.storeForwarded(),x;const N=await this.getStorageKey();if(N)return this.storageService.get(N,0)}async restoreForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const x=await this.tunnelRestoreValue;if(x&&x!==this.knownPortsRestoreValue){const N=JSON.parse(x)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(M=>M.remotePort).join(", ")}`);for(const M of N){const L=w(this.detected,M.remoteHost,M.remotePort);M.source.source!==l.Extension&&!L||M.source.source===l.Extension&&L?await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,privacy:M.privacy,elevateIfNeeded:!0,source:M.source}):M.source.source===l.Extension&&!L&&this.unrestoredExtensionTunnels.set(k(M.remoteHost,M.remotePort),M)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const x=await this.getStorageKey();this.restoreListener=this._register(new E.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async N=>{N.key===x&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(x,0)),await this.restoreForwarded())}))}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const x=JSON.stringify(Array.from(this.forwarded.values()));if(x!==this.knownPortsRestoreValue){this.knownPortsRestoreValue=x;const N=await this.getStorageKey();N&&this.storageService.store(N,this.knownPortsRestoreValue,0,0)}}}async showPortMismatchModalIfNeeded(x,N,M){if(!x.tunnelLocalPort||!M?.requireLocalPort||x.tunnelLocalPort===N)return;const L=new Date;if(this.mismatchCooldown.getTime()+t>L.getTime())return;this.mismatchCooldown=L;const U=I.localize(3,null,N,x.tunnelRemotePort,x.tunnelLocalPort);return this.dialogService.info(U)}async forward(x,N){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await P.Event.toPromise(this.onRestoreComplete.event),this.doForward(x,N)}async doForward(x,N){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const M=w(this.forwarded,x.remote.host,x.remote.port);N=N??(N!==null?(await this.getAttributes([x.remote]))?.get(x.remote.port):void 0);const L=x.local!==void 0?x.local:x.remote.port;let U;if(M)return this.mergeAttributesIntoExistingTunnel(M,x,N);{const B=this.environmentService.remoteAuthority,G=B?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(B)).authority}:void 0,le=k(x.remote.host,x.remote.port);this.inProgress.set(le,!0),x=this.mergeCachedAndUnrestoredProperties(le,x);const Y=await this.tunnelService.openTunnel(G,x.remote.host,x.remote.port,void 0,L,x.elevateIfNeeded?x.elevateIfNeeded:N?.elevateIfNeeded,x.privacy,N?.protocol);if(typeof Y=="string")U=Y;else if(Y&&Y.localAddress){const K=w(this._candidates??new Map,x.remote.host,x.remote.port),Q=Y.protocol?Y.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:N?.protocol??C.TunnelProtocol.Http,ue={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:N?.label??x.name,closeable:!0,localAddress:Y.localAddress,protocol:Q,localUri:await this.makeLocalUri(Y.localAddress,N),runningProcess:K?.detail,hasRunningProcess:!!K,pid:K?.pid,source:x.source??e.UserTunnelSource,privacy:Y.privacy};return this.forwarded.set(le,ue),this.remoteTunnels.set(le,Y),this.inProgress.delete(le),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(Y,L,N),this._onForwardPort.fire(ue),Y}this.inProgress.delete(le)}return U}mergeCachedAndUnrestoredProperties(x,N){const M=this.unrestoredExtensionTunnels.has(x)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(x)?this.sessionCachedProperties:void 0;if(M){const L=M.get(x);M.delete(x),L&&(N.name=L.name??N.name,N.local=("local"in L?L.local:"localPort"in L?L.localPort:void 0)??N.local,N.privacy=L.privacy??N.privacy)}return N}async mergeAttributesIntoExistingTunnel(x,N,M){const L=M?.label??N.name;let U;(function(G){G[G.None=0]="None",G[G.Fire=1]="Fire",G[G.Reopen=2]="Reopen"})(U||(U={}));let B=U.None;switch(L!==x.name&&(x.name=L,B=U.Fire),(M?.protocol||x.protocol!==C.TunnelProtocol.Http)&&M?.protocol!==x.protocol&&(N.source=x.source,B=U.Reopen),N.privacy&&x.privacy!==N.privacy&&(B=U.Reopen),B){case U.Fire:{this._onForwardPort.fire();break}case U.Reopen:await this.close(x.remoteHost,x.remotePort,h.User),await this.doForward(N,M)}return w(this.remoteTunnels,N.remote.host,N.remote.port)}async name(x,N,M){const L=w(this.forwarded,x,N),U=k(x,N);if(L){L.name=M,await this.storeForwarded(),this._onPortName.fire({host:x,port:N});return}else this.detected.has(U)&&(this.detected.get(U).name=M,this._onPortName.fire({host:x,port:N}))}async close(x,N,M){const L=k(x,N),U=this.forwarded.get(L);return M===h.AutoForwardEnd&&U&&U.source.source===l.Auto&&this.sessionCachedProperties.set(L,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.tunnelService.closeTunnel(x,N),this.onTunnelClosed({host:x,port:N},M)}address(x,N){const M=k(x,N);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(x){if(x)for(const N of x){const M=w(this._candidates??new Map,N.remoteAddress.host,N.remoteAddress.port),L=typeof N.localAddress=="string"?N.localAddress:k(N.localAddress.host,N.localAddress.port);this.detected.set(k(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:L,protocol:C.TunnelProtocol.Http,localUri:this.makeLocalUri(L),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:I.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,L,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(x){this._candidateFilter=x}async setCandidates(x){let N=x;this._candidateFilter&&(N=await this._candidateFilter(x));const M=this.updateInResponseToCandidates(N);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(L=>L.port).join(", ")}`),this._onCandidatesChanged.fire(M)}updateInResponseToCandidates(x){const N=this._candidates??new Map,M=new Map;return this._candidates=M,x.forEach(L=>{const U=k(L.host,L.port);M.set(U,{host:L.host,port:L.port,detail:L.detail,pid:L.pid}),N.has(U)&&N.delete(U);const B=w(this.forwarded,L.host,L.port);B&&(B.runningProcess=L.detail,B.hasRunningProcess=!0,B.pid=L.pid)}),N.forEach((L,U)=>{const B=s(U);if(!B)return;const G=w(this.forwarded,B.host,B.port);G&&(G.runningProcess=void 0,G.hasRunningProcess=!1,G.pid=void 0);const le=w(this.detected,B.host,B.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),N}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const x=Array.from(this.forwarded.values()),N=await this.getAttributes(x.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(N)for(const M of x){const L=N.get(M.remotePort);(L?.protocol||M.protocol!==C.TunnelProtocol.Http)&&L?.protocol!==M.protocol&&await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},L),L&&L.label&&L.label!==M.name&&await this.name(M.remoteHost,M.remotePort,L.label)}}async getAttributes(x,N=!0){const M=new Map,L=new Map;x.forEach(Y=>{const K=w(this._candidates??new Map,C.LOCALHOST_ADDRESSES[0],Y.port)??Y;if(K){M.set(Y.port,K);const Q=g(K)?K.pid:void 0;L.has(Q)||L.set(Q,[]),L.get(Q)?.push(Y.port)}});const U=new Map;if(x.forEach(Y=>{const K=this.configPortsAttributes.getAttributes(Y.port,Y.host,M.get(Y.port)?.detail);K&&U.set(Y.port,K)}),this.portAttributesProviders.length===0||!N)return U.size>0?U:void 0;const B=await Promise.all((0,F.flatten)(this.portAttributesProviders.map(Y=>Array.from(L.entries()).map(K=>{const Q=K[1],ue=M.get(Q[0]);return Y.providePortAttributes(Q,ue?.pid,ue?.detail,new i.CancellationTokenSource().token)})))),G=new Map;if(B.forEach(Y=>Y.forEach(K=>{K&&G.set(K.port,K)})),!U&&!G)return;const le=new Map;return x.forEach(Y=>{const K=U.get(Y.port),Q=G.get(Y.port);le.set(Y.port,{elevateIfNeeded:K?.elevateIfNeeded,label:K?.label,onAutoForward:K?.onAutoForward??_.providedActionToAction(Q?.autoForwardAction),requireLocalPort:K?.requireLocalPort,protocol:K?.protocol})}),le}addAttributesProvider(x){this.portAttributesProviders.push(x)}};e.TunnelModel=T,je([(0,f.debounce)(1e3)],T.prototype,"storeForwarded",null),e.TunnelModel=T=je([$e(0,C.ITunnelService),$e(1,S.IStorageService),$e(2,y.IConfigurationService),$e(3,m.IWorkbenchEnvironmentService),$e(4,v.IRemoteAuthorityResolverService),$e(5,c.IWorkspaceContextService),$e(6,D.ILogService),$e(7,R.IDialogService),$e(8,o.IExtensionService),$e(9,a.IContextKeyService)],T)}),define(ye[95],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(A,E){this.line=A,this.character=E}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,E){return new I(0,0)}with(A){return new I(0,0)}}e.Position=I;class F{constructor(A,E,p,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,E),this.end=new I(p,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var f;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ye[36],Ce([1,0,19,35,24,34,12,5,17,14,95,11]),function(me,e,I,F,f,P,A,E,p,y,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",S=" characters skipped \u27EB",C=(v.length+S.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var c;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(c||(e.SearchProviderType=c={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(m||(e.QueryType=m={}));function o(Q){return!!Q.preview}e.resultIsMatch=o;function i(Q){return!!Q.resource}e.isFileMatch=i;function r(Q){return!!Q.message}e.isProgressMessage=r;var n;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class a{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=a;class t{constructor(ue,ne,pe,oe){this.ranges=ne,this.webviewIndex=oe;const q=Array.isArray(ne)?ne:[ne];if(pe&&pe.matchLines===1&&d(q)){ue=(0,A.getNLines)(ue,pe.matchLines);let W="",ie=0,Se=0;const he=Math.floor(pe.charsPerLine/5),fe=[];for(const Z of q){const ee=Math.max(Z.startColumn-he,0),j=Z.startColumn+pe.charsPerLine;if(ee>Se+he+C){const J=v+(ee-Se)+S;W+=J+ue.slice(ee,j),ie+=ee-(Se+J.length)}else W+=ue.slice(Se,j);fe.push(new h(0,Z.startColumn-ie,Z.endColumn-ie)),Se=j}this.preview={text:W,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const W=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:ue,matches:(0,I.mapArrayOrNot)(ne,ie=>new s(ie.startLineNumber-W,ie.startColumn,ie.endLineNumber-W,ie.endColumn))}}}}e.TextSearchMatch=t;function d(Q){const ue=Q[0].startLineNumber;for(const ne of Q)if(ne.startLineNumber!==ue||ne.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,ne,pe,oe){this.startLineNumber=ue,this.startColumn=ne,this.endLineNumber=pe,this.endColumn=oe}}e.SearchRange=s;class h extends s{constructor(ue,ne,pe){super(ue,ne,ue,pe)}}e.OneLineRange=h;var l;(function(Q){Q.List="list",Q.Tree="tree"})(l||(e.ViewMode=l={}));var u;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function w(Q,ue=!0){const ne=Q&&Q.files&&Q.files.exclude,pe=ue&&Q&&Q.search&&Q.search.exclude;if(!ne&&!pe)return;if(!ne||!pe)return ne||pe;let oe=Object.create(null);return oe=f.mixin(oe,f.deepClone(ne)),oe=f.mixin(oe,f.deepClone(pe),!0),oe}e.getExcludes=w;function k(Q,ue){return Q.excludePattern&&F.match(Q.excludePattern,ue)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&F.match(Q.includePattern,ue)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ne=>{const pe=ne.folder.fsPath;if(P.isEqualOrParent(ue,pe)){const oe=p.relative(pe,ue);return!ne.includePattern||!!F.match(ne.includePattern,oe)}else return!1}):!1:!0}e.pathIncludedInQuery=k;var b;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class g extends Error{constructor(ue,ne){super(ue),this.code=ne}}e.SearchError=g;function _(Q){const ue=Q.message;if((0,y.isCancellationError)(Q))return new g(ue,b.canceled);try{const ne=JSON.parse(ue);return new g(ne.message,ne.code)}catch{return new g(ue,b.other)}}e.deserializeSearchError=_;function T(Q){const ue={message:Q.message,code:Q.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=T;function O(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=O;function x(Q){return Q.type==="success"}e.isSerializedSearchSuccess=x;function N(Q){return!!Q.path}e.isSerializedFileMatch=N;function M(Q,ue){const ne=Q.searchPath?Q.searchPath:Q.relativePath;return(0,A.fuzzyContains)(ne,ue)}e.isFilePatternMatch=M;class L{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function U(Q,ue){const ne={...Q||{},...ue||{}};return Object.keys(ne).filter(pe=>{const oe=ne[pe];return typeof oe=="boolean"&&oe})}e.resolvePatternsForProvider=U;class B{constructor(ue,ne){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...ne.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let pe=ue.includePattern;ne.includePattern&&(pe?pe={...pe,...ne.includePattern}:pe=ne.includePattern),pe&&(this._parsedIncludeExpression=F.parse(pe))}matchesExcludesSync(ue,ne,pe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ne,pe))}includedInQuerySync(ue,ne,pe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ne,pe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,ne,pe))}includedInQuery(ue,ne,pe){const oe=this._parsedExcludeExpression(ue,ne,pe),q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,ne,pe):!0;return(0,D.isThenable)(oe)?oe.then(W=>W?!1:q()):q()}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=B;function G(Q){for(const ue in Q)if(typeof Q[ue]!="boolean")return!0;return!1}function le(Q){if(!Q)return;let ue;return ne=>(ue||(ue=(Q()||Promise.resolve([])).then(pe=>pe?K(pe):{})),ue.then(pe=>!!pe[ne]))}e.hasSiblingPromiseFn=le;function Y(Q){if(!Q)return;let ue;return ne=>{if(!ue){const pe=Q();ue=pe?K(pe):{}}return!!ue[ne]}}e.hasSiblingFn=Y;function K(Q){const ue={};for(const ne of Q)ue[ne]=!0;return ue}}),define(ye[41],Ce([1,0,19,11,21,4,3,77,16,122,23,12,2,221,5,13,252,40,59,27,20,15,7,66,36,6,56]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(x,N,M){return new R.ExtUri(L=>g(L,M)).isEqual(x,N)}function w(x,N,M){return u(x.uri,N.uri,M)?0:(0,D.compare)(x.uri.toString(),N.uri.toString())}function k(x,N,M){return x.index!==N.index?x.index<N.index?-1:1:u(x.uri,N.uri,M)?(0,D.compare)(x.name,N.name):(0,D.compare)(x.uri.toString(),N.uri.toString())}function b(x,N,M,L){const U=x.slice(0).sort((G,le)=>M(G,le,L)),B=N.slice(0).sort((G,le)=>M(G,le,L));return(0,I.delta)(U,B,(G,le)=>M(G,le,L))}function g(x,N){const M=N.getCapabilities(x.scheme);return!(M&&M&1024)}class _ extends o.Workspace{static toExtHostWorkspace(N,M,L,U){if(!N)return{workspace:null,added:[],removed:[]};const{id:B,name:G,folders:le,configuration:Y,transient:K,isUntitled:Q}=N,ue=[],ne=M;M?le.forEach((W,ie)=>{const Se=v.URI.revive(W.uri),he=_._findFolder(L||M,Se,U);he?(he.name=W.name,he.index=W.index,ue.push(he)):ue.push({uri:Se,name:W.name,index:ie})}):ue.push(...le.map(({uri:W,name:ie,index:Se})=>({uri:v.URI.revive(W),name:ie,index:Se}))),ue.sort((W,ie)=>W.index<ie.index?-1:1);const pe=new _(B,G,ue,!!K,Y?v.URI.revive(Y):null,!!Q,W=>g(W,U)),{added:oe,removed:q}=b(ne?ne.workspaceFolders:[],pe.workspaceFolders,w,U);return{workspace:pe,added:oe,removed:q}}static _findFolder(N,M,L){for(let U=0;U<N.folders.length;U++){const B=N.workspaceFolders[U];if(u(B.uri,M,L))return B}}constructor(N,M,L,U,B,G,le){super(N,L.map(Y=>new o.WorkspaceFolder(Y)),U,B,le),this._name=M,this._isUntitled=G,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(le),L.forEach(Y=>{this._workspaceFolders.push(Y),this._structure.set(Y.uri,Y)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,M){return M&&this._structure.get(N)&&(N=(0,R.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let T=class{constructor(N,M,L,U,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new P.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=U,this._extHostFileSystemInfo=L,this._uriTransformerService=B,this._requestIdProvider=new y.Counter,this._barrier=new F.Barrier,this._proxy=N.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(h.MainContext.MainThreadMessageService);const G=M.workspace;this._confirmedWorkspace=G?new _(G.id,G.name,[],!!G.transient,G.configuration?v.URI.revive(G.configuration):null,!!G.isUntitled,le=>g(le,L)):void 0}$initializeWorkspace(N,M){this._trusted=M,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:p.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,L,...U){const B=[];if(Array.isArray(U)&&U.forEach(Q=>{v.URI.isUri(Q.uri)&&!B.some(ue=>u(ue.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[M,L].some(Q=>typeof Q!="number"||Q<0)||L===0&&B.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+L>G.length)return!1;const le=G.slice(0);le.splice(M,L,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<le.length;Q++){const ue=le[Q];if(le.some((ne,pe)=>pe!==Q&&u(ue.uri,ne.uri,this._extHostFileSystemInfo)))return!1}le.forEach((Q,ue)=>Q.index=ue);const{added:Y,removed:K}=b(G,le,k,this._extHostFileSystemInfo);if(Y.length===0&&K.length===0)return!1;if(this._proxy){const Q=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(Q,M,L,B).then(void 0,ue=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(m.Severity.Error,(0,S.localize)(0,null,Q,ue.toString()),ne,[])})}return this.trySetWorkspaceFolders(le),!0}getWorkspaceFolder(N,M){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let L,U="";if(typeof N=="string"?(L=v.URI.file(N),U=N):typeof N<"u"&&(L=N,U=N.fsPath),!L)return U;const B=this.getWorkspaceFolder(L,!0);if(!B)return U;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let G=(0,R.relativePath)(B.uri,L);return M&&B.name&&(G=`${B.name}/${G}`),G}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:L,removed:U}=_.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:U}))}findFiles(N,M,L,U,B=f.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let G;if(M===null?G=!1:M&&(typeof M=="string"?G=M:G=M.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Y}=O(a.GlobPattern.from(N));return this._proxy.$startFileSearch(le??null,Y??null,G??null,L??null,B).then(K=>Array.isArray(K)?K.map(Q=>v.URI.revive(Q)):[])}async findTextInFiles(N,M,L,U,B=f.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),le=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:Y,folder:K}=O(a.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ue={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:le,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:Y,excludePattern:Q},ne=!1;if(this._activeSearchCallbacks[G]=pe=>{if(ne)return;const oe=v.URI.revive(pe.resource);pe.results.forEach(q=>{const W=(0,l.revive)(q);(0,s.resultIsMatch)(W)?L({uri:oe,preview:{text:W.preview.text,matches:(0,I.mapArrayOrNot)(W.preview.matches,ie=>new t.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,I.mapArrayOrNot)(W.ranges,ie=>new t.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):L({uri:oe,text:W.text,lineNumber:W.lineNumber})})},B.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(N,K??null,ue,G,B);return delete this._activeSearchCallbacks[G],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[G],pe}}$handleTextSearchResult(N,M){this._activeSearchCallbacks[M]?.(N)}async save(N){const M=await this._proxy.$save(N,{saveAs:!1});return v.URI.revive(M)}async saveAs(N){const M=await this._proxy.$save(N,{saveAs:!0});return v.URI.revive(M)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(N,M){if(this._editSessionIdentityProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._editSessionIdentityProviders.set(N,M);const L=this._uriTransformerService.transformOutgoingScheme(N),U=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(U,L),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(N),this._proxy.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(N,M){this._logService.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!L){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const U=this._editSessionIdentityProviders.get(L.uri.scheme);if(this._logService.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!U),!U)return;const B=await U.provideEditSessionIdentity(L,M);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(N,M,L,U){this._logService.info("Getting edit session identifier for workspaceFolder",N);const B=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const G=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!G),!G)return;const le=await G.provideEditSessionIdentityMatch?.(M,L,U);if(this._logService.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(N){return(M,L,U)=>{const B=function(le){M.call(L,le)};return B.extension=N,this._onWillCreateEditSessionIdentityEvent.event(B,void 0,U)}}async $onWillCreateEditSessionIdentity(N,M,L){const U=await this.resolveWorkspaceFolder(v.URI.revive(N));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:U},M,async(B,G)=>{const le=Date.now();await Promise.resolve(B),Date.now()-le>L&&this._logService.warn("SLOW edit session create-participant",G.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(N,M){if(this._canonicalUriProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._canonicalUriProviders.set(N,M);const L=this._uriTransformerService.transformOutgoingScheme(N),U=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(U,L),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(N),this._proxy.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(N,M,L){const U=this._canonicalUriProviders.get(N.scheme);if(!U)return;const B=await U.provideCanonicalUri?.(v.URI.revive(N),M,L);if(B)return B}async $provideCanonicalUri(N,M,L){return this.provideCanonicalUri(v.URI.revive(N),{targetScheme:M},L)}};e.ExtHostWorkspace=T,e.ExtHostWorkspace=T=je([$e(0,n.IExtHostRpcService),$e(1,r.IExtHostInitDataService),$e(2,i.IExtHostFileSystemInfo),$e(3,c.ILogService),$e(4,d.IURITransformerService)],T),e.IExtHostWorkspace=(0,C.createDecorator)("IExtHostWorkspace");function O(x){let N,M;return x&&(typeof x=="string"?N=x:(N=x.pattern,M=v.URI.revive(x.baseUri))),{includePattern:N,folder:M}}}),define(ye[42],Ce([1,0,24,4,41,6,7,254,87,18,11,5,20,13,2]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(d,s){if(s){const h=s.split(".");let l=d;for(let u=0;l&&u<h.length;u++)l=l[h[u]];return l}}function m(d){return d instanceof C.URI}function o(d){return d&&d.uri instanceof C.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function r(d){return d&&d.uri instanceof C.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function n(d){if(m(d))return{resource:d};if(o(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(r(d))return{resource:d.uri};if(d===null)return{resource:null}}let a=class{constructor(s,h,l){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=h,this._logService=l,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,h){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,h))}};e.ExtHostConfiguration=a,e.ExtHostConfiguration=a=je([$e(0,v.IExtHostRpcService),$e(1,f.IExtHostWorkspace),$e(2,S.ILogService)],a);class t{constructor(s,h,l,u){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=u,this._extHostWorkspace=h,this._configuration=E.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,h){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(h,l))}getConfiguration(s,h,l){const u=n(h)||{},w=this._toReadonlyValue(s?c(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,u,l?.identifier);function k(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(g){return typeof c(w,g)<"u"},get:(g,_)=>{this._validateConfigurationAccess(s?`${s}.${g}`:g,u,l?.identifier);let T=c(w,g);if(typeof T>"u")T=_;else{let O;const x=(N,M)=>{if((0,y.isObject)(N)){let L;const U=()=>{O=O||(0,I.deepClone)(w),L=L||c(O,M)};return new Proxy(N,{get:(B,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return U(),()=>L;if(O)return L=L||c(O,M),L[G];const le=B[G];return typeof G=="string"?x(le,`${M}.${G}`):le},set:(B,G,le)=>(U(),L&&(L[G]=le),!0),deleteProperty:(B,G)=>(U(),L&&delete L[G],!0),defineProperty:(B,G,le)=>(U(),L&&Object.defineProperty(L,G,le),!0)})}return Array.isArray(N)?(0,I.deepClone)(N):N};T=x(T,g)}return T},update:(g,_,T,O)=>{g=s?`${s}.${g}`:g;const x=k(T);return _!==void 0?this._proxy.$updateConfigurationOption(x,g,_,u,O):this._proxy.$removeConfigurationOption(x,g,u,O)},inspect:g=>{g=s?`${s}.${g}`:g;const _=this._configuration.inspect(g,u,this._extHostWorkspace.workspace);if(_)return{key:g,defaultValue:(0,I.deepClone)(_.policy?.value??_.default?.value),globalValue:(0,I.deepClone)(_.user?.value??_.application?.value),workspaceValue:(0,I.deepClone)(_.workspace?.value),workspaceFolderValue:(0,I.deepClone)(_.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(_.default?.override),globalLanguageValue:(0,I.deepClone)(_.user?.override??_.application?.override),workspaceLanguageValue:(0,I.deepClone)(_.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(_.workspaceFolder?.override),languageIds:(0,I.deepClone)(_.overrideIdentifiers)}}};return typeof w=="object"&&(0,I.mixin)(b,w,!1),Object.freeze(b)}_toReadonlyValue(s){const h=l=>(0,y.isObject)(l)?new Proxy(l,{get:(u,w)=>h(u[w]),set:(u,w,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(u,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(u,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return h(s)}_validateConfigurationAccess(s,h,l){const u=p.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),w=l?`[${l.value}] `:"";if(u===4){typeof h?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){h?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,h){const l=new E.ConfigurationChangeEvent(s,h,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,w)=>l.affectsConfiguration(u,n(w))})}_toMap(s){return s.reduce((h,l)=>(h.set(l[0],l[1]),h),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")}),define(ye[96],Ce([1,0,2,11,4,6,7,41,72,42,21,46,20,27,5,16,10,13,92,296,14]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(x){function N(L){if(L!=null)return L}x.from=N;function M(L){if(L!=null)return L}x.to=M})(a||(a={}));var t;(function(x){function N(L){if(L!=null)return L}x.from=N;function M(L){if(L!=null)return L}x.to=M})(t||(t={}));var d;(function(x){function N(L){if(L!=null)return L}x.from=N;function M(L){if(L!=null)return L}x.to=M})(d||(d={}));var s;(function(x){function N(U){if(U){const B=U;return B&&!!B.process}else return!1}x.is=N;function M(U){if(U==null)return;const B={process:U.process,args:U.args};return U.options&&(B.options=d.from(U.options)),B}x.from=M;function L(U){if(U!=null)return new A.ProcessExecution(U.process,U.args,U.options)}x.to=L})(s||(s={}));var h;(function(x){function N(L){if(L!=null)return L}x.from=N;function M(L){if(L!=null)return L}x.to=M})(h||(h={}));var l;(function(x){function N(U){if(U){const B=U;return B&&(!!B.commandLine||!!B.command)}else return!1}x.is=N;function M(U){if(U==null)return;const B={};return U.commandLine!==void 0?B.commandLine=U.commandLine:(B.command=U.command,B.args=U.args),U.options&&(B.options=h.from(U.options)),B}x.from=M;function L(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new A.ShellExecution(U.commandLine,U.options):new A.ShellExecution(U.command,U.args?U.args:[],U.options)}x.to=L})(l||(l={}));var u;(function(x){function N(U){if(U){const B=U;return B&&B.customExecution==="customExecution"}else return!1}x.is=N;function M(U){return{customExecution:"customExecution"}}x.from=M;function L(U,B){return B.get(U)}x.to=L})(u||(e.CustomExecutionDTO=u={}));var w;(function(x){function N(M,L){let U;return M.scope!==void 0&&typeof M.scope!="number"?U=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===A.TaskScope.Workspace&&L&&L.workspaceFile?U=L.workspaceFile:U=r.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:U}}x.from=N})(w||(e.TaskHandleDTO=w={}));var k;(function(x){function N(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}x.from=N})(k||(k={}));var b;(function(x){function N(U,B){if(U==null)return[];const G=[];for(const le of U){const Y=M(le,B);Y&&G.push(Y)}return G}x.fromMany=N;function M(U,B){if(U==null)return;let G;U.execution instanceof A.ProcessExecution?G=s.from(U.execution):U.execution instanceof A.ShellExecution?G=l.from(U.execution):U.execution&&U.execution instanceof A.CustomExecution&&(G=u.from(U.execution));const le=a.from(U.definition);let Y;return U.scope?typeof U.scope=="number"?Y=U.scope:Y=U.scope.uri:Y=A.TaskScope.Workspace,!le||!Y?void 0:{_id:U._id,definition:le,name:U.name,source:{extensionId:B.identifier.value,label:U.source,scope:Y},execution:G,isBackground:U.isBackground,group:k.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}x.from=M;async function L(U,B,G){if(U==null)return;let le;s.is(U.execution)?le=s.to(U.execution):l.is(U.execution)?le=l.to(U.execution):u.is(U.execution)&&(le=u.to(U._id,G));const Y=a.to(U.definition);let K;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?K=U.source.scope:K=await B.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):K=A.TaskScope.Workspace),!Y||!K)return;const Q=new A.Task(Y,K,U.name,U.source.label,le,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=A.TaskGroup.from(U.group._id),Q.group&&U.group.isDefault&&(Q.group=new A.TaskGroup(Q.group.id,Q.group.label),U.group.isDefault===!0&&(Q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Q.presentationOptions=t.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}x.to=L})(b||(e.TaskDTO=b={}));var g;(function(x){function N(L){return L}x.from=N;function M(L){if(L)return Object.assign(Object.create(null),L)}x.to=M})(g||(g={}));class _{#e;constructor(N,M,L){this._id=M,this._task=L,this.#e=N}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let T=class{constructor(N,M,L,U,B,G,le,Y){this._onDidExecuteTask=new f.Emitter,this._onDidTerminateTask=new f.Emitter,this._onDidTaskProcessStarted=new f.Emitter,this._onDidTaskProcessEnded=new f.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=U,this._configurationService=B,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=le,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,M,L){if(!L)return new A.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:M,provider:L,extension:N}),this._proxy.$registerTaskProvider(U,M),new A.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(N,M){this._proxy.$registerTaskSystem(N,M)}fetchTasks(N){return this._proxy.$fetchTasks(g.from(N)).then(async M=>{const L=[];for(const U of M){const B=await b.to(U,this._workspaceProvider,this._providedCustomExecutions2);B&&L.push(B)}return L})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(M=>N.push(M)),N}terminateTask(N){if(!(N instanceof _))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,M,L){const U=this._providedCustomExecutions2.get(N.id);U&&(this._activeCustomExecutions2.set(N.id,U),this._terminalService.attachPtyToTerminal(M,await U.callback(L))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){if(!this._taskExecutionPromises.has(N.id))return;const M=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const M=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:M,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const M=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:N.exitCode})}$provideTasks(N,M){const L=this._handlers.get(N);if(!L)return Promise.reject(new Error("no handler found"));const U=[],B=(0,F.asPromise)(()=>L.provider.provideTasks(R.CancellationToken.None)).then(G=>this.provideTasksInternal(M,U,L,G));return new Promise(G=>{B.then(le=>{Promise.all(U).then(()=>{G(le)})})})}async $resolveTask(N,M){const L=this._handlers.get(N);if(!L)return Promise.reject(new Error("no handler found"));if(M.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${L.type}].`);const U=await b.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const B=await L.provider.resolveTask(U,R.CancellationToken.None);if(!B)return;this.checkDeprecation(B,L);const G=b.from(B,L.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(G.execution)&&await this.addCustomExecution(G,B,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,M,L){const U=await this._proxy.$createTaskId(N);!L&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,M.execution)),this._providedCustomExecutions2.set(U,M.execution)}async getTaskExecution(N,M){if(typeof N=="string"){const B=this._taskExecutionPromises.get(N);if(!B)throw new n.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const L=this._taskExecutionPromises.get(N.id);if(L)return L;let U;return M?U=Promise.resolve(new _(this,N.id,M)):U=b.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(B=>{if(!B)throw new n.ErrorNoTelemetry("Unexpected: Task does not exist.");return new _(this,N.id,B)}),this._taskExecutionPromises.set(N.id,U),U.then(B=>(this._taskExecutions.set(N.id,B),B))}checkDeprecation(N,M){N._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const L=this._notProvidedCustomExecutions.values();let U=L.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=L.next()}};e.ExtHostTaskBase=T,e.ExtHostTaskBase=T=je([$e(0,v.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,p.IExtHostDocumentsAndEditors),$e(4,y.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,o.ILogService),$e(7,i.IExtHostApiDeprecationService)],T);let O=class extends T{constructor(N,M,L,U,B,G,le,Y){super(N,M,L,U,B,G,le,Y),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(N,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const L=b.from(M,N);if(L===void 0)throw new Error("Task is not valid");if(u.is(L.execution))await this.addCustomExecution(L,M,!1);else throw new n.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),M);return this._proxy.$executeTask(L).catch(B=>{throw new Error(B)}),U}provideTasksInternal(N,M,L,U){const B=[];if(U)for(const G of U){if(this.checkDeprecation(G,L),!G.definition||!N[G.definition.type]){const Y=G.source?G.source:"No task source";this._logService.warn(`The task [${Y}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=b.from(G,L.extension);le&&u.is(le.execution)?(B.push(le),M.push(this.addCustomExecution(le,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:L.extension}}async resolveTaskInternal(N){if(u.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,M,L){}};e.WorkerExtHostTask=O,e.WorkerExtHostTask=O=je([$e(0,v.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,p.IExtHostDocumentsAndEditors),$e(4,y.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,o.ILogService),$e(7,i.IExtHostApiDeprecationService)],O),e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(ye[360],Ce([1,0,36,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function f(A){return"cellResults"in A}e.isINotebookFileMatchNoModel=f,e.rawCellPrefix="rawCell#";function P(A,E){let p=-1;const y=[];let R=[];return A.forEach(v=>{v.range.startLineNumber!==p&&R.length>0&&(y.push([...R]),R=[]),R.push(v),p=v.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(v=>{const S=[],C=v[0].range.startLineNumber,c=v[v.length-1].range.endLineNumber;for(let m=C;m<=c;m++)S.push(E.getLineContent(m));return new I.TextSearchMatch(S.join(`
`)+`
`,v.map(m=>new F.Range(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=P}),define(ye[361],Ce([1,0,215,22,4,3,28,12,18,2,32,110,6,33,15,7,68,331,149,24,16,286,360,357]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class s{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}constructor(l,u,w,k,b,g){this._textDocumentsAndEditors=w,this._textDocuments=k,this._extHostFileSystem=b,this._extHostSearch=g,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new f.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new f.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new f.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new f.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=l.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===13){const T=_.notebookEditor?.notebookUri,O=_.cell.handle,N=this._documents.get(T)?.getCell(O);if(N)return N.apiCell}if(_&&_.$mid===14){const T=_.uri,O=this._documents.get(T);if(O)return O.apiNotebook}return _}}),s._registerApiCommands(u)}getEditorById(l){const u=this._editors.get(l);if(!u)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(l){for(const[u,w]of this._editors)if(w.apiEditor===l)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,u){const w=this._documents.get(l);if(!w&&!u)throw new Error(`NO notebook document for '${l}'`);return w}static _convertNotebookRegistrationData(l,u){if(!u)return;const w=u.filenamePattern.map(k=>C.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(u.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:u.displayName,filenamePattern:w,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,u,w){const k=s._notebookStatusBarItemProviderHandlePool++,b=typeof w.onDidChangeCellStatusBarItems=="function"?s._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(k,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(k,b,u);let g;return b!==void 0&&(g=w.onDidChangeCellStatusBarItems(_=>this._notebookProxy.$emitCellStatusBarEvent(b))),new c.Disposable(()=>{this._notebookStatusBarItemProviders.delete(k),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(k,b),g?.dispose()})}async createNotebookDocument(l){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&C.NotebookData.from(l.content)});return y.URI.revive(u)}async openNotebookDocument(l){const u=this._documents.get(l);if(u)return u.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(l),k=this._documents.get(y.URI.revive(w));return(0,p.assertIsDefined)(k?.apiNotebook)}async showNotebookDocument(l,u){y.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let w;typeof u=="object"?w={position:C.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(C.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const k=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,w),b=k&&this._editors.get(k)?.apiEditor;if(b)return b;throw k?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,u,w,k){const b=this._notebookStatusBarItemProviders.get(l),g=y.URI.revive(u),_=this._documents.get(g);if(!_||!b)return;const T=_.getCellFromIndex(w);if(!T)return;const O=await b.provideCellStatusBarItems(T.apiCell,k);if(!O)return;const x=new P.DisposableStore,N=this._statusBarCache.add([x]),L=(Array.isArray(O)?O:[O]).map(U=>C.NotebookStatusBarItem.from(U,this._commandsConverter,x));return{cacheId:N,items:L}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,u,w,k,b){if((0,E.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const g=this._handlePool++;return this._notebookSerializer.set(g,{viewType:u,serializer:w,options:k}),this._notebookProxy.$registerNotebookSerializer(g,{id:l.identifier,location:l.extensionLocation},u,C.NotebookDocumentContentOptions.from(k),s._convertNotebookRegistrationData(l,b)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(g)})}async $dataToNotebook(l,u,w){const k=this._notebookSerializer.get(l);if(!k)throw new Error("NO serializer found");const b=await k.serializer.deserializeNotebook(u.buffer,w);return new m.SerializableObjectWithBuffers(C.NotebookData.from(b))}async $notebookToData(l,u,w){const k=this._notebookSerializer.get(l);if(!k)throw new Error("NO serializer found");const b=await k.serializer.serializeNotebook(C.NotebookData.to(u.value),w);return F.VSBuffer.wrap(b)}async $saveNotebook(l,u,w,k,b){const g=y.URI.revive(u),_=this._notebookSerializer.get(l);if(!_)throw new Error("NO serializer found");const T=this._documents.get(g);if(!T)throw new Error("Document NOT found");if(T.versionId!==w)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(g.scheme))throw new R.FileOperationError((0,I.localize)(0,null,this._resourceForError(g)),6);await this._validateWriteFile(g,k);const O={metadata:(0,r.filter)(T.apiNotebook.metadata,U=>!(_.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of T.apiNotebook.getCells()){const B=new c.NotebookCellData(U.kind,U.document.getText(),U.document.languageId,U.mime,_.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);B.metadata=(0,r.filter)(U.metadata,G=>!(_.options?.transientCellMetadata??{})[G]),O.cells.push(B)}const x=await _.serializer.serializeNotebook(O,b);await this._extHostFileSystem.value.writeFile(g,x);const N=this._extHostFileSystem.getFileSystemProviderExtUri(g.scheme),M=await this._extHostFileSystem.value.stat(g);return{name:N.basename(g),isFile:(M.type&R.FileType.File)!==0,isDirectory:(M.type&R.FileType.Directory)!==0,isSymbolicLink:(M.type&R.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&R.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(g.scheme),locked:!!((M.permissions??0)&R.FilePermission.Locked),etag:R.etag({mtime:M.mtime,size:M.size}),children:void 0}}async $searchInNotebooks(l,u,w,k,b){const g=this._notebookSerializer.get(l)?.serializer;if(!g)return{limitHit:!1,results:[]};const _=new A.ResourceSet;await(async(M,L,U)=>{await Promise.all(M.map(async B=>await Promise.all(B.filenamePatterns.map(G=>{const le={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:G};return this._extHostSearch.doInternalFileSearchWithCustomCallback(le,L,Y=>{Y.forEach(K=>{_.has(K)||k.some(ue=>B.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(ne=>(0,d.globMatchesResource)(ne,K)))||_.add(K)})})}))))})(w,b,u);const O=new A.ResourceMap;let x=!1;const N=Array.from(_).map(async M=>{const L=[];try{if(b.isCancellationRequested)return;if(u.maxResults&&[...O.values()].reduce((le,Y)=>le+Y.cellResults.length,0)>u.maxResults){x=!0;return}const U=[],B=this._documents.get(M);if(B)B.apiNotebook.getCells().forEach(Y=>U.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(K=>K.items.map(Q=>Q.data.toString()))}));else{const le=await this._extHostFileSystem.value.readFile(M),Y=F.VSBuffer.fromString(le.toString()),K=await g.deserializeNotebook(Y.buffer,b);if(b.isCancellationRequested)return;C.NotebookData.from(K).cells.forEach(ue=>U.push({input:ue.source,outputs:ue.outputs.flatMap(ne=>ne.items.map(pe=>pe.valueBytes.toString()))}))}if(b.isCancellationRequested)return;U.forEach((le,Y)=>{const K=u.contentPattern.pattern,Q=new a.CellSearchModel(le.input,void 0,le.outputs),ue=Q.findInInputs(K),ne=Q.findInOutputs(K),pe=ne.flatMap(oe=>(0,t.genericCellMatchesToTextSearchMatches)(oe.matches,oe.textBuffer)).map((oe,q)=>(oe.webviewIndex=q,oe));if(ue.length>0||ne.length>0){const oe={index:Y,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(ue,Q.inputTextBuffer),webviewResults:pe};L.push(oe)}});const G={resource:M,cellResults:L};O.set(M,G);return}catch{return}});return await Promise.all(N),{limitHit:x,results:[...O.values()]}}async _validateWriteFile(l,u){const w=await this._extHostFileSystem.value.stat(l);if(typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==R.ETAG_DISABLED&&typeof w.mtime=="number"&&typeof w.size=="number"&&u.mtime<w.mtime&&u.etag!==R.etag({mtime:u.mtime,size:w.size}))throw new R.FileOperationError((0,I.localize)(1,null),3,u)}_resourceForError(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString()}_createExtHostEditor(l,u,w){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const k=new i.ExtHostNotebookEditor(u,this._notebookEditorsProxy,l,w.visibleRanges.map(C.NotebookRange.to),w.selections.map(C.NotebookRange.to),typeof w.viewColumn=="number"?C.ViewColumn.to(w.viewColumn):void 0);this._editors.set(u,k)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const w of l.value.removedDocuments){const k=y.URI.revive(w),b=this._documents.get(k);b&&(b.dispose(),this._documents.delete(k),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(g=>g.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const g of this._editors.values())g.notebookData.uri.toString()===k.toString()&&this._editors.delete(g.id)}if(l.value.addedDocuments){const w=[];for(const k of l.value.addedDocuments){const b=y.URI.revive(k.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const g=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,b,k);w.push(...k.cells.map(_=>o.ExtHostCell.asModelAddData(g.apiNotebook,_))),this._documents.get(b)?.dispose(),this._documents.set(b,g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(g.apiNotebook)}}if(l.value.addedEditors)for(const w of l.value.addedEditors){if(this._editors.has(w.id))return;const k=y.URI.revive(w.documentUri),b=this._documents.get(k);b&&this._createExtHostEditor(b,w.id,w)}const u=[];if(l.value.removedEditors)for(const w of l.value.removedEditors){const k=this._editors.get(w);k&&(this._editors.delete(w),this._activeNotebookEditor?.id===k.id&&(this._activeNotebookEditor=void 0),u.push(k))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(k=>this._editors.get(k)).filter(k=>!!k);const w=new Set;this._visibleNotebookEditors.forEach(k=>w.add(k.id));for(const k of this._editors.values()){const b=w.has(k.id);k._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(k=>k).filter(k=>k.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._editors.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const u=S.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new S.ApiCommandArgument("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.VSBuffer.wrap(b))],new S.ApiCommandResult("Notebook Data",b=>C.NotebookData.to(b.value))),k=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new m.SerializableObjectWithBuffers(C.NotebookData.from(b)))],new S.ApiCommandResult("Bytes",b=>b.buffer));l.registerApiCommand(w),l.registerApiCommand(k)}}e.ExtHostNotebookController=s}),define(ye[362],Ce([1,0,17,21,44,35,23,38,36]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(v,S,C){this.config=v,this.provider=S,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&P.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&P.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const S=this.config.folderQueries||[];return new Promise((C,c)=>{const m=o=>{this.resultCount++,v(o)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const i=o.toString(),r=I.basename(i);this.globalExcludePattern&&this.globalExcludePattern(i,r)||this.matchFile(m,{base:o,basename:r})}),Promise.all(S.map(o=>this.searchInFolder(o,m))).then(o=>{C({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{c(new Error((0,f.toErrorMessage)(o)))})})}async searchInFolder(v,S){const C=new F.CancellationTokenSource,c=this.getSearchOptionsForFolder(v),m=this.initDirectoryTree(),o=new p.QueryGlobTester(this.config,v),i=!o.hasSiblingExcludeClauses();let r;try{this.activeCancellationTokens.add(C),r=E.StopWatch.create();const n=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,C.token),a=r.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(n&&n.forEach(d=>{const s=I.posix.relative(v.folder.path,d.path);if(i){const h=I.basename(d.path);this.matchFile(S,{base:v.folder,relativePath:s,basename:h});return}this.addDirectoryEntries(m,v.folder,s,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,o,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(v){const S=(0,p.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),C=(0,p.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:C,includes:S,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},S,C,c){if(C===this.filePattern){const o=I.basename(this.filePattern);this.matchFile(c,{base:S,relativePath:this.filePattern,basename:o})}function m(o){const i=I.basename(o),r=I.dirname(o);let n=v[r];n||(n=v[r]=[],m(r)),n.push({base:S,relativePath:o,basename:i})}m(C)}matchDirectoryTree({rootEntries:v,pathToEntries:S},C,c){const m=this,o=this.filePattern;function i(r){const n=(0,p.hasSiblingFn)(()=>r.map(a=>a.basename));for(let a=0,t=r.length;a<t;a++){const d=r[a],{relativePath:s,basename:h}=d;if(C.matchesExcludesSync(s,h,o!==h?n:void 0))continue;const l=S[s];if(l)i(l);else{if(s===o)continue;m.matchFile(c,d)}if(m.isLimitHit)break}}i(v)}matchFile(v,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(S))}}class R{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(v,S,C,c){const m=this.getSessionTokenSource(v.cacheKey),o=new y(v,S,m&&m.token);let i=0;const r=n=>{i+=n.length,C(n.map(a=>this.rawMatchToSearchItem(a)))};return this.doSearch(o,R.BATCH_SIZE,r,c).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(v){this.getSessionTokenSource(v)?.cancel()}getSessionTokenSource(v){if(v)return this.sessions.has(v)||this.sessions.set(v,new F.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:A.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,S,C,c){const m=c.onCancellationRequested(()=>{v.cancel()}),o=r=>{r&&(i.push(r),S>0&&i.length>=S&&(C(i),i=[]))};let i=[];return v.search(o).then(r=>(i.length&&C(i),m.dispose(),r),r=>(i.length&&C(i),m.dispose(),Promise.reject(r)))}}e.FileSearchManager=R}),define(ye[363],Ce([1,0,19,73,35,103,28,16,17,23,12,18,2,100,235,51,13,40,142,358,36]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(g,_,T,O,x){this.configurationService=g,this.workspaceContextService=_,this.editorGroupsService=T,this.logService=O,this.pathService=x}text(g,_,T={}){g=this.getContentPattern(g,T);const O=this.configurationService.getValue(),x=_&&_.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(_?.map(o.toWorkspaceFolder),T),type:2,contentPattern:g,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:O.search.usePCRE2||x||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(g,_){const T=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const O={...g,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(g,_)&&(O.isCaseSensitive=!0),this.isMultiline(g)&&(O.isMultiline=!0),_.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=_.notebookSearchConfig.includeMarkupInput),_.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=_.notebookSearchConfig.includeMarkupPreview),_.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=_.notebookSearchConfig.includeCodeInput),_.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=_.notebookSearchConfig.includeOutput),O}file(g,_={}){return{...this.commonQuery(g,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(g,_){return g?(g=Array.isArray(g)?g.map(l):l(g),_?this.parseSearchPaths(g):{pattern:d(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],_={}){const T=this.handleIncludeExclude(_.includePattern,_.expandPatterns),O=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),x=g.length>1,N=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,_,O)):g.map(U=>this.getFolderQueryForRoot(U,_,O,x))).filter(U=>!!U),M={_reason:_._reason,folderQueries:N,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:O.pattern,includePattern:T.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const U=I.coalesce(I.flatten(this.editorGroupsService.groups.map(le=>le.editors.map(Y=>Y.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const B=U.filter(le=>(0,n.pathIncludedInQuery)(M,le.fsPath)),G=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...M,...G}}const L=_.extraFileResources&&_.extraFileResources.filter(U=>(0,n.pathIncludedInQuery)(M,U.fsPath));return M.extraFileResources=L&&L.length?L:void 0,M}commonQueryFromFileList(g){const _=[],T=new A.ResourceMap,O={};let x=!1;return g.forEach(N=>{if(N.scheme===E.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(N)){const L=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:p.dirname(N.fsPath)});let U=T.get(L);U||(x=!0,U={folder:L,includePattern:{}},_.push(U),T.set(L,U));const B=p.relative(L.fsPath,N.fsPath);(0,D.assertIsDefined)(U.includePattern)[B.replace(/\\/g,"/")]=!0}else N.fsPath&&(x=!0,O[N.fsPath]=!0)}),{folderQueries:_,includePattern:O,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(g,_){if(_.isSmartCase){if(g.isRegExp){if(R.containsUppercaseCharacter(g.pattern,!0))return!0}else if(R.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,S.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const _=G=>p.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),O=(Array.isArray(g)?g:s(g)).map(G=>{const le=this.pathService.resolvedUserHome;return le?(0,P.untildify)(G,le.scheme===E.Schemas.file?le.fsPath:le.path):G}),x=F.groupBy(O,G=>_(G)?"searchPaths":"exprSegments"),N=(x.exprSegments||[]).map(G=>R.rtrim(G,"/")).map(G=>R.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),h(G))),M={},L=this.expandSearchPathPatterns(x.searchPaths||[]);L&&L.length&&(M.searchPaths=L);const U=I.flatten(N),B=d(...U);return B&&(M.pattern=B),M}getExcludesForFolder(g,_){return _.disregardExcludeSettings?void 0:(0,n.getExcludes)(g,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const _=g.flatMap(O=>{let{pathPortion:x,globPortion:N}=t(O);return N&&(N=u(N)),this.expandOneSearchPath(x).flatMap(L=>this.resolveOneSearchPathPattern(L,N))}),T=new Map;return _.forEach(O=>{const x=O.searchPath.toString(),N=T.get(x);N?O.pattern&&(N.pattern=N.pattern||{},N.pattern[O.pattern]=!0):T.set(x,{searchPath:O.searchPath,pattern:O.pattern?d(O.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(g){if(p.isAbsolute(g)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==E.Schemas.file?[{searchPath:_[0].uri.with({path:g})}]:[{searchPath:v.URI.file(p.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=l(g),g.startsWith("../")||g===".."){const O=p.posix.resolve(_.path,g);return[{searchPath:_.with({path:O})}]}const T=u(g);return[{searchPath:_,pattern:T}]}else{if(g==="./"||g===".\\")return[];{const _=g.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(x=>{const N=_.match(new RegExp(`^${R.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return N?{match:N,folder:x}:null}).filter(D.isDefined);if(O.length)return O.map(x=>{const N=x.match[1];return{searchPath:x.folder.uri,pattern:N&&u(N)}});{const x=g.match(/\.[\/\\](.+)[\/\\]?/),N=x?x[1]:g,M=C.localize(0,null,N);throw new Error(M)}}}}resolveOneSearchPathPattern(g,_){const T=g.pattern&&_?`${g.pattern}/${_}`:g.pattern||_,O=[{searchPath:g.searchPath,pattern:T}];return T&&!T.endsWith("**")&&O.push({searchPath:g.searchPath,pattern:T+"/**"}),O}getFolderQueryForSearchPath(g,_,T){const O=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(g.searchPath),_,T,!1);return O?{...O,includePattern:g.pattern}:null}getFolderQueryForRoot(g,_,T,O){let x;const N=v.URI.isUri(g)?g:g.uri;if(T.searchPaths){const G=T.searchPaths.filter(le=>(0,y.isEqual)(le.searchPath,N))[0];if(G&&!G.pattern)return null;G&&(x=G.pattern)}const M=this.configurationService.getValue({resource:N}),U={...this.getExcludesForFolder(M,_)||{},...x||{}},B=v.URI.isUri(g)?(0,y.basename)(g):g.name;return{folder:N,folderName:O?B:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!M.search.followSymlinks}}};e.QueryBuilder=a,e.QueryBuilder=a=je([$e(0,c.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,i.IEditorGroupsService),$e(3,m.ILogService),$e(4,r.IPathService)],a);function t(b){const g=b.match(/[\*\{\}\(\)\[\]\?]/);if(g){const _=g.index,T=b.substr(0,_).match(/[/|\\][^/\\]*$/);if(T){let O=b.substr(0,T.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:b.substr((T.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((g,_)=>(g[_]=!0,g),Object.create(null)):void 0}function s(b){return f.splitGlobAware(b,",").map(g=>g.trim()).filter(g=>!!g.length)}function h(b){return[`**/${b}/**`,`**/${b}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function l(b){return b.replace(/\\/g,"/")}function u(b){return l(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b){return b.replace(/([?*[\]])/g,"[$1]")}function k(b,g){b=I.distinct(b,O=>O.toString());const _=[],T=g.getWorkspace();return b&&b.forEach(O=>{let x;if(g.getWorkbenchState()===2)x=(0,y.relativePath)(T.folders[0].uri,O),x&&x!=="."&&(x="./"+x);else{const N=g.getWorkspaceFolder(O);if(N){const M=N.name;if(T.folders.filter(U=>U.name===M).length===1){const U=(0,y.relativePath)(N.uri,O);U===""?x=`./${N.name}`:x=`./${N.name}/${U}`}else x=O.fsPath}}x&&_.push(w(x))}),_}e.resolveResourcesForSearchIncludes=k}),define(ye[364],Ce([1,0,23,2,21,14,5,363,36,40]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function D(c,m){const o=m.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const h of o)if(/^workspaceContains:/.test(h)){const l=h.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||c.forceUsingSearch?r.push(l):i.push(l)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const a=new Promise((h,l)=>{n=h}),t=h=>n({activationEvent:h}),d=Promise.all(i.map(h=>v(c,h,t))).then(()=>{}),s=S(c,m.identifier,r,t);return Promise.all([d,s]).then(()=>{n(void 0)}),a}e.checkActivateWorkspaceContainsExtension=D;async function v(c,m,o){for(const i of c.folders)if(await c.exists(I.joinPath(F.URI.revive(i),m))){o(`workspaceContains:${m}`);return}}async function S(c,m,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new f.CancellationTokenSource,n=c.checkExists(c.folders,o,r.token),a=setTimeout(async()=>{r.cancel(),c.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let t=!1;try{t=await n}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}r.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function C(c,m,o,i){const r=c.get(A.IInstantiationService),n=c.get(p.ISearchService),t=r.createInstance(E.QueryBuilder).file(m.map(d=>(0,y.toWorkspaceFolder)(F.URI.revive(d))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=C}),define(ye[47],Ce([1,0,212,17,58,23,11,3,77,2,13,6,42,292,117,41,26,144,14,25,22,271,7,64,5,27,94,20,107,70,46,4,364,116,273,16,114,38,10,115]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s,h,l,u,w,k,b,g,_,T,O,x,N,M,L,U){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let G=B=class extends E.Disposable{constructor(q,W,ie,Se,he,fe,Z,ee,j,J,ge,we){super(),this._extHostManagedSockets=we,this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=W,this._extHostContext=ie,this._initData=Z,this._extHostWorkspace=Se,this._extHostConfiguration=he,this._logService=fe,this._extHostTunnelService=j,this._extHostTerminalService=J,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new pe(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Ae=new r.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,ue(this._globalRegistry,Ae)),L.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${K(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${K(this._myRegistry)}`)),this._storage=new C.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=ee,this._instaService=q.createChild(new w.ServiceCollection([C.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState])),this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ee,ke,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ee,i.transformErrorForSerialization(ke),z)},actualActivateExtension:async(Ee,ke)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(Ee,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ee,ke),new S.HostExtension;const z=this._myRegistry.getExtensionDescription(Ee);return this._activateExtension(z,ke)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),f.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(q){i.onUnexpectedError(q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let q=[];try{q=this._myRegistry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch{}await Promise.all(q)}terminate(q,W=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),i.setUnexpectedErrorHandler(Se=>{this._logService.error(Se)}),this._extHostContext.dispose();const ie=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),ie]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`):this._logService.info(`Extension host exiting with code ${W}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(W)})}isActivated(q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(q):!1}async getExtension(q){const W=await this._mainThreadExtensionsProxy.$getExtension(q);return W&&{...W,identifier:new r.ExtensionIdentifier(W.identifier.value),extensionLocation:y.URI.revive(W.extensionLocation)}}_activateByEvent(q,W){return this._activator.activateByEvent(q,W)}_activateById(q,W){return this._activator.activateById(q,W)}activateByIdWithErrors(q,W){return this._activateById(q,W).then(()=>{const ie=this._activator.getActivatedExtension(q);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(q=>this._myRegistry)}getExtensionExports(q){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(q).exports;try{return this._activator.getActivatedExtension(q).exports}catch{return null}}async _realPathExtensionUri(q){if(q.scheme===x.Schemas.file&&this._hostUtils.fsRealpath){const W=await this._hostUtils.fsRealpath(q.fsPath);return y.URI.file(W)}return q}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(q=>new ne(q))),this._extensionPathIndex}async _createExtensionPathIndex(q){const W=p.TernarySearchTree.forUris(ie=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ie));return await Promise.all(q.map(async ie=>{if(this._getEntryPoint(ie)){const Se=await this._realPathExtensionUri(ie.extensionLocation);W.set(Se,ie)}})),W}_deactivate(q){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(q))return W;const ie=this._activator.getActivatedExtension(q);if(!ie)return W;try{typeof ie.module.deactivate=="function"&&(W=Promise.resolve(ie.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${q.value}':`),this._logService.error(Se)}try{(0,E.dispose)(ie.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this._logService.error(Se)}return W}async _activateExtension(q,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier),this._doActivateExtension(q,W).then(ie=>{const Se=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(q.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,W),this._logExtensionActivationTimes(q,W,"success",Se),ie},ie=>{throw this._logExtensionActivationTimes(q,W,"failure"),ie})}_logExtensionActivationTimes(q,W,ie,Se){const he=Y(q,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...he,...Se||{},outcome:ie})}_doActivateExtension(q,W){const ie=Y(q,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const Se=this._getEntryPoint(q);if(!Se)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${q.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const he=new S.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(q,(0,P.joinPath)(q.extensionLocation,Se),he),this._loadExtensionContext(q)]).then(fe=>(f.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),B._callActivate(this._logService,q.identifier,fe[0],fe[1],he))).then(fe=>(f.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),fe))}_loadExtensionContext(q){const W=new a.ExtensionGlobalMemento(q,this._storage),ie=new a.ExtensionMemento(q.identifier.value,!1,this._storage),Se=new O.ExtensionSecrets(q,this._secretState),he=q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([W.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const Z=this;let ee,j;const J=(0,m.isProposedApiEnabled)(q,"ipc")?this._initData.messagePorts?.get(r.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ie,secrets:Se,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(ge){return F.join(q.extensionLocation.fsPath,ge)},get storagePath(){return Z._storagePath.workspaceValue(q)?.fsPath},get globalStoragePath(){return Z._storagePath.globalValue(q).fsPath},get logPath(){return F.join(Z._initData.logsLocation.fsPath,q.identifier.value)},get logUri(){return y.URI.joinPath(Z._initData.logsLocation,q.identifier.value)},get storageUri(){return Z._storagePath.workspaceValue(q)},get globalStorageUri(){return Z._storagePath.globalValue(q)},get extensionMode(){return he},get extension(){return ee===void 0&&(ee=new Q(Z,q.identifier,q,fe,!1)),ee},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(q,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z._extHostTerminalService.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!j){if(!J)return;const ge=g.Event.buffer(g.Event.fromDOMEventEmitter(J,"message",we=>we.data));J.start(),j={onDidReceiveMessage:ge,postMessage:J.postMessage.bind(J)}}return j}})})}static _callActivate(q,W,ie,Se,he){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional(q,W,ie,Se,he).then(fe=>new S.ActivatedExtension(!1,null,he.build(),ie,fe,Se.subscriptions))}static _callActivateOptional(q,W,ie,Se,he){if(typeof ie.activate=="function")try{he.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${W.value}`);const fe=typeof global=="object"?global:self,Z=ie.activate.apply(fe,[Se]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Z).then(ee=>(he.activateResolveStop(),ee))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(ie)}_activateOneStartupFinished(q,W){this._activateById(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:W}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinishedDeferred(q,W=0){const Se=Date.now();(0,L.setTimeout0)(()=>{for(let he=W;he<q.length;he+=1){const fe=q[he];for(const Z of fe.activationEvents??[])if(Z==="onStartupFinished")if(Date.now()-Se>50){this._activateAllStartupFinishedDeferred(q,he);break}else this._activateOneStartupFinished(fe,Z)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(f.getMarks()),this._extHostConfiguration.getConfigProvider().then(q=>{const W=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this._myRegistry.getAllExtensionDescriptions();if(W)this._activateAllStartupFinishedDeferred(ie);else for(const Se of ie)if(Se.activationEvents)for(const he of Se.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(Se,he)})}_handleEagerExtensions(){const q=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(W),Se=this._handleRemoteResolverEagerExtensions(),he=Promise.all([Se,q,ie]).then(()=>{});return Promise.race([he,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),he}_handleWorkspaceContainsEagerExtensions(q){return q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(q,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(q,W){if(this.isActivated(W.identifier))return;const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:q.map(fe=>fe.uri),forceUsingSearch:ie||!this._hostUtils.fsExists,exists:fe=>this._hostUtils.fsExists(fe.fsPath),checkExists:(fe,Z,ee)=>this._mainThreadWorkspaceProxy.$checkExists(fe,Z,ee)},he=await(0,_.checkActivateWorkspaceContainsExtension)(Se,W);if(he)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,fe=>this._logService.error(fe))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(q){throw console.error(q),q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:W}=this._initData.environment;if(!q||!W)throw new Error(I.localize(0,null));const ie=await this._loadCommonJSModule(null,W,new S.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(I.localize(1,null,W.toString()));return new Promise((Se,he)=>{const fe=(j,J)=>{j?(L.isCI&&this._logService.error("Test runner called back with error",j),he(j)):(L.isCI&&(J?this._logService.info(`Test runner called back with ${J} failures.`):this._logService.info("Test runner called back with successful outcome.")),Se(typeof J=="number"&&J>0?1:0))},Z=(0,P.originalFSPath)(W),ee=ie.run(Z,fe);ee&&ee.then&&ee.then(()=>{L.isCI&&this._logService.info("Test runner finished successfully."),Se(0)}).catch(j=>{L.isCI&&this._logService.error("Test runner finished with error",j),he(j instanceof Error&&j.stack?j.stack:String(j))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,W){return this._resolvers[q]=W,(0,E.toDisposable)(()=>{delete this._resolvers[q]})}async getRemoteExecServer(q){const{resolver:W}=await this._activateAndGetResolver(q);return W?.resolveExecServer?.(q,{resolveAttempt:0})}async _activateAndGetResolver(q){const W=q.indexOf("+");if(W===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=q.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this._resolvers[ie]}}async $resolveAuthority(q,W){const ie=M.StopWatch.create(!1),Se=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(q)},${W})][${ie.elapsed()}ms] `,he=te=>this._logService.info(`${Se()}${te}`),fe=te=>this._logService.warn(`${Se()}${te}`),Z=(te,H=void 0)=>this._logService.error(`${Se()}${te}`,H),ee=te=>{if(te instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te},j=async te=>{he(`activating resolver for ${te}...`);const{resolver:H,authorityPrefix:ae}=await this._activateAndGetResolver(te);if(!H)throw Z(`no resolver for ${ae}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${ae}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:ae,remoteAuthority:te}},J=q.split(/@|%40/g).reverse();he(`activating remote resolvers ${J.join(" -> ")}`);let ge;try{ge=await Promise.all(J.map(j)).catch(async te=>{if(!(te instanceof t.RemoteAuthorityResolverError)||te._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw te;return fe(`resolving nested authorities failed: ${te.message}`),[await j(q)]})}catch(te){return ee(te)}const we=new A.IntervalTimer;we.cancelAndSet(()=>he("waiting..."),1e3);let Ae,Ee;for(const[te,{authorityPrefix:H,resolver:ae,remoteAuthority:de}]of ge.entries())try{if(te===ge.length-1)he("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${H}`),Ae=await ae.resolve(de,{resolveAttempt:W,execServer:Ee}),f.mark(`code/extHost/didResolveAuthorityOK/${H}`),he("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ae,t.ManagedResolvedAuthority.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(he(`invoking resolveExecServer() for ${de}`),f.mark(`code/extHost/willResolveExecServer/${H}`),Ee=await ae.resolveExecServer?.(de,{resolveAttempt:W,execServer:Ee}),!Ee)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${de}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Re){return f.mark(`code/extHost/didResolveAuthorityError/${H}`),Z("returned an error",Re),we.dispose(),ee(Re)}we.dispose();const ke={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},z={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let X;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(Ae)){const te=W;this._extHostManagedSockets.setFactory(te,Ae.makeConnection),X={authority:q,connectTo:new d.ManagedRemoteConnection(te),connectionToken:Ae.connectionToken}}else X={authority:q,connectTo:new d.WebSocketRemoteConnection(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:X,options:z,tunnelInformation:ke}}}async $getCanonicalURI(q,W){this._logService.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(q)})`);const{resolver:ie}=await this._activateAndGetResolver(q);if(!ie)return null;const Se=y.URI.revive(W);if(typeof ie.getCanonicalURI>"u")return Se;const he=await(0,A.asPromise)(()=>ie.getCanonicalURI(Se));return he||Se}$startExtensionHost(q){q.toAdd.forEach(Se=>Se.extensionLocation=y.URI.revive(Se.extensionLocation));const{globalRegistry:W,myExtensions:ie}=le(this._activationEventsReader,this._globalRegistry,this._myRegistry,q);return this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(ie),L.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${K(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${K(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(q,W){return W===1?this._almostReadyToRunExtensions.wait().then(ie=>this._activateByEvent(q,!1)):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent(q,!1))}async $activate(q,W){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(q)?(await this._activateById(q,W),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(fe=>fe.extensionLocation=y.URI.revive(fe.extensionLocation));const{globalRegistry:W,myExtensions:ie}=le(this._activationEventsReader,this._globalRegistry,this._myRegistry,q),Se=await this._createExtensionPathIndex(ie);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(ie),L.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${K(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${K(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const W=n.VSBuffer.alloc(q),ie=Math.random()%256;for(let Se=0;Se<q;Se++)W.writeUInt8(ie,Se);return W}async $updateRemoteConnectionData(q){this._remoteConnectionData=q,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=G,e.AbstractExtHostExtensionService=G=B=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,u.IExtHostRpcService),$e(3,c.IExtHostWorkspace),$e(4,v.IExtHostConfiguration),$e(5,R.ILogService),$e(6,h.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,k.IExtHostTunnelService),$e(9,b.IExtHostTerminalService),$e(10,N.IExtHostLocalizationService),$e(11,U.IExtHostManagedSockets)],G);function le(oe,q,W,ie){oe.addActivationEvents(ie.addActivationEvents);const Se=new o.ExtensionDescriptionRegistry(oe,q.getAllExtensionDescriptions());Se.deltaExtensions(ie.toAdd,ie.toRemove);const he=new r.ExtensionIdentifierSet(W.getAllExtensionDescriptions().map(Z=>Z.identifier));for(const Z of ie.myToRemove)he.delete(Z);for(const Z of ie.myToAdd)he.add(Z);const fe=ue(Se,he);return{globalRegistry:Se,myExtensions:fe}}function Y(oe,q){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}function K(oe){return oe.getAllExtensionDescriptions().map(q=>q.identifier.value).join(",")}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(q,W,ie,Se,he){this.#e=q,this.#t=W,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.normalize((0,P.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Se,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Q;function ue(oe,q){return oe.getAllExtensionDescriptions().filter(W=>q.has(W.identifier))}class ne{constructor(q){this._searchTree=q}setSearchTree(q){this._searchTree=q}findSubstr(q){return this._searchTree.findSubstr(q)}forEach(q){return this._searchTree.forEach(q)}}e.ExtensionPaths=ne;class pe{constructor(q){this._map=new r.ExtensionIdentifierMap,this.addActivationEvents(q)}readActivationEvents(q){return this._map.get(q.identifier)??[]}addActivationEvents(q){for(const W of Object.keys(q))this._map.set(W,q[W])}}}),define(ye[365],Ce([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(n,a,t,d,s,h,l){this._apiFactory=n,this._extensionRegistry=a,this._instaService=t,this._extHostConfiguration=d,this._extHostExtensionService=s,this._initData=h,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const n=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,a,this._extensionRegistry,n,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(i,a,this._initData.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const a of n.nodeModuleName)this._factories.set(a,n);else this._factories.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this._alternatives.push(a=>n.alternativeModuleName(a))}};e.RequireInterceptor=c,e.RequireInterceptor=c=je([$e(2,R.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,D.IExtHostExtensionService),$e(5,y.IExtHostInitDataService),$e(6,v.ILogService)],c);let m=class{static{C=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&C.aliased.size){const a=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${s}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(n){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(n));if(!a)return;const[,t,d,s]=a,h=C.aliased.get(d);if(h!==void 0)return console.warn(`${d} as been renamed to ${h}, please update your imports`),t+h+s}forceForwardSlashes(n){return n.replace(/\\/g,"/")}};m=C=je([$e(0,y.IExtHostInitDataService)],m);class o{constructor(n,a,t,d,s){this._apiFactory=n,this._extensionPaths=a,this._extensionRegistry=t,this._configProvider=d,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new E.ExtensionIdentifierMap}load(n,a){const t=this._extensionPaths.findSubstr(a);if(t){let d=this._extApiImpl.get(t.identifier);return d||(d=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,d)),d}if(!this._defaultApiImpl){let d="";this._extensionPaths.forEach((s,h)=>d+=`	${h} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${d}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let i=class{constructor(n,a,t){this._extensionPaths=n,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(f.MainContext.MainThreadTelemetry);const d=t.getProxy(f.MainContext.MainThreadWindow);this._impl=(s,h)=>{const l=F.URI.parse(s);return h?this.callOriginal(s,h):l.scheme==="http"||l.scheme==="https"?d.$openUri(l,s,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?d.$openUri(l,s,{}):this.callOriginal(s,h)}}load(n,a,t){const d=this._extensionPaths.findSubstr(a);return d&&(this._extensionId=d.identifier.value,this.sendShimmingTelemetry()),this._original=t(n),this._impl}callOriginal(n,a){return this.sendNoForwardTelemetry(),this._original(n,a)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};i=je([$e(2,p.IExtHostRpcService)],i)}),define(ye[60],Ce([1,0,43,3,17,49,5,72,71,47,7,41,289,42]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class C extends v.AbstractVariableResolverService{constructor(o,i,r,n,a,t,d){function s(){if(r){const h=r.activeEditor();if(h)return h.document.uri;const l=n.tabGroups.all.find(u=>u.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.TextDiffTabInput||l.input instanceof R.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof R.TextTabInput||l.input instanceof R.NotebookEditorTabInput||l.input instanceof R.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:h=>{const l=t.folders.filter(u=>u.name===h);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,l)=>a.getConfiguration(void 0,h).get(l),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=s();if(h)return f.normalize(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const h=s();if(h){const l=i.getWorkspaceFolder(h);if(l)return f.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(r){const h=r.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(r){const h=r.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>o.getExtension(h)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let c=class extends F.Disposable{constructor(o,i,r,n,a){super(),this.extensionService=o,this.workspaceService=i,this.editorService=r,this.configurationService=n,this.editorTabs=a,this._resolver=new I.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async h=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=c,e.ExtHostVariableResolverProviderService=c=je([$e(0,y.IExtHostExtensionService),$e(1,D.IExtHostWorkspace),$e(2,E.IExtHostDocumentsAndEditors),$e(3,S.IExtHostConfiguration),$e(4,p.IExtHostEditorTabs)],c)}),define(ye[97],Ce([1,0,11,4,2,25,5,6,71,47,20,7,41,140,281,42,60,3,55,33]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(u,w,k,b,g,_,T){this._workspaceService=w,this._extensionService=k,this._configurationService=b,this._editorTabs=g,this._variableResolver=_,this._commands=T,this._debugSessions=new Map,this._debugVisualizationProviders=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new F.Emitter,this._onDidTerminateDebugSession=new F.Emitter,this._onDidChangeActiveDebugSession=new F.Emitter,this._onDidReceiveDebugSessionCustomEvent=new F.Emitter,this._debugServiceProxy=u.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new F.Emitter,this._onDidChangeStackFrameFocus=new F.Emitter,this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(x=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}asDebugSourceUri(u,w){const k=u;if(typeof k.sourceReference=="number"&&k.sourceReference>0){let b=`debug:${encodeURIComponent(k.path||"")}`,g="?";return w&&(b+=`${g}session=${encodeURIComponent(w.id)}`,g="&"),b+=`${g}ref=${k.sourceReference}`,f.URI.parse(b)}else{if(k.path)return f.URI.file(k.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const w=[];for(const k of u.getAllExtensionDescriptions())if(k.contributes){const b=k.contributes.debuggers;if(b&&b.length>0)for(const g of b)(0,C.isDebuggerMainContribution)(g)&&w.push(g.type)}this._debugServiceProxy.$registerDebugTypes(w)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const u=[];return this._breakpoints.forEach(w=>u.push(w)),u}async $resolveDebugVisualizer(u,w){const k=this._visualizers.get(u);if(!k)throw new Error(`No debug visualizer found with id '${u}'`);let{v:b,provider:g}=k;if(b.visualization||(b=await g.resolveDebugVisualization?.(b,w)||b,k.v=b),!b.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${g}'`);return this.serializeVisualization(b.visualization)}async $executeDebugVisualizerCommand(u){const w=this._visualizers.get(u);if(!w)throw new Error(`No debug visualizer found with id '${u}'`);const k=w.v.visualization;k&&"command"in k&&this._commands.executeCommand(k.command,...k.arguments||[])}async $provideDebugVisualizers(u,w,k,b){const g=this._debugSessions.get(k.sessionId),_=this.extensionVisKey(u,w),T=this._debugVisualizationProviders.get(_);if(!g||!T)return[];const O=await T.provideDebugVisualization({session:g,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId},b);return O?O.map(x=>{const N=++this._visualizerIdCounter;this._visualizers.set(N,{v:x,provider:T});const M=x.iconPath?this.getIconPathOrClass(x.iconPath):void 0;return{id:N,name:x.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.serializeVisualization(x.visualization)}}):[]}$disposeDebugVisualizers(u){for(const w of u)this._visualizers.delete(w)}registerDebugVisualizationProvider(u,w,k){if(!u.contributes?.debugVisualizers?.some(_=>_.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const b=P.ExtensionIdentifier.toKey(u.identifier),g=this.extensionVisKey(b,w);if(this._debugVisualizationProviders.has(g))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this._debugVisualizationProviders.set(g,k),this._debugServiceProxy.$registerDebugVisualizer(b,w),(0,o.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(b,w),this._debugVisualizationProviders.delete(w)})}addBreakpoints(u){const w=u.filter(g=>{const _=g.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,g),!0)});this.fireBreakpointChanges(w,[],[]);const k=[],b=new Map;for(const g of w)if(g instanceof D.SourceBreakpoint){let _=b.get(g.location.uri.toString());_||(_={type:"sourceMulti",uri:g.location.uri,lines:[]},b.set(g.location.uri.toString(),_),k.push(_)),_.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof D.FunctionBreakpoint&&k.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this._debugServiceProxy.$registerBreakpoints(k)}removeBreakpoints(u){const w=u.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],w,[]);const k=w.filter(_=>_ instanceof D.SourceBreakpoint).map(_=>_.id),b=w.filter(_=>_ instanceof D.FunctionBreakpoint).map(_=>_.id),g=w.filter(_=>_ instanceof D.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(k,b,g)}startDebugging(u,w,k){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,w,{parentSessionID:k.parentSession?k.parentSession.id:void 0,lifecycleManagedByParent:k.lifecycleManagedByParent,repl:k.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:k.noDebug,compact:k.compact,suppressSaveBeforeStart:k.suppressSaveBeforeStart,suppressDebugStatusbar:k.suppressDebugStatusbar??k.debugUI?.simple,suppressDebugToolbar:k.suppressDebugToolbar??k.debugUI?.simple,suppressDebugView:k.suppressDebugView??k.debugUI?.simple})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,k){if(!w)return new D.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:b,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,k,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,b),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(g=>g.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(u,w,k){if(!k)return new D.Disposable(()=>{});if(!this.definesDebugType(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:b,factory:k}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,b),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(g=>g.factory!==k),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new D.Disposable(()=>{});const k=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:k,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){let k;const b=await this.getFolder(u);return b&&(k={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(k,w)}createDebugAdapter(u,w){if(u.type==="implementation")return new s(u.implementation)}createSignService(){}async $startDASession(u,w){const k=this,b=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const _=this.convertToDto(g),T=this.createDebugAdapter(_,b);if(!T)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const O=T;return this._debugAdapters.set(u,O),this.getDebugAdapterTrackers(b).then(x=>(x&&this._debugAdaptersTrackers.set(u,x),O.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const M=N,L={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);L.body={signature:U},O.sendResponse(L)}else throw new Error("no signer")}catch(U){L.success=!1,L.message=U.message,O.sendResponse(L)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(N),N=(0,C.convertToVSCPaths)(N,!0),k._debugServiceProxy.$acceptDAMessage(u,N)}),O.onError(N=>{x&&x.onError&&x.onError(N),this._debugServiceProxy.$acceptDAError(u,N.name,N.message,N.stack)}),O.onExit(N=>{x&&x.onExit&&x.onExit(N??void 0,void 0),this._debugServiceProxy.$acceptDAExit(u,N??void 0,void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),O.startSession()))})}$sendDAMessage(u,w){w=(0,C.convertToDAPaths)(w,!1);const k=this._debugAdaptersTrackers.get(u);k&&k.onWillReceiveMessage&&k.onWillReceiveMessage(w),this._debugAdapters.get(u)?.sendMessage(w)}$stopDASession(u){const w=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const k=this._debugAdapters.get(u);return this._debugAdapters.delete(u),k?k.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],k=[],b=[];if(u.added)for(const g of u.added){const _=g.id;if(_&&!this._breakpoints.has(_)){let T;if(g.type==="function")T=new D.FunctionBreakpoint(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")T=new D.DataBreakpoint(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const O=f.URI.revive(g.uri);T=new D.SourceBreakpoint(new D.Location(O,new D.Position(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,D.setBreakpointId)(T,_),this._breakpoints.set(_,T),w.push(T)}}if(u.removed)for(const g of u.removed){const _=this._breakpoints.get(g);_&&(this._breakpoints.delete(g),k.push(_))}if(u.changed){for(const g of u.changed)if(g.id){const _=this._breakpoints.get(g.id);if(_){if(_ instanceof D.FunctionBreakpoint&&g.type==="function"){const T=_;T.enabled=g.enabled,T.condition=g.condition,T.hitCondition=g.hitCondition,T.logMessage=g.logMessage,T.functionName=g.functionName}else if(_ instanceof D.SourceBreakpoint&&g.type==="source"){const T=_;T.enabled=g.enabled,T.condition=g.condition,T.hitCondition=g.hitCondition,T.logMessage=g.logMessage,T.location=new D.Location(f.URI.revive(g.uri),new D.Position(g.line,g.character))}b.push(_)}}}this.fireBreakpointChanges(w,k,b)}async $acceptStackFrameFocus(u){let w;const k=u.sessionId?await this.getSession(u.sessionId):void 0;if(!k)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?w=new D.ThreadFocus(k,u.threadId):w=new D.StackFrameFocus(k,u.threadId,u.frameId),this._stackFrameFocus=w,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(u,w,k){return(0,I.asPromise)(async()=>{const b=this.getConfigProviderByHandle(u);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.getFolder(w);return b.provideDebugConfigurations(g,k)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(u,w,k,b){return(0,I.asPromise)(async()=>{const g=this.getConfigProviderByHandle(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(w);return g.resolveDebugConfiguration(_,k,b)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,k,b){return(0,I.asPromise)(async()=>{const g=this.getConfigProviderByHandle(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(w);return g.resolveDebugConfigurationWithSubstitutedVariables(_,k,b)})}async $provideDebugAdapter(u,w){const k=this.getAdapterDescriptorFactoryByHandle(u);if(!k)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(w);return this.getAdapterDescriptor(k,b).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(g)})}async $acceptDebugSessionStarted(u){const w=await this.getSession(u);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.getSession(u);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,w){(await this.getSession(u))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const b={session:await this.getSession(u),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(u){if(u instanceof D.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof D.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const w=this._adapterFactories.filter(k=>k.type===u);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(u){const w=this._adapterFactories.filter(k=>k.handle===u);if(w.length>0)return w[0].factory}getConfigProviderByHandle(u){const w=this._configProviders.filter(k=>k.handle===u);if(w.length>0)return w[0].provider}definesDebugType(u,w){if(u.contributes){const k=u.contributes.debuggers;if(k&&k.length>0){for(const b of k)if(b.label&&b.type&&b.type===w)return!0}}return!1}getDebugAdapterTrackers(u){const k=u.configuration.type,b=this._trackerFactories.filter(g=>g.type===k||g.type==="*").map(g=>(0,I.asPromise)(()=>g.factory.createDebugAdapterTracker(u)).then(_=>_,_=>null));return Promise.race([Promise.all(b).then(g=>{const _=g.filter(T=>!!T);if(_.length>0)return new d(_)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async getAdapterDescriptor(u,w){const k=w.configuration.debugServer;if(typeof k=="number")return Promise.resolve(new D.DebugAdapterServer(k));if(u){const g=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>u.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,g))).then(_=>{if(_)return _})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,b))}daExecutableFromPackage(u,w){}fireBreakpointChanges(u,w,k){(u.length>0||w.length>0||k.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:w,changed:k}))}async getSession(u){if(u)if(typeof u=="string"){const w=this._debugSessions.get(u);if(w)return w}else{let w=this._debugSessions.get(u.id);if(!w){const k=await this.getFolder(u.folderUri),b=u.parent?this._debugSessions.get(u.parent):void 0;w=new a(this._debugServiceProxy,u.id,u.type,u.name,k,u.configuration,b),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(u){if(u){const w=f.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}extensionVisKey(u,w){return`${u}\0${w}`}serializeVisualization(u){if(u){if("title"in u&&"command"in u)return{type:0};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(u){const w=this.getIconUris(u);let k,b;return"id"in w?b=i.ThemeIcon.asClassName(w):k=w,{iconPath:k,iconClass:b}}getIconUris(u){if(u instanceof D.ThemeIcon)return{id:u.id};const w=typeof u=="object"&&"dark"in u?u.dark:u,k=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof w=="string"?f.URI.file(w):w,light:typeof k=="string"?f.URI.file(k):k}}};e.ExtHostDebugServiceBase=n,e.ExtHostDebugServiceBase=n=je([$e(0,R.IExtHostRpcService),$e(1,v.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,p.IExtHostEditorTabs),$e(5,m.IExtHostVariableResolverProvider),$e(6,r.IExtHostCommands)],n);class a{constructor(u,w,k,b,g,_,T){this._debugServiceProxy=u,this._id=w,this._type=k,this._name=b,this._workspaceFolder=g,this._configuration=_,this._parentSession=T}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,w)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=a;class t{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class d{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.trackers.forEach(k=>k.onExit?k.onExit(u,w):void 0)}}class s extends S.AbstractDebugAdapter{constructor(u){super(),this.implementation=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends n{constructor(u,w,k,b,g,_,T){super(u,w,k,b,g,_,T)}};e.WorkerExtHostDebugService=h,e.WorkerExtHostDebugService=h=je([$e(0,R.IExtHostRpcService),$e(1,v.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,p.IExtHostEditorTabs),$e(5,m.IExtHostVariableResolverProvider),$e(6,r.IExtHostCommands)],h)}),define(ye[366],Ce([1,0,14,58,2,6,309,13,84,107,27,247,20,66,47,91]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class m{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(E.ILogService),t=r.get(v.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(d=>{n.error(d);const s=I.transformErrorForSerialization(d);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(E.ILogService),a=r.get(v.IExtHostRpcService),t=r.get(C.IExtHostExtensionService),d=r.get(c.IExtHostTelemetry),s=a.getProxy(P.MainContext.MainThreadExtensionService),h=a.getProxy(P.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),u=new WeakMap;function w(g,_){if(u.has(g))return u.get(g).stack;let T="",O,x;for(const M of _)T+=`
	at ${M.toString()}`,x=M.getFileName(),!O&&x&&(O=l.findSubstr(f.URI.file(x)));const N=`${g.name||"Error"}: ${g.message||""}${T}`;return u.set(g,{extensionIdentifier:O?.identifier,stack:N}),N}const k=Symbol("prepareStackTrace wrapped");let b=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(g){if(g===w||!g||g[k]){b=g||w;return}b=function(_,T){return w(_,T),g.call(Error,_,T)},Object.assign(b,{[k]:!0})}}),I.setUnexpectedErrorHandler(g=>{n.error(g);const _=I.transformErrorForSerialization(g),T=u.get(g);if(!T?.extensionIdentifier){h.$onUnexpectedError(_);return}s.$onExtensionRuntimeError(T.extensionIdentifier,_);const O=d.onExtensionError(T.extensionIdentifier,g);n.trace("forwarded error to extension?",O,T)})}}e.ErrorHandler=m;class o{constructor(r,n,a,t,d){this._hostUtils=a,this._rpcProtocol=new A.RPCProtocol(r,null,t),n=o._transform(n,this._rpcProtocol);const s=new y.ServiceCollection(...(0,p.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...n,messagePorts:d}),s.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),s.set(S.IURITransformerService,new S.URITransformerService(t)),s.set(C.IHostUtils,a);const h=new D.InstantiationService(s,!0);h.invokeFunction(m.installEarlyHandler),this._logService=h.invokeFunction(l=>l.get(E.ILogService)),F.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",n),this._extensionService=h.invokeFunction(l=>l.get(C.IExtHostExtensionService)),this._extensionService.initialize(),h.invokeFunction(m.installFullHandler)}async asBrowserUri(r){const n=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return f.URI.revive(await n.$asBrowserUri(r))}terminate(r){this._extensionService.terminate(r)}static _transform(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=f.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=f.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=f.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=o}),define(ye[367],Ce([1,0,11,10,222,241,138,97,71,47,20,46,7,60,41,282,283,42,33]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let r=class extends E.ExtHostDebugServiceBase{constructor(s,h,l,u,w,k,b,g){super(s,h,l,u,k,b,g),this._terminalService=w,this._integratedTerminalInstances=new t}createDebugAdapter(s,h){switch(s.type){case"server":return new c.SocketDebugAdapter(s);case"pipeServer":return new c.NamedPipeDebugAdapter(s);case"executable":return new c.ExecutableDebugAdapter(s,h.type)}return super.createDebugAdapter(s,h)}daExecutableFromPackage(s,h){const l=c.ExecutableDebugAdapter.platformAdapterExecutable(h.getAllExtensionDescriptions(),s.type);if(l)return new v.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new A.SignService}async $runInTerminal(s,h){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const l=await this._configurationService.getConfigProvider(),u=this._terminalService.getDefaultShell(!0),w=this._terminalService.getDefaultShellArgs(!0),k=s.title||f.localize(0,null),b=JSON.stringify({shell:u,shellArgs:w});let g=await this._integratedTerminalInstances.checkout(b,k),_,T=!1;if(g)_=s.cwd;else{const M={shellPath:u,shellArgs:w,cwd:s.cwd,name:k,iconPath:new v.ThemeIcon("debug")};T=!0,g=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(g,b)}g.show(!0);const O=await g.processId;T?await new Promise(M=>setTimeout(M,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?g.sendText("cls"):u.indexOf("bash")>=0?g.sendText("clear"):F.isWindows?g.sendText("cls"):g.sendText("clear"));const x=(0,m.prepareCommand)(u,s.args,!!s.argsCanBeInterpretedByShell,_,s.env);g.sendText(x);const N=this.onDidTerminateDebugSession(M=>{M.id===h&&(this._integratedTerminalInstances.free(g),N.dispose())});return O}else if(s.kind==="external")return a(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,h)}};e.ExtHostDebugService=r,e.ExtHostDebugService=r=je([$e(0,R.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,D.IExtHostTerminalService),$e(5,p.IExtHostEditorTabs),$e(6,S.IExtHostVariableResolverProvider),$e(7,i.IExtHostCommands)],r);let n;function a(d,s){if(!n)if(F.isWindows)n=new P.WindowsExternalTerminalService;else if(F.isMacintosh)n=new P.MacExternalTerminalService;else if(F.isLinux)n=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=s.getConfiguration("terminal");return n.runInTerminal(d.title,d.cwd,d.args,d.env||{},h.external||{})}class t{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(s,h){const u=[...this._terminalInstances.entries()].map(([w,k])=>(0,I.createCancelablePromise)(async b=>{if(w.name!==h||k.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await w.processId))return null;const g=Date.now();return k.lastUsedAt+t.minUseDelay>g||b.isCancellationRequested||k.config!==s?null:(k.lastUsedAt=g,w)}));return await(0,I.firstParallel)(u,w=>!!w)}insert(s,h){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:h})}free(s){const h=this._terminalInstances.get(s);h&&(h.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}}),define(ye[368],Ce([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,60]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends v.ExtHostTaskBase{constructor(a,t,d,s,h,l,u,w,k){super(a,t,d,s,h,l,u,w),this.workspaceService=d,this.variableResolver=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const s=v.TaskHandleDTO.from(d,this.workspaceService),h=await this._proxy.$getTaskExecution(s);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(h,t);return this._proxy.$executeTask(s).catch(()=>{}),l}else{const s=v.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,t,!1);const h=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),t);return this._proxy.$executeTask(s).catch(()=>{}),h}}provideTasksInternal(a,t,d,s){const h=[];if(s)for(const l of s){this.checkDeprecation(l,d),(!l.definition||!a[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const u=v.TaskDTO.from(l,d.extension);u&&(h.push(u),v.CustomExecutionDTO.is(u.execution)&&t.push(this.addCustomExecution(u,l,!0)))}return{tasks:h,extension:d.extension}}async resolveTaskInternal(a){return a}async getAFolder(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const d=F.URI.file((0,o.homedir)());t=new p.WorkspaceFolder({uri:d,name:m.basename(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const d=F.URI.revive(a),s={process:void 0,variables:Object.create(null)},h=await this._workspaceProvider.resolveWorkspaceFolder(d),l=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.variableResolver.getResolver(),w=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(const k of t.variables)s.variables[k]=await u.resolveAsync(w,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(I.delimiter);for(let b=0;b<k.length;b++)k[b]=await u.resolveAsync(w,k[b])}s.process=await f.win32.findExecutable(await u.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(w,t.process.cwd):void 0,k)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,d){return f.win32.findExecutable(a,t,d)}};e.ExtHostTask=r,e.ExtHostTask=r=je([$e(0,R.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,A.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,y.IExtHostTerminalService),$e(6,C.ILogService),$e(7,c.IExtHostApiDeprecationService),$e(8,i.IExtHostVariableResolverProvider)],r)}),define(ye[369],Ce([1,0,63,60]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class f extends F.ExtHostVariableResolverProviderService{homeDir(){return(0,I.homedir)()}}e.NodeExtHostVariableResolverProviderService=f}),define(ye[154],Ce([1,0,19,11,21,44,16,17,23,2,36]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(i,r,n,a){this.query=i,this.provider=r,this.fileUtils=n,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(i,r){const n=this.query.folderQueries||[],a=new f.CancellationTokenSource(r);return new Promise((t,d)=>{this.collector=new S(i);let s=!1;const h=(l,u)=>{if(!s&&!this.isLimitHit){const w=this.resultSize(l);c(l)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,s=!0,a.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const k=this.resultSize(l);this.resultCount+=k,(k>0||!c(l))&&this.collector.add(l,u)}};Promise.all(n.map((l,u)=>this.searchInFolder(l,w=>h(w,u),a.token))).then(l=>{a.dispose(),this.collector.flush();const u=l.some(w=>!!w&&!!w.limitHit);t({limitHit:this.isLimitHit||u,messages:(0,I.flatten)(l.map(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},l=>{a.dispose();const u=(0,P.toErrorMessage)(l);d(new Error(u))})})}resultSize(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}trimResultToSize(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:a.slice(0,r),text:i.preview.text},uri:i.uri}}async searchInFolder(i,r,n){const a=new R.QueryGlobTester(this.query,i),t=[],d={report:l=>{if(!this.validateProviderResult(l))return;const u=i.folder.scheme===A.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(p.dirname(l.uri))):void 0,w=p.relativePath(i.folder,l.uri);if(w){const k=a.includedInQuery(w,E.basename(w),u);(0,F.isThenable)(k)?t.push(k.then(b=>{b&&r(l)})):k&&r(l)}}},s=this.getSearchOptionsForFolder(i),h=await this.provider.provideTextSearchResults(v(this.query.contentPattern),s,d,n);return t.length&&await Promise.all(t),h}validateProviderResult(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(i){const r=(0,R.resolvePatternsForProvider)(this.query.includePattern,i.includePattern),n=(0,R.resolvePatternsForProvider)(this.query.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.fileUtils.toCanonicalName(i.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=D;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(i){this._onResult=i,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,r=>this.sendItems(r))}add(i,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!p.isEqual(this._currentUri,i.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:i.uri,results:[]}),this._currentFileMatch.results.push(C(i))}pushToCollector(){const i=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,i)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(i){this._onResult(i)}}e.TextSearchResultsCollector=S;function C(o){return c(o)?{preview:{matches:(0,I.mapArrayOrNot)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,I.mapArrayOrNot)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function c(o){return!!o.preview}e.extensionResultIsMatch=c;class m{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(i,r){this.maxBatchSize=i,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(i,r){i&&this.addItemToBatch(i,r)}addItems(i,r){i&&this.addItemsToBatch(i,r)}addItemToBatch(i,r){this.batch.push(i),this.batchSize+=r,this.onUpdate()}addItemsToBatch(i,r){this.batch=this.batch.concat(i),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m}),define(ye[98],Ce([1,0,3,6,5,362,20,66,13,2,154]),function(me,e,I,F,f,P,A,E,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,f.createDecorator)("IExtHostSearch");let D=class{constructor(c,m,o){this.extHostRpc=c,this._uriTransformer=m,this._logService=o,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const o=this._handlePool++;return this._textSearchProvider.set(o,m),this._proxy.$registerTextSearchProvider(o,this._transformScheme(c)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(c,m){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const o=this._handlePool++;return this._fileSearchProvider.set(o,m),this._proxy.$registerFileSearchProvider(o,this._transformScheme(c)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(c,m,o,i){const r=v(o),n=this._fileSearchProvider.get(c);if(n)return this._fileSearchManager.fileSearch(r,n,a=>{this._proxy.$handleFileMatch(c,m,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,o){return{messages:[]}}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,o,i){const r=this._textSearchProvider.get(c);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const n=v(o);return this.createTextSearchManager(n,r).search(t=>this._proxy.$handleTextMatch(c,m,t),i)}$enableExtensionHostSearch(){}createTextSearchManager(c,m){return new R.TextSearchManager(c,m,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=D,e.ExtHostSearch=D=je([$e(0,A.IExtHostRpcService),$e(1,E.IURITransformerService),$e(2,p.ILogService)],D);function v(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(S),extraFileResources:C.extraFileResources&&C.extraFileResources.map(c=>y.URI.revive(c))}}e.reviveQuery=v;function S(C){return{...C,folder:y.URI.revive(C.folder)}}}),define(ye[370],Ce([1,0,21,14,4,3,16,39,2,132,191,172,79,25,32,13,65,88,266,6,311,341,92,312,317,318,319,320,321,298,287,33,322,42,323,97,147,324,300,313,325,326,72,71,314,47,327,69,328,59,27,342,343,315,301,329,330,114,115,302,361,332,272,333,344,334,152,303,335,336,337,20,338,98,116,339,304,340,117,94,96,91,46,345,346,316,347,348,70,15,7,305,66,306,93,349,350,146,41,280,113,26,95]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s,h,l,u,w,k,b,g,_,T,O,x,N,M,L,U,B,G,le,Y,K,Q,ue,ne,pe,oe,q,W,ie,Se,he,fe,Z,ee,j,J,ge,we,Ae,Ee,ke,z,X,te,H,ae,de,Re,Ue,Ve,Ke,Ze,at,st,rt,Pe,xe,Te,Xe,re,se,Ie,He,Qe,it,nt,Me,St,Dt,Ft,Nt,_t,Vt,Mt,Qt,$t,Bt,et,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Gt(dt){const pt=dt.get(q.IExtHostInitDataService),zt=dt.get(oe.IExtHostFileSystemInfo),Kt=dt.get(ne.IExtHostConsumerFileSystem),yt=dt.get(Q.IExtHostExtensionService),ft=dt.get(Qt.IExtHostWorkspace),kt=dt.get(Te.IExtHostTelemetry),Zt=dt.get(T.IExtHostConfiguration),Tt=dt.get(Dt.IURITransformerService),Ge=dt.get(Re.IExtHostRpcService),Lt=dt.get(rt.IExtHostStorage),Ut=dt.get(Pe.IExtensionStoragePaths),Xt=dt.get(c.ILoggerService),mt=dt.get(c.ILogService),Ot=dt.get(it.IExtHostTunnelService),At=dt.get(t.IExtHostApiDeprecationService),Wt=dt.get(Mt.IExtHostWindow),Le=dt.get(Ke.IExtHostSecretState),Ne=dt.get(Y.IExtHostEditorTabs),De=dt.get(j.IExtHostManagedSockets);Ge.set(r.ExtHostContext.ExtHostFileSystemInfo,zt),Ge.set(r.ExtHostContext.ExtHostLogLevelServiceShape,Xt),Ge.set(r.ExtHostContext.ExtHostWorkspace,ft),Ge.set(r.ExtHostContext.ExtHostConfiguration,Zt),Ge.set(r.ExtHostContext.ExtHostExtensionService,yt),Ge.set(r.ExtHostContext.ExtHostStorage,Lt),Ge.set(r.ExtHostContext.ExtHostTunnelService,Ot),Ge.set(r.ExtHostContext.ExtHostWindow,Wt),Ge.set(r.ExtHostContext.ExtHostSecretState,Le),Ge.set(r.ExtHostContext.ExtHostTelemetry,kt),Ge.set(r.ExtHostContext.ExtHostEditorTabs,Ne),Ge.set(r.ExtHostContext.ExtHostManagedSockets,De);const ce=Ge.set(r.ExtHostContext.ExtHostDecorations,dt.get(N.IExtHostDecorations)),Fe=Ge.set(r.ExtHostContext.ExtHostDocumentsAndEditors,dt.get(le.IExtHostDocumentsAndEditors)),ze=Ge.set(r.ExtHostContext.ExtHostCommands,dt.get(g.IExtHostCommands)),Je=Ge.set(r.ExtHostContext.ExtHostTerminalService,dt.get(Xe.IExtHostTerminalService)),qe=Ge.set(r.ExtHostContext.ExtHostDebugService,dt.get(x.IExtHostDebugService)),ct=Ge.set(r.ExtHostContext.ExtHostSearch,dt.get(Ve.IExtHostSearch)),wt=Ge.set(r.ExtHostContext.ExtHostTask,dt.get(xe.IExtHostTask)),qt=Ge.set(r.ExtHostContext.ExtHostOutputService,dt.get(X.IExtHostOutputService)),Ct=Ge.set(r.ExtHostContext.ExtHostLocalization,dt.get(ee.IExtHostLocalizationService)),It=Ge.set(r.ExtHostContext.ExtHostUrls,new Ft.ExtHostUrls(Ge)),Et=Ge.set(r.ExtHostContext.ExtHostDocuments,new G.ExtHostDocuments(Ge,Fe)),Ci=Ge.set(r.ExtHostContext.ExtHostDocumentContentProviders,new U.ExtHostDocumentContentProvider(Ge,Fe,mt)),qi=Ge.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new B.ExtHostDocumentSaveParticipant(mt,Et,Ge.getProxy(r.MainContext.MainThreadBulkEdits))),Pt=Ge.set(r.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Ge,ze,Fe,Et,Kt,ct)),si=Ge.set(r.ExtHostContext.ExtHostNotebookDocuments,new Ae.ExtHostNotebookDocuments(Pt)),gi=Ge.set(r.ExtHostContext.ExtHostNotebookEditors,new Ee.ExtHostNotebookEditors(mt,Pt)),li=Ge.set(r.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(Ge,pt,Pt,ze,mt)),Di=Ge.set(r.ExtHostContext.ExtHostNotebookRenderers,new z.ExtHostNotebookRenderers(Ge,Pt)),Ii=Ge.set(r.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new we.ExtHostNotebookDocumentSaveParticipant(mt,Pt,Ge.getProxy(r.MainContext.MainThreadBulkEdits))),xt=Ge.set(r.ExtHostContext.ExtHostEditors,new se.ExtHostEditors(Ge,Fe)),pi=Ge.set(r.ExtHostContext.ExtHostTreeViews,new Qe.ExtHostTreeViews(Ge.getProxy(r.MainContext.MainThreadTreeViews),ze,mt)),ki=Ge.set(r.ExtHostContext.ExtHostEditorInsets,new b.ExtHostEditorInsets(Ge.getProxy(r.MainContext.MainThreadEditorInsets),xt,pt.remote)),ui=Ge.set(r.ExtHostContext.ExtHostDiagnostics,new M.ExtHostDiagnostics(Ge,mt,zt,Fe)),di=Ge.set(r.ExtHostContext.ExtHostLanguages,new Z.ExtHostLanguages(Ge,Et,ze.converter,Tt)),ht=Ge.set(r.ExtHostContext.ExtHostLanguageFeatures,new fe.ExtHostLanguageFeatures(Ge,Tt,Et,ze,ui,mt,At,kt)),Gi=Ge.set(r.ExtHostContext.ExtHostFileSystem,new ue.ExtHostFileSystem(Ge,ht)),ei=Ge.set(r.ExtHostContext.ExtHostFileSystemEventService,new pe.ExtHostFileSystemEventService(Ge,mt,Fe)),oi=Ge.set(r.ExtHostContext.ExtHostQuickOpen,(0,de.createExtHostQuickOpen)(Ge,ft,ze)),vi=Ge.set(r.ExtHostContext.ExtHostSCM,new Ue.ExtHostSCM(Ge,ze,Et,mt)),Pi=Ge.set(r.ExtHostContext.ExtHostQuickDiff,new ae.ExtHostQuickDiff(Ge,Tt)),Ki=Ge.set(r.ExtHostContext.ExtHostShare,new Ze.ExtHostShare(Ge,Tt)),Ti=Ge.set(r.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(Ge,ze,Et)),bi=Ge.set(r.ExtHostContext.ExtHostProgress,new H.ExtHostProgress(Ge.getProxy(r.MainContext.MainThreadProgress))),Xi=Ge.set(r.ExtHostContext.ExtHostLabelService,new he.ExtHostLabelService(Ge)),Ai=Ge.set(r.ExtHostContext.ExtHostTheming,new Ie.ExtHostTheming(Ge)),hi=Ge.set(r.ExtHostContext.ExtHostAuthentication,new d.ExtHostAuthentication(Ge)),Qi=Ge.set(r.ExtHostContext.ExtHostTimeline,new He.ExtHostTimeline(Ge,ze)),Ei=Ge.set(r.ExtHostContext.ExtHostWebviews,new Nt.ExtHostWebviews(Ge,pt.remote,ft,mt,At)),Ri=Ge.set(r.ExtHostContext.ExtHostWebviewPanels,new _t.ExtHostWebviewPanels(Ge,Ei,ft)),un=Ge.set(r.ExtHostContext.ExtHostCustomEditors,new O.ExtHostCustomEditors(Ge,Et,Ut,Ei,Ri)),Li=Ge.set(r.ExtHostContext.ExtHostWebviewViews,new Vt.ExtHostWebviewViews(Ge,Ei)),ai=Ge.set(r.ExtHostContext.ExtHostTesting,new re.ExtHostTesting(Ge,mt,ze,Fe)),dn=Ge.set(r.ExtHostContext.ExtHostUriOpeners,new St.ExtHostUriOpeners(Ge)),hn=Ge.set(r.ExtHostContext.ExtHostProfileContentHandlers,new te.ExtHostProfileContentHandlers(Ge));Ge.set(r.ExtHostContext.ExtHostInteractive,new ie.ExtHostInteractive(Ge,Pt,Fe,ze,mt));const Yi=Ge.set(r.ExtHostContext.ExtHostInlineChat,new W.ExtHostInteractiveEditor(Ge,ze,Et,mt)),Oi=Ge.set(r.ExtHostContext.ExtHostChatProvider,new u.ExtHostChatProvider(Ge,mt)),Fi=Ge.set(r.ExtHostContext.ExtHostChatAgents2,new l.ExtHostChatAgents2(Ge,Oi,mt)),Ji=Ge.set(r.ExtHostContext.ExtHostChatVariables,new w.ExtHostChatVariables(Ge)),wi=Ge.set(r.ExtHostContext.ExtHostChat,new h.ExtHostChat(Ge)),Ni=Ge.set(r.ExtHostContext.ExtHostAiRelatedInformation,new n.ExtHostRelatedInformation(Ge)),fn=Ge.set(r.ExtHostContext.ExtHostAiEmbeddingVector,new K.ExtHostAiEmbeddingVector(Ge)),Si=Ge.set(r.ExtHostContext.ExtHostIssueReporter,new Se.ExtHostIssueReporter(Ge)),Mi=Ge.set(r.ExtHostContext.ExtHostStatusBar,new st.ExtHostStatusBar(Ge,ze.converter)),ni=Ge.set(r.ExtHostContext.ExtHostSpeech,new at.ExtHostSpeech(Ge)),_i=Object.values(r.ExtHostContext);Ge.assertRegistered(_i);const mn=new s.ExtHostBulkEdits(Ge,Fe),Yt=new k.ExtHostClipboard(Ge),fi=new J.ExtHostMessageService(Ge,mt),Ui=new L.ExtHostDialogs(Ge);return a.ExtHostApiCommands.register(ze),function(We,ti,xi){function ot(ve){return(_e,Be,lt)=>{const bt=ve(Rt=>{try{_e.call(Be,Rt)}catch(ln){F.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event`,{cause:ln})),kt.onExtensionError(We.identifier,ln)}});return lt?.push(bt),bt}}const vt=function(){let ve=!We.isUnderDevelopment;function _e(){ve||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Be(lt){if(Array.isArray(lt))lt.forEach(Be);else if(typeof lt=="string")_e();else{const bt=lt;typeof bt.scheme>"u"&&_e(),typeof bt.exclusive=="boolean"&&(0,et.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return lt}}(),Zi={getSession(ve,_e,Be){return hi.getSession(We,ve,_e,Be)},getSessions(ve,_e){return(0,et.checkProposedApiEnabled)(We,"authGetSessions"),hi.getSessions(We,ve,_e)},async hasSession(ve,_e){return(0,et.checkProposedApiEnabled)(We,"authSession"),!!await hi.getSession(We,ve,_e,{silent:!0})},get onDidChangeSessions(){return ot(hi.onDidChangeSessions)},registerAuthenticationProvider(ve,_e,Be,lt){return hi.registerAuthenticationProvider(ve,_e,Be,lt)}},gn={registerCommand(ve,_e,Be){return ze.registerCommand(!0,ve,_e,Be,void 0,We)},registerTextEditorCommand(ve,_e,Be){return ze.registerCommand(!0,ve,(...lt)=>{const bt=xt.getActiveTextEditor();if(!bt){mt.warn("Cannot execute "+ve+" because there is no active text editor.");return}return bt.edit(Rt=>{_e.apply(Be,[bt,Rt,...lt])}).then(Rt=>{Rt||mt.warn("Edits from command "+ve+" were not applied.")},Rt=>{mt.warn("An error occurred while running command "+ve,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(ve,_e,Be)=>((0,et.checkProposedApiEnabled)(We,"diffCommand"),ze.registerCommand(!0,ve,async(...lt)=>{const bt=Fe.activeEditor(!0);if(!bt){mt.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Rt=await xt.getDiffInformation(bt.id);_e.apply(Be,[Rt,...lt])},void 0,void 0,We)),executeCommand(ve,..._e){return ze.executeCommand(ve,..._e)},getCommands(ve=!1){return ze.getCommands(ve)}},en={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Yt.value},get shell(){return Je.getDefaultShell(!1)},get onDidChangeShell(){return ot(Je.onDidChangeShell)},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(kt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.checkProposedApiEnabled)(We,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.checkProposedApiEnabled)(We,"telemetry"),ot(kt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Te.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,_e){return Te.ExtHostTelemetryLogger.validateSender(ve),kt.instantiateLogger(We,ve,_e)},openExternal(ve,_e){return Wt.openUri(ve,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===pt.environment.appUriScheme)return It.createAppUri(ve);try{return await Wt.asExternalUri(ve,{allowTunneling:!!pt.remote.authority})}catch(_e){if((0,A.matchesScheme)(ve,A.Schemas.http)||(0,A.matchesScheme)(ve,A.Schemas.https))return ve;throw _e}},get remoteName(){return(0,m.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return ot(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(ve){return(0,et.checkProposedApiEnabled)(We,"handleIssueUri"),Si.registerIssueUriRequestHandler(We,ve)},registerIssueDataProvider(ve){return(0,et.checkProposedApiEnabled)(We,"handleIssueUri"),Si.registerIssueDataProvider(We,ve)},get appQuality(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),pt.quality},get appCommit(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(en);const tn={createTestController(ve,_e,Be){return ai.createTestController(We,ve,_e,Be)},createTestObserver(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),ai.createTestObserver()},runTests(ve){return(0,et.checkProposedApiEnabled)(We,"testObserver"),ai.runTests(ve)},get onDidChangeTestResults(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),ai.results}},mi=pt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,nn={getExtension(ve,_e){(0,et.isProposedApiEnabled)(We,"extensionsAny")||(_e=!1);const Be=ti.mine.getExtensionDescription(ve);if(Be)return new Q.Extension(yt,We.identifier,Be,mi,!1);if(_e){const lt=ti.all.getExtensionDescription(ve);if(lt)return new Q.Extension(yt,We.identifier,lt,mi,!0)}},get all(){const ve=[];for(const _e of ti.mine.getAllExtensionDescriptions())ve.push(new Q.Extension(yt,We.identifier,_e,mi,!1));return ve},get allAcrossExtensionHosts(){(0,et.checkProposedApiEnabled)(We,"extensionsAny");const ve=new S.ExtensionIdentifierSet(ti.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),_e=[];for(const Be of ti.all.getAllExtensionDescriptions()){const lt=!ve.has(Be.identifier);_e.push(new Q.Extension(yt,We.identifier,Be,mi,lt))}return _e},get onDidChange(){return(0,et.isProposedApiEnabled)(We,"extensionsAny")?ot(f.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},rn={createDiagnosticCollection(ve){return ui.createDiagnosticCollection(We.identifier,ve)},get onDidChangeDiagnostics(){return ot(ui.onDidChangeDiagnostics)},getDiagnostics:ve=>ui.getDiagnostics(ve),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(ve,_e){return di.changeLanguage(ve.uri,_e)},match(ve,_e){const Be=Et.getDocumentData(_e.uri)?.notebook;return(0,R.score)(nt.LanguageSelector.from(ve),_e.uri,_e.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(ve,_e,Be){return ht.registerCodeActionProvider(We,vt(ve),_e,Be)},registerDocumentPasteEditProvider(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"documentPaste"),ht.registerDocumentPasteEditProvider(We,vt(ve),_e,Be)},registerCodeLensProvider(ve,_e){return ht.registerCodeLensProvider(We,vt(ve),_e)},registerDefinitionProvider(ve,_e){return ht.registerDefinitionProvider(We,vt(ve),_e)},registerDeclarationProvider(ve,_e){return ht.registerDeclarationProvider(We,vt(ve),_e)},registerImplementationProvider(ve,_e){return ht.registerImplementationProvider(We,vt(ve),_e)},registerTypeDefinitionProvider(ve,_e){return ht.registerTypeDefinitionProvider(We,vt(ve),_e)},registerHoverProvider(ve,_e){return ht.registerHoverProvider(We,vt(ve),_e,We.identifier)},registerEvaluatableExpressionProvider(ve,_e){return ht.registerEvaluatableExpressionProvider(We,vt(ve),_e,We.identifier)},registerInlineValuesProvider(ve,_e){return ht.registerInlineValuesProvider(We,vt(ve),_e,We.identifier)},registerDocumentHighlightProvider(ve,_e){return ht.registerDocumentHighlightProvider(We,vt(ve),_e)},registerMultiDocumentHighlightProvider(ve,_e){return ht.registerMultiDocumentHighlightProvider(We,vt(ve),_e)},registerLinkedEditingRangeProvider(ve,_e){return ht.registerLinkedEditingRangeProvider(We,vt(ve),_e)},registerReferenceProvider(ve,_e){return ht.registerReferenceProvider(We,vt(ve),_e)},registerRenameProvider(ve,_e){return ht.registerRenameProvider(We,vt(ve),_e)},registerDocumentSymbolProvider(ve,_e,Be){return ht.registerDocumentSymbolProvider(We,vt(ve),_e,Be)},registerWorkspaceSymbolProvider(ve){return ht.registerWorkspaceSymbolProvider(We,ve)},registerDocumentFormattingEditProvider(ve,_e){return ht.registerDocumentFormattingEditProvider(We,vt(ve),_e)},registerDocumentRangeFormattingEditProvider(ve,_e){return ht.registerDocumentRangeFormattingEditProvider(We,vt(ve),_e)},registerOnTypeFormattingEditProvider(ve,_e,Be,...lt){return ht.registerOnTypeFormattingEditProvider(We,vt(ve),_e,[Be].concat(lt))},registerDocumentSemanticTokensProvider(ve,_e,Be){return ht.registerDocumentSemanticTokensProvider(We,vt(ve),_e,Be)},registerDocumentRangeSemanticTokensProvider(ve,_e,Be){return ht.registerDocumentRangeSemanticTokensProvider(We,vt(ve),_e,Be)},registerSignatureHelpProvider(ve,_e,Be,...lt){return typeof Be=="object"?ht.registerSignatureHelpProvider(We,vt(ve),_e,Be):ht.registerSignatureHelpProvider(We,vt(ve),_e,typeof Be>"u"?[]:[Be,...lt])},registerCompletionItemProvider(ve,_e,...Be){return ht.registerCompletionItemProvider(We,vt(ve),_e,Be)},registerInlineCompletionItemProvider(ve,_e,Be){return _e.handleDidShowCompletionItem&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),Be&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(We,vt(ve),_e,Be)},registerDocumentLinkProvider(ve,_e){return ht.registerDocumentLinkProvider(We,vt(ve),_e)},registerColorProvider(ve,_e){return ht.registerColorProvider(We,vt(ve),_e)},registerFoldingRangeProvider(ve,_e){return ht.registerFoldingRangeProvider(We,vt(ve),_e)},registerSelectionRangeProvider(ve,_e){return ht.registerSelectionRangeProvider(We,ve,_e)},registerCallHierarchyProvider(ve,_e){return ht.registerCallHierarchyProvider(We,ve,_e)},registerTypeHierarchyProvider(ve,_e){return ht.registerTypeHierarchyProvider(We,ve,_e)},setLanguageConfiguration:(ve,_e)=>ht.setLanguageConfiguration(We,ve,_e),getTokenInformationAtPosition(ve,_e){return(0,et.checkProposedApiEnabled)(We,"tokenInformation"),di.tokenAtPosition(ve,_e)},registerInlayHintsProvider(ve,_e){return ht.registerInlayHintsProvider(We,ve,_e)},createLanguageStatusItem(ve,_e){return di.createLanguageStatusItem(We,ve,_e)},registerDocumentDropEditProvider(ve,_e,Be){return ht.registerDocumentOnDropEditProvider(We,ve,_e,(0,et.isProposedApiEnabled)(We,"dropMetadata")?Be:void 0)}},sn={get activeTextEditor(){return xt.getActiveTextEditor()},get visibleTextEditors(){return xt.getVisibleTextEditors()},get activeTerminal(){return Je.activeTerminal},get terminals(){return Je.terminals},async showTextDocument(ve,_e,Be){const lt=await(p.URI.isUri(ve)?Promise.resolve(on.openTextDocument(ve)):Promise.resolve(ve));return xt.showTextDocument(lt,_e,Be)},createTextEditorDecorationType(ve){return xt.createTextEditorDecorationType(We,ve)},onDidChangeActiveTextEditor(ve,_e,Be){return ot(xt.onDidChangeActiveTextEditor)(ve,_e,Be)},onDidChangeVisibleTextEditors(ve,_e,Be){return ot(xt.onDidChangeVisibleTextEditors)(ve,_e,Be)},onDidChangeTextEditorSelection(ve,_e,Be){return ot(xt.onDidChangeTextEditorSelection)(ve,_e,Be)},onDidChangeTextEditorOptions(ve,_e,Be){return ot(xt.onDidChangeTextEditorOptions)(ve,_e,Be)},onDidChangeTextEditorVisibleRanges(ve,_e,Be){return ot(xt.onDidChangeTextEditorVisibleRanges)(ve,_e,Be)},onDidChangeTextEditorViewColumn(ve,_e,Be){return ot(xt.onDidChangeTextEditorViewColumn)(ve,_e,Be)},onDidCloseTerminal(ve,_e,Be){return ot(Je.onDidCloseTerminal)(ve,_e,Be)},onDidOpenTerminal(ve,_e,Be){return ot(Je.onDidOpenTerminal)(ve,_e,Be)},onDidChangeActiveTerminal(ve,_e,Be){return ot(Je.onDidChangeActiveTerminal)(ve,_e,Be)},onDidChangeTerminalDimensions(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"terminalDimensions"),ot(Je.onDidChangeTerminalDimensions)(ve,_e,Be)},onDidChangeTerminalState(ve,_e,Be){return ot(Je.onDidChangeTerminalState)(ve,_e,Be)},onDidWriteTerminalData(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),ot(Je.onDidWriteTerminalData)(ve,_e,Be)},onDidExecuteTerminalCommand(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"terminalExecuteCommandEvent"),ot(Je.onDidExecuteTerminalCommand)(ve,_e,Be)},get state(){return Wt.getState(We)},onDidChangeWindowState(ve,_e,Be){return ot(Wt.onDidChangeWindowState)(ve,_e,Be)},showInformationMessage(ve,..._e){return fi.showMessage(We,E.default.Info,ve,_e[0],_e.slice(1))},showWarningMessage(ve,..._e){return fi.showMessage(We,E.default.Warning,ve,_e[0],_e.slice(1))},showErrorMessage(ve,..._e){return fi.showMessage(We,E.default.Error,ve,_e[0],_e.slice(1))},showQuickPick(ve,_e,Be){return oi.showQuickPick(We,ve,_e,Be)},showWorkspaceFolderPick(ve){return oi.showWorkspaceFolderPick(ve)},showInputBox(ve,_e){return oi.showInput(ve,_e)},showOpenDialog(ve){return Ui.showOpenDialog(We,ve)},showSaveDialog(ve){return Ui.showSaveDialog(ve)},createStatusBarItem(ve,_e,Be){let lt,bt,Rt;return typeof ve=="string"?(lt=ve,bt=_e,Rt=Be):(bt=ve,Rt=_e),Mi.createStatusBarEntry(We,lt,bt,Rt)},setStatusBarMessage(ve,_e){return Mi.setStatusBarMessage(ve,_e)},withScmProgress(ve){return At.report("window.withScmProgress",We,"Use 'withProgress' instead."),bi.withProgress(We,{location:Me.ProgressLocation.SourceControl},(_e,Be)=>ve({report(lt){}}))},withProgress(ve,_e){return bi.withProgress(We,ve,_e)},createOutputChannel(ve,_e){return qt.createOutputChannel(ve,_e,We)},createWebviewPanel(ve,_e,Be,lt){return Ri.createWebviewPanel(We,ve,_e,Be,lt)},createWebviewTextEditorInset(ve,_e,Be,lt){return(0,et.checkProposedApiEnabled)(We,"editorInsets"),ki.createWebviewEditorInset(ve,_e,Be,lt,We)},createTerminal(ve,_e,Be){return typeof ve=="object"?"pty"in ve?Je.createExtensionTerminal(ve):Je.createTerminalFromOptions(ve):Je.createTerminal(ve,_e,Be)},registerTerminalLinkProvider(ve){return Je.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,_e){return Je.registerProfileProvider(We,ve,_e)},registerTerminalQuickFixProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),Je.registerTerminalQuickFixProvider(ve,We.identifier.value,_e)},registerTreeDataProvider(ve,_e){return pi.registerTreeDataProvider(ve,_e,We)},createTreeView(ve,_e){return pi.createTreeView(ve,_e,We)},registerWebviewPanelSerializer:(ve,_e)=>Ri.registerWebviewPanelSerializer(We,ve,_e),registerCustomEditorProvider:(ve,_e,Be={})=>un.registerCustomEditorProvider(We,ve,_e,Be),registerFileDecorationProvider(ve){return ce.registerFileDecorationProvider(ve,We)},registerUriHandler(ve){return It.registerUriHandler(We,ve)},createQuickPick(){return oi.createQuickPick(We)},createInputBox(){return oi.createInputBox(We)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ve,_e,Be){return ot(Ai.onDidChangeActiveColorTheme)(ve,_e,Be)},registerWebviewViewProvider(ve,_e,Be){return Li.registerWebviewViewProvider(We,ve,_e,Be?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,_e,Be){return ot(Pt.onDidChangeActiveNotebookEditor)(ve,_e,Be)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ve,_e,Be){return ot(gi.onDidChangeNotebookEditorSelection)(ve,_e,Be)},onDidChangeNotebookEditorVisibleRanges(ve,_e,Be){return ot(gi.onDidChangeNotebookEditorVisibleRanges)(ve,_e,Be)},showNotebookDocument(ve,_e){return Pt.showNotebookDocument(ve,_e)},registerExternalUriOpener(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"externalUriOpener"),dn.registerExternalUriOpener(We.identifier,ve,_e,Be)},registerProfileContentHandler(ve,_e){return(0,et.checkProposedApiEnabled)(We,"profileContentHandlers"),hn.registerProfileContentHandler(We,ve,_e)},registerQuickDiffProvider(ve,_e,Be,lt){return(0,et.checkProposedApiEnabled)(We,"quickDiffProvider"),Pi.registerQuickDiffProvider(vt(ve),_e,Be,lt)},get tabGroups(){return Ne.tabGroups},registerShareProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"shareProvider"),Ki.registerShareProvider(vt(ve),_e)}},on={get rootPath(){return At.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ve){throw new F.ReadonlyError("rootPath")},getWorkspaceFolder(ve){return ft.getWorkspaceFolder(ve)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ve){throw new F.ReadonlyError("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ve){throw new F.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ve,_e,...Be)=>ft.updateWorkspaceFolders(We,ve,_e||0,...Be),onDidChangeWorkspaceFolders:function(ve,_e,Be){return ot(ft.onDidChangeWorkspace)(ve,_e,Be)},asRelativePath:(ve,_e)=>ft.getRelativePath(ve,_e),findFiles:(ve,_e,Be,lt)=>ft.findFiles(ve,_e,Be,We.identifier,lt),findTextInFiles:(ve,_e,Be,lt)=>{(0,et.checkProposedApiEnabled)(We,"findTextInFiles");let bt,Rt;return typeof _e=="object"?(bt=_e,Rt=Be):(bt={},Rt=_e,lt=Be),ft.findTextInFiles(ve,bt||{},Rt,We.identifier,lt)},save:ve=>ft.save(ve),saveAs:ve=>ft.saveAs(ve),saveAll:ve=>ft.saveAll(ve),applyEdit(ve,_e){return mn.applyWorkspaceEdit(ve,We,_e)},createFileSystemWatcher:(ve,_e,Be,lt)=>{let bt;return typeof _e=="boolean"?bt={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!lt,correlate:!1}:_e&&((0,et.checkProposedApiEnabled)(We,"createFileSystemWatcher"),bt={..._e,correlate:!0}),ei.createFileSystemWatcher(ft,We,ve,bt)},get textDocuments(){return Et.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw new F.ReadonlyError("textDocuments")},openTextDocument(ve){let _e;const Be=ve;if(typeof ve=="string")_e=Promise.resolve(p.URI.file(ve));else if(p.URI.isUri(ve))_e=Promise.resolve(ve);else if(!Be||typeof Be=="object")_e=Et.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(lt=>Et.ensureDocumentData(lt).then(bt=>bt.document))},onDidOpenTextDocument:(ve,_e,Be)=>ot(Et.onDidAddDocument)(ve,_e,Be),onDidCloseTextDocument:(ve,_e,Be)=>ot(Et.onDidRemoveDocument)(ve,_e,Be),onDidChangeTextDocument:(ve,_e,Be)=>ot(Et.onDidChangeDocument)(ve,_e,Be),onDidSaveTextDocument:(ve,_e,Be)=>ot(Et.onDidSaveDocument)(ve,_e,Be),onWillSaveTextDocument:(ve,_e,Be)=>ot(qi.getOnWillSaveTextDocumentEvent(We))(ve,_e,Be),get notebookDocuments(){return Pt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,_e){let Be;if(p.URI.isUri(ve))Be=ve,await Pt.openNotebookDocument(ve);else if(typeof ve=="string")Be=p.URI.revive(await Pt.createNotebookDocument({viewType:ve,content:_e}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ve,_e,Be){return ot(si.onDidSaveNotebookDocument)(ve,_e,Be)},onDidChangeNotebookDocument(ve,_e,Be){return ot(si.onDidChangeNotebookDocument)(ve,_e,Be)},onWillSaveNotebookDocument(ve,_e,Be){return ot(Ii.getOnWillSaveNotebookDocumentEvent(We))(ve,_e,Be)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(ve,_e,Be,lt){return Pt.registerNotebookSerializer(We,ve,_e,Be,(0,et.isProposedApiEnabled)(We,"notebookLiveShare")?lt:void 0)},onDidChangeConfiguration:(ve,_e,Be)=>ot(xi.onDidChangeConfiguration)(ve,_e,Be),getConfiguration(ve,_e){return _e=arguments.length===1?void 0:_e,xi.getConfiguration(ve,_e,We)},registerTextDocumentContentProvider(ve,_e){return Ci.registerTextDocumentContentProvider(ve,_e)},registerTaskProvider:(ve,_e)=>(At.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(We,ve,_e)),registerFileSystemProvider(ve,_e,Be){return(0,P.combinedDisposable)(Gi.registerFileSystemProvider(We,ve,_e,Be),Kt.addFileSystemProvider(ve,_e,Be))},get fs(){return Kt.value},registerFileSearchProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"fileSearchProvider"),ct.registerFileSearchProvider(ve,_e)),registerTextSearchProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"textSearchProvider"),ct.registerTextSearchProvider(ve,_e)),registerRemoteAuthorityResolver:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"resolvers"),yt.registerRemoteAuthorityResolver(ve,_e)),registerResourceLabelFormatter:ve=>((0,et.checkProposedApiEnabled)(We,"resolvers"),Xi.$registerResourceLabelFormatter(ve)),getRemoteExecServer:ve=>((0,et.checkProposedApiEnabled)(We,"resolvers"),yt.getRemoteExecServer(ve)),onDidCreateFiles:(ve,_e,Be)=>ot(ei.onDidCreateFile)(ve,_e,Be),onDidDeleteFiles:(ve,_e,Be)=>ot(ei.onDidDeleteFile)(ve,_e,Be),onDidRenameFiles:(ve,_e,Be)=>ot(ei.onDidRenameFile)(ve,_e,Be),onWillCreateFiles:(ve,_e,Be)=>ot(ei.getOnWillCreateFileEvent(We))(ve,_e,Be),onWillDeleteFiles:(ve,_e,Be)=>ot(ei.getOnWillDeleteFileEvent(We))(ve,_e,Be),onWillRenameFiles:(ve,_e,Be)=>ot(ei.getOnWillRenameFileEvent(We))(ve,_e,Be),openTunnel:ve=>((0,et.checkProposedApiEnabled)(We,"tunnels"),Ot.openTunnel(We,ve).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,et.checkProposedApiEnabled)(We,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(ve,_e,Be)=>((0,et.checkProposedApiEnabled)(We,"tunnels"),ot(Ot.onDidChangeTunnels)(ve,_e,Be)),registerPortAttributesProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"portsAttributes"),Ot.registerPortsAttributesProvider(ve,_e)),registerTunnelProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"tunnelFactory"),Ot.registerTunnelProvider(ve,_e)),registerTimelineProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"timeline"),Qi.registerTimelineProvider(ve,_e,We.identifier,ze.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ve=>((0,et.checkProposedApiEnabled)(We,"workspaceTrust"),ft.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,_e,Be)=>ot(ft.onDidGrantWorkspaceTrust)(ve,_e,Be),registerEditSessionIdentityProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ve,_e)),onWillCreateEditSessionIdentity:(ve,_e,Be)=>((0,et.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(We))(ve,_e,Be)),registerCanonicalUriProvider:(ve,_e)=>((0,et.checkProposedApiEnabled)(We,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ve,_e)),getCanonicalUri:(ve,_e,Be)=>((0,et.checkProposedApiEnabled)(We,"canonicalUriProvider"),ft.provideCanonicalUri(ve,_e,Be))},pn={get inputBox(){return At.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(We)},createSourceControl(ve,_e,Be){return vi.createSourceControl(We,ve,_e,Be)}},an={createCommentController(ve,_e){return Ti.createCommentController(We,ve,_e)}},cn={get activeDebugSession(){return qe.activeDebugSession},get activeDebugConsole(){return qe.activeDebugConsole},get breakpoints(){return qe.breakpoints},get stackFrameFocus(){return qe.stackFrameFocus},registerDebugVisualizationProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"debugVisualization"),qe.registerDebugVisualizationProvider(We,ve,_e)},onDidStartDebugSession(ve,_e,Be){return ot(qe.onDidStartDebugSession)(ve,_e,Be)},onDidTerminateDebugSession(ve,_e,Be){return ot(qe.onDidTerminateDebugSession)(ve,_e,Be)},onDidChangeActiveDebugSession(ve,_e,Be){return ot(qe.onDidChangeActiveDebugSession)(ve,_e,Be)},onDidReceiveDebugSessionCustomEvent(ve,_e,Be){return ot(qe.onDidReceiveDebugSessionCustomEvent)(ve,_e,Be)},onDidChangeBreakpoints(ve,_e,Be){return ot(qe.onDidChangeBreakpoints)(ve,_e,Be)},onDidChangeStackFrameFocus(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"debugFocus"),ot(qe.onDidChangeStackFrameFocus)(ve,_e,Be)},registerDebugConfigurationProvider(ve,_e,Be){return qe.registerDebugConfigurationProvider(ve,_e,Be||$t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,_e){return qe.registerDebugAdapterDescriptorFactory(We,ve,_e)},registerDebugAdapterTrackerFactory(ve,_e){return qe.registerDebugAdapterTrackerFactory(ve,_e)},startDebugging(ve,_e,Be){return!Be||typeof Be=="object"&&"configuration"in Be?qe.startDebugging(ve,_e,{parentSession:Be}):qe.startDebugging(ve,_e,Be||{})},stopDebugging(ve){return qe.stopDebugging(ve)},addBreakpoints(ve){return qe.addBreakpoints(ve)},removeBreakpoints(ve){return qe.removeBreakpoints(ve)},asDebugSourceUri(ve,_e){return qe.asDebugSourceUri(ve,_e)}},Bi={registerTaskProvider:(ve,_e)=>wt.registerTaskProvider(We,ve,_e),fetchTasks:ve=>wt.fetchTasks(ve),executeTask:ve=>wt.executeTask(We,ve),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(ve,_e,Be)=>ot(wt.onDidStartTask)(ve,_e,Be),onDidEndTask:(ve,_e,Be)=>ot(wt.onDidEndTask)(ve,_e,Be),onDidStartTaskProcess:(ve,_e,Be)=>ot(wt.onDidStartTaskProcess)(ve,_e,Be),onDidEndTaskProcess:(ve,_e,Be)=>ot(wt.onDidEndTaskProcess)(ve,_e,Be)},zi={createNotebookController(ve,_e,Be,lt,bt){return li.createNotebookController(We,ve,_e,Be,lt,(0,et.isProposedApiEnabled)(We,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,_e)=>Pt.registerNotebookCellStatusBarItemProvider(We,ve,_e),createRendererMessaging(ve){return Di.createRendererMessaging(We,ve)},createNotebookControllerDetectionTask(ve){return(0,et.checkProposedApiEnabled)(We,"notebookKernelSource"),li.createNotebookControllerDetectionTask(We,ve)},registerKernelSourceActionProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"notebookKernelSource"),li.registerKernelSourceActionProvider(We,ve,_e)},onDidChangeNotebookCellExecutionState(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"notebookCellExecutionState"),ot(li.onDidChangeNotebookCellExecutionState)(ve,_e,Be)}},Wi={t(...ve){if(typeof ve[0]=="string"){const _e=ve.shift(),Be=!ve||typeof ve[0]!="object"?ve:ve[0];return Ct.getMessage(We.identifier.value,{message:_e,args:Be})}return Ct.getMessage(We.identifier.value,ve[0])},get bundle(){return Ct.getBundle(We.identifier.value)},get uri(){return Ct.getBundleUri(We.identifier.value)}},yi={_version:1,registerInteractiveEditorSessionProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),Yi.registerProvider(We,ve,_e)},registerInteractiveSessionProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.registerChatProvider(We,ve,_e)},sendInteractiveRequestToProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.sendInteractiveRequestToProvider(ve,_e)},transferChatSession(ve,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.transferChatSession(ve,_e)}},$i={getRelatedInformation(ve,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),Ni.getRelatedInformation(We,ve,_e)},registerRelatedInformationProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(We,ve,_e)},registerEmbeddingVectorProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,ve,_e)}},Hi={registerChatResponseProvider(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"chatProvider"),Oi.registerProvider(We.identifier,ve,_e,Be)},requestChatAccess(ve){return(0,et.checkProposedApiEnabled)(We,"chatRequestAccess"),Oi.requestChatResponseProvider(We.identifier,ve)},registerVariable(ve,_e,Be){return(0,et.checkProposedApiEnabled)(We,"chatAgents2"),Ji.registerVariableResolver(We,ve,_e,Be)},registerMappedEditsProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"mappedEditsProvider"),ht.registerMappedEditsProvider(We,ve,_e)},createChatAgent(ve,_e){return(0,et.checkProposedApiEnabled)(We,"chatAgents2"),Fi.createChatAgent(We,ve,_e)}},vn={registerSpeechProvider(ve,_e){return(0,et.checkProposedApiEnabled)(We,"speech"),ni.registerProvider(We.identifier,ve,_e)}};return{version:pt.version,ai:$i,authentication:Zi,commands:gn,comments:an,chat:Hi,debug:cn,env:en,extensions:nn,interactive:yi,l10n:Wi,languages:rn,notebooks:zi,scm:pn,speech:vn,tasks:Bi,tests:tn,window:sn,workspace:on,Breakpoint:Me.Breakpoint,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Me.ChatAgentResultFeedbackKind,ChatMessage:Me.ChatMessage,ChatMessageRole:Me.ChatMessageRole,ChatVariableLevel:Me.ChatVariableLevel,ChatAgentCompletionItem:Me.ChatAgentCompletionItem,CallHierarchyIncomingCall:Me.CallHierarchyIncomingCall,CallHierarchyItem:Me.CallHierarchyItem,CallHierarchyOutgoingCall:Me.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:Me.CodeAction,CodeActionKind:Me.CodeActionKind,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.CodeLens,Color:Me.Color,ColorInformation:Me.ColorInformation,ColorPresentation:Me.ColorPresentation,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CompletionItem:Me.CompletionItem,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.CompletionList,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.CustomExecution,DebugAdapterExecutable:Me.DebugAdapterExecutable,DebugAdapterInlineImplementation:Me.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Me.DebugAdapterNamedPipeServer,DebugAdapterServer:Me.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.DebugVisualization,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.Diagnostic,DiagnosticRelatedInformation:Me.DiagnosticRelatedInformation,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.Disposable,DocumentHighlight:Me.DocumentHighlight,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.MultiDocumentHighlight,DocumentLink:Me.DocumentLink,DocumentSymbol:Me.DocumentSymbol,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.EvaluatableExpression,InlineValueText:Me.InlineValueText,InlineValueVariableLookup:Me.InlineValueVariableLookup,InlineValueEvaluatableExpression:Me.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:f.Emitter,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.FileDecoration,FileDecoration2:Me.FileDecoration,FileSystemError:Me.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:Me.FoldingRange,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.FunctionBreakpoint,InlineCompletionItem:Me.InlineSuggestion,InlineCompletionList:Me.InlineSuggestionList,Hover:Me.Hover,IndentAction:D.IndentAction,Location:Me.Location,MarkdownString:Me.MarkdownString,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:Me.ParameterInformation,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.Position,ProcessExecution:Me.ProcessExecution,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.QuickInputButtons,Range:Me.Range,RelativePattern:Me.RelativePattern,Selection:Me.Selection,SelectionRange:Me.SelectionRange,SemanticTokens:Me.SemanticTokens,SemanticTokensBuilder:Me.SemanticTokensBuilder,SemanticTokensEdit:Me.SemanticTokensEdit,SemanticTokensEdits:Me.SemanticTokensEdits,SemanticTokensLegend:Me.SemanticTokensLegend,ShellExecution:Me.ShellExecution,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.SignatureHelp,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.SignatureInformation,SnippetString:Me.SnippetString,SourceBreakpoint:Me.SourceBreakpoint,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.SymbolInformation,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.Task,TaskGroup:Me.TaskGroup,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.TerminalLink,TerminalQuickFixTerminalCommand:Me.TerminalQuickFixCommand,TerminalQuickFixOpener:Me.TerminalQuickFixOpener,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.TerminalProfile,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.TextEdit,SnippetTextEdit:Me.SnippetTextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.ThemeColor,ThemeIcon:Me.ThemeIcon,TreeItem:Me.TreeItem,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.TypeHierarchyItem,UIKind:Bt.UIKind,Uri:p.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.WorkspaceEdit,DocumentDropEdit:Me.DocumentDropEdit,DocumentPasteEdit:Me.DocumentPasteEdit,InlayHint:Me.InlayHint,InlayHintLabelPart:Me.InlayHintLabelPart,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.RemoteAuthorityResolverError,ResolvedAuthority:Me.ResolvedAuthority,ManagedResolvedAuthority:Me.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.TimelineItem,NotebookRange:Me.NotebookRange,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.NotebookCellData,NotebookData:Me.NotebookData,NotebookRendererScript:Me.NotebookRendererScript,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.NotebookCellOutput,NotebookCellOutputItem:Me.NotebookCellOutputItem,NotebookCellStatusBarItem:Me.NotebookCellStatusBarItem,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.NotebookEdit,NotebookKernelSourceAction:Me.NotebookKernelSourceAction,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.PortAttributes,LinkedEditingRanges:Me.LinkedEditingRanges,TestResultState:Me.TestResultState,TestRunRequest:Me.TestRunRequest,TestMessage:Me.TestMessage,TestMessage2:Me.TestMessage,TestTag:Me.TestTag,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Me.DataTransfer,DataTransferItem:Me.DataTransferItem,CoveredCount:Me.CoveredCount,FileCoverage:Me.FileCoverage,StatementCoverage:Me.StatementCoverage,BranchCoverage:Me.BranchCoverage,FunctionCoverage:Me.FunctionCoverage,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.TextTabInput,TabInputTextDiff:Me.TextDiffTabInput,TabInputTextMerge:Me.TextMergeTabInput,TabInputCustom:Me.CustomEditorTabInput,TabInputNotebook:Me.NotebookEditorTabInput,TabInputNotebookDiff:Me.NotebookDiffEditorTabInput,TabInputWebview:Me.WebviewEditorTabInput,TabInputTerminal:Me.TerminalEditorTabInput,TabInputInteractiveWindow:Me.InteractiveWindowInput,TabInputChat:Me.ChatEditorTabInput,TelemetryTrustedValue:o.TelemetryTrustedValue,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatAgentCopyKind:Me.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Me.StackFrameFocus,ThreadFocus:Me.ThreadFocus,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,KeywordRecognitionStatus:Me.KeywordRecognitionStatus}}}e.createApiFactoryAndRegisterActors=Gt}),define(ye[371],Ce([1,0,84,152,41,147,42,33,72,46,96,97,98,117,70,92,146,69,59,116,91,71,145,13,60,114,115]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(h.IExtHostLocalizationService,h.ExtHostLocalizationService,1),(0,I.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,I.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands,0),(0,I.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,I.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,I.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,0),(0,I.registerSingleton)(p.IExtHostDocumentsAndEditors,p.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(l.IExtHostManagedSockets,l.ExtHostManagedSockets,0),(0,I.registerSingleton)(i.IExtHostFileSystemInfo,i.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService,1),(0,I.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,I.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,I.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,I.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,I.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,0),(0,I.registerSingleton)(f.IExtHostWorkspace,f.ExtHostWorkspace,0),(0,I.registerSingleton)(r.IExtHostSecretState,r.ExtHostSecretState,0),(0,I.registerSingleton)(n.IExtHostTelemetry,n.ExtHostTelemetry,0),(0,I.registerSingleton)(a.IExtHostEditorTabs,a.ExtHostEditorTabs,0),(0,I.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(ye[119],Ce([1,0,19,13,36,95]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=A;function E(D,v,S,C){const c=(0,I.mapArrayOrNot)(S,p),m=new f.TextSearchMatch(v,c,C),o=m.preview.matches;return{ranges:(0,I.mapArrayOrNot)(c,y),uri:D,preview:{text:m.preview.text,matches:(0,I.mapArrayOrNot)(o,y)}}}e.createTextSearchResult=E;function p(D){return new f.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function y(D){return new P.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let R=class{constructor(v,S){this.prefix=v,this.logService=S}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};e.OutputChannel=R,e.OutputChannel=R=je([$e(1,F.ILogService)],R)}),define(ye[372],Ce([1,0,50,17,76,34,10,12,119,373]),function(me,e,I,F,f,P,A,E,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(r,n,a,t){const d=v(r,n,a,t),s=n.folder.fsPath;return{cmd:I.spawn(R,d.args,{cwd:s}),rgDiskPath:R,siblingClauses:d.siblingClauses,rgArgs:d,cwd:s}}e.spawnRipgrepCmd=D;function v(r,n,a,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];C([n],a,!1).forEach(h=>{const l=(0,p.anchorGlob)(h);if(d.push("-g",l),A.isMacintosh){const u=(0,f.normalizeNFD)(l);u!==l&&d.push("-g",u)}});const s=S([n],t,void 0,!1);return s.globArgs.forEach(h=>{const l=`!${(0,p.anchorGlob)(h)}`;if(d.push("-g",l),A.isMacintosh){const u=(0,f.normalizeNFD)(l);u!==l&&d.push("-g",u)}}),n.disregardIgnoreFiles!==!1?d.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),n.ignoreSymlinks||d.push("--follow"),r.exists&&d.push("--quiet"),d.push("--no-config"),n.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:s.siblingClauses}}function S(r,n,a,t=!0){const d=[];let s={};return r.forEach(h=>{const l=Object.assign({},h.excludePattern||{},n||{}),u=c(l,t?h.folder.fsPath:void 0,a);d.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:d,siblingClauses:s}}function C(r,n,a=!0){const t=[];return r.forEach(d=>{const s=Object.assign({},n||{},d.includePattern||{}),h=c(s,a?d.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function c(r,n,a){const t=[],d={};return Object.keys(r).forEach(s=>{if(a&&a.has(s)||!s)return;const h=r[s];s=o(n?m(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof h=="boolean"&&h?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):h&&h.when&&(d[s]=h)}),{globArgs:t,siblingClauses:d}}function m(r,n){return F.isAbsolute(n)?n:F.join(r,n)}e.getAbsoluteGlob=m;function o(r){return r=E.rtrim(r,"\\"),E.rtrim(r,"/")}function i(r){return P.getRoot(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.fixDriveC=i}),define(ye[374],Ce([1,0,50,57,17,375,19,44,35,76,34,10,38,12,18,31,36,372,129]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(h){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=h,this.filePattern=h.filePattern||"",this.includePattern=h.includePattern&&p.parse(h.includePattern),this.maxResults=h.maxResults||null,this.exists=!!h.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,i.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=h.excludePattern&&p.parse(h.excludePattern),this.folderExcludePatterns=new Map,h.folderQueries.forEach(l=>{const u=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),w=l.folder.fsPath;h.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==w).forEach(k=>{(0,R.isEqualOrParent)(k,w)&&(u[f.relative(w,k)]=!0)}),this.folderExcludePatterns.set(w,new t(u,w))})}cancel(){this.isCanceled=!0,r.forEach(h=>h())}walk(h,l,u,w,k){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return k(null,this.isLimitHit);l.forEach(b=>{const g=f.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,g)||this.matchFile(u,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(h,(b,g)=>{this.call(this.cmdTraversal,this,b,u,w,_=>{if(_){const T=(0,E.toErrorMessage)(_);console.error(T),this.errors.push(T),g(_,void 0)}else g(null,void 0)})},(b,g)=>{this.fileWalkSW.stop();const _=b?A.coalesce(b)[0]:null;k(_,this.isLimitHit)})}parallel(h,l,u){const w=new Array(h.length),k=new Array(h.length);let b=!1,g=0;if(h.length===0)return u(null,[]);h.forEach((_,T)=>{l(_,(O,x)=>{if(O?(b=!0,w[T]=null,k[T]=O):(w[T]=x,k[T]=null),++g===h.length)return u(b?k:null,w)})})}call(h,l,...u){try{h.apply(l,u)}catch(w){u[u.length-1](w)}}cmdTraversal(h,l,u,w){const k=h.folder.fsPath,b=D.isMacintosh,g=()=>N&&N.kill();r.add(g);let _=B=>{r.delete(g),_=()=>{},w(B)},T="";const O=this.initDirectoryTree(),x=(0,o.spawnRipgrepCmd)(this.config,h,this.config.includePattern,this.folderExcludePatterns.get(h.folder.fsPath).expression),N=x.cmd,M=!Object.keys(x.siblingClauses).length,L=x.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let U=`${x.rgDiskPath} ${L}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),u({message:U}),this.cmdResultCount=0,this.collectStdout(N,"utf8",u,(B,G,le)=>{if(B){_(B);return}if(this.isLimitHit){_();return}const K=(T+(b?y.normalizeNFC(G||""):G)).split(`
`);if(le){const Q=K.length;K[Q-1]=K[Q-1].trim(),K[Q-1]||K.pop()}else T=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){_(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=K.length,M){for(const Q of K)if(this.matchFile(l,{base:k,relativePath:Q,searchPath:this.getSearchPath(h,Q)}),this.isLimitHit){g();break}(le||this.isLimitHit)&&_();return}this.addDirectoryEntries(h,O,k,K,l),le&&(this.matchDirectoryTree(O,k,l),_())})}spawnFindCmd(h){const l=this.folderExcludePatterns.get(h.folder.fsPath),u=l.getBasenameTerms(),w=l.getPathTerms(),k=["-L","."];if(u.length||w.length){k.push("-not","(","(");for(const b of u)k.push("-name",b),k.push("-o");for(const b of w)k.push("-path",b),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),I.spawn("find",k,{cwd:h.folder.fsPath})}readStdout(h,l,u){let w="";this.collectStdout(h,l,()=>{},(k,b,g)=>{if(k){u(k);return}w+=b,g&&u(null,w)})}collectStdout(h,l,u,w){let k=(_,T,O)=>{(_||O)&&(k=()=>{},this.cmdSW?.stop()),w(_,T,O)},b=!1;h.stdout?(this.forwardData(h.stdout,l,k),h.stdout.once("data",()=>b=!0)):u({message:"stdout is null"});let g;h.stderr?g=this.collectData(h.stderr):u({message:"stderr is null"}),h.on("error",_=>{k(_)}),h.on("close",_=>{let T;!b&&(T=this.decodeData(g,l))&&d(T)?k(new Error(`command failed with error code ${_}: ${this.decodeData(g,l)}`)):(this.exists&&_===0&&(this.isLimitHit=!0),k(null,"",!0))})}forwardData(h,l,u){const w=new P.StringDecoder(l);return h.on("data",k=>{u(null,w.write(k))}),w}collectData(h){const l=[];return h.on("data",u=>{l.push(u)}),l}decodeData(h,l){const u=new P.StringDecoder(l);return h.map(w=>u.write(w)).join("")}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries(h,{pathToEntries:l},u,w,k){w.indexOf(this.filePattern)!==-1&&this.matchFile(k,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(h,this.filePattern)});const b=g=>{const _=f.basename(g),T=f.dirname(g);let O=l[T];O||(O=l[T]=[],b(T)),O.push({base:u,relativePath:g,basename:_,searchPath:this.getSearchPath(h,g)})};w.forEach(b)}matchDirectoryTree({rootEntries:h,pathToEntries:l},u,w){const k=this,b=this.folderExcludePatterns.get(u),g=this.filePattern;function _(T){k.directoriesWalked++;const O=(0,m.hasSiblingFn)(()=>T.map(x=>x.basename));for(let x=0,N=T.length;x<N;x++){const M=T[x],{relativePath:L,basename:U}=M;if(b.test(L,U,g!==U?O:void 0))continue;const B=l[L];if(B)_(B);else{if(k.filesWalked++,L===g)continue;k.matchFile(w,M)}if(k.isLimitHit)break}}_(h)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(h,l,u,w,k){const b=h.folder,g=(0,m.hasSiblingFn)(()=>u);this.parallel(u,(_,T)=>{if(this.isCanceled||this.isLimitHit)return T(null);const O=l?[l,_].join(f.sep):_;if(this.folderExcludePatterns.get(h.folder.fsPath).test(O,_,this.config.filePattern!==_?g:void 0))return T(null);const x=[b.fsPath,O].join(f.sep);F.lstat(x,(N,M)=>{if(N||this.isCanceled||this.isLimitHit)return T(null);this.statLinkIfNeeded(x,M,(L,U)=>L||this.isCanceled||this.isLimitHit?T(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,M,(B,G)=>B||this.isCanceled||this.isLimitHit||(G=G||"",this.walkedPaths[G])?T(null):(this.walkedPaths[G]=!0,c.Promises.readdir(x).then(le=>{if(this.isCanceled||this.isLimitHit)return T(null);this.doWalk(h,O,le,w,Y=>T(Y||null))},le=>{T(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&C.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(w,{base:b.fsPath,relativePath:O,searchPath:this.getSearchPath(h,O)}),T(null,void 0)))})},_=>{const T=_&&A.coalesce(_);return k(T&&T.length>0?T[0]:void 0)})}matchFile(h,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,f.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||h(l))}isFileMatch(h){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(h,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(h,l,u){return l.isSymbolicLink()?F.stat(h,u):u(null,l)}realPathIfNeeded(h,l,u){return l.isSymbolicLink()?F.realpath(h,(w,k)=>w?u(w):u(null,k)):u(null,h)}getSearchPath(h,l){return h.folderName?f.join(h.folderName,l):l}}e.FileWalker=n;class a{constructor(h){this.folderQueries=h.folderQueries,this.extraFiles=h.extraFileResources||[],this.walker=new n(h)}search(h,l,u){this.walker.walk(this.folderQueries,this.extraFiles,h,l,(w,k)=>{u(w,{limitHit:k,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(h,l){this.expression=h,this.root=l,this.init(h)}init(h){let l,u;Object.keys(h).filter(w=>h[w]).forEach(w=>{f.isAbsolute(w)?(l=l||p.getEmptyExpression(),l[w]=h[w]):(u=u||p.getEmptyExpression(),u[w]=h[w])}),this.absoluteParsedExpr=l&&p.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=u&&p.parse(u,{trimForExclusions:!0})}test(h,l,u){return this.relativeParsedExpr&&this.relativeParsedExpr(h,l,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(f.join(this.root,h),l,u)}getBasenameTerms(){const h=[];return this.absoluteParsedExpr&&h.push(...p.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&h.push(...p.getBasenameTerms(this.relativeParsedExpr)),h}getPathTerms(){const h=[];return this.absoluteParsedExpr&&h.push(...p.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&h.push(...p.getPathTerms(this.relativeParsedExpr)),h}}function d(s){const h=s.trim().split(`
`),l=h[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return S.uppercaseFirstLetter(h[h.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ye[376],Ce([1,0,99,22,186,21]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===l)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const E=512,p=512,y=512*8,R=512*128;var D;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D||(e.DecodeStreamErrorKind=D={}));class v extends Error{constructor(u,w){super(u),this.decodeStreamErrorKind=w}}e.DecodeStreamError=v;class S{static async create(u){let w;if(u!==e.UTF8)w=(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(u));else{const k=new TextDecoder;w={write(b){return k.decode(b,{stream:!0})},end(){return k.decode()}}}return new S(w)}constructor(u){this.iconvLiteDecoder=u}write(u){return this.iconvLiteDecoder.write(u)}end(){return this.iconvLiteDecoder.end()}}function C(l,u){const w=u.minBytesRequiredForDetection??u.guessEncoding?y:p;return new Promise((k,b)=>{const g=(0,I.newWriteableStream)(M=>M.join("")),_=[];let T=0,O;const x=new P.CancellationTokenSource,N=async()=>{try{const M=await h({buffer:F.VSBuffer.concat(_),bytesRead:T},u.guessEncoding);if(M.seemsBinary&&u.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);M.encoding=await u.overwriteEncoding(M.encoding),O=await S.create(M.encoding);const L=O.write(F.VSBuffer.concat(_).buffer);g.write(L),_.length=0,T=0,k({stream:g,detected:M})}catch(M){x.cancel(),g.destroy(),b(M)}};(0,I.listenStream)(l,{onData:async M=>{O?g.write(O.write(M.buffer)):(_.push(M),T+=M.byteLength,T>=w&&(l.pause(),await N(),setTimeout(()=>l.resume())))},onError:M=>g.error(M),onEnd:async()=>{O||await N(),g.end(O?.end())}},x.token)})}e.toDecodeStream=C;async function c(l,u,w){const b=(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(u),w);let g=!1,_=!1;return{read(){if(_)return null;const T=l.read();if(typeof T!="string"){if(_=!0,!g&&w?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const O=b.end();return O&&O.length>0?(g=!0,F.VSBuffer.wrap(O)):null}return g=!0,F.VSBuffer.wrap(b.write(T))}}}e.toEncodeReadable=c;async function m(l){return(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.encodingExists=m;function o(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=o;function i(l,u){if(!l||u<e.UTF16be_BOM.length)return null;const w=l.readUInt8(0),k=l.readUInt8(1);if(w===e.UTF16be_BOM[0]&&k===e.UTF16be_BOM[1])return e.UTF16be;if(w===e.UTF16le_BOM[0]&&k===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const b=l.readUInt8(2);return w===e.UTF8_BOM[0]&&k===e.UTF8_BOM[1]&&b===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const r=["ascii","utf-16","utf-32"];async function n(l){const u=await(0,f.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),w=l.slice(0,R),k=d(w.buffer),b=u.detect(k);if(!b||!b.encoding)return null;const g=b.encoding.toLowerCase();return 0<=r.indexOf(g)?null:t(b.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[u]||u}function d(l){let u="";for(let w=0;w<l.length;w++)u+=String.fromCharCode(l[w]);return u}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.toCanonicalName=s;function h({buffer:l,bytesRead:u},w){let k=i(l,u),b=!1;if(k!==e.UTF16be&&k!==e.UTF16le&&l){let g=!0,_=!0,T=!1;for(let O=0;O<u&&O<E;O++){const x=O%2===1,N=l.readUInt8(O)===0;if(N&&(T=!0),g&&(x&&!N||!x&&N)&&(g=!1),_&&(x&&N||!x&&!N)&&(_=!1),N&&!g&&!_)break}T&&(g?k=e.UTF16le:_?k=e.UTF16be:b=!0)}return w&&!b&&!k&&l?n(l.slice(0,u)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:b,encoding:k}}e.detectEncodingFromBuffer=h,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[155],Ce([1,0,376,31,154]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends f.TextSearchManager{constructor(E,p,y=F,R="searchProcess"){super(E,p,{readdir:D=>y.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,I.toCanonicalName)(D)},R)}}e.NativeTextSearchManager=P}),define(ye[156],Ce([1,0,50,392,375,19,73,35,12,2,36,95,393,373,119]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const c=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(g){this.outputChannel=g}provideTextSearchResults(g,_,T,O){return this.outputChannel.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((x,N)=>{O.onCancellationRequested(()=>K());const M=t(g,_),L=_.folder.fsPath,U=M.map(oe=>oe.match(/^-/)?oe:`'${oe}'`).join(" ");this.outputChannel.appendLine(`${c} ${U}
 - cwd: ${L}`);let B=I.spawn(c,M,{cwd:L});B.on("error",oe=>{console.error(oe),this.outputChannel.appendLine("Error: "+(oe&&oe.message)),N((0,R.serializeSearchError)(new R.SearchError(oe&&oe.message,R.SearchErrorCode.rgProcessError)))});let G=!1;const le=new r(_.maxResults,_.folder,_.previewOptions);le.on("result",oe=>{G=!0,ue="",T.report(oe)});let Y=!1;const K=()=>{Y=!0,B?.kill(),le?.cancel()};let Q=!1;le.on("hitLimit",()=>{Q=!0,K()});let ue="";B.stdout.on("data",oe=>{le.handleData(oe),G||(ue+=oe)});let ne=!1;B.stdout.once("data",()=>ne=!0);let pe="";B.stderr.on("data",oe=>{const q=oe.toString();this.outputChannel.appendLine(q),pe.length+q.length<1e6&&(pe+=q)}),B.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(G?"Got result from parser":"No result from parser"),ue&&this.outputChannel.appendLine(`Got data without result: ${ue}`),this.outputChannel.appendLine(""),Y)x({limitHit:Q});else{le.flush(),B=null;let oe;pe&&!ne&&(oe=o(pe))?N((0,R.serializeSearchError)(new R.SearchError(oe.message,oe.code))):x({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function o(b){const g=b.split(`
`),_=g[0].trim();if(g.some(O=>O.startsWith("regex parse error")))return new R.SearchError(i(g),R.SearchErrorCode.regexParseError);const T=_.match(/grep config error: unknown encoding: (.*)/);if(T)return new R.SearchError(`Unknown encoding: ${T[1]}`,R.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new R.SearchError(_.charAt(0).toUpperCase()+_.substr(1),R.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new R.SearchError(_.charAt(0).toUpperCase()+_.substr(1),R.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new R.SearchError(_,R.SearchErrorCode.regexParseError)}function i(b){const g=["Regex parse error"],_=b.filter(T=>T.startsWith("PCRE2:"));if(_.length>=1){const T=_[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const O=T.split(":")[1];g.push(":"+O)}}return g.join("")}class r extends F.EventEmitter{constructor(g,_,T){super(),this.maxResults=g,this.root=_,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new f.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(g,_){return super.on(g,_),this}handleData(g){if(this.isDone)return;const _=typeof g=="string"?g:this.stringDecoder.write(g);this.handleDecodedData(_)}handleDecodedData(g){let _=g.indexOf(`
`);const T=this.remainder+g;if(_>=0)_+=this.remainder.length;else{this.remainder=T;return}let O=0;for(;_>=0;)this.handleLine(T.substring(O,_).trim()),O=_+1,_=T.indexOf(`
`,O);this.remainder=T.substring(O)}handleLine(g){if(this.isDone||!g)return;let _;try{_=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(_.type==="match"){const T=n(_.data.path),O=y.URI.joinPath(this.root,T),x=this.createTextSearchMatch(_.data,O);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const T=n(_.data.path),O=y.URI.joinPath(this.root,T);this.createTextSearchContext(_.data,O).forEach(N=>this.onResult(N))}}createTextSearchMatch(g,_){const T=g.line_number-1,O=n(g.lines),x=Buffer.from(O);let N=0,M=0,L=T;g.submatches.length===0&&g.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const U=(0,P.coalesce)(g.submatches.map((B,G)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const le=n(B.match),Y=x.slice(N,B.start).toString(),K=a(Y),Q=K.numLines>0?K.lastLineLength:K.lastLineLength+M,ue=a(le),ne=K.numLines+L,pe=ue.numLines+ne,oe=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+Q;return N=B.end,M=oe,L=pe,new D.Range(ne,Q,pe,oe)}));return(0,C.createTextSearchResult)(_,O,U,this.previewOptions)}createTextSearchContext(g,_){const T=n(g.lines),O=g.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((x,N)=>({text:x,uri:_,lineNumber:O+N}))}onResult(g){this.emit("result",g)}}e.RipgrepParser=r;function n(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function a(b){const g=/\n/g;let _=0,T=-1,O;for(;O=g.exec(b);)_++,T=O.index;const x=T>=0?b.length-T-1:b.length;return{numLines:_,lastLineLength:x}}function t(b,g){const _=["--hidden","--no-require-git"];_.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:O}=(0,A.groupBy)(g.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const N=new Set;O.forEach(M=>{N.add(M)}),_.push("-g","!*"),N.forEach(M=>{d(M).map(C.anchorGlob).forEach(L=>{_.push("-g",L)})})}T&&T.length&&T.forEach(N=>{_.push("-g",N)}),g.excludes.map(C.anchorGlob).forEach(N=>_.push("-g",`!${N}`)),g.maxFileSize&&_.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||_.push("--no-ignore-parent"):_.push("--no-ignore"),g.followSymlinks&&_.push("--follow"),g.encoding&&g.encoding!=="utf8"&&_.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,p.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),g.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),b.isRegExp&&(b.pattern=s(b.pattern),_.push("--engine","auto"));let x;if(b.isWordMatch){const M=(0,p.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",M)}else if(b.isRegExp){let N=l(b.pattern);N=u(N),_.push("--regexp",N)}else x=b.pattern,_.push("--fixed-strings");return _.push("--no-config"),g.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),b.isMultiline&&_.push("--multiline"),g.beforeContext&&_.push("--before-context",g.beforeContext+""),g.afterContext&&_.push("--after-context",g.afterContext+""),_.push("--"),x&&_.push(x),_.push("."),_}e.getRgArgs=t;function d(b){return k(b).flatMap(_=>{const T=(0,E.splitGlobAware)(_,"/");return T.map((O,x)=>T.slice(0,x+1).join("/"))})}function s(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(_);)b=b.replace(_,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=s;const h=b=>b.type==="Assertion"&&b.kind==="lookbehind";function l(b){let g;try{g=new v.RegExpParser().parsePattern(b)}catch{return b}let _="",T=0;const O=(M,L,U)=>{_+=b.slice(T,M)+U,T=L},x=[];return new v.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const L=x[0];if(!L)O(M.start,M.end,"\\r?\\n");else if(!x.some(h))if(L.type==="CharacterClass")if(L.negate){const U=b.slice(L.start+2,M.start)+b.slice(M.end,L.end-1);L.parent?.type==="Quantifier"?O(L.start,L.end,U?`[^${U}]`:"."):O(L.start,L.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(L.start+1,M.start)+b.slice(M.end,L.end-1);O(L.start,L.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else L.type==="Quantifier"&&O(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){x.unshift(M)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(M){x.unshift(M)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(M){x.unshift(M)},onCharacterClassLeave(){x.shift()},onAssertionEnter(M){h(M)&&x.push(M)},onAssertionLeave(M){x[0]===M&&x.shift()}}).visit(g),_+=b.slice(T),_}e.fixRegexNewline=l;function u(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=u;function w(b){let g=!1,_=!1,T="",O="";for(let x=0;x<b.length;x++){const N=b[x];switch(N){case"\\":_?(g?O+="\\"+N:T+="\\"+N,_=!1):_=!0;break;case"{":if(_)g?O+=N:T+=N,_=!1;else{if(g)return{strInBraces:T+"{"+O+"{"+b.substring(x+1)};g=!0}break;case"}":if(_)g?O+=N:T+=N,_=!1;else{if(g)return{fixedStart:T,strInBraces:O,fixedEnd:b.substring(x+1)};T+=N}break;default:g?O+=(_?"\\":"")+N:T+=(_?"\\":"")+N,_=!1;break}}return{strInBraces:T+(g?"{"+O:"")}}function k(b){const{fixedStart:g,strInBraces:_,fixedEnd:T}=w(b);if(g===void 0||T===void 0)return[_];let O=(0,E.splitGlobAware)(_,",");O.length||(O=[""]);const x=k(T);return O.flatMap(N=>{const M=g+N;return x.map(L=>M+L)})}e.performBraceExpansionForRipgrep=k}),define(ye[377],Ce([1,0,21,156,86,16]),function(me,e,I,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(y){this.outputChannel=y,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(y,R,D,v){const S=new F.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.vscodeUserData){const C={...R,folder:R.folder.with({scheme:P.Schemas.file})},c=new f.Progress(m=>D.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.withToken(v,m=>S.provideTextSearchResults(y,C,c,m))}else return this.withToken(v,C=>S.provideTextSearchResults(y,R,D,C))}async withToken(y,R){const D=E(y);this.inProgress.add(D);const v=await R(D.token);return this.inProgress.delete(D),v}dispose(){this.inProgress.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=A;function E(p){const y=new I.CancellationTokenSource;return p.onCancellationRequested(()=>y.cancel()),y}}),define(ye[378],Ce([1,0,31,156,155]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(p){this.query=p}search(p,y,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(S){R({message:S})}},v=new f.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(D),I);return new Promise((S,C)=>v.search(c=>{y(c.map(A))},p).then(c=>S({limitHit:c.limitHit,type:"success",stats:c.stats}),C))}}e.TextSearchEngineAdapter=P;function A(E){return{path:E.resource&&E.resource.fsPath,results:E.results,numMatches:(E.results||[]).reduce((p,y)=>{if(y.ranges){const R=y;return p+(Array.isArray(R.ranges)?R.ranges.length:1)}else return p+1},0)}}}),define(ye[379],Ce([1,0,19,11,14,4,129,17,38,2,32,36,374,378]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{static{this.BATCH_SIZE=512}constructor(n="searchProcess"){this.processType=n,this.caches=Object.create(null)}fileSearch(n){let a;const t=o(n),d=new P.Emitter({onDidAddFirstListener:()=>{a=(0,F.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,t,h=>d.fire(h),s)),a.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}textSearch(n){let a;const t=o(n),d=new P.Emitter({onDidAddFirstListener:()=>{a=(0,F.createCancelablePromise)(s=>this.ripgrepTextSearch(t,h=>d.fire(h),s)),a.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}ripgrepTextSearch(n,a,t){return n.maxFileSize=this.getPlatformFileLimits().maxFileSize,new S.TextSearchEngineAdapter(n).search(t,a,a)}getPlatformFileLimits(){return{maxFileSize:16*R.ByteSize.GB}}doFileSearch(n,a,t){return this.doFileSearchWithEngine(v.Engine,n,a,t)}doFileSearchWithEngine(n,a,t,d,s=C.BATCH_SIZE){let h=0;const l=w=>{Array.isArray(w)?(h+=w.length,t(w.map(k=>this.rawMatchToSearchItem(k)))):w.relativePath?(h++,t(this.rawMatchToSearchItem(w))):t(w)};if(a.sortByScore){let w=this.trySortedSearchFromCache(a,l,d);if(!w){const k=a.maxResults?Object.assign({},a,{maxResults:null}):a,b=new n(k);w=this.doSortedSearch(b,a,t,l,d)}return new Promise((k,b)=>{w.then(([g,_])=>{const T=_.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(T,t,s),k(g)},b)})}const u=new n(a);return this.doSearch(u,l,s,d).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.processType,fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(n){return{path:n.base?(0,E.join)(n.base,n.relativePath):n.relativePath}}doSortedSearch(n,a,t,d,s){const h=new P.Emitter;let l=(0,F.createCancelablePromise)(w=>{let k=[];const b=g=>{Array.isArray(g)?k=g:(d(g),h.fire(g))};return this.doSearch(n,b,-1,w).then(g=>[g,k])}),u;if(a.cacheKey){u=this.getOrCreateCache(a.cacheKey);const w={promise:l,event:h.event,resolved:!1};u.resultsToSearchCache[a.filePattern||""]=w,l.then(()=>{w.resolved=!0},k=>{delete u.resultsToSearchCache[a.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([w,k])=>{const b=u?u.scorerCache:Object.create(null),g=(typeof a.maxResults!="number"||a.maxResults>0)&&p.StopWatch.create(!1);return this.sortResults(a,k,b,s).then(_=>{const T=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:T,fromCache:!1,type:this.processType,workspaceFolderCount:a.folderQueries.length,resultCount:_.length},messages:w.messages,limitHit:w.limitHit||typeof a.maxResults=="number"&&k.length>a.maxResults},_]})})}getOrCreateCache(n){const a=this.caches[n];return a||(this.caches[n]=new c)}trySortedSearchFromCache(n,a,t){const d=n.cacheKey&&this.caches[n.cacheKey];if(!d)return;const s=this.getResultsFromCache(d,n.filePattern||"",a,t);if(s)return s.then(([h,l,u])=>{const w=p.StopWatch.create(!1);return this.sortResults(n,l,d.scorerCache,t).then(k=>{const b=w.elapsed(),g={fromCache:!0,detailStats:u,type:this.processType,resultCount:l.length,sortingTime:b};return[{type:"success",limitHit:h.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults,stats:g},k]})})}sortResults(n,a,t,d){const s=(0,A.prepareQuery)(n.filePattern||""),h=(u,w)=>(0,A.compareItemsByFuzzyScore)(u,w,s,!0,m,t),l=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return I.topAsync(a,h,l,1e4,d)}sendProgress(n,a,t){if(t&&t>0)for(let d=0;d<n.length;d+=t)a(n.slice(d,d+t));else a(n)}getResultsFromCache(n,a,t,d){const s=p.StopWatch.create(!1),h=a.indexOf(E.sep)>=0;let l;for(const b in n.resultsToSearchCache)if(a.startsWith(b)){if(h&&b.indexOf(E.sep)<0&&b!=="")continue;const g=n.resultsToSearchCache[b];l={promise:this.preventCancellation(g.promise),event:g.event,resolved:g.resolved};break}if(!l)return null;const u=s.elapsed(),w=p.StopWatch.create(!1),k=l.event(t);return d&&d.onCancellationRequested(()=>{k.dispose()}),l.promise.then(([b,g])=>{if(d&&d.isCancellationRequested)throw(0,f.canceled)();const _=[],T=(0,A.prepareQuery)(a).normalizedLowercase;for(const O of g)(0,D.isFilePatternMatch)(O,T)&&_.push(O);return[b,_,{cacheWasResolved:l.resolved,cacheLookupTime:u,cacheFilterTime:w.elapsed(),cacheEntryCount:g.length}]})}doSearch(n,a,t,d){return new Promise((s,h)=>{let l=[];d?.onCancellationRequested(()=>n.cancel()),n.search(u=>{u&&(t?(l.push(u),t>0&&l.length>=t&&(a(l),l=[])):a(u))},u=>{a(u)},(u,w)=>{l.length&&a(l),u?(a({message:"Search finished. Error: "+u.message}),h(u)):(a({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),s(w))})})}clearCache(n){return delete this.caches[n],Promise.resolve(void 0)}preventCancellation(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return n.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return n.finally(a)}}}}e.SearchService=C;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(r){return(0,E.basename)(r.relativePath)}getItemDescription(r){return(0,E.dirname)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>y.URI.revive(n))}}function i(r){return{...r,folder:y.URI.revive(r.folder)}}}),define(ye[380],Ce([1,0,3,16,2,31,13,27,20,98,66,36,379,377,119,155]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends y.ExtHostSearch{constructor(i,r,n,a){super(i,n,a),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new I.DisposableStore;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new S.RipgrepSearchProvider(t))),r.remote.isRemote&&r.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new C.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.file,new S.RipgrepSearchProvider(i))),this._disposables.add(this.registerInternalFileSearchProvider(F.Schemas.file,new v.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(i,r){const n=this._handlePool++;return this._internalFileSearchProvider=r,this._internalFileSearchHandle=n,this._proxy.$registerFileSearchProvider(n,this._transformScheme(i)),(0,I.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,a){const t=(0,y.reviveQuery)(n);if(i===this._internalFileSearchHandle){const d=Date.now();return this.doInternalFileSearch(i,r,t,a).then(s=>{const h=Date.now()-d;return this._logService.debug(`Ext host file search time: ${h}ms`),s})}return super.$provideFileSearchResults(i,r,n,a)}doInternalFileSearchWithCustomCallback(i,r,n){const a=t=>{if((0,D.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){n(t.map(d=>f.URI.file(d.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(i,a,r)}async doInternalFileSearch(i,r,n,a){return this.doInternalFileSearchWithCustomCallback(n,a,t=>{this._proxy.$handleFileMatch(i,r,t)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,r){return new c.NativeTextSearchManager(i,r,void 0,"textSearchProvider")}};e.NativeExtHostSearch=m,e.NativeExtHostSearch=m=je([$e(0,p.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,R.IURITransformerService),$e(3,A.ILogService)],m)}),define(ye[120],Ce([1,0,394,62,63,395,22,14,4,3,17,10,30,81,82]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{traceSocketEvent(g,_){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,_)}constructor(g,_=""){this._canWrite=!0,this.debugLabel=_,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,E.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(g){const _=T=>{this.traceSocketEvent("read",T),g(A.VSBuffer.wrap(T))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(g){const _=T=>{g({type:0,hadError:T,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(g){const _=()=>{g()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(g){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,E.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,E.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=c;var m;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class i extends y.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(g,_){this.socket.traceSocketEvent(g,_)}constructor(g,_,T,O){super(),this._onData=this._register(new p.Emitter),this._onClose=this._register(new p.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:T?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new r(this,_,T,O,this._onData,(x,N)=>this._write(x,N))),this._register(this._flowManager.onError(x=>{console.error(x),(0,E.onUnexpectedError)(x),this._onClose.fire({type:0,hadError:!0,error:x})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(x=>this._acceptChunk(x))),this._register(this.socket.onClose(async x=>{this._flowManager.isProcessingReadQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(x)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let _=0;for(;_<g.byteLength;)this._flowManager.writeMessage(g.slice(_,Math.min(_+262144,g.byteLength)),{compressed:!0,opcode:2}),_+=262144}_write(g,{compressed:_,opcode:T}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let O=2;g.byteLength<126?O+=0:g.byteLength<2**16?O+=2:O+=8;const x=A.VSBuffer.alloc(O),N=_?64:0,M=T&15;if(x.writeUInt8(128|N|M,0),g.byteLength<126)x.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){x.writeUInt8(126,1);let L=1;x.writeUInt8(g.byteLength>>>8&255,++L),x.writeUInt8(g.byteLength>>>0&255,++L)}else{x.writeUInt8(127,1);let L=1;x.writeUInt8(0,++L),x.writeUInt8(0,++L),x.writeUInt8(0,++L),x.writeUInt8(0,++L),x.writeUInt8(g.byteLength>>>24&255,++L),x.writeUInt8(g.byteLength>>>16&255,++L),x.writeUInt8(g.byteLength>>>8&255,++L),x.writeUInt8(g.byteLength>>>0&255,++L)}this.socket.write(A.VSBuffer.concat([x,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),T=_.readUInt8(0),O=(T&128)>>>7,x=(T&64)>>>6,N=T&15,M=_.readUInt8(1),L=(M&128)>>>7,U=M&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=!!x),this._state.firstFrameOfMessage=!!O,this._state.mask=0,this._state.opcode=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),T=_.readUInt8(1),O=(T&128)>>>7;let x=T&127,N=1;x===126?x=_.readUInt8(++N)*2**8+_.readUInt8(++N):x===127&&(x=_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N));let M=0;O&&(M=_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N)),this._state.state=3,this._state.readLen=x,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),t(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(_,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=i;class r extends y.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(g,_,T,O,x,N){super(),this._tracer=g,this._onData=x,this._writeFn=N,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new p.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new p.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new n(this._tracer,O,T,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(g,_){this._writeQueue.push({data:g,options:_}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:g,options:_}=this._writeQueue.shift();if(this._zlibDeflateStream&&_.compressed){const T=await this._deflateMessage(this._zlibDeflateStream,g);this._writeFn(T,_)}else this._writeFn(g,{..._,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(g,_){return new Promise((T,O)=>{g.write(_),g.flush(x=>T(x))})}acceptFrame(g,_,T){this._readQueue.push({data:g,isCompressed:_,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const g=this._readQueue.shift();if(this._zlibInflateStream&&g.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,g.data,g.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(g.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(g,_,T){return new Promise((O,x)=>{g.write(_),T&&g.write(A.VSBuffer.fromByteArray([0,0,255,255])),g.flush(N=>O(N))})}}class n extends y.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(g,_,T,O){super(),this._tracer=g,this._recordInflateBytes=_,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,P.createInflateRaw)(O),this._zlibInflate.on("error",x=>{this._tracer.traceSocketEvent("zlibInflateError",{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibInflate.on("data",x=>{this._tracer.traceSocketEvent("zlibInflateData",x),this._pendingInflateData.push(A.VSBuffer.wrap(x))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(g){this._recordInflateBytes&&this._recordedInflateBytes.push(g.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",g),this._zlibInflate.write(g.buffer)}flush(g){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,g(_)})}}class a extends y.Disposable{constructor(g,_){super(),this._tracer=g,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,P.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(A.VSBuffer.wrap(T))})}write(g){this._tracer.traceSocketEvent("zlibDeflateWrite",g.buffer),this._zlibDeflate.write(g.buffer)}flush(g){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),g(_)})}}function t(b,g){if(g===0)return;const _=b.byteLength>>>2;for(let L=0;L<_;L++){const U=b.readUInt32BE(L*4);b.writeUInt32BE(U^g,L*4)}const T=_*4,O=b.byteLength-T,x=g>>>24&255,N=g>>>16&255,M=g>>>8&255;O>=1&&b.writeUInt8(b.readUInt8(T)^x,T),O>=2&&b.writeUInt8(b.readUInt8(T+1)^N,T+1),O>=3&&b.writeUInt8(b.readUInt8(T+2)^M,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function s(){const b=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,f.tmpdir)(),_=(0,R.join)(g,`vscode-ipc-${b}.sock`);return l(_),_}e.createRandomIPCHandle=s;function h(b,g,_){const O=(0,I.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${g}-sock`;const x=_.substr(0,4),N=g.substr(0,6);let M;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${x}-${N}.sock`):M=(0,R.join)(b,`${x}-${N}.sock`),l(M),M}e.createStaticIPCHandle=h;function l(b){const g=d[D.platform];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class u extends S.IPCServer{static toClientConnectionEvent(g){const _=p.Event.fromNodeEventEmitter(g,"connection");return p.Event.map(_,T=>({protocol:new C.Protocol(new c(T,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(T,"close"))}))}constructor(g){super(u.toClientConnectionEvent(g)),this.server=g}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function w(b){return new Promise((g,_)=>{const T=(0,F.createServer)();T.on("error",_),T.listen(b,()=>{T.removeListener("error",_),g(new u(T))})})}e.serve=w;function k(b,g){return new Promise((_,T)=>{const O=(0,F.createConnection)(b,()=>{O.removeListener("error",T),_(C.Client.fromSocket(new c(O,`ipc-client${g}`),g))});O.once("error",T)})}e.connect=k}),define(ye[381],Ce([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,89,22]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,d,s,h,l){let u;for(let w=3;w&&(u?.dispose(),u=await new i(t,d,s,h,l).waitForReady(),!(l&&f.BROWSER_RESTRICTED_PORTS[l]||!f.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));w--);return u}class i extends E.Disposable{constructor(d,s,h,l,u){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=u,this.privacy=c.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=I.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=w=>this._onConnection(w),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const d=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,c.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let h=await(0,f.findFreePortFaster)(d,2,1e3,s),l=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(d){d.pause();const s=(0,c.isLocalhost)(this.tunnelRemoteHost)||(0,c.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,v.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),l=h.getSocket(),u=h.readEntireBuffer();h.dispose(),u.byteLength>0&&d.write(u.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),l.end()}),d.on("close",()=>l.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),l instanceof P.NodeSocket?l.socket.destroy():l.end()}),l instanceof P.NodeSocket?this._mirrorNodeSocket(d,l):this._mirrorGenericSocket(d,l),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),l.end()})}_mirrorGenericSocket(d,s){s.onClose(()=>d.destroy()),s.onEnd(()=>d.end()),s.onData(h=>d.write(h.buffer)),d.on("data",h=>s.write(m.VSBuffer.wrap(h))),d.resume()}_mirrorNodeSocket(d,s){const h=s.socket;h.on("end",()=>d.end()),h.on("close",()=>d.end()),h.on("error",()=>{d.destroy()}),h.pipe(d),d.pipe(h)}}e.NodeRemoteTunnel=i;let r=class extends c.AbstractTunnelService{constructor(d,s,h,l,u){super(s,u),this.remoteSocketFactoryService=d,this.signService=h,this.productService=l}isPortPrivileged(d){return(0,c.isPortPrivileged)(d,this.defaultTunnelHost,p.OS,F.release())}retainOrCreateTunnel(d,s,h,l,u,w,k,b){const g=this.getTunnelFromMap(s,h);if(g)return++g.refcount,g.value;if((0,c.isTunnelProvider)(d))return this.createWithProvider(d,s,h,u,w,k,b);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${h} on local port ${u}.`);const _={commit:this.productService.commit,quality:this.productService.quality,addressProvider:d,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},T=o(_,l,s,h,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,h,T),T}}};e.BaseTunnelService=r,e.BaseTunnelService=r=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,C.ISignService),$e(3,D.IProductService),$e(4,y.IConfigurationService)],r);let n=class extends r{constructor(d,s,h,l,u){super(d,s,h,l,u)}};e.TunnelService=n,e.TunnelService=n=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,C.ISignService),$e(3,D.IProductService),$e(4,y.IConfigurationService)],n);let a=class extends E.Disposable{constructor(d,s,h,l,u){super(),this.remoteSocketFactoryService=d,this.logService=s,this.productService=h,this.signService=l,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(d,s,h,l,u,w,k,b,g){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${l} on local port ${w}.`),!this._tunnelServices.has(d)){const _=new n(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(_),this._tunnelServices.set(d,_),_.onTunnelClosed(async()=>{(await _.tunnels).length===0&&(_.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(s,h,l,u,w,k,b,g)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,D.IProductService),$e(3,C.ISignService),$e(4,y.IConfigurationService)],a)}),define(ye[382],Ce([1,0,120,276,57,33,2,13,40]),function(me,e,I,F,f,P,A,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(v,S,C){this._commands=v,this.logService=S,this._ipcHandlePath=C,this._server=F.createServer((c,m)=>this.onRequest(c,m)),this.setup().catch(c=>(S.error(c),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,S){const C=(m,o)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),i=>i&&this.logService.error(i))},c=[];v.setEncoding("utf8"),v.on("data",m=>c.push(m)),v.on("end",async()=>{try{const m=JSON.parse(c.join(""));let o;switch(m.type){case"open":o=await this.open(m);break;case"openExternal":o=await this.openExternal(m);break;case"status":o=await this.getStatus(m);break;case"extensionManagement":o=await this.manageExtensions(m);break;default:C(404,`Unknown message type: ${m.type}`);break}C(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);C(500,o),this.logService.error("Error while processing pipe request",m)}})}async open(v){const{fileURIs:S,folderURIs:C,forceNewWindow:c,diffMode:m,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:a,remoteAuthority:t}=v,d=[];if(Array.isArray(C))for(const u of C)try{d.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(S))for(const u of S)try{(0,p.hasWorkspaceFileExtension)(u)?d.push({workspaceUri:A.URI.parse(u)}):d.push({fileUri:A.URI.parse(u)})}catch{}const s=a?A.URI.file(a):void 0,l={forceNewWindow:c,diffMode:m,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",d,l)}async openExternal(v){for(const S of v.uris){const C=A.URI.parse(S),c=C.scheme==="file"?C:S;await this._commands.executeCommand("_remoteCLI.openExternal",c)}}async manageExtensions(v){const S=c=>c?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),C={list:v.list,install:S(v.install),uninstall:S(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&f.existsSync(this._ipcHandlePath)&&f.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let R=class extends y{constructor(v,S){super(v,S,(0,I.createRandomIPCHandle)())}};e.CLIServer=R,e.CLIServer=R=je([$e(0,P.IExtHostCommands),$e(1,E.ILogService)],R)}),define(ye[383],Ce([1,0,58,370,365,275,47,352,2,16,7,382,104,307,351]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends f.RequireInterceptor{_installInterceptor(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,h,l){return s=t(s),i._factories.has(s)?i._factories.get(s).load(s,p.URI.file((0,v.realpathSync)(h.filename)),u=>n.apply(this,[u,h,l])):n.apply(this,arguments)};const a=r._resolveLookupPaths;r._resolveLookupPaths=(d,s)=>a.call(this,t(d),s);const t=d=>{for(const s of i._alternatives){const h=s(d);if(h){d=h;break}}return d}}}class m extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(S.ExtHostConsoleForwarder);const i=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(D.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this._instaService.createInstance(C.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(c,i,{mine:this._myRegistry,all:this._globalRegistry}).install(),I.mark("code/extHost/didInitAPI");const n=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,n,this,this._logService,this._mainThreadTelemetryProxy,this._initData),I.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(i){return i.main}async _loadCommonJSModule(i,r,n){if(r.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let a=null;n.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this._logService.flush();const t=i?.identifier.value;i&&await this._extHostLocalizationService.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(r.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this._initData.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.ExtHostExtensionService=m}),define(ye[384],Ce([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,89,381,27,20,70,359]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function a(g){const _=g.trim().split(`
`),T=[];return _.forEach(x=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(x);N&&N.length>=3&&T.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),T.reduce((x,N)=>(x[N.socket]=N,x),{})}e.getSockets=a;function t(...g){const _=[].concat(...g.map(s));return[...new Map(_.filter(T=>T.st==="0A").map(T=>{const O=T.local_address.split(":");return{socket:parseInt(T.inode,10),ip:d(O[0]),port:parseInt(O[1],16)}}).map(T=>[T.ip+":"+T.port,T])).values()]}e.loadListeningPorts=t;function d(g){let _="";if(g.length===8)for(let T=g.length-2;T>=0;T-=2)_+=parseInt(g.substr(T,2),16),T!==0&&(_+=".");else for(let T=0;T<g.length;T+=8){const O=g.substring(T,T+8);let x="";for(let N=8;N>=2;N-=2)x+=O.substring(N-2,N),(N===6||N===2)&&(x=parseInt(x,16).toString(16),_+=`${x}`,x="",T+N!==g.length-6&&(_+=":"))}return _}e.parseIpAddress=d;function s(g){const _=g.trim().split(`
`),T=_.shift().trim().split(/\s+/).filter(x=>x!=="rx_queue"&&x!=="tm->when");return _.map(x=>x.trim().split(/\s+/).reduce((N,M,L)=>(N[T[L]||L]=M,N),{}))}e.loadConnectionTable=s;function h(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function l(g){const _=g.trim().split(`
`),T=[];return _.forEach(O=>{const x=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);x&&x.length>=4&&T.push({pid:parseInt(x[1],10),ppid:parseInt(x[2]),cmd:x[3]})}),T}e.getRootProcesses=l;async function u(g,_,T){const O=T.reduce((N,M)=>(N[M.pid]=M,N),{}),x=[];return g.forEach(({socket:N,ip:M,port:L})=>{const U=_[N]?_[N].pid:void 0,B=U?O[U]?.cmd:void 0;U&&B&&!h(B)&&x.push({host:M,port:L,detail:B,pid:U})}),x}e.findPorts=u;function w(g,_,T){const O=new Map,x=l(_);for(const N of g){const M=T.get(N.port);if(M){O.set(N.port,M);continue}const L=x.find(U=>U.cmd.includes(`${N.port}`));if(L){let U=L,B;do B=x.find(G=>G.ppid===U.pid),B&&(U=B);while(B);O.set(N.port,{host:N.ip,port:N.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else O.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return O}e.tryFindRootPorts=w;let k=class extends r.ExtHostTunnelService{constructor(_,T,O,x){super(_,T,O),this.initData=T,this.signService=x,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,E.isLinux&&T.remote.isRemote&&T.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(_){if(_&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=_;let T;this._initialCandidates&&(T=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const O=new A.MovingAverage;let x=0;for(;this._candidateFindingEnabled;){const N=new Date().getTime(),M=(await this.findCandidatePorts()).filter(B=>(0,c.isLocalhost)(B.host)||(0,c.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(B=>B.port).join(", ")}`);const L=new Date().getTime()-N;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${L} ms.`),x++>3&&O.update(L),(!T||JSON.stringify(T)!==JSON.stringify(M))&&(T=M,await this._proxy.$onFoundNewCandidates(T));const U=this.calculateDelay(O.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${U} ms.`),await new Promise(B=>setTimeout(()=>B(),U))}}calculateDelay(_){return Math.max(_*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(_=>_.port).join(", ")}`)}async findCandidatePorts(){let _="",T="";try{_=await R.Promises.readFile("/proc/net/tcp","utf8"),T=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(_,T),x=await new Promise(Y=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,Q,ue)=>{Y(Q)})}),N=a(x),M=await R.Promises.readdir("/proc"),L=[];for(const Y of M)try{const K=Number(Y),Q=p.joinPath(y.URI.file("/proc"),Y);if((await R.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(K)){const ne=await R.Promises.readlink(p.joinPath(Q,"cwd").fsPath),pe=await R.Promises.readFile(p.joinPath(Q,"cmdline").fsPath,"utf8");L.push({pid:K,cwd:ne,cmd:pe})}}catch{}const U=[],B=O.filter(Y=>{const K=N[Y.socket];return K||U.push(Y),K}),G=u(B,N,L);let le;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const Y=await new Promise(K=>{(0,I.exec)("ps -F -A -l | grep root",(Q,ue,ne)=>{K(ue)})});this._foundRootPorts=w(U,Y,this._foundRootPorts),le=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(K=>K.port).join(", ")}`)}return G.then(Y=>le?Y.concat(le):Y)}makeManagedTunnelFactory(_){return async T=>{const O=new m.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(N,M,L,U){const B=await _.makeConnection();return b.connect(B,M,L,U)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.ManagedRemoteConnection(0),connectionToken:_.connectionToken})}},signService:this.signService},"localhost",T.remoteAddress.host||"localhost",T.remoteAddress.port,T.localAddressPort);await O.waitForReady();const x=new f.Emitter;return{localAddress:(0,n.parseAddress)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:x.event,dispose:()=>{O.dispose(),x.fire(),x.dispose()}}}}};e.NodeExtHostTunnelService=k,e.NodeExtHostTunnelService=k=je([$e(0,i.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,D.ILogService),$e(3,C.ISignService)],k);class b extends v.ManagedSocket{static connect(_,T,O,x){const N=new P.DisposableStore,M={onClose:N.add(new f.Emitter),onData:N.add(new f.Emitter),onEnd:N.add(new f.Emitter)};N.add(_.onDidReceiveMessage(U=>M.onData.fire(F.VSBuffer.wrap(U)))),N.add(_.onDidEnd(()=>M.onEnd.fire())),N.add(_.onDidClose(U=>M.onClose.fire({type:0,error:U,hadError:!!U})));const L=new b(_,x,M);return L._register(N),(0,v.connectManagedSocket)(L,T,O,x,M)}constructor(_,T,O){super(T,O),this.passing=_}write(_){this.passing.send(_.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(ye[385],Ce([1,0,84,354,368,367,380,383,384,97,47,98,96,46,70,94,353,308,13,369,60,270,106,109,138]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o,i,r,n,a,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(R.IExtHostExtensionService,E.ExtHostExtensionService,0),(0,I.registerSingleton)(i.ILoggerService,o.ExtHostLoggerService,1),(0,I.registerSingleton)(i.ILogService,new t.SyncDescriptor(a.ExtHostLogService,[!1],!0)),(0,I.registerSingleton)(d.ISignService,s.SignService,1),(0,I.registerSingleton)(c.IExtensionStoragePaths,m.ExtensionStoragePaths,0),(0,I.registerSingleton)(y.IExtHostDebugService,P.ExtHostDebugService,0),(0,I.registerSingleton)(D.IExtHostSearch,A.NativeExtHostSearch,0),(0,I.registerSingleton)(v.IExtHostTask,f.ExtHostTask,0),(0,I.registerSingleton)(S.IExtHostTerminalService,F.ExtHostTerminalService,0),(0,I.registerSingleton)(C.IExtHostTunnelService,p.NodeExtHostTunnelService,0),(0,I.registerSingleton)(n.IExtHostVariableResolverProvider,r.NodeExtHostVariableResolverProviderService,0)}),define(ye[396],Ce([1,0,62,397,58,14,82,120,253,113,366,22,31,104,11,132,277,291,371,385]),function(me,e,I,F,f,P,A,E,p,y,R,D,v,S,C,c,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,w=u._load;u._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function a(u){process.exit=function(w){if(u)r(w);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,k){w==="uncaughtException"&&(k=function(){try{return k.call(void 0,arguments)}catch{}}),n(w,k)}}let t=function(u){r()};function d(){const u=(0,o.readExtHostConnection)(process.env);if(u.type===3)return new Promise((w,k)=>{const b=g=>{const _=g[0],T=new A.BufferedEmitter;_.on("message",O=>T.fire(D.VSBuffer.wrap(O.data))),_.on("close",()=>{t("renderer closed the MessagePort")}),_.start(),w({onMessage:T.event,send:O=>_.postMessage(O.buffer)})};process.parentPort.on("message",g=>b(g.ports))});if(u.type===2)return new Promise((w,k)=>{let b=null;const g=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),_=108e5,T=3e5,O=new C.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),_),x=new C.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),T);process.on("message",(M,L)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){L.setNoDelay(!0);const U=D.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let B;if(M.skipWebSocketFrames)B=new E.NodeSocket(L,"extHost-socket");else{const G=D.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));B=new E.WebSocketNodeSocket(new E.NodeSocket(L,"extHost-socket"),M.permessageDeflate,G,!1)}b?(O.cancel(),x.cancel(),b.beginAcceptReconnection(B,U),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(g),b=new A.PersistentProtocol({socket:B,initialChunk:U}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),w(b),b.onSocketClose(()=>{O.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(x.isScheduled())return;O.isScheduled()&&x.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const w=u.pipeName;return new Promise((k,b)=>{const g=I.createConnection(w,()=>{g.removeListener("error",b);const _=new A.PersistentProtocol({socket:new E.NodeSocket(g,"extHost-renderer")});_.sendResume(),k(_)});g.once("error",b),g.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const u=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,u.onMessage(w=>{(0,y.isMessageOfType)(w,2)?(this._terminating=!0,t("received terminate message from renderer")):this._onMessage.fire(w)})}send(w){this._terminating||u.send(w)}async drain(){if(u.drain)return u.drain()}}}function h(u){return new Promise(w=>{const k=u.onMessage(b=>{k.dispose();const g=JSON.parse(b.toString()),_=g.commit,T=p.default.commit;if(_&&T&&_!==T&&r(55),g.parentPid){let O=0;setInterval(function(){try{process.kill(g.parentPid,0),O=0}catch(N){N&&N.code==="EPERM"?(O++,O>=3&&t(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):t(`parent process ${g.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let x;try{x=globalThis._VSCODE_NODE_MODULES["native-watchdog"],x.start(g.parentPid)}catch(N){(0,P.onUnexpectedError)(N)}}u.send((0,y.createMessageOfType)(0)),w({protocol:u,initData:g})});u.send((0,y.createMessageOfType)(1))})}async function l(){const u=[];process.on("unhandledRejection",(O,x)=>{u.push(x),setTimeout(()=>{const N=u.indexOf(x);N>=0&&x.catch(M=>{u.splice(N,1),(0,P.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),O&&(0,P.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const x=u.indexOf(O);x>=0&&u.splice(x,1)}),process.on("uncaughtException",function(O){(0,P.isSigPipeError)(O)||(0,P.onUnexpectedError)(O)}),f.mark("code/extHost/willConnectToRenderer");const w=await s();f.mark("code/extHost/didConnectToRenderer");const k=await h(w);f.mark("code/extHost/didWaitForInitData");const{initData:b}=k;a(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,c.boolean)(i.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(x){r(x)}fsExists(x){return v.Promises.exists(x)}fsRealpath(x){return(0,S.realpath)(x)}};let _=null;b.remote.authority&&i.transformURIs&&(_=(0,m.createURITransformer)(b.remote.authority));const T=new R.ExtensionHostMain(k.protocol,b,g,_);t=O=>T.terminate(O)}l().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00d5968fd28fdbb3362ca4686e7ac684b8be63c8/core/vs/workbench/api/node/extensionHostProcess.js.map
