/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],G=function(q){for(var e=[],I=0,w=q.length;I<w;I++)e[I]=K[q[I]];return e};define(K[22],G([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class I{static get(){const k=new Map,P=new Map,r=new Map,f=new Map;function t(o,i){o.has(i.detail)||o.set(i.detail,-i.timestamp)}function c(o,i){const n=o.get(i.detail);n&&(n>=0||o.set(i.detail,n+i.timestamp))}let m=[];typeof q=="function"&&typeof q.getStats=="function"&&(m=q.getStats().slice(0).sort((o,i)=>o.timestamp-i.timestamp));for(const o of m)switch(o.type){case 10:t(k,o);break;case 11:case 12:c(k,o);break;case 21:t(P,o);break;case 22:c(P,o);break;case 33:t(r,o);break;case 34:c(r,o);break;case 31:t(f,o);break;case 32:c(f,o);break}let h=0;r.forEach(o=>h+=o);function u(o){const i=[];return o.forEach((n,s)=>i.push([s,n])),i}return{amdLoad:u(k),amdInvoke:u(P),nodeRequire:u(r),nodeEval:u(f),nodeRequireTotal:h}}static toMarkdownTable(k,P){let r="";const f=[];return k.forEach((t,c)=>{f[c]=t.length}),P.forEach(t=>{t.forEach((c,m)=>{typeof c>"u"&&(c=t[m]="-");const h=c.toString().length;f[m]=Math.max(h,f[m])})}),k.forEach((t,c)=>{r+=`| ${t+" ".repeat(f[c]-t.toString().length)} `}),r+=`|
`,k.forEach((t,c)=>{r+=`| ${"-".repeat(f[c])} `}),r+=`|
`,P.forEach(t=>{t.forEach((c,m)=>{typeof c<"u"&&(r+=`| ${c+" ".repeat(f[m]-c.toString().length)} `)}),r+=`|
`}),r}}e.LoaderStats=I}),define(K[4],G([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let I;function w(n){I=n}e.setLogger=w;function k(){return I}e.getLogger=k;class P{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(s){return r([f(o("|  ",this.indentation)),s])}formatInfo(s){return s.hadValue?s.didChange?[f(" "),c(m(s.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),c(m(s.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),c(m(s.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(s,_){console.log(...this.textToConsoleArgs([t("observable value changed"),c(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_)]))}formatChanges(s){if(s.size!==0)return c(" (changed deps: "+[...s].map(_=>_.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const _=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(y,N)=>(this.changedObservablesSets.get(s).add(y),_.apply(s,[y,N]))}handleDerivedRecomputed(s,_){const y=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("derived recomputed"),c(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_),this.formatChanges(y),{data:[{fn:s._computeFn}]}])),y.clear()}handleFromEventObservableTriggered(s,_){console.log(...this.textToConsoleArgs([t("observable from event triggered"),c(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const _=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(y,N)=>(this.changedObservablesSets.get(s).add(y),_.apply(s,[y,N]))}handleAutorunTriggered(s){const _=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("autorun"),c(s.debugName,{color:"BlueViolet"}),this.formatChanges(_),{data:[{fn:s._runFn}]}])),_.clear(),this.indentation++}handleAutorunFinished(s){this.indentation--}handleBeginTransaction(s){let _=s.getDebugName();_===void 0&&(_=""),console.log(...this.textToConsoleArgs([t("transaction"),c(_,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=P;function r(n){const s=new Array,_=[];let y="";function N(E){if("length"in E)for(const g of E)g&&N(g);else"text"in E?(y+=`%c${E.text}`,s.push(E.style),E.data&&_.push(...E.data)):"data"in E&&_.push(...E.data)}N(n);const R=[y,...s];return R.push(..._),R}function f(n){return c(n,{color:"black"})}function t(n){return c(i(`${n}: `,10),{color:"black",bold:!0})}function c(n,s={color:"black"}){function _(N){return Object.entries(N).reduce((R,[E,g])=>`${R}${E}:${g};`,"")}const y={color:s.color};return s.strikeThrough&&(y["text-decoration"]="line-through"),s.bold&&(y["font-weight"]="bold"),{text:n,style:_(y)}}function m(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?h(n,s):u(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function h(n,s){let _="[ ",y=!0;for(const N of n){if(y||(_+=", "),_.length-5>s){_+="...";break}y=!1,_+=`${m(N,s-_.length)}`}return _+=" ]",_}function u(n,s){let _="{ ",y=!0;for(const[N,R]of Object.entries(n)){if(y||(_+=", "),_.length-5>s){_+="...";break}y=!1,_+=`${N}: ${m(R,s-_.length)}`}return _+=" }",_}function o(n,s){let _="";for(let y=1;y<=s;y++)_+=n;return _}function i(n,s){for(;n.length<s;)n+=" ";return n}}),define(K[5],G([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.getDebugName=e.TransactionImpl=e.subtransaction=e.asyncTransaction=e.globalTransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=e._setKeepObserved=e._setRecomputeInitiallyAndOnChange=void 0;let w;function k(L){w=L}e._setRecomputeInitiallyAndOnChange=k;let P;function r(L){P=L}e._setKeepObserved=r;let f;function t(L){f=L}e._setDerivedOpts=t;class c{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,a){const p=a===void 0?void 0:b,F=a===void 0?b:a;return f({owner:p,debugName:()=>{const W=U(F);if(W!==void 0)return W;const V=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(F.toString());if(V)return`${this.debugName}.${V[2]}`;if(!p)return`${this.debugName} (mapped)`}},W=>F(this.read(W),W))}recomputeInitiallyAndOnChange(b,a){return b.add(w(this,a)),this}keepObserved(b){return b.add(P(this)),this}}e.ConvenientObservable=c;class m extends c{constructor(){super(...arguments),this.observers=new Set}addObserver(b){const a=this.observers.size;this.observers.add(b),a===0&&this.onFirstObserverAdded()}removeObserver(b){this.observers.delete(b)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=m;function h(L,b){const a=new s(L,b);try{L(a)}finally{a.finish()}}e.transaction=h;let u;function o(L){if(u)L(u);else{const b=new s(L,void 0);u=b;try{L(b)}finally{b.finish(),u=void 0}}}e.globalTransaction=o;async function i(L,b){const a=new s(L,b);try{await L(a)}finally{a.finish()}}e.asyncTransaction=i;function n(L,b,a){L?b(L):h(b,a)}e.subtransaction=n;class s{constructor(b,a){this._fn=b,this._getDebugName=a,this.updatingObservers=[],(0,I.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():U(this._fn)}updateObserver(b,a){this.updatingObservers.push({observer:b,observable:a}),b.beginUpdate(a)}finish(){const b=this.updatingObservers;for(let a=0;a<b.length;a++){const{observer:p,observable:F}=b[a];p.endUpdate(F)}this.updatingObservers=null,(0,I.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=s;const _=new Map,y=new WeakMap;function N(L,b,a,p){const F=y.get(L);if(F)return F;const W=R(L,b,a,p);if(W){let j=_.get(W)??0;j++,_.set(W,j);const V=j===1?W:`${W}#${j}`;return y.set(L,V),V}}e.getDebugName=N;function R(L,b,a,p){const F=y.get(L);if(F)return F;const W=p?S(p)+".":"";let j;if(b!==void 0)if(typeof b=="function"){if(j=b(),j!==void 0)return W+j}else return W+b;if(a!==void 0&&(j=U(a),j!==void 0))return W+j;if(p!==void 0){for(const V in p)if(p[V]===L)return W+V}}const E=new Map,g=new WeakMap;function S(L){const b=g.get(L);if(b)return b;const a=O(L);let p=E.get(a)??0;p++,E.set(a,p);const F=p===1?a:`${a}#${p}`;return g.set(L,F),F}function O(L){const b=L.constructor;return b?b.name:"Object"}function U(L){const b=L.toString(),p=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(p?p[1]:void 0)?.trim()}e.getFunctionName=U;function z(L,b){return typeof L=="string"?new d(void 0,L,b):new d(L,void 0,b)}e.observableValue=z;class d extends m{get debugName(){return N(this,this._debugName,void 0,this._owner)??"ObservableValue"}constructor(b,a,p){super(),this._owner=b,this._debugName=a,this._value=p}get(){return this._value}set(b,a,p){if(this._value===b)return;let F;a||(a=F=new s(()=>{},()=>`Setting ${this.debugName}`));try{const W=this._value;this._setValue(b),(0,I.getLogger)()?.handleObservableChanged(this,{oldValue:W,newValue:b,change:p,didChange:!0,hadValue:!0});for(const j of this.observers)a.updateObserver(j,this),j.handleChange(this,p)}finally{F&&F.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(b){this._value=b}}e.ObservableValue=d;function T(L,b){return typeof L=="string"?new A(void 0,L,b):new A(L,void 0,b)}e.disposableObservableValue=T;class A extends d{_setValue(b){this._value!==b&&(this._value&&this._value.dispose(),this._value=b)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=A}),define(K[9],G([0,1,23,2,5,4]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorunOpts=e.autorun=void 0;function r(i){return new u(void 0,i,void 0,void 0)}e.autorun=r;function f(i,n){return new u(i.debugName,n,void 0,void 0)}e.autorunOpts=f;function t(i,n){return new u(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.autorunHandleChanges=t;function c(i,n){const s=new w.DisposableStore,_=t({debugName:i.debugName??(()=>(0,k.getFunctionName)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(y,N)=>{s.clear(),n(y,N,s)});return(0,w.toDisposable)(()=>{_.dispose(),s.dispose()})}e.autorunWithStoreHandleChanges=c;function m(i){const n=new w.DisposableStore,s=f({debugName:()=>(0,k.getFunctionName)(i)||"(anonymous)"},_=>{n.clear(),i(_,n)});return(0,w.toDisposable)(()=>{s.dispose(),n.dispose()})}e.autorunWithStore=m;var h;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class u{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const s=this._debugName();if(s!==void 0)return s}const n=(0,k.getFunctionName)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,s,_,y){this._debugName=n,this._runFn=s,this.createChangeSummary=_,this._handleChange=y,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,P.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,w.trackDisposable)(this)}dispose(){this.disposed=!0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),(0,w.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n,this.state=3;const s=this.disposed;try{if(!s){(0,P.getLogger)()?.handleAutorunTriggered(this);const _=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,_)}}finally{s||(0,P.getLogger)()?.handleAutorunFinished(this);for(const _ of this.dependenciesToBeRemoved)_.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,I.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(n){this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(this.state=1)}handleChange(n,s){this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(!this._handleChange||this._handleChange({changedObservable:n,change:s,didChange:y=>y===n},this.changeSummary))&&(this.state=2)}readObservable(n){if(this.disposed)return n.get();n.addObserver(this);const s=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),s}}e.AutorunObserver=u,function(i){i.Observer=u}(r||(e.autorun=r={}));function o(i,n){let s;return f({debugName:()=>(0,k.getFunctionName)(n)},_=>{const y=i.read(_),N=s;s=y,n({lastValue:N,newValue:y})})}e.autorunDelta=o}),define(K[10],G([0,1,23,2,5,4]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedDisposable=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const r=(i,n)=>i===n;function f(i,n){return n!==void 0?new o(i,void 0,n,void 0,void 0,void 0,r):new o(void 0,void 0,i,void 0,void 0,void 0,r)}e.derived=f;function t(i,n){return new o(i.owner,i.debugName,n,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??r)}e.derivedOpts=t;function c(i,n){return new o(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??r)}e.derivedHandleChanges=c;function m(i,n){let s,_;n===void 0?(s=i,_=void 0):(_=i,s=n);const y=new w.DisposableStore;return new o(_,()=>(0,k.getFunctionName)(s)??"(anonymous)",N=>(y.clear(),s(N,y)),void 0,void 0,()=>y.dispose(),r)}e.derivedWithStore=m;function h(i,n){let s,_;n===void 0?(s=i,_=void 0):(_=i,s=n);const y=new w.DisposableStore;return new o(_,()=>(0,k.getFunctionName)(s)??"(anonymous)",N=>{y.clear();const R=s(N);return R&&y.add(R),R},void 0,void 0,()=>y.dispose(),r)}e.derivedDisposable=h,(0,k._setDerivedOpts)(t);var u;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(u||(u={}));class o extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,this._computeFn,this._owner)??"(anonymous)"}constructor(n,s,_,y,N,R=void 0,E){super(),this._owner=n,this._debugName=s,this._computeFn=_,this.createChangeSummary=y,this._handleChange=N,this._handleLastObserverRemoved=R,this._equalityComparator=E,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,P.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const s=this.state!==0,_=this.value;this.state=3;const y=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,y)}finally{for(const R of this.dependenciesToBeRemoved)R.removeObserver(this);this.dependenciesToBeRemoved.clear()}const N=s&&!this._equalityComparator(_,this.value);if((0,P.getLogger)()?.handleDerivedRecomputed(this,{oldValue:_,newValue:this.value,change:void 0,didChange:N,hadValue:s}),N)for(const R of this.observers)R.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const s=this.updateCount===1;if(this.state===3&&(this.state=1,!s))for(const _ of this.observers)_.handlePossibleChange(this);if(s)for(const _ of this.observers)_.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const s=[...this.observers];for(const _ of s)_.endUpdate(this)}(0,I.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const s of this.observers)s.handlePossibleChange(this)}}handleChange(n,s){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const _=this._handleChange?this._handleChange({changedObservable:n,change:s,didChange:N=>N===n},this.changeSummary):!0,y=this.state===3;if(_&&(this.state===1||y)&&(this.state=2,y))for(const N of this.observers)N.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const s=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),s}addObserver(n){const s=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),s&&n.beginUpdate(this)}removeObserver(n){const s=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),s&&n.endUpdate(this)}}e.Derived=o}),define(K[24],G([0,1,2,9,5,10,4]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapObservableArrayCached=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function f(z){return new t(z)}e.constObservable=f;class t extends k.ConvenientObservable{constructor(d){super(),this.value=d}get debugName(){return this.toString()}get(){return this.value}addObserver(d){}removeObserver(d){}toString(){return`Const: ${this.value}`}}function c(z){const d=(0,k.observableValue)("promiseValue",{});return z.then(T=>{d.set({value:T},void 0)}),d}e.observableFromPromise=c;function m(z,d){return new Promise(T=>{let A=!1,L=!1;const b=z.map(p=>({isFinished:d(p),state:p})),a=(0,w.autorun)(p=>{const{isFinished:F,state:W}=b.read(p);F&&(A?a.dispose():L=!0,T(W))});A=!0,L&&a.dispose()})}e.waitForState=m;function h(z,d){return new u(z,d)}e.observableFromEvent=h;class u extends k.BaseObservable{constructor(d,T){super(),this.event=d,this._getValue=T,this.hasValue=!1,this.handleEvent=A=>{const L=this._getValue(A),b=this.value,a=!this.hasValue||b!==L;let p=!1;a&&(this.value=L,this.hasValue&&(p=!0,(0,k.subtransaction)(u.globalTransaction,F=>{(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:L,change:void 0,didChange:a,hadValue:this.hasValue});for(const W of this.observers)F.updateObserver(W,this),W.handleChange(this,void 0)},()=>{const F=this.getDebugName();return"Event fired"+(F?`: ${F}`:"")})),this.hasValue=!0),p||(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:L,change:void 0,didChange:a,hadValue:this.hasValue})}}getDebugName(){return(0,k.getFunctionName)(this._getValue)}get debugName(){const d=this.getDebugName();return"From Event"+(d?`: ${d}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=u,function(z){z.Observer=u;function d(T,A){let L=!1;u.globalTransaction===void 0&&(u.globalTransaction=T,L=!0);try{A()}finally{L&&(u.globalTransaction=void 0)}}z.batchEventsGlobally=d}(h||(e.observableFromEvent=h={}));function o(z,d){return new i(z,d)}e.observableSignalFromEvent=o;class i extends k.BaseObservable{constructor(d,T){super(),this.debugName=d,this.event=T,this.handleEvent=()=>{(0,k.transaction)(A=>{for(const L of this.observers)A.updateObserver(L,this),L.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function n(z){return typeof z=="string"?new s(z):new s(void 0,z)}e.observableSignal=n;class s extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,void 0,this._owner)??"Observable Signal"}constructor(d,T){super(),this._debugName=d,this._owner=T}trigger(d,T){if(!d){(0,k.transaction)(A=>{this.trigger(A,T)},()=>`Trigger signal ${this.debugName}`);return}for(const A of this.observers)d.updateObserver(A,this),A.handleChange(this,T)}get(){}}function _(z,d,T){const A=(0,k.observableValue)("debounced",void 0);let L;return T.add((0,w.autorun)(b=>{const a=z.read(b);L&&clearTimeout(L),L=setTimeout(()=>{(0,k.transaction)(p=>{A.set(a,p)})},d)})),A}e.debouncedObservable=_;function y(z,d,T){const A=(0,k.observableValue)("triggeredRecently",!1);let L;return T.add(z(()=>{A.set(!0,void 0),L&&clearTimeout(L),L=setTimeout(()=>{A.set(!1,void 0)},d)})),A}e.wasEventTriggeredRecently=y;function N(z){const d=new E(!1,void 0);return z.addObserver(d),(0,I.toDisposable)(()=>{z.removeObserver(d)})}e.keepObserved=N,(0,k._setKeepObserved)(N);function R(z,d){const T=new E(!0,d);return z.addObserver(T),d?d(z.get()):z.reportChanges(),(0,I.toDisposable)(()=>{z.removeObserver(T)})}e.recomputeInitiallyAndOnChange=R,(0,k._setRecomputeInitiallyAndOnChange)(R);class E{constructor(d,T){this._forceRecompute=d,this._handleValue=T,this._counter=0}beginUpdate(d){this._counter++}endUpdate(d){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(d.get()):d.reportChanges())}handlePossibleChange(d){}handleChange(d,T){}}function g(z){let d;return(0,P.derived)(A=>(d=z(A,d),d))}e.derivedObservableWithCache=g;function S(z,d){let T;const A=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),L=(0,P.derived)(z,b=>(A.read(b),T=d(b,T),T));return Object.assign(L,{clearCache:b=>{T=void 0,A.set(A.get()+1,b)}})}e.derivedObservableWithWritableCache=S;function O(z,d,T,A){let L=new U(T,A);return(0,P.derivedOpts)({debugName:()=>(0,k.getDebugName)(L,void 0,T,z),owner:z,onLastObserverRemoved:()=>{L.dispose(),L=new U(T)}},a=>(L.setItems(d.read(a)),L.getItems()))}e.mapObservableArrayCached=O;class U{constructor(d,T){this._map=d,this._keySelector=T,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(d=>d.store.dispose()),this._cache.clear()}setItems(d){const T=[],A=new Set(this._cache.keys());for(const L of d){const b=this._keySelector?this._keySelector(L):L;let a=this._cache.get(b);if(a)A.delete(b);else{const p=new I.DisposableStore;a={out:this._map(L,p),store:p},this._cache.set(b,a)}T.push(a.out)}for(const L of A)this._cache.get(L).store.dispose(),this._cache.delete(L);this._items=T}getItems(){return this._items}}}),define(K[11],G([0,1,5,10,9,24,4]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return I.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return I.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return I.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return I.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return w.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return w.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return w.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return w.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return P.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return P.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return P.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return P.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return P.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return P.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return P.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return P.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return P.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return P.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return P.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return P.wasEventTriggeredRecently}}),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(K[25],G([0,1,6,2]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(R){const E=R;return E?typeof E.read=="function":!1}e.isReadable=k;function P(R){const E=R;return E?[E.on,E.pause,E.resume,E.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=P;function r(R){const E=R;return E?P(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=r;function f(R,E){return new t(R,E)}e.newWriteableStream=f;class t{constructor(E,g){this.reducer=E,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(g=>g(E))}emitError(E){this.listeners.error.length===0?(0,I.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(g=>g(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,g){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(E,g){if(this.state.destroyed)return;let S;switch(E){case"data":S=this.listeners.data;break;case"end":S=this.listeners.end;break;case"error":S=this.listeners.error;break}if(S){const O=S.indexOf(g);O>=0&&S.splice(O,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(S=>S())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(R,E){const g=[];let S;for(;(S=R.read())!==null;)g.push(S);return E(g)}e.consumeReadable=c;function m(R,E,g){const S=[];let O;for(;(O=R.read())!==null&&S.length<g;)S.push(O);return O===null&&S.length>0?E(S):{read:()=>{if(S.length>0)return S.shift();if(typeof O<"u"){const U=O;return O=void 0,U}return R.read()}}}e.peekReadable=m;function h(R,E){return new Promise((g,S)=>{const O=[];u(R,{onData:U=>{E&&O.push(U)},onError:U=>{E?S(U):g(void 0)},onEnd:()=>{g(E?E(O):void 0)}})})}e.consumeStream=h;function u(R,E,g){R.on("error",S=>{g?.isCancellationRequested||E.onError(S)}),R.on("end",()=>{g?.isCancellationRequested||E.onEnd()}),R.on("data",S=>{g?.isCancellationRequested||E.onData(S)})}e.listenStream=u;function o(R,E){return new Promise((g,S)=>{const O=new w.DisposableStore,U=[],z=A=>{if(U.push(A),U.length>E)return O.dispose(),R.pause(),g({stream:R,buffer:U,ended:!1})},d=A=>(O.dispose(),S(A)),T=()=>(O.dispose(),g({stream:R,buffer:U,ended:!0}));O.add((0,w.toDisposable)(()=>R.removeListener("error",d))),R.on("error",d),O.add((0,w.toDisposable)(()=>R.removeListener("end",T))),R.on("end",T),O.add((0,w.toDisposable)(()=>R.removeListener("data",z))),R.on("data",z)})}e.peekStream=o;function i(R,E){const g=f(E);return g.end(R),g}e.toStream=i;function n(){const R=f(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=n;function s(R){let E=!1;return{read:()=>E?null:(E=!0,R)}}e.toReadable=s;function _(R,E,g){const S=f(g);return u(R,{onData:O=>S.write(E.data(O)),onError:O=>S.error(E.error?E.error(O):O),onEnd:()=>S.end()}),S}e.transform=_;function y(R,E,g){let S=!1;return{read:()=>{const O=E.read();return S?O:(S=!0,O!==null?g([R,O]):R)}}}e.prefixedReadable=y;function N(R,E,g){let S=!1;const O=f(g);return u(E,{onData:U=>S?O.write(U):(S=!0,O.write(g([R,U]))),onError:U=>O.error(U),onEnd:()=>{S||(S=!0,O.write(R)),O.end()}}),O}e.prefixedStream=N}),define(K[12],G([0,1,26,25]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",P=new I.Lazy(()=>new Uint8Array(256));let r,f;class t{static alloc(a){return k?new t(Buffer.allocUnsafe(a)):new t(new Uint8Array(a))}static wrap(a){return k&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new t(a)}static fromString(a,p){return!(p?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(a)):(r||(r=new TextEncoder),new t(r.encode(a)))}static fromByteArray(a){const p=t.alloc(a.length);for(let F=0,W=a.length;F<W;F++)p.buffer[F]=a[F];return p}static concat(a,p){if(typeof p>"u"){p=0;for(let j=0,V=a.length;j<V;j++)p+=a[j].byteLength}const F=t.alloc(p);let W=0;for(let j=0,V=a.length;j<V;j++){const $=a[j];F.set($,W),W+=$.byteLength}return F}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=t.alloc(this.byteLength);return a.set(this),a}toString(){return k?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,p){return new t(this.buffer.subarray(a,p))}set(a,p){if(a instanceof t)this.buffer.set(a.buffer,p);else if(a instanceof Uint8Array)this.buffer.set(a,p);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),p);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return u(this.buffer,a)}writeUInt32BE(a,p){o(this.buffer,a,p)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,p){n(this.buffer,a,p)}readUInt8(a){return s(this.buffer,a)}writeUInt8(a,p){_(this.buffer,a,p)}indexOf(a,p=0){return c(this.buffer,a instanceof t?a.buffer:a,p)}}e.VSBuffer=t;function c(b,a,p=0){const F=a.byteLength,W=b.byteLength;if(F===0)return 0;if(F===1)return b.indexOf(a[0]);if(F>W-p)return-1;const j=P.value;j.fill(a.length);for(let J=0;J<a.length;J++)j[a[J]]=a.length-J-1;let V=p+a.length-1,$=V,H=-1;for(;V<W;)if(b[V]===a[$]){if($===0){H=V;break}V--,$--}else V+=Math.max(a.length-$,j[b[V]]),$=a.length-1;return H}e.binaryIndexOf=c;function m(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0}e.readUInt16LE=m;function h(b,a,p){b[p+0]=a&255,a=a>>>8,b[p+1]=a&255}e.writeUInt16LE=h;function u(b,a){return b[a]*2**24+b[a+1]*2**16+b[a+2]*2**8+b[a+3]}e.readUInt32BE=u;function o(b,a,p){b[p+3]=a,a=a>>>8,b[p+2]=a,a=a>>>8,b[p+1]=a,a=a>>>8,b[p]=a}e.writeUInt32BE=o;function i(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0|b[a+2]<<16>>>0|b[a+3]<<24>>>0}e.readUInt32LE=i;function n(b,a,p){b[p+0]=a&255,a=a>>>8,b[p+1]=a&255,a=a>>>8,b[p+2]=a&255,a=a>>>8,b[p+3]=a&255}e.writeUInt32LE=n;function s(b,a){return b[a]}e.readUInt8=s;function _(b,a,p){b[p]=a}e.writeUInt8=_;function y(b){return w.consumeReadable(b,a=>t.concat(a))}e.readableToBuffer=y;function N(b){return w.toReadable(b)}e.bufferToReadable=N;function R(b){return w.consumeStream(b,a=>t.concat(a))}e.streamToBuffer=R;async function E(b){return b.ended?t.concat(b.buffer):t.concat([...b.buffer,await R(b.stream)])}e.bufferedStreamToBuffer=E;function g(b){return w.toStream(b,a=>t.concat(a))}e.bufferToStream=g;function S(b){return w.transform(b,{data:a=>typeof a=="string"?t.fromString(a):t.wrap(a)},a=>t.concat(a))}e.streamToBufferReadableStream=S;function O(b){return w.newWriteableStream(a=>t.concat(a),b)}e.newWriteableBufferStream=O;function U(b,a){return w.prefixedReadable(b,a,p=>t.concat(p))}e.prefixedBufferReadable=U;function z(b,a){return w.prefixedStream(b,a,p=>t.concat(p))}e.prefixedBufferStream=z;function d(b){let a=0,p=0,F=0;const W=new Uint8Array(Math.floor(b.length/4*3)),j=$=>{switch(p){case 3:W[F++]=a|$,p=0;break;case 2:W[F++]=a|$>>>2,a=$<<6,p=3;break;case 1:W[F++]=a|$>>>4,a=$<<4,p=2;break;default:a=$<<2,p=1}};for(let $=0;$<b.length;$++){const H=b.charCodeAt($);if(H>=65&&H<=90)j(H-65);else if(H>=97&&H<=122)j(H-97+26);else if(H>=48&&H<=57)j(H-48+52);else if(H===43||H===45)j(62);else if(H===47||H===95)j(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${b[$]}`)}}const V=F;for(;p>0;)j(0);return t.wrap(W).slice(0,V)}e.decodeBase64=d;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function L({buffer:b},a=!0,p=!1){const F=p?A:T;let W="";const j=b.byteLength%3;let V=0;for(;V<b.byteLength-j;V+=3){const $=b[V+0],H=b[V+1],J=b[V+2];W+=F[$>>>2],W+=F[($<<4|H>>>4)&63],W+=F[(H<<2|J>>>6)&63],W+=F[J&63]}if(j===1){const $=b[V+0];W+=F[$>>>2],W+=F[$<<4&63],a&&(W+="==")}else if(j===2){const $=b[V+0],H=b[V+1];W+=F[$>>>2],W+=F[($<<4|H>>>4)&63],W+=F[H<<2&63],a&&(W+="=")}return W}e.encodeBase64=L}),define(K[27],G([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(K[13],G([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var I;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function w(k){let P=0,r=0,f=0,t=0;for(let c=0,m=k.length;c<m;c++){const h=k.charCodeAt(c);h===13?(P===0&&(r=c),P++,c+1<m&&k.charCodeAt(c+1)===10?(t|=2,c++):t|=3,f=c+1):h===10&&(t|=1,P===0&&(r=c),P++,f=c+1)}return P===0&&(r=k.length),[P,r,k.length-f,t]}e.countEOL=w}),define(K[14],G([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(I||(e.LanguageId=I={}));var w;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(w||(e.FontStyle=w={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var P;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(P||(e.StandardTokenType=P={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class f{static getLanguageId(c){return(c&255)>>>0}static getTokenType(c){return(c&768)>>>8}static containsBalancedBrackets(c){return(c&1024)!==0}static getFontStyle(c){return(c&30720)>>>11}static getForeground(c){return(c&16744448)>>>15}static getBackground(c){return(c&4278190080)>>>24}static getClassNameFromMetadata(c){let h="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&1&&(h+=" mtki"),u&2&&(h+=" mtkb"),u&4&&(h+=" mtku"),u&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(c,m){const h=this.getForeground(c),u=this.getFontStyle(c);let o=`color: ${m[h]};`;u&1&&(o+="font-style: italic;"),u&2&&(o+="font-weight: bold;");let i="";return u&4&&(i+=" underline"),u&8&&(i+=" line-through"),i&&(o+=`text-decoration:${i};`),o}static getPresentationFromMetadata(c){const m=this.getForeground(c),h=this.getFontStyle(c);return{foreground:m,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.TokenMetadata=f}),define(K[28],G([0,1,29]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class w{constructor(r){this._default=r,this._store=[]}get(r){return r<this._store.length?this._store[r]:this._default}set(r,f){for(;r>=this._store.length;)this._store[this._store.length]=this._default;this._store[r]=f}replace(r,f,t){if(r>=this._store.length)return;if(f===0){this.insert(r,t);return}else if(t===0){this.delete(r,f);return}const c=this._store.slice(0,r),m=this._store.slice(r+f),h=k(t,this._default);this._store=c.concat(h,m)}delete(r,f){f===0||r>=this._store.length||this._store.splice(r,f)}insert(r,f){if(f===0||r>=this._store.length)return;const t=[];for(let c=0;c<f;c++)t[c]=this._default;this._store=(0,I.arrayInsert)(this._store,r,t)}}e.FixedArray=w;function k(P,r){const f=[];for(let t=0;t<P;t++)f[t]=r;return f}}),define(K[7],G([0,1,14]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class w{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,f){const t=w.defaultTokenMetadata,c=new Uint32Array(2);return c[0]=r.length,c[1]=t,new w(c,r,f)}constructor(r,f,t){this._lineTokensBrand=void 0,this._tokens=r,this._tokensCount=this._tokens.length>>>1,this._text=f,this._languageIdCodec=t}equals(r){return r instanceof w?this.slicedEquals(r,0,this._tokensCount):!1}slicedEquals(r,f,t){if(this._text!==r._text||this._tokensCount!==r._tokensCount)return!1;const c=f<<1,m=c+(t<<1);for(let h=c;h<m;h++)if(this._tokens[h]!==r._tokens[h])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(r){return r>0?this._tokens[r-1<<1]:0}getMetadata(r){return this._tokens[(r<<1)+1]}getLanguageId(r){const f=this._tokens[(r<<1)+1],t=I.TokenMetadata.getLanguageId(f);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(r){const f=this._tokens[(r<<1)+1];return I.TokenMetadata.getTokenType(f)}getForeground(r){const f=this._tokens[(r<<1)+1];return I.TokenMetadata.getForeground(f)}getClassName(r){const f=this._tokens[(r<<1)+1];return I.TokenMetadata.getClassNameFromMetadata(f)}getInlineStyle(r,f){const t=this._tokens[(r<<1)+1];return I.TokenMetadata.getInlineStyleFromMetadata(t,f)}getPresentation(r){const f=this._tokens[(r<<1)+1];return I.TokenMetadata.getPresentationFromMetadata(f)}getEndOffset(r){return this._tokens[r<<1]}findTokenIndexAtOffset(r){return w.findIndexInTokensArray(this._tokens,r)}inflate(){return this}sliceAndInflate(r,f,t){return new k(this,r,f,t)}static convertToEndOffset(r,f){const c=(r.length>>>1)-1;for(let m=0;m<c;m++)r[m<<1]=r[m+1<<1];r[c<<1]=f}static findIndexInTokensArray(r,f){if(r.length<=2)return 0;let t=0,c=(r.length>>>1)-1;for(;t<c;){const m=t+Math.floor((c-t)/2),h=r[m<<1];if(h===f)return m+1;h<f?t=m+1:h>f&&(c=m)}return t}withInserted(r){if(r.length===0)return this;let f=0,t=0,c="";const m=new Array;let h=0;for(;;){const u=f<this._tokensCount?this._tokens[f<<1]:-1,o=t<r.length?r[t]:null;if(u!==-1&&(o===null||u<=o.offset)){c+=this._text.substring(h,u);const i=this._tokens[(f<<1)+1];m.push(c.length,i),f++,h=u}else if(o){if(o.offset>h){c+=this._text.substring(h,o.offset);const i=this._tokens[(f<<1)+1];m.push(c.length,i),h=o.offset}c+=o.text,m.push(c.length,o.tokenMetadata),t++}else break}return new w(new Uint32Array(m),c,this._languageIdCodec)}}e.LineTokens=w;class k{constructor(r,f,t,c){this._source=r,this._startOffset=f,this._endOffset=t,this._deltaOffset=c,this._firstTokenIndex=r.findTokenIndexAtOffset(f),this._tokensCount=0;for(let m=this._firstTokenIndex,h=r.getCount();m<h&&!(r.getStartOffset(m)>=t);m++)this._tokensCount++}getMetadata(r){return this._source.getMetadata(this._firstTokenIndex+r)}getLanguageId(r){return this._source.getLanguageId(this._firstTokenIndex+r)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(r){return r instanceof k?this._startOffset===r._startOffset&&this._endOffset===r._endOffset&&this._deltaOffset===r._deltaOffset&&this._source.slicedEquals(r._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(r){return this._source.getForeground(this._firstTokenIndex+r)}getEndOffset(r){const f=this._source.getEndOffset(this._firstTokenIndex+r);return Math.min(this._endOffset,f)-this._startOffset+this._deltaOffset}getClassName(r){return this._source.getClassName(this._firstTokenIndex+r)}getInlineStyle(r,f){return this._source.getInlineStyle(this._firstTokenIndex+r,f)}getPresentation(r){return this._source.getPresentation(this._firstTokenIndex+r)}findTokenIndexAtOffset(r){return this._source.findTokenIndexAtOffset(r+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(K[30],G([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class w{static deleteBeginning(r,f){return r===null||r===e.EMPTY_LINE_TOKENS?r:w.delete(r,0,f)}static deleteEnding(r,f){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=k(r),c=t[t.length-2];return w.delete(r,f,c)}static delete(r,f,t){if(r===null||r===e.EMPTY_LINE_TOKENS||f===t)return r;const c=k(r),m=c.length>>>1;if(f===0&&c[c.length-2]===t)return e.EMPTY_LINE_TOKENS;const h=I.LineTokens.findIndexInTokensArray(c,f),u=h>0?c[h-1<<1]:0,o=c[h<<1];if(t<o){const y=t-f;for(let N=h;N<m;N++)c[N<<1]-=y;return r}let i,n;u!==f?(c[h<<1]=f,i=h+1<<1,n=f):(i=h<<1,n=u);const s=t-f;for(let y=h+1;y<m;y++){const N=c[y<<1]-s;N>n&&(c[i++]=N,c[i++]=c[(y<<1)+1],n=N)}if(i===c.length)return r;const _=new Uint32Array(i);return _.set(c.subarray(0,i),0),_.buffer}static append(r,f){if(f===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return f;if(r===null)return r;if(f===null)return null;const t=k(r),c=k(f),m=c.length>>>1,h=new Uint32Array(t.length+c.length);h.set(t,0);let u=t.length;const o=t[t.length-2];for(let i=0;i<m;i++)h[u++]=c[i<<1]+o,h[u++]=c[(i<<1)+1];return h.buffer}static insert(r,f,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const c=k(r),m=c.length>>>1;let h=I.LineTokens.findIndexInTokensArray(c,f);h>0&&c[h-1<<1]===f&&h--;for(let u=h;u<m;u++)c[u<<1]+=t;return r}}e.ContiguousTokensEditing=w;function k(P){return P instanceof Uint32Array?P:new Uint32Array(P)}e.toUint32Array=k}),define(K[31],G([0,1,29,12,44,13,30,15]),function(q,e,I,w,k,P,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(m,h,u){const o=new Uint32Array(m.buffer),i=(0,w.readUInt32BE)(m,h);h+=4;const n=(0,w.readUInt32BE)(m,h);h+=4;const s=[];for(let _=0;_<n;_++){const y=(0,w.readUInt32BE)(m,h);h+=4,s.push(o.subarray(h/4,h/4+y/4)),h+=y}return u.push(new t(i,s)),h}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(m,h){this._startLineNumber=m,this._tokens=h}getLineRange(){return new f.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(m){return this._tokens[m-this._startLineNumber]}appendLineTokens(m){this._tokens.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let h=0;h<this._tokens.length;h++){const u=this._tokens[h];if(!(u instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=u.byteLength}return m}serialize(m,h){(0,w.writeUInt32BE)(m,this._startLineNumber,h),h+=4,(0,w.writeUInt32BE)(m,this._tokens.length,h),h+=4;for(let u=0;u<this._tokens.length;u++){const o=this._tokens[u];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,w.writeUInt32BE)(m,o.byteLength,h),h+=4,m.set(new Uint8Array(o.buffer),h),h+=o.byteLength}return h}applyEdit(m,h){const[u,o]=(0,P.countEOL)(h);this._acceptDeleteRange(m),this._acceptInsertText(new k.Position(m.startLineNumber,m.startColumn),u,o)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const h=m.startLineNumber-this._startLineNumber,u=m.endLineNumber-this._startLineNumber;if(u<0){const o=u-h;this._startLineNumber-=o;return}if(!(h>=this._tokens.length)){if(h<0&&u>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(h===u){this._tokens[h]=r.ContiguousTokensEditing.delete(this._tokens[h],m.startColumn-1,m.endColumn-1);return}if(h>=0)if(this._tokens[h]=r.ContiguousTokensEditing.deleteEnding(this._tokens[h],m.startColumn-1),u<this._tokens.length){const o=r.ContiguousTokensEditing.deleteBeginning(this._tokens[u],m.endColumn-1);this._tokens[h]=r.ContiguousTokensEditing.append(this._tokens[h],o),this._tokens.splice(h+1,u-h)}else this._tokens[h]=r.ContiguousTokensEditing.append(this._tokens[h],null),this._tokens=this._tokens.slice(0,h+1);else{const o=-h;this._startLineNumber-=o,this._tokens[u]=r.ContiguousTokensEditing.deleteBeginning(this._tokens[u],m.endColumn-1),this._tokens=this._tokens.slice(u)}}}_acceptInsertText(m,h,u){if(h===0&&u===0)return;const o=m.lineNumber-this._startLineNumber;if(o<0){this._startLineNumber+=h;return}if(!(o>=this._tokens.length)){if(h===0){this._tokens[o]=r.ContiguousTokensEditing.insert(this._tokens[o],m.column-1,u);return}this._tokens[o]=r.ContiguousTokensEditing.deleteEnding(this._tokens[o],m.column-1),this._tokens[o]=r.ContiguousTokensEditing.insert(this._tokens[o],m.column-1,u),this._insertLines(m.lineNumber,h)}}_insertLines(m,h){if(h===0)return;const u=[];for(let o=0;o<h;o++)u[o]=null;this._tokens=I.arrayInsert(this._tokens,m,u)}}e.ContiguousMultilineTokens=t}),define(K[16],G([0,1,12,31]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(r){let f=0;const t=(0,I.readUInt32BE)(r,f);f+=4;const c=[];for(let m=0;m<t;m++)f=w.ContiguousMultilineTokens.deserialize(r,f,c);return c}constructor(){this._tokens=[]}add(r,f){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(f);return}}this._tokens.push(new w.ContiguousMultilineTokens(r,[f]))}finalize(){return this._tokens}serialize(){const r=this._serializeSize(),f=new Uint8Array(r);return this._serialize(f),f}_serializeSize(){let r=0;r+=4;for(let f=0;f<this._tokens.length;f++)r+=this._tokens[f].serializeSize();return r}_serialize(r){let f=0;(0,I.writeUInt32BE)(r,this._tokens.length,f),f+=4;for(let t=0;t<this._tokens.length;t++)f=this._tokens[t].serialize(r,f)}}e.ContiguousMultilineTokensBuilder=k}),define(K[32],G([0,1,33,3,17,45]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(d){return d===47||d===92}e.isPathSeparator=r;function f(d){return d.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=f;function t(d){return d.indexOf("/")===-1&&(d=f(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=t;function c(d,T=I.posix.sep){if(!d)return"";const A=d.length,L=d.charCodeAt(0);if(r(L)){if(r(d.charCodeAt(1))&&!r(d.charCodeAt(2))){let a=3;const p=a;for(;a<A&&!r(d.charCodeAt(a));a++);if(p!==a&&!r(d.charCodeAt(a+1))){for(a+=1;a<A;a++)if(r(d.charCodeAt(a)))return d.slice(0,a+1).replace(/[\\/]/g,T)}}return T}else if(_(L)&&d.charCodeAt(1)===58)return r(d.charCodeAt(2))?d.slice(0,2)+T:d.slice(0,2);let b=d.indexOf("://");if(b!==-1){for(b+=3;b<A;b++)if(r(d.charCodeAt(b)))return d.slice(0,b+1)}return""}e.getRoot=c;function m(d){if(!w.isWindows||!d||d.length<5)return!1;let T=d.charCodeAt(0);if(T!==92||(T=d.charCodeAt(1),T!==92))return!1;let A=2;const L=A;for(;A<d.length&&(T=d.charCodeAt(A),T!==92);A++);return!(L===A||(T=d.charCodeAt(A+1),isNaN(T)||T===92))}e.isUNC=m;const h=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(d,T=w.isWindows){const A=T?h:u;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||T&&o.test(d)||d==="."||d===".."||T&&d[d.length-1]==="."||T&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=i;function n(d,T,A){const L=d===T;return!A||L?L:!d||!T?!1:(0,k.equalsIgnoreCase)(d,T)}e.isEqual=n;function s(d,T,A,L=I.sep){if(d===T)return!0;if(!d||!T||T.length>d.length)return!1;if(A){if(!(0,k.startsWithIgnoreCase)(d,T))return!1;if(T.length===d.length)return!0;let a=T.length;return T.charAt(T.length-1)===L&&a--,d.charAt(a)===L}return T.charAt(T.length-1)!==L&&(T+=L),d.indexOf(T)===0}e.isEqualOrParent=s;function _(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=_;function y(d,T){return w.isWindows&&d.endsWith(":")&&(d+=I.sep),(0,I.isAbsolute)(d)||(d=(0,I.join)(T,d)),d=(0,I.normalize)(d),w.isWindows?(d=(0,k.rtrim)(d,I.sep),d.endsWith(":")&&(d+=I.sep)):(d=(0,k.rtrim)(d,I.sep),d||(d=I.sep)),d}e.sanitizeFilePath=y;function N(d){const T=(0,I.normalize)(d);return w.isWindows?d.length>3?!1:R(T)&&(d.length===2||T.charCodeAt(2)===92):T===I.posix.sep}e.isRootOrDriveLetter=N;function R(d,T=w.isWindows){return T?_(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function E(d,T=w.isWindows){return R(d,T)?d[0]:void 0}e.getDriveLetter=E;function g(d,T,A){return T.length>d.length?-1:d===T?0:(A&&(d=d.toLowerCase(),T=T.toLowerCase()),d.indexOf(T))}e.indexOfPath=g;function S(d){const T=d.split(":");let A,L,b;for(const a of T){const p=Number(a);(0,P.isNumber)(p)?L===void 0?L=p:b===void 0&&(b=p):A=A?[A,a].join(":"):a}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:L!==void 0?L:void 0,column:b!==void 0?b:L!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",U="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(d,T,A=8){let L="";for(let a=0;a<A;a++){let p;a===0&&w.isWindows&&!T&&(A===3||A===4)?p=U:p=O,L+=p.charAt(Math.floor(Math.random()*p.length))}let b;return T?b=`${T}-${L}`:b=L,d?(0,I.join)(d,b):b}e.randomPath=z}),define(K[18],G([0,1,6,3,17,8]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var r;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(r||(e.Schemas=r={}));function f(u,o){return P.URI.isUri(u)?(0,k.equalsIgnoreCase)(u.scheme,o):(0,k.startsWithIgnoreCase)(u,o+":")}e.matchesScheme=f;function t(u,...o){return o.some(i=>f(u,i))}e.matchesSomeScheme=t,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class c{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${r.vscodeRemoteResource}`}setPreferredWebSchema(o){this._preferredWebSchema=o}setDelegate(o){this._delegate=o}setServerRootPath(o){this._remoteResourcesPath=`${o}/${r.vscodeRemoteResource}`}set(o,i,n){this._hosts[o]=i,this._ports[o]=n}setConnectionToken(o,i){this._connectionTokens[o]=i}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(o){if(this._delegate)try{return this._delegate(o)}catch(N){return I.onUnexpectedError(N),o}const i=o.authority;let n=this._hosts[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this._ports[i],_=this._connectionTokens[i];let y=`path=${encodeURIComponent(o.path)}`;return typeof _=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),P.URI.from({scheme:w.isWeb?this._preferredWebSchema:r.vscodeRemoteResource,authority:`${n}:${s}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new c,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class m{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(o){const i=this.toUri(o,q);return this.uriToBrowserUri(i)}uriToBrowserUri(o){return o.scheme===r.vscodeRemote?e.RemoteAuthorities.rewrite(o):o.scheme===r.file&&(w.isNative||w.webWorkerOrigin===`${r.vscodeFileResource}://${m.FALLBACK_AUTHORITY}`)?o.with({scheme:r.vscodeFileResource,authority:o.authority||m.FALLBACK_AUTHORITY,query:null,fragment:null}):o}asFileUri(o){const i=this.toUri(o,q);return this.uriToFileUri(i)}uriToFileUri(o){return o.scheme===r.vscodeFileResource?o.with({scheme:r.file,authority:o.authority!==m.FALLBACK_AUTHORITY?o.authority:null,query:null,fragment:null}):o}toUri(o,i){return P.URI.isUri(o)?o:P.URI.parse(i.toUrl(o))}}e.FileAccess=new m;var h;(function(u){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(o.get("3"));const i="vscode-coi";function n(_){let y;typeof _=="string"?y=new URL(_).searchParams:_ instanceof URL?y=_.searchParams:P.URI.isUri(_)&&(y=new URL(_.toString(!0)).searchParams);const N=y?.get(i);if(N)return o.get(N)}u.getHeadersFromQuery=n;function s(_,y,N){if(!globalThis.crossOriginIsolated)return;const R=y&&N?"3":N?"2":"1";_ instanceof URLSearchParams?_.set(i,R):_[i]=R}u.addSearchParam=s})(h||(e.COI=h={}))}),define(K[34],G([0,1,22,18,3,8]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class r{constructor(u,o,i){this.id=u,this.dependencies=o,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(u,o,i)=>{typeof u!="string"&&(i=o,o=u,u=null),(typeof o!="object"||!Array.isArray(o))&&(i=o,o=null),this._defineCalls.push(new r(u,o,i))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this._initialize();const o=await(this._isWebWorker?this._workerLoadScript(u):this._isRenderer?this._rendererLoadScript(u):this._nodeJSLoadScript(u));if(!o)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}_rendererLoadScript(u){return new Promise((o,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const s=()=>{n.removeEventListener("load",_),n.removeEventListener("error",y)},_=N=>{s(),o(this._defineCalls.pop())},y=N=>{s(),i(N)};n.addEventListener("load",_),n.addEventListener("error",y),this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),n.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(n)})}_workerLoadScript(u){return new Promise((o,i)=>{try{this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),importScripts(u),o(this._defineCalls.pop())}catch(n){i(n)}})}async _nodeJSLoadScript(u){try{const o=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,s=P.URI.parse(u).fsPath,_=o.readFileSync(s).toString(),y=n.wrap(_.replace(/^#!.*/,""));return new i.Script(y).runInThisContext().apply(),this._defineCalls.pop()}catch(o){throw o}}}const t=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function m(h,u,o){if(I.isESM){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[h]&&(h=c[h]);const i=`${h}/${u}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const N=`${o&&!k.isWeb?w.nodeModulesAsarPath:w.nodeModulesPath}/${i}`;n=w.FileAccess.asBrowserUri(N).toString(!0)}const s=f.INSTANCE.load(n);return t.set(i,s),s}else return await new Promise((i,n)=>{q([h],i,n)})}e.importAMDNodeModule=m}),define(K[19],G([0,1,32,18,33,3,17,8]),function(q,e,I,w,k,P,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(o){return(0,f.uriToFsPath)(o,!0)}e.originalFSPath=t;class c{constructor(i){this._ignorePathCasing=i}compare(i,n,s=!1){return i===n?0:(0,r.compare)(this.getComparisonKey(i,s),this.getComparisonKey(n,s))}isEqual(i,n,s=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,s)===this.getComparisonKey(n,s)}getComparisonKey(i,n=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,n,s=!1){if(i.scheme===n.scheme){if(i.scheme===w.Schemas.file)return I.isEqualOrParent(t(i),t(n),this._ignorePathCasing(i))&&i.query===n.query&&(s||i.fragment===n.fragment);if((0,e.isEqualAuthority)(i.authority,n.authority))return I.isEqualOrParent(i.path,n.path,this._ignorePathCasing(i),"/")&&i.query===n.query&&(s||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return k.posix.basename(i.path)}extname(i){return k.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===w.Schemas.file?n=f.URI.file(k.dirname(t(i))).path:(n=k.posix.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===w.Schemas.file?n=f.URI.file(k.normalize(t(i))).path:n=k.posix.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.isEqualAuthority)(i.authority,n.authority))return;if(i.scheme===w.Schemas.file){const y=k.relative(t(i),t(n));return P.isWindows?I.toSlashes(y):y}let s=i.path||"/";const _=n.path||"/";if(this._ignorePathCasing(i)){let y=0;for(const N=Math.min(s.length,_.length);y<N&&!(s.charCodeAt(y)!==_.charCodeAt(y)&&s.charAt(y).toLowerCase()!==_.charAt(y).toLowerCase());y++);s=_.substr(0,y)+s.substr(y)}return k.posix.relative(s,_)}resolvePath(i,n){if(i.scheme===w.Schemas.file){const s=f.URI.file(k.resolve(t(i),n));return i.with({authority:s.authority,path:s.path})}return n=I.toPosixPath(n),i.with({path:k.posix.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,r.equalsIgnoreCase)(i,n)}hasTrailingPathSeparator(i,n=k.sep){if(i.scheme===w.Schemas.file){const s=t(i);return s.length>I.getRoot(s).length&&s[s.length-1]===n}else{const s=i.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=k.sep){return(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=k.sep){let s=!1;if(i.scheme===w.Schemas.file){const _=t(i);s=_!==void 0&&_.length===I.getRoot(_).length&&_[_.length-1]===n}else{n="/";const _=i.path;s=_.length===1&&_.charCodeAt(_.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path+"/"}):i}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(o=>o.scheme===w.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new c(o=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(o,i){const n=[];for(let s=0;s<o.length;s++){const _=i(o[s]);o.some((y,N)=>N===s?!1:(0,e.isEqualOrParent)(_,i(y)))||n.push(o[s])}return n}e.distinctParents=m;var h;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function i(n){const s=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(N=>{const[R,E]=N.split(":");R&&E&&s.set(R,E)});const y=n.path.substring(0,n.path.indexOf(";"));return y&&s.set(o.META_DATA_MIME,y),s}o.parseMetaData=i})(h||(e.DataUri=h={}));function u(o,i,n){if(i){let s=o.path;return s&&s[0]!==k.posix.sep&&(s=k.posix.sep+s),o.with({scheme:n,authority:i,path:s})}return o.with({scheme:n})}e.toLocalResource=u}),define(K[20],G([0,1,46,6,35,2,19,3,27,26]),function(q,e,I,w,k,P,r,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(D){return!!D&&typeof D.then=="function"}e.isThenable=m;function h(D){const l=new I.CancellationTokenSource,v=D(l.token),C=new Promise((M,B)=>{const Y=l.token.onCancellationRequested(()=>{Y.dispose(),B(new w.CancellationError)});Promise.resolve(v).then(Z=>{Y.dispose(),l.dispose(),M(Z)},Z=>{Y.dispose(),l.dispose(),B(Z)})});return new class{cancel(){l.cancel(),l.dispose()}then(M,B){return C.then(M,B)}catch(M){return this.then(void 0,M)}finally(M){return C.finally(M)}}}e.createCancelablePromise=h;function u(D,l,v){return new Promise((C,M)=>{const B=l.onCancellationRequested(()=>{B.dispose(),C(v)});D.then(C,M).finally(()=>B.dispose())})}e.raceCancellation=u;function o(D,l){return new Promise((v,C)=>{const M=l.onCancellationRequested(()=>{M.dispose(),C(new w.CancellationError)});D.then(v,C).finally(()=>M.dispose())})}e.raceCancellationError=o;async function i(D){let l=-1;const v=D.map((C,M)=>C.then(B=>(l=M,B)));try{return await Promise.race(v)}finally{D.forEach((C,M)=>{M!==l&&C.cancel()})}}e.raceCancellablePromises=i;function n(D,l,v){let C;const M=setTimeout(()=>{C?.(void 0),v?.()},l);return Promise.race([D.finally(()=>clearTimeout(M)),new Promise(B=>C=B)])}e.raceTimeout=n;function s(D){return new Promise((l,v)=>{const C=D();m(C)?C.then(l,v):l(C)})}e.asPromise=s;class _{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const v=()=>{if(this.queuedPromise=null,this.isDisposed)return;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(v,v).then(C)})}return new Promise((v,C)=>{this.queuedPromise.then(v,C)})}return this.activePromise=l(),new Promise((v,C)=>{this.activePromise.then(M=>{this.activePromise=null,v(M)},M=>{this.activePromise=null,C(M)})})}dispose(){this.isDisposed=!0}}e.Throttler=_;class y{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=y;class N{constructor(){this.promiseMap=new Map}queue(l,v){const M=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.promiseMap.get(l)===M&&this.promiseMap.delete(l)});return this.promiseMap.set(l,M),M}}e.SequencerByKey=N;const R=(D,l)=>{let v=!0;const C=setTimeout(()=>{v=!1,l()},D);return{isTriggered:()=>v,dispose:()=>{clearTimeout(C),v=!1}}},E=D=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,D())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class g{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,v=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,B)=>{this.doResolve=M,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=v===t.MicrotaskDelay?E(C):R(v,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new w.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class S{constructor(l){this.delayer=new g(l),this.throttler=new _}trigger(l,v){return this.delayer.trigger(()=>this.throttler.queue(l),v)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=S;class O{constructor(){this._isOpen=!1,this._promise=new Promise((l,v)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=O;class U extends O{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=U;function z(D,l){return l?new Promise((v,C)=>{const M=setTimeout(()=>{B.dispose(),v()},D),B=l.onCancellationRequested(()=>{clearTimeout(M),B.dispose(),C(new w.CancellationError)})}):h(v=>z(D,v))}e.timeout=z;function d(D,l=0,v){const C=setTimeout(()=>{D(),v&&M.dispose()},l),M=(0,P.toDisposable)(()=>{clearTimeout(C),v?.deleteAndLeak(M)});return v?.add(M),M}e.disposableTimeout=d;function T(D){const l=[];let v=0;const C=D.length;function M(){return v<C?D[v++]():null}function B(Y){Y!=null&&l.push(Y);const Z=M();return Z?Z.then(B):Promise.resolve(l)}return Promise.resolve(null).then(B)}e.sequence=T;function A(D,l=C=>!!C,v=null){let C=0;const M=D.length,B=()=>{if(C>=M)return Promise.resolve(v);const Y=D[C++];return Promise.resolve(Y()).then(X=>l(X)?Promise.resolve(X):B())};return B()}e.first=A;function L(D,l=C=>!!C,v=null){if(D.length===0)return Promise.resolve(v);let C=D.length;const M=()=>{C=-1;for(const B of D)B.cancel?.()};return new Promise((B,Y)=>{for(const Z of D)Z.then(X=>{--C>=0&&l(X)?(M(),B(X)):C===0&&B(v)}).catch(X=>{--C>=0&&(M(),Y(X))})})}e.firstParallel=L;class b{constructor(l){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((v,C)=>{this.outstandingPromises.push({factory:l,c:v,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const v=l.factory();v.then(l.c,l.e),v.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class a extends b{constructor(){super(1)}}e.Queue=a;class p{constructor(){this.sequentializer=new te,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}e.LimitedQueue=p;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const l=new x;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueSize(l,v=r.extUri){const C=v.getComparisonKey(l);return this.queues.get(C)?.size??0}queueFor(l,v,C=r.extUri){const M=C.getComparisonKey(l);let B=this.queues.get(M);if(!B){B=new a;const Y=this.drainListenerCount++,Z=k.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(M),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new P.DisposableMap),this.drainListeners.set(Y,Z),this.queues.set(M,B)}return B.queue(v)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class W{constructor(l,v){this._token=-1,typeof l=="function"&&typeof v=="number"&&this.setIfNotSet(l,v)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,v){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},v)}setIfNotSet(l,v){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},v))}}e.TimeoutTimer=W;class j{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(l,v,C=globalThis){this.cancel();const M=C.setInterval(()=>{l()},v);this.disposable=(0,P.toDisposable)(()=>{C.clearInterval(M),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=j;class V{constructor(l,v){this.timeoutToken=-1,this.runner=l,this.timeout=v,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class ${constructor(l,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=v,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class H extends V{constructor(l,v){super(l,v),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class J extends P.Disposable{constructor(l,v){super(),this.options=l,this.handler=v,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const v of l)this.pendingWork.push(v);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(D,l)=>{(0,f.setTimeout0)(()=>{if(v)return;const C=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e._runWhenIdle=(D,l,v)=>{const C=D.requestIdleCallback(l,typeof v=="number"?{timeout:v}:void 0);let M=!1;return{dispose(){M||(M=!0,D.cancelIdleCallback(C))}}},e.runWhenGlobalIdle=D=>(0,e._runWhenIdle)(globalThis,D)}();class ee{constructor(l,v){this._didRun=!1,this._executor=()=>{try{this._value=v()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(l,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class oe extends ee{constructor(l){super(globalThis,l)}}e.GlobalIdleValue=oe;async function ue(D,l,v){let C;for(let M=0;M<v;M++)try{return await D()}catch(B){C=B,await z(l)}throw C}e.retry=ue;class te{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,v,C){return this._running={taskId:l,cancel:()=>C?.(),promise:v},v.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),v}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{let v,C;const M=new Promise((B,Y)=>{v=B,C=Y});this._queued={run:l,promise:M,promiseResolve:v,promiseReject:C}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class le{constructor(l,v=()=>Date.now()){this.interval=l,this.nowFn=v,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var ne;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,v)=>{this.completeCallback=l,this.errorCallback=v})}complete(l){return new Promise(v=>{this.completeCallback(l),this.outcome={outcome:0,value:l},v()})}error(l){return new Promise(v=>{this.errorCallback(l),this.outcome={outcome:1,value:l},v()})}cancel(){return this.error(new w.CancellationError)}}e.DeferredPromise=x;var ie;(function(D){async function l(C){let M;const B=await Promise.all(C.map(Y=>Y.then(Z=>Z,Z=>{M||(M=Z)})));if(typeof M<"u")throw M;return B}D.settled=l;function v(C){return new Promise(async(M,B)=>{try{await C(M,B)}catch(Y){B(Y)}})}D.withAsyncBody=v})(ie||(e.Promises=ie={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(l){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=l.then(v=>(this._value=v,this._isResolved=!0,v),v=>{throw this._error=v,this._isResolved=!0,v})}requireValue(){if(!this._isResolved)throw new w.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class de{constructor(l){this._compute=l,this._promise=new c.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=de;var se;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(se||(se={}));class Q{static fromArray(l){return new Q(v=>{v.emitMany(l)})}static fromPromise(l){return new Q(async v=>{v.emitMany(await l)})}static fromPromises(l){return new Q(async v=>{await Promise.all(l.map(async C=>v.emitOne(await C)))})}static merge(l){return new Q(async v=>{await Promise.all(l.map(async C=>{for await(const M of C)v.emitOne(M)}))})}static{this.EMPTY=Q.fromArray([])}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const v={emitOne:C=>this.emitOne(C),emitMany:C=>this.emitMany(C),reject:C=>this.reject(C)};try{await Promise.resolve(l(v)),this.resolve()}catch(C){this.reject(C)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,v){return new Q(async C=>{for await(const M of l)C.emitOne(v(M))})}map(l){return Q.map(this,l)}static filter(l,v){return new Q(async C=>{for await(const M of l)v(M)&&C.emitOne(M)})}filter(l){return Q.filter(this,l)}static coalesce(l){return Q.filter(l,v=>!!v)}coalesce(){return Q.coalesce(this)}static async toPromise(l){const v=[];for await(const C of l)v.push(C);return v}toPromise(){return Q.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class ae extends Q{constructor(l,v){super(v),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function ce(D){const l=new I.CancellationTokenSource,v=D(l.token);return new ae(l,async C=>{const M=l.token.onCancellationRequested(()=>{M.dispose(),l.dispose(),C.reject(new w.CancellationError)});try{for await(const B of v){if(l.token.isCancellationRequested)return;C.emitOne(B)}M.dispose(),l.dispose()}catch(B){M.dispose(),l.dispose(),C.reject(B)}})}e.createCancelableAsyncIterable=ce;class he{constructor(){this._deferred=new x,this._asyncIterable=new Q(C=>{if(l){C.reject(l);return}return v&&C.emitMany(v),this._errorFn=M=>C.reject(M),this._emitFn=M=>C.emitOne(M),this._deferred.p});let l,v;this._emitFn=C=>{v||(v=[]),v.push(C)},this._errorFn=C=>{l||(l=C)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(l){this._errorFn(l),this._deferred.complete()}emitOne(l){this._emitFn(l)}}e.AsyncIterableSource=he}),define(K[21],G([0,1,36]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(P){return this===P}};function w(P,r){return new I.TokenizationResult([new I.Token(0,"",P)],r)}e.nullTokenize=w;function k(P,r){const f=new Uint32Array(2);return f[0]=0,f[1]=(P<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new I.EncodedTokenizationResult(f,r===null?e.NullState:r)}e.nullTokenizeEncoded=k}),define(K[37],G([0,1,20,6,3,38,13,15,47,21,28,16,7]),function(q,e,I,w,k,P,r,f,t,c,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var o;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class i{constructor(g,S){this.tokenizationSupport=S,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new s(g)}getStartState(g){return this.store.getStartState(g,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=i;class n extends i{constructor(g,S,O,U){super(g,S),this._textModel=O,this._languageIdCodec=U}updateTokensUntilLine(g,S){const O=this._textModel.getLanguageId();for(;;){const U=this.getFirstInvalidLine();if(!U||U.lineNumber>S)break;const z=this._textModel.getLineContent(U.lineNumber),d=N(this._languageIdCodec,O,this.tokenizationSupport,z,!0,U.startState);g.add(U.lineNumber,d.tokens),this.store.setEndState(U.lineNumber,d.endState)}}getTokenTypeIfInsertingCharacter(g,S){const O=this.getStartState(g.lineNumber);if(!O)return 0;const U=this._textModel.getLanguageId(),z=this._textModel.getLineContent(g.lineNumber),d=z.substring(0,g.column-1)+S+z.substring(g.column-1),T=N(this._languageIdCodec,U,this.tokenizationSupport,d,!0,O),A=new u.LineTokens(T.tokens,d,this._languageIdCodec);if(A.getCount()===0)return 0;const L=A.findTokenIndexAtOffset(g.column-1);return A.getStandardTokenType(L)}tokenizeLineWithEdit(g,S,O){const U=g.lineNumber,z=g.column,d=this.getStartState(U);if(!d)return null;const T=this._textModel.getLineContent(U),A=T.substring(0,z-1)+O+T.substring(z-1+S),L=this._textModel.getLanguageIdAtPosition(U,0),b=N(this._languageIdCodec,L,this.tokenizationSupport,A,!0,d);return new u.LineTokens(b.tokens,A,this._languageIdCodec)}isCheapToTokenize(g){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<S||g===S&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,S,O){if(O<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(S<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,O),{heuristicTokens:!1};let U=this.guessStartState(S);const z=this._textModel.getLanguageId();for(let d=S;d<=O;d++){const T=this._textModel.getLineContent(d),A=N(this._languageIdCodec,z,this.tokenizationSupport,T,!0,U);g.add(d,A.tokens),U=A.endState}return{heuristicTokens:!0}}guessStartState(g){let S=this._textModel.getLineFirstNonWhitespaceColumn(g);const O=[];let U=null;for(let T=g-1;S>1&&T>=1;T--){const A=this._textModel.getLineFirstNonWhitespaceColumn(T);if(A!==0&&A<S&&(O.push(this._textModel.getLineContent(T)),S=A,U=this.getStartState(T),U))break}U||(U=this.tokenizationSupport.getInitialState()),O.reverse();const z=this._textModel.getLanguageId();let d=U;for(const T of O)d=N(this._languageIdCodec,z,this.tokenizationSupport,T,!1,d).endState;return d}}e.TokenizerWithStateStoreAndTextModel=n;class s{constructor(g){this.lineCount=g,this._tokenizationStateStore=new _,this._invalidEndStatesLineNumbers=new y,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,g+1))}getEndState(g){return this._tokenizationStateStore.getEndState(g)}setEndState(g,S){if(!S)throw new w.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(g);const O=this._tokenizationStateStore.setEndState(g,S);return O&&g<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(g+1,g+2)),O}acceptChange(g,S){this.lineCount+=S-g.length,this._tokenizationStateStore.acceptChange(g,S),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(g.startLineNumber,g.endLineNumberExclusive),S)}acceptChanges(g){for(const S of g){const[O]=(0,r.countEOL)(S.text);this.acceptChange(new f.LineRange(S.range.startLineNumber,S.range.endLineNumber+1),O+1)}}invalidateEndStateRange(g){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(g,S){return g===1?S:this.getEndState(g-1)}getFirstInvalidLine(g){const S=this.getFirstInvalidEndStateLineNumber();if(S===null)return null;const O=this.getStartState(S,g);if(!O)throw new w.BugIndicatingError("Start state must be defined");return{lineNumber:S,startState:O}}}e.TrackingTokenizationStateStore=s;class _{constructor(){this._lineEndStates=new m.FixedArray(null)}getEndState(g){return this._lineEndStates.get(g)}setEndState(g,S){const O=this._lineEndStates.get(g);return O&&O.equals(S)?!1:(this._lineEndStates.set(g,S),!0)}acceptChange(g,S){let O=g.length;S>0&&O>0&&(O--,S--),this._lineEndStates.replace(g.startLineNumber,O,S)}acceptChanges(g){for(const S of g){const[O]=(0,r.countEOL)(S.text);this.acceptChange(new f.LineRange(S.range.startLineNumber,S.range.endLineNumber+1),O+1)}}}e.TokenizationStateStore=_;class y{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const g=this._ranges[0];return g.start+1===g.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(g.start+1,g.endExclusive),g.start}delete(g){const S=this._ranges.findIndex(O=>O.contains(g));if(S!==-1){const O=this._ranges[S];O.start===g?O.endExclusive===g+1?this._ranges.splice(S,1):this._ranges[S]=new t.OffsetRange(g+1,O.endExclusive):O.endExclusive===g+1?this._ranges[S]=new t.OffsetRange(O.start,g):this._ranges.splice(S,1,new t.OffsetRange(O.start,g),new t.OffsetRange(g+1,O.endExclusive))}}addRange(g){t.OffsetRange.addRange(g,this._ranges)}addRangeAndResize(g,S){let O=0;for(;!(O>=this._ranges.length||g.start<=this._ranges[O].endExclusive);)O++;let U=O;for(;!(U>=this._ranges.length||g.endExclusive<this._ranges[U].start);)U++;const z=S-g.length;for(let d=U;d<this._ranges.length;d++)this._ranges[d]=this._ranges[d].delta(z);if(O===U){const d=new t.OffsetRange(g.start,g.start+S);d.isEmpty||this._ranges.splice(O,0,d)}else{const d=Math.min(g.start,this._ranges[O].start),T=Math.max(g.endExclusive,this._ranges[U-1].endExclusive),A=new t.OffsetRange(d,T+z);A.isEmpty?this._ranges.splice(O,U-O):this._ranges.splice(O,U-O,A)}}toString(){return this._ranges.map(g=>g.toString()).join(" + ")}}e.RangePriorityQueueImpl=y;function N(E,g,S,O,U,z){let d=null;if(S)try{d=S.tokenizeEncoded(O,U,z.clone())}catch(T){(0,w.onUnexpectedError)(T)}return d||(d=(0,c.nullTokenizeEncoded)(E.encodeLanguageId(g),z)),u.LineTokens.convertToEndOffset(d.tokens,O.length),d}class R{constructor(g,S){this._tokenizerWithStateStore=g,this._backgroundTokenStore=S,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,I.runWhenGlobalIdle)(g=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(g)}))}_backgroundTokenizeWithDeadline(g){const S=Date.now()+g.timeRemaining(),O=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<S?(0,k.setTimeout0)(O):this._beginBackgroundTokenization())};O()}_backgroundTokenizeForAtLeast1ms(){const g=this._tokenizerWithStateStore._textModel.getLineCount(),S=new h.ContiguousMultilineTokensBuilder,O=P.StopWatch.create(!1);do if(O.elapsed()>1||this._tokenizeOneInvalidLine(S)>=g)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(S.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(g){const S=this._tokenizerWithStateStore?.getFirstInvalidLine();return S?(this._tokenizerWithStateStore.updateTokensUntilLine(g,S.lineNumber),S.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(g,S){this._tokenizerWithStateStore.store.invalidateEndStateRange(new f.LineRange(g,S))}}e.DefaultBackgroundTokenizer=R}),define(K[39],G([0,1,35,2,38,14,36]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class f extends w.Disposable{constructor(c,m,h,u,o,i,n){super(),this._grammar=c,this._initialState=m,this._containsEmbeddedLanguages=h,this._createBackgroundTokenizer=u,this._backgroundTokenizerShouldOnlyVerifyTokens=o,this._reportTokenizationTime=i,this._reportSlowTokenization=n,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new I.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(c,m,h){throw new Error("Not supported!")}createBackgroundTokenizer(c,m){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(c,m)}tokenizeEncoded(c,m,h){const u=Math.random()*1e4<1,o=this._reportSlowTokenization||u,i=o?new k.StopWatch(!0):void 0,n=this._grammar.tokenizeLine2(c,h,500);if(o){const _=i.elapsed();(u||_>32)&&this._reportTokenizationTime(_,c.length,u)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${c.substring(0,100)}`),new r.EncodedTokenizationResult(n.tokens,h);if(this._containsEmbeddedLanguages){const _=this._seenLanguages,y=n.tokens;for(let N=0,R=y.length>>>1;N<R;N++){const E=y[(N<<1)+1],g=P.TokenMetadata.getLanguageId(E);_[g]||(_[g]=!0,this._onDidEncounterLanguage.fire(g))}}let s;return h.equals(n.ruleStack)?s=h:s=n.ruleStack,new r.EncodedTokenizationResult(n.tokens,s)}}e.TextMateTokenizationSupport=f}),define(K[40],G([0,1,21,2,11]),function(q,e,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class P extends w.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,c){super(),this._encodedLanguageId=f,this._actual=t,this._maxTokenizationLineLength=c,this._register((0,k.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(f,t,c){throw new Error("Not supported!")}tokenizeEncoded(f,t,c){return f.length>=this._maxTokenizationLineLength.get()?(0,I.nullTokenizeEncoded)(this._encodedLanguageId,c):this._actual.tokenizeEncoded(f,t,c)}createBackgroundTokenizer(f,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(f,t)}}e.TokenizationSupportWithLineLimit=P}),define(K[41],G([0,1,34,20,11,3,15,48,37,16,7,39,40]),function(q,e,I,w,k,P,r,f,t,c,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class o extends f.MirrorTextModel{constructor(s,_,y,N,R,E,g,S){super(s,_,y,N),this._host=R,this._languageId=E,this._encodedLanguageId=g,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)(this,-1),this._tokenizeDebouncer=new w.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(S,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(s,_){this._languageId=s,this._encodedLanguageId=_,this._resetTokenization()}onEvents(s){super.onEvents(s),this._tokenizerWithStateStore?.store.acceptChanges(s.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(s){this._maxTokenizationLineLength.set(s,void 0)}retokenize(s,_){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new r.LineRange(s,_)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const s=this._languageId,_=this._encodedLanguageId,y=await this._host.getOrCreateGrammar(s,_);if(!(this._isDisposed||s!==this._languageId||_!==this._encodedLanguageId||!y)){if(y.grammar){const N=new u.TokenizationSupportWithLineLimit(this._encodedLanguageId,new h.TextMateTokenizationSupport(y.grammar,y.initialState,!1,void 0,()=>!1,(R,E,g)=>{this._host.reportTokenizationTime(R,s,y.sourceExtensionId,E,g)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,N)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:_}=await(0,I.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=_}const s=new Date().getTime();for(;;){let _=0;const y=new c.ContiguousMultilineTokensBuilder,N=new i;for(;;){const g=this._tokenizerWithStateStore.getFirstInvalidLine();if(g===null||_>200)break;_++;const S=this._lines[g.lineNumber-1],O=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(S,!0,g.startState);if(this._tokenizerWithStateStore.store.setEndState(g.lineNumber,O.endState)){const z=this._diffStateStacksRefEqFn(g.startState,O.endState);N.setState(g.lineNumber,z)}else N.setState(g.lineNumber,null);if(m.LineTokens.convertToEndOffset(O.tokens,S.length),y.add(g.lineNumber,O.tokens),new Date().getTime()-s>20)break}if(_===0)break;const R=N.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,y.serialize(),R),new Date().getTime()-s>20){(0,P.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=o;class i{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(s,_){s===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(_):this._stateDeltas.push({startLineNumber:s,stateDeltas:[_]}),this._lastStartLineNumber=s}getStateDeltas(){return this._stateDeltas}}}),define(K[42],G([0,1,19]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class w{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(P){if(this._scopeNameToLanguageRegistration[P.scopeName]){const r=this._scopeNameToLanguageRegistration[P.scopeName];I.isEqual(r.location,P.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${P.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${P.location.toString()}`)}this._scopeNameToLanguageRegistration[P.scopeName]=P}getGrammarDefinition(P){return this._scopeNameToLanguageRegistration[P]||null}}e.TMScopeRegistry=w}),define(K[43],G([0,1,2,42]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends I.Disposable{constructor(r,f,t,c){super(),this._host=r,this._initialState=t.INITIAL,this._scopeRegistry=new w.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:c,loadGrammar:async m=>{const h=this._scopeRegistry.getGrammarDefinition(m);if(!h)return this._host.logTrace(`No grammar found for scope ${m}`),null;const u=h.location;try{const o=await this._host.readFile(u);return t.parseRawGrammar(o,u.path)}catch(o){return this._host.logError(`Unable to load and parse grammar for scope ${m} from ${u}`,o),null}},getInjections:m=>{const h=m.split(".");let u=[];for(let o=1;o<=h.length;o++){const i=h.slice(0,o).join(".");u=[...u,...this._injections[i]||[]]}return u}}));for(const m of f){if(this._scopeRegistry.register(m),m.injectTo){for(const h of m.injectTo){let u=this._injections[h];u||(this._injections[h]=u=[]),u.push(m.scopeName)}if(m.embeddedLanguages)for(const h of m.injectTo){let u=this._injectedEmbeddedLanguages[h];u||(this._injectedEmbeddedLanguages[h]=u=[]),u.push(m.embeddedLanguages)}}m.language&&this._languageToScope.set(m.language,m.scopeName)}}has(r){return this._languageToScope.has(r)}setTheme(r,f){this._grammarRegistry.setTheme(r,f)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(r,f){const t=this._languageToScope.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const c=this._scopeRegistry.getGrammarDefinition(t);if(!c)throw new Error(e.missingTMGrammarErrorMessage);const m=c.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const o=this._injectedEmbeddedLanguages[t];for(const i of o)for(const n of Object.keys(i))m[n]=i[n]}const h=Object.keys(m).length>0;let u;try{u=await this._grammarRegistry.loadGrammarWithConfiguration(t,f,{embeddedLanguages:m,tokenTypes:c.tokenTypes,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):o}return{languageId:r,grammar:u,initialState:this._initialState,containsEmbeddedLanguages:h,sourceExtensionId:c.sourceExtensionId}}}e.TMGrammarFactory=k}),define(K[49],G([0,1,8,43,41]),function(q,e,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function P(f,t){return new r(f,t)}e.create=P;class r{constructor(t,c){this._createData=c,this._models=new Map,this._grammarCache=[],this._host=t.host;const m=c.grammarDefinitions.map(h=>({location:I.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(m)}async _loadTMGrammarFactory(t){const c=this._createData.textmateMainUri,m=await new Promise((n,s)=>{q([c],n,s)}),h=await new Promise((n,s)=>{q([this._createData.onigurumaMainUri],n,s)}),o=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(o);const i=Promise.resolve({createOnigScanner:n=>h.createOnigScanner(n),createOnigString:n=>h.createOnigString(n)});return new w.TMGrammarFactory({logTrace:n=>{},logError:(n,s)=>console.error(n,s),readFile:n=>this._host.readFile(n)},t,m,i)}acceptNewModel(t){const c=I.URI.revive(t.uri),m=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(c,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,u){const o=await m._grammarFactory;return o?(m._grammarCache[u]||(m._grammarCache[u]=o.createGrammar(h,u)),m._grammarCache[u]):Promise.resolve(null)},setTokensAndStates(h,u,o){m._host.setTokensAndStates(t.controllerId,h,u,o)},reportTokenizationTime(h,u,o,i,n){m._host.reportTokenizationTime(h,u,o,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,c){this._models.get(t).onEvents(c)}retokenize(t,c,m){this._models.get(t).retokenize(c,m)}acceptModelLanguageChanged(t,c,m){this._models.get(t).onLanguageId(c,m)}acceptRemovedModel(t){const c=this._models.get(t);c&&(c.dispose(),this._models.delete(t))}async acceptTheme(t,c){(await this._grammarFactory)?.setTheme(t,c)}acceptMaxTokenizationLineLength(t,c){this._models.get(t).acceptMaxTokenizationLineLength(c)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00d5968fd28fdbb3362ca4686e7ac684b8be63c8/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
